/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/process","os","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/shellEnv","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(K){for(var e=[],k=0,n=K.length;k<n;k++)e[k]=te[K[k]];return e};define(te[99],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(n,T){if(!n)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=k}),define(te[48],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(P,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(P,b,I){this.id=P,this.definition=b,this.description=I,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function T(A,P){const b=["codicon","codicon-"+A];return P&&b.push("codicon-modifier-"+P),b}e.getClassNamesArray=T;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(E){if(E instanceof n)return["codicon","codicon-"+E.id];const g=P.exec(E.id);if(!g)return b(n.error);let[,S,d]=g;const h=["codicon","codicon-"+S];return d&&h.push("codicon-modifier-"+d.substr(1)),h}A.asClassNameArray=b;function I(E){return b(E).join(" ")}A.asClassName=I;function D(E){return"."+b(E).join(".")}A.asCSSSelector=D})(L=e.CSSIcon||(e.CSSIcon={}))}),define(te[68],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function n(D){const E=[];for(let g in D)k.call(D,g)&&E.push(D[g]);return E}e.values=n;function T(D,E){for(let g in D)if(k.call(D,g)&&E({key:g,value:D[g]},function(){delete D[g]})===!1)return}e.forEach=T;function L(D,E){const g=Object.create(null);for(const S of D){const d=E(S);let h=g[d];h||(h=g[d]=[]),h.push(S)}return g}e.groupBy=L;function A(D){const E=Object.create(null);return D&&D.forEach((g,S)=>{E[S]=g}),E}e.fromMap=A;function P(D,E){const g=[],S=[];for(let d of D)E.has(d)||g.push(d);for(let d of E)D.has(d)||S.push(d);return{removed:g,added:S}}e.diffSets=P;function b(D,E){const g=[],S=[];for(let[d,h]of D)E.has(d)||g.push(h);for(let[d,h]of E)D.has(d)||S.push(h);return{removed:g,added:S}}e.diffMaps=b;class I{constructor(){this.map=new Map}add(E,g){let S=this.map.get(E);S||(S=new Set,this.map.set(E,S)),S.add(g)}delete(E,g){const S=this.map.get(E);!S||(S.delete(g),S.size===0&&this.map.delete(E))}forEach(E,g){const S=this.map.get(E);!S||S.forEach(g)}}e.SetMap=I}),define(te[54],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(P,b,I)=>{let D=null,E=null;if(typeof I.value=="function"?(D="value",E=I.value):typeof I.get=="function"&&(D="get",E=I.get),!E)throw new Error("not supported");I[D]=A(E,b)}}e.createDecorator=k;function n(A,P,b){let I=null,D=null;if(typeof b.value=="function"?(I="value",D=b.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(I="get",D=b.get),!D)throw new Error("not supported");const E=`$memoize$${P}`;b[I]=function(...g){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,g)}),this[E]}}e.memoize=n;function T(A,P,b){return k((I,D)=>{const E=`$debounce$${D}`,g=`$debounce$result$${D}`;return function(...S){this[g]||(this[g]=b?b():void 0),clearTimeout(this[E]),P&&(this[g]=P(this[g],...S),S=[this[g]]),this[E]=setTimeout(()=>{I.apply(this,S),this[g]=b?b():void 0},A)}})}e.debounce=T;function L(A,P,b){return k((I,D)=>{const E=`$throttle$timer$${D}`,g=`$throttle$result$${D}`,S=`$throttle$lastRun$${D}`,d=`$throttle$pending$${D}`;return function(...h){if(this[g]||(this[g]=b?b():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...h)),this[d])return;const v=this[S]+A;v<=Date.now()?(this[S]=Date.now(),I.apply(this,[this[g]]),this[g]=b?b():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),I.apply(this,[this[g]]),this[g]=b?b():void 0},v-Date.now()))}})}e.throttle=L}),define(te[9],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(r=>{r(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=k,e.errorHandler=new k;function n(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=n;function T(p){b(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=T;function L(p){b(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=L;function A(p){if(p instanceof Error){let{name:c,message:r}=p;const l=p.stacktrace||p.stack;return{$isError:!0,name:c,message:r,stack:l}}return p}e.transformErrorForSerialization=A;const P="Canceled";function b(p){return p instanceof I?!0:p instanceof Error&&p.name===P&&p.message===P}e.isCancellationError=b;class I extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=I;function D(){const p=new Error(P);return p.name=p.message,p}e.canceled=D;function E(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=E;function g(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=g;function S(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function d(p){const c=new Error(`${p} has been disposed`);return c.name="DISPOSED",c}e.disposed=d;function h(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=h;class v extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=v;class m extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;class y extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=y}),define(te[16],ne([0,1,9]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(q,U=0){return q[q.length-(1+U)]}e.tail=n;function T(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=T;function L(q,U,M=(W,H)=>W===H){if(q===U)return!0;if(!q||!U||q.length!==U.length)return!1;for(let W=0,H=q.length;W<H;W++)if(!M(q[W],U[W]))return!1;return!0}e.equals=L;function A(q,U,M){let W=0,H=q.length-1;for(;W<=H;){const re=(W+H)/2|0,se=M(q[re],U);if(se<0)W=re+1;else if(se>0)H=re-1;else return re}return-(W+1)}e.binarySearch=A;function P(q,U){let M=0,W=q.length;if(W===0)return 0;for(;M<W;){const H=Math.floor((M+W)/2);U(q[H])?W=H:M=H+1}return M}e.findFirstInSorted=P;function b(q,U,M){if(q=q|0,q>=U.length)throw new TypeError("invalid index");let W=U[Math.floor(U.length*Math.random())],H=[],re=[],se=[];for(let ue of U){const de=M(ue,W);de<0?H.push(ue):de>0?re.push(ue):se.push(ue)}return q<H.length?b(q,H,M):q<H.length+se.length?se[0]:b(q-(H.length+se.length),re,M)}e.quickSelect=b;function I(q,U){const M=[];let W;for(const H of q.slice(0).sort(U))!W||U(W[0],H)!==0?(W=[H],M.push(W)):W.push(H);return M}e.groupBy=I;function D(q,U,M){const W=[];function H(ue,de,we){if(de===0&&we.length===0)return;const pe=W[W.length-1];pe&&pe.start+pe.deleteCount===ue?(pe.deleteCount+=de,pe.toInsert.push(...we)):W.push({start:ue,deleteCount:de,toInsert:we})}let re=0,se=0;for(;;){if(re===q.length){H(re,0,U.slice(se));break}if(se===U.length){H(re,q.length-re,[]);break}const ue=q[re],de=U[se],we=M(ue,de);we===0?(re+=1,se+=1):we<0?(H(re,1,[]),re+=1):we>0&&(H(re,0,[de]),se+=1)}return W}e.sortedDiff=D;function E(q,U,M){const W=D(q,U,M),H=[],re=[];for(const se of W)H.push(...q.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:H,added:re}}e.delta=E;function g(q,U,M){if(M===0)return[];const W=q.slice(0,M).sort(U);return d(q,U,W,M,q.length),W}e.top=g;function S(q,U,M,W,H){return M===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const ue=q.length,de=q.slice(0,M).sort(U);for(let we=M,pe=Math.min(M+W,ue);we<ue;we=pe,pe=Math.min(pe+W,ue)){if(we>M&&await new Promise(ge=>setTimeout(ge)),H&&H.isCancellationRequested)throw(0,k.canceled)();d(q,U,de,we,pe)}return de})().then(re,se)})}e.topAsync=S;function d(q,U,M,W,H){for(const re=M.length;W<H;W++){const se=q[W];if(U(se,M[re-1])<0){M.pop();const ue=P(M,de=>U(se,de)<0);M.splice(ue,0,se)}}}function h(q){return q.filter(U=>!!U)}e.coalesce=h;function v(q){let U=0;for(let M=0;M<q.length;M++)q[M]&&(q[U]=q[M],U+=1);q.length=U}e.coalesceInPlace=v;function m(q,U,M){q.splice(M,0,q.splice(U,1)[0])}e.move=m;function w(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=w;function y(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=y;function p(q,U=M=>M){const M=new Set;return q.filter(W=>{const H=U(W);return M.has(H)?!1:(M.add(H),!0)})}e.distinct=p;function c(q){const U=new Set;return M=>{const W=q(M);return U.has(W)?!1:(U.add(W),!0)}}e.uniqueFilter=c;function r(q,U){const M=l(q,U);if(M!==-1)return q[M]}e.findLast=r;function l(q,U){for(let M=q.length-1;M>=0;M--){const W=q[M];if(U(W))return M}return-1}e.lastIndex=l;function i(q,U){return q.length>0?q[0]:U}e.firstOrDefault=i;function t(q,U,M=(W,H)=>W===H){let W=0;for(let H=0,re=Math.min(q.length,U.length);H<re&&M(q[H],U[H]);H++)W++;return W}e.commonPrefixLength=t;function o(q){return[].concat(...q)}e.flatten=o;function s(q,U){let M=typeof U=="number"?q:0;typeof U=="number"?M=q:(M=0,U=q);const W=[];if(M<=U)for(let H=M;H<U;H++)W.push(H);else for(let H=M;H>U;H--)W.push(H);return W}e.range=s;function a(q,U,M){return q.reduce((W,H)=>(W[U(H)]=M?M(H):H,W),Object.create(null))}e.index=a;function u(q,U){return q.push(U),()=>f(q,U)}e.insert=u;function f(q,U){const M=q.indexOf(U);if(M>-1)return q.splice(M,1),U}e.remove=f;function C(q,U,M){const W=q.slice(0,U),H=q.slice(U);return W.concat(M,H)}e.arrayInsert=C;function _(q,U){let M;if(typeof U=="number"){let W=U;M=()=>{const H=Math.sin(W++)*179426549;return H-Math.floor(H)}}else M=Math.random;for(let W=q.length-1;W>0;W-=1){const H=Math.floor(M()*(W+1)),re=q[W];q[W]=q[H],q[H]=re}}e.shuffle=_;function O(q,U){const M=q.indexOf(U);M>-1&&(q.splice(M,1),q.unshift(U))}e.pushToStart=O;function F(q,U){const M=q.indexOf(U);M>-1&&(q.splice(M,1),q.push(U))}e.pushToEnd=F;function R(q,U){return Array.isArray(q)?q.map(U):U(q)}e.mapArrayOrNot=R;function N(q){return Array.isArray(q)?q:[q]}e.asArray=N;function $(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=$;function j(q,U){for(const M of q){const W=U(M);if(W!==void 0)return W}}e.mapFind=j;function X(q,U,M){const W=J(q,U),H=q.length,re=M.length;q.length=H+re;for(let se=H-1;se>=W;se--)q[se+re]=q[se];for(let se=0;se<re;se++)q[se+W]=M[se]}e.insertInto=X;function z(q,U,M,W){const H=J(q,U),re=q.splice(H,M);return X(q,H,W),re}e.splice=z;function J(q,U){return U<0?Math.max(U+q.length,0):Math.min(U,q.length)}function B(q,U){return(M,W)=>U(q(M),q(W))}e.compareBy=B;const x=(q,U)=>q-U;e.numberComparator=x;function ee(q,U){if(q.length===0)return;let M=q[0];for(let W=1;W<q.length;W++){const H=q[W];U(H,M)>0&&(M=H)}return M}e.findMaxBy=ee;function V(q,U){if(q.length===0)return;let M=q[0];for(let W=1;W<q.length;W++){const H=q[W];U(H,M)>=0&&(M=H)}return M}e.findLastMaxBy=V;function Z(q,U){return ee(q,(M,W)=>-U(M,W))}e.findMinBy=Z;class Y{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let M=this.firstIdx;for(;M<this.items.length&&U(this.items[M]);)M++;const W=M===this.firstIdx?null:this.items.slice(this.firstIdx,M);return this.firstIdx=M,W}takeFromEndWhile(U){let M=this.lastIdx;for(;M>=0&&U(this.items[M]);)M--;const W=M===this.lastIdx?null:this.items.slice(M+1,this.lastIdx+1);return this.lastIdx=M,W}peek(){return this.items[this.firstIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}takeCount(U){const M=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,M}}e.ArrayQueue=Y}),define(te[69],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(n){const T=this;let L=!1,A;return function(){return L||(L=!0,A=n.apply(T,arguments)),A}}e.once=k}),define(te[55],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(n){function T(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=T;const L=Object.freeze([]);function A(){return L}n.empty=A;function*P(c){yield c}n.single=P;function b(c){return c||L}n.from=b;function I(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=I;function D(c){return c[Symbol.iterator]().next().value}n.first=D;function E(c,r){for(const l of c)if(r(l))return!0;return!1}n.some=E;function g(c,r){for(const l of c)if(r(l))return l}n.find=g;function*S(c,r){for(const l of c)r(l)&&(yield l)}n.filter=S;function*d(c,r){let l=0;for(const i of c)yield r(i,l++)}n.map=d;function*h(...c){for(const r of c)for(const l of r)yield l}n.concat=h;function*v(c){for(const r of c)for(const l of r)yield l}n.concatNested=v;function m(c,r,l){let i=l;for(const t of c)i=r(i,t);return i}n.reduce=m;function*w(c,r,l=c.length){for(r<0&&(r+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);r<l;r++)yield c[r]}n.slice=w;function y(c,r=Number.POSITIVE_INFINITY){const l=[];if(r===0)return[l,c];const i=c[Symbol.iterator]();for(let t=0;t<r;t++){const o=i.next();if(o.done)return[l,n.empty()];l.push(o.value)}return[l,{[Symbol.iterator](){return i}}]}n.consume=y;function p(c,r,l=(i,t)=>i===t){const i=c[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=i.next(),s=t.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!l(o.value,s.value))return!1}}n.equals=p})(k=e.Iterable||(e.Iterable={}))}),define(te[35],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(r,l=!1){let i=0,t=r.length,o="",s=0,a=16,u=0;function f($){let j=0,X=0;for(;j<$;){const z=r.charCodeAt(i);if(z>=48&&z<=57)X=X*16+z-48;else if(z>=65&&z<=70)X=X*16+z-65+10;else if(z>=97&&z<=102)X=X*16+z-97+10;else break;i++,j++}return j<$&&(X=-1),X}function C($){i=$,o="",s=0,a=16,u=0}function _(){const $=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&I(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&I(r.charCodeAt(i)))for(i++;i<r.length&&I(r.charCodeAt(i));)i++;else return u=3,r.substring($,i);let j=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&I(r.charCodeAt(i))){for(i++;i<r.length&&I(r.charCodeAt(i));)i++;j=i}else u=3;return r.substring($,j)}function O(){let $="",j=i;for(;;){if(i>=t){$+=r.substring(j,i),u=2;break}const X=r.charCodeAt(i);if(X===34){$+=r.substring(j,i),i++;break}if(X===92){if($+=r.substring(j,i),i++,i>=t){u=2;break}switch(r.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const J=f(4);J>=0?$+=String.fromCharCode(J):u=4;break}default:u=5}j=i;continue}if(X>=0&&X<=31)if(b(X)){$+=r.substring(j,i),u=2;break}else u=6;i++}return $}function F(){if(o="",u=0,s=i,i>=t)return s=t,a=17;let $=r.charCodeAt(i);if(P($)){do i++,o+=String.fromCharCode($),$=r.charCodeAt(i);while(P($));return a=15}if(b($))return i++,o+=String.fromCharCode($),$===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch($){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=O(),a=10;case 47:{const j=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return o=r.substring(j,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const X=t-1;let z=!1;for(;i<X;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,u=1),o=r.substring(j,i),a=13}return o+=String.fromCharCode($),i++,a=16}case 45:if(o+=String.fromCharCode($),i++,i===t||!I(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;i<t&&R($);)i++,$=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode($),i++,a=16}}function R($){if(P($)||b($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>i,scan:l?N:F,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>u}}e.createScanner=A;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function I(r){return r>=48&&r<=57}var D;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(D||(D={}));function E(r,l){const i=[],t=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(f,C,_,O){s.value=f,s.offset=C,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{y(r,{onObjectBegin:(f,C)=>{if(l<=f)throw t;o=void 0,a=l>f,i.push("")},onObjectProperty:(f,C,_)=>{if(l<C||(u(f,C,_,"property"),i[i.length-1]=f,l<=C+_))throw t},onObjectEnd:(f,C)=>{if(l<=f)throw t;o=void 0,i.pop()},onArrayBegin:(f,C)=>{if(l<=f)throw t;o=void 0,i.push(0)},onArrayEnd:(f,C)=>{if(l<=f)throw t;o=void 0,i.pop()},onLiteralValue:(f,C,_)=>{if(l<C||(u(f,C,_,c(f)),l<=C+_))throw t},onSeparator:(f,C,_)=>{if(l<=C)throw t;if(f===":"&&o&&o.type==="property")o.colonOffset=C,a=!1,o=void 0;else if(f===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(f){if(f!==t)throw f}return{path:i,previousNode:o,isAtPropertyKey:a,matches:f=>{let C=0;for(let _=0;C<f.length&&_<i.length;_++)if(f[C]===i[_]||f[C]==="*")C++;else if(f[C]!=="**")return!1;return C===f.length}}}e.getLocation=E;function g(r,l=[],i=L.DEFAULT){let t=null,o=[];const s=[];function a(f){Array.isArray(o)?o.push(f):t!==null&&(o[t]=f)}return y(r,{onObjectBegin:()=>{const f={};a(f),s.push(o),o=f,t=null},onObjectProperty:f=>{t=f},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const f=[];a(f),s.push(o),o=f,t=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(f,C,_)=>{l.push({error:f,offset:C,length:_})}},i),o[0]}e.parse=g;function S(r,l=[],i=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(f){t.type==="property"&&(t.length=f-t.offset,t=t.parent)}function s(f){return t.children.push(f),f}y(r,{onObjectBegin:f=>{t=s({type:"object",offset:f,length:-1,parent:t,children:[]})},onObjectProperty:(f,C,_)=>{t=s({type:"property",offset:C,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:f,offset:C,length:_,parent:t})},onObjectEnd:(f,C)=>{t.length=f+C-t.offset,t=t.parent,o(f+C)},onArrayBegin:(f,C)=>{t=s({type:"array",offset:f,length:-1,parent:t,children:[]})},onArrayEnd:(f,C)=>{t.length=f+C-t.offset,t=t.parent,o(f+C)},onLiteralValue:(f,C,_)=>{s({type:c(f),offset:C,length:_,parent:t,value:f}),o(C+_)},onSeparator:(f,C,_)=>{t.type==="property"&&(f===":"?t.colonOffset=C:f===","&&o(C))},onError:(f,C,_)=>{l.push({error:f,offset:C,length:_})}},i);const u=t.children[0];return u&&delete u.parent,u}e.parseTree=S;function d(r,l){if(!r)return;let i=r;for(let t of l)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],o=!0;break}if(!o)return}else{const o=t;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function h(r){if(!r.parent||!r.parent.children)return[];const l=h(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;l.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&l.push(i)}return l}e.getNodePath=h;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":{const l=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(l[i.children[0].value]=v(t))}return l}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function m(r,l,i=!1){return l>=r.offset&&l<r.offset+r.length||i&&l===r.offset+r.length}e.contains=m;function w(r,l,i=!1){if(m(r,l,i)){const t=r.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=l;o++){const s=w(t[o],l,i);if(s)return s}return r}}e.findNodeAtOffset=w;function y(r,l,i=L.DEFAULT){const t=A(r,!1);function o(Y){return Y?()=>Y(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(Y){return Y?q=>Y(q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=o(l.onObjectBegin),u=s(l.onObjectProperty),f=o(l.onObjectEnd),C=o(l.onArrayBegin),_=o(l.onArrayEnd),O=s(l.onLiteralValue),F=s(l.onSeparator),R=o(l.onComment),N=s(l.onError),$=i&&i.disallowComments,j=i&&i.allowTrailingComma;function X(){for(;;){const Y=t.scan();switch(t.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:$||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(Y){case 12:case 13:$?z(10):R();break;case 16:z(1);break;case 15:case 14:break;default:return Y}}}function z(Y,q=[],U=[]){if(N(Y),q.length+U.length>0){let M=t.getToken();for(;M!==17;){if(q.indexOf(M)!==-1){X();break}else if(U.indexOf(M)!==-1)break;M=X()}}}function J(Y){const q=t.getTokenValue();return Y?O(q):u(q),X(),!0}function B(){switch(t.getToken()){case 11:{let Y=0;try{Y=JSON.parse(t.getTokenValue()),typeof Y!="number"&&(z(2),Y=0)}catch{z(2)}O(Y);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return X(),!0}function x(){return t.getToken()!==10?(z(3,[],[2,5]),!1):(J(!1),t.getToken()===6?(F(":"),X(),Z()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ee(){a(),X();let Y=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Y||z(4,[],[]),F(","),X(),t.getToken()===2&&j)break}else Y&&z(6,[],[]);x()||z(4,[],[2,5]),Y=!0}return f(),t.getToken()!==2?z(7,[2],[]):X(),!0}function V(){C(),X();let Y=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Y||z(4,[],[]),F(","),X(),t.getToken()===4&&j)break}else Y&&z(6,[],[]);Z()||z(4,[],[4,5]),Y=!0}return _(),t.getToken()!==4?z(8,[4],[]):X(),!0}function Z(){switch(t.getToken()){case 3:return V();case 1:return ee();case 10:return J(!0);default:return B()}}return X(),t.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):Z()?(t.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=y;function p(r,l){let i=A(r),t=[],o,s=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==a&&t.push(r.substring(s,a)),l!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,l)),s=i.getPosition();break}while(o!==17);return t.join("")}e.stripComments=p;function c(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[49],ne([0,1,35]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(I,D,E){let g,S,d,h,v;if(D){for(h=D.offset,v=h+D.length,d=h;d>0&&!b(I,d-1);)d--;let a=v;for(;a<I.length&&!b(I,a);)a++;S=I.substring(d,a),g=A(S,E)}else S=I,g=0,d=0,h=0,v=I.length;const m=P(E,I);let w=!1,y=0,p;E.insertSpaces?p=L(" ",E.tabSize||4):p="	";const c=(0,k.createScanner)(S,!1);let r=!1;function l(){return m+L(p,g+y)}function i(){let a=c.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=c.scan();return r=a===16||c.getTokenError()!==0,a}const t=[];function o(a,u,f){!r&&u<v&&f>h&&I.substring(u,f)!==a&&t.push({offset:u,length:f-u,content:a})}let s=i();if(s!==17){const a=c.getTokenOffset()+d,u=L(p,g);o(u,d,a)}for(;s!==17;){let a=c.getTokenOffset()+c.getTokenLength()+d,u=i(),f="";for(;!w&&(u===12||u===13);){const _=c.getTokenOffset()+d;o(" ",a,_),a=c.getTokenOffset()+c.getTokenLength()+d,f=u===12?l():"",u=i()}if(u===2)s!==1&&(y--,f=l());else if(u===4)s!==3&&(y--,f=l());else{switch(s){case 3:case 1:y++,f=l();break;case 5:case 12:f=l();break;case 13:w?f=l():f=" ";break;case 6:f=" ";break;case 10:if(u===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?f=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}w&&(u===12||u===13)&&(f=l())}const C=c.getTokenOffset()+d;o(f,a,C),s=u}return t}e.format=n;function T(I,D){const E=JSON.stringify(I,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?E.replace(/\r\n|\r|\n/g,D.eol):E}e.toFormattedString=T;function L(I,D){let E="";for(let g=0;g<D;g++)E+=I;return E}function A(I,D){let E=0,g=0;const S=D.tabSize||4;for(;E<I.length;){const d=I.charAt(E);if(d===" ")g++;else if(d==="	")g+=S;else break;E++}return Math.floor(g/S)}function P(I,D){for(let E=0;E<D.length;E++){const g=D.charAt(E);if(g==="\r")return E+1<D.length&&D.charAt(E+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=P;function b(I,D){return`\r
`.indexOf(I.charAt(D))!==-1}e.isEOL=b}),define(te[70],ne([0,1,35,49]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(I,D,E){return L(I,D,void 0,E)}e.removeProperty=T;function L(I,D,E,g,S){const d=D.slice(),h=[],v=(0,k.parseTree)(I,h);let m,w;for(;d.length>0&&(w=d.pop(),m=(0,k.findNodeAtLocation)(v,d),m===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const y=(0,k.findNodeAtLocation)(m,[w]);if(y!==void 0)if(E===void 0){if(!y.parent)throw new Error("Malformed AST");const p=m.children.indexOf(y.parent);let c,r=y.parent.offset+y.parent.length;if(p>0){const l=m.children[p-1];c=l.offset+l.length}else c=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return A(I,{offset:c,length:r-c,content:""},g)}else return A(I,{offset:y.offset,length:y.length,content:JSON.stringify(E)},g);else{if(E===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,c=S?S(m.children.map(l=>l.children[0].value)):m.children.length;let r;if(c>0){const l=m.children[c-1];r={offset:l.offset+l.length,length:0,content:","+p}}else m.children.length===0?r={offset:m.offset+1,length:0,content:p}:r={offset:m.offset+1,length:0,content:p+","};return A(I,r,g)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(E!==void 0){const y=`${JSON.stringify(E)}`;let p;if(m.children.length===0||w===0)p={offset:m.offset+1,length:0,content:m.children.length===0?y:y+","};else{const c=w===-1||w>m.children.length?m.children.length:w,r=m.children[c-1];p={offset:r.offset+r.length,length:0,content:","+y}}return A(I,p,g)}else{const y=w,p=m.children[y];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===y){const r=m.children[y-1],l=r.offset+r.length,i=m.offset+m.length;c={offset:l,length:i-2-l,content:""}}else c={offset:p.offset,length:m.children[y+1].offset-p.offset,content:""};return A(I,c,g)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(I,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},g)}}e.setProperty=L;function A(I,D,E){let g=P(I,D),S=D.offset,d=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;S>0&&!(0,n.isEOL)(g,S-1);)S--;for(;d<g.length&&!(0,n.isEOL)(g,d);)d++}const h=(0,n.format)(g,{offset:S,length:d-S},E);for(let m=h.length-1;m>=0;m--){const w=h[m];g=P(g,w),S=Math.min(S,w.offset),d=Math.max(d,w.offset+w.length),d+=w.content.length-w.length}const v=I.length-(g.length-d)-S;return[{offset:S,length:v,content:g.substring(S,d)}]}e.withFormatting=A;function P(I,D){return I.substring(0,D.offset)+D.content+I.substring(D.offset+D.length)}e.applyEdit=P;function b(I,D){let E=D.slice(0).sort((S,d)=>{const h=S.offset-d.offset;return h===0?S.length-d.length:h}),g=I.length;for(let S=E.length-1;S>=0;S--){let d=E[S];if(d.offset+d.length<=g)I=P(I,d);else throw new Error("Overlapping edit");g=d.offset}return I}e.applyEdits=b}),define(te[100],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new k(()=>T(this.getValue()))}}e.Lazy=k}),define(te[2],ne([0,1,69,55]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let L=null;function A(o){L=o}if(e.setDisposableTracker=A,T){const o="__is_disposable_tracked__";A(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function P(o){return L?.trackDisposable(o),o}function b(o){L?.markAsDisposed(o)}function I(o,s){L?.setParent(o,s)}function D(o,s){if(!!L)for(const a of o)L.setParent(a,s)}function E(o){return L?.markAsSingleton(o),o}e.markAsSingleton=E;class g extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=g;function S(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=S;function d(o){if(n.Iterable.is(o)){let s=[];for(const a of o)if(a)try{a.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new g(s);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function h(...o){const s=v(()=>d(o));return D(o,s),s}e.combinedDisposable=h;function v(o){const s=P({dispose:(0,k.once)(()=>{b(s),o()})});return s}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return I(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,P(this),I(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&I(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&I(s,null),s}}e.MutableDisposable=y;class p{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,b(this))},this}}e.SafeDisposable=c;class r{constructor(){this.references=new Map}acquire(s,...a){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,u));const{object:f}=u,C=(0,k.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:f,dispose:C}}}e.ReferenceCollection=r;class l{constructor(s){this.referenceCollection=s}async acquire(s,...a){const u=this.referenceCollection.acquire(s,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=l;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function t(o){const s=new m;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=t}),define(te[101],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(L){this.element=L,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class n{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let L=this._first;for(;L!==k.Undefined;){const A=L.next;L.prev=k.Undefined,L.next=k.Undefined,L=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const P=new k(L);if(this._first===k.Undefined)this._first=P,this._last=P;else if(A){const I=this._last;this._last=P,P.prev=I,I.next=P}else{const I=this._first;this._first=P,P.next=I,I.prev=P}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(P))}}shift(){if(this._first!==k.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==k.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==k.Undefined&&L.next!==k.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===k.Undefined&&L.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):L.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):L.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==k.Undefined;)yield L.element,L=L.next}}e.LinkedList=n}),function(){function K(T){const L=[];typeof T=="number"&&L.push("code/timeOrigin",T);function A(b){L.push(b,Date.now())}function P(){const b=[];for(let I=0;I<L.length;I+=2)b.push({name:L[I],startTime:L[I+1]});return b}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(T+A.startTime)});return L}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=k(n))}(),define(te[4],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let n=!1,T=!1,L=!1,A=!1,P=!1,b=!1,I=!1,D=!1,E=!1,g,S=k,d,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const m=typeof v?.versions?.electron=="string",w=m&&v?.type==="renderer";if(e.isElectronSandboxed=w&&v?.sandboxed,typeof navigator=="object"&&!w)h=navigator.userAgent,n=h.indexOf("Windows")>=0,T=h.indexOf("Macintosh")>=0,D=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,b=!0,g=navigator.language,S=g;else if(typeof v=="object"){n=v.platform==="win32",T=v.platform==="darwin",L=v.platform==="linux",A=L&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,I=m,E=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=k,S=k;const s=v.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),u=a.availableLanguages["*"];g=a.locale,S=u||k,d=a._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function p(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let c=0;T?c=1:n?c=3:L&&(c=2),e.isWindows=n,e.isMacintosh=T,e.isLinux=L,e.isLinuxSnap=A,e.isNative=P,e.isElectron=I,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=D,e.isCI=E,e.platform=c,e.userAgent=h,e.language=S;var r;(function(s){function a(){return e.language}s.value=a;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function f(){return e.language==="en"}s.isDefault=f})(r=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let f=0,C=s.length;f<C;f++){const _=s[f];if(_.id===u.data.vscodeScheduleAsyncWork){s.splice(f,1),_.callback();return}}});let a=0;return u=>{const f=++a;s.push({id:f,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return s=>setTimeout(s)})();var l;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||D?2:n?1:3;let i=!0,t=!1;function o(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[33],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const T=k.globals.vscode.process;n={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(te[10],ne([0,1,33]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,T=97,L=90,A=122,P=46,b=47,I=92,D=58,E=63;class g extends Error{constructor(p,c,r){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const i=p.indexOf(".")!==-1?"property":"argument";let t=`The "${p}" ${i} ${l} of type ${c}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(y,p){if(typeof y!="string")throw new g(p,"string",y)}function d(y){return y===b||y===I}function h(y){return y===b}function v(y){return y>=n&&y<=L||y>=T&&y<=A}function m(y,p,c,r){let l="",i=0,t=-1,o=0,s=0;for(let a=0;a<=y.length;++a){if(a<y.length)s=y.charCodeAt(a);else{if(r(s))break;s=b}if(r(s)){if(!(t===a-1||o===1))if(o===2){if(l.length<2||i!==2||l.charCodeAt(l.length-1)!==P||l.charCodeAt(l.length-2)!==P){if(l.length>2){const u=l.lastIndexOf(c);u===-1?(l="",i=0):(l=l.slice(0,u),i=l.length-1-l.lastIndexOf(c)),t=a,o=0;continue}else if(l.length!==0){l="",i=0,t=a,o=0;continue}}p&&(l+=l.length>0?`${c}..`:"..",i=2)}else l.length>0?l+=`${c}${y.slice(t+1,a)}`:l=y.slice(t+1,a),i=a-t-1;t=a,o=0}else s===P&&o!==-1?++o:o=-1}return l}function w(y,p){if(p===null||typeof p!="object")throw new g("pathObject","Object",p);const c=p.dir||p.root,r=p.base||`${p.name||""}${p.ext||""}`;return c?c===p.root?`${c}${r}`:`${c}${y}${r}`:r}e.win32={resolve(...y){let p="",c="",r=!1;for(let l=y.length-1;l>=-1;l--){let i;if(l>=0){if(i=y[l],S(i,"path"),i.length===0)continue}else p.length===0?i=k.cwd():(i=k.env[`=${p}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===I)&&(i=`${p}\\`));const t=i.length;let o=0,s="",a=!1;const u=i.charCodeAt(0);if(t===1)d(u)&&(o=1,a=!0);else if(d(u))if(a=!0,d(i.charCodeAt(1))){let f=2,C=f;for(;f<t&&!d(i.charCodeAt(f));)f++;if(f<t&&f!==C){const _=i.slice(C,f);for(C=f;f<t&&d(i.charCodeAt(f));)f++;if(f<t&&f!==C){for(C=f;f<t&&!d(i.charCodeAt(f));)f++;(f===t||f!==C)&&(s=`\\\\${_}\\${i.slice(C,f)}`,o=f)}}}else o=1;else v(u)&&i.charCodeAt(1)===D&&(s=i.slice(0,2),o=2,t>2&&d(i.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(p.length>0){if(s.toLowerCase()!==p.toLowerCase())continue}else p=s;if(r){if(p.length>0)break}else if(c=`${i.slice(o)}\\${c}`,r=a,a&&p.length>0)break}return c=m(c,!r,"\\",d),r?`${p}\\${c}`:`${p}${c}`||"."},normalize(y){S(y,"path");const p=y.length;if(p===0)return".";let c=0,r,l=!1;const i=y.charCodeAt(0);if(p===1)return h(i)?"\\":y;if(d(i))if(l=!0,d(y.charCodeAt(1))){let o=2,s=o;for(;o<p&&!d(y.charCodeAt(o));)o++;if(o<p&&o!==s){const a=y.slice(s,o);for(s=o;o<p&&d(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&!d(y.charCodeAt(o));)o++;if(o===p)return`\\\\${a}\\${y.slice(s)}\\`;o!==s&&(r=`\\\\${a}\\${y.slice(s,o)}`,c=o)}}}else c=1;else v(i)&&y.charCodeAt(1)===D&&(r=y.slice(0,2),c=2,p>2&&d(y.charCodeAt(2))&&(l=!0,c=3));let t=c<p?m(y.slice(c),!l,"\\",d):"";return t.length===0&&!l&&(t="."),t.length>0&&d(y.charCodeAt(p-1))&&(t+="\\"),r===void 0?l?`\\${t}`:t:l?`${r}\\${t}`:`${r}${t}`},isAbsolute(y){S(y,"path");const p=y.length;if(p===0)return!1;const c=y.charCodeAt(0);return d(c)||p>2&&v(c)&&y.charCodeAt(1)===D&&d(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let p,c;for(let i=0;i<y.length;++i){const t=y[i];S(t,"path"),t.length>0&&(p===void 0?p=c=t:p+=`\\${t}`)}if(p===void 0)return".";let r=!0,l=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++l;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++l,i>2&&(d(c.charCodeAt(2))?++l:r=!1))}if(r){for(;l<p.length&&d(p.charCodeAt(l));)l++;l>=2&&(p=`\\${p.slice(l)}`)}return e.win32.normalize(p)},relative(y,p){if(S(y,"from"),S(p,"to"),y===p)return"";const c=e.win32.resolve(y),r=e.win32.resolve(p);if(c===r||(y=c.toLowerCase(),p=r.toLowerCase(),y===p))return"";let l=0;for(;l<y.length&&y.charCodeAt(l)===I;)l++;let i=y.length;for(;i-1>l&&y.charCodeAt(i-1)===I;)i--;const t=i-l;let o=0;for(;o<p.length&&p.charCodeAt(o)===I;)o++;let s=p.length;for(;s-1>o&&p.charCodeAt(s-1)===I;)s--;const a=s-o,u=t<a?t:a;let f=-1,C=0;for(;C<u;C++){const O=y.charCodeAt(l+C);if(O!==p.charCodeAt(o+C))break;O===I&&(f=C)}if(C!==u){if(f===-1)return r}else{if(a>u){if(p.charCodeAt(o+C)===I)return r.slice(o+C+1);if(C===2)return r.slice(o+C)}t>u&&(y.charCodeAt(l+C)===I?f=C:C===2&&(f=3)),f===-1&&(f=0)}let _="";for(C=l+f+1;C<=i;++C)(C===i||y.charCodeAt(C)===I)&&(_+=_.length===0?"..":"\\..");return o+=f,_.length>0?`${_}${r.slice(o,s)}`:(r.charCodeAt(o)===I&&++o,r.slice(o,s))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const p=e.win32.resolve(y);if(p.length<=2)return y;if(p.charCodeAt(0)===I){if(p.charCodeAt(1)===I){const c=p.charCodeAt(2);if(c!==E&&c!==P)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(v(p.charCodeAt(0))&&p.charCodeAt(1)===D&&p.charCodeAt(2)===I)return`\\\\?\\${p}`;return y},dirname(y){S(y,"path");const p=y.length;if(p===0)return".";let c=-1,r=0;const l=y.charCodeAt(0);if(p===1)return d(l)?y:".";if(d(l)){if(c=r=1,d(y.charCodeAt(1))){let o=2,s=o;for(;o<p&&!d(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&d(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&!d(y.charCodeAt(o));)o++;if(o===p)return y;o!==s&&(c=r=o+1)}}}}else v(l)&&y.charCodeAt(1)===D&&(c=p>2&&d(y.charCodeAt(2))?3:2,r=c);let i=-1,t=!0;for(let o=p-1;o>=r;--o)if(d(y.charCodeAt(o))){if(!t){i=o;break}}else t=!1;if(i===-1){if(c===-1)return".";i=c}return y.slice(0,i)},basename(y,p){p!==void 0&&S(p,"ext"),S(y,"path");let c=0,r=-1,l=!0,i;if(y.length>=2&&v(y.charCodeAt(0))&&y.charCodeAt(1)===D&&(c=2),p!==void 0&&p.length>0&&p.length<=y.length){if(p===y)return"";let t=p.length-1,o=-1;for(i=y.length-1;i>=c;--i){const s=y.charCodeAt(i);if(d(s)){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1),t>=0&&(s===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return c===r?r=o:r===-1&&(r=y.length),y.slice(c,r)}for(i=y.length-1;i>=c;--i)if(d(y.charCodeAt(i))){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1);return r===-1?"":y.slice(c,r)},extname(y){S(y,"path");let p=0,c=-1,r=0,l=-1,i=!0,t=0;y.length>=2&&y.charCodeAt(1)===D&&v(y.charCodeAt(0))&&(p=r=2);for(let o=y.length-1;o>=p;--o){const s=y.charCodeAt(o);if(d(s)){if(!i){r=o+1;break}continue}l===-1&&(i=!1,l=o+1),s===P?c===-1?c=o:t!==1&&(t=1):c!==-1&&(t=-1)}return c===-1||l===-1||t===0||t===1&&c===l-1&&c===r+1?"":y.slice(c,l)},format:w.bind(null,"\\"),parse(y){S(y,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return p;const c=y.length;let r=0,l=y.charCodeAt(0);if(c===1)return d(l)?(p.root=p.dir=y,p):(p.base=p.name=y,p);if(d(l)){if(r=1,d(y.charCodeAt(1))){let f=2,C=f;for(;f<c&&!d(y.charCodeAt(f));)f++;if(f<c&&f!==C){for(C=f;f<c&&d(y.charCodeAt(f));)f++;if(f<c&&f!==C){for(C=f;f<c&&!d(y.charCodeAt(f));)f++;f===c?r=f:f!==C&&(r=f+1)}}}}else if(v(l)&&y.charCodeAt(1)===D){if(c<=2)return p.root=p.dir=y,p;if(r=2,d(y.charCodeAt(2))){if(c===3)return p.root=p.dir=y,p;r=3}}r>0&&(p.root=y.slice(0,r));let i=-1,t=r,o=-1,s=!0,a=y.length-1,u=0;for(;a>=r;--a){if(l=y.charCodeAt(a),d(l)){if(!s){t=a+1;break}continue}o===-1&&(s=!1,o=a+1),l===P?i===-1?i=a:u!==1&&(u=1):i!==-1&&(u=-1)}return o!==-1&&(i===-1||u===0||u===1&&i===o-1&&i===t+1?p.base=p.name=y.slice(t,o):(p.name=y.slice(t,i),p.base=y.slice(t,o),p.ext=y.slice(i,o))),t>0&&t!==r?p.dir=y.slice(0,t-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let p="",c=!1;for(let r=y.length-1;r>=-1&&!c;r--){const l=r>=0?y[r]:k.cwd();S(l,"path"),l.length!==0&&(p=`${l}/${p}`,c=l.charCodeAt(0)===b)}return p=m(p,!c,"/",h),c?`/${p}`:p.length>0?p:"."},normalize(y){if(S(y,"path"),y.length===0)return".";const p=y.charCodeAt(0)===b,c=y.charCodeAt(y.length-1)===b;return y=m(y,!p,"/",h),y.length===0?p?"/":c?"./":".":(c&&(y+="/"),p?`/${y}`:y)},isAbsolute(y){return S(y,"path"),y.length>0&&y.charCodeAt(0)===b},join(...y){if(y.length===0)return".";let p;for(let c=0;c<y.length;++c){const r=y[c];S(r,"path"),r.length>0&&(p===void 0?p=r:p+=`/${r}`)}return p===void 0?".":e.posix.normalize(p)},relative(y,p){if(S(y,"from"),S(p,"to"),y===p||(y=e.posix.resolve(y),p=e.posix.resolve(p),y===p))return"";const c=1,r=y.length,l=r-c,i=1,t=p.length-i,o=l<t?l:t;let s=-1,a=0;for(;a<o;a++){const f=y.charCodeAt(c+a);if(f!==p.charCodeAt(i+a))break;f===b&&(s=a)}if(a===o)if(t>o){if(p.charCodeAt(i+a)===b)return p.slice(i+a+1);if(a===0)return p.slice(i+a)}else l>o&&(y.charCodeAt(c+a)===b?s=a:a===0&&(s=0));let u="";for(a=c+s+1;a<=r;++a)(a===r||y.charCodeAt(a)===b)&&(u+=u.length===0?"..":"/..");return`${u}${p.slice(i+s)}`},toNamespacedPath(y){return y},dirname(y){if(S(y,"path"),y.length===0)return".";const p=y.charCodeAt(0)===b;let c=-1,r=!0;for(let l=y.length-1;l>=1;--l)if(y.charCodeAt(l)===b){if(!r){c=l;break}}else r=!1;return c===-1?p?"/":".":p&&c===1?"//":y.slice(0,c)},basename(y,p){p!==void 0&&S(p,"ext"),S(y,"path");let c=0,r=-1,l=!0,i;if(p!==void 0&&p.length>0&&p.length<=y.length){if(p===y)return"";let t=p.length-1,o=-1;for(i=y.length-1;i>=0;--i){const s=y.charCodeAt(i);if(s===b){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1),t>=0&&(s===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return c===r?r=o:r===-1&&(r=y.length),y.slice(c,r)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===b){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1);return r===-1?"":y.slice(c,r)},extname(y){S(y,"path");let p=-1,c=0,r=-1,l=!0,i=0;for(let t=y.length-1;t>=0;--t){const o=y.charCodeAt(t);if(o===b){if(!l){c=t+1;break}continue}r===-1&&(l=!1,r=t+1),o===P?p===-1?p=t:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===c+1?"":y.slice(p,r)},format:w.bind(null,"/"),parse(y){S(y,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return p;const c=y.charCodeAt(0)===b;let r;c?(p.root="/",r=1):r=0;let l=-1,i=0,t=-1,o=!0,s=y.length-1,a=0;for(;s>=r;--s){const u=y.charCodeAt(s);if(u===b){if(!o){i=s+1;break}continue}t===-1&&(o=!1,t=s+1),u===P?l===-1?l=s:a!==1&&(a=1):l!==-1&&(a=-1)}if(t!==-1){const u=i===0&&c?1:i;l===-1||a===0||a===1&&l===t-1&&l===i+1?p.base=p.name=y.slice(u,t):(p.name=y.slice(u,l),p.base=y.slice(u,t),p.ext=y.slice(l,t))}return i>0?p.dir=y.slice(0,i-1):c&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1,10]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex",E.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const g=(0,k.extname)(E),S=T[g.toLowerCase()];return S!==void 0?S:P(E)}e.getMediaOrTextMime=A;function P(E){const g=(0,k.extname)(E);return L[g.toLowerCase()]}e.getMediaMime=P;function b(E){for(const g in L)if(L[g]===E)return g}e.getExtensionForMimeType=b;const I=/^(.+)\/(.+?)(;.+)?$/;function D(E,g){const S=I.exec(E);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:g?void 0:E}e.normalizeMimeType=D}),define(te[103],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var n;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(L,...A){const P=A.reduce((D,E)=>(D[E]=!0,D),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(D=>!P[D]).forEach(D=>{for(let E=0;E<b.length;E++)if(D.search(b[E])!==-1){delete L[D];break}})}e.sanitizeProcessEnvironment=T}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var n in k)(typeof exports=="object"?exports:K)[n]=k[n]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function k(n){if(e[n])return e[n].exports;var T=e[n]={i:n,l:!1,exports:{}};return K[n].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=K,k.c=e,k.d=function(n,T,L){k.o(n,T)||Object.defineProperty(n,T,{enumerable:!0,get:L})},k.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},k.t=function(n,T){if(1&T&&(n=k(n)),8&T||4&T&&typeof n=="object"&&n&&n.__esModule)return n;var L=Object.create(null);if(k.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:n}),2&T&&typeof n!="string")for(var A in n)k.d(L,A,function(P){return n[P]}.bind(null,A));return L},k.n=function(n){var T=n&&n.__esModule?function(){return n.default}:function(){return n};return k.d(T,"a",T),T},k.o=function(n,T){return Object.prototype.hasOwnProperty.call(n,T)},k.p="",k(k.s=0)}([function(K,e,k){(function(n){var T;e=K.exports=U,T=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],I=0,D=I++;b[D]="0|[1-9]\\d*";var E=I++;b[E]="[0-9]+";var g=I++;b[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=I++;b[S]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var d=I++;b[d]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var h=I++;b[h]="(?:"+b[D]+"|"+b[g]+")";var v=I++;b[v]="(?:"+b[E]+"|"+b[g]+")";var m=I++;b[m]="(?:-("+b[h]+"(?:\\."+b[h]+")*))";var w=I++;b[w]="(?:-?("+b[v]+"(?:\\."+b[v]+")*))";var y=I++;b[y]="[0-9A-Za-z-]+";var p=I++;b[p]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var c=I++,r="v?"+b[S]+b[m]+"?"+b[p]+"?";b[c]="^"+r+"$";var l="[v=\\s]*"+b[d]+b[w]+"?"+b[p]+"?",i=I++;b[i]="^"+l+"$";var t=I++;b[t]="((?:<|>)?=?)";var o=I++;b[o]=b[E]+"|x|X|\\*";var s=I++;b[s]=b[D]+"|x|X|\\*";var a=I++;b[a]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[m]+")?"+b[p]+"?)?)?";var u=I++;b[u]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[p]+"?)?)?";var f=I++;b[f]="^"+b[t]+"\\s*"+b[a]+"$";var C=I++;b[C]="^"+b[t]+"\\s*"+b[u]+"$";var _=I++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=I++;b[O]="(?:~>?)";var F=I++;b[F]="(\\s*)"+b[O]+"\\s+",P[F]=new RegExp(b[F],"g");var R=I++;b[R]="^"+b[O]+b[a]+"$";var N=I++;b[N]="^"+b[O]+b[u]+"$";var $=I++;b[$]="(?:\\^)";var j=I++;b[j]="(\\s*)"+b[$]+"\\s+",P[j]=new RegExp(b[j],"g");var X=I++;b[X]="^"+b[$]+b[a]+"$";var z=I++;b[z]="^"+b[$]+b[u]+"$";var J=I++;b[J]="^"+b[t]+"\\s*("+l+")$|^$";var B=I++;b[B]="^"+b[t]+"\\s*("+r+")$|^$";var x=I++;b[x]="(\\s*)"+b[t]+"\\s*("+l+"|"+b[a]+")",P[x]=new RegExp(b[x],"g");var ee=I++;b[ee]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var V=I++;b[V]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var Z=I++;b[Z]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)T(Y,b[Y]),P[Y]||(P[Y]=new RegExp(b[Y]));function q(ie,ae){if(ie instanceof U)return ie;if(typeof ie!="string"||ie.length>L||!(ae?P[i]:P[c]).test(ie))return null;try{return new U(ie,ae)}catch{return null}}function U(ie,ae){if(ie instanceof U){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(ie,ae);T("SemVer",ie,ae),this.loose=ae;var le=ie.trim().match(ae?P[i]:P[c]);if(!le)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var be=+ye;if(be>=0&&be<A)return be}return ye}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=q,e.valid=function(ie,ae){var le=q(ie,ae);return le?le.version:null},e.clean=function(ie,ae){var le=q(ie.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ie){return T("SemVer.compare",this.version,this.loose,ie),ie instanceof U||(ie=new U(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},U.prototype.compareMain=function(ie){return ie instanceof U||(ie=new U(ie,this.loose)),W(this.major,ie.major)||W(this.minor,ie.minor)||W(this.patch,ie.patch)},U.prototype.comparePre=function(ie){if(ie instanceof U||(ie=new U(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],ye=ie.prerelease[ae];if(T("prerelease compare",ae,le,ye),le===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(le===void 0)return-1;if(le!==ye)return W(le,ye)}while(++ae)},U.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,le,ye){typeof le=="string"&&(ye=le,le=void 0);try{return new U(ie,le).inc(ae,ye).version}catch{return null}},e.diff=function(ie,ae){if(ue(ie,ae))return null;var le=q(ie),ye=q(ae);if(le.prerelease.length||ye.prerelease.length){for(var be in le)if((be==="major"||be==="minor"||be==="patch")&&le[be]!==ye[be])return"pre"+be;return"prerelease"}for(var be in le)if((be==="major"||be==="minor"||be==="patch")&&le[be]!==ye[be])return be},e.compareIdentifiers=W;var M=/^[0-9]+$/;function W(ie,ae){var le=M.test(ie),ye=M.test(ae);return le&&ye&&(ie=+ie,ae=+ae),le&&!ye?-1:ye&&!le?1:ie<ae?-1:ie>ae?1:0}function H(ie,ae,le){return new U(ie,le).compare(new U(ae,le))}function re(ie,ae,le){return H(ie,ae,le)>0}function se(ie,ae,le){return H(ie,ae,le)<0}function ue(ie,ae,le){return H(ie,ae,le)===0}function de(ie,ae,le){return H(ie,ae,le)!==0}function we(ie,ae,le){return H(ie,ae,le)>=0}function pe(ie,ae,le){return H(ie,ae,le)<=0}function ge(ie,ae,le,ye){var be;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),be=ie===le;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),be=ie!==le;break;case"":case"=":case"==":be=ue(ie,le,ye);break;case"!=":be=de(ie,le,ye);break;case">":be=re(ie,le,ye);break;case">=":be=we(ie,le,ye);break;case"<":be=se(ie,le,ye);break;case"<=":be=pe(ie,le,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return be}function Ee(ie,ae){if(ie instanceof Ee){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof Ee))return new Ee(ie,ae);T("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(ie,ae){return W(ae,ie)},e.major=function(ie,ae){return new U(ie,ae).major},e.minor=function(ie,ae){return new U(ie,ae).minor},e.patch=function(ie,ae){return new U(ie,ae).patch},e.compare=H,e.compareLoose=function(ie,ae){return H(ie,ae,!0)},e.rcompare=function(ie,ae,le){return H(ae,ie,le)},e.sort=function(ie,ae){return ie.sort(function(le,ye){return e.compare(le,ye,ae)})},e.rsort=function(ie,ae){return ie.sort(function(le,ye){return e.rcompare(le,ye,ae)})},e.gt=re,e.lt=se,e.eq=ue,e.neq=de,e.gte=we,e.lte=pe,e.cmp=ge,e.Comparator=Ee;var Te={};function Ce(ie,ae){if(ie instanceof Ce)return ie.loose===ae?ie:new Ce(ie.raw,ae);if(ie instanceof Ee)return new Ce(ie.value,ae);if(!(this instanceof Ce))return new Ce(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function De(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function qe(ie,ae,le,ye,be,Ue,Le,Oe,_e,Q,oe,ce,fe){return((ae=De(le)?"":De(ye)?">="+le+".0.0":De(be)?">="+le+"."+ye+".0":">="+ae)+" "+(Oe=De(_e)?"":De(Q)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+Q+1)+".0":ce?"<="+_e+"."+Q+"."+oe+"-"+ce:"<="+Oe)).trim()}function Je(ie,ae){for(var le=0;le<ie.length;le++)if(!ie[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<ie.length;le++)if(T(ie[le].semver),ie[le].semver!==Te&&ie[le].semver.prerelease.length>0){var ye=ie[le].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function Ve(ie,ae,le){try{ae=new Ce(ae,le)}catch{return!1}return ae.test(ie)}function je(ie,ae,le,ye){var be,Ue,Le,Oe,_e;switch(ie=new U(ie,ye),ae=new Ce(ae,ye),le){case">":be=re,Ue=pe,Le=se,Oe=">",_e=">=";break;case"<":be=se,Ue=we,Le=re,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ie,ae,ye))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],ce=null,fe=null;if(oe.forEach(function(me){me.semver===Te&&(me=new Ee(">=0.0.0")),ce=ce||me,fe=fe||me,be(me.semver,ce.semver,ye)?ce=me:Le(me.semver,fe.semver,ye)&&(fe=me)}),ce.operator===Oe||ce.operator===_e||(!fe.operator||fe.operator===Oe)&&Ue(ie,fe.semver)||fe.operator===_e&&Le(ie,fe.semver))return!1}return!0}Ee.prototype.parse=function(ie){var ae=this.loose?P[J]:P[B],le=ie.match(ae);if(!le)throw new TypeError("Invalid comparator: "+ie);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new U(le[2],this.loose):this.semver=Te},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ie){return T("Comparator.test",ie,this.loose),this.semver===Te||(typeof ie=="string"&&(ie=new U(ie,this.loose)),ge(ie,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ie,ae){if(!(ie instanceof Ee))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ce(ie.value,ae),Ve(this.value,le,ae);if(ie.operator==="")return le=new Ce(this.value,ae),Ve(ie.semver,le,ae);var ye=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Ue=this.semver.version===ie.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Oe=ge(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),_e=ge(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return ye||be||Ue&&Le||Oe||_e},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),T("range",ie,ae);var le=ae?P[V]:P[ee];ie=ie.replace(le,qe),T("hyphen replace",ie),ie=ie.replace(P[x],"$1$2$3"),T("comparator trim",ie,P[x]),ie=(ie=(ie=ie.replace(P[F],"$1~")).replace(P[j],"$1^")).split(/\s+/).join(" ");var ye=ae?P[J]:P[B],be=ie.split(" ").map(function(Ue){return function(Le,Oe){return T("comp",Le),Le=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){T("caret",ce,fe);var me=fe?P[z]:P[X];return ce.replace(me,function(ke,Se,Pe,Re,Ie){var Ae;return T("caret",ce,ke,Se,Pe,Re,Ie),De(Se)?Ae="":De(Pe)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":De(Re)?Ae=Se==="0"?">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+".0 <"+(+Se+1)+".0.0":Ie?(T("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Re+Ie+" <"+Se+"."+Pe+"."+(+Re+1):">="+Se+"."+Pe+"."+Re+Ie+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Re+Ie+" <"+(+Se+1)+".0.0"):(T("no pr"),Ae=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Re+" <"+Se+"."+Pe+"."+(+Re+1):">="+Se+"."+Pe+"."+Re+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Re+" <"+(+Se+1)+".0.0"),T("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Le,Oe),T("caret",Le),Le=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){var me=fe?P[N]:P[R];return ce.replace(me,function(ke,Se,Pe,Re,Ie){var Ae;return T("tilde",ce,ke,Se,Pe,Re,Ie),De(Se)?Ae="":De(Pe)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":De(Re)?Ae=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":Ie?(T("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+Se+"."+Pe+"."+Re+Ie+" <"+Se+"."+(+Pe+1)+".0"):Ae=">="+Se+"."+Pe+"."+Re+" <"+Se+"."+(+Pe+1)+".0",T("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Le,Oe),T("tildes",Le),Le=function(_e,Q){return T("replaceXRanges",_e,Q),_e.split(/\s+/).map(function(oe){return function(ce,fe){ce=ce.trim();var me=fe?P[C]:P[f];return ce.replace(me,function(ke,Se,Pe,Re,Ie,Ae){T("xRange",ce,ke,Se,Pe,Re,Ie,Ae);var Fe=De(Pe),ze=Fe||De(Re),We=ze||De(Ie);return Se==="="&&We&&(Se=""),Fe?ke=Se===">"||Se==="<"?"<0.0.0":"*":Se&&We?(ze&&(Re=0),We&&(Ie=0),Se===">"?(Se=">=",ze?(Pe=+Pe+1,Re=0,Ie=0):We&&(Re=+Re+1,Ie=0)):Se==="<="&&(Se="<",ze?Pe=+Pe+1:Re=+Re+1),ke=Se+Pe+"."+Re+"."+Ie):ze?ke=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":We&&(ke=">="+Pe+"."+Re+".0 <"+Pe+"."+(+Re+1)+".0"),T("xRange return",ke),ke})}(oe,Q)}).join(" ")}(Le,Oe),T("xrange",Le),Le=function(_e,Q){return T("replaceStars",_e,Q),_e.trim().replace(P[Z],"")}(Le,Oe),T("stars",Le),Le}(Ue,ae)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ue){return!!Ue.match(ye)})),be=be.map(function(Ue){return new Ee(Ue,ae)})},Ce.prototype.intersects=function(ie,ae){if(!(ie instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(ye){return ie.set.some(function(be){return be.every(function(Ue){return ye.intersects(Ue,ae)})})})})},e.toComparators=function(ie,ae){return new Ce(ie,ae).set.map(function(le){return le.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new U(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Je(this.set[ae],ie))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ie,ae,le){var ye=null,be=null;try{var Ue=new Ce(ae,le)}catch{return null}return ie.forEach(function(Le){Ue.test(Le)&&(ye&&be.compare(Le)!==-1||(be=new U(ye=Le,le)))}),ye},e.minSatisfying=function(ie,ae,le){var ye=null,be=null;try{var Ue=new Ce(ae,le)}catch{return null}return ie.forEach(function(Le){Ue.test(Le)&&(ye&&be.compare(Le)!==1||(be=new U(ye=Le,le)))}),ye},e.validRange=function(ie,ae){try{return new Ce(ie,ae).range||"*"}catch{return null}},e.ltr=function(ie,ae,le){return je(ie,ae,"<",le)},e.gtr=function(ie,ae,le){return je(ie,ae,">",le)},e.outside=je,e.prerelease=function(ie,ae){var le=q(ie,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(ie,ae,le){return ie=new Ce(ie,le),ae=new Ce(ae,le),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof U)return ie;if(typeof ie!="string")return null;var ae=ie.match(P[_]);return ae==null?null:q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,k(1))},function(K,e){var k,n,T=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(v){if(k===setTimeout)return setTimeout(v,0);if((k===L||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:L}catch{k=L}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var b,I=[],D=!1,E=-1;function g(){D&&b&&(D=!1,b.length?I=b.concat(I):E=-1,I.length&&S())}function S(){if(!D){var v=P(g);D=!0;for(var m=I.length;m;){for(b=I,I=[];++E<m;)b&&b[E].run();E=-1,m=I.length}b=null,D=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(v)}}function d(v,m){this.fun=v,this.array=m}function h(){}T.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];I.push(new d(v,m)),I.length!==1||D||P(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=h,T.addListener=h,T.once=h,T.off=h,T.removeListener=h,T.removeAllListeners=h,T.emit=h,T.prependListener=h,T.prependOnceListener=h,T.listeners=function(v){return[]},T.binding=function(v){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(v){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(K,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(P,b,I){this.level=P,this.key=b,this.value=I,this.forward=[]}}const T=void 0;class L{constructor(P,b=2**16){this.comparator=P,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,T,T)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,b){return L._insert(this,P,b,this.comparator)&&(this._size+=1),this}delete(P){const b=L._delete(this,P,this.comparator);return b&&(this._size-=1),b}forEach(P,b){let I=this._header.forward[0];for(;I;)P.call(b,I.value,I.key,this),I=I.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",b=this._header.forward[0];for(;b;)P+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return P}static _search(P,b,I){let D=P._header;for(let E=P._level-1;E>=0;E--)for(;D.forward[E]&&I(D.forward[E].key,b)<0;)D=D.forward[E];if(D=D.forward[0],D&&I(D.key,b)===0)return D}static _insert(P,b,I,D){let E=[],g=P._header;for(let S=P._level-1;S>=0;S--){for(;g.forward[S]&&D(g.forward[S].key,b)<0;)g=g.forward[S];E[S]=g}if(g=g.forward[0],g&&D(g.key,b)===0)return g.value=I,!1;{let S=L._randomLevel(P);if(S>P._level){for(let d=P._level;d<S;d++)E[d]=P._header;P._level=S}g=new n(S,b,I);for(let d=0;d<S;d++)g.forward[d]=E[d].forward[d],E[d].forward[d]=g;return!0}}static _randomLevel(P,b=.5){let I=1;for(;Math.random()<b&&I<P._maxLevel;)I+=1;return I}static _delete(P,b,I){let D=[],E=P._header;for(let g=P._level-1;g>=0;g--){for(;E.forward[g]&&I(E.forward[g].key,b)<0;)E=E.forward[g];D[g]=E}if(E=E.forward[0],!E||I(E.key,b)!==0)return!1;for(let g=0;g<P._level&&D[g].forward[g]===E;g++)D[g].forward[g]=E.forward[g];for(;P._level>0&&P._header.forward[P._level-1]===T;)P._level-=1;return!0}}e.SkipList=L}),define(te[105],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=k.globals.performance&&typeof k.globals.performance.now=="function";class T{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new T(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=T}),define(te[3],ne([0,1,9,69,2,101,105]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let P=!1,b=!1;var I;(function(i){i.None=()=>T.Disposable.None;function t(V){if(b){const{onListenerDidAdd:Z}=V,Y=d.create();let q=0;V.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),Z?.()}}}function o(V){return(Z,Y=null,q)=>{let U=!1,M;return M=V(W=>{if(!U)return M?M.dispose():U=!0,Z.call(Y,W)},null,q),U&&M.dispose(),M}}i.once=o;function s(V,Z,Y){return O((q,U=null,M)=>V(W=>q.call(U,Z(W)),null,M),Y)}i.map=s;function a(V,Z,Y){return O((q,U=null,M)=>V(W=>{Z(W),q.call(U,W)},null,M),Y)}i.forEach=a;function u(V,Z,Y){return O((q,U=null,M)=>V(W=>Z(W)&&q.call(U,W),null,M),Y)}i.filter=u;function f(V){return V}i.signal=f;function C(...V){return(Z,Y=null,q)=>(0,T.combinedDisposable)(...V.map(U=>U(M=>Z.call(Y,M),null,q)))}i.any=C;function _(V,Z,Y,q){let U=Y;return s(V,M=>(U=Z(U,M),U),q)}i.reduce=_;function O(V,Z){let Y;const q={onFirstListenerAdd(){Y=V(U.fire,U)},onLastListenerRemove(){Y.dispose()}};Z||t(q);const U=new v(q);return Z&&Z.add(U),U.event}function F(V,Z,Y=100,q=!1,U,M){let W,H,re,se=0;const ue={leakWarningThreshold:U,onFirstListenerAdd(){W=V(we=>{se++,H=Z(H,we),q&&!re&&(de.fire(H),H=void 0),clearTimeout(re),re=setTimeout(()=>{const pe=H;H=void 0,re=void 0,(!q||se>1)&&de.fire(pe),se=0},Y)})},onLastListenerRemove(){W.dispose()}};M||t(ue);const de=new v(ue);return M&&M.add(de),de.event}i.debounce=F;function R(V,Z=(q,U)=>q===U,Y){let q=!0,U;return u(V,M=>{const W=q||!Z(M,U);return q=!1,U=M,W},Y)}i.latch=R;function N(V,Z,Y){return[i.filter(V,Z,Y),i.filter(V,q=>!Z(q),Y)]}i.split=N;function $(V,Z=!1,Y=[]){let q=Y.slice(),U=V(H=>{q?q.push(H):W.fire(H)});const M=()=>{q&&q.forEach(H=>W.fire(H)),q=null},W=new v({onFirstListenerAdd(){U||(U=V(H=>W.fire(H)))},onFirstListenerDidAdd(){q&&(Z?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return W.event}i.buffer=$;class j{constructor(Z){this.event=Z}map(Z){return new j(s(this.event,Z))}forEach(Z){return new j(a(this.event,Z))}filter(Z){return new j(u(this.event,Z))}reduce(Z,Y){return new j(_(this.event,Z,Y))}latch(){return new j(R(this.event))}debounce(Z,Y=100,q=!1,U){return new j(F(this.event,Z,Y,q,U))}on(Z,Y,q){return this.event(Z,Y,q)}once(Z,Y,q){return o(this.event)(Z,Y,q)}}function X(V){return new j(V)}i.chain=X;function z(V,Z,Y=q=>q){const q=(...H)=>W.fire(Y(...H)),U=()=>V.on(Z,q),M=()=>V.removeListener(Z,q),W=new v({onFirstListenerAdd:U,onLastListenerRemove:M});return W.event}i.fromNodeEventEmitter=z;function J(V,Z,Y=q=>q){const q=(...H)=>W.fire(Y(...H)),U=()=>V.addEventListener(Z,q),M=()=>V.removeEventListener(Z,q),W=new v({onFirstListenerAdd:U,onLastListenerRemove:M});return W.event}i.fromDOMEventEmitter=J;function B(V){return new Promise(Z=>o(V)(Z))}i.toPromise=B;function x(V,Z){return Z(void 0),V(Y=>Z(Y))}i.runAndSubscribe=x;function ee(V,Z){let Y=null;function q(M){Y?.dispose(),Y=new T.DisposableStore,Z(M,Y)}q(void 0);const U=V(M=>q(M));return(0,T.toDisposable)(()=>{U.dispose(),Y?.dispose()})}i.runAndSubscribeWithStore=ee})(I=e.Event||(e.Event={}));class D{constructor(t){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${t}_${D._idPool++}`}start(t){this._stopWatch=new A.StopWatch(!0),this._listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this._elapsedOverall+=t,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${t.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let E=-1;function g(i){const t=E;return E=i,{dispose(){E=t}}}e.setGlobalLeakWarningThreshold=g;class S{constructor(t,o=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,o){let s=E;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||o<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let u,f=0;for(const[C,_]of this._stacks)(!u||f<_)&&(u=C,f=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${f}):`),console.warn(u)}return()=>{const u=this._stacks.get(t.value)||0;this._stacks.set(t.value,u-1)}}}class d{constructor(t){this.value=t}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(t,o,s){this.callback=t,this.callbackThis=o,this.stack=s,this.subscription=new T.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class v{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=E>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const o of t)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,o,s)=>{this._listeners||(this._listeners=new L.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let u,f;this._leakageMon&&this._listeners.size>=30&&(f=d.create(),u=this._leakageMon.check(f,this._listeners.size+1)),P&&(f=f??d.create());const C=new h(t,o,f),_=this._listeners.push(C);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,o);const O=C.subscription.set(()=>{u&&u(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof T.DisposableStore?s.add(O):Array.isArray(s)&&s.push(O),O}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,t]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,s]=this._deliveryQueue.shift();try{o.invoke(s)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class m extends v{async fireAsync(t,o,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,t]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[a,u]=this._asyncDeliveryQueue.shift(),f=[],C={...u,token:o,waitUntil:_=>{if(Object.isFrozen(f))throw new Error("waitUntil can NOT be called asynchronous");s&&(_=s(_,a.callback)),f.push(_)}};try{a.invoke(C)}catch(_){(0,k.onUnexpectedError)(_);continue}Object.freeze(f),await Promise.allSettled(f).then(_=>{for(const O of _)O.status==="rejected"&&(0,k.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=m;class w extends v{constructor(t){super(t);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=w;class y extends w{constructor(t){super(t);this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=y;class p extends v{constructor(t){super(t);this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=p;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const o={event:t,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const s=()=>{this.hasListeners&&this.unhook(o);const a=this.events.indexOf(o);this.events.splice(a,1)};return(0,T.toDisposable)((0,n.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(o=>this.emitter.fire(o))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class r{constructor(){this.buffers=[]}wrapEvent(t){return(o,s,a)=>t(u=>{const f=this.buffers[this.buffers.length-1];f?f.push(()=>o.call(s,u)):o.call(s,u)},void 0,a)}bufferEvents(t){const o=[];this.buffers.push(o);const s=t();return this.buffers.pop(),o.forEach(a=>a()),s}}e.EventBufferer=r;class l{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=T.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(te[25],ne([0,1,3]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(P,b){const I=setTimeout(P.bind(b),0);return{dispose(){clearTimeout(I)}}});var T;(function(P){function b(I){return I===P.None||I===P.Cancelled||I instanceof L?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=b,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(T=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=T.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=A}),define(te[106],ne([0,1,25]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new k.CancellationTokenSource,P=this.task(A.token);return this.result={promise:P,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=n;class T{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const P=JSON.stringify(A);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=T}),define(te[40],ne([0,1,9,2]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(p){const c=p;return c?typeof c.read=="function":!1}e.isReadable=T;function L(p){const c=p;return c?[c.on,c.pause,c.resume,c.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function A(p){const c=p;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(p,c){return new b(p,c)}e.newWriteableStream=P;class b{constructor(c,r){this.reducer=c,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(r=>r(c))}emitError(c){this.listeners.error.length===0?(0,k.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(r=>r(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,r){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(c,r){if(this.state.destroyed)return;let l;switch(c){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(r);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(p,c){const r=[];let l;for(;(l=p.read())!==null;)r.push(l);return c(r)}e.consumeReadable=I;function D(p,c,r){const l=[];let i;for(;(i=p.read())!==null&&l.length<r;)l.push(i);return i===null&&l.length>0?c(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i!="undefined"){const t=i;return i=void 0,t}return p.read()}}}e.peekReadable=D;function E(p,c){return new Promise((r,l)=>{const i=[];g(p,{onData:t=>{c&&i.push(t)},onError:t=>{c?l(t):r(void 0)},onEnd:()=>{r(c?c(i):void 0)}})})}e.consumeStream=E;function g(p,c){let r=!1;return p.on("error",l=>{r||c.onError(l)}),p.on("end",()=>{r||c.onEnd()}),p.on("data",l=>{r||c.onData(l)}),(0,n.toDisposable)(()=>r=!0)}e.listenStream=g;function S(p,c){return new Promise((r,l)=>{const i=new n.DisposableStore,t=[],o=u=>{if(t.push(u),t.length>c)return i.dispose(),p.pause(),r({stream:p,buffer:t,ended:!1})},s=u=>l(u),a=()=>r({stream:p,buffer:t,ended:!0});i.add((0,n.toDisposable)(()=>p.removeListener("error",s))),p.on("error",s),i.add((0,n.toDisposable)(()=>p.removeListener("end",a))),p.on("end",a),i.add((0,n.toDisposable)(()=>p.removeListener("data",o))),p.on("data",o)})}e.peekStream=S;function d(p,c){const r=P(c);return r.end(p),r}e.toStream=d;function h(){const p=P(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=h;function v(p){let c=!1;return{read:()=>c?null:(c=!0,p)}}e.toReadable=v;function m(p,c,r){const l=P(r);return g(p,{onData:i=>l.write(c.data(i)),onError:i=>l.error(c.error?c.error(i):i),onEnd:()=>l.end()}),l}e.transform=m;function w(p,c,r){let l=!1;return{read:()=>{const i=c.read();return l?i:(l=!0,i!==null?r([p,i]):p)}}}e.prefixedReadable=w;function y(p,c,r){let l=!1;const i=P(r);return g(c,{onData:t=>l?i.write(t):(l=!0,i.write(r([p,t]))),onError:t=>i.error(t),onEnd:()=>{l||(l=!0,i.write(p)),i.end()}}),i}e.prefixedStream=y}),define(te[17],ne([0,1,40]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let T,L;class A{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return n?new A(Buffer.allocUnsafe(u)):new A(new Uint8Array(u))}static wrap(u){return n&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new A(u)}static fromString(u,f){return!(f?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(u)):(T||(T=new TextEncoder),new A(T.encode(u)))}static fromByteArray(u){const f=A.alloc(u.length);for(let C=0,_=u.length;C<_;C++)f.buffer[C]=u[C];return f}static concat(u,f){if(typeof f=="undefined"){f=0;for(let O=0,F=u.length;O<F;O++)f+=u[O].byteLength}const C=A.alloc(f);let _=0;for(let O=0,F=u.length;O<F;O++){const R=u[O];C.set(R,_),_+=R.byteLength}return C}clone(){const u=A.alloc(this.byteLength);return u.set(this),u}toString(){return n?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(u,f){return new A(this.buffer.subarray(u,f))}set(u,f){if(u instanceof A)this.buffer.set(u.buffer,f);else if(u instanceof Uint8Array)this.buffer.set(u,f);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),f);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return I(this.buffer,u)}writeUInt32BE(u,f){D(this.buffer,u,f)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,f){g(this.buffer,u,f)}readUInt8(u){return S(this.buffer,u)}writeUInt8(u,f){d(this.buffer,u,f)}}e.VSBuffer=A;function P(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=P;function b(a,u,f){a[f+0]=u&255,u=u>>>8,a[f+1]=u&255}e.writeUInt16LE=b;function I(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=I;function D(a,u,f){a[f+3]=u,u=u>>>8,a[f+2]=u,u=u>>>8,a[f+1]=u,u=u>>>8,a[f]=u}e.writeUInt32BE=D;function E(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=E;function g(a,u,f){a[f+0]=u&255,u=u>>>8,a[f+1]=u&255,u=u>>>8,a[f+2]=u&255,u=u>>>8,a[f+3]=u&255}e.writeUInt32LE=g;function S(a,u){return a[u]}e.readUInt8=S;function d(a,u,f){a[f]=u}e.writeUInt8=d;function h(a){return k.consumeReadable(a,u=>A.concat(u))}e.readableToBuffer=h;function v(a){return k.toReadable(a)}e.bufferToReadable=v;function m(a){return k.consumeStream(a,u=>A.concat(u))}e.streamToBuffer=m;async function w(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=w;function y(a){return k.toStream(a,u=>A.concat(u))}e.bufferToStream=y;function p(a){return k.transform(a,{data:u=>typeof u=="string"?A.fromString(u):A.wrap(u)},u=>A.concat(u))}e.streamToBufferReadableStream=p;function c(a){return k.newWriteableStream(u=>A.concat(u),a)}e.newWriteableBufferStream=c;function r(a,u){return k.prefixedReadable(a,u,f=>A.concat(f))}e.prefixedBufferReadable=r;function l(a,u){return k.prefixedStream(a,u,f=>A.concat(f))}e.prefixedBufferStream=l;function i(a){let u=0,f=0,C=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=R=>{switch(f){case 3:_[C++]=u|R,f=0;break;case 2:_[C++]=u|R>>>2,u=R<<6,f=3;break;case 1:_[C++]=u|R>>>4,u=R<<4,f=2;break;default:u=R<<2,f=1}};for(let R=0;R<a.length;R++){const N=a.charCodeAt(R);if(N>=65&&N<=90)O(N-65);else if(N>=97&&N<=122)O(N-97+26);else if(N>=48&&N<=57)O(N-48+52);else if(N===43||N===45)O(62);else if(N===47||N===95)O(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[R]}`)}}const F=C;for(;f>0;)O(0);return A.wrap(_).slice(0,F)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},u=!0,f=!1){const C=f?o:t;let _="";const O=a.byteLength%3;let F=0;for(;F<a.byteLength-O;F+=3){const R=a[F+0],N=a[F+1],$=a[F+2];_+=C[R>>>2],_+=C[(R<<4|N>>>4)&63],_+=C[(N<<2|$>>>6)&63],_+=C[$&63]}if(O===1){const R=a[F+0];_+=C[R>>>2],_+=C[R<<4&63],u&&(_+="==")}else if(O===2){const R=a[F+0],N=a[F+1];_+=C[R>>>2],_+=C[(R<<4|N>>>4)&63],_+=C[N<<2&63],u&&(_+="=")}return _}e.encodeBase64=s}),define(te[26],ne([0,1,106,100]),function(K,e,k,n){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function P(Q,...oe){return oe.length===0?Q:Q.replace(A,function(ce,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?ce:oe[me]})}e.format=P;const b=/{([^}]+)}/g;function I(Q,oe){return Q.replace(b,(ce,fe)=>oe[fe]??ce)}e.format2=I;function D(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=D;function E(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function g(Q,oe){let ce=0;const fe=oe.charCodeAt(0);for(let me=Q.length-1;me>=0;me--)Q.charCodeAt(me)===fe&&ce++;return ce}e.count=g;function S(Q,oe,ce="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${ce}`}e.truncate=S;function d(Q,oe=" "){const ce=h(Q,oe);return v(ce,oe)}e.trim=d;function h(Q,oe){if(!Q||!oe)return Q;const ce=oe.length;if(ce===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+ce;return Q.substring(fe)}e.ltrim=h;function v(Q,oe){if(!Q||!oe)return Q;const ce=oe.length,fe=Q.length;if(ce===0||fe===0)return Q;let me=fe,ke=-1;for(;ke=Q.lastIndexOf(oe,me-1),!(ke===-1||ke+ce!==me);){if(ke===0)return"";me=ke}return Q.substring(0,me)}e.rtrim=v;function m(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function y(Q,oe,ce={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=E(Q)),ce.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return ce.global&&(fe+="g"),ce.matchCase||(fe+="i"),ce.multiline&&(fe+="m"),ce.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=y;function p(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function c(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function l(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=l;function i(Q){for(let oe=0,ce=Q.length;oe<ce;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,ce=Q.length){for(let fe=oe;fe<ce;fe++){const me=Q.charCodeAt(fe);if(me!==32&&me!==9)return Q.substring(oe,fe)}return Q.substring(oe,ce)}e.getLeadingWhitespace=t;function o(Q,oe=Q.length-1){for(let ce=oe;ce>=0;ce--){const fe=Q.charCodeAt(ce);if(fe!==32&&fe!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function s(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=s;function a(Q,oe,ce=0,fe=Q.length,me=0,ke=oe.length){for(;ce<fe&&me<ke;ce++,me++){let Re=Q.charCodeAt(ce),Ie=oe.charCodeAt(me);if(Re<Ie)return-1;if(Re>Ie)return 1}const Se=fe-ce,Pe=ke-me;return Se<Pe?-1:Se>Pe?1:0}e.compareSubstring=a;function u(Q,oe){return f(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=u;function f(Q,oe,ce=0,fe=Q.length,me=0,ke=oe.length){for(;ce<fe&&me<ke;ce++,me++){let Re=Q.charCodeAt(ce),Ie=oe.charCodeAt(me);if(Re===Ie)continue;if(Re>=128||Ie>=128)return a(Q.toLowerCase(),oe.toLowerCase(),ce,fe,me,ke);C(Re)&&(Re-=32),C(Ie)&&(Ie-=32);const Ae=Re-Ie;if(Ae!==0)return Ae}const Se=fe-ce,Pe=ke-me;return Se<Pe?-1:Se>Pe?1:0}e.compareSubstringIgnoreCase=f;function C(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=C;function _(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=_;function O(Q,oe){return Q.length===oe.length&&f(Q,oe)===0}e.equalsIgnoreCase=O;function F(Q,oe){const ce=oe.length;return oe.length>Q.length?!1:f(Q,oe,0,ce)===0}e.startsWithIgnoreCase=F;function R(Q,oe){let ce,fe=Math.min(Q.length,oe.length);for(ce=0;ce<fe;ce++)if(Q.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return fe}e.commonPrefixLength=R;function N(Q,oe){let ce,fe=Math.min(Q.length,oe.length);const me=Q.length-1,ke=oe.length-1;for(ce=0;ce<fe;ce++)if(Q.charCodeAt(me-ce)!==oe.charCodeAt(ke-ce))return ce;return fe}e.commonSuffixLength=N;function $(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=$;function j(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=j;function X(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=X;function z(Q,oe,ce){const fe=Q.charCodeAt(ce);if($(fe)&&ce+1<oe){const me=Q.charCodeAt(ce+1);if(j(me))return X(fe,me)}return fe}e.getNextCodePoint=z;function J(Q,oe){const ce=Q.charCodeAt(oe-1);if(j(ce)&&oe>1){const fe=Q.charCodeAt(oe-2);if($(fe))return X(fe,ce)}return ce}class B{constructor(oe,ce=0){this._str=oe,this._len=oe.length,this._offset=ce}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=J(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=z(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class x{constructor(oe,ce=0){this._iterator=new B(oe,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const ke=ce.offset,Se=oe.getGraphemeBreakType(ce.nextCodePoint());if(je(me,Se)){ce.setOffset(ke);break}me=Se}return ce.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const ke=ce.offset,Se=oe.getGraphemeBreakType(ce.prevCodePoint());if(je(Se,me)){ce.setOffset(ke);break}me=Se}return fe-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function ee(Q,oe){return new x(Q,oe).nextGraphemeLength()}e.nextCharLength=ee;function V(Q,oe){return new x(Q,oe).prevGraphemeLength()}e.prevCharLength=V;function Z(Q,oe){oe>0&&j(Q.charCodeAt(oe))&&oe--;const ce=oe+ee(Q,oe);return[ce-V(Q,ce),ce]}e.getCharContainingOffset=Z;const Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(Q){return Y.test(Q)}e.containsRTL=q;const U=/^[\t\n\r\x20-\x7E]*$/;function M(Q){return U.test(Q)}e.isBasicASCII=M,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=W;function H(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=H;function re(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=re;function se(Q,oe){if(Q.length<oe)return Q;const ce=/\b/g;let fe=0;for(;ce.test(Q)&&!(Q.length-ce.lastIndex<oe);)fe=ce.lastIndex,ce.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function pe(Q){return Q&&(Q=Q.replace(ue,""),Q=Q.replace(de,""),Q=Q.replace(we,"")),Q}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function Ee(Q){return ge(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ee;function Te(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const ce=oe.length,fe=Q.toLowerCase();let me=0,ke=-1;for(;me<ce;){const Se=fe.indexOf(oe[me],ke+1);if(Se<0)return!1;ke=Se,me++}return!0}e.fuzzyContains=Te;function Ce(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Ce;function De(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=De;function qe(Q,oe=1){if(oe===0)return"";let ce=-1;do ce=Q.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?Q:(Q[ce-1]==="\r"&&ce--,Q.substr(0,ce))}e.getNLines=qe;function Je(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Je;function Ve(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=Ve;function je(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var ie;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,fe=ce.length/3;let me=1;for(;me<=fe;)if(oe<ce[3*me])me=2*me;else if(oe>ce[3*me+1])me=2*me+1;else return ce[3*me+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(Q,oe){if(Q===0)return 0;const ce=be(Q,oe);if(ce!==void 0)return ce;const fe=new B(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=ye;function be(Q,oe){const ce=new B(oe,Q);let fe=ce.prevCodePoint();for(;Ue(fe)||fe===65039||fe===8419;){if(ce.offset===0)return;fe=ce.prevCodePoint()}if(!re(fe))return;let me=ce.offset;return me>0&&ce.prevCodePoint()===8205&&(me=ce.offset),me}function Ue(Q){return 127995<=Q&&Q<=127999}var Le;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,T=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new k.LRUCachedComputed(Q=>{function oe(Ie){const Ae=new Map;for(let Fe=0;Fe<Ie.length;Fe+=2)Ae.set(Ie[Fe],Ie[Fe+1]);return Ae}function ce(Ie,Ae){const Fe=new Map(Ie);for(const[ze,We]of Ae)Fe.set(ze,We);return Fe}function fe(Ie,Ae){if(!Ie)return Ae;const Fe=new Map;for(const[ze,We]of Ie)Ae.has(ze)&&Fe.set(ze,We);return Fe}const me=T.ambiguousCharacterData.getValue();let ke=Q.filter(Ie=>!Ie.startsWith("_")&&Ie in me);ke.length===0&&(ke=["_default"]);let Se;for(const Ie of ke){const Ae=oe(me[Ie]);Se=fe(Se,Ae)}const Pe=oe(me._common),Re=ce(Pe,Se);return new Oe(Re)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(te[71],ne([0,1,26]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(m){return T(m,0)}e.hash=n;function T(m,w){switch(typeof m){case"object":return m===null?L(349,w):Array.isArray(m)?b(m,w):I(m,w);case"string":return P(m,w);case"boolean":return A(m,w);case"number":return L(m,w);case"undefined":return L(937,w);default:return L(617,w)}}e.doHash=T;function L(m,w){return(w<<5)-w+m|0}e.numberHash=L;function A(m,w){return L(m?433:863,w)}function P(m,w){w=L(149417,w);for(let y=0,p=m.length;y<p;y++)w=L(m.charCodeAt(y),w);return w}e.stringHash=P;function b(m,w){return w=L(104579,w),m.reduce((y,p)=>T(p,y),w)}function I(m,w){return w=L(181387,w),Object.keys(m).sort().reduce((y,p)=>(y=P(p,y),T(m[p],y)),w)}class D{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=T(w,this._value),this._value}}e.Hasher=D;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function g(m,w,y=32){const p=y-w,c=~((1<<p)-1);return(m<<w|(c&m)>>>p)>>>0}function S(m,w=0,y=m.byteLength,p=0){for(let c=0;c<y;c++)m[w+c]=p}function d(m,w,y="0"){for(;m.length<w;)m=y+m;return m}function h(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(y=>y.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),w/4)}e.toHexString=h;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const y=w.length;if(y===0)return;const p=this._buff;let c=this._buffLen,r=this._leftoverHighSurrogate,l,i;for(r!==0?(l=r,i=-1,r=0):(l=w.charCodeAt(0),i=0);;){let t=l;if(k.isHighSurrogate(l))if(i+1<y){const o=w.charCodeAt(i+1);k.isLowSurrogate(o)?(i++,t=k.computeCodePoint(l,o)):t=65533}else{r=l;break}else k.isLowSurrogate(l)&&(t=65533);if(c=this._push(p,c,t),i++,i<y)l=w.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=r}_push(w,y,p){return p<128?w[y++]=p:p<2048?(w[y++]=192|(p&1984)>>>6,w[y++]=128|(p&63)>>>0):p<65536?(w[y++]=224|(p&61440)>>>12,w[y++]=128|(p&4032)>>>6,w[y++]=128|(p&63)>>>0):(w[y++]=240|(p&1835008)>>>18,w[y++]=128|(p&258048)>>>12,w[y++]=128|(p&4032)>>>6,w[y++]=128|(p&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,y=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,g(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let p=this._h0,c=this._h1,r=this._h2,l=this._h3,i=this._h4,t,o,s;for(let a=0;a<80;a++)a<20?(t=c&r|~c&l,o=1518500249):a<40?(t=c^r^l,o=1859775393):a<60?(t=c&r|c&l|r&l,o=2400959708):(t=c^r^l,o=3395469782),s=g(p,5)+t+i+o+w.getUint32(a*4,!1)&4294967295,i=l,l=r,r=g(c,30),c=p,p=s;this._h0=this._h0+p&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var wt=this&&this.__classPrivateFieldSet||function(K,e,k,n,T){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?T.call(K,k):T?T.value=k:e.set(K,k),k},xe=this&&this.__classPrivateFieldGet||function(K,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!n:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(K):n?n.value:e.get(K)};define(te[39],ne([0,1,16,26]),function(K,e,k,n){"use strict";var T,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(i,t,o){let s=i.get(t);return s===void 0&&(s=o,i.set(t,s)),s}e.getOrSet=P;function b(i){const t=[];return i.forEach((o,s)=>{t.push(`${s} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function I(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=I;class D{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=D;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class g{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var S;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(S||(S={}));class d{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(v||(v={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new d(t))}static forPaths(t=!1){return new m(new g(void 0,!t))}static forStrings(){return new m(new D)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(t,o){if(o){const s=o.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a,t)}else{const s=t.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(t,o){const s=this._iter.reset(t);let a;this._root||(this._root=new h,this._root.segment=s.value());const u=[];for(a=this._root;;){const C=s.cmp(a.segment);if(C>0)a.left||(a.left=new h,a.left.segment=s.value()),u.push([-1,a]),a=a.left;else if(C<0)a.right||(a.right=new h,a.right.segment=s.value()),u.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new h,a.mid.segment=s.value()),u.push([0,a]),a=a.mid;else break}const f=a.value;a.value=o,a.key=t;for(let C=u.length-1;C>=0;C--){const _=u[C][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const F=u[C][0],R=u[C+1][0];if(F===1&&R===1)u[C][1]=_.rotateLeft();else if(F===-1&&R===-1)u[C][1]=_.rotateRight();else if(F===1&&R===-1)_.right=u[C+1][1]=u[C+1][1].rotateRight(),u[C][1]=_.rotateLeft();else if(F===-1&&R===1)_.left=u[C+1][1]=u[C+1][1].rotateLeft(),u[C][1]=_.rotateRight();else throw new Error;if(C>0)switch(u[C-1][0]){case-1:u[C-1][1].left=u[C][1];break;case 1:u[C-1][1].right=u[C][1];break;case 0:u[C-1][1].mid=u[C][1];break}else this._root=u[0][1]}}return f}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const s=this._iter.reset(t),a=[];let u=this._root;for(;u;){const f=s.cmp(u.segment);if(f>0)a.push([-1,u]),u=u.left;else if(f<0)a.push([1,u]),u=u.right;else if(s.hasNext())s.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(o?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this._min(u.right),{key:C,value:_,segment:O}=f;this._delete(f.key,!1),u.key=C,u.value=_,u.segment=O}else{const f=u.left??u.right;if(a.length>0){const[C,_]=a[a.length-1];switch(C){case-1:_.left=f;break;case 0:_.mid=f;break;case 1:_.right=f;break}}else this._root=f}for(let f=a.length-1;f>=0;f--){const C=a[f][1];C.updateHeight();const _=C.balanceFactor();if(_>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),a[f][1]=C.rotateLeft()):_<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),a[f][1]=C.rotateRight()),f>0)switch(a[f-1][0]){case-1:a[f-1][1].left=a[f][1];break;case 1:a[f-1][1].right=a[f][1];break;case 0:a[f-1][1].mid=a[f][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let s=this._root,a;for(;s;){const u=o.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(o.hasNext())o.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[o,s]of this)t(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,o){this.uri=t,this.value=o}}class y{constructor(t,o){this[T]="ResourceMap",t instanceof y?(this.map=new Map(t.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=t??y.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[s,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=y,y.defaultToKey=i=>i.toString();var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class c{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const s=this._map.get(t);if(!!s)return o!==0&&this.touch(s,o),s.value}set(t,o,s=0){let a=this._map.get(t);if(a)a.value=o,s!==0&&this.touch(a,s);else{switch(a={key:t,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const s=this._state;let a=this._head;for(;a;){if(o?t.bind(o)(a.value,a.key,this):t(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.key,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}values(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.value,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}entries(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:[s.key,s.value],done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>t;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,s=t.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const s=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const s=t.next,a=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,s)=>{t.push([s,o])}),t}fromJSON(t){this.clear();for(const[o,s]of t)this.set(o,s)}}e.LinkedMap=c;class r extends c{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class l{constructor(t){A.set(this,void 0),wt(this,A,t,"f")}get size(){return xe(this,A,"f").size}forEach(t,o){xe(this,A,"f").forEach(t,o)}get(t){return xe(this,A,"f").get(t)}has(t){return xe(this,A,"f").has(t)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=l}),define(te[72],ne([0,1,39]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new k.LRUCache(1e4);function T(I){return b(I,"NFC",n)}e.normalizeNFC=T;const L=new k.LRUCache(1e4);function A(I){return b(I,"NFD",L)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function b(I,D,E){if(!I)return I;const g=E.get(I);if(g)return g;let S;return P.test(I)?S=I.normalize(D):S=I,E.set(I,S),S}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(D){return A(D).replace(I,"")}}()}),define(te[11],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(s){return Array.isArray(s)}e.isArray=k;function n(s){return typeof s=="string"}e.isString=n;function T(s){return Array.isArray(s)&&s.every(a=>n(a))}e.isStringArray=T;function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=L;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function b(s){return s===!0||s===!1}e.isBoolean=b;function I(s){return typeof s=="undefined"}e.isUndefined=I;function D(s){return!E(s)}e.isDefined=D;function E(s){return I(s)||s===null}e.isUndefinedOrNull=E;function g(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=g;function S(s){if(E(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=S;function d(...s){const a=[];for(let u=0;u<s.length;u++){const f=s[u];if(E(f))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(f)}return a}e.assertAllDefined=d;const h=Object.prototype.hasOwnProperty;function v(s){if(!L(s))return!1;for(let a in s)if(h.call(s,a))return!1;return!0}e.isEmptyObject=v;function m(s){return typeof s=="function"}e.isFunction=m;function w(...s){return s.length>0&&s.every(m)}e.areFunctions=w;function y(s,a){const u=Math.min(s.length,a.length);for(let f=0;f<u;f++)p(s[f],a[f])}e.validateConstraints=y;function p(s,a){if(n(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(m(a)){try{if(s instanceof a)return}catch{}if(!E(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function c(s){let a=[],u=Object.getPrototypeOf(s);for(;Object.prototype!==u;)a=a.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return a}e.getAllPropertyNames=c;function r(s){const a=[];for(const u of c(s))typeof s[u]=="function"&&a.push(u);return a}e.getAllMethodNames=r;function l(s,a){const u=C=>function(){const _=Array.prototype.slice.call(arguments,0);return a(C,_)};let f={};for(const C of s)f[C]=u(C);return f}e.createProxyObject=l;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function t(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=t;function o(s,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(te[41],ne([0,1,10,4,26,11]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function P(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function b(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function I(o,s=k.posix.sep){if(!o)return"";const a=o.length,u=o.charCodeAt(0);if(A(u)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let C=3;const _=C;for(;C<a&&!A(o.charCodeAt(C));C++);if(_!==C&&!A(o.charCodeAt(C+1))){for(C+=1;C<a;C++)if(A(o.charCodeAt(C)))return o.slice(0,C+1).replace(/[\\/]/g,s)}}return s}else if(m(u)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let f=o.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(A(o.charCodeAt(f)))return o.slice(0,f+1)}return""}e.getRoot=I;function D(o){if(!n.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const u=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(u===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=D;const E=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,s=n.isWindows){const a=s?E:g;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&S.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function h(o,s,a){const u=o===s;return!a||u?u:!o||!s?!1:(0,T.equalsIgnoreCase)(o,s)}e.isEqual=h;function v(o,s,a,u=k.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,T.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let C=s.length;return s.charAt(s.length-1)===u&&C--,o.charAt(C)===u}return s.charAt(s.length-1)!==u&&(s+=u),o.indexOf(s)===0}e.isEqualOrParent=v;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function w(o,s){return n.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(s,o)),o=(0,k.normalize)(o),n.isWindows?(o=(0,T.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,T.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=w;function y(o){const s=(0,k.normalize)(o);return n.isWindows?o.length>3?!1:p(s)&&(o.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=y;function p(o,s){return(s!==void 0?s:n.isWindows)?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function c(o){return p(o)?o[0]:void 0}e.getDriveLetter=c;function r(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function l(o){const s=o.split(":");let a,u,f;for(const C of s){const _=Number(C);(0,L.isNumber)(_)?u===void 0?u=_:f===void 0&&(f=_):a=a?[a,C].join(":"):C}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:f!==void 0?f:u!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,s,a=8){let u="";for(let C=0;C<a;C++)u+=i.charAt(Math.floor(Math.random()*i.length));let f;return s?f=`${s}-${u}`:f=u,o?(0,k.join)(o,f):f}e.randomPath=t}),define(te[28],ne([0,1,11]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(m=>{h[m]&&typeof h[m]=="object"?v[m]=n(h[m]):v[m]=h[m]}),v}e.deepClone=n;function T(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(L.call(m,w)){const y=m[w];typeof y=="object"&&!Object.isFrozen(y)&&v.push(y)}}return h}e.deepFreeze=T;const L=Object.prototype.hasOwnProperty;function A(h,v){return P(h,v,new Set)}e.cloneAndChange=A;function P(h,v,m){if((0,k.isUndefinedOrNull)(h))return h;const w=v(h);if(typeof w!="undefined")return w;if((0,k.isArray)(h)){const y=[];for(const p of h)y.push(P(p,v,m));return y}if((0,k.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const y={};for(let p in h)L.call(h,p)&&(y[p]=P(h[p],v,m));return m.delete(h),y}return h}function b(h,v,m=!0){return(0,k.isObject)(h)?((0,k.isObject)(v)&&Object.keys(v).forEach(w=>{w in h?m&&((0,k.isObject)(h[w])&&(0,k.isObject)(v[w])?b(h[w],v[w],m):h[w]=v[w]):h[w]=v[w]}),h):v}e.mixin=b;function I(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(m=0;m<h.length;m++)if(!I(h[m],v[m]))return!1}else{const y=[];for(w in h)y.push(w);y.sort();const p=[];for(w in v)p.push(w);if(p.sort(),!I(y,p))return!1;for(m=0;m<y.length;m++)if(!I(h[y[m]],v[y[m]]))return!1}return!0}e.equals=I;function D(h){const v=new Set;return JSON.stringify(h,(m,w)=>{if((0,k.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=D;function E(h,v,m){const w=v(h);return typeof w=="undefined"?m:w}e.getOrDefault=E;function g(h,v){const m=Object.create(null);return!h||!v||Object.keys(v).forEach(y=>{const p=h[y],c=v[y];I(p,c)||(m[y]=c)}),m}e.distinct=g;function S(h,v){const m=v.toLowerCase(),w=Object.keys(h).find(y=>y.toLowerCase()===m);return w?h[w]:h[v]}e.getCaseInsensitive=S;function d(h,v){const m=Object.create(null);for(const[w,y]of Object.entries(h))v(w,y)&&(m[w]=y);return m}e.filter=d}),define(te[7],ne([0,1,10,4]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function P(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!T.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function I(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const D="",E="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,o,s,a,u,f=!1){typeof t=="object"?(this.scheme=t.scheme||D,this.authority=t.authority||D,this.path=t.path||D,this.query=t.query||D,this.fragment=t.fragment||D):(this.scheme=b(t,f),this.authority=o||D,this.path=I(this.scheme,s||D),this.query=a||D,this.fragment=u||D,P(this,f))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return y(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:s,path:a,query:u,fragment:f}=t;return o===void 0?o=this.scheme:o===null&&(o=D),s===void 0?s=this.authority:s===null&&(s=D),a===void 0?a=this.path:a===null&&(a=D),u===void 0?u=this.query:u===null&&(u=D),f===void 0?f=this.fragment:f===null&&(f=D),o===this.scheme&&s===this.authority&&a===this.path&&u===this.query&&f===this.fragment?this:new h(o,s,a,u,f)}static parse(t,o=!1){const s=g.exec(t);return s?new h(s[2]||D,l(s[4]||D),l(s[5]||D),l(s[7]||D),l(s[9]||D),o):new h(D,D,D,D,D)}static file(t){let o=D;if(n.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const s=t.indexOf(E,2);s===-1?(o=t.substring(2),t=E):(o=t.substring(2,s),t=t.substring(s)||E)}return new h("file",o,t,D,D)}static from(t){const o=new h(t.scheme,t.authority,t.path,t.query,t.fragment);return P(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=S.file(k.win32.join(y(t,!0),...o)).path:s=k.posix.join(t.path,...o),t.with({path:s})}toString(t=!1){return p(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const o=new h(t);return o._formatted=t.external,o._fsPath=t._sep===d?t.fsPath:null,o}}else return t}}e.URI=S;const d=n.isWindows?1:void 0;class h extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(t=!1){return t?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=d),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,t){let o,s=-1;for(let a=0;a<i.length;a++){const u=i.charCodeAt(a);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o!==void 0&&(o+=i.charAt(a));else{o===void 0&&(o=i.substr(0,a));const f=v[u];f!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o+=f):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function w(i){let t;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(t===void 0&&(t=i.substr(0,o)),t+=v[s]):t!==void 0&&(t+=i[o])}return t!==void 0?t:i}function y(i,t){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function p(i,t){const o=t?w:m;let s="",{scheme:a,authority:u,path:f,query:C,fragment:_}=i;if(a&&(s+=a,s+=":"),(u||a==="file")&&(s+=E,s+=E),u){let O=u.indexOf("@");if(O!==-1){const F=u.substr(0,O);u=u.substr(O+1),O=F.indexOf(":"),O===-1?s+=o(F,!1):(s+=o(F.substr(0,O),!1),s+=":",s+=o(F.substr(O+1),!1)),s+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?s+=o(u,!1):(s+=o(u.substr(0,O),!1),s+=u.substr(O))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const O=f.charCodeAt(1);O>=65&&O<=90&&(f=`/${String.fromCharCode(O+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const O=f.charCodeAt(0);O>=65&&O<=90&&(f=`${String.fromCharCode(O+32)}:${f.substr(2)}`)}s+=o(f,!0)}return C&&(s+="?",s+=o(C,!1)),_&&(s+="#",s+=t?_:m(_,!1)),s}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(r)?i.replace(r,t=>c(t)):i}}),define(te[107],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(I){const D=I;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=n;function T(I){const D=[];let E;try{const g=JSON.parse(I.arguments),S=g[g.length-1];S&&S.__$stack&&(g.pop(),E=S.__$stack),D.push(...g)}catch{D.push("Unable to log remote console arguments",I.arguments)}return{args:D,stack:E}}e.parse=T;function L(I){if(typeof I!="string")return L(T(I).stack);const D=I;if(D){const E=A(D),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(g&&g.length===4)return{uri:k.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=L;function A(I){if(!I)return I;const D=I.indexOf(`
`);return D===-1?I:I.substring(0,D)}function P(I,D){const{args:E,stack:g}=T(I),S=typeof E[0]=="string"&&E.length===1;let d=A(g);d&&(d=`(${d.trim()})`);let h=[];if(typeof E[0]=="string"?d&&S?h=[`%c[${D}] %c${E[0]} %c${d}`,b("blue"),b(""),b("grey")]:h=[`%c[${D}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:h=[`%c[${D}]%`,b("blue"),...E],d&&!S&&h.push(d),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,h)}e.log=P;function b(I){return`color: ${I}`}}),define(te[108],ne([0,1,17,26,7]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(I){return JSON.stringify(I,P)}e.stringify=L;function A(I){let D=JSON.parse(I);return D=b(D),D}e.parse=A;function P(I,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,n.regExpFlags)(D)}:D}function b(I,D=0){if(!I||D>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return T.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof k.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let E=0;E<I.length;++E)I[E]=b(I[E],D+1);else for(const E in I)Object.hasOwnProperty.call(I,E)&&(I[E]=b(I[E],D+1))}return I}e.revive=b}),define(te[18],ne([0,1,4,7]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(T=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,I,D){this._hosts[b]=I,this._ports[b]=D}setConnectionToken(b,I){this._connectionTokens[b]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const I=b.authority;let D=this._hosts[I];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const E=this._ports[I],g=this._connectionTokens[I];let S=`path=${encodeURIComponent(b.path)}`;return typeof g=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),n.URI.from({scheme:k.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${D}:${E}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new L;class A{asBrowserUri(b,I){const D=this.toUri(b,I);return D.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===T.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${T.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?D.with({scheme:T.vscodeFileResource,authority:D.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(b,I){const D=this.toUri(b,I);return D.scheme===T.vscodeFileResource?D.with({scheme:T.file,authority:D.authority!==A.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(b,I){return n.URI.isUri(b)?b:n.URI.parse(I.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[20],ne([0,1,41,18,10,4,26,7]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(S){return(0,P.uriToFsPath)(S,!0)}e.originalFSPath=b;class I{constructor(d){this._ignorePathCasing=d}compare(d,h,v=!1){return d===h?0:(0,A.compare)(this.getComparisonKey(d,v),this.getComparisonKey(h,v))}isEqual(d,h,v=!1){return d===h?!0:!d||!h?!1:this.getComparisonKey(d,v)===this.getComparisonKey(h,v)}getComparisonKey(d,h=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,h,v=!1){if(d.scheme===h.scheme){if(d.scheme===n.Schemas.file)return k.isEqualOrParent(b(d),b(h),this._ignorePathCasing(d))&&d.query===h.query&&(v||d.fragment===h.fragment);if((0,e.isEqualAuthority)(d.authority,h.authority))return k.isEqualOrParent(d.path,h.path,this._ignorePathCasing(d),"/")&&d.query===h.query&&(v||d.fragment===h.fragment)}return!1}joinPath(d,...h){return P.URI.joinPath(d,...h)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let h;return d.scheme===n.Schemas.file?h=P.URI.file(T.dirname(b(d))).path:(h=T.posix.dirname(d.path),d.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),h="/")),d.with({path:h})}normalizePath(d){if(!d.path.length)return d;let h;return d.scheme===n.Schemas.file?h=P.URI.file(T.normalize(b(d))).path:h=T.posix.normalize(d.path),d.with({path:h})}relativePath(d,h){if(d.scheme!==h.scheme||!(0,e.isEqualAuthority)(d.authority,h.authority))return;if(d.scheme===n.Schemas.file){const w=T.relative(b(d),b(h));return L.isWindows?k.toSlashes(w):w}let v=d.path||"/",m=h.path||"/";if(this._ignorePathCasing(d)){let w=0;for(const y=Math.min(v.length,m.length);w<y&&!(v.charCodeAt(w)!==m.charCodeAt(w)&&v.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);v=m.substr(0,w)+v.substr(w)}return T.posix.relative(v,m)}resolvePath(d,h){if(d.scheme===n.Schemas.file){const v=P.URI.file(T.resolve(b(d),h));return d.with({authority:v.authority,path:v.path})}return h=k.toPosixPath(h),d.with({path:T.posix.resolve(d.path,h)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,h){return d===h||d!==void 0&&h!==void 0&&(0,A.equalsIgnoreCase)(d,h)}hasTrailingPathSeparator(d,h=T.sep){if(d.scheme===n.Schemas.file){const v=b(d);return v.length>k.getRoot(v).length&&v[v.length-1]===h}else{const v=d.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,h=T.sep){return(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,h=T.sep){let v=!1;if(d.scheme===n.Schemas.file){const m=b(d);v=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===h}else{h="/";const m=d.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path+"/"}):d}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(S=>S.scheme===n.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new I(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(S,d){const h=[];for(let v=0;v<S.length;v++){const m=d(S[v]);S.some((w,y)=>y===v?!1:(0,e.isEqualOrParent)(m,d(w)))||h.push(S[v])}return h}e.distinctParents=D;var E;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function d(h){const v=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(y=>{const[p,c]=y.split(":");p&&c&&v.set(p,c)});const w=h.path.substring(0,h.path.indexOf(";"));return w&&v.set(S.META_DATA_MIME,w),v}S.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function g(S,d,h){if(d){let v=S.path;return v&&v[0]!==T.posix.sep&&(v=T.posix.sep+v),S.with({scheme:h,authority:d,path:v})}return S.with({scheme:h})}e.toLocalResource=g}),define(te[5],ne([0,1,25,9,3,2,20,4]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(q){return!!q&&typeof q.then=="function"}e.isThenable=b;function I(q){const U=new k.CancellationTokenSource,M=q(U.token),W=new Promise((H,re)=>{const se=U.token.onCancellationRequested(()=>{se.dispose(),U.dispose(),re(new n.CancellationError)});Promise.resolve(M).then(ue=>{se.dispose(),U.dispose(),H(ue)},ue=>{se.dispose(),U.dispose(),re(ue)})});return new class{cancel(){U.cancel()}then(H,re){return W.then(H,re)}catch(H){return this.then(void 0,H)}finally(H){return W.finally(H)}}}e.createCancelablePromise=I;function D(q,U,M){return new Promise((W,H)=>{const re=U.onCancellationRequested(()=>{re.dispose(),W(M)});q.then(W,H).finally(()=>re.dispose())})}e.raceCancellation=D;function E(q,U){return new Promise((M,W)=>{const H=U.onCancellationRequested(()=>{H.dispose(),W(new n.CancellationError)});q.then(M,W).finally(()=>H.dispose())})}e.raceCancellationError=E;async function g(q){let U=-1;const M=q.map((H,re)=>H.then(se=>(U=re,se))),W=await Promise.race(M);return q.forEach((H,re)=>{re!==U&&H.cancel()}),W}e.raceCancellablePromises=g;function S(q,U,M){let W;const H=setTimeout(()=>{W?.(void 0),M?.()},U);return Promise.race([q.finally(()=>clearTimeout(H)),new Promise(re=>W=re)])}e.raceTimeout=S;function d(q){return new Promise((U,M)=>{const W=q();b(W)?W.then(U,M):U(W)})}e.asPromise=d;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(M,M).then(W)})}return new Promise((M,W)=>{this.queuedPromise.then(M,W)})}return this.activePromise=U(),new Promise((M,W)=>{this.activePromise.then(H=>{this.activePromise=null,M(H)},H=>{this.activePromise=null,W(H)})})}}e.Throttler=h;class v{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=v;class m{constructor(){this.promiseMap=new Map}queue(U,M){const H=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(U)===H&&this.promiseMap.delete(U)});return this.promiseMap.set(U,H),H}}e.SequencerByKey=m;const w=(q,U)=>{let M=!0;const W=setTimeout(()=>{M=!1,U()},q);return{isTriggered:()=>M,dispose:()=>{clearTimeout(W),M=!1}}},y=q=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,q())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,M=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,re)=>{this.doResolve=H,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?y(W):w(M,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class c{constructor(U){this.delayer=new p(U),this.throttler=new h}trigger(U,M){return this.delayer.trigger(()=>this.throttler.queue(U),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class r{constructor(){this._isOpen=!1,this._promise=new Promise((U,M)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class l extends r{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(q,U){return U?new Promise((M,W)=>{const H=setTimeout(()=>{re.dispose(),M()},q),re=U.onCancellationRequested(()=>{clearTimeout(H),re.dispose(),W(new n.CancellationError)})}):I(M=>i(q,M))}e.timeout=i;function t(q,U=0){const M=setTimeout(q,U);return(0,L.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function o(q){const U=[];let M=0;const W=q.length;function H(){return M<W?q[M++]():null}function re(se){se!=null&&U.push(se);const ue=H();return ue?ue.then(re):Promise.resolve(U)}return Promise.resolve(null).then(re)}e.sequence=o;function s(q,U=W=>!!W,M=null){let W=0;const H=q.length,re=()=>{if(W>=H)return Promise.resolve(M);const se=q[W++];return Promise.resolve(se()).then(de=>U(de)?Promise.resolve(de):re())};return re()}e.first=s;function a(q,U=W=>!!W,M=null){if(q.length===0)return Promise.resolve(M);let W=q.length;const H=()=>{W=-1;for(const re of q)re.cancel?.()};return new Promise((re,se)=>{for(const ue of q)ue.then(de=>{--W>=0&&U(de)?(H(),re(de)):W===0&&re(M)}).catch(de=>{--W>=0&&(H(),se(de))})})}e.firstParallel=a;class u{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((M,W)=>{this.outstandingPromises.push({factory:U,c:M,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const M=U.factory();M.then(U.c,U.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class f extends u{constructor(){super(1)}}e.Queue=f;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new B;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,M=A.extUri){const W=M.getComparisonKey(U);let H=this.queues.get(W);return H||(H=new f,T.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(W),this.onDidQueueFinish()}),this.queues.set(W,H)),H}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class _{constructor(U,M){this._token=-1,typeof U=="function"&&typeof M=="number"&&this.setIfNotSet(U,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},M)}setIfNotSet(U,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},M))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,M){this.cancel(),this._token=setInterval(()=>{U()},M)}}e.IntervalTimer=O;class F{constructor(U,M){this.timeoutToken=-1,this.runner=U,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class R{constructor(U,M){M%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=R;class N extends F{constructor(U,M){super(U,M);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class $ extends L.Disposable{constructor(U,M){super();this.options=U,this.handler=M,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,P.setTimeout0)(()=>{if(U)return;const M=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(q,U)=>{const M=requestIdleCallback(q,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(M))}}}}();class j{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function X(q,U,M){let W;for(let H=0;H<M;H++)try{return await q()}catch(re){W=re,await i(U)}throw W}e.retry=X;class z{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,M,W){return this._pending={taskId:U,cancel:()=>W?.(),promise:M},M.then(()=>this.donePending(U),()=>this.donePending(U)),M}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let M,W;const H=new Promise((re,se)=>{M=re,W=se});this._next={run:U,promise:H,promiseResolve:M,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=z;class J{constructor(U,M=()=>Date.now()){this.interval=U,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,M)=>{this.completeCallback=U,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(M=>{this.completeCallback(U),this.resolved=!0,M()})}error(U){return new Promise(M=>{this.errorCallback(U),this.rejected=!0,M()})}cancel(){new Promise(U=>{this.errorCallback(new n.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=B;var x;(function(q){async function U(W){let H;const re=await Promise.all(W.map(se=>se.then(ue=>ue,ue=>{H||(H=ue)})));if(typeof H!="undefined")throw H;return re}q.settled=U;function M(W){return new Promise(async(H,re)=>{try{await W(H,re)}catch(se){re(se)}})}q.withAsyncBody=M})(x=e.Promises||(e.Promises={}));var ee;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(ee||(ee={}));class V{constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const M={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve(U(M)),this.resolve()}catch(W){this.reject(W)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}static fromArray(U){return new V(M=>{M.emitMany(U)})}static fromPromise(U){return new V(async M=>{M.emitMany(await U)})}static fromPromises(U){return new V(async M=>{await Promise.all(U.map(async W=>M.emitOne(await W)))})}static merge(U){return new V(async M=>{await Promise.all(U.map(async W=>{for await(const H of W)M.emitOne(H)}))})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,M){return new V(async W=>{for await(const H of U)W.emitOne(M(H))})}map(U){return V.map(this,U)}static filter(U,M){return new V(async W=>{for await(const H of U)M(H)&&W.emitOne(H)})}filter(U){return V.filter(this,U)}static coalesce(U){return V.filter(U,M=>!!M)}coalesce(){return V.coalesce(this)}static async toPromise(U){const M=[];for await(const W of U)M.push(W);return M}toPromise(){return V.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class Z extends V{constructor(U,M){super(M);this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function Y(q){const U=new k.CancellationTokenSource,M=q(U.token);return new Z(U,async W=>{const H=U.token.onCancellationRequested(()=>{H.dispose(),U.dispose(),W.reject(new n.CancellationError)});try{for await(const re of M){if(U.token.isCancellationRequested)return;W.emitOne(re)}H.dispose(),U.dispose()}catch(re){H.dispose(),U.dispose(),W.reject(re)}})}e.createCancelableAsyncIterable=Y}),define(te[109],ne([0,1,5,41,39,10,4,26]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",D="[^/\\\\]",E=/\//g;function g(z,J){switch(z){case 0:return"";case 1:return`${D}*?`;default:return`(?:${I}|${D}+${I}${J?`|${I}${D}+`:""})*?`}}function S(z,J){if(!z)return[];const B=[];let x=!1,ee=!1,V="";for(const Z of z){switch(Z){case J:if(!x&&!ee){B.push(V),V="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}V+=Z}return V&&B.push(V),B}e.splitGlobAware=S;function d(z){if(!z)return"";let J="";const B=S(z,e.GLOB_SPLIT);if(B.every(x=>x===e.GLOBSTAR))J=".*";else{let x=!1;B.forEach((ee,V)=>{if(ee===e.GLOBSTAR){if(x)return;J+=g(2,V===B.length-1)}else{let Z=!1,Y="",q=!1,U="";for(const M of ee){if(M!=="}"&&Z){Y+=M;continue}if(q&&(M!=="]"||!U)){let W;M==="-"?W=M:(M==="^"||M==="!")&&!U?W="^":M===e.GLOB_SPLIT?W="":W=(0,P.escapeRegExpCharacters)(M),U+=W;continue}switch(M){case"{":Z=!0;continue;case"[":q=!0;continue;case"}":{J+=`(?:${S(Y,",").map(re=>d(re)).join("|")})`,Z=!1,Y="";break}case"]":{J+="["+U+"]",q=!1,U="";break}case"?":J+=D;continue;case"*":J+=g(1);continue;default:J+=(0,P.escapeRegExpCharacters)(M)}}V<B.length-1&&(B[V+1]!==e.GLOBSTAR||V+2<B.length)&&(J+=I)}x=ee===e.GLOBSTAR})}return J}const h=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new T.LRUCache(1e4),r=function(){return!1},l=function(){return null};function i(z,J){if(!z)return l;let B;typeof z!="string"?B=z.pattern:B=z,B=B.trim();const x=`${B}_${!!J.trimForExclusions}`;let ee=c.get(x);if(ee)return t(ee,z);let V;return h.test(B)?ee=s(B.substr(4),B):(V=v.exec(o(B,J)))?ee=a(V[1],B):(J.trimForExclusions?w:m).test(B)?ee=u(B,J):(V=y.exec(o(B,J)))?ee=f(V[1].substr(1),B,!0):(V=p.exec(o(B,J)))?ee=f(V[1],B,!1):ee=C(B),c.set(x,ee),t(ee,z)}function t(z,J){return typeof J=="string"?z:function(B,x){return(0,n.isEqualOrParent)(B,J.base,!A.isLinux)?z(B.substr(J.base.length+1),x):null}}function o(z,J){return J.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function s(z,J){return function(B,x){return typeof B=="string"&&B.endsWith(z)?J:null}}function a(z,J){const B=`/${z}`,x=`\\${z}`,ee=function(Z,Y){return typeof Z!="string"?null:Y?Y===z?J:null:Z===z||Z.endsWith(B)||Z.endsWith(x)?J:null},V=[z];return ee.basenames=V,ee.patterns=[J],ee.allBasenames=V,ee}function u(z,J){const B=X(z.slice(1,-1).split(",").map(Y=>i(Y,J)).filter(Y=>Y!==l),z),x=B.length;if(!x)return l;if(x===1)return B[0];const ee=function(Y,q){for(let U=0,M=B.length;U<M;U++)if(B[U](Y,q))return z;return null},V=B.find(Y=>!!Y.allBasenames);V&&(ee.allBasenames=V.allBasenames);const Z=B.reduce((Y,q)=>q.allPaths?Y.concat(q.allPaths):Y,[]);return Z.length&&(ee.allPaths=Z),ee}function f(z,J,B){const x=L.sep===L.posix.sep,ee=x?z:z.replace(E,L.sep),V=L.sep+ee,Z=L.posix.sep+z;let Y;return B?Y=function(q,U){return typeof q=="string"&&(q===ee||q.endsWith(V)||!x&&(q===z||q.endsWith(Z)))?J:null}:Y=function(q,U){return typeof q=="string"&&(q===ee||!x&&q===z)?J:null},Y.allPaths=[(B?"*/":"./")+z],Y}function C(z){try{const J=new RegExp(`^${d(z)}$`);return function(B){return J.lastIndex=0,typeof B=="string"&&J.test(B)?z:null}}catch{return l}}function _(z,J,B){return!z||typeof J!="string"?!1:O(z)(J,void 0,B)}e.match=_;function O(z,J={}){if(!z)return r;if(typeof z=="string"||F(z)){const B=i(z,J);if(B===l)return r;const x=function(ee,V){return!!B(ee,V)};return B.allBasenames&&(x.allBasenames=B.allBasenames),B.allPaths&&(x.allPaths=B.allPaths),x}return $(z,J)}e.parse=O;function F(z){const J=z;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=F;function R(z){return z.allBasenames||[]}e.getBasenameTerms=R;function N(z){return z.allPaths||[]}e.getPathTerms=N;function $(z,J){const B=X(Object.getOwnPropertyNames(z).map(Y=>j(Y,z[Y],J)).filter(Y=>Y!==l)),x=B.length;if(!x)return l;if(!B.some(Y=>!!Y.requiresSiblings)){if(x===1)return B[0];const Y=function(M,W){for(let H=0,re=B.length;H<re;H++){const se=B[H](M,W);if(se)return se}return null},q=B.find(M=>!!M.allBasenames);q&&(Y.allBasenames=q.allBasenames);const U=B.reduce((M,W)=>W.allPaths?M.concat(W.allPaths):M,[]);return U.length&&(Y.allPaths=U),Y}const ee=function(Y,q,U){let M;for(let W=0,H=B.length;W<H;W++){const re=B[W];re.requiresSiblings&&U&&(q||(q=(0,L.basename)(Y)),M||(M=q.substr(0,q.length-(0,L.extname)(Y).length)));const se=re(Y,q,M,U);if(se)return se}return null},V=B.find(Y=>!!Y.allBasenames);V&&(ee.allBasenames=V.allBasenames);const Z=B.reduce((Y,q)=>q.allPaths?Y.concat(q.allPaths):Y,[]);return Z.length&&(ee.allPaths=Z),ee}function j(z,J,B){if(J===!1)return l;const x=i(z,B);if(x===l)return l;if(typeof J=="boolean")return x;if(J){const ee=J.when;if(typeof ee=="string"){const V=(Z,Y,q,U)=>{if(!U||!x(Z,Y))return null;const M=ee.replace("$(basename)",q),W=U(M);return(0,k.isThenable)(W)?W.then(H=>H?z:null):W?z:null};return V.requiresSiblings=!0,V}}return x}function X(z,J){const B=z.filter(Y=>!!Y.basenames);if(B.length<2)return z;const x=B.reduce((Y,q)=>{const U=q.basenames;return U?Y.concat(U):Y},[]);let ee;if(J){ee=[];for(let Y=0,q=x.length;Y<q;Y++)ee.push(J)}else ee=B.reduce((Y,q)=>{const U=q.patterns;return U?Y.concat(U):Y},[]);const V=function(Y,q){if(typeof Y!="string")return null;if(!q){let M;for(M=Y.length;M>0;M--){const W=Y.charCodeAt(M-1);if(W===47||W===92)break}q=Y.substr(M)}const U=x.indexOf(q);return U!==-1?ee[U]:null};V.basenames=x,V.patterns=ee,V.allBasenames=x;const Z=z.filter(Y=>!Y.basenames);return Z.push(V),Z}}),define(te[110],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(D){return D.toJSON()}class T{constructor(E){this._uriTransformer=E}transformIncoming(E){const g=this._uriTransformer.transformIncoming(E);return g===E?E:n(k.URI.from(g))}transformOutgoing(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:n(k.URI.from(g))}transformOutgoingURI(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:k.URI.from(g)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function L(D,E,g){if(!D||g>200)return null;if(typeof D=="object"){if(D instanceof k.URI)return E.transformOutgoing(D);for(let S in D)if(Object.hasOwnProperty.call(D,S)){const d=L(D[S],E,g+1);d!==null&&(D[S]=d)}}return null}function A(D,E){const g=L(D,E,0);return g===null?D:g}e.transformOutgoingURIs=A;function P(D,E,g,S){if(!D||S>200)return null;if(typeof D=="object"){if(D.$mid===1)return g?k.URI.revive(E.transformIncoming(D)):E.transformIncoming(D);for(let d in D)if(Object.hasOwnProperty.call(D,d)){const h=P(D[d],E,g,S+1);h!==null&&(D[d]=h)}}return null}function b(D,E){const g=P(D,E,!1,0);return g===null?D:g}e.transformIncomingURIs=b;function I(D,E){const g=P(D,E,!0,0);return g===null?D:g}e.transformAndReviveIncomingURIs=I}),define(te[29],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return k.test(b)}e.isUUID=n;const T=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let I=0;I<b.length;I++)b[I]=Math.floor(Math.random()*256);return b};function P(){A(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let b=0,I="";return I+=L[T[b++]],I+=L[T[b++]],I+=L[T[b++]],I+=L[T[b++]],I+="-",I+=L[T[b++]],I+=L[T[b++]],I+="-",I+=L[T[b++]],I+=L[T[b++]],I+="-",I+=L[T[b++]],I+=L[T[b++]],I+="-",I+=L[T[b++]],I+=L[T[b++]],I+=L[T[b++]],I+=L[T[b++]],I+=L[T[b++]],I+=L[T[b++]],I}e.generateUuid=P}),define(te[111],ne([0,1,250]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(L="utf8"){this.stringDecoder=new k.StringDecoder(L),this.remaining=null}write(L){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(P.length<1)return A;let b=0,I,D=b;for(;D<P.length;)if(I=P.charCodeAt(D),I===13||I===10){if(A.push(P.substring(b,D)),D++,D<P.length){const E=I;I=P.charCodeAt(D),(E===13&&I===10||E===10&&I===13)&&D++}b=D}else D++;return this.remaining=b<P.length?P.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(te[112],ne([0,1,34]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(A){const P=A.replace(/\-/g,":").toLowerCase();return!n.has(P)}function L(){const A=(0,k.networkInterfaces)();for(let P in A){const b=A[P];if(b){for(const{mac:I}of b)if(T(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(te[113],ne([0,1,34,9,39,29,112]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,E=0;const g=(0,k.networkInterfaces)();for(let S in g){const d=g[S];if(d)for(const{mac:h,internal:v}of d)v||(E+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(D+=1))}this._value=E>0?D/E:0}return this._value}};let P;async function b(){return P||(P=(async()=>await I()||L.generateUuid())()),P}e.getMachineId=b;async function I(){try{const D=await new Promise((g,S)=>{K(["crypto"],g,S)}),E=(0,A.getMac)();return D.createHash("sha256").update(E,"utf8").digest("hex")}catch(D){n.onUnexpectedError(D);return}}}),define(te[22],ne([0,1,50,34,251,5,41,72,10,4,20,7]),function(K,e,k,n,T,L,A,P,b,I,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function S($,j=g.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return j===g.UNLINK?h($):d($)}async function d($){try{const j=(0,A.randomPath)((0,n.tmpdir)());try{await k.promises.rename($,j)}catch{return h($)}h(j).catch(X=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function h($){return e.Promises.rmdir($,{recursive:!0,maxRetries:3})}function v($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");k.rmdirSync($,{recursive:!0})}e.rimrafSync=v;async function m($,j){return p(await(j?w($):(0,T.promisify)(k.readdir)($)))}async function w($){try{return await(0,T.promisify)(k.readdir)($,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const j=[],X=await m($);for(const z of X){let J=!1,B=!1,x=!1;try{const ee=await e.Promises.lstat((0,b.join)($,z));J=ee.isFile(),B=ee.isDirectory(),x=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}j.push({name:z,isFile:()=>J,isDirectory:()=>B,isSymbolicLink:()=>x})}return j}function y($){return p(k.readdirSync($))}e.readdirSync=y;function p($){return $.map(j=>typeof j=="string"?I.isMacintosh?(0,P.normalizeNFC)(j):j:(j.name=I.isMacintosh?(0,P.normalizeNFC)(j.name):j.name,j))}async function c($){const j=await m($),X=[];for(const z of j)await l.existsDirectory((0,b.join)($,z))&&X.push(z);return X}function r($,j=1e3){return new Promise(X=>{let z=!1;const J=setInterval(()=>{z||(z=!0,k.access($,B=>{z=!1,B&&(clearInterval(J),X(void 0))}))},j)})}e.whenDeleted=r;var l;(function($){async function j(J){let B;try{if(B=await e.Promises.lstat(J),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(I.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ee}throw x}}$.stat=j;async function X(J){try{const{stat:B,symbolicLink:x}=await $.stat(J);return B.isFile()&&x?.dangling!==!0}catch{}return!1}$.existsFile=X;async function z(J){try{const{stat:B,symbolicLink:x}=await $.stat(J);return B.isDirectory()&&x?.dangling!==!0}catch{}return!1}$.existsDirectory=z})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function t($,j,X){return i.queueFor(E.URI.file($),D.extUriBiasedIgnorePathCase).queue(()=>{const z=u(X);return new Promise((J,B)=>s($,j,z,x=>x?B(x):J()))})}let o=!0;function s($,j,X,z){if(!o)return k.writeFile($,j,{mode:X.mode,flag:X.flag},z);k.open($,X.flag,X.mode,(J,B)=>{if(J)return z(J);k.writeFile(B,j,x=>{if(x)return k.close(B,()=>z(x));k.fdatasync(B,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),o=!1),k.close(B,V=>z(V))))})})}function a($,j,X){const z=u(X);if(!o)return k.writeFileSync($,j,{mode:z.mode,flag:z.flag});const J=k.openSync($,z.flag,z.mode);try{k.writeFileSync(J,j);try{k.fdatasyncSync(J)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o=!1}}finally{k.closeSync(J)}}e.writeFileSync=a;function u($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function f($,j){if($!==j)try{await e.Promises.rename($,j)}catch(X){if($.toLowerCase()!==j.toLowerCase()&&X.code==="EXDEV"||$.endsWith("."))await C($,j,{preserveSymlinks:!1}),await S($,g.MOVE);else throw X}}async function C($,j,X){return O($,j,{root:{source:$,target:j},options:X,handledSourcePaths:new Set})}const _=511;async function O($,j,X){if(X.handledSourcePaths.has($))return;X.handledSourcePaths.add($);const{stat:z,symbolicLink:J}=await l.stat($);if(J){if(X.options.preserveSymlinks)try{return await N($,j,X)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(J.dangling)return}return z.isDirectory()?F($,j,z.mode&_,X):R($,j,z.mode&_)}async function F($,j,X,z){await e.Promises.mkdir(j,{recursive:!0,mode:X});const J=await m($);for(const B of J)await O((0,b.join)($,B),(0,b.join)(j,B),z)}async function R($,j,X){await e.Promises.copyFile($,j),await e.Promises.chmod(j,X)}async function N($,j,X){let z=await e.Promises.readlink($);(0,A.isEqualOrParent)(z,X.root.source,!I.isLinux)&&(z=(0,b.join)(X.root.target,z.substr(X.root.source.length+1))),await e.Promises.symlink(z,j)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return($,j,X,z,J)=>new Promise((B,x)=>{k.read($,j,X,z,J,(ee,V,Z)=>ee?x(ee):B({bytesRead:V,buffer:Z}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return($,j,X,z,J)=>new Promise((B,x)=>{k.write($,j,X,z,J,(ee,V,Z)=>ee?x(ee):B({bytesWritten:V,buffer:Z}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get rename(){return(0,T.promisify)(k.rename)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return S}get move(){return f}get copy(){return C}}}),define(te[114],ne([0,1,50,10,4,26,22]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(g){if(T.isLinux)return g;const S=(0,n.dirname)(g);if(g===S)return g;const d=((0,n.basename)(g)||g).toLowerCase();try{const v=(0,A.readdirSync)(S).filter(m=>m.toLowerCase()===d);if(v.length===1){const m=P(S);if(m)return(0,n.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(d);if(m>=0){const w=P(S);if(w)return(0,n.join)(w,v[m])}}}catch{}return null}e.realcaseSync=P;async function b(g){if(T.isLinux)return g;const S=(0,n.dirname)(g);if(g===S)return g;const d=((0,n.basename)(g)||g).toLowerCase();try{const v=(await A.Promises.readdir(S)).filter(m=>m.toLowerCase()===d);if(v.length===1){const m=await b(S);if(m)return(0,n.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(d);if(m>=0){const w=await b(S);if(w)return(0,n.join)(w,v[m])}}}catch{}return null}e.realcase=b;async function I(g){try{return await A.Promises.realpath(g)}catch{const d=E(g);return await A.Promises.access(d,k.constants.R_OK),d}}e.realpath=I;function D(g){try{return k.realpathSync(g)}catch{const d=E(g);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=D;function E(g){return(0,L.rtrim)((0,n.normalize)(g),n.sep)}}),define(te[115],ne([0,1,56]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(P,b,I,D=1){let E=!1;return new Promise(g=>{const S=setTimeout(()=>{if(!E)return E=!0,g(0)},I);T(P,b,D,d=>{if(!E)return E=!0,clearTimeout(S),g(d)})})}e.findFreePort=n;function T(P,b,I,D){if(b===0)return D(0);const E=new k.Socket;E.once("connect",()=>(A(E),T(P+I,b-1,I,D))),E.once("data",()=>{}),E.once("error",g=>(A(E),g.code!=="ECONNREFUSED"?T(P+I,b-1,I,D):D(P))),E.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,b,I){let D=!1,E,g=1;const S=k.createServer({pauseOnConnect:!0});function d(h,v){D||(D=!0,S.removeAllListeners(),S.close(),E&&clearTimeout(E),v(h))}return new Promise(h=>{E=setTimeout(()=>{d(0,h)},I),S.on("listening",()=>{d(P,h)}),S.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&g<b?(P++,g++,S.listen(P,"127.0.0.1")):d(0,h)}),S.on("close",()=>{d(0,h)}),S.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(b){console.error(b)}}}),define(te[73],ne([0,1,34,10,22]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var b;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(b||(b={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class E{constructor(c,r,l){this.exePath=c,this.displayName=r,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await T.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:p=!1}={}){return p?I===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:p=!1,findPreview:c=!1}={}){const r=g({useAlternateBitness:p});if(!r)return null;const l=n.join(r,"PowerShell");if(!await T.SymlinkSupport.existsDirectory(l))return null;let i=-1,t=null;for(const a of await T.Promises.readdir(l)){let u=-1;if(c){const C=a.indexOf("-");if(C<0)continue;const _=a.substring(0,C);if(!L.test(_)||a.substring(C+1)!=="preview")continue;u=parseInt(_,10)}else{if(!L.test(a))continue;u=parseInt(a,10)}if(u<=i)continue;const f=n.join(l,a,"pwsh.exe");!await T.SymlinkSupport.existsFile(f)||(t=f,i=u)}if(!t)return null;const o=r.includes("x86")?" (x86)":"",s=c?" Preview":"";return new E(t,`PowerShell${s}${o}`,!0)}async function d({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await T.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:r,pwshMsixName:l}=p?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await T.Promises.readdir(c))if(r.test(i)){const t=n.join(c,i,"pwsh.exe");return new E(t,l)}return null}function h(){const p=n.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(p,".NET Core PowerShell Global Tool")}function v(){const p=n.join(process.env.windir,I===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(p,"Windows PowerShell",!0)}async function*m(){let p=await S();p&&(yield p),p=await S({useAlternateBitness:!0}),p&&(yield p),p=await d(),p&&(yield p),p=h(),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await S({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=v(),p&&(yield p)}async function*w(){for await(const p of m())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=w;async function y(){for await(const p of w())return p;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[116],ne([0,1,45,18]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(A){return new Promise((P,b)=>{let I;const D=new Map;function E(S,d,h,v,m){const w=D.get(d);if(S===A||w){const y={name:g(h),cmd:h,pid:S,ppid:d,load:v,mem:m};D.set(S,y),S===A&&(I=y),w&&(w.children||(w.children=[]),w.children.push(y),w.children.length>1&&(w.children=w.children.sort((p,c)=>p.pid-c.pid)))}}function g(S){const d=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,p=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(w.exec(S))return"electron-crash-reporter";if(y.exec(S))return"winpty-process";if(p.exec(S))return"console-window-host (Windows internal process)";let r=c.exec(S);if(r&&r.length===2)return r[1]==="renderer"?d.exec(S)?"shared-process":h.exec(S)?"issue-reporter":v.exec(S)?"process-explorer":"window":r[1]==="utility"&&m.exec(S)?"utility-network-service":r[1];const l=/[a-zA-Z-]+\.js/g;let i="";do r=l.exec(S),r&&(i+=r+" ");while(r);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,h)=>{K(["windows-process-tree"],d,h)}).then(d=>{d.getProcessList(A,h=>{d.getProcessCpuUsage(h,v=>{const m=new Map;v.forEach(w=>{const y=S(w.commandLine||"");m.set(w.pid,{name:g(y),cmd:y,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),I=m.get(A),I?(m.forEach(w=>{const y=m.get(w.ppid);y&&(y.children||(y.children=[]),y.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((y,p)=>y.pid-p.pid))}),P(I)):b(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let S=function(){let d=[I];const h=[];for(;d.length;){const m=d.shift();m&&(h.push(m.pid),m.children&&(d=d.concat(m.children)))}let v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);v+=" "+h.join(" "),(0,k.exec)(v,{},(m,w,y)=>{if(m||y)b(m||new Error(y.toString()));else{const p=w.toString().split(`
`);for(let c=0;c<h.length;c++){const r=D.get(h[c]);r.load=parseFloat(p[c])}if(!I){b(new Error(`Root process ${A} not found`));return}P(I)}})};(0,k.exec)("which ps",{},(d,h,v)=>{if(d||v)if(process.platform!=="linux")b(d||new Error(v.toString()));else{const m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,k.exec)(m,{},(w,y,p)=>{w||p?b(w||new Error(p.toString())):(L(y,E),S())})}else{const m=h.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,p,c)=>{y||c&&!c.includes("screen size is bogus")?b(y||new Error(c.toString())):(L(p,E),process.platform==="linux"?S():I?P(I):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=T;function L(A,P){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=A.toString().split(`
`);for(const D of I){const E=b.exec(D.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var he=this&&this.__decorate||function(K,e,k,n){var T=arguments.length,L=T<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,k):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,k,n);else for(var P=K.length-1;P>=0;P--)(A=K[P])&&(L=(T<3?A(L):T>3?A(e,k,L):A(e,k))||L);return T>3&&L&&Object.defineProperty(e,k,L),L};define(te[36],ne([0,1,16,5,17,25,54,9,3,2,108,26,11]),function(K,e,k,n,T,L,A,P,b,I,D,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function v(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(m||(m={}));class w{constructor(x){this.buffer=x,this.pos=0}read(x){const ee=this.buffer.slice(this.pos,this.pos+x);return this.pos+=ee.byteLength,ee}}class y{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var p;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(p||(p={}));function c(B){const x=T.VSBuffer.alloc(4);return x.writeUInt32BE(B,0),x}function r(B){return B.read(4).readUInt32BE(0)}function l(B){const x=T.VSBuffer.alloc(1);return x.writeUInt8(B,0),x}const i={Undefined:l(p.Undefined),String:l(p.String),Buffer:l(p.Buffer),VSBuffer:l(p.VSBuffer),Array:l(p.Array),Object:l(p.Object)},t=typeof Buffer!="undefined";function o(B,x){if(typeof x=="undefined")B.write(i.Undefined);else if(typeof x=="string"){const ee=T.VSBuffer.fromString(x);B.write(i.String),B.write(c(ee.byteLength)),B.write(ee)}else if(t&&Buffer.isBuffer(x)){const ee=T.VSBuffer.wrap(x);B.write(i.Buffer),B.write(c(ee.byteLength)),B.write(ee)}else if(x instanceof T.VSBuffer)B.write(i.VSBuffer),B.write(c(x.byteLength)),B.write(x);else if(Array.isArray(x)){B.write(i.Array),B.write(c(x.length));for(const ee of x)o(B,ee)}else{const ee=T.VSBuffer.fromString(JSON.stringify(x));B.write(i.Object),B.write(c(ee.byteLength)),B.write(ee)}}function s(B){switch(B.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return B.read(r(B)).toString();case p.Buffer:return B.read(r(B)).buffer;case p.VSBuffer:return B.read(r(B));case p.Array:{const ee=r(B),V=[];for(let Z=0;Z<ee;Z++)V.push(s(B));return V}case p.Object:return JSON.parse(B.read(r(B)).toString())}}class a{constructor(x,ee,V=null,Z=1e3){this.protocol=x,this.ctx=ee,this.logger=V,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(x,ee){this.channels.set(x,ee),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const ee=this.send([x.type]);this.logger?.logOutgoing(ee,0,1,v(x.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(ee,x.id,1,v(x.type),x.data);return}}}send(x,ee=void 0){const V=new y;return o(V,x),o(V,ee),this.sendBuffer(V.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const ee=new w(x),V=s(ee),Z=s(ee),Y=V[0];switch(Y){case 100:return this.logger?.logIncoming(x.byteLength,V[1],1,`${d(Y)}: ${V[2]}.${V[3]}`,Z),this.onPromise({type:Y,id:V[1],channelName:V[2],name:V[3],arg:Z});case 102:return this.logger?.logIncoming(x.byteLength,V[1],1,`${d(Y)}: ${V[2]}.${V[3]}`,Z),this.onEventListen({type:Y,id:V[1],channelName:V[2],name:V[3],arg:Z});case 101:return this.logger?.logIncoming(x.byteLength,V[1],1,`${d(Y)}`),this.disposeActiveRequest({type:Y,id:V[1]});case 103:return this.logger?.logIncoming(x.byteLength,V[1],1,`${d(Y)}`),this.disposeActiveRequest({type:Y,id:V[1]})}}onPromise(x){const ee=this.channels.get(x.channelName);if(!ee){this.collectPendingRequest(x);return}const V=new L.CancellationTokenSource;let Z;try{Z=ee.call(this.ctx,x.name,x.arg,V.token)}catch(U){Z=Promise.reject(U)}const Y=x.id;Z.then(U=>{this.sendResponse({id:Y,data:U,type:201}),this.activeRequests.delete(x.id)},U=>{U instanceof Error?this.sendResponse({id:Y,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:Y,data:U,type:203}),this.activeRequests.delete(x.id)});const q=(0,I.toDisposable)(()=>V.cancel());this.activeRequests.set(x.id,q)}onEventListen(x){const ee=this.channels.get(x.channelName);if(!ee){this.collectPendingRequest(x);return}const V=x.id,Y=ee.listen(this.ctx,x.name,x.arg)(q=>this.sendResponse({id:V,data:q,type:204}));this.activeRequests.set(x.id,Y)}disposeActiveRequest(x){const ee=this.activeRequests.get(x.id);ee&&(ee.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let ee=this.pendingRequests.get(x.channelName);ee||(ee=[],this.pendingRequests.set(x.channelName,ee));const V=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:x,timeoutTimer:V})}flushPendingRequests(x){const ee=this.pendingRequests.get(x);if(ee){for(const V of ee)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var u;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(x,ee=null){this.protocol=x,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=ee}getChannel(x){const ee=this;return{call(V,Z,Y){return ee.isDisposed?Promise.reject(P.canceled()):ee.requestPromise(x,V,Z,Y)},listen(V,Z){return ee.isDisposed?b.Event.None:ee.requestEvent(x,V,Z)}}}requestPromise(x,ee,V,Z=L.CancellationToken.None){const Y=this.lastRequestId++,U={id:Y,type:100,channelName:x,name:ee,arg:V};if(Z.isCancellationRequested)return Promise.reject(P.canceled());let M;return new Promise((H,re)=>{if(Z.isCancellationRequested)return re(P.canceled());const se=()=>{const pe=ge=>{switch(ge.type){case 201:this.handlers.delete(Y),H(ge.data);break;case 202:{this.handlers.delete(Y);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,re(Ee);break}case 203:this.handlers.delete(Y),re(ge.data);break}};this.handlers.set(Y,pe),this.sendRequest(U)};let ue=null;this.state===m.Idle?se():(ue=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ue.then(()=>{ue=null,se()}));const de=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:Y,type:101}),re(P.canceled())},we=Z.onCancellationRequested(de);M=(0,I.combinedDisposable)((0,I.toDisposable)(de),we),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(x,ee,V){const Z=this.lastRequestId++,q={id:Z,type:102,channelName:x,name:ee,arg:V};let U=null;const M=new b.Emitter({onFirstListenerAdd:()=>{U=(0,n.createCancelablePromise)(H=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(M),this.sendRequest(q)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(M),this.sendRequest({id:Z,type:103}))}}),W=H=>M.fire(H.data);return this.handlers.set(Z,W),M.event}sendRequest(x){switch(x.type){case 100:case 102:{const ee=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(ee,x.id,0,`${d(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const ee=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(ee,x.id,0,d(x.type));return}}}send(x,ee=void 0){const V=new y;return o(V,x),o(V,ee),this.sendBuffer(V.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const ee=new w(x),V=s(ee),Z=s(ee),Y=V[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,v(Y)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,V[1],0,v(Y),Z),this.onResponse({type:V[0],id:V[1],data:Z})}}onResponse(x){if(x.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const ee=this.handlers.get(x.id);ee&&ee(x)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([A.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class C{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:ee,onDidClientDisconnect:V})=>{b.Event.once(ee.onMessage)(Y=>{const q=new w(Y),U=s(q),M=new a(ee,U),W=new f(ee);this.channels.forEach((re,se)=>M.registerChannel(se,re));const H={channelServer:M,channelClient:W,ctx:U};this._connections.add(H),this._onDidAddConnection.fire(H),V(()=>{M.dispose(),W.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}get connections(){const x=[];return this._connections.forEach(ee=>x.push(ee)),x}getChannel(x,ee){const V=this;return{call(Z,Y,q){let U;if((0,g.isFunction)(ee)){let W=(0,k.getRandomElement)(V.connections.filter(ee));U=W?Promise.resolve(W):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,ee))}else U=ee.routeCall(V,Z,Y);const M=U.then(W=>W.channelClient.getChannel(x));return O(M).call(Z,Y,q)},listen(Z,Y){if((0,g.isFunction)(ee))return V.getMulticastEvent(x,ee,Z,Y);const q=ee.routeEvent(V,Z,Y).then(U=>U.channelClient.getChannel(x));return O(q).listen(Z,Y)}}}getMulticastEvent(x,ee,V,Z){const Y=this;let q=new I.DisposableStore;const U=new b.Emitter({onFirstListenerAdd:()=>{q=new I.DisposableStore;const M=new b.EventMultiplexer,W=new Map,H=se=>{const de=se.channelClient.getChannel(x).listen(V,Z),we=M.add(de);W.set(se,we)},re=se=>{const ue=W.get(se);!ue||(ue.dispose(),W.delete(se))};Y.connections.filter(ee).forEach(H),b.Event.filter(Y.onDidAddConnection,ee)(H,void 0,q),Y.onDidRemoveConnection(re,void 0,q),M.event(U.fire,U,q),q.add(M)},onLastListenerRemove:()=>{q.dispose()}});return U.event}registerChannel(x,ee){this.channels.set(x,ee),this._connections.forEach(V=>{V.channelServer.registerChannel(x,ee)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class _{constructor(x,ee,V=null){const Z=new y;o(Z,ee),x.send(Z.buffer),this.channelClient=new f(x,V),this.channelServer=new a(x,ee,V)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,ee){this.channelServer.registerChannel(x,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(B){return{call(x,ee,V){return B.then(Z=>Z.call(x,ee,V))},listen(x,ee){const V=new b.Relay;return B.then(Z=>V.input=Z.listen(x,ee)),V.event}}}e.getDelayedChannel=O;function F(B){let x=!1;return{call(ee,V,Z){return x?B.call(ee,V,Z):(0,n.timeout)(0).then(()=>x=!0).then(()=>B.call(ee,V,Z))},listen(ee,V){if(x)return B.listen(ee,V);const Z=new b.Relay;return(0,n.timeout)(0).then(()=>x=!0).then(()=>Z.input=B.listen(ee,V)),Z.event}}}e.getNextTickChannel=F;class R{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const ee of x.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await b.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=R;var N;(function(B){function x(Y,q){const U=Y,M=q&&q.disableMarshalling,W=new Map;for(const H in U)V(H)&&W.set(H,b.Event.buffer(U[H],!0));return new class{listen(H,re,se){const ue=W.get(re);if(ue)return ue;if(Z(re)){const de=U[re];if(typeof de=="function")return de.call(U,se)}throw new Error(`Event not found: ${re}`)}call(H,re,se){const ue=U[re];if(typeof ue=="function"){if(!M&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,D.revive)(se[de]);return ue.apply(U,se)}throw new Error(`Method not found: ${re}`)}}}B.fromService=x;function ee(Y,q){const U=q&&q.disableMarshalling;return new Proxy({},{get(M,W){if(typeof W=="string")return q?.properties?.has(W)?q.properties.get(W):Z(W)?function(H){return Y.listen(W,H)}:V(W)?Y.listen(W):async function(...H){let re;q&&!(0,g.isUndefinedOrNull)(q.context)?re=[q.context,...H]:re=H;const se=await Y.call(W,re);return U?se:(0,D.revive)(se)};throw new Error(`Property not found: ${String(W)}`)}})}B.toService=ee;function V(Y){return Y[0]==="o"&&Y[1]==="n"&&E.isUpperAsciiLetter(Y.charCodeAt(2))}function Z(Y){return/^onDynamic/.test(Y)&&E.isUpperAsciiLetter(Y.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let x=B.toString();if(x!=="[object Object]")return x}return B}function X(B){return Array.isArray(B)?B.map(j):j(B)}function z(B,x,ee,V,Z,Y,q){q=X(q);const U=$[Z],M=U[V%U.length];let W=[`%c[${B}]%c[${String(x).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Y)?(W=W.concat(q),W.push(")")):W.push(q),console.log.apply(console,W)}e.logWithColors=z;class J{constructor(x,ee){this._outgoingPrefix=x,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,ee,V,Z,Y){this._totalOutgoing+=x,z(this._outgoingPrefix,this._totalOutgoing,x,ee,V,Z,Y)}logIncoming(x,ee,V,Z,Y){this._totalIncoming+=x,z(this._incomingPrefix,this._totalIncoming,x,ee,V,Z,Y)}}e.IPCLogger=J}),define(te[117],ne([0,1,17,3,36]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",I=>k.VSBuffer.wrap(I.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends T.IPCClient{constructor(b,I){const D=new L(b);super(D,I);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[74],ne([0,1,17,3,2,36]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let s=0;function a(f,C){if(!o.has(f)){const _=String(++s);o.set(f,_)}return o.get(f)}function u(f,C,_,O){if(!t.enableDiagnostics)return;const F=a(f,C);if(O instanceof k.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const R=k.VSBuffer.alloc(O.byteLength);R.set(O),t.records.push({timestamp:Date.now(),id:F,label:C,type:_,buff:R})}else t.records.push({timestamp:Date.now(),id:F,label:C,type:_,data:O})}t.traceSocketEvent=u})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function D(){return I||(I=k.VSBuffer.alloc(0)),I}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return D();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const C=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),C}if(this._chunks[0].byteLength>o){const C=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),C}let a=k.VSBuffer.alloc(o),u=0,f=0;for(;o>0;){const C=this._chunks[f];if(C.byteLength>o){const _=C.slice(0,o);a.set(_,u),u+=o,s&&(this._chunks[f]=C.slice(o),this._totalLength-=o),o-=o}else a.set(C,u),u+=C.byteLength,s?(this._chunks.shift(),this._totalLength-=C.byteLength):f++,o-=C.byteLength}return a}}e.ChunkStream=E;var g;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(g||(g={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,s,a,u){this.type=o,this.id=s,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends T.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,u=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new h(a,u,f,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends T.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=w;class y extends L.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new y(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=y;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class c{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new c(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class l{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<l._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=l._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const o=Date.now(),s=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<l._HISTORY_LENGTH;u++)o-this.lastRuns[u]<=s&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class i{constructor(o,s=null,a=l.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,D());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new h(7,0,0,D());this._socketWriter.write(o)}sendResume(){const o=new h(8,0,0,D());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,D());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,u=s.length;a<u;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new h(6,0,0,D())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,u=s.length;a<u;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new h(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-s,2e4-a,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,D());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(te[118],ne([0,1,75,3,36,117]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends T.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(I,D)=>D);return n.Event.map(b,I=>{const{port1:D,port2:E}=new MessageChannel,S={protocol:new L.Protocol(D),onDidClientDisconnect:n.Event.fromDOMEventEmitter(D,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[E]),S})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function n(L){return L instanceof T?!0:L instanceof Error&&L.name===k&&L.message===k}e.isOfflineError=n;class T extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=T}),define(te[120],ne([0,1,17,9,119]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(b,I){if(!navigator.onLine)throw new T.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const D=new XMLHttpRequest;return new Promise((E,g)=>{D.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(D,b),D.responseType="arraybuffer",D.onerror=S=>g(new Error(D.statusText&&"XHR failed: "+D.statusText||"XHR failed")),D.onload=S=>{E({res:{statusCode:D.status,headers:P(D)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(D.response)))})},D.ontimeout=S=>g(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(D.timeout=b.timeout),D.send(b.data),I.onCancellationRequested(()=>{D.abort(),g((0,n.canceled)())})})}e.request=L;function A(b,I){if(I.headers){e:for(let D in I.headers){switch(D){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(D,I.headers[D])}}}function P(b){const I=Object.create(null);for(const D of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(D){const E=D.indexOf(":");I[D.substr(0,E).trim().toLowerCase()]=D.substr(E+1).trim()}return I}}),define(te[76],ne([0,1,5,3,2,11]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(E){const g=E;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b=e.StorageState||(e.StorageState={}));class I extends T.Disposable{constructor(g,S=Object.create(null)){super();this.database=g,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((S,d)=>this.accept(d,S)),g.deleted?.forEach(S=>this.accept(S,void 0))}accept(g,S){if(this.state===b.Closed)return;let d=!1;(0,L.isUndefinedOrNull)(S)?d=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),d=!0),d&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const d=this.cache.get(g);return(0,L.isUndefinedOrNull)(d)?S:d}getBoolean(g,S){const d=this.get(g);return(0,L.isUndefinedOrNull)(d)?S:d==="true"}getNumber(g,S){const d=this.get(g);return(0,L.isUndefinedOrNull)(d)?S:parseInt(d,10)}async set(g,S){if(this.state===b.Closed)return;if((0,L.isUndefinedOrNull)(S))return this.delete(g);const d=String(S);if(this.cache.get(g)!==d)return this.cache.set(g,d),this.pendingInserts.set(g,d),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===b.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((S,d)=>this.items.set(d,S)),g.delete&&g.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=D}),define(te[121],ne([12,13]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[57],ne([0,1,121]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,T=n*60,L=T*24,A=L*7,P=L*30,b=L*365;function I(E,g,S){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,k.localize)(0,null,I(new Date().getTime()+d*1e3,!1));if(d<30)return(0,k.localize)(1,null);let h;return d<n?(h=d,g?h===1?S?(0,k.localize)(2,null,h):(0,k.localize)(3,null,h):S?(0,k.localize)(4,null,h):(0,k.localize)(5,null,h):h===1?S?(0,k.localize)(6,null,h):(0,k.localize)(7,null,h):S?(0,k.localize)(8,null,h):(0,k.localize)(9,null,h)):d<T?(h=Math.floor(d/n),g?h===1?S?(0,k.localize)(10,null,h):(0,k.localize)(11,null,h):S?(0,k.localize)(12,null,h):(0,k.localize)(13,null,h):h===1?S?(0,k.localize)(14,null,h):(0,k.localize)(15,null,h):S?(0,k.localize)(16,null,h):(0,k.localize)(17,null,h)):d<L?(h=Math.floor(d/T),g?h===1?S?(0,k.localize)(18,null,h):(0,k.localize)(19,null,h):S?(0,k.localize)(20,null,h):(0,k.localize)(21,null,h):h===1?S?(0,k.localize)(22,null,h):(0,k.localize)(23,null,h):S?(0,k.localize)(24,null,h):(0,k.localize)(25,null,h)):d<A?(h=Math.floor(d/L),g?h===1?(0,k.localize)(26,null,h):(0,k.localize)(27,null,h):h===1?(0,k.localize)(28,null,h):(0,k.localize)(29,null,h)):d<P?(h=Math.floor(d/A),g?h===1?S?(0,k.localize)(30,null,h):(0,k.localize)(31,null,h):S?(0,k.localize)(32,null,h):(0,k.localize)(33,null,h):h===1?S?(0,k.localize)(34,null,h):(0,k.localize)(35,null,h):S?(0,k.localize)(36,null,h):(0,k.localize)(37,null,h)):d<b?(h=Math.floor(d/P),g?h===1?S?(0,k.localize)(38,null,h):(0,k.localize)(39,null,h):S?(0,k.localize)(40,null,h):(0,k.localize)(41,null,h):h===1?S?(0,k.localize)(42,null,h):(0,k.localize)(43,null,h):S?(0,k.localize)(44,null,h):(0,k.localize)(45,null,h)):(h=Math.floor(d/b),g?h===1?S?(0,k.localize)(46,null,h):(0,k.localize)(47,null,h):S?(0,k.localize)(48,null,h):(0,k.localize)(49,null,h):h===1?S?(0,k.localize)(50,null,h):(0,k.localize)(51,null,h):S?(0,k.localize)(52,null,h):(0,k.localize)(53,null,h))}e.fromNow=I;function D(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(te[122],ne([12,13]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,16,11,122]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(E,g){return g&&(E.stack||E.stacktrace)?T.localize(0,null,P(E),A(E.stack)||A(E.stacktrace)):P(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?T.localize(1,null,E.message):E.message||T.localize(2,null)}function b(E=null,g=!1){if(!E)return T.localize(3,null);if(Array.isArray(E)){const S=k.coalesce(E),d=b(S[0],g);return S.length>1?T.localize(4,null,d,S.length):d}if(n.isString(E))return E;if(E.detail){const S=E.detail;if(S.error)return L(S.error,g);if(S.exception)return L(S.exception,g)}return E.stack?L(E,g):E.message?E.message:T.localize(5,null)}e.toErrorMessage=b;function I(E){const g=E;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=I;function D(E,g=Object.create(null)){const S=new Error(E);return g.actions&&(S.actions=g.actions),S}e.createErrorWithActions=D}),define(te[123],ne([12,13]),function(K,e){return K.create("vs/base/node/processes",e)}),define(te[77],ne([0,1,45,41,18,28,10,4,33,103,11,111,22,123]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function d(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(r,l){if(P.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};l&&(i.cwd=l);const t=k.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{t.once("error",s=>{o({success:!1,error:s})}),t.once("exit",(s,a)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(P.isLinux||P.isMacintosh)try{const i=T.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(t=>{k.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,s,a)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,P.isMacintosh&&delete r.DYLD_LIBRARY_PATH,P.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function m(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(l,i,t,o){if(i!==void 0&&t!==void 0&&o!==void 0)this.cmd=l,this.args=i,this.shell=t,this.options=o;else{const s=l;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(a=>{s[a]=b.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const i=l.lastIndexOf(A.sep);return i!==-1&&(l=l.substring(i+1)),w.WellKnowCommands[l]?l:"other"}start(l){return P.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let t,o;const s=new Promise((a,u)=>{t=a,o=u});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(u,f,C)=>{this.childProcess=null;const _=u;_&&_.killed?o({killed:this.terminateRequested,stdout:f.toString(),stderr:C.toString()}):this.handleExec(t,l,u,f,C)})}else{let a=null;const u=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,t,l,o);const C={terminated:this.terminateRequested};D.isNumber(f)&&(C.cmdCode=f),t(C)};if(this.shell&&P.isWindows){const f=L.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let C=!1,_=!1;const O=[];let F=this.ensureQuotes(this.cmd);O.push(F.value),C=F.quoted,this.args&&this.args.forEach(N=>{F=this.ensureQuotes(N),O.push(F.value),_=_&&F.quoted});const R=["/s","/c"];C?_?R.push('"'+O.join(" ")+'"'):O.length>1?R.push('"'+O[0]+'" '+O.slice(1).join(" ")):R.push('"'+O[0]+'"'):R.push(O.join(" ")),a=k.spawn(m(),R,f)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(D.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,o({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",u),this.handleSpawn(a,t,l,o,!0)))}return s})}handleClose(l,i,t,o){}ensureQuotes(l){return w.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,h(l,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!P.isWindows)return l(!1);const i=k.spawn(m(),["/s","/c"]);i.on("error",t=>l(!0)),i.on("exit",t=>l(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class y extends w{constructor(l,i,t,o){super(l,i,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,i,t,o,s){[o,s].forEach((a,u)=>{const f=new E.LineDecoder;f.write(a).forEach(O=>{i({line:O,source:u===0?0:1})});const _=f.end();_&&i({line:_,source:u===0?0:1})}),l({terminated:this.terminateRequested,error:t})}handleSpawn(l,i,t,o,s){const a=new E.LineDecoder,u=new E.LineDecoder;l.stdout.on("data",f=>{a.write(f).forEach(_=>t({line:_,source:0}))}),l.stderr.on("data",f=>{u.write(f).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=u}handleClose(l,i,t,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=y;function p(r){let l=[],i=!1;const t=function(o){if(i){l.push(o);return}(!r.send(o,a=>{if(a&&console.error(a),i=!1,l.length>0){const u=l.slice(0);l=[],u.forEach(f=>t(f))}})||P.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=p;var c;(function(r){async function l(i,t,o){if(A.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),A.dirname(i)!=="."||(o===void 0&&D.isString(b.env.PATH)&&(o=b.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(t,i);async function a(u){if(await g.Promises.exists(u)){let f;try{f=await g.Promises.stat(u)}catch(C){C.message.startsWith("EACCES")&&(f=await g.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(let u of o){let f;if(A.isAbsolute(u)?f=A.join(u,i):f=A.join(t,u,i),await a(f))return f;let C=f+".com";if(await a(C)||(C=f+".exe",await a(C)))return C}return A.join(t,i)}r.findExecutable=l})(c=e.win32||(e.win32={}))}),define(te[124],ne([0,1,34,4,73,77]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(S,d){return S===1?n.isWindows?E():L.getWindowsShell(d):I(S,d)}e.getSystemShell=A;function P(S,d){return S===1?n.isWindows?g(d):L.getWindowsShell(d):I(S,d)}e.getSystemShellSync=P;let b=null;function I(S,d){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!b){let h;if(n.isWindows)h="/bin/bash";else{if(h=d.SHELL,!h)try{h=(0,k.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}b=h}return b}let D=null;async function E(){return D||(D=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),D}function g(S){if(D)return D;const d=n.isWindows&&parseFloat((0,k.release)())>=10,h=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?v:L.getWindowsShell(S)}}),define(te[58],ne([0,1,45,5,17,25,107,9,3,2,28,77,36]),function(K,e,k,n,T,L,A,P,b,I,D,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends g.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>T.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=S;class d{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(v){const m=this;return{call(w,y,p){return m.requestPromise(v,w,y,p)},listen(w,y){return m.requestEvent(v,w,y)}}}requestPromise(v,m,w,y=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(v),c=(0,n.createCancelablePromise)(i=>p.call(m,w,i)),r=y.onCancellationRequested(()=>c.cancel()),l=(0,I.toDisposable)(()=>c.cancel());return this.activeRequests.add(l),c.finally(()=>{r.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(v,m,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let y;const p=new b.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(v).listen(m,w)(p.fire,p),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,v,m);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,A.isRemoteConsoleLog)(t)){(0,A.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(T.VSBuffer.wrap(Buffer.from(t,"base64")))});const p=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,c=t=>this.child&&this.child.connected&&p.send(t.buffer.toString("base64")),r=w.event,l={send:c,onMessage:r};this._client=new g.ChannelClient(l);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,I.dispose)(s)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(te[125],ne([12,13]),function(K,e){return K.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([12,13]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[138],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[139],ne([12,13]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([12,13]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[141],ne([12,13]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([12,13]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([12,13]),function(K,e){return K.create("vs/platform/terminal/node/shellEnv",e)}),define(te[144],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[78],ne([0,1,57,54,18,10,33,20,7]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(h,v,m){this._args=h,this.paths=v,this.productService=m}get appRoot(){return(0,L.dirname)(T.FileAccess.asFileUri("",K).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(b.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?b.URI.file((0,L.join)(h,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.resolve)(h):(0,L.normalize)((0,L.join)(T.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,L.resolve)(h):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.resolve)(h);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const m=A.env.VSCODE_PORTABLE;return m?(0,L.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,L.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?b.URI.parse(h):b.URI.file((0,L.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([n.memoize],I.prototype,"appRoot",null),he([n.memoize],I.prototype,"userHome",null),he([n.memoize],I.prototype,"userDataPath",null),he([n.memoize],I.prototype,"appSettingsHome",null),he([n.memoize],I.prototype,"tmpDir",null),he([n.memoize],I.prototype,"cacheHome",null),he([n.memoize],I.prototype,"userRoamingDataHome",null),he([n.memoize],I.prototype,"settingsResource",null),he([n.memoize],I.prototype,"userDataSyncHome",null),he([n.memoize],I.prototype,"userDataSyncLogResource",null),he([n.memoize],I.prototype,"sync",null),he([n.memoize],I.prototype,"machineSettingsResource",null),he([n.memoize],I.prototype,"globalStorageHome",null),he([n.memoize],I.prototype,"workspaceStorageHome",null),he([n.memoize],I.prototype,"keybindingsResource",null),he([n.memoize],I.prototype,"keyboardLayoutResource",null),he([n.memoize],I.prototype,"argvResource",null),he([n.memoize],I.prototype,"snippetsHome",null),he([n.memoize],I.prototype,"isExtensionDevelopment",null),he([n.memoize],I.prototype,"untitledWorkspacesHome",null),he([n.memoize],I.prototype,"installSourcePath",null),he([n.memoize],I.prototype,"builtinExtensionsPath",null),he([n.memoize],I.prototype,"extensionsPath",null),he([n.memoize],I.prototype,"extensionDevelopmentLocationURI",null),he([n.memoize],I.prototype,"extensionDevelopmentKind",null),he([n.memoize],I.prototype,"extensionTestsLocationURI",null),he([n.memoize],I.prototype,"debugExtensionHost",null),he([n.memoize],I.prototype,"serviceMachineIdResource",null),he([n.memoize],I.prototype,"telemetryLogResource",null),he([n.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function D(d,h){return S(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=D;function E(d,h){return S(d["inspect-search"],d["inspect-brk-search"],5876,h,d.extensionEnvironment)}e.parseSearchPort=E;function g(d,h){return S(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,h,d.extensionEnvironment)}e.parsePtyHostPort=g;function S(d,h,v,m,w,y){const c=Number(h||d)||(m?null:v),r=c?Boolean(!!h):!1;let l;if(y)try{l=JSON.parse(y)}catch{}return{port:c,break:r,debugId:w,env:l}}}),define(te[150],ne([0,1,252,4,127]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,T.localize)(0,null),e:(0,T.localize)(1,null),t:(0,T.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,T.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,T.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,T.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,T.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,T.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,T.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,T.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,T.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,T.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,T.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,T.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,T.localize)(14,null)},category:{type:"string",cat:"e",description:(0,T.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,T.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,T.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,T.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,T.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,T.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,T.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,T.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,T.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,T.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,T.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,T.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,T.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,T.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,T.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,T.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,T.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,T.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function P(d,h,v=A){const m={},w=[],y=[];for(let l in h){const i=h[l];i.alias&&(m[l]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(l),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(y.push(l),i.deprecates&&y.push(...i.deprecates))}const p=k(d,{string:w,boolean:y,alias:m}),c={},r=p;c._=p._.map(l=>String(l)).filter(l=>l.length>0),delete r._;for(let l in h){const i=h[l];i.alias&&delete r[i.alias];let t=r[l];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(t||(t=r[o],t&&v.onDeprecatedOption(o,i.deprecationMessage||(0,T.localize)(33,null))),delete r[o]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),v.onMultipleValues(l,t)),c[l]=t,i.deprecationMessage&&v.onDeprecatedOption(l,i.deprecationMessage)),delete r[l]}for(let l in r)v.onUnknownOption(l);return c}e.parseArgs=P;function b(d,h){let v="";return h.args&&(Array.isArray(h.args)?v=` <${h.args.join("> <")}>`:v=` <${h.args}>`),h.alias?`-${h.alias} --${d}${v}`:`--${d}${v}`}function I(d,h){let v=0,m=[];for(const c in d){const r=d[c],l=b(c,r);v=Math.max(v,l.length),m.push([l,r.description])}let w=v+2+1;if(h-w<25)return m.reduce((c,r)=>c.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let y=h-w-1,p=[];for(const c of m){let r=c[0],l=E(c[1],y),i=D(w-r.length-2);p.push("  "+r+i+l[0]);for(let t=1;t<l.length;t++)p.push(D(w)+l[t])}return p}e.formatOptions=I;function D(d){return" ".repeat(d)}function E(d,h){let v=[];for(;d.length;){let m=d.length<h?d.length:d.lastIndexOf(" ",h),w=d.slice(0,m).trim();d=d.slice(m),v.push(w)}return v}function g(d,h,v,m,w){const y=process.stdout.isTTY&&process.stdout.columns||80,p=w?.noInputFiles!==!0?`[${(0,T.localize)(34,null)}...]`:"",c=[`${d} ${v}`];c.push(""),c.push(`${(0,T.localize)(35,null)}: ${h} [${(0,T.localize)(36,null)}]${p}`),c.push(""),w?.noPipe!==!0&&(n.isWindows?c.push((0,T.localize)(37,null,h)):c.push((0,T.localize)(38,null,h)),c.push(""));const r={};for(const l in m){const i=m[l];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[l]=i}}for(let l in r){const i=l;let t=r[i];t&&(c.push(L[i]),c.push(...I(t,y)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=g;function S(d,h){return`${d||(0,T.localize)(39,null)}
${h||(0,T.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=S}),define(te[151],ne([0,1,253,128,150]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(g,S){const d={onUnknownOption:v=>{console.warn((0,n.localize)(0,null,v))},onMultipleValues:(v,m)=>{console.warn((0,n.localize)(1,null,v,m))},onDeprecatedOption:(v,m)=>{console.warn((0,n.localize)(2,null,v,m))}},h=(0,T.parseArgs)(g,T.OPTIONS,S?d:void 0);return h.goto&&h._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,n.localize)(3,null))),h["max-memory"]&&k(parseInt(h["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),h}function P(g){const S=g.findIndex(d=>!/^-/.test(d));if(S>-1)return[...g.slice(0,S),...g.slice(S+1)]}function b(g){let[,...S]=g;process.env.VSCODE_DEV&&(S=P(S)||[]);const d=!E(process.env);return A(S,d)}e.parseMainProcessArgv=b;function I(g){const[,,...S]=g;return A(S,!0)}e.parseCLIProcessArgv=I;function D(g,...S){const d=g.indexOf("--");return d===-1?g.push(...S):g.splice(d,0,...S),g}e.addArg=D;function E(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function K(e,k,n,T){function L(P){const b=A(P),I=[b];return e.isAbsolute(b)||I.unshift(T),e.resolve(...I)}function A(P){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,n);const D=P["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(E,"AppData","Roaming")}break;case"darwin":I=e.join(k.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,n)}return{getUserDataPath:L}}if(typeof define=="function")define(te[152],ne([0,254,34,18,20,33]),function(e,k,n,T,L,A){const P=L.dirname(T.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return K(k,n,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),n=require("os");module.exports=K(k,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[153],ne([0,1,34,78,152]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends n.AbstractNativeEnvironmentService{constructor(P,b){super(P,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(P)},b)}}e.NativeEnvironmentService=L}),define(te[154],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,T=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(v){const m=v.match(A);return m?m[1]:null}function D(v){if(v.indexOf("://")===-1){const m=v.match(n);return m?I(m[2]):null}try{const m=k.URI.parse(v);if(m.authority)return I(m.authority)}catch{}return null}function E(v,m){const w=new Set;let y;for(;y=P.exec(v);){const c=D(y[1]);c&&w.add(c)}const p=new Set(m);return Array.from(w).map(c=>p.has(c)?c:c.replace(b,"a"))}e.getDomainsOfRemotes=E;function g(v){const m=v.match(L);return m?m[2]:null}function S(v,m,w){return v&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${v}${m}`:`${v}/${m}`):null}function d(v,m){if(v.indexOf("://")===-1){const w=v.match(T);if(w)return S(w[2],w[3],m)}try{const w=k.URI.parse(v);if(w.authority)return S(g(w.authority),w.path,m)}catch{}return null}function h(v,m=!1){const w=[];let y;for(;y=P.exec(v);){const p=d(y[1],m);p&&w.push(p)}return w}e.getRemotes=h}),define(te[155],ne([0,1,28]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function T(L,A){const P=b=>{if(typeof b!="string")return;const I=n.exec(b);if(!I)return;const D=A[I[1]]??b;return typeof D=="string"?D:typeof D.message=="string"?D.message:b};return(0,k.cloneAndChange)(L,P)}e.localizeManifest=T}),define(te[156],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,P,b){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,P,b])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class n{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(te[79],ne([0,1,135]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function L(g){return g=g.trim(),g==="*"||n.test(g)}e.isValidVersionStr=L;function A(g){if(!L(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=A;function P(g){if(!g)return null;let S=g.majorBase,d=g.majorMustEqual,h=g.minorBase,v=g.minorMustEqual,m=g.patchBase,w=g.patchMustEqual;g.hasCaret&&(S===0||(v=!1),w=!1);let y=0;if(g.preRelease){const p=T.exec(g.preRelease);if(p){const[,c,r,l]=p;y=Date.UTC(Number(c),Number(r)-1,Number(l))}}return{majorBase:S,majorMustEqual:d,minorBase:h,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:g.hasGreaterEquals,notBefore:y}}e.normalizeVersion=P;function b(g,S,d){let h;typeof g=="string"?h=P(A(g)):h=g;let v;S instanceof Date?v=S.getTime():typeof S=="string"&&(v=new Date(S).getTime());let m;if(typeof d=="string"?m=P(A(d)):m=d,!h||!m)return!1;let w=h.majorBase,y=h.minorBase,p=h.patchBase,c=m.majorBase,r=m.minorBase,l=m.patchBase,i=m.notBefore,t=m.majorMustEqual,o=m.minorMustEqual,s=m.patchMustEqual;return m.isMinimum?w>c?!0:w<c?!1:y>r?!0:y<r||v&&v<i?!1:p>=l:(w===1&&c===0&&(!t||!o||!s)&&(c=1,r=0,l=0,t=!0,o=!1,s=!1),w<c?!1:w>c?!t:y<r?!1:y>r?!o:p<l?!1:p>l?!s:!(v&&v<i))}e.isValidVersion=b;function I(g,S,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:E(g,S,d.engines.vscode,h)}e.isValidExtensionVersion=I;function D(g,S,d){return g==="*"||E(S,d,g)}e.isEngineValid=D;function E(g,S,d,h=[]){let v=P(A(d));if(!v)return h.push(k.localize(0,null,d)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(k.localize(1,null,d)),!1}else if(!v.majorMustEqual)return h.push(k.localize(2,null,d)),!1;return b(g,S,v)?!0:(h.push(k.localize(3,null,g,d)),!1)}}),define(te[46],ne([0,1,17,29]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(L,A,P){let b=P&&P.get("storage.serviceMachineId",0)||null;if(b)return b;try{const D=(await A.readFile(L.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(D)?D:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(b))}catch{}}return P&&P.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=T}),define(te[51],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(T,L=[],A=!1){this.ctor=T,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(te[80],ne([0,1,51]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function T(A,P,b){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],b)),n.push([A,P])}e.registerSingleton=T;function L(){return n}e.getSingletonServiceDescriptors=L}),define(te[157],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=k;class n{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const P=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(L),P)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let P=this._nodes.get(A);return P||(P=new k(L),this._nodes.set(A,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[A,P]of this._nodes)L.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,A]of this._nodes){const P=new Set([L]),b=this._findCycle(A,P);if(b)return b}}_findCycle(L,A){for(let[P,b]of L.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const I=this._findCycle(b,A);if(I)return I;A.delete(P)}}}e.Graph=n}),define(te[6],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(k=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function n(A,P,b){P[k.DI_TARGET]===P?P[k.DI_DEPENDENCIES].push({id:A,index:b}):(P[k.DI_DEPENDENCIES]=[{id:A,index:b}],P[k.DI_TARGET]=P)}function T(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const P=function(b,I,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(P,b,D)};return P.toString=()=>A,k.serviceIds.set(A,P),P}e.createDecorator=T;function L(A){return A}e.refineServiceDecorator=L}),define(te[158],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[19],ne([0,1,11,7,6]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function L(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof n.URI)}e.isConfigurationOverrides=L;function A(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||k.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function I(v,m){const w=Object.create(null);for(let y in v)D(w,y,v[y],m);return w}e.toValuesTree=I;function D(v,m,w,y){const p=m.split("."),c=p.pop();let r=v;for(let l=0;l<p.length;l++){let i=p[l],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${m} as ${p.slice(0,l+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[c]=w}catch{y(`Ignoring ${m} as ${p.join(".")} is ${JSON.stringify(r)}`)}else y(`Ignoring ${m} as ${p.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=D;function E(v,m){const w=m.split(".");g(v,w)}e.removeFromValueTree=E;function g(v,m){const w=m.shift();if(m.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const y=v[w];typeof y=="object"&&!Array.isArray(y)&&(g(y,m),Object.keys(y).length===0&&delete v[w])}}function S(v,m,w){function y(r,l){let i=r;for(const t of l){if(typeof i!="object"||i===null)return;i=i[t]}return i}const p=m.split("."),c=y(v,p);return typeof c=="undefined"?w:c}e.getConfigurationValue=S;function d(v,m,w){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in v?k.isObject(v[y])&&k.isObject(m[y])?d(v[y],m[y],w):w&&(v[y]=m[y]):v[y]=m[y])})}e.merge=d;function h(v,m,w){const y=v.inspect(m),p=v.inspect(w);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:y.defaultValue}e.getMigratedSettingValue=h}),define(te[159],ne([0,1,4,26,6]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",k.isMacintosh),L.set("isLinux",k.isLinux),L.set("isWindows",k.isWindows),L.set("isWeb",k.isWeb),L.set("isMacNative",k.isMacintosh&&!k.isWeb),L.set("isEdge",k.isEdge),L.set("isFirefox",k.isFirefox),L.set("isChrome",k.isChrome),L.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return E.INSTANCE}static true(){return g.INSTANCE}static has(R){return S.create(R)}static equals(R,N){return d.create(R,N)}static notEquals(R,N){return m.create(R,N)}static regex(R,N){return i.create(R,N)}static in(R,N){return h.create(R,N)}static not(R){return w.create(R)}static and(...R){return s.create(R,null)}static or(...R){return a.create(R,null,!0)}static greater(R,N){return p.create(R,N)}static greaterEquals(R,N){return c.create(R,N)}static smaller(R,N){return r.create(R,N)}static smallerEquals(R,N){return l.create(R,N)}static deserialize(R,N=!1){if(!!R)return this._deserializeOrExpression(R,N)}static _deserializeOrExpression(R,N){let $=R.split("||");return a.create($.map(j=>this._deserializeAndExpression(j,N)),null,!0)}static _deserializeAndExpression(R,N){let $=R.split("&&");return s.create($.map(j=>this._deserializeOne(j,N)),null)}static _deserializeOne(R,N){if(R=R.trim(),R.indexOf("!=")>=0){let $=R.split("!=");return m.create($[0].trim(),this._deserializeValue($[1],N))}if(R.indexOf("==")>=0){let $=R.split("==");return d.create($[0].trim(),this._deserializeValue($[1],N))}if(R.indexOf("=~")>=0){let $=R.split("=~");return i.create($[0].trim(),this._deserializeRegexValue($[1],N))}if(R.indexOf(" in ")>=0){let $=R.split(" in ");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const $=R.split(">=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const $=R.split(">");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const $=R.split("<=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const $=R.split("<");return r.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(R)?w.create(R.substr(1).trim()):S.create(R)}static _deserializeValue(R,N){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;let $=/^'([^']*)'$/.exec(R);return $?$[1].trim():R}static _deserializeRegexValue(R,N){if((0,n.isFalsyOrWhitespace)(R)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=R.indexOf("/"),j=R.lastIndexOf("/");if($===j||$<0){if(N)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}let X=R.slice($+1,j),z=R[j+1]==="i"?"i":"";try{return new RegExp(X,z)}catch(J){if(N)throw new Error(`bad regexp-value '${R}', parse error: ${J}`);return console.warn(`bad regexp-value '${R}', parse error: ${J}`),null}}}e.ContextKeyExpr=b;function I(F,R){const N=F?F.substituteConstants():void 0,$=R?R.substituteConstants():void 0;return!N&&!$?!0:!N||!$?!1:N.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function D(F,R){return F.cmp(R)}class E{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class g{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class S{constructor(R,N){this.key=R,this.negated=N,this.type=2}static create(R,N=null){const $=L.get(R);return typeof $=="boolean"?$?g.INSTANCE:E.INSTANCE:new S(R,N)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?g.INSTANCE:E.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class d{constructor(R,N,$){this.key=R,this.value=N,this.negated=$,this.type=4}static create(R,N,$=null){if(typeof N=="boolean")return N?S.create(R,$):w.create(R,$);const j=L.get(R);return typeof j=="boolean"?N===(j?"true":"false")?g.INSTANCE:E.INSTANCE:new d(R,N,$)}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const N=R?"true":"false";return this.value===N?g.INSTANCE:E.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class h{constructor(R,N){this.key=R,this.valueKey=N,this.type=10,this.negated=null}static create(R,N){return new h(R,N)}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const N=R.getValue(this.valueKey),$=R.getValue(this.key);return Array.isArray(N)?N.indexOf($)>=0:typeof $=="string"&&typeof N=="object"&&N!==null?A.call(N,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=h;class v{constructor(R){this._actual=R,this.type=11}static create(R){return new v(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new v(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class m{constructor(R,N,$){this.key=R,this.value=N,this.negated=$,this.type=5}static create(R,N,$=null){if(typeof N=="boolean")return N?w.create(R,$):S.create(R,$);const j=L.get(R);return typeof j=="boolean"?N===(j?"true":"false")?E.INSTANCE:g.INSTANCE:new m(R,N,$)}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const N=R?"true":"false";return this.value===N?E.INSTANCE:g.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class w{constructor(R,N){this.key=R,this.negated=N,this.type=3}static create(R,N=null){const $=L.get(R);return typeof $=="boolean"?$?E.INSTANCE:g.INSTANCE:new w(R,N)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?E.INSTANCE:g.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function y(F,R){if(typeof F=="string"){const N=parseFloat(F);isNaN(N)||(F=N)}return typeof F=="string"||typeof F=="number"?R(F):E.INSTANCE}class p{constructor(R,N,$){this.key=R,this.value=N,this.negated=$,this.type=12}static create(R,N,$=null){return y(N,j=>new p(R,j,$))}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class c{constructor(R,N,$){this.key=R,this.value=N,this.negated=$,this.type=13}static create(R,N,$=null){return y(N,j=>new c(R,j,$))}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class r{constructor(R,N,$){this.key=R,this.value=N,this.negated=$,this.type=14}static create(R,N,$=null){return y(N,j=>new r(R,j,$))}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class l{constructor(R,N,$){this.key=R,this.value=N,this.negated=$,this.type=15}static create(R,N,$=null){return y(N,j=>new l(R,j,$))}cmp(R){return R.type!==this.type?this.type-R.type:C(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class i{constructor(R,N){this.key=R,this.regexp=N,this.type=7,this.negated=null}static create(R,N){return new i(R,N)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const N=this.regexp?this.regexp.source:"",$=R.regexp?R.regexp.source:"";return N<$?-1:N>$?1:0}equals(R){if(R.type===this.type){const N=this.regexp?this.regexp.source:"",$=R.regexp?R.regexp.source:"";return this.key===R.key&&N===$}return!1}substituteConstants(){return this}evaluate(R){let N=R.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class t{constructor(R){this._actual=R,this.type=8}static create(R){return new t(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new t(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function o(F){let R=null;for(let N=0,$=F.length;N<$;N++){const j=F[N].substituteConstants();if(F[N]!==j&&R===null){R=[];for(let X=0;X<N;X++)R[X]=F[X]}R!==null&&(R[N]=j)}return R===null?F:R}class s{constructor(R,N){this.expr=R,this.negated=N,this.type=6}static create(R,N){return s._normalizeArr(R,N)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const j=D(this.expr[N],R.expr[N]);if(j!==0)return j}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(R.expr[N]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:s.create(R,this.negated)}evaluate(R){for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].evaluate(R))return!1;return!0}static _normalizeArr(R,N){const $=[];let j=!1;for(const X of R)if(!!X){if(X.type===1){j=!0;continue}if(X.type===0)return E.INSTANCE;if(X.type===6){$.push(...X.expr);continue}$.push(X)}if($.length===0&&j)return g.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(D);for(let X=1;X<$.length;X++)$[X-1].equals($[X])&&($.splice(X,1),X--);if($.length===1)return $[0];for(;$.length>1;){const X=$[$.length-1];if(X.type!==9)break;$.pop();const z=$.pop(),J=$.length===0,B=a.create(X.expr.map(x=>s.create([x,z],null)),null,J);B&&($.push(B),$.sort(D))}return $.length===1?$[0]:new s($,N)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(let N of this.expr)R.push(...N.keys());return R}map(R){return new s(this.expr.map(N=>N.map(R)),null)}negate(){if(!this.negated){const R=[];for(let N of this.expr)R.push(N.negate());this.negated=a.create(R,this,!0)}return this.negated}}class a{constructor(R,N){this.expr=R,this.negated=N,this.type=9}static create(R,N,$){return a._normalizeArr(R,N,$)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const j=D(this.expr[N],R.expr[N]);if(j!==0)return j}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(R.expr[N]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:a.create(R,this.negated,!1)}evaluate(R){for(let N=0,$=this.expr.length;N<$;N++)if(this.expr[N].evaluate(R))return!0;return!1}static _normalizeArr(R,N,$){let j=[],X=!1;if(R){for(let z=0,J=R.length;z<J;z++){const B=R[z];if(!!B){if(B.type===0){X=!0;continue}if(B.type===1)return g.INSTANCE;if(B.type===9){j=j.concat(B.expr);continue}j.push(B)}}if(j.length===0&&X)return E.INSTANCE;j.sort(D)}if(j.length!==0){if(j.length===1)return j[0];for(let z=1;z<j.length;z++)j[z-1].equals(j[z])&&(j.splice(z,1),z--);if(j.length===1)return j[0];if($){for(let z=0;z<j.length;z++)for(let J=z+1;J<j.length;J++)_(j[z],j[J])&&(j.splice(J,1),J--);if(j.length===1)return j[0]}return new a(j,N)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(let N of this.expr)R.push(...N.keys());return R}map(R){return new a(this.expr.map(N=>N.map(R)),null)}negate(){if(!this.negated){let R=[];for(let N of this.expr)R.push(N.negate());for(;R.length>1;){const N=R.shift(),$=R.shift(),j=[];for(const z of O(N))for(const J of O($))j.push(s.create([z,J],null));const X=R.length===0;R.unshift(a.create(j,null,X))}this.negated=R[0]}return this.negated}}class u extends S{constructor(R,N,$){super(R,null);this._defaultValue=N,typeof $=="object"?u._info.push({...$,key:R}):$!==!0&&u._info.push({key:R,description:$,type:N!=null?typeof N:void 0})}static all(){return u._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return d.create(this.key,R)}notEqualsTo(R){return m.create(this.key,R)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(F,R){return F<R?-1:F>R?1:0}function C(F,R,N,$){return F<N?-1:F>N?1:R<$?-1:R>$?1:0}function _(F,R){if(R.type===6&&F.type!==9&&F.type!==6){for(const j of R.expr)if(F.equals(j))return!0}const N=F.negate(),$=O(N).concat(O(R));$.sort(D);for(let j=0;j<$.length;j++){const z=$[j].negate();for(let J=j+1;J<$.length;J++){const B=$[J];if(z.equals(B))return!0}}return!1}e.implies=_;function O(F){return F.type===9?F.expr:[F]}}),define(te[81],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n;class T{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=T}),define(te[82],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[14],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[83],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function T(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[15],ne([0,1,9,39,10,26,11,7,137,6]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function D(z){return z.create===!0}e.isFileOpenForWriteOptions=D;var E;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var g;(function(z){z[z.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var S;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=d;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function v(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function m(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=m;function w(z){return d(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var y;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(J,B){super(J);this.code=B}}e.FileSystemProviderError=p;function c(z,J){const B=new p(z.toString(),J);return l(B,J),B}e.createFileSystemProviderError=c;function r(z){return z||c((0,b.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=r;function l(z,J){return z.name=J?`${J} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=l;function i(z){if(!z)return y.Unknown;if(z instanceof p)return z.code;const J=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!J)return y.Unknown;switch(J[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=i;function t(z){if(z instanceof C)return z.fileOperationResult;switch(i(z)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var o;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class s{constructor(J,B,x){this.resource=J,this.operation=B,this.target=x}isOperation(J){return this.operation===J}}e.FileOperationEvent=s;var a;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class u{constructor(J,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=J;const x=new Map;for(const ee of J){const V=x.get(ee.type);switch(V?V.push([ee.resource,ee]):x.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,V]of x)switch(ee){case 1:this.added=n.TernarySearchTree.forUris(()=>B),this.added.fill(V);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>B),this.updated.fill(V);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>B),this.deleted.fill(V);break}}contains(J,...B){return this.doContains(J,{includeChildren:!1},...B)}affects(J,...B){return this.doContains(J,{includeChildren:!0},...B)}doContains(J,B,...x){if(!J)return!1;const ee=x.length>0;return!!((!ee||x.includes(1))&&(this.added?.get(J)||B.includeChildren&&this.added?.findSuperstr(J))||(!ee||x.includes(0))&&(this.updated?.get(J)||B.includeChildren&&this.updated?.findSuperstr(J))||(!ee||x.includes(2))&&(this.deleted?.findSubstr(J)||B.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function f(z,J,B){return!z||!J||z===J||J.length>z.length?!1:(J.charAt(J.length-1)!==T.sep&&(J+=T.sep),B?(0,L.startsWithIgnoreCase)(z,J):z.indexOf(J)===0)}e.isParent=f;class C extends k.ErrorNoTelemetry{constructor(J,B,x){super(J);this.fileOperationResult=B,this.options=x}}e.FileOperationError=C;class _ extends C{constructor(J,B,x){super(J,2,x);this.stat=B}}e.NotModifiedSinceFileOperationError=_;var O;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=R;async function N(z,J){if(!J.hasProvider(P.URI.from({scheme:z.scheme})))return new Promise(B=>{const x=J.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===z.scheme&&ee.added&&(x.dispose(),B())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(J){return(0,A.isNumber)(J)||(J=0),J<$.KB?(0,b.localize)(1,null,J.toFixed(0)):J<$.MB?(0,b.localize)(2,null,(J/$.KB).toFixed(2)):J<$.GB?(0,b.localize)(3,null,(J/$.MB).toFixed(2)):J<$.TB?(0,b.localize)(4,null,(J/$.GB).toFixed(2)):(0,b.localize)(5,null,(J/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var j;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function X(z){return{maxFileSize:z===0?300*$.MB:16*$.GB,maxHeapSize:z===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=X});var G=this&&this.__param||function(K,e){return function(k,n){e(k,n,K)}};define(te[160],ne([0,1,84,40,15]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const b=(await this.fileService.readFileStream(P)).value;return new Promise((I,D)=>{const E=(0,k.createHash)("md5");(0,n.listenStream)(b,{onData:g=>E.update(g.buffer),onError:g=>D(g),onEnd:()=>I(E.digest("base64").replace(/=+$/,""))})})}};L=he([G(0,T.IFileService)],L),e.ChecksumService=L}),define(te[161],ne([0,1,17,37,9,3,2,40,7,29,15]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(S,d){super();this.channel=S,this.extraCapabilities=d,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,d){const{buffer:h}=await this.channel.call("readFile",[S,d]);return h}readFileStream(S,d,h){const v=(0,P.newWriteableStream)(w=>k.VSBuffer.concat(w.map(y=>k.VSBuffer.wrap(y))).buffer),m=this.channel.listen("readFileStream",[S,d])(w=>{if(w instanceof k.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let y=w;y instanceof Error||(y=(0,D.createFileSystemProviderError)((0,n.toErrorMessage)(y),D.FileSystemProviderErrorCode.Unknown)),v.error(y),v.end()}m.dispose()}});return h.onCancellationRequested(()=>{v.error((0,T.canceled)()),v.end(),m.dispose()}),v}writeFile(S,d,h){return this.channel.call("writeFile",[S,k.VSBuffer.wrap(d),h])}open(S,d){return this.channel.call("open",[S,d])}close(S){return this.channel.call("close",[S])}async read(S,d,h,v,m){const[w,y]=await this.channel.call("read",[S,d,m]);return h.set(w.buffer.slice(0,y),v),y}write(S,d,h,v,m){return this.channel.call("write",[S,d,k.VSBuffer.wrap(h),v,m])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,d){return this.channel.call("delete",[S,d])}rename(S,d,h){return this.channel.call("rename",[S,d,h])}copy(S,d,h){return this.channel.call("copy",[S,d,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const d=S;this._onDidChange.fire(d.map(h=>({resource:b.URI.revive(h.resource),type:h.type})))}else{const d=S;this._onDidWatchError.fire(d)}}))}watch(S,d){const h=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,h,S,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=E}),define(te[85],ne([0,1,17,9,138,15]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(D,E,g,S,d,h){let v;try{await P(D,E,g,S,d,h)}catch(m){v=m}finally{v&&d.errorTransformer&&(v=d.errorTransformer(v)),typeof v!="undefined"&&g.error(v),g.end()}}e.readFileIntoStream=A;async function P(D,E,g,S,d,h){b(h);const v=await D.open(E,{create:!1});try{b(h);let m=0,w=0,y=d&&typeof d.length=="number"?d.length:void 0,p=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof y=="number"?y:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,r=0;do w=await D.read(v,c,p.buffer,r,p.byteLength-r),c+=w,r+=w,m+=w,typeof y=="number"&&(y-=w),r===p.byteLength&&(await g.write(S(p)),p=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof y=="number"?y:d.bufferSize)),r=0);while(w>0&&(typeof y!="number"||y>0)&&b(h)&&I(m,d));if(r>0){let l=r;typeof y=="number"&&(l=Math.min(r,y)),g.write(S(p.slice(0,l)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await D.close(v)}}function b(D){if(D.isCancellationRequested)throw(0,n.canceled)();return!0}function I(D,E){if(E?.limits){if(typeof E.limits.memory=="number"&&D>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,T.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&D>E.limits.size)throw(0,L.createFileSystemProviderError)((0,T.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[52],ne([0,1,2,4,7,15]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(S){return S.recursive===!0}e.isRecursiveWatchRequest=A;class P extends k.Disposable{constructor(d,h,v,m){super();this.onFileChanges=d,this.onLogMessage=h,this.verboseLogging=v,this.options=m,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new k.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),d.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),d.add(this.watcher.onDidError(h=>this.onError(h)))}onError(d){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class b extends P{constructor(d,h,v){super(d,h,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class I extends P{constructor(d,h,v){super(d,h,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function D(S){return S.map(d=>({type:d.type,resource:T.URI.file(d.path)}))}e.toFileChanges=D;function E(S){const d=new g;for(const h of S)d.processEvent(h);return d.coalesce()}e.coalesceEvents=E;class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return n.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const h=this.mapPathToChange.get(this.toKey(d));let v=!1;if(h){const m=h.type,w=d.type;h.path!==d.path&&(d.type===2||d.type===1)?v=!0:m===1&&w===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(h)):m===2&&w===1?h.type=0:m===1&&w===0||(h.type=w)}else v=!0;v&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],h=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,m)=>v.path.length-m.path.length).filter(v=>h.some(m=>(0,L.isParent)(v.path,m,!n.isLinux))?!1:(h.push(v.path),!0)).concat(d)}}}),define(te[162],ne([0,1,50,5,25,41,109,2,72,10,4,114,22,52]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends P.Disposable{constructor(m,w,y,p){super();this.request=m,this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=p,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,A.parse)(c)),this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await g.Promises.stat(m);this._register(await this.doWatch(m,w.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let w=m.path;try{w=await g.Promises.realpath(m.path),m.path===w&&(w=await(0,E.realcase)(m.path)??m.path),m.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${w})`)}catch{}return w}async doWatch(m,w){if(D.isMacintosh&&(0,L.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.Disposable.None;const y=new T.CancellationTokenSource(this.cts.token);let p=new P.DisposableStore;try{const c=(0,I.basename)(m),r=(0,k.watch)(m);p.add((0,P.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${m}'`);const l=new Set;if(w)try{for(const t of await g.Promises.readdir(m))l.add(t)}catch(t){this.error(t)}const i=new Map;p.add((0,P.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,o)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),r.on("change",(t,o)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),D.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(s)?.dispose();const a=setTimeout(async()=>{if(i.delete(s),s===c&&!await g.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,I.join)(m,s));if(y.token.isCancellationRequested)return;let f;u?l.has(s)?f=0:(f=1,l.add(s)):(l.delete(s),f=2),this.onFileChange({path:(0,I.join)(this.request.path,s),type:f})},d.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,P.toDisposable)(()=>clearTimeout(a)))}else{let a;l.has(s)?a=0:(a=1,l.add(s)),this.onFileChange({path:(0,I.join)(this.request.path,s),type:a})}else if(t==="rename"||s!==c){const a=setTimeout(async()=>{const u=await g.Promises.exists(m);y.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),p.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);p.clear(),p.add((0,P.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await g.Promises.exists(m)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${c.toString()})`)}return(0,P.toDisposable)(()=>{y.dispose(!0),p.dispose()})}async onFileChange(m,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!w&&this.excludes.some(y=>y(m.path))?this.verboseLogging&&this.trace(` >> ignored ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.coalesceEvents)(y);if(p.length>0){if(this.verboseLogging)for(const r of p)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(p)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${p.length}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(D.isLinux)return g.Promises.exists(m);try{const w=(0,I.basename)(m);return(await g.Promises.readdir((0,I.dirname)(m))).some(p=>p===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function h(v,m,w,y,p=512){const c=await g.Promises.open(v,"r"),r=Buffer.allocUnsafe(p),l=new T.CancellationTokenSource(y);let i,t=!1;const o={path:v,excludes:[],recursive:!1},s=new d(o,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(t)return;t=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:f}=await g.Promises.read(c,r,0,p,null);if(!f||l.token.isCancellationRequested)break;m(r.slice(0,f))}}catch(f){i=new Error(f),l.dispose(!0)}finally{t=!1}}})()});return await s.ready,w(),new Promise((a,u)=>{l.token.onCancellationRequested(async()=>{s.dispose();try{await g.Promises.close(c)}catch(f){i=new Error(f)}i?u(i):a()})})}e.watchFileContents=h}),define(te[163],ne([0,1,16,3,2,4,162]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends T.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const D=this.normalizeRequests(I),E=D.filter(S=>{const d=this.watchers.get(S.path);return d?!(0,k.equals)(d.request.excludes,S.excludes):!0}),g=Array.from(this.watchers.values()).filter(({request:S})=>!D.find(d=>d.path===S.path&&(0,k.equals)(d.excludes,S.excludes))).map(({request:S})=>S.path);E.length&&this.trace(`Request to start watching: ${E.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const S of g)this.stopWatching(S);for(const S of E)this.startWatching(S)}startWatching(I){const D=new A.NodeJSFileWatcherLibrary(I,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),E={request:I,instance:D};this.watchers.set(I.path,E)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const D=this.watchers.get(I);D&&(this.watchers.delete(I),D.instance.dispose())}normalizeRequests(I){const D=new Map;for(const E of I){const g=L.isLinux?E.path:E.path.toLowerCase();D.set(g,E)}return Array.from(D.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,D]of this.watchers)D.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,D){return D?`[File Watcher (node.js)] ${I} (path: ${D.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=P}),define(te[164],ne([0,1,52,163]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends k.AbstractNonRecursiveWatcherClient{constructor(A,P,b){super(A,P,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=T}),define(te[165],ne([0,1,18,36,58,52]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(b,I,D){super(b,I,D);this.init()}createWatcher(b){const I=b.add(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(I.onDidProcessExit(({code:D,signal:E})=>this.onError(`terminated by itself with code ${D}, signal: ${E}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[86],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...T){this._entries=new Map;for(let[L,A]of T)this.set(L,A)}set(T,L){const A=this._entries.get(T);return this._entries.set(T,L),A}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=k}),define(te[166],ne([0,1,5,9,51,157,6,86]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class I extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class D{constructor(d=new P.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=d,this._strict=h,this._parent=v,this._services.set(A.IInstantiationService,this)}createChild(d){return new D(d,this._strict,this)}invokeFunction(d,...h){let v=g.traceInvocation(d),m=!1;try{return d({get:y=>{if(m)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(y,v);if(!p)throw new Error(`[invokeFunction] unknown service '${y}'`);return p}},...h)}finally{m=!0,v.stop()}}createInstance(d,...h){let v,m;return d instanceof T.SyncDescriptor?(v=g.traceCreation(d.ctor),m=this._createInstance(d.ctor,d.staticArguments.concat(h),v)):(v=g.traceCreation(d),m=this._createInstance(d,h,v)),v.stop(),m}_createInstance(d,h=[],v){let m=A._util.getServiceDependencies(d).sort((p,c)=>p.index-c.index),w=[];for(const p of m){let c=this._getOrCreateServiceInstance(p.id,v);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${p.id}.`,!1),w.push(c)}let y=m.length>0?m[0].index:h.length;if(h.length!==y){console.warn(`[createInstance] First service dependency of ${d.name} at position ${y+1} conflicts with ${h.length} static arguments`);let p=y-h.length;p>0?h=h.concat(new Array(p)):h=h.slice(0,y)}return new d(...[...h,...w])}_setServiceInstance(d,h){if(this._services.get(d)instanceof T.SyncDescriptor)this._services.set(d,h);else if(this._parent)this._parent._setServiceInstance(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let h=this._services.get(d);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):h}_getOrCreateServiceInstance(d,h){let v=this._getServiceInstanceOrDescriptor(d);return v instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,v,h.branch(d,!0)):(h.branch(d,!1),v)}_safeCreateAndCacheServiceInstance(d,h,v){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,h,v)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,h,v){const m=new L.Graph(p=>p.id.toString());let w=0;const y=[{id:d,desc:h,_trace:v}];for(;y.length;){const p=y.pop();if(m.lookupOrInsertNode(p),w++>1e3)throw new I(m);for(let c of A._util.getServiceDependencies(p.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(c.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),r instanceof T.SyncDescriptor){const l={id:c.id,desc:r,_trace:p._trace.branch(c.id,!0)};m.insertEdge(p,l),y.push(l)}}}for(;;){const p=m.roots();if(p.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:c}of p){if(this._getServiceInstanceOrDescriptor(c.id)instanceof T.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}m.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,h,v=[],m,w){if(this._services.get(d)instanceof T.SyncDescriptor)return this._createServiceInstance(h,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,h,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(d,h=[],v,m){if(v){const w=new k.IdleValue(()=>this._createInstance(d,h,m));return new Proxy(Object.create(null),{get(y,p){if(p in y)return y[p];let c=w.value,r=c[p];return typeof r!="function"||(r=r.bind(c),y[p]=r),r},set(y,p,c){return w.value[p]=c,!0}})}else return this._createInstance(d,h,m)}_throwIfStrict(d,h){if(h&&console.warn(h),this._strict)throw new Error(d)}}e.InstantiationService=D;var E;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(E||(E={}));class g{constructor(d,h){this.type=d,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return b?new g(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(d){return b?new g(0,d.name):g._None}branch(d,h){let v=new g(2,d.toString());return this._dep.push([d,h,v]),v}stop(){let d=Date.now()-this._start;g._totals+=d;let h=!1;function v(w,y){let p=[],c=new Array(w+1).join("	");for(const[r,l,i]of y._dep)if(l&&i){h=!0,p.push(`${c}CREATES -> ${r}`);let t=v(w+1,i);t&&p.push(t)}else p.push(`${c}uses -> ${r}`);return p.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(d>2||h)&&console.log(m.join(`
`))}}e.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(te[167],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(T,L){this.server=T,this.router=L}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,L){this.server.registerChannel(T,L)}}e.MessagePortMainProcessService=k}),define(te[168],ne([0,1,36,51,80,6]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(S,d,h){const v=h.getChannel(S);return P(d)?new d.channelClientCtor(v):k.ProxyChannel.toService(v,d?.proxyOptions)}}function P(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let b=class extends A{constructor(S,d,h){super(S,d,h)}};b=he([G(2,e.IMainProcessService)],b);function I(g,S,d){(0,T.registerSingleton)(g,new n.SyncDescriptor(b,[S,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let D=class extends A{constructor(S,d,h){super(S,d,h)}};D=he([G(2,e.ISharedProcessService)],D);function E(g,S,d){(0,T.registerSingleton)(g,new n.SyncDescriptor(D,[S,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[59],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function n(T){if(typeof T.languageId!="string"||!Array.isArray(T.translations)||T.translations.length===0)return!1;for(const L of T.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(T.languageName&&typeof T.languageName!="string"||T.localizedLanguageName&&typeof T.localizedLanguageName!="string")}e.isValidLocalization=n}),define(te[169],ne([0,1,2,59]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};T=he([G(0,n.ILocalizationsService)],T),e.LocalizationsUpdater=T}),define(te[8],ne([0,1,37,3,2,4,6]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var b;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function I(l,i,t){switch(i){case b.Trace:l.trace(t);break;case b.Debug:l.debug(t);break;case b.Info:l.info(t);break;case b.Warning:l.warn(t);break;case b.Error:l.error(t);break;case b.Critical:l.critical(t);break;default:throw new Error("Invalid log level")}}e.log=I;function D(l){let i="";for(let t=0;t<l.length;t++){let o=l[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(t>0?" ":"")+o}return i}e.format=D;class E extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class g extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,D([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,D([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,D([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,D([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(b.Error,D(o))}else this.log(b.Error,D([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,D([i,...t]))}flush(){}}e.AbstractMessageLogger=g;class S extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...t):console.warn(`[main ${P()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class d extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends E{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class v extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const o of this.logServices)o.trace(i,...t)}debug(i,...t){for(const o of this.logServices)o.debug(i,...t)}info(i,...t){for(const o of this.logServices)o.info(i,...t)}warn(i,...t){for(const o of this.logServices)o.warn(i,...t)}error(i,...t){for(const o of this.logServices)o.error(i,...t)}critical(i,...t){for(const o of this.logServices)o.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=v;class m extends T.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends T.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class y{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=y;function p(l){if(l.verbose)return b.Trace;if(typeof l.logLevel=="string"){const i=c(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function c(l){switch(l){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=c;function r(l){switch(l){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(te[170],ne([0,1,5,9,2,10,22,14,8]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends T.Disposable{constructor(E,g){super();this.environmentService=E,this.logService=g,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,L.basename)(this.environmentService.logsPath),g=(0,L.dirname)(this.environmentService.logsPath),h=(await A.Promises.readdir(g)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),v=h.slice(0,Math.max(0,h.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(m=>A.Promises.rm((0,L.join)(g,m)))))}catch(E){(0,n.onUnexpectedError)(E)}}};I=he([G(0,P.IEnvironmentService),G(1,b.ILogService)],I),e.LogsDataCleaner=I}),define(te[171],ne([0,1,5,9,2,10,22,14,8]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class ht extends T.Disposable{constructor(E,g,S){super();this.backupWorkspacesPath=E,this.environmentService=g,this.logService=S,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(E).emptyWorkspaceInfos.map(h=>h.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async h=>{h.length===ht.NON_EMPTY_WORKSPACE_ID_LENGTH||h===ht.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(h)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${h}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,h)))}))}catch(E){(0,n.onUnexpectedError)(E)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",I=he([G(1,P.INativeEnvironmentService),G(2,b.ILogService)],I),e.StorageDataCleaner=I}),define(te[172],ne([0,1,45,5,37,3,2,18,10,22,14,8]),function(K,e,k,n,T,L,A,P,b,I,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends A.Disposable{constructor(d,h){super();this.environmentService=d,this.logService=h,this.processesLimiter=new n.Limiter(5)}async postUninstall(d){const h=this.parseScript(d,"uninstall");return h&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${v}`)))),I.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(d,h){const v=`vscode:${h}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[v]=="string"){const m=d.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${v} should be a node script`),null):{script:(0,b.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,h,v,m,w){return new Promise((y,p)=>{const c=this.start(d,h,v,w);let r;const l=i=>{r&&(clearTimeout(r),r=null),i?p(i):y(void 0)};c.on("error",i=>{l((0,T.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,t)=>{l(i?`post-${h} process exited with code ${i}`:void 0)}),m&&(r=setTimeout(()=>{r=null,c.kill(),p("timed out")},5e3))})}start(d,h,v,m){const w={silent:!0,execArgv:void 0},y=(0,k.fork)(d,[`--type=extension-post-${h}`,...v],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=L.Event.fromNodeEventEmitter(y.stdout,"data"),c=L.Event.fromNodeEventEmitter(y.stderr,"data");p(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${h}`,i)),c(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${h}`,i));const r=L.Event.any(L.Event.map(p,i=>({data:`%c${i}`,format:[""]})),L.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(d){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};g=he([G(0,D.IEnvironmentService),G(1,E.ILogService)],g),e.ExtensionsLifecycle=g}),define(te[173],ne([0,1,16,5,9,3,2,10,52,8]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends A.Disposable{constructor(g,S){super();this.logService=g,this.options=S,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(g,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,S):this.watchNonRecursive(g,S)}watchUniversal(g,S){const d={path:this.toFilePath(g),excludes:S.excludes,recursive:S.recursive},h=(0,k.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,T.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,b.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const S of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const S of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(S)&&g.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,S){const d={path:this.toFilePath(g),excludes:S.excludes,recursive:!1},h=(0,k.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,T.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,b.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,P.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(te[174],ne([0,1,16,5,17,25,3,71,55,2,39,18,175,20,40,136,15,85,8]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends I.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,r){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${c}`);const l=new I.DisposableStore;return this.provider.set(c,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:r}),l.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new v.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&l.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),l.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:c}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:r}),this.provider.delete(c),(0,I.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){r.push(l)}}),!this.provider.has(c)&&await n.Promises.settled(r)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,r){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([c,r])=>({scheme:c,capabilities:r.capabilities}))}async withProvider(c){if(!(0,S.isAbsolutePath)(c))throw new v.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const r=this.provider.get(c.scheme);if(!r){const l=new Error;throw l.name="ENOPRO",l.message=(0,h.localize)(1,null,c.toString()),l}return r}async withReadProvider(c){const r=await this.withProvider(c);if((0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasReadWriteCapability)(r)||(0,v.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const r=await this.withProvider(c);if((0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,r){try{return await this.doResolveFile(c,r)}catch(l){throw(0,v.toFileSystemProviderErrorCode)(l)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,v.ensureFileSystemProviderError)(l)}}async doResolveFile(c,r){const l=await this.withProvider(c),i=this.isPathCaseSensitive(l),t=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,a=await l.stat(c);let u;return this.toFileStat(l,c,a,void 0,!!s,(f,C)=>(u||(u=D.TernarySearchTree.forUris(()=>!i),u.set(c,!0),t&&u.fill(!0,t)),u.get(f.resource)||u.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&o?C===1:!1))}async toFileStat(c,r,l,i,t,o){const{providerExtUri:s}=this.getExtUri(c),a={resource:r,name:s.basename(r),isFile:(l.type&v.FileType.File)!=0,isDirectory:(l.type&v.FileType.Directory)!=0,isSymbolicLink:(l.type&v.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&v.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,v.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const u=await c.readdir(r),f=await n.Promises.settled(u.map(async([C,_])=>{try{const O=s.joinPath(r,C),F=t?await c.stat(O):{type:_};return await this.toFileStat(c,O,F,u.length,t,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,k.coalesce)(f)}catch(u){this.logService.trace(u),a.children=[]}return a}return a}async resolveAll(c){return n.Promises.settled(c.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(c){const r=await this.withProvider(c),l=await r.stat(c);return this.toFileStat(r,c,l,void 0,!0,()=>!1)}async exists(c){const r=await this.withProvider(c);try{return!!await r.stat(c)}catch{return!1}}async canCreateFile(c,r){try{await this.doValidateCreateFile(c,r)}catch(l){return l}return!0}async doValidateCreateFile(c,r){if(!r?.overwrite&&await this.exists(c))throw new v.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,r)}async createFile(c,r=T.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const i=await this.writeFile(c,r);return this._onDidRunOperation.fire(new v.FileOperationEvent(c,0,i)),i}async writeFile(c,r,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,c,l)||await this.mkdirp(i,t.dirname(c));let s;if((0,v.hasReadWriteCapability)(i)&&!(r instanceof T.VSBuffer))if((0,d.isReadableStream)(r)){const a=await(0,d.peekStream)(r,3);a.ended?s=T.VSBuffer.concat(a.buffer):s=a}else s=(0,d.peekReadable)(r,a=>T.VSBuffer.concat(a),3);else s=r;!(0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i)&&s instanceof T.VSBuffer?await this.doWriteUnbuffered(i,c,l,s):await this.doWriteBuffered(i,c,l,s instanceof T.VSBuffer?(0,T.bufferToReadable)(s):s),this._onDidRunOperation.fire(new v.FileOperationEvent(c,4))}catch(o){throw new v.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,r,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(r)));let t;try{t=await c.stat(r)}catch{return}if((t.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,h.localize)(6,null,this.resourceForError(r)),0,l);if(this.throwIfFileIsReadonly(r,t),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==v.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&l.mtime<t.mtime&&l.etag!==(0,v.etag)({mtime:l.mtime,size:t.size}))throw new v.FileOperationError((0,h.localize)(7,null),3,l);return t}async readFile(c,r,l){const i=await this.withReadProvider(c);return r?.atomic?this.doReadFileAtomic(i,c,r,l):this.doReadFile(i,c,r,l)}async doReadFileAtomic(c,r,l,i){return new Promise((t,o)=>{this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,r,l,i);t(s)}catch(s){o(s)}})})}async doReadFile(c,r,l,i){const t=await this.doReadFileStream(c,r,{...l,preferUnbuffered:!0},i);return{...t,value:await(0,T.streamToBuffer)(t.value)}}async readFileStream(c,r,l){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,r,l)}async doReadFileStream(c,r,l,i){const t=new L.CancellationTokenSource(i),o=this.validateReadFile(r,l).then(a=>a,a=>{throw t.cancel(),a});let s;try{return typeof l?.etag=="string"&&l.etag!==v.ETAG_DISABLED&&await o,l?.atomic&&(0,v.hasFileAtomicReadCapability)(c)||!((0,v.hasOpenReadWriteCloseCapability)(c)||(0,v.hasFileReadStreamCapability)(c))||(0,v.hasReadWriteCapability)(c)&&l?.preferUnbuffered?s=this.readFileUnbuffered(c,r,l):(0,v.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,r,t.token,l):s=this.readFileBuffered(c,r,t.token,l),{...await o,value:s}}catch(a){s&&await(0,d.consumeStream)(s);const u=(0,h.localize)(8,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(a).toString());throw a instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(u,a.stat,l):new v.FileOperationError(u,(0,v.toFileOperationResult)(a),l)}}readFileStreamed(c,r,l,i=Object.create(null)){const t=c.readFileStream(r,i,l);return(0,d.transform)(t,{data:o=>o instanceof T.VSBuffer?o:T.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,h.localize)(9,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),i)},o=>T.VSBuffer.concat(o))}readFileBuffered(c,r,l,i=Object.create(null)){const t=(0,T.newWriteableBufferStream)();return(0,m.readFileIntoStream)(c,r,t,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,h.localize)(10,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),i)},l),t}readFileUnbuffered(c,r,l){const i=(0,d.newWriteableStream)(t=>T.VSBuffer.concat(t));return(async()=>{try{let t;l?.atomic&&(0,v.hasFileAtomicReadCapability)(c)?t=await c.readFile(r,{atomic:!0}):t=await c.readFile(r),typeof l?.position=="number"&&(t=t.slice(l.position)),typeof l?.length=="number"&&(t=t.slice(0,l.length)),this.validateReadFileLimits(r,t.byteLength,l),i.end(T.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(c,r){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new v.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,r);if(typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&r.etag===l.etag)throw new v.NotModifiedSinceFileOperationError((0,h.localize)(12,null),l,r);return this.validateReadFileLimits(c,l.size,r),l}validateReadFileLimits(c,r,l){if(l?.limits){let i;if(typeof l.limits.memory=="number"&&r>l.limits.memory&&(i=9),typeof l.limits.size=="number"&&r>l.limits.size&&(i=7),typeof i=="number")throw new v.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,r,l){return this.doCanMoveCopy(c,r,"move",l)}async canCopy(c,r,l){return this.doCanMoveCopy(c,r,"copy",l)}async doCanMoveCopy(c,r,l,i){if(c.toString()!==r.toString())try{const t=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,c,o,r,l,i)}catch(t){return t}return!0}async move(c,r,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,c,t,r,"move",!!l),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(c,o==="move"?2:3,s)),s}async copy(c,r,l){const i=await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,c,t,r,"copy",!!l),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(c,o==="copy"?3:2,s)),s}async doMoveCopy(c,r,l,i,t,o){if(r.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,r,l,i,t,o);if(s&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(i)),t==="copy"){if(c===l&&(0,v.hasFileFolderCopyCapability)(c))await c.copy(r,i,{overwrite:o});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(c,u,l,i):await this.doCopyFile(c,r,l,i)}return t}else return c===l?(await c.rename(r,i,{overwrite:o}),t):(await this.doMoveCopy(c,r,l,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(c,r,l,i){if((0,v.hasOpenReadWriteCloseCapability)(c)&&(0,v.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,r,l,i);if((0,v.hasOpenReadWriteCloseCapability)(c)&&(0,v.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,r,l,i);if((0,v.hasReadWriteCapability)(c)&&(0,v.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,r,l,i);if((0,v.hasReadWriteCapability)(c)&&(0,v.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,r,l,i)}async doCopyFolder(c,r,l,i){await l.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const o=this.getExtUri(l).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(c,await this.resolve(t.resource),l,o):this.doCopyFile(c,t.resource,l,o)}))}async doValidateMoveCopy(c,r,l,i,t,o){let s=!1;if(c===l){const{providerExtUri:u,isPathCaseSensitive:f}=this.getExtUri(c);if(f||(s=u.isEqual(r,i)),s&&t==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&u.isEqualOrParent(i,r))throw new Error((0,h.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!o)throw new v.FileOperationError((0,h.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(c===l){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(r,i))throw new Error((0,h.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const r=this.isPathCaseSensitive(c);return{providerExtUri:r?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(r,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(c,0,l)),l}async mkdirp(c,r){const l=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(r,i.dirname(r));)try{if(((await c.stat(r)).type&v.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,v.toFileSystemProviderErrorCode)(t)!==v.FileSystemProviderErrorCode.FileNotFound)throw t;l.push(i.basename(r)),r=i.dirname(r)}for(let t=l.length-1;t>=0;t--){r=i.joinPath(r,l[t]);try{await c.mkdir(r)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,r){try{await this.doValidateDelete(c,r)}catch(l){return l}return!0}async doValidateDelete(c,r){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!r?.useTrash&&!(l.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let t;try{t=await l.stat(c)}catch{}if(t)this.throwIfFileIsReadonly(c,t);else throw new v.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!r?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return l}async del(c,r){const l=await this.doValidateDelete(c,r),i=!!r?.useTrash,t=!!r?.recursive;await l.delete(c,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new v.FileOperationEvent(c,1))}watch(c,r={recursive:!1,excludes:[]}){const l=new I.DisposableStore;let i=!1,t=()=>{i=!0};return l.add((0,I.toDisposable)(()=>t())),(async()=>{try{const o=await this.doWatch(c,r);i?(0,I.dispose)(o):t=()=>(0,I.dispose)(o)}catch(o){this.logService.error(o)}})(),l}async doWatch(c,r){const l=await this.withProvider(c),i=(0,P.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:l.watch(c,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,I.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,I.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,I.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,r,l,i){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(async()=>{const t=await c.open(r,{create:!0,unlock:l?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,t,i):await this.doWriteReadableBufferedQueued(c,t,i)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await c.close(t)}})}async doWriteStreamBufferedQueued(c,r,l){let i=0,t;if((0,d.isReadableBufferedStream)(l)){if(l.buffer.length>0){const o=T.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,r,o,o.byteLength,i,0),i+=o.byteLength}if(l.ended)return;t=l.stream}else t=l;return new Promise((o,s)=>{(0,d.listenStream)(t,{onData:async a=>{t.pause();try{await this.doWriteBuffer(c,r,a,a.byteLength,i,0)}catch(u){return s(u)}i+=a.byteLength,setTimeout(()=>t.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,r,l){let i=0,t;for(;(t=l.read())!==null;)await this.doWriteBuffer(c,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(c,r,l,i,t,o){let s=0;for(;s<i;)s+=await c.write(r,t+s,l.buffer,o+s,i-s)}async doWriteUnbuffered(c,r,l,i){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,r,l,i))}async doWriteUnbufferedQueued(c,r,l,i){let t;i instanceof T.VSBuffer?t=i:(0,d.isReadableStream)(i)?t=await(0,T.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?t=await(0,T.bufferedStreamToBuffer)(i):t=(0,T.readableToBuffer)(i),await c.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,r,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,r,l,i))}async doPipeBufferedQueued(c,r,l,i){let t,o;try{t=await c.open(r,{create:!1}),o=await l.open(i,{create:!0,unlock:!1});const s=T.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,u=0,f=0;do f=await c.read(t,a,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(l,o,s,f,a,u),a+=f,u+=f,u===s.byteLength&&(u=0);while(f>0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?c.close(t):Promise.resolve(),typeof o=="number"?l.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,r,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,r,l,i))}async doPipeUnbufferedQueued(c,r,l,i){return l.writeFile(i,await c.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,r,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,r,l,i))}async doPipeUnbufferedToBufferedQueued(c,r,l,i){const t=await l.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(r);await this.doWriteBuffer(l,t,T.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await l.close(t)}}async doPipeBufferedToUnbuffered(c,r,l,i){const t=await(0,T.streamToBuffer)(this.readFileBuffered(c,r,L.CancellationToken.None));await this.doWriteUnbuffered(l,i,void 0,t)}throwIfFileSystemIsReadonly(c,r){if(c.capabilities&2048)throw new v.FileOperationError((0,h.localize)(22,null,this.resourceForError(r)),6);return c}throwIfFileIsReadonly(c,r){if((r.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===E.Schemas.file?c.fsPath:c.toString(!0)}};y=he([G(0,w.ILogService)],y),e.FileService=y}),define(te[176],ne([0,1,50,255,5,39,17,3,41,2,10,4,20,40,22,139,15,85,173,37,165,164]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(k)}catch(l){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(l)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(o=>g.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,g.joinPath)(i,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let o;return t?.dangling?o=v.FileType.Unknown:i.isFile()?o=v.FileType.File:i.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,t&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(i){const t=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const s=new T.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),s.open()})}async readFile(i,t){let o;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await d.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,t,o){const s=(0,S.newWriteableStream)(a=>A.VSBuffer.concat(a.map(u=>A.VSBuffer.wrap(u))).buffer);return(0,m.readFileIntoStream)(this,i,s,a=>a.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(i,t,o){let s;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(a)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,h.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,h.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){const o=this.toFilePath(i);let s;(0,v.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let a;try{if((0,v.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:f}=await d.SymlinkSupport.stat(o);f.mode&128||await d.Promises.chmod(o,f.mode|128)}catch(f){this.logService.trace(f)}let u;if((0,v.isFileOpenForWriteOptions)(t)){if(E.isWindows)try{await d.Promises.truncate(o,0),u="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}u||(u="w")}else u="r";a=await d.Promises.open(o,u)}catch(u){throw s?.dispose(),(0,v.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(a,0),(0,v.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(a,i),s){const u=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,s),u&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),u.dispose())}return a}async close(i){const t=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{t&&(this.mapHandleToLock.get(i)===t&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,o,s,a){const u=this.normalizePos(i,t);let f=null;try{f=(await d.Promises.read(i,o,s,a,u)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(i,u,f)}return f}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,t,o,s,a){return(0,T.retry)(()=>this.doWrite(i,t,o,s,a),100,3)}async doWrite(i,t,o,s,a){const u=this.normalizePos(i,t);let f=null;try{f=(await d.Promises.write(i,o,s,a,u)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),C)}finally{this.updatePos(i,u,f)}return f}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const o=this.toFilePath(i);t.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,t,o){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"move",o.overwrite),await d.Promises.move(s,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,h.localize)(2,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(i,t,o){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"copy",o.overwrite),await d.Promises.copy(s,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,h.localize)(3,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(i,t,o,s){const a=this.toFilePath(i),u=this.toFilePath(t);let f=!1;if(!!(this.capabilities&1024)||(f=(0,b.isEqual)(a,u,!0)),f&&o==="copy")throw(0,v.createFileSystemProviderError)((0,h.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!f&&await d.Promises.exists(u)){if(!s)throw(0,v.createFileSystemProviderError)((0,h.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,t,o){return new p.UniversalWatcherClient(s=>i(s),s=>t(s),o)}createNonRecursiveWatcher(i,t,o){return new c.NodeJSWatcherClient(s=>i(s),s=>t(s),o)}toFileSystemProviderError(i){if(i instanceof v.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=v.FileSystemProviderErrorCode.NoPermissions;break;default:t=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let o=this.toFileSystemProviderError(t);if(i&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,v.createFileSystemProviderError)(t,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(te[87],ne([0,1,3,7,8]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(g){this.service=g,this.onDidChangeLogLevel=k.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(g,S,d){switch(S){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=L;class A{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){A.setLevel(this.channel,g)}static setLevel(g,S){return g.call("setLevel",S)}}e.LogLevelChannelClient=A;class P{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,S){throw new Error(`Event not found: ${S}`)}async call(g,S,d){switch(S){case"createLogger":this.createLogger(n.URI.revive(d[0]),d[1]);return;case"log":return this.log(n.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${S}`)}createLogger(g,S){this.loggers.set(g.toString(),this.loggerService.createLogger(g,S))}consoleLog(g,S){let d=console.log;switch(g){case T.LogLevel.Error:d=console.error;break;case T.LogLevel.Warning:d=console.warn;break;case T.LogLevel.Info:d=console.info;break}d.call(console,...S)}log(g,S){const d=this.loggers.get(g.toString());if(!d)throw new Error("Create the logger before logging");for(const[h,v]of S)(0,T.log)(d,h,v)}}e.LoggerChannel=P;class b extends T.AbstractLoggerService{constructor(g,S,d){super(g,S);this.channel=d}createConsoleMainLogger(){return new T.AdapterLogger({log:(g,S)=>{this.channel.call("consoleLog",[g,S])}})}doCreateLogger(g,S,d){return new I(this.channel,g,S,d)}}e.LoggerChannelClient=b;class I extends T.AbstractMessageLogger{constructor(g,S,d,h){super(h?.always);this.channel=g,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[S,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,S){const d=[[g,S]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(g){this.channel.call("log",[this.file,g])}}class D extends T.LogService{constructor(g,S){super(S);this.parent=g,this._register(g.onDidChangeLogLevel(d=>S.setLevel(d)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=D}),define(te[60],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[88],ne([0,1,18,4,33,20]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const P=n.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,L.dirname)(k.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const b=K.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(te[27],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[177],ne([0,1,5,9,2,10,22,8,27]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends T.Disposable{constructor(E,g,S){super();this.productService=g,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),S=(0,L.dirname)(E),d=(0,L.basename)(E),h=await A.Promises.readdir(S);await Promise.all(h.map(async v=>{if(v===d)return;const m=(0,L.join)(S,v),w=await A.Promises.stat(m);if(w.isDirectory()&&g-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),A.Promises.rm(m)}))}catch(g){(0,n.onUnexpectedError)(g)}}};I=he([G(1,b.IProductService),G(2,P.ILogService)],I),e.CodeCacheCleaner=I}),define(te[178],ne([0,1,5,9,2,10,22,14,8,27]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends T.Disposable{constructor(g,S,d){super();this.environmentService=g,this.logService=S,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),S=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(S)){const y=S[w];g[`${y.hash}.${w}`]=!0}const d=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const v=await A.Promises.readdir(d);for(const w of v){if(g[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,L.join)(d,w))}const m=Date.now();for(const w of Object.keys(g)){const y=(0,L.join)(d,w),p=await A.Promises.readdir(y);for(const c of p){if(c==="tcf.json")continue;const r=(0,L.join)(y,c),l=await A.Promises.stat(r);l.isDirectory()&&m-l.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(w,c)}`),await A.Promises.rm(r))}}}catch(g){(0,n.onUnexpectedError)(g)}}};D=he([G(0,P.INativeEnvironmentService),G(1,b.ILogService),G(2,I.IProductService)],D),e.LanguagePackCachedDataCleaner=D}),define(te[179],ne([0,1,10,6]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var T;(function(L){function A(P,b="noAbsolutePaths"){for(const I of P.nodes)I.callFrame&&I.callFrame.url&&((0,k.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(I.callFrame.url))&&(I.callFrame.url=(0,k.join)(b,(0,k.basename)(I.callFrame.url)));return P}L.rewriteAbsolutePaths=A})(T=e.Utils||(e.Utils={}))}),define(te[180],ne([0,1,29]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((I,D)=>{K(["v8-inspect-profiler"],I,D)})).startProfiling({port:L.port,checkForPaused:!0}),b=(0,k.generateUuid)();return this._sessions.set(b,P),b}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const P=await A.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=n}),define(te[38],ne([0,1,99,11]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(A,P){k.ok(n.isString(A)),k.ok(n.isObject(P)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new T}),define(te[89],ne([0,1,3,38]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,I){this.schemasById[T(b)]=I,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;n.Registry.add(e.Extensions.JSONContribution,A)}),define(te[42],ne([0,1,16,3,11,126,89,38]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=P.Registry.as(A.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,r=!0){this.registerConfigurations([c],r)}registerConfigurations(c,r=!0){const l=this.doRegisterConfigurations(c,r);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(c){const r=this.doDeregisterConfigurations(c);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:c,remove:r}){const l=[];l.push(...this.doDeregisterConfigurations(r)),l.push(...this.doRegisterConfigurations(c,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(l)})}registerDefaultConfigurations(c){const r=[],l=[];for(const{overrides:i,source:t}of c)for(const o in i)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:s});const a={type:"object",default:s,description:L.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:T.isString(t)?void 0:t};l.push(...d(o)),this.configurationProperties[o]=a,this.defaultLanguageConfigurationOverridesNode.properties[o]=a}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:t});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const r=[];for(const{overrides:l,source:i}of c)for(const t in l){const o=this.configurationDefaultsOverrides.get(t),s=T.isString(i)?i:i?.id,a=T.isString(o?.source)?o?.source:o?.source?.id;if(s===a)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const r of c)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,r){const l=[];return c.forEach(i=>{l.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),l}doDeregisterConfigurations(c){const r=[],l=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>l(t))};for(const i of c){l(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(c,r=!0,l,i,t=3){t=T.isUndefinedOrNull(c.scope)?t:c.scope;let o=[],s=c.properties;if(s)for(let u in s){if(r&&w(u)){delete s[u];continue}const f=s[u];if(f.source=l,f.defaultDefaultValue=s[u].default,this.updatePropertyDefaultValue(u,f),e.OVERRIDE_PROPERTY_REGEX.test(u)?f.scope=void 0:(f.scope=T.isUndefinedOrNull(f.scope)?t:f.scope,f.restricted=T.isUndefinedOrNull(f.restricted)?!!i?.includes(u):f.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),o.push(u)}let a=c.allOf;if(a)for(let u of a)o.push(...this.validateAndRegisterProperties(u,r,l,i,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const r=l=>{let i=l.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let t=l.allOf;t&&t.forEach(r)};r(c)}updateSchema(c,r){switch(e.allSettings.properties[c]=r,r.scope){case 1:e.applicationSettings.properties[c]=r;break;case 2:e.machineSettings.properties[c]=r;break;case 6:e.machineOverridableSettings.properties[c]=r;break;case 3:e.windowSettings.properties[c]=r;break;case 4:e.resourceSettings.properties[c]=r;break;case 5:e.resourceSettings.properties[c]=r,this.resourceLanguageSettingsSchema.properties[c]=r;break}}removeFromSchema(c,r){switch(delete e.allSettings.properties[c],r.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const r=`[${c}]`,l={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,l),e.allSettings.properties[r]=l,e.applicationSettings.properties[r]=l,e.machineSettings.properties[r]=l,e.machineOverridableSettings.properties[r]=l,e.windowSettings.properties[r]=l,e.resourceSettings.properties[r]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,r){const l=this.configurationDefaultsOverrides.get(c);let i=l?.value,t=l?.source;T.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),T.isUndefined(i)&&(i=v(r.type)),r.default=i,r.defaultValueSource=t}}const g="\\[([^\\]]+)\\]",S=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(p){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let r=S.exec(p);for(;r?.length;){const l=r[1].trim();l&&c.push(l),r=S.exec(p)}}return(0,k.distinct)(c)}e.overrideIdentifiersFromKey=d;function h(p){return p.reduce((c,r)=>`${c}[${r}]`,"")}e.keyFromOverrideIdentifiers=h;function v(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new E;P.Registry.add(e.Extensions.Configuration,m);function w(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?L.localize(7,null,p):m.getConfigurationProperties()[p]!==void 0?L.localize(8,null,p):null:L.localize(6,null)}e.validateProperty=w;function y(){const p=[],c=m.getConfigurationProperties();for(const r of Object.keys(c))p.push([r,c[r].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=y}),define(te[90],ne([0,1,16,3,35,2,39,28,11,7,19,42,38]),function(K,e,k,n,T,L,A,P,b,I,D,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},t=[],o=[]){this._contents=i,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,D.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const o=this.getContentsForOverrideIdentifer(t);return o?i?(0,D.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const o of this.overrides)o.identifiers.includes(i)&&t.push(...o.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return k.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=P.deepClone(this.contents),o=P.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(t,a.contents);for(const u of a.overrides){const[f]=o.filter(C=>k.equals(C.identifiers,u.identifiers));f?(this.mergeContents(f.contents,u.contents),f.keys.push(...u.keys),f.keys=k.distinct(f.keys)):o.push(P.deepClone(u))}for(const u of a.keys)s.indexOf(u)===-1&&s.push(u)}return new S(t,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[s],u=t[s];u&&(typeof a=="object"&&typeof u=="object"?(a=P.deepClone(a),this.mergeContents(a,u)):a=u),o[s]=a}return new S(o,this.keys,this.overrides)}mergeContents(i,t){for(const o of Object.keys(t)){if(o in i&&b.isObject(i[o])&&b.isObject(t[o])){this.mergeContents(i[o],t[o]);continue}i[o]=P.deepClone(t[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=P.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[i])?t=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,D.addToValueTree)(this.contents,i,t,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,D.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let o=0;o<t;o++)i.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class d extends S{constructor(i={}){const t=g.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),s=Object.create(null),a=[];for(const u in t){const f=i[u],C=f!==void 0?f:t[u].default;(0,D.addToValueTree)(s,u,C,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(s))E.OVERRIDE_PROPERTY_REGEX.test(u)&&a.push({identifiers:(0,E.overrideIdentifiersFromKey)(u),keys:Object.keys(s[u]),contents:(0,D.toValuesTree)(s[u],f=>console.error(`Conflict in default settings file: ${f}`))});super(s,o,a)}}e.DefaultConfigurationModel=d;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:o,keys:s,overrides:a,restricted:u}=this.doParseRaw(i,t);this._configurationModel=new S(o,s,a),this._restrictedConfigurations=u||[]}doParseContent(i){let t={},o=null,s=[],a=[],u=[];function f(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let C={onObjectBegin:()=>{let _={};f(_),a.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let _=[];f(_),a.push(s),s=_,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:f,onError:(_,O,F)=>{u.push({error:_,offset:O,length:F})}};if(i)try{T.visit(i,C),t=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const o=g.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,t);i=s.raw;const a=(0,D.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),u=Object.keys(i),f=this.toOverrides(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:a,keys:u,overrides:f,restricted:s.restricted}}filter(i,t,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},u=[];for(let f in i)if(E.OVERRIDE_PROPERTY_REGEX.test(f)&&o){const C=this.filter(i[f],t,!1,s);a[f]=C.raw,u.push(...C.restricted)}else{const C=t[f],_=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&u.push(f),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&C?.restricted||(a[f]=i[f]))}return{raw:a,restricted:u}}toOverrides(i,t){const o=[];for(const s of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const u in i[s])a[u]=i[s][u];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,D.toValuesTree)(a,t)})}return o}}e.ConfigurationModelParser=h;class v extends L.Disposable{constructor(i,t,o,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(i,t,o=new S,s=new S,a=new A.ResourceMap,u=new S,f=new A.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=f,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(i)}updateValue(i,t,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new S,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,o){const s=this.getConsolidateConfigurationModel(t,o),a=this.getFolderConfigurationModelForResource(t.resource,o),u=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,f=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),F=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,R=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,N=t.overrideIdentifier?u.override(t.overrideIdentifier).getValue(i):u.getValue(i),$=s.getValue(i),j=k.distinct(k.flatten(s.overrides.map(X=>X.identifiers))).filter(X=>s.getOverrideValue(i,X)!==void 0);return{defaultValue:f,userValue:C,userLocalValue:_,userRemoteValue:O,workspaceValue:F,workspaceFolderValue:R,memoryValue:N,value:$,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:a?.freeze().getValue(i),override:t.overrideIdentifier?a?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:u.getValue(i),override:t.overrideIdentifier?u.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const o=[];if(!t){const{added:s,updated:a,removed:u}=c(this._defaultConfiguration,i);t=[...s,...a,...u]}for(const s of t)for(const a of(0,E.overrideIdentifiersFromKey)(s)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=i.getKeysForOverrideIdentifier(a),C=[...f.filter(_=>u.indexOf(_)===-1),...u.filter(_=>f.indexOf(_)===-1),...u.filter(_=>!P.equals(this._defaultConfiguration.override(a).getValue(_),i.override(a).getValue(_)))];o.push([a,C])}return this.updateDefaultConfiguration(i),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=c(this.localUserConfiguration,i),u=[...t,...o,...s];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=c(this.remoteUserConfiguration,i);let u=[...t,...o,...s];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=c(this.workspaceConfiguration,i);let u=[...t,...o,...s];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(i,t){const o=this.folderConfigurations.get(i),{added:s,updated:a,removed:u,overrides:f}=c(o,t);let C=[...s,...a,...u];return(C.length||!o)&&this.updateFolderConfiguration(i,t),{keys:C,overrides:f}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:a,overrides:u}=c(t,void 0);return{keys:[...o,...s,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let o=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(i);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=o.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=o}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const o=t.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(t);return i.push([t,{contents:o,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((u,f)=>(u.set(I.URI.revive(f[0]),this.parseConfigurationModel(f[1])),u),new A.ResourceMap);return new m(t,o,new S,s,a,new S,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=m;function w(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,t=new Map;for(const s of l)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,u])=>{const f=(0,A.getOrSet)(t,a,new Set);u.forEach(C=>f.add(C))});const o=[];return t.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=w;class y{constructor(i,t,o,s){this.change=i,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(f=>a.add(f)),i.overrides.forEach(([,f])=>f.forEach(C=>a.add(C))),this.affectedKeys=[...a.values()];const u=new S;this.affectedKeys.forEach(f=>u.setValue(f,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!P.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let o=(0,D.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=y;class p extends y{constructor(i,t,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=p;function c(l,i){const{added:t,removed:o,updated:s}=r(i,l),a=[],u=l?.getAllOverrideIdentifiers()||[],f=i?.getAllOverrideIdentifiers()||[];if(i){const C=f.filter(_=>!u.includes(_));for(const _ of C)a.push([_,i.getKeysForOverrideIdentifier(_)])}if(l){const C=u.filter(_=>!f.includes(_));for(const _ of C)a.push([_,l.getKeysForOverrideIdentifier(_)])}if(i&&l){for(const C of u)if(f.includes(C)){const _=r({contents:l.getOverrideValue(void 0,C)||{},keys:l.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});a.push([C,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:s,overrides:a}}function r(l,i){const t=l?i?l.keys.filter(a=>i.keys.indexOf(a)===-1):[...l.keys]:[],o=i?l?i.keys.filter(a=>l.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(l&&i){for(const a of i.keys)if(l.keys.indexOf(a)!==-1){const u=(0,D.getConfigurationValue)(i.contents,a),f=(0,D.getConfigurationValue)(l.contents,a);P.equals(u,f)||s.push(a)}}return{added:t,removed:o,updated:s}}}),define(te[181],ne([0,1,5,3,2,20,19,90,42,38]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends T.Disposable{constructor(g,S){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,S)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,S){const d=typeof g=="string"?g:void 0,h=(0,A.isConfigurationOverrides)(g)?g:(0,A.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(d,h,void 0)}updateValue(g,S,d,h){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(d,S,1)}onDidDefaultConfigurationChange(g){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,g);this.trigger(d,S,6)}trigger(g,S,d){const h=new P.ConfigurationChangeEvent(g,{data:S},this.configuration);h.source=d,h.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(te[182],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var n;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(A,P=n.Unknown,b){super(A);this._message=A,this._code=P,this._detail=b,this.isHandled=P===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(A){return A instanceof T&&A._code===n.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof T&&A._code===n.NoResolverFound}static isHandled(A){return A instanceof T&&A.isHandled}}e.RemoteAuthorityResolverError=T}),define(te[183],ne([0,1,5,17,25,9,3,2,29,74,182]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var g;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function S(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(V){const Z=new T.CancellationTokenSource;return setTimeout(()=>Z.cancel(),V),Z.token}function h(V,Z){if(V.isCancellationRequested||Z.isCancellationRequested)return T.CancellationToken.Cancelled;const Y=new T.CancellationTokenSource;return V.onCancellationRequested(()=>Y.cancel()),Z.onCancellationRequested(()=>Y.cancel()),Y.token}class v{constructor(Z){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((Y,q)=>{this._resolvePromise=Y,this._rejectPromise=q}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function m(V,Z){const Y=new v(Z);return Y.registerDisposable(V.onControlMessage(q=>{const U=JSON.parse(q.toString()),M=z(U);M?Y.reject(M):Y.resolve(U)})),Y.promise}function w(V,Z,Y,q,U,M,W){const H=new v(W);return Z.connect(Y,q,U,M,(re,se)=>{H.didTimeout?(re&&V.error(re),se?.dispose()):re||!se?H.reject(re):H.resolve(se)}),H.promise}function y(V,Z){const Y=new v(Z);return V.then(q=>{Y.didTimeout||Y.resolve(q)},q=>{Y.didTimeout||Y.reject(q)}),Y.promise}async function p(V,Z,Y,q){const U=x(V,Z);V.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let M;try{M=await w(V.logService,V.socketFactory,V.host,V.port,`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${S(Z)}-${V.reconnectionToken}`,q)}catch(ue){throw V.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),V.logService.error(ue),ue}V.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let W,H;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(M,null),W=V.reconnectionProtocol,H=!1):(W=new I.PersistentProtocol(M,null),H=!0),V.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const re=await y(V.signService.createNewMessage((0,b.generateUuid)()),q),se={type:"auth",auth:V.connectionToken||"00000000000000000000",data:re.data};W.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ue=await m(W,h(q,d(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(V.logService.trace(`${U} 4/6. received SignRequest control message.`),!await y(V.signService.validate(re,ue.signedData),q)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const we=await y(V.signService.sign(ue.data),q),pe={type:"connectionType",commit:V.commit,signedData:we,desiredConnectionType:Z};return Y&&(pe.args=Y),V.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:W,ownsProtocol:H}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(V.logService.error(`${U} the handshake timed out. Error:`),V.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${U} received error control message when negotiating connection. Error:`),V.logService.error(ue)),H&&X(W),ue}}async function c(V,Z,Y,q){const U=Date.now(),M=x(V,Z),{protocol:W,ownsProtocol:H}=await p(V,Z,Y,q),re=new v(q);return re.registerDisposable(W.onControlMessage(se=>{const ue=JSON.parse(se.toString()),de=z(ue);de?(V.logService.error(`${M} received error control message when negotiating connection. Error:`),V.logService.error(de),H&&X(W),re.reject(de)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${ee(U)}!`),re.resolve({protocol:W,firstMessage:ue}))})),re.promise}async function r(V,Z){const{protocol:Y}=await c(V,1,void 0,Z);return{protocol:Y}}async function l(V,Z,Y){const{protocol:q,firstMessage:U}=await c(V,2,Z,Y),M=U&&U.debugPort;return{protocol:q,debugPort:M}}async function i(V,Z,Y){const q=Date.now(),U=x(V,3),{protocol:M}=await p(V,3,Z,Y);return V.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ee(q)}!`),M}async function t(V,Z,Y){const{host:q,port:U,connectionToken:M}=await V.addressProvider.getAddress();return{commit:V.commit,host:q,port:U,connectionToken:M,reconnectionToken:Z,reconnectionProtocol:Y,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function o(V,Z,Y){try{const q=(0,b.generateUuid)(),U=await t(V,q,null),{protocol:M}=await r(U,T.CancellationToken.None);return new $(V,Z,Y,q,M)}catch(q){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(q),N.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=o;async function s(V,Z){try{const Y=(0,b.generateUuid)(),q=await t(V,Y,null),{protocol:U,debugPort:M}=await l(q,Z,T.CancellationToken.None);return new j(V,Z,Y,U,M)}catch(Y){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(Y),N.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(Y)),Y}}e.connectRemoteAgentExtensionHost=s;async function a(V,Z,Y){const q=await t(V,(0,b.generateUuid)(),null);return await i(q,{host:Z,port:Y},T.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function u(V){return(0,k.createCancelablePromise)(Z=>new Promise((Y,q)=>{const U=setTimeout(Y,V*1e3);Z.onCancellationRequested(()=>{clearTimeout(U),Y()})}))}var f;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(f=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class C{constructor(Z,Y){this.reconnectionToken=Z,this.millisSinceLastIncomingData=Y,this.type=0}}e.ConnectionLostEvent=C;class _{constructor(Z,Y,q,U){this.reconnectionToken=Z,this.millisSinceLastIncomingData=Y,this.durationSeconds=q,this.cancellableTimer=U,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,Y,q){this.reconnectionToken=Z,this.millisSinceLastIncomingData=Y,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=O;class F{constructor(Z,Y,q){this.reconnectionToken=Z,this.millisSinceLastIncomingData=Y,this.attempt=q,this.type=4}}e.ConnectionGainEvent=F;class R{constructor(Z,Y,q,U){this.reconnectionToken=Z,this.millisSinceLastIncomingData=Y,this.attempt=q,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=R;class N extends P.Disposable{constructor(Z,Y,q,U){super();this._connectionType=Z,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Y,this.reconnectionToken=q,this.protocol=U,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(U.onSocketClose(M=>{const W=B(this._connectionType,this.reconnectionToken,!0);M?M.type===0?(this._options.logService.info(`${W} received socket close event (hadError: ${M.hadError}).`),M.error&&this._options.logService.error(M.error)):(this._options.logService.info(`${W} received socket close event (wasClean: ${M.wasClean}, code: ${M.code}, reason: ${M.reason}).`),M.event&&this._options.logService.error(M.event)):this._options.logService.info(`${W} received socket close event.`),this._beginReconnecting()})),this._register(U.onSocketTimeout(()=>{const M=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${M} received socket timeout event.`),this._beginReconnecting()})),N._instances.push(this),N._permanentFailure&&this._gotoPermanentFailure(N._permanentFailureMillisSinceLastIncomingData,N._permanentFailureAttempt,N._permanentFailureHandled)}static triggerPermanentFailure(Z,Y,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=Y,this._permanentFailureHandled=q,this._instances.forEach(U=>U._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(N._permanentFailure)return;const Z=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Y=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const U=q<Y.length?Y[q]:Y[Y.length-1];try{if(U>0){const W=u(U);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,W)),this._options.logService.info(`${Z} waiting for ${U} seconds before reconnecting...`);try{await W}catch{}}if(N._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${Z} resolving connection...`);const M=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${M.host}:${M.port}...`),await this._reconnect(M,d(E)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(M){if(M.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(M),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(M),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(D.RemoteAuthorityResolverError.isTemporarilyNotAvailable(M)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(M);continue}if((M.code==="ETIMEDOUT"||M.code==="ENETUNREACH"||M.code==="ECONNREFUSED"||M.code==="ECONNRESET")&&M.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(M);continue}if((0,L.isCancellationError)(M)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(M);continue}if(M instanceof D.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(M),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,D.RemoteAuthorityResolverError.isHandled(M));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(M),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!N._permanentFailure)}_gotoPermanentFailure(Z,Y,q){this._onDidStateChange.fire(new R(this.reconnectionToken,Z,Y,q)),X(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=N,N._permanentFailure=!1,N._permanentFailureMillisSinceLastIncomingData=0,N._permanentFailureAttempt=0,N._permanentFailureHandled=!1,N._instances=[];class $ extends N{constructor(Z,Y,q,U,M){super(1,Z,U,M);this.client=this._register(new I.Client(M,{remoteAuthority:Y,clientId:q},Z.ipcLogger))}async _reconnect(Z,Y){await r(Z,Y)}}e.ManagementPersistentConnection=$;class j extends N{constructor(Z,Y,q,U,M){super(2,Z,q,U);this._startArguments=Y,this.debugPort=M}async _reconnect(Z,Y){await l(Z,this._startArguments,Y)}}e.ExtensionHostPersistentConnection=j;function X(V){try{V.acceptDisconnect();const Z=V.getSocket();V.dispose(),Z.dispose()}catch(Z){(0,L.onUnexpectedError)(Z)}}function z(V){if(V&&V.type==="error"){const Z=new Error(`Connection error: ${V.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function J(V,Z){for(;V.length<Z;)V+=" ";return V}function B(V,Z,Y){return`[remote-connection][${J(S(V),13)}][${Z.substr(0,5)}\u2026][${Y?"reconnect":"initial"}]`}function x(V,Z){return`${B(Z,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function ee(V){return`${Date.now()-V} ms`}}),define(te[184],ne([0,1,18]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(L){return L.scheme===k.Schemas.vscodeRemote?L.authority:void 0}e.getRemoteAuthority=n;function T(L){if(!L)return;const A=L.indexOf("+");return A<0?L:L.substr(0,A)}e.getRemoteName=T}),define(te[61],ne([0,1,26,6,184]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=L;function A(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,d){if(typeof S=="undefined"||S===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof S=="string"||typeof d=="string"){let h=typeof S=="string"?S:S.value,v=typeof d=="string"?d:d.value;return k.equalsIgnoreCase(h,v)}return S._lower===d._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function I(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function D(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=D;function E(g,S){if(S){const d=`onResolveRemoteAuthority:${(0,T.getRemoteName)(S)}`;return g.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,26,61]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(d,h){return d.uuid&&h.uuid?d.uuid===h.uuid:d.id===h.id?!0:(0,k.compareIgnoreCase)(d.id,h.id)===0}e.areSameExtensions=T;class L{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof L?T(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=L;function A(d,h){return`${d}.${h}`}e.getExtensionId=A;function P(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function b(d,h){return P(A(d,h))}e.getGalleryExtensionId=b;function I(d,h){const v=[],m=w=>{for(const y of v)if(y.some(p=>T(h(p),h(w))))return y;return null};for(const w of d){const y=m(w);y?y.push(w):v.push([w])}return v}e.groupByExtension=I;function D(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function E(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function g(d){const h=new Set;if(d.malicious)for(const v of d.malicious)h.add(v.id);return h}e.getMaliciousExtensionsSet=g;function S(d,h){const v=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(y=>!T(y.identifier,{id:w}))){const y=d.filter(p=>T(p.identifier,{id:w}));y.length===1&&(v.push(y[0]),m.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=S}),define(te[30],ne([0,1,130,31,6]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const L=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function A(c){const r=L.exec(c);return r&&r[1]?[(0,n.adoptToGalleryExtensionId)(r[1]),r[2]]:[(0,n.adoptToGalleryExtensionId)(c),void 0]}e.getIdAndVersion=A;var P;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));function b(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function D(c,r){switch(c){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function E(c,r){return r==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function g(c,r,l){return E(r,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:S(l).includes(c)}e.isTargetPlatformCompatible=g;function S(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=d;var h;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(h=e.SortBy||(e.SortBy={}));var v;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var m;(function(c){c.Install="install",c.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var w;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var y;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(r,l){super(r);this.code=l,this.name=l}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(te[185],ne([0,1,3,2,28,7,110,30]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(h,v){return L.URI.revive(v?v.transformIncoming(h):h)}function I(h,v){return v?v.transformOutgoingURI(h):h}function D(h,v){v=v||A.DefaultURITransformer;const m=h.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...h,manifest:void 0},v),manifest:m}}function E(h,v){return v?(0,T.cloneAndChange)(h,m=>m instanceof L.URI?v.transformOutgoingURI(m):void 0):h}class g{constructor(v,m){this.service=v,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,m){const w=this.getUriTransformer(v);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,y=>y.map(p=>({...p,local:p.local?E(p.local,w):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,m,w){const y=this.getUriTransformer(v);switch(m){case"zip":return this.service.zip(D(w[0],y)).then(p=>I(p,y));case"unzip":return this.service.unzip(b(w[0],y));case"install":return this.service.install(b(w[0],y),w[1]);case"getManifest":return this.service.getManifest(b(w[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(D(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(D(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(p=>p.map(c=>E(c,y)));case"updateMetadata":return this.service.updateMetadata(D(w[0],y),w[1]).then(p=>E(p,y));case"updateExtensionScope":return this.service.updateExtensionScope(D(w[0],y),w[1]).then(p=>E(p,y));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class S extends n.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?L.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?D(w.local,null):w.local,source:this.isUriComponents(w.source)?L.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const m=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,P.isTargetPlatformCompatible)(w,v.allTargetPlatforms,m))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(m=>L.URI.revive(m)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,m){return Promise.resolve(this.channel.call("install",[v,m])).then(w=>D(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,m){return Promise.resolve(this.channel.call("installFromGallery",[v,m])).then(w=>D(w,null))}uninstall(v,m){return Promise.resolve(this.channel.call("uninstall",[v,m]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(m=>m.map(w=>D(w,null)))}updateMetadata(v,m){return Promise.resolve(this.channel.call("updateMetadata",[v,m])).then(w=>D(w,null))}updateExtensionScope(v,m){return Promise.resolve(this.channel.call("updateExtensionScope",[v,m])).then(w=>D(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class d{constructor(v){this.service=v}listen(v,m){throw new Error("Invalid listen")}call(v,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(te[186],ne([0,1,25,31]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(L,A,P,b,I){try{const D=await L.getExtensionsControlManifest();if(!D.unsupportedPreReleaseExtensions)return;const E=await L.getInstalled(1);for(const[g,{id:S,migrateStorage:d}]of Object.entries(D.unsupportedPreReleaseExtensions)){const h=E.find(m=>(0,n.areSameExtensions)(m.identifier,{id:g}));if(!h)continue;const v=(await A.getExtensions([{id:S,preRelease:!0}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!v){I.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${S}' extension is not found`);continue}try{I.info(`Migrating '${h.identifier.id}' extension to '${S}' extension...`);const m=!b.getDisabledExtensions().some(y=>(0,n.areSameExtensions)(y,h.identifier));await L.uninstall(h),I.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let w=E.find(y=>(0,n.areSameExtensions)(y.identifier,{id:S}));(!w||!w.isPreReleaseVersion&&m)&&(w=await L.installFromGallery(v,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),I.info(`Installed the pre-release extension '${w.identifier.id}'`),m||(await b.disableExtension(w.identifier),I.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),d&&(P.addToMigrationList((0,n.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,n.getExtensionId)(w.manifest.publisher,w.manifest.name)),I.info("Added pre-release extension to the storage migration list"))),I.info(`Migrated '${h.identifier.id}' extension to '${S}' extension.`)}catch(m){I.error(m)}}}catch(D){I.error(D)}}e.migrateUnsupportedExtensions=T}),define(te[187],ne([0,1,5,9,2,4,20,62,7,29,22,14,30,31,15,8]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends T.Disposable{constructor(y,p,c,r){super();this.fileService=p,this.extensionGalleryService=c,this.logService=r,this.extensionsDownloadDir=b.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,p){await this.cleanUpPromise;const c=this.getName(y),r=(0,A.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(r)){const l=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(l)||await this.extensionGalleryService.download(y,l,p);try{await this.rename(l,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(l)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,l.path),i}}return r}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,p,c){try{await D.Promises.rename(y.fsPath,p.fsPath)}catch(r){if(L.isWindows&&r&&r.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${y} to ${p} with 'EPERM' error. Trying again...`),this.rename(y,p,c);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const p=[],c=[];for(const i of y.children){const t=this.parse(i.name);t&&c.push([t,i])}const r=(0,S.groupByExtension)(c,([i])=>i),l=[];for(const i of r)i.sort((t,o)=>P.rcompare(t[0].version,o[0].version)),p.push(...i.slice(1).map(t=>t[1].resource)),l.push(i[0][1]);l.sort((i,t)=>i.mtime-t.mtime),p.push(...l.slice(0,Math.max(0,l.length-this.cache)).map(i=>i.resource)),await k.Promises.settled(p.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new S.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(y){const p=v.exec(y);return p&&p[1]&&p[2]?new S.ExtensionIdentifierWithVersion({id:p[1]},p[2]):null}};m=he([G(0,E.INativeEnvironmentService),G(1,d.IFileService),G(2,g.IExtensionGalleryService),G(3,h.ILogService)],m),e.ExtensionsDownloader=m}),define(te[188],ne([0,1,2,10,22,61]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(b,I){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(I.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(b){b.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[189],ne([0,1,84,16,5,2,18,10,22,14,30,31,59,8]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends L.Disposable{constructor(m,w,y){super();this.extensionManagementService=m,this.logService=y,this.cache=this._register(new h(w,y)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,n.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(y=>w[y]&&w[y].extensions.some(p=>(0,E.areSameExtensions)(p.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(w);return!(0,n.equals)(Object.keys(m),Object.keys(y))}};d=he([G(0,D.IExtensionManagementService),G(1,I.INativeEnvironmentService),G(2,S.ILogService)],d),e.LocalizationsService=d;let h=class extends L.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(y=>delete w[y]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const y of w)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,y);Object.keys(m).forEach(y=>this.updateHash(m[y]))}createLanguagePacksFromExtension(m,w){const y=w.identifier,p=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const c of p)if(w.location.scheme===A.Schemas.file&&(0,g.isValidLocalization)(c)){let r=m[c.languageId];r||(r={hash:"",extensions:[],translations:{}},m[c.languageId]=r);let l=r.extensions.filter(i=>(0,E.areSameExtensions)(i.extensionIdentifier,y))[0];l?l.version=w.manifest.version:r.extensions.push({extensionIdentifier:y,version:w.manifest.version});for(const i of c.translations)r.translations[i.id]=(0,P.join)(w.location.fsPath,i.path)}}updateHash(m){if(m){const w=(0,k.createHash)("md5");for(const y of m.extensions)w.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(w=m(y),y)).then(y=>{for(const c of Object.keys(y))y[c]||delete y[c];this.languagePacks=y,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),b.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>w,y=>this.logService.error(y))})}};h=he([G(0,I.INativeEnvironmentService),G(1,S.ILogService)],h)}),define(te[190],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[191],ne([0,1,120,19,8]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,b){this.configurationService=P,this.logService=b}request(P,b){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(P,b)}async resolveProxy(P){}};L=he([G(0,n.IConfigurationService),G(1,T.ILogService)],L),e.RequestService=L}),define(te[43],ne([0,1,17,140,42,6,38]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=P;function b(d){return d.res.statusCode===204}async function I(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);return b(d)?null:(await(0,k.streamToBuffer)(d.stream)).toString()}e.asText=I;async function D(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);if(b(d))return null;const v=(await(0,k.streamToBuffer)(d.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}e.asJson=D;function E(d){S(d)}e.updateProxyConfigurationsScope=E;let g;function S(d){const h=A.Registry.as(T.Extensions.Configuration),v=g;g={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[g],remove:v?[v]:[]})}S(2)}),define(te[192],ne([0,1,25,18,15,43]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,I){this.requestService=b,this.fileService=I}async download(b,I,D=k.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,I);return}const E={type:"GET",url:b.toString()},g=await this.requestService.request(E,D);if(g.res.statusCode===200)await this.fileService.writeFile(I,g.stream);else{const S=await(0,L.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${S}`)}}};A=he([G(0,L.IRequestService),G(1,T.IFileService)],A),e.DownloadService=A}),define(te[193],ne([0,1,16,25,68,2,20,154,15,8,27,43]),function(K,e,k,n,T,L,A,P,b,I,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends L.Disposable{constructor(d,h,v,m){super();this.fileService=d,this.productService=h,this.requestService=v,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,T.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const h=[];for(const[v,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==d.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(d,v)),y=new Map;(0,T.forEach)(m.recommendations,({key:c,value:r})=>{if((0,k.isNonEmptyArray)(r.remotes))for(const l of r.remotes)y.set(l,{extensionId:c,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled});else h.push({extensionId:c,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled})});const p=(0,P.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const c of p){const r=y.get(c);r&&h.push(r)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(d.res.statusCode!==200)return[];const h=await(0,E.asJson)(d);return h?h.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};g=he([G(0,b.IFileService),G(1,D.IProductService),G(2,E.IRequestService),G(3,I.ILogService)],g),e.ExtensionTipsService=g}),define(te[91],ne([0,1,71,6]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function T(L){return(0,k.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=T,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[194],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[195],ne([0,1,75,5,25,3,2,18,29,8,91,194]),function(K,e,k,n,T,L,A,P,b,I,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let g=class{constructor(h){this.logService=h,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(h){const v=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const m=(0,D.hash)(h);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(h));const w=new T.CancellationTokenSource;let y,p,c;this.processeDisposables.set(m,t=>{w.dispose(!0),y?.terminate(h,T.CancellationToken.None),p?.close(),c?.close(),this.processeDisposables.delete(m);const o=this.processResolvers.get(m);o&&(this.processResolvers.delete(m),o({reason:t}))}),y=await this.getOrCreateWebWorker(h);const r=new Promise(t=>{this.processResolvers.set(m,t)});if(w.token.isCancellationRequested)return r;const{port1:l,port2:i}=new MessageChannel;return p=l,c=i,await y.spawn(h,c,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",h,[p])),r}getOrCreateWebWorker(h){let v=this.workers.get(h.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${h.process.moduleId})`);const m=new S(h.process.type,this.logService);v=m.init(),m.onDidProcessSelfTerminate(({configuration:w,reason:y})=>{this.doDisposeWorker(w,y)}),this.workers.set(h.process.moduleId,v)}return v}async disposeWorker(h){return this.doDisposeWorker(h)}doDisposeWorker(h,v){const m=this.processeDisposables.get((0,D.hash)(h));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),m(v))}};g=he([G(0,I.ILogService)],g),e.SharedProcessWorkerService=g;class S extends A.Disposable{constructor(h,v){super();this.type=h,this.logService=v,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const h=new n.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},v.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},v.onmessage=m=>{const{id:w,message:y,configuration:p,nonce:c}=m.data;switch(w){case E.SharedProcessWorkerMessages.Ready:h.complete(v);break;case E.SharedProcessWorkerMessages.Ack:if(c){const r=this.mapMessageNonceToPendingMessageResolve.get(c);r&&(this.mapMessageNonceToPendingMessageResolve.delete(c),r())}break;case E.SharedProcessWorkerMessages.SelfTerminated:p&&y&&this._onDidProcessSelfTerminate.fire({configuration:p,reason:JSON.parse(y)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,y);break;case E.SharedProcessWorkerMessages.Info:y&&this.logService.info(y);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,y);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,y);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),h.p}async send(h,v,m){const w=await this.workerReady;if(!v.isCancellationRequested)return new Promise(y=>{const p=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(p,y);const c={...h,nonce:p};m?w.postMessage(c,[m]):w.postMessage(c),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(p)&&y()})})}spawn(h,v,m){const w={id:E.SharedProcessWorkerMessages.Spawn,configuration:h,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",K).fsPath}};return this.send(w,m,v)}terminate(h,v){const m={id:E.SharedProcessWorkerMessages.Terminate,configuration:h};return this.send(m,v)}}}),define(te[196],ne([0,1,54,18,153]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends T.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}he([k.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(te[92],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[197],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((T,L)=>K(["vsda"],T,L))}async createNewMessage(T){try{const L=await this.vsda(),A=new L.validator;if(A){const P=String(k._nextId++);return this.validators.set(P,A),{id:P,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,L){if(!T.id)return!0;const A=this.validators.get(T.id);if(!A)return!1;this.validators.delete(T.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(T){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(T)}catch{}return T}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,175,11,76,6]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var D;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(D=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var g;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class S extends T.Disposable{constructor(m={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===I?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,y){return this.getStorage(w)?.get(m,y)}getBoolean(m,w,y){return this.getStorage(w)?.getBoolean(m,y)}getNumber(m,w,y){return this.getStorage(w)?.getNumber(m,y)}store(m,w,y,p){if((0,A.isUndefinedOrNull)(w)){this.remove(m,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,y,p),this.getStorage(y)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const y=[],p=this.getKeyTargets(m);for(const c of Object.keys(p))p[c]===w&&y.push(c);return y}updateKeyTarget(m,w,y){const p=this.getKeyTargets(w);typeof y=="number"?p[m]!==y&&(p[m]=y,this.getStorage(w)?.set(I,JSON.stringify(p))):typeof p[m]=="number"&&(delete p[m],this.getStorage(w)?.set(I,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(I,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=D.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),y=this.getStorage(1);switch(m){case D.NONE:await k.Promises.settled([w?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await k.Promises.settled([w?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return h(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends S{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=d;async function h(v,m,w,y){const p=s=>{try{return JSON.parse(s)}catch{return s}},c=new Map,r=new Map;v.forEach((s,a)=>{c.set(a,s),r.set(a,p(s))});const l=new Map,i=new Map;m.forEach((s,a)=>{l.set(a,s),i.set(a,p(s))}),console.group(`Storage: Global (path: ${w})`);let t=[];c.forEach((s,a)=>{t.push({key:a,value:s})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${y})`);let o=[];l.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=h}),define(te[198],ne([0,1,3,2,11,30,31,23]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(E,g){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(E)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(g.onDidInstallExtensions(S=>S.forEach(({local:d,operation:h})=>{d&&h===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(E,g){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:g}),!0):!1}async disableExtension(E,g){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let g=this.getDisabledExtensions();return g.every(S=>!(0,A.areSameExtensions)(S,E))?(g.push(E),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(E){let g=this.getDisabledExtensions();for(let S=0;S<g.length;S++){const d=g[S];if((0,A.areSameExtensions)(d,E))return g.splice(S,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(E){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,g){this.storageManger.set(E,g,0)}};b=he([G(0,P.IStorageService),G(1,L.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class I extends n.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(E,g){let S;return g===0?((0,T.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,g)),S=this.storage[E]):S=this._get(E,g),JSON.parse(S)}set(E,g,S){let d=JSON.stringify(g.map(({id:v,uuid:m})=>({id:v,uuid:m})));this._get(E,S)!==d&&(S===0&&(g.length?this.storage[E]=d:delete this.storage[E]),this._set(E,g.length?d:void 0,S))}onDidStorageChange(E){if(E.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const S=this.get(E.key,E.scope);delete this.storage[E.key];const d=this.get(E.key,E.scope),h=S.filter(m=>!d.some(w=>(0,A.areSameExtensions)(m,w))),v=d.filter(m=>!S.some(w=>(0,A.areSameExtensions)(w,m)));(h.length||v.length)&&this._onDidChange.fire([...h,...v])}}_get(E,g){return this.storageService.get(E,g,"[]")}_set(E,g,S){g?this.storageService.store(E,g,S,1):this.storageService.remove(E,S)}}e.StorageManager=I}),define(te[63],ne([0,1,6,3,2,23,31,27,16,8,11]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class nt extends T.Disposable{constructor(d,h,v){super();this.storageService=d,this.productService=h,this.logService=v,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const h=E.exec(d);if(h&&h[1])return{id:h[1],version:h[2]}}initialize(){const d=this.storageService.keys(0,1);for(const h of d){const v=nt.fromKey(h);v&&this.extensionsWithKeysForSync.add(v.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const h=nt.fromKey(d.key);if(h){this.extensionsWithKeysForSync.add(h.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(d){if((0,D.isString)(d))return d;const h=d.manifest?d.manifest.publisher:d.publisher,v=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(h,v)}getExtensionState(d,h){const v=this.getExtensionId(d),m=this.storageService.get(v,h?0:1);if(m)try{return JSON.parse(m)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${h}): ${w}`)}}setExtensionState(d,h,v){const m=this.getExtensionId(d);h===void 0?this.storageService.remove(m,v?0:1):this.storageService.store(m,JSON.stringify(h),v?0:1,1)}setKeysForSync(d,h){this.storageService.store(nt.toKey(d),JSON.stringify(h),0,1)}getKeysForSync(d){const h=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],v=this.storageService.get(nt.toKey(d),0),m=v?JSON.parse(v):void 0;return m&&h?(0,b.distinct)([...m,...h]):m||h}addToMigrationList(d,h){if(d!==h){const v=this.migrationList.filter(m=>!m.includes(d)&&!m.includes(h));v.push([d,h]),this.migrationList=v}}getSourceExtensionToMigrate(d){const h=this.migrationList.find(([,v])=>d===v);return h?h[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const h=JSON.parse(d);if((0,D.isArray)(h))return h}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};g=he([G(0,L.IStorageService),G(1,P.IProductService),G(2,I.ILogService)],g),e.ExtensionStorageService=g}),define(te[199],ne([0,1,2,30,63,186,8]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let P=class extends k.Disposable{constructor(I,D,E,g,S){super();I.removeDeprecatedExtensions(),(0,L.migrateUnsupportedExtensions)(I,D,E,g,S)}};P=he([G(0,n.IExtensionManagementService),G(1,n.IExtensionGalleryService),G(2,T.IExtensionStorageService),G(3,n.IGlobalExtensionEnablementService),G(4,A.ILogService)],P),e.ExtensionsCleaner=P}),define(te[200],ne([0,1,3,2]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class T extends n.Disposable{constructor(I,D){super();this.channel=I,this.workspace=D}async getItems(){const I={workspace:this.workspace},D=await this.channel.call("getItems",I);return new Map(D)}updateItems(I){const D={workspace:this.workspace};return I.insert&&(D.insert=Array.from(I.insert.entries())),I.delete&&(D.delete=Array.from(I.delete.values())),this.channel.call("updateItems",D)}}class L extends T{constructor(I){super(I,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(I=>this.onDidChangeGlobalStorage(I)))}onDidChangeGlobalStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}async close(){this.dispose()}}class A extends T{constructor(I,D){super(I,D);this.onDidChangeItemsExternal=k.Event.None}async close(){const I={workspace:this.workspace};return this.channel.call("close",I)}}class P extends n.Disposable{constructor(I,D){super();this.channel=I,this.workspace=D,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[201],ne([0,1,5,2,20,76,23,200]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(D,E,g){super();this.mainProcessService=E,this.environmentService=g,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(D)}createGlobalStorage(){const D=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new L.Storage(D.globalStorage);return this._register(E.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),E}createWorkspaceStorage(D){const E=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),D);if(E.workspaceStorage){const g=new L.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=g.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=D?.id,g}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(D){const E=this.workspaceStorage,g=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(D),await this.workspaceStorage.init();for(const[S,d]of g)this.workspaceStorage.set(S,d)}}e.NativeStorageService=b}),define(te[202],ne([0,1,4,33,7,29]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,D,E,g,S,d,h,v,m,w){const y=Object.create(null);y["common.machineId"]=h,y.sessionID=(0,L.generateUuid)()+Date.now(),y.commitHash=S,y.version=d,y["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,k.PlatformToString)(k.platform),y["common.nodePlatform"]=n.platform,y["common.nodeArch"]=g,y["common.product"]=w||"desktop";const p=b(v||[]);p&&(y["common.msftInternal"]=p);let c=0;const r=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),k.isLinuxSnap&&(y["common.snap"]="true");const l=A(E);l&&(y["common.platformDetail"]=l);try{const i=await I.readFile(T.URI.file(m));y["common.source"]=i.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=P;function b(I){const D=n.env.USERDNSDOMAIN;if(!D)return!1;const E=D.toLowerCase();return I.some(g=>E===g)}e.verifyMicrosoftInternalDomain=b}),define(te[21],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[203],ne([0,1,34,55,5,35,18,10,4,7,113,22,116,81,15,27,21]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function w(l,i){const t=`${l}::${i.join(":")}`,o=m.get(t);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,u=new Map,f=2e4;function C(O,F,R,N){const $=F.substring(O.length+1);return T.Promises.withAsyncBody(async j=>{let X;try{X=await E.Promises.readdir(F,{withFileTypes:!0})}catch{j();return}if(N.count>=f){N.count+=X.length,N.maxReached=!0,j();return}let z=X.length;if(z===0){j();return}let J=X;N.count+X.length>f&&(N.maxReached=!0,z=f-N.count,J=X.slice(0,z)),N.count+=X.length;for(const B of J)if(B.isDirectory()){if(R.includes(B.name)||await C(O,(0,P.join)(F,B.name),R,N),--z==0){j();return}}else{const x=B.name.lastIndexOf(".");if(x>=0){const ee=B.name.substring(x+1);ee&&a.set(ee,(a.get(ee)??0)+1)}for(const ee of s)ee.relativePathPattern?.test($)!==!1&&ee.filePattern.test(B.name)&&u.set(ee.tag,(u.get(ee.tag)??0)+1);if(--z==0){j();return}}})}const _=T.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1};await C(l,l,i,F);const R=await c(l);O({configFiles:y(u),fileTypes:y(a),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:R})});return m.set(t,_),_}e.collectWorkspaceStats=w;function y(l){return[...n.Iterable.map(l.entries(),([i,t])=>({name:i,count:t}))].sort((i,t)=>t.count-i.count)}function p(){const l={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=p;async function c(l){try{const i=new Map,t=(0,P.join)(l,".vscode","launch.json"),o=await E.Promises.readFile(t),s=[],a=(0,L.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const u of a.configurations){const f=u.type;f&&(i.has(f)?i.set(f,i.get(f)+1):i.set(f,1))}return y(i)}catch{return[]}}e.collectLaunchConfigs=c;let r=class{constructor(i,t){this.telemetryService=i,this.productService=t}formatMachineInfo(i){const t=[];return t.push(`OS Version:       ${i.os}`),t.push(`CPUs:             ${i.cpus}`),t.push(`Memory (System):  ${i.memory}`),t.push(`VM:               ${i.vmHint}`),t.join(`
`)}formatEnvironment(i){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const o=k.cpus();return o&&o.length>0&&t.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||t.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${i.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(i,t){return Promise.all([(0,g.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[s,a]=o,u=this.formatProcessList(i,s);return t.forEach(f=>{if((0,S.isRemoteDiagnosticError)(f))u+=`
${f.errorMessage}`,a+=`
${f.errorMessage}`;else if(u+=`

Remote: ${f.hostName}`,f.processes&&(u+=`
${this.formatProcessList(i,f.processes)}`),f.workspaceMetadata){a+=`
|  Remote: ${f.hostName}`;for(const C of Object.keys(f.workspaceMetadata)){const _=f.workspaceMetadata[C];let O=`${_.fileCount} files`;_.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${C}): ${O}`,a+=this.formatWorkspaceStats(_)}}}),{processInfo:u,workspaceInfo:a}})}async getSystemInfo(i,t){const{memory:o,vmHint:s,os:a,cpus:u}=p(),f={os:a,memory:o,cpus:u,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:t};return b.isWindows||(f.load=`${k.loadavg().map(C=>Math.round(C)).join(", ")}`),b.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(i,t){const o=[];return(0,g.listProcesses)(i.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,s)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),t.forEach(a=>{if((0,S.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const u of Object.keys(a.workspaceMetadata)){const f=a.workspaceMetadata[u];let C=`${f.fileCount} files`;f.maxFilesReached&&(C=`more than ${C}`),o.push(`Folder (${u}): ${C}`),o.push(this.formatWorkspaceStats(f))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const t=[],o=60;let s=0;const a=(_,O)=>{const F=` ${_}(${O})`;s+F.length>o?(t.push(u),u="|                 ",s=u.length):s+=F.length,u+=F};let u="|      File types:";const f=10;let C=i.fileTypes.length>f?f:i.fileTypes.length;for(let _=0;_<C;_++){const O=i.fileTypes[_];a(O.name,O.count)}if(t.push(u),i.configFiles.length>=0&&(u="|      Conf files:",s=0,i.configFiles.forEach(_=>{a(_.name,_.count)}),t.push(u)),i.launchConfigFiles.length>0){let _="|      Launch Configs:";i.launchConfigFiles.forEach(O=>{_+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),t.push(_)}return t.join(`
`)}expandGPUFeatures(i){const t=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(t-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const t=[],o=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const u=I.URI.revive(a);if(u.scheme===A.Schemas.file){const f=u.fsPath;o.push(w(f,["node_modules",".git"]).then(C=>{let _=`${C.fileCount} files`;C.maxFilesReached&&(_=`more than ${_}`),t.push(`|    Folder (${(0,P.basename)(f)}): ${_}`),t.push(this.formatWorkspaceStats(C))}).catch(C=>{t.push(`|      Error: Unable to collect workspace stats for folder ${f} (${C.toString()})`)}))}else t.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,t){const o=new Map;i.windows.forEach(a=>o.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(i.mainPID,o,s,t,0),s.join(`
`)}formatProcessItem(i,t,o,s,a){const u=a===0;let f;u?f=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(f=`${f} (${t.get(s.pid)})`));const C=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(C/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(_=>this.formatProcessItem(i,t,o,_,a+1))}async getWorkspaceFileExtensions(i){const t=new Set;for(const{uri:o}of i.folders){const s=I.URI.revive(o);if(s.scheme!==A.Schemas.file)continue;const a=s.fsPath;try{(await w(a,["node_modules",".git"])).fileTypes.forEach(f=>t.add(f.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(i){for(const{uri:t}of i.folders){const o=I.URI.revive(t);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{const a=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),a.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),a.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};r=he([G(0,v.ITelemetryService),G(1,h.IProductService)],r),e.DiagnosticsService=r}),define(te[204],ne([0,1,16,5,25,9,3,2,4,11,7,129,30,31,8,27,21]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{constructor(l,i,t,o){super();this.galleryService=l,this.telemetryService=i,this.logService=t,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(l){const i=await this.getTargetPlatform();return l.allTargetPlatforms.some(t=>(0,g.isTargetPlatformCompatible)(t,l.allTargetPlatforms,i))}async installFromGallery(l,i={}){try{if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(E.localize(0,null),g.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(l,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw p(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(l),void 0,t),this.logService.error("Failed to install extension.",l.identifier.id),this.logService.error(t),y(t)}}async uninstall(l,i={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,i)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.getTargetPlatform(),[t]=await this.galleryService.getExtensions([{...l.identifier,preRelease:l.preRelease}],{targetPlatform:i,compatible:!0},T.CancellationToken.None);if(!t)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsControlManifest(){const l=new Date().getTime();return(!this.extensionsControlManifest||l-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=l),this.extensionsControlManifest}registerParticipant(l){this.participants.push(l)}async installExtension(l,i,t){if(!D.URI.isUri(i)){let f=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(f)return this.logService.info("Extensions is already requested to install",i.identifier.id),f.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],a=this.createInstallExtensionTask(l,i,t);D.URI.isUri(i)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(a.identifier,l.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:i}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:l});let u=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const C=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,l,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of C)if(u=u||!!O.extensionDependencies?.some(F=>(0,S.areSameExtensions)({id:F},a.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const F=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(F.identifier,O.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:_}),this.logService.info("Installing extension:",F.identifier.id),o.push({task:F,manifest:O})}}catch(C){if(D.URI.isUri(a.source))(0,k.isNonEmptyArray)(l.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,C.message),(0,k.isNonEmptyArray)(l.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,C.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),C}const f=o.reduce((C,{task:_,manifest:O})=>(C.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),C),new Map);for(;f.size;){let C;const _=[...f.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(F=>f.has(F.toLowerCase())));_.length?C=f.size===1?_:_.filter(({task:O})=>!(O===a&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),C=[...f.values()]),await this.joinAllSettled(C.map(async({task:O})=>{const F=new Date().getTime(),R=(0,I.isUndefined)(t.operation)?O.operation:t.operation;try{const N=await O.run();if(await this.joinAllSettled(this.participants.map($=>$.postInstall(N,O.source,t,T.CancellationToken.None))),!D.URI.isUri(O.source)&&(p(this.telemetryService,R===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,void 0),b.isWeb&&R!==3))try{await this.galleryService.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,"install")}catch{}s.push({local:N,identifier:O.identifier,operation:R,source:O.source})}catch(N){throw D.URI.isUri(O.source)||p(this.telemetryService,R===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,N),this.logService.error("Error while installing the extension:",O.identifier.id),N}finally{f.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:C})=>this.logService.info("Extension installed successfully:",C.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:C})=>(0,S.areSameExtensions)(C,a.identifier))[0].local}catch(f){if(o.forEach(({task:C})=>C.cancel()),s.length)try{const C=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<C.length;_++){const O=C[_],{identifier:F}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,L.getErrorMessage)(O.reason))}}catch(C){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(C),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:C})=>({identifier:C.identifier,operation:2,source:C.source}))),f}finally{for(const{task:f,manifest:C}of o)if(!D.URI.isUri(f.source)){const _=new S.ExtensionIdentifierWithVersion(f.identifier,C.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(l){const i=[],t=[],o=await Promise.allSettled(l);for(const s of o)s.status==="fulfilled"?i.push(s.value):t.push(s.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(l,i,t,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[l,...s.map(C=>C.identifier)],u=[],f=async(C,_)=>{const O=_.extensionDependencies||[],F=[...O];if(_.extensionPack){const R=t?s.find(N=>(0,S.areSameExtensions)(N.identifier,C)):void 0;for(const N of _.extensionPack)R&&R.manifest.extensionPack&&R.manifest.extensionPack.some($=>(0,S.areSameExtensions)({id:$},{id:N}))||F.every($=>!(0,S.areSameExtensions)({id:$},{id:N}))&&F.push(N)}if(F.length){const R=[...a,...u.map($=>$.gallery.identifier)],N=F.filter($=>R.every(j=>!(0,S.areSameExtensions)(j,{id:$})));if(N.length){const $=await this.galleryService.getExtensions(N.map(j=>({id:j,preRelease:o})),T.CancellationToken.None);for(const j of $){if(R.find(J=>(0,S.areSameExtensions)(J,j.identifier)))continue;const X=O.some(J=>(0,S.areSameExtensions)({id:J},j.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(j,!0,o)}catch(J){if(J instanceof g.ExtensionManagementError&&J.code===g.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw J}u.push({gallery:z.extension,manifest:z.manifest}),await f(z.extension.identifier,z.manifest)}}}};return await f(l,i),s=await this.getInstalled(),u.filter(C=>!s.some(_=>(0,S.areSameExtensions)(_.identifier,C.gallery.identifier)))}async checkAndGetCompatibleVersion(l,i,t){const o=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(o).has(l.identifier.id))throw new g.ExtensionManagementError(E.localize(3,null,l.identifier.id),g.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[l.identifier.id])throw new g.ExtensionManagementError(E.localize(4,null,l.identifier.id,o.unsupportedPreReleaseExtensions[l.identifier.id].displayName),g.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(l)){const u=await this.getTargetPlatform();throw new g.ExtensionManagementError(E.localize(5,null,l.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(u)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(l,i,t);if(s){if(t&&i&&l.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new g.ExtensionManagementError(E.localize(6,null,l.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&l.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([l.identifier],T.CancellationToken.None))[0]?new g.ExtensionManagementError(E.localize(7,null,l.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(E.localize(8,null,l.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const a=await this.galleryService.getManifest(s,T.CancellationToken.None);if(a===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(a.version!==s.version)throw new g.ExtensionManagementError(`Cannot install '${l.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:a}}async getCompatibleVersion(l,i,t){const o=await this.getTargetPlatform();let s=null;return i&&l.hasPreReleaseVersion&&l.properties.isPreReleaseVersion!==t&&(s=(await this.galleryService.getExtensions([{...l.identifier,preRelease:t}],{targetPlatform:o,compatible:!0},T.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(l,t,o)&&(s=l),!s&&i&&(s=await this.galleryService.getCompatibleExtension(l,t,o)),s}async unininstallExtension(l,i){const t=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),t.waitUntilTaskIsFinished();const o=(f,C)=>{const _=this.createUninstallExtensionTask(f,C);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),_},s=(f,C)=>{C?this.logService.error("Failed to uninstall extension:",f.identifier.id,C.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(f),void 0,C),this._onDidUninstallExtension.fire({identifier:f.identifier,error:C?.code})},a=[],u=[];try{a.push(o(l,{}));const f=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const C=this.getAllPackExtensionsToUninstall(l,f);for(const _ of C)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(o(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(a.map(C=>C.extension),f,l),await this.joinAllSettled(a.map(async C=>{try{if(await C.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(C.extension,i,T.CancellationToken.None))),C.extension.identifier.uuid)try{await this.galleryService.reportStatistic(C.extension.manifest.publisher,C.extension.manifest.name,C.extension.manifest.version,"uninstall")}catch{}s(C.extension)}catch(_){const O=_ instanceof g.ExtensionManagementError?_:new g.ExtensionManagementError((0,L.getErrorMessage)(_),g.ExtensionManagementErrorCode.Internal);throw s(C.extension,O),O}finally{u.push(C)}}))}catch(f){const C=f instanceof g.ExtensionManagementError?f:new g.ExtensionManagementError((0,L.getErrorMessage)(f),g.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}u.includes(_)||s(_.extension,C)}throw C}finally{for(const f of a)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(l,i,t){for(const o of l){const s=this.getDependents(o,i);if(s.length){const a=s.filter(u=>!l.some(f=>(0,S.areSameExtensions)(f.identifier,u.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,t))}}}getDependentsErrorMessage(l,i,t){return t===l?i.length===1?E.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(11,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(12,null,t.manifest.displayName||t.manifest.name,l.manifest.displayName||l.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(13,null,t.manifest.displayName||t.manifest.name,l.manifest.displayName||l.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(14,null,t.manifest.displayName||t.manifest.name,l.manifest.displayName||l.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(l,i,t=[]){if(t.indexOf(l)!==-1)return[];t.push(l);const o=l.manifest.extensionPack?l.manifest.extensionPack:[];if(o.length){const s=i.filter(u=>!u.isBuiltin&&o.some(f=>(0,S.areSameExtensions)({id:f},u.identifier))),a=[];for(const u of s)a.push(...this.getAllPackExtensionsToUninstall(u,i,t));return[...s,...a]}return[]}getDependents(l,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(o=>(0,S.areSameExtensions)({id:o},l.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",l),l}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=he([G(0,g.IExtensionGalleryService),G(1,v.ITelemetryService),G(2,d.ILogService),G(3,h.IProductService)],m),e.AbstractExtensionManagementService=m;function w(r){const l=Array.isArray(r)?r:[r];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function y(r){if(r instanceof g.ExtensionManagementError)return r;const l=new g.ExtensionManagementError(r.message,g.ExtensionManagementErrorCode.Internal);return l.stack=r.stack,l}function p(r,l,i,t,o){const s=o?o instanceof g.ExtensionManagementError?o.code:g.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(l,{...i,success:!o,duration:t,errorcode:s})}e.reportTelemetry=p;class c{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(l=>new Promise((i,t)=>{const o=l.onCancellationRequested(()=>{o.dispose(),t((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=c}),define(te[205],ne([0,1,16,5,68,3,10,4,33,7,131,14,30,31,193,83,15,8,60,27,43,23,21]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const l="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let t=class extends d.ExtensionTipsService{constructor(s,a,u,f,C,_,O,F,R,N){super(O,F,R,N);this.environmentService=s,this.telemetryService=a,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=C,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&(0,T.forEach)(F.exeBasedExtensionTips,({key:$,value:j})=>{const X=[],z=[],J=[];(0,T.forEach)(j.recommendations,({key:B,value:x})=>{x.important?j.important?X.push({extensionId:B,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):z.push({extensionId:B,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):J.push({extensionId:B,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),X.length&&this.highImportanceExecutableTips.set($,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:X}),z.length&&this.mediumImportanceExecutableTips.set($,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:z}),J.length&&this.allOtherExecutableTips.set($,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:J})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,u)}groupImportantTipsByExe(s,a){const u=new Map;s.forEach(F=>u.set(F.extensionId.toLowerCase(),F));const{installed:f,uninstalled:C}=this.groupByInstalled([...u.keys()],a);for(const F of f){const R=u.get(F);R&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:R.exeName})}for(const F of C){const R=u.get(F);R&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:R.exeName})}const _=this.getPromptedExecutableTips(),O=new Map;for(const F of C){const R=u.get(F);if(R&&(!_[R.exeName]||!_[R.exeName].includes(R.extensionId))){let N=O.get(R.exeName);N||(N=[],O.set(R.exeName,N)),N.push(R)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const f=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const f=this._register((0,n.disposableTimeout)(()=>{f.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),a=Date.now()-s,u=7*24*60*60*1e3;if(a<u){const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u-a));return}const[f,C]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(C).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(C[0].exeName,C);const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const a=await this.extensionManagementService.getInstalled(1),u=s.filter(C=>!C.whenNotInstalled||C.whenNotInstalled.every(_=>a.every(O=>!(0,S.areSameExtensions)(O.identifier,{id:_})))).map(({extensionId:C})=>C.toLowerCase()),f=(0,D.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,f,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(i,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(i,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(l,0,"{}"))}addToRecommendedExecutables(s,a){const u=this.getPromptedExecutableTips();u[s]=a.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(l,JSON.stringify(u),0,0)}groupByInstalled(s,a){const u=[],f=[],C=a.reduce((_,O)=>(_.add(O.identifier.id.toLowerCase()),_),new Set);return s.forEach(_=>{C.has(_.toLowerCase())?u.push(_):f.push(_)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const a=[],u=new Map;for(const f of s.keys()){const C=s.get(f);if(!C||!(0,k.isNonEmptyArray)(C.recommendations))continue;const _=[];P.isWindows?C.windowsPath&&_.push(C.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(_.push((0,A.join)("/usr/local/bin",f)),_.push((0,A.join)("/usr/bin",f)),_.push((0,A.join)(this.environmentService.userHome.fsPath,f)));for(const O of _){let F=u.get(O);if(F===void 0&&(F=await this.fileService.exists(I.URI.file(O)),u.set(O,F)),F)for(const{extensionId:R,extensionName:N,isExtensionPack:$,whenNotInstalled:j}of C.recommendations)a.push({extensionId:R,extensionName:N,isExtensionPack:$,exeName:f,exeFriendlyName:C.exeFriendlyName,windowsPath:C.windowsPath,whenNotInstalled:j})}}return a}};t=he([G(0,E.INativeEnvironmentService),G(1,r.ITelemetryService),G(2,g.IExtensionManagementService),G(3,c.IStorageService),G(4,w.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,v.IFileService),G(7,y.IProductService),G(8,p.IRequestService),G(9,m.ILogService)],t),e.ExtensionTipsService=t}),define(te[93],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:P,data:b}){return this.appenders.forEach(I=>I.log(P,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class n{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(te[47],ne([0,1,28,11,19,21]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,y){return Promise.resolve(void 0)}publicLog2(w,y){return this.publicLog(w,y)}publicLogError(w,y){return Promise.resolve(void 0)}publicLogError2(w,y){return this.publicLogError(w,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class P{async publicLog(w,y,p){}async publicLogError(w,y,p){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(m,w){return w.onDidChangeConfiguration(y=>{y.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(y.source),configurationKeys:d(y.sourceConfig)})})}e.configurationTelemetry=b;function I(m,w){return!(w.disableTelemetry||!m.enableTelemetry||w.extensionTestsLocationURI)}e.supportsTelemetry=I;function D(m){const w=m.getValue(L.TELEMETRY_SETTING_ID),y=m.getValue("telemetry.enableCrashReporter");if(m.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=D;function E(m){const w=Object.create(null),y=Object.create(null),p=Object.create(null);S(m,p);for(let c in p){c=c.length>150?c.substr(c.length-149):c;const r=p[c];typeof r=="number"?y[c]=r:typeof r=="boolean"?y[c]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${r.length}`),w[c]=r.substring(0,8191)):typeof r!="undefined"&&r!==null&&(w[c]=r)}return{properties:w,measurements:y}}e.validateTelemetryData=E;function g(m){if(!m)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{m.indexOf(`${p}+`)===0&&(w=p)}),w}e.cleanRemoteAuthority=g;function S(m,w,y=0,p){if(!!m)for(let c of Object.getOwnPropertyNames(m)){const r=m[c],l=p?p+c:c;Array.isArray(r)?w[l]=(0,k.safeStringify)(r):r instanceof Date?w[l]=r.toISOString():(0,n.isObject)(r)?y<2?S(r,w,y+1,l+"."):w[l]=(0,k.safeStringify)(r):w[l]=r}}function d(m){if(!m)return[];const w=[];return h(w,"",m),w}function h(m,w,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(p=>h(m,w?`${w}.${p}`:p,y[p])):m.push(w)}function v(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=v}),define(te[206],ne([0,1,46,47]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(L,A,P,b,I,D){const E={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},g=await(0,k.getServiceMachineId)(P,I,D);return(0,n.supportsTelemetry)(A,P)&&(0,n.getTelemetryLevel)(b)===3&&(E["X-Market-User-Id"]=g),E}e.resolveMarketplaceHeaders=T}),define(te[207],ne([0,1,16,25,9,28,4,33,11,7,19,14,30,31,79,15,8,27,43,206,23,21]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=A.isWeb?"web":(0,g.getTargetPlatform)(A.platform,P.arch);var l;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(l||(l={}));function i(...U){return String(U.reduce((M,W)=>M|W,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class f{constructor(M=u){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,W=this.state.pageSize){return new f({...this.state,pageNumber:M,pageSize:W})}withFilter(M,...W){const H=[...this.state.criteria,...W.length?W.map(re=>({filterType:M,value:re})):[{filterType:M}]];return new f({...this.state,criteria:H})}withSortBy(M){return new f({...this.state,sortBy:M})}withSortOrder(M){return new f({...this.state,sortOrder:M})}withFlags(...M){return new f({...this.state,flags:M.reduce((W,H)=>W|H,0)})}withAssetTypes(...M){return new f({...this.state,assetTypes:M})}get raw(){const{criteria:M,pageNumber:W,pageSize:H,sortBy:re,sortOrder:se,flags:ue,assetTypes:de}=this.state;return{filters:[{criteria:M,pageNumber:W,pageSize:H,sortBy:re,sortOrder:se}],assetTypes:de,flags:ue}}get searchText(){const M=this.state.criteria.filter(W=>W.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber)}}}function C(U,M){const W=(U||[]).filter(H=>H.statisticName===M)[0];return W?W.value:0}function _(U){const M="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(H=>H.assetType.indexOf(M)===0).reduce((H,re)=>{const se=R(U,re.assetType);return se&&H.push([re.assetType.substring(M.length),se]),H},[])}function O(U){if(U.properties){const M=U.properties.filter(re=>re.key===o.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=M.filter(re=>W.test(re.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return R(U,o.Repository)}function F(U){return{uri:`${U.fallbackAssetUri}/${o.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${o.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function R(U,M){return U.files.filter(H=>H.assetType===M)[0]?{uri:`${U.assetUri}/${M}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${M}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function N(U,M){const W=U.properties?U.properties.filter(re=>re.key===M):[],H=W.length>0&&W[0].value;return H?H.split(",").map(re=>(0,S.adoptToGalleryExtensionId)(re)):[]}function $(U){const M=U.properties?U.properties.filter(W=>W.key===s.Engine):[];return M.length>0&&M[0].value||""}function j(U){const M=U.properties?U.properties.filter(W=>W.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function X(U){const M=U.properties?U.properties.filter(H=>H.key===s.LocalizedLanguages):[],W=M.length>0&&M[0].value||"";return W?W.split(","):[]}function z(U){return U.indexOf("preview")!==-1}function J(U){return U.targetPlatform?(0,g.toTargetPlatform)(U.targetPlatform):"undefined"}function B(U){const M=(0,k.distinct)(U.versions.map(J)),W=!!U.tags?.includes(g.WEB_EXTENSION_TAG),H=M.indexOf("web");return W?H===-1&&M.push("web"):H!==-1&&M.splice(H,1),M}function x(U,M){const W=(0,g.getFallbackTargetPlarforms)(M);for(let H=0;H<U.length;H++){const re=U[H];if(re.version===U[H-1]?.version){let se=H;const ue=J(re);if(ue===M)for(;se>0&&U[se-1].version===re.version;)se--;else if(W.includes(ue))for(;se>0&&U[se-1].version===re.version&&J(U[se-1])!==M;)se--;se!==H&&(U.splice(H,1),U.splice(se,0,re))}}return U}e.sortExtensionVersions=x;function ee(U,M,W){U.telemetryData={index:M,querySource:W}}function V(U,M,W){const H=U.versions[0],re={manifest:R(M,o.Manifest),readme:R(M,o.Details),changelog:R(M,o.Changelog),license:R(M,o.License),repository:O(M),download:F(M),icon:R(M,o.Icon),coreTranslations:_(M)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:M.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:C(U.statistics,"install"),rating:C(U.statistics,"averagerating"),ratingCount:C(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:W,assets:re,properties:{dependencies:N(M,s.Dependency),extensionPack:N(M,s.ExtensionPack),engine:$(M),localizedLanguages:X(M),targetPlatform:J(M),isPreReleaseVersion:j(M)},hasPreReleaseVersion:j(H),hasReleaseVersion:!0,preview:z(U.flags)}}let Z=class{constructor(M,W,H,re,se,ue,de,we){this.requestService=W,this.logService=H,this.environmentService=re,this.telemetryService=se,this.fileService=ue,this.productService=de,this.configurationService=we;const pe=de.extensionsGallery;this.extensionsGalleryUrl=pe&&pe.serviceUrl,this.extensionsControlUrl=pe&&pe.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(de.version,de,this.environmentService,this.configurationService,this.fileService,M)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,W,H){const re=n.CancellationToken.isCancellationToken(W)?{}:W,se=n.CancellationToken.isCancellationToken(W)?W:H,ue=[],de=[],we=[],pe=[];let ge=!0;for(const Ce of M){Ce.uuid?de.push(Ce.uuid):ue.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);we.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&pe.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),ge=ge&&!!Ce.hasPreRelease&&!De}if(!de.length&&!ue.length)return[];let Ee=new f().withPage(1,M.length);de.length&&(Ee=Ee.withFilter(t.ExtensionId,...de)),ue.length&&(Ee=Ee.withFilter(t.ExtensionName,...ue)),(re.queryAllVersions||ge)&&(Ee=Ee.withFlags(Ee.flags,l.IncludeVersions));const{extensions:Te}=await this.queryGalleryExtensions(Ee,{targetPlatform:re.targetPlatform??r,includePreRelease:we,versions:pe,compatible:!!re.compatible},se);return re.source&&Te.forEach((Ce,De)=>ee(Ce,De,re.source)),Te}async getCompatibleExtension(M,W,H){if((0,g.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(M,W,H))return M;const re=new f().withFlags(l.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:se}=await this.queryGalleryExtensions(re,{targetPlatform:H,compatible:!0,includePreRelease:W},n.CancellationToken.None);return se[0]||null}async isExtensionCompatible(M,W,H){if(!(0,g.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,H)||!W&&M.properties.isPreReleaseVersion)return!1;let re=M.properties.engine;if(!re){const se=await this.getManifest(M,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");re=se.engines.vscode}return(0,d.isEngineValid)(re,this.productService.version,this.productService.date)}async isValidVersion(M,W,H,re,se){if(!(0,g.isTargetPlatformCompatible)(J(M),re,se)||W!=="any"&&j(M)!==(W==="prerelease"))return!1;if(H){const ue=await this.getEngine(M);if(!(0,d.isEngineValid)(ue,this.productService.version,this.productService.date))return!1}return!0}async query(M,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let H=M.text||"";const re=(0,L.getOrDefault)(M,ge=>ge.pageSize,50);let se=new f().withPage(1,re);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Te)=>(se=se.withFilter(t.Category,Te||Ee),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Te)=>(se=se.withFilter(t.Tag,Te||Ee),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(t.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),se=se.withFilter(t.SearchText,H)),se=se.withSortBy(0)):M.ids?se=se.withFilter(t.ExtensionId,...M.ids):M.names?se=se.withFilter(t.ExtensionName,...M.names):se=se.withSortBy(4),typeof M.sortBy=="number"&&(se=se.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(se=se.withSortOrder(M.sortOrder));const ue=async(ge,Ee)=>{const{extensions:Te,total:Ce}=await this.queryGalleryExtensions(ge,{targetPlatform:r,compatible:!1,includePreRelease:!!M.includePreRelease},Ee);return Te.forEach((De,qe)=>ee(De,(ge.pageNumber-1)*ge.pageSize+qe,M.source)),{extensions:Te,total:Ce}},{extensions:de,total:we}=await ue(se,W),pe=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw new T.CancellationError;const{extensions:Te}=await ue(se.withPage(ge+1),Ee);return Te};return{firstPage:de,total:we,pageSize:se.pageSize,getPage:pe}}async queryGalleryExtensions(M,W,H){const re=M.flags;!!(M.flags&l.IncludeLatestVersionOnly)&&!!(M.flags&l.IncludeVersions)&&(M=M.withFlags(M.flags&~l.IncludeVersions,l.IncludeLatestVersionOnly)),!(M.flags&l.IncludeLatestVersionOnly)&&!(M.flags&l.IncludeVersions)&&(M=M.withFlags(M.flags,l.IncludeLatestVersionOnly)),W.versions?.length&&(M=M.withFlags(M.flags&~l.IncludeLatestVersionOnly,l.IncludeVersions)),M=M.withFlags(M.flags,l.IncludeAssetUri,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeStatistics,l.IncludeVersionProperties);const{galleryExtensions:se,total:ue}=await this.queryRawGalleryExtensions(M,H);if(!(M.flags&l.IncludeLatestVersionOnly)){const ge=[];for(const Ee of se){const Te=await this.toGalleryExtensionWithCriteria(Ee,W,!0);Te&&ge.push(Te)}return{extensions:ge,total:ue}}const we=[],pe=new Map;for(let ge=0;ge<se.length;ge++){const Ee=se[ge],Te={id:(0,S.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Ce=(0,b.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(qe=>(0,S.areSameExtensions)(qe,Te))?.includePreRelease;let De=await this.toGalleryExtensionWithCriteria(Ee,W,!1);!De||De.properties.isPreReleaseVersion&&(!Ce||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==W.targetPlatform&&De.hasPreReleaseVersion?pe.set(Ee.extensionId,ge):we.push([ge,De])}if(pe.size){const ge=new Date().getTime(),Ee=new f().withFlags(re&~l.IncludeLatestVersionOnly,l.IncludeVersions).withPage(1,pe.size).withFilter(t.ExtensionId,...pe.keys()),{extensions:Te}=await this.queryGalleryExtensions(Ee,W,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:pe.size});for(const Ce of Te){const De=pe.get(Ce.identifier.uuid);we.push([De,Ce])}}return{extensions:we.sort((ge,Ee)=>ge[0]-Ee[0]).map(([,ge])=>ge),total:ue}}async toGalleryExtensionWithCriteria(M,W,H){const re={id:(0,S.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},se=W.versions?.find(pe=>(0,S.areSameExtensions)(pe,re))?.version,ue=(0,b.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(pe=>(0,S.areSameExtensions)(pe,re))?.includePreRelease,de=B(M),we=x(M.versions,W.targetPlatform);if(W.compatible&&H&&(0,g.isNotWebExtensionInWebTargetPlatform)(de,W.targetPlatform))return null;for(let pe=0;pe<we.length;pe++){const ge=we[pe];if(!(se&&ge.version!==se)){if(await this.isValidVersion(ge,ue?"any":"release",W.compatible,de,W.targetPlatform))return V(M,ge,de);if(se&&ge.version===se)return null}}return se||W.compatible?null:V(M,M.versions[0],de)}async queryRawGalleryExtensions(M,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,l.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(l.Unpublished));const H=await this.commonHeadersPromise,re=JSON.stringify(M.raw),se={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},ue=new Date().getTime();let de,we,pe=0;try{if(de=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:re,headers:se},W),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:pe};const ge=await(0,w.asJson)(de);if(ge){const Ee=ge.results[0],Te=Ee.extensions,Ce=Ee.resultMetadata&&Ee.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return pe=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:pe}}return{galleryExtensions:[],total:pe}}catch(ge){throw we=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(re.length),duration:new Date().getTime()-ue,success:!!de&&(0,w.isSuccess)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:we?(0,T.isCancellationError)(we)?"canceled":(0,T.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(M,W,H,re){if(!this.isEnabled())return;const se=A.isWeb?this.api(`/itemName/${M}.${W}/version/${H}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${W}/${H}/stats?statType=${re}`),ue=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:ue};try{await this.requestService.request({type:"POST",url:se,headers:we},n.CancellationToken.None)}catch{}}async download(M,W,H){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const re=(0,S.getGalleryExtensionTelemetryData)(M),se=new Date().getTime(),ue=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:ge}),de=H===2?"install":H===3?"update":"",we=de?{uri:`${M.assets.download.uri}${I.URI.parse(M.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${M.assets.download.fallbackUri}${I.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:M.assets.download,pe=await this.getAsset(we);await this.fileService.writeFile(W,pe.stream),ue(new Date().getTime()-se)}async getReadme(M,W){if(M.assets.readme){const H=await this.getAsset(M.assets.readme,{},W);return await(0,w.asText)(H)||""}return""}async getManifest(M,W){if(M.assets.manifest){const H=await this.getAsset(M.assets.manifest,{},W),re=await(0,w.asText)(H);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(M,W){const H=R(M,o.Manifest);if(!H)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},se=await this.getAsset(H,{headers:re});return await(0,w.asJson)(se)}async getCoreTranslation(M,W){const H=M.assets.coreTranslations.filter(re=>re[0]===W.toUpperCase())[0];if(H){const re=await this.getAsset(H[1]),se=await(0,w.asText)(re);return se?JSON.parse(se):null}return null}async getChangelog(M,W){if(M.assets.changelog){const H=await this.getAsset(M.assets.changelog,{},W);return await(0,w.asText)(H)||""}return""}async getAllCompatibleVersions(M,W,H){let re=new f().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?re=re.withFilter(t.ExtensionId,M.identifier.uuid):re=re.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:se}=await this.queryRawGalleryExtensions(re,n.CancellationToken.None);if(!se.length)return[];const ue=B(se[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(ue,H))return[];const de=[],we=new Set;return await Promise.all(se[0].versions.map(async pe=>{try{if(we.has(pe.version))return;await this.isValidVersion(pe,W?"any":"release",!0,ue,H)&&(de.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:j(pe)}),we.add(pe.version))}catch{}})),de}async getAsset(M,W={},H=n.CancellationToken.None){const re=await this.commonHeadersPromise,se={type:"GET"},ue={...re,...W.headers||{}};W={...W,...se,headers:ue};const de=M.uri,we=M.fallbackUri,pe={...W,url:de};try{const ge=await this.requestService.request(pe,H);if(ge.res.statusCode===200)return ge;const Ee=await(0,w.asText)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${Ee}`)}catch(ge){if((0,T.isCancellationError)(ge))throw ge;const Ee=(0,T.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:Ee});const Te={...W,url:we};return this.requestService.request(Te,H)}}async getEngine(M){let W=$(M);if(!W){const H=await this.getManifestFromRawExtensionVersion(M,n.CancellationToken.None);if(!H)throw new Error("Manifest was not found");W=H.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,w.asJson)(M),H=[],re={};if(W){for(const se of W.malicious)H.push({id:se});if(W.unsupported)for(const se of Object.keys(W.unsupported)){const ue=W.unsupported[se];(0,b.isBoolean)(ue)||(re[se.toLowerCase()]=ue.preReleaseExtension)}if(W.migrateToPreRelease)for(const[se,ue]of Object.entries(W.migrateToPreRelease))(!ue.engine||(0,d.isEngineValid)(ue.engine,this.productService.version,this.productService.date))&&(re[se.toLowerCase()]=ue)}return{malicious:H,unsupportedPreReleaseExtensions:re}}};Z=he([G(1,w.IRequestService),G(2,v.ILogService),G(3,E.IEnvironmentService),G(4,c.ITelemetryService),G(5,h.IFileService),G(6,m.IProductService),G(7,D.IConfigurationService)],Z);let Y=class extends Z{constructor(M,W,H,re,se,ue,de,we){super(M,W,H,re,se,ue,de,we)}};Y=he([G(0,p.IStorageService),G(1,w.IRequestService),G(2,v.ILogService),G(3,E.IEnvironmentService),G(4,c.ITelemetryService),G(5,h.IFileService),G(6,m.IProductService),G(7,D.IConfigurationService)],Y),e.ExtensionGalleryService=Y;let q=class extends Z{constructor(M,W,H,re,se,ue,de){super(void 0,M,W,H,re,se,ue,de)}};q=he([G(0,w.IRequestService),G(1,v.ILogService),G(2,E.IEnvironmentService),G(3,c.ITelemetryService),G(4,h.IFileService),G(5,m.IProductService),G(6,D.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q}),define(te[94],ne([0,1,2,14,8,47]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(b,I,D=""){super();this.prefix=D;const E=b.getLogger(I.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,I){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,L.validateTelemetryData)(I))}};A=he([G(0,T.ILoggerService),G(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[95],ne([0,1,2,28,4,26,141,19,42,88,38,21,47]),function(K,e,k,n,T,L,A,P,b,I,D,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,w=v["common.machineId"],y=v["common.firstSessionDate"],p=v["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:y,msftInternal:p}}dispose(){this._disposables.dispose()}_log(v,m,w,y){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(p=>{w=(0,n.mixin)(w,p),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,c=>{if(typeof c=="string")return this._cleanupInfo(c,y)}),this._appenders.forEach(c=>c.log(v,w))},p=>{console.error(p)})}publicLog(v,m,w){return this._log(v,3,m,w)}publicLog2(v,m,w){return this.publicLog(v,m,w)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const w=[];for(let r of this._cleanupPatterns)for(;;){const l=r.exec(v);if(!l)break;w.push([l.index,r.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(m="";;){const r=p.exec(v);if(!r)break;!y.test(r[0])&&w.every(([l,i])=>r.index<l||r.index>=i)&&(m+=v.substring(c,r.index)+"<REDACTED: user-file-path>",c=p.lastIndex)}return c<v.length&&(m+=v.substr(c)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,p=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":p.test(m)?"<REDACTED: token>":v}_cleanupInfo(v,m){let w=v;m&&(w=this._anonymizeFilePaths(w));for(let y of this._cleanupPatterns)w=w.replace(y,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=he([G(1,P.IConfigurationService)],S),e.TelemetryService=S;function d(){const h=(0,A.localize)(0,null,I.default.nameLong),v=I.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=T.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),y=(0,A.localize)(5,null),p=(0,A.localize)(6,null),c=(0,A.localize)(7,null),r=`
|       | ${w} | ${y} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,A.localize)(8,null);return`
${h} ${v} ${m}

&nbsp;

${c}
${r}

&nbsp;

${l}
`}D.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),D.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,A.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,A.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[208],ne([0,1,9,28,47]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(P){const b=await new Promise((D,E)=>{K(["applicationinsights"],D,E)});let I;return b.defaultClient?(I=new b.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(b.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=b.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),I}class A{constructor(b,I,D){this._eventPrefix=b,this._defaultData=I,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(I=>{b(I)},I=>{(0,k.onUnexpectedError)(I),console.error(I)})}}log(b,I){if(!!this._aiClient){I=(0,n.mixin)(I,this._defaultData),I=(0,T.validateTelemetryData)(I);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+b,properties:I.properties,measurements:I.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(I=>{try{I.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[209],ne([0,1,18,58,19,14,8,21,93,94,95]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(S,d,h,v){this.configurationService=S,this.telemetryService=d,this.loggerService=h,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(S){if(!this.customTelemetryServices.has(S.id)){const{machineId:d,sessionId:h}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=d,v["common.vscodesessionid"]=h;const m=[S.id,JSON.stringify(v),S.aiKey],y=new n.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=[new b.TelemetryAppenderClient(y),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${S.id}] `)];this.customTelemetryServices.set(S.id,new D.TelemetryService({appenders:p,sendErrorTelemetry:S.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(S.id)}async publicLog(S,d,h){await(await this.getCustomTelemetryService(S)).publicLog(d,h)}async publicLogError(S,d,h){await(await this.getCustomTelemetryService(S)).publicLogError(d,h)}};E=he([G(0,T.IConfigurationService),G(1,P.ITelemetryService),G(2,A.ILoggerService),G(3,L.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[210],ne([0,1,5,25,3,2,8]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(I,D){super();this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new T.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((D,E)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,D),this._onCreateRequest.fire({requestId:g,...I});const S=new n.CancellationTokenSource;(0,k.timeout)(this._timeout,S.token).then(()=>E(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,L.toDisposable)(()=>S.cancel())])})}acceptReply(I,D){const E=this._pendingRequests.get(I);E?(this._pendingRequests.delete(I),(0,L.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),E(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};P=he([G(1,A.ILogService)],P),e.RequestStore=P}),define(te[96],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var T;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",h.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",h.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(T=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var b;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var D;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(D=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(h){h.TerminalView="view",h.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(g=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var d;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(d=e.ProfileSource||(e.ProfileSource={}))}),define(te[211],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[212],ne([0,1,45,10,143,25,37,9,4,29,124,151,5]),function(K,e,k,n,T,L,A,P,b,I,D,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let d;async function h(m,w,y){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(y)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=g.Promises.withAsyncBody(async(p,c)=>{const r=new L.CancellationTokenSource,l=setTimeout(()=>{r.dispose(!0),c(new Error((0,T.localize)(0,null)))},S);try{p(await v(m,r.token))}catch(i){!(0,P.isCancellationError)(i)&&!r.token.isCancellationRequested?c(new Error((0,T.localize)(1,null,(0,A.toErrorMessage)(i)))):p({})}finally{clearTimeout(l),r.dispose()}})),d)}e.getResolvedShellEnv=h;async function v(m,w){const y=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",y);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",p);const c=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",l);const i=await(0,D.getSystemShell)(b.OS,l);return m.trace("getUnixShellEnvironment#shell",i),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,P.canceled)());const s=(0,n.basename)(i);let a,u;const f=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${f} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${f} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s==="tcsh"?u=["-ic"]:u=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const C=(0,k.spawn)(i,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});w.onCancellationRequested(()=>(C.kill(),o((0,P.canceled)()))),C.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),o(F)});const _=[];C.stdout.on("data",F=>_.push(F));const O=[];C.stderr.on("data",F=>O.push(F)),C.on("close",(F,R)=>{const N=Buffer.concat(_).toString("utf8");m.trace("getUnixShellEnvironment#raw",N);const $=Buffer.concat(O).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),F||R)return o(new Error((0,T.localize)(2,null,F,R)));const j=r.exec(N),X=j?j[1]:"{}";try{const z=JSON.parse(X);y?z.ELECTRON_RUN_AS_NODE=y:delete z.ELECTRON_RUN_AS_NODE,p?z.ELECTRON_NO_ATTACH_CONSOLE=p:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",z),t(z)}catch(z){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(z)),o(z)}})})}}),define(te[213],ne([0,1,34,18,28,10,4,33,26,11,22]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let c=0;return p&&p.length===4&&(c=parseInt(p[3])),c}e.getWindowsBuildNumber=E;async function g(p,c,r,l=P.env,i=D.Promises.exists){if(L.isAbsolute(p))return await i(p)?p:void 0;if(c===void 0&&(c=P.cwd()),L.dirname(p)!=="."){const a=L.join(c,p);return await i(a)?a:void 0}const o=(0,T.getCaseInsensitive)(l,"PATH");if(r===void 0&&(0,I.isString)(o)&&(r=o.split(L.delimiter)),r===void 0||r.length===0){const a=L.join(c,p);return await i(a)?a:void 0}for(let a of r){let u;if(L.isAbsolute(a)?u=L.join(a,p):u=L.join(c,a,p),await i(u))return u;if(A.isWindows){let f=u+".com";if(await i(f)||(f=u+".exe",await i(f)))return f}}const s=L.join(c,p);return await i(s)?s:void 0}e.findExecutable=g;function S(p,c){if(!c.enabled||!p.executable||p.isFeatureTerminal)return;const r=p.args,l=P.platform==="win32"?L.basename(p.executable).toLowerCase():L.basename(p.executable),i=L.dirname(n.FileAccess.asFileUri("",K).fsPath);let t;if(A.isWindows){if(l==="pwsh.exe"){if(!r||w(r)?t=e.shellIntegrationArgs.get(d.WindowsPwsh):m(r)&&(t=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),!t)return;if(t){const s=c.showWelcome?"":" -HideWelcome";t=[...t],t[t.length-1]=(0,b.format)(t[t.length-1],i,s)}return{newArgs:t}}return}const o={};switch(l){case"bash":return!r||r.length===0?t=e.shellIntegrationArgs.get(d.Bash):y(r)&&(o.VSCODE_SHELL_LOGIN="1",t=e.shellIntegrationArgs.get(d.Bash)),t?(t=[...t],t[t.length-1]=(0,b.format)(t[t.length-1],i),c.showWelcome||(o.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:o}):void 0;case"pwsh":{if(!r||w(r)?t=e.shellIntegrationArgs.get(d.Pwsh):m(r)&&(t=e.shellIntegrationArgs.get(d.PwshLogin)),!t)return;const s=c.showWelcome?"":" -HideWelcome";return t=[...t],t[t.length-1]=(0,b.format)(t[t.length-1],i,s),{newArgs:t}}case"zsh":{if(!r||r.length===0?t=e.shellIntegrationArgs.get(d.Zsh):y(r)?t=e.shellIntegrationArgs.get(d.ZshLogin):(r===e.shellIntegrationArgs.get(d.Zsh)||r===e.shellIntegrationArgs.get(d.ZshLogin))&&(t=r),!t)return;t=[...t],t[t.length-1]=(0,b.format)(t[t.length-1],i);const s=L.join(k.tmpdir(),"vscode-zsh");o.ZDOTDIR=s;const a=[];return a.push({source:L.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration.zsh"),dest:L.join(s,".zshrc")}),c.showWelcome||(o.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:o,filesToCopy:a}}}}e.getShellIntegrationInjection=S;var d;(function(p){p.WindowsPwsh="windows-pwsh",p.WindowsPwshLogin="windows-pwsh-login",p.Pwsh="pwsh",p.PwshLogin="pwsh-login",p.Zsh="zsh",p.ZshLogin="zsh-login",p.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const h=["-login","-l"],v=["-nol","-nologo"];function m(p){return typeof p=="string"?h.includes(p.toLowerCase()):p.length===1&&h.includes(p[0].toLowerCase())||p.length===2&&(h.includes(p[0].toLowerCase())||h.includes(p[1].toLowerCase()))&&(v.includes(p[0].toLowerCase())||v.includes(p[1].toLowerCase()))}function w(p){return typeof p=="string"?v.includes(p.toLowerCase()):p.length===0||p?.length===1&&v.includes(p[0].toLowerCase())}function y(p){return p==="string"&&h.includes(p.toLowerCase())||typeof p!="string"&&p.length===1&&h.includes(p[0].toLowerCase())}}),define(te[214],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,48,3,2,6,38,214]),function(K,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var b;(function(v){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=m})(b=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var D;(function(v){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}v.isThemeIcon=m;const w=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function y(t){const o=w.exec(t);if(!o)return;let[,s]=o;return{id:s}}v.fromString=y;function p(t){return{id:t}}v.fromId=p;function c(t,o){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}v.modify=c;function r(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}v.getModifier=r;function l(t,o){return t.id===o.id&&t.color?.id===o.color?.id}v.isEqual=l;function i(t,o){return{id:t.id,color:o?I(o):void 0}}v.asThemeIcon=i,v.asClassNameArray=k.CSSIcon.asClassNameArray,v.asClassName=k.CSSIcon.asClassName,v.asCSSSelector=k.CSSIcon.asCSSSelector})(D=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(v){switch(v){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,T.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new g;A.Registry.add(e.Extensions.ThemingContribution,S);function d(v){return S.onColorThemeChange(v)}e.registerThemingParticipant=d;class h extends T.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let y=this.theme.getColor(m);return y&&w&&(y=w(y,this.theme)),y?y.toString():null}}e.Themable=h}),define(te[215],ne([0,1,48,7,97]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(E,g){const S=E.map(d=>({name:d.profileName,description:A(d)}));return g&&S.push(...g.map(d=>({name:d.title,description:P(d)}))),{values:S.map(d=>d.name),markdownDescriptions:S.map(d=>d.description)}}e.createProfileSchemaEnums=L;function A(E){let g=`$(${T.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?g+=`
- args: "${E.args}"`:g+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(g+=`
- overrideName: ${E.overrideName}`),E.color&&(g+=`
- color: ${E.color}`),E.env&&(g+=`
- env: ${JSON.stringify(E.env)}`),g}function P(E){return`$(${T.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function b(E,g){if(!E&&!g)return!0;if(typeof E=="string"&&typeof g=="string")return E===g;if(Array.isArray(E)&&Array.isArray(g)){if(E.length!==g.length)return!1;for(let S=0;S<E.length;S++)if(E[S]!==g[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function I(E,g){if(!E&&!g)return!0;if(!E||!g)return!1;if(T.ThemeIcon.isThemeIcon(E)&&T.ThemeIcon.isThemeIcon(g))return E.id===g.id&&E.color===g.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof g=="object"&&g&&"light"in g&&"dark"in g){const S=E,d=g;if((n.URI.isUri(S.light)||D(S.light))&&(n.URI.isUri(S.dark)||D(S.dark))&&(n.URI.isUri(d.light)||D(d.light))&&(n.URI.isUri(d.dark)||D(d.dark)))return S.light.path===d.light.path&&S.dark.path===d.dark.path}if(n.URI.isUri(E)&&n.URI.isUri(g)||D(E)||D(g)){const S=E,d=g;return S.path===d.path&&S.scheme===d.scheme}return!1}e.terminalIconsEqual=I;function D(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=D}),define(te[216],ne([0,1,48,142,42,38,215]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),p=>p.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),p=>`$(${p.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},I={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...P}},D=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...P}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...P}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...P}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){L.Registry.as(T.Extensions.Configuration).registerConfiguration(v),y()}e.registerTerminalPlatformConfiguration=m;let w;function y(p,c){const r=L.Registry.as(T.Extensions.Configuration);let l;p&&(l=(0,A.createProfileSchemaEnums)(p?.profiles,c));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:p?.os===3?l?.values:void 0,markdownEnumDescriptions:p?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:p?.os===2?l?.values:void 0,markdownEnumDescriptions:p?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:p?.os===1?l?.values:void 0,markdownEnumDescriptions:p?.os===1?l?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(te[217],ne([0,1,45,48,10,4,22,73,213,97]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D,E=!0;function g(l,i,t,o,s=process.env,a,u,f,C){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?S(t,a,s,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),C,f):p(a,u,t,l&&typeof l=="object"?{...l}:o.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),C,f,s)}e.detectAvailableProfiles=g;async function S(l,i,t,o,s,a,u,f,C){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await v(f);const R=new Map;l&&(R.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),R.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),R.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),c(a,R);const N=await d(R.entries(),u,i,t,o,C);if(l||!l&&s)try{const $=await w(`${O}\\${F?"wsl":"bash"}.exe`,u);for(const j of $)(!a||!(j.profileName in a))&&N.push(j)}catch{E&&(o?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return N}async function d(l,i,t,o=process.env,s,a){const u=[];for(const[f,C]of l){if(C===null)continue;let _,O,F;if("source"in C){const $=D?.get(C.source);if(!$)continue;_=$.paths,O=C.args||$.args,C.icon?F=h(C.icon):$.icon&&(F=$.icon)}else _=Array.isArray(C.path)?C.path:[C.path],O=L.isWindows||Array.isArray(C.args)?C.args:void 0,F=h(C.icon);const R=await a?.(_)||_.slice(),N=await r(f,i,R,t,o,O,C.env,C.overrideName,C.isAutoDetected,s);N?(N.isAutoDetected=C.isAutoDetected,N.icon=F,N.color=C.color,u.push(N)):s?.trace("profile not validated",f,_)}return u}function h(l){return typeof l=="string"?{id:l}:l}async function v(l){D&&!l||(D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),D.set("PowerShell",{profileName:"PowerShell",paths:l||await m(),icon:I.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function m(){const l=[];for await(const i of(0,P.enumeratePowerShellInstallations)())l.push(i.exePath);return l}async function w(l,i){const t=[],o=await new Promise((u,f)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,_)=>{if(C)return f("Problem occurred when getting wsl distros");u(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),a=o.split(s).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const f=`${u} (WSL)`,C={profileName:f,path:l,args:["-d",`${u}`],isDefault:f===i,icon:y(u),isAutoDetected:!1};t.push(C)}return t}function y(l){return l.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):l.includes("Debian")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function p(l,i,t,o,s,a,u,f){const C=new Map;if(t){const _=(await l.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),F=new Map;for(const R of O){let N=(0,T.basename)(R),$=F.get(N)||0;$++,$>1&&(N=`${N} (${$})`),F.set(N,$),C.set(N,{path:R,isAutoDetected:!0})}}return c(o,C),await d(C.entries(),s,l,f,i,u)}function c(l,i){if(!!l)for(const[t,o]of Object.entries(l))o===null||!("path"in o)&&!("source"in o)?i.delete(t):(o.icon=o.icon||i.get(t)?.icon,i.set(t,o))}async function r(l,i,t,o,s,a,u,f,C,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(l,i,t,o,s,a,u,f,C);const F={profileName:l,path:O,args:a,env:u,overrideName:f,isAutoDetected:C,isDefault:l===i};if((0,T.basename)(O)===O){const N=s.PATH?s.PATH.split(T.delimiter):void 0,$=await(0,b.findExecutable)(O,void 0,N,void 0,o.existsFile);return $?(F.path=$,F.isFromPath=!0,F):r(l,i,t,o,s,a)}return await o.existsFile((0,T.normalize)(O))?F:r(l,i,t,o,s,a,u,f,C)}}),define(te[218],ne([0,1,3,2,18,4,36,58,19,14,78,212,8,87,210,96,216,217]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let y=0,p=class extends n.Disposable{constructor(r,l,i,t){super();this._reconnectConstants=r,this._configurationService=l,this._environmentService=i,this._logService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:y,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},l=(0,D.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);l&&(l.break&&l.port?r.debugBrk=l.port:!l.break&&l.port&&(r.debug=l.port));const i=new P.Client(T.FileAccess.asFileUri("bootstrap-fork",K).fsPath,r);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=i.getChannel(h.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const s=A.ProxyChannel.toService(i.getChannel(h.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(a=>this._onProcessData.fire(a))),this._register(s.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(s.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(s.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(s.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(s.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(s.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,l,i,t,o,s,a,u,f,C,_){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),h.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(r,l,i,t,o,s,a,u,f,C,_);return clearTimeout(O),y=Math.max(y,F),F}updateTitle(r,l,i){return this._proxy.updateTitle(r,l,i)}updateIcon(r,l,i){return this._proxy.updateIcon(r,l,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,l){return this._proxy.shutdown(r,l)}input(r,l){return this._proxy.input(r,l)}processBinary(r,l){return this._proxy.processBinary(r,l)}resize(r,l,i){return this._proxy.resize(r,l,i)}acknowledgeDataEvent(r,l){return this._proxy.acknowledgeDataEvent(r,l)}setUnicodeVersion(r,l){return this._proxy.setUnicodeVersion(r,l)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,l){return this._proxy.installAutoReply(r,l)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,l,i,t=!1){const o=await this._shellEnv;return(0,m.detectAvailableProfiles)(l,i,t,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,l){return this._proxy.requestDetachInstance(r,l)}async acceptDetachInstanceReply(r,l){return this._proxy.acceptDetachInstanceReply(r,l)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,l){return this._proxy.reviveTerminalProcesses(r,l)}async refreshProperty(r,l){return this._proxy.refreshProperty(r,l)}async updateProperty(r,l,i){return this._proxy.updateProperty(r,l,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,l){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:l})}async acceptPtyHostResolvedVariables(r,l){this._resolveVariablesRequestStore.acceptReply(r,l)}};p=he([G(1,b.IConfigurationService),G(2,I.IEnvironmentService),G(3,g.ILogService)],p),e.PtyHostService=p}),define(te[64],ne([0,1,3,4,6,8]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=E;function g(d,h){return h?h!==1&&d<1024:!n.isWindows&&d<1024}e.isPortPrivileged=g;let S=class{constructor(h){this.logService=h,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],v=Array.from(this._tunnels.values());for(let m of v){const w=Array.from(m.values());for(let y of w){const p=await y.value;p&&h.push(p)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:v}of h.values())await v.then(m=>m?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,v,m,w,y=!1,p=P.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${m} on local port ${w}.`),!h)return;v||(v="localhost");const r=this.retainOrCreateTunnel(h,v,m,w,y,p,c);return r?r.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(l);return(l.tunnelRemoteHost!==v||l.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const v=this._tunnels.get(h.tunnelRemoteHost);if(v){const m=v.get(h.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,m))}}}}async tryDisposeTunnel(h,v,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${v}.`);const w=m.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(v),w}}async closeTunnel(h,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${v} `);const m=this._tunnels.get(h);if(m&&m.has(v)){const w=m.get(v);w.refcount=0,await this.tryDisposeTunnel(h,v,w)}}addTunnelToMap(h,v,m){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(v,{refcount:1,value:m})}async removeEmptyTunnelFromMap(h,v){const m=this._tunnels.get(h);m&&(await m.get(v)||m.delete(v),m.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,v){let m=[h];D(h)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(h)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(y=>this._tunnels.get(y));for(const y of w){const p=y?.get(v);if(p)return p}}canTunnel(h){return!!I(h)}createWithProvider(h,v,m,w,y,p,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${m} on local port ${w}.`);const l={elevationRequired:y?g(w===void 0?m:w):!1},i={remoteAddress:{host:v,port:m},localAddressPort:w,privacy:p,public:p!==P.Private,protocol:c},t=h.forwardPort(i,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,m,t),t}};S=he([G(0,L.ILogService)],S),e.AbstractTunnelService=S}),define(te[219],ne([0,1,8,64,2,9,5]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends T.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(D){this._address=D,this._addressPromise&&(this._addressPromise.complete(D),this._addressPromise=null)}setTunnel(D){this._register(D)}}let b=class yt extends T.Disposable{constructor(D,E){super();this._tunnelService=D,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(D=>D.dispose())}async createTunnel(){return{id:String(++yt._lastId)}}async startTunnel(D,E,g,S,d,h){const v=new P,m=await Promise.resolve(this._tunnelService.openTunnel(D,v,g,S,d,h));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${S} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await m.dispose(),(0,L.canceled)();return v.setTunnel(m),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${g}:${S} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(D,E){const g=this._tunnels.get(D);!g||g.setAddress(E)}async destroyTunnel(D){const E=this._tunnels.get(D);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${D}.`),this._tunnels.delete(D),await E.dispose();return}this._disposedTunnels.add(D)}};b._lastId=0,b=he([G(0,n.ISharedTunnelsService),G(1,k.ILogService)],b),e.SharedProcessTunnelService=b}),define(te[32],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[220],ne([0,1,3,2,7,14,31,15,8,32]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends n.Disposable{constructor(g,S,d,h,v){super();this.extensionsManagementService=g,this.logService=h,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(w=>this.onInstallExtension(w))),this._register(g.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(g.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=T.URI.file(d.extensionsPath);this._register(S.watch(m)),this._register(k.Event.filter(S.onDidFilesChange,w=>w.rawChanges.some(y=>this.doesChangeAffects(y,m)))(()=>this.onDidChange()))}doesChangeAffects(g,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),S)?this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(g.type!==1&&g.type!==2||this.uriIdentityService.extUri.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const S of g)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(S=>!(0,A.areSameExtensions)(S,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,A.areSameExtensions)(S,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),S=g.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,A.areSameExtensions)(v,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),d=this.installedExtensions.filter(h=>this.installingExtensions.some(v=>(0,A.areSameExtensions)(v,h))?!1:g.every(v=>!(0,A.areSameExtensions)(v.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=g.map(h=>h.identifier),(S.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:d})}}};D=he([G(1,P.IFileService),G(2,L.INativeEnvironmentService),G(3,b.ILogService),G(4,I.IUriIdentityService)],D),e.ExtensionsWatcher=D}),define(te[221],ne([0,1,32,80,15,20,104,3,2]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(g){this.uri=g,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let D=class{constructor(g){this._fileService=g,this._dispooables=new b.DisposableStore,this._limit=2**16;const S=new Map,d=h=>{let v=S.get(h.scheme);return v===void 0&&(v=g.hasProvider(h)&&!this._fileService.hasCapability(h,1024),S.set(h.scheme,v)),v};this._dispooables.add(P.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(h=>{S.delete(h.scheme)})),this.extUri=new L.ExtUri(d),this._canonicalUris=new A.SkipList((h,v)=>this.extUri.compare(h,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,L.normalizePath)(g));let S=this._canonicalUris.get(g);return S?S.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new I(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((d,h)=>d[1].touch<h[1].touch?1:d[1].touch>h[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let d=0;d<S;d++)this._canonicalUris.set(g[d][0],g[d][1].touch())}};D=he([G(0,T.IFileService)],D),e.UriIdentityService=D,(0,n.registerSingleton)(k.IUriIdentityService,D,!0)}),define(te[222],ne([0,1,3,2,40,39,17]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{constructor(I,D,E,g){super();this.fileSystemScheme=I,this.fileSystemProvider=D,this.userDataScheme=E,this.logService=g,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(S=>this.handleFileChanges(S)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(I,D){this.watchResources.set(I,I);const E=this.fileSystemProvider.watch(this.toFileSystemResource(I),D);return(0,n.toDisposable)(()=>{this.watchResources.delete(I),E.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,D,E){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(D),E)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,D,E){const g=(0,T.newWriteableStream)(S=>A.VSBuffer.concat(S.map(d=>A.VSBuffer.wrap(d))).buffer);return(async()=>{try{const S=await this.readFile(I);g.end(S)}catch(S){g.error(S),g.end()}})(),g}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,D,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),D,E)}delete(I,D){return this.fileSystemProvider.delete(this.toFileSystemResource(I),D)}handleFileChanges(I){const D=[];for(const E of I){if(E.resource.scheme!==this.fileSystemScheme)continue;const g=this.toUserDataResource(E.resource);this.watchResources.findSubstr(g)&&D.push({resource:g,type:E.type})}D.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(D))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(te[53],ne([0,1,70]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,P,b,I){const D=(0,k.setProperty)(A,P,b,I)[0];return D&&(A=A.substring(0,D.offset)+D.content+A.substring(D.offset+D.length)),A}e.edit=n;function T(A,P,b){let I=b;for(;I>=0;){if(A.charAt(I)===P.charAt(P.length-1)&&P.length===1)return I+1;if(I--,P.length===2&&I>=0&&A.charAt(I)===P.charAt(0))return I+2}return 0}e.getLineStartOffset=T;function L(A,P,b){let I=b;for(;I>=0;)if(A.charAt(I)===P.charAt(P.length-1)&&P.length===1||(I++,P.length===2&&I>=0&&A.charAt(I)===P.charAt(1)))return I;return A.length-1}e.getLineEndOffset=L}),define(te[223],ne([0,1,28,62,11]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(g,S,d,h,v){const m=[],w=[],y=[];if(!S){const O=g.filter(({identifier:F})=>v.every(R=>R.toLowerCase()!==F.id.toLowerCase()));return{local:{added:m,removed:w,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}g=g.map(D),S=S.map(D),d=d?d.map(D):null;const p=new Map,c=O=>{O.uuid&&p.set(O.id.toLowerCase(),O.uuid)};g.forEach(({identifier:O})=>c(O)),S.forEach(({identifier:O})=>c(O)),d&&d.forEach(({identifier:O})=>c(O));const r=O=>{const F=O.identifier.uuid||p.get(O.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${O.identifier.id.toLowerCase()}`},l=(O,F)=>(O.set(r(F),F),O),i=g.reduce(l,new Map),t=S.reduce(l,new Map),o=S.reduce((O,F)=>{const R=r(F);F=(0,k.deepClone)(F);const N=i.get(R);return N&&(N.installed&&(F.installed=!0),F.version||(F.version=N.version)),l(O,F)},new Map),s=d?d.reduce(l,new Map):null,a=h.reduce(l,new Map),u=v.reduce((O,F)=>{const R=p.get(F.toLowerCase());return O.add(R?`uuid:${R}`:`id:${F.toLowerCase()}`)},new Set),f=A(i,t,u);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const O=A(s,i,u),F=A(s,t,u),R=(N,$)=>{const j=i.get(N);if(j){const X=t.get(N),z=$?X:j;return{...z,version:X.version&&(!j.installed||n.gt(X.version,j.version))?X.version:j.version,state:P(j,X,s?.get(N)),preRelease:(0,T.isUndefined)(z.preRelease)?j.preRelease:j.installed?z.preRelease:X.preRelease}}};for(const N of F.removed.values()){const $=i.get(N);$&&w.push($.identifier)}for(const N of F.added.values())if(O.added.has(N)){if(f.updated.has(N)){const $=R(N,!0);$&&(y.push(E($,N)),o.set(N,$))}}else{const $=t.get(N);$.installed&&m.push(E($,N))}for(const N of F.updated.values()){const $=R(N,!0);$&&(y.push(E($,N)),o.set(N,$))}for(const N of O.added.values())F.added.has(N)||o.set(N,i.get(N));for(const N of O.updated.values())if(!F.removed.has(N)&&!F.updated.has(N)){const $=R(N,!1);$&&(o.get(N)?.installed&&($.installed=!0),o.set(N,$))}for(const N of O.removed.values())!a.has(N)&&!F.updated.has(N)&&s?.get(N)?.installed&&o.delete(N)}const C=[],_=A(t,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,F)=>C.push(E(O,F))),{local:{added:m,removed:w,updated:y},remote:C.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:C}:null}}e.merge=L;function A(g,S,d,{checkInstalledProperty:h,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=g?[...g.keys()].filter(r=>!d.has(r)):[],w=[...S.keys()].filter(r=>!d.has(r)),y=w.filter(r=>m.indexOf(r)===-1).reduce((r,l)=>(r.add(l),r),new Set),p=m.filter(r=>w.indexOf(r)===-1).reduce((r,l)=>(r.add(l),r),new Set),c=new Set;for(const r of m){if(p.has(r))continue;const l=g.get(r),i=S.get(r);(!i||l.disabled!==i.disabled||l.installed&&i.installed&&l.preRelease!==i.preRelease||!I(l.state,i.state)||v&&l.version!==i.version||h&&l.installed!==i.installed)&&c.add(r)}return{added:y,removed:p,updated:c}}function P(g,S,d){const h=g.state,v=S.state,m=d?.state;if(!S.version||h&&n.gt(g.version,S.version))return h;if(v&&n.gt(S.version,g.version)||!h)return v;if(!v)return h;const w=(0,k.deepClone)(h),y=m?b(m,v):{added:Object.keys(v).reduce((c,r)=>(c.add(r),c),new Set),removed:new Set,updated:new Set},p=m?b(m,h):{added:Object.keys(h).reduce((c,r)=>(c.add(r),c),new Set),removed:new Set,updated:new Set};for(const c of[...y.added.values(),...y.updated.values()])w[c]=v[c];for(const c of y.removed.values())p.updated.has(c)||delete w[c];return w}function b(g,S){const d=Object.keys(g),h=Object.keys(S),v=h.filter(y=>d.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),m=d.filter(y=>h.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),w=new Set;for(const y of d){if(m.has(y))continue;const p=g[y],c=S[y];(0,k.equals)(p,c)||w.add(y)}return{added:v,removed:m,updated:w}}function I(g={},S={}){const{added:d,removed:h,updated:v}=b(g,S);return d.size===0&&h.size===0&&v.size===0}function D(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function E(g,S){const d={identifier:{id:g.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!g.preRelease};return g.version&&(d.version=g.version),g.disabled&&(d.disabled=!0),g.installed&&(d.installed=!0),g.state&&(d.state=g.state),d}}),define(te[98],ne([0,1,16,19,6]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,b){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return I=I.filter(D=>D!==P&&D!==`-${P}`),b&&I.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}updateSynchronizedExtensions(P,b){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return I=I.filter(D=>D!==P&&D!==`-${P}`),b&&I.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}getIgnoredExtensions(P){const b=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),D=[],E=[];if(Array.isArray(I))for(const g of I)g.startsWith("-")?E.push(g.substring(1)):D.push(g);return(0,k.distinct)([...b,...D].filter(g=>E.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};L=he([G(0,n.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(te[224],ne([0,1,16,35,28,159,53]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(p){return(0,n.parse)(p)||[]}e.parseKeybindings=P;async function b(p,c,r,l,i){const t=P(p),o=P(c),s=r?P(r):null,a=[...t,...o,...s||[]].map(X=>X.key),u=await i.resolveUserBindings(a);let f=D(t,o,s,u);if(!f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!f.hasLocalForwarded&&f.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const C=g(t),_=g(o),O=s?g(s):null,F=d(C,_,u),R=O?d(O,C,u):{added:[...C.keys()].reduce((X,z)=>(X.add(z),X),new Set),removed:new Set,updated:new Set},N=O?d(O,_,u):{added:[..._.keys()].reduce((X,z)=>(X.add(z),X),new Set),removed:new Set,updated:new Set},$=I(F,R,N);let j=p;for(const X of $.removed.values())$.conflicts.has(X)||(j=w(j,X,l));for(const X of $.added.values()){if($.conflicts.has(X))continue;const z=_.get(X);if(z.some(J=>J.command!==`-${X}`&&f.conflicts.has(u[J.key]))){$.conflicts.add(X);continue}j=m(j,z,l)}for(const X of $.updated.values()){if($.conflicts.has(X))continue;const z=_.get(X);if(z.some(J=>J.command!==`-${X}`&&f.conflicts.has(u[J.key]))){$.conflicts.add(X);continue}j=y(j,X,z,l)}return{mergeContent:j,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=b;function I(p,c,r){const l=new Set,i=new Set,t=new Set,o=new Set;for(const s of c.removed.values())r.updated.has(s)&&o.add(s);for(const s of r.removed.values())o.has(s)||(c.updated.has(s)?o.add(s):i.add(s));for(const s of c.added.values())o.has(s)||r.added.has(s)&&p.updated.has(s)&&o.add(s);for(const s of r.added.values())o.has(s)||(c.added.has(s)?p.updated.has(s)&&o.add(s):l.add(s));for(const s of c.updated.values())o.has(s)||r.updated.has(s)&&p.updated.has(s)&&o.add(s);for(const s of r.updated.values())o.has(s)||(c.updated.has(s)?p.updated.has(s)&&o.add(s):t.add(s));return{added:l,removed:i,updated:t,conflicts:o}}function D(p,c,r,l){const i=new Set,t=E(p,l),o=E(c,l),s=r?E(r,l):null,a=S(t,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const u=s?S(s,t):{added:[...t.keys()].reduce((R,N)=>(R.add(N),R),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const f=s?S(s,o):{added:[...o.keys()].reduce((R,N)=>(R.add(N),R),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:C,removed:_,updated:O,conflicts:F}=I(a,u,f);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:_,updated:O,conflicts:F}}function E(p,c){const r=new Map;for(const l of p){const i=c[l.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(l)}return r}function g(p){const c=new Map;for(const r of p){const l=r.command[0]==="-"?r.command.substring(1):r.command;let i=c.get(l);i||(i=[],c.set(l,i)),i.push(r)}return c}function S(p,c){const r=[...p.keys()],l=[...c.keys()],i=l.filter(s=>r.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),t=r.filter(s=>l.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),o=new Set;for(const s of r){if(t.has(s))continue;const a=p.get(s).map(f=>({...f,key:s})),u=c.get(s).map(f=>({...f,key:s}));(0,k.equals)(a,u,(f,C)=>v(f,C))||o.add(s)}return{added:i,removed:t,updated:o}}function d(p,c,r){const l=[...p.keys()],i=[...c.keys()],t=i.filter(a=>l.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=l.filter(a=>i.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),s=new Set;for(const a of l){if(o.has(a))continue;const u=p.get(a).map(C=>({...C,key:r[C.key]})),f=c.get(a).map(C=>({...C,key:r[C.key]}));h(u,f)||s.add(a)}return{added:t,removed:o,updated:s}}function h(p,c){return!(!(0,k.equals)(p.filter(({command:r})=>r[0]!=="-"),c.filter(({command:r})=>r[0]!=="-"),(r,l)=>v(r,l))||!(0,k.equals)(p.filter(({command:r})=>r[0]==="-"),c.filter(({command:r})=>r[0]==="-"),(r,l)=>v(r,l)))}function v(p,c){if(p.command!==c.command||p.key!==c.key)return!1;const r=L.ContextKeyExpr.deserialize(p.when),l=L.ContextKeyExpr.deserialize(c.when);return!(r&&!l||!r&&l||r&&l&&!r.equals(l)||!T.equals(p.args,c.args))}function m(p,c,r){for(const l of c)p=A.edit(p,[-1],l,r);return p}function w(p,c,r){const l=P(p);for(let i=l.length-1;i>=0;i--)(l[i].command===c||l[i].command===`-${c}`)&&(p=A.edit(p,[i],void 0,r));return p}function y(p,c,r,l){const i=P(p),t=i.findIndex(o=>o.command===c||o.command===`-${c}`);for(let o=i.length-1;o>=0;o--)(i[o].command===c||i[o].command===`-${c}`)&&(p=A.edit(p,[o],void 0,l));for(let o=r.length-1;o>=0;o--)p=A.edit(p,[t],r[o],l);return p}}),define(te[225],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(L,A,P){const b={},I={},D=new Set;if(!A)return{local:{added:b,updated:I,removed:[...D.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=n(L,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:I,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=n(P,L),S=n(P,A),d={},h={},v=new Set,m=new Set;for(const w of g.removed.values())S.updated.has(w)?b[w]=A[w]:v.add(w);for(const w of S.removed.values())m.has(w)||(g.updated.has(w)?m.add(w):D.add(w));for(const w of g.updated.values())m.has(w)||(S.updated.has(w)?E.updated.has(w)&&m.add(w):h[w]=L[w]);for(const w of S.updated.values())m.has(w)||(g.updated.has(w)?E.updated.has(w)&&m.add(w):L[w]!==void 0&&(I[w]=A[w]));for(const w of g.added.values())m.has(w)||(S.added.has(w)?E.updated.has(w)&&m.add(w):d[w]=L[w]);for(const w of S.added.values())m.has(w)||(g.added.has(w)?E.updated.has(w)&&m.add(w):b[w]=A[w]);return{local:{added:b,removed:[...D.values()],updated:I},remote:{added:d,removed:[...v.values()],updated:h},conflicts:[...m.values()]}}e.merge=k;function n(L,A){const P=L?Object.keys(L):[],b=A?Object.keys(A):[],I=b.filter(g=>P.indexOf(g)===-1).reduce((g,S)=>(g.add(S),g),new Set),D=P.filter(g=>b.indexOf(g)===-1).reduce((g,S)=>(g.add(S),g),new Set),E=new Set;for(const g of P){if(D.has(g))continue;const S=L[g],d=A[g];S!==d&&E.add(g)}return{added:I,removed:D,updated:E}}function T(L,A){const{added:P,removed:b,updated:I}=n(L,A);return P.size===0&&b.size===0&&I.size===0}e.areSame=T}),define(te[24],ne([0,1,16,20,11,148,42,30,6,89,38]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function g(){const s=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(C=>!!s[C].ignoreSync),u=Object.keys(s).filter(C=>s[C].scope===2||s[C].scope===6),f=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...u,...f])}e.getDefaultIgnoredSettings=g,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const s="vscode://schemas/ignoredSettings",a=D.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=D.Registry.as(I.Extensions.JSONContribution),f=()=>{const C=E(),_=g().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(N=>_.indexOf(N)===-1),F=_.filter(N=>C.indexOf(N)===-1),R={items:{type:"string",enum:[...O,...F.map(N=>`-${N}`)]}};u.registerSchema(s,R)};return a.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=S;function d(s){return s&&(0,T.isObject)(s)&&(0,T.isString)(s.id)&&(0,T.isArray)(s.scopes)}e.isAuthenticationProvider=d;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function v(s,a,u){return u.joinPath(a.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=m;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(a,u,f,C){super(a);this.code=u,this.resource=f,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class p extends y{constructor(a,u,f,C,_){super(a,f,void 0,_);this.url=u,this.serverCode=C}}e.UserDataSyncStoreError=p;class c extends y{constructor(a,u){super(a,u)}}e.UserDataAutoSyncError=c,function(s){function a(u){if(u instanceof s)return u;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(f&&f[1]){const C=f[2]==="unknown"?void 0:f[2],_=f[3]==="unknown"?void 0:f[3];return new s(u.message,f[1],C,_)}return new s(u.message,"Unknown")}s.toUserDataSyncError=a}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var l;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(l=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,a){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(a.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[44],ne([0,1,16,5,17,25,3,35,2,26,11,7,144,19,14,15,8,46,23,21,32,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=r;let l=class extends b.Disposable{constructor(a,u,f,C,_,O,F,R,N,$,j){super();this.resource=a,this.fileService=u,this.environmentService=f,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=F,this.telemetryService=R,this.logService=N,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(f.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(a,f,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(f,u,C)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const u=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,u={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),u)}async preview(a,u,f={}){return this._sync(a,!1,u,f)}async apply(a,u={}){try{this.syncHeaders={...u};const f=await this.doApply(a);return this.setStatus(f),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,u,f,C){try{if(this.syncHeaders={...C},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(F,O,u,f),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const u=await this.resolveContent(a);if(!u)return!1;const f=this.parseSyncData(u);if(!f)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const C=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,C),O=await this.isRemoteDataFromCurrentMachine(_),F=await this.generateSyncPreview({ref:_.ref,syncData:f},C,O,this.getUserDataSyncConfiguration(),L.CancellationToken.None),R=[];for(const N of F){const $=await this.getAcceptResult(N,N.remoteResource,void 0,L.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,L.CancellationToken.None);R.push([N,{...$,remoteChange:j!==0?j:2}])}await this.applyResult(_,C,R,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const u=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===u}async getLatestRemoteUserData(a,u){if(u){const f=a&&a.latest?a.latest[this.resource]:void 0;if(u.ref===f||f===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(a,u,f,C){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,g.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,u,f,C)}catch(_){if(_ instanceof c.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,u,f,C);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(a,u,f,C)}throw _}}async doSync(a,u,f,C){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,u,f,C,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":f?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async u=>{const f=await this.getMergeResult(u,L.CancellationToken.None);await this.fileService.writeFile(u.previewResource,T.VSBuffer.fromString(f?.content||""));const C=f&&!f.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,L.CancellationToken.None):void 0;return u.acceptResult=C,u.mergeState=f.hasConflicts?"conflict":C?"accepted":"preview",u.localChange=C?C.localChange:f.localChange,u.remoteChange=C?C.remoteChange:f.remoteChange,u}),this.syncPreviewPromise}async accept(a,u){return await this.updateSyncResourcePreview(a,async f=>{const C=await this.getAcceptResult(f,a,u,L.CancellationToken.None);return f.acceptResult=C,f.mergeState="accepted",f.localChange=C.localChange,f.remoteChange=C.remoteChange,f}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async u=>{const f=await this.getMergeResult(u,L.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,T.VSBuffer.fromString(f.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=f.localChange,u.remoteChange=f.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(a,u){if(!this.syncPreviewPromise)return;let f=await this.syncPreviewPromise;const C=f.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:F})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(F,a));C!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...f.resourcePreviews];return O[C]=await u(O[C]),{...f,resourcePreviews:O}}),f=await this.syncPreviewPromise,this.updateConflicts(f.resourcePreviews),f.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:f})=>f!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(f=>[f,f.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const u=a.filter(({mergeState:f})=>f==="conflict");(0,k.equals)(this._conflicts,u,(f,C)=>this.extUri.isEqual(f.previewResource,C.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:f})=>({created:u,uri:this.toRemoteBackupResource(f)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:f})=>({created:u,uri:this.toLocalBackupResource(f)}))}toRemoteBackupResource(a){return E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:f}=await this.getUserData(u);if(f)return this.parseSyncData(f)?.machineId}}async resolveContent(a){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:f}=await this.getUserData(u);return f}return this.extUri.isEqual(a,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(a){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const f of u.resourcePreviews){if(this.extUri.isEqual(f.acceptedResource,a))return f.acceptResult?f.acceptResult.content:null;if(this.extUri.isEqual(f.remoteResource,a))return f.remoteContent;if(this.extUri.isEqual(f.localResource,a))return f.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,u,f,C,_){const O=await this.isRemoteDataFromCurrentMachine(a),F=await this.generateSyncPreview(a,u,O,C,_),R=[];for(const N of F){const $=N.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(N.localChange===0&&N.remoteChange===0)R.push({...N,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=f?await this.getMergeResult(N,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(N.previewResource,T.VSBuffer.fromString(j?.content||""));const X=j&&!j.hasConflicts?await this.getAcceptResult(N,N.previewResource,void 0,_):void 0;R.push({...N,acceptResult:X,mergeState:j?.hasConflicts?"conflict":X?"accepted":"preview",localChange:X?X.localChange:j?j.localChange:N.localChange,remoteChange:X?X.remoteChange:j?j.remoteChange:N.remoteChange})}}return{remoteUserData:a,lastSyncUserData:u,resourcePreviews:R,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(a.value.toString()),f=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&f&&u.version!==f,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${f}.`),await this.resetLocal(),null;const C=u;if(C.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(C.content);if(r(_))return{...u,syncData:_,content:void 0}}catch(a){a instanceof h.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const f=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),C={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:f,...u};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(C)))}async getRemoteUserData(a){const{ref:u,content:f}=await this.getUserData(a);let C=null;return f!==null&&(C=this.parseSyncData(f)),{ref:u,syncData:C}}parseSyncData(a){try{const u=JSON.parse(a);if(r(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,g.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,D.isString)(a)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:u}}else{const u=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(a,u){const f=await this.currentMachineIdPromise,C={version:this.version,machineId:f,content:a};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(C),u,this.syncHeaders),{ref:u,syncData:C}}async backupLocal(a){const u={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};l=he([G(1,h.IFileService),G(2,d.IEnvironmentService),G(3,w.IStorageService),G(4,c.IUserDataSyncStoreService),G(5,c.IUserDataSyncBackupStoreService),G(6,c.IUserDataSyncEnablementService),G(7,y.ITelemetryService),G(8,c.IUserDataSyncLogService),G(9,S.IConfigurationService),G(10,p.IUriIdentityService)],l),e.AbstractSynchroniser=l;let i=class extends l{constructor(a,u,f,C,_,O,F,R,N,$,j,X){super(u,f,C,_,O,F,R,N,$,j,X);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,u,f){try{u?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(a),f?void 0:u):await this.fileService.createFile(this.file,T.VSBuffer.fromString(a),{overwrite:f})}catch(C){throw C instanceof h.FileOperationError&&C.fileOperationResult===1||C instanceof h.FileOperationError&&C.fileOperationResult===3?new c.UserDataSyncError(C.message,"LocalPreconditionFailed"):C}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};i=he([G(2,h.IFileService),G(3,d.IEnvironmentService),G(4,w.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncEnablementService),G(8,y.ITelemetryService),G(9,c.IUserDataSyncLogService),G(10,S.IConfigurationService),G(11,p.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(a,u,f,C,_,O,F,R,N,$,j,X,z){super(a,u,f,C,_,O,F,R,N,$,X,z);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(a){const u=[];return(0,P.parse)(a,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=he([G(2,h.IFileService),G(3,d.IEnvironmentService),G(4,w.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncEnablementService),G(8,y.ITelemetryService),G(9,c.IUserDataSyncLogService),G(10,c.IUserDataSyncUtilService),G(11,S.IConfigurationService),G(12,p.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(a,u,f,C,_){this.resource=a,this.environmentService=u,this.logService=f,this.fileService=C,this.extUri=_.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:a,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const f=this.parseSyncData(u);if(!!f)try{await this.doInitialize({ref:a,syncData:f})}catch(C){this.logService.error(C)}}parseSyncData(a){try{const u=JSON.parse(a);if(r(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,u={}){const f={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(f)))}};o=he([G(1,d.IEnvironmentService),G(2,v.ILogService),G(3,h.IFileService),G(4,p.IUriIdentityService)],o),e.AbstractInitializer=o}),define(te[226],ne([0,1,5,25,9,3,49,26,7,19,14,30,31,63,15,8,23,21,32,44,223,98,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function l(o,s){const a=JSON.parse(o.content);if(o.version===1||o.version===2){const u=(await s.getInstalled(0)).filter(f=>f.isBuiltin);for(const f of a)o.version===1&&(f.enabled===!1&&(f.disabled=!0),delete f.enabled),o.version===2&&u.every(C=>!(0,g.areSameExtensions)(C.identifier,f.identifier))&&(f.installed=!0)}return a}let i=class dt extends y.AbstractSynchroniser{constructor(s,a,u,f,C,_,O,F,R,N,$,j,X,z,J){super("extensions",a,s,u,f,C,j,X,R,$,J);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=N,this.extensionStorageService=z,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:x})=>!!x)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a){const u=s.syncData?await l(s.syncData,this.extensionManagementService):null,f=a?.skippedExtensions||[],C=a?.syncData?await l(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:R,remote:N}=(0,p.merge)(O,u,C,f,F),$={local:R,remote:N,content:this.getPreviewContent(O,R.added,R.updated,R.removed),localChange:R.added.length>0||R.removed.length>0||R.updated.length>0?2:0,remoteChange:N!==null?2:0};return[{skippedExtensions:f,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const a=s.syncData?await l(s.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),f=this.getLocalExtensions(u),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,p.merge)(f,a,a,s.skippedExtensions||[],C);return _!==null}getPreviewContent(s,a,u,f){const C=[...a,...u],_=new Set,O=F=>{_.add(F.id.toLowerCase()),F.uuid&&_.add(F.uuid)};C.forEach(({identifier:F})=>O(F)),f.forEach(O);for(const F of s)_.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&_.has(F.identifier.uuid)||C.push(F);return this.stringify(C,!1)}async getMergeResult(s,a){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,a,u,f){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(a,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(s){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),f=(0,p.merge)(s.localExtensions,null,null,s.skippedExtensions,u),{local:C,remote:_}=f;return{content:s.localContent,local:C,remote:_,localChange:C.added.length>0||C.removed.length>0||C.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),f=s.remoteContent?JSON.parse(s.remoteContent):null;if(f!==null){const C=(0,p.merge)(s.localExtensions,f,s.localExtensions,[],u),{local:_,remote:O}=C;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,a,u,f){let{skippedExtensions:C,localExtensions:_}=u[0][0],{local:O,remote:F,localChange:R,remoteChange:N}=u[0][1];if(R===0&&N===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),R!==0&&(await this.backupLocal(JSON.stringify(_)),C=await this.updateLocalExtensions(O.added,O.removed,O.updated,C)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const $=JSON.stringify(F.all);s=await this.updateRemoteUserData($,f?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(j=>j.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(j=>j.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(j=>j.identifier.id))}.`:""}`)}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:C}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${C.length?` Skipped: ${JSON.stringify(C.map($=>$.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:dt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,dt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),C=this.getLocalExtensions(u).filter(_=>!f.some(O=>(0,g.areSameExtensions)({id:O},_.identifier)));return this.stringify(C,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const u=await this.resolvePreviewContent(s);return u&&this.stringify(JSON.parse(u),!0)}let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const u=this.parseSyncData(a);if(u)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(s,a){return s.sort((u,f)=>!u.identifier.uuid&&f.identifier.uuid?-1:u.identifier.uuid&&!f.identifier.uuid?1:(0,P.compare)(u.identifier.id,f.identifier.id)),a?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,a,u,f){const C=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const R=O.filter(({identifier:N,isBuiltin:$})=>!$&&a.some(j=>(0,g.areSameExtensions)(N,j)));await k.Promises.settled(R.map(async N=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,N.identifier.id),await this.extensionManagementService.uninstall(N,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,N.identifier.id),C.push(N.identifier)}))}(s.length||u.length)&&await k.Promises.settled([...s,...u].map(async R=>{const N=O.find(j=>(0,g.areSameExtensions)(j.identifier,R.identifier));if(N&&N.isBuiltin){R.state&&N.manifest.version===R.version&&this.updateExtensionState(R.state,N,N.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(X=>(0,g.areSameExtensions)(X,R.identifier))!==!!R.disabled&&(R.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,R.identifier.id),await this.extensionEnablementService.disableExtension(R.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,R.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,R.identifier.id),await this.extensionEnablementService.enableExtension(R.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,R.identifier.id))),C.push(R.identifier);return}const $=(await this.extensionGalleryService.getExtensions([{...R.identifier,preRelease:R.preRelease}],n.CancellationToken.None))[0];if(R.state&&(N?N.manifest.version===R.version:!!$)&&this.updateExtensionState(R.state,N||$,N?.manifest.version),$)try{this.extensionEnablementService.getDisabledExtensions().some(X=>(0,g.areSameExtensions)(X,R.identifier))!==!!R.disabled&&(R.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,R.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,R.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,R.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,R.identifier.id,$.version))),(!N||N.preRelease!==R.preRelease)&&(await this.extensionManagementService.canInstall($)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,R.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:R.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,R.identifier.id,$.version),C.push($.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),_.push(R)))}catch(j){_.push(R),j instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id))}else _.push(R),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,R.identifier.id)}));const F=[];for(const R of f)C.some(N=>(0,g.areSameExtensions)(N,R.identifier))||F.push(R);for(const R of _)F.some(N=>(0,g.areSameExtensions)(N.identifier,R.identifier))||F.push(R);return F}updateExtensionState(s,a,u){const f=this.extensionStorageService.getExtensionState(a,!0)||{},C=u?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:u}):void 0;C?C.forEach(_=>{f[_]=s[_]}):Object.keys(s).forEach(_=>f[_]=s[_]),this.extensionStorageService.setExtensionState(a,f,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const a=this.extensionEnablementService.getDisabledExtensions();return s.map(u=>{const{identifier:f,isBuiltin:C,manifest:_,preRelease:O}=u,F={identifier:f,preRelease:O,version:_.version};a.some(R=>(0,g.areSameExtensions)(R,f))&&(F.disabled=!0),C||(F.installed=!0);try{const R=this.extensionStorageService.getKeysForSync({id:f.id,version:_.version});if(R){const N=this.extensionStorageService.getExtensionState(u,!0)||{};F.state=Object.keys(N).reduce(($,j)=>(R.includes(j)&&($[j]=N[j]),$),{})}}catch(R){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,T.getErrorMessage)(R))}return F})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=he([G(0,D.IEnvironmentService),G(1,d.IFileService),G(2,v.IStorageService),G(3,r.IUserDataSyncStoreService),G(4,r.IUserDataSyncBackupStoreService),G(5,E.IExtensionManagementService),G(6,E.IGlobalExtensionEnablementService),G(7,c.IIgnoredExtensionsManagementService),G(8,r.IUserDataSyncLogService),G(9,E.IExtensionGalleryService),G(10,I.IConfigurationService),G(11,r.IUserDataSyncEnablementService),G(12,m.ITelemetryService),G(13,S.IExtensionStorageService),G(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends y.AbstractInitializer{constructor(s,a,u,f,C,_){super("extensions",f,C,u,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=a}async parseExtensions(s){return s.syncData?await l(s.syncData,this.extensionManagementService):null}generatePreview(s,a){const u=[],f=[],C=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(F=>(0,g.areSameExtensions)(F.identifier,_.identifier));O?(u.push(O),_.disabled&&C.push(_.identifier)):_.installed&&(f.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&C.push(_.identifier))}return{installedExtensions:u,newExtensions:f,disabledExtensions:C,remoteExtensions:s}}};t=he([G(0,E.IExtensionManagementService),G(1,c.IIgnoredExtensionsManagementService),G(2,d.IFileService),G(3,D.IEnvironmentService),G(4,h.ILogService),G(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(te[227],ne([0,1,28,24]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(P,b,I,D,E){if(!b)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const g=L(P,b);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=I?L(I,b):{added:Object.keys(b).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},d=I?L(I,P):{added:Object.keys(P).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},v=k.deepClone(b),m=!I;for(const w of d.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&m&&S.added.has(w)||(v[w]=P[w]);for(const w of d.updated.values())v[w]=P[w];for(const w of d.removed.values())D.unregistered.includes(w)||delete v[w];for(const w of S.added.values()){const y=b[w];if(D.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(w))continue;const p=P[w];p&&p.value===y.value||w===n.SYNC_SERVICE_URL_TYPE&&m&&d.added.has(w)||(p?h.updated[w]=y:h.added[w]=y)}for(const w of S.updated.values()){const y=b[w];if(D.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(w)||d.removed.has(w))continue;const p=P[w];p&&p.value===y.value||(h.updated[w]=y)}for(const w of S.removed.values()){if(D.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}d.updated.has(w)||d.removed.has(w)||h.removed.push(w)}return{local:h,remote:A(v,b)?null:v}}e.merge=T;function L(P,b){const I=Object.keys(P),D=Object.keys(b),E=D.filter(d=>I.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),g=I.filter(d=>D.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),S=new Set;for(const d of I){if(g.has(d))continue;const h=P[d],v=b[d];k.equals(h,v)||S.add(d)}return{added:E,removed:g,updated:S}}function A(P,b){const{added:I,removed:D,updated:E}=L(P,b);return I.size===0&&D.size===0&&E.size===0}}),define(te[228],ne([0,1,17,9,3,35,49,4,7,29,19,14,15,8,46,23,21,32,44,53,227,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",l=["locale"];function i(u,f){const C=u.storage?Object.keys(u.storage).sort():[],_={};return C.forEach(O=>_[O]=u.storage[O]),u.storage=_,f?(0,A.toFormattedString)(u,{}):JSON.stringify(u)}const t=1;let o=class ft extends w.AbstractSynchroniser{constructor(f,C,_,O,F,R,N,$,j,X){super("globalState",f,F,j,C,_,R,N,O,$,X);this.storageService=j,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(f.onDidFilesChange,z=>z.contains(this.environmentService.argvResource)),T.Event.filter(j.onDidChangeValue,z=>z.scope===0&&z.target!==void 0?z.target===0:j.keys(0,0).includes(z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,C,_){const O=f.syncData?JSON.parse(f.syncData.content):null;C=C===null&&_?f:C;const F=C&&C.syncData?JSON.parse(C.syncData.content):null,R=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const N=this.getStorageKeys(F),{local:$,remote:j}=(0,p.merge)(R.storage,O?O.storage:null,F?F.storage:null,N,this.logService),X={content:null,local:$,remote:j,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i(R,!1),localUserData:R,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.acceptedResource,storageKeys:N}]}async hasRemoteChanged(f){const C=f.syncData?JSON.parse(f.syncData.content):null;if(C===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(C),{remote:F}=(0,p.merge)(_.storage,C.storage,C.storage,O,this.logService);return F!==null}async getMergeResult(f,C){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,C,_,O){if(this.extUri.isEqual(C,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(C,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(C,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async acceptLocal(f){return{content:f.localContent,local:{added:{},removed:[],updated:{}},remote:f.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(f){if(f.remoteContent!==null){const C=JSON.parse(f.remoteContent),{local:_,remote:O}=(0,p.merge)(f.localUserData.storage,C.storage,null,f.storageKeys,this.logService);return{content:f.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:f.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(f,C,_,O){let{localUserData:F}=_[0][0],{local:R,remote:N,localChange:$,remoteChange:j}=_[0][1];if($===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(R),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const X=JSON.stringify({storage:N});f=await this.updateRemoteUserData(X,O?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}C?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,ft.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f)){const _=await this.resolvePreviewContent(f);return _&&i(JSON.parse(_),!0)}let C=await super.resolveContent(f);if(C)return C;if(C=await super.resolveContent(this.extUri.dirname(f)),C){const _=this.parseSyncData(C);if(_)switch(this.extUri.basename(f)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:f}=await this.getLocalGlobalState();if(Object.keys(f).length>1||f[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const f={},C=await this.getLocalArgvContent(),_=(0,L.parse)(C);for(const O of l)_[O]!==void 0&&(f[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const F=this.storageService.get(O,0);F&&(f[O]={version:1,value:F})}return{storage:f}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const f=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),f.value.toString()}catch(f){this.logService.debug((0,n.getErrorMessage)(f))}return"{}"}async writeLocalGlobalState({added:f,removed:C,updated:_}){const O={},F={},R=($,j)=>{for(const X of $){if(X.startsWith(r)){O[X.substring(r.length)]=j?j[X].value:void 0;continue}if(j){const z=j[X];z.value!==String(this.storageService.get(X,0))&&(F[X]=z.value)}else this.storageService.get(X,0)!==void 0&&(F[X]=void 0)}};if(R(Object.keys(f),f),R(Object.keys(_),_),R(C),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(F))this.storageService.store($,F[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(f){const C=await this.getLocalArgvContent();let _=C;for(const O of Object.keys(f))_=(0,y.edit)(_,[O],f[O],{});C!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(f){const C=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...C,..._],F=f?.storage?Object.keys(f.storage).filter(R=>!R.startsWith(r)&&!O.includes(R)&&this.storageService.get(R,0)!==void 0):[];if(!P.isWeb){const R=[...c.ALL_SYNC_RESOURCES.map(N=>(0,c.getEnablementKey)(N)),c.SYNC_SERVICE_URL_TYPE];F.push(...R),_.push(...R)}return{user:C,machine:_,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([G(0,g.IFileService),G(1,c.IUserDataSyncStoreService),G(2,c.IUserDataSyncBackupStoreService),G(3,c.IUserDataSyncLogService),G(4,E.IEnvironmentService),G(5,c.IUserDataSyncEnablementService),G(6,v.ITelemetryService),G(7,D.IConfigurationService),G(8,h.IStorageService),G(9,m.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(f,C,_,O,F){super("globalState",_,O,C,F);this.storageService=f}async doInitialize(f){const C=f.syncData?JSON.parse(f.syncData.content):null;if(!C){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const F of Object.keys(C.storage))F.startsWith(r)?_[F.substring(r.length)]=C.storage[F].value:this.storageService.get(F,0)===void 0&&(O[F]=C.storage[F].value);if(Object.keys(_).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const R of Object.keys(_))F=(0,y.edit)(F,[R],_[R],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(F))}if(Object.keys(O).length)for(const F of Object.keys(O))this.storageService.store(F,O[F],0,0)}};s=he([G(0,h.IStorageService),G(1,g.IFileService),G(2,E.IEnvironmentService),G(3,c.IUserDataSyncLogService),G(4,m.IUriIdentityService)],s),e.GlobalStateInitializer=s;let a=class{constructor(f,C,_,O,F){this.userDataSyncStoreClient=f,this.storageService=C,this.environmentService=_,this.fileService=O,this.logService=F}getSyncStoreType(f){return this.parseGlobalState(f)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(f){const C=(0,c.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(f,C)}catch(_){if(_ instanceof c.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(f,C)}throw _}}async doSync(f,C){const _=await this.userDataSyncStoreClient.read("globalState",null,C),O=this.parseGlobalState(_)||{storage:{}};O.storage[c.SYNC_SERVICE_URL_TYPE]={value:f,version:t};const F=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),R={version:t,machineId:F,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(R),_.ref,C)}parseGlobalState({content:f}){if(!f)return null;const C=JSON.parse(f);if((0,w.isSyncData)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};a=he([G(1,h.IStorageService),G(2,E.IEnvironmentService),G(3,g.IFileService),G(4,S.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(te[229],ne([0,1,16,17,3,35,4,11,145,19,14,15,23,21,32,44,224,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(c,r,l){try{const i=JSON.parse(c);if(!r)return(0,P.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,P.isUndefined)(i.mac)?null:i.mac;case 3:return(0,P.isUndefined)(i.linux)?null:i.linux;case 1:return(0,P.isUndefined)(i.windows)?null:i.windows}}catch(i){return l.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let y=class extends h.AbstractJsonFileSynchroniser{constructor(r,l,i,t,o,s,a,u,f,C,_){super(a.keybindingsResource,"keybindings",s,a,u,r,l,o,C,i,f,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,l,i,t){const o=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;l=l===null&&i?r:l;const s=l?this.getKeybindingsContentFromLastSyncUserData(l):null,a=await this.getLocalFileContent(),u=await this.getFormattingOptions();let f=null,C=!1,_=!1,O=!1;if(o){let R=a?a.value.toString():"[]";if(R=R||"[]",this.hasErrors(R))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==R||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const N=await(0,v.merge)(R,o,s,u,this.userDataSyncUtilService);N.hasChanges&&(f=N.mergeContent,O=N.hasConflicts,C=O||N.mergeContent!==R,_=O||N.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=a.value.toString(),_=!0);const F={content:f,localChange:C?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const l=this.getKeybindingsContentFromLastSyncUserData(r);if(l===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",o=await this.getFormattingOptions(),s=await(0,v.merge)(t||"[]",l,l,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==l}async getMergeResult(r,l){return r.previewResult}async getAcceptResult(r,l,i,t){if(this.extUri.isEqual(l,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(l,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(l,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(r,l,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:u}=i[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const f=this.toSyncContent(s||"[]",r.syncData?.content);r=await this.updateRemoteUserData(f,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}l?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const l=(0,L.parse)(r.value.toString());if((0,k.isNonEmptyArray)(l))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const l=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:l}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let l=await super.resolveContent(r);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(r)),l){const i=this.parseSyncData(l);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,l){let i={};try{i=JSON.parse(l||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=he([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncBackupStoreService),G(2,m.IUserDataSyncLogService),G(3,I.IConfigurationService),G(4,m.IUserDataSyncEnablementService),G(5,E.IFileService),G(6,D.IEnvironmentService),G(7,g.IStorageService),G(8,m.IUserDataSyncUtilService),G(9,S.ITelemetryService),G(10,d.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let p=class extends h.AbstractInitializer{constructor(r,l,i,t){super("keybindings",l,i,r,t)}async doInitialize(r){const l=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!l){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(l)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),l=(0,L.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(l)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(l){return this.logService.error(l),null}}};p=he([G(0,E.IFileService),G(1,D.IEnvironmentService),G(2,m.IUserDataSyncLogService),G(3,d.IUriIdentityService)],p),e.KeybindingsInitializer=p}),define(te[230],ne([0,1,16,35,70,49,28,53,24]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function I(s,a,u){let f=[];u?f=E(u):f=D(a);const C=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(f))for(const O of f)O.startsWith("-")?_.push(O.substring(1)):C.push(O);return(0,k.distinct)([...s,...C].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=I;function D(s){let a=s.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=s.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:s.getValue("settingsSync.ignoredSettings")||[]}function E(s){const a=(0,n.parse)(s);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function g(s,a,u,f){if(u.length){const C=o(a),_=(0,n.parse)(a),O=(0,n.parse)(s),F=[];for(const R of u){const N=_[R],$=O[R];N===void 0?s=P.edit(s,[R],void 0,f):$!==void 0?s=P.edit(s,[R],N,f):F.push(c(R,C))}F.sort((R,N)=>R.startOffset-N.startOffset),F.forEach(R=>s=m(R.setting.key,a,s,f))}return s}e.updateIgnoredSettings=g;function S(s,a,u,f,C,_){const O=g(s,a,f,_),F=u!==O,R=u!==a;if(!F&&!R)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!R)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(R&&!F)return{conflictsSettings:[],localContent:g(a,s,f,_),remoteContent:null,hasConflicts:!1};if(u===null&&h(s)){const W=d(s,a,f)?null:g(a,s,f,_);return{conflictsSettings:[],localContent:W,remoteContent:null,hasConflicts:!1}}let N=s,$=a;const j=(0,n.parse)(s),X=(0,n.parse)(a),z=u?(0,n.parse)(u):null,J=f.reduce((W,H)=>(W.add(H),W),new Set),B=v(j,X,J),x=v(z,j,J),ee=v(z,X,J),V=new Map,Z=new Set,Y=W=>{Z.add(W);const H=C.filter(({key:re})=>re===W)[0];H?(N=P.edit(N,[W],H.value,_),$=P.edit($,[W],H.value,_)):V.set(W,{key:W,localValue:j[W],remoteValue:X[W]})};for(const W of x.removed.values())ee.updated.has(W)?Y(W):$=P.edit($,[W],void 0,_);for(const W of ee.removed.values())Z.has(W)||(x.updated.has(W)?Y(W):N=P.edit(N,[W],void 0,_));for(const W of x.updated.values())Z.has(W)||(ee.updated.has(W)?B.updated.has(W)&&Y(W):$=P.edit($,[W],j[W],_));for(const W of ee.updated.values())Z.has(W)||(x.updated.has(W)?B.updated.has(W)&&Y(W):N=P.edit(N,[W],X[W],_));for(const W of x.added.values())Z.has(W)||(ee.added.has(W)?B.updated.has(W)&&Y(W):$=m(W,N,$,_));for(const W of ee.added.values())Z.has(W)||(x.added.has(W)?B.updated.has(W)&&Y(W):N=m(W,$,N,_));const q=V.size>0||!d(N,$,f),U=q||!d(N,s,[]),M=q||!d($,a,[]);return{localContent:U?N:null,remoteContent:M?$:null,conflictsSettings:[...V.values()],hasConflicts:q}}e.merge=S;function d(s,a,u){if(s===a)return!0;const f=(0,n.parse)(s),C=(0,n.parse)(a),_=u.reduce((R,N)=>(R.add(N),R),new Set),O=o(s).filter(R=>!(R.setting&&_.has(R.setting.key))),F=o(a).filter(R=>!(R.setting&&_.has(R.setting.key)));if(O.length!==F.length)return!1;for(let R=0;R<O.length;R++){const N=O[R],$=F[R];if(N.setting&&$.setting){if(N.setting.key!==$.setting.key||!A.equals(f[N.setting.key],C[N.setting.key]))return!1}else if(!N.setting&&!$.setting){if(N.value!==$.value)return!1}else return!1}return!0}e.areSame=d;function h(s){return s?o(s).length===0:!0}e.isEmpty=h;function v(s,a,u){const f=s?Object.keys(s).filter(R=>!u.has(R)):[],C=Object.keys(a).filter(R=>!u.has(R)),_=C.filter(R=>f.indexOf(R)===-1).reduce((R,N)=>(R.add(N),R),new Set),O=f.filter(R=>C.indexOf(R)===-1).reduce((R,N)=>(R.add(N),R),new Set),F=new Set;if(s)for(const R of f){if(O.has(R))continue;const N=s[R],$=a[R];A.equals(N,$)||F.add(R)}return{added:_,removed:O,updated:F}}function m(s,a,u,f){const C=(0,n.parse)(a),_=o(a),O=o(u),F=w(s,_,O);return y(u,s,C[s],F,O,f)}e.addSetting=m;function w(s,a,u){const f=a.findIndex(_=>_.setting?.key===s),C=a[f-1];if(C){if(C.setting){const O=c(C.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!0}}else{const O=r(f,a);if(O){const F=c(O.setting.key,u);if(F){const R=l(u.indexOf(F),u),N=i(a,O,a[f]);if(R){const $=i(u,F,R),j=t(N,$);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.indexOf(R),insertAfter:!1}}else{const $=i(u,F,u[u.length-1]),j=t(N,$);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=a[f+1];if(_)if(_.setting){const O=c(_.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!1}}else{const O=l(f,a);if(O){const F=c(O.setting.key,u);if(F){const R=r(u.indexOf(F),u),N=i(a,a[f],O);if(R){const $=i(u,R,F),j=t(N.reverse(),$.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:u.indexOf(R),insertAfter:!0}}else{const $=i(u,u[0],F),j=t(N.reverse(),$.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function y(s,a,u,f,C,_){let O;return f.index===-1?O=(0,T.setProperty)(s,[a],u,_):O=p(s,a,u,f,C,_).map(F=>(0,T.withFormatting)(s,F,_)[0]),(0,T.applyEdits)(s,O)}function p(s,a,u,f,C,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(u)}`,F=(0,L.getEOL)(_,s),R=C[f.index];if(f.insertAfter){const N=[];if(R.setting)N.push({offset:R.endOffset,length:0,content:","+O});else{const $=l(f.index,C),j=r(f.index,C),X=j?.setting?.commaOffset;j&&X===void 0&&N.push({offset:j.endOffset,length:0,content:","});const z=X!==void 0&&X>R.endOffset;N.push({offset:z?X+1:R.endOffset,length:0,content:$?F+O+",":F+O})}return N}else{if(R.setting)return[{offset:R.startOffset,length:0,content:O+","}];const N=(C[f.index-1]&&!C[f.index-1].setting?F:"")+O+(l(f.index,C)?",":"")+F;return[{offset:R.startOffset,length:0,content:N}]}}function c(s,a){return a.filter(u=>u.setting?.key===s)[0]}function r(s,a){for(let u=s-1;u>=0;u--)if(a[u].setting)return a[u]}function l(s,a){for(let u=s+1;u<a.length;u++)if(a[u].setting)return a[u]}function i(s,a,u){const f=s.indexOf(a),C=s.indexOf(u);return s.filter((_,O)=>f<O&&O<C)}function t(s,a){if(s.length&&a.length){let u=0;for(;u<a.length&&u<s.length;u++)if(s[u].value!==a[u].value)return a[u-1];return a[u-1]}}function o(s){const a=[];let u=-1,f,C;const _={onObjectBegin:O=>{u++},onObjectProperty:(O,F,R)=>{u===0&&(f=F,C=O)},onObjectEnd:(O,F)=>{u--,u===0&&a.push({startOffset:f,endOffset:O+F,value:s.substring(f,O+F),setting:{key:C,commaOffset:void 0}})},onArrayBegin:(O,F)=>{u++},onArrayEnd:(O,F)=>{u--,u===0&&a.push({startOffset:f,endOffset:O+F,value:s.substring(f,O+F),setting:{key:C,commaOffset:void 0}})},onLiteralValue:(O,F,R)=>{u===0&&a.push({startOffset:f,endOffset:F+R,value:s.substring(f,F+R),setting:{key:C,commaOffset:void 0}})},onSeparator:(O,F,R)=>{if(u===0&&O===","){let N=a.length-1;for(;N>=0&&!a[N].setting;N--);const $=a[N];$&&a.splice(N,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:F}})}},onComment:(O,F)=>{u===0&&a.push({startOffset:O,endOffset:O+F,value:s.substring(O,O+F)})}};return(0,n.visit)(s,_),a}}),define(te[231],ne([0,1,17,3,146,19,90,14,30,15,23,21,32,44,53,230,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(c){return c&&c.settings&&typeof c.settings=="string"&&Object.keys(c).length===1}function w(c){const r=JSON.parse(c);return m(r)?r:{settings:c}}e.parseSettingsSyncContent=w;let y=class extends S.AbstractJsonFileSynchroniser{constructor(r,l,i,t,o,s,a,u,f,C,_,O){super(l.settingsResource,"settings",r,l,i,t,o,f,C,s,a,u,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const l=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,l),t=this.getSettingsSyncContent(i),o=new A.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&o.parse(t.settings),o.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,l,i){const t=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(r);l=l===null&&i?r:l;const a=l?this.getSettingsSyncContent(l):null,u=await this.getIgnoredSettings();let f=null,C=!1,_=!1,O=!1;if(s){let R=t?t.value.toString().trim():"{}";R=R||"{}",this.validateContent(R),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const N=(0,h.merge)(R,s.settings,a?a.settings:null,u,[],o);f=N.localContent||N.remoteContent,C=N.localContent!==null,_=N.remoteContent!==null,O=N.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),f=t.value.toString(),_=!0);const F={content:f,localChange:C?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const l=this.getSettingsSyncContent(r);if(l===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,h.merge)(t||"{}",l.settings,l.settings,o,[],s).remoteContent!==null}async getMergeResult(r,l){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,h.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,l,i,t){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(l,this.localResource))return{content:r.fileContent?(0,h.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(l,this.remoteResource))return{content:r.remoteContent!==null?(0,h.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(l,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,h.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(r,l,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:u}=i[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const f=await this.getFormattingOptions(),C=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(s);s=(0,h.updateIgnoredSettings)(s,C?C.settings:"{}",_,f),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}l?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const l=await this.getFormattingOptions(),i=(0,d.edit)(r.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,l);return!(0,h.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const l=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:l}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let l=await super.resolveContent(r);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(r)),l){const i=this.parseSyncData(l);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let l=await super.resolvePreviewContent(r);if(l){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();l=(0,h.updateIgnoredSettings)(l,"{}",t,i)}return l}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(l){this.logService.error(l)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:o})=>!!o)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const l=await this._defaultIgnoredSettings;return(0,h.getIgnoredSettings)(l,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new v.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};y=he([G(0,I.IFileService),G(1,P.IEnvironmentService),G(2,D.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncBackupStoreService),G(5,v.IUserDataSyncLogService),G(6,v.IUserDataSyncUtilService),G(7,L.IConfigurationService),G(8,v.IUserDataSyncEnablementService),G(9,E.ITelemetryService),G(10,b.IExtensionManagementService),G(11,g.IUriIdentityService)],y),e.SettingsSynchroniser=y;let p=class extends S.AbstractInitializer{constructor(r,l,i,t){super("settings",l,i,r,t)}async doInitialize(r){const l=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!l){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(l.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,h.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(l){this.logService.error(l)}return null}};p=he([G(0,I.IFileService),G(1,P.IEnvironmentService),G(2,v.IUserDataSyncLogService),G(3,g.IUriIdentityService)],p),e.SettingsInitializer=p}),define(te[232],ne([0,1,17,3,28,19,14,15,23,21,32,44,225,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends E.AbstractSynchroniser{constructor(m,w,y,p,c,r,l,i,t,o){super("snippets",w,m,y,p,c,i,t,r,l,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,y){const p=await this.getSnippetsFileContents(),c=this.toSnippetsContents(p),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&y?m:w;const l=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,g.merge)(c,r,l);return this.getResourcePreviews(i,p,r||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const y=await this.getSnippetsFileContents(),p=this.toSnippetsContents(y),c=(0,g.merge)(p,w,w);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,y,p){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:y,localChange:y===null?m.fileContent!==null?3:0:2,remoteChange:y===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,y,p){const c=y.map(([r,l])=>({...r,acceptResult:l}));c.every(({localChange:r,remoteChange:l})=>r===0&&l===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,p)),c.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(c,m,p)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of c)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,w,y){const p=new Map;for(const c of Object.keys(m.local.added)){const r={content:m.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};p.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(m.local.updated)){const r={content:m.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(m.remote.added)){const r={content:m.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(m.remote.updated)){const r={content:m.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of m.conflicts){const r={content:w[c]?w[c].value.toString():null,hasConflicts:!0,localChange:w[c]?2:1,remoteChange:y[c]?2:1};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c]||null,localContent:w[c]?w[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(w))if(!p.has(c)){const r={content:w[c]?w[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c]||null,localContent:w[c]?w[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const y=this.parseSyncData(w);if(y){const p=this.parseSnippets(y),c=[];for(const r of Object.keys(p)){const l=this.extUri.joinPath(m,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);c.push({resource:l,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const y of m)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:y,acceptResult:p,localResource:c,remoteResource:r,localChange:l}of m)if(l!==0){const i=r?this.extUri.basename(r):this.extUri.basename(c),t=this.extUri.joinPath(this.snippetsFolder,i);l===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):l===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,k.VSBuffer.fromString(p.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,k.VSBuffer.fromString(p.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,y){const p=w.syncData?this.parseSnippets(w.syncData):{},c=(0,T.deepClone)(p);for(const{acceptResult:r,localResource:l,remoteResource:i,remoteChange:t}of m)if(t!==0){const o=l?this.extUri.basename(l):this.extUri.basename(i);t===3?delete c[o]:c[o]=r.content}return(0,g.areSame)(p,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(c),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const y of Object.keys(m))w[y]=m[y].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof P.FileOperationError&&y.fileOperationResult===1)return m;throw y}for(const y of w.children||[]){const p=y.resource,c=this.extUri.extname(p);if(c===".json"||c===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,p),l=await this.fileService.readFile(p);m[r]=l}}return m}};d=he([G(0,A.IEnvironmentService),G(1,P.IFileService),G(2,b.IStorageService),G(3,S.IUserDataSyncStoreService),G(4,S.IUserDataSyncBackupStoreService),G(5,S.IUserDataSyncLogService),G(6,L.IConfigurationService),G(7,S.IUserDataSyncEnablementService),G(8,I.ITelemetryService),G(9,D.IUriIdentityService)],d),e.SnippetsSynchroniser=d;let h=class extends E.AbstractInitializer{constructor(m,w,y,p){super("snippets",w,y,m,p)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(w)){const c=w[p];if(c){const r=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(r,k.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};h=he([G(0,P.IFileService),G(1,A.IEnvironmentService),G(2,S.IUserDataSyncLogService),G(3,D.IUriIdentityService)],h),e.SnippetsInitializer=h}),define(te[233],ne([0,1,17,19,14,15,23,21,32,44,24]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function E(h,v){try{return JSON.parse(h).tasks}catch(m){return v.error(m),null}}e.getTasksContentFromSyncContent=E;let g=class extends I.AbstractFileSynchroniser{constructor(v,m,w,y,p,c,r,l,i,t){super(t.extUri.joinPath(t.extUri.dirname(r.settingsResource),"tasks.json"),"tasks",c,r,l,v,m,p,i,w,y,t);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:D.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:D.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:D.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(v,m,w,y){const p=v.syncData?E(v.syncData.content,this.logService):null;m=m===null&&w?v:m;const c=m?.syncData?E(m.syncData.content,this.logService):null,r=await this.getLocalFileContent();let l=null,i=!1,t=!1,o=!1;if(p){const a=r?r.value.toString():null;if(!c||c!==a||c!==p){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const u=d(a,p,c);l=u.content,o=u.hasConflicts,i=u.hasLocalChanged,t=u.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),l=r.value.toString(),t=!0);const s={content:l,localChange:i?r?2:1:0,remoteChange:t?2:0,hasConflicts:o};return[{fileContent:r,localResource:this.localResource,localContent:r?r.value.toString():null,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:p,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(v){const m=v?.syncData?E(v.syncData.content,this.logService):null;if(m===null)return!0;const w=await this.getLocalFileContent(),y=w?w.value.toString():null,p=d(y,m,m);return p.hasLocalChanged||p.hasRemoteChanged}async getMergeResult(v,m){return v.previewResult}async getAcceptResult(v,m,w,y){if(this.extUri.isEqual(m,this.localResource))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:v.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return w===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:w,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(v,m,w,y){const{fileContent:p}=w[0][0];let{content:c,localChange:r,remoteChange:l}=w[0][1];if(r===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),p&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(p.value.toString()))),await this.updateLocalFileContent(c||"{}",p,y),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(c||"{}"));v=await this.updateRemoteUserData(i,y?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:v}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(v,"tasks.json"),comparableResource:m}]}async resolveContent(v){if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let m=await super.resolveContent(v);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(v)),m){const w=this.parseSyncData(m);if(w)switch(this.extUri.basename(v)){case"tasks.json":return E(w.content,this.logService)}}return null}toTasksSyncContent(v){return{tasks:v}}};g=he([G(0,D.IUserDataSyncStoreService),G(1,D.IUserDataSyncBackupStoreService),G(2,D.IUserDataSyncLogService),G(3,n.IConfigurationService),G(4,D.IUserDataSyncEnablementService),G(5,L.IFileService),G(6,T.IEnvironmentService),G(7,A.IStorageService),G(8,P.ITelemetryService),G(9,b.IUriIdentityService)],g),e.TasksSynchroniser=g;let S=class extends I.AbstractInitializer{constructor(v,m,w,y){super("tasks",m,w,v,y);this.uriIdentityService=y,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(v){const m=v.syncData?E(v.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(m)),await this.updateLastSyncUserData(v)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};S=he([G(0,L.IFileService),G(1,T.IEnvironmentService),G(2,D.IUserDataSyncLogService),G(3,b.IUriIdentityService)],S),e.TasksInitializer=S;function d(h,v,m){if(h===null&&v===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===v)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const w=m!==h,y=m!==v;return!w&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:w&&!y?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!w?{content:v,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(te[65],ne([0,1,3,2,6,24]),function(K,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(b,I){super();this.userDataSyncStoreService=b,this.logService=I,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=he([G(0,L.IUserDataSyncStoreService),G(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(te[234],ne([0,1,5,17,57,2,20,19,14,15,24]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends L.Disposable{constructor(S,d,h,v){super();this.environmentService=S,this.fileService=d,this.configurationService=h,this.logService=v,D.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(S){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),h=await this.fileService.resolve(d);return h.children?h.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(S,d){if(!d){const h=await this.getAllRefs(S);h.length&&(d=h[h.length-1].ref)}if(d){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,S,d);return(await this.fileService.readFile(h)).value.toString()}return null}async backup(S,d){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),v=(0,A.joinPath)(h,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,n.VSBuffer.fromString(d))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(d))return}catch{return}const h=await this.fileService.resolve(d);if(h.children){const v=h.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(p=>Date.now()-this.getCreationTime(p)>m);const y=v.length-w.length;y<10&&(w=w.slice(10-y)),await k.Promises.settled(w.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(h){this.logService.error(h)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};E=he([G(0,b.IEnvironmentService),G(1,I.IFileService),G(2,P.IConfigurationService),G(3,D.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[235],ne([0,1,3,2,4,14,23,21,24]),function(K,e,k,n,T,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const I="sync.enable";let D=class extends n.Disposable{constructor(g,S,d,h){super();this.storageService=g,this.telemetryService=S,this.environmentService=d,this.userDataSyncStoreManagementService=h,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(g.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(I,{enabled:g}),this.storageService.store(I,g,0,1))}isResourceEnabled(g){return this.storageService.getBoolean((0,b.getEnablementKey)(g),0,!0)}setResourceEnablement(g,S){if(this.isResourceEnabled(g)!==S){const d=(0,b.getEnablementKey)(g);this.storeResourceEnablement(d,S)}}getResourceSyncStateVersion(g){}storeResourceEnablement(g,S){this.storageService.store(g,S,0,T.isWeb?0:1)}onDidStorageChange(g){if(g.scope!==0)return;if(I===g.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=b.ALL_SYNC_RESOURCES.filter(d=>(0,b.getEnablementKey)(d)===g.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};D=he([G(0,A.IStorageService),G(1,P.ITelemetryService),G(2,L.IEnvironmentService),G(3,b.IUserDataSyncStoreManagementService)],D),e.UserDataSyncEnablementService=D}),define(te[236],ne([0,1,2,7]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(g){this.service=g}listen(g,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class L{constructor(g){this.service=g}listen(g,S){throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(g){this.service=g}listen(g,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(g,S,d){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class b{constructor(g){this.service=g}listen(g,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class I{constructor(g){this.service=g}listen(g,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class D extends k.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:n.URI.revive(g.url),type:g.type,defaultUrl:n.URI.revive(g.defaultUrl),insidersUrl:n.URI.revive(g.insidersUrl),stableUrl:n.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(te[237],ne([0,1,14,8]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends n.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};T=he([G(0,n.ILoggerService),G(1,k.IEnvironmentService)],T),e.UserDataSyncLogService=T}),define(te[66],ne([0,1,3,2,4,26,149,14,15,6,27,46,23,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",h="Safari",v="Chrome",m="Edge",w="Firefox",y="Android";function p(l){switch(l){case h:case v:case m:case w:case y:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=p;function c(){return T.isSafari?h:T.isChrome?v:T.isEdge?m:T.isFirefox?w:T.isAndroid?y:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let r=class Ze extends n.Disposable{constructor(i,t,o,s,a,u){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=a,this.productService=u,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(i,t,o)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(i);o.machines.some(({id:s})=>s===t)||(o.machines.push({id:t,name:this.computeCurrentMachineName(o.machines),platform:c()}),await this.writeMachinesData(o))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(i),s=o.machines.filter(({id:a})=>a!==t);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(i,t,o){const s=await this.readMachinesData(o),a=s.machines.find(({id:u})=>u===i);if(a){a.name=t,await this.writeMachinesData(s);const u=await this.currentMachineIdPromise;i===u&&this.storageService.store(d,t,0,1)}}async setEnablements(i){const t=await this.readMachinesData();for(const[o,s]of i){const a=t.machines.find(u=>u.id===o);a&&(a.disabled=s?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(i){const t=this.storageService.get(d,0);if(t)return t;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${c()} (${this.productService.nameShort})`,s=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const u of i){const f=s.exec(u.name),C=f?parseInt(f[1]):0;a=C>a?C:a}return`${o} #${a+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,t,this.userData?.ref||null);this.userData={ref:o,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:Ze.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=he([G(0,P.IEnvironmentService),G(1,b.IFileService),G(2,g.IStorageService),G(3,S.IUserDataSyncStoreService),G(4,S.IUserDataSyncLogService),G(5,D.IProductService)],r),e.UserDataSyncMachinesService=r}),define(te[238],ne([0,1,5,57,37,9,3,2,4,20,7,147,27,23,21,24,65,66]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",y="sync.sessionId",p="sync.storeUrl",c="sync.productQuality";let r=class extends P.Disposable{constructor(t,o,s,a,u,f,C,_,O,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=u,this.logService=f,this.userDataSyncAccountService=C,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(C.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(u.onDidChangeLocal(R=>this.triggerSync([R],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,R])=>R)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(p,0);return t?D.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),0,1):this.storageService.remove(p,0)}get productQuality(){return this.storageService.get(c,0)}set productQuality(t){t?this.storageService.store(c,t,0,1):this.storageService.remove(c,0)}updateAutoSync(){const{enabled:t,message:o}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new l(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const o=h.UserDataSyncError.toUserDataSyncError(t);o instanceof h.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};r=he([G(0,g.IProductService),G(1,h.IUserDataSyncStoreManagementService),G(2,h.IUserDataSyncStoreService),G(3,h.IUserDataSyncEnablementService),G(4,h.IUserDataSyncService),G(5,h.IUserDataSyncLogService),G(6,v.IUserDataSyncAccountService),G(7,d.ITelemetryService),G(8,m.IUserDataSyncMachinesService),G(9,S.IStorageService)],r),e.UserDataAutoSyncService=r;class l extends P.Disposable{constructor(t,o,s,a,u,f,C,_){super();this.lastSyncUrl=t,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=u,this.userDataSyncMachinesService=f,this.logService=C,this.storageService=_,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(l.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(l.INTERVAL_SYNCING,!1),this.interval)}sync(t,o){const s=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,L.isCancellationError)(u))return}return this.doSync(t,o,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!t&&(!(0,I.isEqual)(o.defaultUrl,t.defaultUrl)||!(0,I.isEqual)(o.insidersUrl,t.insidersUrl)||!(0,I.isEqual)(o.stableUrl,t.stableUrl))}async doSync(t,o,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new h.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const u=this.storageService.get(y,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new h.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const f=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const C=f.find(_=>_.isCurrent);if(C?.disabled)throw new h.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new h.UserDataAutoSyncError((0,T.toErrorMessage)(_),_ instanceof h.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(y,this.manifest.session,0,1),s.isCancellationRequested)return;C||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),a=u}this._onDidFinishSync.fire(a)}register(t){return super._register(t)}}l.INTERVAL_SYNCING="Interval"}),define(te[239],ne([0,1,16,5,37,3,2,20,11,29,19,30,6,23,21,226,228,229,231,232,233,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let l=class extends A.Disposable{constructor(a,u,f,C,_,O,F,R){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=u,this.instantiationService=f,this.configurationService=C,this.logService=_,this.telemetryService=O,this.storageService=F,this.userDataSyncEnablementService=R,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(r,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,u){this.checkEnablement();const f=(0,I.generateUuid)();try{const R=(0,c.createSyncHeaders)(f);u&&(R["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,R)}catch(R){const N=c.UserDataSyncError.toUserDataSyncError(R);throw this.reportUserDataSyncError(N,f),N}let C=!1;const _=this,O=this.getEnabledSynchronizers();let F;return{manifest:a,async run(){if(C)throw new Error("Can run a task only once");return F=(0,n.createCancelablePromise)(R=>_.sync(O,a,f,R)),F.finally(()=>F=void 0)},async stop(){if(F&&F.cancel(),_.status!=="idle")return _.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new c.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,I.generateUuid)(),u=(0,c.createSyncHeaders)(a);let f;try{f=await this.userDataSyncStoreService.manifest(null,u)}catch(O){const F=c.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(F,a),F}await this.resetLocal();const C=this.getEnabledSynchronizers(),_=async()=>{await this.stop(C),await this.resetLocal()};return new i(a,f,u,C,_,this.configurationService,this.logService)}async sync(a,u,f,C){if(C.isCancellationRequested||!a.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,c.createSyncHeaders)(f);for(const F of a){if(C.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(u,O)}catch(R){let N=!1;if(R instanceof c.UserDataSyncError)switch(R.code){case"TooLarge":R=new c.UserDataSyncError(R.message,R.code,F.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const $=c.UserDataSyncError.toUserDataSyncError(R);if(this.reportUserDataSyncError($,f),N)throw $;this.logService.error(R),this.logService.error(`${F.resource}: ${(0,T.toErrorMessage)(R)}`),this._syncErrors.push([F.resource,$])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(O){const F=c.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(F,f),F}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const u of a)try{u.status!=="idle"&&await u.stop()}catch(f){this.logService.error(f)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(a))return!0})}async accept(a,u,f,C){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===a)return await _.accept(u,f),C&&await _.apply(!1,(0,c.createSyncHeaders)((0,I.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async u=>{const f=await u.resolveContent(a);if(f)return f})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async f=>{if(f.resource===a)return f.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async f=>{if(f.resource===a)return f.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,u){return await this.performSynchronizerAction(async C=>{if(C.resource===a)return C.getAssociatedResources(u)})||[]}async getMachineId(a,u){return await this.performSynchronizerAction(async C=>{if(C.resource===a)return await C.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(r,0),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(u){this.logService.error(`${a.resource}: ${(0,T.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const u=new A.DisposableStore;try{const f=this.synchronizers.value||u.add(this.instantiationService.createInstance(t,()=>{},()=>{},()=>{})),C=[...f.enabled,...f.disabled.map(_=>u.add(f.createSynchronizer(_)))];for(const _ of C){const O=await a(_);if(!(0,b.isUndefined)(O))return O}return null}finally{u.dispose()}}setStatus(a){const u=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const u=this.computeStatus(a);this.setStatus(u)}updateConflicts(a){const u=this.computeConflicts(a);(0,k.equals)(this._conflicts,u,([f,C],[_,O])=>f===f&&(0,k.equals)(C,O,(F,R)=>(0,P.isEqual)(F.previewResource,R.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(u))}computeConflicts(a){return a.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(u=>u.status==="hasConflicts")?"hasConflicts":a.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(r,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,u){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof c.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof c.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(t,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=he([G(0,c.IUserDataSyncStoreService),G(1,c.IUserDataSyncStoreManagementService),G(2,g.IInstantiationService),G(3,D.IConfigurationService),G(4,c.IUserDataSyncLogService),G(5,d.ITelemetryService),G(6,S.IStorageService),G(7,c.IUserDataSyncEnablementService)],l),e.UserDataSyncService=l;class i extends A.Disposable{constructor(a,u,f,C,_,O,F){super();this.id=a,this.manifest=u,this.syncHeaders=f,this.synchronisers=C,this.onStop=_,this.configurationService=O,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,u){try{return await this.performAction(a,f=>f.accept(a,u))}catch(f){throw this.logService.error(f),f}}async merge(a){try{return a?await this.performAction(a,u=>u.merge(a)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(a){try{return await this.performAction(a,u=>u.discard(a))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,u]of this.previews)for(const f of u.resourcePreviews)f.mergeState==="conflict"&&a.push(f.previewResource);for(const u of a)await this.discard(u);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[u,f]of this.previews){this.synchronizingResources.push([u,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(O=>O.resource===u);for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await C.merge(O.previewResource);const _=await C.apply(!1,this.syncHeaders);_&&a.push(this.toSyncResourcePreview(C.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(C=>C.resource===a);for(const C of u.resourcePreviews)await f.accept(C.remoteResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(C=>C.resource===a);for(const C of u.resourcePreviews)await f.accept(C.localResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const f=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:X,previewResource:z,remoteResource:J})=>(0,P.isEqual)(a,X)||(0,P.isEqual)(a,z)||(0,P.isEqual)(a,J)));if(f===-1)return this.previews;const[C,_]=this.previews[f],O=_.resourcePreviews.find(({localResource:j,remoteResource:X,previewResource:z})=>(0,P.isEqual)(j,a)||(0,P.isEqual)(X,a)||(0,P.isEqual)(z,a));if(!O)return this.previews;let F=this.synchronizingResources.find(j=>j[0]===C);F||(F=[C,[]],this.synchronizingResources.push(F)),F[1].some(j=>(0,P.isEqual)(j,O.localResource))||(F[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const R=this.synchronisers.find(j=>j.resource===this.previews[f][0]),N=await u(R);N?this.previews.splice(f,1,this.toSyncResourcePreview(R.resource,N)):this.previews.splice(f,1);const $=this.synchronizingResources.findIndex(j=>j[0]===C);return this.synchronizingResources[$][1].splice(F[1].findIndex(j=>(0,P.isEqual)(j,O.localResource)),1),F[1].length||(this.synchronizingResources.splice($,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[u,f]of this.previews){this.synchronizingResources.push([u,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(O=>O.resource===u);let _=f;for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(_=await C.merge(O.previewResource));_&&a.push(this.toSyncResourcePreview(C.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const u=[],f=await this.getUserDataSyncConfiguration();for(const C of this.synchronisers){if(a.isCancellationRequested)return[];const _=await C.preview(this.manifest,f,this.syncHeaders);_&&u.push(this.toSyncResourcePreview(C.resource,_))}return u}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=this.synchronisers.find(f=>f instanceof w.SettingsSynchroniser);if(u){const f=await u.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...f}}return a}toSyncResourcePreview(a,u){return[a,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let t=class extends A.Disposable{constructor(a,u,f,C,_,O,F){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=u,this.onDidChangeLocal=f,this.userDataSyncEnablementService=C,this.instantiationService=_,this.extensionGalleryService=O,this.logService=F,this._enabled=[],this._register(C.onDidChangeResourceEnablement(([R,N])=>this.onDidChangeResourceEnablement(R,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,R])=>R.dispose())));for(const R of c.ALL_SYNC_RESOURCES)C.isResourceEnabled(R)&&this.registerSynchronizer(R)}get enabled(){return this._enabled.sort((a,u)=>a[1]-u[1]).map(([a])=>a)}get disabled(){return c.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,u){u?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([_])=>_.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new A.DisposableStore,f=u.add(this.createSynchronizer(a));u.add(f.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(f.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(f.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const C=this.getOrder(a);this._enabled.push([f,C,u])}deRegisterSynchronizer(a){const u=this._enabled.findIndex(([f])=>f.resource===a);if(u!==-1){const f=this._enabled.splice(u,1);for(const[C,,_]of f){if(C.status!=="idle"){const O=C.conflicts.length>0;C.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(y.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(p.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};t=he([G(3,c.IUserDataSyncEnablementService),G(4,g.IInstantiationService),G(5,E.IExtensionGalleryService),G(6,c.IUserDataSyncLogService)],t);function o(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[240],ne([0,1,3,2,11,7,24]),function(K,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(E,g){this.service=E,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(E,g,S){try{return await this._call(E,g,S)}catch(d){throw this.logService.error(d),d}}async _call(E,g,S){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],L.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:L.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:L.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const d=g.substring("manualSync/".length),h=S[0],v=this.getManualSyncTask(h);switch(S=S.slice(1),d){case"preview":return v.preview();case"accept":return v.accept(L.URI.revive(S[0]),S[1]);case"merge":return v.merge(L.URI.revive(S[0]));case"discard":return v.discard(L.URI.revive(S[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const g=this.manualSyncTasks.get(this.createKey(E));if(!g)throw new Error(`Manual sync taks not found: ${E}`);return g.manualSyncTask}async createManualSyncTask(){const E=new n.DisposableStore,g=E.add(await this.service.createManualSyncTask());return E.add(g.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:S}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:E}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(E){E.dispose();const g=this.createKey(E.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=P;class b extends n.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,S,d){return E.call(g,S,d).then(null,h=>{throw A.UserDataSyncError.toUserDataSyncError(h)})},listen(g,S){return E.listen(g,S)}},this.channel.call("_getInitialData").then(([g,S,d])=>{this.updateStatus(g),this.updateConflicts(S),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([S,d])=>[S,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:g,status:S}=await this.channel.call("createManualSyncTask"),d=this,h=new I(E,g,S,{async call(v,m,w){return d.channel.call(`manualSync/${v}`,[E,...(0,T.isArray)(m)?m:[m]],w)},listen(v,m){return k.Event.map(k.Event.filter(d.channel.listen(`manualSync/${v}`,m),w=>!h.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return h}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,g,S,d){return this.channel.call("accept",[E,g,S,d])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:S,uri:d})=>({created:S,uri:L.URI.revive(d)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:S,uri:d})=>({created:S,uri:L.URI.revive(d)}))}async getAssociatedResources(E,g){return(await this.channel.call("getAssociatedResources",[E,g])).map(({resource:d,comparableResource:h})=>({resource:L.URI.revive(d),comparableResource:L.URI.revive(h)}))}async getMachineId(E,g){return this.channel.call("getMachineId",[E,g])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([g,S])=>[g,S.map(d=>({...d,localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class I extends n.Disposable{constructor(E,g,S,d){super();this.id=E,this.manifest=g,this._disposed=!1,this._status=S;const h=this;this.channel={async call(v,m,w){try{const y=await d.call(v,m,w);return h.isDiposed()||(h._status=await d.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(v,m){return d.listen(v,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,g){const S=await this.channel.call("accept",[E,g]);return this.deserializePreviews(S)}async merge(E){const g=await this.channel.call("merge",[E]);return this.deserializePreviews(g)}async discard(E){const g=await this.channel.call("discard",[E]);return this.deserializePreviews(g)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([g,S])=>[g,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(d=>({...d,localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource),acceptedResource:L.URI.revive(d.acceptedResource)}))}])}}}),define(te[241],ne([0,1,5,25,9,3,2,102,4,20,11,7,29,19,14,15,27,43,46,23,24]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",r="sync.donot-make-requests-until",l="sync.user-session-id",i="sync.machine-session-id",t=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(O,F,R){super();this.productService=O,this.configurationService=F,this.storageService=R,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(R.onDidChangeValue,N=>N.key===p.SYNC_SERVICE_URL_TYPE&&N.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[p.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=b.isWeb&&O?.web?{...O,...O.web}:O;const R={...O||{},...F||{}};if(R&&(0,D.isString)(R.url)&&(0,D.isObject)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(N=>(0,D.isArray)(R.authenticationProviders[N].scopes))){const N=R,$=!!N.canSwitch&&!F?.url,j=N.url===N.insidersUrl?"insiders":"stable",X=($?this.userDataSyncStoreType:void 0)||j,z=F?.url||(X==="insiders"?N.insidersUrl:X==="stable"?N.stableUrl:N.url);return{url:E.URI.parse(z),type:X,defaultType:j,defaultUrl:E.URI.parse(N.url),stableUrl:E.URI.parse(N.stableUrl),insidersUrl:E.URI.parse(N.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(N.authenticationProviders).reduce((J,B)=>(J.push({id:B,scopes:N.authenticationProviders[B].scopes}),J),[])}}}};s=he([G(0,v.IProductService),G(1,S.IConfigurationService),G(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(O,F,R){super(O,F,R);const N=this.storageService.get(c,0);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const $=this.productService[p.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(c,JSON.stringify($),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=he([G(0,v.IProductService),G(1,S.IConfigurationService),G(2,y.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends A.Disposable{constructor(O,F,R,N,$,j,X){super();this.requestService=R,this.logService=N,this.storageService=X,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)($,j,X).then(z=>{const J={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(J["X-Client-Commit"]=F.commit),J}),this.session=new C(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),R={},N=await this.request(F.toString(),{type:"GET",headers:R},[],n.CancellationToken.None);return(await(0,m.asJson)(N)||[]).map(({url:j,created:X})=>({ref:(0,I.relativePath)(F,F.with({path:j})),created:X*1e3}))}async resolveContent(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString(),N={};N["Cache-Control"]="no-cache";const $=await this.request(R,{type:"GET",headers:N},[],n.CancellationToken.None);return await(0,m.asText)($)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),R={};await this.request(F,{type:"DELETE",headers:R},[],n.CancellationToken.None)}async read(O,F,R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();R={...R},R["Cache-Control"]="no-cache",F&&(R["If-None-Match"]=F.ref);const $=await this.request(N,{type:"GET",headers:R},[304],n.CancellationToken.None);let j=null;if($.res.statusCode===304&&(j=F),j===null){const X=$.res.headers.etag;if(!X)throw new p.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);const z=await(0,m.asText)($);if(!z&&$.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",N,"EmptyResponse",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);j={ref:X,content:z}}return j}async write(O,F,R,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();N={...N},N["Content-Type"]=P.Mimes.text,R&&(N["If-Match"]=R);const j=await this.request($,{type:"POST",data:F,headers:N},[],n.CancellationToken.None),X=j.res.headers.etag;if(!X)throw new p.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",j.res.statusCode,j.res.headers[p.HEADER_OPERATION_ID]);return X}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const N=await this.request(R,{type:"GET",headers:F},[304],n.CancellationToken.None);let $=null;if(N.res.statusCode===304&&($=O),!$){const X=N.res.headers.etag;if(!X)throw new p.UserDataSyncStoreError("Server did not return the ref",R,"NoRef",N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);const z=await(0,m.asText)(N);if(!z&&N.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",R,"EmptyResponse",N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);z&&($={...JSON.parse(z),ref:X})}const j=this.storageService.get(l,0);return j&&$&&j!==$.session&&this.clearSession(),$===null&&j&&this.clearSession(),$&&this.storageService.store(l,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(l,0),this.storageService.remove(i,0)}async request(O,F,R,N){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;F.headers={...F.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let j;try{j=await this.session.request(O,F,N)}catch(B){if(!(B instanceof p.UserDataSyncStoreError)){let x="RequestFailed";const ee=(0,T.getErrorMessage)(B).toLowerCase();ee.includes("xhr timeout")?x="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?x="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":ee.includes("headers must be an object")?x="RequestHeadersNotObject":(0,T.isCancellationError)(B)&&(x="RequestCanceled"),B=new p.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,x,void 0,void 0)}throw this.logService.info("Request failed",O),B}const X=j.res.headers[p.HEADER_OPERATION_ID],z={url:O,status:j.res.statusCode,"execution-id":F.headers[p.HEADER_EXECUTION_ID],"operation-id":X},J=(0,m.isSuccess)(j)||j.res.statusCode&&R.indexOf(j.res.statusCode)!==-1;if(J?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new p.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",j.res.statusCode,X);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",j.res.statusCode,X);if(j.res.statusCode===410)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",j.res.statusCode,X);if(j.res.statusCode===412)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",j.res.statusCode,X);if(j.res.statusCode===413)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",j.res.statusCode,X);if(j.res.statusCode===426)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",j.res.statusCode,X);if(j.res.statusCode===429){const B=j.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",j.res.statusCode,X)):new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",j.res.statusCode,X)}if(!J)throw new p.UserDataSyncStoreError("Server returned "+j.res.statusCode,O,"Unknown",j.res.statusCode,X);return j}addSessionHeaders(O){let F=this.storageService.get(i,0);F===void 0&&(F=(0,g.generateUuid)(),this.storageService.store(i,F,0,1)),O["X-Machine-Session-Id"]=F;const R=this.storageService.get(l,0);R!==void 0&&(O["X-User-Session-Id"]=R)}};u=he([G(1,v.IProductService),G(2,m.IRequestService),G(3,p.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,h.IFileService),G(6,y.IStorageService)],u),e.UserDataSyncStoreClient=u;let f=class extends u{constructor(O,F,R,N,$,j,X){super(O.userDataSyncStore?.url,F,R,N,$,j,X);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};f=he([G(0,p.IUserDataSyncStoreManagementService),G(1,v.IProductService),G(2,m.IRequestService),G(3,p.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,h.IFileService),G(6,y.IStorageService)],f),e.UserDataSyncStoreService=f;class C{constructor(O,F,R,N){this.limit=O,this.interval=F,this.requestService=R,this.logService=N,this.requests=[],this.startTime=void 0}request(O,F,R){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,R)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=C}),define(te[242],ne([0,1,3,60,27,23,21,238,24,65,66]),function(K,e,k,n,T,L,A,P,b,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends P.UserDataAutoSyncService{constructor(S,d,h,v,m,w,y,p,c,r,l){super(S,d,h,v,m,y,p,c,r,l);this._register(k.Event.debounce(k.Event.any(k.Event.map(w.onDidFocusWindow,()=>"windowFocus"),k.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};E=he([G(0,T.IProductService),G(1,b.IUserDataSyncStoreManagementService),G(2,b.IUserDataSyncStoreService),G(3,b.IUserDataSyncEnablementService),G(4,b.IUserDataSyncService),G(5,n.INativeHostService),G(6,b.IUserDataSyncLogService),G(7,I.IUserDataSyncAccountService),G(8,A.ITelemetryService),G(9,D.IUserDataSyncMachinesService),G(10,L.IStorageService)],E),e.UserDataAutoSyncService=E}),define(te[243],ne([0,1,5,3,2]),function(K,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends T.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:b,getActiveWindowId:I}){super();this.disposables=this._register(new T.DisposableStore),n.Event.latch(n.Event.any(P,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>I()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(te[67],ne([0,1,50,5,10,11,22,125,256,257]),function(K,e,k,n,T,L,A,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(r,l){let i=l.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=l}}e.ExtractError=D;function E(c){const r=c.externalFileAttributes>>16||33188;return[448,56,7].map(l=>r&l).reduce((l,i)=>l+i,r&61440)}function g(c){if(c instanceof D)return c;let r;return/end of central directory record signature not found/.test(c.message)&&(r="CorruptZip"),new D(r,c)}function S(c,r,l,i,t,o){const s=T.dirname(r),a=T.join(i,s);if(!a.startsWith(i))return Promise.reject(new Error(P.localize(0,null,r)));const u=T.join(i,r);let f;return o.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((C,_)=>{if(!o.isCancellationRequested)try{f=(0,k.createWriteStream)(u,{mode:l}),f.once("close",()=>C()),f.once("error",_),c.once("error",_),c.pipe(f)}catch(O){_(O)}}))}function d(c,r,l,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{t.cancel(),c.close()}),new Promise((s,a)=>{const u=new n.Sequencer,f=C=>{C.isCancellationRequested||(o++,c.readEntry())};c.once("error",a),c.once("close",()=>t.then(()=>{i.isCancellationRequested||c.entryCount===o?s():a(new D("Incomplete",new Error(P.localize(1,null,o,c.entryCount))))},a)),c.readEntry(),c.on("entry",C=>{if(i.isCancellationRequested)return;if(!l.sourcePathRegex.test(C.fileName)){f(i);return}const _=C.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(_)){const R=T.join(r,_);t=(0,n.createCancelablePromise)(N=>A.Promises.mkdir(R,{recursive:!0}).then(()=>f(N)).then(void 0,a));return}const O=v(c,C),F=E(C);t=(0,n.createCancelablePromise)(R=>u.queue(()=>O.then(N=>S(N,_,F,r,l,R).then(()=>f(R)))).then(null,a))})})}function h(c,r=!1){return new Promise((l,i)=>{(0,b.open)(c,r?{lazyEntries:!0}:void 0,(t,o)=>{t?i(g(t)):l((0,L.assertIsDefined)(o))})})}function v(c,r){return new Promise((l,i)=>{c.openReadStream(r,(t,o)=>{t?i(g(t)):l((0,L.assertIsDefined)(o))})})}function m(c,r){return new Promise((l,i)=>{const t=new I.ZipFile;r.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const o=(0,k.createWriteStream)(c);t.outputStream.pipe(o),t.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>l(c))})}e.zip=m;function w(c,r,l={},i){const t=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let o=h(c,!0);return l.overwrite&&(o=o.then(s=>A.Promises.rm(r).then(()=>s))),o.then(s=>d(s,r,{sourcePathRegex:t},i))}e.extract=w;function y(c,r){return h(c).then(l=>new Promise((i,t)=>{l.on("entry",o=>{o.fileName===r&&v(l,o).then(s=>i(s),s=>t(s))}),l.once("close",()=>t(new Error(P.localize(2,null,r))))}))}function p(c,r){return y(c,r).then(l=>new Promise((i,t)=>{const o=[];l.once("error",t),l.on("data",s=>o.push(s)),l.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=p}),define(te[244],ne([0,1,67,133]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(L){return(0,k.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=T}),define(te[245],ne([0,1,16,5,9,2,18,10,4,20,62,7,29,22,67,134,14,30,31,155,61,15,8,27]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends L.Disposable{constructor(o,s,a,u,f){super();this.beforeRemovingExtension=o,this.fileService=s,this.logService=a,this.environmentService=u,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(o){const s=[];(o===null||o===0)&&s.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal)))),(o===null||o===1)&&s.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(s);return(0,k.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(o){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(u=>!s[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),o&&(a=(0,w.groupByExtension)(a,f=>f.identifier).map(f=>f.sort((C,_)=>D.rcompare(C.manifest.version,_.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(o,s,a,u){const f=o.key(),C=P.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),_=P.join(this.extensionsPath,f);try{await S.Promises.rm(_)}catch{try{await S.Promises.rm(_)}catch{}throw new m.ExtensionManagementError((0,h.localize)(0,null,_,o.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(o,s,C,u);let O=await this.scanExtension(E.URI.file(C),1);if(!O)throw new Error((0,h.localize)(1,null,C));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(o,C,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(F){try{await S.Promises.rm(C)}catch{}if(F.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",o.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(F)}. Deleted from extracted location`,C),F}try{O=await this.scanExtension(E.URI.file(_),1)}catch{}if(O)return O;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(o,s){return this.setMetadata(o,s),await this.storeMetadata(o,{...s,installedTimestamp:o.installedTimestamp}),o}async storeMetadata(o,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=P.join(o.location.fsPath,"package.json"),u=await S.Promises.readFile(a,"utf8"),{manifest:f}=await this.parseManifest(u);return f.__metadata=s,await S.Promises.writeFile(a,JSON.stringify(f,null,"	")),o}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...o){const s=o.map(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{s.forEach(u=>a[u.key()]=!0)})}async setInstalled(o){await this.withUninstalledExtensions(u=>delete u[o.key()]);const a=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(o))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(o){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let a={};if(s)try{a=JSON.parse(s)}catch{}return o&&(o(a),Object.keys(a).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await S.Promises.rm(this.uninstalledPath)),a})}async removeExtension(o,s){this.logService.trace(`Deleting ${s} extension from disk`,o.identifier.id,o.location.fsPath),await S.Promises.rm(o.location.fsPath),this.logService.info("Deleted from disk",o.identifier.id,o.location.fsPath)}async removeUninstalledExtension(o){await this.removeExtension(o,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version).key()])}async extractAtLocation(o,s,a,u){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await S.Promises.rm(a)}catch(f){throw new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(s,a,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${a}:`,o.id)}catch(f){try{await S.Promises.rm(a)}catch{}let C=m.ExtensionManagementErrorCode.Extract;throw f instanceof d.ExtractError&&(f.type==="CorruptZip"?C=m.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(C=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(f.message,C)}}async rename(o,s,a,u){try{await S.Promises.rename(s,a)}catch(f){if(b.isWindows&&f&&f.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,o.id),this.rename(o,s,a,u);throw new m.ExtensionManagementError(f.message||(0,h.localize)(3,null,s,a),f.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const o=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return o;const s=this.scanDevSystemExtensions(),[a,u]=await Promise.all([o,s]);return[...a,...u]}async scanExtensionsInDir(o,s){const a=new n.Limiter(10),u=await this.fileService.resolve(E.URI.file(o));return u.children?(await Promise.all(u.children.filter(C=>C.isDirectory).map(C=>a.queue(async()=>s===1&&(0,I.basename)(C.resource).indexOf(".")===0?null:this.scanExtension(C.resource,s))))).filter(C=>C&&C.identifier):[]}async scanExtension(o,s){try{const a=await this.fileService.resolve(o);if(a.children){const{manifest:u,metadata:f}=await this.readManifest(o.fsPath),C=a.children.find(({name:R})=>/^readme(\.txt|\.md|)$/i.test(R))?.resource,_=a.children.find(({name:R})=>/^changelog(\.txt|\.md|)$/i.test(R))?.resource,O={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},F={type:s,identifier:O,manifest:u,location:o,readmeUrl:C,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(F,f),F}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const o=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",o.length),o}async scanDevSystemExtensions(){const o=this.getDevSystemExtensionsList();if(o.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>o.some(u=>(0,w.areSameExtensions)(a.identifier,{id:u})))}else return[]}setMetadata(o,s){o.publisherDisplayName=s?.publisherDisplayName||null,o.publisherId=s?.publisherId||null,o.identifier.uuid=s?.id,o.isMachineScoped=!!s?.isMachineScoped,o.isPreReleaseVersion=!!s?.isPreReleaseVersion,o.preRelease=!!s?.preRelease,o.isBuiltin=o.type===0||!!s?.isBuiltin,o.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const o=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),a=new Set;for(const C of s)o[new w.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]||a.add(C.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(s,C=>C.identifier);await n.Promises.settled(u.map(async C=>{const _=C.sort((O,F)=>D.rcompare(O.manifest.version,F.manifest.version))[0];a.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(_)}));const f=s.filter(C=>o[new w.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]);await n.Promises.settled(f.map(C=>this.removeUninstalledExtension(C)))}async removeOutdatedExtensions(){const o=await this.scanAllUserExtensions(),s=[],a=(0,w.groupByExtension)(o,u=>u.identifier);s.push(...(0,k.flatten)(a.map(u=>u.sort((f,C)=>D.rcompare(f.manifest.version,C.manifest.version)).slice(1)))),await n.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(o=>o.name)}joinErrors(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,u)=>new Error(`${a.message}${a.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(o){const s=[S.Promises.readFile(P.join(o,"package.json"),"utf8").then(C=>this.parseManifest(C)),S.Promises.readFile(P.join(o,"package.nls.json"),"utf8").then(void 0,C=>C.code!=="ENOENT"?Promise.reject(C):"{}").then(C=>JSON.parse(C))],[{manifest:a,metadata:u},f]=await Promise.all(s);return{manifest:(0,y.localizeManifest)(a,f),metadata:u}}parseManifest(o){return new Promise((s,a)=>{try{const u=JSON.parse(o);u.publisher||(u.publisher=p.UNDEFINED_PUBLISHER);const f=u.__metadata||null;s({manifest:u,metadata:f})}catch{a(new Error((0,h.localize)(4,null)))}})}};i=he([G(1,c.IFileService),G(2,r.ILogService),G(3,v.INativeEnvironmentService),G(4,l.IProductService)],i),e.ExtensionsScanner=i}),define(te[246],ne([0,1,37,9,18,10,4,33,20,62,11,7,29,22,67,132,82,14,204,30,31,187,172,244,188,245,220,79,15,6,8,27,21,32]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c,r,l,i,t,o,s,a,u,f,C,_,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let F=class extends w.AbstractExtensionManagementService{constructor(z,J,B,x,ee,V,Z,Y,q){super(z,J,B,Y);this.environmentService=x,this.downloadService=ee,this.fileService=Z;const U=this._register(V.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(t.ExtensionsScanner,W=>U.postUninstall(W))),this.manifestCache=this._register(new i.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(V.createInstance(c.ExtensionsDownloader));const M=this._register(new o.ExtensionsWatcher(this,Z,x,B,q));this._register(M.onDidChangeExtensionsByAnotherSource(({added:W,removed:H})=>{W.length&&this._onDidInstallExtensions.fire(W.map(re=>({identifier:re.identifier,operation:1,local:re}))),H.forEach(re=>this._onDidUninstallExtension.fire({identifier:re}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const z=await this.isAlpineLinux(),J=(0,y.getTargetPlatform)(z?"alpine":A.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",J),J})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let z;try{z=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{z=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(B){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(B))}}return!!z&&(z.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const J=await this.collectFiles(z),B=await(0,d.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)()).fsPath,J);return E.URI.file(B)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const J=await this.downloadVsix(z),B=L.resolve(J.fsPath);return(0,l.getManifest)(B)}getInstalled(z=null){return this.extensionsScanner.scanExtensions(z)}async install(z,J={}){this.logService.trace("ExtensionManagementService#install",z.toString());const B=await this.downloadVsix(z),x=await(0,l.getManifest)(L.resolve(B.fsPath));if(x.engines&&x.engines.vscode&&!(0,s.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,p.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,B,J)}async updateMetadata(z,J){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const B={...z.manifest.__metadata||{},...J};return J.isPreReleaseVersion&&(B.preRelease=!0),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,B),this.manifestCache.invalidate(),z}async updateExtensionScope(z,J){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,{...z.manifest.__metadata||{},isMachineScoped:J}),this.manifestCache.invalidate(),z}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(z){if(z.scheme===T.Schemas.file)return z;const J=(0,b.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)());return await this.downloadService.download(z,J),J}createInstallExtensionTask(z,J,B){return E.URI.isUri(J)?new $(z,J,B,this.galleryService,this.extensionsScanner,this.logService):new N(J,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(z,J){return new j(z,J,this.extensionsScanner)}async collectFiles(z){const J=async x=>{let ee=await S.Promises.readdir(x);ee=ee.map(Y=>L.join(x,Y));const V=await Promise.all(ee.map(Y=>S.Promises.stat(Y)));let Z=Promise.resolve([]);return V.forEach((Y,q)=>{const U=ee[q];Y.isFile()&&(Z=Z.then(M=>[...M,U])),Y.isDirectory()&&(Z=Z.then(M=>J(U).then(W=>[...M,...W])))}),Z};return(await J(z.location.fsPath)).map(x=>({path:`extension/${L.relative(z.location.fsPath,x)}`,localPath:x}))}};F=he([G(0,y.IExtensionGalleryService),G(1,_.ITelemetryService),G(2,f.ILogService),G(3,m.INativeEnvironmentService),G(4,v.IDownloadService),G(5,u.IInstantiationService),G(6,a.IFileService),G(7,C.IProductService),G(8,O.IUriIdentityService)],F),e.ExtensionManagementService=F;class R extends w.AbstractExtensionTask{constructor(z,J,B,x){super();this.identifier=z,this.source=J,this.extensionsScanner=B,this.logService=x,this._operation=2}get operation(){return this._operation}async installExtension(z,J){try{const B=await this.unsetUninstalledAndGetLocal(z.identifierWithVersion);if(B)return z.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...z.metadata}):B}catch{throw A.isMacintosh?new y.ExtensionManagementError(h.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(h.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(z,J)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const B=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),B}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.key()]}async extract({zipPath:z,identifierWithVersion:J,metadata:B},x){let ee=await this.extensionsScanner.extractUserExtension(J,z,B,x);return this.logService.info("Extracting completed.",J.id),ee}}class N extends R{constructor(z,J,B,x,ee){super(z.identifier,z,x,ee);this.gallery=z,this.options=J,this.extensionsDownloader=B}async doRun(z){const B=(await this.extensionsScanner.scanExtensions(null)).find(ee=>(0,p.areSameExtensions)(ee.identifier,this.gallery.identifier));B&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,D.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:B?.preRelease);try{const ee=await this.installExtension(x,z);return B&&I.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B),ee}catch(ee){throw await this.deleteDownloadedVSIX(x.zipPath),ee}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(E.URI.file(z))}catch(J){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,n.getErrorMessage)(J))}}async downloadInstallableExtension(z,J){const B={id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",z.identifier.id),x=(await this.extensionsDownloader.downloadExtension(z,J)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,x)}catch(ee){throw new y.ExtensionManagementError((0,w.joinErrors)(ee).message,y.ExtensionManagementErrorCode.Download)}try{const ee=await(0,l.getManifest)(x);return{zipPath:x,identifierWithVersion:new p.ExtensionIdentifierWithVersion(z.identifier,ee.version),metadata:B}}catch(ee){throw await this.deleteDownloadedVSIX(x),new y.ExtensionManagementError((0,w.joinErrors)(ee).message,y.ExtensionManagementErrorCode.Invalid)}}}class $ extends R{constructor(z,J,B,x,ee,V){super({id:(0,p.getGalleryExtensionId)(z.publisher,z.name)},J,ee,V);this.manifest=z,this.location=J,this.options=B,this.galleryService=x}async doRun(z){const J=new p.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(V=>(0,p.areSameExtensions)(this.identifier,V.identifier)),ee=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(ee.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,ee.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,J.equals(new p.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const V=await this.unsetUninstalledAndGetLocal(J);if(V)try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:J,metadata:ee},z)}async getMetadata(z,J,B){try{let[x]=await this.galleryService.getExtensions([{id:z,version:J}],B);if(x||([x]=await this.galleryService.getExtensions([{id:z}],B)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class j extends w.AbstractExtensionTask{constructor(z,J,B){super();this.extension=z,this.options=J,this.extensionsScanner=B}async doRun(z){const J=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new p.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);J.push(...B.filter(ee=>x.equals(new p.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version))))}else J.push(...B.filter(x=>(0,p.areSameExtensions)(x.identifier,this.extension.identifier)));if(!J.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...J),this.options.remove)for(const x of J)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(ee){throw new Error(h.localize(6,null,(0,k.toErrorMessage)(ee)))}}}}),define(te[247],ne([0,1,84,56,34,17,9,3,2,10,4,29,36,74,258]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(C,_=""){this.debugLabel=_,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(C,_){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(C){const _=O=>{this.traceSocketEvent("read",O),C(L.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(C){const _=O=>{this.traceSocketEvent("close",{hadError:O}),C({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(C){const _=()=>{this.traceSocketEvent("nodeEndReceived"),C()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(C){if(!this.socket.destroyed)try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=h;var v;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var m;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(m||(m={}));class w extends b.Disposable{constructor(C,_,O,F){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new y(this,_,O,F,this._onData,(R,N)=>this._write(R,N))),this._register(this._flowManager.onError(R=>{console.error(R),(0,A.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,_){this.socket.traceSocketEvent(C,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){this._flowManager.writeMessage(C)}_write(C,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let O=2;C.byteLength<126?O+=0:C.byteLength<2**16?O+=2:O+=8;const F=L.VSBuffer.alloc(O);if(_?F.writeUInt8(194,0):F.writeUInt8(130,0),C.byteLength<126)F.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){F.writeUInt8(126,1);let R=1;F.writeUInt8(C.byteLength>>>8&255,++R),F.writeUInt8(C.byteLength>>>0&255,++R)}else{F.writeUInt8(127,1);let R=1;F.writeUInt8(0,++R),F.writeUInt8(0,++R),F.writeUInt8(0,++R),F.writeUInt8(0,++R),F.writeUInt8(C.byteLength>>>24&255,++R),F.writeUInt8(C.byteLength>>>16&255,++R),F.writeUInt8(C.byteLength>>>8&255,++R),F.writeUInt8(C.byteLength>>>0&255,++R)}this.socket.write(L.VSBuffer.concat([F,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),F=(O&128)>>>7,R=(O&64)>>>6,N=_.readUInt8(1),$=(N&128)>>>7,j=N&127;this._state.state=2,this._state.readLen=2+($?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),F=(O&128)>>>7;let R=O&127,N=1;R===126?R=_.readUInt8(++N)*2**8+_.readUInt8(++N):R===127&&(R=_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N));let $=0;F&&($=_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class y extends b.Disposable{constructor(C,_,O,F,R,N){super();this._tracer=C,this._onData=R,this._writeFn=N,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new p(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(C){this._writeQueue.push(C),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const C=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(_,!0)}else this._writeFn(C,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,_){return new Promise((O,F)=>{C.write(_),C.flush(R=>O(R))})}acceptFrame(C,_,O){this._readQueue.push({data:C,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1}}_inflateFrame(C,_,O){return new Promise((F,R)=>{C.write(_),O&&C.write(L.VSBuffer.fromByteArray([0,0,255,255])),C.flush(N=>F(N))})}}class p extends b.Disposable{constructor(C,_,O,F){super();this._tracer=C,this._recordInflateBytes=_,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(F),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(L.VSBuffer.wrap(R))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(_)})}}class c extends b.Disposable{constructor(C,_){super();this._tracer=C,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(L.VSBuffer.wrap(O))})}write(C){this._tracer.traceSocketEvent("zlibDeflateWrite",C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),C(_)})}}function r(f,C){if(C===0)return;let _=f.byteLength>>>2;for(let j=0;j<_;j++){const X=f.readUInt32BE(j*4);f.writeUInt32BE(X^C,j*4)}let O=_*4,F=f.byteLength-O;const R=C>>>24&255,N=C>>>16&255,$=C>>>8&255;F>=1&&f.writeUInt8(f.readUInt8(O)^R,O),F>=2&&f.writeUInt8(f.readUInt8(O+1)^N,O+1),F>=3&&f.writeUInt8(f.readUInt8(O+2)^$,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function i(){const f=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let C;return e.XDG_RUNTIME_DIR?C=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):C=(0,I.join)((0,T.tmpdir)(),`vscode-ipc-${f}.sock`),o(C),C}e.createRandomIPCHandle=i;function t(f,C,_){const O=(0,k.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${C}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${C}.sock`):F=(0,I.join)(f,`${_}-${C}.sock`),o(F),F}e.createStaticIPCHandle=t;function o(f){const C=l[D.platform];typeof C=="number"&&f.length>=C&&console.warn(`WARNING: IPC handle "${f}" is longer than ${C} chars, try a shorter --user-data-dir`)}class s extends g.IPCServer{constructor(C){super(s.toClientConnectionEvent(C));this.server=C}static toClientConnectionEvent(C){const _=P.Event.fromNodeEventEmitter(C,"connection");return P.Event.map(_,O=>({protocol:new S.Protocol(new h(O,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(f){return new Promise((C,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(f,()=>{O.removeListener("error",_),C(new s(O))})})}e.serve=a;function u(f,C){return new Promise((_,O)=>{const F=(0,n.createConnection)(f,()=>{F.removeListener("error",O),_(S.Client.fromSocket(new h(F,`ipc-client${C}`),C))});F.once("error",O)})}e.connect=u}),define(te[248],ne([0,1,56,247]),function(K,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(T,L,A,P,b){const I=E=>b(E,void 0),D=k.createConnection({host:T,port:L},()=>{D.removeListener("error",I);const E=Buffer.alloc(16);for(let h=0;h<16;h++)E[h]=Math.round(Math.random()*256);const g=E.toString("base64"),S=[`GET ws://${/:/.test(T)?`[${T}]`:T}:${L}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];D.write(S.join(`\r
`)+`\r
\r
`);const d=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(D.off("data",d),b(void 0,new n.NodeSocket(D,P)))};D.on("data",d)});D.setNoDelay(!0),D.once("error",I)}}}),define(te[249],ne([0,1,56,115,248,5,2,19,8,27,183,64,92]),function(K,e,k,n,T,L,A,P,b,I,D,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,y,p,c,r){let l;for(let i=3;i&&(l&&l.dispose(),l=await new d(w,y,p,c,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));i--);return l}class d extends A.Disposable{constructor(y,p,c,r,l){super();this.defaultTunnelHost=p,this.suggestedLocalPort=l,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=k.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let y=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(y){y.pause();const p=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,D.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),r=c.getSocket().socket,l=c.readEntireBuffer();c.dispose(),l.byteLength>0&&y.write(l.buffer),y.on("end",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),r.end()}),y.on("close",()=>r.end()),y.on("error",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),r.destroy()}),r.on("end",()=>y.end()),r.on("close",()=>y.end()),r.on("error",()=>{y.destroy()}),y.pipe(r),r.pipe(y),y.localAddress&&this._socketsDispose.set(y.localAddress,()=>{y.end(),r.end()})}}let h=class extends E.AbstractTunnelService{constructor(y,p,c,r,l){super(p);this.socketFactory=y,this.signService=c,this.productService=r,this.configurationService=l}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,p,c,r,l,i,t){const o=this.getTunnelFromMap(p,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,c,r,l,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${c} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},a=S(s,this.defaultTunnelHost,p,c,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,c,a),a}}};h=he([G(1,b.ILogService),G(2,g.ISignService),G(3,I.IProductService),G(4,P.IConfigurationService)],h),e.BaseTunnelService=h;let v=class extends h{constructor(y,p,c,r){super(T.nodeSocketFactory,y,p,c,r)}};v=he([G(0,b.ILogService),G(1,g.ISignService),G(2,I.IProductService),G(3,P.IConfigurationService)],v),e.TunnelService=v;let m=class extends A.Disposable{constructor(y,p,c,r){super();this.logService=y,this.productService=p,this.signService=c,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(y,p,c,r,l,i,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${r} on local port ${l}.`),!this._tunnelServices.has(y)){const s=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(y,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(y))})}return this._tunnelServices.get(y).openTunnel(p,c,r,l,i,t,o)}};m=he([G(0,b.ILogService),G(1,I.IProductService),G(2,g.ISignService),G(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[259],ne([0,1,75,34,37,9,2,18,20,7,36,118,177,199,178,169,170,171,158,160,19,181,81,203,82,192,14,196,198,207,30,185,205,246,83,156,15,174,176,51,6,166,86,167,168,59,189,8,87,60,88,27,191,43,23,201,202,21,93,94,95,47,208,209,96,211,218,63,98,24,65,234,236,237,66,235,239,240,241,242,243,92,197,64,249,190,219,91,195,32,221,4,222,161,180,179]),function(K,e,k,n,T,L,A,P,b,I,D,E,g,S,d,h,v,m,w,y,p,c,r,l,i,t,o,s,a,u,f,C,_,O,F,R,N,$,j,X,z,J,B,x,ee,V,Z,Y,q,U,M,W,H,re,se,ue,de,we,pe,ge,Ee,Te,Ce,De,qe,Je,Ve,je,ie,ae,le,ye,be,Ue,Le,Oe,_e,Q,oe,ce,fe,me,ke,Se,Pe,Re,Ie,Ae,Fe,ze,We,Et,bt,gt,Ct,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class It extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",$e=(He,Ne)=>this.onDisposeWorker(Ne);k.ipcRenderer.on(Me,$e),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Me,$e)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Me=>{const $e=Me.get(Y.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(ve.createInstance(g.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(d.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(h.LocalizationsUpdater),ve.createInstance(S.ExtensionsCleaner)))}async initServices(){const ve=new B.ServiceCollection,Me={_serviceBrand:void 0,...M.default};ve.set(W.IProductService,Me);const $e=new D.StaticRouter(Be=>Be==="main"),He=new x.MessagePortMainProcessService(this.server,$e);ve.set(ee.IMainProcessService,He);const Ne=new s.SharedProcessEnvironmentService(this.configuration.args,Me);ve.set(o.INativeEnvironmentService,Ne);const it=new q.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Qe=new q.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,He.getChannel("logger"));ve.set(Y.ILoggerService,Qe);const st=this._register(new Y.MultiplexLogService([this._register(new Y.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,b.joinPath)(I.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new q.FollowerLogService(it,st));ve.set(Y.ILogService,Ge),this.sharedProcessWorkerService=new Fe.SharedProcessWorkerService(Ge),ve.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ke=this._register(new $.FileService(Ge));ve.set(N.IFileService,Ke);const ot=this._register(new j.DiskFileSystemProvider(Ge));Ke.registerProvider(P.Schemas.file,ot);const at=this._register(new bt.FileUserDataProvider(P.Schemas.file,this._register(new gt.DiskFileSystemProviderClient(He.getChannel(gt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Et.isLinux})),P.Schemas.userData,Ge));Ke.registerProvider(P.Schemas.userData,at);const Ye=this._register(new c.ConfigurationService(Ne.settingsResource,Ke));ve.set(p.IConfigurationService,Ye);const et=new ue.NativeStorageService(void 0,He,Ne);ve.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]),ve.set(ze.IUriIdentityService,new We.UriIdentityService(Ke)),ve.set(re.IRequestService,new X.SyncDescriptor(H.RequestService)),ve.set(w.IChecksumService,new X.SyncDescriptor(y.ChecksumService)),ve.set(mt.IV8InspectProfilingService,new X.SyncDescriptor(Ct.InspectProfilingService));const rt=D.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(U.INativeHostService,rt),ve.set(i.IDownloadService,new X.SyncDescriptor(t.DownloadService));const ct=this._register(new fe.ActiveWindowManager(rt)),lt=new D.StaticRouter(Be=>ct.getActiveClientId().then(ut=>Be===ut));ve.set(F.IExtensionRecommendationNotificationService,new R.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Xe;const tt=[];if((0,Te.supportsTelemetry)(Me,Ne)){const Be=new ge.TelemetryLogAppender(Qe,Ne);tt.push(Be);const{installSourcePath:ut}=Ne;if(Me.aiConfig&&Me.aiConfig.asimovKey){const St=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>St.flush())),tt.push(St)}Xe=new Ee.TelemetryService({appenders:tt,commonProperties:(0,de.resolveCommonProperties)(Ke,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,ut),sendErrorTelemetry:!0,piiPaths:(0,Te.getPiiPathsFromEnvironment)(Ne)},Ye)}else{Xe=Te.NullTelemetryService;const Be=Te.NullAppender;tt.push(Be)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(tt)),ve.set(we.ITelemetryService,Xe);const Rt=new De.CustomEndpointTelemetryService(Ye,Xe,Qe,Ne);ve.set(we.ICustomEndpointTelemetryService,Rt),ve.set(f.IExtensionManagementService,new X.SyncDescriptor(O.ExtensionManagementService)),ve.set(f.IExtensionGalleryService,new X.SyncDescriptor(u.ExtensionGalleryService)),ve.set(f.IExtensionTipsService,new X.SyncDescriptor(_.ExtensionTipsService)),ve.set(V.ILocalizationsService,new X.SyncDescriptor(Z.LocalizationsService)),ve.set(r.IDiagnosticsService,new X.SyncDescriptor(l.DiagnosticsService)),ve.set(le.IUserDataSyncAccountService,new X.SyncDescriptor(le.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new X.SyncDescriptor(Ue.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(f.IGlobalExtensionEnablementService,new X.SyncDescriptor(a.GlobalExtensionEnablementService)),ve.set(ie.IIgnoredExtensionsManagementService,new X.SyncDescriptor(ie.IgnoredExtensionsManagementService)),ve.set(je.IExtensionStorageService,new X.SyncDescriptor(je.ExtensionStorageService)),ve.set(ae.IUserDataSyncStoreManagementService,new X.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new X.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(Le.IUserDataSyncMachinesService,new X.SyncDescriptor(Le.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new X.SyncDescriptor(ye.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataSyncEnablementService,new X.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ae.IUserDataSyncService,new X.SyncDescriptor(_e.UserDataSyncService));const pt=new Ve.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,Ne,Ge);return await pt.initialize(),ve.set(Je.ILocalPtyService,this._register(pt)),ve.set(me.ISignService,new X.SyncDescriptor(ke.SignService)),ve.set(Se.ISharedTunnelsService,new X.SyncDescriptor(Pe.SharedTunnelsService)),ve.set(Re.ISharedProcessTunnelService,new X.SyncDescriptor(Ie.SharedProcessTunnelService)),new J.InstantiationService(ve)}initChannels(ve){const Me=new C.ExtensionManagementChannel(ve.get(f.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const $e=D.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",$e);const He=D.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const Ne=new C.ExtensionTipsChannel(ve.get(f.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const it=D.ProxyChannel.fromService(ve.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Qe=D.ProxyChannel.fromService(ve.get(mt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Qe);const st=new be.UserDataSyncMachinesServiceChannel(ve.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",st);const Ge=D.ProxyChannel.fromService(ve.get(we.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Ke=new be.UserDataSyncAccountServiceChannel(ve.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const ot=new be.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ot);const at=new Q.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(Y.ILogService));this.server.registerChannel("userDataSync",at);const Ye=this._register(ve.get(z.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),et=new be.UserDataAutoSyncChannel(Ye);this.server.registerChannel("userDataAutoSync",et);const rt=ve.get(Je.ILocalPtyService),ct=D.ProxyChannel.fromService(rt);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,ct);const lt=D.ProxyChannel.fromService(ve.get(Re.ISharedProcessTunnelService));this.server.registerChannel(Re.ipcSharedProcessTunnelChannelName,lt);const Xe=D.ProxyChannel.fromService(ve.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,L.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Me=>{const $e=(0,T.toErrorMessage)(Me,!0);!$e||ve.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Pt(vt){const ve=new It(vt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Pt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/45b4204501ac1f50b6231af3c996d35f86359ecd/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
