/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/terminal/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],Z=function(H){for(var e=[],w=0,n=H.length;w<n;w++)e[w]=J[H[w]];return e};define(J[106],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(n,R){if(!n)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=w}),define(J[107],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(M){return M?M.replace(/\$\((.*?)\)/g,(b,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=w;class n{constructor(b,d,E){this.id=b,this.definition=d,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function R(M,b){const d=["codicon","codicon-"+M];return b&&d.push("codicon-modifier-"+b),d}e.getClassNamesArray=R;var D;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function d(k){if(k instanceof n)return["codicon","codicon-"+k.id];const I=b.exec(k.id);if(!I)return d(n.error);let[,p,t]=I;const h=["codicon","codicon-"+p];return t&&h.push("codicon-modifier-"+t.substr(1)),h}M.asClassNameArray=d;function E(k){return d(k).join(" ")}M.asClassName=E;function P(k){return"."+d(k).join(".")}M.asCSSSelector=P})(D=e.CSSIcon||(e.CSSIcon={}))}),define(J[46],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(M){return(b,d,E)=>{let P=null,k=null;if(typeof E.value=="function"?(P="value",k=E.value):typeof E.get=="function"&&(P="get",k=E.get),!k)throw new Error("not supported");E[P]=M(k,d)}}e.createDecorator=w;function n(M,b,d){let E=null,P=null;if(typeof d.value=="function"?(E="value",P=d.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(E="get",P=d.get),!P)throw new Error("not supported");const k=`$memoize$${b}`;d[E]=function(...I){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,I)}),this[k]}}e.memoize=n;function R(M,b,d){return w((E,P)=>{const k=`$debounce$${P}`,I=`$debounce$result$${P}`;return function(...p){this[I]||(this[I]=d?d():void 0),clearTimeout(this[k]),b&&(this[I]=b(this[I],...p),p=[this[I]]),this[k]=setTimeout(()=>{E.apply(this,p),this[I]=d?d():void 0},M)}})}e.debounce=R;function D(M,b,d){return w((E,P)=>{const k=`$throttle$timer$${P}`,I=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,t=`$throttle$pending$${P}`;return function(...h){if(this[I]||(this[I]=d?d():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),b&&(this[I]=b(this[I],...h)),this[t])return;const f=this[p]+M;f<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[I]]),this[I]=d?d():void 0):(this[t]=!0,this[k]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),E.apply(this,[this[I]]),this[I]=d?d():void 0},f-Date.now()))}})}e.throttle=D}),define(J[15],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(a=>{a(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=w,e.errorHandler=new w;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function R(u){d(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=R;function D(u){d(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=D;function M(u){if(u instanceof Error){let{name:c,message:a}=u;const g=u.stacktrace||u.stack;return{$isError:!0,name:c,message:a,stack:g}}return u}e.transformErrorForSerialization=M;const b="Canceled";function d(u){return u instanceof E?!0:u instanceof Error&&u.name===b&&u.message===b}e.isCancellationError=d;class E extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=E;function P(){const u=new Error(b);return u.name=u.message,u}e.canceled=P;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function I(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=I;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(u){const c=new Error(`${u} has been disposed`);return c.name="DISPOSED",c}e.disposed=t;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=h;class f extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=f;class v extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=v;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;class m extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=m}),define(J[30],Z([0,1,15]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(W,A=0){return W[W.length-(1+A)]}e.tail=n;function R(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=R;function D(W,A,F=(N,K)=>N===K){if(W===A)return!0;if(!W||!A||W.length!==A.length)return!1;for(let N=0,K=W.length;N<K;N++)if(!F(W[N],A[N]))return!1;return!0}e.equals=D;function M(W,A,F){let N=0,K=W.length-1;for(;N<=K;){const se=(N+K)/2|0,ae=F(W[se],A);if(ae<0)N=se+1;else if(ae>0)K=se-1;else return se}return-(N+1)}e.binarySearch=M;function b(W,A){let F=0,N=W.length;if(N===0)return 0;for(;F<N;){const K=Math.floor((F+N)/2);A(W[K])?N=K:F=K+1}return F}e.findFirstInSorted=b;function d(W,A,F){if(W=W|0,W>=A.length)throw new TypeError("invalid index");let N=A[Math.floor(A.length*Math.random())],K=[],se=[],ae=[];for(let ce of A){const ne=F(ce,N);ne<0?K.push(ce):ne>0?se.push(ce):ae.push(ce)}return W<K.length?d(W,K,F):W<K.length+ae.length?ae[0]:d(W-(K.length+ae.length),se,F)}e.quickSelect=d;function E(W,A){const F=[];let N;for(const K of W.slice(0).sort(A))!N||A(N[0],K)!==0?(N=[K],F.push(N)):N.push(K);return F}e.groupBy=E;function P(W,A,F){const N=[];function K(ce,ne,le){if(ne===0&&le.length===0)return;const he=N[N.length-1];he&&he.start+he.deleteCount===ce?(he.deleteCount+=ne,he.toInsert.push(...le)):N.push({start:ce,deleteCount:ne,toInsert:le})}let se=0,ae=0;for(;;){if(se===W.length){K(se,0,A.slice(ae));break}if(ae===A.length){K(se,W.length-se,[]);break}const ce=W[se],ne=A[ae],le=F(ce,ne);le===0?(se+=1,ae+=1):le<0?(K(se,1,[]),se+=1):le>0&&(K(se,0,[ne]),ae+=1)}return N}e.sortedDiff=P;function k(W,A,F){const N=P(W,A,F),K=[],se=[];for(const ae of N)K.push(...W.slice(ae.start,ae.start+ae.deleteCount)),se.push(...ae.toInsert);return{removed:K,added:se}}e.delta=k;function I(W,A,F){if(F===0)return[];const N=W.slice(0,F).sort(A);return t(W,A,N,F,W.length),N}e.top=I;function p(W,A,F,N,K){return F===0?Promise.resolve([]):new Promise((se,ae)=>{(async()=>{const ce=W.length,ne=W.slice(0,F).sort(A);for(let le=F,he=Math.min(F+N,ce);le<ce;le=he,he=Math.min(he+N,ce)){if(le>F&&await new Promise(we=>setTimeout(we)),K&&K.isCancellationRequested)throw(0,w.canceled)();t(W,A,ne,le,he)}return ne})().then(se,ae)})}e.topAsync=p;function t(W,A,F,N,K){for(const se=F.length;N<K;N++){const ae=W[N];if(A(ae,F[se-1])<0){F.pop();const ce=b(F,ne=>A(ae,ne)<0);F.splice(ce,0,ae)}}}function h(W){return W.filter(A=>!!A)}e.coalesce=h;function f(W){let A=0;for(let F=0;F<W.length;F++)W[F]&&(W[A]=W[F],A+=1);W.length=A}e.coalesceInPlace=f;function v(W,A,F){W.splice(F,0,W.splice(A,1)[0])}e.move=v;function C(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=C;function m(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=m;function u(W,A=F=>F){const F=new Set;return W.filter(N=>{const K=A(N);return F.has(K)?!1:(F.add(K),!0)})}e.distinct=u;function c(W){const A=new Set;return F=>{const N=W(F);return A.has(N)?!1:(A.add(N),!0)}}e.uniqueFilter=c;function a(W,A){const F=g(W,A);if(F!==-1)return W[F]}e.findLast=a;function g(W,A){for(let F=W.length-1;F>=0;F--){const N=W[F];if(A(N))return F}return-1}e.lastIndex=g;function r(W,A){return W.length>0?W[0]:A}e.firstOrDefault=r;function i(W,A,F=(N,K)=>N===K){let N=0;for(let K=0,se=Math.min(W.length,A.length);K<se&&F(W[K],A[K]);K++)N++;return N}e.commonPrefixLength=i;function s(W){return[].concat(...W)}e.flatten=s;function o(W,A){let F=typeof A=="number"?W:0;typeof A=="number"?F=W:(F=0,A=W);const N=[];if(F<=A)for(let K=F;K<A;K++)N.push(K);else for(let K=F;K>A;K--)N.push(K);return N}e.range=o;function l(W,A,F){return W.reduce((N,K)=>(N[A(K)]=F?F(K):K,N),Object.create(null))}e.index=l;function y(W,A){return W.push(A),()=>S(W,A)}e.insert=y;function S(W,A){const F=W.indexOf(A);if(F>-1)return W.splice(F,1),A}e.remove=S;function L(W,A,F){const N=W.slice(0,A),K=W.slice(A);return N.concat(F,K)}e.arrayInsert=L;function T(W,A){let F;if(typeof A=="number"){let N=A;F=()=>{const K=Math.sin(N++)*179426549;return K-Math.floor(K)}}else F=Math.random;for(let N=W.length-1;N>0;N-=1){const K=Math.floor(F()*(N+1)),se=W[N];W[N]=W[K],W[K]=se}}e.shuffle=T;function B(W,A){const F=W.indexOf(A);F>-1&&(W.splice(F,1),W.unshift(A))}e.pushToStart=B;function Y(W,A){const F=W.indexOf(A);F>-1&&(W.splice(F,1),W.push(A))}e.pushToEnd=Y;function ee(W,A){return Array.isArray(W)?W.map(A):A(W)}e.mapArrayOrNot=ee;function te(W){return Array.isArray(W)?W:[W]}e.asArray=te;function Q(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=Q;function q(W,A){for(const F of W){const N=A(F);if(N!==void 0)return N}}e.mapFind=q;function G(W,A,F){const N=x(W,A),K=W.length,se=F.length;W.length=K+se;for(let ae=K-1;ae>=N;ae--)W[ae+se]=W[ae];for(let ae=0;ae<se;ae++)W[ae+N]=F[ae]}e.insertInto=G;function _(W,A,F,N){const K=x(W,A),se=W.splice(K,F);return G(W,K,N),se}e.splice=_;function x(W,A){return A<0?Math.max(A+W.length,0):Math.min(A,W.length)}function $(W,A){return(F,N)=>A(W(F),W(N))}e.compareBy=$;const V=(W,A)=>W-A;e.numberComparator=V;function X(W,A){if(W.length===0)return;let F=W[0];for(let N=1;N<W.length;N++){const K=W[N];A(K,F)>0&&(F=K)}return F}e.findMaxBy=X;function z(W,A){if(W.length===0)return;let F=W[0];for(let N=1;N<W.length;N++){const K=W[N];A(K,F)>=0&&(F=K)}return F}e.findLastMaxBy=z;function O(W,A){return X(W,(F,N)=>-A(F,N))}e.findMinBy=O;class U{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let F=this.firstIdx;for(;F<this.items.length&&A(this.items[F]);)F++;const N=F===this.firstIdx?null:this.items.slice(this.firstIdx,F);return this.firstIdx=F,N}takeFromEndWhile(A){let F=this.lastIdx;for(;F>=0&&A(this.items[F]);)F--;const N=F===this.lastIdx?null:this.items.slice(F+1,this.lastIdx+1);return this.lastIdx=F,N}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const F=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,F}}e.ArrayQueue=U}),define(J[43],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(n){const R=this;let D=!1,M;return function(){return D||(D=!0,M=n.apply(R,arguments)),M}}e.once=w}),define(J[68],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(n){function R(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=R;const D=Object.freeze([]);function M(){return D}n.empty=M;function*b(c){yield c}n.single=b;function d(c){return c||D}n.from=d;function E(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(c){return c[Symbol.iterator]().next().value}n.first=P;function k(c,a){for(const g of c)if(a(g))return!0;return!1}n.some=k;function I(c,a){for(const g of c)if(a(g))return g}n.find=I;function*p(c,a){for(const g of c)a(g)&&(yield g)}n.filter=p;function*t(c,a){let g=0;for(const r of c)yield a(r,g++)}n.map=t;function*h(...c){for(const a of c)for(const g of a)yield g}n.concat=h;function*f(c){for(const a of c)for(const g of a)yield g}n.concatNested=f;function v(c,a,g){let r=g;for(const i of c)r=a(r,i);return r}n.reduce=v;function*C(c,a,g=c.length){for(a<0&&(a+=c.length),g<0?g+=c.length:g>c.length&&(g=c.length);a<g;a++)yield c[a]}n.slice=C;function m(c,a=Number.POSITIVE_INFINITY){const g=[];if(a===0)return[g,c];const r=c[Symbol.iterator]();for(let i=0;i<a;i++){const s=r.next();if(s.done)return[g,n.empty()];g.push(s.value)}return[g,{[Symbol.iterator](){return r}}]}n.consume=m;function u(c,a,g=(r,i)=>r===i){const r=c[Symbol.iterator](),i=a[Symbol.iterator]();for(;;){const s=r.next(),o=i.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!g(s.value,o.value))return!1}}n.equals=u})(w=e.Iterable||(e.Iterable={}))}),define(J[44],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var n;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(a){a.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function M(a,g=!1){let r=0,i=a.length,s="",o=0,l=16,y=0;function S(Q){let q=0,G=0;for(;q<Q;){const _=a.charCodeAt(r);if(_>=48&&_<=57)G=G*16+_-48;else if(_>=65&&_<=70)G=G*16+_-65+10;else if(_>=97&&_<=102)G=G*16+_-97+10;else break;r++,q++}return q<Q&&(G=-1),G}function L(Q){r=Q,s="",o=0,l=16,y=0}function T(){const Q=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&E(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&E(a.charCodeAt(r)))for(r++;r<a.length&&E(a.charCodeAt(r));)r++;else return y=3,a.substring(Q,r);let q=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&E(a.charCodeAt(r))){for(r++;r<a.length&&E(a.charCodeAt(r));)r++;q=r}else y=3;return a.substring(Q,q)}function B(){let Q="",q=r;for(;;){if(r>=i){Q+=a.substring(q,r),y=2;break}const G=a.charCodeAt(r);if(G===34){Q+=a.substring(q,r),r++;break}if(G===92){if(Q+=a.substring(q,r),r++,r>=i){y=2;break}switch(a.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const x=S(4);x>=0?Q+=String.fromCharCode(x):y=4;break}default:y=5}q=r;continue}if(G>=0&&G<=31)if(d(G)){Q+=a.substring(q,r),y=2;break}else y=6;r++}return Q}function Y(){if(s="",y=0,o=r,r>=i)return o=i,l=17;let Q=a.charCodeAt(r);if(b(Q)){do r++,s+=String.fromCharCode(Q),Q=a.charCodeAt(r);while(b(Q));return l=15}if(d(Q))return r++,s+=String.fromCharCode(Q),Q===13&&a.charCodeAt(r)===10&&(r++,s+=`
`),l=14;switch(Q){case 123:return r++,l=1;case 125:return r++,l=2;case 91:return r++,l=3;case 93:return r++,l=4;case 58:return r++,l=6;case 44:return r++,l=5;case 34:return r++,s=B(),l=10;case 47:{const q=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(a.charCodeAt(r));)r++;return s=a.substring(q,r),l=12}if(a.charCodeAt(r+1)===42){r+=2;const G=i-1;let _=!1;for(;r<G;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,_=!0;break}r++}return _||(r++,y=1),s=a.substring(q,r),l=13}return s+=String.fromCharCode(Q),r++,l=16}case 45:if(s+=String.fromCharCode(Q),r++,r===i||!E(a.charCodeAt(r)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),l=11;default:for(;r<i&&ee(Q);)r++,Q=a.charCodeAt(r);if(o!==r){switch(s=a.substring(o,r),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(Q),r++,l=16}}function ee(Q){if(b(Q)||d(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let Q;do Q=Y();while(Q>=12&&Q<=15);return Q}return{setPosition:L,getPosition:()=>r,scan:g?te:Y,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>y}}e.createScanner=M;function b(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function d(a){return a===10||a===13||a===8232||a===8233}function E(a){return a>=48&&a<=57}var P;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(P||(P={}));function k(a,g){const r=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function y(S,L,T,B){o.value=S,o.offset=L,o.length=T,o.type=B,o.colonOffset=void 0,s=o}try{m(a,{onObjectBegin:(S,L)=>{if(g<=S)throw i;s=void 0,l=g>S,r.push("")},onObjectProperty:(S,L,T)=>{if(g<L||(y(S,L,T,"property"),r[r.length-1]=S,g<=L+T))throw i},onObjectEnd:(S,L)=>{if(g<=S)throw i;s=void 0,r.pop()},onArrayBegin:(S,L)=>{if(g<=S)throw i;s=void 0,r.push(0)},onArrayEnd:(S,L)=>{if(g<=S)throw i;s=void 0,r.pop()},onLiteralValue:(S,L,T)=>{if(g<L||(y(S,L,T,c(S)),g<=L+T))throw i},onSeparator:(S,L,T)=>{if(g<=L)throw i;if(S===":"&&s&&s.type==="property")s.colonOffset=L,l=!1,s=void 0;else if(S===","){const B=r[r.length-1];typeof B=="number"?r[r.length-1]=B+1:(l=!0,r[r.length-1]=""),s=void 0}}})}catch(S){if(S!==i)throw S}return{path:r,previousNode:s,isAtPropertyKey:l,matches:S=>{let L=0;for(let T=0;L<S.length&&T<r.length;T++)if(S[L]===r[T]||S[L]==="*")L++;else if(S[L]!=="**")return!1;return L===S.length}}}e.getLocation=k;function I(a,g=[],r=D.DEFAULT){let i=null,s=[];const o=[];function l(S){Array.isArray(s)?s.push(S):i!==null&&(s[i]=S)}return m(a,{onObjectBegin:()=>{const S={};l(S),o.push(s),s=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const S=[];l(S),o.push(s),s=S,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(S,L,T)=>{g.push({error:S,offset:L,length:T})}},r),s[0]}e.parse=I;function p(a,g=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function o(S){return i.children.push(S),S}m(a,{onObjectBegin:S=>{i=o({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,L,T)=>{i=o({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:L,length:T,parent:i})},onObjectEnd:(S,L)=>{i.length=S+L-i.offset,i=i.parent,s(S+L)},onArrayBegin:(S,L)=>{i=o({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,L)=>{i.length=S+L-i.offset,i=i.parent,s(S+L)},onLiteralValue:(S,L,T)=>{o({type:c(S),offset:L,length:T,parent:i,value:S}),s(L+T)},onSeparator:(S,L,T)=>{i.type==="property"&&(S===":"?i.colonOffset=L:S===","&&s(L))},onError:(S,L,T)=>{g.push({error:S,offset:L,length:T})}},r);const y=i.children[0];return y&&delete y.parent,y}e.parseTree=p;function t(a,g){if(!a)return;let r=a;for(let i of g)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=t;function h(a){if(!a.parent||!a.parent.children)return[];const g=h(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;g.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&g.push(r)}return g}e.getNodePath=h;function f(a){switch(a.type){case"array":return a.children.map(f);case"object":{const g=Object.create(null);for(let r of a.children){const i=r.children[1];i&&(g[r.children[0].value]=f(i))}return g}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=f;function v(a,g,r=!1){return g>=a.offset&&g<a.offset+a.length||r&&g===a.offset+a.length}e.contains=v;function C(a,g,r=!1){if(v(a,g,r)){const i=a.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=g;s++){const o=C(i[s],g,r);if(o)return o}return a}}e.findNodeAtOffset=C;function m(a,g,r=D.DEFAULT){const i=M(a,!1);function s(U){return U?()=>U(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(U){return U?W=>U(W,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=s(g.onObjectBegin),y=o(g.onObjectProperty),S=s(g.onObjectEnd),L=s(g.onArrayBegin),T=s(g.onArrayEnd),B=o(g.onLiteralValue),Y=o(g.onSeparator),ee=s(g.onComment),te=o(g.onError),Q=r&&r.disallowComments,q=r&&r.allowTrailingComma;function G(){for(;;){const U=i.scan();switch(i.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:Q||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(U){case 12:case 13:Q?_(10):ee();break;case 16:_(1);break;case 15:case 14:break;default:return U}}}function _(U,W=[],A=[]){if(te(U),W.length+A.length>0){let F=i.getToken();for(;F!==17;){if(W.indexOf(F)!==-1){G();break}else if(A.indexOf(F)!==-1)break;F=G()}}}function x(U){const W=i.getTokenValue();return U?B(W):y(W),G(),!0}function $(){switch(i.getToken()){case 11:{let U=0;try{U=JSON.parse(i.getTokenValue()),typeof U!="number"&&(_(2),U=0)}catch{_(2)}B(U);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return G(),!0}function V(){return i.getToken()!==10?(_(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(Y(":"),G(),O()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function X(){l(),G();let U=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(U||_(4,[],[]),Y(","),G(),i.getToken()===2&&q)break}else U&&_(6,[],[]);V()||_(4,[],[2,5]),U=!0}return S(),i.getToken()!==2?_(7,[2],[]):G(),!0}function z(){L(),G();let U=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(U||_(4,[],[]),Y(","),G(),i.getToken()===4&&q)break}else U&&_(6,[],[]);O()||_(4,[],[4,5]),U=!0}return T(),i.getToken()!==4?_(8,[4],[]):G(),!0}function O(){switch(i.getToken()){case 3:return z();case 1:return X();case 10:return x(!0);default:return $()}}return G(),i.getToken()===17?r.allowEmptyContent?!0:(_(4,[],[]),!1):O()?(i.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}e.visit=m;function u(a,g){let r=M(a),i=[],s,o=0,l;do switch(l=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:o!==l&&i.push(a.substring(o,l)),g!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,g)),o=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=u;function c(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[108],Z([0,1,44]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,k){let I,p,t,h,f;if(P){for(h=P.offset,f=h+P.length,t=h;t>0&&!d(E,t-1);)t--;let l=f;for(;l<E.length&&!d(E,l);)l++;p=E.substring(t,l),I=M(p,k)}else p=E,I=0,t=0,h=0,f=E.length;const v=b(k,E);let C=!1,m=0,u;k.insertSpaces?u=D(" ",k.tabSize||4):u="	";const c=(0,w.createScanner)(p,!1);let a=!1;function g(){return v+D(u,I+m)}function r(){let l=c.scan();for(C=!1;l===15||l===14;)C=C||l===14,l=c.scan();return a=l===16||c.getTokenError()!==0,l}const i=[];function s(l,y,S){!a&&y<f&&S>h&&E.substring(y,S)!==l&&i.push({offset:y,length:S-y,content:l})}let o=r();if(o!==17){const l=c.getTokenOffset()+t,y=D(u,I);s(y,t,l)}for(;o!==17;){let l=c.getTokenOffset()+c.getTokenLength()+t,y=r(),S="";for(;!C&&(y===12||y===13);){const T=c.getTokenOffset()+t;s(" ",l,T),l=c.getTokenOffset()+c.getTokenLength()+t,S=y===12?g():"",y=r()}if(y===2)o!==1&&(m--,S=g());else if(y===4)o!==3&&(m--,S=g());else{switch(o){case 3:case 1:m++,S=g();break;case 5:case 12:S=g();break;case 13:C?S=g():S=" ";break;case 6:S=" ";break;case 10:if(y===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?S=" ":y!==5&&y!==17&&(a=!0);break;case 16:a=!0;break}C&&(y===12||y===13)&&(S=g())}const L=c.getTokenOffset()+t;s(S,l,L),o=y}return i}e.format=n;function R(E,P){const k=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?k.replace(/\r\n|\r|\n/g,P.eol):k}e.toFormattedString=R;function D(E,P){let k="";for(let I=0;I<P;I++)k+=E;return k}function M(E,P){let k=0,I=0;const p=P.tabSize||4;for(;k<E.length;){const t=E.charAt(k);if(t===" ")I++;else if(t==="	")I+=p;else break;k++}return Math.floor(I/p)}function b(E,P){for(let k=0;k<P.length;k++){const I=P.charAt(k);if(I==="\r")return k+1<P.length&&P.charAt(k+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=b;function d(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=d}),define(J[109],Z([0,1,44,108]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,P,k){return D(E,P,void 0,k)}e.removeProperty=R;function D(E,P,k,I,p){const t=P.slice(),h=[],f=(0,w.parseTree)(E,h);let v,C;for(;t.length>0&&(C=t.pop(),v=(0,w.findNodeAtLocation)(f,t),v===void 0&&k!==void 0);)typeof C=="string"?k={[C]:k}:k=[k];if(v)if(v.type==="object"&&typeof C=="string"&&Array.isArray(v.children)){const m=(0,w.findNodeAtLocation)(v,[C]);if(m!==void 0)if(k===void 0){if(!m.parent)throw new Error("Malformed AST");const u=v.children.indexOf(m.parent);let c,a=m.parent.offset+m.parent.length;if(u>0){const g=v.children[u-1];c=g.offset+g.length}else c=v.offset+1,v.children.length>1&&(a=v.children[1].offset);return M(E,{offset:c,length:a-c,content:""},I)}else return M(E,{offset:m.offset,length:m.length,content:JSON.stringify(k)},I);else{if(k===void 0)return[];const u=`${JSON.stringify(C)}: ${JSON.stringify(k)}`,c=p?p(v.children.map(g=>g.children[0].value)):v.children.length;let a;if(c>0){const g=v.children[c-1];a={offset:g.offset+g.length,length:0,content:","+u}}else v.children.length===0?a={offset:v.offset+1,length:0,content:u}:a={offset:v.offset+1,length:0,content:u+","};return M(E,a,I)}}else if(v.type==="array"&&typeof C=="number"&&Array.isArray(v.children))if(k!==void 0){const m=`${JSON.stringify(k)}`;let u;if(v.children.length===0||C===0)u={offset:v.offset+1,length:0,content:v.children.length===0?m:m+","};else{const c=C===-1||C>v.children.length?v.children.length:C,a=v.children[c-1];u={offset:a.offset+a.length,length:0,content:","+m}}return M(E,u,I)}else{const m=C,u=v.children[m];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===m){const a=v.children[m-1],g=a.offset+a.length,r=v.offset+v.length;c={offset:g,length:r-2-g,content:""}}else c={offset:u.offset,length:v.children[m+1].offset-u.offset,content:""};return M(E,c,I)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${v.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return M(E,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(k)},I)}}e.setProperty=D;function M(E,P,k){let I=b(E,P),p=P.offset,t=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,n.isEOL)(I,p-1);)p--;for(;t<I.length&&!(0,n.isEOL)(I,t);)t++}const h=(0,n.format)(I,{offset:p,length:t-p},k);for(let v=h.length-1;v>=0;v--){const C=h[v];I=b(I,C),p=Math.min(p,C.offset),t=Math.max(t,C.offset+C.length),t+=C.content.length-C.length}const f=E.length-(I.length-t)-p;return[{offset:p,length:f,content:I.substring(p,t)}]}e.withFormatting=M;function b(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=b;function d(E,P){let k=P.slice(0).sort((p,t)=>{const h=p.offset-t.offset;return h===0?p.length-t.length:h}),I=E.length;for(let p=k.length-1;p>=0;p--){let t=k[p];if(t.offset+t.length<=I)E=b(E,t);else throw new Error("Overlapping edit");I=t.offset}return E}e.applyEdits=d}),define(J[83],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var w;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(w=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,f){this._keyCodeToStr[h]=f,this._strToKeyCode[f.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const D=new R,M=new R,b=new R;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],E=Object.create(null),P=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>P[t]||0,toEnum:t=>E[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",h=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let f=[],v=[];for(const C of h){const[m,u,c,a,g,r,i,s,o,l]=C;if(v[c]||(v[c]=!0,d[c]=a,E[a]=c,P[a.toLowerCase()]=c,u&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=g,g!==0&&g!==3&&g!==5&&g!==4&&g!==6&&g!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[g]=c))),!f[g]){if(f[g]=!0,!r)throw new Error(`String representation missing for key code ${g} around scan code ${a}`);D.define(g,r),M.define(g,o||r),b.define(g,l||o||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=g),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=g)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var k;(function(t){function h(c){return D.keyCodeToStr(c)}t.toString=h;function f(c){return D.strToKeyCode(c)}t.fromString=f;function v(c){return M.keyCodeToStr(c)}t.toUserSettingsUS=v;function C(c){return b.keyCodeToStr(c)}t.toUserSettingsGeneral=C;function m(c){return M.strToKeyCode(c)||b.strToKeyCode(c)}t.fromUserSettings=m;function u(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(c)}t.toElectronAccelerator=u})(k=e.KeyCodeUtils||(e.KeyCodeUtils={}));var I;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(I=e.KeyMod||(e.KeyMod={}));function p(t,h){const f=(h&65535)<<16>>>0;return(t|f)>>>0}e.KeyChord=p}),define(J[59],Z([0,1,15]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(k){k[k.CtrlCmd=2048]="CtrlCmd",k[k.Shift=1024]="Shift",k[k.Alt=512]="Alt",k[k.WinCtrl=256]="WinCtrl",k[k.KeyCode=255]="KeyCode"})(n||(n={}));function R(k,I){if(k===0)return null;const p=(k&65535)>>>0,t=(k&4294901760)>>>16;return t!==0?new b([D(p,I),D(t,I)]):new b([D(p,I)])}e.createKeybinding=R;function D(k,I){const p=!!(k&2048),t=!!(k&256),h=I===2?t:p,f=!!(k&1024),v=!!(k&512),C=I===2?p:t,m=k&255;return new M(h,f,v,C,m)}e.createSimpleKeybinding=D;class M{constructor(I,p,t,h,f){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.keyCode=f}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.keyCode===I.keyCode}getHashCode(){const I=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${I}${p}${t}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=M;class b{constructor(I){if(I.length===0)throw(0,w.illegalArgument)("parts");this.parts=I}getHashCode(){let I="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(I+=";"),I+=this.parts[p].getHashCode();return I}equals(I){if(I===null||this.parts.length!==I.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(I.parts[p]))return!1;return!0}}e.ChordKeybinding=b;class d{constructor(I,p,t,h,f){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.scanCode=f}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.scanCode===I.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class E{constructor(I,p,t,h,f,v){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.keyLabel=f,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=E;class P{}e.ResolvedKeybinding=P}),define(J[110],Z([0,1,83,59]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(M){M=M.toLowerCase().trim();let b=!1,d=!1,E=!1,P=!1,k;do k=!1,/^ctrl(\+|\-)/.test(M)&&(b=!0,M=M.substr("ctrl-".length),k=!0),/^shift(\+|\-)/.test(M)&&(d=!0,M=M.substr("shift-".length),k=!0),/^alt(\+|\-)/.test(M)&&(E=!0,M=M.substr("alt-".length),k=!0),/^meta(\+|\-)/.test(M)&&(P=!0,M=M.substr("meta-".length),k=!0),/^win(\+|\-)/.test(M)&&(P=!0,M=M.substr("win-".length),k=!0),/^cmd(\+|\-)/.test(M)&&(P=!0,M=M.substr("cmd-".length),k=!0);while(k);let I;const p=M.indexOf(" ");return p>0?(I=M.substring(0,p),M=M.substring(p)):(I=M,M=""),{remains:M,ctrl:b,shift:d,alt:E,meta:P,key:I}}static parseSimpleKeybinding(M){const b=this._readModifiers(M),d=w.KeyCodeUtils.fromUserSettings(b.key);return[new n.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,d),b.remains]}static parseKeybinding(M,b){if(!M)return null;const d=[];let E;do[E,M]=this.parseSimpleKeybinding(M),d.push(E);while(M.length>0);return new n.ChordKeybinding(d)}static parseSimpleUserBinding(M){const b=this._readModifiers(M),d=b.key.match(/^\[([^\]]+)\]$/);if(d){const P=d[1],k=w.ScanCodeUtils.lowerCaseToEnum(P);return[new n.ScanCodeBinding(b.ctrl,b.shift,b.alt,b.meta,k),b.remains]}const E=w.KeyCodeUtils.fromUserSettings(b.key);return[new n.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,E),b.remains]}static parseUserBinding(M){if(!M)return[];const b=[];let d;for(;M.length>0;)[d,M]=this.parseSimpleUserBinding(M),b.push(d);return b}}e.KeybindingParser=R}),define(J[111],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new w(()=>R(this.getValue()))}}e.Lazy=w}),define(J[2],Z([0,1,43,68]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let D=null;function M(s){D=s}if(e.setDisposableTracker=M,R){const s="__is_disposable_tracked__";M(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[s]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==C.None)try{o[s]=!0}catch{}}markAsDisposed(o){if(o&&o!==C.None)try{o[s]=!0}catch{}}markAsSingleton(o){}})}function b(s){return D?.trackDisposable(s),s}function d(s){D?.markAsDisposed(s)}function E(s,o){D?.setParent(s,o)}function P(s,o){if(!!D)for(const l of s)D.setParent(l,o)}function k(s){return D?.markAsSingleton(s),s}e.markAsSingleton=k;class I extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=I;function p(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=p;function t(s){if(n.Iterable.is(s)){let o=[];for(const l of s)if(l)try{l.dispose()}catch(y){o.push(y)}if(o.length===1)throw o[0];if(o.length>1)throw new I(o);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=t;function h(...s){const o=f(()=>t(s));return P(s,o),o}e.combinedDisposable=h;function f(s){const o=b({dispose:(0,w.once)(()=>{d(o),s()})});return o}e.toDisposable=f;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new v,b(this),E(this._store,this)}dispose(){d(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=m;class u{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(o){let l=o;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,d(this))},this}}e.SafeDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...l){let y=this.references.get(o);y||(y={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,y));const{object:S}=y,L=(0,w.once)(()=>{--y.counter==0&&(this.destroyReferencedObject(o,y.object),this.references.delete(o))});return y.counter++,{object:S,dispose:L}}}e.ReferenceCollection=a;class g{constructor(o){this.referenceCollection=o}async acquire(o,...l){const y=this.referenceCollection.acquire(o,...l);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(S){throw y.dispose(),S}}}e.AsyncReferenceCollection=g;class r{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=r;function i(s){const o=new v;try{s(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(J[112],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(D){this.element=D,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class n{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let D=this._first;for(;D!==w.Undefined;){const M=D.next;D.prev=w.Undefined,D.next=w.Undefined,D=M}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,M){const b=new w(D);if(this._first===w.Undefined)this._first=b,this._last=b;else if(M){const E=this._last;this._last=b,b.prev=E,E.next=b}else{const E=this._first;this._first=b,b.next=E,E.prev=b}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(b))}}shift(){if(this._first!==w.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==w.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==w.Undefined&&D.next!==w.Undefined){const M=D.prev;M.next=D.next,D.next.prev=M}else D.prev===w.Undefined&&D.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):D.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):D.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==w.Undefined;)yield D.element,D=D.next}}e.LinkedList=n}),function(){function H(R){const D=[];typeof R=="number"&&D.push("code/timeOrigin",R);function M(d){D.push(d,Date.now())}function b(){const d=[];for(let E=0;E<D.length;E+=2)d.push({name:D[E],startTime:D[E+1]});return d}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))D.push({name:M.name,startTime:Math.round(R+M.startTime)});return D}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function w(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=w(n))}(),define(J[3],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let n=!1,R=!1,D=!1,M=!1,b=!1,d=!1,E=!1,P=!1,k=!1,I,p=w,t,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const v=typeof f?.versions?.electron=="string",C=v&&f?.type==="renderer";if(e.isElectronSandboxed=C&&f?.sandboxed,typeof navigator=="object"&&!C)h=navigator.userAgent,n=h.indexOf("Windows")>=0,R=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=h.indexOf("Linux")>=0,d=!0,I=navigator.language,p=I;else if(typeof f=="object"){n=f.platform==="win32",R=f.platform==="darwin",D=f.platform==="linux",M=D&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,E=v,k=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=w,p=w;const o=f.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),y=l.availableLanguages["*"];I=l.locale,p=y||w,t=l._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var m;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function u(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let c=0;R?c=1:n?c=3:D&&(c=2),e.isWindows=n,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=M,e.isNative=b,e.isElectron=E,e.isWeb=d,e.isWebWorker=d&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=k,e.platform=c,e.userAgent=h,e.language=p;var a;(function(o){function l(){return e.language}o.value=l;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=y;function S(){return e.language==="en"}o.isDefault=S})(a=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let S=0,L=o.length;S<L;S++){const T=o[S];if(T.id===y.data.vscodeScheduleAsyncWork){o.splice(S,1),T.callback();return}}});let l=0;return y=>{const S=++l;o.push({id:S,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return o=>setTimeout(o)})();var g;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||P?2:n?1:3;let r=!0,i=!1;function s(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,r=new Uint16Array(o.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[36],Z([0,1,3]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const R=w.globals.vscode.process;n={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(J[7],Z([0,1,36]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,R=97,D=90,M=122,b=46,d=47,E=92,P=58,k=63;class I extends Error{constructor(u,c,a){let g;typeof c=="string"&&c.indexOf("not ")===0?(g="must not be",c=c.replace(/^not /,"")):g="must be";const r=u.indexOf(".")!==-1?"property":"argument";let i=`The "${u}" ${r} ${g} of type ${c}`;i+=`. Received type ${typeof a}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function p(m,u){if(typeof m!="string")throw new I(u,"string",m)}function t(m){return m===d||m===E}function h(m){return m===d}function f(m){return m>=n&&m<=D||m>=R&&m<=M}function v(m,u,c,a){let g="",r=0,i=-1,s=0,o=0;for(let l=0;l<=m.length;++l){if(l<m.length)o=m.charCodeAt(l);else{if(a(o))break;o=d}if(a(o)){if(!(i===l-1||s===1))if(s===2){if(g.length<2||r!==2||g.charCodeAt(g.length-1)!==b||g.charCodeAt(g.length-2)!==b){if(g.length>2){const y=g.lastIndexOf(c);y===-1?(g="",r=0):(g=g.slice(0,y),r=g.length-1-g.lastIndexOf(c)),i=l,s=0;continue}else if(g.length!==0){g="",r=0,i=l,s=0;continue}}u&&(g+=g.length>0?`${c}..`:"..",r=2)}else g.length>0?g+=`${c}${m.slice(i+1,l)}`:g=m.slice(i+1,l),r=l-i-1;i=l,s=0}else o===b&&s!==-1?++s:s=-1}return g}function C(m,u){if(u===null||typeof u!="object")throw new I("pathObject","Object",u);const c=u.dir||u.root,a=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${a}`:`${c}${m}${a}`:a}e.win32={resolve(...m){let u="",c="",a=!1;for(let g=m.length-1;g>=-1;g--){let r;if(g>=0){if(r=m[g],p(r,"path"),r.length===0)continue}else u.length===0?r=w.cwd():(r=w.env[`=${u}`]||w.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==u.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${u}\\`));const i=r.length;let s=0,o="",l=!1;const y=r.charCodeAt(0);if(i===1)t(y)&&(s=1,l=!0);else if(t(y))if(l=!0,t(r.charCodeAt(1))){let S=2,L=S;for(;S<i&&!t(r.charCodeAt(S));)S++;if(S<i&&S!==L){const T=r.slice(L,S);for(L=S;S<i&&t(r.charCodeAt(S));)S++;if(S<i&&S!==L){for(L=S;S<i&&!t(r.charCodeAt(S));)S++;(S===i||S!==L)&&(o=`\\\\${T}\\${r.slice(L,S)}`,s=S)}}}else s=1;else f(y)&&r.charCodeAt(1)===P&&(o=r.slice(0,2),s=2,i>2&&t(r.charCodeAt(2))&&(l=!0,s=3));if(o.length>0)if(u.length>0){if(o.toLowerCase()!==u.toLowerCase())continue}else u=o;if(a){if(u.length>0)break}else if(c=`${r.slice(s)}\\${c}`,a=l,l&&u.length>0)break}return c=v(c,!a,"\\",t),a?`${u}\\${c}`:`${u}${c}`||"."},normalize(m){p(m,"path");const u=m.length;if(u===0)return".";let c=0,a,g=!1;const r=m.charCodeAt(0);if(u===1)return h(r)?"\\":m;if(t(r))if(g=!0,t(m.charCodeAt(1))){let s=2,o=s;for(;s<u&&!t(m.charCodeAt(s));)s++;if(s<u&&s!==o){const l=m.slice(o,s);for(o=s;s<u&&t(m.charCodeAt(s));)s++;if(s<u&&s!==o){for(o=s;s<u&&!t(m.charCodeAt(s));)s++;if(s===u)return`\\\\${l}\\${m.slice(o)}\\`;s!==o&&(a=`\\\\${l}\\${m.slice(o,s)}`,c=s)}}}else c=1;else f(r)&&m.charCodeAt(1)===P&&(a=m.slice(0,2),c=2,u>2&&t(m.charCodeAt(2))&&(g=!0,c=3));let i=c<u?v(m.slice(c),!g,"\\",t):"";return i.length===0&&!g&&(i="."),i.length>0&&t(m.charCodeAt(u-1))&&(i+="\\"),a===void 0?g?`\\${i}`:i:g?`${a}\\${i}`:`${a}${i}`},isAbsolute(m){p(m,"path");const u=m.length;if(u===0)return!1;const c=m.charCodeAt(0);return t(c)||u>2&&f(c)&&m.charCodeAt(1)===P&&t(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let u,c;for(let r=0;r<m.length;++r){const i=m[r];p(i,"path"),i.length>0&&(u===void 0?u=c=i:u+=`\\${i}`)}if(u===void 0)return".";let a=!0,g=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++g;const r=c.length;r>1&&t(c.charCodeAt(1))&&(++g,r>2&&(t(c.charCodeAt(2))?++g:a=!1))}if(a){for(;g<u.length&&t(u.charCodeAt(g));)g++;g>=2&&(u=`\\${u.slice(g)}`)}return e.win32.normalize(u)},relative(m,u){if(p(m,"from"),p(u,"to"),m===u)return"";const c=e.win32.resolve(m),a=e.win32.resolve(u);if(c===a||(m=c.toLowerCase(),u=a.toLowerCase(),m===u))return"";let g=0;for(;g<m.length&&m.charCodeAt(g)===E;)g++;let r=m.length;for(;r-1>g&&m.charCodeAt(r-1)===E;)r--;const i=r-g;let s=0;for(;s<u.length&&u.charCodeAt(s)===E;)s++;let o=u.length;for(;o-1>s&&u.charCodeAt(o-1)===E;)o--;const l=o-s,y=i<l?i:l;let S=-1,L=0;for(;L<y;L++){const B=m.charCodeAt(g+L);if(B!==u.charCodeAt(s+L))break;B===E&&(S=L)}if(L!==y){if(S===-1)return a}else{if(l>y){if(u.charCodeAt(s+L)===E)return a.slice(s+L+1);if(L===2)return a.slice(s+L)}i>y&&(m.charCodeAt(g+L)===E?S=L:L===2&&(S=3)),S===-1&&(S=0)}let T="";for(L=g+S+1;L<=r;++L)(L===r||m.charCodeAt(L)===E)&&(T+=T.length===0?"..":"\\..");return s+=S,T.length>0?`${T}${a.slice(s,o)}`:(a.charCodeAt(s)===E&&++s,a.slice(s,o))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const u=e.win32.resolve(m);if(u.length<=2)return m;if(u.charCodeAt(0)===E){if(u.charCodeAt(1)===E){const c=u.charCodeAt(2);if(c!==k&&c!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(f(u.charCodeAt(0))&&u.charCodeAt(1)===P&&u.charCodeAt(2)===E)return`\\\\?\\${u}`;return m},dirname(m){p(m,"path");const u=m.length;if(u===0)return".";let c=-1,a=0;const g=m.charCodeAt(0);if(u===1)return t(g)?m:".";if(t(g)){if(c=a=1,t(m.charCodeAt(1))){let s=2,o=s;for(;s<u&&!t(m.charCodeAt(s));)s++;if(s<u&&s!==o){for(o=s;s<u&&t(m.charCodeAt(s));)s++;if(s<u&&s!==o){for(o=s;s<u&&!t(m.charCodeAt(s));)s++;if(s===u)return m;s!==o&&(c=a=s+1)}}}}else f(g)&&m.charCodeAt(1)===P&&(c=u>2&&t(m.charCodeAt(2))?3:2,a=c);let r=-1,i=!0;for(let s=u-1;s>=a;--s)if(t(m.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(c===-1)return".";r=c}return m.slice(0,r)},basename(m,u){u!==void 0&&p(u,"ext"),p(m,"path");let c=0,a=-1,g=!0,r;if(m.length>=2&&f(m.charCodeAt(0))&&m.charCodeAt(1)===P&&(c=2),u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let i=u.length-1,s=-1;for(r=m.length-1;r>=c;--r){const o=m.charCodeAt(r);if(t(o)){if(!g){c=r+1;break}}else s===-1&&(g=!1,s=r+1),i>=0&&(o===u.charCodeAt(i)?--i==-1&&(a=r):(i=-1,a=s))}return c===a?a=s:a===-1&&(a=m.length),m.slice(c,a)}for(r=m.length-1;r>=c;--r)if(t(m.charCodeAt(r))){if(!g){c=r+1;break}}else a===-1&&(g=!1,a=r+1);return a===-1?"":m.slice(c,a)},extname(m){p(m,"path");let u=0,c=-1,a=0,g=-1,r=!0,i=0;m.length>=2&&m.charCodeAt(1)===P&&f(m.charCodeAt(0))&&(u=a=2);for(let s=m.length-1;s>=u;--s){const o=m.charCodeAt(s);if(t(o)){if(!r){a=s+1;break}continue}g===-1&&(r=!1,g=s+1),o===b?c===-1?c=s:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||g===-1||i===0||i===1&&c===g-1&&c===a+1?"":m.slice(c,g)},format:C.bind(null,"\\"),parse(m){p(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const c=m.length;let a=0,g=m.charCodeAt(0);if(c===1)return t(g)?(u.root=u.dir=m,u):(u.base=u.name=m,u);if(t(g)){if(a=1,t(m.charCodeAt(1))){let S=2,L=S;for(;S<c&&!t(m.charCodeAt(S));)S++;if(S<c&&S!==L){for(L=S;S<c&&t(m.charCodeAt(S));)S++;if(S<c&&S!==L){for(L=S;S<c&&!t(m.charCodeAt(S));)S++;S===c?a=S:S!==L&&(a=S+1)}}}}else if(f(g)&&m.charCodeAt(1)===P){if(c<=2)return u.root=u.dir=m,u;if(a=2,t(m.charCodeAt(2))){if(c===3)return u.root=u.dir=m,u;a=3}}a>0&&(u.root=m.slice(0,a));let r=-1,i=a,s=-1,o=!0,l=m.length-1,y=0;for(;l>=a;--l){if(g=m.charCodeAt(l),t(g)){if(!o){i=l+1;break}continue}s===-1&&(o=!1,s=l+1),g===b?r===-1?r=l:y!==1&&(y=1):r!==-1&&(y=-1)}return s!==-1&&(r===-1||y===0||y===1&&r===s-1&&r===i+1?u.base=u.name=m.slice(i,s):(u.name=m.slice(i,r),u.base=m.slice(i,s),u.ext=m.slice(r,s))),i>0&&i!==a?u.dir=m.slice(0,i-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let u="",c=!1;for(let a=m.length-1;a>=-1&&!c;a--){const g=a>=0?m[a]:w.cwd();p(g,"path"),g.length!==0&&(u=`${g}/${u}`,c=g.charCodeAt(0)===d)}return u=v(u,!c,"/",h),c?`/${u}`:u.length>0?u:"."},normalize(m){if(p(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===d,c=m.charCodeAt(m.length-1)===d;return m=v(m,!u,"/",h),m.length===0?u?"/":c?"./":".":(c&&(m+="/"),u?`/${m}`:m)},isAbsolute(m){return p(m,"path"),m.length>0&&m.charCodeAt(0)===d},join(...m){if(m.length===0)return".";let u;for(let c=0;c<m.length;++c){const a=m[c];p(a,"path"),a.length>0&&(u===void 0?u=a:u+=`/${a}`)}return u===void 0?".":e.posix.normalize(u)},relative(m,u){if(p(m,"from"),p(u,"to"),m===u||(m=e.posix.resolve(m),u=e.posix.resolve(u),m===u))return"";const c=1,a=m.length,g=a-c,r=1,i=u.length-r,s=g<i?g:i;let o=-1,l=0;for(;l<s;l++){const S=m.charCodeAt(c+l);if(S!==u.charCodeAt(r+l))break;S===d&&(o=l)}if(l===s)if(i>s){if(u.charCodeAt(r+l)===d)return u.slice(r+l+1);if(l===0)return u.slice(r+l)}else g>s&&(m.charCodeAt(c+l)===d?o=l:l===0&&(o=0));let y="";for(l=c+o+1;l<=a;++l)(l===a||m.charCodeAt(l)===d)&&(y+=y.length===0?"..":"/..");return`${y}${u.slice(r+o)}`},toNamespacedPath(m){return m},dirname(m){if(p(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===d;let c=-1,a=!0;for(let g=m.length-1;g>=1;--g)if(m.charCodeAt(g)===d){if(!a){c=g;break}}else a=!1;return c===-1?u?"/":".":u&&c===1?"//":m.slice(0,c)},basename(m,u){u!==void 0&&p(u,"ext"),p(m,"path");let c=0,a=-1,g=!0,r;if(u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let i=u.length-1,s=-1;for(r=m.length-1;r>=0;--r){const o=m.charCodeAt(r);if(o===d){if(!g){c=r+1;break}}else s===-1&&(g=!1,s=r+1),i>=0&&(o===u.charCodeAt(i)?--i==-1&&(a=r):(i=-1,a=s))}return c===a?a=s:a===-1&&(a=m.length),m.slice(c,a)}for(r=m.length-1;r>=0;--r)if(m.charCodeAt(r)===d){if(!g){c=r+1;break}}else a===-1&&(g=!1,a=r+1);return a===-1?"":m.slice(c,a)},extname(m){p(m,"path");let u=-1,c=0,a=-1,g=!0,r=0;for(let i=m.length-1;i>=0;--i){const s=m.charCodeAt(i);if(s===d){if(!g){c=i+1;break}continue}a===-1&&(g=!1,a=i+1),s===b?u===-1?u=i:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||a===-1||r===0||r===1&&u===a-1&&u===c+1?"":m.slice(u,a)},format:C.bind(null,"/"),parse(m){p(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const c=m.charCodeAt(0)===d;let a;c?(u.root="/",a=1):a=0;let g=-1,r=0,i=-1,s=!0,o=m.length-1,l=0;for(;o>=a;--o){const y=m.charCodeAt(o);if(y===d){if(!s){r=o+1;break}continue}i===-1&&(s=!1,i=o+1),y===b?g===-1?g=o:l!==1&&(l=1):g!==-1&&(l=-1)}if(i!==-1){const y=r===0&&c?1:r;g===-1||l===0||l===1&&g===i-1&&g===r+1?u.base=u.name=m.slice(y,i):(u.name=m.slice(y,g),u.base=m.slice(y,i),u.ext=m.slice(g,i))}return r>0?u.dir=m.slice(0,r-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[84],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var n;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(D,...M){const b=M.reduce((P,k)=>(P[k]=!0,P),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(P=>!b[P]).forEach(P=>{for(let k=0;k<d.length;k++)if(P.search(d[k])!==-1){delete D[P];break}})}e.sanitizeProcessEnvironment=R}),define(J[85],Z([0,1,3]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=w.globals.performance&&typeof w.globals.performance.now=="function";class R{constructor(M){this._highResolution=n&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new R(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=R}),define(J[4],Z([0,1,15,43,2,112,85]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let b=!1,d=!1;var E;(function(r){r.None=()=>R.Disposable.None;function i(z){if(d){const{onListenerDidAdd:O}=z,U=t.create();let W=0;z.onListenerDidAdd=()=>{++W==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),O?.()}}}function s(z){return(O,U=null,W)=>{let A=!1,F;return F=z(N=>{if(!A)return F?F.dispose():A=!0,O.call(U,N)},null,W),A&&F.dispose(),F}}r.once=s;function o(z,O,U){return B((W,A=null,F)=>z(N=>W.call(A,O(N)),null,F),U)}r.map=o;function l(z,O,U){return B((W,A=null,F)=>z(N=>{O(N),W.call(A,N)},null,F),U)}r.forEach=l;function y(z,O,U){return B((W,A=null,F)=>z(N=>O(N)&&W.call(A,N),null,F),U)}r.filter=y;function S(z){return z}r.signal=S;function L(...z){return(O,U=null,W)=>(0,R.combinedDisposable)(...z.map(A=>A(F=>O.call(U,F),null,W)))}r.any=L;function T(z,O,U,W){let A=U;return o(z,F=>(A=O(A,F),A),W)}r.reduce=T;function B(z,O){let U;const W={onFirstListenerAdd(){U=z(A.fire,A)},onLastListenerRemove(){U.dispose()}};O||i(W);const A=new f(W);return O&&O.add(A),A.event}function Y(z,O,U=100,W=!1,A,F){let N,K,se,ae=0;const ce={leakWarningThreshold:A,onFirstListenerAdd(){N=z(le=>{ae++,K=O(K,le),W&&!se&&(ne.fire(K),K=void 0),clearTimeout(se),se=setTimeout(()=>{const he=K;K=void 0,se=void 0,(!W||ae>1)&&ne.fire(he),ae=0},U)})},onLastListenerRemove(){N.dispose()}};F||i(ce);const ne=new f(ce);return F&&F.add(ne),ne.event}r.debounce=Y;function ee(z,O=(W,A)=>W===A,U){let W=!0,A;return y(z,F=>{const N=W||!O(F,A);return W=!1,A=F,N},U)}r.latch=ee;function te(z,O,U){return[r.filter(z,O,U),r.filter(z,W=>!O(W),U)]}r.split=te;function Q(z,O=!1,U=[]){let W=U.slice(),A=z(K=>{W?W.push(K):N.fire(K)});const F=()=>{W&&W.forEach(K=>N.fire(K)),W=null},N=new f({onFirstListenerAdd(){A||(A=z(K=>N.fire(K)))},onFirstListenerDidAdd(){W&&(O?setTimeout(F):F())},onLastListenerRemove(){A&&A.dispose(),A=null}});return N.event}r.buffer=Q;class q{constructor(O){this.event=O}map(O){return new q(o(this.event,O))}forEach(O){return new q(l(this.event,O))}filter(O){return new q(y(this.event,O))}reduce(O,U){return new q(T(this.event,O,U))}latch(){return new q(ee(this.event))}debounce(O,U=100,W=!1,A){return new q(Y(this.event,O,U,W,A))}on(O,U,W){return this.event(O,U,W)}once(O,U,W){return s(this.event)(O,U,W)}}function G(z){return new q(z)}r.chain=G;function _(z,O,U=W=>W){const W=(...K)=>N.fire(U(...K)),A=()=>z.on(O,W),F=()=>z.removeListener(O,W),N=new f({onFirstListenerAdd:A,onLastListenerRemove:F});return N.event}r.fromNodeEventEmitter=_;function x(z,O,U=W=>W){const W=(...K)=>N.fire(U(...K)),A=()=>z.addEventListener(O,W),F=()=>z.removeEventListener(O,W),N=new f({onFirstListenerAdd:A,onLastListenerRemove:F});return N.event}r.fromDOMEventEmitter=x;function $(z){return new Promise(O=>s(z)(O))}r.toPromise=$;function V(z,O){return O(void 0),z(U=>O(U))}r.runAndSubscribe=V;function X(z,O){let U=null;function W(F){U?.dispose(),U=new R.DisposableStore,O(F,U)}W(void 0);const A=z(F=>W(F));return(0,R.toDisposable)(()=>{A.dispose(),U?.dispose()})}r.runAndSubscribeWithStore=X})(E=e.Event||(e.Event={}));class P{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${P._idPool++}`}start(i){this._stopWatch=new M.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let k=-1;function I(r){const i=k;return k=r,{dispose(){k=i}}}e.setGlobalLeakWarningThreshold=I;class p{constructor(i,s=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,s){let o=k;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||s<o)return;this._stacks||(this._stacks=new Map);const l=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let y,S=0;for(const[L,T]of this._stacks)(!y||S<T)&&(y=L,S=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${S}):`),console.warn(y)}return()=>{const y=this._stacks.get(i.value)||0;this._stacks.set(i.value,y-1)}}}class t{constructor(i){this.value=i}static create(){return new t(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(i,s,o){this.callback=i,this.callbackThis=s,this.stack=o,this.subscription=new R.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class f{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=k>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const s of i)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,s,o)=>{this._listeners||(this._listeners=new D.LinkedList);const l=this._listeners.isEmpty();l&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let y,S;this._leakageMon&&this._listeners.size>=30&&(S=t.create(),y=this._leakageMon.check(S,this._listeners.size+1)),b&&(S=S??t.create());const L=new h(i,s,S),T=this._listeners.push(L);l&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,s);const B=L.subscription.set(()=>{y&&y(),this._disposed||(T(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof R.DisposableStore?o.add(B):Array.isArray(o)&&o.push(B),B}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,o]=this._deliveryQueue.shift();try{s.invoke(o)}catch(l){(0,w.onUnexpectedError)(l)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class v extends f{async fireAsync(i,s,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const l of this._listeners)this._asyncDeliveryQueue.push([l,i]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[l,y]=this._asyncDeliveryQueue.shift(),S=[],L={...y,token:s,waitUntil:T=>{if(Object.isFrozen(S))throw new Error("waitUntil can NOT be called asynchronous");o&&(T=o(T,l.callback)),S.push(T)}};try{l.invoke(L)}catch(T){(0,w.onUnexpectedError)(T);continue}Object.freeze(S),await Promise.allSettled(S).then(T=>{for(const B of T)B.status==="rejected"&&(0,w.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=v;class C extends f{constructor(i){super(i);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=C;class m extends C{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=m;class u extends f{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=u;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const s={event:i,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const o=()=>{this.hasListeners&&this.unhook(s);const l=this.events.indexOf(s);this.events.splice(l,1)};return(0,R.toDisposable)((0,n.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(s=>this.emitter.fire(s))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class a{constructor(){this.buffers=[]}wrapEvent(i){return(s,o,l)=>i(y=>{const S=this.buffers[this.buffers.length-1];S?S.push(()=>s.call(o,y)):s.call(o,y)},void 0,l)}bufferEvents(i){const s=[];this.buffers.push(s);const o=i();return this.buffers.pop(),s.forEach(l=>l()),o}}e.EventBufferer=a;class g{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=R.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(J[23],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(b,d){const E=setTimeout(b.bind(d),0);return{dispose(){clearTimeout(E)}}});var R;(function(b){function d(E){return E===b.None||E===b.Cancelled||E instanceof D?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}b.isCancellationToken=d,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(R=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=R.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=M}),define(J[113],Z([0,1,23]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(M){this.task=M,this.result=null}get(){if(this.result)return this.result;const M=new w.CancellationTokenSource,b=this.task(M.token);return this.result={promise:b,dispose:()=>{this.result=null,M.cancel(),M.dispose()}},this.result}}e.Cache=n;class R{constructor(M){this.computeFn=M,this.lastCache=void 0,this.lastArgKey=void 0}get(M){const b=JSON.stringify(M);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.computeFn(M)),this.lastCache}}e.LRUCachedComputed=R}),define(J[48],Z([0,1,15,2]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=R;function D(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=D;function M(u){const c=u;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=M;function b(u,c){return new d(u,c)}e.newWriteableStream=b;class d{constructor(c,a){this.reducer=c,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(a=>a(c))}emitError(c){this.listeners.error.length===0?(0,w.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(a=>a(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,a){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(c,a){if(this.state.destroyed)return;let g;switch(c){case"data":g=this.listeners.data;break;case"end":g=this.listeners.end;break;case"error":g=this.listeners.error;break}if(g){const r=g.indexOf(a);r>=0&&g.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(g=>g())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(u,c){const a=[];let g;for(;(g=u.read())!==null;)a.push(g);return c(a)}e.consumeReadable=E;function P(u,c,a){const g=[];let r;for(;(r=u.read())!==null&&g.length<a;)g.push(r);return r===null&&g.length>0?c(g):{read:()=>{if(g.length>0)return g.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return u.read()}}}e.peekReadable=P;function k(u,c){return new Promise((a,g)=>{const r=[];I(u,{onData:i=>{c&&r.push(i)},onError:i=>{c?g(i):a(void 0)},onEnd:()=>{a(c?c(r):void 0)}})})}e.consumeStream=k;function I(u,c){let a=!1;return u.on("error",g=>{a||c.onError(g)}),u.on("end",()=>{a||c.onEnd()}),u.on("data",g=>{a||c.onData(g)}),(0,n.toDisposable)(()=>a=!0)}e.listenStream=I;function p(u,c){return new Promise((a,g)=>{const r=new n.DisposableStore,i=[],s=y=>{if(i.push(y),i.length>c)return r.dispose(),u.pause(),a({stream:u,buffer:i,ended:!1})},o=y=>g(y),l=()=>a({stream:u,buffer:i,ended:!0});r.add((0,n.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),r.add((0,n.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),r.add((0,n.toDisposable)(()=>u.removeListener("data",s))),u.on("data",s)})}e.peekStream=p;function t(u,c){const a=b(c);return a.end(u),a}e.toStream=t;function h(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=h;function f(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=f;function v(u,c,a){const g=b(a);return I(u,{onData:r=>g.write(c.data(r)),onError:r=>g.error(c.error?c.error(r):r),onEnd:()=>g.end()}),g}e.transform=v;function C(u,c,a){let g=!1;return{read:()=>{const r=c.read();return g?r:(g=!0,r!==null?a([u,r]):u)}}}e.prefixedReadable=C;function m(u,c,a){let g=!1;const r=b(a);return I(c,{onData:i=>g?r.write(i):(g=!0,r.write(a([u,i]))),onError:i=>r.error(i),onEnd:()=>{g||(g=!0,r.write(u)),r.end()}}),r}e.prefixedStream=m}),define(J[16],Z([0,1,48]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let R,D;class M{constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}static alloc(y){return n?new M(Buffer.allocUnsafe(y)):new M(new Uint8Array(y))}static wrap(y){return n&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new M(y)}static fromString(y,S){return!(S?.dontUseNodeBuffer||!1)&&n?new M(Buffer.from(y)):(R||(R=new TextEncoder),new M(R.encode(y)))}static fromByteArray(y){const S=M.alloc(y.length);for(let L=0,T=y.length;L<T;L++)S.buffer[L]=y[L];return S}static concat(y,S){if(typeof S=="undefined"){S=0;for(let B=0,Y=y.length;B<Y;B++)S+=y[B].byteLength}const L=M.alloc(S);let T=0;for(let B=0,Y=y.length;B<Y;B++){const ee=y[B];L.set(ee,T),T+=ee.byteLength}return L}clone(){const y=M.alloc(this.byteLength);return y.set(this),y}toString(){return n?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(y,S){return new M(this.buffer.subarray(y,S))}set(y,S){if(y instanceof M)this.buffer.set(y.buffer,S);else if(y instanceof Uint8Array)this.buffer.set(y,S);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),S);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return E(this.buffer,y)}writeUInt32BE(y,S){P(this.buffer,y,S)}readUInt32LE(y){return k(this.buffer,y)}writeUInt32LE(y,S){I(this.buffer,y,S)}readUInt8(y){return p(this.buffer,y)}writeUInt8(y,S){t(this.buffer,y,S)}}e.VSBuffer=M;function b(l,y){return l[y+0]<<0>>>0|l[y+1]<<8>>>0}e.readUInt16LE=b;function d(l,y,S){l[S+0]=y&255,y=y>>>8,l[S+1]=y&255}e.writeUInt16LE=d;function E(l,y){return l[y]*2**24+l[y+1]*2**16+l[y+2]*2**8+l[y+3]}e.readUInt32BE=E;function P(l,y,S){l[S+3]=y,y=y>>>8,l[S+2]=y,y=y>>>8,l[S+1]=y,y=y>>>8,l[S]=y}e.writeUInt32BE=P;function k(l,y){return l[y+0]<<0>>>0|l[y+1]<<8>>>0|l[y+2]<<16>>>0|l[y+3]<<24>>>0}e.readUInt32LE=k;function I(l,y,S){l[S+0]=y&255,y=y>>>8,l[S+1]=y&255,y=y>>>8,l[S+2]=y&255,y=y>>>8,l[S+3]=y&255}e.writeUInt32LE=I;function p(l,y){return l[y]}e.readUInt8=p;function t(l,y,S){l[S]=y}e.writeUInt8=t;function h(l){return w.consumeReadable(l,y=>M.concat(y))}e.readableToBuffer=h;function f(l){return w.toReadable(l)}e.bufferToReadable=f;function v(l){return w.consumeStream(l,y=>M.concat(y))}e.streamToBuffer=v;async function C(l){return l.ended?M.concat(l.buffer):M.concat([...l.buffer,await v(l.stream)])}e.bufferedStreamToBuffer=C;function m(l){return w.toStream(l,y=>M.concat(y))}e.bufferToStream=m;function u(l){return w.transform(l,{data:y=>typeof y=="string"?M.fromString(y):M.wrap(y)},y=>M.concat(y))}e.streamToBufferReadableStream=u;function c(l){return w.newWriteableStream(y=>M.concat(y),l)}e.newWriteableBufferStream=c;function a(l,y){return w.prefixedReadable(l,y,S=>M.concat(S))}e.prefixedBufferReadable=a;function g(l,y){return w.prefixedStream(l,y,S=>M.concat(S))}e.prefixedBufferStream=g;function r(l){let y=0,S=0,L=0;const T=new Uint8Array(Math.floor(l.length/4*3)),B=ee=>{switch(S){case 3:T[L++]=y|ee,S=0;break;case 2:T[L++]=y|ee>>>2,y=ee<<6,S=3;break;case 1:T[L++]=y|ee>>>4,y=ee<<4,S=2;break;default:y=ee<<2,S=1}};for(let ee=0;ee<l.length;ee++){const te=l.charCodeAt(ee);if(te>=65&&te<=90)B(te-65);else if(te>=97&&te<=122)B(te-97+26);else if(te>=48&&te<=57)B(te-48+52);else if(te===43||te===45)B(62);else if(te===47||te===95)B(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const Y=L;for(;S>0;)B(0);return M.wrap(T).slice(0,Y)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},y=!0,S=!1){const L=S?s:i;let T="";const B=l.byteLength%3;let Y=0;for(;Y<l.byteLength-B;Y+=3){const ee=l[Y+0],te=l[Y+1],Q=l[Y+2];T+=L[ee>>>2],T+=L[(ee<<4|te>>>4)&63],T+=L[(te<<2|Q>>>6)&63],T+=L[Q&63]}if(B===1){const ee=l[Y+0];T+=L[ee>>>2],T+=L[ee<<4&63],y&&(T+="==")}else if(B===2){const ee=l[Y+0],te=l[Y+1];T+=L[ee>>>2],T+=L[(ee<<4|te>>>4)&63],T+=L[te<<2&63],y&&(T+="=")}return T}e.encodeBase64=o}),define(J[27],Z([0,1,113,111]),function(H,e,w,n){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=D;const M=/{(\d+)}/g;function b(j,...re){return re.length===0?j:j.replace(M,function(oe,fe){const Se=parseInt(fe,10);return isNaN(Se)||Se<0||Se>=re.length?oe:re[Se]})}e.format=b;const d=/{([^}]+)}/g;function E(j,re){return j.replace(d,(oe,fe)=>re[fe]??oe)}e.format2=E;function P(j){return j.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=P;function k(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function I(j,re){let oe=0;const fe=re.charCodeAt(0);for(let Se=j.length-1;Se>=0;Se--)j.charCodeAt(Se)===fe&&oe++;return oe}e.count=I;function p(j,re,oe="\u2026"){return j.length<=re?j:`${j.substr(0,re)}${oe}`}e.truncate=p;function t(j,re=" "){const oe=h(j,re);return f(oe,re)}e.trim=t;function h(j,re){if(!j||!re)return j;const oe=re.length;if(oe===0||j.length===0)return j;let fe=0;for(;j.indexOf(re,fe)===fe;)fe=fe+oe;return j.substring(fe)}e.ltrim=h;function f(j,re){if(!j||!re)return j;const oe=re.length,fe=j.length;if(oe===0||fe===0)return j;let Se=fe,Re=-1;for(;Re=j.lastIndexOf(re,Se-1),!(Re===-1||Re+oe!==Se);){if(Re===0)return"";Se=Re}return j.substring(0,Se)}e.rtrim=f;function v(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function C(j){return j.replace(/\*/g,"")}e.stripWildcards=C;function m(j,re,oe={}){if(!j)throw new Error("Cannot create regex from empty string");re||(j=k(j)),oe.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(j,fe)}e.createRegExp=m;function u(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=a;function g(j){return j.split(/\r\n|\r|\n/)}e.splitLines=g;function r(j){for(let re=0,oe=j.length;re<oe;re++){const fe=j.charCodeAt(re);if(fe!==32&&fe!==9)return re}return-1}e.firstNonWhitespaceIndex=r;function i(j,re=0,oe=j.length){for(let fe=re;fe<oe;fe++){const Se=j.charCodeAt(fe);if(Se!==32&&Se!==9)return j.substring(re,fe)}return j.substring(re,oe)}e.getLeadingWhitespace=i;function s(j,re=j.length-1){for(let oe=re;oe>=0;oe--){const fe=j.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function o(j,re){return j<re?-1:j>re?1:0}e.compare=o;function l(j,re,oe=0,fe=j.length,Se=0,Re=re.length){for(;oe<fe&&Se<Re;oe++,Se++){let Ve=j.charCodeAt(oe),Ae=re.charCodeAt(Se);if(Ve<Ae)return-1;if(Ve>Ae)return 1}const Oe=fe-oe,Ke=Re-Se;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstring=l;function y(j,re){return S(j,re,0,j.length,0,re.length)}e.compareIgnoreCase=y;function S(j,re,oe=0,fe=j.length,Se=0,Re=re.length){for(;oe<fe&&Se<Re;oe++,Se++){let Ve=j.charCodeAt(oe),Ae=re.charCodeAt(Se);if(Ve===Ae)continue;if(Ve>=128||Ae>=128)return l(j.toLowerCase(),re.toLowerCase(),oe,fe,Se,Re);L(Ve)&&(Ve-=32),L(Ae)&&(Ae-=32);const qe=Ve-Ae;if(qe!==0)return qe}const Oe=fe-oe,Ke=Re-Se;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstringIgnoreCase=S;function L(j){return j>=97&&j<=122}e.isLowerAsciiLetter=L;function T(j){return j>=65&&j<=90}e.isUpperAsciiLetter=T;function B(j,re){return j.length===re.length&&S(j,re)===0}e.equalsIgnoreCase=B;function Y(j,re){const oe=re.length;return re.length>j.length?!1:S(j,re,0,oe)===0}e.startsWithIgnoreCase=Y;function ee(j,re){let oe,fe=Math.min(j.length,re.length);for(oe=0;oe<fe;oe++)if(j.charCodeAt(oe)!==re.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=ee;function te(j,re){let oe,fe=Math.min(j.length,re.length);const Se=j.length-1,Re=re.length-1;for(oe=0;oe<fe;oe++)if(j.charCodeAt(Se-oe)!==re.charCodeAt(Re-oe))return oe;return fe}e.commonSuffixLength=te;function Q(j){return 55296<=j&&j<=56319}e.isHighSurrogate=Q;function q(j){return 56320<=j&&j<=57343}e.isLowSurrogate=q;function G(j,re){return(j-55296<<10)+(re-56320)+65536}e.computeCodePoint=G;function _(j,re,oe){const fe=j.charCodeAt(oe);if(Q(fe)&&oe+1<re){const Se=j.charCodeAt(oe+1);if(q(Se))return G(fe,Se)}return fe}e.getNextCodePoint=_;function x(j,re){const oe=j.charCodeAt(re-1);if(q(oe)&&re>1){const fe=j.charCodeAt(re-2);if(Q(fe))return G(fe,oe)}return oe}class ${constructor(re,oe=0){this._str=re,this._len=re.length,this._offset=oe}get offset(){return this._offset}setOffset(re){this._offset=re}prevCodePoint(){const re=x(this._str,this._offset);return this._offset-=re>=65536?2:1,re}nextCodePoint(){const re=_(this._str,this._len,this._offset);return this._offset+=re>=65536?2:1,re}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class V{constructor(re,oe=0){this._iterator=new $(re,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const re=ze.getInstance(),oe=this._iterator,fe=oe.offset;let Se=re.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Re=oe.offset,Oe=re.getGraphemeBreakType(oe.nextCodePoint());if(Ze(Se,Oe)){oe.setOffset(Re);break}Se=Oe}return oe.offset-fe}prevGraphemeLength(){const re=ze.getInstance(),oe=this._iterator,fe=oe.offset;let Se=re.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Re=oe.offset,Oe=re.getGraphemeBreakType(oe.prevCodePoint());if(Ze(Oe,Se)){oe.setOffset(Re);break}Se=Oe}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function X(j,re){return new V(j,re).nextGraphemeLength()}e.nextCharLength=X;function z(j,re){return new V(j,re).prevGraphemeLength()}e.prevCharLength=z;function O(j,re){re>0&&q(j.charCodeAt(re))&&re--;const oe=re+X(j,re);return[oe-z(j,oe),oe]}e.getCharContainingOffset=O;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(j){return U.test(j)}e.containsRTL=W;const A=/^[\t\n\r\x20-\x7E]*$/;function F(j){return A.test(j)}e.isBasicASCII=F,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=N;function K(j){return j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=K;function se(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129008||j>=129280&&j<=129535||j>=129648&&j<=129782}e.isEmojiImprecise=se;function ae(j,re){if(j.length<re)return j;const oe=/\b/g;let fe=0;for(;oe.test(j)&&!(j.length-oe.lastIndex<re);)fe=oe.lastIndex,oe.lastIndex+=1;return j.substring(fe).replace(/^\s/,"")}e.lcut=ae;const ce=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(j){return j&&(j=j.replace(ce,""),j=j.replace(ne,""),j=j.replace(le,"")),j}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function be(j){return we(j)?j.substr(1):j}e.stripUTF8BOM=be;function Ce(j,re){if(!j||!re||j.length<re.length)return!1;const oe=re.length,fe=j.toLowerCase();let Se=0,Re=-1;for(;Se<oe;){const Oe=fe.indexOf(re[Se],Re+1);if(Oe<0)return!1;Re=Oe,Se++}return!0}e.fuzzyContains=Ce;function ye(j,re=!1){return j?(re&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=ye;function pe(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=pe;function Ee(j,re=1){if(re===0)return"";let oe=-1;do oe=j.indexOf(`
`,oe+1),re--;while(re>0&&oe>=0);return oe===-1?j:(j[oe-1]==="\r"&&oe--,j.substr(0,oe))}e.getNLines=Ee;function Le(j){const re=90-65+1;return j=j%(2*re),j<re?String.fromCharCode(97+j):String.fromCharCode(65+j-re)}e.singleLetterHash=Le;function Ne(j){return ze.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ne;function Ze(j,re){return j===0?re!==5&&re!==7:j===2&&re===3?!1:j===4||j===2||j===3||re===4||re===2||re===3?!0:!(j===8&&(re===8||re===9||re===11||re===12)||(j===11||j===9)&&(re===9||re===10)||(j===12||j===10)&&re===10||re===5||re===13||re===7||j===1||j===13&&re===14||j===6&&re===6)}var Fe;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ge()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const oe=this._data,fe=oe.length/3;let Se=1;for(;Se<=fe;)if(re<oe[3*Se])Se=2*Se;else if(re>oe[3*Se+1])Se=2*Se+1;else return oe[3*Se+2];return 0}}ze._INSTANCE=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(j,re){if(j===0)return 0;const oe=wt(j,re);if(oe!==void 0)return oe;const fe=new $(re,j);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=ot;function wt(j,re){const oe=new $(re,j);let fe=oe.prevCodePoint();for(;tt(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!se(fe))return;let Se=oe.offset;return Se>0&&oe.prevCodePoint()===8205&&(Se=oe.offset),Se}function tt(j){return 127995<=j&&j<=127999}var Ye;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class He{constructor(re){this.confusableDictionary=re}static getInstance(re){return He.cache.get(Array.from(re))}static getLocales(){return He._locales.getValue()}isAmbiguous(re){return this.confusableDictionary.has(re)}getPrimaryConfusable(re){return this.confusableDictionary.get(re)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,R=He,He.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new w.LRUCachedComputed(j=>{function re(Ae){const qe=new Map;for(let je=0;je<Ae.length;je+=2)qe.set(Ae[je],Ae[je+1]);return qe}function oe(Ae,qe){const je=new Map(Ae);for(const[xe,it]of qe)je.set(xe,it);return je}function fe(Ae,qe){if(!Ae)return qe;const je=new Map;for(const[xe,it]of Ae)qe.has(xe)&&je.set(xe,it);return je}const Se=R.ambiguousCharacterData.getValue();let Re=j.filter(Ae=>!Ae.startsWith("_")&&Ae in Se);Re.length===0&&(Re=["_default"]);let Oe;for(const Ae of Re){const qe=re(Se[Ae]);Oe=fe(Oe,qe)}const Ke=re(Se._common),Ve=oe(Ke,Oe);return new He(Ve)}),He._locales=new n.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(j=>!j.startsWith("_")));class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(re){return Qe.getData().has(re)}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe,Qe._data=void 0}),define(J[69],Z([0,1,27]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return R(v,0)}e.hash=n;function R(v,C){switch(typeof v){case"object":return v===null?D(349,C):Array.isArray(v)?d(v,C):E(v,C);case"string":return b(v,C);case"boolean":return M(v,C);case"number":return D(v,C);case"undefined":return D(937,C);default:return D(617,C)}}e.doHash=R;function D(v,C){return(C<<5)-C+v|0}e.numberHash=D;function M(v,C){return D(v?433:863,C)}function b(v,C){C=D(149417,C);for(let m=0,u=v.length;m<u;m++)C=D(v.charCodeAt(m),C);return C}e.stringHash=b;function d(v,C){return C=D(104579,C),v.reduce((m,u)=>R(u,m),C)}function E(v,C){return C=D(181387,C),Object.keys(v).sort().reduce((m,u)=>(m=b(u,m),R(v[u],m)),C)}class P{constructor(){this._value=0}get value(){return this._value}hash(C){return this._value=R(C,this._value),this._value}}e.Hasher=P;var k;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function I(v,C,m=32){const u=m-C,c=~((1<<u)-1);return(v<<C|(c&v)>>>u)>>>0}function p(v,C=0,m=v.byteLength,u=0){for(let c=0;c<m;c++)v[C+c]=u}function t(v,C,m="0"){for(;v.length<C;)v=m+v;return v}function h(v,C=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(m=>m.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),C/4)}e.toHexString=h;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const m=C.length;if(m===0)return;const u=this._buff;let c=this._buffLen,a=this._leftoverHighSurrogate,g,r;for(a!==0?(g=a,r=-1,a=0):(g=C.charCodeAt(0),r=0);;){let i=g;if(w.isHighSurrogate(g))if(r+1<m){const s=C.charCodeAt(r+1);w.isLowSurrogate(s)?(r++,i=w.computeCodePoint(g,s)):i=65533}else{a=g;break}else w.isLowSurrogate(g)&&(i=65533);if(c=this._push(u,c,i),r++,r<m)g=C.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=a}_push(C,m,u){return u<128?C[m++]=u:u<2048?(C[m++]=192|(u&1984)>>>6,C[m++]=128|(u&63)>>>0):u<65536?(C[m++]=224|(u&61440)>>>12,C[m++]=128|(u&4032)>>>6,C[m++]=128|(u&63)>>>0):(C[m++]=240|(u&1835008)>>>18,C[m++]=128|(u&258048)>>>12,C[m++]=128|(u&4032)>>>6,C[m++]=128|(u&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=f._bigBlock32,m=this._buffDV;for(let l=0;l<64;l+=4)C.setUint32(l,m.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)C.setUint32(l,I(C.getUint32(l-12,!1)^C.getUint32(l-32,!1)^C.getUint32(l-56,!1)^C.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,a=this._h2,g=this._h3,r=this._h4,i,s,o;for(let l=0;l<80;l++)l<20?(i=c&a|~c&g,s=1518500249):l<40?(i=c^a^g,s=1859775393):l<60?(i=c&a|c&g|a&g,s=2400959708):(i=c^a^g,s=3395469782),o=I(u,5)+i+r+s+C.getUint32(l*4,!1)&4294967295,r=g,g=a,a=I(c,30),c=u,u=o;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+g&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(H,e,w,n,R){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!R:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?R.call(H,w):R?R.value=w:e.set(H,w),w},Je=this&&this.__classPrivateFieldGet||function(H,e,w,n){if(w==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!n:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?n:w==="a"?n.call(H):n?n.value:e.get(H)};define(J[35],Z([0,1,30,27]),function(H,e,w,n){"use strict";var R,D,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(r,i,s){let o=r.get(i);return o===void 0&&(o=s,r.set(i,o)),o}e.getOrSet=b;function d(r){const i=[];return r.forEach((s,o)=>{i.push(`${o} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=d;function E(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class I{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(f||(f={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new I(void 0,!i))}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new k)}clear(){this._root=void 0}fill(i,s){if(s){const o=s.slice(0);(0,w.shuffle)(o);for(let l of o)this.set(l,i)}else{const o=i.slice(0);(0,w.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(i,s){const o=this._iter.reset(i);let l;this._root||(this._root=new h,this._root.segment=o.value());const y=[];for(l=this._root;;){const L=o.cmp(l.segment);if(L>0)l.left||(l.left=new h,l.left.segment=o.value()),y.push([-1,l]),l=l.left;else if(L<0)l.right||(l.right=new h,l.right.segment=o.value()),y.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new h,l.mid.segment=o.value()),y.push([0,l]),l=l.mid;else break}const S=l.value;l.value=s,l.key=i;for(let L=y.length-1;L>=0;L--){const T=y[L][1];T.updateHeight();const B=T.balanceFactor();if(B<-1||B>1){const Y=y[L][0],ee=y[L+1][0];if(Y===1&&ee===1)y[L][1]=T.rotateLeft();else if(Y===-1&&ee===-1)y[L][1]=T.rotateRight();else if(Y===1&&ee===-1)T.right=y[L+1][1]=y[L+1][1].rotateRight(),y[L][1]=T.rotateLeft();else if(Y===-1&&ee===1)T.left=y[L+1][1]=y[L+1][1].rotateLeft(),y[L][1]=T.rotateRight();else throw new Error;if(L>0)switch(y[L-1][0]){case-1:y[L-1][1].left=y[L][1];break;case 1:y[L-1][1].right=y[L][1];break;case 0:y[L-1][1].mid=y[L][1];break}else this._root=y[0][1]}}return S}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const o=this._iter.reset(i),l=[];let y=this._root;for(;y;){const S=o.cmp(y.segment);if(S>0)l.push([-1,y]),y=y.left;else if(S<0)l.push([1,y]),y=y.right;else if(o.hasNext())o.next(),l.push([0,y]),y=y.mid;else break}if(!!y){if(s?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const S=this._min(y.right),{key:L,value:T,segment:B}=S;this._delete(S.key,!1),y.key=L,y.value=T,y.segment=B}else{const S=y.left??y.right;if(l.length>0){const[L,T]=l[l.length-1];switch(L){case-1:T.left=S;break;case 0:T.mid=S;break;case 1:T.right=S;break}}else this._root=S}for(let S=l.length-1;S>=0;S--){const L=l[S][1];L.updateHeight();const T=L.balanceFactor();if(T>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),l[S][1]=L.rotateLeft()):T<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),l[S][1]=L.rotateRight()),S>0)switch(l[S-1][0]){case-1:l[S-1][1].left=l[S][1];break;case 1:l[S-1][1].right=l[S][1];break;case 0:l[S-1][1].mid=l[S][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let o=this._root,l;for(;o;){const y=s.cmp(o.segment);if(y>0)o=o.left;else if(y<0)o=o.right;else if(s.hasNext())s.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[s,o]of this)i(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=v;class C{constructor(i,s){this.uri=i,this.value=s}}class m{constructor(i,s){this[R]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=s??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new C(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[o,l]of this.map)i(l.value,l.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=r=>r.toString();var u;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class c{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const o=this._map.get(i);if(!!o)return s!==0&&this.touch(o,s),o.value}set(i,s,o=0){let l=this._map.get(i);if(l)l.value=s,o!==0&&this.touch(l,o);else{switch(l={key:i,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const o=this._state;let l=this._head;for(;l;){if(s?i.bind(s)(l.value,l.key,this):i(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,s=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:o.key,done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return l}values(){const i=this,s=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:o.value,done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return l}entries(){const i=this,s=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:[o.key,o.value],done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>i;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,o=i.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const o=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const o=i.next,l=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,o)=>{i.push([o,s])}),i}fromJSON(i){this.clear();for(const[s,o]of i)this.set(s,o)}}e.LinkedMap=c;class a extends c{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class g{constructor(i){M.set(this,void 0),Dt(this,M,i,"f")}get size(){return Je(this,M,"f").size}forEach(i,s){Je(this,M,"f").forEach(i,s)}get(i){return Je(this,M,"f").get(i)}has(i){return Je(this,M,"f").has(i)}entries(){return Je(this,M,"f").entries()}keys(){return Je(this,M,"f").keys()}values(){return Je(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Je(this,M,"f").entries()}}e.ReadonlyMapView=g}),define(J[70],Z([0,1,35]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new w.LRUCache(1e4);function R(E){return d(E,"NFC",n)}e.normalizeNFC=R;const D=new w.LRUCache(1e4);function M(E){return d(E,"NFD",D)}e.normalizeNFD=M;const b=/[^\u0000-\u0080]/;function d(E,P,k){if(!E)return E;const I=k.get(E);if(I)return I;let p;return b.test(E)?p=E.normalize(P):p=E,k.set(E,p),p}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return M(P).replace(E,"")}}()}),define(J[14],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(o){return Array.isArray(o)}e.isArray=w;function n(o){return typeof o=="string"}e.isString=n;function R(o){return Array.isArray(o)&&o.every(l=>n(l))}e.isStringArray=R;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function M(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=M;function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=b;function d(o){return o===!0||o===!1}e.isBoolean=d;function E(o){return typeof o=="undefined"}e.isUndefined=E;function P(o){return!k(o)}e.isDefined=P;function k(o){return E(o)||o===null}e.isUndefinedOrNull=k;function I(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=I;function p(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=p;function t(...o){const l=[];for(let y=0;y<o.length;y++){const S=o[y];if(k(S))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);l.push(S)}return l}e.assertAllDefined=t;const h=Object.prototype.hasOwnProperty;function f(o){if(!D(o))return!1;for(let l in o)if(h.call(o,l))return!1;return!0}e.isEmptyObject=f;function v(o){return typeof o=="function"}e.isFunction=v;function C(...o){return o.length>0&&o.every(v)}e.areFunctions=C;function m(o,l){const y=Math.min(o.length,l.length);for(let S=0;S<y;S++)u(o[S],l[S])}e.validateConstraints=m;function u(o,l){if(n(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(v(l)){try{if(o instanceof l)return}catch{}if(!k(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(o){let l=[],y=Object.getPrototypeOf(o);for(;Object.prototype!==y;)l=l.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return l}e.getAllPropertyNames=c;function a(o){const l=[];for(const y of c(o))typeof o[y]=="function"&&l.push(y);return l}e.getAllMethodNames=a;function g(o,l){const y=L=>function(){const T=Array.prototype.slice.call(arguments,0);return l(L,T)};let S={};for(const L of o)S[L]=y(L);return S}e.createProxyObject=g;function r(o){return o===null?void 0:o}e.withNullAsUndefined=r;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function s(o,l="Unreachable"){throw new Error(l)}e.assertNever=s}),define(J[28],Z([0,1,7,3,27,14]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function b(s){return s.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=b;function d(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=d;function E(s,o=w.posix.sep){if(!s)return"";const l=s.length,y=s.charCodeAt(0);if(M(y)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let L=3;const T=L;for(;L<l&&!M(s.charCodeAt(L));L++);if(T!==L&&!M(s.charCodeAt(L+1))){for(L+=1;L<l;L++)if(M(s.charCodeAt(L)))return s.slice(0,L+1).replace(/[\\/]/g,o)}}return o}else if(v(y)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let S=s.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(M(s.charCodeAt(S)))return s.slice(0,S+1)}return""}e.getRoot=E;function P(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let l=2;const y=l;for(;l<s.length&&(o=s.charCodeAt(l),o!==92);l++);return!(y===l||(o=s.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=P;const k=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,o=n.isWindows){const l=o?k:I;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||o&&p.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function h(s,o,l){const y=s===o;return!l||y?y:!s||!o?!1:(0,R.equalsIgnoreCase)(s,o)}e.isEqual=h;function f(s,o,l,y=w.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(l){if(!(0,R.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let L=o.length;return o.charAt(o.length-1)===y&&L--,s.charAt(L)===y}return o.charAt(o.length-1)!==y&&(o+=y),s.indexOf(o)===0}e.isEqualOrParent=f;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function C(s,o){return n.isWindows&&s.endsWith(":")&&(s+=w.sep),(0,w.isAbsolute)(s)||(s=(0,w.join)(o,s)),s=(0,w.normalize)(s),n.isWindows?(s=(0,R.rtrim)(s,w.sep),s.endsWith(":")&&(s+=w.sep)):(s=(0,R.rtrim)(s,w.sep),s||(s=w.sep)),s}e.sanitizeFilePath=C;function m(s){const o=(0,w.normalize)(s);return n.isWindows?s.length>3?!1:u(o)&&(s.length===2||o.charCodeAt(2)===92):o===w.posix.sep}e.isRootOrDriveLetter=m;function u(s,o){return(o!==void 0?o:n.isWindows)?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(s){return u(s)?s[0]:void 0}e.getDriveLetter=c;function a(s,o,l){return o.length>s.length?-1:s===o?0:(l&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=a;function g(s){const o=s.split(":");let l,y,S;for(const L of o){const T=Number(L);(0,D.isNumber)(T)?y===void 0?y=T:S===void 0&&(S=T):l=l?[l,L].join(":"):L}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:y!==void 0?y:void 0,column:S!==void 0?S:y!==void 0?1:void 0}}e.parseLineAndColumnAware=g;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,o,l=8){let y="";for(let L=0;L<l;L++)y+=r.charAt(Math.floor(Math.random()*r.length));let S;return o?S=`${o}-${y}`:S=y,s?(0,w.join)(s,S):S}e.randomPath=i}),define(J[49],Z([0,1,14]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.keys(h).forEach(v=>{h[v]&&typeof h[v]=="object"?f[v]=n(h[v]):f[v]=h[v]}),f}e.deepClone=n;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const v=f.shift();Object.freeze(v);for(const C in v)if(D.call(v,C)){const m=v[C];typeof m=="object"&&!Object.isFrozen(m)&&f.push(m)}}return h}e.deepFreeze=R;const D=Object.prototype.hasOwnProperty;function M(h,f){return b(h,f,new Set)}e.cloneAndChange=M;function b(h,f,v){if((0,w.isUndefinedOrNull)(h))return h;const C=f(h);if(typeof C!="undefined")return C;if((0,w.isArray)(h)){const m=[];for(const u of h)m.push(b(u,f,v));return m}if((0,w.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const m={};for(let u in h)D.call(h,u)&&(m[u]=b(h[u],f,v));return v.delete(h),m}return h}function d(h,f,v=!0){return(0,w.isObject)(h)?((0,w.isObject)(f)&&Object.keys(f).forEach(C=>{C in h?v&&((0,w.isObject)(h[C])&&(0,w.isObject)(f[C])?d(h[C],f[C],v):h[C]=f[C]):h[C]=f[C]}),h):f}e.mixin=d;function E(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let v,C;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(v=0;v<h.length;v++)if(!E(h[v],f[v]))return!1}else{const m=[];for(C in h)m.push(C);m.sort();const u=[];for(C in f)u.push(C);if(u.sort(),!E(m,u))return!1;for(v=0;v<m.length;v++)if(!E(h[m[v]],f[m[v]]))return!1}return!0}e.equals=E;function P(h){const f=new Set;return JSON.stringify(h,(v,C)=>{if((0,w.isObject)(C)||Array.isArray(C)){if(f.has(C))return"[Circular]";f.add(C)}return C})}e.safeStringify=P;function k(h,f,v){const C=f(h);return typeof C=="undefined"?v:C}e.getOrDefault=k;function I(h,f){const v=Object.create(null);return!h||!f||Object.keys(f).forEach(m=>{const u=h[m],c=f[m];E(u,c)||(v[m]=c)}),v}e.distinct=I;function p(h,f){const v=f.toLowerCase(),C=Object.keys(h).find(m=>m.toLowerCase()===v);return C?h[C]:h[f]}e.getCaseInsensitive=p;function t(h,f){const v=Object.create(null);for(const[C,m]of Object.entries(h))f(C,m)&&(v[C]=m);return v}e.filter=t}),define(J[8],Z([0,1,7,3]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,D=/^\//,M=/^\/\//;function b(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!R.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(r,i){return!r&&!i?"file":r}function E(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const P="",k="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(i,s,o,l,y,S=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=d(i,S),this.authority=s||P,this.path=E(this.scheme,o||P),this.query=l||P,this.fragment=y||P,b(this,S))}static isUri(i){return i instanceof p?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return m(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:o,path:l,query:y,fragment:S}=i;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),l===void 0?l=this.path:l===null&&(l=P),y===void 0?y=this.query:y===null&&(y=P),S===void 0?S=this.fragment:S===null&&(S=P),s===this.scheme&&o===this.authority&&l===this.path&&y===this.query&&S===this.fragment?this:new h(s,o,l,y,S)}static parse(i,s=!1){const o=I.exec(i);return o?new h(o[2]||P,g(o[4]||P),g(o[5]||P),g(o[7]||P),g(o[9]||P),s):new h(P,P,P,P,P)}static file(i){let s=P;if(n.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const o=i.indexOf(k,2);o===-1?(s=i.substring(2),i=k):(s=i.substring(2,o),i=i.substring(o)||k)}return new h("file",s,i,P,P)}static from(i){const s=new h(i.scheme,i.authority,i.path,i.query,i.fragment);return b(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&i.scheme==="file"?o=p.file(w.win32.join(m(i,!0),...s)).path:o=w.posix.join(i.path,...s),i.with({path:o})}toString(i=!1){return u(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof p)return i;{const s=new h(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=p;const t=n.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(i=!1){return i?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,i){let s,o=-1;for(let l=0;l<r.length;l++){const y=r.charCodeAt(l);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||i&&y===47)o!==-1&&(s+=encodeURIComponent(r.substring(o,l)),o=-1),s!==void 0&&(s+=r.charAt(l));else{s===void 0&&(s=r.substr(0,l));const S=f[y];S!==void 0?(o!==-1&&(s+=encodeURIComponent(r.substring(o,l)),o=-1),s+=S):o===-1&&(o=l)}}return o!==-1&&(s+=encodeURIComponent(r.substring(o))),s!==void 0?s:r}function C(r){let i;for(let s=0;s<r.length;s++){const o=r.charCodeAt(s);o===35||o===63?(i===void 0&&(i=r.substr(0,s)),i+=f[o]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function m(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function u(r,i){const s=i?C:v;let o="",{scheme:l,authority:y,path:S,query:L,fragment:T}=r;if(l&&(o+=l,o+=":"),(y||l==="file")&&(o+=k,o+=k),y){let B=y.indexOf("@");if(B!==-1){const Y=y.substr(0,B);y=y.substr(B+1),B=Y.indexOf(":"),B===-1?o+=s(Y,!1):(o+=s(Y.substr(0,B),!1),o+=":",o+=s(Y.substr(B+1),!1)),o+="@"}y=y.toLowerCase(),B=y.indexOf(":"),B===-1?o+=s(y,!1):(o+=s(y.substr(0,B),!1),o+=y.substr(B))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const B=S.charCodeAt(1);B>=65&&B<=90&&(S=`/${String.fromCharCode(B+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const B=S.charCodeAt(0);B>=65&&B<=90&&(S=`${String.fromCharCode(B+32)}:${S.substr(2)}`)}o+=s(S,!0)}return L&&(o+="?",o+=s(L,!1)),T&&(o+="#",o+=i?T:v(T,!1)),o}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(r){return r.match(a)?r.replace(a,i=>c(i)):r}}),define(J[114],Z([0,1,8]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function R(E){const P=[];let k;try{const I=JSON.parse(E.arguments),p=I[I.length-1];p&&p.__$stack&&(I.pop(),k=p.__$stack),P.push(...I)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:k}}e.parse=R;function D(E){if(typeof E!="string")return D(R(E).stack);const P=E;if(P){const k=M(P),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(I&&I.length===4)return{uri:w.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=D;function M(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function b(E,P){const{args:k,stack:I}=R(E),p=typeof k[0]=="string"&&k.length===1;let t=M(I);t&&(t=`(${t.trim()})`);let h=[];if(typeof k[0]=="string"?t&&p?h=[`%c[${P}] %c${k[0]} %c${t}`,d("blue"),d(""),d("grey")]:h=[`%c[${P}] %c${k[0]}`,d("blue"),d(""),...k.slice(1)]:h=[`%c[${P}]%`,d("blue"),...k],t&&!p&&h.push(t),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}e.log=b;function d(E){return`color: ${E}`}}),define(J[115],Z([0,1,16,27,8]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(E){return JSON.stringify(E,b)}e.stringify=D;function M(E){let P=JSON.parse(E);return P=d(P),P}e.parse=M;function b(E,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,n.regExpFlags)(P)}:P}function d(E,P=0){if(!E||P>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof w.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let k=0;k<E.length;++k)E[k]=d(E[k],P+1);else for(const k in E)Object.hasOwnProperty.call(E,k)&&(E[k]=d(E[k],P+1))}return E}e.revive=d}),define(J[10],Z([0,1,3,8]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.userData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,E,P){this._hosts[d]=E,this._ports[d]=P}setConnectionToken(d,E){this._connectionTokens[d]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)return this._delegate(d);const E=d.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const k=this._ports[E],I=this._connectionTokens[E];let p=`path=${encodeURIComponent(d.path)}`;return typeof I=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),n.URI.from({scheme:w.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${P}:${k}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new D;class M{asBrowserUri(d,E){const P=this.toUri(d,E);return P.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===R.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${R.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?P.with({scheme:R.vscodeFileResource,authority:P.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(d,E){const P=this.toUri(d,E);return P.scheme===R.vscodeFileResource?P.with({scheme:R.file,authority:P.authority!==M.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(d,E){return n.URI.isUri(d)?d:n.URI.parse(E.toUrl(d))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(J[17],Z([0,1,28,10,7,3,27,8]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(p){return(0,b.uriToFsPath)(p,!0)}e.originalFSPath=d;class E{constructor(t){this._ignorePathCasing=t}compare(t,h,f=!1){return t===h?0:(0,M.compare)(this.getComparisonKey(t,f),this.getComparisonKey(h,f))}isEqual(t,h,f=!1){return t===h?!0:!t||!h?!1:this.getComparisonKey(t,f)===this.getComparisonKey(h,f)}getComparisonKey(t,h=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,h,f=!1){if(t.scheme===h.scheme){if(t.scheme===n.Schemas.file)return w.isEqualOrParent(d(t),d(h),this._ignorePathCasing(t))&&t.query===h.query&&(f||t.fragment===h.fragment);if((0,e.isEqualAuthority)(t.authority,h.authority))return w.isEqualOrParent(t.path,h.path,this._ignorePathCasing(t),"/")&&t.query===h.query&&(f||t.fragment===h.fragment)}return!1}joinPath(t,...h){return b.URI.joinPath(t,...h)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return R.posix.basename(t.path)}extname(t){return R.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let h;return t.scheme===n.Schemas.file?h=b.URI.file(R.dirname(d(t))).path:(h=R.posix.dirname(t.path),t.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),h="/")),t.with({path:h})}normalizePath(t){if(!t.path.length)return t;let h;return t.scheme===n.Schemas.file?h=b.URI.file(R.normalize(d(t))).path:h=R.posix.normalize(t.path),t.with({path:h})}relativePath(t,h){if(t.scheme!==h.scheme||!(0,e.isEqualAuthority)(t.authority,h.authority))return;if(t.scheme===n.Schemas.file){const C=R.relative(d(t),d(h));return D.isWindows?w.toSlashes(C):C}let f=t.path||"/",v=h.path||"/";if(this._ignorePathCasing(t)){let C=0;for(const m=Math.min(f.length,v.length);C<m&&!(f.charCodeAt(C)!==v.charCodeAt(C)&&f.charAt(C).toLowerCase()!==v.charAt(C).toLowerCase());C++);f=v.substr(0,C)+f.substr(C)}return R.posix.relative(f,v)}resolvePath(t,h){if(t.scheme===n.Schemas.file){const f=b.URI.file(R.resolve(d(t),h));return t.with({authority:f.authority,path:f.path})}return h=w.toPosixPath(h),t.with({path:R.posix.resolve(t.path,h)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,h){return t===h||t!==void 0&&h!==void 0&&(0,M.equalsIgnoreCase)(t,h)}hasTrailingPathSeparator(t,h=R.sep){if(t.scheme===n.Schemas.file){const f=d(t);return f.length>w.getRoot(f).length&&f[f.length-1]===h}else{const f=t.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,h=R.sep){return(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,h=R.sep){let f=!1;if(t.scheme===n.Schemas.file){const v=d(t);f=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=t.path;f=v.length===1&&v.charCodeAt(v.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path+"/"}):t}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(p=>p.scheme===n.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new E(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,t){const h=[];for(let f=0;f<p.length;f++){const v=t(p[f]);p.some((C,m)=>m===f?!1:(0,e.isEqualOrParent)(v,t(C)))||h.push(p[f])}return h}e.distinctParents=P;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(h){const f=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(m=>{const[u,c]=m.split(":");u&&c&&f.set(u,c)});const C=h.path.substring(0,h.path.indexOf(";"));return C&&f.set(p.META_DATA_MIME,C),f}p.parseMetaData=t})(k=e.DataUri||(e.DataUri={}));function I(p,t,h){if(t){let f=p.path;return f&&f[0]!==R.posix.sep&&(f=R.posix.sep+f),p.with({scheme:h,authority:t,path:f})}return p.with({scheme:h})}e.toLocalResource=I}),define(J[9],Z([0,1,23,15,4,2,17,3]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(W){return!!W&&typeof W.then=="function"}e.isThenable=d;function E(W){const A=new w.CancellationTokenSource,F=W(A.token),N=new Promise((K,se)=>{const ae=A.token.onCancellationRequested(()=>{ae.dispose(),A.dispose(),se(new n.CancellationError)});Promise.resolve(F).then(ce=>{ae.dispose(),A.dispose(),K(ce)},ce=>{ae.dispose(),A.dispose(),se(ce)})});return new class{cancel(){A.cancel()}then(K,se){return N.then(K,se)}catch(K){return this.then(void 0,K)}finally(K){return N.finally(K)}}}e.createCancelablePromise=E;function P(W,A,F){return new Promise((N,K)=>{const se=A.onCancellationRequested(()=>{se.dispose(),N(F)});W.then(N,K).finally(()=>se.dispose())})}e.raceCancellation=P;function k(W,A){return new Promise((F,N)=>{const K=A.onCancellationRequested(()=>{K.dispose(),N(new n.CancellationError)});W.then(F,N).finally(()=>K.dispose())})}e.raceCancellationError=k;async function I(W){let A=-1;const F=W.map((K,se)=>K.then(ae=>(A=se,ae))),N=await Promise.race(F);return W.forEach((K,se)=>{se!==A&&K.cancel()}),N}e.raceCancellablePromises=I;function p(W,A,F){let N;const K=setTimeout(()=>{N?.(void 0),F?.()},A);return Promise.race([W.finally(()=>clearTimeout(K)),new Promise(se=>N=se)])}e.raceTimeout=p;function t(W){return new Promise((A,F)=>{const N=W();d(N)?N.then(A,F):A(N)})}e.asPromise=t;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(F,F).then(N)})}return new Promise((F,N)=>{this.queuedPromise.then(F,N)})}return this.activePromise=A(),new Promise((F,N)=>{this.activePromise.then(K=>{this.activePromise=null,F(K)},K=>{this.activePromise=null,N(K)})})}}e.Throttler=h;class f{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=f;class v{constructor(){this.promiseMap=new Map}queue(A,F){const K=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(A)===K&&this.promiseMap.delete(A)});return this.promiseMap.set(A,K),K}}e.SequencerByKey=v;const C=(W,A)=>{let F=!0;const N=setTimeout(()=>{F=!1,A()},W);return{isTriggered:()=>F,dispose:()=>{clearTimeout(N),F=!1}}},m=W=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,W())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,F=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((K,se)=>{this.doResolve=K,this.doReject=se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const K=this.task;return this.task=null,K()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===e.MicrotaskDelay?m(N):C(F,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(A){this.delayer=new u(A),this.throttler=new h}trigger(A,F){return this.delayer.trigger(()=>this.throttler.queue(A),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class a{constructor(){this._isOpen=!1,this._promise=new Promise((A,F)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class g extends a{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function r(W,A){return A?new Promise((F,N)=>{const K=setTimeout(()=>{se.dispose(),F()},W),se=A.onCancellationRequested(()=>{clearTimeout(K),se.dispose(),N(new n.CancellationError)})}):E(F=>r(W,F))}e.timeout=r;function i(W,A=0){const F=setTimeout(W,A);return(0,D.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=i;function s(W){const A=[];let F=0;const N=W.length;function K(){return F<N?W[F++]():null}function se(ae){ae!=null&&A.push(ae);const ce=K();return ce?ce.then(se):Promise.resolve(A)}return Promise.resolve(null).then(se)}e.sequence=s;function o(W,A=N=>!!N,F=null){let N=0;const K=W.length,se=()=>{if(N>=K)return Promise.resolve(F);const ae=W[N++];return Promise.resolve(ae()).then(ne=>A(ne)?Promise.resolve(ne):se())};return se()}e.first=o;function l(W,A=N=>!!N,F=null){if(W.length===0)return Promise.resolve(F);let N=W.length;const K=()=>{N=-1;for(const se of W)se.cancel?.()};return new Promise((se,ae)=>{for(const ce of W)ce.then(ne=>{--N>=0&&A(ne)?(K(),se(ne)):N===0&&se(F)}).catch(ne=>{--N>=0&&(K(),ae(ne))})})}e.firstParallel=l;class y{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((F,N)=>{this.outstandingPromises.push({factory:A,c:F,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const F=A.factory();F.then(A.c,A.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=y;class S extends y{constructor(){super(1)}}e.Queue=S;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new $;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,F=M.extUri){const N=F.getComparisonKey(A);let K=this.queues.get(N);return K||(K=new S,R.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(N),this.onDidQueueFinish()}),this.queues.set(N,K)),K}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class T{constructor(A,F){this._token=-1,typeof A=="function"&&typeof F=="number"&&this.setIfNotSet(A,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},F)}setIfNotSet(A,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},F))}}e.TimeoutTimer=T;class B{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,F){this.cancel(),this._token=setInterval(()=>{A()},F)}}e.IntervalTimer=B;class Y{constructor(A,F){this.timeoutToken=-1,this.runner=A,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Y;class ee{constructor(A,F){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=ee;class te extends Y{constructor(A,F){super(A,F);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=te;class Q extends D.Disposable{constructor(A,F){super();this.options=A,this.handler=F,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Y(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,b.setTimeout0)(()=>{if(A)return;const F=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(W,A)=>{const F=requestIdleCallback(W,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(F))}}}}();class q{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function G(W,A,F){let N;for(let K=0;K<F;K++)try{return await W()}catch(se){N=se,await r(A)}throw N}e.retry=G;class _{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,F,N){return this._pending={taskId:A,cancel:()=>N?.(),promise:F},F.then(()=>this.donePending(A),()=>this.donePending(A)),F}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let F,N;const K=new Promise((se,ae)=>{F=se,N=ae});this._next={run:A,promise:K,promiseResolve:F,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=_;class x{constructor(A,F=()=>Date.now()){this.interval=A,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,F)=>{this.completeCallback=A,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(F=>{this.completeCallback(A),this.resolved=!0,F()})}error(A){return new Promise(F=>{this.errorCallback(A),this.rejected=!0,F()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=$;var V;(function(W){async function A(N){let K;const se=await Promise.all(N.map(ae=>ae.then(ce=>ce,ce=>{K||(K=ce)})));if(typeof K!="undefined")throw K;return se}W.settled=A;function F(N){return new Promise(async(K,se)=>{try{await N(K,se)}catch(ae){se(ae)}})}W.withAsyncBody=F})(V=e.Promises||(e.Promises={}));var X;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(X||(X={}));class z{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const F={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(A(F)),this.resolve()}catch(N){this.reject(N)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}static fromArray(A){return new z(F=>{F.emitMany(A)})}static fromPromise(A){return new z(async F=>{F.emitMany(await A)})}static fromPromises(A){return new z(async F=>{await Promise.all(A.map(async N=>F.emitOne(await N)))})}static merge(A){return new z(async F=>{await Promise.all(A.map(async N=>{for await(const K of N)F.emitOne(K)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,F){return new z(async N=>{for await(const K of A)N.emitOne(F(K))})}map(A){return z.map(this,A)}static filter(A,F){return new z(async N=>{for await(const K of A)F(K)&&N.emitOne(K)})}filter(A){return z.filter(this,A)}static coalesce(A){return z.filter(A,F=>!!F)}coalesce(){return z.coalesce(this)}static async toPromise(A){const F=[];for await(const N of A)F.push(N);return F}toPromise(){return z.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class O extends z{constructor(A,F){super(F);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=O;function U(W){const A=new w.CancellationTokenSource,F=W(A.token);return new O(A,async N=>{const K=A.token.onCancellationRequested(()=>{K.dispose(),A.dispose(),N.reject(new n.CancellationError)});try{for await(const se of F){if(A.token.isCancellationRequested)return;N.emitOne(se)}K.dispose(),A.dispose()}catch(se){K.dispose(),A.dispose(),N.reject(se)}})}e.createCancelableAsyncIterable=U}),define(J[116],Z([0,1,9,28,35,7,3,27]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",P="[^/\\\\]",k=/\//g;function I(_,x){switch(_){case 0:return"";case 1:return`${P}*?`;default:return`(?:${E}|${P}+${E}${x?`|${E}${P}+`:""})*?`}}function p(_,x){if(!_)return[];const $=[];let V=!1,X=!1,z="";for(const O of _){switch(O){case x:if(!V&&!X){$.push(z),z="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":X=!0;break;case"]":X=!1;break}z+=O}return z&&$.push(z),$}e.splitGlobAware=p;function t(_){if(!_)return"";let x="";const $=p(_,e.GLOB_SPLIT);if($.every(V=>V===e.GLOBSTAR))x=".*";else{let V=!1;$.forEach((X,z)=>{if(X===e.GLOBSTAR){if(V)return;x+=I(2,z===$.length-1)}else{let O=!1,U="",W=!1,A="";for(const F of X){if(F!=="}"&&O){U+=F;continue}if(W&&(F!=="]"||!A)){let N;F==="-"?N=F:(F==="^"||F==="!")&&!A?N="^":F===e.GLOB_SPLIT?N="":N=(0,b.escapeRegExpCharacters)(F),A+=N;continue}switch(F){case"{":O=!0;continue;case"[":W=!0;continue;case"}":{x+=`(?:${p(U,",").map(se=>t(se)).join("|")})`,O=!1,U="";break}case"]":{x+="["+A+"]",W=!1,A="";break}case"?":x+=P;continue;case"*":x+=I(1);continue;default:x+=(0,b.escapeRegExpCharacters)(F)}}z<$.length-1&&($[z+1]!==e.GLOBSTAR||z+2<$.length)&&(x+=E)}V=X===e.GLOBSTAR})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,C=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new R.LRUCache(1e4),a=function(){return!1},g=function(){return null};function r(_,x){if(!_)return g;let $;typeof _!="string"?$=_.pattern:$=_,$=$.trim();const V=`${$}_${!!x.trimForExclusions}`;let X=c.get(V);if(X)return i(X,_);let z;return h.test($)?X=o($.substr(4),$):(z=f.exec(s($,x)))?X=l(z[1],$):(x.trimForExclusions?C:v).test($)?X=y($,x):(z=m.exec(s($,x)))?X=S(z[1].substr(1),$,!0):(z=u.exec(s($,x)))?X=S(z[1],$,!1):X=L($),c.set(V,X),i(X,_)}function i(_,x){return typeof x=="string"?_:function($,V){return(0,n.isEqualOrParent)($,x.base,!M.isLinux)?_($.substr(x.base.length+1),V):null}}function s(_,x){return x.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function o(_,x){return function($,V){return typeof $=="string"&&$.endsWith(_)?x:null}}function l(_,x){const $=`/${_}`,V=`\\${_}`,X=function(O,U){return typeof O!="string"?null:U?U===_?x:null:O===_||O.endsWith($)||O.endsWith(V)?x:null},z=[_];return X.basenames=z,X.patterns=[x],X.allBasenames=z,X}function y(_,x){const $=G(_.slice(1,-1).split(",").map(U=>r(U,x)).filter(U=>U!==g),_),V=$.length;if(!V)return g;if(V===1)return $[0];const X=function(U,W){for(let A=0,F=$.length;A<F;A++)if($[A](U,W))return _;return null},z=$.find(U=>!!U.allBasenames);z&&(X.allBasenames=z.allBasenames);const O=$.reduce((U,W)=>W.allPaths?U.concat(W.allPaths):U,[]);return O.length&&(X.allPaths=O),X}function S(_,x,$){const V=D.sep===D.posix.sep,X=V?_:_.replace(k,D.sep),z=D.sep+X,O=D.posix.sep+_;let U;return $?U=function(W,A){return typeof W=="string"&&(W===X||W.endsWith(z)||!V&&(W===_||W.endsWith(O)))?x:null}:U=function(W,A){return typeof W=="string"&&(W===X||!V&&W===_)?x:null},U.allPaths=[($?"*/":"./")+_],U}function L(_){try{const x=new RegExp(`^${t(_)}$`);return function($){return x.lastIndex=0,typeof $=="string"&&x.test($)?_:null}}catch{return g}}function T(_,x,$){return!_||typeof x!="string"?!1:B(_)(x,void 0,$)}e.match=T;function B(_,x={}){if(!_)return a;if(typeof _=="string"||Y(_)){const $=r(_,x);if($===g)return a;const V=function(X,z){return!!$(X,z)};return $.allBasenames&&(V.allBasenames=$.allBasenames),$.allPaths&&(V.allPaths=$.allPaths),V}return Q(_,x)}e.parse=B;function Y(_){const x=_;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=Y;function ee(_){return _.allBasenames||[]}e.getBasenameTerms=ee;function te(_){return _.allPaths||[]}e.getPathTerms=te;function Q(_,x){const $=G(Object.getOwnPropertyNames(_).map(U=>q(U,_[U],x)).filter(U=>U!==g)),V=$.length;if(!V)return g;if(!$.some(U=>!!U.requiresSiblings)){if(V===1)return $[0];const U=function(F,N){for(let K=0,se=$.length;K<se;K++){const ae=$[K](F,N);if(ae)return ae}return null},W=$.find(F=>!!F.allBasenames);W&&(U.allBasenames=W.allBasenames);const A=$.reduce((F,N)=>N.allPaths?F.concat(N.allPaths):F,[]);return A.length&&(U.allPaths=A),U}const X=function(U,W,A){let F;for(let N=0,K=$.length;N<K;N++){const se=$[N];se.requiresSiblings&&A&&(W||(W=(0,D.basename)(U)),F||(F=W.substr(0,W.length-(0,D.extname)(U).length)));const ae=se(U,W,F,A);if(ae)return ae}return null},z=$.find(U=>!!U.allBasenames);z&&(X.allBasenames=z.allBasenames);const O=$.reduce((U,W)=>W.allPaths?U.concat(W.allPaths):U,[]);return O.length&&(X.allPaths=O),X}function q(_,x,$){if(x===!1)return g;const V=r(_,$);if(V===g)return g;if(typeof x=="boolean")return V;if(x){const X=x.when;if(typeof X=="string"){const z=(O,U,W,A)=>{if(!A||!V(O,U))return null;const F=X.replace("$(basename)",W),N=A(F);return(0,w.isThenable)(N)?N.then(K=>K?_:null):N?_:null};return z.requiresSiblings=!0,z}}return V}function G(_,x){const $=_.filter(U=>!!U.basenames);if($.length<2)return _;const V=$.reduce((U,W)=>{const A=W.basenames;return A?U.concat(A):U},[]);let X;if(x){X=[];for(let U=0,W=V.length;U<W;U++)X.push(x)}else X=$.reduce((U,W)=>{const A=W.patterns;return A?U.concat(A):U},[]);const z=function(U,W){if(typeof U!="string")return null;if(!W){let F;for(F=U.length;F>0;F--){const N=U.charCodeAt(F-1);if(N===47||N===92)break}W=U.substr(F)}const A=V.indexOf(W);return A!==-1?X[A]:null};z.basenames=V,z.patterns=X,z.allBasenames=V;const O=_.filter(U=>!U.basenames);return O.push(z),O}}),define(J[32],Z([0,1,28,10,7,3,17,27,8]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function E(i,s,o){if(typeof i=="string"&&(i=d.URI.file(i)),o){const y=o.getWorkspaceFolder(i);if(y){const S=o.getWorkspace().folders.length>1;let L;if((0,M.isEqual)(y.uri,i)?L="":L=(0,M.relativePath)(y.uri,i),S){const T=y.name?y.name:(0,M.basename)(y.uri);L=L?T+" \u2022 "+L:T}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(i.fsPath))return(0,R.normalize)(k(i.fsPath));let l=(0,R.normalize)(i.fsPath);return!D.isWindows&&s?.userHome&&(l=p(l,s.userHome.fsPath)),l}e.getPathLabel=E;function P(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const s=(0,M.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,w.isRootOrDriveLetter)(s)?k(s):s}e.getBaseLabel=P;function k(i,s){return(0,w.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let I=Object.create(null);function p(i,s){if(D.isWindows||!i||!s)return i;let o=I.original===s?I.normalized:void 0;return o||(o=`${(0,b.rtrim)(s,R.posix.sep)}${R.posix.sep}`,I={original:s,normalized:o}),(D.isLinux?i.startsWith(o):(0,b.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=p;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const h="\u2026",f="\\\\",v="~";function C(i,s=R.sep){const o=new Array(i.length);let l=!1;for(let y=0;y<i.length;y++){let S=i[y];if(S===""){o[y]=`.${s}`;continue}if(!S){o[y]=S;continue}l=!0;let L="";S.indexOf(f)===0?(L=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length)):S.indexOf(s)===0?(L=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length)):S.indexOf(v)===0&&(L=S.substr(0,S.indexOf(v)+v.length),S=S.substr(S.indexOf(v)+v.length));const T=S.split(s);for(let B=1;l&&B<=T.length;B++)for(let Y=T.length-B;l&&Y>=0;Y--){l=!1;let ee=T.slice(Y,Y+B).join(s);for(let te=0;!l&&te<i.length;te++)if(te!==y&&i[te]&&i[te].indexOf(ee)>-1){const Q=Y+B===T.length,q=Y>0&&i[te].indexOf(s)>-1?s+ee:ee,G=i[te].endsWith(q);l=!Q||G}if(!l){let te="";(T[0].endsWith(":")||L!=="")&&(Y===1&&(Y=0,B++,ee=T[0]+s+ee),Y>0&&(te=T[0]+s),te=L+te),Y>0&&(te=te+h+s),te=te+ee,Y+B<T.length&&(te=te+s+h),o[y]=te}}l&&(o[y]=S)}return o}e.shorten=C;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function u(i,s=Object.create(null)){const o=[];let l=!1,y="";for(const S of i)if(S==="$"||l&&S==="{")y&&o.push({value:y,type:m.TEXT}),y="",l=!0;else if(S==="}"&&l){const L=s[y];if(typeof L=="string")L.length&&o.push({value:L,type:m.VARIABLE});else if(L){const T=o[o.length-1];(!T||T.type!==m.SEPARATOR)&&o.push({value:L.label,type:m.SEPARATOR})}y="",l=!1}else y+=S;return y&&!l&&o.push({value:y,type:m.TEXT}),o.filter((S,L)=>{if(S.type===m.SEPARATOR){const T=o[L-1],B=o[L+1];return[T,B].every(Y=>Y&&(Y.type===m.VARIABLE||Y.type===m.TEXT)&&Y.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=u;function c(i,s){return D.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function a(i,s){return D.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function g(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=g;function r(i){const s=i.indexOf("/")!==-1?R.posix:R.win32,o=s.basename(i),l=s.dirname(i);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(J[117],Z([0,1,8]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const I=this._uriTransformer.transformIncoming(k);return I===k?k:n(w.URI.from(I))}transformOutgoing(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:n(w.URI.from(I))}transformOutgoingURI(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:w.URI.from(I)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function D(P,k,I){if(!P||I>200)return null;if(typeof P=="object"){if(P instanceof w.URI)return k.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const t=D(P[p],k,I+1);t!==null&&(P[p]=t)}}return null}function M(P,k){const I=D(P,k,0);return I===null?P:I}e.transformOutgoingURIs=M;function b(P,k,I,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return I?w.URI.revive(k.transformIncoming(P)):k.transformIncoming(P);for(let t in P)if(Object.hasOwnProperty.call(P,t)){const h=b(P[t],k,I,p+1);h!==null&&(P[t]=h)}}return null}function d(P,k){const I=b(P,k,!1,0);return I===null?P:I}e.transformIncomingURIs=d;function E(P,k){const I=b(P,k,!0,0);return I===null?P:I}e.transformAndReviveIncomingURIs=E}),define(J[31],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(d){return w.test(d)}e.isUUID=n;const R=new Uint8Array(16),D=[];for(let d=0;d<256;d++)D.push(d.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(d){for(let E=0;E<d.length;E++)d[E]=Math.floor(Math.random()*256);return d};function b(){M(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let d=0,E="";return E+=D[R[d++]],E+=D[R[d++]],E+=D[R[d++]],E+=D[R[d++]],E+="-",E+=D[R[d++]],E+=D[R[d++]],E+="-",E+=D[R[d++]],E+=D[R[d++]],E+="-",E+=D[R[d++]],E+=D[R[d++]],E+="-",E+=D[R[d++]],E+=D[R[d++]],E+=D[R[d++]],E+=D[R[d++]],E+=D[R[d++]],E+=D[R[d++]],E}e.generateUuid=b}),define(J[118],Z([0,1,15,4,2,3,14,27]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let E=!1;function P(r){!D.isWeb||(E||(E=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=P;var k;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(k||(k={}));class I{constructor(i,s,o,l){this.vsWorker=i,this.req=s,this.method=o,this.args=l,this.type=0}}class p{constructor(i,s,o,l){this.vsWorker=i,this.seq=s,this.res=o,this.err=l,this.type=1}}class t{constructor(i,s,o,l){this.vsWorker=i,this.req=s,this.eventName=o,this.arg=l,this.type=2}}class h{constructor(i,s,o){this.vsWorker=i,this.req=s,this.event=o,this.type=3}}class f{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const o=String(++this._lastSentReq);return new Promise((l,y)=>{this._pendingReplies[o]={resolve:l,reject:y},this._send(new I(this._workerId,o,i,s))})}listen(i,s){let o=null;const l=new n.Emitter({onFirstListenerAdd:()=>{o=String(++this._lastSentReq),this._pendingEmitters.set(o,l),this._send(new t(this._workerId,o,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(o),this._send(new f(this._workerId,o)),o=null}});return l.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let o=i.err;i.err.$isError&&(o=new Error,o.name=i.err.name,o.message=i.err.message,o.stack=i.err.stack),s.reject(o);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(l=>{this._send(new p(this._workerId,s,l,void 0))},l=>{l.detail instanceof Error&&(l.detail=(0,w.transformErrorForSerialization)(l.detail)),this._send(new p(this._workerId,s,void 0,(0,w.transformErrorForSerialization)(l)))})}_handleSubscribeEventMessage(i){const s=i.req,o=this._handler.handleEvent(i.eventName,i.arg)(l=>{this._send(new h(this._workerId,s,l))});this._pendingEvents.set(s,o)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let o=0;o<i.args.length;o++)i.args[o]instanceof ArrayBuffer&&s.push(i.args[o]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class C extends R.Disposable{constructor(i,s,o){super();let l=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",B=>{this._protocol.handleMessage(B)},B=>{l&&l(B)})),this._protocol=new v({sendMessage:(B,Y)=>{this._worker.postMessage(B,Y)},handleMessage:(B,Y)=>{if(typeof o[B]!="function")return Promise.reject(new Error("Missing method "+B+" on main thread host."));try{return Promise.resolve(o[B].apply(o,Y))}catch(ee){return Promise.reject(ee)}},handleEvent:(B,Y)=>{if(u(B)){const ee=o[B].call(o,Y);if(typeof ee!="function")throw new Error(`Missing dynamic event ${B} on main thread host.`);return ee}if(m(B)){const ee=o[B];if(typeof ee!="function")throw new Error(`Missing event ${B} on main thread host.`);return ee}throw new Error(`Malformed event name ${B}`)}}),this._protocol.setWorkerId(this._worker.getId());let y=null;typeof D.globals.require!="undefined"&&typeof D.globals.require.getConfig=="function"?y=D.globals.require.getConfig():typeof D.globals.requirejs!="undefined"&&(y=D.globals.requirejs.s.contexts._.config);const S=M.getAllMethodNames(o);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(y)),s,S]);const L=(B,Y)=>this._request(B,Y),T=(B,Y)=>this._protocol.listen(B,Y);this._lazyProxy=new Promise((B,Y)=>{l=Y,this._onModuleLoaded.then(ee=>{B(c(ee,L,T))},ee=>{Y(ee),this._onError("Worker failed to load "+s,ee)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((o,l)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(o,l)},l)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=C;function m(r){return r[0]==="o"&&r[1]==="n"&&b.isUpperAsciiLetter(r.charCodeAt(2))}function u(r){return/^onDynamic/.test(r)&&b.isUpperAsciiLetter(r.charCodeAt(9))}function c(r,i,s){const o=S=>function(){const L=Array.prototype.slice.call(arguments,0);return i(S,L)},l=S=>function(L){return s(S,L)};let y={};for(const S of r){if(u(S)){y[S]=l(S);continue}if(m(S)){y[S]=s(S,void 0);continue}y[S]=o(S)}return y}class a{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new v({sendMessage:(o,l)=>{i(o,l)},handleMessage:(o,l)=>this._handleMessage(o,l),handleEvent:(o,l)=>this._handleEvent(o,l)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===d)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(o){return Promise.reject(o)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(u(i)){const o=this._requestHandler[i].call(this._requestHandler,s);if(typeof o!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return o}if(m(i)){const o=this._requestHandler[i];if(typeof o!="function")throw new Error(`Missing event ${i} on request handler.`);return o}throw new Error(`Malformed event name ${i}`)}initialize(i,s,o,l){this._protocol.setWorkerId(i);const L=c(l,(T,B)=>this._protocol.sendMessage(T,B),(T,B)=>this._protocol.listen(T,B));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,D.globals.require.config(s)),new Promise((T,B)=>{(D.globals.require||H)([o],ee=>{if(this._requestHandler=ee.create(L),!this._requestHandler){B(new Error("No RequestHandler!"));return}T(M.getAllMethodNames(this._requestHandler))},B)}))}}e.SimpleWorkerServer=a;function g(r){return new a(r,null)}e.create=g}),define(J[119],Z([0,1,60,29,43]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(M,b){if(await new Promise((P,k)=>{const I=n.createReadStream(M),p=w.createHash("sha1");I.pipe(p);const t=(0,R.once)((h,f)=>{I.removeAllListeners(),p.removeAllListeners(),h?k(h):P(f)});I.once("error",t),I.once("end",t),p.once("error",t),p.once("data",h=>t(void 0,h.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=D}),define(J[120],Z([0,1,248]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(D="utf8"){this.stringDecoder=new w.StringDecoder(D),this.remaining=null}write(D){const M=[],b=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(b.length<1)return M;let d=0,E,P=d;for(;P<b.length;)if(E=b.charCodeAt(P),E===13||E===10){if(M.push(b.substring(d,P)),P++,P<b.length){const k=E;E=b.charCodeAt(P),(k===13&&E===10||k===10&&E===13)&&P++}d=P}else P++;return this.remaining=d<b.length?b.substr(d):null,M}end(){return this.remaining}}e.LineDecoder=n}),define(J[121],Z([0,1,26]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(M){const b=M.replace(/\-/g,":").toLowerCase();return!n.has(b)}function D(){const M=(0,w.networkInterfaces)();for(let b in M){const d=M[b];if(d){for(const{mac:E}of d)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(J[71],Z([0,1,26,15,35,31,121]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,k=0;const I=(0,w.networkInterfaces)();for(let p in I){const t=I[p];if(t)for(const{mac:h,internal:f}of t)f||(k+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(P+=1))}this._value=k>0?P/k:0}return this._value}};let b;async function d(){return b||(b=(async()=>await E()||D.generateUuid())()),b}e.getMachineId=d;async function E(){try{const P=await new Promise((I,p)=>{H(["crypto"],I,p)}),k=(0,M.getMac)();return P.createHash("sha256").update(k,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(J[24],Z([0,1,29,26,122,9,28,70,7,3,17,8]),function(H,e,w,n,R,D,M,b,d,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function p(Q,q=I.UNLINK){if((0,M.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");return q===I.UNLINK?h(Q):t(Q)}async function t(Q){try{const q=(0,M.randomPath)((0,n.tmpdir)());try{await w.promises.rename(Q,q)}catch{return h(Q)}h(q).catch(G=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function h(Q){return e.Promises.rmdir(Q,{recursive:!0,maxRetries:3})}function f(Q){if((0,M.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(Q,{recursive:!0})}e.rimrafSync=f;async function v(Q,q){return u(await(q?C(Q):(0,R.promisify)(w.readdir)(Q)))}async function C(Q){try{return await(0,R.promisify)(w.readdir)(Q,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const q=[],G=await v(Q);for(const _ of G){let x=!1,$=!1,V=!1;try{const X=await e.Promises.lstat((0,d.join)(Q,_));x=X.isFile(),$=X.isDirectory(),V=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}q.push({name:_,isFile:()=>x,isDirectory:()=>$,isSymbolicLink:()=>V})}return q}function m(Q){return u(w.readdirSync(Q))}e.readdirSync=m;function u(Q){return Q.map(q=>typeof q=="string"?E.isMacintosh?(0,b.normalizeNFC)(q):q:(q.name=E.isMacintosh?(0,b.normalizeNFC)(q.name):q.name,q))}async function c(Q){const q=await v(Q),G=[];for(const _ of q)await g.existsDirectory((0,d.join)(Q,_))&&G.push(_);return G}function a(Q,q=1e3){return new Promise(G=>{let _=!1;const x=setInterval(()=>{_||(_=!0,w.access(Q,$=>{_=!1,$&&(clearInterval(x),G(void 0))}))},q)})}e.whenDeleted=a;var g;(function(Q){async function q(x){let $;try{if($=await e.Promises.lstat(x),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(E.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw X}throw V}}Q.stat=q;async function G(x){try{const{stat:$,symbolicLink:V}=await Q.stat(x);return $.isFile()&&V?.dangling!==!0}catch{}return!1}Q.existsFile=G;async function _(x){try{const{stat:$,symbolicLink:V}=await Q.stat(x);return $.isDirectory()&&V?.dangling!==!0}catch{}return!1}Q.existsDirectory=_})(g=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function i(Q,q,G){return r.queueFor(k.URI.file(Q),P.extUriBiasedIgnorePathCase).queue(()=>{const _=y(G);return new Promise((x,$)=>o(Q,q,_,V=>V?$(V):x()))})}let s=!0;function o(Q,q,G,_){if(!s)return w.writeFile(Q,q,{mode:G.mode,flag:G.flag},_);w.open(Q,G.flag,G.mode,(x,$)=>{if(x)return _(x);w.writeFile($,q,V=>{if(V)return w.close($,()=>_(V));w.fdatasync($,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),s=!1),w.close($,z=>_(z))))})})}function l(Q,q,G){const _=y(G);if(!s)return w.writeFileSync(Q,q,{mode:_.mode,flag:_.flag});const x=w.openSync(Q,_.flag,_.mode);try{w.writeFileSync(x,q);try{w.fdatasyncSync(x)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),s=!1}}finally{w.closeSync(x)}}e.writeFileSync=l;function y(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function S(Q,q){if(Q!==q)try{await e.Promises.rename(Q,q)}catch(G){if(Q.toLowerCase()!==q.toLowerCase()&&G.code==="EXDEV"||Q.endsWith("."))await L(Q,q,{preserveSymlinks:!1}),await p(Q,I.MOVE);else throw G}}async function L(Q,q,G){return B(Q,q,{root:{source:Q,target:q},options:G,handledSourcePaths:new Set})}const T=511;async function B(Q,q,G){if(G.handledSourcePaths.has(Q))return;G.handledSourcePaths.add(Q);const{stat:_,symbolicLink:x}=await g.stat(Q);if(x){if(G.options.preserveSymlinks)try{return await te(Q,q,G)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(x.dangling)return}return _.isDirectory()?Y(Q,q,_.mode&T,G):ee(Q,q,_.mode&T)}async function Y(Q,q,G,_){await e.Promises.mkdir(q,{recursive:!0,mode:G});const x=await v(Q);for(const $ of x)await B((0,d.join)(Q,$),(0,d.join)(q,$),_)}async function ee(Q,q,G){await e.Promises.copyFile(Q,q),await e.Promises.chmod(q,G)}async function te(Q,q,G){let _=await e.Promises.readlink(Q);(0,M.isEqualOrParent)(_,G.root.source,!E.isLinux)&&(_=(0,d.join)(G.root.target,_.substr(G.root.source.length+1))),await e.Promises.symlink(_,q)}e.Promises=new class{get access(){return(0,R.promisify)(w.access)}get stat(){return(0,R.promisify)(w.stat)}get lstat(){return(0,R.promisify)(w.lstat)}get utimes(){return(0,R.promisify)(w.utimes)}get read(){return(Q,q,G,_,x)=>new Promise(($,V)=>{w.read(Q,q,G,_,x,(X,z,O)=>X?V(X):$({bytesRead:z,buffer:O}))})}get readFile(){return(0,R.promisify)(w.readFile)}get write(){return(Q,q,G,_,x)=>new Promise(($,V)=>{w.write(Q,q,G,_,x,(X,z,O)=>X?V(X):$({bytesWritten:z,buffer:O}))})}get appendFile(){return(0,R.promisify)(w.appendFile)}get fdatasync(){return(0,R.promisify)(w.fdatasync)}get truncate(){return(0,R.promisify)(w.truncate)}get rename(){return(0,R.promisify)(w.rename)}get copyFile(){return(0,R.promisify)(w.copyFile)}get open(){return(0,R.promisify)(w.open)}get close(){return(0,R.promisify)(w.close)}get symlink(){return(0,R.promisify)(w.symlink)}get readlink(){return(0,R.promisify)(w.readlink)}get chmod(){return(0,R.promisify)(w.chmod)}get mkdir(){return(0,R.promisify)(w.mkdir)}get unlink(){return(0,R.promisify)(w.unlink)}get rmdir(){return(0,R.promisify)(w.rmdir)}get realpath(){return(0,R.promisify)(w.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return p}get move(){return S}get copy(){return L}}}),define(J[86],Z([0,1,29,7,3,27,24]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(I){if(R.isLinux)return I;const p=(0,n.dirname)(I);if(I===p)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const f=(0,M.readdirSync)(p).filter(v=>v.toLowerCase()===t);if(f.length===1){const v=b(p);if(v)return(0,n.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(t);if(v>=0){const C=b(p);if(C)return(0,n.join)(C,f[v])}}}catch{}return null}e.realcaseSync=b;async function d(I){if(R.isLinux)return I;const p=(0,n.dirname)(I);if(I===p)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const f=(await M.Promises.readdir(p)).filter(v=>v.toLowerCase()===t);if(f.length===1){const v=await d(p);if(v)return(0,n.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(t);if(v>=0){const C=await d(p);if(C)return(0,n.join)(C,f[v])}}}catch{}return null}e.realcase=d;async function E(I){try{return await M.Promises.realpath(I)}catch{const t=k(I);return await M.Promises.access(t,w.constants.R_OK),t}}e.realpath=E;function P(I){try{return w.realpathSync(I)}catch{const t=k(I);return w.accessSync(t,w.constants.R_OK),t}}e.realpathSync=P;function k(I){return(0,D.rtrim)((0,n.normalize)(I),n.sep)}}),define(J[123],Z([0,1,61]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(b,d,E,P=1){let k=!1;return new Promise(I=>{const p=setTimeout(()=>{if(!k)return k=!0,I(0)},E);R(b,d,P,t=>{if(!k)return k=!0,clearTimeout(p),I(t)})})}e.findFreePort=n;function R(b,d,E,P){if(d===0)return P(0);const k=new w.Socket;k.once("connect",()=>(M(k),R(b+E,d-1,E,P))),k.once("data",()=>{}),k.once("error",I=>(M(k),I.code!=="ECONNREFUSED"?R(b+E,d-1,E,P):P(b))),k.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(b,d,E){let P=!1,k,I=1;const p=w.createServer({pauseOnConnect:!0});function t(h,f){P||(P=!0,p.removeAllListeners(),p.close(),k&&clearTimeout(k),f(h))}return new Promise(h=>{k=setTimeout(()=>{t(0,h)},E),p.on("listening",()=>{t(b,h)}),p.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&I<d?(b++,I++,p.listen(b,"127.0.0.1")):t(0,h)}),p.on("close",()=>{t(0,h)}),p.listen(b,"127.0.0.1")})}e.findFreePortFaster=D;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(d){console.error(d)}}}),define(J[124],Z([0,1,26,7,24]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,M=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var d;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(d||(d={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class k{constructor(c,a,g){this.exePath=c,this.displayName=a,this.knownToExist=g}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:u=!1}={}){return u?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:u=!1,findPreview:c=!1}={}){const a=I({useAlternateBitness:u});if(!a)return null;const g=n.join(a,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(g))return null;let r=-1,i=null;for(const l of await R.Promises.readdir(g)){let y=-1;if(c){const L=l.indexOf("-");if(L<0)continue;const T=l.substring(0,L);if(!D.test(T)||l.substring(L+1)!=="preview")continue;y=parseInt(T,10)}else{if(!D.test(l))continue;y=parseInt(l,10)}if(y<=r)continue;const S=n.join(g,l,"pwsh.exe");!await R.SymlinkSupport.existsFile(S)||(i=S,r=y)}if(!i)return null;const s=a.includes("x86")?" (x86)":"",o=c?" Preview":"";return new k(i,`PowerShell${o}${s}`,!0)}async function t({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:a,pwshMsixName:g}=u?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const r of await R.Promises.readdir(c))if(a.test(r)){const i=n.join(c,r,"pwsh.exe");return new k(i,g)}return null}function h(){const u=n.join(w.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function f(){const u=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}async function*v(){let u=await p();u&&(yield u),u=await p({useAlternateBitness:!0}),u&&(yield u),u=await t(),u&&(yield u),u=h(),u&&(yield u),u=await p({findPreview:!0}),u&&(yield u),u=await t({findPreview:!0}),u&&(yield u),u=await p({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=f(),u&&(yield u)}async function*C(){for await(const u of v())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=C;async function m(){for await(const u of C())return u;return null}e.getFirstAvailablePowerShellInstallation=m}),define(J[87],Z([0,1,45,10]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(M){return new Promise((b,d)=>{let E;const P=new Map;function k(p,t,h,f,v){const C=P.get(t);if(p===M||C){const m={name:I(h),cmd:h,pid:p,ppid:t,load:f,mem:v};P.set(p,m),p===M&&(E=m),C&&(C.children||(C.children=[]),C.children.push(m),C.children.length>1&&(C.children=C.children.sort((u,c)=>u.pid-c.pid)))}}function I(p){const t=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,C=/--crashes-directory/,m=/\\pipe\\winpty-control/,u=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(C.exec(p))return"electron-crash-reporter";if(m.exec(p))return"winpty-process";if(u.exec(p))return"console-window-host (Windows internal process)";let a=c.exec(p);if(a&&a.length===2)return a[1]==="renderer"?t.exec(p)?"shared-process":h.exec(p)?"issue-reporter":f.exec(p)?"process-explorer":"window":a[1]==="utility"&&v.exec(p)?"utility-network-service":a[1];const g=/[a-zA-Z-]+\.js/g;let r="";do a=g.exec(p),a&&(r+=a+" ");while(a);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,h)=>{H(["windows-process-tree"],t,h)}).then(t=>{t.getProcessList(M,h=>{t.getProcessCpuUsage(h,f=>{const v=new Map;f.forEach(C=>{const m=p(C.commandLine||"");v.set(C.pid,{name:I(m),cmd:m,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),E=v.get(M),E?(v.forEach(C=>{const m=v.get(C.ppid);m&&(m.children||(m.children=[]),m.children.push(C))}),v.forEach(C=>{C.children&&(C.children=C.children.sort((m,u)=>m.pid-u.pid))}),b(E)):d(new Error(`Root process ${M} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[E];const h=[];for(;t.length;){const v=t.shift();v&&(h.push(v.pid),v.children&&(t=t.concat(v.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);f+=" "+h.join(" "),(0,w.exec)(f,{},(v,C,m)=>{if(v||m)d(v||new Error(m.toString()));else{const u=C.toString().split(`
`);for(let c=0;c<h.length;c++){const a=P.get(h[c]);a.load=parseFloat(u[c])}if(!E){d(new Error(`Root process ${M} not found`));return}b(E)}})};(0,w.exec)("which ps",{},(t,h,f)=>{if(t||f)if(process.platform!=="linux")d(t||new Error(f.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,w.exec)(v,{},(C,m,u)=>{C||u?d(C||new Error(u.toString())):(D(m,k),p())})}else{const v=h.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${v} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,u,c)=>{m||c&&!c.includes("screen size is bogus")?d(m||new Error(c.toString())):(D(u,k),process.platform==="linux"?p():E?b(E):d(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=R;function D(M,b){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=M.toString().split(`
`);for(const P of E){const k=d.exec(P.trim());k&&k.length===6&&b(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(J[125],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[126],Z([0,1,12,14,125]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){w.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(b,d,E,P,k)=>{const I=M(b,P,E);I.popup({window:(0,n.withNullAsUndefined)(w.BrowserWindow.fromWebContents(b.sender)),x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{I&&b.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=D;function M(b,d,E){const P=new w.Menu;return E.forEach(k=>{let I;k.type==="separator"?I=new w.MenuItem({type:k.type}):Array.isArray(k.submenu)?I=new w.MenuItem({submenu:M(b,d,k.submenu),label:k.label}):I=new w.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(p,t,h)=>b.sender.send(d,k.id,h)}),P.append(I)}),P}});var ue=this&&this.__decorate||function(H,e,w,n){var R=arguments.length,D=R<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,w):n,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(H,e,w,n);else for(var b=H.length-1;b>=0;b--)(M=H[b])&&(D=(R<3?M(D):R>3?M(e,w,D):M(e,w))||D);return R>3&&D&&Object.defineProperty(e,w,D),D};define(J[37],Z([0,1,30,9,16,23,46,15,4,2,115,27,14]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function f($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(v||(v={}));class C{constructor(V){this.buffer=V,this.pos=0}read(V){const X=this.buffer.slice(this.pos,this.pos+V);return this.pos+=X.byteLength,X}}class m{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var u;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(u||(u={}));function c($){const V=R.VSBuffer.alloc(4);return V.writeUInt32BE($,0),V}function a($){return $.read(4).readUInt32BE(0)}function g($){const V=R.VSBuffer.alloc(1);return V.writeUInt8($,0),V}const r={Undefined:g(u.Undefined),String:g(u.String),Buffer:g(u.Buffer),VSBuffer:g(u.VSBuffer),Array:g(u.Array),Object:g(u.Object)},i=typeof Buffer!="undefined";function s($,V){if(typeof V=="undefined")$.write(r.Undefined);else if(typeof V=="string"){const X=R.VSBuffer.fromString(V);$.write(r.String),$.write(c(X.byteLength)),$.write(X)}else if(i&&Buffer.isBuffer(V)){const X=R.VSBuffer.wrap(V);$.write(r.Buffer),$.write(c(X.byteLength)),$.write(X)}else if(V instanceof R.VSBuffer)$.write(r.VSBuffer),$.write(c(V.byteLength)),$.write(V);else if(Array.isArray(V)){$.write(r.Array),$.write(c(V.length));for(const X of V)s($,X)}else{const X=R.VSBuffer.fromString(JSON.stringify(V));$.write(r.Object),$.write(c(X.byteLength)),$.write(X)}}function o($){switch($.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return $.read(a($)).toString();case u.Buffer:return $.read(a($)).buffer;case u.VSBuffer:return $.read(a($));case u.Array:{const X=a($),z=[];for(let O=0;O<X;O++)z.push(o($));return z}case u.Object:return JSON.parse($.read(a($)).toString())}}class l{constructor(V,X,z=null,O=1e3){this.protocol=V,this.ctx=X,this.logger=z,this.timeoutDelay=O,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(V,X){this.channels.set(V,X),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const X=this.send([V.type]);this.logger?.logOutgoing(X,0,1,f(V.type));return}case 201:case 202:case 204:case 203:{const X=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(X,V.id,1,f(V.type),V.data);return}}}send(V,X=void 0){const z=new m;return s(z,V),s(z,X),this.sendBuffer(z.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const X=new C(V),z=o(X),O=o(X),U=z[0];switch(U){case 100:return this.logger?.logIncoming(V.byteLength,z[1],1,`${t(U)}: ${z[2]}.${z[3]}`,O),this.onPromise({type:U,id:z[1],channelName:z[2],name:z[3],arg:O});case 102:return this.logger?.logIncoming(V.byteLength,z[1],1,`${t(U)}: ${z[2]}.${z[3]}`,O),this.onEventListen({type:U,id:z[1],channelName:z[2],name:z[3],arg:O});case 101:return this.logger?.logIncoming(V.byteLength,z[1],1,`${t(U)}`),this.disposeActiveRequest({type:U,id:z[1]});case 103:return this.logger?.logIncoming(V.byteLength,z[1],1,`${t(U)}`),this.disposeActiveRequest({type:U,id:z[1]})}}onPromise(V){const X=this.channels.get(V.channelName);if(!X){this.collectPendingRequest(V);return}const z=new D.CancellationTokenSource;let O;try{O=X.call(this.ctx,V.name,V.arg,z.token)}catch(A){O=Promise.reject(A)}const U=V.id;O.then(A=>{this.sendResponse({id:U,data:A,type:201}),this.activeRequests.delete(V.id)},A=>{A instanceof Error?this.sendResponse({id:U,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:U,data:A,type:203}),this.activeRequests.delete(V.id)});const W=(0,E.toDisposable)(()=>z.cancel());this.activeRequests.set(V.id,W)}onEventListen(V){const X=this.channels.get(V.channelName);if(!X){this.collectPendingRequest(V);return}const z=V.id,U=X.listen(this.ctx,V.name,V.arg)(W=>this.sendResponse({id:z,data:W,type:204}));this.activeRequests.set(V.id,U)}disposeActiveRequest(V){const X=this.activeRequests.get(V.id);X&&(X.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let X=this.pendingRequests.get(V.channelName);X||(X=[],this.pendingRequests.set(V.channelName,X));const z=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:V,timeoutTimer:z})}flushPendingRequests(V){const X=this.pendingRequests.get(V);if(X){for(const z of X)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var y;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(V,X=null){this.protocol=V,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=X}getChannel(V){const X=this;return{call(z,O,U){return X.isDisposed?Promise.reject(b.canceled()):X.requestPromise(V,z,O,U)},listen(z,O){return X.isDisposed?d.Event.None:X.requestEvent(V,z,O)}}}requestPromise(V,X,z,O=D.CancellationToken.None){const U=this.lastRequestId++,A={id:U,type:100,channelName:V,name:X,arg:z};if(O.isCancellationRequested)return Promise.reject(b.canceled());let F;return new Promise((K,se)=>{if(O.isCancellationRequested)return se(b.canceled());const ae=()=>{const he=we=>{switch(we.type){case 201:this.handlers.delete(U),K(we.data);break;case 202:{this.handlers.delete(U);const be=new Error(we.data.message);be.stack=we.data.stack,be.name=we.data.name,se(be);break}case 203:this.handlers.delete(U),se(we.data);break}};this.handlers.set(U,he),this.sendRequest(A)};let ce=null;this.state===v.Idle?ae():(ce=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ce.then(()=>{ce=null,ae()}));const ne=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:U,type:101}),se(b.canceled())},le=O.onCancellationRequested(ne);F=(0,E.combinedDisposable)((0,E.toDisposable)(ne),le),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(V,X,z){const O=this.lastRequestId++,W={id:O,type:102,channelName:V,name:X,arg:z};let A=null;const F=new d.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(K=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(F),this.sendRequest(W)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(F),this.sendRequest({id:O,type:103}))}}),N=K=>F.fire(K.data);return this.handlers.set(O,N),F.event}sendRequest(V){switch(V.type){case 100:case 102:{const X=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger&&this.logger.logOutgoing(X,V.id,0,`${t(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const X=this.send([V.type,V.id]);this.logger&&this.logger.logOutgoing(X,V.id,0,t(V.type));return}}}send(V,X=void 0){const z=new m;return s(z,V),s(z,X),this.sendBuffer(z.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const X=new C(V),z=o(X),O=o(X),U=z[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(V.byteLength,0,0,f(U)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(V.byteLength,z[1],0,f(U),O),this.onResponse({type:z[0],id:z[1],data:O})}}onResponse(V){if(V.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(V.id);X&&X(V)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([M.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class L{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:X,onDidClientDisconnect:z})=>{d.Event.once(X.onMessage)(U=>{const W=new C(U),A=o(W),F=new l(X,A),N=new S(X);this.channels.forEach((se,ae)=>F.registerChannel(ae,se));const K={channelServer:F,channelClient:N,ctx:A};this._connections.add(K),this._onDidAddConnection.fire(K),z(()=>{F.dispose(),N.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const V=[];return this._connections.forEach(X=>V.push(X)),V}getChannel(V,X){const z=this;return{call(O,U,W){let A;if((0,I.isFunction)(X)){let N=(0,w.getRandomElement)(z.connections.filter(X));A=N?Promise.resolve(N):d.Event.toPromise(d.Event.filter(z.onDidAddConnection,X))}else A=X.routeCall(z,O,U);const F=A.then(N=>N.channelClient.getChannel(V));return B(F).call(O,U,W)},listen(O,U){if((0,I.isFunction)(X))return z.getMulticastEvent(V,X,O,U);const W=X.routeEvent(z,O,U).then(A=>A.channelClient.getChannel(V));return B(W).listen(O,U)}}}getMulticastEvent(V,X,z,O){const U=this;let W=new E.DisposableStore;const A=new d.Emitter({onFirstListenerAdd:()=>{W=new E.DisposableStore;const F=new d.EventMultiplexer,N=new Map,K=ae=>{const ne=ae.channelClient.getChannel(V).listen(z,O),le=F.add(ne);N.set(ae,le)},se=ae=>{const ce=N.get(ae);!ce||(ce.dispose(),N.delete(ae))};U.connections.filter(X).forEach(K),d.Event.filter(U.onDidAddConnection,X)(K,void 0,W),U.onDidRemoveConnection(se,void 0,W),F.event(A.fire,A,W),W.add(F)},onLastListenerRemove:()=>{W.dispose()}});return A.event}registerChannel(V,X){this.channels.set(V,X),this._connections.forEach(z=>{z.channelServer.registerChannel(V,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class T{constructor(V,X,z=null){const O=new m;s(O,X),V.send(O.buffer),this.channelClient=new S(V,z),this.channelServer=new l(V,X,z)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,X){this.channelServer.registerChannel(V,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function B($){return{call(V,X,z){return $.then(O=>O.call(V,X,z))},listen(V,X){const z=new d.Relay;return $.then(O=>z.input=O.listen(V,X)),z.event}}}e.getDelayedChannel=B;function Y($){let V=!1;return{call(X,z,O){return V?$.call(X,z,O):(0,n.timeout)(0).then(()=>V=!0).then(()=>$.call(X,z,O))},listen(X,z){if(V)return $.listen(X,z);const O=new d.Relay;return(0,n.timeout)(0).then(()=>V=!0).then(()=>O.input=$.listen(X,z)),O.event}}}e.getNextTickChannel=Y;class ee{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const X of V.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await d.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=ee;var te;(function($){function V(U,W){const A=U,F=W&&W.disableMarshalling,N=new Map;for(const K in A)z(K)&&N.set(K,d.Event.buffer(A[K],!0));return new class{listen(K,se,ae){const ce=N.get(se);if(ce)return ce;if(O(se)){const ne=A[se];if(typeof ne=="function")return ne.call(A,ae)}throw new Error(`Event not found: ${se}`)}call(K,se,ae){const ce=A[se];if(typeof ce=="function"){if(!F&&Array.isArray(ae))for(let ne=0;ne<ae.length;ne++)ae[ne]=(0,P.revive)(ae[ne]);return ce.apply(A,ae)}throw new Error(`Method not found: ${se}`)}}}$.fromService=V;function X(U,W){const A=W&&W.disableMarshalling;return new Proxy({},{get(F,N){if(typeof N=="string")return W?.properties?.has(N)?W.properties.get(N):O(N)?function(K){return U.listen(N,K)}:z(N)?U.listen(N):async function(...K){let se;W&&!(0,I.isUndefinedOrNull)(W.context)?se=[W.context,...K]:se=K;const ae=await U.call(N,se);return A?ae:(0,P.revive)(ae)};throw new Error(`Property not found: ${String(N)}`)}})}$.toService=X;function z(U){return U[0]==="o"&&U[1]==="n"&&k.isUpperAsciiLetter(U.charCodeAt(2))}function O(U){return/^onDynamic/.test(U)&&k.isUpperAsciiLetter(U.charCodeAt(9))}})(te=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let V=$.toString();if(V!=="[object Object]")return V}return $}function G($){return Array.isArray($)?$.map(q):q($)}function _($,V,X,z,O,U,W){W=G(W);const A=Q[O],F=A[z%A.length];let N=[`%c[${$}]%c[${String(V).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(U)?(N=N.concat(W),N.push(")")):N.push(W),console.log.apply(console,N)}e.logWithColors=_;class x{constructor(V,X){this._outgoingPrefix=V,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,X,z,O,U){this._totalOutgoing+=V,_(this._outgoingPrefix,this._totalOutgoing,V,X,z,O,U)}logIncoming(V,X,z,O,U){this._totalIncoming+=V,_(this._incomingPrefix,this._totalIncoming,V,X,z,O,U)}}e.IPCLogger=x}),define(J[127],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(R,D){this.sender=R,this.onMessage=D}send(R){try{this.sender.send("vscode:message",R.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(J[128],Z([0,1,16,4,37]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(d){this.port=d,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>w.VSBuffer.wrap(E.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class M extends R.IPCClient{constructor(d,E){const P=new D(d);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=M}),define(J[88],Z([0,1,16,4,2,37]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let o=0;function l(S,L){if(!s.has(S)){const T=String(++o);s.set(S,T)}return s.get(S)}function y(S,L,T,B){if(!i.enableDiagnostics)return;const Y=l(S,L);if(B instanceof w.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const ee=w.VSBuffer.alloc(B.byteLength);ee.set(B),i.records.push({timestamp:Date.now(),id:Y,label:L,type:T,buff:ee})}else i.records.push({timestamp:Date.now(),id:Y,label:L,type:T,data:B})}i.traceSocketEvent=y})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=w.VSBuffer.alloc(0)),E}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const L=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),L}if(this._chunks[0].byteLength>s){const L=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),L}let l=w.VSBuffer.alloc(s),y=0,S=0;for(;s>0;){const L=this._chunks[S];if(L.byteLength>s){const T=L.slice(0,s);l.set(T,y),y+=s,o&&(this._chunks[S]=L.slice(s),this._totalLength-=s),s-=s}else l.set(L,y),y+=L.byteLength,o?(this._chunks.shift(),this._totalLength-=L.byteLength):S++,s-=L.byteLength}return l}}e.ChunkStream=k;var I;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(I||(I={}));function p(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(s,o,l,y){this.type=s,this.id=o,this.ack=l,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,y=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new h(l,y,S,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=w.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const l=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,l}_bufferTake(){const s=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class C extends R.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new h(1,0,0,s))}}e.Protocol=C;class m extends D.IPCClient{constructor(s,o,l=null){super(s,o,l);this.protocol=s}static fromSocket(s,o){return new m(new C(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=m;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,l=this._first;for(;l;)s[o++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new c(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class g{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<g._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=g._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return g._INSTANCE||(g._INSTANCE=new g),g._INSTANCE}load(){const s=Date.now(),o=(1+g._HISTORY_LENGTH)*1e3;let l=0;for(let y=0;y<g._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=o&&l++;return 1-l/g._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}g._HISTORY_LENGTH=10,g._INSTANCE=null;class r{constructor(s,o=null,l=g.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new h(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new h(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new h(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let l=0,y=o.length;l<y;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let l=0,y=o.length;l<y;l++)this._socketWriter.write(o[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const o=new h(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&l>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const S=Math.max(2e4-o,2e4-l,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(J[129],Z([0,1,12,16,4,2,37,127]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(P,k){const I=R.Event.fromNodeEventEmitter(w.ipcMain,k,(t,h)=>({event:t,message:h})),p=R.Event.filter(I,({event:t})=>t.sender.id===P);return R.Event.map(p,({message:t})=>t&&n.VSBuffer.wrap(t))}class E extends M.IPCServer{constructor(){super(E.getOnDidClientConnect())}static getOnDidClientConnect(){const k=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:I})=>I);return R.Event.map(k,I=>{const p=I.id,t=E.Clients.get(p);t&&t.dispose();const h=new R.Emitter;E.Clients.set(p,(0,D.toDisposable)(()=>h.fire()));const f=d(p,"vscode:message"),v=R.Event.any(R.Event.signal(d(p,"vscode:disconnect")),h.event);return{protocol:new b.Protocol(I,f),onDidClientDisconnect:v}})}}e.Server=E,E.Clients=new Map}),define(J[89],Z([0,1,12,4,31,128]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends D.Client{constructor(E,P){super({addEventListener:(k,I)=>E.addListener(k,I),removeEventListener:(k,I)=>E.removeListener(k,I),postMessage:k=>E.postMessage(k),start:()=>E.start(),close:()=>E.close()},P)}}e.Client=M;async function b(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const E=(0,R.generateUuid)();d.webContents.send("vscode:createMessageChannel",E);const P=n.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(I,p)=>({nonce:p,port:I.ports[0]})),{port:k}=await n.Event.toPromise(n.Event.once(n.Event.filter(P,I=>I.nonce===E)));return k}e.connect=b}),define(J[90],Z([0,1,9,4,2,14]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function b(k){const I=k;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var d;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(I,p=Object.create(null)){super();this.database=I,this.options=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((p,t)=>this.accept(t,p)),I.deleted?.forEach(p=>this.accept(p,void 0))}accept(I,p){if(this.state===d.Closed)return;let t=!1;(0,D.isUndefinedOrNull)(p)?t=this.cache.delete(I):this.cache.get(I)!==p&&(this.cache.set(I,p),t=!0),t&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,p){const t=this.cache.get(I);return(0,D.isUndefinedOrNull)(t)?p:t}getBoolean(I,p){const t=this.get(I);return(0,D.isUndefinedOrNull)(t)?p:t==="true"}getNumber(I,p){const t=this.get(I);return(0,D.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(I,p){if(this.state===d.Closed)return;if((0,D.isUndefinedOrNull)(p))return this.delete(I);const t=String(p);if(this.cache.get(I)!==t)return this.cache.set(I,t),this.pendingInserts.set(I,t),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===d.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((p,t)=>this.items.set(t,p)),I.delete&&I.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(J[130],Z([0,1,9,4,35,7,24]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(P,k=Object.create(null)){this.path=P,this.options=k,this.name=(0,D.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const P=await this.whenConnected,k=new Map;return(await this.all(P,"SELECT * FROM ItemTable")).forEach(p=>k.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(P){const k=await this.whenConnected;return this.doUpdateItems(k,P)}doUpdateItems(P,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,R.mapToString)(k.insert):"0"}), delete(${k.delete?(0,R.setToString)(k.delete):"0"})`),this.transaction(P,()=>{const I=k.insert,p=k.delete;if(I&&I.size>0){const t=[];t.push([]);let h=0;I.forEach((f,v)=>{let C=t[h];C.length>b.MAX_HOST_PARAMETERS&&(h++,C=[],t.push(C)),C.push(v,f)}),t.forEach(f=>{this.prepare(P,`INSERT INTO ItemTable VALUES ${new Array(f.length/2).fill("(?,?)").join(",")}`,v=>v.run(f),()=>{const v=[];let C=0;return I.forEach((m,u)=>{v.push(u),C+=m.length}),`Keys: ${v.join(", ")} Length: ${C}`})})}if(p&&p.size){const t=[];t.push([]);let h=0;p.forEach(f=>{let v=t[h];v.length>b.MAX_HOST_PARAMETERS&&(h++,v=[],t.push(v)),v.push(f)}),t.forEach(f=>{this.prepare(P,`DELETE FROM ItemTable WHERE key IN (${new Array(f.length).fill("?").join(",")})`,v=>v.run(f),()=>{const v=[];return p.forEach(C=>{v.push(C)}),`Keys: ${v.join(", ")}`})})}})}async close(P){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,P)}doClose(P,k){return new Promise((I,p)=>{P.db.close(t=>(t&&this.handleSQLiteError(P,`[storage ${this.name}] close(): ${t}`),this.path===b.IN_MEMORY_PATH?I():!P.isErroneous&&!P.isInMemory?this.backup().then(I,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),I())):typeof k=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const f=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:k()}).then(()=>f(),v=>(f(),Promise.reject(v)))})).then(I,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const P=this.toBackupPath(this.path);return M.Promises.copy(this.path,P,{preserveSymlinks:!1})}toBackupPath(P){return`${P}.backup`}async checkIntegrity(P){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${P})`);const k=await this.whenConnected,I=await this.get(k,P?"PRAGMA integrity_check":"PRAGMA quick_check"),p=P?I.integrity_check:I.quick_check;return k.isErroneous?`${p} (last error: ${k.lastError})`:k.isInMemory?`${p} (in-memory!)`:p}async connect(P,k=!0){this.logger.trace(`[storage ${this.name}] open(${P}, retryOnBusy: ${k})`);try{return await this.doConnect(P)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&k)return await(0,w.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(P,!1);try{await M.Promises.unlink(P);try{await M.Promises.rename(this.toBackupPath(P),P)}catch{}return await this.doConnect(P)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(P,k){P.isErroneous=!0,P.lastError=k,this.logger.error(k)}doConnect(P){return new Promise((k,I)=>{new Promise((p,t)=>{H(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(P,h=>h?t.db?t.db.close(()=>I(h)):I(h):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(t),f=>t.db.close(()=>I(f)))),isInMemory:P===b.IN_MEMORY_PATH};t.db.on("error",h=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&t.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},I)})}exec(P,k){return new Promise((I,p)=>{P.db.exec(k,t=>t?(this.handleSQLiteError(P,`[storage ${this.name}] exec(): ${t}`),p(t)):I())})}get(P,k){return new Promise((I,p)=>{P.db.get(k,(t,h)=>t?(this.handleSQLiteError(P,`[storage ${this.name}] get(): ${t}`),p(t)):I(h))})}all(P,k){return new Promise((I,p)=>{P.db.all(k,(t,h)=>t?(this.handleSQLiteError(P,`[storage ${this.name}] all(): ${t}`),p(t)):I(h))})}transaction(P,k){return new Promise((I,p)=>{P.db.serialize(()=>{P.db.run("BEGIN TRANSACTION"),k(),P.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(P,`[storage ${this.name}] transaction(): ${t}`),p(t)):I())})})}prepare(P,k,I,p){const t=P.db.prepare(k),h=f=>{this.handleSQLiteError(P,`[storage ${this.name}] prepare(): ${f} (${k}). Details: ${p()}`)};t.on("error",h),I(t),t.finalize(f=>{f&&h(f),t.removeListener("error",h)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class d{constructor(P){P&&typeof P.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=P.logTrace),P&&typeof P.logError=="function"&&(this.logError=P.logError)}get isTracing(){return!!this.logTrace}trace(P){this.logTrace&&this.logTrace(P)}error(P){this.logError&&this.logError(P)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[131],Z([13,11]),function(H,e){return H.create("vs/base/common/date",e)}),define(J[132],Z([0,1,131]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,R=n*60,D=R*24,M=D*7,b=D*30,d=D*365;function E(k,I,p){typeof k!="number"&&(k=k.getTime());const t=Math.round((new Date().getTime()-k)/1e3);if(t<-30)return(0,w.localize)(0,null,E(new Date().getTime()+t*1e3,!1));if(t<30)return(0,w.localize)(1,null);let h;return t<n?(h=t,I?h===1?p?(0,w.localize)(2,null,h):(0,w.localize)(3,null,h):p?(0,w.localize)(4,null,h):(0,w.localize)(5,null,h):h===1?p?(0,w.localize)(6,null,h):(0,w.localize)(7,null,h):p?(0,w.localize)(8,null,h):(0,w.localize)(9,null,h)):t<R?(h=Math.floor(t/n),I?h===1?p?(0,w.localize)(10,null,h):(0,w.localize)(11,null,h):p?(0,w.localize)(12,null,h):(0,w.localize)(13,null,h):h===1?p?(0,w.localize)(14,null,h):(0,w.localize)(15,null,h):p?(0,w.localize)(16,null,h):(0,w.localize)(17,null,h)):t<D?(h=Math.floor(t/R),I?h===1?p?(0,w.localize)(18,null,h):(0,w.localize)(19,null,h):p?(0,w.localize)(20,null,h):(0,w.localize)(21,null,h):h===1?p?(0,w.localize)(22,null,h):(0,w.localize)(23,null,h):p?(0,w.localize)(24,null,h):(0,w.localize)(25,null,h)):t<M?(h=Math.floor(t/D),I?h===1?(0,w.localize)(26,null,h):(0,w.localize)(27,null,h):h===1?(0,w.localize)(28,null,h):(0,w.localize)(29,null,h)):t<b?(h=Math.floor(t/M),I?h===1?p?(0,w.localize)(30,null,h):(0,w.localize)(31,null,h):p?(0,w.localize)(32,null,h):(0,w.localize)(33,null,h):h===1?p?(0,w.localize)(34,null,h):(0,w.localize)(35,null,h):p?(0,w.localize)(36,null,h):(0,w.localize)(37,null,h)):t<d?(h=Math.floor(t/b),I?h===1?p?(0,w.localize)(38,null,h):(0,w.localize)(39,null,h):p?(0,w.localize)(40,null,h):(0,w.localize)(41,null,h):h===1?p?(0,w.localize)(42,null,h):(0,w.localize)(43,null,h):p?(0,w.localize)(44,null,h):(0,w.localize)(45,null,h)):(h=Math.floor(t/d),I?h===1?p?(0,w.localize)(46,null,h):(0,w.localize)(47,null,h):p?(0,w.localize)(48,null,h):(0,w.localize)(49,null,h):h===1?p?(0,w.localize)(50,null,h):(0,w.localize)(51,null,h):p?(0,w.localize)(52,null,h):(0,w.localize)(53,null,h))}e.fromNow=E;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(J[133],Z([13,11]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(J[39],Z([0,1,30,14,133]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(k,I){return I&&(k.stack||k.stacktrace)?R.localize(0,null,b(k),M(k.stack)||M(k.stacktrace)):b(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function b(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function d(k=null,I=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const p=w.coalesce(k),t=d(p[0],I);return p.length>1?R.localize(4,null,t,p.length):t}if(n.isString(k))return k;if(k.detail){const p=k.detail;if(p.error)return D(p.error,I);if(p.exception)return D(p.exception,I)}return k.stack?D(k,I):k.message?k.message:R.localize(5,null)}e.toErrorMessage=d;function E(k){const I=k;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=E;function P(k,I=Object.create(null)){const p=new Error(k);return I.actions&&(p.actions=I.actions),p}e.createErrorWithActions=P}),define(J[134],Z([13,11]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(J[135],Z([0,1,134]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(M,b,d=b){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=b,this.modifierLabels[3]=d}toLabel(M,b,d){if(b.length===0)return null;const E=[];for(let P=0,k=b.length;P<k;P++){const I=b[P],p=d(I);if(p===null)return null;E[P]=R(I,p,this.modifierLabels[M])}return E.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(D,M,b){if(M===null)return"";const d=[];return D.ctrlKey&&d.push(b.ctrlKey),D.shiftKey&&d.push(b.shiftKey),D.altKey&&d.push(b.altKey),D.metaKey&&d.push(b.metaKey),M!==""&&d.push(M),d.join(b.separator)}}),define(J[136],Z([13,11]),function(H,e){return H.create("vs/base/node/processes",e)}),define(J[72],Z([0,1,45,28,10,49,7,3,36,84,14,120,24,136]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function t(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,g){if(b.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};g&&(r.cwd=g);const i=w.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],r);return new Promise(s=>{i.once("error",o=>{s({success:!1,error:o})}),i.once("exit",(o,l)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(b.isLinux||b.isMacintosh)try{const r=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(i=>{w.execFile(r,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,o,l)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function f(a){!a||(delete a.DEBUG,b.isMacintosh&&delete a.DYLD_LIBRARY_PATH,b.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=f;function v(a=d.env){return a.comspec||"cmd.exe"}e.getWindowsShell=v;class C{constructor(g,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=g,this.args=r,this.shell=i,this.options=s;else{const o=g;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(d.env).forEach(l=>{o[l]=d.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const r=g.lastIndexOf(M.sep);return r!==-1&&(g=g.substring(r+1)),C.WellKnowCommands[g]?g:"other"}start(g){return b.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(d.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let i,s;const o=new Promise((l,y)=>{i=l,s=y});if(r){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=w.exec(l,this.options,(y,S,L)=>{this.childProcess=null;const T=y;T&&T.killed?s({killed:this.terminateRequested,stdout:S.toString(),stderr:L.toString()}):this.handleExec(i,g,y,S,L)})}else{let l=null;const y=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,i,g,s);const L={terminated:this.terminateRequested};P.isNumber(S)&&(L.cmdCode=S),i(L)};if(this.shell&&b.isWindows){const S=D.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let L=!1,T=!1;const B=[];let Y=this.ensureQuotes(this.cmd);B.push(Y.value),L=Y.quoted,this.args&&this.args.forEach(te=>{Y=this.ensureQuotes(te),B.push(Y.value),T=T&&Y.quoted});const ee=["/s","/c"];L?T?ee.push('"'+B.join(" ")+'"'):B.length>1?ee.push('"'+B[0]+'" '+B.slice(1).join(" ")):ee.push('"'+B[0]+'"'):ee.push(B.join(" ")),l=w.spawn(v(),ee,S)}else this.cmd&&(l=w.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(P.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,s({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",y),this.handleSpawn(l,i,g,s,!0)))}return o})}handleClose(g,r,i,s){}ensureQuotes(g){return C.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,h(g,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!b.isWindows)return g(!1);const r=w.spawn(v(),["/s","/c"]);r.on("error",i=>g(!0)),r.on("exit",i=>g(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class m extends C{constructor(g,r,i,s){super(g,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,r,i,s,o){[s,o].forEach((l,y)=>{const S=new k.LineDecoder;S.write(l).forEach(B=>{r({line:B,source:y===0?0:1})});const T=S.end();T&&r({line:T,source:y===0?0:1})}),g({terminated:this.terminateRequested,error:i})}handleSpawn(g,r,i,s,o){const l=new k.LineDecoder,y=new k.LineDecoder;g.stdout.on("data",S=>{l.write(S).forEach(T=>i({line:T,source:0}))}),g.stderr.on("data",S=>{y.write(S).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=y}handleClose(g,r,i,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=m;function u(a){let g=[],r=!1;const i=function(s){if(r){g.push(s);return}(!a.send(s,l=>{if(l&&console.error(l),r=!1,g.length>0){const y=g.slice(0);g=[],y.forEach(S=>i(S))}})||b.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=u;var c;(function(a){async function g(r,i,s){if(M.isAbsolute(r))return r;if(i===void 0&&(i=d.cwd()),M.dirname(r)!=="."||(s===void 0&&P.isString(d.env.PATH)&&(s=d.env.PATH.split(M.delimiter)),s===void 0||s.length===0))return M.join(i,r);async function l(y){if(await I.Promises.exists(y)){let S;try{S=await I.Promises.stat(y)}catch(L){L.message.startsWith("EACCES")&&(S=await I.Promises.lstat(y))}return S?!S.isDirectory():!1}return!1}for(let y of s){let S;if(M.isAbsolute(y)?S=M.join(y,r):S=M.join(i,y,r),await l(S))return S;let L=S+".com";if(await l(L)||(L=S+".exe",await l(L)))return L}return M.join(i,r)}a.findExecutable=g})(c=e.win32||(e.win32={}))}),define(J[137],Z([0,1,26,3,124,72]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(p,t){return p===1?n.isWindows?k():D.getWindowsShell(t):E(p,t)}e.getSystemShell=M;function b(p,t){return p===1?n.isWindows?I(t):D.getWindowsShell(t):E(p,t)}e.getSystemShellSync=b;let d=null;function E(p,t){if(n.isLinux&&p===2||n.isMacintosh&&p===3)return"/bin/bash";if(!d){let h;if(n.isWindows)h="/bin/bash";else{if(h=t.SHELL,!h)try{h=(0,w.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}d=h}return d}let P=null;async function k(){return P||(P=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),P}function I(p){if(P)return P;const t=n.isWindows&&parseFloat((0,w.release)())>=10,h=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${p.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?f:D.getWindowsShell(p)}}),define(J[138],Z([0,1,45,9,16,23,114,15,4,2,49,72,37]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends I.ChannelServer{constructor(f){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",v=>R.VSBuffer.wrap(Buffer.from(v,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(f,v){this.modulePath=f,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(C),this.child=null,this._client=null}getChannel(f){const v=this;return{call(C,m,u){return v.requestPromise(f,C,m,u)},listen(C,m){return v.requestEvent(f,C,m)}}}requestPromise(f,v,C,m=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(f),c=(0,n.createCancelablePromise)(r=>u.call(v,C,r)),a=m.onCancellationRequested(()=>c.cancel()),g=(0,E.toDisposable)(()=>c.cancel());return this.activeRequests.add(g),c.finally(()=>{a.dispose(),this.activeRequests.delete(g),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(f,v,C){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let m;const u=new d.Emitter({onFirstListenerAdd:()=>{m=this.getCachedChannel(f).listen(v,C)(u.fire,u),this.activeRequests.add(m)},onLastListenerRemove:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,k.removeDangerousEnvVariables)(v.env),this.child=(0,w.fork)(this.modulePath,f,v);const C=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,M.isRemoteConsoleLog)(i)){(0,M.log)(i,`IPC Library: ${this.options.serverName}`);return}C.fire(R.VSBuffer.wrap(Buffer.from(i,"base64")))});const u=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&u.send(i.buffer.toString("base64")),a=C.event,g={send:c,onMessage:a};this._client=new I.ChannelClient(g);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,E.dispose)(o)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(f){let v=this.channels.get(f);return v||(v=this.client.getChannel(f),this.channels.set(f,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(J[139],Z([13,11]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(J[140],Z([13,11]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[141],Z([13,11]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[142],Z([13,11]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(J[143],Z([13,11]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(J[144],Z([13,11]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[145],Z([13,11]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(J[146],Z([13,11]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(J[147],Z([13,11]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(J[148],Z([13,11]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[149],Z([13,11]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[150],Z([13,11]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[151],Z([13,11]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[152],Z([13,11]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[153],Z([13,11]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(J[154],Z([13,11]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[155],Z([13,11]),function(H,e){return H.create("vs/platform/terminal/node/shellEnv",e)}),define(J[156],Z([13,11]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(J[157],Z([13,11]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(J[158],Z([13,11]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[159],Z([13,11]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(J[160],Z([13,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[161],Z([13,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[162],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(R){return R&&R.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function n(R){return R&&R.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=n}),define(J[163],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(J[164],Z([0,1,4,2]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(b,d,E){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:E[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:E[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:E[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:E[0],port:E[1],subId:E[2]}))}throw new Error("Method not implemented.")}listen(b,d,E){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class D extends n.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,d,E){this.channel.call("attach",[b,d,E])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,d){this.channel.call("terminate",[b,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,d){return this.channel.call("openExtensionDevelopmentHostWindow",[b,d])}}e.ExtensionHostDebugChannelClient=D}),define(J[165],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(M){this.driver=M}listen(M,b){throw new Error(`No event found: ${b}`)}call(M,b,d){switch(b){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${b}`)}}e.WindowDriverChannel=w;class n{constructor(M){this.channel=M}click(M,b,d){return this.channel.call("click",[M,b,d])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,b){return this.channel.call("setValue",[M,b])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,b){return this.channel.call("getElements",[M,b])}getElementXY(M,b,d){return this.channel.call("getElementXY",[M,b,d])}typeInEditor(M,b){return this.channel.call("typeInEditor",[M,b])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,b){return this.channel.call("writeInTerminal",[M,b])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class R{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=R}),define(J[166],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(R){this.machineId=R}encryption(){return new Promise((R,D)=>H(["vscode-encrypt"],R,D))}async encrypt(R){try{return(await this.encryption()).encrypt(this.machineId,R)}catch{return R}}async decrypt(R){try{return(await this.encryption()).decrypt(this.machineId,R)}catch{return R}}}e.EncryptionMainService=w}),define(J[167],Z([0,1,132,46,10,7,36,17,8]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(h,f,v){this._args=h,this.paths=f,this.productService=v}get appRoot(){return(0,D.dirname)(R.FileAccess.asFileUri("",H).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(d.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=M.env.VSCODE_PORTABLE;return h?d.URI.file((0,D.join)(h,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(R.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,D.resolve)(h):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const f=M.env.VSCODE_EXTENSIONS;if(f)return f;const v=M.env.VSCODE_PORTABLE;return v?(0,D.join)(v,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(f=>/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,D.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?d.URI.parse(h):d.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],E.prototype,"appRoot",null),ue([n.memoize],E.prototype,"userHome",null),ue([n.memoize],E.prototype,"userDataPath",null),ue([n.memoize],E.prototype,"appSettingsHome",null),ue([n.memoize],E.prototype,"tmpDir",null),ue([n.memoize],E.prototype,"cacheHome",null),ue([n.memoize],E.prototype,"userRoamingDataHome",null),ue([n.memoize],E.prototype,"settingsResource",null),ue([n.memoize],E.prototype,"userDataSyncHome",null),ue([n.memoize],E.prototype,"userDataSyncLogResource",null),ue([n.memoize],E.prototype,"sync",null),ue([n.memoize],E.prototype,"machineSettingsResource",null),ue([n.memoize],E.prototype,"globalStorageHome",null),ue([n.memoize],E.prototype,"workspaceStorageHome",null),ue([n.memoize],E.prototype,"keybindingsResource",null),ue([n.memoize],E.prototype,"keyboardLayoutResource",null),ue([n.memoize],E.prototype,"argvResource",null),ue([n.memoize],E.prototype,"snippetsHome",null),ue([n.memoize],E.prototype,"isExtensionDevelopment",null),ue([n.memoize],E.prototype,"untitledWorkspacesHome",null),ue([n.memoize],E.prototype,"installSourcePath",null),ue([n.memoize],E.prototype,"builtinExtensionsPath",null),ue([n.memoize],E.prototype,"extensionsPath",null),ue([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],E.prototype,"extensionDevelopmentKind",null),ue([n.memoize],E.prototype,"extensionTestsLocationURI",null),ue([n.memoize],E.prototype,"debugExtensionHost",null),ue([n.memoize],E.prototype,"serviceMachineIdResource",null),ue([n.memoize],E.prototype,"telemetryLogResource",null),ue([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(t,h){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,h,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=P;function k(t,h){return p(t["inspect-search"],t["inspect-brk-search"],5876,h,t.extensionEnvironment)}e.parseSearchPort=k;function I(t,h){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,h,t.extensionEnvironment)}e.parsePtyHostPort=I;function p(t,h,f,v,C,m){const c=Number(h||t)||(v?null:f),a=c?Boolean(!!h):!1;let g;if(m)try{g=JSON.parse(m)}catch{}return{port:c,break:a,debugId:C,env:g}}}),define(J[91],Z([0,1,249,3,142]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function b(t,h,f=M){const v={},C=[],m=[];for(let g in h){const r=h[g];r.alias&&(v[g]=r.alias),r.type==="string"||r.type==="string[]"?(C.push(g),r.deprecates&&C.push(...r.deprecates)):r.type==="boolean"&&(m.push(g),r.deprecates&&m.push(...r.deprecates))}const u=w(t,{string:C,boolean:m,alias:v}),c={},a=u;c._=u._.map(g=>String(g)).filter(g=>g.length>0),delete a._;for(let g in h){const r=h[g];r.alias&&delete a[r.alias];let i=a[g];if(r.deprecates)for(const s of r.deprecates)a.hasOwnProperty(s)&&(i||(i=a[s],i&&f.onDeprecatedOption(s,r.deprecationMessage||(0,R.localize)(33,null))),delete a[s]);typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),f.onMultipleValues(g,i)),c[g]=i,r.deprecationMessage&&f.onDeprecatedOption(g,r.deprecationMessage)),delete a[g]}for(let g in a)f.onUnknownOption(g);return c}e.parseArgs=b;function d(t,h){let f="";return h.args&&(Array.isArray(h.args)?f=` <${h.args.join("> <")}>`:f=` <${h.args}>`),h.alias?`-${h.alias} --${t}${f}`:`--${t}${f}`}function E(t,h){let f=0,v=[];for(const c in t){const a=t[c],g=d(c,a);f=Math.max(f,g.length),v.push([g,a.description])}let C=f+2+1;if(h-C<25)return v.reduce((c,a)=>c.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);let m=h-C-1,u=[];for(const c of v){let a=c[0],g=k(c[1],m),r=P(C-a.length-2);u.push("  "+a+r+g[0]);for(let i=1;i<g.length;i++)u.push(P(C)+g[i])}return u}e.formatOptions=E;function P(t){return" ".repeat(t)}function k(t,h){let f=[];for(;t.length;){let v=t.length<h?t.length:t.lastIndexOf(" ",h),C=t.slice(0,v).trim();t=t.slice(v),f.push(C)}return f}function I(t,h,f,v,C){const m=process.stdout.isTTY&&process.stdout.columns||80,u=C?.noInputFiles!==!0?`[${(0,R.localize)(34,null)}...]`:"",c=[`${t} ${f}`];c.push(""),c.push(`${(0,R.localize)(35,null)}: ${h} [${(0,R.localize)(36,null)}]${u}`),c.push(""),C?.noPipe!==!0&&(n.isWindows?c.push((0,R.localize)(37,null,h)):c.push((0,R.localize)(38,null,h)),c.push(""));const a={};for(const g in v){const r=v[g];if(r.description&&r.cat){let i=a[r.cat];i||(a[r.cat]=i={}),i[g]=r}}for(let g in a){const r=g;let i=a[r];i&&(c.push(D[r]),c.push(...E(i,m)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=I;function p(t,h){return`${t||(0,R.localize)(39,null)}
${h||(0,R.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[168],Z([0,1,61,164,91]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends n.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,d,E){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(E[0],E[1]):super.call(b,d,E)}async openExtensionDevelopmentHostWindow(b,d){const E=(0,R.parseArgs)(b,R.OPTIONS);E.debugRenderer=d;const P=E.extensionDevelopmentPath;if(!P)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:E});if(!d)return{success:!0};const I=k.win;if(!I)return{success:!0};const p=I.webContents.debugger;let t=p.isAttached()?1/0:0;const h=(0,w.createServer)(f=>{t++==0&&p.attach();let v=!1;const C=c=>{v||f.write(JSON.stringify(c)+"\0")},m=(c,a,g,r)=>C({method:a,params:g,sessionId:r});I.on("close",()=>{p.removeListener("message",m),f.end(),v=!0}),p.addListener("message",m);let u=Buffer.alloc(0);f.on("data",c=>{u=Buffer.concat([u,c]);for(let a=u.indexOf(0);a!==-1;a=u.indexOf(0)){let g;try{const r=u.slice(0,a).toString("utf8");u=u.slice(a+1),g=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}p.sendCommand(g.method,g.params,g.sessionId).then(r=>C({id:g.id,sessionId:g.sessionId,result:r})).catch(r=>C({id:g.id,sessionId:g.sessionId,error:{code:0,message:r.message}}))}}),f.on("error",c=>{console.error("error on cdp pipe:",c)}),f.on("close",()=>{v=!0,--t==0&&p.detach()})});return await new Promise(f=>h.listen(0,f)),I.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),define(J[50],Z([0,1,250,143,91]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function M(I,p){const t={onUnknownOption:f=>{console.warn((0,n.localize)(0,null,f))},onMultipleValues:(f,v)=>{console.warn((0,n.localize)(1,null,f,v))},onDeprecatedOption:(f,v)=>{console.warn((0,n.localize)(2,null,f,v))}},h=(0,R.parseArgs)(I,R.OPTIONS,p?t:void 0);return h.goto&&h._.forEach(f=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,n.localize)(3,null))),h["max-memory"]&&w(parseInt(h["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),h}function b(I){const p=I.findIndex(t=>!/^-/.test(t));if(p>-1)return[...I.slice(0,p),...I.slice(p+1)]}function d(I){let[,...p]=I;process.env.VSCODE_DEV&&(p=b(p)||[]);const t=!k(process.env);return M(p,t)}e.parseMainProcessArgv=d;function E(I){const[,,...p]=I;return M(p,!0)}e.parseCLIProcessArgv=E;function P(I,...p){const t=I.indexOf("--");return t===-1?I.push(...p):I.splice(t,0,...p),I}e.addArg=P;function k(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function H(e,w,n,R){function D(b){const d=M(b),E=[d];return e.isAbsolute(d)||E.unshift(R),e.resolve(...E)}function M(b){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=b["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(k,"AppData","Roaming")}break;case"darwin":E=e.join(w.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:D}}if(typeof define=="function")define(J[169],Z([0,251,26,10,17,36]),function(e,w,n,R,D,M){const b=D.dirname(R.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(D.joinPath(b,"package.json").fsPath);return H(w,n,d.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),n=require("os");module.exports=H(w,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[170],Z([0,1,26,167,169]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends n.AbstractNativeEnvironmentService{constructor(b,d){super(b,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,R.getUserDataPath)(b)},d)}}e.NativeEnvironmentService=D}),define(J[171],Z([0,1,29,26,28]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(M){const b=(0,R.randomPath)((0,n.tmpdir)());try{return(0,w.writeFileSync)(b,""),M&&console.log(`Marker file for --wait created: ${b}`),b}catch(d){M&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=D}),define(J[172],Z([0,1,16,31]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(D,M,b){let d=b&&b.get("storage.serviceMachineId",0)||null;if(d)return d;try{const P=(await M.readFile(D.serviceMachineIdResource)).value.toString();d=(0,n.isUUID)(P)?P:null}catch{d=null}if(!d){d=(0,n.generateUuid)();try{await M.writeFile(D.serviceMachineIdResource,w.VSBuffer.fromString(d))}catch{}}return b&&b.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=R}),define(J[73],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(R,D=[],M=!1){this.ctor=R,this.staticArguments=D,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=w}),define(J[173],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=w;class n{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let M of this._nodes.values())M.outgoing.size===0&&D.push(M);return D}insertEdge(D,M){const b=this.lookupOrInsertNode(D),d=this.lookupOrInsertNode(M);b.outgoing.set(this._hashFn(M),d),d.incoming.set(this._hashFn(D),b)}removeNode(D){const M=this._hashFn(D);this._nodes.delete(M);for(let b of this._nodes.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(D){const M=this._hashFn(D);let b=this._nodes.get(M);return b||(b=new w(D),this._nodes.set(M,b)),b}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[M,b]of this._nodes)D.push(`${M}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,M]of this._nodes){const b=new Set([D]),d=this._findCycle(M,b);if(d)return d}}_findCycle(D,M){for(let[b,d]of D.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const E=this._findCycle(d,M);if(E)return E;M.delete(b)}}}e.Graph=n}),define(J[5],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(d){return d[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(w=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function n(M,b,d){b[w.DI_TARGET]===b?b[w.DI_DEPENDENCIES].push({id:M,index:d}):(b[w.DI_DEPENDENCIES]=[{id:M,index:d}],b[w.DI_TARGET]=b)}function R(M){if(w.serviceIds.has(M))return w.serviceIds.get(M);const b=function(d,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(b,d,P)};return b.toString=()=>M,w.serviceIds.set(M,b),b}e.createDecorator=R;function D(M){return M}e.refineServiceDecorator=D}),define(J[51],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(J[19],Z([0,1,14,8,5]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof n.URI)}e.isConfigurationOverrides=D;function M(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||w.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=M;var b;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function E(f,v){const C=Object.create(null);for(let m in f)P(C,m,f[m],v);return C}e.toValuesTree=E;function P(f,v,C,m){const u=v.split("."),c=u.pop();let a=f;for(let g=0;g<u.length;g++){let r=u[g],i=a[r];switch(typeof i){case"undefined":i=a[r]=Object.create(null);break;case"object":break;default:m(`Ignoring ${v} as ${u.slice(0,g+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[c]=C}catch{m(`Ignoring ${v} as ${u.join(".")} is ${JSON.stringify(a)}`)}else m(`Ignoring ${v} as ${u.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=P;function k(f,v){const C=v.split(".");I(f,C)}e.removeFromValueTree=k;function I(f,v){const C=v.shift();if(v.length===0){delete f[C];return}if(Object.keys(f).indexOf(C)!==-1){const m=f[C];typeof m=="object"&&!Array.isArray(m)&&(I(m,v),Object.keys(m).length===0&&delete f[C])}}function p(f,v,C){function m(a,g){let r=a;for(const i of g){if(typeof r!="object"||r===null)return;r=r[i]}return r}const u=v.split("."),c=m(f,u);return typeof c=="undefined"?C:c}e.getConfigurationValue=p;function t(f,v,C){Object.keys(v).forEach(m=>{m!=="__proto__"&&(m in f?w.isObject(f[m])&&w.isObject(v[m])?t(f[m],v[m],C):C&&(f[m]=v[m]):f[m]=v[m])})}e.merge=t;function h(f,v,C){const m=f.inspect(v),u=f.inspect(C);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:m.defaultValue}e.getMigratedSettingValue=h}),define(J[74],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(D,M){return this.secretVault[D]?.[M]??null}async setPassword(D,M,b){this.secretVault[D]=this.secretVault[D]??{},this.secretVault[D][M]=b}async deletePassword(D,M){return this.secretVault[D]?.[M]?(delete this.secretVault[D][M],Object.keys(this.secretVault[D]).length===0&&delete this.secretVault[D],!0):!1}async findPassword(D){return JSON.stringify(this.secretVault[D])??null}async findCredentials(D){const M=[];for(const b of Object.keys(this.secretVault[D]||{}))M.push({account:b,password:this.secretVault[D][b]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(J[75],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n;class R{async getPerformanceInfo(M,b){return{}}async getSystemInfo(M,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,b){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=R}),define(J[92],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(J[52],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(J[174],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(J[175],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[93],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(J[176],Z([0,1,45,10,7,3,84,24,72,144,93]),function(H,e,w,n,R,D,M,b,d,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=E.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends I{openTerminal(u,c){return this.spawnTerminal(w,u,d.getWindowsShell(),c)}spawnTerminal(u,c,a,g){const r=c.windowsExec||p.getDefaultTerminalWindows();g&&g[1]===":"&&(g=g[0].toUpperCase()+g.substr(1));const i=R.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return u.spawn(r,g?[g]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((o,l)=>{const y=f(process),S=u.spawn(a,s,{cwd:g,env:y});S.on("error",l),S.on("exit",()=>o())})}runInTerminal(u,c,a,g,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((s,o)=>{const l=`"${c} - ${k}"`,y=`""${a.join('" "')}" & pause"`,S=["/c","start",l,"/wait",i,"/c",y],L=Object.assign({},f(process),g);Object.keys(L).filter(Y=>L[Y]===null).forEach(Y=>delete L[Y]);const T={cwd:c,env:L,windowsVerbatimArguments:!0};w.spawn(p.CMD,S,T).on("error",Y=>{o(v(Y))}),s(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends I{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,a,g,r){const i=r.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((s,o)=>{if(i===P.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const l=i===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,H).fsPath,"-t",u||k,"-w",c];for(let B of a)S.push("-a"),S.push(B);if(g){const B=Object.assign({},f(process),g);for(let Y in B){const ee=B[Y];ee===null?(S.push("-u"),S.push(Y)):(S.push("-e"),S.push(`${Y}=${ee}`))}}let L="";const T=w.spawn(t.OSASCRIPT,S);T.on("error",B=>{o(v(B))}),T.stderr.on("data",B=>{L+=B.toString()}),T.on("exit",B=>{if(B===0)s(void 0);else if(L){const Y=L.split(`
`,1);o(new Error(Y[0]))}else o(new Error(E.localize(1,null,l,B)))})}else o(new Error(E.localize(2,null,i)))})}spawnTerminal(u,c,a){const g=c.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",g];a&&s.push(a);const o=f(process),l=u.spawn("/usr/bin/open",s,{cwd:a,env:o});l.on("error",i),l.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class h extends I{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,a,g,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,o)=>{let l=[];i.then(y=>{y.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const S=`${C(a)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;l.push(`''${S}''`);const L=Object.assign({},f(process),g);Object.keys(L).filter(ee=>L[ee]===null).forEach(ee=>delete L[ee]);const T={cwd:c,env:L};let B="";const Y=w.spawn(y,l,T);Y.on("error",ee=>{o(v(ee))}),Y.stderr.on("data",ee=>{B+=ee.toString()}),Y.on("exit",ee=>{if(ee===0)s(void 0);else if(B){const te=B.split(`
`,1);o(new Error(te[0]))}else o(new Error(E.localize(4,null,y,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await b.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,a){const g=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{g.then(s=>{const o=f(process),l=u.spawn(s,[],{cwd:a,env:o});l.on("error",i),l.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=E.localize(3,null);function f(m){const u={...m.env};return(0,M.sanitizeProcessEnvironment)(u),u}function v(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(E.localize(5,null,m.path)):m}function C(m){let u="";for(let c of m)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(J[20],Z([0,1,15,35,7,27,14,8,146,5]),function(H,e,w,n,R,D,M,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(_){return _.create===!0}e.isFileOpenForWriteOptions=P;var k;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var I;(function(_){_[_.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var p;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function t(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=t;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function f(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function v(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=v;function C(_){return t(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(x,$){super(x);this.code=$}}e.FileSystemProviderError=u;function c(_,x){const $=new u(_.toString(),x);return g($,x),$}e.createFileSystemProviderError=c;function a(_){return _||c((0,d.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=a;function g(_,x){return _.name=x?`${x} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=g;function r(_){if(!_)return m.Unknown;if(_ instanceof u)return _.code;const x=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!x)return m.Unknown;switch(x[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function i(_){if(_ instanceof L)return _.fileOperationResult;switch(r(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(x,$,V){this.resource=x,this.operation=$,this.target=V}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var l;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class y{constructor(x,$){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=x;const V=new Map;for(const X of x){const z=V.get(X.type);switch(z?z.push([X.resource,X]):V.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,z]of V)switch(X){case 1:this.added=n.TernarySearchTree.forUris(()=>$),this.added.fill(z);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>$),this.updated.fill(z);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>$),this.deleted.fill(z);break}}contains(x,...$){return this.doContains(x,{includeChildren:!1},...$)}affects(x,...$){return this.doContains(x,{includeChildren:!0},...$)}doContains(x,$,...V){if(!x)return!1;const X=V.length>0;return!!((!X||V.includes(1))&&(this.added?.get(x)||$.includeChildren&&this.added?.findSuperstr(x))||(!X||V.includes(0))&&(this.updated?.get(x)||$.includeChildren&&this.updated?.findSuperstr(x))||(!X||V.includes(2))&&(this.deleted?.findSubstr(x)||$.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=y;function S(_,x,$){return!_||!x||_===x||x.length>_.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),$?(0,D.startsWithIgnoreCase)(_,x):_.indexOf(x)===0)}e.isParent=S;class L extends w.ErrorNoTelemetry{constructor(x,$,V){super(x);this.fileOperationResult=$,this.options=V}}e.FileOperationError=L;class T extends L{constructor(x,$,V){super(x,2,V);this.stat=$}}e.NotModifiedSinceFileOperationError=T;var B;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(B=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Y;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ee(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=ee;async function te(_,x){if(!x.hasProvider(b.URI.from({scheme:_.scheme})))return new Promise($=>{const V=x.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===_.scheme&&X.added&&(V.dispose(),$())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(x){return(0,M.isNumber)(x)||(x=0),x<Q.KB?(0,d.localize)(1,null,x.toFixed(0)):x<Q.MB?(0,d.localize)(2,null,(x/Q.KB).toFixed(2)):x<Q.GB?(0,d.localize)(3,null,(x/Q.MB).toFixed(2)):x<Q.TB?(0,d.localize)(4,null,(x/Q.GB).toFixed(2)):(0,d.localize)(5,null,(x/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var q;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function G(_){return{maxFileSize:_===0?300*Q.MB:16*Q.GB,maxHeapSize:_===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=G}),define(J[177],Z([0,1,16,39,15,4,2,48,8,31,20]),function(H,e,w,n,R,D,M,b,d,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends M.Disposable{constructor(p,t){super();this.channel=p,this.extraCapabilities=t,this.onDidChangeCapabilities=D.Event.None,this._onDidChange=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,t){const{buffer:h}=await this.channel.call("readFile",[p,t]);return h}readFileStream(p,t,h){const f=(0,b.newWriteableStream)(C=>w.VSBuffer.concat(C.map(m=>w.VSBuffer.wrap(m))).buffer),v=this.channel.listen("readFileStream",[p,t])(C=>{if(C instanceof w.VSBuffer)f.write(C.buffer);else{if(C==="end")f.end();else{let m=C;m instanceof Error||(m=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(m),P.FileSystemProviderErrorCode.Unknown)),f.error(m),f.end()}v.dispose()}});return h.onCancellationRequested(()=>{f.error((0,R.canceled)()),f.end(),v.dispose()}),f}writeFile(p,t,h){return this.channel.call("writeFile",[p,w.VSBuffer.wrap(t),h])}open(p,t){return this.channel.call("open",[p,t])}close(p){return this.channel.call("close",[p])}async read(p,t,h,f,v){const[C,m]=await this.channel.call("read",[p,t,v]);return h.set(C.buffer.slice(0,m),f),m}write(p,t,h,f,v){return this.channel.call("write",[p,t,w.VSBuffer.wrap(h),f,v])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,t){return this.channel.call("delete",[p,t])}rename(p,t,h){return this.channel.call("rename",[p,t,h])}copy(p,t,h){return this.channel.call("copy",[p,t,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const t=p;this._onDidChange.fire(t.map(h=>({resource:d.URI.revive(h.resource),type:h.type})))}else{const t=p;this._onDidWatchError.fire(t)}}))}watch(p,t){const h=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,h,p,t]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=k}),define(J[94],Z([0,1,16,15,147,20]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(P,k,I,p,t,h){let f;try{await b(P,k,I,p,t,h)}catch(v){f=v}finally{f&&t.errorTransformer&&(f=t.errorTransformer(f)),typeof f!="undefined"&&I.error(f),I.end()}}e.readFileIntoStream=M;async function b(P,k,I,p,t,h){d(h);const f=await P.open(k,{create:!1});try{d(h);let v=0,C=0,m=t&&typeof t.length=="number"?t.length:void 0,u=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof m=="number"?m:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,a=0;do C=await P.read(f,c,u.buffer,a,u.byteLength-a),c+=C,a+=C,v+=C,typeof m=="number"&&(m-=C),a===u.byteLength&&(await I.write(p(u)),u=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof m=="number"?m:t.bufferSize)),a=0);while(C>0&&(typeof m!="number"||m>0)&&d(h)&&E(v,t));if(a>0){let g=a;typeof m=="number"&&(g=Math.min(a,m)),I.write(p(u.slice(0,g)))}}catch(v){throw(0,D.ensureFileSystemProviderError)(v)}finally{await P.close(f)}}function d(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,k){if(k?.limits){if(typeof k.limits.memory=="number"&&P>k.limits.memory)throw(0,D.createFileSystemProviderError)((0,R.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&P>k.limits.size)throw(0,D.createFileSystemProviderError)((0,R.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[62],Z([0,1,2,3,8,20]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function M(p){return p.recursive===!0}e.isRecursiveWatchRequest=M;class b extends w.Disposable{constructor(t,h,f,v){super();this.onFileChanges=t,this.onLogMessage=h,this.verboseLogging=f,this.options=v,this.watcherDisposables=this._register(new w.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new w.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),t.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),t.add(this.watcher.onDidError(h=>this.onError(h)))}onError(t){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class d extends b{constructor(t,h,f){super(t,h,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=d;class E extends b{constructor(t,h,f){super(t,h,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function P(p){return p.map(t=>({type:t.type,resource:R.URI.file(t.path)}))}e.toFileChanges=P;function k(p){const t=new I;for(const h of p)t.processEvent(h);return t.coalesce()}e.coalesceEvents=k;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const h=this.mapPathToChange.get(this.toKey(t));let f=!1;if(h){const v=h.type,C=t.type;h.path!==t.path&&(t.type===2||t.type===1)?f=!0:v===1&&C===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(h)):v===2&&C===1?h.type=0:v===1&&C===0||(h.type=C)}else f=!0;f&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],h=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(t.push(f),!1):!0).sort((f,v)=>f.path.length-v.path.length).filter(f=>h.some(v=>(0,D.isParent)(f.path,v,!n.isLinux))?!1:(h.push(f.path),!0)).concat(t)}}}),define(J[178],Z([0,1,29,9,23,28,116,2,70,7,3,86,24,62]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends b.Disposable{constructor(v,C,m,u){super();this.request=v,this.onDidFilesChange=C,this.onLogMessage=m,this.verboseLogging=u,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,M.parse)(c)),this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const C=await I.Promises.stat(v);this._register(await this.doWatch(v,C.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let C=v.path;try{C=await I.Promises.realpath(v.path),v.path===C&&(C=await(0,k.realcase)(v.path)??v.path),v.path!==C&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${C})`)}catch{}return C}async doWatch(v,C){if(P.isMacintosh&&(0,D.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),b.Disposable.None;const m=new R.CancellationTokenSource(this.cts.token);let u=new b.DisposableStore;try{const c=(0,E.basename)(v),a=(0,w.watch)(v);u.add((0,b.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${v}'`);const g=new Set;if(C)try{for(const i of await I.Promises.readdir(v))g.add(i)}catch(i){this.error(i)}const r=new Map;u.add((0,b.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),a.on("error",(i,s)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),a.on("change",(i,s)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),P.isMacintosh&&(o=(0,d.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(C)if(i==="rename"){r.get(o)?.dispose();const l=setTimeout(async()=>{if(r.delete(o),o===c&&!await I.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.existsChildStrictCase((0,E.join)(v,o));if(m.token.isCancellationRequested)return;let S;y?g.has(o)?S=0:(S=1,g.add(o)):(g.delete(o),S=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:S})},t.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,b.toDisposable)(()=>clearTimeout(l)))}else{let l;g.has(o)?l=0:(l=1,g.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:l})}else if(i==="rename"||o!==c){const l=setTimeout(async()=>{const y=await I.Promises.exists(v);m.token.isCancellationRequested||(y?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,b.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await I.Promises.exists(v)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,b.toDisposable)(()=>{m.dispose(!0),u.dispose()})}async onFileChange(v,C=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!C&&this.excludes.some(m=>m(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,p.coalesceEvents)(m);if(u.length>0){if(this.verboseLogging)for(const a of u)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(P.isLinux)return I.Promises.exists(v);try{const C=(0,E.basename)(v);return(await I.Promises.readdir((0,E.dirname)(v))).some(u=>u===C)}catch(C){return this.trace(C),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function h(f,v,C,m,u=512){const c=await I.Promises.open(f,"r"),a=Buffer.allocUnsafe(u),g=new R.CancellationTokenSource(m);let r,i=!1;const s={path:f,excludes:[],recursive:!1},o=new t(s,l=>{(async()=>{for(const{type:y}of l)if(y===0){if(i)return;i=!0;try{for(;!g.token.isCancellationRequested;){const{bytesRead:S}=await I.Promises.read(c,a,0,u,null);if(!S||g.token.isCancellationRequested)break;v(a.slice(0,S))}}catch(S){r=new Error(S),g.dispose(!0)}finally{i=!1}}})()});return await o.ready,C(),new Promise((l,y)=>{g.token.onCancellationRequested(async()=>{o.dispose();try{await I.Promises.close(c)}catch(S){r=new Error(S)}r?y(r):l()})})}e.watchFileContents=h}),define(J[179],Z([0,1,30,4,2,3,178]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends R.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const P=this.normalizeRequests(E),k=P.filter(p=>{const t=this.watchers.get(p.path);return t?!(0,w.equals)(t.request.excludes,p.excludes):!0}),I=Array.from(this.watchers.values()).filter(({request:p})=>!P.find(t=>t.path===p.path&&(0,w.equals)(t.excludes,p.excludes))).map(({request:p})=>p.path);k.length&&this.trace(`Request to start watching: ${k.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const p of I)this.stopWatching(p);for(const p of k)this.startWatching(p)}startWatching(E){const P=new M.NodeJSFileWatcherLibrary(E,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),k={request:E,instance:P};this.watchers.set(E.path,k)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const P=this.watchers.get(E);P&&(this.watchers.delete(E),P.instance.dispose())}normalizeRequests(E){const P=new Map;for(const k of E){const I=D.isLinux?k.path:k.path.toLowerCase();P.set(I,k)}return Array.from(P.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,P]of this.watchers)P.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,P){return P?`[File Watcher (node.js)] ${E} (path: ${P.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=b}),define(J[180],Z([0,1,62,179]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends w.AbstractNonRecursiveWatcherClient{constructor(M,b,d){super(M,b,d);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(J[181],Z([0,1,10,37,138,62]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends D.AbstractUniversalWatcherClient{constructor(d,E,P){super(d,E,P);this.init()}createWatcher(d){const E=d.add(new R.Client(w.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(E.onDidProcessExit(({code:P,signal:k})=>this.onError(`terminated by itself with code ${P}, signal: ${k}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(J[76],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...R){this._entries=new Map;for(let[D,M]of R)this.set(D,M)}set(R,D){const M=this._entries.get(R);return this._entries.set(R,D),M}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=w}),define(J[182],Z([0,1,9,15,73,173,5,76]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const d=!1;class E extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class P{constructor(t=new b.ServiceCollection,h=!1,f){this._activeInstantiations=new Set,this._services=t,this._strict=h,this._parent=f,this._services.set(M.IInstantiationService,this)}createChild(t){return new P(t,this._strict,this)}invokeFunction(t,...h){let f=I.traceInvocation(t),v=!1;try{return t({get:m=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(m,f);if(!u)throw new Error(`[invokeFunction] unknown service '${m}'`);return u}},...h)}finally{v=!0,f.stop()}}createInstance(t,...h){let f,v;return t instanceof R.SyncDescriptor?(f=I.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(h),f)):(f=I.traceCreation(t),v=this._createInstance(t,h,f)),f.stop(),v}_createInstance(t,h=[],f){let v=M._util.getServiceDependencies(t).sort((u,c)=>u.index-c.index),C=[];for(const u of v){let c=this._getOrCreateServiceInstance(u.id,f);c||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${u.id}.`,!1),C.push(c)}let m=v.length>0?v[0].index:h.length;if(h.length!==m){console.warn(`[createInstance] First service dependency of ${t.name} at position ${m+1} conflicts with ${h.length} static arguments`);let u=m-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,m)}return new t(...[...h,...C])}_setServiceInstance(t,h){if(this._services.get(t)instanceof R.SyncDescriptor)this._services.set(t,h);else if(this._parent)this._parent._setServiceInstance(t,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let h=this._services.get(t);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):h}_getOrCreateServiceInstance(t,h){let f=this._getServiceInstanceOrDescriptor(t);return f instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,f,h.branch(t,!0)):(h.branch(t,!1),f)}_safeCreateAndCacheServiceInstance(t,h,f){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,h,f)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,h,f){const v=new D.Graph(u=>u.id.toString());let C=0;const m=[{id:t,desc:h,_trace:f}];for(;m.length;){const u=m.pop();if(v.lookupOrInsertNode(u),C++>1e3)throw new E(v);for(let c of M._util.getServiceDependencies(u.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(c.id);if(a||this._throwIfStrict(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`,!0),a instanceof R.SyncDescriptor){const g={id:c.id,desc:a,_trace:u._trace.branch(c.id,!0)};v.insertEdge(u,g),m.push(g)}}}for(;;){const u=v.roots();if(u.length===0){if(!v.isEmpty())throw new E(v);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const g=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,g)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,h,f=[],v,C){if(this._services.get(t)instanceof R.SyncDescriptor)return this._createServiceInstance(h,f,v,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,h,f,v,C);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(t,h=[],f,v){if(f){const C=new w.IdleValue(()=>this._createInstance(t,h,v));return new Proxy(Object.create(null),{get(m,u){if(u in m)return m[u];let c=C.value,a=c[u];return typeof a!="function"||(a=a.bind(c),m[u]=a),a},set(m,u,c){return C.value[u]=c,!0}})}else return this._createInstance(t,h,v)}_throwIfStrict(t,h){if(h&&console.warn(h),this._strict)throw new Error(t)}}e.InstantiationService=P;var k;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(k||(k={}));class I{constructor(t,h){this.type=t,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new I(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(t){return d?new I(0,t.name):I._None}branch(t,h){let f=new I(2,t.toString());return this._dep.push([t,h,f]),f}stop(){let t=Date.now()-this._start;I._totals+=t;let h=!1;function f(C,m){let u=[],c=new Array(C+1).join("	");for(const[a,g,r]of m._dep)if(g&&r){h=!0,u.push(`${c}CREATES -> ${a}`);let i=f(C+1,r);i&&u.push(i)}else u.push(`${c}uses -> ${a}`);return u.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(t>2||h)&&console.log(v.join(`
`))}}e.Trace=I,I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(J[183],Z([0,1,15,135,59]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends R.ResolvedKeybinding{constructor(b,d){super();if(d.length===0)throw(0,w.illegalArgument)("parts");this._os=b,this._parts=d}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,b=>this._getLabel(b))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,b=>this._getAriaLabel(b))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,b=>this._getElectronAccelerator(b))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,b=>this._getUserSettingsLabel(b))}isWYSIWYG(){return this._parts.every(b=>this._isWYSIWYG(b))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(b=>this._getPart(b))}_getPart(b){return new R.ResolvedKeybindingPart(b.ctrlKey,b.shiftKey,b.altKey,b.metaKey,this._getLabel(b),this._getAriaLabel(b))}getDispatchParts(){return this._parts.map(b=>this._getDispatchPart(b))}getSingleModifierDispatchParts(){return this._parts.map(b=>this._getSingleModifierDispatchPart(b))}}e.BaseResolvedKeybinding=D}),define(J[184],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class w{constructor(D,M,b,d,E,P,k){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=D,this.keypressParts=D?n(D.getDispatchParts()):[],D&&this.keypressParts.length===0&&(this.keypressParts=n(D.getSingleModifierDispatchParts())),this.bubble=M?M.charCodeAt(0)===94:!1,this.command=this.bubble?M.substr(1):M,this.commandArgs=b,this.when=d,this.isDefault=E,this.extensionId=P,this.isBuiltinExtension=k}}e.ResolvedKeybindingItem=w;function n(R){let D=[];for(let M=0,b=R.length;M<b;M++){const d=R[M];if(!d)return D;D.push(d)}return D}e.removeElementsAfterNulls=n}),define(J[185],Z([0,1,83,59,183,184]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends R.BaseResolvedKeybinding{constructor(d,E){super(E,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return w.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const E=w.KeyCodeUtils.toUserSettingsUS(d.keyCode);return E&&E.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return M.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let E="";return d.ctrlKey&&(E+="ctrl+"),d.shiftKey&&(E+="shift+"),d.altKey&&(E+="alt+"),d.metaKey&&(E+="meta+"),E+=w.KeyCodeUtils.toString(d.keyCode),E}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const E=w.IMMUTABLE_CODE_TO_KEY_CODE[d];if(E!==-1)return E;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof n.SimpleKeybinding)return d;const E=this._scanCodeToKeyCode(d.scanCode);return E===0?null:new n.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,E)}static resolveUserBinding(d,E){const P=(0,D.removeElementsAfterNulls)(d.map(k=>this._resolveSimpleUserBinding(k)));return P.length>0?[new M(new n.ChordKeybinding(P),E)]:[]}}e.USLayoutResolvedKeybinding=M}),define(J[6],Z([0,1,39,4,2,3,5]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function b(){return new Date().toISOString()}var d;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function E(g,r,i){switch(r){case d.Trace:g.trace(i);break;case d.Debug:g.debug(i);break;case d.Info:g.info(i);break;case d.Warning:g.warn(i);break;case d.Error:g.error(i);break;case d.Critical:g.critical(i);break;default:throw new Error("Invalid log level")}}e.log=E;function P(g){let r="";for(let i=0;i<g.length;i++){let s=g[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(i>0?" ":"")+s}return r}e.format=P;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class I extends k{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,P([r,...i]))}debug(r,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,P([r,...i]))}info(r,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,P([r,...i]))}warn(r,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,P([r,...i]))}error(r,...i){if(this.checkLogLevel(d.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(d.Error,P(s))}else this.log(d.Error,P([r,...i]))}critical(r,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,P([r,...i]))}flush(){}}e.AbstractMessageLogger=I;class p extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!D.isWindows}trace(r,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,r,...i):console.log(`[main ${b()}]`,r,...i))}debug(r,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,r,...i):console.log(`[main ${b()}]`,r,...i))}info(r,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,r,...i):console.log(`[main ${b()}]`,r,...i))}warn(r,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,r,...i):console.warn(`[main ${b()}]`,r,...i))}error(r,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,r,...i):console.error(`[main ${b()}]`,r,...i))}critical(r,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,r,...i):console.error(`[main ${b()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class h extends k{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,w.toErrorMessage)(r,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class f extends k{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const s of this.logServices)s.trace(r,...i)}debug(r,...i){for(const s of this.logServices)s.debug(r,...i)}info(r,...i){for(const s of this.logServices)s.info(r,...i)}warn(r,...i){for(const s of this.logServices)s.warn(r,...i)}error(r,...i){for(const s of this.logServices)s.error(r,...i)}critical(r,...i){for(const s of this.logServices)s.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=f;class v extends R.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=v;class C extends R.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,i?.always?d.Trace:this.logLevel,i),this.loggers.set(r.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class m{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return d.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=m;function u(g){if(g.verbose)return d.Trace;if(typeof g.logLevel=="string"){const r=c(g.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(g){switch(g){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=c;function a(g){switch(g){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=a}),define(J[186],Z([0,1,30,9,15,4,2,7,62,6]),function(H,e,w,n,R,D,M,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends M.Disposable{constructor(I,p){super();this.logService=I,this.options=p,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(I,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,p):this.watchNonRecursive(I,p)}watchUniversal(I,p){const t={path:this.toFilePath(I),excludes:p.excludes,recursive:p.recursive},h=(0,w.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,R.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,d.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const p of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const p of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(p)&&I.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,p){const t={path:this.toFilePath(I),excludes:p.excludes,recursive:!1},h=(0,w.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,R.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,d.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,b.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=P});var ie=this&&this.__param||function(H,e){return function(w,n){e(w,n,H)}};define(J[187],Z([0,1,30,9,16,23,4,69,68,2,35,10,63,17,48,145,20,94,6]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends E.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`);const g=new E.DisposableStore;return this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a}),g.add(a.onDidChangeFile(r=>this._onDidFilesChange.fire(new f.FileChangesEvent(r,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&g.add(a.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),g.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,E.dispose)(g)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(g){a.push(g)}}),!this.provider.has(c)&&await n.Promises.settled(a)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,a){const g=this.provider.get(c.scheme);return!!(g&&g.capabilities&a)}listCapabilities(){return d.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,p.isAbsolutePath)(c))throw new f.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const g=new Error;throw g.name="ENOPRO",g.message=(0,h.localize)(1,null,c.toString()),g}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasReadWriteCapability)(a)||(0,f.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(g){throw(0,f.toFileSystemProviderErrorCode)(g)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,f.ensureFileSystemProviderError)(g)}}async doResolveFile(c,a){const g=await this.withProvider(c),r=this.isPathCaseSensitive(g),i=a?.resolveTo,s=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,l=await g.stat(c);let y;return this.toFileStat(g,c,l,void 0,!!o,(S,L)=>(y||(y=P.TernarySearchTree.forUris(()=>!r),y.set(c,!0),i&&y.fill(!0,i)),y.get(S.resource)||y.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&s?L===1:!1))}async toFileStat(c,a,g,r,i,s){const{providerExtUri:o}=this.getExtUri(c),l={resource:a,name:o.basename(a),isFile:(g.type&f.FileType.File)!=0,isDirectory:(g.type&f.FileType.Directory)!=0,isSymbolicLink:(g.type&f.FileType.SymbolicLink)!=0,mtime:g.mtime,ctime:g.ctime,size:g.size,readonly:Boolean((g.permissions??0)&f.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,f.etag)({mtime:g.mtime,size:g.size}),children:void 0};if(l.isDirectory&&s(l,r)){try{const y=await c.readdir(a),S=await n.Promises.settled(y.map(async([L,T])=>{try{const B=o.joinPath(a,L),Y=i?await c.stat(B):{type:T};return await this.toFileStat(c,B,Y,y.length,i,s)}catch(B){return this.logService.trace(B),null}}));l.children=(0,w.coalesce)(S)}catch(y){this.logService.trace(y),l.children=[]}return l}return l}async resolveAll(c){return n.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(g){return this.logService.trace(g),{stat:void 0,success:!1}}}))}async stat(c){const a=await this.withProvider(c),g=await a.stat(c);return this.toFileStat(a,c,g,void 0,!0,()=>!1)}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch{return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(g){return g}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new f.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=R.VSBuffer.fromString(""),g){await this.doValidateCreateFile(c,g);const r=await this.writeFile(c,a);return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,r)),r}async writeFile(c,a,g){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,c,g)||await this.mkdirp(r,i.dirname(c));let o;if((0,f.hasReadWriteCapability)(r)&&!(a instanceof R.VSBuffer))if((0,t.isReadableStream)(a)){const l=await(0,t.peekStream)(a,3);l.ended?o=R.VSBuffer.concat(l.buffer):o=l}else o=(0,t.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else o=a;!(0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r)&&o instanceof R.VSBuffer?await this.doWriteUnbuffered(r,c,g,o):await this.doWriteBuffered(r,c,g,o instanceof R.VSBuffer?(0,R.bufferToReadable)(o):o),this._onDidRunOperation.fire(new f.FileOperationEvent(c,4))}catch(s){throw new f.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),g)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,g){if(!!g?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(a)));let i;try{i=await c.stat(a)}catch{return}if((i.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,h.localize)(6,null,this.resourceForError(a)),0,g);if(this.throwIfFileIsReadonly(a,i),typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==f.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&g.mtime<i.mtime&&g.etag!==(0,f.etag)({mtime:g.mtime,size:i.size}))throw new f.FileOperationError((0,h.localize)(7,null),3,g);return i}async readFile(c,a,g){const r=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(r,c,a,g):this.doReadFile(r,c,a,g)}async doReadFileAtomic(c,a,g,r){return new Promise((i,s)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,a,g,r);i(o)}catch(o){s(o)}})})}async doReadFile(c,a,g,r){const i=await this.doReadFileStream(c,a,{...g,preferUnbuffered:!0},r);return{...i,value:await(0,R.streamToBuffer)(i.value)}}async readFileStream(c,a,g){const r=await this.withReadProvider(c);return this.doReadFileStream(r,c,a,g)}async doReadFileStream(c,a,g,r){const i=new D.CancellationTokenSource(r),s=this.validateReadFile(a,g).then(l=>l,l=>{throw i.cancel(),l});let o;try{return typeof g?.etag=="string"&&g.etag!==f.ETAG_DISABLED&&await s,g?.atomic&&(0,f.hasFileAtomicReadCapability)(c)||!((0,f.hasOpenReadWriteCloseCapability)(c)||(0,f.hasFileReadStreamCapability)(c))||(0,f.hasReadWriteCapability)(c)&&g?.preferUnbuffered?o=this.readFileUnbuffered(c,a,g):(0,f.hasFileReadStreamCapability)(c)?o=this.readFileStreamed(c,a,i.token,g):o=this.readFileBuffered(c,a,i.token,g),{...await s,value:o}}catch(l){o&&await(0,t.consumeStream)(o);const y=(0,h.localize)(8,null,this.resourceForError(a),(0,f.ensureFileSystemProviderError)(l).toString());throw l instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(y,l.stat,g):new f.FileOperationError(y,(0,f.toFileOperationResult)(l),g)}}readFileStreamed(c,a,g,r=Object.create(null)){const i=c.readFileStream(a,r,g);return(0,t.transform)(i,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new f.FileOperationError((0,h.localize)(9,null,this.resourceForError(a),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(c,a,g,r=Object.create(null)){const i=(0,R.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,a,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new f.FileOperationError((0,h.localize)(10,null,this.resourceForError(a),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),r)},g),i}readFileUnbuffered(c,a,g){const r=(0,t.newWriteableStream)(i=>R.VSBuffer.concat(i));return(async()=>{try{let i;g?.atomic&&(0,f.hasFileAtomicReadCapability)(c)?i=await c.readFile(a,{atomic:!0}):i=await c.readFile(a),typeof g?.position=="number"&&(i=i.slice(g.position)),typeof g?.length=="number"&&(i=i.slice(0,g.length)),this.validateReadFileLimits(a,i.byteLength,g),r.end(R.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(c,a){const g=await this.resolve(c,{resolveMetadata:!0});if(g.isDirectory)throw new f.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==f.ETAG_DISABLED&&a.etag===g.etag)throw new f.NotModifiedSinceFileOperationError((0,h.localize)(12,null),g,a);return this.validateReadFileLimits(c,g.size,a),g}validateReadFileLimits(c,a,g){if(g?.limits){let r;if(typeof g.limits.memory=="number"&&a>g.limits.memory&&(r=9),typeof g.limits.size=="number"&&a>g.limits.size&&(r=7),typeof r=="number")throw new f.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),r)}}async canMove(c,a,g){return this.doCanMoveCopy(c,a,"move",g)}async canCopy(c,a,g){return this.doCanMoveCopy(c,a,"copy",g)}async doCanMoveCopy(c,a,g,r){if(c.toString()!==a.toString())try{const i=g==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,c,s,a,g,r)}catch(i){return i}return!0}async move(c,a,g){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,c,i,a,"move",!!g),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,s==="move"?2:3,o)),o}async copy(c,a,g){const r=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,c,i,a,"copy",!!g),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,s==="copy"?3:2,o)),o}async doMoveCopy(c,a,g,r,i,s){if(a.toString()===r.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,a,g,r,i,s);if(o&&!l&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(g,this.getExtUri(g).providerExtUri.dirname(r)),i==="copy"){if(c===g&&(0,f.hasFileFolderCopyCapability)(c))await c.copy(a,r,{overwrite:s});else{const y=await this.resolve(a);y.isDirectory?await this.doCopyFolder(c,y,g,r):await this.doCopyFile(c,a,g,r)}return i}else return c===g?(await c.rename(a,r,{overwrite:s}),i):(await this.doMoveCopy(c,a,g,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,g,r){if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(g))return this.doPipeBuffered(c,a,g,r);if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasReadWriteCapability)(g))return this.doPipeBufferedToUnbuffered(c,a,g,r);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(g))return this.doPipeUnbufferedToBuffered(c,a,g,r);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasReadWriteCapability)(g))return this.doPipeUnbuffered(c,a,g,r)}async doCopyFolder(c,a,g,r){await g.mkdir(r),Array.isArray(a.children)&&await n.Promises.settled(a.children.map(async i=>{const s=this.getExtUri(g).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),g,s):this.doCopyFile(c,i.resource,g,s)}))}async doValidateMoveCopy(c,a,g,r,i,s){let o=!1;if(c===g){const{providerExtUri:y,isPathCaseSensitive:S}=this.getExtUri(c);if(S||(o=y.isEqual(a,r)),o&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!o&&y.isEqualOrParent(r,a))throw new Error((0,h.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!o){if(!s)throw new f.FileOperationError((0,h.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(c===g){const{providerExtUri:y}=this.getExtUri(c);if(y.isEqualOrParent(a,r))throw new Error((0,h.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const g=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,g)),g}async mkdirp(c,a){const g=[],{providerExtUri:r}=this.getExtUri(c);for(;!r.isEqual(a,r.dirname(a));)try{if(((await c.stat(a)).type&f.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,f.toFileSystemProviderErrorCode)(i)!==f.FileSystemProviderErrorCode.FileNotFound)throw i;g.push(r.basename(a)),a=r.dirname(a)}for(let i=g.length-1;i>=0;i--){a=r.joinPath(a,g[i]);try{await c.mkdir(a)}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(g){return g}return!0}async doValidateDelete(c,a){const g=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(g.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let i;try{i=await g.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new f.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return g}async del(c,a){const g=await this.doValidateDelete(c,a),r=!!a?.useTrash,i=!!a?.recursive;await g.delete(c,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new f.FileOperationEvent(c,1))}watch(c,a={recursive:!1,excludes:[]}){const g=new E.DisposableStore;let r=!1,i=()=>{r=!0};return g.add((0,E.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(c,a);r?(0,E.dispose)(s):i=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),g}async doWatch(c,a){const g=await this.withProvider(c),r=(0,b.hash)([this.getExtUri(g).providerExtUri.getComparisonKey(c),a]);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:g.watch(c,a)},this.activeWatchers.set(r,i)),i.count+=1,(0,E.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,E.dispose)(i.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,E.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,g,r){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(a,{create:!0,unlock:g?.unlock??!1});try{(0,t.isReadableStream)(r)||(0,t.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(c,i,r):await this.doWriteReadableBufferedQueued(c,i,r)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,a,g){let r=0,i;if((0,t.isReadableBufferedStream)(g)){if(g.buffer.length>0){const s=R.VSBuffer.concat(g.buffer);await this.doWriteBuffer(c,a,s,s.byteLength,r,0),r+=s.byteLength}if(g.ended)return;i=g.stream}else i=g;return new Promise((s,o)=>{(0,t.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(c,a,l,l.byteLength,r,0)}catch(y){return o(y)}r+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>o(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,a,g){let r=0,i;for(;(i=g.read())!==null;)await this.doWriteBuffer(c,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(c,a,g,r,i,s){let o=0;for(;o<r;)o+=await c.write(a,i+o,g.buffer,s+o,r-o)}async doWriteUnbuffered(c,a,g,r){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,g,r))}async doWriteUnbufferedQueued(c,a,g,r){let i;r instanceof R.VSBuffer?i=r:(0,t.isReadableStream)(r)?i=await(0,R.streamToBuffer)(r):(0,t.isReadableBufferedStream)(r)?i=await(0,R.bufferedStreamToBuffer)(r):i=(0,R.readableToBuffer)(r),await c.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:g?.unlock??!1})}async doPipeBuffered(c,a,g,r){return this.writeQueue.queueFor(r,this.getExtUri(g).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,g,r))}async doPipeBufferedQueued(c,a,g,r){let i,s;try{i=await c.open(a,{create:!1}),s=await g.open(r,{create:!0,unlock:!1});const o=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,y=0,S=0;do S=await c.read(i,l,o.buffer,y,o.byteLength-y),await this.doWriteBuffer(g,s,o,S,l,y),l+=S,y+=S,y===o.byteLength&&(y=0);while(S>0)}catch(o){throw(0,f.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof s=="number"?g.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,a,g,r){return this.writeQueue.queueFor(r,this.getExtUri(g).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,g,r))}async doPipeUnbufferedQueued(c,a,g,r){return g.writeFile(r,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,g,r){return this.writeQueue.queueFor(r,this.getExtUri(g).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,g,r))}async doPipeUnbufferedToBufferedQueued(c,a,g,r){const i=await g.open(r,{create:!0,unlock:!1});try{const s=await c.readFile(a);await this.doWriteBuffer(g,i,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await g.close(i)}}async doPipeBufferedToUnbuffered(c,a,g,r){const i=await(0,R.streamToBuffer)(this.readFileBuffered(c,a,D.CancellationToken.None));await this.doWriteUnbuffered(g,r,void 0,i)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new f.FileOperationError((0,h.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===k.Schemas.file?c.fsPath:c.toString(!0)}};m=ue([ie(0,C.ILogService)],m),e.FileService=m}),define(J[77],Z([0,1,29,252,9,35,16,4,28,2,7,3,17,48,24,149,20,94,186,39,181,180]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(w)}catch(g){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(g)}`)}})();class a extends C.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new D.ResourceMap(s=>I.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:s}=await t.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await t.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,I.joinPath)(r,o.name))).type:l=this.toType(o),s.push([o.name,l])}catch(l){this.logService.trace(l)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let s;return i?.dangling?s=f.FileType.Unknown:r.isFile()?s=f.FileType.File:r.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,i&&(s|=f.FileType.SymbolicLink),s}async createResourceLock(r){const i=this.toFilePath(r);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new R.Barrier;return this.resourceLocks.set(r,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(r)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const o=this.toFilePath(r);return await t.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(r,i,s){const o=(0,p.newWriteableStream)(l=>M.VSBuffer.concat(l.map(y=>M.VSBuffer.wrap(y))).buffer);return(0,v.readFileIntoStream)(this,r,o,l=>l.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(r,i,s){let o;try{const l=this.toFilePath(r);if(!s.create||!s.overwrite){if(await t.Promises.exists(l)){if(!s.overwrite)throw(0,f.createFileSystemProviderError)((0,h.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.createFileSystemProviderError)((0,h.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(r,l)}finally{typeof o=="number"&&await this.close(o)}}async open(r,i){const s=this.toFilePath(r);let o;(0,f.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(r));let l;try{if((0,f.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await t.SymlinkSupport.stat(s);S.mode&128||await t.Promises.chmod(s,S.mode|128)}catch(S){this.logService.trace(S)}let y;if((0,f.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await t.Promises.truncate(s,0),y="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}y||(y="w")}else y="r";l=await t.Promises.open(s,y)}catch(y){throw o?.dispose(),(0,f.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(l,0),(0,f.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,r),o){const y=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,o),y&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),y.dispose())}return l}async close(r){const i=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await t.Promises.fdatasync(r)}catch(s){this.canFlush=!1,this.logService.error(s)}return await t.Promises.close(r)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(r)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,o,l){const y=this.normalizePos(r,i);let S=null;try{S=(await t.Promises.read(r,s,o,l,y)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(r,y,S)}return S}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,s){const o=this.mapHandleToPos.get(r);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,o+s):this.mapHandleToPos.delete(r)))}async write(r,i,s,o,l){return(0,R.retry)(()=>this.doWrite(r,i,s,o,l),100,3)}async doWrite(r,i,s,o,l){const y=this.normalizePos(r,i);let S=null;try{S=(await t.Promises.write(r,s,o,l,y)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),L)}finally{this.updatePos(r,y,S)}return S}async mkdir(r){try{await t.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const s=this.toFilePath(r);i.recursive?await t.Promises.rm(s,t.RimRafMode.MOVE):await t.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,i,s){const o=this.toFilePath(r),l=this.toFilePath(i);if(o!==l)try{await this.validateTargetDeleted(r,i,"move",s.overwrite),await t.Promises.move(o,l)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(r,i,s){const o=this.toFilePath(r),l=this.toFilePath(i);if(o!==l)try{await this.validateTargetDeleted(r,i,"copy",s.overwrite),await t.Promises.copy(o,l,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(r,i,s,o){const l=this.toFilePath(r),y=this.toFilePath(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,d.isEqual)(l,y,!0)),S&&s==="copy")throw(0,f.createFileSystemProviderError)((0,h.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!S&&await t.Promises.exists(y)){if(!o)throw(0,f.createFileSystemProviderError)((0,h.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,i,s){return new u.UniversalWatcherClient(o=>r(o),o=>i(o),s)}createNonRecursiveWatcher(r,i,s){return new c.NodeJSWatcherClient(o=>r(o),o=>i(o),s)}toFileSystemProviderError(r){if(r instanceof f.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=f.FileSystemProviderErrorCode.NoPermissions;break;default:i=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let s=this.toFileSystemProviderError(i);if(r&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await t.SymlinkSupport.stat(this.toFilePath(r));o.mode&128||(s=(0,f.createFileSystemProviderError)(i,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=a}),define(J[188],Z([0,1,4,77,2,16,48,23]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends R.Disposable{constructor(k,I){super();this.provider=k,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,I,p){const t=this.getUriTransformer(k);switch(I){case"stat":return this.stat(t,p[0]);case"readdir":return this.readdir(t,p[0]);case"open":return this.open(t,p[0],p[1]);case"close":return this.close(p[0]);case"read":return this.read(p[0],p[1],p[2]);case"readFile":return this.readFile(t,p[0],p[1]);case"write":return this.write(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.writeFile(t,p[0],p[1],p[2]);case"rename":return this.rename(t,p[0],p[1],p[2]);case"copy":return this.copy(t,p[0],p[1],p[2]);case"mkdir":return this.mkdir(t,p[0]);case"delete":return this.delete(t,p[0],p[1]);case"watch":return this.watch(t,p[0],p[1],p[2],p[3]);case"unwatch":return this.unwatch(p[0],p[1])}throw new Error(`IPC Command ${I} not found`)}listen(k,I,p){const t=this.getUriTransformer(k);switch(I){case"fileChange":return this.onFileChange(t,p[0]);case"readFileStream":return this.onReadFileStream(t,p[0],p[1])}throw new Error(`Unknown event ${I}`)}stat(k,I){const p=this.transformIncoming(k,I,!0);return this.provider.stat(p)}readdir(k,I){const p=this.transformIncoming(k,I);return this.provider.readdir(p)}async readFile(k,I,p){const t=this.transformIncoming(k,I,!0),h=await this.provider.readFile(t,p);return D.VSBuffer.wrap(h)}onReadFileStream(k,I,p){const t=this.transformIncoming(k,I,!0),h=new b.CancellationTokenSource,f=new w.Emitter({onLastListenerRemove:()=>{h.cancel()}}),v=this.provider.readFileStream(t,p,h.token);return(0,M.listenStream)(v,{onData:C=>f.fire(D.VSBuffer.wrap(C)),onError:C=>f.fire(C),onEnd:()=>{f.fire("end"),f.dispose(),h.dispose()}}),f.event}writeFile(k,I,p,t){const h=this.transformIncoming(k,I);return this.provider.writeFile(h,p.buffer,t)}open(k,I,p){const t=this.transformIncoming(k,I,!0);return this.provider.open(t,p)}close(k){return this.provider.close(k)}async read(k,I,p){const t=D.VSBuffer.alloc(p),h=0,f=await this.provider.read(k,I,t.buffer,h,p);return[t,f]}write(k,I,p,t,h){return this.provider.write(k,I,p.buffer,t,h)}mkdir(k,I){const p=this.transformIncoming(k,I);return this.provider.mkdir(p)}delete(k,I,p){const t=this.transformIncoming(k,I);return this.provider.delete(t,p)}rename(k,I,p,t){const h=this.transformIncoming(k,I),f=this.transformIncoming(k,p);return this.provider.rename(h,f,t)}copy(k,I,p,t){const h=this.transformIncoming(k,I),f=this.transformIncoming(k,p);return this.provider.copy(h,f,t)}onFileChange(k,I){const p=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(k,p))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return p.event}async watch(k,I,p,t,h){const f=this.sessionToWatcher.get(I);if(f){const v=this.transformIncoming(k,t),C=f.watch(p,v,h);this.watchRequests.set(I+p,C)}}async unwatch(k,I){const p=k+I,t=this.watchRequests.get(p);t&&((0,R.dispose)(t),this.watchRequests.delete(p))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class E extends R.Disposable{constructor(k,I,p,t){super();this.uriTransformer=k,this.logService=p,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(k){const I=this._register(new w.Emitter);this._register(I.event(p=>{k.fire(p.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(p=>I.fire(p))),this._register(this.fileWatcher.onDidWatchError(p=>k.fire(p)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,I,p){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(p.excludes=[...p.excludes,...t]),this.watcherRequests.set(k,this.fileWatcher.watch(I,p)),(0,R.toDisposable)(()=>{(0,R.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=E}),define(J[189],Z([0,1,12,148,3,8,20,7,188,117]),function(H,e,w,n,R,D,M,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class P extends d.AbstractDiskFileSystemProviderChannel{constructor(p,t,h){super(p,t);this.environmentService=h}getUriTransformer(p){return E.DefaultURITransformer}transformIncoming(p,t){return D.URI.revive(t)}async delete(p,t,h){if(!h.useTrash)return super.delete(p,t,h);const f=this.transformIncoming(p,t),v=(0,b.normalize)(f.fsPath);try{await w.shell.trashItem(v)}catch{throw(0,M.createFileSystemProviderError)(R.isWindows?(0,n.localize)(0,null,(0,b.basename)(v)):(0,n.localize)(1,null,(0,b.basename)(v)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,t){return new k(p,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=P;class k extends d.AbstractSessionFileWatcher{watch(p,t,h){if(h.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(p,t,h)}}}),define(J[95],Z([0,1,6]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(D,M){switch(M){case w.LogLevel.Trace:return D.trace;case w.LogLevel.Debug:return D.debug;case w.LogLevel.Info:return D.info;case w.LogLevel.Warning:return D.warn;case w.LogLevel.Error:return D.error;case w.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class R extends w.AbstractLogger{constructor(M=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}set logger(M){this._logger=M;for(const{level:b,args:d}of this.buffer)n(M,b).apply(M,d);this.buffer=[]}_log(M,...b){this._logger?n(this._logger,M).apply(this._logger,b):this.getLevel()<=M&&this.buffer.push({level:M,args:b})}trace(M,...b){this._log(w.LogLevel.Trace,M,...b)}debug(M,...b){this._log(w.LogLevel.Debug,M,...b)}info(M,...b){this._log(w.LogLevel.Info,M,...b)}warn(M,...b){this._log(w.LogLevel.Warning,M,...b)}error(M,...b){this._log(w.LogLevel.Error,M,...b)}critical(M,...b){this._log(w.LogLevel.Critical,M,...b)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(J[190],Z([0,1,9,16,17,20,5,95,6]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const E=5*D.ByteSize.MB;let P=class extends d.AbstractLogger{constructor(p,t,h,f,v){super();this.name=p,this.resource=t,this.donotUseFormatters=f,this.fileService=v,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>E&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=t:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(h))})}getCurrentTimestamp(){const p=f=>f<10?`0${f}`:f,t=f=>f<10?`00${f}`:f<100?`0${f}`:f,h=new Date;return`${h.getFullYear()}-${p(h.getMonth()+1)}-${p(h.getDate())} ${p(h.getHours())}:${p(h.getMinutes())}:${p(h.getSeconds())}.${t(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,R.joinPath)((0,R.dirname)(this.resource),`${(0,R.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(p){switch(p){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};P=ue([ie(4,D.IFileService)],P),e.FileLogger=P;let k=class extends d.AbstractLoggerService{constructor(p,t,h){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=h}doCreateLogger(p,t,h){const f=new b.BufferLogService(t);return(0,D.whenProviderRegistered)(p,this.fileService).then(()=>f.logger=this.instantiationService.createInstance(P,h?.name||(0,R.basename)(p),p,f.getLevel(),!!h?.donotUseFormatters)),f}};k=ue([ie(0,d.ILogService),ie(1,M.IInstantiationService),ie(2,D.IFileService)],k),e.FileLoggerService=k}),define(J[191],Z([0,1,4,8,6]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(I){this.service=I,this.onDidChangeLogLevel=w.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(I,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=D;class M{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){M.setLevel(this.channel,I)}static setLevel(I,p){return I.call("setLevel",p)}}e.LogLevelChannelClient=M;class b{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,p){throw new Error(`Event not found: ${p}`)}async call(I,p,t){switch(p){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(I,p){this.loggers.set(I.toString(),this.loggerService.createLogger(I,p))}consoleLog(I,p){let t=console.log;switch(I){case R.LogLevel.Error:t=console.error;break;case R.LogLevel.Warning:t=console.warn;break;case R.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(I,p){const t=this.loggers.get(I.toString());if(!t)throw new Error("Create the logger before logging");for(const[h,f]of p)(0,R.log)(t,h,f)}}e.LoggerChannel=b;class d extends R.AbstractLoggerService{constructor(I,p,t){super(I,p);this.channel=t}createConsoleMainLogger(){return new R.AdapterLogger({log:(I,p)=>{this.channel.call("consoleLog",[I,p])}})}doCreateLogger(I,p,t){return new E(this.channel,I,p,t)}}e.LoggerChannelClient=d;class E extends R.AbstractMessageLogger{constructor(I,p,t,h){super(h?.always);this.channel=I,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,p){const t=[[I,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(I){this.channel.call("log",[this.file,I])}}class P extends R.LogService{constructor(I,p){super(p);this.parent=I,this._register(I.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=P}),define(J[96],Z([0,1,20,6]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function R(b,d,E,P,k){try{const I=await new Promise((t,h)=>{H(["spdlog"],t,h)});I.setFlushOn(n.LogLevel.Trace);const p=await I.createAsyncRotatingLogger(b,d,E,P);return k&&p.clearFormatters(),p}catch(I){console.error(I)}return null}function D(b,d,E){switch(d){case n.LogLevel.Trace:b.trace(E);break;case n.LogLevel.Debug:b.debug(E);break;case n.LogLevel.Info:b.info(E);break;case n.LogLevel.Warning:b.warn(E);break;case n.LogLevel.Error:b.error(E);break;case n.LogLevel.Critical:b.critical(E);break;default:throw new Error("Invalid log level")}}class M extends n.AbstractMessageLogger{constructor(d,E,P,k,I){super();this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(d,E,P,k),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(d,E,P,k){const I=P?6:1,p=30/I*w.ByteSize.MB,t=await R(d,E,p,I,k);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:h,message:f}of this.buffer)D(this._logger,h,f);this.buffer=[]}}log(d,E){this._logger?D(this._logger,d,E):this.getLevel()<=d&&this.buffer.push({level:d,message:E})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(J[192],Z([0,1,10,17,31,20,190,6,96]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let E=class extends b.AbstractLoggerService{constructor(k,I){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=I}doCreateLogger(k,I,p){return k.scheme===w.Schemas.file?new d.SpdLogLogger(p?.name||(0,R.generateUuid)(),k.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,I):new M.FileLogger(p?.name??(0,n.basename)(k),k,I,!!p?.donotUseFormatters,this.fileService)}};E=ue([ie(0,b.ILogService),ie(1,D.IFileService)],E),e.LoggerService=E}),define(J[193],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function n(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function R(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function D(M){return!w(M)&&!n(M)&&!R(M)}e.isMenubarMenuItemAction=D}),define(J[53],Z([0,1,10,3,36,17]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const b=n.globals.vscode.context.configuration();if(b)M=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const b=(0,D.dirname)(w.FileAccess.asFileUri("",H));M=H.__$__nodeRequire((0,D.joinPath)(b,"product.json").fsPath);const d=H.__$__nodeRequire((0,D.joinPath)(b,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:d.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(J[21],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[194],Z([0,1,74,4,2,6,3,52,21]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let E=class gt extends R.Disposable{constructor(k,I,p,t){super();this.isRunningOnServer=k,this.logService=I,this.environmentMainService=p,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(k,I){const p=await this.withKeytar(),t=await p.getPassword(k,I);if(t)try{let{content:h,hasNextChunk:f}=JSON.parse(t);if(!h||!f)return t;let v=1;for(;f;){const C=await p.getPassword(k,`${I}-${v}`),m=JSON.parse(C);h+=m.content,f=m.hasNextChunk,v++}return h}catch{return t}return t}async setPassword(k,I,p){const t=await this.withKeytar(),h=3,f=async(v,C,m)=>{let u=0,c;for(;u<h;)try{await t.setPassword(v,C,m);return}catch(a){c=a,this.logService.warn("Error attempting to set a password: ",a),u++,await new Promise(g=>setTimeout(g,200))}throw c};if(M.isWindows&&p.length>gt.MAX_PASSWORD_LENGTH){let v=0,C=0,m=!0;for(;m;){const u=p.substring(v,v+gt.PASSWORD_CHUNK_SIZE);v+=gt.PASSWORD_CHUNK_SIZE,m=p.length-v>0;const c={content:u,hasNextChunk:m};await f(k,C?`${I}-${C}`:I,JSON.stringify(c)),C++}}else await f(k,I,p);this._onDidChangePassword.fire({service:k,account:I})}async deletePassword(k,I){const t=await(await this.withKeytar()).deletePassword(k,I);return t&&this._onDidChangePassword.fire({service:k,account:I}),t}async findPassword(k){return(await this.withKeytar()).findPassword(k)}async findCredentials(k){return(await this.withKeytar()).findCredentials(k)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((k,I)=>{H(["keytar"],k,I)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(k){if(!this.isRunningOnServer)throw k;this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${k.message}`),this._keytarCache=new w.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=ue([ie(1,D.ILogService),ie(2,b.INativeEnvironmentService),ie(3,d.IProductService)],E),e.CredentialsMainService=E}),define(J[195],Z([0,1,60,6,21]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(b,d){this.productService=b,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const E=/^(.*)#([^#]+)$/.exec(d);if(!E)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,P,k]=E;let I=this.trustedExtensionUrlPublicKeys.get(b);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[b],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...I])}const p=Buffer.from(decodeURIComponent(k),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=p.slice(0,6),h=p.readUIntBE(0,6),f=Date.now()-h;if(f<0||f>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const v=p.slice(6),C=w.createVerify("SHA256");C.write(t),C.write(Buffer.from(P)),C.end();for(let m=0;m<I.length;m++){let u=I[m];if(u!==null){if(typeof u=="string")try{u=w.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),I[m]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${b}:`,c),I[m]=null;continue}if(C.verify(u,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};D=ue([ie(0,R.IProductService),ie(1,n.ILogService)],D),e.ExtensionUrlTrustService=D}),define(J[54],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(J[196],Z([0,1,12,2,35,10,7,3,8,31,52,6]),function(H,e,w,n,R,D,M,b,d,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends n.Disposable{constructor(t,h){super();this.logService=h,this.validRoots=R.TernarySearchTree.forPaths(!b.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(t.appRoot),this.addValidFileRoot(t.extensionsPath),this.addValidFileRoot(t.globalStorageHome.fsPath),this.addValidFileRoot(t.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=w.session;t.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(h,f)=>this.handleResourceRequest(h,f)),t.protocol.interceptFileProtocol(D.Schemas.file,(h,f)=>this.handleFileRequest(h,f)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(t){const h=(0,M.normalize)(t);return this.validRoots.get(h)?n.Disposable.None:(this.validRoots.set(h,!0),(0,n.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(t,h){const f=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${f.fsPath} from ${D.Schemas.file}: protocol (original URL: ${t.url})`),h({error:-3})}handleResourceRequest(t,h){const f=this.requestToNormalizedFilePath(t);return this.validRoots.findSubstr(f)?h({path:f}):this.validExtensions.has((0,M.extname)(f))?h({path:f}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),h({error:-3}))}requestToNormalizedFilePath(t){const h=d.URI.parse(t.url),f=D.FileAccess.asFileUri(h);return(0,M.normalize)(f.fsPath)}createIPCObjectUrl(){let t;const h=d.URI.from({scheme:"vscode",path:(0,E.generateUuid)()}),f=h.toString(),v=async()=>t;return w.ipcMain.handle(f,v),this.logService.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:h,update:C=>t=C,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${f}.`),w.ipcMain.removeHandler(f)}}}};I=ue([ie(0,P.INativeEnvironmentService),ie(1,k.ILogService)],I),e.ProtocolMainService=I}),define(J[40],Z([0,1,106,14]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(M,b){w.ok(n.isString(M)),w.ok(n.isObject(b)),w.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,b)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new R}),define(J[197],Z([0,1,4,40]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class D{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,E){this.schemasById[R(d)]=E,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new D;n.Registry.add(e.Extensions.JSONContribution,M)}),define(J[55],Z([0,1,30,4,14,140,197,40]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=b.Registry.as(M.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,a=!0){this.registerConfigurations([c],a)}registerConfigurations(c,a=!0){const g=this.doRegisterConfigurations(c,a);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}deregisterConfigurations(c){const a=this.doDeregisterConfigurations(c);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:c,remove:a}){const g=[];g.push(...this.doDeregisterConfigurations(a)),g.push(...this.doRegisterConfigurations(c,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(g)})}registerDefaultConfigurations(c){const a=[],g=[];for(const{overrides:r,source:i}of c)for(const s in r)if(a.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:o});const l={type:"object",default:o,description:D.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:R.isString(i)?void 0:i};g.push(...t(s)),this.configurationProperties[s]=l,this.defaultLanguageConfigurationOverridesNode.properties[s]=l}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:i});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const a=[];for(const{overrides:g,source:r}of c)for(const i in g){const s=this.configurationDefaultsOverrides.get(i),o=R.isString(r)?r:r?.id,l=R.isString(s?.source)?s?.source:s?.source?.id;if(o===l)if(a.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const y=this.configurationProperties[i];y&&(this.updatePropertyDefaultValue(i,y),this.updateSchema(i,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const a of c)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,a){const g=[];return c.forEach(r=>{g.push(...this.validateAndRegisterProperties(r,a,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),g}doDeregisterConfigurations(c){const a=[],g=r=>{if(r.properties)for(const i in r.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>g(i))};for(const r of c){g(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(c,a=!0,g,r,i=3){i=R.isUndefinedOrNull(c.scope)?i:c.scope;let s=[],o=c.properties;if(o)for(let y in o){if(a&&C(y)){delete o[y];continue}const S=o[y];if(S.source=g,S.defaultDefaultValue=o[y].default,this.updatePropertyDefaultValue(y,S),e.OVERRIDE_PROPERTY_REGEX.test(y)?S.scope=void 0:(S.scope=R.isUndefinedOrNull(S.scope)?i:S.scope,S.restricted=R.isUndefinedOrNull(S.restricted)?!!r?.includes(y):S.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.excludedConfigurationProperties[y]=o[y],delete o[y];continue}else this.configurationProperties[y]=o[y];!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),s.push(y)}let l=c.allOf;if(l)for(let y of l)s.push(...this.validateAndRegisterProperties(y,a,g,r,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const a=g=>{let r=g.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let i=g.allOf;i&&i.forEach(a)};a(c)}updateSchema(c,a){switch(e.allSettings.properties[c]=a,a.scope){case 1:e.applicationSettings.properties[c]=a;break;case 2:e.machineSettings.properties[c]=a;break;case 6:e.machineOverridableSettings.properties[c]=a;break;case 3:e.windowSettings.properties[c]=a;break;case 4:e.resourceSettings.properties[c]=a;break;case 5:e.resourceSettings.properties[c]=a,this.resourceLanguageSettingsSchema.properties[c]=a;break}}removeFromSchema(c,a){switch(delete e.allSettings.properties[c],a.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const a=`[${c}]`,g={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,g),e.allSettings.properties[a]=g,e.applicationSettings.properties[a]=g,e.machineSettings.properties[a]=g,e.machineOverridableSettings.properties[a]=g,e.windowSettings.properties[a]=g,e.resourceSettings.properties[a]=g}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,a){const g=this.configurationDefaultsOverrides.get(c);let r=g?.value,i=g?.source;R.isUndefined(r)&&(r=a.defaultDefaultValue,i=void 0),R.isUndefined(r)&&(r=f(a.type)),a.default=r,a.defaultValueSource=i}}const I="\\[([^\\]]+)\\]",p=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(u){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let a=p.exec(u);for(;a?.length;){const g=a[1].trim();g&&c.push(g),a=p.exec(u)}}return(0,w.distinct)(c)}e.overrideIdentifiersFromKey=t;function h(u){return u.reduce((c,a)=>`${c}[${a}]`,"")}e.keyFromOverrideIdentifiers=h;function f(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new k;b.Registry.add(e.Extensions.Configuration,v);function C(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?D.localize(7,null,u):v.getConfigurationProperties()[u]!==void 0?D.localize(8,null,u):null:D.localize(6,null)}e.validateProperty=C;function m(){const u=[],c=v.getConfigurationProperties();for(const a of Object.keys(c))u.push([a,c[a].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=m}),define(J[198],Z([0,1,30,4,44,2,35,49,14,8,19,55,40]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,P.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=b.deepClone(this.contents),s=b.deepClone(this.overrides),o=[...this.keys];for(const l of r){this.mergeContents(i,l.contents);for(const y of l.overrides){const[S]=s.filter(L=>w.equals(L.identifiers,y.identifiers));S?(this.mergeContents(S.contents,y.contents),S.keys.push(...y.keys),S.keys=w.distinct(S.keys)):s.push(b.deepClone(y))}for(const y of l.keys)o.indexOf(y)===-1&&o.push(y)}return new p(i,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o],y=i[o];y&&(typeof l=="object"&&typeof y=="object"?(l=b.deepClone(l),this.mergeContents(l,y)):l=y),s[o]=l}return new p(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&d.isObject(r[s])&&d.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=b.deepClone(i[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const o=l=>{l&&(s?this.mergeContents(s,l):s=b.deepClone(l))};for(const l of this.overrides)w.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&o(l.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,P.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(r={}){const i=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),o=Object.create(null),l=[];for(const y in i){const S=r[y],L=S!==void 0?S:i[y].default;(0,P.addToValueTree)(o,y,L,T=>console.error(`Conflict in default settings: ${T}`))}for(const y of Object.keys(o))k.OVERRIDE_PROPERTY_REGEX.test(y)&&l.push({identifiers:(0,k.overrideIdentifiersFromKey)(y),keys:Object.keys(o[y]),contents:(0,P.toValuesTree)(o[y],S=>console.error(`Conflict in default settings file: ${S}`))});super(o,s,l)}}e.DefaultConfigurationModel=t;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!d.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:o,overrides:l,restricted:y}=this.doParseRaw(r,i);this._configurationModel=new p(s,o,l),this._restrictedConfigurations=y||[]}doParseContent(r){let i={},s=null,o=[],l=[],y=[];function S(T){Array.isArray(o)?o.push(T):s!==null&&(o[s]=T)}let L={onObjectBegin:()=>{let T={};S(T),l.push(o),o=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let T=[];S(T),l.push(o),o=T,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:S,onError:(T,B,Y)=>{y.push({error:T,offset:B,length:Y})}};if(r)try{R.visit(r,L),i=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const s=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,s,!0,i);r=o.raw;const l=(0,P.toValuesTree)(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),y=Object.keys(r),S=this.toOverrides(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:l,keys:y,overrides:S,restricted:o.restricted}}filter(r,i,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const l={},y=[];for(let S in r)if(k.OVERRIDE_PROPERTY_REGEX.test(S)&&s){const L=this.filter(r[S],i,!1,o);l[S]=L.raw,y.push(...L.restricted)}else{const L=i[S],T=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&y.push(S),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&L?.restricted||(l[S]=r[S]))}return{raw:l,restricted:y}}toOverrides(r,i){const s=[];for(const o of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const y in r[o])l[y]=r[o][y];s.push({identifiers:(0,k.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,P.toValuesTree)(l,i)})}return s}}e.ConfigurationModelParser=h;class f extends D.Disposable{constructor(r,i,s,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class v{constructor(r,i,s=new p,o=new p,l=new M.ResourceMap,y=new p,S=new M.ResourceMap,L=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=y,this._memoryConfigurationByResource=S,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(r)}updateValue(r,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new p,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const o=this.getConsolidateConfigurationModel(i,s),l=this.getFolderConfigurationModelForResource(i.resource,s),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),B=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),Y=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ee=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(r):l.freeze().getValue(r):void 0,te=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(r):y.getValue(r),Q=o.getValue(r),q=w.distinct(w.flatten(o.overrides.map(G=>G.identifiers))).filter(G=>o.getOverrideValue(r,G)!==void 0);return{defaultValue:S,userValue:L,userLocalValue:T,userRemoteValue:B,workspaceValue:Y,workspaceFolderValue:ee,memoryValue:te,value:Q,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:B!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:Y!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:l?.freeze().getValue(r),override:i.overrideIdentifier?l?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:y.getValue(r),override:i.overrideIdentifier?y.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:o,updated:l,removed:y}=c(this._defaultConfiguration,r);i=[...o,...l,...y]}for(const o of i)for(const l of(0,k.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=r.getKeysForOverrideIdentifier(l),L=[...S.filter(T=>y.indexOf(T)===-1),...y.filter(T=>S.indexOf(T)===-1),...y.filter(T=>!b.equals(this._defaultConfiguration.override(l).getValue(T),r.override(l).getValue(T)))];s.push([l,L])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:l}=c(this.localUserConfiguration,r),y=[...i,...s,...o];return y.length&&this.updateLocalUserConfiguration(r),{keys:y,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:l}=c(this.remoteUserConfiguration,r);let y=[...i,...s,...o];return y.length&&this.updateRemoteUserConfiguration(r),{keys:y,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:o,overrides:l}=c(this.workspaceConfiguration,r);let y=[...i,...s,...o];return y.length&&this.updateWorkspaceConfiguration(r),{keys:y,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:o,updated:l,removed:y,overrides:S}=c(s,i);let L=[...o,...l,...y];return(L.length||!s)&&this.updateFolderConfiguration(r,i),{keys:L,overrides:S}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:l,overrides:y}=c(i,void 0);return{keys:[...s,...o,...l],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let s=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const l=this._memoryConfigurationByResource.get(r);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:o,keys:l}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:o,keys:l}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),l=r.folders.reduce((y,S)=>(y.set(E.URI.revive(S[0]),this.parseConfigurationModel(S[1])),y),new M.ResourceMap);return new v(i,s,new p,o,l,new p,new M.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=v;function C(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const r=new Set,i=new Map;for(const o of g)o.keys.forEach(l=>r.add(l)),o.overrides.forEach(([l,y])=>{const S=(0,M.getOrSet)(i,l,new Set);y.forEach(L=>S.add(L))});const s=[];return i.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=C;class m{constructor(r,i,s,o){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;r.keys.forEach(S=>l.add(S)),r.overrides.forEach(([,S])=>S.forEach(L=>l.add(L))),this.affectedKeys=[...l.values()];const y=new p;this.affectedKeys.forEach(S=>y.setValue(S,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!b.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,P.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(r=r[o],!r)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=m;class u extends m{constructor(r,i,s,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=u;function c(g,r){const{added:i,removed:s,updated:o}=a(r,g),l=[],y=g?.getAllOverrideIdentifiers()||[],S=r?.getAllOverrideIdentifiers()||[];if(r){const L=S.filter(T=>!y.includes(T));for(const T of L)l.push([T,r.getKeysForOverrideIdentifier(T)])}if(g){const L=y.filter(T=>!S.includes(T));for(const T of L)l.push([T,g.getKeysForOverrideIdentifier(T)])}if(r&&g){for(const L of y)if(S.includes(L)){const T=a({contents:g.getOverrideValue(void 0,L)||{},keys:g.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});l.push([L,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:s,updated:o,overrides:l}}function a(g,r){const i=g?r?g.keys.filter(l=>r.keys.indexOf(l)===-1):[...g.keys]:[],s=r?g?r.keys.filter(l=>g.keys.indexOf(l)===-1):[...r.keys]:[],o=[];if(g&&r){for(const l of r.keys)if(g.keys.indexOf(l)!==-1){const y=(0,P.getConfigurationValue)(r.contents,l),S=(0,P.getConfigurationValue)(g.contents,l);b.equals(y,S)||o.push(l)}}return{added:i,removed:s,updated:o}}}),define(J[199],Z([0,1,9,4,2,17,19,198,55,40]),function(H,e,w,n,R,D,M,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends R.Disposable{constructor(I,p){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,p)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,p){const t=typeof I=="string"?I:void 0,h=(0,M.isConfigurationOverrides)(I)?I:(0,M.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,h,void 0)}updateValue(I,p,t,h){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(t,p,1)}onDidDefaultConfigurationChange(I){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,I);this.trigger(t,p,6)}trigger(I,p,t){const h=new b.ConfigurationChangeEvent(I,{data:p},this.configuration);h.source=t,h.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(J[200],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var n;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(M,b=n.Unknown,d){super(M);this._message=M,this._code=b,this._detail=d,this.isHandled=b===n.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(M){return M instanceof R&&M._code===n.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof R&&M._code===n.NoResolverFound}static isHandled(M){return M instanceof R&&M.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[201],Z([0,1,9,16,23,15,4,2,31,88,200]),function(H,e,w,n,R,D,M,b,d,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const k=30*1e3;var I;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function p(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(z){const O=new R.CancellationTokenSource;return setTimeout(()=>O.cancel(),z),O.token}function h(z,O){if(z.isCancellationRequested||O.isCancellationRequested)return R.CancellationToken.Cancelled;const U=new R.CancellationTokenSource;return z.onCancellationRequested(()=>U.cancel()),O.onCancellationRequested(()=>U.cancel()),U.token}class f{constructor(O){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((U,W)=>{this._resolvePromise=U,this._rejectPromise=W}),O.isCancellationRequested?this._timeout():this._disposables.add(O.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(O){this._state==="pending"?this._disposables.add(O):O.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(O))}reject(O){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(O))}}function v(z,O){const U=new f(O);return U.registerDisposable(z.onControlMessage(W=>{const A=JSON.parse(W.toString()),F=_(A);F?U.reject(F):U.resolve(A)})),U.promise}function C(z,O,U,W,A,F,N){const K=new f(N);return O.connect(U,W,A,F,(se,ae)=>{K.didTimeout?(se&&z.error(se),ae?.dispose()):se||!ae?K.reject(se):K.resolve(ae)}),K.promise}function m(z,O){const U=new f(O);return z.then(W=>{U.didTimeout||U.resolve(W)},W=>{U.didTimeout||U.reject(W)}),U.promise}async function u(z,O,U,W){const A=V(z,O);z.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let F;try{F=await C(z.logService,z.socketFactory,z.host,z.port,`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${p(O)}-${z.reconnectionToken}`,W)}catch(ce){throw z.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let N,K;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(F,null),N=z.reconnectionProtocol,K=!1):(N=new E.PersistentProtocol(F,null),K=!0),z.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const se=await m(z.signService.createNewMessage((0,d.generateUuid)()),W),ae={type:"auth",auth:z.connectionToken||"00000000000000000000",data:se.data};N.sendControl(n.VSBuffer.fromString(JSON.stringify(ae)));try{const ce=await v(N,h(W,t(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${A} 4/6. received SignRequest control message.`),!await m(z.signService.validate(se,ce.signedData),W)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const le=await m(z.signService.sign(ce.data),W),he={type:"connectionType",commit:z.commit,signedData:le,desiredConnectionType:O};return U&&(he.args=U),z.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:N,ownsProtocol:K}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${A} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${A} received error control message when negotiating connection. Error:`),z.logService.error(ce)),K&&G(N),ce}}async function c(z,O,U,W){const A=Date.now(),F=V(z,O),{protocol:N,ownsProtocol:K}=await u(z,O,U,W),se=new f(W);return se.registerDisposable(N.onControlMessage(ae=>{const ce=JSON.parse(ae.toString()),ne=_(ce);ne?(z.logService.error(`${F} received error control message when negotiating connection. Error:`),z.logService.error(ne),K&&G(N),se.reject(ne)):(z.reconnectionProtocol&&z.reconnectionProtocol.endAcceptReconnection(),z.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${X(A)}!`),se.resolve({protocol:N,firstMessage:ce}))})),se.promise}async function a(z,O){const{protocol:U}=await c(z,1,void 0,O);return{protocol:U}}async function g(z,O,U){const{protocol:W,firstMessage:A}=await c(z,2,O,U),F=A&&A.debugPort;return{protocol:W,debugPort:F}}async function r(z,O,U){const W=Date.now(),A=V(z,3),{protocol:F}=await u(z,3,O,U);return z.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${X(W)}!`),F}async function i(z,O,U){const{host:W,port:A,connectionToken:F}=await z.addressProvider.getAddress();return{commit:z.commit,host:W,port:A,connectionToken:F,reconnectionToken:O,reconnectionProtocol:U,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function s(z,O,U){try{const W=(0,d.generateUuid)(),A=await i(z,W,null),{protocol:F}=await a(A,R.CancellationToken.None);return new Q(z,O,U,W,F)}catch(W){throw z.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),z.logService.error(W),te.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=s;async function o(z,O){try{const U=(0,d.generateUuid)(),W=await i(z,U,null),{protocol:A,debugPort:F}=await g(W,O,R.CancellationToken.None);return new q(z,O,U,A,F)}catch(U){throw z.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),z.logService.error(U),te.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentExtensionHost=o;async function l(z,O,U){const W=await i(z,(0,d.generateUuid)(),null);return await r(W,{host:O,port:U},R.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function y(z){return(0,w.createCancelablePromise)(O=>new Promise((U,W)=>{const A=setTimeout(U,z*1e3);O.onCancellationRequested(()=>{clearTimeout(A),U()})}))}var S;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(S=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(O,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=L;class T{constructor(O,U,W,A){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.durationSeconds=W,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class B{constructor(O,U,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=B;class Y{constructor(O,U,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=4}}e.ConnectionGainEvent=Y;class ee{constructor(O,U,W,A){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=W,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=ee;class te extends b.Disposable{constructor(O,U,W,A){super();this._connectionType=O,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=U,this.reconnectionToken=W,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new Y(this.reconnectionToken,0,0)),this._register(A.onSocketClose(F=>{const N=$(this._connectionType,this.reconnectionToken,!0);F?F.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${F.hadError}).`),F.error&&this._options.logService.error(F.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${F.wasClean}, code: ${F.code}, reason: ${F.reason}).`),F.event&&this._options.logService.error(F.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const F=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} received socket timeout event.`),this._beginReconnecting()})),te._instances.push(this),te._permanentFailure&&this._gotoPermanentFailure(te._permanentFailureMillisSinceLastIncomingData,te._permanentFailureAttempt,te._permanentFailureHandled)}static triggerPermanentFailure(O,U,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=O,this._permanentFailureAttempt=U,this._permanentFailureHandled=W,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(O=>O._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(O=>O._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(te._permanentFailure)return;const O=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const A=W<U.length?U[W]:U[U.length-1];try{if(A>0){const N=y(A);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,N)),this._options.logService.info(`${O} waiting for ${A} seconds before reconnecting...`);try{await N}catch{}}if(te._permanentFailure){this._options.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${O} resolving connection...`);const F=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${O} connecting to ${F.host}:${F.port}...`),await this._reconnect(F,t(k)),this._options.logService.info(`${O} reconnected!`),this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(F){if(F.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(F),te.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(F),te.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(F)){this._options.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(F);continue}if((F.code==="ETIMEDOUT"||F.code==="ENETUNREACH"||F.code==="ECONNREFUSED"||F.code==="ECONNRESET")&&F.syscall==="connect"){this._options.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(F);continue}if((0,D.isCancellationError)(F)){this._options.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(F);continue}if(F instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(F),te.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,P.RemoteAuthorityResolverError.isHandled(F));break}this._options.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(F),te.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!te._permanentFailure)}_gotoPermanentFailure(O,U,W){this._onDidStateChange.fire(new ee(this.reconnectionToken,O,U,W)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=te,te._permanentFailure=!1,te._permanentFailureMillisSinceLastIncomingData=0,te._permanentFailureAttempt=0,te._permanentFailureHandled=!1,te._instances=[];class Q extends te{constructor(O,U,W,A,F){super(1,O,A,F);this.client=this._register(new E.Client(F,{remoteAuthority:U,clientId:W},O.ipcLogger))}async _reconnect(O,U){await a(O,U)}}e.ManagementPersistentConnection=Q;class q extends te{constructor(O,U,W,A,F){super(2,O,W,A);this._startArguments=U,this.debugPort=F}async _reconnect(O,U){await g(O,this._startArguments,U)}}e.ExtensionHostPersistentConnection=q;function G(z){try{z.acceptDisconnect();const O=z.getSocket();z.dispose(),O.dispose()}catch(O){(0,D.onUnexpectedError)(O)}}function _(z){if(z&&z.type==="error"){const O=new Error(`Connection error: ${z.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function x(z,O){for(;z.length<O;)z+=" ";return z}function $(z,O,U){return`[remote-connection][${x(p(z),13)}][${O.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function V(z,O){return`${$(O,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function X(z){return`${Date.now()-z} ms`}}),define(J[78],Z([0,1,10]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(D){return D.scheme===w.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=n;function R(D){if(!D)return;const M=D.indexOf("+");return M<0?D:D.substr(0,M)}e.getRemoteName=R}),define(J[56],Z([0,1,16,153,55,5,40]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function b(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=b;function d(t){return t.res.statusCode===204}async function E(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,w.streamToBuffer)(t.stream)).toString()}e.asText=E;async function P(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const f=(await(0,w.streamToBuffer)(t.stream)).toString();try{return JSON.parse(f)}catch(v){throw v.message+=`:
`+f,v}}e.asJson=P;function k(t){p(t)}e.updateProxyConfigurationsScope=k;let I;function p(t){const h=M.Registry.as(R.Extensions.Configuration),f=I;I={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[I],remove:f?[f]:[]})}p(2)}),define(J[202],Z([0,1,203,14]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(M,b){return M.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:M.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function D(M,b,d={}){const E=(0,w.parse)(M),P=d.proxyUrl||R(E,b);if(!P)return null;const k=(0,w.parse)(P);if(!/^https?:$/.test(k.protocol||""))return null;const I={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,n.isBoolean)(d.strictSSL)?d.strictSSL:!0};return E.protocol==="http:"?new(await new Promise((p,t)=>{H(["http-proxy-agent"],p,t)}))(I):new(await new Promise((p,t)=>{H(["https-proxy-agent"],p,t)}))(I)}e.getProxyAgent=D}),define(J[79],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[204],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((R,D)=>H(["vsda"],R,D))}async createNewMessage(R){try{const D=await this.vsda(),M=new D.validator;if(M){const b=String(w._nextId++);return this.validators.set(b,M),{id:b,data:M.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,D){if(!R.id)return!0;const M=this.validators.get(R.id);if(!M)return!1;this.validators.delete(R.id);try{return M.validate(D)==="ok"}catch{return!1}}async sign(R){try{const D=await this.vsda(),M=new D.signer;if(M)return M.sign(R)}catch{}return R}}e.SignService=w,w._nextId=1}),define(J[38],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(J[18],Z([0,1,12,9,4,2,3,36,14,5,6,38]),function(H,e,w,n,R,D,M,b,d,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var I;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(I=e.ShutdownReason||(e.ShutdownReason={}));var p;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class mt extends D.Disposable{constructor(f,v){super();this.logService=f,this.stateMainService=v,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(mt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(mt.QUIT_AND_RESTART_KEY)}registerListeners(){const f=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),M.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",f);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!M.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",v),w.app.once("will-quit",C=>{this.logService.trace("Lifecycle#app.on(will-quit)"),C.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",f),w.app.removeListener("window-all-closed",v),w.app.quit()})})}fireOnWillShutdown(f){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const v=[];return this._onWillShutdown.fire({reason:f,join(C){v.push(C)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(v)}catch(C){this.logService.error(C)}try{await this.stateMainService.close()}catch(C){this.logService.error(C)}})(),this.pendingWillShutdownPromise}set phase(f){if(f<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===f)return;this.logService.trace(`lifecycle (main): phase changed (value: ${f})`),this._phase=f;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(f){if(f<=this._phase)return;let v=this.phaseWhen.get(f);v||(v=new n.Barrier,this.phaseWhen.set(f,v)),await v.wait()}registerWindow(f){const v=new D.DisposableStore;this.windowCounter++,v.add(f.onWillLoad(m=>this._onWillLoadWindow.fire({window:f,workspace:m.workspace,reason:m.reason})));const C=(0,d.assertIsDefined)(f.win);C.on("close",m=>{const u=f.id;if(this.windowToCloseRequest.has(u)){this.windowToCloseRequest.delete(u);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${f.id}`),m.preventDefault(),this.unload(f,1).then(c=>{if(c){this.windowToCloseRequest.delete(u);return}this.windowToCloseRequest.add(u),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${u}`),this._onBeforeCloseWindow.fire(f),f.close()})}),C.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${f.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!M.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(f,v){await this.unload(f,3)||f.reload(v)}unload(f,v){const C=this.mapWindowIdToPendingUnload.get(f.id);if(C)return C;const m=this.doUnload(f,v).finally(()=>{this.mapWindowIdToPendingUnload.delete(f.id)});return this.mapWindowIdToPendingUnload.set(f.id,m),m}async doUnload(f,v){if(!f.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${f.id}`);const C=this._quitRequested?2:v;let m=await this.onBeforeUnloadWindowInRenderer(f,C);return m?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${f.id})`),this.handleWindowUnloadVeto(m)):(await this.onWillUnloadWindowInRenderer(f,C),!1)}handleWindowUnloadVeto(f){return f?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(f){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(f),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(f,v){return new Promise(C=>{const m=this.oneTimeListenerTokenGenerator++,u=`vscode:ok${m}`,c=`vscode:cancel${m}`;w.ipcMain.once(u,()=>{C(!1)}),w.ipcMain.once(c,()=>{C(!0)}),f.send("vscode:onBeforeUnload",{okChannel:u,cancelChannel:c,reason:v})})}onWillUnloadWindowInRenderer(f,v){return new Promise(C=>{const u=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(u,()=>C()),f.send("vscode:onWillUnload",{replyChannel:u,reason:v})})}quit(f){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${f}`),f&&this.stateMainService.setItem(mt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(f){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(f?.addArgs&&v.push(...f.addArgs),f?.removeArgs)for(const u of f.removeArgs){const c=v.indexOf(u);c>=0&&v.splice(c,1)}const C=()=>{try{if(M.isWindows){const u=(0,b.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.logService.error(u)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:v})};w.app.once("quit",C),await this.quit(!0)&&w.app.removeListener("quit",C)}async kill(f){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of w.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let C;v.webContents&&!v.webContents.isDestroyed()?C=new Promise(m=>v.once("closed",m)):C=Promise.resolve(),v.destroy(),await C}})()]),w.app.exit(f)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ue([ie(0,P.ILogService),ie(1,k.IStateMainService)],t),e.LifecycleMainService=t}),define(J[205],Z([0,1,4,2,5,18]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let M=class extends n.Disposable{constructor(E){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,E.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const E=await new Promise((P,k)=>{H(["native-keymap"],P,k)});this._keyboardLayoutData=b(E),E.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(E),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ue([ie(0,D.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function b(d){const E=d.getKeyMap(),P=d.getCurrentKeyboardLayout();return{keyboardMapping:E,keyboardLayoutInfo:P}}}),define(J[97],Z([0,1,9,4,2,63,14,90,5]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var I;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class p extends R.Disposable{constructor(v={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,C){C===E?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:C,target:this.getKeyTargets(v)[C]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,C,m){return this.getStorage(C)?.get(v,m)}getBoolean(v,C,m){return this.getStorage(C)?.getBoolean(v,m)}getNumber(v,C,m){return this.getStorage(C)?.getNumber(v,m)}store(v,C,m,u){if((0,M.isUndefinedOrNull)(C)){this.remove(v,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,m,u),this.getStorage(m)?.set(v,C)})}remove(v,C){this.withPausedEmitters(()=>{this.updateKeyTarget(v,C,void 0),this.getStorage(C)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,C){const m=[],u=this.getKeyTargets(v);for(const c of Object.keys(u))u[c]===C&&m.push(c);return m}updateKeyTarget(v,C,m){const u=this.getKeyTargets(C);typeof m=="number"?u[v]!==m&&(u[v]=m,this.getStorage(C)?.set(E,JSON.stringify(u))):typeof u[v]=="number"&&(delete u[v],this.getStorage(C)?.set(E,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const C=this.get(E,v);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=P.NONE){this._onWillSaveState.fire({reason:v});const C=this.getStorage(0),m=this.getStorage(1);switch(v){case P.NONE:await w.Promises.settled([C?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await w.Promises.settled([C?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return h(v,C,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function h(f,v,C,m){const u=o=>{try{return JSON.parse(o)}catch{return o}},c=new Map,a=new Map;f.forEach((o,l)=>{c.set(l,o),a.set(l,u(o))});const g=new Map,r=new Map;v.forEach((o,l)=>{g.set(l,o),r.set(l,u(o))}),console.group(`Storage: Global (path: ${C})`);let i=[];c.forEach((o,l)=>{i.push({key:l,value:o})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${m})`);let s=[];g.forEach((o,l)=>{s.push({key:l,value:o})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=h}),define(J[206],Z([0,1,3,36,8,31]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(E){if(w.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function b(E,P,k,I,p,t,h,f,v,C){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,D.generateUuid)()+Date.now(),m.commitHash=p,m.version=t,m["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,w.PlatformToString)(w.platform),m["common.nodePlatform"]=n.platform,m["common.nodeArch"]=I,m["common.product"]=C||"desktop";const u=d(f||[]);u&&(m["common.msftInternal"]=u);let c=0;const a=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(m["common.snap"]="true");const g=M(k);g&&(m["common.platformDetail"]=g);try{const r=await E.readFile(R.URI.file(v));m["common.source"]=r.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=b;function d(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const k=P.toLowerCase();return E.some(I=>k===I)}e.verifyMicrosoftInternalDomain=d}),define(J[33],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[207],Z([0,1,26,68,9,44,10,7,3,8,71,24,87,75,20,21,33]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function C(g,r){const i=`${g}::${r.join(":")}`,s=v.get(i);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,y=new Map,S=2e4;function L(B,Y,ee,te){const Q=Y.substring(B.length+1);return R.Promises.withAsyncBody(async q=>{let G;try{G=await k.Promises.readdir(Y,{withFileTypes:!0})}catch{q();return}if(te.count>=S){te.count+=G.length,te.maxReached=!0,q();return}let _=G.length;if(_===0){q();return}let x=G;te.count+G.length>S&&(te.maxReached=!0,_=S-te.count,x=G.slice(0,_)),te.count+=G.length;for(const $ of x)if($.isDirectory()){if(ee.includes($.name)||await L(B,(0,b.join)(Y,$.name),ee,te),--_==0){q();return}}else{const V=$.name.lastIndexOf(".");if(V>=0){const X=$.name.substring(V+1);X&&l.set(X,(l.get(X)??0)+1)}for(const X of o)X.relativePathPattern?.test(Q)!==!1&&X.filePattern.test($.name)&&y.set(X.tag,(y.get(X.tag)??0)+1);if(--_==0){q();return}}})}const T=R.Promises.withAsyncBody(async B=>{const Y={count:0,maxReached:!1};await L(g,g,r,Y);const ee=await c(g);B({configFiles:m(y),fileTypes:m(l),fileCount:Y.count,maxFilesReached:Y.maxReached,launchConfigFiles:ee})});return v.set(i,T),T}e.collectWorkspaceStats=C;function m(g){return[...n.Iterable.map(g.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function u(){const g={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},r=w.cpus();return r&&r.length>0&&(g.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),g}e.getMachineInfo=u;async function c(g){try{const r=new Map,i=(0,b.join)(g,".vscode","launch.json"),s=await k.Promises.readFile(i),o=[],l=(0,D.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,D.getNodeType)(l)==="object"&&l.configurations)for(const y of l.configurations){const S=y.type;S&&(r.has(S)?r.set(S,r.get(S)+1):r.set(S,1))}return m(r)}catch{return[]}}e.collectLaunchConfigs=c;let a=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const s=w.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||i.push(`Load (avg):       ${w.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,I.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[o,l]=s,y=this.formatProcessList(r,o);return i.forEach(S=>{if((0,p.isRemoteDiagnosticError)(S))y+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(y+=`

Remote: ${S.hostName}`,S.processes&&(y+=`
${this.formatProcessList(r,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const L of Object.keys(S.workspaceMetadata)){const T=S.workspaceMetadata[L];let B=`${T.fileCount} files`;T.maxFilesReached&&(B=`more than ${B}`),l+=`|    Folder (${L}): ${B}`,l+=this.formatWorkspaceStats(T)}}}),{processInfo:y,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:s,vmHint:o,os:l,cpus:y}=u(),S={os:l,memory:s,cpus:y,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return d.isWindows||(S.load=`${w.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(r,i){const s=[];return(0,I.listProcesses)(r.mainPID).then(async o=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,o)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),i.forEach(l=>{if((0,p.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(r,l.processes)),l.workspaceMetadata)for(const y of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[y];let L=`${S.fileCount} files`;S.maxFilesReached&&(L=`more than ${L}`),s.push(`Folder (${y}): ${L}`),s.push(this.formatWorkspaceStats(S))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const i=[],s=60;let o=0;const l=(T,B)=>{const Y=` ${T}(${B})`;o+Y.length>s?(i.push(y),y="|                 ",o=y.length):o+=Y.length,y+=Y};let y="|      File types:";const S=10;let L=r.fileTypes.length>S?S:r.fileTypes.length;for(let T=0;T<L;T++){const B=r.fileTypes[T];l(B.name,B.count)}if(i.push(y),r.configFiles.length>=0&&(y="|      Conf files:",o=0,r.configFiles.forEach(T=>{l(T.name,T.count)}),i.push(y)),r.launchConfigFiles.length>0){let T="|      Launch Configs:";r.launchConfigFiles.forEach(B=>{T+=B.count>1?` ${B.name}(${B.count})`:` ${B.name}`}),i.push(T)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],s=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const y=E.URI.revive(l);if(y.scheme===M.Schemas.file){const S=y.fsPath;s.push(C(S,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),i.push(`|    Folder (${(0,b.basename)(S)}): ${T}`),i.push(this.formatWorkspaceStats(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${S} (${L.toString()})`)}))}else i.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(r,i){const s=new Map;r.windows.forEach(l=>s.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,s,o,i,0),o.join(`
`)}formatProcessItem(r,i,s,o,l){const y=l===0;let S;y?S=o.pid===r?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(S=`${S} (${i.get(o.pid)})`));const L=process.platform==="win32"?o.mem:w.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(o.children)&&o.children.forEach(T=>this.formatProcessItem(r,i,s,T,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:s}of r.folders){const o=E.URI.revive(s);if(o.scheme!==M.Schemas.file)continue;const l=o.fsPath;try{(await C(l,["node_modules",".git"])).fileTypes.forEach(S=>i.add(S.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const s=E.URI.revive(i);if(s.scheme!==M.Schemas.file)continue;const o=s.fsPath;try{const l=await C(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})})}catch{}}}};a=ue([ie(0,f.ITelemetryService),ie(1,h.IProductService)],a),e.DiagnosticsService=a}),define(J[208],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(D){this.appenders=D}listen(D,M){throw new Error(`Event not found: ${M}`)}call(D,M,{eventName:b,data:d}){return this.appenders.forEach(E=>E.log(b,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class n{constructor(D){this.channel=D}log(D,M){return this.channel.call("log",{eventName:D,data:M}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(J[64],Z([0,1,49,14,19,33]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(C,m){return Promise.resolve(void 0)}publicLog2(C,m){return this.publicLog(C,m)}publicLogError(C,m){return Promise.resolve(void 0)}publicLogError2(C,m){return this.publicLogError(C,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class b{async publicLog(C,m,u){}async publicLogError(C,m,u){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(v,C){return C.onDidChangeConfiguration(m=>{m.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(m.source),configurationKeys:t(m.sourceConfig)})})}e.configurationTelemetry=d;function E(v,C){return!(C.disableTelemetry||!v.enableTelemetry||C.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(v){const C=v.getValue(D.TELEMETRY_SETTING_ID),m=v.getValue("telemetry.enableCrashReporter");if(v.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(C??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function k(v){const C=Object.create(null),m=Object.create(null),u=Object.create(null);p(v,u);for(let c in u){c=c.length>150?c.substr(c.length-149):c;const a=u[c];typeof a=="number"?m[c]=a:typeof a=="boolean"?m[c]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${a.length}`),C[c]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(C[c]=a)}return{properties:C,measurements:m}}e.validateTelemetryData=k;function I(v){if(!v)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{v.indexOf(`${u}+`)===0&&(C=u)}),C}e.cleanRemoteAuthority=I;function p(v,C,m=0,u){if(!!v)for(let c of Object.getOwnPropertyNames(v)){const a=v[c],g=u?u+c:c;Array.isArray(a)?C[g]=(0,w.safeStringify)(a):a instanceof Date?C[g]=a.toISOString():(0,n.isObject)(a)?m<2?p(a,C,m+1,g+"."):C[g]=(0,w.safeStringify)(a):C[g]=a}}function t(v){if(!v)return[];const C=[];return h(C,"",v),C}function h(v,C,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(u=>h(v,C?`${C}.${u}`:u,m[u])):v.push(C)}function f(v){return[v.appRoot,v.extensionsPath,v.userHome.fsPath,v.tmpDir.fsPath,v.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(J[209],Z([0,1,172,64]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(D,M,b,d,E,P){const k={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${M.nameShort})`},I=await(0,w.getServiceMachineId)(b,E,P);return(0,n.supportsTelemetry)(M,b)&&(0,n.getTelemetryLevel)(d)===3&&(k["X-Market-User-Id"]=I),k}e.resolveMarketplaceHeaders=R}),define(J[210],Z([0,1,2,49,3,27,154,19,55,53,40,33,64]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(f,v){this._configurationService=v,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let C of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(C),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(f,v){this._experimentProperties[f]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,I.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let v=f.sessionID,C=f["common.machineId"],m=f["common.firstSessionDate"],u=f["common.msftInternal"];return{sessionId:v,machineId:C,firstSessionDate:m,msftInternal:u}}dispose(){this._disposables.dispose()}_log(f,v,C,m){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(u=>{C=(0,n.mixin)(C,u),C=(0,n.mixin)(C,this._experimentProperties),C=(0,n.cloneAndChange)(C,c=>{if(typeof c=="string")return this._cleanupInfo(c,m)}),this._appenders.forEach(c=>c.log(f,C))},u=>{console.error(u)})}publicLog(f,v,C){return this._log(f,3,v,C)}publicLog2(f,v,C){return this.publicLog(f,v,C)}publicLogError(f,v){return this.sendErrorTelemetry?this._log(f,2,v,!0):Promise.resolve(void 0)}publicLogError2(f,v){return this.publicLogError(f,v)}_anonymizeFilePaths(f){let v=f;const C=[];for(let a of this._cleanupPatterns)for(;;){const g=a.exec(f);if(!g)break;C.push([g.index,a.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const a=u.exec(f);if(!a)break;!m.test(a[0])&&C.every(([g,r])=>a.index<g||a.index>=r)&&(v+=f.substring(c,a.index)+"<REDACTED: user-file-path>",c=u.lastIndex)}return c<f.length&&(v+=f.substr(c)),v}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const v=f.toLowerCase(),C=/@[a-zA-Z0-9-.]+/,m=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,u=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return m.test(v)?"<REDACTED: secret>":C.test(v)?"<REDACTED: email>":u.test(v)?"<REDACTED: token>":f}_cleanupInfo(f,v){let C=f;v&&(C=this._anonymizeFilePaths(C));for(let m of this._cleanupPatterns)C=C.replace(m,"");return C=this._removePropertiesWithPossibleUserInfo(C),C}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([ie(1,b.IConfigurationService)],p),e.TelemetryService=p;function t(){const h=(0,M.localize)(0,null,E.default.nameLong),f=E.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=R.isWeb?"":(0,M.localize)(3,null),C=(0,M.localize)(4,null),m=(0,M.localize)(5,null),u=(0,M.localize)(6,null),c=(0,M.localize)(7,null),a=`
|       | ${C} | ${m} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,g=(0,M.localize)(8,null);return`
${h} ${f} ${v}

&nbsp;

${c}
${a}

&nbsp;

${g}
`}P.Registry.as(d.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[k.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(d.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[k.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,M.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,M.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${k.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[98],Z([0,1,45,7,155,23,39,15,3,31,137,50,9]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let t;async function h(v,C,m){return C["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(m)&&!C["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(m)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=I.Promises.withAsyncBody(async(u,c)=>{const a=new D.CancellationTokenSource,g=setTimeout(()=>{a.dispose(!0),c(new Error((0,R.localize)(0,null)))},p);try{u(await f(v,a.token))}catch(r){!(0,b.isCancellationError)(r)&&!a.token.isCancellationRequested?c(new Error((0,R.localize)(1,null,(0,M.toErrorMessage)(r)))):u({})}finally{clearTimeout(g),a.dispose()}})),t)}e.getResolvedShellEnv=h;async function f(v,C){const m=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",m);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",u);const c=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(c+"(.*)"+c),g={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",g);const r=await(0,P.getSystemShell)(d.OS,g);return v.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(C.isCancellationRequested)return s((0,b.canceled)());const o=(0,n.basename)(r);let l,y;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${S} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,y=["-Login","-Command"]):(l=`'${process.execPath}' ${S} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,o==="tcsh"?y=["-ic"]:y=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),l);const L=(0,w.spawn)(r,[...y,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:g});C.onCancellationRequested(()=>(L.kill(),s((0,b.canceled)()))),L.on("error",Y=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(Y)),s(Y)});const T=[];L.stdout.on("data",Y=>T.push(Y));const B=[];L.stderr.on("data",Y=>B.push(Y)),L.on("close",(Y,ee)=>{const te=Buffer.concat(T).toString("utf8");v.trace("getUnixShellEnvironment#raw",te);const Q=Buffer.concat(B).toString("utf8");if(Q.trim()&&v.trace("getUnixShellEnvironment#stderr",Q),Y||ee)return s(new Error((0,R.localize)(2,null,Y,ee)));const q=a.exec(te),G=q?q[1]:"{}";try{const _=JSON.parse(G);m?_.ELECTRON_RUN_AS_NODE=m:delete _.ELECTRON_RUN_AS_NODE,u?_.ELECTRON_NO_ATTACH_CONSOLE=u:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",_),i(_)}catch(_){v.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(_)),s(_)}})})}}),define(J[211],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(J[212],Z([0,1,107,4,2,5,40,211]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var d;(function(f){function v(C){return C&&typeof C=="object"&&typeof C.id=="string"}f.isThemeColor=v})(d=e.ThemeColor||(e.ThemeColor={}));function E(f){return{id:f}}e.themeColorFromId=E;var P;(function(f){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||d.isThemeColor(i.color))}f.isThemeIcon=v;const C=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function m(i){const s=C.exec(i);if(!s)return;let[,o]=s;return{id:o}}f.fromString=m;function u(i){return{id:i}}f.fromId=u;function c(i,s){let o=i.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),s&&(o=`${o}~${s}`),{id:o}}f.modify=c;function a(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}f.getModifier=a;function g(i,s){return i.id===s.id&&i.color?.id===s.color?.id}f.isEqual=g;function r(i,s){return{id:i.id,color:s?E(s):void 0}}f.asThemeIcon=r,f.asClassNameArray=w.CSSIcon.asClassNameArray,f.asClassName=w.CSSIcon.asClassName,f.asCSSSelector=w.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function k(f){switch(f){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const C=this.themingParticipants.indexOf(v);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new I;M.Registry.add(e.Extensions.ThemingContribution,p);function t(f){return p.onColorThemeChange(f)}e.registerThemingParticipant=t;class h extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,C){let m=this.theme.getColor(v);return m&&C&&(m=C(m,this.theme)),m?m.toString():null}}e.Themable=h}),define(J[65],Z([0,1,12,3,5,38]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",b="#1E1E1E",d="#000000",E="theme",P="themeBackground",k="windowSplash";e.IThemeMainService=(0,R.createDecorator)("themeMainService");let I=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(P,null);if(!t){let h;(n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateMainService.getItem(E,"vs-dark").split(" ")[0],t=h==="hc-black"?d:h==="vs"?M:b}return n.isMacintosh&&t.toUpperCase()===b&&(t="#171717"),t}saveWindowSplash(t,h){this.stateMainService.setItems([{key:E,data:h.baseTheme},{key:P,data:h.colorInfo.background},{key:k,data:h}]),typeof t=="number"&&this.updateBackgroundColor(t,h)}updateBackgroundColor(t,h){for(const f of w.BrowserWindow.getAllWindows())if(f.id===t){f.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(k)}};I=ue([ie(0,D.IStateMainService)],I),e.ThemeMainService=I}),define(J[99],Z([0,1,4,3,5,6]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var M;(function(t){t.Http="http",t.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=k;function I(t,h){return h?h!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=I;let p=class{constructor(h){this.logService=h,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],f=Array.from(this._tunnels.values());for(let v of f){const C=Array.from(v.values());for(let m of C){const u=await m.value;u&&h.push(u)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:f}of h.values())await f.then(v=>v?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,f,v,C,m=!1,u=b.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${C}.`),!h)return;f||(f="localhost");const a=this.retainOrCreateTunnel(h,f,v,C,m,u,c);return a?a.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(g);return(g.tunnelRemoteHost!==f||g.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this._tunnels.get(h.tunnelRemoteHost);if(f){const v=f.get(h.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async tryDisposeTunnel(h,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const C=v.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(f),C}}async closeTunnel(h,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const v=this._tunnels.get(h);if(v&&v.has(f)){const C=v.get(f);C.refcount=0,await this.tryDisposeTunnel(h,f,C)}}addTunnelToMap(h,f,v){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(h,f){const v=this._tunnels.get(h);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,f){let v=[h];P(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const C=v.map(m=>this._tunnels.get(m));for(const m of C){const u=m?.get(f);if(u)return u}}canTunnel(h){return!!E(h)}createWithProvider(h,f,v,C,m,u,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${C}.`);const g={elevationRequired:m?I(C===void 0?v:C):!1},r={remoteAddress:{host:f,port:v},localAddressPort:C,privacy:u,public:u!==b.Private,protocol:c},i=h.forwardPort(r,g);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(f,v,i),i}};p=ue([ie(0,D.ILogService)],p),e.AbstractTunnelService=p}),define(J[41],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(n=e.StateType||(e.StateType={}));var R;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,M)=>({type:"idle",updateType:D,error:M}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(J[213],Z([0,1,3,156,55,40]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[214],Z([0,1,4,41]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(b){this.service=b}listen(b,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(b,d,E){switch(d){case"checkForUpdates":return this.service.checkForUpdates(E);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=R;class D{constructor(b){this.channel=b,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(J[100],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(J[215],Z([0,1,8]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(b){this.handler=b}listen(b,d){throw new Error(`Event not found: ${d}`)}call(b,d,E){switch(d){case"handleURL":return this.handler.handleURL(w.URI.revive(E[0]),E[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=n;class R{constructor(b){this.channel=b}handleURL(b,d){return this.channel.call("handleURL",[b.toJSON(),d])}}e.URLHandlerChannelClient=R;class D{constructor(b){this.next=b}async routeCall(b,d,E,P){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(E){const k=w.URI.revive(E);if(k&&k.query){const I=/\bwindowId=(\d+)/.exec(k.query);if(I){const p=I[1],t=new RegExp(`window:${p}`),h=b.connections.find(f=>t.test(f.ctx));if(h)return h}}}return this.next.routeCall(b,d,E,P)}routeEvent(b,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=D}),define(J[216],Z([0,1,9,2,8,21]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(E,P){const k=[...this.handlers.values()];return(0,w.first)(k.map(I=>()=>I.handleURL(E,P)),void 0,!1).then(I=>I||!1)}registerHandler(E){return this.handlers.add(E),(0,n.toDisposable)(()=>this.handlers.delete(E))}}e.AbstractURLService=M;let b=class extends M{constructor(E){super();this.productService=E}create(E){let{authority:P,path:k,query:I,fragment:p}=E||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return P&&k&&k.indexOf("/")!==0&&(k=`/${k}`),R.URI.from({scheme:this.productService.urlProtocol,authority:P,path:k,query:I,fragment:p})}};b=ue([ie(0,D.IProductService)],b),e.NativeURLService=b}),define(J[217],Z([0,1,12,9,4,2,3,8]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(P){try{return b.URI.parse(P)}catch{return null}}class E{constructor(k,I,p,t,h){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=k,M.isWindows){const C=t.isBuilt?[]:[`"${t.appRoot}"`];C.push("--open-url","--"),w.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,C)}const f=R.Event.map(R.Event.fromNodeEventEmitter(w.app,"open-url",(C,m)=>({event:C,url:m})),({event:C,url:m})=>(C.preventDefault(),m));this.disposables.add(f(C=>{const m=d(C);!m||this.urlService.open(m,{originalUrl:C})})),p.getWindows().filter(C=>C.isReady).length>0?this.flush():R.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||k.push(I);k.length!==0&&(this.uris=k,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=E}),define(J[218],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(J[219],Z([0,1,12,2,10,8]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends n.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(R.Schemas.vscodeWebview,d)}handleWebviewRequest(d,E){try{const P=D.URI.parse(d.url),k=M.validWebviewFilePaths.get(P.path);if(typeof k=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${k}`,p=R.FileAccess.asFileUri(I,H);return E(decodeURIComponent(p.fsPath))}else return E({error:-10})}catch{}return E({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[66],Z([0,1,3]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(E){return!!E.workspaceUri}e.isWorkspaceToOpen=n;function R(E){return!!E.folderUri}e.isFolderToOpen=R;function D(E){return!!E.fileUri}e.isFileToOpen=D;function M(E){const P=b(E),k=E.getValue("window.menuBarVisibility");return k==="default"||P==="native"&&k==="compact"||w.isMacintosh&&w.isNative?"classic":k}e.getMenuBarVisibility=M;function b(E){if(w.isWeb)return"custom";const P=E.getValue("window");if(P){if(w.isMacintosh&&P.nativeTabs===!0||w.isMacintosh&&P.nativeFullScreen===!1)return"native";const p=E.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=P.titleBarStyle;if(t==="native"||t==="custom")return t}return w.isLinux?"native":"custom"}e.getTitleBarStyle=b;function d(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=d}),define(J[101],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var n;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(n=e.UnloadReason||(e.UnloadReason={}));const R=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=R;var D;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={}));var M;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.CRASHED=2]="CRASHED",b[b.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(J[34],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var n;(function(R){R[R.CLI=0]="CLI",R[R.DOCK=1]="DOCK",R[R.MENU=2]="MENU",R[R.DIALOG=3]="DIALOG",R[R.DESKTOP=4]="DESKTOP",R[R.API=5]="API"})(n=e.OpenContext||(e.OpenContext={}))}),define(J[220],Z([0,1,12,23,4,69,2,31,74,92,6,21,34]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends M.Disposable{constructor(f,v,C,m,u){super();this.logService=f,this.windowsMainService=v,this.credentialsService=C,this.encryptionMainService=m,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const f=R.Event.fromNodeEventEmitter(w.app,"login",(v,C,m,u,c)=>({event:v,webContents:C,req:m,authInfo:u,callback:c}));this._register(f(this.onLogin,this))}async onLogin({event:f,authInfo:v,req:C,callback:m}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&C.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}f.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}m(u?.username,u?.password)}async resolveProxyCredentials(f){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(f);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(f){this.logService.trace("auth#doResolveProxyCredentials - enter",f);const v=String((0,D.hash)({scheme:f.scheme,host:f.host,port:f.port}));let C,m;try{const g=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(g){const r=JSON.parse(await this.encryptionMainService.decrypt(g));C=r.username,m=r.password}}catch(g){this.logService.error(g)}if(this.state!==p.StoredCredentialsUsed&&typeof C=="string"&&typeof m=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:C,password:m};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:f,username:this.sessionCredentials?.username??C,password:this.sessionCredentials?.password??m,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=p.LoginDialogShown;const a=await new Promise(g=>{const r=async(i,s,o)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",r),o){const l={username:o.username,password:o.password};try{if(o.remember){const y=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,y)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(y){this.logService.error(y)}g({username:l.username,password:l.password})}else g(void 0)};u.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=a,a}};t=ue([ie(0,P.ILogService),ie(1,I.IWindowsMainService),ie(2,d.ICredentialsMainService),ie(3,E.IEncryptionMainService),ie(4,k.IProductService)],t),e.ProxyAuthHandler=t}),define(J[221],Z([0,1,12,4,2,219,34]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends R.Disposable{constructor(E){super();this.windowsMainService=E,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(E,P){let k;if(typeof E.windowId=="number"){const{windowId:I}=E,p=this.windowsMainService.getWindowById(I);if(!p?.win)throw new Error(`Invalid windowId: ${I}`);k=p.win.webContents}else{const{webContentsId:I}=E;if(k=w.webContents.fromId(I),!k)throw new Error(`Invalid webContentsId: ${I}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(P)}async findInFrame(E,P,k,I){const p=this.getFrameByName(E,P),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(k,{findNext:I.findNext,forward:I.forward});const h=(f,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),p.removeListener("found-in-frame",h))};p.on("found-in-frame",h)}}async stopFindInFrame(E,P,k){const p=this.getFrameByName(E,P);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(E,P){const k=this.windowsMainService.getWindowById(E.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${E}`);const I=k.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===P);if(!I)throw new Error(`Unknown frame: ${P}`);return I}};b=ue([ie(0,M.IWindowsMainService)],b),e.WebviewMainService=b}),define(J[222],Z([0,1,9,4,2]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends R.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:d,getActiveWindowId:E}){super();this.disposables=this._register(new R.DisposableStore),n.Event.latch(n.Event.any(b,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>E()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(J[25],Z([0,1,159,7,35,17,8,5,10]),function(H,e,w,n,R,D,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function E(r){const i=r;return typeof i?.id=="string"&&M.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=E;function P(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=P;function k(r){const i=r;return typeof i?.id=="string"&&M.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=k;function I(r){const i=r;if(i?.uri)return{id:i.id,uri:M.URI.revive(i.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:M.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=I;var p;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function t(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=t;function h(r){const i=r;return!!(i&&typeof i=="object"&&M.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class f{constructor(i,s,o,l,y){this._id=i,this._transient=o,this._configuration=l,this._ignorePathCasing=y,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class v{constructor(i,s){this.raw=s,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,D.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function C(r){return new v({uri:r,index:0,name:(0,D.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(r,i){return D.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(r){let i;return M.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=c;function a(r,i){return!u(r,i)&&!c(r)}e.isSavedWorkspace=a;function g(r){return(typeof r=="string"?(0,n.extname)(r):(0,D.extname)(r))===m}e.hasWorkspaceFileExtension=g}),define(J[47],Z([0,1,12,9,69,32,2,70,7,3,14,24,141,5,6,38,25]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let v=class bt{constructor(m,u){this.stateMainService=m,this.logService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(m,u){return this.doPick({...m,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},u)}pickFolder(m,u){return this.doPick({...m,pickFolders:!0,title:(0,I.localize)(1,null)},u)}pickFile(m,u){return this.doPick({...m,pickFiles:!0,title:(0,I.localize)(2,null)},u)}pickWorkspace(m,u){const c=(0,I.localize)(3,null),a=(0,D.mnemonicButtonLabel)((0,I.localize)(4,null)),g=f.WORKSPACE_FILTER;return this.doPick({...m,pickFiles:!0,title:c,filters:g,buttonLabel:a},u)}async doPick(m,u){const c={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters};c.defaultPath=m.defaultPath||this.stateMainService.getItem(bt.workingDirPickerStorageKey),(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(c.properties=void 0,m.pickFiles&&m.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&c.properties.push("treatPackageAsDirectory");const a=u||w.BrowserWindow.getFocusedWindow(),g=await this.showOpenDialog(c,(0,P.withNullAsUndefined)(a));if(g&&g.filePaths&&g.filePaths.length>0)return this.stateMainService.setItem(bt.workingDirPickerStorageKey,(0,d.dirname)(g.filePaths[0])),g.filePaths}getWindowDialogQueue(m){if(m){let u=this.windowDialogQueues.get(m.id);return u||(u=new n.Queue,this.windowDialogQueues.set(m.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(m,u){return this.getWindowDialogQueue(u).queue(async()=>u?w.dialog.showMessageBox(u,m):w.dialog.showMessageBox(m))}async showSaveDialog(m,u){const c=this.acquireFileDialogLock(m,u);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await w.dialog.showSaveDialog(u,m):a=await w.dialog.showSaveDialog(m),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,M.dispose)(c)}}normalizePath(m){return m&&E.isMacintosh&&(m=(0,b.normalizeNFC)(m)),m}normalizePaths(m){return m.map(u=>this.normalizePath(u))}async showOpenDialog(m,u){m.defaultPath&&(await k.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const c=this.acquireFileDialogLock(m,u);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await w.dialog.showOpenDialog(u,m):a=await w.dialog.showOpenDialog(m),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,M.dispose)(c)}}acquireFileDialogLock(m,u){if(!u)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",m);let c=this.windowFileDialogLocks.get(u.id);c||(c=new Set,this.windowFileDialogLocks.set(u.id,c));const a=(0,R.hash)(m);if(!c.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",m),c.add(a),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",m),c?.delete(a),c?.size===0&&this.windowFileDialogLocks.delete(u.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([ie(0,h.IStateMainService),ie(1,t.ILogService)],v),e.DialogMainService=v}),define(J[223],Z([0,1,4,2,25]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends n.Disposable{constructor(b,d){super();this.logService=b,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(b,d)=>(b?b.push(d):b=[d],b),D.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(b))}))}serializeGlobalStorageEvents(b){const d=new Map,E=new Set;return b.forEach(P=>{const k=this.storageMainService.globalStorage.get(P.key);typeof k=="string"?d.set(P.key,k):E.add(P.key)}),{changed:Array.from(d.entries()),deleted:Array.from(E.values())}}listen(b,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(b,d,E){const P=(0,R.reviveIdentifier)(E.workspace),k=await this.withStorageInitialized(P);switch(d){case"getItems":return Array.from(k.items.entries());case"updateItems":{const I=E;if(I.insert)for(const[p,t]of I.insert)k.set(p,t);I.delete&&I.delete.forEach(p=>k.delete(p));break}case"close":{if(P)return k.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(b){const d=b?this.storageMainService.workspaceStorage(b):this.storageMainService.globalStorage;try{await d.init()}catch(E){this.logService.error(`StorageIPC#init: Unable to init ${b?"workspace":"global"} storage due to ${E}`)}return d}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[224],Z([0,1,9,4,2,7,24,90,130,6,97,33,25]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends R.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new b.Storage(new b.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new w.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=b.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===b.StorageState.None)try{const v=await this.doCreate();this._storage.dispose(),this._storage=v,this._register(v.onDidChangeStorage(m=>this._onDidChangeStorage.fire({key:m}))),await this.doInit(v);const C=v.getBoolean(P.IS_NEW_KEY);C===void 0?v.set(P.IS_NEW_KEY,!0):C&&v.set(P.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.state=b.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this._storage.items}get(v,C){return this._storage.get(v,C)}set(v,C){return this._storage.set(v,C)}delete(v){return this._storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,this.state=b.StorageState.Closed,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends p{constructor(v,C,m){super(C);this.options=v,this.environmentService=m}async doCreate(){let v;return this.options.useInMemoryStorage?v=d.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,D.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new b.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(k.firstSessionDateStorageKey,void 0)===void 0&&v.set(k.firstSessionDateStorageKey,new Date().toUTCString());const m=v.get(k.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();v.set(k.lastSessionDateStorageKey,typeof m=="undefined"?null:m),v.set(k.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class h extends p{constructor(v,C,m,u){super(m);this.workspace=v,this.options=C,this.environmentService=u}async doCreate(){const{storageFilePath:v,wasCreated:C}=await this.prepareWorkspaceStorageFolder();return new b.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:C?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),C=(0,D.join)(v,h.WORKSPACE_STORAGE_NAME);return await M.Promises.exists(v)?{storageFilePath:C,wasCreated:!1}:(await M.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:C,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let C;if((0,I.isSingleFolderWorkspaceIdentifier)(this.workspace)?C={folder:this.workspace.uri.toString()}:(0,I.isWorkspaceIdentifier)(this.workspace)&&(C={workspace:this.workspace.configPath.toString()}),C)try{const m=(0,D.join)(v,h.WORKSPACE_META_NAME);await M.Promises.exists(m)||await M.Promises.writeFile(m,JSON.stringify(C,void 0,2))}catch(m){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${m}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json"}),define(J[102],Z([0,1,17,8,25]),function(H,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(d,E,P){for(const I of d){const p=I.openedWorkspace;if((0,R.isWorkspaceIdentifier)(p)){const t=P(p);if(t){if(t.folders.some(h=>w.extUriBiasedIgnorePathCase.isEqualOrParent(E,h.uri)))return I}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(E,p.configPath))return I}}const k=d.filter(I=>(0,R.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(E,I.openedWorkspace.uri));if(k.length)return k.sort((I,p)=>-(I.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function M(d,E){for(const P of d)if((0,R.isWorkspaceIdentifier)(P.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.configPath,E)||(0,R.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.uri,E))return P}e.findWindowOnWorkspaceOrFolder=M;function b(d,E){const P=k=>E.some(I=>w.extUriBiasedIgnorePathCase.isEqual(n.URI.file(I),n.URI.file(k)));for(const k of d)if(k.config?.extensionDevelopmentPath?.some(I=>P(I)))return k}e.findWindowOnExtensionDevelopmentPath=b}),define(J[225],Z([0,1,12,2,3,17,8,19,18,6,38,34,101,25]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let t=class Et extends n.Disposable{constructor(u,c,a,g,r){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=a,this.logService=g,this.configurationService=r,this._state=h(this.stateMainService.getItem(Et.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let g=this.windowsMainService.getLastActiveWindow();(!g||g.isExtensionDevelopmentHost)&&(g=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),g&&(u.lastActiveWindow=this.toWindowState(g))}const c=this.windowsMainService.getWindows().find(g=>g.isExtensionDevelopmentHost&&!g.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(g=>!g.isExtensionDevelopmentHost).map(g=>this.toWindowState(g)));const a=v(u);this.stateMainService.setItem(Et.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(a=>{const g=(0,p.isWorkspaceIdentifier)(u.openedWorkspace)&&a.workspace?.id===u.openedWorkspace.id,r=(0,p.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&a.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(a.folderUri,u.openedWorkspace.uri);(g||r)&&(a.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,p.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,p.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),a=this.configurationService.getValue("window");let g;return c.hasDefaultState?g=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):(g=!!(this.lifecycleMainService.wasRestarted||a?.restoreFullscreen),g&&R.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(g=!1)),c.mode===3&&!g&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=u.workspace;if((0,p.isWorkspaceIdentifier)(o)){const y=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===o.id).map(S=>S.uiState);if(y.length)return y[0]}if((0,p.isSingleFolderWorkspaceIdentifier)(o)){const y=this.state.openedWindows.filter(S=>S.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(S.folderUri,o.uri)).map(S=>S.uiState);if(y.length)return y[0]}else if(u.backupPath){const y=this.state.openedWindows.filter(S=>S.backupPath===u.backupPath).map(S=>S.uiState);if(y.length)return y[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let a;const g=w.screen.getAllDisplays();if(g.length===1)a=g[0];else{if(R.isMacintosh){const o=w.screen.getCursorScreenPoint();a=w.screen.getDisplayNearestPoint(o)}!a&&c&&(a=w.screen.getDisplayMatching(c.getBounds())),a||(a=w.screen.getPrimaryDisplay()||g[0])}let r=(0,I.defaultWindowState)();r.x=Math.round(a.bounds.x+a.bounds.width/2-r.width/2),r.y=Math.round(a.bounds.y+a.bounds.height/2-r.height/2);const i=this.configurationService.getValue("window");let s=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")r.mode=0,s=!1;else if(i.newWindowDimensions==="fullscreen")r.mode=3,s=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&c){const o=c.serializeWindowState();o.mode===3?r.mode=3:r=o,s=r.mode!==3&&i.newWindowDimensions==="offset"}}return s&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;c.some(a=>a.x===u.x||a.y===u.y);)u.x+=30,u.y+=30;return u}};t.windowsStateStorageKey="windowsState",t=ue([ie(0,k.IWindowsMainService),ie(1,P.IStateMainService),ie(2,d.ILifecycleMainService),ie(3,E.ILogService),ie(4,b.IConfigurationService)],t),e.WindowsStateHandler=t;function h(m){const u={openedWindows:[]},c=m||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=f(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=f(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(a=>f(a))),u}e.restoreWindowsState=h;function f(m){const u={uiState:m.uiState};return m.backupPath&&(u.backupPath=m.backupPath),m.remoteAuthority&&(u.remoteAuthority=m.remoteAuthority),m.folder&&(u.folderUri=M.URI.parse(m.folder)),m.workspaceIdentifier&&(u.workspace={id:m.workspaceIdentifier.id,configPath:M.URI.parse(m.workspaceIdentifier.configURIPath)}),u}function v(m){return{lastActiveWindow:m.lastActiveWindow&&C(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&C(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(u=>C(u))}}e.getWindowsStateStoreData=v;function C(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(J[80],Z([0,1,28,44,109,32,10,7,3,17,8,5,78,25]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function t(S){return S.hasOwnProperty("workspace")}e.isRecentWorkspace=t;function h(S){return S.hasOwnProperty("folderUri")}e.isRecentFolder=h;function f(S){return S.hasOwnProperty("fileUri")}e.isRecentFile=f;function v(S){return C(S)||m(S)}e.isStoredWorkspaceFolder=v;function C(S){const L=S;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function m(S){const L=S;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function u(S,L,T,B,Y=!d.isWindows,ee){if(S.scheme!==B.scheme)return{name:T,uri:S.toString(!0)};let te=L?void 0:ee.relativePath(B,S);if(te!==void 0)te.length===0?te=".":d.isWindows&&S.scheme===M.Schemas.file&&!Y&&(te=te.replace(/\//g,"\\"));else if(S.scheme===M.Schemas.file)te=S.fsPath,d.isWindows&&(te=(0,D.normalizeDriveLetter)(te),Y&&(te=(0,w.toSlashes)(te)));else{if(!ee.isEqualAuthority(S.authority,B.authority))return{name:T,uri:S.toString(!0)};te=S.path}return{name:T,path:te}}e.getStoredWorkspaceFolder=u;function c(S,L,T){let B=[],Y=new Set;const ee=T.dirname(L);for(let te of S){let Q;if(C(te))te.path&&(Q=T.resolvePath(ee,te.path));else if(m(te))try{Q=P.URI.parse(te.uri),Q.path[0]!=="/"&&(Q=Q.with({path:"/"+Q.path}))}catch(q){console.warn(q)}if(Q){let q=T.getComparisonKey(Q);if(!Y.has(q)){Y.add(q);const G=te.name||T.basenameOrAuthority(Q);B.push(new p.WorkspaceFolder({uri:Q,name:G,index:B.length},te))}}}return B}e.toWorkspaceFolders=c;function a(S,L,T,B,Y){let ee=g(L,S);const te=Y.dirname(L),Q=Y.dirname(B),q=[],G=r(ee.folders);for(const V of ee.folders){const X=C(V)?Y.resolvePath(te,V.path):P.URI.parse(V.uri);let z;T?z=!1:z=!C(V)||(0,b.isAbsolute)(V.path),q.push(u(X,z,V.name,Q,G,Y))}const _={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},x=R.setProperty(S,["folders"],q,_);let $=R.applyEdits(S,x);return(0,E.isEqualAuthority)(ee.remoteAuthority,(0,I.getRemoteAuthority)(B))&&($=R.applyEdits($,R.removeProperty($,["remoteAuthority"],_))),$}e.rewriteWorkspaceFileForNewLocation=a;function g(S,L){let T=n.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(B=>v(B));else throw new Error(`${S} looks like an invalid workspace file.`);return T}function r(S){return d.isWindows?S.some(L=>C(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=r;function i(S){return S.workspace&&typeof S.workspace=="object"&&typeof S.workspace.id=="string"&&typeof S.workspace.configPath=="string"}function s(S){return typeof S.folderUri=="string"}function o(S){return typeof S.fileUri=="string"}function l(S,L){const T={workspaces:[],files:[]};if(S){const B=function(ee,te){for(let Q=0;Q<ee.length;Q++)try{te(ee[Q],Q)}catch(q){L.warn(`Error restoring recent entry ${JSON.stringify(ee[Q])}: ${q.toString()}. Skip entry.`)}},Y=S;if(Array.isArray(Y.entries))B(Y.entries,ee=>{const te=ee.label,Q=ee.remoteAuthority;i(ee)?T.workspaces.push({label:te,remoteAuthority:Q,workspace:{id:ee.workspace.id,configPath:P.URI.parse(ee.workspace.configPath)}}):s(ee)?T.workspaces.push({label:te,remoteAuthority:Q,folderUri:P.URI.parse(ee.folderUri)}):o(ee)&&T.files.push({label:te,remoteAuthority:Q,fileUri:P.URI.parse(ee.fileUri)})});else{const ee=S;Array.isArray(ee.workspaces3)&&B(ee.workspaces3,(te,Q)=>{const q=Array.isArray(ee.workspaceLabels)&&ee.workspaceLabels[Q]||void 0;typeof te=="object"&&typeof te.id=="string"&&typeof te.configURIPath=="string"?T.workspaces.push({label:q,workspace:{id:te.id,configPath:P.URI.parse(te.configURIPath)}}):typeof te=="string"&&T.workspaces.push({label:q,folderUri:P.URI.parse(te)})}),Array.isArray(ee.files2)&&B(ee.files2,(te,Q)=>{const q=Array.isArray(ee.fileLabels)&&ee.fileLabels[Q]||void 0;typeof te=="string"&&T.files.push({label:q,fileUri:P.URI.parse(te)})})}}return T}e.restoreRecentlyOpened=l;function y(S){const L={entries:[]};for(const T of S.workspaces)h(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of S.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=y}),define(J[103],Z([0,1,60,29,10,3,17]),function(H,e,w,n,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(E){function P(){let k=E.scheme===R.Schemas.file?(0,M.originalFSPath)(E):E.toString();return D.isLinux||(k=k.toLowerCase()),(0,w.createHash)("md5").update(k).digest("hex")}return{id:P(),configPath:E}}e.getWorkspaceIdentifier=b;function d(E,P){function k(){if(E.scheme!==R.Schemas.file)return(0,w.createHash)("md5").update(E.toString()).digest("hex");if(!P)try{P=(0,n.statSync)(E.fsPath)}catch{return}let p;return D.isLinux?p=P.ino:D.isMacintosh?p=P.birthtime.getTime():D.isWindows&&(typeof P.birthtimeMs=="number"?p=Math.floor(P.birthtimeMs):p=P.birthtime.getTime()),(0,w.createHash)("md5").update(E.fsPath).update(p?String(p):"").digest("hex")}const I=k();if(typeof I=="string")return{id:I,uri:E}}e.getSingleFolderWorkspaceIdentifier=d}),define(J[226],Z([0,1,15,4,10,6,253,118,18,85]),function(H,e,w,n,R,D,M,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class P{constructor(t,h){this._worker=new M.Worker(R.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",H).fsPath),this._worker.on("message",t),this._worker.on("error",h),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,h){this._worker.postMessage(t,h)}dispose(){this._worker.terminate()}}let k=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};k=ue([ie(0,D.ILogService)],k);let I=class{constructor(t,h){this._logService=t,this._shutdown=!1,this._proxy=null;const f={create:(v,C,m)=>{const u=new P(C,m);return u.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),u.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),u.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),u.postMessage(v,[]),u}};this._worker=new b.SimpleWorkerClient(f,"vs/platform/extensions/node/extensionHostStarterWorker",new k(this._logService)),this._initialize(),h.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return t.createExtensionHost()}async start(t,h){const f=E.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();const C=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),m=await v.start(t,h),u=f.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${u} ms.`),clearTimeout(C),m}async enableInspectPort(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return h.enableInspectPort(t)}async kill(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return h.kill(t)}};I=ue([ie(0,D.ILogService),ie(1,d.ILifecycleMainService)],I),e.WorkerMainProcessExtensionHostStarter=I}),define(J[57],Z([0,1,60,61,26,16,15,4,2,7,3,31,37,88,227]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(L,T=""){this.debugLabel=T,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=B=>{if(this.traceSocketEvent("error",{code:B?.code,message:B?.message}),B){if(B.code==="EPIPE")return;(0,M.onUnexpectedError)(B)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,T){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const T=B=>{this.traceSocketEvent("read",B),L(D.VSBuffer.wrap(B))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(L){const T=B=>{this.traceSocketEvent("close",{hadError:B}),L({type:0,hadError:B,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(L){const T=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,M.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,M.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const B=()=>{this.socket.off("close",B),this.socket.off("end",B),this.socket.off("error",B),this.socket.off("timeout",B),this.socket.off("drain",B),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",B),this.socket.on("end",B),this.socket.on("error",B),this.socket.on("timeout",B),this.socket.on("drain",B)})}}e.NodeSocket=h;var f;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var v;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(v||(v={}));class C extends d.Disposable{constructor(L,T,B,Y){super();this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:B?.byteLength||0,recordInflateBytes:Y}),this._flowManager=this._register(new m(this,T,B,Y,this._onData,(ee,te)=>this._write(ee,te))),this._register(this._flowManager.onError(ee=>{console.error(ee),(0,M.onUnexpectedError)(ee),this._onClose.fire({type:0,hadError:!0,error:ee})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(ee=>this._acceptChunk(ee))),this._register(this.socket.onClose(ee=>this._onClose.fire(ee)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,T){this.socket.traceSocketEvent(L,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let B=2;L.byteLength<126?B+=0:L.byteLength<2**16?B+=2:B+=8;const Y=D.VSBuffer.alloc(B);if(T?Y.writeUInt8(194,0):Y.writeUInt8(130,0),L.byteLength<126)Y.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Y.writeUInt8(126,1);let ee=1;Y.writeUInt8(L.byteLength>>>8&255,++ee),Y.writeUInt8(L.byteLength>>>0&255,++ee)}else{Y.writeUInt8(127,1);let ee=1;Y.writeUInt8(0,++ee),Y.writeUInt8(0,++ee),Y.writeUInt8(0,++ee),Y.writeUInt8(0,++ee),Y.writeUInt8(L.byteLength>>>24&255,++ee),Y.writeUInt8(L.byteLength>>>16&255,++ee),Y.writeUInt8(L.byteLength>>>8&255,++ee),Y.writeUInt8(L.byteLength>>>0&255,++ee)}this.socket.write(D.VSBuffer.concat([Y,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),B=T.readUInt8(0),Y=(B&128)>>>7,ee=(B&64)>>>6,te=T.readUInt8(1),Q=(te&128)>>>7,q=te&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=Y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ee)),this._state.firstFrameOfMessage=Boolean(Y),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),B=T.readUInt8(1),Y=(B&128)>>>7;let ee=B&127,te=1;ee===126?ee=T.readUInt8(++te)*2**8+T.readUInt8(++te):ee===127&&(ee=T.readUInt8(++te)*0+T.readUInt8(++te)*0+T.readUInt8(++te)*0+T.readUInt8(++te)*0+T.readUInt8(++te)*2**24+T.readUInt8(++te)*2**16+T.readUInt8(++te)*2**8+T.readUInt8(++te));let Q=0;Y&&(Q=T.readUInt8(++te)*2**24+T.readUInt8(++te)*2**16+T.readUInt8(++te)*2**8+T.readUInt8(++te)),this._state.state=3,this._state.readLen=ee,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),a(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class m extends d.Disposable{constructor(L,T,B,Y,ee,te){super();this._tracer=L,this._onData=ee,this._writeFn=te,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new u(this._tracer,Y,B,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(T,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,T){return new Promise((B,Y)=>{L.write(T),L.flush(ee=>B(ee))})}acceptFrame(L,T,B){this._readQueue.push({data:L,isCompressed:T,isLastFrameOfMessage:B}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,T,B){return new Promise((Y,ee)=>{L.write(T),B&&L.write(D.VSBuffer.fromByteArray([0,0,255,255])),L.flush(te=>Y(te))})}}class u extends d.Disposable{constructor(L,T,B,Y){super();this._tracer=L,this._recordInflateBytes=T,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Y),this._zlibInflate.on("error",ee=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this._onError.fire(ee)}),this._zlibInflate.on("data",ee=>{this._tracer.traceSocketEvent("zlibInflateData",ee),this._pendingInflateData.push(D.VSBuffer.wrap(ee))}),B&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",B.buffer),this._zlibInflate.write(B.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(T)})}}class c extends d.Disposable{constructor(L,T){super();this._tracer=L,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",B=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibDeflate.on("data",B=>{this._tracer.traceSocketEvent("zlibDeflateData",B),this._pendingDeflateData.push(D.VSBuffer.wrap(B))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),L(T)})}}function a(S,L){if(L===0)return;let T=S.byteLength>>>2;for(let q=0;q<T;q++){const G=S.readUInt32BE(q*4);S.writeUInt32BE(G^L,q*4)}let B=T*4,Y=S.byteLength-B;const ee=L>>>24&255,te=L>>>16&255,Q=L>>>8&255;Y>=1&&S.writeUInt8(S.readUInt8(B)^ee,B),Y>=2&&S.writeUInt8(S.readUInt8(B+1)^te,B+1),Y>=3&&S.writeUInt8(S.readUInt8(B+2)^Q,B+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const g={[2]:107,[1]:103};function r(){const S=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${S}.sock`):L=(0,E.join)((0,R.tmpdir)(),`vscode-ipc-${S}.sock`),s(L),L}e.createRandomIPCHandle=r;function i(S,L,T){const B=(0,w.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${T}-${L}-sock`;let Y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Y=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${B.substr(0,8)}-${T}-${L}.sock`):Y=(0,E.join)(S,`${T}-${L}.sock`),s(Y),Y}e.createStaticIPCHandle=i;function s(S){const L=g[P.platform];typeof L=="number"&&S.length>=L&&console.warn(`WARNING: IPC handle "${S}" is longer than ${L} chars, try a shorter --user-data-dir`)}class o extends I.IPCServer{constructor(L){super(o.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const T=b.Event.fromNodeEventEmitter(L,"connection");return b.Event.map(T,B=>({protocol:new p.Protocol(new h(B,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(B,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(S){return new Promise((L,T)=>{const B=(0,n.createServer)();B.on("error",T),B.listen(S,()=>{B.removeListener("error",T),L(new o(B))})})}e.serve=l;function y(S,L){return new Promise((T,B)=>{const Y=(0,n.createConnection)(S,()=>{Y.removeListener("error",B),T(p.Client.fromSocket(new h(Y,`ipc-client${L}`),L))});Y.once("error",B)})}e.connect=y}),define(J[228],Z([0,1,57]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(d){this.driver=d}listen(d,E){throw new Error("No event found")}call(d,E,P){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(P);case"startTracing":return this.driver.startTracing(P[0],P[1]);case"stopTracing":return this.driver.stopTracing(P[0],P[1],P[2]);case"reloadWindow":return this.driver.reloadWindow(P);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(P[0],P[1]);case"click":return this.driver.click(P[0],P[1],P[2],P[3]);case"doubleClick":return this.driver.doubleClick(P[0],P[1]);case"setValue":return this.driver.setValue(P[0],P[1],P[2]);case"getTitle":return this.driver.getTitle(P[0]);case"isActiveElement":return this.driver.isActiveElement(P[0],P[1]);case"getElements":return this.driver.getElements(P[0],P[1],P[2]);case"getElementXY":return this.driver.getElementXY(P[0],P[1],P[2]);case"typeInEditor":return this.driver.typeInEditor(P[0],P[1],P[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(P[0],P[1]);case"writeInTerminal":return this.driver.writeInTerminal(P[0],P[1],P[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(P);case"getLocalizedStrings":return this.driver.getLocalizedStrings(P)}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=n;class R{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}startTracing(d,E){return this.channel.call("startTracing",[d,E])}stopTracing(d,E,P){return this.channel.call("stopTracing",[d,E,P])}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,E){return this.channel.call("dispatchKeybinding",[d,E])}click(d,E,P,k){return this.channel.call("click",[d,E,P,k])}doubleClick(d,E){return this.channel.call("doubleClick",[d,E])}setValue(d,E,P){return this.channel.call("setValue",[d,E,P])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,E){return this.channel.call("isActiveElement",[d,E])}getElements(d,E,P){return this.channel.call("getElements",[d,E,P])}getElementXY(d,E,P,k){return this.channel.call("getElementXY",[d,E,P,k])}typeInEditor(d,E,P){return this.channel.call("typeInEditor",[d,E,P])}getTerminalBuffer(d,E){return this.channel.call("getTerminalBuffer",[d,E])}writeInTerminal(d,E,P){return this.channel.call("writeInTerminal",[d,E,P])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=R;class D{constructor(d){this.registry=d}listen(d,E){throw new Error(`Event not found: ${E}`)}call(d,E,P){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(P);case"reloadWindowDriver":return this.registry.reloadWindowDriver(P)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=D;async function M(b){const d=await(0,w.connect)(b,"driverClient"),E=d.getChannel("driver"),P=new R(E);return{client:d,driver:P}}e.connect=M}),define(J[22],Z([0,1,46,7,57,52,170,5]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(D.IEnvironmentService);class d extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,R.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([w.memoize],d.prototype,"cachedLanguagesPath",null),ue([w.memoize],d.prototype,"backupHome",null),ue([w.memoize],d.prototype,"backupWorkspacesPath",null),ue([w.memoize],d.prototype,"mainIPCHandle",null),ue([w.memoize],d.prototype,"mainLockfile",null),ue([w.memoize],d.prototype,"sandbox",null),ue([w.memoize],d.prototype,"driverVerbose",null),ue([w.memoize],d.prototype,"disableUpdates",null),ue([w.memoize],d.prototype,"disableKeytar",null),ue([w.memoize],d.prototype,"codeCachePath",null),ue([w.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(J[229],Z([0,1,60,29,28,10,7,3,17,8,24,163,19,22,20,6,162,25]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let C=class{constructor(u,c,a){this.configurationService=c,this.logService=a,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(g,r)=>(0,R.isEqual)(g,r,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await P.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(g=>({workspace:{id:g.id,configPath:E.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let a=[];try{Array.isArray(u.folderWorkspaceInfos)?a=u.folderWorkspaceInfos.map(g=>({folderUri:E.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(a=u.folderURIWorkspaces.map(g=>({folderUri:E.URI.parse(g),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(a),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(g=>u.workspace.id===g.workspace.id)||(this.workspaces.push(u),this.saveSync());const a=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(a,c),a}moveBackupFolderSync(u,c){if(n.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),n.existsSync(c))try{n.renameSync(c,u)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,a=this.workspaces.findIndex(g=>g.workspace.id===c);a!==-1&&(this.workspaces.splice(a,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(a=>this.backupUriComparer.isEqual(u,a.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const a=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(g=>!!g.backupFolder&&this.backupPathComparer.isEqual(g.backupFolder,a))||(this.emptyWindows.push({backupFolder:a,remoteAuthority:c}),this.saveSync()),this.getBackupPath(a)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,M.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,a=[];for(let g of u){const r=g.workspace;if(!(0,v.isWorkspaceIdentifier)(r))return[];if(!c.has(r.id)){c.add(r.id);const i=this.getBackupPath(r.id);await this.doHasBackups(i)?r.configPath.scheme!==D.Schemas.file||await P.Promises.exists(r.configPath.fsPath)?a.push(g):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],a=new Set;for(let g of u){const r=g.folderUri,i=this.backupUriComparer.getComparisonKey(r);if(!a.has(i)){a.add(i);const s=this.getBackupPath(this.getFolderHash(g));await this.doHasBackups(s)?r.scheme!==D.Schemas.file||await P.Promises.exists(r.fsPath)?c.push(g):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],a=new Set;for(let g of u){const r=g.backupFolder;if(typeof r!="string")return[];if(!a.has(r)){a.add(r);const i=this.getBackupPath(r);await this.doHasBackups(i)?c.push(g):await this.deleteStaleBackup(i)}}return c}async deleteStaleBackup(u){try{await P.Promises.exists(u)&&await P.Promises.rm(u,P.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(g=>!!g.backupFolder&&this.backupPathComparer.isEqual(g.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{await P.Promises.rename(u,a)}catch(g){return this.logService.error(`Backup: Could not rename backup folder: ${g.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(g=>!!g.backupFolder&&this.backupPathComparer.isEqual(g.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{n.renameSync(u,a)}catch(g){return this.logService.error(`Backup: Could not rename backup folder: ${g.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,k.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,f.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await P.Promises.readdir(u);for(const a of c)try{if((await P.Promises.readdir((0,M.join)(u,a))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await P.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let a;return c.scheme===D.Schemas.file?a=b.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,w.createHash)("md5").update(a).digest("hex")}};C=ue([ie(0,p.IEnvironmentMainService),ie(1,I.IConfigurationService),ie(2,h.ILogService)],C),e.BackupMainService=C}),define(J[230],Z([0,1,9,4,110,59,2,3,37,57,165,228,22,185,18,34,20,8,7,16,6]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(r){return r<21}let a=class{constructor(i,s,o,l,y,S,L){this.windowServer=i,this.options=s,this.windowsMainService=o,this.lifecycleMainService=l,this.fileService=y,this.environmentMainService=S,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(s=>s.id).filter(s=>this.registeredWindowIds.has(s)&&!this.reloadingWindowIds.has(s))}async capturePage(i){const s=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!s?.win)throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,s){}async stopTracing(i,s,o){if(!o)return;const l=await this.capturePage(i),y=Buffer.from(l,"base64");await this.fileService.writeFile(v.URI.file((0,C.join)(this.environmentMainService.logsPath,`${s}.png`)),m.VSBuffer.wrap(y))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const s=this.windowsMainService.getWindowById(i);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(s)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,s){await this.whenUnfrozen(i);const o=R.KeybindingParser.parseUserBinding(s);for(let l of o)await this._dispatchKeybinding(i,l)}async _dispatchKeybinding(i,s){if(s instanceof D.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const o=this.windowsMainService.getWindowById(i);if(!o?.win)throw new Error("Invalid window");const l=o.win.webContents,y=new D.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),L=new p.USLayoutResolvedKeybinding(y.toChord(),b.OS).getElectronAccelerator(),T=[];s.ctrlKey&&T.push("ctrl"),s.metaKey&&T.push("meta"),s.shiftKey&&T.push("shift"),s.altKey&&T.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:L,modifiers:T}),c(s.keyCode)||l.sendInputEvent({type:"char",keyCode:L,modifiers:T}),l.sendInputEvent({type:"keyUp",keyCode:L,modifiers:T}),await(0,w.timeout)(100)}async click(i,s,o,l){await(await this.getWindowDriver(i)).click(s,o,l)}async doubleClick(i,s){await(await this.getWindowDriver(i)).doubleClick(s)}async setValue(i,s,o){await(await this.getWindowDriver(i)).setValue(s,o)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,s){return await(await this.getWindowDriver(i)).isActiveElement(s)}async getElements(i,s,o){return await(await this.getWindowDriver(i)).getElements(s,o)}async getElementXY(i,s,o,l){return await(await this.getWindowDriver(i)).getElementXY(s,o,l)}async typeInEditor(i,s,o){await(await this.getWindowDriver(i)).typeInEditor(s,o)}async getTerminalBuffer(i,s){return await(await this.getWindowDriver(i)).getTerminalBuffer(s)}async writeInTerminal(i,s,o){await(await this.getWindowDriver(i)).writeInTerminal(s,o)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const s=`window:${i}`,o=new d.StaticRouter(y=>y===s),l=this.windowServer.getChannel("windowDriver",o);return new P.WindowDriverChannelClient(l)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};a=ue([ie(2,h.IWindowsMainService),ie(3,t.ILifecycleMainService),ie(4,f.IFileService),ie(5,I.IEnvironmentMainService),ie(6,u.ILogService)],a),e.Driver=a;async function g(r,i,s,o){const l=s.driverVerbose,y=o.createInstance(a,r,{verbose:l}),S=new k.WindowDriverRegistryChannel(y);r.registerChannel("windowDriverRegistry",S);const L=await(0,E.serve)(i),T=new k.DriverChannel(y);return L.registerChannel("driver",T),(0,M.combinedDisposable)(L,r)}e.serve=g}),define(J[231],Z([0,1,61,57]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,D,M,b,d){const E=k=>d(k,void 0),P=w.createConnection({host:R,port:D},()=>{P.removeListener("error",E);const k=Buffer.alloc(16);for(let h=0;h<16;h++)k[h]=Math.round(Math.random()*256);const I=k.toString("base64"),p=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${D}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];P.write(p.join(`\r
`)+`\r
\r
`);const t=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",t),d(void 0,new n.NodeSocket(P,b)))};P.on("data",t)});P.setNoDelay(!0),P.once("error",E)}}}),define(J[232],Z([0,1,203,9,16,15,2,14,19,52,98,6,202,227]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends M.Disposable{constructor(f,v,C){super();this.environmentService=v,this.logService=C,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,v){this.logService.trace("RequestService#request",f.url);const{proxyUrl:C,strictSSL:m}=this;let u;try{u=await(0,P.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(g){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",g))}const c={...process.env,...u},a=f.agent?f.agent:await(0,I.getProxyAgent)(f.url||"",c,{proxyUrl:C,strictSSL:m});return f.agent=a,f.strictSSL=m,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,v)}async getNodeRequest(f){return((0,w.parse)(f.url).protocol==="https:"?await new Promise((m,u)=>{H(["https"],m,u)}):await new Promise((m,u)=>{H(["http"],m,u)})).request}_request(f,v){return n.Promises.withAsyncBody(async(C,m)=>{let u;const c=(0,w.parse)(f.url),a=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),g={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,b.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(g.auth=f.user+":"+f.password),u=a(g,r=>{const i=(0,b.isNumber)(f.followRedirects)?f.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...f,url:r.headers.location,followRedirects:i-1},v).then(C,m);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,p.createGunzip)())),C({res:r,stream:(0,R.streamToBufferReadableStream)(s)})}}),u.on("error",m),f.timeout&&u.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&u.write(f.data),u.end(),v.onCancellationRequested(()=>{u.abort(),m((0,D.canceled)())})})}async resolveProxy(f){}};t=ue([ie(0,d.IConfigurationService),ie(1,E.INativeEnvironmentService),ie(2,k.ILogService)],t),e.RequestService=t}),define(J[233],Z([0,1,12,232]),function(H,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(M){return w.net.request}class D extends n.RequestService{request(b,d){return super.request({...b||{},getRawRequest:R},d)}}e.RequestMainService=D}),define(J[234],Z([0,1,12,9,4,2,10,14,89,22,18,6,53,54,65,39]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(C,m,u,c,a,g,r){super();this.machineId=C,this.userEnv=m,this.environmentMainService=u,this.lifecycleMainService=c,this.logService=a,this.themeMainService=g,this.protocolMainService=r,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:createSharedProcessMessageChannel",(C,m)=>this.onWindowConnection(C,m)),w.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(C,m)=>this.onWorkerConnection(C,m)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(C,m){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const u=await this.connect();if(C.sender.isDestroyed())return u.close();C.sender.postMessage("vscode:createSharedProcessMessageChannelResult",m,[u])}onWorkerConnection(C,m){this.logService.trace("SharedProcess: onWorkerConnection",m);const u=new D.DisposableStore,c=g=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${g}')`,m),u.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",m))},a=w.BrowserWindow.fromId(m.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!m.reply.channel){c("unavailable");return}u.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,g=>g.window.win===a)(()=>c("load"))),u.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>c("closed"))),a.webContents.postMessage(m.reply.channel,m.reply.nonce,C.ports)}onWillShutdown(){const C=this.window;!C||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(C.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{C.close()}catch{}this.window=void 0},0))}send(C,...m){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${C}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(C,...m)}catch(u){this.logService.warn(`Error sending IPC message to channel '${C}' of shared process: ${(0,h.toErrorMessage)(u)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(C=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),C()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(C=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),C()}))})()),this._whenIpcReady}createWindow(){const C=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${C.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),C.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=C=>{this.logService.trace("SharedProcess#close prevented"),C.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(C,m)=>this._onDidError.fire({type:2,details:m})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(C,m,u)=>this._onDidError.fire({type:3,details:{reason:u,exitCode:m}})))}async connect(){await this.whenIpcReady;const C=(0,b.assertIsDefined)(this.window);return(0,d.connect)(C)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const C=this.window;return C?!C.isDestroyed()&&!C.webContents.isDestroyed():!1}};f=ue([ie(2,E.IEnvironmentMainService),ie(3,P.ILifecycleMainService),ie(4,k.ILogService),ie(5,t.IThemeMainService),ie(6,p.IProtocolMainService)],f),e.SharedProcess=f}),define(J[235],Z([0,1,9,16,7,14,8,22,20,6]),function(H,e,w,n,R,D,M,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class P{constructor(p,t,h){this.storagePath=p,this.logService=t,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const h=this.storage[p];return(0,D.isUndefinedOrNull)(h)?t:h}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:h,data:f}of p)this.storage[h]!==f&&((0,D.isUndefinedOrNull)(f)?(0,D.isUndefined)(this.storage[h])||(this.storage[h]=void 0,t=!0):(this.storage[h]=f,t=!0));t&&this.save()}removeItem(p){(0,D.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=P;let k=class Mt{constructor(p,t,h){this.fileStorage=new P(M.URI.file((0,R.join)(p.userDataPath,Mt.STATE_FILE)),t,h)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};k.STATE_FILE="storage.json",k=ue([ie(0,b.IEnvironmentMainService),ie(1,E.ILogService),ie(2,d.IFileService)],k),e.StateMainService=k}),define(J[81],Z([0,1,43,2,52,22,5,18,6,97,224]),function(H,e,w,n,R,D,M,b,d,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let k=class extends n.Disposable{constructor(t,h,f){super();this.logService=t,this.environmentService=h,this.lifecycleMainService=f,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{this.logService.trace("storageMainService#onWillShutdown()"),t.join(this.globalStorage.close());for(const[,h]of this.mapWorkspaceToStorage)t.join(h.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const t=new P.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}workspaceStorage(t){let h=this.mapWorkspaceToStorage.get(t.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),h=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,h),(0,w.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),h}createWorkspaceStorage(t){return new P.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}};k=ue([ie(0,d.ILogService),ie(1,R.IEnvironmentService),ie(2,b.ILifecycleMainService)],k),e.StorageMainService=k,e.IGlobalStorageMainService=(0,M.createDecorator)("globalStorageMainService");let I=class extends E.AbstractStorageService{constructor(t,h){super();this.environmentMainService=t,this.storageMainService=h,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};I=ue([ie(0,D.IEnvironmentMainService),ie(1,e.IStorageMainService)],I),e.GlobalStorageMainService=I}),define(J[236],Z([0,1,61,123,231,9,2,19,6,21,201,99,79]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(C,m,u,c,a){let g;for(let r=3;r&&(g&&g.dispose(),g=await new t(C,m,u,c,a).waitForReady(),!(a&&n.BROWSER_RESTRICTED_PORTS[a]||!n.BROWSER_RESTRICTED_PORTS[g.tunnelLocalPort]));r--);return g}class t extends M.Disposable{constructor(m,u,c,a,g){super();this.defaultTunnelHost=u,this.suggestedLocalPort=g,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=w.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let m=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(m){m.pause();const u=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,P.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),a=c.getSocket().socket,g=c.readEntireBuffer();c.dispose(),g.byteLength>0&&m.write(g.buffer),m.on("end",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),a.end()}),m.on("close",()=>a.end()),m.on("error",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),a.destroy()}),a.on("end",()=>m.end()),a.on("close",()=>m.end()),a.on("error",()=>{m.destroy()}),m.pipe(a),a.pipe(m),m.localAddress&&this._socketsDispose.set(m.localAddress,()=>{m.end(),a.end()})}}let h=class extends k.AbstractTunnelService{constructor(m,u,c,a,g){super(u);this.socketFactory=m,this.signService=c,this.productService=a,this.configurationService=g}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,u,c,a,g,r,i){const s=this.getTunnelFromMap(u,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,a,g,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},l=p(o,this.defaultTunnelHost,u,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};h=ue([ie(1,d.ILogService),ie(2,I.ISignService),ie(3,E.IProductService),ie(4,b.IConfigurationService)],h),e.BaseTunnelService=h;let f=class extends h{constructor(m,u,c,a){super(R.nodeSocketFactory,m,u,c,a)}};f=ue([ie(0,d.ILogService),ie(1,I.ISignService),ie(2,E.IProductService),ie(3,b.IConfigurationService)],f),e.TunnelService=f;let v=class extends M.Disposable{constructor(m,u,c,a){super();this.logService=m,this.productService=u,this.signService=c,this.configurationService=a,this._tunnelServices=new Map}async openTunnel(m,u,c,a,g,r,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${a} on local port ${g}.`),!this._tunnelServices.has(m)){const o=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(m,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(u,c,a,g,r,i,s)}};v=ue([ie(0,d.ILogService),ie(1,E.IProductService),ie(2,I.ISignService),ie(3,b.IConfigurationService)],v),e.SharedTunnelsService=v}),define(J[82],Z([0,1,9,23,4,19,22,18,6,21,56,41]),function(H,e,w,n,R,D,M,b,d,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(t,h,f){return`${f.updateUrl}/api/update/${t}/${h}/${f.commit}`}e.createUpdateURL=I;let p=class{constructor(h,f,v,C,m,u){this.lifecycleMainService=h,this.configurationService=f,this.environmentMainService=v,this.requestService=C,this.logService=m,this.productService=u,this._state=k.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),f=this.getProductQuality(h);if(!f){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(f),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,w.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=ue([ie(0,b.ILifecycleMainService),ie(1,D.IConfigurationService),ie(2,M.IEnvironmentMainService),ie(3,P.IRequestService),ie(4,d.ILogService),ie(5,E.IProductService)],p),e.AbstractUpdateService=p}),define(J[237],Z([0,1,12,46,4,2,19,22,18,6,21,56,33,41,82]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends t.AbstractUpdateService{constructor(v,C,m,u,c,a,g){super(v,C,u,c,a,g);this.telemetryService=m,this.disposables=new D.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"error",(v,C)=>C)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(v,C,m)=>({url:C,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(v,C,m,u)=>({releaseNotes:C,version:m,productVersion:m,date:u}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const m=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(p.State.Idle(1,m))}buildUpdateFeedUrl(v){let C;this.productService.darwinUniversalAssetId?C=this.productService.darwinUniversalAssetId:C=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,t.createUpdateURL)(C,v,this.productService);try{w.autoUpdater.setFeedURL({url:m})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return m}doCheckForUpdates(v){this.setState(p.State.CheckingForUpdates(v)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(p.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],h.prototype,"onRawError",null),ue([n.memoize],h.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateDownloaded",null),h=ue([ie(0,d.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,I.ITelemetryService),ie(3,b.IEnvironmentMainService),ie(4,k.IRequestService),ie(5,E.ILogService),ie(6,P.IProductService)],h),e.DarwinUpdateService=h}),define(J[238],Z([0,1,45,29,9,4,7,22,18,6,33,41]),function(H,e,w,n,R,D,M,b,d,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(h,f,v){if(this.lifecycleMainService=h,this.logService=v,this._state=k.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,f.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,C=>this.logService.error(C))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,R.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([ie(0,d.ILifecycleMainService),ie(1,b.IEnvironmentMainService),ie(2,E.ILogService)],I);let p=class extends I{constructor(h,f,v,C,m,u){super(v,C,m);this.snap=h,this.snapRevision=f,this.telemetryService=u;const c=(0,n.watch)(M.dirname(this.snap)),a=D.Event.fromNodeEventEmitter(c,"change",(s,o)=>o),g=D.Event.filter(a,s=>s==="current"),i=D.Event.debounce(g,(s,o)=>o,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((v,C)=>(0,n.realpath)(`${M.dirname(this.snap)}/current`,(m,u)=>m?C(m):v(u))),f=M.basename(h);return this.snapRevision!==f}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ue([ie(2,d.ILifecycleMainService),ie(3,b.IEnvironmentMainService),ie(4,E.ILogService),ie(5,P.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[42],Z([0,1,12,29,4,44,32,2,10,7,3,17,14,24,161,51,47,22,5,6,21,102,25,80,103]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let i=class extends b.Disposable{constructor(o,l,y,S,L){super();this.environmentMainService=o,this.logService=l,this.backupMainService=y,this.dialogMainService=S,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new R.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new R.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,l=>(0,n.readFileSync)(l,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,l=>p.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(o,l){if(!!this.isWorkspacePath(o)&&o.scheme===d.Schemas.file)try{const y=l(o.fsPath);return y instanceof Promise?y.then(S=>this.doResolveWorkspace(o,S),S=>{}):this.doResolveWorkspace(o,y)}catch{return}}isWorkspacePath(o){return(0,a.isUntitledWorkspace)(o,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,l){try{const y=this.doParseStoredWorkspace(o,l),S=(0,r.getWorkspaceIdentifier)(o);return{id:S.id,configPath:S.configPath,folders:(0,g.toWorkspaceFolders)(y.folders,S.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:y.remoteAuthority,transient:y.transient}}catch(y){this.logService.warn(y.toString())}}doParseStoredWorkspace(o,l){const y=(0,D.parse)(l);if(y&&Array.isArray(y.folders))y.folders=y.folders.filter(S=>(0,g.isStoredWorkspaceFolder)(S));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return y}async createUntitledWorkspace(o,l){const{workspace:y,storedWorkspace:S}=this.newUntitledWorkspace(o,l),L=y.configPath.fsPath;return await p.Promises.mkdir((0,E.dirname)(L),{recursive:!0}),await p.Promises.writeFile(L,JSON.stringify(S,null,"	")),y}createUntitledWorkspaceSync(o,l){const{workspace:y,storedWorkspace:S}=this.newUntitledWorkspace(o,l),L=y.configPath.fsPath;return(0,n.mkdirSync)((0,E.dirname)(L),{recursive:!0}),(0,p.writeFileSync)(L,JSON.stringify(S,null,"	")),y}newUntitledWorkspace(o=[],l){const y=(Date.now()+Math.round(Math.random()*1e3)).toString(),S=(0,k.joinPath)(this.untitledWorkspacesHome,y),L=(0,k.joinPath)(S,a.UNTITLED_WORKSPACE_NAME),T=[];for(const B of o)T.push((0,g.getStoredWorkspaceFolder)(B.uri,!0,B.name,S,!P.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(L),storedWorkspace:{folders:T,remoteAuthority:l}}}async getWorkspaceIdentifier(o){return(0,r.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,a.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const l=(0,k.originalFSPath)(o.configPath);try{(0,p.rimrafSync)((0,E.dirname)(l));const y=(0,E.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,n.existsSync)(y)&&(0,p.writeFileSync)((0,E.join)(y,"obsolete"),"")}catch(y){this.logService.warn(`Unable to delete untitled workspace ${l} (${y}).`)}}getUntitledWorkspacesSync(){const o=[];try{const l=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(y=>(0,k.joinPath)(this.untitledWorkspacesHome,y,a.UNTITLED_WORKSPACE_NAME));for(const y of l){const S=(0,r.getWorkspaceIdentifier)(y),L=this.resolveLocalWorkspaceSync(y);L?o.push({workspace:S,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(S)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return o}async enterWorkspace(o,l,y){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,l,y))return;const L=this.doEnterWorkspace(o,(0,r.getWorkspaceIdentifier)(y));if(!!L)return this._onDidEnterWorkspace.fire({window:o,workspace:L.workspace}),L}async isValidTargetWorkspacePath(o,l,y){if(!y)return!0;if((0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,y))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,y)){const S={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,k.basename)(y)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(S,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,l){if(!o.config)return;o.focus();let y;return o.config.extensionDevelopmentPath||(y=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=l,o.config.backupPath=y,{workspace:l,backupPath:y}}};i=ue([ie(0,v.IEnvironmentMainService),ie(1,m.ILogService),ie(2,h.IBackupMainService),ie(3,f.IDialogMainService),ie(4,u.IProductService)],i),e.WorkspacesManagementMainService=i}),define(J[104],Z([0,1,12,23,5,34,25,42]),function(H,e,w,n,R,D,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let d=class{constructor(P,k){this.windowsMainService=P,this.workspacesManagementMainService=k}async getRemoteDiagnostics(P){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(p=>new Promise(t=>{const h=p.remoteAuthority;if(h){const f=`vscode:getDiagnosticInfoResponse${p.id}`,v={includeProcesses:P.includeProcesses,folders:P.includeWorkspaceMetadata?this.getFolderURIs(p):void 0};p.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:f,args:v}),w.ipcMain.once(f,(C,m)=>{m||t({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),t(m)}),setTimeout(()=>{t({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else t(void 0)})))).filter(p=>!!p)}getFolderURIs(P){const k=[],I=P.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(I))k.push(I.uri);else if((0,M.isWorkspaceIdentifier)(I)){const p=this.workspacesManagementMainService.resolveLocalWorkspaceSync(I.configPath);p&&p.folders.forEach(h=>{k.push(h.uri)})}return k}};d=ue([ie(0,D.IWindowsMainService),ie(1,b.IWorkspacesManagementMainService)],d),e.DiagnosticsMainService=d}),define(J[105],Z([0,1,12,30,3,14,8,24,19,50,5,6,100,34,25,42]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let f=class{constructor(C,m,u,c,a){this.logService=C,this.windowsMainService=m,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=a}async start(C,m){this.logService.trace("Received data from other instance: ",C,m),R.isMacintosh&&w.app.focus({steal:!0});const u=this.parseOpenUrl(C);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:a,url:g}of u)this.urlService.open(a,{originalUrl:g})})}else return this.startOpenWindow(C,m)}parseOpenUrl(C){return C["open-url"]&&C._urls&&C._urls.length>0?(0,n.coalesce)(C._urls.map(m=>{try{return{uri:M.URI.parse(m),url:m}}catch{return null}})):[]}async startOpenWindow(C,m){const u=(0,E.isLaunchedFromCli)(m)?0:4;let c=[];const a=C.wait&&C.waitMarkerFilePath?M.URI.file(C.waitMarkerFilePath):void 0,g=C.remote||void 0,r={context:u,cli:C,userEnv:m,waitMarkerFileURI:a,remoteAuthority:g};if(C.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(C.extensionDevelopmentPath,r);else if(!C._.length&&!C["folder-uri"]&&!C["file-uri"]){let i=!1;if(C["new-window"]||C["unity-launch"])i=!0;else if(C["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!R.isMacintosh}if(i)c=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,r),c=[s]):c=this.windowsMainService.open({...r,forceEmpty:!0})}}else c=this.windowsMainService.open({...r,forceNewWindow:C["new-window"],preferNewWindow:!C["reuse-window"]&&!C.wait,forceReuseWindow:C["reuse-window"],diffMode:C.diff,addMode:C.add,noRecentEntry:!!C["skip-add-to-recently-opened"],gotoLineMode:C.goto});if(a&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,b.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const C=[];return w.BrowserWindow.getAllWindows().forEach(m=>{const u=this.windowsMainService.getWindowById(m.id);u?C.push(this.codeWindowToInfo(u)):C.push(this.browserWindowToInfo(m))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:C,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(C){const m=[],u=C.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(u))m.push(u.uri);else if((0,t.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(g=>{m.push(g.uri)})}return m}codeWindowToInfo(C){const m=this.getFolderURIs(C),u=(0,D.assertIsDefined)(C.win);return this.browserWindowToInfo(u,m,C.remoteAuthority)}browserWindowToInfo(C,m=[],u){return{pid:C.webContents.getOSProcessId(),title:C.getTitle(),folderURIs:m,remoteAuthority:u}}};f=ue([ie(0,k.ILogService),ie(1,p.IWindowsMainService),ie(2,I.IURLService),ie(3,h.IWorkspacesManagementMainService),ie(4,d.IConfigurationService)],f),e.LaunchMainService=f}),define(J[58],Z([0,1,45,12,26,122,46,4,32,2,10,7,3,8,86,71,24,152,47,22,5,18,6,21,65,34,25,42]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a,g,r,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,u.createDecorator)("nativeHostMainService");let l=class extends E.Disposable{constructor(S,L,T,B,Y,ee,te,Q,q){super();this.sharedProcess=S,this.windowsMainService=L,this.dialogMainService=T,this.lifecycleMainService=B,this.environmentMainService=Y,this.logService=ee,this.productService=te,this.themeMainService=Q,this.workspacesManagementMainService=q,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(G,_)=>_.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(G,_)=>_.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(G,_)=>_.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(G,_)=>_.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new b.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(G,_,x)=>x),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),b.Event.fromNodeEventEmitter(n.screen,"display-added"),b.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(L=>({id:L.id,workspace:L.openedWorkspace,title:L.win?.getTitle()??"",filename:L.getRepresentedFilename(),dirty:L.isDocumentEdited()}))}async getWindowCount(S){return this.windowsMainService.getWindowCount()}async getActiveWindowId(S){const L=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(L)return L.id}openWindow(S,L,T){return Array.isArray(L)?this.doOpenWindow(S,L,T):this.doOpenEmptyWindow(S,L)}async doOpenWindow(S,L,T=Object.create(null)){L.length>0&&this.windowsMainService.open({context:5,contextWindowId:S,urisToOpen:L,cli:this.environmentMainService.args,forceNewWindow:T.forceNewWindow,forceReuseWindow:T.forceReuseWindow,preferNewWindow:T.preferNewWindow,diffMode:T.diffMode,addMode:T.addMode,gotoLineMode:T.gotoLineMode,noRecentEntry:T.noRecentEntry,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:T.remoteAuthority||void 0})}async doOpenEmptyWindow(S,L){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:S},L)}async toggleFullScreen(S){const L=this.windowById(S);L&&L.toggleFullScreen()}async handleTitleDoubleClick(S){const L=this.windowById(S);L&&L.handleTitleDoubleClick()}async isMaximized(S){const L=this.windowById(S);return L?.win?L.win.isMaximized():!1}async maximizeWindow(S){const L=this.windowById(S);L?.win&&L.win.maximize()}async unmaximizeWindow(S){const L=this.windowById(S);L?.win&&L.win.unmaximize()}async minimizeWindow(S){const L=this.windowById(S);L?.win&&L.win.minimize()}async focusWindow(S,L){L&&typeof L.windowId=="number"&&(S=L.windowId);const T=this.windowById(S);T&&T.focus({force:L?.force??!1})}async setMinimumSize(S,L,T){const B=this.windowById(S);if(B?.win){const[Y,ee]=B.win.getSize(),[te,Q]=B.win.getMinimumSize(),[q,G]=[L??te,T??Q],[_,x]=[Math.max(Y,q),Math.max(ee,G)];(te!==q||Q!==G)&&B.win.setMinimumSize(q,G),(Y!==_||ee!==x)&&B.win.setSize(_,x)}}async saveWindowSplash(S,L){this.themeMainService.saveWindowSplash(S,L)}async installShellCommand(S){const{source:L,target:T}=await this.getShellCommandLink();try{const{symbolicLink:B}=await f.SymlinkSupport.stat(L);if(B&&!B.dangling){const Y=await(0,t.realpath)(L);if(T===Y)return}await f.Promises.unlink(L)}catch(B){if(B.code!=="ENOENT")throw B}try{await f.Promises.symlink(T,L)}catch(B){if(B.code!=="EACCES"&&B.code!=="ENOENT")throw B;const{response:Y}=await this.showMessageBox(S,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(Y===0)try{const ee=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${T}' '${L}'\\" with administrator privileges"`;await(0,D.promisify)(w.exec)(ee)}catch{throw new Error((0,v.localize)(3,null,L))}}}async uninstallShellCommand(S){const{source:L}=await this.getShellCommandLink();try{await f.Promises.unlink(L)}catch(T){switch(T.code){case"EACCES":{const{response:B}=await this.showMessageBox(S,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(B===0)try{const Y=`osascript -e "do shell script \\"rm '${L}'\\" with administrator privileges"`;await(0,D.promisify)(w.exec)(Y)}catch{throw new Error((0,v.localize)(7,null,L))}break}case"ENOENT":break;default:throw T}}}async getShellCommandLink(){const S=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),L=`/usr/local/bin/${this.productService.applicationName}`;if(!await f.Promises.exists(S))throw new Error((0,v.localize)(8,null,S));return{source:L,target:S}}async showMessageBox(S,L){return this.dialogMainService.showMessageBox(L,this.toBrowserWindow(S))}async showSaveDialog(S,L){return this.dialogMainService.showSaveDialog(L,this.toBrowserWindow(S))}async showOpenDialog(S,L){return this.dialogMainService.showOpenDialog(L,this.toBrowserWindow(S))}toBrowserWindow(S){const L=this.windowById(S);if(L?.win)return L.win}async pickFileFolderAndOpen(S,L){const T=await this.dialogMainService.pickFileFolder(L);T&&this.doOpenPicked(await Promise.all(T.map(async B=>await f.SymlinkSupport.existsDirectory(B)?{folderUri:p.URI.file(B)}:{fileUri:p.URI.file(B)})),L,S)}async pickFolderAndOpen(S,L){const T=await this.dialogMainService.pickFolder(L);T&&this.doOpenPicked(T.map(B=>({folderUri:p.URI.file(B)})),L,S)}async pickFileAndOpen(S,L){const T=await this.dialogMainService.pickFile(L);T&&this.doOpenPicked(T.map(B=>({fileUri:p.URI.file(B)})),L,S)}async pickWorkspaceAndOpen(S,L){const T=await this.dialogMainService.pickWorkspace(L);T&&this.doOpenPicked(T.map(B=>({workspaceUri:p.URI.file(B)})),L,S)}doOpenPicked(S,L,T){this.windowsMainService.open({context:3,contextWindowId:T,cli:this.environmentMainService.args,urisToOpen:S,forceNewWindow:L.forceNewWindow})}async showItemInFolder(S,L){n.shell.showItemInFolder(L)}async setRepresentedFilename(S,L){const T=this.windowById(S);T&&T.setRepresentedFilename(L)}async setDocumentEdited(S,L){const T=this.windowById(S);T&&T.setDocumentEdited(L)}async openExternal(S,L){return I.isLinuxSnap?this.safeSnapOpenExternal(L):n.shell.openExternal(L),!0}safeSnapOpenExternal(S){const L=process.env.GDK_PIXBUF_MODULE_FILE,T=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(S),process.env.GDK_PIXBUF_MODULE_FILE=L,process.env.GDK_PIXBUF_MODULEDIR=T}moveItemToTrash(S,L){return n.shell.trashItem(L)}async isAdmin(){let S;return I.isWindows?S=(await new Promise((L,T)=>{H(["native-is-elevated"],L,T)}))():S=process.getuid()===0,S}async writeElevated(S,L,T,B){const Y=await new Promise((ee,te)=>{H(["@vscode/sudo-prompt"],ee,te)});return new Promise((ee,te)=>{const Q=[`"${this.cliPath}"`];B?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${L.fsPath}"`,`"${T.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};Y.exec(Q.join(" "),q,(G,_,x)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),x&&this.logService.trace(`[sudo-prompt] received stderr: ${x}`),G?te(G):ee(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(S,L,T){process.kill(L,T)}async readClipboardText(S,L){return n.clipboard.readText(L)}async writeClipboardText(S,L,T){return n.clipboard.writeText(L,T)}async readClipboardFindText(S){return n.clipboard.readFindText()}async writeClipboardFindText(S,L){return n.clipboard.writeFindText(L)}async writeClipboardBuffer(S,L,T,B){return n.clipboard.writeBuffer(L,Buffer.from(T),B)}async readClipboardBuffer(S,L){return n.clipboard.readBuffer(L)}async hasClipboard(S,L,T){return n.clipboard.has(L,T)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(S,L){const T=this.windowById(S);T&&T.updateTouchBar(L)}async notifyReady(S){const L=this.windowById(S);L&&L.setReady()}async relaunch(S,L){return this.lifecycleMainService.relaunch(L)}async reload(S,L){const T=this.windowById(S);if(T){if((0,s.isWorkspaceIdentifier)(T.openedWorkspace)){const B=T.openedWorkspace.configPath;if(B.scheme===P.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(B))?.transient)return this.openWindow(T.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(T,L?.disableExtensions!==void 0?{_:[],"disable-extensions":L.disableExtensions}:void 0)}}async closeWindow(S){this.closeWindowById(S,S)}async closeWindowById(S,L){const T=this.windowById(L);if(T?.win)return T.win.close()}async quit(S){const L=this.windowsMainService.getLastActiveWindow();L?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&L.win?L.win.close():this.lifecycleMainService.quit()}async exit(S,L){await this.lifecycleMainService.kill(L)}async resolveProxy(S,L){const B=this.windowById(S)?.win?.webContents?.session;if(B)return B.resolveProxy(L)}async openDevTools(S,L){const T=this.windowById(S);T?.win&&T.win.webContents.openDevTools(L)}async toggleDevTools(S){const L=this.windowById(S);L?.win&&L.win.webContents.toggleDevTools()}async sendInputEvent(S,L){const T=this.windowById(S);T?.win&&(L.type==="mouseDown"||L.type==="mouseUp")&&T.win.webContents.sendInputEvent(L)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(S,L,T,B){if(!I.isWindows)return;const Y=await new Promise((ee,te)=>{H(["@vscode/windows-registry"],ee,te)});try{return Y.GetStringRegKey(L,T,B)}catch{return}}windowById(S){if(typeof S=="number")return this.windowsMainService.getWindowById(S)}};ue([M.memoize],l.prototype,"cliPath",null),l=ue([ie(1,i.IWindowsMainService),ie(2,C.IDialogMainService),ie(3,c.ILifecycleMainService),ie(4,m.IEnvironmentMainService),ie(5,a.ILogService),ie(6,g.IProductService),ie(7,r.IThemeMainService),ie(8,o.IWorkspacesManagementMainService)],l),e.NativeHostMainService=l}),define(J[239],Z([0,1,12,26,32,2,10,3,87,150,75,104,47,22,5,105,6,58,53,21,54,66]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let a=class Ct{constructor(r,i,s,o,l,y,S,L,T,B){this.userEnv=r,this.environmentMainService=i,this.launchMainService=s,this.logService=o,this.diagnosticsService=l,this.diagnosticsMainService=y,this.dialogMainService=S,this.nativeHostMainService=L,this.protocolMainService=T,this.productService=B,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[i,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(i,s);this.safeSend(r,"vscode:issueSystemInfoResponse",o)}),w.ipcMain.on("vscode:listProcesses",async r=>{const i=[];try{const s=await this.launchMainService.getMainProcessId();i.push({name:(0,E.localize)(0,null),rootProcess:await(0,d.listProcesses)(s)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(l=>{(0,P.isRemoteDiagnosticError)(l)?i.push({name:l.hostName,rootProcess:l}):l.processes&&i.push({name:l.hostName,rootProcess:l.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(r,"vscode:listProcessesResponse",i)}),w.ipcMain.on("vscode:issueReporterClipboard",async r=>{const i={title:this.productService.nameLong,message:(0,E.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",s.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const i=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",i)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,E.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(r,i)=>{const{id:s,from:o,args:l}=i;let y;switch(o){case"issueReporter":y=this.issueReporterParentWindow;break;case"processExplorer":y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}y&&y.webContents.send("vscode:runAction",{id:s,from:o,args:l})}),w.ipcMain.on("vscode:openExternal",(r,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),w.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async r=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",i.windows)})}safeSend(r,i,...s){r.sender.isDestroyed()||r.sender.send(i,...s)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new D.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,s,{backgroundColor:r.styles.backgroundColor,title:(0,E.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:C.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new D.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,s,{backgroundColor:r.styles.backgroundColor,title:(0,E.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:C.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,i,s,o){const l=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:s.title,backgroundColor:s.backgroundColor||Ct.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,i)}getWindowPosition(r,i,s){let o;const l=w.screen.getAllDisplays();if(l.length===1)o=l[0];else{if(b.isMacintosh){const L=w.screen.getCursorScreenPoint();o=w.screen.getDisplayNearestPoint(L)}!o&&r&&(o=w.screen.getDisplayMatching(r.getBounds())),o||(o=w.screen.getPrimaryDisplay()||l[0])}const y={width:i,height:s},S=o.bounds;return y.x=S.x+S.width/2-y.width/2,y.y=S.y+S.height/2-y.height/2,S.width>0&&S.height>0&&(y.x<S.x&&(y.x=S.x),y.y<S.y&&(y.y=S.y),y.x>S.x+S.width&&(y.x=S.x),y.y>S.y+S.height&&(y.y=S.y),y.width>S.width&&(y.width=S.width),y.height>S.height&&(y.height=S.height)),y}async getPerformanceInfo(){try{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,i)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};a.DEFAULT_BACKGROUND_COLOR="#1E1E1E",a=ue([ie(1,p.IEnvironmentMainService),ie(2,h.ILaunchMainService),ie(3,f.ILogService),ie(4,P.IDiagnosticsService),ie(5,k.IDiagnosticsMainService),ie(6,I.IDialogMainService),ie(7,v.INativeHostMainService),ie(8,u.IProtocolMainService),ie(9,m.IProductService)],a),e.IssueMainService=a}),define(J[240],Z([0,1,23,19,22,18,6,58,21,56,33,41,82]),function(H,e,w,n,R,D,M,b,d,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends I.AbstractUpdateService{constructor(h,f,v,C,m,u,c,a){super(h,f,C,m,u,a);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,I.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(k.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},w.CancellationToken.None).then(E.asJson).then(f=>{!f||!f.url||!f.version||!f.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(f))}).then(void 0,f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const v=h?f.message||f:void 0;this.setState(k.State.Idle(1,v))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(k.State.Idle(1))}};p=ue([ie(0,D.ILifecycleMainService),ie(1,n.IConfigurationService),ie(2,P.ITelemetryService),ie(3,R.IEnvironmentMainService),ie(4,E.IRequestService),ie(5,M.ILogService),ie(6,b.INativeHostMainService),ie(7,d.IProductService)],p),e.LinuxUpdateService=p}),define(J[241],Z([0,1,45,29,26,9,23,46,7,8,119,24,19,22,20,18,6,58,21,56,33,41,82]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function g(o,l=1e3){for(;!o();)await(0,D.timeout)(l)}let r;function i(){return typeof r=="undefined"&&(r=n.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends a.AbstractUpdateService{constructor(l,y,S,L,T,B,Y,ee,te){super(l,y,L,T,B,te);this.telemetryService=S,this.fileService=Y,this.nativeHostMainService=ee}get cachePath(){const l=d.join((0,R.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(l,{recursive:!0}).then(()=>l)}initialize(){super.initialize()}buildUpdateFeedUrl(l){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),i()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,a.createUpdateURL)(y,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},M.CancellationToken.None).then(m.asJson).then(y=>{const S=i();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(S)),Promise.resolve(null)):S===1?(this.setState(c.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(c.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(L=>k.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const B=y.url,Y=y.hash,ee=`${L}.tmp`;return this.requestService.request({url:B},M.CancellationToken.None).then(te=>this.fileService.writeFile(E.URI.file(ee),te.stream)).then(Y?()=>(0,P.checksum)(ee,y.hash):()=>{}).then(()=>k.Promises.rename(ee,L)).then(()=>L)})).then(L=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},T&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(y)):this.setState(c.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const S=l?y.message||y:void 0;this.setState(c.State.Idle(i(),S))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(l){const y=await this.cachePath;return d.join(y,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const y=l?B=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(B):()=>!0,S=await this.cachePath,T=(await k.Promises.readdir(S)).filter(y).map(async B=>{try{await k.Promises.unlink(d.join(S,B))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const y=await this.cachePath;this.availableUpdate.updateFilePath=d.join(y,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,T=await new Promise((B,Y)=>{H(["windows-mutex"],B,Y)});g(()=>T.isActive(L)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([b.memoize],s.prototype,"cachePath",null),s=ue([ie(0,h.ILifecycleMainService),ie(1,I.IConfigurationService),ie(2,u.ITelemetryService),ie(3,p.IEnvironmentMainService),ie(4,m.IRequestService),ie(5,f.ILogService),ie(6,t.IFileService),ie(7,v.INativeHostMainService),ie(8,C.IProductService)],s),e.Win32UpdateService=s}),define(J[242],Z([0,1,12,9,23,39,4,32,2,10,7,63,3,8,157,51,19,47,22,50,20,18,6,21,54,209,81,33,212,65,66,34,25,42,101]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a,g,r,i,s,o,l,y,S,L,T,B,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ee;(function(Q){Q[Q.NONE=0]="NONE",Q[Q.NAVIGATING=1]="NAVIGATING",Q[Q.READY=2]="READY"})(ee||(ee={}));let te=class extends d.Disposable{constructor(q,G,_,x,$,V,X,z,O,U,W,A,F,N,K){super();this.logService=G,this.environmentMainService=_,this.fileService=x,this.globalStorageMainService=$,this.configurationService=V,this.themeMainService=X,this.workspacesManagementMainService=z,this.backupMainService=O,this.telemetryService=U,this.dialogMainService=W,this.lifecycleMainService=A,this.productService=F,this.protocolMainService=N,this.windowsMainService=K,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[se,ae]=this.restoreWindowState(q.state);this.windowState=se,this.logService.trace("window#ctor: using window state",se);const ce=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),le={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:S.WindowMinimumSize.WIDTH,minHeight:S.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,S.zoomLevelToZoomFactor)(ne?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?le.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(le.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1),I.isMacintosh&&(le.acceptFirstMouse=!0,ne?.clickThroughInactive===!1&&(le.acceptFirstMouse=!1));const he=I.isMacintosh&&ne?.nativeTabs===!0;he&&(le.tabbingIdentifier=this.productService.nameShort);const we=(0,S.getTitleBarStyle)(this.configurationService)==="custom";if(we&&(le.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(le.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(le),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&we&&this._win.setSheetOffset(22),I.isMacintosh&&ae&&(!he||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(be=>typeof be=="number")){const be=this.windowState;this._win.setBounds({width:be.width,height:be.height,x:be.x,y:be.y})}ce&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(q){I.isMacintosh?this._win.setRepresentedFilename(q):this.representedFilename=q}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(q){I.isMacintosh&&this._win.setDocumentEdited(q),this.documentEdited=q}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(q){I.isMacintosh&&q?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(q=>{if(this.isReady)return q(this);this.whenReadyCallbacks.push(q)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(q=>{function G(){_.dispose(),x.dispose(),q()}const _=this.onDidClose(()=>G()),x=this.onWillLoad(()=>G())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(G,_)=>this.onWindowError(2,_)),this._win.webContents.on("did-fail-load",(G,_,x)=>this.onWindowError(3,{reason:x,exitCode:_})),this._win.webContents.on("will-prevent-unload",G=>{G.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",G=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",G,this._win)}),this._win.on("unmaximize",G=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",G,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",R.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",R.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(G=>this.onDidDeleteUntitledWorkspace(G)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(G,_)=>{const x=await this.getMarketplaceHeaders();_({cancel:!1,requestHeaders:Object.assign(G.requestHeaders,x)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(q,G){switch(q){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:q,reason:G?.reason,code:G?.exitCode}),q){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(q===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(_.response!==1){const x=_.response===0;this.destroyWindow(x)}}else if(q===2){let _;G?_=(0,t.localize)(6,null,G.reason,G.exitCode??"<unknown>"):_=(0,t.localize)(5,null);const $=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(8,null))],message:_,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow($)}break}}destroyWindow(q){if(this._onDidDestroy.fire(),this._win?.destroy(),q&&this.config){let G,_;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?G={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?G={workspaceUri:this.openedWorkspace.configPath}:_=!0;const[x]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:G?[G]:void 0,forceEmpty:_,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});x.focus()}}onDidDeleteUntitledWorkspace(q){this.openedWorkspace?.id===q.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const q=this.getMenuBarVisibility();q!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=q,this.setMenuBarVisibility(q));let G=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;G?.endsWith("/")&&(G=G.substr(0,G.length-1));const _=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((G||"").indexOf("@")===-1&&(G!==this.currentHttpProxy||_!==this.currentNoProxy)){this.currentHttpProxy=G,this.currentNoProxy=_;const x=G||"",$=_?`${_},<local>`:"<local>";this.logService.trace(`Setting proxy to '${x}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:x,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(q){I.isMacintosh&&q.win&&this._win.addTabbedWindow(q.win)}load(q,G=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!G.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),G.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(q,G),this.readyState===0?this.currentConfig=q:this.pendingLoadConfig=q,this.readyState=1,this._win.loadURL(E.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",H).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:q.workspace,reason:G.isReload?3:_?2:1})}updateConfiguration(q,G){const _=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(_){const x=(0,m.isLaunchedFromCli)(_)&&!(0,m.isLaunchedFromCli)(q.userEnv),$=this.isExtensionDevelopmentHost;(x||$)&&(q.userEnv={..._,...q.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(q.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),G.disableExtensions!==void 0&&(q["disable-extensions"]=G.disableExtensions),q.fullscreen=this.isFullScreen,q.maximized=this._win.isMaximized(),q.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),q.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(q)}async reload(q){const G=Object.assign({},this.currentConfig);G.workspace=await this.validateWorkspaceBeforeReload(G),delete G.filesToOpenOrCreate,delete G.filesToDiff,delete G.filesToWait,this.isExtensionDevelopmentHost&&q&&(G.verbose=q.verbose,G.debugId=q.debugId,G.extensionEnvironment=q.extensionEnvironment,G["inspect-extensions"]=q["inspect-extensions"],G["inspect-brk-extensions"]=q["inspect-brk-extensions"],G["extensions-dir"]=q["extensions-dir"]),G.isInitialStartup=!1,this.load(G,{isReload:!0,disableExtensions:q?.["disable-extensions"]})}async validateWorkspaceBeforeReload(q){if((0,T.isWorkspaceIdentifier)(q.workspace)){const G=q.workspace.configPath;if(G.scheme===E.Schemas.file&&!await this.fileService.exists(G))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(q.workspace)){const G=q.workspace.uri;if(G.scheme===E.Schemas.file&&!await this.fileService.exists(G))return}return q.workspace}serializeWindowState(){if(!this._win)return(0,Y.defaultWindowState)();if(this.isFullScreen){let _;try{_=w.screen.getDisplayMatching(this.getBounds())}catch{}const x=(0,Y.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||x.width,height:this.windowState.height||x.height,x:this.windowState.x||0,y:this.windowState.y||0}}const q=Object.create(null);let G;if(!I.isMacintosh&&this._win.isMaximized()?G=0:G=1,G===0?q.mode=0:q.mode=1,G===1||G===0){let _;G===1?_=this.getBounds():_=this._win.getNormalBounds(),q.x=_.x,q.y=_.y,q.width=_.width,q.height=_.height}return q}restoreWindowState(q){(0,k.mark)("code/willRestoreCodeWindowState");let G=!1;if(q)try{const _=w.screen.getAllDisplays();G=_.length>1,q=this.validateWindowState(q,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[q||(0,Y.defaultWindowState)(),G]}validateWindowState(q,G){if(this.logService.trace(`window#validateWindowState: validating window state on ${G.length} display(s)`,q),typeof q.x!="number"||typeof q.y!="number"||typeof q.width!="number"||typeof q.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(q.width<=0||q.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(G.length===1){const $=this.getWorkingArea(G[0]);if($){let V=function(){!q||typeof q.x!="number"||typeof q.y!="number"||!$||(q.x<$.x&&(q.x=$.x),q.y<$.y&&(q.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),V(),q.width>$.width&&(q.width=$.width),q.height>$.height&&(q.height=$.height),q.x>$.x+$.width-128&&(q.x=$.x+$.width-q.width),q.y>$.y+$.height-128&&(q.y=$.y+$.height-q.height),V()}return q}if(q.display&&q.mode===3){const $=G.find(V=>V.id===q.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,Y.defaultWindowState)(3);return V.x=$.bounds.x,V.y=$.bounds.y,V}}let _,x;try{_=w.screen.getDisplayMatching({x:q.x,y:q.y,width:q.width,height:q.height}),x=this.getWorkingArea(_)}catch{}if(_&&x&&q.x+q.width>x.x&&q.y+q.height>x.y&&q.x<x.x+x.width&&q.y<x.y+x.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",x),q}getWorkingArea(q){if(q.workArea.width>0&&q.workArea.height>0)return q.workArea;if(q.bounds.width>0&&q.bounds.height>0)return q.bounds}getBounds(){const[q,G]=this._win.getPosition(),[_,x]=this._win.getSize();return{x:q,y:G,width:_,height:x}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(q){this.useNativeFullScreen()?this.setNativeFullScreen(q):this.setSimpleFullScreen(q),this.sendWhenReady(q?"vscode:enterFullScreen":"vscode:leaveFullScreen",R.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(q){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(q)}setSimpleFullScreen(q){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(q),this._win.webContents.focus()}useNativeFullScreen(){const q=this.configurationService.getValue("window");return!q||typeof q.nativeFullScreen!="boolean"||q.nativeTabs?!0:q.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let q=(0,S.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(q)<0&&(q="classic"),q}setMenuBarVisibility(q,G=!0){I.isMacintosh||(q==="toggle"&&G&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),q==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(q)}):this.doSetMenuBarVisibility(q))}doSetMenuBarVisibility(q){const G=this.isFullScreen;switch(q){case"classic":this._win.setMenuBarVisibility(!G),this._win.autoHideMenuBar=G;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(q,G,..._){this.isReady?this.send(q,..._):this.ready().then(()=>{G.isCancellationRequested||this.send(q,..._)})}send(q,...G){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${q}' for window that is destroyed`);return}try{this._win.webContents.send(q,...G)}catch(_){this.logService.warn(`Error sending IPC message to channel '${q}' of window ${this._id}: ${(0,D.toErrorMessage)(_)}`)}}}updateTouchBar(q){!I.isMacintosh||this.touchBarGroups.forEach((G,_)=>{const x=q[_];G.segments=this.createTouchBarGroupSegments(x)})}createTouchBar(){if(!!I.isMacintosh){for(let q=0;q<10;q++){const G=this.createTouchBarGroup();this.touchBarGroups.push(G)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(q=[]){const G=this.createTouchBarGroupSegments(q),_=new w.TouchBar.TouchBarSegmentedControl({segments:G,mode:"buttons",segmentStyle:"automatic",change:x=>{this.sendWhenReady("vscode:runAction",R.CancellationToken.None,{id:_.segments[x].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(q=[]){return q.map(_=>{let x;_.icon&&!l.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===E.Schemas.file&&(x=w.nativeImage.createFromPath(p.URI.revive(_.icon.dark).fsPath),x.isEmpty()&&(x=void 0));let $;return typeof _.title=="string"?$=_.title:$=_.title.value,{id:_.id,label:x?void 0:$,icon:x}})}dispose(){super.dispose(),this._win=null}};te=ue([ie(1,a.ILogService),ie(2,C.IEnvironmentMainService),ie(3,u.IFileService),ie(4,s.IGlobalStorageMainService),ie(5,f.IConfigurationService),ie(6,y.IThemeMainService),ie(7,B.IWorkspacesManagementMainService),ie(8,h.IBackupMainService),ie(9,o.ITelemetryService),ie(10,v.IDialogMainService),ie(11,c.ILifecycleMainService),ie(12,g.IProductService),ie(13,r.IProtocolMainService),ie(14,L.IWindowsMainService)],te),e.CodeWindow=te}),define(J[67],Z([0,1,12,30,9,4,32,2,10,3,17,8,24,160,5,18,6,38,81,80,25,42]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class $e extends b.Disposable{constructor(r,i,s,o,l){super();this.stateMainService=r,this.logService=i,this.workspacesManagementMainService=s,this.lifecycleMainService=o,this.globalStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new R.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],s=[];for(let o of r)if((0,m.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,m.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const l=this.indexOfFile(s,o.fileUri)>=0,y=o.fileUri.scheme===d.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,P.basename)(o.fileUri))>=0;!l&&!y&&(s.push(o),E.isWindows&&o.fileUri.scheme===d.Schemas.file&&w.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(i.length=$e.MAX_TOTAL_RECENT_ENTRIES),s.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(s.length=$e.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),E.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=y=>{const S=this.location(y);for(const L of r)if(P.extUriBiasedIgnorePathCase.isEqual(L,S))return!1;return!0},s=await this.getRecentlyOpened(),o=s.workspaces.filter(i),l=s.files.filter(i);(o.length!==s.workspaces.length||l.length!==s.files.length)&&(await this.saveRecentlyOpened({files:l,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),E.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const i=[],s=[];if(r){const l=r.config?.workspace;(0,u.isWorkspaceIdentifier)(l)&&!this.workspacesManagementMainService.isUntitledWorkspace(l)?i.push({workspace:l,remoteAuthority:r.remoteAuthority}):(0,u.isSingleFolderWorkspaceIdentifier)(l)&&i.push({folderUri:l.uri,remoteAuthority:r.remoteAuthority})}const o=r?.config?.filesToOpenOrCreate;if(o)for(let l of o){const y=l.fileUri;y&&this.indexOfFile(s,y)===-1&&s.push({fileUri:y})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(r,i){let s=await this.getRecentlyOpenedFromStorage();for(let o of s.workspaces){let l=(0,m.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);l>=0?r[l].label=r[l].label||o.label:r.push(o)}for(let o of s.files){let l=this.indexOfFile(i,o.fileUri);l>=0?i[l].label=i[l].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let r;const i=this.globalStorageMainService.get($e.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{r=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}else r=this.stateMainService.getItem($e.legacyRecentlyOpenedStorageKey),r&&(this.stateMainService.removeItem($e.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(r),0,1));return(0,m.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,m.toStoreData)(r)),0,1)}location(r){return(0,m.isRecentFolder)(r)?r.folderUri:(0,m.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(s=>(0,m.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(s=>(0,m.isRecentFolder)(s)&&P.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(r,i){return r.findIndex(s=>P.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!E.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!E.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let l of w.app.getJumpListSettings().removedItems){const y=l.args;if(y){const S=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);S&&i.push(k.URI.parse(S[2]))}}await this.removeRecentlyOpened(i);let s=!1;const o=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(l=>{const y=(0,m.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:S,description:L}=this.getWindowsJumpListLabel(y,l.label);let T;return k.URI.isUri(y)?T=`--folder-uri "${y.toString()}"`:(s=!0,T=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:S.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:s?(0,p.localize)(2,null):(0,p.localize)(3,null),items:o})}r.push({type:"recent"});try{w.app.setJumpList(r)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(k.URI.isUri(r))return{title:(0,P.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,p.localize)(4,null),description:""};let s=(0,P.basename)(r.configPath);return s.endsWith(u.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,M.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!E.isMacintosh)return;w.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let s=0;for(let l=0;l<r.workspaces.length&&s<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;l++){const y=this.location(r.workspaces[l]);if(y.scheme===d.Schemas.file){const S=(0,P.originalFSPath)(y);await I.Promises.exists(S)&&(i.push(S),s++)}}const o=[];for(let l=0;l<r.files.length&&s<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;l++){const y=this.location(r.files[l]);if(y.scheme===d.Schemas.file){const S=(0,P.originalFSPath)(y);if($e.COMMON_FILES_FILTER.includes((0,P.basename)(y))||i.includes(S))continue;await I.Promises.exists(S)&&(o.push(S),s++)}}o.reverse().forEach(l=>w.app.addRecentDocument(l)),i.reverse().forEach(l=>w.app.addRecentDocument(l))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.legacyRecentlyOpenedStorageKey="openedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ue([ie(0,v.IStateMainService),ie(1,f.ILogService),ie(2,c.IWorkspacesManagementMainService),ie(3,h.ILifecycleMainService),ie(4,C.IGlobalStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(J[243],Z([0,1,12,9,23,32,3,8,151,19,22,18,6,193,58,21,38,33,41,66,34,67]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let g=class It{constructor(s,o,l,y,S,L,T,B,Y,ee,te){this.updateService=s,this.configurationService=o,this.windowsMainService=l,this.environmentMainService=y,this.telemetryService=S,this.workspacesHistoryMainService=L,this.stateMainService=T,this.lifecycleMainService=B,this.logService=Y,this.nativeHostMainService=ee,this.productService=te,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,m.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(It.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,T,B)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,T,B)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,T,B)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(B),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,T,B)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(B),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const o=this.productService.requestFeatureUrl;o&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(o,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const S=this.productService.privacyStatementUrl;S&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(S,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,o){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(It.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=w.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(M.isMacintosh?new w.Menu:null);return}const o=new w.Menu;let l;if(M.isMacintosh){const S=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:S}),this.setMacApplicationMenu(S),o.append(l)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const S=new w.Menu;S.append(new w.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(S)}if(this.shouldDrawMenu("File")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:S});this.setMenuById(S,"File"),o.append(L)}if(this.shouldDrawMenu("Edit")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:S});this.setMenuById(S,"Edit"),o.append(L)}if(this.shouldDrawMenu("Selection")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:S});this.setMenuById(S,"Selection"),o.append(L)}if(this.shouldDrawMenu("View")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:S});this.setMenuById(S,"View"),o.append(L)}if(this.shouldDrawMenu("Go")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:S});this.setMenuById(S,"Go"),o.append(L)}if(this.shouldDrawMenu("Run")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:S});this.setMenuById(S,"Run"),o.append(L)}if(this.shouldDrawMenu("Terminal")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:S});this.setMenuById(S,"Terminal"),o.append(L)}let y;if(this.shouldDrawMenu("Window")){const S=new w.Menu;y=new w.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:S,role:"window"}),this.setMacWindowMenu(S)}if(y&&o.append(y),this.shouldDrawMenu("Help")){const S=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:S,role:"help"});this.setMenuById(S,"Help"),o.append(L)}o.items&&o.items.length>0?w.Menu.setApplicationMenu(o):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const o=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const Q=new w.Menu;this.setMenuById(Q,"Preferences"),y=new w.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:Q})}const S=new w.Menu,L=new w.MenuItem({label:d.localize(12,null),role:"services",submenu:S}),T=new w.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),B=new w.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new w.MenuItem({label:d.localize(15,null),role:"unhide"}),ee=new w.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),te=[o];te.push(...l),y&&te.push(r(),y),te.push(r(),L,r(),T,B,Y,r(),ee),te.forEach(Q=>s.append(Q))}shouldDrawMenu(s){if(!M.isMacintosh&&(0,m.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,o){o.forEach(l=>{if((0,p.isMenubarMenuItemSeparator)(l))s.append(r());else if((0,p.isMenubarMenuItemSubmenu)(l)){const y=new w.Menu,S=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:y});this.setMenu(y,l.submenu.items),s.append(S)}else(0,p.isMenubarMenuItemRecentAction)(l)?s.append(this.createOpenRecentMenuItem(l)):(0,p.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?s.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):s.append(this.createMenuItem(l.label,l.id,!1,l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(s,o){this.menubarMenus&&this.menubarMenus[o]&&this.setMenu(s,this.menubarMenus[o].items)}insertCheckForUpdatesItems(s){const o=this.getUpdateMenuItems();o.length&&(o.forEach(l=>s.append(l)),s.append(r()))}createOpenRecentMenuItem(s){const o=b.URI.revive(s.uri),l=s.id,y=l==="openRecentFile"?{fileUri:o}:l==="openRecentWorkspace"?{workspaceUri:o}:{folderUri:o};return new w.MenuItem(this.likeAction(l,{label:s.label,click:(S,L,T)=>{const B=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:B,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([o])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,o,l){const y={label:this.mnemonicLabel(s),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(o,y))}setMacWindowMenu(s){const o=new w.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new w.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),S=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(r()),L.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[o,l,r(),S,...L,r(),y].forEach(T=>s.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,o,l,y){const S=this.mnemonicLabel(s),L=typeof o=="function"?o:(te,Q,q)=>{const G=te?te.userSettingsLabel:null;let _=o;Array.isArray(o)&&(_=this.isOptionClick(q)?o[1]:o[0]),G&&q.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:G}):this.runActionInRenderer({type:"commandId",commandId:_})},T=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,B=typeof y=="boolean"?y:!1,Y={label:S,click:L,enabled:T};B&&(Y.type="checkbox",Y.checked=B);let ee;return typeof o=="string"?ee=o:Array.isArray(o)&&(ee=o[0]),M.isMacintosh&&(ee==="editor.action.clipboardCutAction"?Y.role="cut":ee==="editor.action.clipboardCopyAction"?Y.role="copy":ee==="editor.action.clipboardPasteAction"&&(Y.role="paste"),ee==="undo"?Y.click=this.makeContextAwareClickHandler(L,{inDevTools:te=>te.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?Y.click=this.makeContextAwareClickHandler(L,{inDevTools:te=>te.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(Y.click=this.makeContextAwareClickHandler(L,{inDevTools:te=>te.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(ee,Y))}makeContextAwareClickHandler(s,o){return(l,y,S)=>{const L=w.BrowserWindow.getFocusedWindow();if(!L)return o.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return o.inDevTools(L.webContents.devToolsWebContents);s(l,y||L,S)}}runActionInRenderer(s){let o=w.BrowserWindow.getFocusedWindow();if(!o){const y=this.windowsMainService.getLastActiveWindow();y?.isMinimized()&&(o=y.win)}const l=o?this.windowsMainService.getWindowById(o.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const y={id:s.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",R.CancellationToken.None,y)}else{const y={userSettingsLabel:s.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",R.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,o){const l=typeof s=="string"?this.keybindings[s]:void 0;if(l?.label){if(l.isNative!==!1)o.accelerator=l.label,o.userSettingsLabel=l.userSettingsLabel;else if(typeof o.label=="string"){const y=o.label.indexOf("[");y>=0?o.label=`${o.label.substr(0,y)} [${l.label}]`:o.label=`${o.label} [${l.label}]`}}else o.accelerator=void 0;return o}likeAction(s,o,l=!o.accelerator){l&&(o=this.withKeybinding(s,o));const y=o.click;return o.click=(S,L,T)=>{this.reportMenuActionTelemetry(s),y&&y(S,L,T)},o}openUrl(s,o){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(o)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:a})}mnemonicLabel(s){return(0,D.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};g.lastKnownMenubarStorageKey="lastKnownMenubarData",g=ue([ie(0,C.IUpdateService),ie(1,E.IConfigurationService),ie(2,u.IWindowsMainService),ie(3,P.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,c.IWorkspacesHistoryMainService),ie(6,f.IStateMainService),ie(7,k.ILifecycleMainService),ie(8,I.ILogService),ie(9,t.INativeHostMainService),ie(10,h.IProductService)],g),e.Menubar=g;function r(){return new w.MenuItem({type:"separator"})}}),define(J[244],Z([0,1,5,18,6,243]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let M=class{constructor(d,E,P){this.instantiationService=d,this.lifecycleMainService=E,this.logService=P,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(d,E){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(E,d)}};M=ue([ie(0,w.IInstantiationService),ie(1,n.ILifecycleMainService),ie(2,R.ILogService)],M),e.MenubarMainService=M}),define(J[245],Z([0,1,12,29,26,30,23,4,28,43,32,2,10,7,63,3,36,17,14,8,158,51,19,47,22,20,5,18,6,53,21,54,78,38,66,242,102,225,25,103,67,42]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a,g,r,i,s,o,l,y,S,L,T,B,Y,ee,te,Q,q,G,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(z){return(0,q.isWorkspaceIdentifier)(z?.workspace)}function V(z){return(0,q.isSingleFolderWorkspaceIdentifier)(z?.workspace)}let X=class st extends k.Disposable{constructor(O,U,W,A,F,N,K,se,ae,ce,ne,le,he,we,be){super();this.machineId=O,this.initialUserEnv=U,this.logService=W,this.stateMainService=A,this.environmentMainService=F,this.lifecycleMainService=N,this.backupMainService=K,this.configurationService=se,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=ce,this.instantiationService=ne,this.dialogMainService=le,this.fileService=he,this.productService=we,this.protocolMainService=be,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(O=>this._onDidSignalReadyWindow.fire(O.window))),this._register(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const U=new k.DisposableStore;if(U.add(b.Event.any(O.onDidClose,O.onDidDestroy)(()=>U.dispose())),O.config.extensionDevelopmentPath)for(const W of O.config.extensionDevelopmentPath)U.add(this.protocolMainService.addValidFileRoot(W));O.config.extensionTestsPath&&U.add(this.protocolMainService.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,U){let W=this.environmentMainService.args;const A=U?.remoteAuthority||void 0,F=!0,N=U?.forceReuseWindow,K=!N;return this.open({...O,cli:W,forceEmpty:F,forceNewWindow:K,forceReuseWindow:N,remoteAuthority:A})}openExistingWindow(O,U){O.focus(),this.handleWaitMarkerFile(U,[O])}open(O){this.logService.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const U=[],W=[],A=[],F=[],N=[];let K,se=0;const ae=this.getPathsToOpen(O);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const he of ae)V(he)?O.addMode?U.push(he):W.push(he):$(he)?A.push(he):he.fileUri?(K||(K={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),K.filesToOpenOrCreate.push(he)):he.backupPath?N.push({backupFolder:(0,p.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):se++;O.diffMode&&K&&K.filesToOpenOrCreate.length>=2&&(K.filesToDiff=K.filesToOpenOrCreate.slice(0,2),K.filesToOpenOrCreate=[]),K&&O.waitMarkerFileURI&&(K.filesToWait={paths:[...K.filesToDiff,...K.filesToOpenOrCreate],waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(F.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...F),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:ce,filesOpenedInWindow:ne}=this.doOpen(O,A,W,N,se,K,U);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${W.length}, emptyToRestore: ${N.length}, emptyToOpen: ${se})`),ce.length>1)if(ne)ne.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let we=!0,be=!0;if(he){const Ce=ce.filter(ye=>this.windowsStateHandler.state.lastActiveWindow&&ye.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),we=!1,be=!1)}if(we)for(let Ce=ce.length-1;Ce>=0;Ce--){const ye=ce[Ce];if(!(ye.openedWorkspace&&F.some(pe=>ye.openedWorkspace&&pe.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&N.some(pe=>ye.backupPath&&pe.backupFolder===(0,p.basename)(ye.backupPath)))){ye.focus(),be=!1;break}}be&&ce[ce.length-1].focus()}const le=K&&K.filesToDiff.length>0;if(!ce.some(he=>he.isExtensionDevelopmentHost)&&!le&&!O.noRecentEntry){const he=[];for(const we of ae)$(we)&&!we.transient?he.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):V(we)?he.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&he.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(O,ce),ce}handleWaitMarkerFile(O,U){const W=O.waitMarkerFileURI;O.context===0&&W&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.fileService.del(W)}catch{}})()}doOpen(O,U,W,A,F,N,K){const se=[];let ae;function ce(ye,pe){se.push(ye),pe&&(ae=ye,N=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:le}=this.shouldOpenNewWindow(O);if(!O.initialStartup&&K.length>0){const ye=K[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(ye);pe&&ce(this.doAddFoldersToExistingWindow(pe,K.map(Ee=>Ee.workspace.uri)))}const he=W.length+U.length+A.length;if(N&&he===0){const ye=N.filesToOpenOrCreate[0]||N.filesToDiff[0],pe=this.getWindows().filter(Le=>N&&(0,v.isEqualAuthority)(Le.remoteAuthority,N.remoteAuthority));let Ee;ye?.fileUri&&!le&&((O.context===4||O.context===0||O.context===1)&&(Ee=(0,te.findWindowOnFile)(pe,ye.fileUri,Le=>Le.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(pe))),Ee?(0,q.isWorkspaceIdentifier)(Ee.openedWorkspace)?U.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,q.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?W.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(O,Ee,N),!0):ce(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow}),!0)}const we=(0,D.distinct)(U,ye=>ye.workspace.id);if(we.length>0){const ye=(0,D.coalesce)(we.map(pe=>(0,te.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(ye.length>0){const pe=ye[0],Ee=(0,v.isEqualAuthority)(N?.remoteAuthority,pe.remoteAuthority)?N:void 0;ce(this.doOpenFilesInExistingWindow(O,pe,Ee),!!Ee),ne=!0}we.forEach(pe=>{if(ye.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===pe.workspace.id))return;const Ee=pe.remoteAuthority,Le=(0,v.isEqualAuthority)(N?.remoteAuthority,Ee)?N:void 0;ce(this.doOpenFolderOrWorkspace(O,pe,ne,Le),!!Le),ne=!0})}const be=(0,D.distinct)(W,ye=>v.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(be.length>0){const ye=(0,D.coalesce)(be.map(pe=>(0,te.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(ye.length>0){const pe=ye[0],Ee=(0,v.isEqualAuthority)(N?.remoteAuthority,pe.remoteAuthority)?N:void 0;ce(this.doOpenFilesInExistingWindow(O,pe,Ee),!!Ee),ne=!0}be.forEach(pe=>{if(ye.some(Ne=>(0,q.isSingleFolderWorkspaceIdentifier)(Ne.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ne.openedWorkspace.uri,pe.workspace.uri)))return;const Ee=pe.remoteAuthority,Le=(0,v.isEqualAuthority)(N?.remoteAuthority,Ee)?N:void 0;ce(this.doOpenFolderOrWorkspace(O,pe,ne,Le),!!Le),ne=!0})}const Ce=(0,D.distinct)(A,ye=>ye.backupFolder);if(Ce.length>0&&Ce.forEach(ye=>{const pe=ye.remoteAuthority,Ee=(0,v.isEqualAuthority)(N?.remoteAuthority,pe)?N:void 0;ce(this.doOpenEmpty(O,!0,pe,Ee,ye),!!Ee),ne=!0}),se.length===0||N){N&&!F&&F++;const ye=N?N.remoteAuthority:O.remoteAuthority;for(let pe=0;pe<F;pe++)ce(this.doOpenEmpty(O,ne,ye,N),!!N),ne=!0}return{windows:(0,D.distinct)(se),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(O,U,W){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),U.focus();const A={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToWait:W?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",M.CancellationToken.None,A),U}doAddFoldersToExistingWindow(O,U){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),O.focus();const W={foldersToAdd:U};return O.sendWhenReady("vscode:addFolders",M.CancellationToken.None,W),O}doOpenEmpty(O,U,W,A,F){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!F,remoteAuthority:W,filesToOpen:A,forceNewWindow:U});let N;return!U&&typeof O.contextWindowId=="number"&&(N=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:W,forceNewWindow:U,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:A,windowToUse:N,emptyWindowBackupInfo:F})}doOpenFolderOrWorkspace(O,U,W,A,F){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:A}),!W&&!F&&typeof O.contextWindowId=="number"&&(F=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({workspace:U.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:A,windowToUse:F})}getPathsToOpen(O){let U,W=!1,A=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(U=this.doExtractPathsFromAPI(O),W=!0):O.forceEmpty?U=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(U=this.doExtractPathsFromCLI(O.cli),U.length===0&&U.push(Object.create(null)),W=!0):(U=this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),A=!0),!O.addMode&&W){const F=U.filter(N=>V(N));if(F.length>1){const N=F[0].remoteAuthority;if(F.every(K=>(0,v.isEqualAuthority)(K.remoteAuthority,N))){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(F.map(se=>({uri:se.workspace.uri})));U.push({workspace:K,remoteAuthority:N}),U=U.filter(se=>!V(se))}}}return O.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&U.unshift(...this.doGetPathsFromLastSession().filter(F=>$(F)||V(F)||F.backupPath)),U}doExtractPathsFromAPI(O){const U=[],W={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority};for(const A of(0,D.coalesce)(O.urisToOpen||[])){const F=this.resolveOpenable(A,W);if(F)F.label=A.label,U.push(F);else{const N=this.resourceFromOpenable(A),K={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:N.scheme===I.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:N.scheme===I.Schemas.file?(0,u.localize)(3,null,(0,P.getPathLabel)(N.fsPath,this.environmentMainService)):(0,u.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(K,(0,C.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return U}doExtractPathsFromCLI(O){const U=[],W={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:!1},A=O["folder-uri"];if(A)for(const K of A){const se=this.cliArgToUri(K);if(se){const ae=this.resolveOpenable({folderUri:se},W);ae&&U.push(ae)}}const F=O["file-uri"];if(F)for(const K of F){const se=this.cliArgToUri(K);if(se){const ae=this.resolveOpenable((0,q.hasWorkspaceFileExtension)(K)?{workspaceUri:se}:{fileUri:se},W);ae&&U.push(ae)}}const N=O._;for(const K of N){const se=W.remoteAuthority?this.doResolvePathRemote(K,W):this.doResolveFilePath(K,W);se&&U.push(se)}return U}cliArgToUri(O){try{const U=m.URI.parse(O);if(!U.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${O}`);return}return U}catch(U){this.logService.error(`Invalid URI input string: ${O}, ${U.message}`)}}doGetPathsFromLastSession(){const O=this.getRestoreWindowsSetting();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];O!=="one"&&U.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&U.push(this.windowsStateHandler.state.lastActiveWindow);const W=[];for(const A of U)if(A.workspace){const F=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});$(F)&&W.push(F)}else if(A.folderUri){const F=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});V(F)&&W.push(F)}else O!=="folders"&&A.backupPath&&W.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return W}}}getRestoreWindowsSetting(){let O;return this.lifecycleMainService.wasRestarted?O="all":(O=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}resolveOpenable(O,U=Object.create(null)){let W=this.resourceFromOpenable(O);return W.scheme===I.Schemas.file?((0,Y.isFileToOpen)(O)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(W.fsPath,U)):this.doResolveRemoteOpenable(O,U)}doResolveRemoteOpenable(O,U){let W=this.resourceFromOpenable(O);const A=(0,T.getRemoteAuthority)(W)||U.remoteAuthority;if(W=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(W)),(0,Y.isFileToOpen)(O)){if(U.gotoLineMode){const{path:F,line:N,column:K}=(0,d.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:F}),selection:N?{startLineNumber:N,startColumn:K||1}:void 0,remoteAuthority:A}}return{fileUri:W,remoteAuthority:A}}else if((0,Y.isWorkspaceToOpen)(O))return{workspace:(0,G.getWorkspaceIdentifier)(W),remoteAuthority:A};return{workspace:(0,G.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:A}}resourceFromOpenable(O){return(0,Y.isWorkspaceToOpen)(O)?O.workspaceUri:(0,Y.isFolderToOpen)(O)?O.folderUri:O.fileUri}doResolveFilePath(O,U){let W,A;U.gotoLineMode&&({path:O,line:W,column:A}=(0,d.parseLineAndColumnAware)(O)),O=(0,d.sanitizeFilePath)((0,p.normalize)(O),(0,f.cwd)());try{const F=(0,n.statSync)(O);if(F.isFile()){if(!U.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(m.URI.file(O));if(N)return N.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:i.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:m.URI.file(O),type:i.FileType.File,exists:!0,selection:W?{startLineNumber:W,startColumn:A||1}:void 0}}else{if(F.isDirectory())return{workspace:(0,G.getSingleFolderWorkspaceIdentifier)(m.URI.file(O),F),type:i.FileType.Directory,exists:!0};if(!h.isWindows&&O==="/dev/null")return{fileUri:m.URI.file(O),type:i.FileType.File,exists:!0}}}catch{const N=m.URI.file(O);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),U.ignoreFileNotFound)return{fileUri:N,type:i.FileType.File,exists:!1}}}doResolvePathRemote(O,U){const W=O.charCodeAt(0),A=U.remoteAuthority;let F,N;U.gotoLineMode&&({path:O,line:F,column:N}=(0,d.parseLineAndColumnAware)(O)),W!==47&&((0,d.isWindowsDriveLetter)(W)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,d.toSlashes)(O)),O=`/${O}`);const K=m.URI.from({scheme:I.Schemas.vscodeRemote,authority:A,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,q.hasWorkspaceFileExtension)(O))return U.forceOpenWorkspaceAsFile?{fileUri:K,selection:F?{startLineNumber:F,startColumn:N||1}:void 0,remoteAuthority:U.remoteAuthority}:{workspace:(0,G.getWorkspaceIdentifier)(K),remoteAuthority:A};if(U.gotoLineMode||p.posix.basename(O).indexOf(".")!==-1)return{fileUri:K,selection:F?{startLineNumber:F,startColumn:N||1}:void 0,remoteAuthority:A}}return{workspace:(0,G.getSingleFolderWorkspaceIdentifier)(K),remoteAuthority:A}}shouldOpenNewWindow(O){const U=this.configurationService.getValue("window"),W=U?.openFoldersInNewWindow||"default",A=U?.openFilesInNewWindow||"off";let F=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(W==="on"||W==="off")&&(F=W==="on");let N=!1;return O.forceNewWindow||O.forceReuseWindow?N=!!O.forceNewWindow&&!O.forceReuseWindow:(h.isMacintosh?O.context===1&&(N=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!O.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(N=A==="on")),{openFolderInNewWindow:!!F,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(O,U){const W=(0,te.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(W)return this.lifecycleMainService.reload(W,U.cli),W.focus(),[W];let A=U.cli["folder-uri"]||[],F=U.cli["file-uri"]||[],N=U.cli._;if(!N.length&&!A.length&&!F.length&&!U.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=ce&&(ce.workspace||ce.folderUri);ne&&(m.URI.isUri(ne)?ne.scheme===I.Schemas.file?N=[ne.fsPath]:A=[ne.toString()]:ne.configPath.scheme===I.Schemas.file?N=[(0,v.originalFSPath)(ne.configPath)]:F=[ne.configPath.toString()])}let K=U.remoteAuthority;for(const ce of O)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=m.URI.parse(ce),le=(0,T.getRemoteAuthority)(ne);le&&(K?(0,v.isEqualAuthority)(le,K)||this.logService.error("more than one extension development path authority"):K=le)}N=N.filter(ce=>{const ne=m.URI.file(ce);return(0,te.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(ne),K)}),A=A.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,te.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(ne),K):!1}),F=F.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,te.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(ne),K):!1}),U.cli._=N,U.cli["folder-uri"]=A,U.cli["file-uri"]=F;const se=!N.length&&!A.length&&!F.length,ae={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:se,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:K};return this.open(ae)}openInBrowserWindow(O){const U=this.configurationService.getValue("window"),W={...this.environmentMainService.args,...O.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.initialUserEnv,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:y.default,isInitialStartup:O.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof U?.zoomLevel=="number"?U.zoomLevel:void 0,autoDetectHighContrast:U?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let A;if(!O.forceNewWindow&&!O.forceNewTabbedWindow&&(A=O.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const F=A.config;!W.extensionDevelopmentPath&&F&&!!F.extensionDevelopmentPath&&(W.extensionDevelopmentPath=F.extensionDevelopmentPath,W.verbose=F.verbose,W["inspect-brk-extensions"]=F["inspect-brk-extensions"],W.debugId=F.debugId,W.extensionEnvironment=F.extensionEnvironment,W["inspect-extensions"]=F["inspect-extensions"],W["extensions-dir"]=F["extensions-dir"])}else{const F=this.windowsStateHandler.getNewWindowState(W);(0,t.mark)("code/willCreateCodeWindow");const N=A=this.instantiationService.createInstance(ee.CodeWindow,{state:F,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(N)}st.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,E.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,E.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,E.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const K=(0,C.assertIsDefined)(N.win?.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return W.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(F=>{F||this.doOpenInBrowserWindow(A,W,O)}):this.doOpenInBrowserWindow(A,W,O),A}doOpenInBrowserWindow(O,U,W){if(!U.extensionDevelopmentPath)if((0,q.isWorkspaceIdentifier)(U.workspace))U.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:U.workspace,remoteAuthority:U.remoteAuthority});else if((0,q.isSingleFolderWorkspaceIdentifier)(U.workspace))U.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority});else{const A=W.emptyWindowBackupInfo&&W.emptyWindowBackupInfo.backupFolder;U.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,U.remoteAuthority)}O.load(U)}onWindowClosed(O){const U=st.WINDOWS.indexOf(O);st.WINDOWS.splice(U,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=w.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(O){return this.doGetLastActiveWindow(this.getWindows().filter(U=>(0,v.isEqualAuthority)(U.remoteAuthority,O)))}doGetLastActiveWindow(O){const U=Math.max.apply(Math,O.map(W=>W.lastFocusTime));return O.find(W=>W.lastFocusTime===U)}sendToFocused(O,...U){const W=this.getFocusedWindow()||this.getLastActiveWindow();W&&W.sendWhenReady(O,M.CancellationToken.None,...U)}sendToAll(O,U,W){for(const A of this.getWindows())W&&W.indexOf(A.id)>=0||A.sendWhenReady(O,M.CancellationToken.None,U)}getWindows(){return st.WINDOWS}getWindowCount(){return st.WINDOWS.length}getWindowById(O){const U=this.getWindows().filter(W=>W.id===O);return(0,D.firstOrDefault)(U)}getWindowByWebContents(O){const U=w.BrowserWindow.fromWebContents(O);if(!!U)return this.getWindowById(U.id)}};X.WINDOWS=[],X=ue([ie(2,l.ILogService),ie(3,B.IStateMainService),ie(4,r.IEnvironmentMainService),ie(5,o.ILifecycleMainService),ie(6,c.IBackupMainService),ie(7,a.IConfigurationService),ie(8,_.IWorkspacesHistoryMainService),ie(9,x.IWorkspacesManagementMainService),ie(10,s.IInstantiationService),ie(11,g.IDialogMainService),ie(12,i.IFileService),ie(13,S.IProductService),ie(14,L.IProtocolMainService)],X),e.WindowsMainService=X}),define(J[246],Z([0,1,51,34,67,42]),function(H,e,w,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(d,E,P,k){this.workspacesManagementMainService=d,this.windowsMainService=E,this.workspacesHistoryMainService=P,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,E){const P=this.windowsMainService.getWindowById(d);if(P)return this.workspacesManagementMainService.enterWorkspace(P,this.windowsMainService.getWindows(),E)}createUntitledWorkspace(d,E,P){return this.workspacesManagementMainService.createUntitledWorkspace(E,P)}deleteUntitledWorkspace(d,E){return this.workspacesManagementMainService.deleteUntitledWorkspace(E)}getWorkspaceIdentifier(d,E){return this.workspacesManagementMainService.getWorkspaceIdentifier(E)}getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}addRecentlyOpened(d,E){return this.workspacesHistoryMainService.addRecentlyOpened(E)}removeRecentlyOpened(d,E){return this.workspacesHistoryMainService.removeRecentlyOpened(E)}clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ue([ie(0,D.IWorkspacesManagementMainService),ie(1,n.IWindowsMainService),ie(2,R.IWorkspacesHistoryMainService),ie(3,w.IBackupMainService)],M),e.WorkspacesMainService=M}),define(J[247],Z([0,1,12,29,26,16,39,15,28,43,44,32,2,10,7,3,14,8,31,71,126,37,129,89,220,139,51,229,19,74,194,168,75,104,47,230,92,166,22,50,98,174,195,175,226,93,176,177,20,189,77,73,5,76,239,205,105,18,6,191,244,58,21,78,234,79,38,223,81,206,33,208,210,64,41,214,237,240,238,241,100,215,216,217,218,221,34,245,222,25,80,67,246,42]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a,g,r,i,s,o,l,y,S,L,T,B,Y,ee,te,Q,q,G,_,x,$,V,X,z,O,U,W,A,F,N,K,se,ae,ce,ne,le,he,we,be,Ce,ye,pe,Ee,Le,Ne,Ze,Fe,ze,Ge,ot,wt,tt,Ye,He,Qe,j,re,oe,fe,Se,Re,Oe,Ke,Ve,Ae,qe,je,xe,it,kt,Lt,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends I.Disposable{constructor(de,me,ve,ge,Pe,De,Me,Ie,ke,We){super();this.mainProcessNodeIpcServer=de,this.userEnv=me,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ie,this.fileService=ke,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const de=Ie=>Ie?.startsWith(`${p.Schemas.vscodeWebview}://`),me=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ie,ke,We,_e)=>de(_e.requestingUrl)?We(me.has(ke)):We(!1)),w.session.defaultSession.setPermissionCheckHandler((Ie,ke,We,_e)=>de(_e.requestingUrl)?me.has(ke):!1);const ve=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,"devtools"]),ge=Ie=>{for(let ke=Ie;ke;ke=ke.parent)if(ke.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ie=>Ie.resourceType==="xhr"||ge(Ie.frame),De=Ie=>{const ke=Ie.frame;if(!ke||!this.windowsMainService)return!1;const We=w.BrowserWindow.getAllWindows();for(const _e of We)if(ke.processId===_e.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ie,ke)=>{const We=v.URI.parse(Ie.url);return We.scheme===p.Schemas.vscodeFileResource&&!De(Ie)?(this.logService.error("Blocked vscode-file request",Ie.url),ke({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?ke({cancel:!Pe(Ie)}):ke({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ie,ke)=>{const We=Ie.responseHeaders,_e=We["content-type"]||We["Content-Type"];if(_e&&Array.isArray(_e)){const Xe=v.URI.parse(Ie.url);if(Xe.path.endsWith(".svg")&&ve.has(Xe.scheme))return We["Content-Type"]=["image/svg+xml"],ke({cancel:!1,responseHeaders:We});if(!Xe.path.includes(p.Schemas.vscodeRemoteResource)&&_e.some(et=>et.toLowerCase().includes("image/svg")))return ke({cancel:!Pe(Ie)})}return ke({cancel:!1})});const Me=w.session.defaultSession;typeof Me.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Me.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,b.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,b.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),w.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ge.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let de=[],me;w.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),me!==void 0&&(clearTimeout(me),me=void 0),me=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],me=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let Pe,De;return ge?.config?(Pe=ge.config,De={...process.env,...ge.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),w.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Pe)=>{const De=this.validateNlsPath([ge]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,D.VSBuffer.fromString(Pe))}),w.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Pe=this.validateNlsPath(ge);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let me;for(const ve of de)typeof ve=="string"&&(typeof me!="string"?me=ve:me=(0,t.join)(me,ve));if(!(typeof me!="string"||!(0,t.isAbsolute)(me)||!(0,d.isEqualOrParent)(me,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return v.URI.file(me)}onUnexpectedError(de){if(de){const me={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(me))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;h.isWindows&&de&&w.app.setAppUserModelId(de);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const me=new a.Server;this.lifecycleMainService.onWillShutdown(ke=>{ke.reason===2&&me.dispose()}),this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(ve),Me=await this.initServices(ve,ge,Pe);if(this.environmentMainService.driverHandle){const ke=await(0,ee.serve)(me,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(ke=>this.initChannels(ke,me,De));const Ie=Me.invokeFunction(ke=>this.openFirstWindow(ke,me));Me.invokeFunction(ke=>this.afterWindowOpen(ke,ge)),this.environmentMainService.args.trace&&Me.invokeFunction(ke=>this.stopTracingEventually(ke,Ie))}async resolveMachineId(){let de=this.stateMainService.getItem(Ge.machineIdKey);return(!de||h.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,m.getMachineId)(),this.stateMainService.setItem(Ge.machineIdKey,de)),de}setupSharedProcess(de){const me=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await me.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new g.Client(Pe,"main")})(),ge=(async()=>(await me.whenReady(),ve))();return{sharedProcess:me,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,me,ve){const ge=new se.ServiceCollection;switch(process.platform){case"win32":ge.set(Ye.IUpdateService,new N.SyncDescriptor(oe.Win32UpdateService));break;case"linux":h.isLinuxSnap?ge.set(Ye.IUpdateService,new N.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Ye.IUpdateService,new N.SyncDescriptor(j.LinuxUpdateService));break;case"darwin":ge.set(Ye.IUpdateService,new N.SyncDescriptor(Qe.DarwinUpdateService));break}ge.set(Ae.IWindowsMainService,new N.SyncDescriptor(qe.WindowsMainService,[de,this.userEnv])),ge.set(Y.IDialogMainService,new N.SyncDescriptor(Y.DialogMainService)),ge.set(ne.ILaunchMainService,new N.SyncDescriptor(ne.LaunchMainService)),ge.set(B.IDiagnosticsMainService,new N.SyncDescriptor(B.DiagnosticsMainService)),ge.set(T.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ae.IIssueMainService,new N.SyncDescriptor(ae.IssueMainService,[this.userEnv])),ge.set(te.IEncryptionMainService,new N.SyncDescriptor(Q.EncryptionMainService,[de])),ge.set(ce.IKeyboardLayoutMainService,new N.SyncDescriptor(ce.KeyboardLayoutMainService)),ge.set(Ce.INativeHostMainService,new N.SyncDescriptor(Ce.NativeHostMainService,[me])),ge.set(y.ICredentialsMainService,new N.SyncDescriptor(S.CredentialsMainService,[!1])),ge.set(Ke.IWebviewManagerService,new N.SyncDescriptor(Ve.WebviewMainService)),ge.set(it.IWorkspacesService,new N.SyncDescriptor(Lt.WorkspacesMainService)),ge.set(Pt.IWorkspacesManagementMainService,new N.SyncDescriptor(Pt.WorkspacesManagementMainService)),ge.set(kt.IWorkspacesHistoryMainService,new N.SyncDescriptor(kt.WorkspacesHistoryMainService)),ge.set(be.IMenubarMainService,new N.SyncDescriptor(be.MenubarMainService)),ge.set(x.IExtensionUrlTrustService,new N.SyncDescriptor($.ExtensionUrlTrustService)),ge.set(V.IExtensionHostStarter,new N.SyncDescriptor(X.WorkerMainProcessExtensionHostStarter)),ge.set(Fe.IStorageMainService,new N.SyncDescriptor(Fe.StorageMainService)),ge.set(Fe.IGlobalStorageMainService,new N.SyncDescriptor(Fe.GlobalStorageMainService)),h.isWindows?ge.set(z.IExternalTerminalMainService,new N.SyncDescriptor(O.WindowsExternalTerminalService)):h.isMacintosh?ge.set(z.IExternalTerminalMainService,new N.SyncDescriptor(O.MacExternalTerminalService)):h.isLinux&&ge.set(z.IExternalTerminalMainService,new N.SyncDescriptor(O.LinuxExternalTerminalService));const Pe=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(s.IBackupMainService,Pe),ge.set(fe.IURLService,new N.SyncDescriptor(Re.NativeURLService)),(0,tt.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(_e=>_e.getChannel("telemetryAppender"))),Me=new ot.TelemetryAppenderClient(De),Ie=(0,ze.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=(0,tt.getPiiPathsFromEnvironment)(this.environmentMainService),We={appenders:[Me],commonProperties:Ie,piiPaths:ke,sendErrorTelemetry:!0};ge.set(Ge.ITelemetryService,new N.SyncDescriptor(wt.TelemetryService,[We]))}else ge.set(Ge.ITelemetryService,tt.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,me,ve){const ge=c.ProxyChannel.fromService(de.get(ne.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Pe=c.ProxyChannel.fromService(de.get(B.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Pe);const De=this.fileService.getProvider(p.Schemas.file);(0,f.assertType)(De instanceof F.DiskFileSystemProvider);const Me=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);me.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ve.then(Be=>Be.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const Ie=new He.UpdateChannel(de.get(Ye.IUpdateService));me.registerChannel("update",Ie);const ke=c.ProxyChannel.fromService(de.get(ae.IIssueMainService));me.registerChannel("issue",ke);const We=c.ProxyChannel.fromService(de.get(te.IEncryptionMainService));me.registerChannel("encryption",We);const _e=c.ProxyChannel.fromService(de.get(y.ICredentialsMainService));me.registerChannel("credentials",_e);const Xe=c.ProxyChannel.fromService(de.get(Le.ISignService));me.registerChannel("sign",Xe);const et=c.ProxyChannel.fromService(de.get(ce.IKeyboardLayoutMainService));me.registerChannel("keyboardLayout",et),this.nativeHostMainService=de.get(Ce.INativeHostMainService);const ut=c.ProxyChannel.fromService(this.nativeHostMainService);me.registerChannel("nativeHost",ut),ve.then(Be=>Be.registerChannel("nativeHost",ut));const vt=c.ProxyChannel.fromService(de.get(it.IWorkspacesService));me.registerChannel("workspaces",vt);const Ue=c.ProxyChannel.fromService(de.get(be.IMenubarMainService));me.registerChannel("menubar",Ue);const ht=c.ProxyChannel.fromService(de.get(fe.IURLService));me.registerChannel("url",ht);const at=c.ProxyChannel.fromService(de.get(x.IExtensionUrlTrustService));me.registerChannel("extensionUrlTrust",at);const ct=c.ProxyChannel.fromService(de.get(Ke.IWebviewManagerService));me.registerChannel("webview",ct);const lt=this._register(new Ze.StorageDatabaseChannel(this.logService,de.get(Fe.IStorageMainService)));me.registerChannel("storage",lt),ve.then(Be=>Be.registerChannel("storage",lt));const dt=c.ProxyChannel.fromService(de.get(z.IExternalTerminalMainService));me.registerChannel("externalTerminal",dt);const nt=new we.LogLevelChannel(de.get(he.ILogService));me.registerChannel("logLevel",nt),ve.then(Be=>Be.registerChannel("logLevel",nt));const rt=new we.LoggerChannel(de.get(he.ILoggerService));me.registerChannel("logger",rt),ve.then(Be=>Be.registerChannel("logger",rt));const ft=new L.ElectronExtensionHostDebugBroadcastChannel(de.get(Ae.IWindowsMainService));me.registerChannel("extensionhostdebugservice",ft);const Te=c.ProxyChannel.fromService(de.get(V.IExtensionHostStarter));me.registerChannel(V.ipcExtensionHostStarterChannelName,Te)}openFirstWindow(de,me){const ve=this.windowsMainService=de.get(Ae.IWindowsMainService),ge=de.get(fe.IURLService),Pe=de.get(Ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:v.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(Te.uri);return Be?(De.push(Be),!1):!0}),Ie=this,ke=this.environmentMainService,We=this.productService,_e=this.logService;ge.registerHandler({async handleURL(Te,Be){if(_e.trace("app#handleURL: ",Te.toString(!0),Be),Te.scheme===We.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:v.URI.parse(Te.query).path,query:""})),Ie.shouldBlockURI(Te))return!0;const St=Ie.getWindowOpenableFromProtocolLink(Te);if(_e.trace("app#handleURL: windowOpenableFromProtocolLink = ",St),St){const[yt]=ve.open({context:5,cli:{...ke.args},urisToOpen:[St],gotoLineMode:!0});return yt.focus(),!0}if(h.isMacintosh&&ve.getWindowCount()===0){const[yt]=ve.open({context:5,cli:{...ke.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Te)});return await yt.ready(),ge.open(Te,Be)}return!1}});const Xe=this._register(new je.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),et=new c.StaticRouter(Te=>Xe.getActiveClientId().then(Be=>Te===Be)),ut=new Se.URLHandlerRouter(et),vt=me.getChannel("urlHandler",ut);ge.registerHandler(new Se.URLHandlerChannelClient(vt)),this._register(new Oe.ElectronURLListener(Me,ge,ve,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ht=global.macOpenFiles,at=(0,G.isLaunchedFromCli)(process.env)?0:4,ct=Ue._.length,lt=!!Ue["folder-uri"],dt=!!Ue["file-uri"],nt=Ue["skip-add-to-recently-opened"]===!0,rt=Ue.wait&&Ue.waitMarkerFilePath?v.URI.file(Ue.waitMarkerFilePath):void 0,ft=Ue.remote||void 0;return De.length>0?ve.open({context:at,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!ct&&!lt&&!dt?ve.open({context:at,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0,remoteAuthority:ft}):ht.length&&!ct&&!lt&&!dt?ve.open({context:1,cli:Ue,urisToOpen:ht.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0}):ve.open({context:at,cli:Ue,forceNewWindow:Ue["new-window"]||!ct&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:nt,waitMarkerFileURI:rt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ft})}shouldBlockURI(de){return!!(de.authority===p.Schemas.file&&h.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,k.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===p.Schemas.file){const me=v.URI.file(de.fsPath);return(0,xe.hasWorkspaceFileExtension)(me)?{workspaceUri:me}:{fileUri:me}}else if(de.authority===p.Schemas.vscodeRemote){const me=de.path.indexOf(t.posix.sep,1);if(me!==-1){const ve=de.path.substring(1,me),ge=de.path.substring(me),Pe=v.URI.from({scheme:p.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,xe.hasWorkspaceFileExtension)(ge)?{workspaceUri:Pe}:/:[\d]+$/.test(ge)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,xe.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,me){this.lifecycleMainService.phase=3;let ve=!1;(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ge.ITelemetryService);this._register(me.onDidError(({type:Me,details:Ie})=>{let ke;switch(Me){case 1:ke="SharedProcess: detected unresponsive window";break;case 2:ke=`SharedProcess: crashed (detail: ${Ie?.reason??"<unknown>"}, code: ${Ie?.exitCode??"<unknown>"})`;break;case 3:ke=`SharedProcess: failed to load (detail: ${Ie?.reason??"<unknown>"}, code: ${Ie?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(ke)),ge.publicLog2("sharedprocesserror",{type:Me,reason:Ie?.reason,code:Ie?.exitCode,visible:me.isVisible(),shuttingdown:ve})}));const Pe=this.productService.win32MutexName;if(h.isWindows&&Pe)try{const Me=H.__$__nodeRequire("windows-mutex").Mutex,Ie=new Me(Pe);(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>Ie.release())}catch(Me){this.logService.error(Me)}w.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Me,Ie)=>{Ie({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=de.get(Ye.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof j.LinuxUpdateService||De instanceof Qe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,P.stripComments)(Ie))["enable-crash-reporter"]===void 0){const _e=(0,tt.getTelemetryLevel)(this.configurationService)>=1,Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,C.generateUuid)()}"`,"}"],et=Ie.substring(0,Ie.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(et))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(de,me,ve){try{return await(0,_.getResolvedShellEnv)(this.logService,de,me)}catch(ge){const Pe=(0,M.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(de,me){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(Y.IDialogMainService);let ge=!1;const Pe=async Me=>{if(ge)return;ge=!0;const Ie=await w.contentTracing.stopRecording(`${(0,d.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ie}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ie),buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,f.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(me.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};pt=ue([ie(2,K.IInstantiationService),ie(3,he.ILogService),ie(4,q.IEnvironmentMainService),ie(5,le.ILifecycleMainService),ie(6,l.IConfigurationService),ie(7,Ne.IStateMainService),ie(8,W.IFileService),ie(9,ye.IProductService)],pt),e.CodeApplication=pt}),define(J[254],Z([0,1,12,29,30,9,39,15,28,43,32,10,7,63,3,36,27,24,37,57,247,11,19,199,207,22,50,171,20,187,77,73,182,76,18,95,6,192,96,53,21,54,196,99,236,56,233,79,204,38,235,64,65,213]),function(H,e,w,n,R,D,M,b,d,E,P,k,I,p,t,h,f,v,C,m,u,c,a,g,r,i,s,o,l,y,S,L,T,B,Y,ee,te,Q,q,G,_,x,$,V,X,z,O,U,W,A,F,N,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class se{main(){try{this.startup()}catch(ne){console.error(ne.message),w.app.exit(1)}}async startup(){(0,b.setUnexpectedErrorHandler)(pe=>console.error(pe));const[ne,le,he,we,be,Ce,ye]=this.createServices();try{try{await this.initServices(he,we,be)}catch(pe){throw this.handleStartupDataDirError(he,ye.nameLong,pe),pe}await ne.invokeFunction(async pe=>{const Ee=pe.get(te.ILogService),Le=pe.get(Y.ILifecycleMainService),Ne=pe.get(l.IFileService),Ze=await this.claimInstance(Ee,he,Le,ne,ye,!0);return v.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Fe=>{Ee.warn(`Error writing main lockfile: ${Fe.stack}`)}),Ce.logger=new q.SpdLogLogger("main",(0,I.join)(he.logsPath,"main.log"),!0,!1,Ce.getLevel()),(0,E.once)(Le.onWillShutdown)(Fe=>{Ne.dispose(),we.dispose(),Fe.join(v.Promises.unlink(he.mainLockfile).catch(()=>{}))}),ne.createInstance(u.CodeApplication,Ze,le).startup()})}catch(pe){ne.invokeFunction(this.quit,pe)}}createServices(){const ne=new B.ServiceCollection,le={_serviceBrand:void 0,...G.default};ne.set(_.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),we=this.patchEnvironment(he);ne.set(i.IEnvironmentMainService,he);const be=new ee.BufferLogService,Ce=new te.MultiplexLogService([new te.ConsoleMainLogger((0,te.getLogLevel)(he)),be]);process.once("exit",()=>Ce.dispose()),ne.set(te.ILogService,Ce);const ye=new y.FileService(Ce);ne.set(l.IFileService,ye);const pe=new S.DiskFileSystemProvider(Ce);ye.registerProvider(k.Schemas.file,pe),ne.set(te.ILoggerService,new Q.LoggerService(Ce,ye));const Ee=new g.ConfigurationService(he.settingsResource,ye);ne.set(a.IConfigurationService,Ee),ne.set(Y.ILifecycleMainService,new L.SyncDescriptor(Y.LifecycleMainService));const Le=new F.StateMainService(he,Ce,ye);return ne.set(A.IStateMainService,Le),ne.set(z.IRequestService,new L.SyncDescriptor(O.RequestMainService)),ne.set(K.IThemeMainService,new L.SyncDescriptor(K.ThemeMainService)),ne.set(U.ISignService,new L.SyncDescriptor(W.SignService)),ne.set(V.ITunnelService,new L.SyncDescriptor(X.TunnelService)),ne.set(x.IProtocolMainService,new L.SyncDescriptor($.ProtocolMainService)),[new T.InstantiationService(ne,!0),we,he,Ee,Le,be,le]}patchEnvironment(ne){const le={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const we=process.env[he];typeof we=="string"&&(le[he]=we)}),Object.assign(process.env,le),le}initServices(ne,le,he){return D.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(ne,le,he,we,be,Ce){let ye;try{(0,p.mark)("code/willStartMainServer"),ye=await(0,m.serve)(le.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,E.once)(he.onWillShutdown)(()=>ye.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,be.nameLong,pe),pe;let Ee;try{Ee=await(0,m.connect)(le.mainIPCHandle,"main")}catch(Fe){if(!Ce||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,be.nameShort),(0,c.localize)(1,null),be.nameLong),Fe;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch(ze){throw ne.warn("Could not delete obsolete instance handle",ze),ze}return this.claimInstance(ne,le,he,we,be,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Fe),Ee.dispose(),new Error(Fe)}let Le;!le.args.wait&&!le.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,be.nameShort),(0,c.localize)(3,null),be.nameLong)},1e4));const Ne=C.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0}),Ze=C.ProxyChannel.toService(Ee.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return we.invokeFunction(async()=>{const Fe=new r.DiagnosticsService(N.NullTelemetryService,be),ze=await Ne.getMainProcessInfo(),Ge=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ot=await Fe.getDiagnostics(ze,Ge);throw console.log(ot),new b.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,ne),ne.trace("Sending env to running instance..."),await Ne.start(le.args,process.env),Ee.dispose(),Le&&clearTimeout(Le),new b.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new b.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(ne,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const we=(0,R.coalesce)([ne.userDataPath,ne.extensionsPath,m.XDG_RUNTIME_DIR]).map(be=>(0,P.getPathLabel)(be,ne));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,M.toErrorMessage)(he),we.join(`
`)),le)}}showStartupWarningDialog(ne,le,he){w.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ne,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,le){if(t.isWindows){const he=await ne.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((we,be)=>{H(["windows-foreground-love"],we,be)})).allowSetForegroundWindow(he)}catch(we){le.error(we)}}}quit(ne,le){const he=ne.get(te.ILogService),we=ne.get(Y.ILifecycleMainService);let be=0;le&&(le.isExpected?le.message&&he.trace(le.message):(be=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),we.kill(be)}resolveArgs(){const ne=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const le=(0,o.createWaitMarkerFile)(ne.verbose);le&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",le),ne.waitMarkerFilePath=le)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const le=this.doValidatePaths(ne._,ne.goto);ne._=le}return ne}doValidatePaths(ne,le){const he=(0,h.cwd)(),we=ne.map(ye=>{let pe=String(ye),Ee;le&&(Ee=(0,d.parseLineAndColumnAware)(pe),pe=Ee.path),pe&&(pe=this.preparePath(he,pe));const Le=(0,d.sanitizeFilePath)(pe,he),Ne=(0,I.basename)(Le);return Ne&&!(0,d.isValidBasename)(Ne)?null:le&&Ee?(Ee.path=Le,this.toPath(Ee)):Le}),be=t.isWindows||t.isMacintosh,Ce=(0,R.distinct)(we,ye=>ye&&be?ye.toLowerCase():ye||"");return(0,R.coalesce)(Ce)}preparePath(ne,le){return t.isWindows&&(le=(0,f.rtrim)(le,'"')),le=(0,f.trim)((0,f.trim)(le," "),"	"),t.isWindows&&(le=(0,I.resolve)(ne,le),le=(0,f.rtrim)(le,".")),le}toPath(ne){const le=[ne.path];return typeof ne.line=="number"&&le.push(String(ne.line)),typeof ne.column=="number"&&le.push(String(ne.column)),le.join(":")}}new se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/45b4204501ac1f50b6231af3c996d35f86359ecd/core/vs/code/electron-main/main.js.map
