/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/base/common/glob","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ve=function(te){for(var e=[],f=0,n=te.length;f<n;f++)e[f]=pe[te[f]];return e};define(pe[55],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(n,I){if(!n)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(pe[72],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(C){return C?C.replace(/\$\((.*?)\)/g,(k,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=f;class n{constructor(k,S,L){this.id=k,this.definition=S,this.description=L,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(C,k){const S=["codicon","codicon-"+C];return k&&S.push("codicon-modifier-"+k),S}e.getClassNamesArray=I;var T;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(y){if(y instanceof n)return["codicon","codicon-"+y.id];const v=k.exec(y.id);if(!v)return S(n.error);let[,b,g]=v;const d=["codicon","codicon-"+b];return g&&d.push("codicon-modifier-"+g.substr(1)),d}C.asClassNameArray=S;function L(y){return S(y).join(" ")}C.asClassName=L;function O(y){return"."+S(y).join(".")}C.asCSSSelector=O})(T=e.CSSIcon||(e.CSSIcon={}))}),define(pe[73],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function n(O){const y=[];for(let v in O)f.call(O,v)&&y.push(O[v]);return y}e.values=n;function I(O,y){for(let v in O)if(f.call(O,v)&&y({key:v,value:O[v]},function(){delete O[v]})===!1)return}e.forEach=I;function T(O,y){const v=Object.create(null);for(const b of O){const g=y(b);let d=v[g];d||(d=v[g]=[]),d.push(b)}return v}e.groupBy=T;function C(O){const y=Object.create(null);return O&&O.forEach((v,b)=>{y[b]=v}),y}e.fromMap=C;function k(O,y){const v=[],b=[];for(let g of O)y.has(g)||v.push(g);for(let g of y)O.has(g)||b.push(g);return{removed:v,added:b}}e.diffSets=k;function S(O,y){const v=[],b=[];for(let[g,d]of O)y.has(g)||v.push(d);for(let[g,d]of y)O.has(g)||b.push(d);return{removed:v,added:b}}e.diffMaps=S;class L{constructor(){this.map=new Map}add(y,v){let b=this.map.get(y);b||(b=new Set,this.map.set(y,b)),b.add(v)}delete(y,v){const b=this.map.get(y);!b||(b.delete(v),b.size===0&&this.map.delete(y))}forEach(y,v){const b=this.map.get(y);!b||b.forEach(v)}}e.SetMap=L}),define(pe[56],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(C){return(k,S,L)=>{let O=null,y=null;if(typeof L.value=="function"?(O="value",y=L.value):typeof L.get=="function"&&(O="get",y=L.get),!y)throw new Error("not supported");L[O]=C(y,S)}}e.createDecorator=f;function n(C,k,S){let L=null,O=null;if(typeof S.value=="function"?(L="value",O=S.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(L="get",O=S.get),!O)throw new Error("not supported");const y=`$memoize$${k}`;S[L]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,v)}),this[y]}}e.memoize=n;function I(C,k,S){return f((L,O)=>{const y=`$debounce$${O}`,v=`$debounce$result$${O}`;return function(...b){this[v]||(this[v]=S?S():void 0),clearTimeout(this[y]),k&&(this[v]=k(this[v],...b),b=[this[v]]),this[y]=setTimeout(()=>{L.apply(this,b),this[v]=S?S():void 0},C)}})}e.debounce=I;function T(C,k,S){return f((L,O)=>{const y=`$throttle$timer$${O}`,v=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,g=`$throttle$pending$${O}`;return function(...d){if(this[v]||(this[v]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...d)),this[g])return;const p=this[b]+C;p<=Date.now()?(this[b]=Date.now(),L.apply(this,[this[v]]),this[v]=S?S():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),L.apply(this,[this[v]]),this[v]=S?S():void 0},p-Date.now()))}})}e.throttle=T}),define(pe[15],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(l=>{l(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=f,e.errorHandler=new f;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function I(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=I;function T(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function C(c){if(c instanceof Error){let{name:u,message:l}=c;const E=c.stacktrace||c.stack;return{$isError:!0,name:u,message:l,stack:E}}return c}e.transformErrorForSerialization=C;const k="Canceled";function S(c){return c instanceof L?!0:c instanceof Error&&c.name===k&&c.message===k}e.isCancellationError=S;class L extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=L;function O(){const c=new Error(k);return c.name=c.message,c}e.canceled=O;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=v;function b(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function g(c){const u=new Error(`${c} has been disposed`);return u.name="DISPOSED",u}e.disposed=g;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class p extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=p;class P extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=P;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;class o extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=o}),define(pe[18],ve([1,0,15]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(Q,Y=0){return Q[Q.length-(1+Y)]}e.tail=n;function I(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}e.tail2=I;function T(Q,Y,oe=(de,Ee)=>de===Ee){if(Q===Y)return!0;if(!Q||!Y||Q.length!==Y.length)return!1;for(let de=0,Ee=Q.length;de<Ee;de++)if(!oe(Q[de],Y[de]))return!1;return!0}e.equals=T;function C(Q,Y,oe){let de=0,Ee=Q.length-1;for(;de<=Ee;){const Re=(de+Ee)/2|0,Ne=oe(Q[Re],Y);if(Ne<0)de=Re+1;else if(Ne>0)Ee=Re-1;else return Re}return-(de+1)}e.binarySearch=C;function k(Q,Y){let oe=0,de=Q.length;if(de===0)return 0;for(;oe<de;){const Ee=Math.floor((oe+de)/2);Y(Q[Ee])?de=Ee:oe=Ee+1}return oe}e.findFirstInSorted=k;function S(Q,Y,oe){if(Q=Q|0,Q>=Y.length)throw new TypeError("invalid index");let de=Y[Math.floor(Y.length*Math.random())],Ee=[],Re=[],Ne=[];for(let be of Y){const we=oe(be,de);we<0?Ee.push(be):we>0?Re.push(be):Ne.push(be)}return Q<Ee.length?S(Q,Ee,oe):Q<Ee.length+Ne.length?Ne[0]:S(Q-(Ee.length+Ne.length),Re,oe)}e.quickSelect=S;function L(Q,Y){const oe=[];let de;for(const Ee of Q.slice(0).sort(Y))!de||Y(de[0],Ee)!==0?(de=[Ee],oe.push(de)):de.push(Ee);return oe}e.groupBy=L;function O(Q,Y,oe){const de=[];function Ee(be,we,H){if(we===0&&H.length===0)return;const B=de[de.length-1];B&&B.start+B.deleteCount===be?(B.deleteCount+=we,B.toInsert.push(...H)):de.push({start:be,deleteCount:we,toInsert:H})}let Re=0,Ne=0;for(;;){if(Re===Q.length){Ee(Re,0,Y.slice(Ne));break}if(Ne===Y.length){Ee(Re,Q.length-Re,[]);break}const be=Q[Re],we=Y[Ne],H=oe(be,we);H===0?(Re+=1,Ne+=1):H<0?(Ee(Re,1,[]),Re+=1):H>0&&(Ee(Re,0,[we]),Ne+=1)}return de}e.sortedDiff=O;function y(Q,Y,oe){const de=O(Q,Y,oe),Ee=[],Re=[];for(const Ne of de)Ee.push(...Q.slice(Ne.start,Ne.start+Ne.deleteCount)),Re.push(...Ne.toInsert);return{removed:Ee,added:Re}}e.delta=y;function v(Q,Y,oe){if(oe===0)return[];const de=Q.slice(0,oe).sort(Y);return g(Q,Y,de,oe,Q.length),de}e.top=v;function b(Q,Y,oe,de,Ee){return oe===0?Promise.resolve([]):new Promise((Re,Ne)=>{(async()=>{const be=Q.length,we=Q.slice(0,oe).sort(Y);for(let H=oe,B=Math.min(oe+de,be);H<be;H=B,B=Math.min(B+de,be)){if(H>oe&&await new Promise(N=>setTimeout(N)),Ee&&Ee.isCancellationRequested)throw(0,f.canceled)();g(Q,Y,we,H,B)}return we})().then(Re,Ne)})}e.topAsync=b;function g(Q,Y,oe,de,Ee){for(const Re=oe.length;de<Ee;de++){const Ne=Q[de];if(Y(Ne,oe[Re-1])<0){oe.pop();const be=k(oe,we=>Y(Ne,we)<0);oe.splice(be,0,Ne)}}}function d(Q){return Q.filter(Y=>!!Y)}e.coalesce=d;function p(Q){let Y=0;for(let oe=0;oe<Q.length;oe++)Q[oe]&&(Q[Y]=Q[oe],Y+=1);Q.length=Y}e.coalesceInPlace=p;function P(Q,Y,oe){Q.splice(oe,0,Q.splice(Y,1)[0])}e.move=P;function _(Q){return!Array.isArray(Q)||Q.length===0}e.isFalsyOrEmpty=_;function o(Q){return Array.isArray(Q)&&Q.length>0}e.isNonEmptyArray=o;function c(Q,Y=oe=>oe){const oe=new Set;return Q.filter(de=>{const Ee=Y(de);return oe.has(Ee)?!1:(oe.add(Ee),!0)})}e.distinct=c;function u(Q){const Y=new Set;return oe=>{const de=Q(oe);return Y.has(de)?!1:(Y.add(de),!0)}}e.uniqueFilter=u;function l(Q,Y){const oe=E(Q,Y);if(oe!==-1)return Q[oe]}e.findLast=l;function E(Q,Y){for(let oe=Q.length-1;oe>=0;oe--){const de=Q[oe];if(Y(de))return oe}return-1}e.lastIndex=E;function s(Q,Y){return Q.length>0?Q[0]:Y}e.firstOrDefault=s;function t(Q,Y,oe=(de,Ee)=>de===Ee){let de=0;for(let Ee=0,Re=Math.min(Q.length,Y.length);Ee<Re&&oe(Q[Ee],Y[Ee]);Ee++)de++;return de}e.commonPrefixLength=t;function r(Q){return[].concat(...Q)}e.flatten=r;function i(Q,Y){let oe=typeof Y=="number"?Q:0;typeof Y=="number"?oe=Q:(oe=0,Y=Q);const de=[];if(oe<=Y)for(let Ee=oe;Ee<Y;Ee++)de.push(Ee);else for(let Ee=oe;Ee>Y;Ee--)de.push(Ee);return de}e.range=i;function a(Q,Y,oe){return Q.reduce((de,Ee)=>(de[Y(Ee)]=oe?oe(Ee):Ee,de),Object.create(null))}e.index=a;function m(Q,Y){return Q.push(Y),()=>h(Q,Y)}e.insert=m;function h(Q,Y){const oe=Q.indexOf(Y);if(oe>-1)return Q.splice(oe,1),Y}e.remove=h;function w(Q,Y,oe){const de=Q.slice(0,Y),Ee=Q.slice(Y);return de.concat(oe,Ee)}e.arrayInsert=w;function A(Q,Y){let oe;if(typeof Y=="number"){let de=Y;oe=()=>{const Ee=Math.sin(de++)*179426549;return Ee-Math.floor(Ee)}}else oe=Math.random;for(let de=Q.length-1;de>0;de-=1){const Ee=Math.floor(oe()*(de+1)),Re=Q[de];Q[de]=Q[Ee],Q[Ee]=Re}}e.shuffle=A;function F(Q,Y){const oe=Q.indexOf(Y);oe>-1&&(Q.splice(oe,1),Q.unshift(Y))}e.pushToStart=F;function R(Q,Y){const oe=Q.indexOf(Y);oe>-1&&(Q.splice(oe,1),Q.push(Y))}e.pushToEnd=R;function D(Q,Y){return Array.isArray(Q)?Q.map(Y):Y(Q)}e.mapArrayOrNot=D;function $(Q){return Array.isArray(Q)?Q:[Q]}e.asArray=$;function M(Q){return Q[Math.floor(Math.random()*Q.length)]}e.getRandomElement=M;function q(Q,Y){for(const oe of Q){const de=Y(oe);if(de!==void 0)return de}}e.mapFind=q;function G(Q,Y,oe){const de=W(Q,Y),Ee=Q.length,Re=oe.length;Q.length=Ee+Re;for(let Ne=Ee-1;Ne>=de;Ne--)Q[Ne+Re]=Q[Ne];for(let Ne=0;Ne<Re;Ne++)Q[Ne+de]=oe[Ne]}e.insertInto=G;function U(Q,Y,oe,de){const Ee=W(Q,Y),Re=Q.splice(Ee,oe);return G(Q,Ee,de),Re}e.splice=U;function W(Q,Y){return Y<0?Math.max(Y+Q.length,0):Math.min(Y,Q.length)}function ee(Q,Y){return(oe,de)=>Y(Q(oe),Q(de))}e.compareBy=ee;const Z=(Q,Y)=>Q-Y;e.numberComparator=Z;function V(Q,Y){if(Q.length===0)return;let oe=Q[0];for(let de=1;de<Q.length;de++){const Ee=Q[de];Y(Ee,oe)>0&&(oe=Ee)}return oe}e.findMaxBy=V;function J(Q,Y){if(Q.length===0)return;let oe=Q[0];for(let de=1;de<Q.length;de++){const Ee=Q[de];Y(Ee,oe)>=0&&(oe=Ee)}return oe}e.findLastMaxBy=J;function se(Q,Y){return V(Q,(oe,de)=>-Y(oe,de))}e.findMinBy=se;class ae{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let oe=this.firstIdx;for(;oe<this.items.length&&Y(this.items[oe]);)oe++;const de=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,de}takeFromEndWhile(Y){let oe=this.lastIdx;for(;oe>=0&&Y(this.items[oe]);)oe--;const de=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,de}peek(){return this.items[this.firstIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}takeCount(Y){const oe=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,oe}}e.ArrayQueue=ae}),define(pe[74],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(n){const I=this;let T=!1,C;return function(){return T||(T=!0,C=n.apply(I,arguments)),C}}e.once=f}),define(pe[75],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(pe[76],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(n){function I(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=I;const T=Object.freeze([]);function C(){return T}n.empty=C;function*k(u){yield u}n.single=k;function S(u){return u||T}n.from=S;function L(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=L;function O(u){return u[Symbol.iterator]().next().value}n.first=O;function y(u,l){for(const E of u)if(l(E))return!0;return!1}n.some=y;function v(u,l){for(const E of u)if(l(E))return E}n.find=v;function*b(u,l){for(const E of u)l(E)&&(yield E)}n.filter=b;function*g(u,l){let E=0;for(const s of u)yield l(s,E++)}n.map=g;function*d(...u){for(const l of u)for(const E of l)yield E}n.concat=d;function*p(u){for(const l of u)for(const E of l)yield E}n.concatNested=p;function P(u,l,E){let s=E;for(const t of u)s=l(s,t);return s}n.reduce=P;function*_(u,l,E=u.length){for(l<0&&(l+=u.length),E<0?E+=u.length:E>u.length&&(E=u.length);l<E;l++)yield u[l]}n.slice=_;function o(u,l=Number.POSITIVE_INFINITY){const E=[];if(l===0)return[E,u];const s=u[Symbol.iterator]();for(let t=0;t<l;t++){const r=s.next();if(r.done)return[E,n.empty()];E.push(r.value)}return[E,{[Symbol.iterator](){return s}}]}n.consume=o;function c(u,l,E=(s,t)=>s===t){const s=u[Symbol.iterator](),t=l[Symbol.iterator]();for(;;){const r=s.next(),i=t.next();if(r.done!==i.done)return!1;if(r.done)return!0;if(!E(r.value,i.value))return!1}}n.equals=c})(f=e.Iterable||(e.Iterable={}))}),define(pe[141],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var n;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function C(l,E=!1){let s=0,t=l.length,r="",i=0,a=16,m=0;function h(M){let q=0,G=0;for(;q<M;){const U=l.charCodeAt(s);if(U>=48&&U<=57)G=G*16+U-48;else if(U>=65&&U<=70)G=G*16+U-65+10;else if(U>=97&&U<=102)G=G*16+U-97+10;else break;s++,q++}return q<M&&(G=-1),G}function w(M){s=M,r="",i=0,a=16,m=0}function A(){const M=s;if(l.charCodeAt(s)===48)s++;else for(s++;s<l.length&&L(l.charCodeAt(s));)s++;if(s<l.length&&l.charCodeAt(s)===46)if(s++,s<l.length&&L(l.charCodeAt(s)))for(s++;s<l.length&&L(l.charCodeAt(s));)s++;else return m=3,l.substring(M,s);let q=s;if(s<l.length&&(l.charCodeAt(s)===69||l.charCodeAt(s)===101))if(s++,(s<l.length&&l.charCodeAt(s)===43||l.charCodeAt(s)===45)&&s++,s<l.length&&L(l.charCodeAt(s))){for(s++;s<l.length&&L(l.charCodeAt(s));)s++;q=s}else m=3;return l.substring(M,q)}function F(){let M="",q=s;for(;;){if(s>=t){M+=l.substring(q,s),m=2;break}const G=l.charCodeAt(s);if(G===34){M+=l.substring(q,s),s++;break}if(G===92){if(M+=l.substring(q,s),s++,s>=t){m=2;break}switch(l.charCodeAt(s++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const W=h(4);W>=0?M+=String.fromCharCode(W):m=4;break}default:m=5}q=s;continue}if(G>=0&&G<=31)if(S(G)){M+=l.substring(q,s),m=2;break}else m=6;s++}return M}function R(){if(r="",m=0,i=s,s>=t)return i=t,a=17;let M=l.charCodeAt(s);if(k(M)){do s++,r+=String.fromCharCode(M),M=l.charCodeAt(s);while(k(M));return a=15}if(S(M))return s++,r+=String.fromCharCode(M),M===13&&l.charCodeAt(s)===10&&(s++,r+=`
`),a=14;switch(M){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,r=F(),a=10;case 47:{const q=s-1;if(l.charCodeAt(s+1)===47){for(s+=2;s<t&&!S(l.charCodeAt(s));)s++;return r=l.substring(q,s),a=12}if(l.charCodeAt(s+1)===42){s+=2;const G=t-1;let U=!1;for(;s<G;){if(l.charCodeAt(s)===42&&l.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,m=1),r=l.substring(q,s),a=13}return r+=String.fromCharCode(M),s++,a=16}case 45:if(r+=String.fromCharCode(M),s++,s===t||!L(l.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=A(),a=11;default:for(;s<t&&D(M);)s++,M=l.charCodeAt(s);if(i!==s){switch(r=l.substring(i,s),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(M),s++,a=16}}function D(M){if(k(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let M;do M=R();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>s,scan:E?$:R,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>i,getTokenLength:()=>s-i,getTokenError:()=>m}}e.createScanner=C;function k(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function S(l){return l===10||l===13||l===8232||l===8233}function L(l){return l>=48&&l<=57}var O;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(O||(O={}));function y(l,E){const s=[],t=new Object;let r;const i={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function m(h,w,A,F){i.value=h,i.offset=w,i.length=A,i.type=F,i.colonOffset=void 0,r=i}try{o(l,{onObjectBegin:(h,w)=>{if(E<=h)throw t;r=void 0,a=E>h,s.push("")},onObjectProperty:(h,w,A)=>{if(E<w||(m(h,w,A,"property"),s[s.length-1]=h,E<=w+A))throw t},onObjectEnd:(h,w)=>{if(E<=h)throw t;r=void 0,s.pop()},onArrayBegin:(h,w)=>{if(E<=h)throw t;r=void 0,s.push(0)},onArrayEnd:(h,w)=>{if(E<=h)throw t;r=void 0,s.pop()},onLiteralValue:(h,w,A)=>{if(E<w||(m(h,w,A,u(h)),E<=w+A))throw t},onSeparator:(h,w,A)=>{if(E<=w)throw t;if(h===":"&&r&&r.type==="property")r.colonOffset=w,a=!1,r=void 0;else if(h===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(a=!0,s[s.length-1]=""),r=void 0}}})}catch(h){if(h!==t)throw h}return{path:s,previousNode:r,isAtPropertyKey:a,matches:h=>{let w=0;for(let A=0;w<h.length&&A<s.length;A++)if(h[w]===s[A]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=y;function v(l,E=[],s=T.DEFAULT){let t=null,r=[];const i=[];function a(h){Array.isArray(r)?r.push(h):t!==null&&(r[t]=h)}return o(l,{onObjectBegin:()=>{const h={};a(h),i.push(r),r=h,t=null},onObjectProperty:h=>{t=h},onObjectEnd:()=>{r=i.pop()},onArrayBegin:()=>{const h=[];a(h),i.push(r),r=h,t=null},onArrayEnd:()=>{r=i.pop()},onLiteralValue:a,onError:(h,w,A)=>{E.push({error:h,offset:w,length:A})}},s),r[0]}e.parse=v;function b(l,E=[],s=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){t.type==="property"&&(t.length=h-t.offset,t=t.parent)}function i(h){return t.children.push(h),h}o(l,{onObjectBegin:h=>{t=i({type:"object",offset:h,length:-1,parent:t,children:[]})},onObjectProperty:(h,w,A)=>{t=i({type:"property",offset:w,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:h,offset:w,length:A,parent:t})},onObjectEnd:(h,w)=>{t.length=h+w-t.offset,t=t.parent,r(h+w)},onArrayBegin:(h,w)=>{t=i({type:"array",offset:h,length:-1,parent:t,children:[]})},onArrayEnd:(h,w)=>{t.length=h+w-t.offset,t=t.parent,r(h+w)},onLiteralValue:(h,w,A)=>{i({type:u(h),offset:w,length:A,parent:t,value:h}),r(w+A)},onSeparator:(h,w,A)=>{t.type==="property"&&(h===":"?t.colonOffset=w:h===","&&r(w))},onError:(h,w,A)=>{E.push({error:h,offset:w,length:A})}},s);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=b;function g(l,E){if(!l)return;let s=l;for(let t of E)if(typeof t=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const i of s.children)if(Array.isArray(i.children)&&i.children[0].value===t){s=i.children[1],r=!0;break}if(!r)return}else{const r=t;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=g;function d(l){if(!l.parent||!l.parent.children)return[];const E=d(l.parent);if(l.parent.type==="property"){const s=l.parent.children[0].value;E.push(s)}else if(l.parent.type==="array"){const s=l.parent.children.indexOf(l);s!==-1&&E.push(s)}return E}e.getNodePath=d;function p(l){switch(l.type){case"array":return l.children.map(p);case"object":{const E=Object.create(null);for(let s of l.children){const t=s.children[1];t&&(E[s.children[0].value]=p(t))}return E}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=p;function P(l,E,s=!1){return E>=l.offset&&E<l.offset+l.length||s&&E===l.offset+l.length}e.contains=P;function _(l,E,s=!1){if(P(l,E,s)){const t=l.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=E;r++){const i=_(t[r],E,s);if(i)return i}return l}}e.findNodeAtOffset=_;function o(l,E,s=T.DEFAULT){const t=C(l,!1);function r(ae){return ae?()=>ae(t.getTokenOffset(),t.getTokenLength()):()=>!0}function i(ae){return ae?Q=>ae(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=r(E.onObjectBegin),m=i(E.onObjectProperty),h=r(E.onObjectEnd),w=r(E.onArrayBegin),A=r(E.onArrayEnd),F=i(E.onLiteralValue),R=i(E.onSeparator),D=r(E.onComment),$=i(E.onError),M=s&&s.disallowComments,q=s&&s.allowTrailingComma;function G(){for(;;){const ae=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ae){case 12:case 13:M?U(10):D();break;case 16:U(1);break;case 15:case 14:break;default:return ae}}}function U(ae,Q=[],Y=[]){if($(ae),Q.length+Y.length>0){let oe=t.getToken();for(;oe!==17;){if(Q.indexOf(oe)!==-1){G();break}else if(Y.indexOf(oe)!==-1)break;oe=G()}}}function W(ae){const Q=t.getTokenValue();return ae?F(Q):m(Q),G(),!0}function ee(){switch(t.getToken()){case 11:{let ae=0;try{ae=JSON.parse(t.getTokenValue()),typeof ae!="number"&&(U(2),ae=0)}catch{U(2)}F(ae);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return G(),!0}function Z(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(W(!1),t.getToken()===6?(R(":"),G(),se()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){a(),G();let ae=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ae||U(4,[],[]),R(","),G(),t.getToken()===2&&q)break}else ae&&U(6,[],[]);Z()||U(4,[],[2,5]),ae=!0}return h(),t.getToken()!==2?U(7,[2],[]):G(),!0}function J(){w(),G();let ae=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ae||U(4,[],[]),R(","),G(),t.getToken()===4&&q)break}else ae&&U(6,[],[]);se()||U(4,[],[4,5]),ae=!0}return A(),t.getToken()!==4?U(8,[4],[]):G(),!0}function se(){switch(t.getToken()){case 3:return J();case 1:return V();case 10:return W(!0);default:return ee()}}return G(),t.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):se()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=o;function c(l,E){let s=C(l),t=[],r,i=0,a;do switch(a=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:i!==a&&t.push(l.substring(i,a)),E!==void 0&&t.push(s.getTokenValue().replace(/[^\r\n]/g,E)),i=s.getPosition();break}while(r!==17);return t.join("")}e.stripComments=c;function u(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(pe[89],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(pe[6],ve([1,0,74,76]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let T=null;function C(r){T=r}if(e.setDisposableTracker=C,I){const r="__is_disposable_tracked__";C(new class{trackDisposable(i){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(a)},3e3)}setParent(i,a){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function k(r){return T?.trackDisposable(r),r}function S(r){T?.markAsDisposed(r)}function L(r,i){T?.setParent(r,i)}function O(r,i){if(!!T)for(const a of r)T.setParent(a,i)}function y(r){return T?.markAsSingleton(r),r}e.markAsSingleton=y;class v extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=v;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=b;function g(r){if(n.Iterable.is(r)){let i=[];for(const a of r)if(a)try{a.dispose()}catch(m){i.push(m)}if(i.length===1)throw i[0];if(i.length>1)throw new v(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=g;function d(...r){const i=p(()=>g(r));return O(r,i),i}e.combinedDisposable=d;function p(r){const i=k({dispose:(0,f.once)(()=>{S(i),r()})});return i}e.toDisposable=p;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return L(i,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new P,k(this),L(this._store,this)}dispose(){S(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&L(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&L(i,null),i}}e.MutableDisposable=o;class c{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(i){let a=i;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,S(this))},this}}e.SafeDisposable=u;class l{constructor(){this.references=new Map}acquire(i,...a){let m=this.references.get(i);m||(m={counter:0,object:this.createReferencedObject(i,...a)},this.references.set(i,m));const{object:h}=m,w=(0,f.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(i,m.object),this.references.delete(i))});return m.counter++,{object:h,dispose:w}}}e.ReferenceCollection=l;class E{constructor(i){this.referenceCollection=i}async acquire(i,...a){const m=this.referenceCollection.acquire(i,...a);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(h){throw m.dispose(),h}}}e.AsyncReferenceCollection=E;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function t(r){const i=new P;try{r(i)}finally{i.dispose()}}e.disposeOnReturn=t}),define(pe[90],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(T){this.element=T,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class n{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let T=this._first;for(;T!==f.Undefined;){const C=T.next;T.prev=f.Undefined,T.next=f.Undefined,T=C}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,C){const k=new f(T);if(this._first===f.Undefined)this._first=k,this._last=k;else if(C){const L=this._last;this._last=k,k.prev=L,L.next=k}else{const L=this._first;this._first=k,k.next=L,L.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==f.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==f.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==f.Undefined&&T.next!==f.Undefined){const C=T.prev;C.next=T.next,T.next.prev=C}else T.prev===f.Undefined&&T.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):T.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):T.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==f.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(pe[142],ve([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(be,we){for(var H=0;H<we.length;H++){var B=we[H];B.enumerable=B.enumerable||!1,B.configurable=!0,"value"in B&&(B.writable=!0),Object.defineProperty(be,B.key,B)}}function f(be,we,H){return we&&e(be.prototype,we),H&&e(be,H),Object.defineProperty(be,"prototype",{writable:!1}),be}function n(be,we){if(!!be){if(typeof be=="string")return I(be,we);var H=Object.prototype.toString.call(be).slice(8,-1);if(H==="Object"&&be.constructor&&(H=be.constructor.name),H==="Map"||H==="Set")return Array.from(be);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return I(be,we)}}function I(be,we){(we==null||we>be.length)&&(we=be.length);for(var H=0,B=new Array(we);H<we;H++)B[H]=be[H];return B}function T(be,we){var H=typeof Symbol!="undefined"&&be[Symbol.iterator]||be["@@iterator"];if(H)return(H=H.call(be)).next.bind(H);if(Array.isArray(be)||(H=n(be))||we&&be&&typeof be.length=="number"){H&&(be=H);var B=0;return function(){return B>=be.length?{done:!0}:{done:!1,value:be[B++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function k(be){te.defaults=be}var S=/[&<>"']/,L=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(we){return v[we]};function g(be,we){if(we){if(S.test(be))return be.replace(L,b)}else if(O.test(be))return be.replace(y,b);return be}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(be){return be.replace(d,function(we,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var P=/(^|[^\[])\^/g;function _(be,we){be=be.source||be,we=we||"";var H={replace:function(N,z){return z=z.source||z,z=z.replace(P,"$1"),be=be.replace(N,z),H},getRegex:function(){return new RegExp(be,we)}};return H}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(be,we,H){if(be){var B;try{B=decodeURIComponent(p(H)).replace(o,"").toLowerCase()}catch{return null}if(B.indexOf("javascript:")===0||B.indexOf("vbscript:")===0||B.indexOf("data:")===0)return null}we&&!c.test(H)&&(H=r(we,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var l={},E=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(be,we){l[" "+be]||(E.test(be)?l[" "+be]=be+"/":l[" "+be]=h(be,"/",!0)),be=l[" "+be];var H=be.indexOf(":")===-1;return we.substring(0,2)==="//"?H?we:be.replace(s,"$1")+we:we.charAt(0)==="/"?H?we:be.replace(t,"$1")+we:be+we}var i={exec:function(){}};function a(be){for(var we=1,H,B;we<arguments.length;we++){H=arguments[we];for(B in H)Object.prototype.hasOwnProperty.call(H,B)&&(be[B]=H[B])}return be}function m(be,we){var H=be.replace(/\|/g,function(z,j,re){for(var he=!1,Ce=j;--Ce>=0&&re[Ce]==="\\";)he=!he;return he?"|":" |"}),B=H.split(/ \|/),N=0;if(B[0].trim()||B.shift(),B[B.length-1].trim()||B.pop(),B.length>we)B.splice(we);else for(;B.length<we;)B.push("");for(;N<B.length;N++)B[N]=B[N].trim().replace(/\\\|/g,"|");return B}function h(be,we,H){var B=be.length;if(B===0)return"";for(var N=0;N<B;){var z=be.charAt(B-N-1);if(z===we&&!H)N++;else if(z!==we&&H)N++;else break}return be.substr(0,B-N)}function w(be,we){if(be.indexOf(we[1])===-1)return-1;for(var H=be.length,B=0,N=0;N<H;N++)if(be[N]==="\\")N++;else if(be[N]===we[0])B++;else if(be[N]===we[1]&&(B--,B<0))return N;return-1}function A(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(be,we){if(we<1)return"";for(var H="";we>1;)we&1&&(H+=be),we>>=1,be+=be;return H+be}function R(be,we,H,B){var N=we.href,z=we.title?g(we.title):null,j=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){B.state.inLink=!0;var re={type:"link",raw:H,href:N,title:z,text:j,tokens:B.inlineTokens(j,[])};return B.state.inLink=!1,re}else return{type:"image",raw:H,href:N,title:z,text:g(j)}}function D(be,we){var H=be.match(/^(\s+)(?:```)/);if(H===null)return we;var B=H[1];return we.split(`
`).map(function(N){var z=N.match(/^\s+/);if(z===null)return N;var j=z[0];return j.length>=B.length?N.slice(B.length):N}).join(`
`)}var $=function(){function be(H){this.options=H||te.defaults}var we=be.prototype;return we.space=function(B){var N=this.rules.block.newline.exec(B);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},we.code=function(B){var N=this.rules.block.code.exec(B);if(N){var z=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?z:h(z,`
`)}}},we.fences=function(B){var N=this.rules.block.fences.exec(B);if(N){var z=N[0],j=D(z,N[3]||"");return{type:"code",raw:z,lang:N[2]?N[2].trim():N[2],text:j}}},we.heading=function(B){var N=this.rules.block.heading.exec(B);if(N){var z=N[2].trim();if(/#$/.test(z)){var j=h(z,"#");(this.options.pedantic||!j||/ $/.test(j))&&(z=j.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:z,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},we.hr=function(B){var N=this.rules.block.hr.exec(B);if(N)return{type:"hr",raw:N[0]}},we.blockquote=function(B){var N=this.rules.block.blockquote.exec(B);if(N){var z=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens(z,[]),text:z}}},we.list=function(B){var N=this.rules.block.list.exec(B);if(N){var z,j,re,he,Ce,Te,We,ze,qe,He,Ue,Je,et=N[1].trim(),Le=et.length>1,it={type:"list",raw:"",ordered:Le,start:Le?+et.slice(0,-1):"",loose:!1,items:[]};et=Le?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Le?et:"[*+-]");for(var ne=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");B&&(Je=!1,!(!(N=ne.exec(B))||this.rules.block.hr.test(B)));){if(z=N[0],B=B.substring(z.length),ze=N[2].split(`
`,1)[0],qe=B.split(`
`,1)[0],this.options.pedantic?(he=2,Ue=ze.trimLeft()):(he=N[2].search(/[^ ]/),he=he>4?1:he,Ue=ze.slice(he),he+=N[1].length),Te=!1,!ze&&/^ *$/.test(qe)&&(z+=qe+`
`,B=B.substring(qe.length+1),Je=!0),!Je)for(var le=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])");B&&(He=B.split(`
`,1)[0],ze=He,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!le.test(ze));){if(ze.search(/[^ ]/)>=he||!ze.trim())Ue+=`
`+ze.slice(he);else if(!Te)Ue+=`
`+ze;else break;!Te&&!ze.trim()&&(Te=!0),z+=He+`
`,B=B.substring(He.length+1)}it.loose||(We?it.loose=!0:/\n *\n *$/.test(z)&&(We=!0)),this.options.gfm&&(j=/^\[[ xX]\] /.exec(Ue),j&&(re=j[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:z,task:!!j,checked:re,loose:!1,text:Ue}),it.raw+=z}it.items[it.items.length-1].raw=z.trimRight(),it.items[it.items.length-1].text=Ue.trimRight(),it.raw=it.raw.trimRight();var X=it.items.length;for(Ce=0;Ce<X;Ce++){this.lexer.state.top=!1,it.items[Ce].tokens=this.lexer.blockTokens(it.items[Ce].text,[]);var ge=it.items[Ce].tokens.filter(function(Me){return Me.type==="space"}),Se=ge.every(function(Me){for(var $e=Me.raw.split(""),Ye=0,lt=T($e),vt;!(vt=lt()).done;){var wt=vt.value;if(wt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!it.loose&&ge.length&&Se&&(it.loose=!0,it.items[Ce].loose=!0)}return it}},we.html=function(B){var N=this.rules.block.html.exec(B);if(N){var z={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&(z.type="paragraph",z.text=this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]),z.tokens=[],this.lexer.inline(z.text,z.tokens)),z}},we.def=function(B){var N=this.rules.block.def.exec(B);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var z=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:z,raw:N[0],href:N[2],title:N[3]}}},we.table=function(B){var N=this.rules.block.table.exec(B);if(N){var z={type:"table",header:m(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=N[0];var j=z.align.length,re,he,Ce,Te;for(re=0;re<j;re++)/^ *-+: *$/.test(z.align[re])?z.align[re]="right":/^ *:-+: *$/.test(z.align[re])?z.align[re]="center":/^ *:-+ *$/.test(z.align[re])?z.align[re]="left":z.align[re]=null;for(j=z.rows.length,re=0;re<j;re++)z.rows[re]=m(z.rows[re],z.header.length).map(function(We){return{text:We}});for(j=z.header.length,he=0;he<j;he++)z.header[he].tokens=[],this.lexer.inlineTokens(z.header[he].text,z.header[he].tokens);for(j=z.rows.length,he=0;he<j;he++)for(Te=z.rows[he],Ce=0;Ce<Te.length;Ce++)Te[Ce].tokens=[],this.lexer.inlineTokens(Te[Ce].text,Te[Ce].tokens);return z}}},we.lheading=function(B){var N=this.rules.block.lheading.exec(B);if(N){var z={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline(z.text,z.tokens),z}},we.paragraph=function(B){var N=this.rules.block.paragraph.exec(B);if(N){var z={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline(z.text,z.tokens),z}},we.text=function(B){var N=this.rules.block.text.exec(B);if(N){var z={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline(z.text,z.tokens),z}},we.escape=function(B){var N=this.rules.inline.escape.exec(B);if(N)return{type:"escape",raw:N[0],text:g(N[1])}},we.tag=function(B){var N=this.rules.inline.tag.exec(B);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]):N[0]}},we.link=function(B){var N=this.rules.inline.link.exec(B);if(N){var z=N[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var j=h(z.slice(0,-1),"\\");if((z.length-j.length)%2==0)return}else{var re=w(N[2],"()");if(re>-1){var he=N[0].indexOf("!")===0?5:4,Ce=he+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,Ce).trim(),N[3]=""}}var Te=N[2],We="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);ze&&(Te=ze[1],We=ze[3])}else We=N[3]?N[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(z)?Te=Te.slice(1):Te=Te.slice(1,-1)),R(N,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},we.reflink=function(B,N){var z;if((z=this.rules.inline.reflink.exec(B))||(z=this.rules.inline.nolink.exec(B))){var j=(z[2]||z[1]).replace(/\s+/g," ");if(j=N[j.toLowerCase()],!j||!j.href){var re=z[0].charAt(0);return{type:"text",raw:re,text:re}}return R(z,j,z[0],this.lexer)}},we.emStrong=function(B,N,z){z===void 0&&(z="");var j=this.rules.inline.emStrong.lDelim.exec(B);if(!!j&&!(j[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=j[1]||j[2]||"";if(!re||re&&(z===""||this.rules.inline.punctuation.exec(z))){var he=j[0].length-1,Ce,Te,We=he,ze=0,qe=j[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(qe.lastIndex=0,N=N.slice(-1*B.length+he);(j=qe.exec(N))!=null;)if(Ce=j[1]||j[2]||j[3]||j[4]||j[5]||j[6],!!Ce){if(Te=Ce.length,j[3]||j[4]){We+=Te;continue}else if((j[5]||j[6])&&he%3&&!((he+Te)%3)){ze+=Te;continue}if(We-=Te,!(We>0)){if(Te=Math.min(Te,Te+We+ze),Math.min(he,Te)%2){var He=B.slice(1,he+j.index+Te);return{type:"em",raw:B.slice(0,he+j.index+Te+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}var Ue=B.slice(2,he+j.index+Te-1);return{type:"strong",raw:B.slice(0,he+j.index+Te+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},we.codespan=function(B){var N=this.rules.inline.code.exec(B);if(N){var z=N[2].replace(/\n/g," "),j=/[^ ]/.test(z),re=/^ /.test(z)&&/ $/.test(z);return j&&re&&(z=z.substring(1,z.length-1)),z=g(z,!0),{type:"codespan",raw:N[0],text:z}}},we.br=function(B){var N=this.rules.inline.br.exec(B);if(N)return{type:"br",raw:N[0]}},we.del=function(B){var N=this.rules.inline.del.exec(B);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},we.autolink=function(B,N){var z=this.rules.inline.autolink.exec(B);if(z){var j,re;return z[2]==="@"?(j=g(this.options.mangle?N(z[1]):z[1]),re="mailto:"+j):(j=g(z[1]),re=j),{type:"link",raw:z[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},we.url=function(B,N){var z;if(z=this.rules.inline.url.exec(B)){var j,re;if(z[2]==="@")j=g(this.options.mangle?N(z[0]):z[0]),re="mailto:"+j;else{var he;do he=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(he!==z[0]);j=g(z[0]),z[1]==="www."?re="http://"+j:re=j}return{type:"link",raw:z[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},we.inlineText=function(B,N){var z=this.rules.inline.text.exec(B);if(z){var j;return this.lexer.state.inRawBlock?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):g(z[0]):z[0]:j=g(this.options.smartypants?N(z[0]):z[0]),{type:"text",raw:z[0],text:j}}},be}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:i,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=_(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=_(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=_(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=_(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=_(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=_(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=a({},M),M.gfm=a({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=_(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=_(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=a({},M.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:i,paragraph:_(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:i,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:i,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=_(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=_(M._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=_(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=_(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=_(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=_(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=_(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=_(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=_(q.reflink).replace("label",q._label).replace("ref",M._label).getRegex(),q.nolink=_(q.nolink).replace("ref",M._label).getRegex(),q.reflinkSearch=_(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=a({},q),q.pedantic=a({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=a({},q.normal,{escape:_(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=_(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=a({},q.gfm,{br:_(q.br).replace("{2,}","*").getRegex(),text:_(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(be){var we="",H,B,N=be.length;for(H=0;H<N;H++)B=be.charCodeAt(H),Math.random()>.5&&(B="x"+B.toString(16)),we+="&#"+B+";";return we}var W=function(){function be(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||te.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var B={block:M.normal,inline:q.normal};this.options.pedantic?(B.block=M.pedantic,B.inline=q.pedantic):this.options.gfm&&(B.block=M.gfm,this.options.breaks?B.inline=q.breaks:B.inline=q.gfm),this.tokenizer.rules=B}be.lex=function(B,N){var z=new be(N);return z.lex(B)},be.lexInline=function(B,N){var z=new be(N);return z.inlineTokens(B)};var we=be.prototype;return we.lex=function(B){B=B.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(B,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},we.blockTokens=function(B,N){var z=this;N===void 0&&(N=[]),this.options.pedantic&&(B=B.replace(/^ +$/gm,""));for(var j,re,he,Ce;B;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(j=We.call({lexer:z},B,N))?(B=B.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.space(B)){B=B.substring(j.raw.length),j.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(j);continue}if(j=this.tokenizer.code(B)){B=B.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(j=this.tokenizer.fences(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.heading(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.hr(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.blockquote(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.list(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.html(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.def(B)){B=B.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[j.tag]||(this.tokens.links[j.tag]={href:j.href,title:j.title});continue}if(j=this.tokenizer.table(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.lheading(B)){B=B.substring(j.raw.length),N.push(j);continue}if(he=B,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,ze=B.slice(1),qe=void 0;z.options.extensions.startBlock.forEach(function(He){qe=He.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(We=Math.min(We,qe))}),We<1/0&&We>=0&&(he=B.substring(0,We+1))}(),this.state.top&&(j=this.tokenizer.paragraph(he))){re=N[N.length-1],Ce&&re.type==="paragraph"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j),Ce=he.length!==B.length,B=B.substring(j.raw.length);continue}if(j=this.tokenizer.text(B)){B=B.substring(j.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(B){var Te="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,N},we.inline=function(B,N){this.inlineQueue.push({src:B,tokens:N})},we.inlineTokens=function(B,N){var z=this;N===void 0&&(N=[]);var j,re,he,Ce=B,Te,We,ze;if(this.tokens.links){var qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)qe.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Te.index)+"["+F("a",Te[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Te.index)+"["+F("a",Te[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Te.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;B;)if(We||(ze=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(j=Ue.call({lexer:z},B,N))?(B=B.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.escape(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.tag(B)){B=B.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.link(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.reflink(B,this.tokens.links)){B=B.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.emStrong(B,Ce,ze)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.codespan(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.br(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.del(B)){B=B.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.autolink(B,U)){B=B.substring(j.raw.length),N.push(j);continue}if(!this.state.inLink&&(j=this.tokenizer.url(B,U))){B=B.substring(j.raw.length),N.push(j);continue}if(he=B,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Je=B.slice(1),et=void 0;z.options.extensions.startInline.forEach(function(Le){et=Le.call({lexer:this},Je),typeof et=="number"&&et>=0&&(Ue=Math.min(Ue,et))}),Ue<1/0&&Ue>=0&&(he=B.substring(0,Ue+1))}(),j=this.tokenizer.inlineText(he,G)){B=B.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(ze=j.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(B){var He="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return N},f(be,null,[{key:"rules",get:function(){return{block:M,inline:q}}}]),be}(),ee=function(){function be(H){this.options=H||te.defaults}var we=be.prototype;return we.code=function(B,N,z){var j=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(B,j);re!=null&&re!==B&&(z=!0,B=re)}return B=B.replace(/\n$/,"")+`
`,j?'<pre><code class="'+this.options.langPrefix+g(j,!0)+'">'+(z?B:g(B,!0))+`</code></pre>
`:"<pre><code>"+(z?B:g(B,!0))+`</code></pre>
`},we.blockquote=function(B){return`<blockquote>
`+B+`</blockquote>
`},we.html=function(B){return B},we.heading=function(B,N,z,j){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+j.slug(z)+'">'+B+"</h"+N+`>
`:"<h"+N+">"+B+"</h"+N+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(B,N,z){var j=N?"ol":"ul",re=N&&z!==1?' start="'+z+'"':"";return"<"+j+re+`>
`+B+"</"+j+`>
`},we.listitem=function(B){return"<li>"+B+`</li>
`},we.checkbox=function(B){return"<input "+(B?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(B){return"<p>"+B+`</p>
`},we.table=function(B,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+B+`</thead>
`+N+`</table>
`},we.tablerow=function(B){return`<tr>
`+B+`</tr>
`},we.tablecell=function(B,N){var z=N.header?"th":"td",j=N.align?"<"+z+' align="'+N.align+'">':"<"+z+">";return j+B+"</"+z+`>
`},we.strong=function(B){return"<strong>"+B+"</strong>"},we.em=function(B){return"<em>"+B+"</em>"},we.codespan=function(B){return"<code>"+B+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(B){return"<del>"+B+"</del>"},we.link=function(B,N,z){if(B=u(this.options.sanitize,this.options.baseUrl,B),B===null)return z;var j='<a href="'+g(B)+'"';return N&&(j+=' title="'+N+'"'),j+=">"+z+"</a>",j},we.image=function(B,N,z){if(B=u(this.options.sanitize,this.options.baseUrl,B),B===null)return z;var j='<img src="'+B+'" alt="'+z+'"';return N&&(j+=' title="'+N+'"'),j+=this.options.xhtml?"/>":">",j},we.text=function(B){return B},be}(),Z=function(){function be(){}var we=be.prototype;return we.strong=function(B){return B},we.em=function(B){return B},we.codespan=function(B){return B},we.del=function(B){return B},we.html=function(B){return B},we.text=function(B){return B},we.link=function(B,N,z){return""+z},we.image=function(B,N,z){return""+z},we.br=function(){return""},be}(),V=function(){function be(){this.seen={}}var we=be.prototype;return we.serialize=function(B){return B.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(B,N){var z=B,j=0;if(this.seen.hasOwnProperty(z)){j=this.seen[B];do j++,z=B+"-"+j;while(this.seen.hasOwnProperty(z))}return N||(this.seen[B]=j,this.seen[z]=0),z},we.slug=function(B,N){N===void 0&&(N={});var z=this.serialize(B);return this.getNextSafeSlug(z,N.dryrun)},be}(),J=function(){function be(H){this.options=H||te.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new V}be.parse=function(B,N){var z=new be(N);return z.parse(B)},be.parseInline=function(B,N){var z=new be(N);return z.parseInline(B)};var we=be.prototype;return we.parse=function(B,N){N===void 0&&(N=!0);var z="",j,re,he,Ce,Te,We,ze,qe,He,Ue,Je,et,Le,it,ne,le,X,ge,Se,Me=B.length;for(j=0;j<Me;j++){if(Ue=B[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Se=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){z+=Se||"";continue}switch(Ue.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,p(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(qe="",ze="",Ce=Ue.header.length,re=0;re<Ce;re++)ze+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(qe+=this.renderer.tablerow(ze),He="",Ce=Ue.rows.length,re=0;re<Ce;re++){for(We=Ue.rows[re],ze="",Te=We.length,he=0;he<Te;he++)ze+=this.renderer.tablecell(this.parseInline(We[he].tokens),{header:!1,align:Ue.align[he]});He+=this.renderer.tablerow(ze)}z+=this.renderer.table(qe,He);continue}case"blockquote":{He=this.parse(Ue.tokens),z+=this.renderer.blockquote(He);continue}case"list":{for(Je=Ue.ordered,et=Ue.start,Le=Ue.loose,Ce=Ue.items.length,He="",re=0;re<Ce;re++)ne=Ue.items[re],le=ne.checked,X=ne.task,it="",ne.task&&(ge=this.renderer.checkbox(le),Le?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=ge+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=ge+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:ge}):it+=ge),it+=this.parse(ne.tokens,Le),He+=this.renderer.listitem(it,X,le);z+=this.renderer.list(He,Je,et);continue}case"html":{z+=this.renderer.html(Ue.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;j+1<Me&&B[j+1].type==="text";)Ue=B[++j],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);z+=N?this.renderer.paragraph(He):He;continue}default:{var $e='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return z},we.parseInline=function(B,N){N=N||this.renderer;var z="",j,re,he,Ce=B.length;for(j=0;j<Ce;j++){if(re=B[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(he=this.options.extensions.renderers[re.type].call({parser:this},re),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){z+=he||"";continue}switch(re.type){case"escape":{z+=N.text(re.text);break}case"html":{z+=N.html(re.text);break}case"link":{z+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{z+=N.image(re.href,re.title,re.text);break}case"strong":{z+=N.strong(this.parseInline(re.tokens,N));break}case"em":{z+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{z+=N.codespan(re.text);break}case"br":{z+=N.br();break}case"del":{z+=N.del(this.parseInline(re.tokens,N));break}case"text":{z+=N.text(re.text);break}default:{var Te='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return z},be}();function se(be,we,H){if(typeof be=="undefined"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof we=="function"&&(H=we,we=null),we=a({},se.defaults,we||{}),A(we),H){var B=we.highlight,N;try{N=W.lex(be,we)}catch(he){return H(he)}var z=function(Ce){var Te;if(!Ce)try{we.walkTokens&&se.walkTokens(N,we.walkTokens),Te=J.parse(N,we)}catch(We){Ce=We}return we.highlight=B,Ce?H(Ce):H(null,Te)};if(!B||B.length<3||(delete we.highlight,!N.length))return z();var j=0;se.walkTokens(N,function(he){he.type==="code"&&(j++,setTimeout(function(){B(he.text,he.lang,function(Ce,Te){if(Ce)return z(Ce);Te!=null&&Te!==he.text&&(he.text=Te,he.escaped=!0),j--,j===0&&z()})},0))}),j===0&&z();return}try{var re=W.lex(be,we);return we.walkTokens&&se.walkTokens(re,we.walkTokens),J.parse(re,we)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(he.message+"",!0)+"</pre>";throw he}}se.options=se.setOptions=function(be){return a(se.defaults,be),k(se.defaults),se},se.getDefaults=C,se.defaults=te.defaults,se.use=function(){for(var be=arguments.length,we=new Array(be),H=0;H<be;H++)we[H]=arguments[H];var B=a.apply(void 0,[{}].concat(we)),N=se.defaults.extensions||{renderers:{},childTokens:{}},z;we.forEach(function(j){if(j.extensions&&(z=!0,j.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=N.renderers?N.renderers[he.name]:null;Ce?N.renderers[he.name]=function(){for(var Te=arguments.length,We=new Array(Te),ze=0;ze<Te;ze++)We[ze]=arguments[ze];var qe=he.renderer.apply(this,We);return qe===!1&&(qe=Ce.apply(this,We)),qe}:N.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[he.level]?N[he.level].unshift(he.tokenizer):N[he.level]=[he.tokenizer],he.start&&(he.level==="block"?N.startBlock?N.startBlock.push(he.start):N.startBlock=[he.start]:he.level==="inline"&&(N.startInline?N.startInline.push(he.start):N.startInline=[he.start]))}he.childTokens&&(N.childTokens[he.name]=he.childTokens)})),j.renderer&&function(){var he=se.defaults.renderer||new ee,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=j.renderer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Te in j.renderer)Ce(Te);B.renderer=he}(),j.tokenizer&&function(){var he=se.defaults.tokenizer||new $,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=j.tokenizer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Te in j.tokenizer)Ce(Te);B.tokenizer=he}(),j.walkTokens){var re=se.defaults.walkTokens;B.walkTokens=function(he){j.walkTokens.call(this,he),re&&re.call(this,he)}}z&&(B.extensions=N),se.setOptions(B)})},se.walkTokens=function(be,we){for(var H=function(){var j=N.value;switch(we.call(se,j),j.type){case"table":{for(var re=T(j.header),he;!(he=re()).done;){var Ce=he.value;se.walkTokens(Ce.tokens,we)}for(var Te=T(j.rows),We;!(We=Te()).done;)for(var ze=We.value,qe=T(ze),He;!(He=qe()).done;){var Ue=He.value;se.walkTokens(Ue.tokens,we)}break}case"list":{se.walkTokens(j.items,we);break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[j.type]?se.defaults.extensions.childTokens[j.type].forEach(function(Je){se.walkTokens(j[Je],we)}):j.tokens&&se.walkTokens(j.tokens,we)}},B=T(be),N;!(N=B()).done;)H()},se.parseInline=function(be,we){if(typeof be=="undefined"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");we=a({},se.defaults,we||{}),A(we);try{var H=W.lexInline(be,we);return we.walkTokens&&se.walkTokens(H,we.walkTokens),J.parseInline(H,we)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(B.message+"",!0)+"</pre>";throw B}},se.Parser=J,se.parser=J.parse,se.Renderer=ee,se.TextRenderer=Z,se.Lexer=W,se.lexer=W.lex,se.Tokenizer=$,se.Slugger=V,se.parse=se;var ae=se.options,Q=se.setOptions,Y=se.use,oe=se.walkTokens,de=se.parseInline,Ee=se,Re=J.parse,Ne=W.lex;te.Lexer=W,te.Parser=J,te.Renderer=ee,te.Slugger=V,te.TextRenderer=Z,te.Tokenizer=$,te.getDefaults=C,te.lexer=Ne,te.marked=se,te.options=ae,te.parse=Ee,te.parseInline=de,te.parser=Re,te.setOptions=Q,te.use=Y,te.walkTokens=oe,Object.defineProperty(te,"__esModule",{value:!0})}),define(pe[91],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(k,S,L){return Math.min(Math.max(k,S),L)}e.clamp=f;function n(k,S){return(S+k%S)%S}e.rot=n;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class T{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class C{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const L=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=L,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function te(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function C(S){T.push(S,Date.now())}function k(){const S=[];for(let L=0;L<T.length;L+=2)S.push({name:T[L],startTime:T[L+1]});return S}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))T.push({name:C.name,startTime:Math.round(I+C.startTime)});return T}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=f(n))}(),define(pe[12],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let n=!1,I=!1,T=!1,C=!1,k=!1,S=!1,L=!1,O=!1,y=!1,v,b=f,g,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const P=typeof p?.versions?.electron=="string",_=P&&p?.type==="renderer";if(e.isElectronSandboxed=_&&p?.sandboxed,typeof navigator=="object"&&!_)d=navigator.userAgent,n=d.indexOf("Windows")>=0,I=d.indexOf("Macintosh")>=0,O=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=d.indexOf("Linux")>=0,S=!0,v=navigator.language,b=v;else if(typeof p=="object"){n=p.platform==="win32",I=p.platform==="darwin",T=p.platform==="linux",C=T&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,L=P,y=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=f,b=f;const i=p.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),m=a.availableLanguages["*"];v=a.locale,b=m||f,g=a._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var o;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(o=e.Platform||(e.Platform={}));function c(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;I?u=1:n?u=3:T&&(u=2),e.isWindows=n,e.isMacintosh=I,e.isLinux=T,e.isLinuxSnap=C,e.isNative=k,e.isElectron=L,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=O,e.isCI=y,e.platform=u,e.userAgent=d,e.language=b;var l;(function(i){function a(){return e.language}i.value=a;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=m;function h(){return e.language==="en"}i.isDefault=h})(l=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let h=0,w=i.length;h<w;h++){const A=i[h];if(A.id===m.data.vscodeScheduleAsyncWork){i.splice(h,1),A.callback();return}}});let a=0;return m=>{const h=++a;i.push({id:h,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return i=>setTimeout(i)})();var E;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(E=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||O?2:n?1:3;let s=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,s=new Uint16Array(i.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[41],ve([1,0,12]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;n={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(pe[9],ve([1,0,41]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,I=97,T=90,C=122,k=46,S=47,L=92,O=58,y=63;class v extends Error{constructor(c,u,l){let E;typeof u=="string"&&u.indexOf("not ")===0?(E="must not be",u=u.replace(/^not /,"")):E="must be";const s=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${s} ${E} of type ${u}`;t+=`. Received type ${typeof l}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function b(o,c){if(typeof o!="string")throw new v(c,"string",o)}function g(o){return o===S||o===L}function d(o){return o===S}function p(o){return o>=n&&o<=T||o>=I&&o<=C}function P(o,c,u,l){let E="",s=0,t=-1,r=0,i=0;for(let a=0;a<=o.length;++a){if(a<o.length)i=o.charCodeAt(a);else{if(l(i))break;i=S}if(l(i)){if(!(t===a-1||r===1))if(r===2){if(E.length<2||s!==2||E.charCodeAt(E.length-1)!==k||E.charCodeAt(E.length-2)!==k){if(E.length>2){const m=E.lastIndexOf(u);m===-1?(E="",s=0):(E=E.slice(0,m),s=E.length-1-E.lastIndexOf(u)),t=a,r=0;continue}else if(E.length!==0){E="",s=0,t=a,r=0;continue}}c&&(E+=E.length>0?`${u}..`:"..",s=2)}else E.length>0?E+=`${u}${o.slice(t+1,a)}`:E=o.slice(t+1,a),s=a-t-1;t=a,r=0}else i===k&&r!==-1?++r:r=-1}return E}function _(o,c){if(c===null||typeof c!="object")throw new v("pathObject","Object",c);const u=c.dir||c.root,l=c.base||`${c.name||""}${c.ext||""}`;return u?u===c.root?`${u}${l}`:`${u}${o}${l}`:l}e.win32={resolve(...o){let c="",u="",l=!1;for(let E=o.length-1;E>=-1;E--){let s;if(E>=0){if(s=o[E],b(s,"path"),s.length===0)continue}else c.length===0?s=f.cwd():(s=f.env[`=${c}`]||f.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===L)&&(s=`${c}\\`));const t=s.length;let r=0,i="",a=!1;const m=s.charCodeAt(0);if(t===1)g(m)&&(r=1,a=!0);else if(g(m))if(a=!0,g(s.charCodeAt(1))){let h=2,w=h;for(;h<t&&!g(s.charCodeAt(h));)h++;if(h<t&&h!==w){const A=s.slice(w,h);for(w=h;h<t&&g(s.charCodeAt(h));)h++;if(h<t&&h!==w){for(w=h;h<t&&!g(s.charCodeAt(h));)h++;(h===t||h!==w)&&(i=`\\\\${A}\\${s.slice(w,h)}`,r=h)}}}else r=1;else p(m)&&s.charCodeAt(1)===O&&(i=s.slice(0,2),r=2,t>2&&g(s.charCodeAt(2))&&(a=!0,r=3));if(i.length>0)if(c.length>0){if(i.toLowerCase()!==c.toLowerCase())continue}else c=i;if(l){if(c.length>0)break}else if(u=`${s.slice(r)}\\${u}`,l=a,a&&c.length>0)break}return u=P(u,!l,"\\",g),l?`${c}\\${u}`:`${c}${u}`||"."},normalize(o){b(o,"path");const c=o.length;if(c===0)return".";let u=0,l,E=!1;const s=o.charCodeAt(0);if(c===1)return d(s)?"\\":o;if(g(s))if(E=!0,g(o.charCodeAt(1))){let r=2,i=r;for(;r<c&&!g(o.charCodeAt(r));)r++;if(r<c&&r!==i){const a=o.slice(i,r);for(i=r;r<c&&g(o.charCodeAt(r));)r++;if(r<c&&r!==i){for(i=r;r<c&&!g(o.charCodeAt(r));)r++;if(r===c)return`\\\\${a}\\${o.slice(i)}\\`;r!==i&&(l=`\\\\${a}\\${o.slice(i,r)}`,u=r)}}}else u=1;else p(s)&&o.charCodeAt(1)===O&&(l=o.slice(0,2),u=2,c>2&&g(o.charCodeAt(2))&&(E=!0,u=3));let t=u<c?P(o.slice(u),!E,"\\",g):"";return t.length===0&&!E&&(t="."),t.length>0&&g(o.charCodeAt(c-1))&&(t+="\\"),l===void 0?E?`\\${t}`:t:E?`${l}\\${t}`:`${l}${t}`},isAbsolute(o){b(o,"path");const c=o.length;if(c===0)return!1;const u=o.charCodeAt(0);return g(u)||c>2&&p(u)&&o.charCodeAt(1)===O&&g(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let c,u;for(let s=0;s<o.length;++s){const t=o[s];b(t,"path"),t.length>0&&(c===void 0?c=u=t:c+=`\\${t}`)}if(c===void 0)return".";let l=!0,E=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++E;const s=u.length;s>1&&g(u.charCodeAt(1))&&(++E,s>2&&(g(u.charCodeAt(2))?++E:l=!1))}if(l){for(;E<c.length&&g(c.charCodeAt(E));)E++;E>=2&&(c=`\\${c.slice(E)}`)}return e.win32.normalize(c)},relative(o,c){if(b(o,"from"),b(c,"to"),o===c)return"";const u=e.win32.resolve(o),l=e.win32.resolve(c);if(u===l||(o=u.toLowerCase(),c=l.toLowerCase(),o===c))return"";let E=0;for(;E<o.length&&o.charCodeAt(E)===L;)E++;let s=o.length;for(;s-1>E&&o.charCodeAt(s-1)===L;)s--;const t=s-E;let r=0;for(;r<c.length&&c.charCodeAt(r)===L;)r++;let i=c.length;for(;i-1>r&&c.charCodeAt(i-1)===L;)i--;const a=i-r,m=t<a?t:a;let h=-1,w=0;for(;w<m;w++){const F=o.charCodeAt(E+w);if(F!==c.charCodeAt(r+w))break;F===L&&(h=w)}if(w!==m){if(h===-1)return l}else{if(a>m){if(c.charCodeAt(r+w)===L)return l.slice(r+w+1);if(w===2)return l.slice(r+w)}t>m&&(o.charCodeAt(E+w)===L?h=w:w===2&&(h=3)),h===-1&&(h=0)}let A="";for(w=E+h+1;w<=s;++w)(w===s||o.charCodeAt(w)===L)&&(A+=A.length===0?"..":"\\..");return r+=h,A.length>0?`${A}${l.slice(r,i)}`:(l.charCodeAt(r)===L&&++r,l.slice(r,i))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const c=e.win32.resolve(o);if(c.length<=2)return o;if(c.charCodeAt(0)===L){if(c.charCodeAt(1)===L){const u=c.charCodeAt(2);if(u!==y&&u!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===O&&c.charCodeAt(2)===L)return`\\\\?\\${c}`;return o},dirname(o){b(o,"path");const c=o.length;if(c===0)return".";let u=-1,l=0;const E=o.charCodeAt(0);if(c===1)return g(E)?o:".";if(g(E)){if(u=l=1,g(o.charCodeAt(1))){let r=2,i=r;for(;r<c&&!g(o.charCodeAt(r));)r++;if(r<c&&r!==i){for(i=r;r<c&&g(o.charCodeAt(r));)r++;if(r<c&&r!==i){for(i=r;r<c&&!g(o.charCodeAt(r));)r++;if(r===c)return o;r!==i&&(u=l=r+1)}}}}else p(E)&&o.charCodeAt(1)===O&&(u=c>2&&g(o.charCodeAt(2))?3:2,l=u);let s=-1,t=!0;for(let r=c-1;r>=l;--r)if(g(o.charCodeAt(r))){if(!t){s=r;break}}else t=!1;if(s===-1){if(u===-1)return".";s=u}return o.slice(0,s)},basename(o,c){c!==void 0&&b(c,"ext"),b(o,"path");let u=0,l=-1,E=!0,s;if(o.length>=2&&p(o.charCodeAt(0))&&o.charCodeAt(1)===O&&(u=2),c!==void 0&&c.length>0&&c.length<=o.length){if(c===o)return"";let t=c.length-1,r=-1;for(s=o.length-1;s>=u;--s){const i=o.charCodeAt(s);if(g(i)){if(!E){u=s+1;break}}else r===-1&&(E=!1,r=s+1),t>=0&&(i===c.charCodeAt(t)?--t==-1&&(l=s):(t=-1,l=r))}return u===l?l=r:l===-1&&(l=o.length),o.slice(u,l)}for(s=o.length-1;s>=u;--s)if(g(o.charCodeAt(s))){if(!E){u=s+1;break}}else l===-1&&(E=!1,l=s+1);return l===-1?"":o.slice(u,l)},extname(o){b(o,"path");let c=0,u=-1,l=0,E=-1,s=!0,t=0;o.length>=2&&o.charCodeAt(1)===O&&p(o.charCodeAt(0))&&(c=l=2);for(let r=o.length-1;r>=c;--r){const i=o.charCodeAt(r);if(g(i)){if(!s){l=r+1;break}continue}E===-1&&(s=!1,E=r+1),i===k?u===-1?u=r:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||E===-1||t===0||t===1&&u===E-1&&u===l+1?"":o.slice(u,E)},format:_.bind(null,"\\"),parse(o){b(o,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return c;const u=o.length;let l=0,E=o.charCodeAt(0);if(u===1)return g(E)?(c.root=c.dir=o,c):(c.base=c.name=o,c);if(g(E)){if(l=1,g(o.charCodeAt(1))){let h=2,w=h;for(;h<u&&!g(o.charCodeAt(h));)h++;if(h<u&&h!==w){for(w=h;h<u&&g(o.charCodeAt(h));)h++;if(h<u&&h!==w){for(w=h;h<u&&!g(o.charCodeAt(h));)h++;h===u?l=h:h!==w&&(l=h+1)}}}}else if(p(E)&&o.charCodeAt(1)===O){if(u<=2)return c.root=c.dir=o,c;if(l=2,g(o.charCodeAt(2))){if(u===3)return c.root=c.dir=o,c;l=3}}l>0&&(c.root=o.slice(0,l));let s=-1,t=l,r=-1,i=!0,a=o.length-1,m=0;for(;a>=l;--a){if(E=o.charCodeAt(a),g(E)){if(!i){t=a+1;break}continue}r===-1&&(i=!1,r=a+1),E===k?s===-1?s=a:m!==1&&(m=1):s!==-1&&(m=-1)}return r!==-1&&(s===-1||m===0||m===1&&s===r-1&&s===t+1?c.base=c.name=o.slice(t,r):(c.name=o.slice(t,s),c.base=o.slice(t,r),c.ext=o.slice(s,r))),t>0&&t!==l?c.dir=o.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let c="",u=!1;for(let l=o.length-1;l>=-1&&!u;l--){const E=l>=0?o[l]:f.cwd();b(E,"path"),E.length!==0&&(c=`${E}/${c}`,u=E.charCodeAt(0)===S)}return c=P(c,!u,"/",d),u?`/${c}`:c.length>0?c:"."},normalize(o){if(b(o,"path"),o.length===0)return".";const c=o.charCodeAt(0)===S,u=o.charCodeAt(o.length-1)===S;return o=P(o,!c,"/",d),o.length===0?c?"/":u?"./":".":(u&&(o+="/"),c?`/${o}`:o)},isAbsolute(o){return b(o,"path"),o.length>0&&o.charCodeAt(0)===S},join(...o){if(o.length===0)return".";let c;for(let u=0;u<o.length;++u){const l=o[u];b(l,"path"),l.length>0&&(c===void 0?c=l:c+=`/${l}`)}return c===void 0?".":e.posix.normalize(c)},relative(o,c){if(b(o,"from"),b(c,"to"),o===c||(o=e.posix.resolve(o),c=e.posix.resolve(c),o===c))return"";const u=1,l=o.length,E=l-u,s=1,t=c.length-s,r=E<t?E:t;let i=-1,a=0;for(;a<r;a++){const h=o.charCodeAt(u+a);if(h!==c.charCodeAt(s+a))break;h===S&&(i=a)}if(a===r)if(t>r){if(c.charCodeAt(s+a)===S)return c.slice(s+a+1);if(a===0)return c.slice(s+a)}else E>r&&(o.charCodeAt(u+a)===S?i=a:a===0&&(i=0));let m="";for(a=u+i+1;a<=l;++a)(a===l||o.charCodeAt(a)===S)&&(m+=m.length===0?"..":"/..");return`${m}${c.slice(s+i)}`},toNamespacedPath(o){return o},dirname(o){if(b(o,"path"),o.length===0)return".";const c=o.charCodeAt(0)===S;let u=-1,l=!0;for(let E=o.length-1;E>=1;--E)if(o.charCodeAt(E)===S){if(!l){u=E;break}}else l=!1;return u===-1?c?"/":".":c&&u===1?"//":o.slice(0,u)},basename(o,c){c!==void 0&&b(c,"ext"),b(o,"path");let u=0,l=-1,E=!0,s;if(c!==void 0&&c.length>0&&c.length<=o.length){if(c===o)return"";let t=c.length-1,r=-1;for(s=o.length-1;s>=0;--s){const i=o.charCodeAt(s);if(i===S){if(!E){u=s+1;break}}else r===-1&&(E=!1,r=s+1),t>=0&&(i===c.charCodeAt(t)?--t==-1&&(l=s):(t=-1,l=r))}return u===l?l=r:l===-1&&(l=o.length),o.slice(u,l)}for(s=o.length-1;s>=0;--s)if(o.charCodeAt(s)===S){if(!E){u=s+1;break}}else l===-1&&(E=!1,l=s+1);return l===-1?"":o.slice(u,l)},extname(o){b(o,"path");let c=-1,u=0,l=-1,E=!0,s=0;for(let t=o.length-1;t>=0;--t){const r=o.charCodeAt(t);if(r===S){if(!E){u=t+1;break}continue}l===-1&&(E=!1,l=t+1),r===k?c===-1?c=t:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||l===-1||s===0||s===1&&c===l-1&&c===u+1?"":o.slice(c,l)},format:_.bind(null,"/"),parse(o){b(o,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return c;const u=o.charCodeAt(0)===S;let l;u?(c.root="/",l=1):l=0;let E=-1,s=0,t=-1,r=!0,i=o.length-1,a=0;for(;i>=l;--i){const m=o.charCodeAt(i);if(m===S){if(!r){s=i+1;break}continue}t===-1&&(r=!1,t=i+1),m===k?E===-1?E=i:a!==1&&(a=1):E!==-1&&(a=-1)}if(t!==-1){const m=s===0&&u?1:s;E===-1||a===0||a===1&&E===t-1&&E===s+1?c.base=c.name=o.slice(m,t):(c.name=o.slice(m,E),c.base=o.slice(m,t),c.ext=o.slice(E,t))}return s>0?c.dir=o.slice(0,s-1):u&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[92],ve([1,0,9]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(y){y.text="text/plain",y.binary="application/octet-stream",y.unknown="application/unknown",y.markdown="text/markdown",y.latex="text/latex",y.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(y){const v=(0,f.extname)(y),b=I[v.toLowerCase()];return b!==void 0?b:k(y)}e.getMediaOrTextMime=C;function k(y){const v=(0,f.extname)(y);return T[v.toLowerCase()]}e.getMediaMime=k;function S(y){for(const v in T)if(T[v]===y)return v}e.getExtensionForMimeType=S;const L=/^(.+)\/(.+?)(;.+)?$/;function O(y,v){const b=L.exec(y);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:v?void 0:y}e.normalizeMimeType=O}),define(pe[93],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var n;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(T,...C){const k=C.reduce((O,y)=>(O[y]=!0,O),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(O=>!k[O]).forEach(O=>{for(let y=0;y<S.length;y++)if(O.search(S[y])!==-1){delete T[O];break}})}e.sanitizeProcessEnvironment=I}),define(pe[46],ve([1,0,12]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(C){this._highResolution=n&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new I(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(pe[3],ve([1,0,15,74,6,90,46]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let k=!1,S=!1;var L;(function(s){s.None=()=>I.Disposable.None;function t(J){if(S){const{onListenerDidAdd:se}=J,ae=g.create();let Q=0;J.onListenerDidAdd=()=>{++Q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),se?.()}}}function r(J){return(se,ae=null,Q)=>{let Y=!1,oe;return oe=J(de=>{if(!Y)return oe?oe.dispose():Y=!0,se.call(ae,de)},null,Q),Y&&oe.dispose(),oe}}s.once=r;function i(J,se,ae){return F((Q,Y=null,oe)=>J(de=>Q.call(Y,se(de)),null,oe),ae)}s.map=i;function a(J,se,ae){return F((Q,Y=null,oe)=>J(de=>{se(de),Q.call(Y,de)},null,oe),ae)}s.forEach=a;function m(J,se,ae){return F((Q,Y=null,oe)=>J(de=>se(de)&&Q.call(Y,de),null,oe),ae)}s.filter=m;function h(J){return J}s.signal=h;function w(...J){return(se,ae=null,Q)=>(0,I.combinedDisposable)(...J.map(Y=>Y(oe=>se.call(ae,oe),null,Q)))}s.any=w;function A(J,se,ae,Q){let Y=ae;return i(J,oe=>(Y=se(Y,oe),Y),Q)}s.reduce=A;function F(J,se){let ae;const Q={onFirstListenerAdd(){ae=J(Y.fire,Y)},onLastListenerRemove(){ae.dispose()}};se||t(Q);const Y=new p(Q);return se&&se.add(Y),Y.event}function R(J,se,ae=100,Q=!1,Y,oe){let de,Ee,Re,Ne=0;const be={leakWarningThreshold:Y,onFirstListenerAdd(){de=J(H=>{Ne++,Ee=se(Ee,H),Q&&!Re&&(we.fire(Ee),Ee=void 0),clearTimeout(Re),Re=setTimeout(()=>{const B=Ee;Ee=void 0,Re=void 0,(!Q||Ne>1)&&we.fire(B),Ne=0},ae)})},onLastListenerRemove(){de.dispose()}};oe||t(be);const we=new p(be);return oe&&oe.add(we),we.event}s.debounce=R;function D(J,se=(Q,Y)=>Q===Y,ae){let Q=!0,Y;return m(J,oe=>{const de=Q||!se(oe,Y);return Q=!1,Y=oe,de},ae)}s.latch=D;function $(J,se,ae){return[s.filter(J,se,ae),s.filter(J,Q=>!se(Q),ae)]}s.split=$;function M(J,se=!1,ae=[]){let Q=ae.slice(),Y=J(Ee=>{Q?Q.push(Ee):de.fire(Ee)});const oe=()=>{Q&&Q.forEach(Ee=>de.fire(Ee)),Q=null},de=new p({onFirstListenerAdd(){Y||(Y=J(Ee=>de.fire(Ee)))},onFirstListenerDidAdd(){Q&&(se?setTimeout(oe):oe())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return de.event}s.buffer=M;class q{constructor(se){this.event=se}map(se){return new q(i(this.event,se))}forEach(se){return new q(a(this.event,se))}filter(se){return new q(m(this.event,se))}reduce(se,ae){return new q(A(this.event,se,ae))}latch(){return new q(D(this.event))}debounce(se,ae=100,Q=!1,Y){return new q(R(this.event,se,ae,Q,Y))}on(se,ae,Q){return this.event(se,ae,Q)}once(se,ae,Q){return r(this.event)(se,ae,Q)}}function G(J){return new q(J)}s.chain=G;function U(J,se,ae=Q=>Q){const Q=(...Ee)=>de.fire(ae(...Ee)),Y=()=>J.on(se,Q),oe=()=>J.removeListener(se,Q),de=new p({onFirstListenerAdd:Y,onLastListenerRemove:oe});return de.event}s.fromNodeEventEmitter=U;function W(J,se,ae=Q=>Q){const Q=(...Ee)=>de.fire(ae(...Ee)),Y=()=>J.addEventListener(se,Q),oe=()=>J.removeEventListener(se,Q),de=new p({onFirstListenerAdd:Y,onLastListenerRemove:oe});return de.event}s.fromDOMEventEmitter=W;function ee(J){return new Promise(se=>r(J)(se))}s.toPromise=ee;function Z(J,se){return se(void 0),J(ae=>se(ae))}s.runAndSubscribe=Z;function V(J,se){let ae=null;function Q(oe){ae?.dispose(),ae=new I.DisposableStore,se(oe,ae)}Q(void 0);const Y=J(oe=>Q(oe));return(0,I.toDisposable)(()=>{Y.dispose(),ae?.dispose()})}s.runAndSubscribeWithStore=V})(L=e.Event||(e.Event={}));class O{constructor(t){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${t}_${O._idPool++}`}start(t){this._stopWatch=new C.StopWatch(!0),this._listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this._elapsedOverall+=t,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${t.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}O._idPool=0;let y=-1;function v(s){const t=y;return y=s,{dispose(){y=t}}}e.setGlobalLeakWarningThreshold=v;class b{constructor(t,r=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,r){let i=y;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||r<i)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let m,h=0;for(const[w,A]of this._stacks)(!m||h<A)&&(m=w,h=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${h}):`),console.warn(m)}return()=>{const m=this._stacks.get(t.value)||0;this._stacks.set(t.value,m-1)}}}class g{constructor(t){this.value=t}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(t,r,i){this.callback=t,this.callbackThis=r,this.stack=i,this.subscription=new I.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class p{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=y>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new O(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const r of t)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,r,i)=>{this._listeners||(this._listeners=new T.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let m,h;this._leakageMon&&this._listeners.size>=30&&(h=g.create(),m=this._leakageMon.check(h,this._listeners.size+1)),k&&(h=h??g.create());const w=new d(t,r,h),A=this._listeners.push(w);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,r);const F=w.subscription.set(()=>{m&&m(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof I.DisposableStore?i.add(F):Array.isArray(i)&&i.push(F),F}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,t]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,i]=this._deliveryQueue.shift();try{r.invoke(i)}catch(a){(0,f.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class P extends p{async fireAsync(t,r,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,t]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[a,m]=this._asyncDeliveryQueue.shift(),h=[],w={...m,token:r,waitUntil:A=>{if(Object.isFrozen(h))throw new Error("waitUntil can NOT be called asynchronous");i&&(A=i(A,a.callback)),h.push(A)}};try{a.invoke(w)}catch(A){(0,f.onUnexpectedError)(A);continue}Object.freeze(h),await Promise.allSettled(h).then(A=>{for(const F of A)F.status==="rejected"&&(0,f.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=P;class _ extends p{constructor(t){super(t);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=_;class o extends _{constructor(t){super(t);this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=o;class c extends p{constructor(t){super(t);this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=c;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const r={event:t,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const i=()=>{this.hasListeners&&this.unhook(r);const a=this.events.indexOf(r);this.events.splice(a,1)};return(0,I.toDisposable)((0,n.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(r=>this.emitter.fire(r))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class l{constructor(){this.buffers=[]}wrapEvent(t){return(r,i,a)=>t(m=>{const h=this.buffers[this.buffers.length-1];h?h.push(()=>r.call(i,m)):r.call(i,m)},void 0,a)}bufferEvents(t){const r=[];this.buffers.push(r);const i=t();return this.buffers.pop(),r.forEach(a=>a()),i}}e.EventBufferer=l;class E{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=I.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(pe[21],ve([1,0,3]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(k,S){const L=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(L)}}});var I;(function(k){function S(L){return L===k.None||L===k.Cancelled||L instanceof T?!0:!L||typeof L!="object"?!1:typeof L.isCancellationRequested=="boolean"&&typeof L.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(I=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(pe[143],ve([1,0,21]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new f.CancellationTokenSource,k=this.task(C.token);return this.result={promise:k,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=n;class I{constructor(C){this.computeFn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const k=JSON.stringify(C);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(C)),this.lastCache}}e.LRUCachedComputed=I}),define(pe[94],ve([1,0,15,6]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(c){const u=c;return u?typeof u.read=="function":!1}e.isReadable=I;function T(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=T;function C(c){const u=c;return u?T(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(c,u){return new S(c,u)}e.newWriteableStream=k;class S{constructor(u,l){this.reducer=u,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(l=>l(u))}emitError(u){this.listeners.error.length===0?(0,f.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(l=>l(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,l){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(u,l){if(this.state.destroyed)return;let E;switch(u){case"data":E=this.listeners.data;break;case"end":E=this.listeners.end;break;case"error":E=this.listeners.error;break}if(E){const s=E.indexOf(l);s>=0&&E.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(E=>E())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function L(c,u){const l=[];let E;for(;(E=c.read())!==null;)l.push(E);return u(l)}e.consumeReadable=L;function O(c,u,l){const E=[];let s;for(;(s=c.read())!==null&&E.length<l;)E.push(s);return s===null&&E.length>0?u(E):{read:()=>{if(E.length>0)return E.shift();if(typeof s!="undefined"){const t=s;return s=void 0,t}return c.read()}}}e.peekReadable=O;function y(c,u){return new Promise((l,E)=>{const s=[];v(c,{onData:t=>{u&&s.push(t)},onError:t=>{u?E(t):l(void 0)},onEnd:()=>{l(u?u(s):void 0)}})})}e.consumeStream=y;function v(c,u){let l=!1;return c.on("error",E=>{l||u.onError(E)}),c.on("end",()=>{l||u.onEnd()}),c.on("data",E=>{l||u.onData(E)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=v;function b(c,u){return new Promise((l,E)=>{const s=new n.DisposableStore,t=[],r=m=>{if(t.push(m),t.length>u)return s.dispose(),c.pause(),l({stream:c,buffer:t,ended:!1})},i=m=>E(m),a=()=>l({stream:c,buffer:t,ended:!0});s.add((0,n.toDisposable)(()=>c.removeListener("error",i))),c.on("error",i),s.add((0,n.toDisposable)(()=>c.removeListener("end",a))),c.on("end",a),s.add((0,n.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=b;function g(c,u){const l=k(u);return l.end(c),l}e.toStream=g;function d(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function p(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}e.toReadable=p;function P(c,u,l){const E=k(l);return v(c,{onData:s=>E.write(u.data(s)),onError:s=>E.error(u.error?u.error(s):s),onEnd:()=>E.end()}),E}e.transform=P;function _(c,u,l){let E=!1;return{read:()=>{const s=u.read();return E?s:(E=!0,s!==null?l([c,s]):c)}}}e.prefixedReadable=_;function o(c,u,l){let E=!1;const s=k(l);return v(u,{onData:t=>E?s.write(t):(E=!0,s.write(l([c,t]))),onError:t=>s.error(t),onEnd:()=>{E||(E=!0,s.write(c)),s.end()}}),s}e.prefixedStream=o}),define(pe[22],ve([1,0,94]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let I,T;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return n?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return n&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,h){return!(h?.dontUseNodeBuffer||!1)&&n?new C(Buffer.from(m)):(I||(I=new TextEncoder),new C(I.encode(m)))}static fromByteArray(m){const h=C.alloc(m.length);for(let w=0,A=m.length;w<A;w++)h.buffer[w]=m[w];return h}static concat(m,h){if(typeof h=="undefined"){h=0;for(let F=0,R=m.length;F<R;F++)h+=m[F].byteLength}const w=C.alloc(h);let A=0;for(let F=0,R=m.length;F<R;F++){const D=m[F];w.set(D,A),A+=D.byteLength}return w}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(m,h){return new C(this.buffer.subarray(m,h))}set(m,h){if(m instanceof C)this.buffer.set(m.buffer,h);else if(m instanceof Uint8Array)this.buffer.set(m,h);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),h);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return L(this.buffer,m)}writeUInt32BE(m,h){O(this.buffer,m,h)}readUInt32LE(m){return y(this.buffer,m)}writeUInt32LE(m,h){v(this.buffer,m,h)}readUInt8(m){return b(this.buffer,m)}writeUInt8(m,h){g(this.buffer,m,h)}}e.VSBuffer=C;function k(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0}e.readUInt16LE=k;function S(a,m,h){a[h+0]=m&255,m=m>>>8,a[h+1]=m&255}e.writeUInt16LE=S;function L(a,m){return a[m]*2**24+a[m+1]*2**16+a[m+2]*2**8+a[m+3]}e.readUInt32BE=L;function O(a,m,h){a[h+3]=m,m=m>>>8,a[h+2]=m,m=m>>>8,a[h+1]=m,m=m>>>8,a[h]=m}e.writeUInt32BE=O;function y(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0|a[m+2]<<16>>>0|a[m+3]<<24>>>0}e.readUInt32LE=y;function v(a,m,h){a[h+0]=m&255,m=m>>>8,a[h+1]=m&255,m=m>>>8,a[h+2]=m&255,m=m>>>8,a[h+3]=m&255}e.writeUInt32LE=v;function b(a,m){return a[m]}e.readUInt8=b;function g(a,m,h){a[h]=m}e.writeUInt8=g;function d(a){return f.consumeReadable(a,m=>C.concat(m))}e.readableToBuffer=d;function p(a){return f.toReadable(a)}e.bufferToReadable=p;function P(a){return f.consumeStream(a,m=>C.concat(m))}e.streamToBuffer=P;async function _(a){return a.ended?C.concat(a.buffer):C.concat([...a.buffer,await P(a.stream)])}e.bufferedStreamToBuffer=_;function o(a){return f.toStream(a,m=>C.concat(m))}e.bufferToStream=o;function c(a){return f.transform(a,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=c;function u(a){return f.newWriteableStream(m=>C.concat(m),a)}e.newWriteableBufferStream=u;function l(a,m){return f.prefixedReadable(a,m,h=>C.concat(h))}e.prefixedBufferReadable=l;function E(a,m){return f.prefixedStream(a,m,h=>C.concat(h))}e.prefixedBufferStream=E;function s(a){let m=0,h=0,w=0;const A=new Uint8Array(Math.floor(a.length/4*3)),F=D=>{switch(h){case 3:A[w++]=m|D,h=0;break;case 2:A[w++]=m|D>>>2,m=D<<6,h=3;break;case 1:A[w++]=m|D>>>4,m=D<<4,h=2;break;default:m=D<<2,h=1}};for(let D=0;D<a.length;D++){const $=a.charCodeAt(D);if($>=65&&$<=90)F($-65);else if($>=97&&$<=122)F($-97+26);else if($>=48&&$<=57)F($-48+52);else if($===43||$===45)F(62);else if($===47||$===95)F(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${a[D]}`)}}const R=w;for(;h>0;)F(0);return C.wrap(A).slice(0,R)}e.decodeBase64=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function i({buffer:a},m=!0,h=!1){const w=h?r:t;let A="";const F=a.byteLength%3;let R=0;for(;R<a.byteLength-F;R+=3){const D=a[R+0],$=a[R+1],M=a[R+2];A+=w[D>>>2],A+=w[(D<<4|$>>>4)&63],A+=w[($<<2|M>>>6)&63],A+=w[M&63]}if(F===1){const D=a[R+0];A+=w[D>>>2],A+=w[D<<4&63],m&&(A+="==")}else if(F===2){const D=a[R+0],$=a[R+1];A+=w[D>>>2],A+=w[(D<<4|$>>>4)&63],A+=w[$<<2&63],m&&(A+="=")}return A}e.encodeBase64=i}),define(pe[8],ve([1,0,143,89]),function(te,e,f,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const C=/{(\d+)}/g;function k(X,...ge){return ge.length===0?X:X.replace(C,function(Se,Me){const $e=parseInt(Me,10);return isNaN($e)||$e<0||$e>=ge.length?Se:ge[$e]})}e.format=k;const S=/{([^}]+)}/g;function L(X,ge){return X.replace(S,(Se,Me)=>ge[Me]??Se)}e.format2=L;function O(X){return X.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=O;function y(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function v(X,ge){let Se=0;const Me=ge.charCodeAt(0);for(let $e=X.length-1;$e>=0;$e--)X.charCodeAt($e)===Me&&Se++;return Se}e.count=v;function b(X,ge,Se="\u2026"){return X.length<=ge?X:`${X.substr(0,ge)}${Se}`}e.truncate=b;function g(X,ge=" "){const Se=d(X,ge);return p(Se,ge)}e.trim=g;function d(X,ge){if(!X||!ge)return X;const Se=ge.length;if(Se===0||X.length===0)return X;let Me=0;for(;X.indexOf(ge,Me)===Me;)Me=Me+Se;return X.substring(Me)}e.ltrim=d;function p(X,ge){if(!X||!ge)return X;const Se=ge.length,Me=X.length;if(Se===0||Me===0)return X;let $e=Me,Ye=-1;for(;Ye=X.lastIndexOf(ge,$e-1),!(Ye===-1||Ye+Se!==$e);){if(Ye===0)return"";$e=Ye}return X.substring(0,$e)}e.rtrim=p;function P(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function _(X){return X.replace(/\*/g,"")}e.stripWildcards=_;function o(X,ge,Se={}){if(!X)throw new Error("Cannot create regex from empty string");ge||(X=y(X)),Se.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let Me="";return Se.global&&(Me+="g"),Se.matchCase||(Me+="i"),Se.multiline&&(Me+="m"),Se.unicode&&(Me+="u"),new RegExp(X,Me)}e.createRegExp=o;function c(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function u(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function l(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=l;function E(X){return X.split(/\r\n|\r|\n/)}e.splitLines=E;function s(X){for(let ge=0,Se=X.length;ge<Se;ge++){const Me=X.charCodeAt(ge);if(Me!==32&&Me!==9)return ge}return-1}e.firstNonWhitespaceIndex=s;function t(X,ge=0,Se=X.length){for(let Me=ge;Me<Se;Me++){const $e=X.charCodeAt(Me);if($e!==32&&$e!==9)return X.substring(ge,Me)}return X.substring(ge,Se)}e.getLeadingWhitespace=t;function r(X,ge=X.length-1){for(let Se=ge;Se>=0;Se--){const Me=X.charCodeAt(Se);if(Me!==32&&Me!==9)return Se}return-1}e.lastNonWhitespaceIndex=r;function i(X,ge){return X<ge?-1:X>ge?1:0}e.compare=i;function a(X,ge,Se=0,Me=X.length,$e=0,Ye=ge.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=X.charCodeAt(Se),je=ge.charCodeAt($e);if(wt<je)return-1;if(wt>je)return 1}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstring=a;function m(X,ge){return h(X,ge,0,X.length,0,ge.length)}e.compareIgnoreCase=m;function h(X,ge,Se=0,Me=X.length,$e=0,Ye=ge.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=X.charCodeAt(Se),je=ge.charCodeAt($e);if(wt===je)continue;if(wt>=128||je>=128)return a(X.toLowerCase(),ge.toLowerCase(),Se,Me,$e,Ye);w(wt)&&(wt-=32),w(je)&&(je-=32);const st=wt-je;if(st!==0)return st}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstringIgnoreCase=h;function w(X){return X>=97&&X<=122}e.isLowerAsciiLetter=w;function A(X){return X>=65&&X<=90}e.isUpperAsciiLetter=A;function F(X,ge){return X.length===ge.length&&h(X,ge)===0}e.equalsIgnoreCase=F;function R(X,ge){const Se=ge.length;return ge.length>X.length?!1:h(X,ge,0,Se)===0}e.startsWithIgnoreCase=R;function D(X,ge){let Se,Me=Math.min(X.length,ge.length);for(Se=0;Se<Me;Se++)if(X.charCodeAt(Se)!==ge.charCodeAt(Se))return Se;return Me}e.commonPrefixLength=D;function $(X,ge){let Se,Me=Math.min(X.length,ge.length);const $e=X.length-1,Ye=ge.length-1;for(Se=0;Se<Me;Se++)if(X.charCodeAt($e-Se)!==ge.charCodeAt(Ye-Se))return Se;return Me}e.commonSuffixLength=$;function M(X){return 55296<=X&&X<=56319}e.isHighSurrogate=M;function q(X){return 56320<=X&&X<=57343}e.isLowSurrogate=q;function G(X,ge){return(X-55296<<10)+(ge-56320)+65536}e.computeCodePoint=G;function U(X,ge,Se){const Me=X.charCodeAt(Se);if(M(Me)&&Se+1<ge){const $e=X.charCodeAt(Se+1);if(q($e))return G(Me,$e)}return Me}e.getNextCodePoint=U;function W(X,ge){const Se=X.charCodeAt(ge-1);if(q(Se)&&ge>1){const Me=X.charCodeAt(ge-2);if(M(Me))return G(Me,Se)}return Se}class ee{constructor(ge,Se=0){this._str=ge,this._len=ge.length,this._offset=Se}get offset(){return this._offset}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=W(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=U(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=ee;class Z{constructor(ge,Se=0){this._iterator=new ee(ge,Se)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ge=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=ge.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ye=Se.offset,lt=ge.getGraphemeBreakType(Se.nextCodePoint());if(ze($e,lt)){Se.setOffset(Ye);break}$e=lt}return Se.offset-Me}prevGraphemeLength(){const ge=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=ge.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ye=Se.offset,lt=ge.getGraphemeBreakType(Se.prevCodePoint());if(ze(lt,$e)){Se.setOffset(Ye);break}$e=lt}return Me-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Z;function V(X,ge){return new Z(X,ge).nextGraphemeLength()}e.nextCharLength=V;function J(X,ge){return new Z(X,ge).prevGraphemeLength()}e.prevCharLength=J;function se(X,ge){ge>0&&q(X.charCodeAt(ge))&&ge--;const Se=ge+V(X,ge);return[Se-J(X,Se),Se]}e.getCharContainingOffset=se;const ae=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(X){return ae.test(X)}e.containsRTL=Q;const Y=/^[\t\n\r\x20-\x7E]*$/;function oe(X){return Y.test(X)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=de;function Ee(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=Ee;function Re(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=Re;function Ne(X,ge){if(X.length<ge)return X;const Se=/\b/g;let Me=0;for(;Se.test(X)&&!(X.length-Se.lastIndex<ge);)Me=Se.lastIndex,Se.lastIndex+=1;return X.substring(Me).replace(/^\s/,"")}e.lcut=Ne;const be=/\x1B\x5B[12]?K/g,we=/\x1b\[\d+m/g,H=/\x1b\[0?m/g;function B(X){return X&&(X=X.replace(be,""),X=X.replace(we,""),X=X.replace(H,"")),X}e.removeAnsiEscapeCodes=B,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function z(X){return N(X)?X.substr(1):X}e.stripUTF8BOM=z;function j(X,ge){if(!X||!ge||X.length<ge.length)return!1;const Se=ge.length,Me=X.toLowerCase();let $e=0,Ye=-1;for(;$e<Se;){const lt=Me.indexOf(ge[$e],Ye+1);if(lt<0)return!1;Ye=lt,$e++}return!0}e.fuzzyContains=j;function re(X,ge=!1){return X?(ge&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=re;function he(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=he;function Ce(X,ge=1){if(ge===0)return"";let Se=-1;do Se=X.indexOf(`
`,Se+1),ge--;while(ge>0&&Se>=0);return Se===-1?X:(X[Se-1]==="\r"&&Se--,X.substr(0,Se))}e.getNLines=Ce;function Te(X){const ge=90-65+1;return X=X%(2*ge),X<ge?String.fromCharCode(97+X):String.fromCharCode(65+X-ge)}e.singleLetterHash=Te;function We(X){return He.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=We;function ze(X,ge){return X===0?ge!==5&&ge!==7:X===2&&ge===3?!1:X===4||X===2||X===3||ge===4||ge===2||ge===3?!0:!(X===8&&(ge===8||ge===9||ge===11||ge===12)||(X===11||X===9)&&(ge===9||ge===10)||(X===12||X===10)&&ge===10||ge===5||ge===13||ge===7||X===1||X===13&&ge===14||X===6&&ge===6)}var qe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{constructor(){this._data=Ue()}static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const Se=this._data,Me=Se.length/3;let $e=1;for(;$e<=Me;)if(ge<Se[3*$e])$e=2*$e;else if(ge>Se[3*$e+1])$e=2*$e+1;else return Se[3*$e+2];return 0}}He._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(X,ge){if(X===0)return 0;const Se=et(X,ge);if(Se!==void 0)return Se;const Me=new ee(ge,X);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Je;function et(X,ge){const Se=new ee(ge,X);let Me=Se.prevCodePoint();for(;Le(Me)||Me===65039||Me===8419;){if(Se.offset===0)return;Me=Se.prevCodePoint()}if(!Re(Me))return;let $e=Se.offset;return $e>0&&Se.prevCodePoint()===8205&&($e=Se.offset),$e}function Le(X){return 127995<=X&&X<=127999}var it;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class ne{constructor(ge){this.confusableDictionary=ge}static getInstance(ge){return ne.cache.get(Array.from(ge))}static getLocales(){return ne._locales.getValue()}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new f.LRUCachedComputed(X=>{function ge(je){const st=new Map;for(let _t=0;_t<je.length;_t+=2)st.set(je[_t],je[_t+1]);return st}function Se(je,st){const _t=new Map(je);for(const[nt,ct]of st)_t.set(nt,ct);return _t}function Me(je,st){if(!je)return st;const _t=new Map;for(const[nt,ct]of je)st.has(nt)&&_t.set(nt,ct);return _t}const $e=I.ambiguousCharacterData.getValue();let Ye=X.filter(je=>!je.startsWith("_")&&je in $e);Ye.length===0&&(Ye=["_default"]);let lt;for(const je of Ye){const st=ge($e[je]);lt=Me(lt,st)}const vt=ge($e._common),wt=Se(vt,lt);return new ne(wt)}),ne._locales=new n.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class le{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(le.getRawData())),this._data}static isInvisibleCharacter(ge){return le.getData().has(ge)}static get codePoints(){return le.getData()}}e.InvisibleCharacters=le,le._data=void 0}),define(pe[57],ve([1,0,8]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(P){return I(P,0)}e.hash=n;function I(P,_){switch(typeof P){case"object":return P===null?T(349,_):Array.isArray(P)?S(P,_):L(P,_);case"string":return k(P,_);case"boolean":return C(P,_);case"number":return T(P,_);case"undefined":return T(937,_);default:return T(617,_)}}e.doHash=I;function T(P,_){return(_<<5)-_+P|0}e.numberHash=T;function C(P,_){return T(P?433:863,_)}function k(P,_){_=T(149417,_);for(let o=0,c=P.length;o<c;o++)_=T(P.charCodeAt(o),_);return _}e.stringHash=k;function S(P,_){return _=T(104579,_),P.reduce((o,c)=>I(c,o),_)}function L(P,_){return _=T(181387,_),Object.keys(P).sort().reduce((o,c)=>(o=k(c,o),I(P[c],o)),_)}class O{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=I(_,this._value),this._value}}e.Hasher=O;var y;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function v(P,_,o=32){const c=o-_,u=~((1<<c)-1);return(P<<_|(u&P)>>>c)>>>0}function b(P,_=0,o=P.byteLength,c=0){for(let u=0;u<o;u++)P[_+u]=c}function g(P,_,o="0"){for(;P.length<_;)P=o+P;return P}function d(P,_=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(o=>o.toString(16).padStart(2,"0")).join(""):g((P>>>0).toString(16),_/4)}e.toHexString=d;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const o=_.length;if(o===0)return;const c=this._buff;let u=this._buffLen,l=this._leftoverHighSurrogate,E,s;for(l!==0?(E=l,s=-1,l=0):(E=_.charCodeAt(0),s=0);;){let t=E;if(f.isHighSurrogate(E))if(s+1<o){const r=_.charCodeAt(s+1);f.isLowSurrogate(r)?(s++,t=f.computeCodePoint(E,r)):t=65533}else{l=E;break}else f.isLowSurrogate(E)&&(t=65533);if(u=this._push(c,u,t),s++,s<o)E=_.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=l}_push(_,o,c){return c<128?_[o++]=c:c<2048?(_[o++]=192|(c&1984)>>>6,_[o++]=128|(c&63)>>>0):c<65536?(_[o++]=224|(c&61440)>>>12,_[o++]=128|(c&4032)>>>6,_[o++]=128|(c&63)>>>0):(_[o++]=240|(c&1835008)>>>18,_[o++]=128|(c&258048)>>>12,_[o++]=128|(c&4032)>>>6,_[o++]=128|(c&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=p._bigBlock32,o=this._buffDV;for(let a=0;a<64;a+=4)_.setUint32(a,o.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)_.setUint32(a,v(_.getUint32(a-12,!1)^_.getUint32(a-32,!1)^_.getUint32(a-56,!1)^_.getUint32(a-64,!1),1),!1);let c=this._h0,u=this._h1,l=this._h2,E=this._h3,s=this._h4,t,r,i;for(let a=0;a<80;a++)a<20?(t=u&l|~u&E,r=1518500249):a<40?(t=u^l^E,r=1859775393):a<60?(t=u&l|u&E|l&E,r=2400959708):(t=u^l^E,r=3395469782),i=v(c,5)+t+s+r+_.getUint32(a*4,!1)&4294967295,s=E,E=l,l=v(u,30),u=c,c=i;this._h0=this._h0+c&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[24],ve([1,0,18,8]),function(te,e,f,n){"use strict";var I,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(s,t,r){let i=s.get(t);return i===void 0&&(i=r,s.set(t,i)),i}e.getOrSet=k;function S(s){const t=[];return s.forEach((r,i)=>{t.push(`${i} => ${r}`)}),`Map(${s.size}) {${t.join(", ")}}`}e.mapToString=S;function L(s){const t=[];return s.forEach(r=>{t.push(r)}),`Set(${s.size}) {${t.join(", ")}}`}e.setToString=L;class O{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=O;class y{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class v{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const i=this._value.charCodeAt(r);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var b;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(b||(b={}));class g{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(p||(p={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new g(t))}static forPaths(t=!1){return new P(new v(void 0,!t))}static forStrings(){return new P(new O)}static forConfigKeys(){return new P(new y)}clear(){this._root=void 0}fill(t,r){if(r){const i=r.slice(0);(0,f.shuffle)(i);for(let a of i)this.set(a,t)}else{const i=t.slice(0);(0,f.shuffle)(i);for(let a of i)this.set(a[0],a[1])}}set(t,r){const i=this._iter.reset(t);let a;this._root||(this._root=new d,this._root.segment=i.value());const m=[];for(a=this._root;;){const w=i.cmp(a.segment);if(w>0)a.left||(a.left=new d,a.left.segment=i.value()),m.push([-1,a]),a=a.left;else if(w<0)a.right||(a.right=new d,a.right.segment=i.value()),m.push([1,a]),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new d,a.mid.segment=i.value()),m.push([0,a]),a=a.mid;else break}const h=a.value;a.value=r,a.key=t;for(let w=m.length-1;w>=0;w--){const A=m[w][1];A.updateHeight();const F=A.balanceFactor();if(F<-1||F>1){const R=m[w][0],D=m[w+1][0];if(R===1&&D===1)m[w][1]=A.rotateLeft();else if(R===-1&&D===-1)m[w][1]=A.rotateRight();else if(R===1&&D===-1)A.right=m[w+1][1]=m[w+1][1].rotateRight(),m[w][1]=A.rotateLeft();else if(R===-1&&D===1)A.left=m[w+1][1]=m[w+1][1].rotateLeft(),m[w][1]=A.rotateRight();else throw new Error;if(w>0)switch(m[w-1][0]){case-1:m[w-1][1].left=m[w][1];break;case 1:m[w-1][1].right=m[w][1];break;case 0:m[w-1][1].mid=m[w][1];break}else this._root=m[0][1]}}return h}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let i=this._root;for(;i;){const a=r.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const i=this._iter.reset(t),a=[];let m=this._root;for(;m;){const h=i.cmp(m.segment);if(h>0)a.push([-1,m]),m=m.left;else if(h<0)a.push([1,m]),m=m.right;else if(i.hasNext())i.next(),a.push([0,m]),m=m.mid;else break}if(!!m){if(r?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const h=this._min(m.right),{key:w,value:A,segment:F}=h;this._delete(h.key,!1),m.key=w,m.value=A,m.segment=F}else{const h=m.left??m.right;if(a.length>0){const[w,A]=a[a.length-1];switch(w){case-1:A.left=h;break;case 0:A.mid=h;break;case 1:A.right=h;break}}else this._root=h}for(let h=a.length-1;h>=0;h--){const w=a[h][1];w.updateHeight();const A=w.balanceFactor();if(A>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),a[h][1]=w.rotateLeft()):A<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),a[h][1]=w.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let i=this._root,a;for(;i;){const m=r.cmp(i.segment);if(m>0)i=i.left;else if(m<0)i=i.right;else if(r.hasNext())r.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(t){const r=this._iter.reset(t);let i=this._root;for(;i;){const a=r.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(t){for(const[r,i]of this)t(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const i=r.balanceFactor();return i<-1||i>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=P;class _{constructor(t,r){this.uri=t,this.value=r}}class o{constructor(t,r){this[I]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=r??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new _(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[i,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=s=>s.toString();var c;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const i=this._map.get(t);if(!!i)return r!==0&&this.touch(i,r),i.value}set(t,r,i=0){let a=this._map.get(t);if(a)a.value=r,i!==0&&this.touch(a,i);else{switch(a={key:t,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const i=this._state;let a=this._head;for(;a;){if(r?t.bind(r)(a.value,a.key,this):t(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:i.key,done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return a}values(){const t=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:i.value,done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return a}entries(){const t=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:[i.key,i.value],done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>t;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,i=t.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const i=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const i=t.next,a=t.previous;t===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,i)=>{t.push([i,r])}),t}fromJSON(t){this.clear();for(const[r,i]of t)this.set(r,i)}}e.LinkedMap=u;class l extends u{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class E{constructor(t){C.set(this,void 0),Ke(this,C,t,"f")}get size(){return ke(this,C,"f").size}forEach(t,r){ke(this,C,"f").forEach(t,r)}get(t){return ke(this,C,"f").get(t)}has(t){return ke(this,C,"f").has(t)}entries(){return ke(this,C,"f").entries()}keys(){return ke(this,C,"f").keys()}values(){return ke(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return ke(this,C,"f").entries()}}e.ReadonlyMapView=E}),define(pe[95],ve([1,0,24,8]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...N){return function(z,j){for(let re=0,he=N.length;re<he;re++){const Ce=N[re](z,j);if(Ce)return Ce}return null}}e.or=I,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(N,z,j){if(!j||j.length<z.length)return null;let re;return N?re=n.startsWithIgnoreCase(j,z):re=j.indexOf(z)===0,re?z.length>0?[{start:0,end:z.length}]:[]:null}function C(N,z){const j=z.toLowerCase().indexOf(N.toLowerCase());return j===-1?null:[{start:j,end:j+N.length}]}e.matchesContiguousSubString=C;function k(N,z){return S(N.toLowerCase(),z.toLowerCase(),0,0)}e.matchesSubString=k;function S(N,z,j,re){if(j===N.length)return[];if(re===z.length)return null;if(N[j]===z[re]){let he=null;return(he=S(N,z,j+1,re+1))?P({start:re,end:re+1},he):null}return S(N,z,j,re+1)}function L(N){return 97<=N&&N<=122}function O(N){return 65<=N&&N<=90}e.isUpper=O;function y(N){return 48<=N&&N<=57}function v(N){return N===32||N===9||N===10||N===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>b.add(N.charCodeAt(0)));function g(N){return v(N)||b.has(N)}function d(N,z){return N===z||g(N)&&g(z)}function p(N){return L(N)||O(N)||y(N)}function P(N,z){return z.length===0?z=[N]:N.end===z[0].start?z[0].start=N.start:z.unshift(N),z}function _(N,z){for(let j=z;j<N.length;j++){const re=N.charCodeAt(j);if(O(re)||y(re)||j>0&&!p(N.charCodeAt(j-1)))return j}return N.length}function o(N,z,j,re){if(j===N.length)return[];if(re===z.length)return null;if(N[j]!==z[re].toLowerCase())return null;{let he=null,Ce=re+1;for(he=o(N,z,j+1,re+1);!he&&(Ce=_(z,Ce))<z.length;)he=o(N,z,j+1,Ce),Ce++;return he===null?null:P({start:re,end:re+1},he)}}function c(N){let z=0,j=0,re=0,he=0,Ce=0;for(let He=0;He<N.length;He++)Ce=N.charCodeAt(He),O(Ce)&&z++,L(Ce)&&j++,p(Ce)&&re++,y(Ce)&&he++;const Te=z/N.length,We=j/N.length,ze=re/N.length,qe=he/N.length;return{upperPercent:Te,lowerPercent:We,alphaPercent:ze,numericPercent:qe}}function u(N){const{upperPercent:z,lowerPercent:j}=N;return j===0&&z>.6}function l(N){const{upperPercent:z,lowerPercent:j,alphaPercent:re,numericPercent:he}=N;return j>.2&&z<.8&&re>.6&&he<.2}function E(N){let z=0,j=0,re=0,he=0;for(let Ce=0;Ce<N.length;Ce++)re=N.charCodeAt(Ce),O(re)&&z++,L(re)&&j++,v(re)&&he++;return(z===0||j===0)&&he===0?N.length<=30:z<=5}function s(N,z){if(!z||(z=z.trim(),z.length===0)||!E(N)||z.length>60)return null;const j=c(z);if(!l(j)){if(!u(j))return null;z=z.toLowerCase()}let re=null,he=0;for(N=N.toLowerCase();he<z.length&&(re=o(N,z,0,he))===null;)he=_(z,he+1);return re}e.matchesCamelCase=s;function t(N,z,j=!1){if(!z||z.length===0)return null;let re=null,he=0;for(N=N.toLowerCase(),z=z.toLowerCase();he<z.length&&(re=r(N,z,0,he,j))===null;)he=i(z,he+1);return re}e.matchesWords=t;function r(N,z,j,re,he){if(j===N.length)return[];if(re===z.length)return null;if(d(N.charCodeAt(j),z.charCodeAt(re))){let Ce=null,Te=re+1;if(Ce=r(N,z,j+1,re+1,he),!he)for(;!Ce&&(Te=i(z,Te))<z.length;)Ce=r(N,z,j+1,Te,he),Te++;return Ce===null?null:P({start:re,end:re+1},Ce)}else return null}function i(N,z){for(let j=z;j<N.length;j++)if(g(N.charCodeAt(j))||j>0&&g(N.charCodeAt(j-1)))return j;return N.length}const a=I(e.matchesPrefix,s,C),m=I(e.matchesPrefix,s,k),h=new f.LRUCache(1e4);function w(N,z,j=!1){if(typeof N!="string"||typeof z!="string")return null;let re=h.get(N);re||(re=new RegExp(n.convertSimple2RegExpPattern(N),"i"),h.set(N,re));const he=re.exec(z);return he?[{start:he.index,end:he.index+he[0].length}]:j?m(N,z):a(N,z)}e.matchesFuzzy=w;function A(N,z){const j=Ee(N,N.toLowerCase(),0,z,z.toLowerCase(),0,!0);return j?R(j):null}e.matchesFuzzy2=A;function F(N,z,j,re,he,Ce){const Te=Math.min(13,N.length);for(;j<Te;j++){const We=Ee(N,z,j,re,he,Ce,!1);if(We)return We}return[0,Ce]}e.anyScore=F;function R(N){if(typeof N=="undefined")return[];const z=[],j=N[1];for(let re=N.length-1;re>1;re--){const he=N[re]+j,Ce=z[z.length-1];Ce&&Ce.end===he?Ce.end=he+1:z.push({start:he,end:he+1})}return z}e.createMatches=R;const D=128;function $(){const N=[],z=[];for(let j=0;j<=D;j++)z[j]=0;for(let j=0;j<=D;j++)N.push(z.slice(0));return N}function M(N){const z=[];for(let j=0;j<=N;j++)z[j]=0;return z}const q=M(2*D),G=M(2*D),U=$(),W=$(),ee=$(),Z=!1;function V(N,z,j,re,he){function Ce(We,ze,qe=" "){for(;We.length<ze;)We=qe+We;return We}let Te=` |   |${re.split("").map(We=>Ce(We,3)).join("|")}
`;for(let We=0;We<=j;We++)We===0?Te+=" |":Te+=`${z[We-1]}|`,Te+=N[We].slice(0,he+1).map(ze=>Ce(ze.toString(),3)).join("|")+`
`;return Te}function J(N,z,j,re){N=N.substr(z),j=j.substr(re),console.log(V(W,N,N.length,j,j.length)),console.log(V(ee,N,N.length,j,j.length)),console.log(V(U,N,N.length,j,j.length))}function se(N,z){if(z<0||z>=N.length)return!1;const j=N.codePointAt(z);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(j)}}function ae(N,z){if(z<0||z>=N.length)return!1;switch(N.charCodeAt(z)){case 32:case 9:return!0;default:return!1}}function Q(N,z,j){return z[N]!==j[N]}function Y(N,z,j,re,he,Ce,Te=!1){for(;z<j&&he<Ce;)N[z]===re[he]&&(Te&&(q[z]=he),z+=1),he+=1;return z===j}e.isPatternInWord=Y;var oe;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var de;(function(N){N.Default=[-100,0];function z(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}N.isDefault=z})(de=e.FuzzyScore||(e.FuzzyScore={}));function Ee(N,z,j,re,he,Ce,Te){const We=N.length>D?D:N.length,ze=re.length>D?D:re.length;if(j>=We||Ce>=ze||We-j>ze-Ce||!Y(z,j,We,he,Ce,ze,!0))return;Re(We,ze,j,Ce,z,he);let qe=1,He=1,Ue=j,Je=Ce;const et=[!1];for(qe=1,Ue=j;Ue<We;qe++,Ue++){const X=q[Ue],ge=G[Ue],Se=Ue+1<We?G[Ue+1]:ze;for(He=X-Ce+1,Je=X;Je<Se;He++,Je++){let Me=Number.MIN_SAFE_INTEGER,$e=!1;Je<=ge&&(Me=Ne(N,z,Ue,j,re,he,Je,ze,Ce,U[qe-1][He-1]===0,et));let Ye=0;Me!==Number.MAX_SAFE_INTEGER&&($e=!0,Ye=Me+W[qe-1][He-1]);const lt=Je>X,vt=lt?W[qe][He-1]+(U[qe][He-1]>0?-5:0):0,wt=Je>X+1&&U[qe][He-1]>0,je=wt?W[qe][He-2]+(U[qe][He-2]>0?-5:0):0;if(wt&&(!lt||je>=vt)&&(!$e||je>=Ye))W[qe][He]=je,ee[qe][He]=3,U[qe][He]=0;else if(lt&&(!$e||vt>=Ye))W[qe][He]=vt,ee[qe][He]=2,U[qe][He]=0;else if($e)W[qe][He]=Ye,ee[qe][He]=1,U[qe][He]=U[qe-1][He-1]+1;else throw new Error("not possible")}}if(Z&&J(N,j,re,Ce),!et[0]&&!Te)return;qe--,He--;const Le=[W[qe][He],Ce];let it=0,ne=0;for(;qe>=1;){let X=He;do{const ge=ee[qe][X];if(ge===3)X=X-2;else if(ge===2)X=X-1;else break}while(X>=1);it>1&&z[j+qe-1]===he[Ce+He-1]&&!Q(X+Ce-1,re,he)&&it+1>U[qe][X]&&(X=He),X===He?it++:it=1,ne||(ne=X),qe--,He=X-1,Le.push(He)}ze===We&&(Le[0]+=2);const le=ne-We;return Le[0]-=le,Le}e.fuzzyScore=Ee;function Re(N,z,j,re,he,Ce){let Te=N-1,We=z-1;for(;Te>=j&&We>=re;)he[Te]===Ce[We]&&(G[Te]=We,Te--),We--}function Ne(N,z,j,re,he,Ce,Te,We,ze,qe,He){if(z[j]!==Ce[Te])return Number.MIN_SAFE_INTEGER;let Ue=1,Je=!1;return Te===j-re?Ue=N[j]===he[Te]?7:5:Q(Te,he,Ce)&&(Te===0||!Q(Te-1,he,Ce))?(Ue=N[j]===he[Te]?7:5,Je=!0):se(Ce,Te)&&(Te===0||!se(Ce,Te-1))?Ue=5:(se(Ce,Te-1)||ae(Ce,Te-1))&&(Ue=5,Je=!0),Ue>1&&j===re&&(He[0]=!0),Je||(Je=Q(Te,he,Ce)||se(Ce,Te-1)||ae(Ce,Te-1)),j===re?Te>ze&&(Ue-=Je?3:5):qe?Ue+=Je?2:0:Ue+=Je?0:1,Te+1===We&&(Ue-=Je?3:5),Ue}function be(N,z,j,re,he,Ce,Te){return H(N,z,j,re,he,Ce,!0,Te)}e.fuzzyScoreGracefulAggressive=be;function we(N,z,j,re,he,Ce,Te){return H(N,z,j,re,he,Ce,!1,Te)}e.fuzzyScoreGraceful=we;function H(N,z,j,re,he,Ce,Te,We){let ze=Ee(N,z,j,re,he,Ce,We);if(ze&&!Te)return ze;if(N.length>=3){const qe=Math.min(7,N.length-1);for(let He=j+1;He<qe;He++){const Ue=B(N,He);if(Ue){const Je=Ee(Ue,Ue.toLowerCase(),j,re,he,Ce,We);Je&&(Je[0]-=3,(!ze||Je[0]>ze[0])&&(ze=Je))}}}return ze}function B(N,z){if(z+1>=N.length)return;const j=N[z],re=N[z+1];if(j!==re)return N.slice(0,z)+re+j+N.slice(z+2)}}),define(pe[144],ve([1,0,72,95,8]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(f.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${T.source}`,"g");function S(p){return p.replace(k,(P,_)=>_?P:`\\${P}`)}e.escapeIcons=S;const L=new RegExp(`\\\\${T.source}`,"g");function O(p){return p.replace(L,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=O;const y=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function v(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(y,(P,_,o,c)=>o?P:_||c||"")}e.stripIcons=v;function b(p){const P=p.indexOf(e.iconStartMarker);return P===-1?{text:p}:g(p,P)}e.parseLabelWithIcons=b;function g(p,P){const _=[];let o="";function c(a){if(a){o+=a;for(const m of a)_.push(E)}}let u=-1,l="",E=0,s,t,r=P;const i=p.length;for(c(p.substr(0,P));r<i;)s=p[r],t=p[r+1],s===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(u=r,c(l),l=e.iconStartMarker,r++):s===")"&&u!==-1?(E+=r-u+1,u=-1,l=""):u!==-1?C.test(s)?l+=s:(c(l),u=-1,l=""):c(s),r++;return c(l),{text:o,iconOffsets:_}}function d(p,P,_=!1){const{text:o,iconOffsets:c}=P;if(!c||c.length===0)return(0,n.matchesFuzzy)(p,o,_);const u=(0,I.ltrim)(o," "),l=o.length-u.length,E=(0,n.matchesFuzzy)(p,u,_);if(E)for(const s of E){const t=c[s.start+l]+l;s.start+=t,s.end+=t}return E}e.matchesFuzzyIconAware=d}),define(pe[77],ve([1,0,24]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new f.LRUCache(1e4);function I(L){return S(L,"NFC",n)}e.normalizeNFC=I;const T=new f.LRUCache(1e4);function C(L){return S(L,"NFD",T)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function S(L,O,y){if(!L)return L;const v=y.get(L);if(v)return v;let b;return k.test(L)?b=L.normalize(O):b=L,y.set(L,b),b}e.removeAccents=function(){const L=/[\u0300-\u036f]/g;return function(O){return C(O).replace(L,"")}}()}),define(pe[47],ve([1,0,8]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(n||(n={})),function(I){const T="error",C="warning",k="warn",S="info",L="ignore";function O(v){return v?f.equalsIgnoreCase(T,v)?I.Error:f.equalsIgnoreCase(C,v)||f.equalsIgnoreCase(k,v)?I.Warning:f.equalsIgnoreCase(S,v)?I.Info:I.Ignore:I.Ignore}I.fromValue=O;function y(v){switch(v){case I.Error:return T;case I.Warning:return C;case I.Info:return S;default:return L}}I.toString=y}(n||(n={})),e.default=n}),define(pe[13],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(i){return Array.isArray(i)}e.isArray=f;function n(i){return typeof i=="string"}e.isString=n;function I(i){return Array.isArray(i)&&i.every(a=>n(a))}e.isStringArray=I;function T(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=T;function C(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=C;function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.isIterable=k;function S(i){return i===!0||i===!1}e.isBoolean=S;function L(i){return typeof i=="undefined"}e.isUndefined=L;function O(i){return!y(i)}e.isDefined=O;function y(i){return L(i)||i===null}e.isUndefinedOrNull=y;function v(i,a){if(!i)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=v;function b(i){if(y(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=b;function g(...i){const a=[];for(let m=0;m<i.length;m++){const h=i[m];if(y(h))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);a.push(h)}return a}e.assertAllDefined=g;const d=Object.prototype.hasOwnProperty;function p(i){if(!T(i))return!1;for(let a in i)if(d.call(i,a))return!1;return!0}e.isEmptyObject=p;function P(i){return typeof i=="function"}e.isFunction=P;function _(...i){return i.length>0&&i.every(P)}e.areFunctions=_;function o(i,a){const m=Math.min(i.length,a.length);for(let h=0;h<m;h++)c(i[h],a[h])}e.validateConstraints=o;function c(i,a){if(n(a)){if(typeof i!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(P(a)){try{if(i instanceof a)return}catch{}if(!y(i)&&i.constructor===a||a.length===1&&a.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(i){let a=[],m=Object.getPrototypeOf(i);for(;Object.prototype!==m;)a=a.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return a}e.getAllPropertyNames=u;function l(i){const a=[];for(const m of u(i))typeof i[m]=="function"&&a.push(m);return a}e.getAllMethodNames=l;function E(i,a){const m=w=>function(){const A=Array.prototype.slice.call(arguments,0);return a(w,A)};let h={};for(const w of i)h[w]=m(w);return h}e.createProxyObject=E;function s(i){return i===null?void 0:i}e.withNullAsUndefined=s;function t(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=t;function r(i,a="Unreachable"){throw new Error(a)}e.assertNever=r}),define(pe[29],ve([1,0,9,12,8,13]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function k(r){return r.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=k;function S(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function L(r,i=f.posix.sep){if(!r)return"";const a=r.length,m=r.charCodeAt(0);if(C(m)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let w=3;const A=w;for(;w<a&&!C(r.charCodeAt(w));w++);if(A!==w&&!C(r.charCodeAt(w+1))){for(w+=1;w<a;w++)if(C(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(P(m)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<a;h++)if(C(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=L;function O(r){if(!n.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let a=2;const m=a;for(;a<r.length&&(i=r.charCodeAt(a),i!==92);a++);return!(m===a||(i=r.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=O;const y=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,i=n.isWindows){const a=i?y:v;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||i&&b.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function d(r,i,a){const m=r===i;return!a||m?m:!r||!i?!1:(0,I.equalsIgnoreCase)(r,i)}e.isEqual=d;function p(r,i,a,m=f.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(a){if(!(0,I.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let w=i.length;return i.charAt(i.length-1)===m&&w--,r.charAt(w)===m}return i.charAt(i.length-1)!==m&&(i+=m),r.indexOf(i)===0}e.isEqualOrParent=p;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function _(r,i){return n.isWindows&&r.endsWith(":")&&(r+=f.sep),(0,f.isAbsolute)(r)||(r=(0,f.join)(i,r)),r=(0,f.normalize)(r),n.isWindows?(r=(0,I.rtrim)(r,f.sep),r.endsWith(":")&&(r+=f.sep)):(r=(0,I.rtrim)(r,f.sep),r||(r=f.sep)),r}e.sanitizeFilePath=_;function o(r){const i=(0,f.normalize)(r);return n.isWindows?r.length>3?!1:c(i)&&(r.length===2||i.charCodeAt(2)===92):i===f.posix.sep}e.isRootOrDriveLetter=o;function c(r,i){return(i!==void 0?i:n.isWindows)?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(r){return c(r)?r[0]:void 0}e.getDriveLetter=u;function l(r,i,a){return i.length>r.length?-1:r===i?0:(a&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=l;function E(r){const i=r.split(":");let a,m,h;for(const w of i){const A=Number(w);(0,T.isNumber)(A)?m===void 0?m=A:h===void 0&&(h=A):a=a?[a,w].join(":"):w}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:m!==void 0?m:void 0,column:h!==void 0?h:m!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(r,i,a=8){let m="";for(let w=0;w<a;w++)m+=s.charAt(Math.floor(Math.random()*s.length));let h;return i?h=`${i}-${m}`:h=m,r?(0,f.join)(r,h):h}e.randomPath=t}),define(pe[25],ve([1,0,13]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(P=>{d[P]&&typeof d[P]=="object"?p[P]=n(d[P]):p[P]=d[P]}),p}e.deepClone=n;function I(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const P=p.shift();Object.freeze(P);for(const _ in P)if(T.call(P,_)){const o=P[_];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return d}e.deepFreeze=I;const T=Object.prototype.hasOwnProperty;function C(d,p){return k(d,p,new Set)}e.cloneAndChange=C;function k(d,p,P){if((0,f.isUndefinedOrNull)(d))return d;const _=p(d);if(typeof _!="undefined")return _;if((0,f.isArray)(d)){const o=[];for(const c of d)o.push(k(c,p,P));return o}if((0,f.isObject)(d)){if(P.has(d))throw new Error("Cannot clone recursive data-structure");P.add(d);const o={};for(let c in d)T.call(d,c)&&(o[c]=k(d[c],p,P));return P.delete(d),o}return d}function S(d,p,P=!0){return(0,f.isObject)(d)?((0,f.isObject)(p)&&Object.keys(p).forEach(_=>{_ in d?P&&((0,f.isObject)(d[_])&&(0,f.isObject)(p[_])?S(d[_],p[_],P):d[_]=p[_]):d[_]=p[_]}),d):p}e.mixin=S;function L(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let P,_;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(P=0;P<d.length;P++)if(!L(d[P],p[P]))return!1}else{const o=[];for(_ in d)o.push(_);o.sort();const c=[];for(_ in p)c.push(_);if(c.sort(),!L(o,c))return!1;for(P=0;P<o.length;P++)if(!L(d[o[P]],p[o[P]]))return!1}return!0}e.equals=L;function O(d){const p=new Set;return JSON.stringify(d,(P,_)=>{if((0,f.isObject)(_)||Array.isArray(_)){if(p.has(_))return"[Circular]";p.add(_)}return _})}e.safeStringify=O;function y(d,p,P){const _=p(d);return typeof _=="undefined"?P:_}e.getOrDefault=y;function v(d,p){const P=Object.create(null);return!d||!p||Object.keys(p).forEach(o=>{const c=d[o],u=p[o];L(c,u)||(P[o]=u)}),P}e.distinct=v;function b(d,p){const P=p.toLowerCase(),_=Object.keys(d).find(o=>o.toLowerCase()===P);return _?d[_]:d[p]}e.getCaseInsensitive=b;function g(d,p){const P=Object.create(null);for(const[_,o]of Object.entries(d))p(_,o)&&(P[_]=o);return P}e.filter=g}),define(pe[96],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function n(T){return T<0?0:T>255?255:T|0}e.toUint8=n;function I(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=I}),define(pe[2],ve([1,0,9,12]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,T=/^\//,C=/^\/\//;function k(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,t){return!s&&!t?"file":s}function L(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==y&&(t=y+t):t=y;break}return t}const O="",y="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(t,r,i,a,m,h=!1){typeof t=="object"?(this.scheme=t.scheme||O,this.authority=t.authority||O,this.path=t.path||O,this.query=t.query||O,this.fragment=t.fragment||O):(this.scheme=S(t,h),this.authority=r||O,this.path=L(this.scheme,i||O),this.query=a||O,this.fragment=m||O,k(this,h))}static isUri(t){return t instanceof b?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:i,path:a,query:m,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=O),i===void 0?i=this.authority:i===null&&(i=O),a===void 0?a=this.path:a===null&&(a=O),m===void 0?m=this.query:m===null&&(m=O),h===void 0?h=this.fragment:h===null&&(h=O),r===this.scheme&&i===this.authority&&a===this.path&&m===this.query&&h===this.fragment?this:new d(r,i,a,m,h)}static parse(t,r=!1){const i=v.exec(t);return i?new d(i[2]||O,E(i[4]||O),E(i[5]||O),E(i[7]||O),E(i[9]||O),r):new d(O,O,O,O,O)}static file(t){let r=O;if(n.isWindows&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){const i=t.indexOf(y,2);i===-1?(r=t.substring(2),t=y):(r=t.substring(2,i),t=t.substring(i)||y)}return new d("file",r,t,O,O)}static from(t){const r=new d(t.scheme,t.authority,t.path,t.query,t.fragment);return k(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let i;return n.isWindows&&t.scheme==="file"?i=b.file(f.win32.join(o(t,!0),...r)).path:i=f.posix.join(t.path,...r),t.with({path:i})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof b)return t;{const r=new d(t);return r._formatted=t.external,r._fsPath=t._sep===g?t.fsPath:null,r}}else return t}}e.URI=b;const g=n.isWindows?1:void 0;class d extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=g),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(s,t){let r,i=-1;for(let a=0;a<s.length;a++){const m=s.charCodeAt(a);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)i!==-1&&(r+=encodeURIComponent(s.substring(i,a)),i=-1),r!==void 0&&(r+=s.charAt(a));else{r===void 0&&(r=s.substr(0,a));const h=p[m];h!==void 0?(i!==-1&&(r+=encodeURIComponent(s.substring(i,a)),i=-1),r+=h):i===-1&&(i=a)}}return i!==-1&&(r+=encodeURIComponent(s.substring(i))),r!==void 0?r:s}function _(s){let t;for(let r=0;r<s.length;r++){const i=s.charCodeAt(r);i===35||i===63?(t===void 0&&(t=s.substr(0,r)),t+=p[i]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function o(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=o;function c(s,t){const r=t?_:P;let i="",{scheme:a,authority:m,path:h,query:w,fragment:A}=s;if(a&&(i+=a,i+=":"),(m||a==="file")&&(i+=y,i+=y),m){let F=m.indexOf("@");if(F!==-1){const R=m.substr(0,F);m=m.substr(F+1),F=R.indexOf(":"),F===-1?i+=r(R,!1):(i+=r(R.substr(0,F),!1),i+=":",i+=r(R.substr(F+1),!1)),i+="@"}m=m.toLowerCase(),F=m.indexOf(":"),F===-1?i+=r(m,!1):(i+=r(m.substr(0,F),!1),i+=m.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}i+=r(h,!0)}return w&&(i+="?",i+=r(w,!1)),A&&(i+="#",i+=t?A:P(A,!1)),i}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(s){return s.match(l)?s.replace(l,t=>u(t)):s}}),define(pe[58],ve([1,0,22,8,2]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(L){return JSON.stringify(L,k)}e.stringify=T;function C(L){let O=JSON.parse(L);return O=S(O),O}e.parse=C;function k(L,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,n.regExpFlags)(O)}:O}function S(L,O=0){if(!L||O>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return I.URI.revive(L);case 2:return new RegExp(L.source,L.flags);case 14:return new Date(L.source)}if(L instanceof f.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let y=0;y<L.length;++y)L[y]=S(L[y],O+1);else for(const y in L)Object.hasOwnProperty.call(L,y)&&(L[y]=S(L[y],O+1))}return L}e.revive=S}),define(pe[10],ve([1,0,12,2]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,L,O){this._hosts[S]=L,this._ports[S]=O}setConnectionToken(S,L){this._connectionTokens[S]=L}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const L=S.authority;let O=this._hosts[L];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const y=this._ports[L],v=this._connectionTokens[L];let b=`path=${encodeURIComponent(S.path)}`;return typeof v=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),n.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${O}:${y}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new T;class C{asBrowserUri(S,L){const O=this.toUri(S,L);return O.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===I.file&&(f.isNative||f.isWebWorker&&f.globals.origin===`${I.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?O.with({scheme:I.vscodeFileResource,authority:O.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):O}asFileUri(S,L){const O=this.toUri(S,L);return O.scheme===I.vscodeFileResource?O.with({scheme:I.file,authority:O.authority!==C.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(S,L){return n.URI.isUri(S)?S:n.URI.parse(L.toUrl(S))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(pe[23],ve([1,0,29,10,9,12,8,2]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,k.uriToFsPath)(b,!0)}e.originalFSPath=S;class L{constructor(g){this._ignorePathCasing=g}compare(g,d,p=!1){return g===d?0:(0,C.compare)(this.getComparisonKey(g,p),this.getComparisonKey(d,p))}isEqual(g,d,p=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,p)===this.getComparisonKey(d,p)}getComparisonKey(g,d=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,d,p=!1){if(g.scheme===d.scheme){if(g.scheme===n.Schemas.file)return f.isEqualOrParent(S(g),S(d),this._ignorePathCasing(g))&&g.query===d.query&&(p||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return f.isEqualOrParent(g.path,d.path,this._ignorePathCasing(g),"/")&&g.query===d.query&&(p||g.fragment===d.fragment)}return!1}joinPath(g,...d){return k.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return I.posix.basename(g.path)}extname(g){return I.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===n.Schemas.file?d=k.URI.file(I.dirname(S(g))).path:(d=I.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===n.Schemas.file?d=k.URI.file(I.normalize(S(g))).path:d=I.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===n.Schemas.file){const _=I.relative(S(g),S(d));return T.isWindows?f.toSlashes(_):_}let p=g.path||"/",P=d.path||"/";if(this._ignorePathCasing(g)){let _=0;for(const o=Math.min(p.length,P.length);_<o&&!(p.charCodeAt(_)!==P.charCodeAt(_)&&p.charAt(_).toLowerCase()!==P.charAt(_).toLowerCase());_++);p=P.substr(0,_)+p.substr(_)}return I.posix.relative(p,P)}resolvePath(g,d){if(g.scheme===n.Schemas.file){const p=k.URI.file(I.resolve(S(g),d));return g.with({authority:p.authority,path:p.path})}return d=f.toPosixPath(d),g.with({path:I.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,C.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=I.sep){if(g.scheme===n.Schemas.file){const p=S(g);return p.length>f.getRoot(p).length&&p[p.length-1]===d}else{const p=g.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=I.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=I.sep){let p=!1;if(g.scheme===n.Schemas.file){const P=S(g);p=P!==void 0&&P.length===f.getRoot(P).length&&P[P.length-1]===d}else{d="/";const P=g.path;p=P.length===1&&P.charCodeAt(P.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=L,e.extUri=new L(()=>!1),e.extUriBiasedIgnorePathCase=new L(b=>b.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new L(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(b,g){const d=[];for(let p=0;p<b.length;p++){const P=g(b[p]);b.some((_,o)=>o===p?!1:(0,e.isEqualOrParent)(P,g(_)))||d.push(b[p])}return d}e.distinctParents=O;var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(d){const p=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,u]=o.split(":");c&&u&&p.set(c,u)});const _=d.path.substring(0,d.path.indexOf(";"));return _&&p.set(b.META_DATA_MIME,_),p}b.parseMetaData=g})(y=e.DataUri||(e.DataUri={}));function v(b,g,d){if(g){let p=b.path;return p&&p[0]!==I.posix.sep&&(p=I.posix.sep+p),b.with({scheme:d,authority:g,path:p})}return b.with({scheme:d})}e.toLocalResource=v}),define(pe[16],ve([1,0,21,15,3,6,23,12]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=S;function L(Q){const Y=new f.CancellationTokenSource,oe=Q(Y.token),de=new Promise((Ee,Re)=>{const Ne=Y.token.onCancellationRequested(()=>{Ne.dispose(),Y.dispose(),Re(new n.CancellationError)});Promise.resolve(oe).then(be=>{Ne.dispose(),Y.dispose(),Ee(be)},be=>{Ne.dispose(),Y.dispose(),Re(be)})});return new class{cancel(){Y.cancel()}then(Ee,Re){return de.then(Ee,Re)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return de.finally(Ee)}}}e.createCancelablePromise=L;function O(Q,Y,oe){return new Promise((de,Ee)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),de(oe)});Q.then(de,Ee).finally(()=>Re.dispose())})}e.raceCancellation=O;function y(Q,Y){return new Promise((oe,de)=>{const Ee=Y.onCancellationRequested(()=>{Ee.dispose(),de(new n.CancellationError)});Q.then(oe,de).finally(()=>Ee.dispose())})}e.raceCancellationError=y;async function v(Q){let Y=-1;const oe=Q.map((Ee,Re)=>Ee.then(Ne=>(Y=Re,Ne))),de=await Promise.race(oe);return Q.forEach((Ee,Re)=>{Re!==Y&&Ee.cancel()}),de}e.raceCancellablePromises=v;function b(Q,Y,oe){let de;const Ee=setTimeout(()=>{de?.(void 0),oe?.()},Y);return Promise.race([Q.finally(()=>clearTimeout(Ee)),new Promise(Re=>de=Re)])}e.raceTimeout=b;function g(Q){return new Promise((Y,oe)=>{const de=Q();S(de)?de.then(Y,oe):Y(de)})}e.asPromise=g;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const oe=()=>{this.queuedPromise=null;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(oe,oe).then(de)})}return new Promise((oe,de)=>{this.queuedPromise.then(oe,de)})}return this.activePromise=Y(),new Promise((oe,de)=>{this.activePromise.then(Ee=>{this.activePromise=null,oe(Ee)},Ee=>{this.activePromise=null,de(Ee)})})}}e.Throttler=d;class p{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=p;class P{constructor(){this.promiseMap=new Map}queue(Y,oe){const Ee=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(Y)===Ee&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Ee),Ee}}e.SequencerByKey=P;const _=(Q,Y)=>{let oe=!0;const de=setTimeout(()=>{oe=!1,Y()},Q);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(de),oe=!1}}},o=Q=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,Q())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,oe=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ee,Re)=>{this.doResolve=Ee,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ee=this.task;return this.task=null,Ee()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===e.MicrotaskDelay?o(de):_(oe,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class u{constructor(Y){this.delayer=new c(Y),this.throttler=new d}trigger(Y,oe){return this.delayer.trigger(()=>this.throttler.queue(Y),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class l{constructor(){this._isOpen=!1,this._promise=new Promise((Y,oe)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class E extends l{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function s(Q,Y){return Y?new Promise((oe,de)=>{const Ee=setTimeout(()=>{Re.dispose(),oe()},Q),Re=Y.onCancellationRequested(()=>{clearTimeout(Ee),Re.dispose(),de(new n.CancellationError)})}):L(oe=>s(Q,oe))}e.timeout=s;function t(Q,Y=0){const oe=setTimeout(Q,Y);return(0,T.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=t;function r(Q){const Y=[];let oe=0;const de=Q.length;function Ee(){return oe<de?Q[oe++]():null}function Re(Ne){Ne!=null&&Y.push(Ne);const be=Ee();return be?be.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=r;function i(Q,Y=de=>!!de,oe=null){let de=0;const Ee=Q.length,Re=()=>{if(de>=Ee)return Promise.resolve(oe);const Ne=Q[de++];return Promise.resolve(Ne()).then(we=>Y(we)?Promise.resolve(we):Re())};return Re()}e.first=i;function a(Q,Y=de=>!!de,oe=null){if(Q.length===0)return Promise.resolve(oe);let de=Q.length;const Ee=()=>{de=-1;for(const Re of Q)Re.cancel?.()};return new Promise((Re,Ne)=>{for(const be of Q)be.then(we=>{--de>=0&&Y(we)?(Ee(),Re(we)):de===0&&Re(oe)}).catch(we=>{--de>=0&&(Ee(),Ne(we))})})}e.firstParallel=a;class m{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((oe,de)=>{this.outstandingPromises.push({factory:Y,c:oe,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const oe=Y.factory();oe.then(Y.c,Y.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class h extends m{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new ee;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,oe=C.extUri){const de=oe.getComparisonKey(Y);let Ee=this.queues.get(de);return Ee||(Ee=new h,I.Event.once(Ee.onFinished)(()=>{Ee?.dispose(),this.queues.delete(de),this.onDidQueueFinish()}),this.queues.set(de,Ee)),Ee}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class A{constructor(Y,oe){this._token=-1,typeof Y=="function"&&typeof oe=="number"&&this.setIfNotSet(Y,oe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,oe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},oe)}setIfNotSet(Y,oe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},oe))}}e.TimeoutTimer=A;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,oe){this.cancel(),this._token=setInterval(()=>{Y()},oe)}}e.IntervalTimer=F;class R{constructor(Y,oe){this.timeoutToken=-1,this.runner=Y,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class D{constructor(Y,oe){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class $ extends R{constructor(Y,oe){super(Y,oe);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class M extends T.Disposable{constructor(Y,oe){super();this.options=Y,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,k.setTimeout0)(()=>{if(Y)return;const oe=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(Q,Y)=>{const oe=requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(oe))}}}}();class q{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(oe){this._error=oe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function G(Q,Y,oe){let de;for(let Ee=0;Ee<oe;Ee++)try{return await Q()}catch(Re){de=Re,await s(Y)}throw de}e.retry=G;class U{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,oe,de){return this._pending={taskId:Y,cancel:()=>de?.(),promise:oe},oe.then(()=>this.donePending(Y),()=>this.donePending(Y)),oe}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let oe,de;const Ee=new Promise((Re,Ne)=>{oe=Re,de=Ne});this._next={run:Y,promise:Ee,promiseResolve:oe,promiseReject:de}}return this._next.promise}}e.TaskSequentializer=U;class W{constructor(Y,oe=()=>Date.now()){this.interval=Y,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,oe)=>{this.completeCallback=Y,this.errorCallback=oe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(oe=>{this.completeCallback(Y),this.resolved=!0,oe()})}error(Y){return new Promise(oe=>{this.errorCallback(Y),this.rejected=!0,oe()})}cancel(){new Promise(Y=>{this.errorCallback(new n.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=ee;var Z;(function(Q){async function Y(de){let Ee;const Re=await Promise.all(de.map(Ne=>Ne.then(be=>be,be=>{Ee||(Ee=be)})));if(typeof Ee!="undefined")throw Ee;return Re}Q.settled=Y;function oe(de){return new Promise(async(Ee,Re)=>{try{await de(Ee,Re)}catch(Ne){Re(Ne)}})}Q.withAsyncBody=oe})(Z=e.Promises||(e.Promises={}));var V;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(V||(V={}));class J{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const oe={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(Y(oe)),this.resolve()}catch(de){this.reject(de)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}static fromArray(Y){return new J(oe=>{oe.emitMany(Y)})}static fromPromise(Y){return new J(async oe=>{oe.emitMany(await Y)})}static fromPromises(Y){return new J(async oe=>{await Promise.all(Y.map(async de=>oe.emitOne(await de)))})}static merge(Y){return new J(async oe=>{await Promise.all(Y.map(async de=>{for await(const Ee of de)oe.emitOne(Ee)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,oe){return new J(async de=>{for await(const Ee of Y)de.emitOne(oe(Ee))})}map(Y){return J.map(this,Y)}static filter(Y,oe){return new J(async de=>{for await(const Ee of Y)oe(Ee)&&de.emitOne(Ee)})}filter(Y){return J.filter(this,Y)}static coalesce(Y){return J.filter(Y,oe=>!!oe)}coalesce(){return J.coalesce(this)}static async toPromise(Y){const oe=[];for await(const de of Y)oe.push(de);return oe}toPromise(){return J.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class se extends J{constructor(Y,oe){super(oe);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function ae(Q){const Y=new f.CancellationTokenSource,oe=Q(Y.token);return new se(Y,async de=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),Y.dispose(),de.reject(new n.CancellationError)});try{for await(const Re of oe){if(Y.token.isCancellationRequested)return;de.emitOne(Re)}Ee.dispose(),Y.dispose()}catch(Re){Ee.dispose(),Y.dispose(),de.reject(Re)}})}e.createCancelableAsyncIterable=ae}),define(pe[97],ve([1,0,16,9]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),T=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(h,w,A=!1){const F=h||"",R=w||"",D=I.value.collator.compare(F,R);return I.value.collatorIsNumeric&&D===0&&F!==R?F<R?-1:1:D}e.compareFileNames=k;function S(h,w){const A=T.value.collator;return h=h||"",w=w||"",u(A,h,w)}e.compareFileNamesDefault=S;function L(h,w){const A=T.value.collator;return h=h||"",w=w||"",t(h,w)||u(A,h,w)}e.compareFileNamesUpper=L;function O(h,w){const A=T.value.collator;return h=h||"",w=w||"",s(h,w)||u(A,h,w)}e.compareFileNamesLower=O;function y(h,w){return h=h||"",w=w||"",h===w?0:h<w?-1:1}e.compareFileNamesUnicode=y;function v(h,w,A=!1){A||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase());const[F,R]=o(h),[D,$]=o(w);return F!==D?F<D?-1:1:R===$?0:R<$?-1:1}e.noIntlCompareFileNames=v;function b(h,w){const[A,F]=o(h),[R,D]=o(w);let $=I.value.collator.compare(F,D);if($===0){if(I.value.collatorIsNumeric&&F!==D)return F<D?-1:1;if($=I.value.collator.compare(A,R),I.value.collatorIsNumeric&&$===0&&A!==R)return A<R?-1:1}return $}e.compareFileExtensions=b;function g(h,w){h=h||"",w=w||"";const A=c(h),F=c(w),R=T.value.collator,D=C.value.collator;return u(D,A,F)||u(R,h,w)}e.compareFileExtensionsDefault=g;function d(h,w){h=h||"",w=w||"";const A=c(h),F=c(w),R=T.value.collator,D=C.value.collator;return u(D,A,F)||t(h,w)||u(R,h,w)}e.compareFileExtensionsUpper=d;function p(h,w){h=h||"",w=w||"";const A=c(h),F=c(w),R=T.value.collator,D=C.value.collator;return u(D,A,F)||s(h,w)||u(R,h,w)}e.compareFileExtensionsLower=p;function P(h,w){h=h||"",w=w||"";const A=c(h).toLowerCase(),F=c(w).toLowerCase();return A!==F?A<F?-1:1:h!==w?h<w?-1:1:0}e.compareFileExtensionsUnicode=P;const _=/^(.*?)(\.([^.]*))?$/;function o(h,w=!1){const A=h?_.exec(h):[];let F=[A&&A[1]||"",A&&A[3]||""];return w&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function c(h){const w=h?_.exec(h):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function u(h,w,A){let F=h.compare(w,A);return F!==0?F:w.length!==A.length?w.length<A.length?-1:1:0}function l(h){const w=h.charAt(0);return w.toLocaleUpperCase()!==w}function E(h){const w=h.charAt(0);return w.toLocaleLowerCase()!==w}function s(h,w){return l(h)&&E(w)?-1:E(h)&&l(w)?1:0}function t(h,w){return E(h)&&l(w)?-1:l(h)&&E(w)?1:0}function r(h,w,A=!1){return A||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase()),h===w?0:h<w?-1:1}function i(h,w,A=!1){const F=h.split(n.sep),R=w.split(n.sep),D=F.length-1,$=R.length-1;let M,q;for(let G=0;;G++){if(M=D===G,q=$===G,M&&q)return k(F[G],R[G],A);if(M)return-1;if(q)return 1;const U=r(F[G],R[G],A);if(U!==0)return U}}e.comparePaths=i;function a(h,w,A){const F=h.toLowerCase(),R=w.toLowerCase(),D=m(h,w,A);if(D)return D;const $=F.endsWith(A),M=R.endsWith(A);if($!==M)return $?-1:1;const q=k(F,R);return q!==0?q:F.localeCompare(R)}e.compareAnything=a;function m(h,w,A){const F=h.toLowerCase(),R=w.toLowerCase(),D=F.startsWith(A),$=R.startsWith(A);if(D!==$)return D?-1:1;if(D&&$){if(F.length<R.length)return-1;if(F.length>R.length)return 1}return 0}e.compareByPrefix=m}),define(pe[98],ve([1,0,97,95,57,9,12,8]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,L=[S,[]];function O(U,W,ee,Z){if(!U||!W)return L;const V=U.length,J=W.length;if(V<J)return L;const se=U.toLowerCase();return y(W,ee,J,U,se,V,Z)}e.scoreFuzzy=O;function y(U,W,ee,Z,V,J,se){const ae=[],Q=[];for(let Ee=0;Ee<ee;Ee++){const Re=Ee*J,Ne=Re-J,be=Ee>0,we=U[Ee],H=W[Ee];for(let B=0;B<J;B++){const N=B>0,z=Re+B,j=z-1,re=Ne+B-1,he=N?ae[j]:0,Ce=be&&N?ae[re]:0,Te=be&&N?Q[re]:0;let We;!Ce&&be?We=0:We=v(we,H,Z,V,B,Te),We&&Ce+We>=he&&(se||be||V.startsWith(W,B))?(Q[z]=Te+1,ae[z]=Ce+We):(Q[z]=S,ae[z]=he)}}const Y=[];let oe=ee-1,de=J-1;for(;oe>=0&&de>=0;){const Ee=oe*J+de;Q[Ee]===S||(Y.push(de),oe--),de--}return[ae[ee*J-1],Y.reverse()]}function v(U,W,ee,Z,V,J){let se=0;if(!b(W,Z[V]))return se;if(se+=1,J>0&&(se+=J*5),U===ee[V]&&(se+=1),V===0)se+=8;else{const ae=g(ee.charCodeAt(V-1));ae?se+=ae:(0,n.isUpper)(ee.charCodeAt(V))&&J===0&&(se+=2)}return se}function b(U,W){return U===W?!0:U==="/"||U==="\\"?W==="/"||W==="\\":!1}function g(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function p(U,W,ee=0,Z=0){const V=W;return V.values&&V.values.length>1?P(U,V.values,ee,Z):_(U,W,ee,Z)}e.scoreFuzzy2=p;function P(U,W,ee,Z){let V=0;const J=[];for(const se of W){const[ae,Q]=_(U,se,ee,Z);if(typeof ae!="number")return d;V+=ae,J.push(...Q)}return[V,m(J)]}function _(U,W,ee,Z){const V=(0,n.fuzzyScore)(W.original,W.originalLowercase,ee,U,U.toLowerCase(),Z,!0);return V?[V[0],(0,n.createMatches)(V)]:d}const o=Object.freeze({score:0}),c=1<<18,u=1<<17,l=1<<16;function E(U,W,ee,Z){const V=Z.values?Z.values:[Z];return(0,I.hash)({[Z.normalized]:{values:V.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:U,description:W,allowNonContiguousMatches:ee}})}function s(U,W,ee,Z,V){if(!U||!W.normalized)return o;const J=Z.getItemLabel(U);if(!J)return o;const se=Z.getItemDescription(U),ae=E(J,se,ee,W),Q=V[ae];if(Q)return Q;const Y=t(J,se,Z.getItemPath(U),W,ee);return V[ae]=Y,Y}e.scoreItemFuzzy=s;function t(U,W,ee,Z,V){const J=!ee||!Z.containsPathSeparator;return ee&&(C.isLinux?Z.pathNormalized===ee:(0,k.equalsIgnoreCase)(Z.pathNormalized,ee))?{score:c,labelMatch:[{start:0,end:U.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:Z.values&&Z.values.length>1?r(U,W,ee,Z.values,J,V):i(U,W,ee,Z,J,V)}function r(U,W,ee,Z,V,J){let se=0;const ae=[],Q=[];for(const Y of Z){const{score:oe,labelMatch:de,descriptionMatch:Ee}=i(U,W,ee,Y,V,J);if(oe===S)return o;se+=oe,de&&ae.push(...de),Ee&&Q.push(...Ee)}return{score:se,labelMatch:m(ae),descriptionMatch:m(Q)}}function i(U,W,ee,Z,V,J){if(V||!W){const[se,ae]=O(U,Z.normalized,Z.normalizedLowercase,J&&!Z.expectContiguousMatch);if(se){const Q=(0,n.matchesPrefix)(Z.normalized,U);let Y;return Q?(Y=u,Y+=Math.round(Z.normalized.length/U.length*100)):Y=l,{score:Y+se,labelMatch:Q||a(ae)}}}if(W){let se=W;ee&&(se=`${W}${T.sep}`);const ae=se.length,Q=`${se}${U}`,[Y,oe]=O(Q,Z.normalized,Z.normalizedLowercase,J&&!Z.expectContiguousMatch);if(Y){const de=a(oe),Ee=[],Re=[];return de.forEach(Ne=>{Ne.start<ae&&Ne.end>ae?(Ee.push({start:0,end:Ne.end-ae}),Re.push({start:Ne.start,end:ae})):Ne.start>=ae?Ee.push({start:Ne.start-ae,end:Ne.end-ae}):Re.push(Ne)}),{score:Y,labelMatch:Ee,descriptionMatch:Re}}}return o}function a(U){const W=[];if(!U)return W;let ee;for(const Z of U)ee&&ee.end===Z?ee.end+=1:(ee={start:Z,end:Z+1},W.push(ee));return W}function m(U){const W=U.sort((V,J)=>V.start-J.start),ee=[];let Z;for(const V of W)!Z||!h(Z,V)?(Z=V,ee.push(V)):(Z.start=Math.min(Z.start,V.start),Z.end=Math.max(Z.end,V.end));return ee}function h(U,W){return!(U.end<W.start||W.end<U.start)}function w(U,W,ee,Z,V,J){const se=s(U,ee,Z,V,J),ae=s(W,ee,Z,V,J),Q=se.score,Y=ae.score;if((Q===c||Y===c)&&Q!==Y)return Q===c?-1:1;if(Q>l||Y>l){if(Q!==Y)return Q>Y?-1:1;if(Q<u&&Y<u){const we=F(se.labelMatch,ae.labelMatch);if(we!==0)return we}const Ne=V.getItemLabel(U)||"",be=V.getItemLabel(W)||"";if(Ne.length!==be.length)return Ne.length-be.length}if(Q!==Y)return Q>Y?-1:1;const oe=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,de=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0;if(oe&&!de)return-1;if(de&&!oe)return 1;const Ee=A(U,se,V),Re=A(W,ae,V);return Ee&&Re&&Ee!==Re?Re>Ee?-1:1:R(U,W,ee,V)}e.compareItemsByFuzzyScore=w;function A(U,W,ee){let Z=-1,V=-1;if(W.descriptionMatch&&W.descriptionMatch.length?Z=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(Z=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(V=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const J=ee.getItemDescription(U);J&&(V+=J.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(V=W.descriptionMatch[W.descriptionMatch.length-1].end);return V-Z}function F(U,W){if(!U&&!W||(!U||!U.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!U||!U.length)return 1;const ee=U[0].start,V=U[U.length-1].end-ee,J=W[0].start,ae=W[W.length-1].end-J;return V===ae?0:ae<V?1:-1}function R(U,W,ee,Z){const V=Z.getItemLabel(U)||"",J=Z.getItemLabel(W)||"",se=Z.getItemDescription(U),ae=Z.getItemDescription(W),Q=V.length+(se?se.length:0),Y=J.length+(ae?ae.length:0);if(Q!==Y)return Q-Y;const oe=Z.getItemPath(U),de=Z.getItemPath(W);return oe&&de&&oe.length!==de.length?oe.length-de.length:V!==J?(0,f.compareAnything)(V,J,ee.normalized):se&&ae&&se!==ae?(0,f.compareAnything)(se,ae,ee.normalized):oe&&de&&oe!==de?(0,f.compareAnything)(oe,de,ee.normalized):0}function D(U){return U.startsWith('"')&&U.endsWith('"')}const $=" ";function M(U){typeof U!="string"&&(U="");const W=U.toLowerCase(),{pathNormalized:ee,normalized:Z,normalizedLowercase:V}=q(U),J=ee.indexOf(T.sep)>=0,se=D(U);let ae;const Q=U.split($);if(Q.length>1)for(const Y of Q){const oe=D(Y),{pathNormalized:de,normalized:Ee,normalizedLowercase:Re}=q(Y);Ee&&(ae||(ae=[]),ae.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:de,normalized:Ee,normalizedLowercase:Re,expectContiguousMatch:oe}))}return{original:U,originalLowercase:W,pathNormalized:ee,normalized:Z,normalizedLowercase:V,values:ae,containsPathSeparator:J,expectContiguousMatch:se}}e.prepareQuery=M;function q(U){let W;C.isWindows?W=U.replace(/\//g,T.sep):W=U.replace(/\\/g,T.sep);const ee=(0,k.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:ee,normalizedLowercase:ee.toLowerCase()}}function G(U){return Array.isArray(U)?M(U.map(W=>W.original).join($)):M(U.original)}e.pieceToQuery=G}),define(pe[34],ve([1,0,16,29,24,9,12,8]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",O="[^/\\\\]",y=/\//g;function v(U,W){switch(U){case 0:return"";case 1:return`${O}*?`;default:return`(?:${L}|${O}+${L}${W?`|${L}${O}+`:""})*?`}}function b(U,W){if(!U)return[];const ee=[];let Z=!1,V=!1,J="";for(const se of U){switch(se){case W:if(!Z&&!V){ee.push(J),J="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":V=!0;break;case"]":V=!1;break}J+=se}return J&&ee.push(J),ee}e.splitGlobAware=b;function g(U){if(!U)return"";let W="";const ee=b(U,e.GLOB_SPLIT);if(ee.every(Z=>Z===e.GLOBSTAR))W=".*";else{let Z=!1;ee.forEach((V,J)=>{if(V===e.GLOBSTAR){if(Z)return;W+=v(2,J===ee.length-1)}else{let se=!1,ae="",Q=!1,Y="";for(const oe of V){if(oe!=="}"&&se){ae+=oe;continue}if(Q&&(oe!=="]"||!Y)){let de;oe==="-"?de=oe:(oe==="^"||oe==="!")&&!Y?de="^":oe===e.GLOB_SPLIT?de="":de=(0,k.escapeRegExpCharacters)(oe),Y+=de;continue}switch(oe){case"{":se=!0;continue;case"[":Q=!0;continue;case"}":{W+=`(?:${b(ae,",").map(Re=>g(Re)).join("|")})`,se=!1,ae="";break}case"]":{W+="["+Y+"]",Q=!1,Y="";break}case"?":W+=O;continue;case"*":W+=v(1);continue;default:W+=(0,k.escapeRegExpCharacters)(oe)}}J<ee.length-1&&(ee[J+1]!==e.GLOBSTAR||J+2<ee.length)&&(W+=L)}Z=V===e.GLOBSTAR})}return W}const d=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,_=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new I.LRUCache(1e4),l=function(){return!1},E=function(){return null};function s(U,W){if(!U)return E;let ee;typeof U!="string"?ee=U.pattern:ee=U,ee=ee.trim();const Z=`${ee}_${!!W.trimForExclusions}`;let V=u.get(Z);if(V)return t(V,U);let J;return d.test(ee)?V=i(ee.substr(4),ee):(J=p.exec(r(ee,W)))?V=a(J[1],ee):(W.trimForExclusions?_:P).test(ee)?V=m(ee,W):(J=o.exec(r(ee,W)))?V=h(J[1].substr(1),ee,!0):(J=c.exec(r(ee,W)))?V=h(J[1],ee,!1):V=w(ee),u.set(Z,V),t(V,U)}function t(U,W){return typeof W=="string"?U:function(ee,Z){return(0,n.isEqualOrParent)(ee,W.base,!C.isLinux)?U(ee.substr(W.base.length+1),Z):null}}function r(U,W){return W.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function i(U,W){return function(ee,Z){return typeof ee=="string"&&ee.endsWith(U)?W:null}}function a(U,W){const ee=`/${U}`,Z=`\\${U}`,V=function(se,ae){return typeof se!="string"?null:ae?ae===U?W:null:se===U||se.endsWith(ee)||se.endsWith(Z)?W:null},J=[U];return V.basenames=J,V.patterns=[W],V.allBasenames=J,V}function m(U,W){const ee=G(U.slice(1,-1).split(",").map(ae=>s(ae,W)).filter(ae=>ae!==E),U),Z=ee.length;if(!Z)return E;if(Z===1)return ee[0];const V=function(ae,Q){for(let Y=0,oe=ee.length;Y<oe;Y++)if(ee[Y](ae,Q))return U;return null},J=ee.find(ae=>!!ae.allBasenames);J&&(V.allBasenames=J.allBasenames);const se=ee.reduce((ae,Q)=>Q.allPaths?ae.concat(Q.allPaths):ae,[]);return se.length&&(V.allPaths=se),V}function h(U,W,ee){const Z=T.sep===T.posix.sep,V=Z?U:U.replace(y,T.sep),J=T.sep+V,se=T.posix.sep+U;let ae;return ee?ae=function(Q,Y){return typeof Q=="string"&&(Q===V||Q.endsWith(J)||!Z&&(Q===U||Q.endsWith(se)))?W:null}:ae=function(Q,Y){return typeof Q=="string"&&(Q===V||!Z&&Q===U)?W:null},ae.allPaths=[(ee?"*/":"./")+U],ae}function w(U){try{const W=new RegExp(`^${g(U)}$`);return function(ee){return W.lastIndex=0,typeof ee=="string"&&W.test(ee)?U:null}}catch{return E}}function A(U,W,ee){return!U||typeof W!="string"?!1:F(U)(W,void 0,ee)}e.match=A;function F(U,W={}){if(!U)return l;if(typeof U=="string"||R(U)){const ee=s(U,W);if(ee===E)return l;const Z=function(V,J){return!!ee(V,J)};return ee.allBasenames&&(Z.allBasenames=ee.allBasenames),ee.allPaths&&(Z.allPaths=ee.allPaths),Z}return M(U,W)}e.parse=F;function R(U){const W=U;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=R;function D(U){return U.allBasenames||[]}e.getBasenameTerms=D;function $(U){return U.allPaths||[]}e.getPathTerms=$;function M(U,W){const ee=G(Object.getOwnPropertyNames(U).map(ae=>q(ae,U[ae],W)).filter(ae=>ae!==E)),Z=ee.length;if(!Z)return E;if(!ee.some(ae=>!!ae.requiresSiblings)){if(Z===1)return ee[0];const ae=function(oe,de){for(let Ee=0,Re=ee.length;Ee<Re;Ee++){const Ne=ee[Ee](oe,de);if(Ne)return Ne}return null},Q=ee.find(oe=>!!oe.allBasenames);Q&&(ae.allBasenames=Q.allBasenames);const Y=ee.reduce((oe,de)=>de.allPaths?oe.concat(de.allPaths):oe,[]);return Y.length&&(ae.allPaths=Y),ae}const V=function(ae,Q,Y){let oe;for(let de=0,Ee=ee.length;de<Ee;de++){const Re=ee[de];Re.requiresSiblings&&Y&&(Q||(Q=(0,T.basename)(ae)),oe||(oe=Q.substr(0,Q.length-(0,T.extname)(ae).length)));const Ne=Re(ae,Q,oe,Y);if(Ne)return Ne}return null},J=ee.find(ae=>!!ae.allBasenames);J&&(V.allBasenames=J.allBasenames);const se=ee.reduce((ae,Q)=>Q.allPaths?ae.concat(Q.allPaths):ae,[]);return se.length&&(V.allPaths=se),V}function q(U,W,ee){if(W===!1)return E;const Z=s(U,ee);if(Z===E)return E;if(typeof W=="boolean")return Z;if(W){const V=W.when;if(typeof V=="string"){const J=(se,ae,Q,Y)=>{if(!Y||!Z(se,ae))return null;const oe=V.replace("$(basename)",Q),de=Y(oe);return(0,f.isThenable)(de)?de.then(Ee=>Ee?U:null):de?U:null};return J.requiresSiblings=!0,J}}return Z}function G(U,W){const ee=U.filter(ae=>!!ae.basenames);if(ee.length<2)return U;const Z=ee.reduce((ae,Q)=>{const Y=Q.basenames;return Y?ae.concat(Y):ae},[]);let V;if(W){V=[];for(let ae=0,Q=Z.length;ae<Q;ae++)V.push(W)}else V=ee.reduce((ae,Q)=>{const Y=Q.patterns;return Y?ae.concat(Y):ae},[]);const J=function(ae,Q){if(typeof ae!="string")return null;if(!Q){let oe;for(oe=ae.length;oe>0;oe--){const de=ae.charCodeAt(oe-1);if(de===47||de===92)break}Q=ae.substr(oe)}const Y=Z.indexOf(Q);return Y!==-1?V[Y]:null};J.basenames=Z,J.patterns=V,J.allBasenames=Z;const se=U.filter(ae=>!ae.basenames);return se.push(J),se}}),define(pe[99],ve([1,0,15,144,23,8,2]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(p="",P=!1){if(this.value=p,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof P=="boolean"?(this.isTrusted=P,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=P.isTrusted??void 0,this.supportThemeIcons=P.supportThemeIcons??!1,this.supportHtml=P.supportHtml??!1)}appendText(p,P=0){return this.value+=v(this.supportThemeIcons?(0,n.escapeIcons)(p):p).replace(/([ \t]+)/g,(_,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,P===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,P){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=P,this.value+="\n```\n",this}appendLink(p,P,_){return this.value+="[",this.value+=this._escape(P,"]"),this.value+="](",this.value+=this._escape(String(p),")"),_&&(this.value+=` "${this._escape(this._escape(_,'"'),")")}"`),this.value+=")",this}_escape(p,P){const _=new RegExp((0,T.escapeRegExpCharacters)(P),"g");return p.replace(_,(o,c)=>p.charAt(c-1)!=="\\"?`\\${o}`:o)}}e.MarkdownString=S;function L(d){return O(d)?!d.value:Array.isArray(d)?d.every(L):!0}e.isEmptyMarkdownString=L;function O(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function y(d,p){return d===p?!0:!d||!p?!1:d.value===p.value&&d.isTrusted===p.isTrusted&&d.supportThemeIcons===p.supportThemeIcons&&d.supportHtml===p.supportHtml&&(d.baseUri===p.baseUri||!!d.baseUri&&!!p.baseUri&&(0,I.isEqual)(C.URI.from(d.baseUri),C.URI.from(p.baseUri)))}e.markdownStringEqual=y;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function b(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function g(d){const p=[],P=d.split("|").map(o=>o.trim());d=P[0];const _=P[1];if(_){const o=/height=(\d+)/.exec(_),c=/width=(\d+)/.exec(_),u=o?o[1]:"",l=c?c[1]:"",E=isFinite(parseInt(l)),s=isFinite(parseInt(u));E&&p.push(`width="${l}"`),s&&p.push(`height="${u}"`)}return{href:d,dimensions:p}}e.parseHrefAndDimensions=g}),define(pe[100],ve([1,0,29,10,9,12,23,8,2]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(t,r,i){if(typeof t=="string"&&(t=S.URI.file(t)),i){const m=i.getWorkspaceFolder(t);if(m){const h=i.getWorkspace().folders.length>1;let w;if((0,C.isEqual)(m.uri,t)?w="":w=(0,C.relativePath)(m.uri,t),h){const A=m.name?m.name:(0,C.basename)(m.uri);w=w?A+" \u2022 "+w:A}return w}}if(t.scheme!==n.Schemas.file&&t.scheme!==n.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(t.fsPath))return(0,I.normalize)(y(t.fsPath));let a=(0,I.normalize)(t.fsPath);return!T.isWindows&&r?.userHome&&(a=b(a,r.userHome.fsPath)),a}e.getPathLabel=L;function O(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const r=(0,C.basename)(t)||(t.scheme===n.Schemas.file?t.fsPath:t.path);return T.isWindows&&(0,f.isRootOrDriveLetter)(r)?y(r):r}e.getBaseLabel=O;function y(t,r){return(0,f.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=y;let v=Object.create(null);function b(t,r){if(T.isWindows||!t||!r)return t;let i=v.original===r?v.normalized:void 0;return i||(i=`${(0,k.rtrim)(r,I.posix.sep)}${I.posix.sep}`,v={original:r,normalized:i}),(T.isLinux?t.startsWith(i):(0,k.startsWithIgnoreCase)(t,i))&&(t=`~/${t.substr(i.length)}`),t}e.tildify=b;function g(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const d="\u2026",p="\\\\",P="~";function _(t,r=I.sep){const i=new Array(t.length);let a=!1;for(let m=0;m<t.length;m++){let h=t[m];if(h===""){i[m]=`.${r}`;continue}if(!h){i[m]=h;continue}a=!0;let w="";h.indexOf(p)===0?(w=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(r)===0?(w=h.substr(0,h.indexOf(r)+r.length),h=h.substr(h.indexOf(r)+r.length)):h.indexOf(P)===0&&(w=h.substr(0,h.indexOf(P)+P.length),h=h.substr(h.indexOf(P)+P.length));const A=h.split(r);for(let F=1;a&&F<=A.length;F++)for(let R=A.length-F;a&&R>=0;R--){a=!1;let D=A.slice(R,R+F).join(r);for(let $=0;!a&&$<t.length;$++)if($!==m&&t[$]&&t[$].indexOf(D)>-1){const M=R+F===A.length,q=R>0&&t[$].indexOf(r)>-1?r+D:D,G=t[$].endsWith(q);a=!M||G}if(!a){let $="";(A[0].endsWith(":")||w!=="")&&(R===1&&(R=0,F++,D=A[0]+r+D),R>0&&($=A[0]+r),$=w+$),R>0&&($=$+d+r),$=$+D,R+F<A.length&&($=$+r+d),i[m]=$}}a&&(i[m]=h)}return i}e.shorten=_;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function c(t,r=Object.create(null)){const i=[];let a=!1,m="";for(const h of t)if(h==="$"||a&&h==="{")m&&i.push({value:m,type:o.TEXT}),m="",a=!0;else if(h==="}"&&a){const w=r[m];if(typeof w=="string")w.length&&i.push({value:w,type:o.VARIABLE});else if(w){const A=i[i.length-1];(!A||A.type!==o.SEPARATOR)&&i.push({value:w.label,type:o.SEPARATOR})}m="",a=!1}else m+=h;return m&&!a&&i.push({value:m,type:o.TEXT}),i.filter((h,w)=>{if(h.type===o.SEPARATOR){const A=i[w-1],F=i[w+1];return[A,F].every(R=>R&&(R.type===o.VARIABLE||R.type===o.TEXT)&&R.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=c;function u(t,r){return T.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):t.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function l(t,r){return T.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):T.isWindows?t.replace(/&&|&/g,i=>i==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function E(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=E;function s(t){const r=t.indexOf("/")!==-1?I.posix:I.win32,i=r.basename(t),a=r.dirname(t);return i.length?{name:i,parentPath:a}:{name:a,parentPath:""}}e.splitName=s}),define(pe[101],ve([1,0,2]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(O){return O.toJSON()}class I{constructor(y){this._uriTransformer=y}transformIncoming(y){const v=this._uriTransformer.transformIncoming(y);return v===y?y:n(f.URI.from(v))}transformOutgoing(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:n(f.URI.from(v))}transformOutgoingURI(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:f.URI.from(v)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function T(O,y,v){if(!O||v>200)return null;if(typeof O=="object"){if(O instanceof f.URI)return y.transformOutgoing(O);for(let b in O)if(Object.hasOwnProperty.call(O,b)){const g=T(O[b],y,v+1);g!==null&&(O[b]=g)}}return null}function C(O,y){const v=T(O,y,0);return v===null?O:v}e.transformOutgoingURIs=C;function k(O,y,v,b){if(!O||b>200)return null;if(typeof O=="object"){if(O.$mid===1)return v?f.URI.revive(y.transformIncoming(O)):y.transformIncoming(O);for(let g in O)if(Object.hasOwnProperty.call(O,g)){const d=k(O[g],y,v,b+1);d!==null&&(O[g]=d)}}return null}function S(O,y){const v=k(O,y,!1,0);return v===null?O:v}e.transformIncomingURIs=S;function L(O,y){const v=k(O,y,!0,0);return v===null?O:v}e.transformAndReviveIncomingURIs=L}),define(pe[32],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(S){return f.test(S)}e.isUUID=n;const I=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(S){for(let L=0;L<S.length;L++)S[L]=Math.floor(Math.random()*256);return S};function k(){C(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let S=0,L="";return L+=T[I[S++]],L+=T[I[S++]],L+=T[I[S++]],L+=T[I[S++]],L+="-",L+=T[I[S++]],L+=T[I[S++]],L+="-",L+=T[I[S++]],L+=T[I[S++]],L+="-",L+=T[I[S++]],L+=T[I[S++]],L+="-",L+=T[I[S++]],L+=T[I[S++]],L+=T[I[S++]],L+=T[I[S++]],L+=T[I[S++]],L+=T[I[S++]],L}e.generateUuid=k}),define(pe[145],ve([1,0,102]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new f.StringDecoder(T),this.remaining=null}write(T){const C=[],k=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(k.length<1)return C;let S=0,L,O=S;for(;O<k.length;)if(L=k.charCodeAt(O),L===13||L===10){if(C.push(k.substring(S,O)),O++,O<k.length){const y=L;L=k.charCodeAt(O),(y===13&&L===10||y===10&&L===13)&&O++}S=O}else O++;return this.remaining=S<k.length?k.substr(S):null,C}end(){return this.remaining}}e.LineDecoder=n}),define(pe[28],ve([1,0,59,60,291,16,29,77,9,12,23,2]),function(te,e,f,n,I,T,C,k,S,L,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function b(M,q=v.UNLINK){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return q===v.UNLINK?d(M):g(M)}async function g(M){try{const q=(0,C.randomPath)((0,n.tmpdir)());try{await f.promises.rename(M,q)}catch{return d(M)}d(q).catch(G=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function d(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function p(M){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(M,{recursive:!0})}e.rimrafSync=p;async function P(M,q){return c(await(q?_(M):(0,I.promisify)(f.readdir)(M)))}async function _(M){try{return await(0,I.promisify)(f.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const q=[],G=await P(M);for(const U of G){let W=!1,ee=!1,Z=!1;try{const V=await e.Promises.lstat((0,S.join)(M,U));W=V.isFile(),ee=V.isDirectory(),Z=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}q.push({name:U,isFile:()=>W,isDirectory:()=>ee,isSymbolicLink:()=>Z})}return q}function o(M){return c(f.readdirSync(M))}e.readdirSync=o;function c(M){return M.map(q=>typeof q=="string"?L.isMacintosh?(0,k.normalizeNFC)(q):q:(q.name=L.isMacintosh?(0,k.normalizeNFC)(q.name):q.name,q))}async function u(M){const q=await P(M),G=[];for(const U of q)await E.existsDirectory((0,S.join)(M,U))&&G.push(U);return G}function l(M,q=1e3){return new Promise(G=>{let U=!1;const W=setInterval(()=>{U||(U=!0,f.access(M,ee=>{U=!1,ee&&(clearInterval(W),G(void 0))}))},q)})}e.whenDeleted=l;var E;(function(M){async function q(W){let ee;try{if(ee=await e.Promises.lstat(W),!ee.isSymbolicLink())return{stat:ee}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:ee?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&ee)return{stat:ee,symbolicLink:{dangling:!0}};if(L.isWindows&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&ee)return{stat:ee,symbolicLink:{dangling:!0}};throw V}throw Z}}M.stat=q;async function G(W){try{const{stat:ee,symbolicLink:Z}=await M.stat(W);return ee.isFile()&&Z?.dangling!==!0}catch{}return!1}M.existsFile=G;async function U(W){try{const{stat:ee,symbolicLink:Z}=await M.stat(W);return ee.isDirectory()&&Z?.dangling!==!0}catch{}return!1}M.existsDirectory=U})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function t(M,q,G){return s.queueFor(y.URI.file(M),O.extUriBiasedIgnorePathCase).queue(()=>{const U=m(G);return new Promise((W,ee)=>i(M,q,U,Z=>Z?ee(Z):W()))})}let r=!0;function i(M,q,G,U){if(!r)return f.writeFile(M,q,{mode:G.mode,flag:G.flag},U);f.open(M,G.flag,G.mode,(W,ee)=>{if(W)return U(W);f.writeFile(ee,q,Z=>{if(Z)return f.close(ee,()=>U(Z));f.fdatasync(ee,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),r=!1),f.close(ee,J=>U(J))))})})}function a(M,q,G){const U=m(G);if(!r)return f.writeFileSync(M,q,{mode:U.mode,flag:U.flag});const W=f.openSync(M,U.flag,U.mode);try{f.writeFileSync(W,q);try{f.fdatasyncSync(W)}catch(ee){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ee),r=!1}}finally{f.closeSync(W)}}e.writeFileSync=a;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function h(M,q){if(M!==q)try{await e.Promises.rename(M,q)}catch(G){if(M.toLowerCase()!==q.toLowerCase()&&G.code==="EXDEV"||M.endsWith("."))await w(M,q,{preserveSymlinks:!1}),await b(M,v.MOVE);else throw G}}async function w(M,q,G){return F(M,q,{root:{source:M,target:q},options:G,handledSourcePaths:new Set})}const A=511;async function F(M,q,G){if(G.handledSourcePaths.has(M))return;G.handledSourcePaths.add(M);const{stat:U,symbolicLink:W}=await E.stat(M);if(W){if(G.options.preserveSymlinks)try{return await $(M,q,G)}catch(ee){console.warn("[node.js fs] copy of symlink failed: ",ee)}if(W.dangling)return}return U.isDirectory()?R(M,q,U.mode&A,G):D(M,q,U.mode&A)}async function R(M,q,G,U){await e.Promises.mkdir(q,{recursive:!0,mode:G});const W=await P(M);for(const ee of W)await F((0,S.join)(M,ee),(0,S.join)(q,ee),U)}async function D(M,q,G){await e.Promises.copyFile(M,q),await e.Promises.chmod(q,G)}async function $(M,q,G){let U=await e.Promises.readlink(M);(0,C.isEqualOrParent)(U,G.root.source,!L.isLinux)&&(U=(0,S.join)(G.root.target,U.substr(G.root.source.length+1))),await e.Promises.symlink(U,q)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(M,q,G,U,W)=>new Promise((ee,Z)=>{f.read(M,q,G,U,W,(V,J,se)=>V?Z(V):ee({bytesRead:J,buffer:se}))})}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(M,q,G,U,W)=>new Promise((ee,Z)=>{f.write(M,q,G,U,W,(V,J,se)=>V?Z(V):ee({bytesWritten:J,buffer:se}))})}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return b}get move(){return h}get copy(){return w}}}),define(pe[103],ve([1,0,59,9,12,8,28]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(v){if(I.isLinux)return v;const b=(0,n.dirname)(v);if(v===b)return v;const g=((0,n.basename)(v)||v).toLowerCase();try{const p=(0,C.readdirSync)(b).filter(P=>P.toLowerCase()===g);if(p.length===1){const P=k(b);if(P)return(0,n.join)(P,p[0])}else if(p.length>1){const P=p.indexOf(g);if(P>=0){const _=k(b);if(_)return(0,n.join)(_,p[P])}}}catch{}return null}e.realcaseSync=k;async function S(v){if(I.isLinux)return v;const b=(0,n.dirname)(v);if(v===b)return v;const g=((0,n.basename)(v)||v).toLowerCase();try{const p=(await C.Promises.readdir(b)).filter(P=>P.toLowerCase()===g);if(p.length===1){const P=await S(b);if(P)return(0,n.join)(P,p[0])}else if(p.length>1){const P=p.indexOf(g);if(P>=0){const _=await S(b);if(_)return(0,n.join)(_,p[P])}}}catch{}return null}e.realcase=S;async function L(v){try{return await C.Promises.realpath(v)}catch{const g=y(v);return await C.Promises.access(g,f.constants.R_OK),g}}e.realpath=L;function O(v){try{return f.realpathSync(v)}catch{const g=y(v);return f.accessSync(g,f.constants.R_OK),g}}e.realpathSync=O;function y(v){return(0,T.rtrim)((0,n.normalize)(v),n.sep)}});var Be=this&&this.__decorate||function(te,e,f,n){var I=arguments.length,T=I<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,f):n,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(te,e,f,n);else for(var k=te.length-1;k>=0;k--)(C=te[k])&&(T=(I<3?C(T):I>3?C(e,f,T):C(e,f))||T);return I>3&&T&&Object.defineProperty(e,f,T),T};define(pe[104],ve([1,0,18,16,22,21,56,15,3,6,58,8,13]),function(te,e,f,n,I,T,C,k,S,L,O,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function g(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function p(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(P||(P={}));class _{constructor(Z){this.buffer=Z,this.pos=0}read(Z){const V=this.buffer.slice(this.pos,this.pos+Z);return this.pos+=V.byteLength,V}}class o{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(Z){this.buffers.push(Z)}}var c;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object"})(c||(c={}));function u(ee){const Z=I.VSBuffer.alloc(4);return Z.writeUInt32BE(ee,0),Z}function l(ee){return ee.read(4).readUInt32BE(0)}function E(ee){const Z=I.VSBuffer.alloc(1);return Z.writeUInt8(ee,0),Z}const s={Undefined:E(c.Undefined),String:E(c.String),Buffer:E(c.Buffer),VSBuffer:E(c.VSBuffer),Array:E(c.Array),Object:E(c.Object)},t=typeof Buffer!="undefined";function r(ee,Z){if(typeof Z=="undefined")ee.write(s.Undefined);else if(typeof Z=="string"){const V=I.VSBuffer.fromString(Z);ee.write(s.String),ee.write(u(V.byteLength)),ee.write(V)}else if(t&&Buffer.isBuffer(Z)){const V=I.VSBuffer.wrap(Z);ee.write(s.Buffer),ee.write(u(V.byteLength)),ee.write(V)}else if(Z instanceof I.VSBuffer)ee.write(s.VSBuffer),ee.write(u(Z.byteLength)),ee.write(Z);else if(Array.isArray(Z)){ee.write(s.Array),ee.write(u(Z.length));for(const V of Z)r(ee,V)}else{const V=I.VSBuffer.fromString(JSON.stringify(Z));ee.write(s.Object),ee.write(u(V.byteLength)),ee.write(V)}}function i(ee){switch(ee.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return ee.read(l(ee)).toString();case c.Buffer:return ee.read(l(ee)).buffer;case c.VSBuffer:return ee.read(l(ee));case c.Array:{const V=l(ee),J=[];for(let se=0;se<V;se++)J.push(i(ee));return J}case c.Object:return JSON.parse(ee.read(l(ee)).toString())}}class a{constructor(Z,V,J=null,se=1e3){this.protocol=Z,this.ctx=V,this.logger=J,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(Z,V){this.channels.set(Z,V),setTimeout(()=>this.flushPendingRequests(Z),0)}sendResponse(Z){switch(Z.type){case 200:{const V=this.send([Z.type]);this.logger?.logOutgoing(V,0,1,p(Z.type));return}case 201:case 202:case 204:case 203:{const V=this.send([Z.type,Z.id],Z.data);this.logger?.logOutgoing(V,Z.id,1,p(Z.type),Z.data);return}}}send(Z,V=void 0){const J=new o;return r(J,Z),r(J,V),this.sendBuffer(J.buffer)}sendBuffer(Z){try{return this.protocol.send(Z),Z.byteLength}catch{return 0}}onRawMessage(Z){const V=new _(Z),J=i(V),se=i(V),ae=J[0];switch(ae){case 100:return this.logger?.logIncoming(Z.byteLength,J[1],1,`${g(ae)}: ${J[2]}.${J[3]}`,se),this.onPromise({type:ae,id:J[1],channelName:J[2],name:J[3],arg:se});case 102:return this.logger?.logIncoming(Z.byteLength,J[1],1,`${g(ae)}: ${J[2]}.${J[3]}`,se),this.onEventListen({type:ae,id:J[1],channelName:J[2],name:J[3],arg:se});case 101:return this.logger?.logIncoming(Z.byteLength,J[1],1,`${g(ae)}`),this.disposeActiveRequest({type:ae,id:J[1]});case 103:return this.logger?.logIncoming(Z.byteLength,J[1],1,`${g(ae)}`),this.disposeActiveRequest({type:ae,id:J[1]})}}onPromise(Z){const V=this.channels.get(Z.channelName);if(!V){this.collectPendingRequest(Z);return}const J=new T.CancellationTokenSource;let se;try{se=V.call(this.ctx,Z.name,Z.arg,J.token)}catch(Y){se=Promise.reject(Y)}const ae=Z.id;se.then(Y=>{this.sendResponse({id:ae,data:Y,type:201}),this.activeRequests.delete(Z.id)},Y=>{Y instanceof Error?this.sendResponse({id:ae,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ae,data:Y,type:203}),this.activeRequests.delete(Z.id)});const Q=(0,L.toDisposable)(()=>J.cancel());this.activeRequests.set(Z.id,Q)}onEventListen(Z){const V=this.channels.get(Z.channelName);if(!V){this.collectPendingRequest(Z);return}const J=Z.id,ae=V.listen(this.ctx,Z.name,Z.arg)(Q=>this.sendResponse({id:J,data:Q,type:204}));this.activeRequests.set(Z.id,ae)}disposeActiveRequest(Z){const V=this.activeRequests.get(Z.id);V&&(V.dispose(),this.activeRequests.delete(Z.id))}collectPendingRequest(Z){let V=this.pendingRequests.get(Z.channelName);V||(V=[],this.pendingRequests.set(Z.channelName,V));const J=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.sendResponse({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:Z,timeoutTimer:J})}flushPendingRequests(Z){const V=this.pendingRequests.get(Z);if(V){for(const J of V)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(Z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,L.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var m;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(Z,V=null){this.protocol=Z,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=V}getChannel(Z){const V=this;return{call(J,se,ae){return V.isDisposed?Promise.reject(k.canceled()):V.requestPromise(Z,J,se,ae)},listen(J,se){return V.isDisposed?S.Event.None:V.requestEvent(Z,J,se)}}}requestPromise(Z,V,J,se=T.CancellationToken.None){const ae=this.lastRequestId++,Y={id:ae,type:100,channelName:Z,name:V,arg:J};if(se.isCancellationRequested)return Promise.reject(k.canceled());let oe;return new Promise((Ee,Re)=>{if(se.isCancellationRequested)return Re(k.canceled());const Ne=()=>{const B=N=>{switch(N.type){case 201:this.handlers.delete(ae),Ee(N.data);break;case 202:{this.handlers.delete(ae);const z=new Error(N.data.message);z.stack=N.data.stack,z.name=N.data.name,Re(z);break}case 203:this.handlers.delete(ae),Re(N.data);break}};this.handlers.set(ae,B),this.sendRequest(Y)};let be=null;this.state===P.Idle?Ne():(be=(0,n.createCancelablePromise)(B=>this.whenInitialized()),be.then(()=>{be=null,Ne()}));const we=()=>{be?(be.cancel(),be=null):this.sendRequest({id:ae,type:101}),Re(k.canceled())},H=se.onCancellationRequested(we);oe=(0,L.combinedDisposable)((0,L.toDisposable)(we),H),this.activeRequests.add(oe)}).finally(()=>{this.activeRequests.delete(oe)})}requestEvent(Z,V,J){const se=this.lastRequestId++,Q={id:se,type:102,channelName:Z,name:V,arg:J};let Y=null;const oe=new S.Emitter({onFirstListenerAdd:()=>{Y=(0,n.createCancelablePromise)(Ee=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(oe),this.sendRequest(Q)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(oe),this.sendRequest({id:se,type:103}))}}),de=Ee=>oe.fire(Ee.data);return this.handlers.set(se,de),oe.event}sendRequest(Z){switch(Z.type){case 100:case 102:{const V=this.send([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.logger&&this.logger.logOutgoing(V,Z.id,0,`${g(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const V=this.send([Z.type,Z.id]);this.logger&&this.logger.logOutgoing(V,Z.id,0,g(Z.type));return}}}send(Z,V=void 0){const J=new o;return r(J,Z),r(J,V),this.sendBuffer(J.buffer)}sendBuffer(Z){try{return this.protocol.send(Z),Z.byteLength}catch{return 0}}onBuffer(Z){const V=new _(Z),J=i(V),se=i(V),ae=J[0];switch(ae){case 200:return this.logger&&this.logger.logIncoming(Z.byteLength,0,0,p(ae)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(Z.byteLength,J[1],0,p(ae),se),this.onResponse({type:J[0],id:J[1],data:se})}}onResponse(Z){if(Z.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(Z.id);V&&V(Z)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,L.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([C.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class w{constructor(Z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,Z(({protocol:V,onDidClientDisconnect:J})=>{S.Event.once(V.onMessage)(ae=>{const Q=new _(ae),Y=i(Q),oe=new a(V,Y),de=new h(V);this.channels.forEach((Re,Ne)=>oe.registerChannel(Ne,Re));const Ee={channelServer:oe,channelClient:de,ctx:Y};this._connections.add(Ee),this._onDidAddConnection.fire(Ee),J(()=>{oe.dispose(),de.dispose(),this._connections.delete(Ee),this._onDidRemoveConnection.fire(Ee)})})})}get connections(){const Z=[];return this._connections.forEach(V=>Z.push(V)),Z}getChannel(Z,V){const J=this;return{call(se,ae,Q){let Y;if((0,v.isFunction)(V)){let de=(0,f.getRandomElement)(J.connections.filter(V));Y=de?Promise.resolve(de):S.Event.toPromise(S.Event.filter(J.onDidAddConnection,V))}else Y=V.routeCall(J,se,ae);const oe=Y.then(de=>de.channelClient.getChannel(Z));return F(oe).call(se,ae,Q)},listen(se,ae){if((0,v.isFunction)(V))return J.getMulticastEvent(Z,V,se,ae);const Q=V.routeEvent(J,se,ae).then(Y=>Y.channelClient.getChannel(Z));return F(Q).listen(se,ae)}}}getMulticastEvent(Z,V,J,se){const ae=this;let Q=new L.DisposableStore;const Y=new S.Emitter({onFirstListenerAdd:()=>{Q=new L.DisposableStore;const oe=new S.EventMultiplexer,de=new Map,Ee=Ne=>{const we=Ne.channelClient.getChannel(Z).listen(J,se),H=oe.add(we);de.set(Ne,H)},Re=Ne=>{const be=de.get(Ne);!be||(be.dispose(),de.delete(Ne))};ae.connections.filter(V).forEach(Ee),S.Event.filter(ae.onDidAddConnection,V)(Ee,void 0,Q),ae.onDidRemoveConnection(Re,void 0,Q),oe.event(Y.fire,Y,Q),Q.add(oe)},onLastListenerRemove:()=>{Q.dispose()}});return Y.event}registerChannel(Z,V){this.channels.set(Z,V),this._connections.forEach(J=>{J.channelServer.registerChannel(Z,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class A{constructor(Z,V,J=null){const se=new o;r(se,V),Z.send(se.buffer),this.channelClient=new h(Z,J),this.channelServer=new a(Z,V,J)}getChannel(Z){return this.channelClient.getChannel(Z)}registerChannel(Z,V){this.channelServer.registerChannel(Z,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function F(ee){return{call(Z,V,J){return ee.then(se=>se.call(Z,V,J))},listen(Z,V){const J=new S.Relay;return ee.then(se=>J.input=se.listen(Z,V)),J.event}}}e.getDelayedChannel=F;function R(ee){let Z=!1;return{call(V,J,se){return Z?ee.call(V,J,se):(0,n.timeout)(0).then(()=>Z=!0).then(()=>ee.call(V,J,se))},listen(V,J){if(Z)return ee.listen(V,J);const se=new S.Relay;return(0,n.timeout)(0).then(()=>Z=!0).then(()=>se.input=ee.listen(V,J)),se.event}}}e.getNextTickChannel=R;class D{constructor(Z){this.fn=Z}routeCall(Z){return this.route(Z)}routeEvent(Z){return this.route(Z)}async route(Z){for(const V of Z.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await S.Event.toPromise(Z.onDidAddConnection),await this.route(Z)}}e.StaticRouter=D;var $;(function(ee){function Z(ae,Q){const Y=ae,oe=Q&&Q.disableMarshalling,de=new Map;for(const Ee in Y)J(Ee)&&de.set(Ee,S.Event.buffer(Y[Ee],!0));return new class{listen(Ee,Re,Ne){const be=de.get(Re);if(be)return be;if(se(Re)){const we=Y[Re];if(typeof we=="function")return we.call(Y,Ne)}throw new Error(`Event not found: ${Re}`)}call(Ee,Re,Ne){const be=Y[Re];if(typeof be=="function"){if(!oe&&Array.isArray(Ne))for(let we=0;we<Ne.length;we++)Ne[we]=(0,O.revive)(Ne[we]);return be.apply(Y,Ne)}throw new Error(`Method not found: ${Re}`)}}}ee.fromService=Z;function V(ae,Q){const Y=Q&&Q.disableMarshalling;return new Proxy({},{get(oe,de){if(typeof de=="string")return Q?.properties?.has(de)?Q.properties.get(de):se(de)?function(Ee){return ae.listen(de,Ee)}:J(de)?ae.listen(de):async function(...Ee){let Re;Q&&!(0,v.isUndefinedOrNull)(Q.context)?Re=[Q.context,...Ee]:Re=Ee;const Ne=await ae.call(de,Re);return Y?Ne:(0,O.revive)(Ne)};throw new Error(`Property not found: ${String(de)}`)}})}ee.toService=V;function J(ae){return ae[0]==="o"&&ae[1]==="n"&&y.isUpperAsciiLetter(ae.charCodeAt(2))}function se(ae){return/^onDynamic/.test(ae)&&y.isUpperAsciiLetter(ae.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){let Z=ee.toString();if(Z!=="[object Object]")return Z}return ee}function G(ee){return Array.isArray(ee)?ee.map(q):q(ee)}function U(ee,Z,V,J,se,ae,Q){Q=G(Q);const Y=M[se],oe=Y[J%Y.length];let de=[`%c[${ee}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${oe}`];/\($/.test(ae)?(de=de.concat(Q),de.push(")")):de.push(Q),console.log.apply(console,de)}e.logWithColors=U;class W{constructor(Z,V){this._outgoingPrefix=Z,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Z,V,J,se,ae){this._totalOutgoing+=Z,U(this._outgoingPrefix,this._totalOutgoing,Z,V,J,se,ae)}logIncoming(Z,V,J,se,ae){this._totalIncoming+=Z,U(this._incomingPrefix,this._totalIncoming,Z,V,J,se,ae)}}e.IPCLogger=W}),define(pe[105],ve([1,0,22,3,6,104]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let i=0;function a(h,w){if(!r.has(h)){const A=String(++i);r.set(h,A)}return r.get(h)}function m(h,w,A,F){if(!t.enableDiagnostics)return;const R=a(h,w);if(F instanceof f.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const D=f.VSBuffer.alloc(F.byteLength);D.set(F),t.records.push({timestamp:Date.now(),id:R,label:w,type:A,buff:D})}else t.records.push({timestamp:Date.now(),id:R,label:w,type:A,data:F})}t.traceSocketEvent=m})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function O(){return L||(L=f.VSBuffer.alloc(0)),L}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,i){if(r===0)return O();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const w=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=r),w}if(this._chunks[0].byteLength>r){const w=this._chunks[0].slice(0,r);return i&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),w}let a=f.VSBuffer.alloc(r),m=0,h=0;for(;r>0;){const w=this._chunks[h];if(w.byteLength>r){const A=w.slice(0,r);a.set(A,m),m+=r,i&&(this._chunks[h]=w.slice(r),this._totalLength-=r),r-=r}else a.set(w,m),m+=w.byteLength,i?(this._chunks.shift(),this._totalLength-=w.byteLength):h++,r-=w.byteLength}return a}}e.ChunkStream=y;var v;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(v||(v={}));function b(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,i,a,m){this.type=r,this.id=i,this.ack=a,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends I.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,m=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",i),this._onMessage.fire(new d(a,m,h,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=f.VSBuffer.alloc(13);i.writeUInt8(r.type,0),i.writeUInt32BE(r.id,1),i.writeUInt32BE(r.ack,5),i.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(i,r.data)}_bufferAdd(r,i){const a=this._totalLength===0;return this._data.push(r,i),this._totalLength+=r.byteLength+i.byteLength,a}_bufferTake(){const r=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,i){this._bufferAdd(r,i)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class _ extends I.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=_;class o extends T.IPCClient{constructor(r,i,a=null){super(r,i,a);this.protocol=r}static fromSocket(r,i){return new o(new _(r),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=o;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class u{constructor(r){this.data=r,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],i=0,a=this._first;for(;a;)r[i++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const i=new u(r);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class E{constructor(){this.lastRuns=[];const r=Date.now();for(let i=0;i<E._HISTORY_LENGTH;i++)this.lastRuns[i]=r-1e3*i;setInterval(()=>{for(let i=E._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const r=Date.now(),i=(1+E._HISTORY_LENGTH)*1e3;let a=0;for(let m=0;m<E._HISTORY_LENGTH;m++)r-this.lastRuns[m]<=i&&a++;return 1-a/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class s{constructor(r,i=null,a=E.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),i&&this._socketReader.acceptChunk(i)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,O());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,O());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,O());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,i){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,O());this._socketWriter.write(r);const i=this._outgoingUnackMsg.toArray();for(let a=0,m=i.length;a<m;a++)this._socketWriter.write(i[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new d(6,0,0,O())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const i=this._outgoingUnackMsg.toArray();for(let a=0,m=i.length;a<m;a++)this._socketWriter.write(i[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new d(1,i,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const i=new d(2,0,0,r);this._socketWriter.write(i)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),i=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(i>=2e4&&a>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-i,2e4-a,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,O());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(pe[106],ve([1,0,96]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class n{constructor(k){const S=(0,f.toUint8)(k);this._defaultValue=S,this._asciiMap=n._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){const S=new Uint8Array(256);for(let L=0;L<256;L++)S[L]=k;return S}set(k,S){const L=(0,f.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=L:this._map.set(k,L)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=n;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(I||(I={}));class T{constructor(){this._actual=new n(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(pe[48],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,T){this.lineNumber=I,this.column=T}with(I=this.lineNumber,T=this.column){return I===this.lineNumber&&T===this.column?this:new f(I,T)}delta(I=0,T=0){return this.with(this.lineNumber+I,this.column+T)}equals(I){return f.equals(this,I)}static equals(I,T){return!I&&!T?!0:!!I&&!!T&&I.lineNumber===T.lineNumber&&I.column===T.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<T.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<=T.column}static compare(I,T){const C=I.lineNumber|0,k=T.lineNumber|0;if(C===k){const S=I.column|0,L=T.column|0;return S-L}return C-k}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(pe[35],ve([1,0,48]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(T,C,k,S){T>k||T===k&&C>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=T,this.endColumn=C):(this.startLineNumber=T,this.startColumn=C,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return n.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return n.containsPosition(this,T)}static containsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<T.startColumn||C.lineNumber===T.endLineNumber&&C.column>T.endColumn)}static strictContainsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<=T.startColumn||C.lineNumber===T.endLineNumber&&C.column>=T.endColumn)}containsRange(T){return n.containsRange(this,T)}static containsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>T.endColumn)}strictContainsRange(T){return n.strictContainsRange(this,T)}static strictContainsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<=T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>=T.endColumn)}plusRange(T){return n.plusRange(this,T)}static plusRange(T,C){let k,S,L,O;return C.startLineNumber<T.startLineNumber?(k=C.startLineNumber,S=C.startColumn):C.startLineNumber===T.startLineNumber?(k=C.startLineNumber,S=Math.min(C.startColumn,T.startColumn)):(k=T.startLineNumber,S=T.startColumn),C.endLineNumber>T.endLineNumber?(L=C.endLineNumber,O=C.endColumn):C.endLineNumber===T.endLineNumber?(L=C.endLineNumber,O=Math.max(C.endColumn,T.endColumn)):(L=T.endLineNumber,O=T.endColumn),new n(k,S,L,O)}intersectRanges(T){return n.intersectRanges(this,T)}static intersectRanges(T,C){let k=T.startLineNumber,S=T.startColumn,L=T.endLineNumber,O=T.endColumn,y=C.startLineNumber,v=C.startColumn,b=C.endLineNumber,g=C.endColumn;return k<y?(k=y,S=v):k===y&&(S=Math.max(S,v)),L>b?(L=b,O=g):L===b&&(O=Math.min(O,g)),k>L||k===L&&S>O?null:new n(k,S,L,O)}equalsRange(T){return n.equalsRange(this,T)}static equalsRange(T,C){return!!T&&!!C&&T.startLineNumber===C.startLineNumber&&T.startColumn===C.startColumn&&T.endLineNumber===C.endLineNumber&&T.endColumn===C.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(T){return new f.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(T){return new f.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,C){return new n(this.startLineNumber,this.startColumn,T,C)}setStartPosition(T,C){return new n(T,C,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(T){return new n(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,C=T){return new n(T.lineNumber,T.column,C.lineNumber,C.column)}static lift(T){return T?new n(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn)}static areIntersecting(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,C){if(T&&C){const L=T.startLineNumber|0,O=C.startLineNumber|0;if(L===O){const y=T.startColumn|0,v=C.startColumn|0;if(y===v){const b=T.endLineNumber|0,g=C.endLineNumber|0;if(b===g){const d=T.endColumn|0,p=C.endColumn|0;return d-p}return b-g}return y-v}return L-O}return(T?1:0)-(C?1:0)}static compareRangesUsingEnds(T,C){return T.endLineNumber===C.endLineNumber?T.endColumn===C.endColumn?T.startLineNumber===C.startLineNumber?T.startColumn-C.startColumn:T.startLineNumber-C.startLineNumber:T.endColumn-C.endColumn:T.endLineNumber-C.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.Range=n}),define(pe[146],ve([1,0,48,35]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class T extends n.Range{constructor(k,S,L,O){super(k,S,L,O);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=L,this.positionColumn=O}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,S):new T(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new T(k,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new T(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new T(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new T(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let L=0,O=k.length;L<O;L++)if(!this.selectionsEqual(k[L],S[L]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,L,O,y){return y===0?new T(k,S,L,O):new T(L,O,k,S)}}e.Selection=T}),define(pe[147],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(pe[148],ve([1,0,106]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var n;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(n=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(k){super(0);for(let S=0,L=k.length;S<L;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function T(C){const k={};return S=>(k.hasOwnProperty(S)||(k[S]=C(S)),k[S])}e.getMapForWordSeparators=T(C=>new I(C))}),define(pe[107],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const L of e.USUAL_WORD_SEPARATORS)k.indexOf(L)>=0||(S+="\\"+L);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=f();function n(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let L="g";k.ignoreCase&&(L+="i"),k.multiline&&(L+="m"),k.unicode&&(L+="u"),S=new RegExp(k.source,L)}return S.lastIndex=0,S}e.ensureValidWordDefinition=n;const I={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,S,L,O,y=I){if(L.length>y.maxLen){let p=k-y.maxLen/2;return p<0?p=0:O+=p,L=L.substring(p,k+y.maxLen/2),T(k,S,L,O,y)}const v=Date.now(),b=k-1-O;let g=-1,d=null;for(let p=1;!(Date.now()-v>=y.timeBudget);p++){const P=b-y.windowSize*p;S.lastIndex=Math.max(0,P);const _=C(S,L,b,g);if(!_&&d||(d=_,P<=0))break;g=P}if(d){const p={word:d[0],startColumn:O+1+d.index,endColumn:O+1+d.index+d[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=T;function C(k,S,L,O){let y;for(;y=k.exec(S);){const v=y.index||0;if(v<=L&&k.lastIndex>=L)return y;if(O>0&&v>O)return null}return null}}),define(pe[108],ve([1,0,34,9]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(T,C,k,S,L){if(Array.isArray(T)){let O=0;for(const y of T){const v=I(y,C,k,S,L);if(v===10)return v;v>O&&(O=v)}return O}else{if(typeof T=="string")return S?T==="*"?5:T===k?10:0:0;if(T){const{language:O,pattern:y,scheme:v,hasAccessToAllModels:b,notebookType:g}=T;if(!S&&!b)return 0;let d=0;if(v)if(v===C.scheme)d=10;else if(v==="*")d=5;else return 0;if(O)if(O===k)d=10;else if(O==="*")d=Math.max(d,5);else return 0;if(g)if(g===L)d=10;else if(g==="*")d=Math.max(d,5);else return 0;if(y){let p;if(typeof y=="string"?p=y:p={...y,base:(0,n.normalize)(y.base)},p===C.fsPath||(0,f.match)(p,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=I}),define(pe[149],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class n{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let S=0,L=k.notIn.length;S<L;S++)switch(k.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const L=k.findTokenIndexAtOffset(S-2),O=k.getStandardTokenType(L);return this.isOK(O)}_findNeutralCharacterInRange(k,S){for(let L=k;L<=S;L++){const O=String.fromCharCode(L);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=n;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function T(C,k,S){C.has(k)?C.get(k).push(S):C.set(k,[S])}}),define(pe[150],ve([1,0,106]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var n;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(n=e.State||(e.State={}));class I{constructor(g,d,p){const P=new Uint8Array(g*d);for(let _=0,o=g*d;_<o;_++)P[_]=p;this._data=P,this.rows=g,this.cols=d}get(g,d){return this._data[g*this.cols+d]}set(g,d,p){this._data[g*this.cols+d]=p}}e.Uint8Matrix=I;class T{constructor(g){let d=0,p=0;for(let _=0,o=g.length;_<o;_++){const[c,u,l]=g[_];u>d&&(d=u),c>p&&(p=c),l>p&&(p=l)}d++,p++;const P=new I(p,d,0);for(let _=0,o=g.length;_<o;_++){const[c,u,l]=g[_];P.set(c,u,l)}this._states=P,this._maxCharCode=d}nextState(g,d){return d<0||d>=this._maxCharCode?0:this._states.get(g,d)}}e.StateMachine=T;let C=null;function k(){return C===null&&(C=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let L=null;function O(){if(L===null){L=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<b.length;d++)L.set(b.charCodeAt(d),1);const g=".,;";for(let d=0;d<g.length;d++)L.set(g.charCodeAt(d),2)}return L}class y{static _createLink(g,d,p,P,_){let o=_-1;do{const c=d.charCodeAt(o);if(g.get(c)!==2)break;o--}while(o>P);if(P>0){const c=d.charCodeAt(P-1),u=d.charCodeAt(o);(c===40&&u===41||c===91&&u===93||c===123&&u===125)&&o--}return{range:{startLineNumber:p,startColumn:P+1,endLineNumber:p,endColumn:o+2},url:d.substring(P,o+1)}}static computeLinks(g,d=k()){const p=O(),P=[];for(let _=1,o=g.getLineCount();_<=o;_++){const c=g.getLineContent(_),u=c.length;let l=0,E=0,s=0,t=1,r=!1,i=!1,a=!1,m=!1;for(;l<u;){let h=!1;const w=c.charCodeAt(l);if(t===13){let A;switch(w){case 40:r=!0,A=0;break;case 41:A=r?0:1;break;case 91:a=!0,i=!0,A=0;break;case 93:a=!1,A=i?0:1;break;case 123:m=!0,A=0;break;case 125:A=m?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=a?0:1;break;default:A=p.get(w)}A===1&&(P.push(y._createLink(p,c,_,E,l)),h=!0)}else if(t===12){let A;w===91?(i=!0,A=0):A=p.get(w),A===1?h=!0:t=13}else t=d.nextState(t,w),t===0&&(h=!0);h&&(t=1,r=!1,i=!1,m=!1,E=l+1,s=w),l++}t===13&&P.push(y._createLink(p,c,_,E,u))}return P}}e.LinkComputer=y;function v(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:y.computeLinks(b)}e.computeLinks=v}),define(pe[109],ve([1,0,25]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var n;(function(_){_[_.Left=1]="Left",_[_.Center=2]="Center",_[_.Right=4]="Right",_[_.Full=7]="Full"})(n=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(_){_[_.Inline=1]="Inline",_[_.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(_){_[_.Both=0]="Both",_[_.Right=1]="Right",_[_.Left=2]="Left",_[_.None=3]="None"})(T=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(_){_[_.TextDefined=0]="TextDefined",_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(_){_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(_){_[_.LF=0]="LF",_[_.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class L{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=L;class O{constructor(o,c){this._findMatchBrand=void 0,this.range=o,this.matches=c}}e.FindMatch=O;var y;(function(_){_[_.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",_[_.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",_[_.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",_[_.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var v;(function(_){_[_.Left=0]="Left",_[_.Right=1]="Right",_[_.None=2]="None"})(v=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(_){_[_.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class g{constructor(o,c,u,l,E,s){this.identifier=o,this.range=c,this.text=u,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=E,this._isTracked=s}}e.ValidAnnotatedEditOperation=g;class d{constructor(o,c,u){this.regex=o,this.wordSeparators=c,this.simpleSearch=u}}e.SearchData=d;class p{constructor(o,c,u){this.reverseEdits=o,this.changes=c,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=p;function P(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(pe[110],ve([1,0,18,96]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,L){S=(0,n.toUint32)(S);const O=this.values,y=this.prefixSum,v=L.length;return v===0?!1:(this.values=new Uint32Array(O.length+v),this.values.set(O.subarray(0,S),0),this.values.set(O.subarray(S),S+v),this.values.set(L,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,L){return S=(0,n.toUint32)(S),L=(0,n.toUint32)(L),this.values[S]===L?!1:(this.values[S]=L,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,L){S=(0,n.toUint32)(S),L=(0,n.toUint32)(L);const O=this.values,y=this.prefixSum;if(S>=O.length)return!1;const v=O.length-S;return L>=v&&(L=v),L===0?!1:(this.values=new Uint32Array(O.length-L),this.values.set(O.subarray(0,S),0),this.values.set(O.subarray(S+L),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,n.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let L=this.prefixSumValidIndex[0]+1;L===0&&(this.prefixSum[0]=this.values[0],L++),S>=this.values.length&&(S=this.values.length-1);for(let O=L;O<=S;O++)this.prefixSum[O]=this.prefixSum[O-1]+this.values[O];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let L=0,O=this.values.length-1,y=0,v=0,b=0;for(;L<=O;)if(y=L+(O-L)/2|0,v=this.prefixSum[y],b=v-this.values[y],S<b)O=y-1;else if(S>=v)L=y+1;else break;return new C(y,S-b)}}e.PrefixSumComputer=I;class T{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const L=this._indexBySum[S],O=L>0?this._prefixSum[L-1]:0;return new C(L,S-O)}removeValues(S,L){this._values.splice(S,L),this._invalidate(S)}insertValues(S,L){this._values=(0,f.arrayInsert)(this._values,S,L),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,L=this._values.length;S<L;S++){const O=this._values[S],y=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=y+O;for(let v=0;v<O;v++)this._indexBySum[y+v]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,L){this._values[S]!==L&&(this._values[S]=L,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=T;class C{constructor(S,L){this.index=S,this.remainder=L,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=L}}e.PrefixSumIndexOfResult=C}),define(pe[151],ve([1,0,8,48,110]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,S,L,O){this._uri=k,this._lines=S,this._eol=L,this._versionId=O,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const L of S)this._acceptDeleteRange(L.range),this._acceptInsertText(new n.Position(L.range.startLineNumber,L.range.startColumn),L.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,L=new Uint32Array(S);for(let O=0;O<S;O++)L[O]=this._lines[O].length+k;this._lineStarts=new I.PrefixSumComputer(L)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;const L=(0,f.splitLines)(S);if(L.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+L[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}L[L.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+L[0]);const O=new Uint32Array(L.length-1);for(let y=1;y<L.length;y++)this._lines.splice(k.lineNumber+y-1,0,L[y]),O[y-1]=L[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,O)}}e.MirrorTextModel=T}),define(pe[152],ve([1,0,8,148,48,35,109]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(_,o,c,u){this.searchString=_,this.isRegex=o,this.matchCase=c,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=L(this.searchString):_=this.searchString.indexOf(`
`)>=0;let o=null;try{o=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!o)return null;let c=!this.isRegex&&!_;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new C.SearchData(o,this.wordSeparators?(0,n.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=S;function L(P){if(!P||P.length===0)return!1;for(let _=0,o=P.length;_<o;_++)if(P.charCodeAt(_)===92){if(_++,_>=o)break;const u=P.charCodeAt(_);if(u===110||u===114||u===87)return!0}return!1}e.isMultilineRegexSource=L;function O(P,_,o){if(!o)return new C.FindMatch(P,null);const c=[];for(let u=0,l=_.length;u<l;u++)c[u]=_[u];return new C.FindMatch(P,c)}e.createFindMatch=O;class y{constructor(_){const o=[];let c=0;for(let u=0,l=_.length;u<l;u++)_.charCodeAt(u)===10&&(o[c++]=u);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(_){const o=this._lineFeedsOffsets;let c=0,u=o.length-1;if(u===-1||_<=o[0])return 0;for(;c<u;){const l=c+((u-c)/2>>0);o[l]>=_?u=l-1:o[l+1]>=_?(c=l,u=l):c=l+1}return c+1}}class v{static findMatches(_,o,c,u,l){const E=o.parseSearchRequest();return E?E.regex.multiline?this._doFindMatchesMultiline(_,c,new p(E.wordSeparators,E.regex),u,l):this._doFindMatchesLineByLine(_,c,E,u,l):[]}static _getMultilineMatchRange(_,o,c,u,l,E){let s,t=0;u?(t=u.findLineFeedCountBeforeOffset(l),s=o+l+t):s=o+l;let r;if(u){const h=u.findLineFeedCountBeforeOffset(l+E.length)-t;r=s+E.length+h}else r=s+E.length;const i=_.getPositionAt(s),a=_.getPositionAt(r);return new T.Range(i.lineNumber,i.column,a.lineNumber,a.column)}static _doFindMatchesMultiline(_,o,c,u,l){const E=_.getOffsetAt(o.getStartPosition()),s=_.getValueInRange(o,1),t=_.getEOL()===`\r
`?new y(s):null,r=[];let i=0,a;for(c.reset(0);a=c.next(s);)if(r[i++]=O(this._getMultilineMatchRange(_,E,s,t,a.index,a[0]),a,u),i>=l)return r;return r}static _doFindMatchesLineByLine(_,o,c,u,l){const E=[];let s=0;if(o.startLineNumber===o.endLineNumber){const r=_.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return s=this._findMatchesInLine(c,r,o.startLineNumber,o.startColumn-1,s,E,u,l),E}const t=_.getLineContent(o.startLineNumber).substring(o.startColumn-1);s=this._findMatchesInLine(c,t,o.startLineNumber,o.startColumn-1,s,E,u,l);for(let r=o.startLineNumber+1;r<o.endLineNumber&&s<l;r++)s=this._findMatchesInLine(c,_.getLineContent(r),r,0,s,E,u,l);if(s<l){const r=_.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);s=this._findMatchesInLine(c,r,o.endLineNumber,0,s,E,u,l)}return E}static _findMatchesInLine(_,o,c,u,l,E,s,t){const r=_.wordSeparators;if(!s&&_.simpleSearch){const m=_.simpleSearch,h=m.length,w=o.length;let A=-h;for(;(A=o.indexOf(m,A+h))!==-1;)if((!r||d(r,o,w,A,h))&&(E[l++]=new C.FindMatch(new T.Range(c,A+1+u,c,A+1+h+u),null),l>=t))return l;return l}const i=new p(_.wordSeparators,_.regex);let a;i.reset(0);do if(a=i.next(o),a&&(E[l++]=O(new T.Range(c,a.index+1+u,c,a.index+1+a[0].length+u),a,s),l>=t))return l;while(a);return l}static findNextMatch(_,o,c,u){const l=o.parseSearchRequest();if(!l)return null;const E=new p(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(_,c,E,u):this._doFindNextMatchLineByLine(_,c,E,u)}static _doFindNextMatchMultiline(_,o,c,u){const l=new I.Position(o.lineNumber,1),E=_.getOffsetAt(l),s=_.getLineCount(),t=_.getValueInRange(new T.Range(l.lineNumber,l.column,s,_.getLineMaxColumn(s)),1),r=_.getEOL()===`\r
`?new y(t):null;c.reset(o.column-1);let i=c.next(t);return i?O(this._getMultilineMatchRange(_,E,t,r,i.index,i[0]),i,u):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(_,new I.Position(1,1),c,u):null}static _doFindNextMatchLineByLine(_,o,c,u){const l=_.getLineCount(),E=o.lineNumber,s=_.getLineContent(E),t=this._findFirstMatchInLine(c,s,E,o.column,u);if(t)return t;for(let r=1;r<=l;r++){const i=(E+r-1)%l,a=_.getLineContent(i+1),m=this._findFirstMatchInLine(c,a,i+1,1,u);if(m)return m}return null}static _findFirstMatchInLine(_,o,c,u,l){_.reset(u-1);const E=_.next(o);return E?O(new T.Range(c,E.index+1,c,E.index+1+E[0].length),E,l):null}static findPreviousMatch(_,o,c,u){const l=o.parseSearchRequest();if(!l)return null;const E=new p(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(_,c,E,u):this._doFindPreviousMatchLineByLine(_,c,E,u)}static _doFindPreviousMatchMultiline(_,o,c,u){const l=this._doFindMatchesMultiline(_,new T.Range(1,1,o.lineNumber,o.column),c,u,10*k);if(l.length>0)return l[l.length-1];const E=_.getLineCount();return o.lineNumber!==E||o.column!==_.getLineMaxColumn(E)?this._doFindPreviousMatchMultiline(_,new I.Position(E,_.getLineMaxColumn(E)),c,u):null}static _doFindPreviousMatchLineByLine(_,o,c,u){const l=_.getLineCount(),E=o.lineNumber,s=_.getLineContent(E).substring(0,o.column-1),t=this._findLastMatchInLine(c,s,E,u);if(t)return t;for(let r=1;r<=l;r++){const i=(l+E-r-1)%l,a=_.getLineContent(i+1),m=this._findLastMatchInLine(c,a,i+1,u);if(m)return m}return null}static _findLastMatchInLine(_,o,c,u){let l=null,E;for(_.reset(0);E=_.next(o);)l=O(new T.Range(c,E.index+1,c,E.index+1+E[0].length),E,u);return l}}e.TextModelSearch=v;function b(P,_,o,c,u){if(c===0)return!0;const l=_.charCodeAt(c-1);if(P.get(l)!==0||l===13||l===10)return!0;if(u>0){const E=_.charCodeAt(c);if(P.get(E)!==0)return!0}return!1}function g(P,_,o,c,u){if(c+u===o)return!0;const l=_.charCodeAt(c+u);if(P.get(l)!==0||l===13||l===10)return!0;if(u>0){const E=_.charCodeAt(c+u-1);if(P.get(E)!==0)return!0}return!1}function d(P,_,o,c,u){return b(P,_,o,c,u)&&g(P,_,o,c,u)}e.isValidMatch=d;class p{constructor(_,o){this._wordSeparators=_,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const o=_.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(c=this._searchRegex.exec(_),!c))return null;const u=c.index,l=c[0].length;if(u===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){f.getNextCodePoint(_,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=l,!this._wordSeparators||d(this._wordSeparators,_,o,u,l))return c}while(c);return null}}e.Searcher=p}),define(pe[111],ve([1,0,22,12]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function T(y){for(let v=0,b=y.length;v<b;v+=4){const g=y[v+0],d=y[v+1],p=y[v+2],P=y[v+3];y[v+0]=P,y[v+1]=p,y[v+2]=d,y[v+3]=g}}function C(y){const v=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return n.isLittleEndian()||T(v),f.VSBuffer.wrap(v)}function k(y){const v=y.buffer;if(n.isLittleEndian()||T(v),v.byteOffset%4==0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const b=new Uint8Array(v.byteLength);return b.set(v),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(y){const v=new Uint32Array(L(y));let b=0;if(v[b++]=y.id,y.type==="full")v[b++]=1,v[b++]=y.data.length,v.set(y.data,b),b+=y.data.length;else{v[b++]=2,v[b++]=y.deltas.length;for(const g of y.deltas)v[b++]=g.start,v[b++]=g.deleteCount,g.data?(v[b++]=g.data.length,v.set(g.data,b),b+=g.data.length):v[b++]=0}return C(v)}e.encodeSemanticTokensDto=S;function L(y){let v=0;if(v+=1+1,y.type==="full")v+=1+y.data.length;else{v+=1,v+=(1+1+1)*y.deltas.length;for(const b of y.deltas)b.data&&(v+=b.data.length)}return v}function O(y){const v=k(y);let b=0;const g=v[b++];if(v[b++]===1){const _=v[b++],o=v.subarray(b,b+_);return b+=_,{id:g,type:"full",data:o}}const p=v[b++],P=[];for(let _=0;_<p;_++){const o=v[b++],c=v[b++],u=v[b++];let l;u>0&&(l=v.subarray(b,b+u),b+=u),P[_]={start:o,deleteCount:c,data:l}}return{id:g,type:"delta",deltas:P}}e.decodeSemanticTokensDto=O}),define(pe[153],ve([1,0,3,6]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this._map.set(k,S),this.fire([k]),(0,n.toDisposable)(()=>{this._map.get(k)===S&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,S){this._factories.get(k)?.dispose();const L=new T(this,k,S);return this._factories.set(k,L),(0,n.toDisposable)(()=>{const O=this._factories.get(k);!O||O!==L||(this._factories.delete(k),O.dispose())})}async getOrCreate(k){const S=this.get(k);if(S)return S;const L=this._factories.get(k);return!L||L.isResolved?null:(await L.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const L=this._factories.get(k);return!!(!L||L.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class T extends n.Disposable{constructor(k,S,L){super();this._registry=k,this._languageId=S,this._factory=L,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(pe[78],ve([1,0,2,35,153,72]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(R){R[R.Null=0]="Null",R[R.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));var k;(function(R){R[R.NotSet=-1]="NotSet",R[R.None=0]="None",R[R.Italic=1]="Italic",R[R.Bold=2]="Bold",R[R.Underline=4]="Underline",R[R.Strikethrough=8]="Strikethrough"})(k=e.FontStyle||(e.FontStyle={}));var S;(function(R){R[R.None=0]="None",R[R.DefaultForeground=1]="DefaultForeground",R[R.DefaultBackground=2]="DefaultBackground"})(S=e.ColorId||(e.ColorId={}));var L;(function(R){R[R.Other=0]="Other",R[R.Comment=1]="Comment",R[R.String=2]="String",R[R.RegEx=3]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var O;(function(R){R[R.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",R[R.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",R[R.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",R[R.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",R[R.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",R[R.ITALIC_MASK=1024]="ITALIC_MASK",R[R.BOLD_MASK=2048]="BOLD_MASK",R[R.UNDERLINE_MASK=4096]="UNDERLINE_MASK",R[R.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",R[R.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",R[R.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",R[R.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",R[R.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",R[R.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",R[R.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",R[R.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",R[R.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",R[R.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",R[R.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",R[R.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(O=e.MetadataConsts||(e.MetadataConsts={}));class y{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&768)>>>8}static getFontStyle(D){return(D&15360)>>>10}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){const $=this.getForeground(D);let M="mtk"+$;const q=this.getFontStyle(D);return q&1&&(M+=" mtki"),q&2&&(M+=" mtkb"),q&4&&(M+=" mtku"),q&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(D,$){const M=this.getForeground(D),q=this.getFontStyle(D);let G=`color: ${$[M]};`;q&1&&(G+="font-style: italic;"),q&2&&(G+="font-weight: bold;");let U="";return q&4&&(U+=" underline"),q&8&&(U+=" line-through"),U&&(G+=`text-decoration:${U};`),G}static getPresentationFromMetadata(D){const $=this.getForeground(D),M=this.getFontStyle(D);return{foreground:$,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=y;class v{constructor(D,$,M){this._tokenBrand=void 0,this.offset=D,this.type=$,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class b{constructor(D,$){this._tokenizationResultBrand=void 0,this.tokens=D,this.endState=$}}e.TokenizationResult=b;class g{constructor(D,$){this._encodedTokenizationResultBrand=void 0,this.tokens=D,this.endState=$}}e.EncodedTokenizationResult=g;var d;(function(R){R[R.Method=0]="Method",R[R.Function=1]="Function",R[R.Constructor=2]="Constructor",R[R.Field=3]="Field",R[R.Variable=4]="Variable",R[R.Class=5]="Class",R[R.Struct=6]="Struct",R[R.Interface=7]="Interface",R[R.Module=8]="Module",R[R.Property=9]="Property",R[R.Event=10]="Event",R[R.Operator=11]="Operator",R[R.Unit=12]="Unit",R[R.Value=13]="Value",R[R.Constant=14]="Constant",R[R.Enum=15]="Enum",R[R.EnumMember=16]="EnumMember",R[R.Keyword=17]="Keyword",R[R.Text=18]="Text",R[R.Color=19]="Color",R[R.File=20]="File",R[R.Reference=21]="Reference",R[R.Customcolor=22]="Customcolor",R[R.Folder=23]="Folder",R[R.TypeParameter=24]="TypeParameter",R[R.User=25]="User",R[R.Issue=26]="Issue",R[R.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(R){const D=new Map;D.set(0,T.Codicon.symbolMethod),D.set(1,T.Codicon.symbolFunction),D.set(2,T.Codicon.symbolConstructor),D.set(3,T.Codicon.symbolField),D.set(4,T.Codicon.symbolVariable),D.set(5,T.Codicon.symbolClass),D.set(6,T.Codicon.symbolStruct),D.set(7,T.Codicon.symbolInterface),D.set(8,T.Codicon.symbolModule),D.set(9,T.Codicon.symbolProperty),D.set(10,T.Codicon.symbolEvent),D.set(11,T.Codicon.symbolOperator),D.set(12,T.Codicon.symbolUnit),D.set(13,T.Codicon.symbolValue),D.set(15,T.Codicon.symbolEnum),D.set(14,T.Codicon.symbolConstant),D.set(15,T.Codicon.symbolEnum),D.set(16,T.Codicon.symbolEnumMember),D.set(17,T.Codicon.symbolKeyword),D.set(27,T.Codicon.symbolSnippet),D.set(18,T.Codicon.symbolText),D.set(19,T.Codicon.symbolColor),D.set(20,T.Codicon.symbolFile),D.set(21,T.Codicon.symbolReference),D.set(22,T.Codicon.symbolCustomColor),D.set(23,T.Codicon.symbolFolder),D.set(24,T.Codicon.symbolTypeParameter),D.set(25,T.Codicon.account),D.set(26,T.Codicon.issues);function $(G){let U=D.get(G);return U||(console.info("No codicon found for CompletionItemKind "+G),U=T.Codicon.symbolProperty),U}R.toIcon=$;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function q(G,U){let W=M.get(G);return typeof W=="undefined"&&!U&&(W=9),W}R.fromString=q})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(R){R[R.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(R){R[R.KeepWhitespace=1]="KeepWhitespace",R[R.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var o;(function(R){R[R.Invoke=0]="Invoke",R[R.TriggerCharacter=1]="TriggerCharacter",R[R.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(o=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var c;(function(R){R[R.Automatic=0]="Automatic",R[R.Explicit=1]="Explicit"})(c=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(R){R[R.Invoke=1]="Invoke",R[R.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(R){R[R.Invoke=1]="Invoke",R[R.TriggerCharacter=2]="TriggerCharacter",R[R.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var E;(function(R){R[R.Text=0]="Text",R[R.Read=1]="Read",R[R.Write=2]="Write"})(E=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(R){return R&&f.URI.isUri(R.uri)&&n.Range.isIRange(R.range)&&(n.Range.isIRange(R.originSelectionRange)||n.Range.isIRange(R.targetSelectionRange))}e.isLocationLink=s;var t;(function(R){R[R.File=0]="File",R[R.Module=1]="Module",R[R.Namespace=2]="Namespace",R[R.Package=3]="Package",R[R.Class=4]="Class",R[R.Method=5]="Method",R[R.Property=6]="Property",R[R.Field=7]="Field",R[R.Constructor=8]="Constructor",R[R.Enum=9]="Enum",R[R.Interface=10]="Interface",R[R.Function=11]="Function",R[R.Variable=12]="Variable",R[R.Constant=13]="Constant",R[R.String=14]="String",R[R.Number=15]="Number",R[R.Boolean=16]="Boolean",R[R.Array=17]="Array",R[R.Object=18]="Object",R[R.Key=19]="Key",R[R.Null=20]="Null",R[R.EnumMember=21]="EnumMember",R[R.Struct=22]="Struct",R[R.Event=23]="Event",R[R.Operator=24]="Operator",R[R.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(R){R[R.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(R){const D=new Map;D.set(0,T.Codicon.symbolFile),D.set(1,T.Codicon.symbolModule),D.set(2,T.Codicon.symbolNamespace),D.set(3,T.Codicon.symbolPackage),D.set(4,T.Codicon.symbolClass),D.set(5,T.Codicon.symbolMethod),D.set(6,T.Codicon.symbolProperty),D.set(7,T.Codicon.symbolField),D.set(8,T.Codicon.symbolConstructor),D.set(9,T.Codicon.symbolEnum),D.set(10,T.Codicon.symbolInterface),D.set(11,T.Codicon.symbolFunction),D.set(12,T.Codicon.symbolVariable),D.set(13,T.Codicon.symbolConstant),D.set(14,T.Codicon.symbolString),D.set(15,T.Codicon.symbolNumber),D.set(16,T.Codicon.symbolBoolean),D.set(17,T.Codicon.symbolArray),D.set(18,T.Codicon.symbolObject),D.set(19,T.Codicon.symbolKey),D.set(20,T.Codicon.symbolNull),D.set(21,T.Codicon.symbolEnumMember),D.set(22,T.Codicon.symbolStruct),D.set(23,T.Codicon.symbolEvent),D.set(24,T.Codicon.symbolOperator),D.set(25,T.Codicon.symbolTypeParameter);function $(M){let q=D.get(M);return q||(console.info("No codicon found for SymbolKind "+M),q=T.Codicon.symbolProperty),q}R.toIcon=$})(i=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(D){this.value=D}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var m;(function(R){function D($){return!$||typeof $!="object"?!1:typeof $.id=="string"&&typeof $.title=="string"}R.is=D})(m=e.Command||(e.Command={}));var h;(function(R){R[R.Collapsed=0]="Collapsed",R[R.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(R){R[R.Editing=0]="Editing",R[R.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var A;(function(R){R[R.Type=1]="Type",R[R.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var F;(function(R){R[R.None=0]="None",R[R.Option=1]="Option",R[R.Default=2]="Default",R[R.Preferred=3]="Preferred"})(F=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[154],ve([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(pe[155],ve([1,0,154]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,I=n*60,T=I*24,C=T*7,k=T*30,S=T*365;function L(y,v,b){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,f.localize)(0,null,L(new Date().getTime()+g*1e3,!1));if(g<30)return(0,f.localize)(1,null);let d;return g<n?(d=g,v?d===1?b?(0,f.localize)(2,null,d):(0,f.localize)(3,null,d):b?(0,f.localize)(4,null,d):(0,f.localize)(5,null,d):d===1?b?(0,f.localize)(6,null,d):(0,f.localize)(7,null,d):b?(0,f.localize)(8,null,d):(0,f.localize)(9,null,d)):g<I?(d=Math.floor(g/n),v?d===1?b?(0,f.localize)(10,null,d):(0,f.localize)(11,null,d):b?(0,f.localize)(12,null,d):(0,f.localize)(13,null,d):d===1?b?(0,f.localize)(14,null,d):(0,f.localize)(15,null,d):b?(0,f.localize)(16,null,d):(0,f.localize)(17,null,d)):g<T?(d=Math.floor(g/I),v?d===1?b?(0,f.localize)(18,null,d):(0,f.localize)(19,null,d):b?(0,f.localize)(20,null,d):(0,f.localize)(21,null,d):d===1?b?(0,f.localize)(22,null,d):(0,f.localize)(23,null,d):b?(0,f.localize)(24,null,d):(0,f.localize)(25,null,d)):g<C?(d=Math.floor(g/T),v?d===1?(0,f.localize)(26,null,d):(0,f.localize)(27,null,d):d===1?(0,f.localize)(28,null,d):(0,f.localize)(29,null,d)):g<k?(d=Math.floor(g/C),v?d===1?b?(0,f.localize)(30,null,d):(0,f.localize)(31,null,d):b?(0,f.localize)(32,null,d):(0,f.localize)(33,null,d):d===1?b?(0,f.localize)(34,null,d):(0,f.localize)(35,null,d):b?(0,f.localize)(36,null,d):(0,f.localize)(37,null,d)):g<S?(d=Math.floor(g/k),v?d===1?b?(0,f.localize)(38,null,d):(0,f.localize)(39,null,d):b?(0,f.localize)(40,null,d):(0,f.localize)(41,null,d):d===1?b?(0,f.localize)(42,null,d):(0,f.localize)(43,null,d):b?(0,f.localize)(44,null,d):(0,f.localize)(45,null,d)):(d=Math.floor(g/S),v?d===1?b?(0,f.localize)(46,null,d):(0,f.localize)(47,null,d):b?(0,f.localize)(48,null,d):(0,f.localize)(49,null,d):d===1?b?(0,f.localize)(50,null,d):(0,f.localize)(51,null,d):b?(0,f.localize)(52,null,d):(0,f.localize)(53,null,d))}e.fromNow=L;function O(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(pe[156],ve([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(pe[49],ve([1,0,18,13,156]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(y,v){return v&&(y.stack||y.stacktrace)?I.localize(0,null,k(y),C(y.stack)||C(y.stacktrace)):k(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?I.localize(1,null,y.message):y.message||I.localize(2,null)}function S(y=null,v=!1){if(!y)return I.localize(3,null);if(Array.isArray(y)){const b=f.coalesce(y),g=S(b[0],v);return b.length>1?I.localize(4,null,g,b.length):g}if(n.isString(y))return y;if(y.detail){const b=y.detail;if(b.error)return T(b.error,v);if(b.exception)return T(b.exception,v)}return y.stack?T(y,v):y.message?y.message:I.localize(5,null)}e.toErrorMessage=S;function L(y){const v=y;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=L;function O(y,v=Object.create(null)){const b=new Error(y);return v.actions&&(b.actions=v.actions),b}e.createErrorWithActions=O}),define(pe[157],ve([19,20]),function(te,e){return te.create("vs/base/node/processes",e)}),define(pe[112],ve([1,0,38,29,10,25,9,12,41,93,13,145,28,157]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function g(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(l,E){if(k.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};E&&(s.cwd=E);const t=f.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],s);return new Promise(r=>{t.once("error",i=>{r({success:!1,error:i})}),t.once("exit",(i,a)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?g(s.status):1})}else if(k.isLinux||k.isMacintosh)try{const s=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(t=>{f.execFile(s,[l.pid.toString()],{encoding:"utf8",shell:!0},(r,i,a)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function p(l){!l||(delete l.DEBUG,k.isMacintosh&&delete l.DYLD_LIBRARY_PATH,k.isLinux&&delete l.LD_PRELOAD)}e.removeDangerousEnvVariables=p;function P(l=S.env){return l.comspec||"cmd.exe"}e.getWindowsShell=P;class _{constructor(E,s,t,r){if(s!==void 0&&t!==void 0&&r!==void 0)this.cmd=E,this.args=s,this.shell=t,this.options=r;else{const i=E;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(S.env).forEach(a=>{i[a]=S.env[a]}),Object.keys(this.options.env).forEach(a=>{i[a]=this.options.env[a]}),this.options.env=i}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const s=E.lastIndexOf(C.sep);return s!==-1&&(E=E.substring(s+1)),_.WellKnowCommands[E]?E:"other"}start(E){return k.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(S.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(s=>{let t,r;const i=new Promise((a,m)=>{t=a,r=m});if(s){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=f.exec(a,this.options,(m,h,w)=>{this.childProcess=null;const A=m;A&&A.killed?r({killed:this.terminateRequested,stdout:h.toString(),stderr:w.toString()}):this.handleExec(t,E,m,h,w)})}else{let a=null;const m=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,t,E,r);const w={terminated:this.terminateRequested};O.isNumber(h)&&(w.cmdCode=h),t(w)};if(this.shell&&k.isWindows){const h=T.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let w=!1,A=!1;const F=[];let R=this.ensureQuotes(this.cmd);F.push(R.value),w=R.quoted,this.args&&this.args.forEach($=>{R=this.ensureQuotes($),F.push(R.value),A=A&&R.quoted});const D=["/s","/c"];w?A?D.push('"'+F.join(" ")+'"'):F.length>1?D.push('"'+F[0]+'" '+F.slice(1).join(" ")):D.push('"'+F[0]+'"'):D.push(F.join(" ")),a=f.spawn(P(),D,h)}else this.cmd&&(a=f.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(O.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",h=>{this.childProcess=null,r({terminated:this.terminateRequested,error:h})}),a.pid&&(this.childProcess.on("close",m),this.handleSpawn(a,t,E,r,!0)))}return i})}handleClose(E,s,t,r){}ensureQuotes(E){return _.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,d(E,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!k.isWindows)return E(!1);const s=f.spawn(P(),["/s","/c"]);s.on("error",t=>E(!0)),s.on("exit",t=>E(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class o extends _{constructor(E,s,t,r){super(E,s,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,s,t,r,i){[r,i].forEach((a,m)=>{const h=new y.LineDecoder;h.write(a).forEach(F=>{s({line:F,source:m===0?0:1})});const A=h.end();A&&s({line:A,source:m===0?0:1})}),E({terminated:this.terminateRequested,error:t})}handleSpawn(E,s,t,r,i){const a=new y.LineDecoder,m=new y.LineDecoder;E.stdout.on("data",h=>{a.write(h).forEach(A=>t({line:A,source:0}))}),E.stderr.on("data",h=>{m.write(h).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=m}handleClose(E,s,t,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&t({line:i,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=o;function c(l){let E=[],s=!1;const t=function(r){if(s){E.push(r);return}(!l.send(r,a=>{if(a&&console.error(a),s=!1,E.length>0){const m=E.slice(0);E=[],m.forEach(h=>t(h))}})||k.isWindows)&&(s=!0)};return{send:t}}e.createQueuedSender=c;var u;(function(l){async function E(s,t,r){if(C.isAbsolute(s))return s;if(t===void 0&&(t=S.cwd()),C.dirname(s)!=="."||(r===void 0&&O.isString(S.env.PATH)&&(r=S.env.PATH.split(C.delimiter)),r===void 0||r.length===0))return C.join(t,s);async function a(m){if(await v.Promises.exists(m)){let h;try{h=await v.Promises.stat(m)}catch(w){w.message.startsWith("EACCES")&&(h=await v.Promises.lstat(m))}return h?!h.isDirectory():!1}return!1}for(let m of r){let h;if(C.isAbsolute(m)?h=C.join(m,s):h=C.join(t,m,s),await a(h))return h;let w=h+".com";if(await a(w)||(w=h+".exe",await a(w)))return w}return C.join(t,s)}l.findExecutable=E})(u=e.win32||(e.win32={}))}),define(pe[158],ve([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(pe[113],ve([1,0,158,12,107,18,25,147]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class L{constructor(le){this._values=le}hasChanged(le){return this._values[le]}}e.ConfigurationChangedEvent=L;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class y{constructor(le,X,ge,Se){this.id=le,this.name=X,this.defaultValue=ge,this.schema=Se}applyUpdate(le,X){return b(le,X)}compute(le,X,ge){return ge}}class v{constructor(le,X){this.newValue=le,this.didChange=X}}e.ApplyUpdateResult=v;function b(ne,le){if(typeof ne!="object"||typeof le!="object"||!ne||!le)return new v(le,ne!==le);if(Array.isArray(ne)||Array.isArray(le)){const ge=Array.isArray(ne)&&Array.isArray(le)&&T.equals(ne,le);return new v(le,ge)}let X=!1;for(const ge in le)if(le.hasOwnProperty(ge)){const Se=b(ne[ge],le[ge]);Se.didChange&&(ne[ge]=Se.newValue,X=!0)}return new v(ne,X)}class g{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,X){return b(le,X)}validate(le){return this.defaultValue}}class d{constructor(le,X,ge,Se){this.id=le,this.name=X,this.defaultValue=ge,this.schema=Se}applyUpdate(le,X){return b(le,X)}validate(le){return typeof le=="undefined"?this.defaultValue:le}compute(le,X,ge){return ge}}function p(ne,le){return typeof ne=="undefined"?le:ne==="false"?!1:Boolean(ne)}e.boolean=p;class P extends d{constructor(le,X,ge,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=ge);super(le,X,ge,Se)}validate(le){return p(le,this.defaultValue)}}function _(ne,le,X,ge){if(typeof ne=="undefined")return le;let Se=parseInt(ne,10);return isNaN(Se)?le:(Se=Math.max(X,Se),Se=Math.min(ge,Se),Se|0)}e.clampedInt=_;class o extends d{constructor(le,X,ge,Se,Me,$e=void 0){typeof $e!="undefined"&&($e.type="integer",$e.default=ge,$e.minimum=Se,$e.maximum=Me);super(le,X,ge,$e);this.minimum=Se,this.maximum=Me}static clampedInt(le,X,ge,Se){return _(le,X,ge,Se)}validate(le){return o.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}class c extends d{constructor(le,X,ge,Se,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=ge);super(le,X,ge,Me);this.validationFn=Se}static clamp(le,X,ge){return le<X?X:le>ge?ge:le}static float(le,X){if(typeof le=="number")return le;if(typeof le=="undefined")return X;const ge=parseFloat(le);return isNaN(ge)?X:ge}validate(le){return this.validationFn(c.float(le,this.defaultValue))}}class u extends d{static string(le,X){return typeof le!="string"?X:le}constructor(le,X,ge,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=ge);super(le,X,ge,Se)}validate(le){return u.string(le,this.defaultValue)}}function l(ne,le,X){return typeof ne!="string"||X.indexOf(ne)===-1?le:ne}e.stringSet=l;class E extends d{constructor(le,X,ge,Se,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=Se,Me.default=ge);super(le,X,ge,Me);this._allowedValues=Se}validate(le){return l(le,this.defaultValue,this._allowedValues)}}class s extends y{constructor(le,X,ge,Se,Me,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Me,Ye.default=Se);super(le,X,ge,Ye);this._allowedValues=Me,this._convert=$e}validate(le){return typeof le!="string"?this.defaultValue:this._allowedValues.indexOf(le)===-1?this.defaultValue:this._convert(le)}}function t(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,X,ge){return ge===0?le.accessibilitySupport:ge}}class i extends y{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:f.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{insertSpace:p(X.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(X.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ne){switch(ne){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function A(ne){switch(ne){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class F extends g{constructor(){super(128)}compute(le,X,ge){const Se=["monaco-editor"];return X.get(33)&&Se.push(X.get(33)),le.extraEditorClassName&&Se.push(le.extraEditorClassName),X.get(66)==="default"?Se.push("mouse-default"):X.get(66)==="copy"&&Se.push("mouse-copy"),X.get(100)&&Se.push("showUnused"),X.get(126)&&Se.push("showDeprecated"),Se.join(" ")}}class R extends P{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(le,X,ge){return ge&&le.emptySelectionClipboard}}class D extends y{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:f.localize(16,null),included:n.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:f.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{cursorMoveOnType:p(X.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":l(X.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":l(X.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(X.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(X.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(X.loop,this.defaultValue.loop)}}}class $ extends y{constructor(){super(45,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(le){return typeof le=="undefined"?this.defaultValue:typeof le=="string"?le==="false"?$.OFF:le==="true"?$.ON:le:Boolean(le)?$.ON:$.OFF}}e.EditorFontLigatures=$,$.OFF='"liga" off, "calt" off',$.ON='"liga" on, "calt" on';class M extends g{constructor(){super(44)}compute(le,X,ge){return le.fontInfo}}class q extends d{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(le){const X=c.float(le,this.defaultValue);return X===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(X,6,100)}compute(le,X,ge){return le.fontInfo.fontSize}}class G extends y{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(le){return le==="normal"||le==="bold"?le:String(o.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}G.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],G.MINIMUM_VALUE=1,G.MAXIMUM_VALUE=1e3;class U extends y{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},X={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...X},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...X},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...X},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...X},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...X},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:ge,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:ge,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:ge,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:ge,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:ge,description:f.localize(38,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{multiple:l(X.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:X.multipleDefinitions??l(X.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:X.multipleTypeDefinitions??l(X.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:X.multipleDeclarations??l(X.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:X.multipleImplementations??l(X.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:X.multipleReferences??l(X.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(X.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(X.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(X.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(X.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(X.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends y{constructor(){const le={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:le.above,description:f.localize(42,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{enabled:p(X.enabled,this.defaultValue.enabled),delay:o.clampedInt(X.delay,this.defaultValue.delay,0,1e4),sticky:p(X.sticky,this.defaultValue.sticky),above:p(X.above,this.defaultValue.above)}}}var ee;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(ee=e.RenderMinimap||(e.RenderMinimap={}));class Z extends g{constructor(){super(131)}compute(le,X,ge){return Z.computeLayout(X,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio})}static computeContainedMinimapLineCount(le){const X=le.height/le.lineHeight,ge=le.scrollBeyondLastLine?X-1:0,Se=(le.viewLineCount+ge)/(le.pixelRatio*le.height),Me=Math.floor(le.viewLineCount/Se);return{typicalViewportLineCount:X,extraLinesBeyondLastLine:ge,desiredRatio:Se,minimapLineCount:Me}}static _computeMinimapLayout(le,X){const ge=le.outerWidth,Se=le.outerHeight,Me=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const $e=X.stableMinimapLayoutInput,Ye=$e&&le.outerHeight===$e.outerHeight&&le.lineHeight===$e.lineHeight&&le.typicalHalfwidthCharacterWidth===$e.typicalHalfwidthCharacterWidth&&le.pixelRatio===$e.pixelRatio&&le.scrollBeyondLastLine===$e.scrollBeyondLastLine&&le.minimap.enabled===$e.minimap.enabled&&le.minimap.side===$e.minimap.side&&le.minimap.size===$e.minimap.size&&le.minimap.showSlider===$e.minimap.showSlider&&le.minimap.renderCharacters===$e.minimap.renderCharacters&&le.minimap.maxColumn===$e.minimap.maxColumn&&le.minimap.scale===$e.minimap.scale&&le.verticalScrollbarWidth===$e.verticalScrollbarWidth&&le.isViewportWrapping===$e.isViewportWrapping,lt=le.lineHeight,vt=le.typicalHalfwidthCharacterWidth,wt=le.scrollBeyondLastLine,je=le.minimap.renderCharacters;let st=Me>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const _t=le.minimap.maxColumn,nt=le.minimap.size,ct=le.minimap.side,Rt=le.verticalScrollbarWidth,Tt=le.viewLineCount,yt=le.remainingWidth,mt=le.isViewportWrapping,Lt=je?2:3;let Mt=Math.floor(Me*Se);const Ft=Mt/Me;let xe=!1,_e=!1,ye=Lt*st,me=st/Me,ie=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:St,extraLinesBeyondLastLine:ot,desiredRatio:dt,minimapLineCount:ut}=Z.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:wt,height:Se,lineHeight:lt,pixelRatio:Me});if(Tt/ut>1)xe=!0,_e=!0,st=1,ye=1,me=st/Me;else{let pt=!1,kt=st+1;if(nt==="fit"){const Ut=Math.ceil((Tt+ot)*ye);mt&&Ye&&yt<=X.stableFitRemainingWidth?(pt=!0,kt=X.stableFitMaxMinimapScale):pt=Ut>Mt}if(nt==="fill"||pt){xe=!0;const Ut=st;ye=Math.min(lt*Me,Math.max(1,Math.floor(1/dt))),mt&&Ye&&yt<=X.stableFitRemainingWidth&&(kt=X.stableFitMaxMinimapScale),st=Math.min(kt,Math.max(1,Math.floor(ye/Lt))),st>Ut&&(ie=Math.min(2,st/Ut)),me=st/Me/ie,Mt=Math.ceil(Math.max(St,Tt+ot)*ye),mt?(X.stableMinimapLayoutInput=le,X.stableFitRemainingWidth=yt,X.stableFitMaxMinimapScale=st):(X.stableMinimapLayoutInput=null,X.stableFitRemainingWidth=0)}}}const Ie=Math.floor(_t*me),Ae=Math.min(Ie,Math.max(0,Math.floor((yt-Rt-2)*me/(vt+me)))+e.MINIMAP_GUTTER_WIDTH);let Ve=Math.floor(Me*Ae);const Xe=Ve/Me;Ve=Math.floor(Ve*ie);const ht=je?1:2,Et=ct==="left"?0:ge-Ae-Rt;return{renderMinimap:ht,minimapLeft:Et,minimapWidth:Ae,minimapHeightIsEditorHeight:xe,minimapIsSampling:_e,minimapScale:st,minimapLineHeight:ye,minimapCanvasInnerWidth:Ve,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Xe,minimapCanvasOuterHeight:Ft}}static computeLayout(le,X){const ge=X.outerWidth|0,Se=X.outerHeight|0,Me=X.lineHeight|0,$e=X.lineNumbersDigitCount|0,Ye=X.typicalHalfwidthCharacterWidth,lt=X.maxDigitWidth,vt=X.pixelRatio,wt=X.viewLineCount,je=le.get(123),st=je==="inherit"?le.get(122):je,_t=st==="inherit"?le.get(118):st,nt=le.get(121),ct=le.get(2),Rt=X.isDominatedByLongLines,Tt=le.get(50),yt=le.get(60).renderType!==0,mt=le.get(61),Lt=le.get(94),Mt=le.get(65),Ft=le.get(92),xe=Ft.verticalScrollbarSize,_e=Ft.verticalHasArrows,ye=Ft.arrowSize,me=Ft.horizontalScrollbarSize,ie=le.get(58),Ie=le.get(37);let Ae;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const Ht=parseFloat(ie.substr(0,ie.length-2));Ae=o.clampedInt(Ht*Ye,0,0,1e3)}else Ae=o.clampedInt(ie,0,0,1e3);Ie&&(Ae+=16);let Ve=0;if(yt){const Ht=Math.max($e,mt);Ve=Math.round(Ht*lt)}let Xe=0;Tt&&(Xe=Me);let ht=0,Et=ht+Xe,St=Et+Ve,ot=St+Ae;const dt=ge-Xe-Ve-Ae;let ut=!1,Nt=!1,pt=-1;ct!==2&&(st==="inherit"&&Rt?(ut=!0,Nt=!0):_t==="on"||_t==="bounded"?Nt=!0:_t==="wordWrapColumn"&&(pt=nt));const kt=Z._computeMinimapLayout({outerWidth:ge,outerHeight:Se,lineHeight:Me,typicalHalfwidthCharacterWidth:Ye,pixelRatio:vt,scrollBeyondLastLine:Lt,minimap:Mt,verticalScrollbarWidth:xe,viewLineCount:wt,remainingWidth:dt,isViewportWrapping:Nt},X.memory||new O);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ht+=kt.minimapWidth,Et+=kt.minimapWidth,St+=kt.minimapWidth,ot+=kt.minimapWidth);const Ut=dt-kt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-xe-2)/Ye)),Bt=_e?ye:0;return Nt&&(pt=Math.max(1,Ct),_t==="bounded"&&(pt=Math.min(pt,nt))),{width:ge,height:Se,glyphMarginLeft:ht,glyphMarginWidth:Xe,lineNumbersLeft:Et,lineNumbersWidth:Ve,decorationsLeft:St,decorationsWidth:Ae,contentLeft:ot,contentWidth:Ut,minimap:kt,viewportColumn:Ct,isWordWrapMinified:ut,isViewportWrapping:Nt,wrappingColumn:pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:me,overviewRuler:{top:Bt,width:xe,height:Se-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=Z;class V extends y{constructor(){const le={enabled:!0};super(57,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:f.localize(43,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:p(le.enabled,this.defaultValue.enabled)}}}class J extends y{constructor(){const le={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",le,{"editor.inlayHints.enabled":{type:"boolean",default:le.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:f.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{enabled:p(X.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(X.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(X.fontFamily,this.defaultValue.fontFamily)}}}class se extends c{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>c.clamp(le,0,150),{markdownDescription:f.localize(47,null)})}compute(le,X,ge){return le.fontInfo.lineHeight}}class ae extends y{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:le.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:f.localize(57,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{enabled:p(X.enabled,this.defaultValue.enabled),size:l(X.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(X.side,this.defaultValue.side,["right","left"]),showSlider:l(X.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(X.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(X.scale,1,1,3),maxColumn:o.clampedInt(X.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(ne){return ne==="ctrlCmd"?n.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends y{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{top:o.clampedInt(X.top,0,0,1e3),bottom:o.clampedInt(X.bottom,0,0,1e3)}}}class oe extends y{constructor(){const le={enabled:!0,cycle:!1};super(76,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:f.localize(61,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{enabled:p(X.enabled,this.defaultValue.enabled),cycle:p(X.cycle,this.defaultValue.cycle)}}}class de extends g{constructor(){super(129)}compute(le,X,ge){return le.pixelRatio}}class Ee extends y{constructor(){const le={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",le,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:le.strings,description:f.localize(62,null)},comments:{type:"boolean",default:le.comments,description:f.localize(63,null)},other:{type:"boolean",default:le.other,description:f.localize(64,null)}}}],default:le,description:f.localize(65,null)});this.defaultValue=le}validate(le){if(typeof le=="boolean")return le;if(le&&typeof le=="object"){const X=le,ge={other:p(X.other,this.defaultValue.other),comments:p(X.comments,this.defaultValue.comments),strings:p(X.strings,this.defaultValue.strings)};return ge.other&&ge.comments&&ge.strings?!0:!ge.other&&!ge.comments&&!ge.strings?!1:ge}return this.defaultValue}}var Re;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends y{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(le){let X=this.defaultValue.renderType,ge=this.defaultValue.renderFn;return typeof le!="undefined"&&(typeof le=="function"?(X=4,ge=le):le==="interval"?X=3:le==="relative"?X=2:le==="on"?X=1:X=0),{renderType:X,renderFn:ge}}}function be(ne){const le=ne.get(87);return le==="editable"?ne.get(81):le!=="on"}e.filterValidationDecorations=be;class we extends y{constructor(){const le=[],X={type:"number",description:f.localize(71,null)};super(91,"rulers",le,{type:"array",items:{anyOf:[X,{type:["object"],properties:{column:X,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:le,description:f.localize(73,null)})}validate(le){if(Array.isArray(le)){const X=[];for(let ge of le)if(typeof ge=="number")X.push({column:o.clampedInt(ge,0,0,1e4),color:null});else if(ge&&typeof ge=="object"){const Se=ge;X.push({column:o.clampedInt(Se.column,0,0,1e4),color:Se.color})}return X.sort((ge,Se)=>ge.column-Se.column),X}return this.defaultValue}}function H(ne,le){if(typeof ne!="string")return le;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends y{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:f.localize(84,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le,ge=o.clampedInt(X.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=o.clampedInt(X.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(X.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(X.vertical,this.defaultValue.vertical),horizontal:H(X.horizontal,this.defaultValue.horizontal),useShadows:p(X.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(X.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(X.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(X.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(X.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ge,horizontalSliderSize:o.clampedInt(X.horizontalSliderSize,ge,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:o.clampedInt(X.verticalSliderSize,Se,0,1e3),scrollByPage:p(X.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends y{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:f.localize(91,null)}})}applyUpdate(le,X){let ge=!1;X.allowedCharacters&&(C.equals(le.allowedCharacters,X.allowedCharacters)||(le={...le,allowedCharacters:X.allowedCharacters},ge=!0)),X.allowedLocales&&(C.equals(le.allowedLocales,X.allowedLocales)||(le={...le,allowedLocales:X.allowedLocales},ge=!0));const Se=super.applyUpdate(le,X);return ge?new v(Se.newValue,!0):Se}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{nonBasicASCII:he(X.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(X.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(X.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(X.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(X.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(le.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(le,X){if(typeof le!="object"||!le)return X;const ge={};for(const[Se,Me]of Object.entries(le))Me===!0&&(ge[Se]=!0);return ge}}class z extends y{constructor(){const le={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:f.localize(92,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{enabled:p(X.enabled,this.defaultValue.enabled),mode:l(X.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends y{constructor(){const le={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,description:f.localize(93,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:p(le.enabled,this.defaultValue.enabled)}}}class re extends y{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:le.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:le.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:le.highlightActiveIndentation,description:f.localize(104,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{bracketPairs:he(X.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(X.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(X.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(X.indentation,this.defaultValue.indentation),highlightActiveIndentation:p(X.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function he(ne,le,X){const ge=X.indexOf(ne);return ge===-1?le:X[ge]}class Ce extends y{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:le.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const X=le;return{insertMode:l(X.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(X.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(X.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(X.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(X.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(X.showIcons,this.defaultValue.showIcons),showStatusBar:p(X.showStatusBar,this.defaultValue.showStatusBar),preview:p(X.preview,this.defaultValue.preview),previewMode:l(X.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(X.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(X.showMethods,this.defaultValue.showMethods),showFunctions:p(X.showFunctions,this.defaultValue.showFunctions),showConstructors:p(X.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(X.showDeprecated,this.defaultValue.showDeprecated),showFields:p(X.showFields,this.defaultValue.showFields),showVariables:p(X.showVariables,this.defaultValue.showVariables),showClasses:p(X.showClasses,this.defaultValue.showClasses),showStructs:p(X.showStructs,this.defaultValue.showStructs),showInterfaces:p(X.showInterfaces,this.defaultValue.showInterfaces),showModules:p(X.showModules,this.defaultValue.showModules),showProperties:p(X.showProperties,this.defaultValue.showProperties),showEvents:p(X.showEvents,this.defaultValue.showEvents),showOperators:p(X.showOperators,this.defaultValue.showOperators),showUnits:p(X.showUnits,this.defaultValue.showUnits),showValues:p(X.showValues,this.defaultValue.showValues),showConstants:p(X.showConstants,this.defaultValue.showConstants),showEnums:p(X.showEnums,this.defaultValue.showEnums),showEnumMembers:p(X.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(X.showKeywords,this.defaultValue.showKeywords),showWords:p(X.showWords,this.defaultValue.showWords),showColors:p(X.showColors,this.defaultValue.showColors),showFiles:p(X.showFiles,this.defaultValue.showFiles),showReferences:p(X.showReferences,this.defaultValue.showReferences),showFolders:p(X.showFolders,this.defaultValue.showFolders),showTypeParameters:p(X.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(X.showSnippets,this.defaultValue.showSnippets),showUsers:p(X.showUsers,this.defaultValue.showUsers),showIssues:p(X.showIssues,this.defaultValue.showIssues)}}}class Te extends y{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends g{constructor(){super(130)}compute(le,X,ge){return X.get(81)?!0:le.tabFocusMode}}var ze;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(ze=e.WrappingIndent||(e.WrappingIndent={}));function qe(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends g{constructor(){super(132)}compute(le,X,ge){const Se=X.get(131);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:n.isMacintosh?Je:n.isLinux?et:Ue,fontWeight:"normal",fontSize:n.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var it;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new P(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:Le(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new o(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:Le(new u(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:Le(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:Le(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:Le(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:Le(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:Le(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:Le(new P(10,"automaticLayout",!1)),autoSurround:Le(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:Le(new j),bracketPairGuides:Le(new re),stickyTabStops:Le(new P(104,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:Le(new P(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:Le(new u(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:Le(new o(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:Le(new P(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:Le(new P(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:Le(new i),contextmenu:Le(new P(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new P(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:Le(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:Le(new P(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:Le(new s(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:f.localize(182,null)})),cursorSurroundingLines:Le(new o(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:Le(new E(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:Le(new o(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:Le(new P(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new P(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new P(30,"domReadOnly",!1)),dragAndDrop:Le(new P(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:Le(new R),extraEditorClassName:Le(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:f.localize(189,null)})),find:Le(new D),fixedOverflowWidgets:Le(new P(36,"fixedOverflowWidgets",!1)),folding:Le(new P(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:Le(new E(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:Le(new P(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:Le(new P(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),foldingMaximumRegions:Le(new o(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(196,null)})),unfoldOnClickAfterEndOfLine:Le(new P(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(197,null)})),fontFamily:Le(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(198,null)})),fontInfo:Le(new M),fontLigatures2:Le(new $),fontSize:Le(new q),fontWeight:Le(new G),formatOnPaste:Le(new P(48,"formatOnPaste",!1,{description:f.localize(199,null)})),formatOnType:Le(new P(49,"formatOnType",!1,{description:f.localize(200,null)})),glyphMargin:Le(new P(50,"glyphMargin",!0,{description:f.localize(201,null)})),gotoLocation:Le(new U),hideCursorInOverviewRuler:Le(new P(52,"hideCursorInOverviewRuler",!1,{description:f.localize(202,null)})),hover:Le(new W),inDiffEditor:Le(new P(54,"inDiffEditor",!1)),letterSpacing:Le(new c(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:f.localize(203,null)})),lightbulb:Le(new V),lineDecorationsWidth:Le(new d(58,"lineDecorationsWidth",10)),lineHeight:Le(new se),lineNumbers:Le(new Ne),lineNumbersMinChars:Le(new o(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new P(62,"linkedEditing",!1,{description:f.localize(204,null)})),links:Le(new P(63,"links",!0,{description:f.localize(205,null)})),matchBrackets:Le(new E(64,"matchBrackets","always",["always","near","never"],{description:f.localize(206,null)})),minimap:Le(new ae),mouseStyle:Le(new E(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:f.localize(207,null)})),mouseWheelZoom:Le(new P(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(208,null)})),multiCursorMergeOverlapping:Le(new P(69,"multiCursorMergeOverlapping",!0,{description:f.localize(209,null)})),multiCursorModifier:Le(new s(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[f.localize(210,null),f.localize(211,null)],markdownDescription:f.localize(212,null)})),multiCursorPaste:Le(new E(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(213,null),f.localize(214,null)],markdownDescription:f.localize(215,null)})),occurrencesHighlight:Le(new P(72,"occurrencesHighlight",!0,{description:f.localize(216,null)})),overviewRulerBorder:Le(new P(73,"overviewRulerBorder",!0,{description:f.localize(217,null)})),overviewRulerLanes:Le(new o(74,"overviewRulerLanes",3,0,3)),padding:Le(new Y),parameterHints:Le(new oe),peekWidgetDefaultFocus:Le(new E(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(218,null),f.localize(219,null)],description:f.localize(220,null)})),definitionLinkOpensInPeek:Le(new P(78,"definitionLinkOpensInPeek",!1,{description:f.localize(221,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new o(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(222,null)})),readOnly:Le(new P(81,"readOnly",!1)),renameOnType:Le(new P(82,"renameOnType",!1,{description:f.localize(223,null),markdownDeprecationMessage:f.localize(224,null)})),renderControlCharacters:Le(new P(83,"renderControlCharacters",!0,{description:f.localize(225,null),restricted:!0})),renderFinalNewline:Le(new P(84,"renderFinalNewline",!0,{description:f.localize(226,null)})),renderLineHighlight:Le(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(227,null)],description:f.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Le(new P(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(229,null)})),renderValidationDecorations:Le(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(230,null),f.localize(231,null),f.localize(232,null),""],description:f.localize(233,null)})),revealHorizontalRightPadding:Le(new o(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Le(new P(90,"roundedSelection",!0,{description:f.localize(234,null)})),rulers:Le(new we),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new o(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(235,null)})),scrollBeyondLastLine:Le(new P(94,"scrollBeyondLastLine",!0,{description:f.localize(236,null)})),scrollPredominantAxis:Le(new P(95,"scrollPredominantAxis",!0,{description:f.localize(237,null)})),selectionClipboard:Le(new P(96,"selectionClipboard",!0,{description:f.localize(238,null),included:n.isLinux})),selectionHighlight:Le(new P(97,"selectionHighlight",!0,{description:f.localize(239,null)})),selectOnLineNumbers:Le(new P(98,"selectOnLineNumbers",!0)),showFoldingControls:Le(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),showUnused:Le(new P(100,"showUnused",!0,{description:f.localize(243,null)})),showDeprecated:Le(new P(126,"showDeprecated",!0,{description:f.localize(244,null)})),inlayHints:Le(new J),snippetSuggestions:Le(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null),f.localize(248,null)],description:f.localize(249,null)})),smartSelect:Le(new Te),smoothScrolling:Le(new P(103,"smoothScrolling",!1,{description:f.localize(250,null)})),stopRenderingLineAfter:Le(new o(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ce),inlineSuggest:Le(new z),suggestFontSize:Le(new o(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestLineHeight:Le(new o(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(252,null)})),suggestOnTriggerCharacters:Le(new P(109,"suggestOnTriggerCharacters",!0,{description:f.localize(253,null)})),suggestSelection:Le(new E(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(254,null),f.localize(255,null),f.localize(256,null)],description:f.localize(257,null)})),tabCompletion:Le(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabIndex:Le(new o(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new N),unusualLineTerminators:Le(new E(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),useShadowDOM:Le(new P(115,"useShadowDOM",!0)),useTabStops:Le(new P(116,"useTabStops",!0,{description:f.localize(266,null)})),wordSeparators:Le(new u(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(267,null)})),wordWrap:Le(new E(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(268,null),f.localize(269,null),f.localize(270,null),f.localize(271,null)],description:f.localize(272,null)})),wordWrapBreakAfterCharacters:Le(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new o(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(273,null)})),wordWrapOverride1:Le(new E(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new E(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new s(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],qe,{enumDescriptions:[f.localize(274,null),f.localize(275,null),f.localize(276,null),f.localize(277,null)],description:f.localize(278,null)})),wrappingStrategy:Le(new E(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),editorClassName:Le(new F),pixelRatio:Le(new de),tabFocusMode:Le(new We),layoutInfo:Le(new Z),wrappingInfo:Le(new He)}}),define(pe[159],ve([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[160],ve([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[161],ve([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[162],ve([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[163],ve([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(pe[164],ve([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(pe[165],ve([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(pe[166],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[167],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[168],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[169],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[170],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[171],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[172],ve([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[173],ve([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[174],ve([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[175],ve([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(pe[176],ve([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[177],ve([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(pe[178],ve([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[179],ve([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[180],ve([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[181],ve([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(pe[182],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var f;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var n;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var I;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(I=e.EditorOpenSource||(e.EditorOpenSource={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(pe[183],ve([1,0,161]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function T(v){return v=v.trim(),v==="*"||n.test(v)}e.isValidVersionStr=T;function C(v){if(!T(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=v.match(n);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=C;function k(v){if(!v)return null;let b=v.majorBase,g=v.majorMustEqual,d=v.minorBase,p=v.minorMustEqual,P=v.patchBase,_=v.patchMustEqual;v.hasCaret&&(b===0||(p=!1),_=!1);let o=0;if(v.preRelease){const c=I.exec(v.preRelease);if(c){const[,u,l,E]=c;o=Date.UTC(Number(u),Number(l)-1,Number(E))}}return{majorBase:b,majorMustEqual:g,minorBase:d,minorMustEqual:p,patchBase:P,patchMustEqual:_,isMinimum:v.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function S(v,b,g){let d;typeof v=="string"?d=k(C(v)):d=v;let p;b instanceof Date?p=b.getTime():typeof b=="string"&&(p=new Date(b).getTime());let P;if(typeof g=="string"?P=k(C(g)):P=g,!d||!P)return!1;let _=d.majorBase,o=d.minorBase,c=d.patchBase,u=P.majorBase,l=P.minorBase,E=P.patchBase,s=P.notBefore,t=P.majorMustEqual,r=P.minorMustEqual,i=P.patchMustEqual;return P.isMinimum?_>u?!0:_<u?!1:o>l?!0:o<l||p&&p<s?!1:c>=E:(_===1&&u===0&&(!t||!r||!i)&&(u=1,l=0,E=0,t=!0,r=!1,i=!1),_<u?!1:_>u?!t:o<l?!1:o>l?!r:c<E?!1:c>E?!i:!(p&&p<s))}e.isValidVersion=S;function L(v,b,g,d){return g.isBuiltin||typeof g.main=="undefined"?!0:y(v,b,g.engines.vscode,d)}e.isValidExtensionVersion=L;function O(v,b,g){return v==="*"||y(b,g,v)}e.isEngineValid=O;function y(v,b,g,d=[]){let p=k(C(g));if(!p)return d.push(f.localize(0,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return d.push(f.localize(1,null,g)),!1}else if(!p.majorMustEqual)return d.push(f.localize(2,null,g)),!1;return S(v,b,p)?!0:(d.push(f.localize(3,null,v,g)),!1)}}),define(pe[114],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,T=[],C=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=f}),define(pe[79],ve([1,0,114]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function I(C,k,S){k instanceof f.SyncDescriptor||(k=new f.SyncDescriptor(k,[],S)),n.push([C,k])}e.registerSingleton=I;function T(){return n}e.getSingletonServiceDescriptors=T}),define(pe[184],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=f;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let C of this._nodes.values())C.outgoing.size===0&&T.push(C);return T}insertEdge(T,C){const k=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(C);k.outgoing.set(this._hashFn(C),S),S.incoming.set(this._hashFn(T),k)}removeNode(T){const C=this._hashFn(T);this._nodes.delete(C);for(let k of this._nodes.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(T){const C=this._hashFn(T);let k=this._nodes.get(C);return k||(k=new f(T),this._nodes.set(C,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[C,k]of this._nodes)T.push(`${C}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,C]of this._nodes){const k=new Set([T]),S=this._findCycle(C,k);if(S)return S}}_findCycle(T,C){for(let[k,S]of T.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const L=this._findCycle(S,C);if(L)return L;C.delete(k)}}}e.Graph=n}),define(pe[4],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function n(C,k,S){k[f.DI_TARGET]===k?k[f.DI_DEPENDENCIES].push({id:C,index:S}):(k[f.DI_DEPENDENCIES]=[{id:C,index:S}],k[f.DI_TARGET]=k)}function I(C){if(f.serviceIds.has(C))return f.serviceIds.get(C);const k=function(S,L,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(k,S,O)};return k.toString=()=>C,f.serviceIds.set(C,k),k}e.createDecorator=I;function T(C){return C}e.refineServiceDecorator=T}),define(pe[115],ve([1,0,13,2,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=T;function C(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||f.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function L(p,P){const _=Object.create(null);for(let o in p)O(_,o,p[o],P);return _}e.toValuesTree=L;function O(p,P,_,o){const c=P.split("."),u=c.pop();let l=p;for(let E=0;E<c.length;E++){let s=c[E],t=l[s];switch(typeof t){case"undefined":t=l[s]=Object.create(null);break;case"object":break;default:o(`Ignoring ${P} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(t)}`);return}l=t}if(typeof l=="object"&&l!==null)try{l[u]=_}catch{o(`Ignoring ${P} as ${c.join(".")} is ${JSON.stringify(l)}`)}else o(`Ignoring ${P} as ${c.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=O;function y(p,P){const _=P.split(".");v(p,_)}e.removeFromValueTree=y;function v(p,P){const _=P.shift();if(P.length===0){delete p[_];return}if(Object.keys(p).indexOf(_)!==-1){const o=p[_];typeof o=="object"&&!Array.isArray(o)&&(v(o,P),Object.keys(o).length===0&&delete p[_])}}function b(p,P,_){function o(l,E){let s=l;for(const t of E){if(typeof s!="object"||s===null)return;s=s[t]}return s}const c=P.split("."),u=o(p,c);return typeof u=="undefined"?_:u}e.getConfigurationValue=b;function g(p,P,_){Object.keys(P).forEach(o=>{o!=="__proto__"&&(o in p?f.isObject(p[o])&&f.isObject(P[o])?g(p[o],P[o],_):_&&(p[o]=P[o]):p[o]=P[o])})}e.merge=g;function d(p,P,_){const o=p.inspect(P),c=p.inspect(_);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:o.defaultValue}e.getMigratedSettingValue=d}),define(pe[61],ve([1,0,12,8,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",f.isMacintosh),T.set("isLinux",f.isLinux),T.set("isWindows",f.isWindows),T.set("isWeb",f.isWeb),T.set("isMacNative",f.isMacintosh&&!f.isWeb),T.set("isEdge",f.isEdge),T.set("isFirefox",f.isFirefox),T.set("isChrome",f.isChrome),T.set("isSafari",f.isSafari);const C=Object.prototype.hasOwnProperty;var k;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return y.INSTANCE}static true(){return v.INSTANCE}static has(D){return b.create(D)}static equals(D,$){return g.create(D,$)}static notEquals(D,$){return P.create(D,$)}static regex(D,$){return s.create(D,$)}static in(D,$){return d.create(D,$)}static not(D){return _.create(D)}static and(...D){return i.create(D,null)}static or(...D){return a.create(D,null,!0)}static greater(D,$){return c.create(D,$)}static greaterEquals(D,$){return u.create(D,$)}static smaller(D,$){return l.create(D,$)}static smallerEquals(D,$){return E.create(D,$)}static deserialize(D,$=!1){if(!!D)return this._deserializeOrExpression(D,$)}static _deserializeOrExpression(D,$){let M=D.split("||");return a.create(M.map(q=>this._deserializeAndExpression(q,$)),null,!0)}static _deserializeAndExpression(D,$){let M=D.split("&&");return i.create(M.map(q=>this._deserializeOne(q,$)),null)}static _deserializeOne(D,$){if(D=D.trim(),D.indexOf("!=")>=0){let M=D.split("!=");return P.create(M[0].trim(),this._deserializeValue(M[1],$))}if(D.indexOf("==")>=0){let M=D.split("==");return g.create(M[0].trim(),this._deserializeValue(M[1],$))}if(D.indexOf("=~")>=0){let M=D.split("=~");return s.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(D.indexOf(" in ")>=0){let M=D.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const M=D.split(">=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const M=D.split(">");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const M=D.split("<=");return E.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const M=D.split("<");return l.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(D)?_.create(D.substr(1).trim()):b.create(D)}static _deserializeValue(D,$){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let M=/^'([^']*)'$/.exec(D);return M?M[1].trim():D}static _deserializeRegexValue(D,$){if((0,n.isFalsyOrWhitespace)(D)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=D.indexOf("/"),q=D.lastIndexOf("/");if(M===q||M<0){if($)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let G=D.slice(M+1,q),U=D[q+1]==="i"?"i":"";try{return new RegExp(G,U)}catch(W){if($)throw new Error(`bad regexp-value '${D}', parse error: ${W}`);return console.warn(`bad regexp-value '${D}', parse error: ${W}`),null}}}e.ContextKeyExpr=S;function L(R,D){const $=R?R.substituteConstants():void 0,M=D?D.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=L;function O(R,D){return R.cmp(D)}class y{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class v{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class b{constructor(D,$){this.key=D,this.negated=$,this.type=2}static create(D,$=null){const M=T.get(D);return typeof M=="boolean"?M?v.INSTANCE:y.INSTANCE:new b(D,$)}cmp(D){return D.type!==this.type?this.type-D.type:h(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?v.INSTANCE:y.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class g{constructor(D,$,M){this.key=D,this.value=$,this.negated=M,this.type=4}static create(D,$,M=null){if(typeof $=="boolean")return $?b.create(D,M):_.create(D,M);const q=T.get(D);return typeof q=="boolean"?$===(q?"true":"false")?v.INSTANCE:y.INSTANCE:new g(D,$,M)}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const $=D?"true":"false";return this.value===$?v.INSTANCE:y.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class d{constructor(D,$){this.key=D,this.valueKey=$,this.type=10,this.negated=null}static create(D,$){return new d(D,$)}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const $=D.getValue(this.valueKey),M=D.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?C.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=d;class p{constructor(D){this._actual=D,this.type=11}static create(D){return new p(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new p(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class P{constructor(D,$,M){this.key=D,this.value=$,this.negated=M,this.type=5}static create(D,$,M=null){if(typeof $=="boolean")return $?_.create(D,M):b.create(D,M);const q=T.get(D);return typeof q=="boolean"?$===(q?"true":"false")?y.INSTANCE:v.INSTANCE:new P(D,$,M)}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const $=D?"true":"false";return this.value===$?y.INSTANCE:v.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class _{constructor(D,$){this.key=D,this.negated=$,this.type=3}static create(D,$=null){const M=T.get(D);return typeof M=="boolean"?M?y.INSTANCE:v.INSTANCE:new _(D,$)}cmp(D){return D.type!==this.type?this.type-D.type:h(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?y.INSTANCE:v.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function o(R,D){if(typeof R=="string"){const $=parseFloat(R);isNaN($)||(R=$)}return typeof R=="string"||typeof R=="number"?D(R):y.INSTANCE}class c{constructor(D,$,M){this.key=D,this.value=$,this.negated=M,this.type=12}static create(D,$,M=null){return o($,q=>new c(D,q,M))}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class u{constructor(D,$,M){this.key=D,this.value=$,this.negated=M,this.type=13}static create(D,$,M=null){return o($,q=>new u(D,q,M))}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class l{constructor(D,$,M){this.key=D,this.value=$,this.negated=M,this.type=14}static create(D,$,M=null){return o($,q=>new l(D,q,M))}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=l;class E{constructor(D,$,M){this.key=D,this.value=$,this.negated=M,this.type=15}static create(D,$,M=null){return o($,q=>new E(D,q,M))}cmp(D){return D.type!==this.type?this.type-D.type:w(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=E;class s{constructor(D,$){this.key=D,this.regexp=$,this.type=7,this.negated=null}static create(D,$){return new s(D,$)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const $=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return $<M?-1:$>M?1:0}equals(D){if(D.type===this.type){const $=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return this.key===D.key&&$===M}return!1}substituteConstants(){return this}evaluate(D){let $=D.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class t{constructor(D){this._actual=D,this.type=8}static create(D){return new t(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new t(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function r(R){let D=null;for(let $=0,M=R.length;$<M;$++){const q=R[$].substituteConstants();if(R[$]!==q&&D===null){D=[];for(let G=0;G<$;G++)D[G]=R[G]}D!==null&&(D[$]=q)}return D===null?R:D}class i{constructor(D,$){this.expr=D,this.negated=$,this.type=6}static create(D,$){return i._normalizeArr(D,$)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const q=O(this.expr[$],D.expr[$]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(D.expr[$]))return!1;return!0}return!1}substituteConstants(){const D=r(this.expr);return D===this.expr?this:i.create(D,this.negated)}evaluate(D){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(D))return!1;return!0}static _normalizeArr(D,$){const M=[];let q=!1;for(const G of D)if(!!G){if(G.type===1){q=!0;continue}if(G.type===0)return y.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&q)return v.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(O);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const U=M.pop(),W=M.length===0,ee=a.create(G.expr.map(Z=>i.create([Z,U],null)),null,W);ee&&(M.push(ee),M.sort(O))}return M.length===1?M[0]:new i(M,$)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let $ of this.expr)D.push(...$.keys());return D}map(D){return new i(this.expr.map($=>$.map(D)),null)}negate(){if(!this.negated){const D=[];for(let $ of this.expr)D.push($.negate());this.negated=a.create(D,this,!0)}return this.negated}}class a{constructor(D,$){this.expr=D,this.negated=$,this.type=9}static create(D,$,M){return a._normalizeArr(D,$,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const q=O(this.expr[$],D.expr[$]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(D.expr[$]))return!1;return!0}return!1}substituteConstants(){const D=r(this.expr);return D===this.expr?this:a.create(D,this.negated,!1)}evaluate(D){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(D))return!0;return!1}static _normalizeArr(D,$,M){let q=[],G=!1;if(D){for(let U=0,W=D.length;U<W;U++){const ee=D[U];if(!!ee){if(ee.type===0){G=!0;continue}if(ee.type===1)return v.INSTANCE;if(ee.type===9){q=q.concat(ee.expr);continue}q.push(ee)}}if(q.length===0&&G)return y.INSTANCE;q.sort(O)}if(q.length!==0){if(q.length===1)return q[0];for(let U=1;U<q.length;U++)q[U-1].equals(q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0];if(M){for(let U=0;U<q.length;U++)for(let W=U+1;W<q.length;W++)A(q[U],q[W])&&(q.splice(W,1),W--);if(q.length===1)return q[0]}return new a(q,$)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let $ of this.expr)D.push(...$.keys());return D}map(D){return new a(this.expr.map($=>$.map(D)),null)}negate(){if(!this.negated){let D=[];for(let $ of this.expr)D.push($.negate());for(;D.length>1;){const $=D.shift(),M=D.shift(),q=[];for(const U of F($))for(const W of F(M))q.push(i.create([U,W],null));const G=D.length===0;D.unshift(a.create(q,null,G))}this.negated=D[0]}return this.negated}}class m extends b{constructor(D,$,M){super(D,null);this._defaultValue=$,typeof M=="object"?m._info.push({...M,key:D}):M!==!0&&m._info.push({key:D,description:M,type:$!=null?typeof $:void 0})}static all(){return m._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return g.create(this.key,D)}notEqualsTo(D){return P.create(this.key,D)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(R,D){return R<D?-1:R>D?1:0}function w(R,D,$,M){return R<$?-1:R>$?1:D<M?-1:D>M?1:0}function A(R,D){if(D.type===6&&R.type!==9&&R.type!==6){for(const q of D.expr)if(R.equals(q))return!0}const $=R.negate(),M=F($).concat(F(D));M.sort(O);for(let q=0;q<M.length;q++){const U=M[q].negate();for(let W=q+1;W<M.length;W++){const ee=M[W];if(U.equals(ee))return!0}}return!1}e.implies=A;function F(R){return R.type===9?R.expr:[R]}}),define(pe[185],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[186],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(pe[187],ve([1,0,38,10,9,12,93,28,112,162,186]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=L.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends v{openTerminal(c,u){return this.spawnTerminal(f,c,S.getWindowsShell(),u)}spawnTerminal(c,u,l,E){const s=u.windowsExec||b.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const t=I.basename(s).toLowerCase();if(t==="cmder"||t==="cmder.exe")return c.spawn(s,E?[E]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(t==="wt"||t==="wt.exe")&&r.push("-d ."),new Promise((i,a)=>{const m=p(process),h=c.spawn(l,r,{cwd:E,env:m});h.on("error",a),h.on("exit",()=>i())})}runInTerminal(c,u,l,E,s){const t="windowsExec"in s&&s.windowsExec?s.windowsExec:b.getDefaultTerminalWindows();return new Promise((r,i)=>{const a=`"${u} - ${y}"`,m=`""${l.join('" "')}" & pause"`,h=["/c","start",a,"/wait",t,"/c",m],w=Object.assign({},p(process),E);Object.keys(w).filter(R=>w[R]===null).forEach(R=>delete w[R]);const A={cwd:u,env:w,windowsVerbatimArguments:!0};f.spawn(b.CMD,h,A).on("error",R=>{i(P(R))}),r(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class g extends v{openTerminal(c,u){return this.spawnTerminal(f,c,u)}runInTerminal(c,u,l,E,s){const t=s.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{if(t===O.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const a=t===O.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,te).fsPath,"-t",c||y,"-w",u];for(let F of l)h.push("-a"),h.push(F);if(E){const F=Object.assign({},p(process),E);for(let R in F){const D=F[R];D===null?(h.push("-u"),h.push(R)):(h.push("-e"),h.push(`${R}=${D}`))}}let w="";const A=f.spawn(g.OSASCRIPT,h);A.on("error",F=>{i(P(F))}),A.stderr.on("data",F=>{w+=F.toString()}),A.on("exit",F=>{if(F===0)r(void 0);else if(w){const R=w.split(`
`,1);i(new Error(R[0]))}else i(new Error(L.localize(1,null,a,F)))})}else i(new Error(L.localize(2,null,t)))})}spawnTerminal(c,u,l){const E=u.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((s,t)=>{const r=["-a",E];l&&r.push(l);const i=p(process),a=c.spawn("/usr/bin/open",r,{cwd:l,env:i});a.on("error",t),a.on("exit",()=>s())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class d extends v{openTerminal(c,u){return this.spawnTerminal(f,c,u)}runInTerminal(c,u,l,E,s){const t=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{let a=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const h=`${_(l)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;a.push(`''${h}''`);const w=Object.assign({},p(process),E);Object.keys(w).filter(D=>w[D]===null).forEach(D=>delete w[D]);const A={cwd:u,env:w};let F="";const R=f.spawn(m,a,A);R.on("error",D=>{i(P(D))}),R.stderr.on("data",D=>{F+=D.toString()}),R.on("exit",D=>{if(D===0)r(void 0);else if(F){const $=F.split(`
`,1);i(new Error($[0]))}else i(new Error(L.localize(4,null,m,D)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!T.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await k.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{c?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,u,l){const E=u.linuxExec?Promise.resolve(u.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,t)=>{E.then(r=>{const i=p(process),a=c.spawn(r,[],{cwd:l,env:i});a.on("error",t),a.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=L.localize(3,null);function p(o){const c={...o.env};return(0,C.sanitizeProcessEnvironment)(c),c}function P(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(L.localize(5,null,o.path)):o}function _(o){let c="";for(let u of o)u.indexOf(" ")>=0?c+='"'+u+'"':c+=u,c+=" ";return c}}),define(pe[42],ve([1,0,15,24,9,8,13,2,163,4]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,L.createDecorator)("fileService");function O(U){return U.create===!0}e.isFileOpenForWriteOptions=O;var y;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var v;(function(U){U[U.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var b;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=g;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function p(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;function _(U){return g(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=_;var o;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(o=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(W,ee){super(W);this.code=ee}}e.FileSystemProviderError=c;function u(U,W){const ee=new c(U.toString(),W);return E(ee,W),ee}e.createFileSystemProviderError=u;function l(U){return U||u((0,S.localize)(0,null),o.Unknown)}e.ensureFileSystemProviderError=l;function E(U,W){return U.name=W?`${W} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=E;function s(U){if(!U)return o.Unknown;if(U instanceof c)return U.code;const W=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!W)return o.Unknown;switch(W[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileExceedsMemoryLimit:return o.FileExceedsMemoryLimit;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.toFileSystemProviderErrorCode=s;function t(U){if(U instanceof w)return U.fileOperationResult;switch(s(U)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 10;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileExceedsMemoryLimit:return 9;case o.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(W,ee,Z){this.resource=W,this.operation=ee,this.target=Z}isOperation(W){return this.operation===W}}e.FileOperationEvent=i;var a;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class m{constructor(W,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const Z=new Map;for(const V of W){const J=Z.get(V.type);switch(J?J.push([V.resource,V]):Z.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,J]of Z)switch(V){case 1:this.added=n.TernarySearchTree.forUris(()=>ee),this.added.fill(J);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>ee),this.updated.fill(J);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>ee),this.deleted.fill(J);break}}contains(W,...ee){return this.doContains(W,{includeChildren:!1},...ee)}affects(W,...ee){return this.doContains(W,{includeChildren:!0},...ee)}doContains(W,ee,...Z){if(!W)return!1;const V=Z.length>0;return!!((!V||Z.includes(1))&&(this.added?.get(W)||ee.includeChildren&&this.added?.findSuperstr(W))||(!V||Z.includes(0))&&(this.updated?.get(W)||ee.includeChildren&&this.updated?.findSuperstr(W))||(!V||Z.includes(2))&&(this.deleted?.findSubstr(W)||ee.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function h(U,W,ee){return!U||!W||U===W||W.length>U.length?!1:(W.charAt(W.length-1)!==I.sep&&(W+=I.sep),ee?(0,T.startsWithIgnoreCase)(U,W):U.indexOf(W)===0)}e.isParent=h;class w extends f.ErrorNoTelemetry{constructor(W,ee,Z){super(W);this.fileOperationResult=ee,this.options=Z}}e.FileOperationError=w;class A extends w{constructor(W,ee,Z){super(W,2,Z);this.stat=ee}}e.NotModifiedSinceFileOperationError=A;var F;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=D;async function $(U,W){if(!W.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(ee=>{const Z=W.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===U.scheme&&V.added&&(Z.dispose(),ee())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(W){return(0,C.isNumber)(W)||(W=0),W<M.KB?(0,S.localize)(1,null,W.toFixed(0)):W<M.MB?(0,S.localize)(2,null,(W/M.KB).toFixed(2)):W<M.GB?(0,S.localize)(3,null,(W/M.MB).toFixed(2)):W<M.TB?(0,S.localize)(4,null,(W/M.GB).toFixed(2)):(0,S.localize)(5,null,(W/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var q;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function G(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G}),define(pe[80],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[T,C]of I)this.set(T,C)}set(I,T){const C=this._entries.get(I);return this._entries.set(I,T),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(pe[188],ve([1,0,16,15,114,184,4,80]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class L extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class O{constructor(g=new k.ServiceCollection,d=!1,p){this._activeInstantiations=new Set,this._services=g,this._strict=d,this._parent=p,this._services.set(C.IInstantiationService,this)}createChild(g){return new O(g,this._strict,this)}invokeFunction(g,...d){let p=v.traceInvocation(g),P=!1;try{return g({get:o=>{if(P)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(o,p);if(!c)throw new Error(`[invokeFunction] unknown service '${o}'`);return c}},...d)}finally{P=!0,p.stop()}}createInstance(g,...d){let p,P;return g instanceof I.SyncDescriptor?(p=v.traceCreation(g.ctor),P=this._createInstance(g.ctor,g.staticArguments.concat(d),p)):(p=v.traceCreation(g),P=this._createInstance(g,d,p)),p.stop(),P}_createInstance(g,d=[],p){let P=C._util.getServiceDependencies(g).sort((c,u)=>c.index-u.index),_=[];for(const c of P){let u=this._getOrCreateServiceInstance(c.id,p);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${c.id}.`,!1),_.push(u)}let o=P.length>0?P[0].index:d.length;if(d.length!==o){console.warn(`[createInstance] First service dependency of ${g.name} at position ${o+1} conflicts with ${d.length} static arguments`);let c=o-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,o)}return new g(...[...d,..._])}_setServiceInstance(g,d){if(this._services.get(g)instanceof I.SyncDescriptor)this._services.set(g,d);else if(this._parent)this._parent._setServiceInstance(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let d=this._services.get(g);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):d}_getOrCreateServiceInstance(g,d){let p=this._getServiceInstanceOrDescriptor(g);return p instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,p,d.branch(g,!0)):(d.branch(g,!1),p)}_safeCreateAndCacheServiceInstance(g,d,p){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,d,p)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,d,p){const P=new T.Graph(c=>c.id.toString());let _=0;const o=[{id:g,desc:d,_trace:p}];for(;o.length;){const c=o.pop();if(P.lookupOrInsertNode(c),_++>1e3)throw new L(P);for(let u of C._util.getServiceDependencies(c.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(u.id);if(l||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),l instanceof I.SyncDescriptor){const E={id:u.id,desc:l,_trace:c._trace.branch(u.id,!0)};P.insertEdge(c,E),o.push(E)}}}for(;;){const c=P.roots();if(c.length===0){if(!P.isEmpty())throw new L(P);break}for(const{data:u}of c){if(this._getServiceInstanceOrDescriptor(u.id)instanceof I.SyncDescriptor){const E=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,E)}P.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,d,p=[],P,_){if(this._services.get(g)instanceof I.SyncDescriptor)return this._createServiceInstance(d,p,P,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,d,p,P,_);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(g,d=[],p,P){if(p){const _=new f.IdleValue(()=>this._createInstance(g,d,P));return new Proxy(Object.create(null),{get(o,c){if(c in o)return o[c];let u=_.value,l=u[c];return typeof l!="function"||(l=l.bind(u),o[c]=l),l},set(o,c,u){return _.value[c]=u,!0}})}else return this._createInstance(g,d,P)}_throwIfStrict(g,d){if(d&&console.warn(d),this._strict)throw new Error(g)}}e.InstantiationService=O;var y;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(y||(y={}));class v{constructor(g,d){this.type=g,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return S?new v(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(g){return S?new v(0,g.name):v._None}branch(g,d){let p=new v(2,g.toString());return this._dep.push([g,d,p]),p}stop(){let g=Date.now()-this._start;v._totals+=g;let d=!1;function p(_,o){let c=[],u=new Array(_+1).join("	");for(const[l,E,s]of o._dep)if(E&&s){d=!0,c.push(`${u}CREATES -> ${l}`);let t=p(_+1,s);t&&c.push(t)}else c.push(`${u}uses -> ${l}`);return c.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(g>2||d)&&console.log(P.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(pe[11],ve([1,0,49,3,6,12,4]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function L(E,s,t){switch(s){case S.Trace:E.trace(t);break;case S.Debug:E.debug(t);break;case S.Info:E.info(t);break;case S.Warning:E.warn(t);break;case S.Error:E.error(t);break;case S.Critical:E.critical(t);break;default:throw new Error("Invalid log level")}}e.log=L;function O(E){let s="";for(let t=0;t<E.length;t++){let r=E[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(t>0?" ":"")+r}return s}e.format=O;class y extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class v extends y{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,O([s,...t]))}debug(s,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,O([s,...t]))}info(s,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,O([s,...t]))}warn(s,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,O([s,...t]))}error(s,...t){if(this.checkLogLevel(S.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(S.Error,O(r))}else this.log(S.Error,O([s,...t]))}critical(s,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,O([s,...t]))}flush(){}}e.AbstractMessageLogger=v;class b extends y{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!T.isWindows}trace(s,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...t):console.log(`[main ${k()}]`,s,...t))}debug(s,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...t):console.log(`[main ${k()}]`,s,...t))}info(s,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...t):console.log(`[main ${k()}]`,s,...t))}warn(s,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,s,...t):console.warn(`[main ${k()}]`,s,...t))}error(s,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,s,...t):console.error(`[main ${k()}]`,s,...t))}critical(s,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,s,...t):console.error(`[main ${k()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class g extends y{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=g;class d extends y{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,f.toErrorMessage)(s,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class p extends y{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=p;class P extends I.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=P;class _ extends I.Disposable{constructor(s,t){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,t){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,t?.always?S.Trace:this.logLevel,t),this.loggers.set(s.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class o{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return S.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=o;function c(E){if(E.verbose)return S.Trace;if(typeof E.logLevel=="string"){const s=u(E.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(E){switch(E){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=u;function l(E){switch(E){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(pe[189],ve([1,0,42,11]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,S,L,O,y){try{const v=await new Promise((g,d)=>{te(["spdlog"],g,d)});v.setFlushOn(n.LogLevel.Trace);const b=await v.createAsyncRotatingLogger(k,S,L,O);return y&&b.clearFormatters(),b}catch(v){console.error(v)}return null}function T(k,S,L){switch(S){case n.LogLevel.Trace:k.trace(L);break;case n.LogLevel.Debug:k.debug(L);break;case n.LogLevel.Info:k.info(L);break;case n.LogLevel.Warning:k.warn(L);break;case n.LogLevel.Error:k.error(L);break;case n.LogLevel.Critical:k.critical(L);break;default:throw new Error("Invalid log level")}}class C extends n.AbstractMessageLogger{constructor(S,L,O,y,v){super();this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(S,L,O,y),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(S,L,O,y){const v=O?6:1,b=30/v*f.ByteSize.MB,g=await I(S,L,b,v,y);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:d,message:p}of this.buffer)T(this._logger,d,p);this.buffer=[]}}log(S,L){this._logger?T(this._logger,S,L):this.getLevel()<=S&&this.buffer.push({level:S,message:L})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(pe[116],ve([1,0,47,164,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function L(g,d){return d-g}S.compare=L;const O=Object.create(null);O[S.Error]=(0,n.localize)(0,null),O[S.Warning]=(0,n.localize)(1,null),O[S.Info]=(0,n.localize)(2,null);function y(g){return O[g]||""}S.toString=y;function v(g){switch(g){case f.default.Error:return S.Error;case f.default.Warning:return S.Warning;case f.default.Info:return S.Info;case f.default.Ignore:return S.Hint}}S.fromSeverity=v;function b(g){switch(g){case S.Error:return f.default.Error;case S.Warning:return f.default.Warning;case S.Info:return f.default.Info;case S.Hint:return f.default.Ignore}}S.toSeverity=b}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const L="";function O(v){return y(v,!0)}S.makeKey=O;function y(v,b){let g=[L];return v.source?g.push(v.source.replace("\xA6","\\\xA6")):g.push(L),v.code?typeof v.code=="string"?g.push(v.code.replace("\xA6","\\\xA6")):g.push(v.code.value.replace("\xA6","\\\xA6")):g.push(L),v.severity!==void 0&&v.severity!==null?g.push(C.toString(v.severity)):g.push(L),v.message&&b?g.push(v.message.replace("\xA6","\\\xA6")):g.push(L),v.startLineNumber!==void 0&&v.startLineNumber!==null?g.push(v.startLineNumber.toString()):g.push(L),v.startColumn!==void 0&&v.startColumn!==null?g.push(v.startColumn.toString()):g.push(L),v.endLineNumber!==void 0&&v.endLineNumber!==null?g.push(v.endLineNumber.toString()):g.push(L),v.endColumn!==void 0&&v.endColumn!==null?g.push(v.endColumn.toString()):g.push(L),g.push(L),g.join("\xA6")}S.makeKeyOptionalMessage=y})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(pe[190],ve([1,0,3,47,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=n.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=S}),define(pe[117],ve([1,0,6,8,2,4]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function C(O,y){return I.URI.isUri(O)?(0,n.equalsIgnoreCase)(O.scheme,y):(0,n.startsWithIgnoreCase)(O,y+":")}e.matchesScheme=C;function k(O,...y){return y.some(v=>C(O,v))}e.matchesSomeScheme=k;function S(O,y){return O.with({fragment:`${y.startLineNumber},${y.startColumn}${y.endLineNumber?`-${y.endLineNumber}${y.endColumn?`,${y.endColumn}`:""}`:""}`})}e.withSelection=S;function L(O){let y;const v=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return v&&(y={startLineNumber:parseInt(v[1]),startColumn:v[2]?parseInt(v[2]):1,endLineNumber:v[4]?parseInt(v[4]):void 0,endColumn:v[4]?v[5]?parseInt(v[5]):1:void 0},O=O.with({fragment:""})),{selection:y,uri:O}}e.extractSelection=L}),define(pe[191],ve([1,0,10,12,41,23]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const k=n.globals.vscode.context.configuration();if(k)C=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const k=(0,T.dirname)(f.FileAccess.asFileUri("",te));C=te.__$__nodeRequire((0,T.joinPath)(k,"product.json").fsPath);const S=te.__$__nodeRequire((0,T.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:S.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C});var Fe=this&&this.__param||function(te,e){return function(f,n){e(f,n,te)}};define(pe[118],ve([1,0,16,21,6,4]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var C;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(y,v){super();this.deferred=new f.DeferredPromise,v.withProgress(y,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};S=Be([Fe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class L extends I.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(y){this.stop();const v=++this.currentOperationId,b=new n.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{v===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:v,token:b.token,stop:()=>this.doStop(v),isCurrent:()=>this.currentOperationId===v}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=L,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(pe[50],ve([1,0,55,13]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,k){f.ok(n.isString(C)),f.ok(n.isObject(k)),f.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,k)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(pe[192],ve([1,0,3,50]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,L){this.schemasById[I(S)]=L,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new T;n.Registry.add(e.Extensions.JSONContribution,C)}),define(pe[119],ve([1,0,18,3,13,159,192,50]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const O=k.Registry.as(C.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,l=!0){this.registerConfigurations([u],l)}registerConfigurations(u,l=!0){const E=this.doRegisterConfigurations(u,l);O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(u){const l=this.doDeregisterConfigurations(u);O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:u,remove:l}){const E=[];E.push(...this.doDeregisterConfigurations(l)),E.push(...this.doRegisterConfigurations(u,!1)),O.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(E)})}registerDefaultConfigurations(u){const l=[],E=[];for(const{overrides:s,source:t}of u)for(const r in s)if(l.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const i={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:i});const a={type:"object",default:i,description:T.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:i,source:I.isString(t)?void 0:t};E.push(...g(r)),this.configurationProperties[r]=a,this.defaultLanguageConfigurationOverridesNode.properties[r]=a}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:t});const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const l=[];for(const{overrides:E,source:s}of u)for(const t in E){const r=this.configurationDefaultsOverrides.get(t),i=I.isString(s)?s:s?.id,a=I.isString(r?.source)?r?.source:r?.source?.id;if(i===a)if(l.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const m=this.configurationProperties[t];m&&(this.updatePropertyDefaultValue(t,m),this.updateSchema(t,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const l of u)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,l){const E=[];return u.forEach(s=>{E.push(...this.validateAndRegisterProperties(s,l,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),E}doDeregisterConfigurations(u){const l=[],E=s=>{if(s.properties)for(const t in s.properties)l.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,s.properties[t]);s.allOf&&s.allOf.forEach(t=>E(t))};for(const s of u){E(s);const t=this.configurationContributors.indexOf(s);t!==-1&&this.configurationContributors.splice(t,1)}return l}validateAndRegisterProperties(u,l=!0,E,s,t=3){t=I.isUndefinedOrNull(u.scope)?t:u.scope;let r=[],i=u.properties;if(i)for(let m in i){if(l&&_(m)){delete i[m];continue}const h=i[m];if(h.source=E,h.defaultDefaultValue=i[m].default,this.updatePropertyDefaultValue(m,h),e.OVERRIDE_PROPERTY_REGEX.test(m)?h.scope=void 0:(h.scope=I.isUndefinedOrNull(h.scope)?t:h.scope,h.restricted=I.isUndefinedOrNull(h.restricted)?!!s?.includes(m):h.restricted),i[m].hasOwnProperty("included")&&!i[m].included){this.excludedConfigurationProperties[m]=i[m],delete i[m];continue}else this.configurationProperties[m]=i[m];!i[m].deprecationMessage&&i[m].markdownDeprecationMessage&&(i[m].deprecationMessage=i[m].markdownDeprecationMessage),r.push(m)}let a=u.allOf;if(a)for(let m of a)r.push(...this.validateAndRegisterProperties(m,l,E,s,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const l=E=>{let s=E.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let t=E.allOf;t&&t.forEach(l)};l(u)}updateSchema(u,l){switch(e.allSettings.properties[u]=l,l.scope){case 1:e.applicationSettings.properties[u]=l;break;case 2:e.machineSettings.properties[u]=l;break;case 6:e.machineOverridableSettings.properties[u]=l;break;case 3:e.windowSettings.properties[u]=l;break;case 4:e.resourceSettings.properties[u]=l;break;case 5:e.resourceSettings.properties[u]=l,this.resourceLanguageSettingsSchema.properties[u]=l;break}}removeFromSchema(u,l){switch(delete e.allSettings.properties[u],l.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const l=`[${u}]`,E={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,E),e.allSettings.properties[l]=E,e.applicationSettings.properties[l]=E,e.machineSettings.properties[l]=E,e.machineOverridableSettings.properties[l]=E,e.windowSettings.properties[l]=E,e.resourceSettings.properties[l]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,l){const E=this.configurationDefaultsOverrides.get(u);let s=E?.value,t=E?.source;I.isUndefined(s)&&(s=l.defaultDefaultValue,t=void 0),I.isUndefined(s)&&(s=p(l.type)),l.default=s,l.defaultValueSource=t}}const v="\\[([^\\]]+)\\]",b=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(c){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let l=b.exec(c);for(;l?.length;){const E=l[1].trim();E&&u.push(E),l=b.exec(c)}}return(0,f.distinct)(u)}e.overrideIdentifiersFromKey=g;function d(c){return c.reduce((u,l)=>`${u}[${l}]`,"")}e.keyFromOverrideIdentifiers=d;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const P=new y;k.Registry.add(e.Extensions.Configuration,P);function _(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?T.localize(7,null,c):P.getConfigurationProperties()[c]!==void 0?T.localize(8,null,c):null:T.localize(6,null)}e.validateProperty=_;function o(){const c=[],u=P.getConfigurationProperties();for(const l of Object.keys(u))c.push([l,u[l].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=o}),define(pe[193],ve([1,0,18,3,141,6,24,25,13,2,115,119,50]),function(te,e,f,n,I,T,C,k,S,L,O,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(s={},t=[],r=[]){this._contents=s,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,O.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,t){const r=this.getContentsForOverrideIdentifer(t);return r?s?(0,O.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const r of this.overrides)r.identifiers.includes(s)&&t.push(...r.keys);return f.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return f.distinct(s)}override(s){let t=this.overrideConfigurations.get(s);return t||(t=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,t)),t}merge(...s){const t=k.deepClone(this.contents),r=k.deepClone(this.overrides),i=[...this.keys];for(const a of s){this.mergeContents(t,a.contents);for(const m of a.overrides){const[h]=r.filter(w=>f.equals(w.identifiers,m.identifiers));h?(this.mergeContents(h.contents,m.contents),h.keys.push(...m.keys),h.keys=f.distinct(h.keys)):r.push(k.deepClone(m))}for(const m of a.keys)i.indexOf(m)===-1&&i.push(m)}return new b(t,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const t=this.getContentsForOverrideIdentifer(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const i of f.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[i],m=t[i];m&&(typeof a=="object"&&typeof m=="object"?(a=k.deepClone(a),this.mergeContents(a,m)):a=m),r[i]=a}return new b(r,this.keys,this.overrides)}mergeContents(s,t){for(const r of Object.keys(t)){if(r in s&&S.isObject(s[r])&&S.isObject(t[r])){this.mergeContents(s[r],t[r]);continue}s[r]=k.deepClone(t[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?k.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let t=null,r=null;const i=a=>{a&&(r?this.mergeContents(r,a):r=k.deepClone(a))};for(const a of this.overrides)f.equals(a.identifiers,[s])?t=a.contents:a.identifiers.includes(s)&&i(a.contents);return i(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,t){this.addKey(s),(0,O.addToValueTree)(this.contents,s,t,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,O.removeFromValueTree)(this.contents,s)}addKey(s){let t=this.keys.length;for(let r=0;r<t;r++)s.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,s)}removeKey(s){let t=this.keys.indexOf(s);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=b;class g extends b{constructor(s={}){const t=v.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),i=Object.create(null),a=[];for(const m in t){const h=s[m],w=h!==void 0?h:t[m].default;(0,O.addToValueTree)(i,m,w,A=>console.error(`Conflict in default settings: ${A}`))}for(const m of Object.keys(i))y.OVERRIDE_PROPERTY_REGEX.test(m)&&a.push({identifiers:(0,y.overrideIdentifiersFromKey)(m),keys:Object.keys(i[m]),contents:(0,O.toValuesTree)(i[m],h=>console.error(`Conflict in default settings file: ${h}`))});super(i,r,a)}}e.DefaultConfigurationModel=g;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,t){if(!S.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,t)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,t){this._raw=s;const{contents:r,keys:i,overrides:a,restricted:m}=this.doParseRaw(s,t);this._configurationModel=new b(r,i,a),this._restrictedConfigurations=m||[]}doParseContent(s){let t={},r=null,i=[],a=[],m=[];function h(A){Array.isArray(i)?i.push(A):r!==null&&(i[r]=A)}let w={onObjectBegin:()=>{let A={};h(A),a.push(i),i=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let A=[];h(A),a.push(i),i=A,r=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:h,onError:(A,F,R)=>{m.push({error:A,offset:F,length:R})}};if(s)try{I.visit(s,w),t=i[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(s,t){const r=v.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),i=this.filter(s,r,!0,t);s=i.raw;const a=(0,O.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),m=Object.keys(s),h=this.toOverrides(s,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:m,overrides:h,restricted:i.restricted}}filter(s,t,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:s,restricted:[]};const a={},m=[];for(let h in s)if(y.OVERRIDE_PROPERTY_REGEX.test(h)&&r){const w=this.filter(s[h],t,!1,i);a[h]=w.raw,m.push(...w.restricted)}else{const w=t[h],A=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&m.push(h),(A===void 0||i.scopes===void 0||i.scopes.includes(A))&&(i.skipRestricted&&w?.restricted||(a[h]=s[h]))}return{raw:a,restricted:m}}toOverrides(s,t){const r=[];for(const i of Object.keys(s))if(y.OVERRIDE_PROPERTY_REGEX.test(i)){const a={};for(const m in s[i])a[m]=s[i][m];r.push({identifiers:(0,y.overrideIdentifiersFromKey)(i),keys:Object.keys(a),contents:(0,O.toValuesTree)(a,t)})}return r}}e.ConfigurationModelParser=d;class p extends T.Disposable{constructor(s,t,r,i){super();this.userSettingsResource=s,this.scopes=t,this.fileService=i,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class P{constructor(s,t,r=new b,i=new b,a=new C.ResourceMap,m=new b,h=new C.ResourceMap,w=!0){this._defaultConfiguration=s,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=h,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(s,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(s)}updateValue(s,t,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new b,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,t===void 0?i.removeValue(s):i.setValue(s,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,t,r){const i=this.getConsolidateConfigurationModel(t,r),a=this.getFolderConfigurationModelForResource(t.resource,r),m=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,h=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),w=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),A=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),F=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),R=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,D=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(s):a.freeze().getValue(s):void 0,$=t.overrideIdentifier?m.override(t.overrideIdentifier).getValue(s):m.getValue(s),M=i.getValue(s),q=f.distinct(f.flatten(i.overrides.map(G=>G.identifiers))).filter(G=>i.getOverrideValue(s,G)!==void 0);return{defaultValue:h,userValue:w,userLocalValue:A,userRemoteValue:F,workspaceValue:R,workspaceFolderValue:D,memoryValue:$,value:M,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:a?.freeze().getValue(s),override:t.overrideIdentifier?a?.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:m.getValue(s),override:t.overrideIdentifier?m.getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(s){const t=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,t){this._folderConfigurations.set(s,t),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const r=[];if(!t){const{added:i,updated:a,removed:m}=u(this._defaultConfiguration,s);t=[...i,...a,...m]}for(const i of t)for(const a of(0,y.overrideIdentifiersFromKey)(i)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),h=s.getKeysForOverrideIdentifier(a),w=[...h.filter(A=>m.indexOf(A)===-1),...m.filter(A=>h.indexOf(A)===-1),...m.filter(A=>!k.equals(this._defaultConfiguration.override(a).getValue(A),s.override(a).getValue(A)))];r.push([a,w])}return this.updateDefaultConfiguration(s),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:r,removed:i,overrides:a}=u(this.localUserConfiguration,s),m=[...t,...r,...i];return m.length&&this.updateLocalUserConfiguration(s),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:r,removed:i,overrides:a}=u(this.remoteUserConfiguration,s);let m=[...t,...r,...i];return m.length&&this.updateRemoteUserConfiguration(s),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:r,removed:i,overrides:a}=u(this.workspaceConfiguration,s);let m=[...t,...r,...i];return m.length&&this.updateWorkspaceConfiguration(s),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(s,t){const r=this.folderConfigurations.get(s),{added:i,updated:a,removed:m,overrides:h}=u(r,t);let w=[...i,...a,...m];return(w.length||!r)&&this.updateFolderConfiguration(s,t),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(s){const t=this.folderConfigurations.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:i,removed:a,overrides:m}=u(t,void 0);return{keys:[...r,...i,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&s){const i=t.getFolder(s);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const a=this._memoryConfigurationByResource.get(s);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let t=this._foldersConsolidatedConfigurations.get(s);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(s);i?(t=r.merge(i),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(s,t)):t=r}return t}getFolderConfigurationModelForResource(s,t){if(t&&s){const r=t.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,t)=>{const{contents:r,overrides:i,keys:a}=this._folderConfigurations.get(t);return s.push([t,{contents:r,overrides:i,keys:a}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>s.add(t)),this.userConfiguration.freeze().keys.forEach(t=>s.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(i=>t.add(i))),[...t.values()]}static parse(s){const t=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),i=this.parseConfigurationModel(s.workspace),a=s.folders.reduce((m,h)=>(m.set(L.URI.revive(h[0]),this.parseConfigurationModel(h[1])),m),new C.ResourceMap);return new P(t,r,new b,i,a,new b,new C.ResourceMap,!1)}static parseConfigurationModel(s){return new b(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=P;function _(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const s=new Set,t=new Map;for(const i of E)i.keys.forEach(a=>s.add(a)),i.overrides.forEach(([a,m])=>{const h=(0,C.getOrSet)(t,a,new Set);m.forEach(w=>h.add(w))});const r=[];return t.forEach((i,a)=>r.push([a,[...i.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=_;class o{constructor(s,t,r,i){this.change=s,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;s.keys.forEach(h=>a.add(h)),s.overrides.forEach(([,h])=>h.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const m=new b;this.affectedKeys.forEach(h=>m.setValue(h,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(s,t,this.currentWorkspace);return!k.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(s,t){let r=(0,O.toValuesTree)({[t]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(s=s[i],!s)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=o;class c extends o{constructor(s,t,r,i){super({keys:s.allKeys(),overrides:[]},void 0,s,t);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=c;function u(E,s){const{added:t,removed:r,updated:i}=l(s,E),a=[],m=E?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const w=h.filter(A=>!m.includes(A));for(const A of w)a.push([A,s.getKeysForOverrideIdentifier(A)])}if(E){const w=m.filter(A=>!h.includes(A));for(const A of w)a.push([A,E.getKeysForOverrideIdentifier(A)])}if(s&&E){for(const w of m)if(h.includes(w)){const A=l({contents:E.getOverrideValue(void 0,w)||{},keys:E.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});a.push([w,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:r,updated:i,overrides:a}}function l(E,s){const t=E?s?E.keys.filter(a=>s.keys.indexOf(a)===-1):[...E.keys]:[],r=s?E?s.keys.filter(a=>E.keys.indexOf(a)===-1):[...s.keys]:[],i=[];if(E&&s){for(const a of s.keys)if(E.keys.indexOf(a)!==-1){const m=(0,O.getConfigurationValue)(s.contents,a),h=(0,O.getConfigurationValue)(E.contents,a);k.equals(m,h)||i.push(a)}}return{added:t,removed:r,updated:i}}}),define(pe[120],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var n;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(C,k=n.Unknown,S){super(C);this._message=C,this._code=k,this._detail=S,this.isHandled=k===n.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===n.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===n.NoResolverFound}static isHandled(C){return C instanceof I&&C.isHandled}}e.RemoteAuthorityResolverError=I}),define(pe[121],ve([1,0,10]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(T){return T.scheme===f.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=n;function I(T){if(!T)return;const C=T.indexOf("+");return C<0?T:T.substr(0,C)}e.getRemoteName=I}),define(pe[27],ve([1,0,8,4,121]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=T;function C(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b=="undefined"||b===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){let d=typeof b=="string"?b:b.value,p=typeof g=="string"?g:g.value;return f.equalsIgnoreCase(d,p)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=S;function L(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function O(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=O;function y(v,b){if(b){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(b)}`;return v.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[122],ve([1,0,8,27]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(g,d){return g.uuid&&d.uuid?g.uuid===d.uuid:g.id===d.id?!0:(0,f.compareIgnoreCase)(g.id,d.id)===0}e.areSameExtensions=I;class T{constructor(d,p){this.version=p,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof T?I(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=T;function C(g,d){return`${g}.${d}`}e.getExtensionId=C;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(g,d){return k(C(g,d))}e.getGalleryExtensionId=S;function L(g,d){const p=[],P=_=>{for(const o of p)if(o.some(c=>I(d(c),d(_))))return o;return null};for(const _ of g){const o=P(_);o?o.push(_):p.push([_])}return p}e.groupByExtension=L;function O(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=O;function y(g){return{id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),...g.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function v(g){const d=new Set;if(g.malicious)for(const p of g.malicious)d.add(p.id);return d}e.getMaliciousExtensionsSet=v;function b(g,d){const p=[],P=d.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const _=P.shift();if(_&&p.every(o=>!I(o.identifier,{id:_}))){const o=g.filter(c=>I(c.identifier,{id:_}));o.length===1&&(p.push(o[0]),P.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=b}),define(pe[194],ve([1,0,160,122,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(u){const l=T.exec(u);return l&&l[1]?[(0,n.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,n.adoptToGalleryExtensionId)(u),void 0]}e.getIdAndVersion=C;var k;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function S(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function O(u,l){switch(u){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function y(u,l){return l==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function v(u,l,E){return y(l,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:b(E).includes(u)}e.isTargetPlatformCompatible=v;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=g;var d;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(d=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var P;(function(u){u.Install="install",u.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var _;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var o;(function(u){u.Unsupported="Unsupported",u.UnsupportedPreRelease="UnsupportedPreRelease",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(o=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(l,E){super(l);this.code=E,this.name=E}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,f.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,f.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(pe[195],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((I,T)=>te(["vsda"],I,T))}async createNewMessage(I){try{const T=await this.vsda(),C=new T.validator;if(C){const k=String(f._nextId++);return this.validators.set(k,C),{id:k,data:C.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,T){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(T)==="ok"}catch{return!1}}async sign(I){try{const T=await this.vsda(),C=new T.signer;if(C)return C.sign(I)}catch{}return I}}e.SignService=f,f._nextId=1}),define(pe[196],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,T,C=5){let k;return k=T(S=>{const L=typeof S=="string"?S:S.data;let O=this._terminalBufferMap.get(I);if(O){O.data.push(L);return}const y=setTimeout(()=>this.flushBuffer(I),C);O={data:[L],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,O)}),k}stopBuffering(I){const T=this._terminalBufferMap.get(I);T&&T.dispose()}flushBuffer(I){const T=this._terminalBufferMap.get(I);T&&(this._terminalBufferMap.delete(I),this._callback(I,T.data.join("")))}}e.TerminalDataBufferer=f}),define(pe[197],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(pe[81],ve([1,0,72,3,6,4,50,197]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(p){function P(_){return _&&typeof _=="object"&&typeof _.id=="string"}p.isThemeColor=P})(S=e.ThemeColor||(e.ThemeColor={}));function L(p){return{id:p}}e.themeColorFromId=L;var O;(function(p){function P(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=P;const _=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function o(t){const r=_.exec(t);if(!r)return;let[,i]=r;return{id:i}}p.fromString=o;function c(t){return{id:t}}p.fromId=c;function u(t,r){let i=t.id;const a=i.lastIndexOf("~");return a!==-1&&(i=i.substring(0,a)),r&&(i=`${i}~${r}`),{id:i}}p.modify=u;function l(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}p.getModifier=l;function E(t,r){return t.id===r.id&&t.color?.id===r.color?.id}p.isEqual=E;function s(t,r){return{id:t.id,color:r?L(r):void 0}}p.asThemeIcon=s,p.asClassNameArray=f.CSSIcon.asClassNameArray,p.asClassName=f.CSSIcon.asClassName,p.asCSSSelector=f.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function y(p){switch(p){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(P);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new v;C.Registry.add(e.Extensions.ThemingContribution,b);function g(p){return b.onColorThemeChange(p)}e.registerThemingParticipant=g;class d extends I.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,_){let o=this.theme.getColor(P);return o&&_&&(o=_(o,this.theme)),o?o.toString():null}}e.Themable=d}),define(pe[123],ve([1,0,3,12,4,11]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var C;(function(g){g.Http="http",g.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function L(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=L,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=y;function v(g,d){return d?d!==1&&g<1024:!n.isWindows&&g<1024}e.isPortPrivileged=v;let b=class{constructor(d){this.logService=d,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],p=Array.from(this._tunnels.values());for(let P of p){const _=Array.from(P.values());for(let o of _){const c=await o.value;c&&d.push(c)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:p}of d.values())await p.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,p,P,_,o=!1,c=k.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${P} on local port ${_}.`),!d)return;p||(p="localhost");const l=this.retainOrCreateTunnel(d,p,P,_,o,c,u);return l?l.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(E);return(E.tunnelRemoteHost!==p||E.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const p=this._tunnels.get(d.tunnelRemoteHost);if(p){const P=p.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,p,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${p}.`);const _=P.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(p),_}}async closeTunnel(d,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${p} `);const P=this._tunnels.get(d);if(P&&P.has(p)){const _=P.get(p);_.refcount=0,await this.tryDisposeTunnel(d,p,_)}}addTunnelToMap(d,p,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(p,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,p){const P=this._tunnels.get(d);P&&(await P.get(p)||P.delete(p),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,p){let P=[d];O(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):y(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const _=P.map(o=>this._tunnels.get(o));for(const o of _){const c=o?.get(p);if(c)return c}}canTunnel(d){return!!L(d)}createWithProvider(d,p,P,_,o,c,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${P} on local port ${_}.`);const E={elevationRequired:o?v(_===void 0?P:_):!1},s={remoteAddress:{host:p,port:P},localAddressPort:_,privacy:c,public:c!==k.Private,protocol:u},t=d.forwardPort(s,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(p,P,t),t}};b=Be([Fe(0,T.ILogService)],b),e.AbstractTunnelService=b}),define(pe[198],ve([1,0,10]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function n(k){return k.scheme!==f.Schemas.file&&k.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=n;function I(k){if(k.folders.length)return k.folders.every(S=>n(S.uri))?k.folders[0].uri:void 0;if(k.configuration&&n(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function T(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=T;function C(k){return I(k)!==void 0}e.isVirtualWorkspace=C}),define(pe[43],ve([1,0,165,9,24,23,2,4,10]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function L(s){const t=s;return typeof t?.id=="string"&&C.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=L;function O(s){if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=O;function y(s){const t=s;return typeof t?.id=="string"&&C.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=y;function v(s){const t=s;if(t?.uri)return{id:t.id,uri:C.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=v;var b;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function g(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=g;function d(s){const t=s;return!!(t&&typeof t=="object"&&C.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=d;class p{constructor(t,r,i,a,m){this._id=t,this._transient=i,this._configuration=a,this._ignorePathCasing=m,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t.with({scheme:t.scheme,authority:t.authority,path:t.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class P{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=P;function _(s){return new P({uri:s,index:0,name:(0,T.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=_,e.WORKSPACE_EXTENSION="code-workspace";const o=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,f.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(s,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function u(s){let t;return C.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=u;function l(s,t){return!c(s,t)&&!u(s)}e.isSavedWorkspace=l;function E(s){return(typeof s=="string"?(0,n.extname)(s):(0,T.extname)(s))===o}e.hasWorkspaceFileExtension=E}),define(pe[82],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const T=this._idPool++;return this._data.set(T,I),this.logDebugInfo(),T}get(I,T){return this._data.has(I)?this._data.get(I)[T]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(pe[44],ve([1,0,10,23,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new n.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(pe[199],ve([1,0,16]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class n{constructor(C,k,S){this._deferredPromises=new Map,this._id=C,this._shared=k,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(L=>(this._value=L,this)),this._storageListener=this._storage.onDidChangeStorage(L=>{L.shared===this._shared&&L.key===this._id&&(this._value=L.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const L=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of L.values())O.complete()}catch(O){for(const y of L.values())y.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,k){let S=this._value[C];return typeof S=="undefined"&&(S=k),S}update(C,k){this._value[C]=k;let S=this._deferredPromises.get(C);if(S!==void 0)return S.p;const L=new f.DeferredPromise;return this._deferredPromises.set(C,L),this._scheduler.isScheduled()||this._scheduler.schedule(),L.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=n;class I extends n{constructor(C,k){super(C.identifier.value,!0,k);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=I}),define(pe[200],ve([1,0,3,2,11]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,L){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k)).acceptModelChanged(S.value,L)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const L=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k));L.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:L.apiNotebook})}};T=Be([Fe(0,I.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(pe[17],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class n{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=n});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[201],ve([1,0,27,3]),function(te,e,f,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,S){I.set(this,void 0),this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(k.identifier),Ke(this,I,S,"f"),ke(this,I,"f").onDidChangePassword(L=>{L.extensionId===this._id&&this._onDidChange.fire({key:L.key})})}get(k){return ke(this,I,"f").get(this._id,k)}store(k,S){return ke(this,I,"f").store(this._id,k,S)}delete(k){return ke(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=T,I=new WeakMap}),define(pe[124],ve([1,0,4,3]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new n.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new n.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(C){this._level=C}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(pe[62],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const n=new WeakMap,I=(_,o)=>{const c={controllerId:o};return n.set(_,c),c};e.createPrivateApiFor=I;const T=_=>n.get(_);e.getPrivateApiFor=T;const C=(_,o,c,u)=>{let l=c;return{enumerable:!0,configurable:!1,get(){return l},set(E){if(!u(l,E)){const s=l;l=E,_.listener?.({op:3,key:o,value:E,previous:s})}}}},k=(_,o)=>_===o,S={range:(_,o)=>_===o?!0:!_||!o?!1:_.isEqual(o),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(_,o)=>!(_.length!==o.length||_.some(c=>!o.find(u=>c.id===u.id)))},L=Object.keys(S),O=(_,o)=>({range:C(_,"range",void 0,S.range),label:C(_,"label",o,S.label),description:C(_,"description",void 0,S.description),sortText:C(_,"sortText",void 0,S.sortText),canResolveChildren:C(_,"canResolveChildren",!1,S.canResolveChildren),busy:C(_,"busy",!1,S.busy),error:C(_,"error",void 0,S.error),tags:C(_,"tags",[],S.tags)}),y=(_,o)=>{const c=new Map;for(const u of L)S[u](_[u],o[u])||c.set(u,o[u]);return c};e.diffTestItems=y;class v extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=v;class b extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class g extends Error{constructor(o,c,u){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=g;const d=_=>{const o=(0,e.getPrivateApiFor)(_);let c=new Map;return{get size(){return c.size},forEach(u,l){for(const E of c.values())u.call(l,E,this)},replace(u){const l=new Map,E=new Set(c.keys()),s={op:4,ops:[]};for(const t of u){if(!(t instanceof p))throw new b(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==o.controllerId)throw new g(t.id,r,o.controllerId);if(l.has(t.id))throw new v(t.id);l.set(t.id,t),E.delete(t.id),s.ops.push({op:0,item:t})}for(const t of E.keys())s.ops.push({op:1,id:t});o.listener?.(s),c=l},add(u){if(!(u instanceof p))throw new b(u.id);c.set(u.id,u),o.listener?.({op:0,item:u})},delete(u){c.delete(u)&&o.listener?.({op:1,id:u})},get(u){return c.get(u)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class p{constructor(o,c,u,l){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const E=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof P?void 0:E.parent}},children:{value:d(this),enumerable:!0,writable:!1},...O(E,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class P extends p{constructor(o,c){super(o,o,c,void 0)}}e.TestItemRootImpl=P}),define(pe[51],ve([1,0,4,123,3,17]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function L(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?n.TunnelPrivacyId.Public:n.TunnelPrivacyId.Private),protocol:y.protocol}}S.fromApiTunnel=L;function O(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==n.TunnelPrivacyId.ConstantPrivate&&y.privacy!==n.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}S.fromServiceTunnel=O})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let k=class{constructor(L){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(L){return L}async openTunnel(L,O){}async getTunnels(){return[]}async setTunnelFactory(L){return{dispose:()=>{}}}registerPortsAttributesProvider(L,O){return{dispose:()=>{}}}async $providePortAttributes(L,O,y,v,b){return[]}async $forwardPort(L,O){}async $closeTunnel(L){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Be([Fe(0,T.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[7],ve([1,0,18,15,99,24,92,8,13,2,32,42,120]),function(te,e,f,n,I,T,C,k,S,L,O,y,v){"use strict";var b,g,d,p,P,_,o,c,u,l,E,s,t,r,i,a,m,h,w,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(K){function x(){return Reflect.construct(K,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(K,"name")),Object.setPrototypeOf(x,K),Object.setPrototypeOf(x.prototype,K.prototype),x}let R=P=class{constructor(x){b.set(this,void 0),Ke(this,b,x,"f")}static from(...x){let ue=x;return new P(function(){if(ue){for(const De of ue)De&&typeof De.dispose=="function"&&De.dispose();ue=void 0}})}dispose(){typeof ke(this,b,"f")=="function"&&(ke(this,b,"f").call(this),Ke(this,b,void 0,"f"))}};b=new WeakMap,R=P=Be([F],R),e.Disposable=R;let D=_=class{constructor(x,ue){if(x<0)throw(0,n.illegalArgument)("line must be non-negative");if(ue<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=x,this._character=ue}static Min(...x){if(x.length===0)throw new TypeError;let ue=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isBefore(ue)&&(ue=Ge)}return ue}static Max(...x){if(x.length===0)throw new TypeError;let ue=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isAfter(ue)&&(ue=Ge)}return ue}static isPosition(x){if(!x)return!1;if(x instanceof _)return!0;let{line:ue,character:De}=x;return typeof ue=="number"&&typeof De=="number"}static of(x){if(x instanceof _)return x;if(this.isPosition(x))return new _(x.line,x.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,ue=0){if(x===null||ue===null)throw(0,n.illegalArgument)();let De;return typeof x=="undefined"?De=0:typeof x=="number"?De=x:(De=typeof x.lineDelta=="number"?x.lineDelta:0,ue=typeof x.characterDelta=="number"?x.characterDelta:0),De===0&&ue===0?this:new _(this.line+De,this.character+ue)}with(x,ue=this.character){if(x===null||ue===null)throw(0,n.illegalArgument)();let De;return typeof x=="undefined"?De=this.line:typeof x=="number"?De=x:(De=typeof x.line=="number"?x.line:this.line,ue=typeof x.character=="number"?x.character:this.character),De===this.line&&ue===this.character?this:new _(De,ue)}toJSON(){return{line:this.line,character:this.character}}};D=_=Be([F],D),e.Position=D;let $=o=class{constructor(x,ue,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new D(x,ue),Ze=new D(De,Ge)):D.isPosition(x)&&D.isPosition(ue)&&(Qe=D.of(x),Ze=D.of(ue)),!Qe||!Ze)throw new Error("Invalid arguments");Qe.isBefore(Ze)?(this._start=Qe,this._end=Ze):(this._start=Ze,this._end=Qe)}static isRange(x){return x instanceof o?!0:x?D.isPosition(x.start)&&D.isPosition(x.end):!1}static of(x){if(x instanceof o)return x;if(this.isRange(x))return new o(x.start,x.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(x){return o.isRange(x)?this.contains(x.start)&&this.contains(x.end):D.isPosition(x)?!(D.of(x).isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const ue=D.Max(x.start,this._start),De=D.Min(x.end,this._end);if(!ue.isAfter(De))return new o(ue,De)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const ue=D.Min(x.start,this._start),De=D.Max(x.end,this.end);return new o(ue,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,ue=this.end){if(x===null||ue===null)throw(0,n.illegalArgument)();let De;return x?D.isPosition(x)?De=x:(De=x.start||this.start,ue=x.end||this.end):De=this.start,De.isEqual(this._start)&&ue.isEqual(this.end)?this:new o(De,ue)}toJSON(){return[this.start,this.end]}};$=o=Be([F],$),e.Range=$;let M=c=class extends ${constructor(x,ue,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new D(x,ue),Ze=new D(De,Ge)):D.isPosition(x)&&D.isPosition(ue)&&(Qe=D.of(x),Ze=D.of(ue)),!Qe||!Ze)throw new Error("Invalid arguments");super(Qe,Ze);this._anchor=Qe,this._active=Ze}static isSelection(x){return x instanceof c?!0:x?$.isRange(x)&&D.isPosition(x.anchor)&&D.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=c=Be([F],M),e.Selection=M;class q{constructor(x,ue,De){if(typeof x!="string"||x.length===0)throw(0,n.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,n.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,n.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(ue),this.connectionToken=De}}e.ResolvedAuthority=q;class G extends Error{constructor(x,ue=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(x);this._message=x,this._code=ue,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(x,ue){return new G(x,v.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(x){return new G(x,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var U;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var W;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=u=class{constructor(x,ue){this._range=x,this._newText=ue}static isTextEdit(x){return x instanceof u?!0:x?$.isRange(x)&&typeof x.newText=="string":!1}static replace(x,ue){return new u(x,ue)}static insert(x,ue){return u.replace(new $(x,x),ue)}static delete(x){return u.replace(x,"")}static setEndOfLine(x){const ue=new u(new $(new D(0,0),new D(0,0)),"");return ue.newEol=x,ue}get range(){return this._range}set range(x){if(x&&!$.isRange(x))throw(0,n.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,n.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,n.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=u=Be([F],ee),e.TextEdit=ee;var Z;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace"})(Z=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,ue,De,Ge){this._edits.push({_type:1,from:x,to:ue,options:De,metadata:Ge})}createFile(x,ue,De){this._edits.push({_type:1,from:void 0,to:x,options:ue,metadata:De})}deleteFile(x,ue,De){this._edits.push({_type:1,from:x,to:void 0,options:ue,metadata:De})}replaceNotebookMetadata(x,ue,De){this._edits.push({_type:3,metadata:De,uri:x,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(x,ue,De,Ge,Qe){let Ze,rt,Dt=[],At;if(Kt.isNotebookRange(ue)&&Oe.isNotebookCellDataArray(De)&&!Oe.isNotebookCellDataArray(Ge)?(Ze=ue.start,rt=ue.end,Dt=De,At=Ge):typeof ue=="number"&&typeof De=="number"&&Oe.isNotebookCellDataArray(Ge)&&(Ze=ue,rt=De,Dt=Ge,At=Qe),Ze===void 0||rt===void 0)throw new Error("Invalid arguments");(Ze!==rt||Dt.length>0)&&this._edits.push({_type:5,uri:x,index:Ze,count:rt-Ze,cells:Dt,metadata:At})}replaceNotebookCellMetadata(x,ue,De,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:8,index:ue,metadata:De}})}replace(x,ue,De,Ge){this._edits.push({_type:2,uri:x,edit:new ee(ue,De),metadata:Ge})}insert(x,ue,De,Ge){this.replace(x,new $(ue,ue),De,Ge)}delete(x,ue,De){this.replace(x,ue,"",De)}has(x){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===x.toString())}set(x,ue){if(ue)for(const De of ue)De&&this._edits.push({_type:2,uri:x,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ge=this._edits[De];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[De]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(x){const ue=[];for(let De of this._edits)De._type===2&&De.uri.toString()===x.toString()&&ue.push(De.edit);return ue}entries(){const x=new T.ResourceMap;for(let ue of this._edits)if(ue._type===2){let De=x.get(ue.uri);De||(De=[ue.uri,[]],x.set(ue.uri,De)),De[1].push(ue.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=Be([F],V),e.WorkspaceEdit=V;let J=l=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof l?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=l._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,ue=this._tabstop++){if(typeof x=="function"){const De=new l;De._tabstop=this._tabstop,x(De),this._tabstop=De._tabstop,x=De.value}else x=l._escape(x);return this.value+="${",this.value+=ue,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,ue=this._tabstop++){const De=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(x,ue){if(typeof ue=="function"){const De=new l;De._tabstop=this._tabstop,ue(De),this._tabstop=De._tabstop,ue=De.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};J=l=Be([F],J),e.SnippetString=J;var se;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=E=class{constructor(x,ue){if(this.uri=x,ue)if($.isRange(ue))this.range=$.of(ue);else if(D.isPosition(ue))this.range=new $(ue,ue);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof E?!0:x?$.isRange(x.range)&&L.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=E=Be([F],Q),e.Location=Q;let Y=class{constructor(x,ue){this.location=x,this.message=ue}static is(x){return x?typeof x.message=="string"&&x.location&&$.isRange(x.location.range)&&L.URI.isUri(x.location.uri):!1}static isEqual(x,ue){return x===ue?!0:!x||!ue?!1:x.message===ue.message&&x.location.range.isEqual(ue.location.range)&&x.location.uri.toString()===ue.location.uri.toString()}};Y=Be([F],Y),e.DiagnosticRelatedInformation=Y;let oe=class{constructor(x,ue,De=ae.Error){if(!$.isRange(x))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=x,this.message=ue,this.severity=De}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,ue){return x===ue?!0:!x||!ue?!1:x.message===ue.message&&x.severity===ue.severity&&x.code===ue.code&&x.severity===ue.severity&&x.source===ue.source&&x.range.isEqual(ue.range)&&(0,f.equals)(x.tags,ue.tags)&&(0,f.equals)(x.relatedInformation,ue.relatedInformation,Y.isEqual)}};oe=Be([F],oe),e.Diagnostic=oe;let de=class{constructor(x,ue){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=ue}};de=Be([F],de),e.Hover=de;var Ee;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Ee=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(x,ue=Ee.Text){this.range=x,this.kind=ue}toJSON(){return{range:this.range,kind:Ee[this.kind]}}};Re=Be([F],Re),e.DocumentHighlight=Re;var Ne;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var be;(function(K){K[K.Deprecated=1]="Deprecated"})(be=e.SymbolTag||(e.SymbolTag={}));let we=s=class{constructor(x,ue,De,Ge,Qe){this.name=x,this.kind=ue,this.containerName=Qe,typeof De=="string"&&(this.containerName=De),Ge instanceof Q?this.location=Ge:De instanceof $&&(this.location=new Q(Ge,De)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};we=s=Be([F],we),e.SymbolInformation=we;let H=t=class{constructor(x,ue,De,Ge,Qe){this.name=x,this.detail=ue,this.kind=De,this.range=Ge,this.selectionRange=Qe,this.children=[],t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(t.validate)}};H=t=Be([F],H),e.DocumentSymbol=H;var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(x,ue){this.title=x,this.kind=ue}};N=Be([F],N),e.CodeAction=N;let z=r=class{constructor(x){this.value=x}append(x){return new r(this.value?this.value+r.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+r.sep)}};z.sep=".",z=r=Be([F],z),e.CodeActionKind=z,z.Empty=new z(""),z.QuickFix=z.Empty.append("quickfix"),z.Refactor=z.Empty.append("refactor"),z.RefactorExtract=z.Refactor.append("extract"),z.RefactorInline=z.Refactor.append("inline"),z.RefactorRewrite=z.Refactor.append("rewrite"),z.Source=z.Empty.append("source"),z.SourceOrganizeImports=z.Source.append("organizeImports"),z.SourceFixAll=z.Source.append("fixAll");let j=class{constructor(x,ue){if(this.range=x,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=Be([F],j),e.SelectionRange=j;class re{constructor(x,ue,De,Ge,Qe,Ze){this.kind=x,this.name=ue,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class he{constructor(x,ue){this.fromRanges=ue,this.from=x}}e.CallHierarchyIncomingCall=he;class Ce{constructor(x,ue){this.fromRanges=ue,this.to=x}}e.CallHierarchyOutgoingCall=Ce;var Te;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Te=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(x,ue){this.range=x,this.command=ue}get isResolved(){return!!this.command}};We=Be([F],We),e.CodeLens=We;let ze=i=class{constructor(x,ue=!1){g.set(this,void 0),Ke(this,g,new I.MarkdownString(x,{supportThemeIcons:ue}),"f")}static isMarkdownString(x){return x instanceof i?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return ke(this,g,"f").value}set value(x){ke(this,g,"f").value=x}get isTrusted(){return ke(this,g,"f").isTrusted}set isTrusted(x){ke(this,g,"f").isTrusted=x}get supportThemeIcons(){return ke(this,g,"f").supportThemeIcons}set supportThemeIcons(x){ke(this,g,"f").supportThemeIcons=x}get supportHtml(){return ke(this,g,"f").supportHtml}set supportHtml(x){ke(this,g,"f").supportHtml=x}get baseUri(){return ke(this,g,"f").baseUri}set baseUri(x){ke(this,g,"f").baseUri=x}appendText(x){return ke(this,g,"f").appendText(x),this}appendMarkdown(x){return ke(this,g,"f").appendMarkdown(x),this}appendCodeblock(x,ue){return ke(this,g,"f").appendCodeblock(ue??"",x),this}};g=new WeakMap,ze=i=Be([F],ze),e.MarkdownString=ze;let qe=class{constructor(x,ue){this.label=x,this.documentation=ue}};qe=Be([F],qe),e.ParameterInformation=qe;let He=class{constructor(x,ue){this.label=x,this.documentation=ue,this.parameters=[]}};He=Be([F],He),e.SignatureInformation=He;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([F],Ue),e.SignatureHelp=Ue;var Je;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(x){this.value=x}};Le=Be([F],Le),e.InlayHintLabelPart=Le;let it=class{constructor(x,ue,De){this.position=x,this.label=ue,this.kind=De}};it=Be([F],it),e.InlayHint=it;var ne;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(K){K[K.Deprecated=1]="Deprecated"})(X=e.CompletionItemTag||(e.CompletionItemTag={}));let ge=class{constructor(x,ue){this.label=x,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ge=Be([F],ge),e.CompletionItem=ge;let Se=class{constructor(x=[],ue=!1){this.items=x,this.isIncomplete=ue}};Se=Be([F],Se),e.CompletionList=Se;let Me=class{constructor(x,ue,De){this.insertText=x,this.range=ue,this.command=De}};Me=Be([F],Me),e.InlineSuggestion=Me;let $e=class{constructor(x){this.items=x}};$e=Be([F],$e),e.InlineSuggestions=$e;var Ye;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var lt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var je;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(je=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(K){function x(ue){switch(ue){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=x}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(x,ue){if(ue&&!L.URI.isUri(ue))throw(0,n.illegalArgument)("target");if(!$.isRange(x)||x.isEmpty)throw(0,n.illegalArgument)("range");this.range=x,this.target=ue}};ct=Be([F],ct),e.DocumentLink=ct;let Rt=class{constructor(x,ue,De,Ge){this.red=x,this.green=ue,this.blue=De,this.alpha=Ge}};Rt=Be([F],Rt),e.Color=Rt;let Tt=class{constructor(x,ue){if(ue&&!(ue instanceof Rt))throw(0,n.illegalArgument)("color");if(!$.isRange(x)||x.isEmpty)throw(0,n.illegalArgument)("range");this.range=x,this.color=ue}};Tt=Be([F],Tt),e.ColorInformation=Tt;let yt=class{constructor(x){if(!x||typeof x!="string")throw(0,n.illegalArgument)("label");this.label=x}};yt=Be([F],yt),e.ColorPresentation=yt;var mt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(mt=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(x,ue,De){if(this.startIndex=x,this.length=ue,this.tooltip=De,typeof x!="number"||x<0)throw(0,n.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,n.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Ft;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(x){this.options=x,typeof x!="object"&&(0,n.illegalArgument)("options")}}e.TerminalProfile=xe;var _e;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var ye;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(ye=e.TaskPanelKind||(e.TaskPanelKind={}));let me=a=class{constructor(x,ue){if(this.label=ue,typeof x!="string"||typeof ue!="string")throw(0,n.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};me.Clean=new a("clean","Clean"),me.Build=new a("build","Build"),me.Rebuild=new a("rebuild","Rebuild"),me.Test=new a("test","Test"),me=a=Be([F],me),e.TaskGroup=me;function ie(K){let x="";for(let ue=0;ue<K.length;ue++)x+=K[ue].replace(/,/g,",,")+",";return x}let Ie=class{constructor(x,ue,De){if(typeof x!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=x,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=De):this._options=ue)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,n.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)x.push(ue);return ie(x)}};Ie=Be([F],Ie),e.ProcessExecution=Ie;let Ae=class{constructor(x,ue,De){if(this._args=[],Array.isArray(ue)){if(!x)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,n.illegalArgument)("command");this._command=x,this._args=ue,this._options=De}else{if(typeof x!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=x,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,n.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)x.push(typeof ue=="string"?ue:ue.value);return ie(x)}};Ae=Be([F],Ae),e.ShellExecution=Ae;var Ve;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Ve=e.ShellQuoting||(e.ShellQuoting={}));var Xe;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Xe=e.TaskScope||(e.TaskScope={}));class ht{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=ht;let Et=m=class{constructor(x,ue,De,Ge,Qe,Ze){this.__deprecated=!1,this._definition=this.definition=x;let rt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=De,this.execution=Ge,rt=Qe,this.__deprecated=!0):ue===Xe.Global||ue===Xe.Workspace?(this.target=ue,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze):(this.target=ue,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze),typeof rt=="string"?(this._problemMatchers=[rt],this._hasDefinedMatchers=!0):Array.isArray(rt)?(this._problemMatchers=rt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const ue=this._definition.type;(m.EmptyType===ue||m.ProcessType===ue||m.ShellType===ue||m.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=m=Be([F],Et),e.Task=Et;var St;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let ot=class{constructor(x,ue=dt.None){this.collapsibleState=ue,L.URI.isUri(x)?this.resourceUri=x:this.label=x}};ot=Be([F],ot),e.TreeItem=ot;var dt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(x){this.value=x}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ut=Be([F],ut),e.DataTransferItem=ut;let Nt=class{constructor(){this._items=new Map}get(x){return this._items.get(x)}set(x,ue){this._items.set(x,ue)}forEach(x){this._items.forEach(x)}};Nt=Be([F],Nt),e.DataTransfer=Nt;let pt=class{constructor(x,ue){this.id=x,this.color=ue}};pt=Be([F],pt),e.ThemeIcon=pt,pt.File=new pt("file"),pt.Folder=new pt("folder");let kt=class{constructor(x){this.id=x}};kt=Be([F],kt),e.ThemeColor=kt;var Ut;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(x,ue){if(typeof x!="string"&&(!x||!L.URI.isUri(x)&&!L.URI.isUri(x.uri)))throw(0,n.illegalArgument)("base");if(typeof ue!="string")throw(0,n.illegalArgument)("pattern");typeof x=="string"?this.baseUri=L.URI.file(x):L.URI.isUri(x)?this.baseUri=x:this.baseUri=x.uri,this.pattern=ue}get base(){return this._base}set base(x){this._base=x,this._baseUri=L.URI.file(x)}get baseUri(){return this._baseUri}set baseUri(x){this._baseUri=x,this._base=x.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([F],Ct),e.RelativePattern=Ct;let Bt=class{constructor(x,ue,De,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof ue=="string"&&(this.condition=ue),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};Bt=Be([F],Bt),e.Breakpoint=Bt;let Ht=class extends Bt{constructor(x,ue,De,Ge,Qe){super(ue,De,Ge,Qe);if(x===null)throw(0,n.illegalArgument)("location");this.location=x}};Ht=Be([F],Ht),e.SourceBreakpoint=Ht;let bt=class extends Bt{constructor(x,ue,De,Ge,Qe){super(ue,De,Ge,Qe);this.functionName=x}};bt=Be([F],bt),e.FunctionBreakpoint=bt;let ei=class extends Bt{constructor(x,ue,De,Ge,Qe,Ze,rt){super(Ge,Qe,Ze,rt);if(!ue)throw(0,n.illegalArgument)("dataId");this.label=x,this.dataId=ue,this.canPersist=De}};ei=Be([F],ei),e.DataBreakpoint=ei;let Xt=class{constructor(x,ue,De){this.command=x,this.args=ue||[],this.options=De}};Xt=Be([F],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(x,ue){this.port=x,this.host=ue}};ti=Be([F],ti),e.DebugAdapterServer=ti;let ai=class{constructor(x){this.path=x}};ai=Be([F],ai),e.DebugAdapterNamedPipeServer=ai;let Pt=class{constructor(x){this.implementation=x}};Pt=Be([F],Pt),e.DebugAdapterInlineImplementation=Pt;let ii=class{constructor(x,ue){this.range=x,this.expression=ue}};ii=Be([F],ii),e.EvaluatableExpression=ii;var bi;(function(K){K[K.Automatic=0]="Automatic",K[K.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(x,ue){this.range=x,this.text=ue}};qt=Be([F],qt),e.InlineValueText=qt;let Gt=class{constructor(x,ue,De=!0){this.range=x,this.variableName=ue,this.caseSensitiveLookup=De}};Gt=Be([F],Gt),e.InlineValueVariableLookup=Gt;let at=class{constructor(x,ue){this.range=x,this.expression=ue}};at=Be([F],at),e.InlineValueEvaluatableExpression=at;let li=class{constructor(x,ue){this.frameId=x,this.stoppedLocation=ue}};li=Be([F],li),e.InlineValueContext=li;var $t;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})($t=e.FileChangeType||(e.FileChangeType={}));let xt=h=class extends Error{constructor(x,ue=y.FileSystemProviderErrorCode.Unknown,De){super(L.URI.isUri(x)?x.toString(!0):x);this.code=De?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(x){return new h(x,y.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(x){return new h(x,y.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(x){return new h(x,y.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(x){return new h(x,y.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(x){return new h(x,y.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(x){return new h(x,y.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};xt=h=Be([F],xt),e.FileSystemError=xt;let ni=class{constructor(x,ue,De){this.start=x,this.end=ue,this.kind=De}};ni=Be([F],ni),e.FoldingRange=ni;var _i;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(x,ue=[]){this.tokenTypes=x,this.tokenModifiers=ue}}e.SemanticTokensLegend=ri;function Ci(K){return typeof K=="undefined"||(0,S.isStringArray)(K)}class Qt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let ue=0,De=x.tokenTypes.length;ue<De;ue++)this._tokenTypeStrToInt.set(x.tokenTypes[ue],ue);for(let ue=0,De=x.tokenModifiers.length;ue<De;ue++)this._tokenModifierStrToInt.set(x.tokenModifiers[ue],ue)}}push(x,ue,De,Ge,Qe){if(typeof x=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Qe=="number"||typeof Qe=="undefined"))return typeof Qe=="undefined"&&(Qe=0),this._pushEncoded(x,ue,De,Ge,Qe);if($.isRange(x)&&typeof ue=="string"&&Ci(De))return this._push(x,ue,De);throw(0,n.illegalArgument)()}_push(x,ue,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,Qe=x.start.character,Ze=x.end.character-x.start.character,rt=this._tokenTypeStrToInt.get(ue);let Dt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(At);Dt|=1<<Wt>>>0}this._pushEncoded(Ge,Qe,Ze,rt,Dt)}_pushEncoded(x,ue,De,Ge,Qe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Wt=0;for(let zt=0;zt<Dt;zt++){let Vt=this._data[5*zt],di=this._data[5*zt+1];Vt===0?(Vt=At,di+=Wt):Vt+=At,this._data[5*zt]=Vt,this._data[5*zt+1]=di,At=Vt,Wt=di}}let Ze=x,rt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(rt-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=rt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Qe,this._prevLine=x,this._prevChar=ue}static _sortAndDeltaEncode(x){let ue=[];const De=x.length/5|0;for(let rt=0;rt<De;rt++)ue[rt]=rt;ue.sort((rt,Dt)=>{const At=x[5*rt],Wt=x[5*Dt];if(At===Wt){const zt=x[5*rt+1],Vt=x[5*Dt+1];return zt-Vt}return At-Wt});const Ge=new Uint32Array(x.length);let Qe=0,Ze=0;for(let rt=0;rt<De;rt++){const Dt=5*ue[rt],At=x[Dt+0],Wt=x[Dt+1],zt=x[Dt+2],Vt=x[Dt+3],di=x[Dt+4],xi=At-Qe,Ji=xi===0?Wt-Ze:Wt,hi=5*rt;Ge[hi+0]=xi,Ge[hi+1]=Ji,Ge[hi+2]=zt,Ge[hi+3]=Vt,Ge[hi+4]=di,Qe=At,Ze=Wt}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),x):new Yt(Qt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(x,ue){this.resultId=ue,this.data=x}}e.SemanticTokens=Yt;class yi{constructor(x,ue,De){this.start=x,this.deleteCount=ue,this.data=De}}e.SemanticTokensEdit=yi;class Di{constructor(x,ue){this.resultId=ue,this.edits=x}}e.SemanticTokensEdits=Di;var Jt;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new pt("arrow-left")},si=Be([F],si),e.QuickInputButtons=si;var Ii;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Pi{constructor(x,ue,De){this.badge=x,this.tooltip=ue,this.color=De}static validate(x){if(x.badge){let ue=(0,k.nextCharLength)(x.badge,0);if(ue<x.badge.length&&(ue+=(0,k.nextCharLength)(x.badge,ue)),x.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Pi;let Zt=class{constructor(x){this.kind=x}};Zt=Be([F],Zt),e.ColorTheme=Zt;var gi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(x,ue){if(x<0)throw(0,n.illegalArgument)("start must be positive");if(ue<0)throw(0,n.illegalArgument)("end must be positive");x<=ue?(this._start=x,this._end=ue):(this._start=ue,this._end=x)}static isNotebookRange(x){return x instanceof Kt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let ue=this._start,De=this._end;return x.start!==void 0&&(ue=x.start),x.end!==void 0&&(De=x.end),ue===this._start&&De===this._end?this:new Kt(ue,De)}}e.NotebookRange=Kt;class Oe{constructor(x,ue,De,Ge,Qe,Ze,rt){this.kind=x,this.value=ue,this.languageId=De,this.mime=Ge,this.outputs=Qe??[],this.metadata=Ze,this.executionSummary=rt,Oe.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(ue=>Oe.isNotebookCellData(ue))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Oe;class ci{constructor(x){this.cells=x}}e.NotebookData=ci;class Ot{constructor(x,ue){this.data=x,this.mime=ue;const De=(0,C.normalizeMimeType)(ue,!0);if(!De)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(x){return x instanceof Ot?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const ue={name:x.name,message:x.message,stack:x.stack};return Ot.json(ue,"application/vnd.code.notebook.error")}static stdout(x){return Ot.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return Ot.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,ue="application/octet-stream"){return new Ot(x,ue)}static text(x,ue=C.Mimes.text){const De=ke(Ot,d,"f",p).encode(String(x));return new Ot(De,ue)}static json(x,ue="text/x-json"){const De=JSON.stringify(x,void 0,"	");return Ot.text(De,ue)}}e.NotebookCellOutputItem=Ot,d=Ot,p={value:new TextEncoder};class ft{constructor(x,ue,De){this.items=ft.ensureUniqueMimeTypes(x,!0),typeof ue=="string"?(this.id=ue,this.metadata=De):(this.id=(0,O.generateUuid)(),this.metadata=ue??De)}static isNotebookCellOutput(x){return x instanceof ft?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&(0,S.isArray)(x.items)}static ensureUniqueMimeTypes(x,ue=!1){const De=new Set,Ge=new Set;for(let Qe=0;Qe<x.length;Qe++){const Ze=x[Qe],rt=(0,C.normalizeMimeType)(Ze.mime);if(!De.has(rt)){De.add(rt);continue}Ge.add(Qe),ue&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ge.size===0?x:x.filter((Qe,Ze)=>!Ge.has(Ze))}}e.NotebookCellOutput=ft;var Ti;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Ti=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(x,ue){this.text=x,this.alignment=ue}}e.NotebookCellStatusBarItem=Ri;var Li;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Li=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(x,ue=[]){this.uri=x,this.provides=(0,f.asArray)(ue)}}e.NotebookRendererScript=Oi;let ui=class{constructor(x,ue){this.label=x,this.timestamp=ue}};ui=Be([F],ui),e.TimelineItem=ui;var wi;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(wi=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Mi{constructor(x,ue){this.ranges=x,this.wordPattern=ue}}e.LinkedEditingRanges=Mi;class Ui{constructor(x,ue){this._port=x,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var ce;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ce=e.TestRunProfileKind||(e.TestRunProfileKind={}));let fe=class{constructor(x=void 0,ue=void 0,De=void 0){this.include=x,this.exclude=ue,this.profile=De}};fe=Be([F],fe),e.TestRunRequest=fe;let Pe=w=class{constructor(x){this.message=x}static diff(x,ue,De){const Ge=new w(x);return Ge.expectedOutput=ue,Ge.actualOutput=De,Ge}};Pe=w=Be([F],Pe),e.TestMessage=Pe;let tt=class{constructor(x){this.id=x}};tt=Be([F],tt),e.TestTag=tt;let gt=class{constructor(x,ue){this.covered=x,this.total=ue}};gt=Be([F],gt),e.CoveredCount=gt;let It=A=class{constructor(x,ue,De,Ge){this.uri=x,this.statementCoverage=ue,this.branchCoverage=De,this.functionCoverage=Ge}static fromDetails(x,ue){const De=new gt(0,0),Ge=new gt(0,0),Qe=new gt(0,0);for(const rt of ue)if("branches"in rt){De.total+=1,De.covered+=rt.executionCount>0?1:0;for(const Dt of rt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=rt.executionCount>0?1:0;const Ze=new A(x,De,Ge.total>0?Ge:void 0,Qe.total>0?Qe:void 0);return Ze.detailedCoverage=ue,Ze}};It=A=Be([F],It),e.FileCoverage=It;let Wi=class{constructor(x,ue,De=[]){this.executionCount=x,this.location=ue,this.branches=De}};Wi=Be([F],Wi),e.StatementCoverage=Wi;let zi=class{constructor(x,ue){this.executionCount=x,this.location=ue}};zi=Be([F],zi),e.BranchCoverage=zi;let Hi=class{constructor(x,ue){this.executionCount=x,this.location=ue}};Hi=Be([F],Hi),e.FunctionCoverage=Hi;var Ki;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(x,ue,De,Ge,Qe,Ze){this.kind=x,this.name=ue,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.TypeHierarchyItem=Yi}),define(pe[125],ve([1,0,55,10,8,151,107,7,18]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const L=new Map;function O(g,d){d?L.set(g,d):L.delete(g)}e.setWordDefinitionFor=O;function y(g){return L.get(g)}e.getWordDefinitionFor=y;class v extends T.MirrorTextModel{constructor(d,p,P,_,o,c,u,l){super(p,P,_,o);this._proxy=d,this._languageId=c,this._isDirty=u,this._notebook=l,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,S.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===n.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(p){return p?d._getTextInRange(p):d.getText()},get eol(){return d._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(p){return d._lineAt(p)},offsetAt(p){return d._offsetAt(p)},positionAt(p){return d._positionAt(p)},validateRange(p){return d._validateRange(p)},validatePosition(p){return d._validatePosition(p)},getWordRangeAtPosition(p,P){return d._getWordRangeAtPosition(p,P)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,f.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,f.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const p=this._validateRange(d);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const P=this._eol,_=p.start.line,o=p.end.line,c=[];c.push(this._lines[_].substring(p.start.character));for(let u=_+1;u<o;u++)c.push(this._lines[u]);return c.push(this._lines[o].substring(0,p.end.character)),c.join(P)}_lineAt(d){let p;if(d instanceof k.Position?p=d.line:typeof d=="number"&&(p=d),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new b(p,this._lines[p],p===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(d),P=this._lines[p.index].length;return new k.Position(p.index,Math.min(p.remainder,P))}_validateRange(d){if(!(d instanceof k.Range))throw new Error("Invalid argument");const p=this._validatePosition(d.start),P=this._validatePosition(d.end);return p===d.start&&P===d.end?d:new k.Range(p.line,p.character,P.line,P.character)}_validatePosition(d){if(!(d instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:p,character:P}=d,_=!1;if(p<0)p=0,P=0,_=!0;else if(p>=this._lines.length)p=this._lines.length-1,P=this._lines[p].length,_=!0;else{const o=this._lines[p].length;P<0?(P=0,_=!0):P>o&&(P=o,_=!0)}return _?new k.Position(p,P):d}_getWordRangeAtPosition(d,p){const P=this._validatePosition(d);if(!p)p=y(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const _=(0,C.getWordAtText)(P.character+1,(0,C.ensureValidWordDefinition)(p),this._lines[P.line],0);if(_)return new k.Range(P.line,_.startColumn-1,P.line,_.endColumn-1)}}e.ExtHostDocumentData=v;class b{constructor(d,p,P){this._line=d,this._text=p,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(pe[202],ve([1,0,7,3,110,6,108,24,2,32]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class O{constructor(v,b,g,d){this._notebook=g,this._selector=d,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,L.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(P=>{const _=this._cellUris.get(P.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(v.onDidChangeNotebookCells(P=>p(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const v=[],b=[];for(const g of this._notebook.getCells())g.kind===f.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,g.document.uri,g.document.languageId,!0,void 0))&&(this._cellUris.set(g.document.uri,this._cells.length),this._cells.push(g),v.push(g.document.getText().length+1),b.push(g.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(v)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(v){if(!v){let _="";for(const o of this._cells)_+=o.document.getText()+`
`;return _=_.slice(0,-1),_}if(v.isEmpty)return"";const b=this.locationAt(v.start),g=this.locationAt(v.end),d=this._cellUris.get(b.uri),p=this._cellUris.get(g.uri);if(d===void 0||p===void 0)return"";if(d===p)return this._cells[d].document.getText(new f.Range(b.range.start,g.range.end));const P=[this._cells[d].document.getText(new f.Range(b.range.start,new f.Position(this._cells[d].document.lineCount,0)))];for(let _=d+1;_<p;_++)P.push(this._cells[_].document.getText());return P.push(this._cells[p].document.getText(new f.Range(new f.Position(0,0),g.range.end))),P.join(`
`)}offsetAt(v){const b=this._cellLines.getIndexOf(v.line),g=this._cellLengths.getPrefixSum(b.index-1),d=this._cells[b.index].document.offsetAt(v.with(b.remainder));return g+d}positionAt(v){if(typeof v=="number"){const g=this._cellLengths.getIndexOf(v),d=this._cellLines.getPrefixSum(g.index-1);return this._cells[g.index].document.positionAt(g.remainder).translate(d)}const b=this._cellUris.get(v.uri);if(b!==void 0){const g=this._cellLines.getPrefixSum(b-1);return new f.Position(g+v.range.start.line,v.range.start.character)}return new f.Position(0,0)}locationAt(v){f.Range.isRange(v)||(v=new f.Range(v,v));const b=this._cellLines.getIndexOf(v.start.line);let g=b;v.isEmpty||(g=this._cellLines.getIndexOf(v.end.line));const d=new f.Position(b.remainder,v.start.character),p=new f.Position(g.remainder,v.end.character),P=new f.Range(d,p),_=this._cells[b.index];return new f.Location(_.document.uri,_.document.validateRange(P))}contains(v){return this._cellUris.has(v)}validateRange(v){const b=this.validatePosition(v.start),g=this.validatePosition(v.end);return v.with(b,g)}validatePosition(v){const b=this._cellLines.getIndexOf(v.line),g=new f.Position(b.remainder,v.character),d=this._cells[b.index].document.validatePosition(g),p=this._cellLines.getPrefixSum(b.index-1);return new f.Position(p+d.line,d.character)}}e.ExtHostNotebookConcatDocument=O}),define(pe[203],ve([1,0,7,17,3]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?f.ColorThemeKind.Light:k==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([Fe(0,n.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(pe[63],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class n{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=n}),define(pe[204],ve([1,0,22]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class n{constructor(){this.buffers=[]}add(S){let L=this.buffers.indexOf(S);return L<0&&(L=this.buffers.length,this.buffers.push(S)),L}}function I(k,S){if(S.serializeBuffersForPostMessage){const L=new n,O=(b,g)=>{if(g instanceof ArrayBuffer){const d=L.add(g);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(g)){const d=T(g);if(d){const p=L.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},y=JSON.stringify(k,O),v=L.buffers.map(b=>{const g=new Uint8Array(b);return f.VSBuffer.wrap(g)});return{message:y,buffers:v}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function T(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(k,S){const L=S.map(v=>{const b=new ArrayBuffer(v.byteLength);return new Uint8Array(b).set(v.buffer),b}),O=S.length?(v,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:d}=g,p=L[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(p,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return b}:void 0;return{message:JSON.parse(k,O),arrayBuffers:L}}e.deserializeWebviewMessage=C}),define(pe[205],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(n){function I(C){const k=new Map;return C.types.forEach((S,L)=>{k.set(S,{asString:async()=>C.items[L].asString,value:void 0})}),k}n.toITreeDataTransfer=I;async function T(C){const k={types:[],items:[]},S=Array.from(C.entries());for(const L of S)k.types.push(L[0]),k.items.push({asString:await L[1].asString()});return k}n.toTreeDataTransferDTO=T})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[206],ve([1,0,101]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(T){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:T,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function I(T){return new f.URITransformer(n(T))}e.createURITransformer=I}),define(pe[207],ve([1,0,175,13,2,6,4,50,42,18,10]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(y=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var v;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(v=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b(G){const U=G;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}e.isEditorPaneWithSelection=b;function g(G,U,W){for(const ee of W.visibleEditorPanes)if(ee.group.id===U&&G.matches(ee.input))return ee.getViewState()}e.findViewStateForEditor=g;function d(G){if(E(G))return!1;const U=G;return I.URI.isUri(U?.resource)}e.isResourceEditorInput=d;function p(G){if(E(G))return!1;const U=G;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=p;function P(G){if(E(G)||p(G))return!1;const U=G;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=P;function _(G){if(E(G))return!1;const U=G;return U?U.resource===void 0||U.resource.scheme===O.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var o;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var c;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));var u;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends T.Disposable{}e.AbstractEditorInput=l;function E(G){return G instanceof l}e.isEditorInput=E;function s(G){const U=G;return I.URI.isUri(U?.preferredResource)}function t(G){const U=G;return E(U?.primary)&&E(U?.secondary)}e.isSideBySideEditorInput=t;function r(G){const U=G;return E(U?.modified)&&E(U?.original)}e.isDiffEditorInput=r;function i(G){return E(G?.editor)}e.isEditorInputWithOptions=i;function a(G){const U=G;return i(G)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=a;function m(G){const U=G;return typeof U?.groupId=="number"&&E(U.editor)}e.isEditorIdentifier=m;var h;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var w;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(w=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var A;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(A=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(U,W){if(!U)return;if(W?.supportSideBySide){const{primary:Z,secondary:V}=this.getSideEditors(U);if(Z&&V){if(W?.supportSideBySide===A.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===A.ANY)return this.getOriginalUri(Z,{filterByScheme:W.filterByScheme})??this.getOriginalUri(V,{filterByScheme:W.filterByScheme});U=W.supportSideBySide===A.PRIMARY?Z:V}}if(p(U)||P(U))return;const ee=s(U)?U.preferredResource:U.resource;return!ee||!W||!W.filterByScheme?ee:this.filterUri(ee,W.filterByScheme)}getSideEditors(U){return t(U)||P(U)?{primary:U.primary,secondary:U.secondary}:r(U)||p(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,W){if(!U)return;if(W?.supportSideBySide){const{primary:Z,secondary:V}=this.getSideEditors(U);if(Z&&V){if(W?.supportSideBySide===A.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===A.ANY)return this.getCanonicalUri(Z,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:W.filterByScheme});U=W.supportSideBySide===A.PRIMARY?Z:V}}if(p(U)||P(U))return;const ee=U.resource;return!ee||!W||!W.filterByScheme?ee:this.filterUri(ee,W.filterByScheme)}filterUri(U,W){if(Array.isArray(W)){if(W.some(ee=>U.scheme===ee))return U}else if(W===U.scheme)return U}}e.EditorResourceAccessor=new F;var R;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(R=e.CloseDirection||(e.CloseDirection={}));class D{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const W=this.instantiationService=U.get(C.IInstantiationService);for(const[ee,Z]of this.editorSerializerConstructors)this.createEditorSerializer(ee,Z,W);this.editorSerializerConstructors.clear()}createEditorSerializer(U,W,ee){const Z=ee.createInstance(W);this.editorSerializerInstances.set(U,Z)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,W){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,W,this.instantiationService):this.editorSerializerConstructors.set(U,W),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new D);async function $(G,U){if(!G||!G.length)return[];const W=await Promise.all(G.map(async ee=>{const Z=I.URI.revive(ee.fileUri);if(!Z||!await U.canHandleResource(Z))return;let J=ee.exists,se=ee.type;if(typeof J!="boolean"||typeof se!="number")try{se=(await U.stat(Z)).isDirectory?S.FileType.Directory:S.FileType.Unknown,J=!0}catch{J=!1}if(!J&&ee.openOnlyIfExists||se===S.FileType.Directory)return;const ae={selection:J?ee.selection:void 0,pinned:!0,override:ee.editorOverrideId};let Q;return J?Q={resource:Z,options:ae}:Q={resource:Z,options:ae,forceUntitled:!0},Q}));return(0,L.coalesce)(W)}e.pathsToEditors=$;var M;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function q(G){const U=G;if(!U)return!1;const W=U;if(W.modified)return q(W.modified);const ee=U;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}e.isTextEditorViewState=q}),define(pe[83],ve([1,0,10,2]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,S){return k.scheme===f.Schemas.http||k.scheme===f.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===f.Schemas.file&&(k=n.URI.from({scheme:f.Schemas.vscodeRemote,authority:S.authority,path:k.path})),n.URI.from({scheme:f.Schemas.https,authority:`${k.scheme}+${T(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function T(k){return k.replace(/./g,S=>{const L=S.charCodeAt(0);return L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57?S:"-"+L.toString(16).padStart(4,"0")})}function C(k){return k.replace(/-([0-9a-f]{4})/g,(S,L)=>String.fromCharCode(parseInt(L,16)))}e.decodeAuthority=C}),define(pe[208],ve([1,0,3,6,83]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(k,S,L){this._proxy=k,this._editors=S,this._initData=L,this._handlePool=0,this._disposables=new n.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const O=S.getVisibleTextEditors();for(const y of this._insets.values())O.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,L,O,y){let v;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){v=o;break}if(!v)throw new Error("not a visible editor");const b=this,g=this._handlePool++,d=new f.Emitter,p=new f.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,I.asWebviewUri)(o,b._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(o){this._options=o,b._proxy.$setOptions(g,o)}get options(){return this._options}set html(o){this._html=o,b._proxy.$setHtml(g,o)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(o){return b._proxy.$postMessage(g,o)}},_=new class{constructor(){this.editor=k,this.line=S,this.height=L,this.webview=P,this.onDidDispose=p.event}dispose(){b._insets.has(g)&&(b._insets.delete(g),b._proxy.$disposeEditorInset(g),p.fire(),p.dispose(),d.dispose())}};return this._proxy.$createEditorInset(g,v.id,v.value.document.uri,S+1,L,O||{},y.identifier,y.extensionLocation),this._insets.set(g,{editor:k,inset:_,onDidReceiveMessage:d}),_}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const L=this._insets.get(k);L&&L.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=T}),define(pe[126],ve([1,0,3,16,176]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,L,O){const y={command:k};if(S&&Object.keys(S).length>0&&(y.arguments=S),this.internalSend("request",y),typeof O=="number"){const v=setTimeout(()=>{clearTimeout(v);const b=this.pendingRequests.get(y.seq);if(b){this.pendingRequests.delete(y.seq);const g={type:"response",seq:0,request_seq:y.seq,success:!1,command:k,message:(0,I.localize)(0,null,O,k)};b(g)}},O)}return L&&this.pendingRequests.set(y.seq,L),y.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,n.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const S=k,L=this.pendingRequests.get(S.request_seq);L&&(this.pendingRequests.delete(S.request_seq),L(S));break}}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,L)=>k.set(L,S)),await(0,n.timeout)(500),k.forEach((S,L)=>{S({type:"response",seq:0,request_seq:L,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(L)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(pe[209],ve([1,0,177,61,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new n.RawContextKey("debugType",void 0,{type:"string",description:f.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new n.RawContextKey("debugConfigurationType",void 0,{type:"string",description:f.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new n.RawContextKey("debugState","inactive",{type:"string",description:f.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new n.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:f.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new n.RawContextKey("inDebugMode",!1,{type:"boolean",description:f.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new n.RawContextKey("inDebugRepl",!1,{type:"boolean",description:f.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new n.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:f.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new n.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:f.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new n.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:f.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new n.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:f.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new n.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:f.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new n.RawContextKey("variablesFocused",!0,{type:"boolean",description:f.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new n.RawContextKey("expressionSelected",!1,{type:"boolean",description:f.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new n.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:f.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new n.RawContextKey("callStackItemType",void 0,{type:"string",description:f.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new n.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:f.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new n.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:f.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new n.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:f.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new n.RawContextKey("watchItemType",void 0,{type:"string",description:f.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new n.RawContextKey("canViewMemory",void 0,{type:"boolean",description:f.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new n.RawContextKey("breakpointItemType",void 0,{type:"string",description:f.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new n.RawContextKey("breakpointAccessType",void 0,{type:"string",description:f.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new n.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:f.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new n.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:f.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new n.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:f.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new n.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:f.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new n.RawContextKey("stepBackSupported",!1,{type:"boolean",description:f.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new n.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:f.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new n.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:f.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new n.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:f.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new n.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:f.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new n.RawContextKey("breakpointsExist",!1,{type:"boolean",description:f.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new n.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:f.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new n.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:f.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new n.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:f.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new n.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:f.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new n.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:f.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new n.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:f.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new n.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:f.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new n.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:f.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new n.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:f.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new n.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:f.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new n.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:f.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new n.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:f.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new n.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:f.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new n.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:f.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new n.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:f.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new n.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:f.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new n.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:f.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new n.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:f.localize(49,null)});const T=y=>f.localize(50,null,y);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:f.localize(51,null)};var C;(function(y){y[y.Inactive=0]="Inactive",y[y.Initializing=1]="Initializing",y[y.Stopped=2]="Stopped",y[y.Running=3]="Running"})(C=e.State||(e.State={}));function k(y){switch(y){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var S;(function(y){y[y.Valid=0]="Valid",y[y.Unreadable=1]="Unreadable",y[y.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var L;(function(y){y[y.Initial=1]="Initial",y[y.Dynamic=2]="Dynamic"})(L=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var O;(function(y){y[y.CONDITION=0]="CONDITION",y[y.HIT_COUNT=1]="HIT_COUNT",y[y.LOG_MESSAGE=2]="LOG_MESSAGE"})(O=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(pe[210],ve([1,0,8,2,9,25,10]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(s,t,r){return s.replace(k,function(i,a){return t&&a.length>0&&a[0]!=="_"?i:r&&r.hasOwnProperty(a)?r[a]:i})}e.formatPII=S;function L(s){const t={};for(const r of Object.keys(s))r.startsWith("!")||(t[r]=s[r]);return t}e.filterExceptionsFromTelemetry=L;function O(s){return s.configuration.request==="attach"&&!y(s)&&(!s.parentSession||O(s.parentSession))}e.isSessionAttach=O;function y(s){let t=s.configuration.type;if(!!t)return t==="vslsShare"&&(t=s.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(t,"extensionhost")||(0,f.equalsIgnoreCase)(t,"pwa-extensionhost")?s:s.parentSession?y(s.parentSession):void 0}e.getExtensionHostDebugSession=y;function v(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=v;function b(s,t,r){let i,a=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=m.exec(s);){const w=h.index+1,A=w+h[0].length;if(w<=t&&A>=r){i=h[0],a=w;break}}if(i){const w=/\w+/g;let A=null;for(;(A=w.exec(i))&&!(A.index+1+a+A[0].length>=r););A&&(i=i.substring(0,w.lastIndex))}return i?{start:a,end:a+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(s){return!!(s&&s.match(g))}e.isUri=d;function p(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(d(s.path))return n.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return n.URI.file(s.path)}return s.path}function P(s){if(typeof s.path=="object"){const t=n.URI.revive(s.path);if(t)return t.scheme===C.Schemas.file?t.fsPath:t.toString()}return s.path}function _(s,t){const r=t?p:P,i=(0,T.deepClone)(s);return c(i,(a,m)=>{a&&m&&(m.path=r(m))}),i}e.convertToDAPaths=_;function o(s,t){const r=t?p:P,i=(0,T.deepClone)(s);return c(i,(a,m)=>{!a&&m&&(m.path=r(m))}),i}e.convertToVSCPaths=o;function c(s,t){switch(s.type){case"event":{const r=s;switch(r.event){case"output":t(!1,r.body.source);break;case"loadedSource":t(!1,r.body.source);break;case"breakpoint":t(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=s;switch(r.command){case"setBreakpoints":t(!0,r.arguments.source);break;case"breakpointLocations":t(!0,r.arguments.source);break;case"source":t(!0,r.arguments.source);break;case"gotoTargets":t(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(i=>t(!1,i));break;default:break}break}case"response":{const r=s;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(i=>t(!1,i.source));break;case"loadedSources":r.body.sources.forEach(i=>t(!1,i));break;case"scopes":r.body.scopes.forEach(i=>t(!1,i.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(i=>t(!1,i.source));break;case"setBreakpoints":r.body.breakpoints.forEach(i=>t(!1,i.source));break;case"disassemble":{const i=r;i.body&&i.body.instructions.forEach(a=>t(!1,a.location))}break;default:break}break}}}function u(s){return s.filter(t=>!t.presentation?.hidden).sort((t,r)=>t.presentation?r.presentation?t.presentation.group?r.presentation.group?t.presentation.group!==r.presentation.group?t.presentation.group.localeCompare(r.presentation.group):l(t.presentation.order,r.presentation.order):-1:r.presentation.group?1:l(t.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=u;function l(s,t){return typeof s!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:s-t}async function E(s,t){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(r!=="none"&&(await t.saveAll(),r==="allEditorsInActiveGroup")){const i=t.activeEditorPane;i&&i.input.resource?.scheme===C.Schemas.untitled&&await t.save({editor:i.input,groupId:i.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(pe[211],ve([1,0,28,38,178,127,9,8,25,12,194,126]),function(te,e,f,n,I,T,C,k,S,L,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class v extends y.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",c=>this.handleData(c))}sendMessage(_){if(this.outputStream){const o=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${v.TWO_CRLF}${o}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+o))}continue}}else{const o=this.rawData.indexOf(v.TWO_CRLF);if(o!==-1){const u=this.rawData.toString("utf8",0,o).split(v.HEADER_LINESEPARATOR);for(const l of u){const E=l.split(v.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(o+v.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=v,v.TWO_CRLF=`\r
\r
`,v.HEADER_LINESEPARATOR=/\r?\n/,v.HEADER_FIELDSEPARATOR=/: */;class b extends v{startSession(){return new Promise((_,o)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",u=>{c?this._onError.fire(u):o(u)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class g extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=g;class d extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=d;class p extends v{constructor(_,o,c){super();this.adapterExecutable=_,this.debugType=o,this.outputService=c}async startSession(){const _=this.adapterExecutable.command,o=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(_)if(C.isAbsolute(_)){if(!await f.Promises.exists(_))throw new Error(I.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let u=process.env;if(c.env&&Object.keys(c.env).length>0&&(u=S.mixin(S.deepClone(process.env),c.env)),_==="node")if(Array.isArray(o)&&o.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:u,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const t=n.fork(o[0],o.slice(1),s);if(!t.pid)throw new Error(I.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(I.localize(3,null));else{const E={env:u};c.cwd&&(E.cwd=c.cwd),this.serverProcess=n.spawn(_,o,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,s)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const l=this.outputService;if(l){const E=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const t=l.getChannel(O.ExtensionsChannelId);t&&t.append(E(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(u){this._onError.fire(u)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),L.isWindows?new Promise((_,o)=>{const c=n.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(u,l,E){if(u)return o(u)});c.on("exit",_),c.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,o){if(!_)return;const c=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?c.runtime=C.join(o,_.runtime):c.runtime=_.runtime),_.runtimeArgs&&(c.runtimeArgs=_.runtimeArgs),_.program&&(C.isAbsolute(_.program)?c.program=_.program:c.program=C.join(o,_.program)),_.args&&(c.args=_.args);const u=_;return u.win&&(c.win=p.extract(u.win,o)),u.winx86&&(c.winx86=p.extract(u.winx86,o)),u.windows&&(c.windows=p.extract(u.windows,o)),u.osx&&(c.osx=p.extract(u.osx,o)),u.linux&&(c.linux=p.extract(u.linux,o)),c}static platformAdapterExecutable(_,o){let c=Object.create(null);o=o.toLowerCase();for(const r of _)if(r.contributes){const i=r.contributes.debuggers;i&&i.length>0&&i.filter(a=>typeof a.type=="string"&&k.equalsIgnoreCase(a.type,o)).forEach(a=>{const m=p.extract(a,r.extensionLocation.fsPath);c=S.mixin(c,m,r.isBuiltin)})}let u;L.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=c.winx86||c.win||c.windows:L.isWindows?u=c.win||c.windows:L.isMacintosh?u=c.osx:L.isLinux&&(u=c.linux),u=u||c;const l=u.program||c.program,E=u.args||c.args,s=u.runtime||c.runtime,t=u.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(t||[]).concat(typeof l=="string"?[l]:[]).concat(E||[])};if(l)return{type:"executable",command:l,args:E||[]}}}e.ExecutableDebugAdapter=p}),define(pe[212],ve([1,0,38,29,12]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function T(L,O){return new Promise((y,v)=>{let b="";const g=f.spawn(L,O);g.pid&&g.stdout.on("data",d=>{b+=d.toString()}),g.on("error",d=>{v(d)}),g.on("close",d=>{y(b)})})}async function C(L){if(L)if(I.isWindows){const O=await new Promise((y,v)=>{te(["windows-process-tree"],y,v)});return new Promise(y=>{O.getProcessTree(L,v=>{y(v.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(L)]).then(O=>{const y=O.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},O=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var k;(function(L){L[L.cmd=0]="cmd",L[L.powershell=1]="powershell",L[L.bash=2]="bash"})(k||(k={}));function S(L,O,y,v){L=L.trim().toLowerCase();let b;L.indexOf("powershell")>=0||L.indexOf("pwsh")>=0?b=1:L.indexOf("cmd.exe")>=0?b=0:L.indexOf("bash")>=0?b=2:I.isWindows?b=0:b=2;let g,d=" ";switch(b){case 1:if(g=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),y){const p=(0,n.getDriveLetter)(y);p&&(d+=`${p}:; `),d+=`cd ${g(y)}; `}if(v)for(const p in v){const P=v[p];P===null?d+=`Remove-Item env:${p}; `:d+=`\${env:${p}}='${P}'; `}if(O.length>0){const p=g(O.shift());d+=p[0]==="'"?`& ${p} `:`${p} `;for(const P of O)d+=`${g(P)} `}break;case 0:if(g=p=>(p=p.replace(/\"/g,'""'),p.indexOf(" ")>=0||p.indexOf('"')>=0||p.length===0?`"${p}"`:p),y){const p=(0,n.getDriveLetter)(y);p&&(d+=`${p}: && `),d+=`cd ${g(y)} && `}if(v){d+='cmd /C "';for(const p in v){let P=v[p];P===null?d+=`set "${p}=" && `:(P=P.replace(/[\^\&\|\<\>]/g,_=>`^${_}`),d+=`set "${p}=${P}" && `)}}for(const p of O)d+=`${g(p)} `;v&&(d+='"');break;case 2:{g=P=>(P=P.replace(/(["'\\\$])/g,"\\$1"),P.indexOf(" ")>=0||P.indexOf(";")>=0||P.length===0?`"${P}"`:P);const p=P=>/[^\w@%\/+=,.:^-]/.test(P)?`'${P.replace(/'/g,"'\\''")}'`:P;if(y&&(d+=`cd ${g(y)} ; `),v){d+="/usr/bin/env";for(const P in v){const _=v[P];_===null?d+=` -u ${p(P)}`:d+=` ${p(`${P}=${_}`)}`}d+=" "}for(const P of O)d+=`${g(P)} `;break}}return d}e.prepareCommand=S}),define(pe[128],ve([1,0,34,76,92,10,9,12,61]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var O;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(O=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeLanguage=5]="ChangeLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var P;(function(i){i.scheme=T.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function m(D,$){return D.with({scheme:i.scheme,fragment:`ch${$.toString().padStart(7,"0")}${D.scheme!==T.Schemas.file?D.scheme:""}`})}i.generate=m;function h(D){if(D.scheme!==i.scheme)return;const $=a.exec(D.fragment);return $?{handle:Number($[1]),notebook:D.with({scheme:D.fragment.substring($[0].length)||T.Schemas.file,fragment:null})}:void 0}i.parse=h;function w(D,$){return D.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${$??""},${D.scheme!==T.Schemas.file?D.scheme:""}`})}i.generateCellOutputUri=w;function A(D){if(D.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const $=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(D.fragment);if(!$)return;const M=$[1]&&$[1]!==""?$[1]:void 0,q=$[2];return{outputId:M,notebook:D.with({scheme:q||T.Schemas.file,fragment:null})}}i.parseCellOutputUri=A;function F(D,$,M){return D.with({scheme:M,fragment:`ch${$.toString().padStart(7,"0")}${D.scheme!==T.Schemas.file?D.scheme:""}`})}i.generateCellUri=F;function R(D,$){if(D.scheme!==$)return;const M=a.exec(D.fragment);return M?{handle:Number(M[1]),notebook:D.with({scheme:D.fragment.substring(M[0].length)||T.Schemas.file,fragment:null})}:void 0}i.parseCellUri=R})(P=e.CellUri||(e.CellUri={}));const _=i=>k.isWindows?i.replace(/\//g,"\\"):i;class o{constructor(a=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(a)].map(h=>({pattern:h,matches:f.parse(_(h))}))}sort(a){const m=new Map(n.Iterable.map(a,w=>[w,_(w)]));let h=[];for(const{matches:w}of this.order)for(const[A,F]of m)if(w(F)){h.push(A),m.delete(A);break}return m.size&&(h=h.concat([...m.keys()].sort((w,A)=>this.defaultOrder.indexOf(w)-this.defaultOrder.indexOf(A)))),h}prioritize(a,m){const h=this.findIndex(a);if(h===-1){this.order.unshift({pattern:a,matches:f.parse(_(a))});return}const w=new Set(m.map(F=>this.findIndex(F,h)));w.delete(-1);const A=Array.from(w).sort();this.order.splice(h+1,0,...A.map(F=>this.order[F]));for(let F=A.length-1;F>=0;F--)this.order.splice(A[F],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,m=this.order.length){const h=_(a);for(let w=0;w<m;w++)if(this.order[w].matches(h))return w;return-1}}e.MimeTypeDisplayOrder=o;function c(i,a,m,h=(w,A)=>w===A){const w=[];function A(D,$,M){if($===0&&M.length===0)return;const q=w[w.length-1];q&&q.start+q.deleteCount===D?(q.deleteCount+=$,q.toInsert.push(...M)):w.push({start:D,deleteCount:$,toInsert:M})}let F=0,R=0;for(;;){if(F===i.length){A(F,0,a.slice(R));break}if(R===a.length){A(F,i.length-F,[]);break}const D=i[F],$=a[R];if(h(D,$)){F+=1,R+=1;continue}m($)?(A(F,1,[]),F+=1):(A(F,0,[$]),R+=1)}return w}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(i){i.default="default",i.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(i){const a=i;return!!((typeof a.include=="string"||f.isRelativePattern(a.include))&&(typeof a.exclude=="string"||f.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=l;function E(i,a,m){if(Array.isArray(i.viewType)&&i.viewType.indexOf(a)>=0||i.viewType===a)return!0;if(i.filenamePattern){const h=l(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,w=l(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(f.match(h,(0,C.basename)(m.fsPath).toLowerCase()))return!(w&&f.match(w,(0,C.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=E;class s{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)a[m]=this.textModel.cells[m].getHashValue();return a}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var t;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(t=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(a){return`${r._prefix}${a}`}static parse(a){if(a.startsWith(r._prefix))return a.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(pe[213],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var n;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(n=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(pe[214],ve([1,0,4,61]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new n.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new n.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new n.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[215],ve([1,0,179,4,61]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,n.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[216],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function n(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=n}),define(pe[84],ve([1,0,2,35]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var T;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(T=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(r){r.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),r.deserialize=i=>({range:n.Range.lift(i.range),uri:f.URI.revive(i.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var S;(function(r){r.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&C.serialize(i.location)}),r.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&C.deserialize(i.location)})})(S=e.ITestErrorMessage||(e.ITestErrorMessage={}));var L;(function(r){r.serialize=i=>({message:i.message,type:1,offset:i.offset,location:i.location&&C.serialize(i.location)}),r.deserialize=i=>({message:i.message,type:1,offset:i.offset,location:i.location&&C.deserialize(i.location)})})(L=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(r){r.serialize=i=>i.type===0?S.serialize(i):L.serialize(i),r.deserialize=i=>i.type===0?S.deserialize(i):L.deserialize(i)})(O=e.ITestMessage||(e.ITestMessage={}));var y;(function(r){r.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(O.serialize)}),r.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(O.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",b=(r,i)=>r+v+i;e.namespaceTestTag=b;const g=r=>{const i=r.indexOf(v);return{ctrlId:r.slice(0,i),tagId:r.slice(i+1)}};e.denamespaceTestTag=g;var d;(function(r){r.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),r.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?f.URI.revive(i.uri):void 0,range:i.range?n.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(d=e.ITestItem||(e.ITestItem={}));var p;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(r){r.serialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:d.serialize(i.item)}),r.deserialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:d.deserialize(i.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var _;(function(r){r.serialize=i=>{let a;return i.item&&(a={},i.item.label!==void 0&&(a.label=i.item.label),i.item.tags!==void 0&&(a.tags=i.item.tags),i.item.busy!==void 0&&(a.busy=i.item.busy),i.item.uri!==void 0&&(a.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(a.range=i.item.range?.toJSON()),i.item.description!==void 0&&(a.description=i.item.description),i.item.error!==void 0&&(a.error=i.item.error),i.item.sortText!==void 0&&(a.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:a}},r.deserialize=i=>{let a;return i.item&&(a={},i.item.label!==void 0&&(a.label=i.item.label),i.item.tags!==void 0&&(a.tags=i.item.tags),i.item.busy!==void 0&&(a.busy=i.item.busy),i.item.range!==void 0&&(a.range=i.item.range?n.Range.lift(i.item.range):null),i.item.description!==void 0&&(a.description=i.item.description),i.item.error!==void 0&&(a.error=i.item.error),i.item.sortText!==void 0&&(a.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:a}}})(_=e.ITestItemUpdate||(e.ITestItemUpdate={}));const o=(r,i)=>{i.expand!==void 0&&(r.expand=i.expand),i.item!==void 0&&(r.item=r.item?Object.assign(r.item,i.item):i.item)};e.applyTestItemUpdate=o;var c;(function(r){r.serialize=(i,a)=>({...P.serialize(i),children:a,ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var l;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var E;(function(r){r.deserialize=i=>i.op===0?{op:i.op,item:P.deserialize(i.item)}:i.op===1?{op:i.op,item:_.deserialize(i.item)}:i,r.serialize=i=>i.op===0?{op:i.op,item:P.serialize(i.item)}:i.op===1?{op:i.op,item:_.serialize(i.item)}:i})(E=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(i){}update(i){}remove(i,a){}complete(){}}e.IncrementalChangeCollector=s;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const a=this.createChangeCollector();for(const m of i)switch(m.op){case 0:{const h=P.deserialize(m.item);if(h.parent){if(this.items.has(h.parent)){const w=this.items.get(h.parent);w.children.add(h.item.extId);const A=this.createItem(h,w);this.items.set(h.item.extId,A),a.add(A)}}else{const w=this.createItem(h);this.roots.add(w),this.items.set(h.item.extId,w),a.add(w)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=_.deserialize(m.item),w=this.items.get(h.extId);if(!w)break;h.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,h),a.update(w);break}case 2:{const h=this.items.get(m.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const w=[[m.itemId]];for(;w.length;)for(const A of w.pop()){const F=this.items.get(A);F&&(w.push(F.children),this.items.delete(A),a.remove(F,F!==h),F.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}a.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=t}),define(pe[85],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(T){T.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class I{constructor(C,k=C.length){if(this.path=C,this.viewEnd=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,k,S=C.parent){if(C.id===k)return new I([k]);let L=[C.id];for(let O=S;O&&O.id!==k;O=O.parent)L.push(O.id);return L.push(k),new I(L.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new I(C.split("\0"))}static join(C,k){return new I([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static compare(C,k){return C===k?0:k.startsWith(C+"\0")?2:C.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new I(this.path,C)}compare(C){if(typeof C=="string")return I.compare(this.toString(),C);for(let k=0;k<C.viewEnd&&k<this.viewEnd;k++)if(C.path[k]!==this.path[k])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=I}),define(pe[217],ve([1,0,9,41,13,25,12,100,180]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(y,v,b,g){this._contributedVariables=new Map,this._context=y,this._labelService=v,this._userHomePromise=b,g&&(this._envVariablesPromise=g.then(d=>this.prepareEnv(d)))}prepareEnv(y){if(C.isWindows){const v=Object.create(null);return Object.keys(y).forEach(b=>{v[b.toLowerCase()]=y[b]}),v}return y}resolveWithEnvironment(y,v,b){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},v?v.uri:void 0,b)}async resolveAsync(y,v){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,y?y.uri:void 0,v)}async resolveAnyBase(y,v,b,g){const d=T.deepClone(v);C.isWindows&&d.windows?Object.keys(d.windows).forEach(P=>d[P]=d.windows[P]):C.isMacintosh&&d.osx?Object.keys(d.osx).forEach(P=>d[P]=d.osx[P]):C.isLinux&&d.linux&&Object.keys(d.linux).forEach(P=>d[P]=d.linux[P]),delete d.windows,delete d.osx,delete d.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,y?y.uri:void 0,d,b,g)}async resolveAnyAsync(y,v,b){return this.resolveAnyBase(y,v,b)}async resolveAnyMap(y,v,b){const g=new Map;return{newConfig:await this.resolveAnyBase(y,v,b,g),resolvedVariables:g}}resolveWithInteractionReplace(y,v,b,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,b,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,v)}recursiveResolve(y,v,b,g,d){if(I.isString(b))return this.resolveString(y,v,b,g,d);if(I.isArray(b))return b.map(p=>this.recursiveResolve(y,v,p,g,d));if(I.isObject(b)){let p=Object.create(null);return Object.keys(b).forEach(P=>{const _=this.resolveString(y,v,P,g,d);p[_]=this.recursiveResolve(y,v,b[P],g,d)}),p}return b}resolveString(y,v,b,g,d){return b.replace(L.VARIABLE_REGEXP,(P,_)=>{if(_.includes(L.VARIABLE_LHS))return P;let o=this.evaluateSingleVariable(y,P,_,v,g);return d&&d.set(_,o),o!==P&&I.isString(o)&&o.match(L.VARIABLE_REGEXP)&&(o=this.resolveString(y,v,o,g,d)),o})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,v,b,g,d){let p;const P=b.split(":");P.length>1&&(b=P[0],p=P[1]);const _=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,S.localize)(0,null,v))},o=()=>{const u=_();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,S.localize)(1,null,v,f.basename(u)))},c=()=>{if(p){const u=this._context.getFolderUri(p);if(u)return u;throw new Error((0,S.localize)(2,null,v,p))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,v)):new Error((0,S.localize)(4,null,v))};switch(b){case"env":if(p){if(y.env){const u=y.env[C.isWindows?p.toLowerCase():p];if(I.isString(u))return u}return""}throw new Error((0,S.localize)(5,null,v));case"config":if(p){const u=this._context.getConfigurationValue(g,p);if(I.isUndefinedOrNull(u))throw new Error((0,S.localize)(6,null,v,p));if(I.isObject(u))throw new Error((0,S.localize)(7,null,v,p));return u}throw new Error((0,S.localize)(8,null,v));case"command":return this.resolveFromMap(v,p,d,"command");case"input":return this.resolveFromMap(v,p,d,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return g||p?(0,k.normalizeDriveLetter)(this.fsPath(c())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(c()));case"userHome":{if(y.userHome)return y.userHome;throw new Error((0,S.localize)(9,null,v))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,S.localize)(10,null,v))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,S.localize)(11,null,v))}case"file":return _();case"fileWorkspaceFolder":return o();case"relativeFile":return g||p?f.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":{const u=f.dirname(_());if(g||p){const l=f.relative(this.fsPath(c()),u);return l.length===0?".":l}return u}case"fileDirname":return f.dirname(_());case"fileExtname":return f.extname(_());case"fileBasename":return f.basename(_());case"fileBasenameNoExtension":{const u=f.basename(_());return u.slice(0,u.length-f.extname(u).length)}case"fileDirnameBasename":return f.basename(f.dirname(_()));case"execPath":{const u=this._context.getExecPath();return u||v}case"execInstallFolder":{const u=this._context.getAppRoot();return u||v}case"pathSeparator":return f.sep;default:try{const u=p?`${b}:${p}`:b;return this.resolveFromMap(v,u,d,void 0)}catch{return v}}}}resolveFromMap(y,v,b,g){if(v&&b){const d=g===void 0?b[v]:b[g+":"+v];if(typeof d=="string")return d;throw new Error((0,S.localize)(12,null,y))}return y}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[129],ve([1,0,4,207]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function L(g){const d=g;return(0,n.isEditorInput)(d?.editor)&&(0,n.isEditorInput)(d?.replacement)}e.isEditorReplacement=L;var O;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function v(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=v;function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(pe[218],ve([1,0,4,129]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(T){const C=T;return typeof T=="number"||(0,n.isEditorGroup)(C)}e.isPreferredGroup=I}),define(pe[14],ve([1,0,18,22,99,142,58,25,13,2,35,78,182,116,62,128,84,85,218,7]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(_e){function ye(ie){const{selectionStartLineNumber:Ie,selectionStartColumn:Ae,positionLineNumber:Ve,positionColumn:Xe}=ie,ht=new o.Position(Ie-1,Ae-1),Et=new o.Position(Ve-1,Xe-1);return new o.Selection(ht,Et)}_e.to=ye;function me(ie){const{anchor:Ie,active:Ae}=ie;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}_e.from=me})(c=e.Selection||(e.Selection={}));var u;(function(_e){function ye(ie){if(!ie)return;const{start:Ie,end:Ae}=ie;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}_e.from=ye;function me(ie){if(!ie)return;const{startLineNumber:Ie,startColumn:Ae,endLineNumber:Ve,endColumn:Xe}=ie;return new o.Range(Ie-1,Ae-1,Ve-1,Xe-1)}_e.to=me})(u=e.Range||(e.Range={}));var l;(function(_e){function ye(me){switch(me){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}_e.to=ye})(l=e.TokenType||(e.TokenType={}));var E;(function(_e){function ye(ie){return new o.Position(ie.lineNumber-1,ie.column-1)}_e.to=ye;function me(ie){return{lineNumber:ie.line+1,column:ie.character+1}}_e.from=me})(E=e.Position||(e.Position={}));var s;(function(_e){function ye(Ie,Ae){return(0,f.coalesce)((0,f.asArray)(Ie).map(Ve=>me(Ve,Ae)))}_e.from=ye;function me(Ie,Ae){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:ie(Ie.scheme,Ae),pattern:X.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType}}function ie(Ie,Ae){return Ae&&typeof Ie=="string"?Ae.transformOutgoingScheme(Ie):Ie}})(s=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(_e){function ye(ie){switch(ie){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}_e.from=ye;function me(ie){switch(ie){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}_e.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ye(ie){let Ie;return ie.code&&((0,S.isString)(ie.code)||(0,S.isNumber)(ie.code)?Ie=String(ie.code):Ie={value:String(ie.code.value),target:ie.code.target}),{...u.from(ie.range),message:ie.message,source:ie.source,code:Ie,severity:a.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(i.from),tags:Array.isArray(ie.tags)?(0,f.coalesce)(ie.tags.map(t.from)):void 0}}_e.from=ye;function me(ie){const Ie=new o.Diagnostic(u.to(ie),ie.message,a.to(ie.severity));return Ie.source=ie.source,Ie.code=(0,S.isString)(ie.code)?ie.code:ie.code?.value,Ie.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(i.to),Ie.tags=ie.tags&&(0,f.coalesce)(ie.tags.map(t.to)),Ie}_e.to=me})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(_e){function ye(ie){return{...u.from(ie.location.range),message:ie.message,resource:ie.location.uri}}_e.from=ye;function me(ie){return new o.DiagnosticRelatedInformation(new o.Location(ie.resource,u.to(ie)),ie.message)}_e.to=me})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(_e){function ye(ie){switch(ie){case o.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}_e.from=ye;function me(ie){switch(ie){case b.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}_e.to=me})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(_e){function ye(ie){return typeof ie=="number"&&ie>=o.ViewColumn.One?ie-1:ie===o.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}_e.from=ye;function me(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=me})(m=e.ViewColumn||(e.ViewColumn={}));function h(_e){return typeof _e.range!="undefined"}function w(_e){return _e.length===0?!0:!!h(_e[0])}e.isDecorationOptionsArr=w;var A;(function(_e){function ye(Xe){return Xe.map(_e.from)}_e.fromMany=ye;function me(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function ie(Xe){let ht;if(me(Xe)){const{language:dt,value:ut}=Xe;ht={value:"```"+dt+`
`+ut+"\n```\n"}}else o.MarkdownString.isMarkdownString(Xe)?ht={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?ht={value:Xe}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const St=dt=>{try{let ut=L.URI.parse(dt,!0);ut=ut.with({query:Ie(ut.query,Et)}),Et[dt]=ut}catch{}return""},ot=new T.marked.Renderer;return ot.link=St,ot.image=dt=>typeof dt=="string"?St(I.parseHrefAndDimensions(dt).href):"",(0,T.marked)(ht.value,{renderer:ot}),ht}_e.from=ie;function Ie(Xe,ht){if(!Xe)return Xe;let Et;try{Et=(0,C.parse)(Xe)}catch{}if(!Et)return Xe;let St=!1;return Et=(0,k.cloneAndChange)(Et,ot=>{if(L.URI.isUri(ot)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[dt]=ot,St=!0,dt}else return}),St?JSON.stringify(Et):Xe}function Ae(Xe){const ht=new o.MarkdownString(Xe.value,Xe.supportThemeIcons);return ht.isTrusted=Xe.isTrusted,ht.supportHtml=Xe.supportHtml,ht.baseUri=Xe.baseUri?L.URI.from(Xe.baseUri):void 0,ht}_e.to=Ae;function Ve(Xe){if(!!Xe)return typeof Xe=="string"?Xe:_e.from(Xe)}_e.fromStrict=Ve})(A=e.MarkdownString||(e.MarkdownString={}));function F(_e){return w(_e)?_e.map(ye=>({range:u.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?A.fromMany(ye.hoverMessage):ye.hoverMessage?A.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):_e.map(ye=>({range:u.from(ye)}))}e.fromRangeOrRangeWithMessage=F;function R(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?L.URI.file(_e):_e}e.pathOrURIToURI=R;var D;(function(_e){function ye(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?R(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}_e.from=ye})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(_e){function ye(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?R(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?D.from(me.before):void 0,after:me.after?D.from(me.after):void 0}}_e.from=ye})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(_e){function ye(me){if(typeof me=="undefined")return me;switch(me){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ye})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(_e){function ye(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?M.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?$.from(me.light):void 0,dark:me.dark?$.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?R(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?D.from(me.before):void 0,after:me.after?D.from(me.after):void 0}}_e.from=ye})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(_e){function ye(ie){return{text:ie.newText,eol:ie.newEol&&et.from(ie.newEol),range:u.from(ie.range)}}_e.from=ye;function me(ie){const Ie=new o.TextEdit(u.to(ie.range),ie.text);return Ie.newEol=typeof ie.eol=="undefined"?void 0:et.to(ie.eol),Ie}_e.to=me})(G=e.TextEdit||(e.TextEdit={}));var U;(function(_e){function ye(ie,Ie){const Ae={edits:[]};if(ie instanceof o.WorkspaceEdit)for(let Ve of ie._allEntries())Ve._type===1?Ae.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Ae.edits.push({_type:2,resource:Ve.uri,edit:G.from(Ve.edit),modelVersionId:Ie?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ae.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ae.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(vt.from)}});return Ae}_e.from=ye;function me(ie){const Ie=new o.WorkspaceEdit;for(const Ae of ie.edits)Ae.edit?Ie.replace(L.URI.revive(Ae.resource),u.to(Ae.edit.range),Ae.edit.text):Ie.renameFile(L.URI.revive(Ae.oldUri),L.URI.revive(Ae.newUri),Ae.options);return Ie}_e.to=me})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(_e){const ye=Object.create(null);ye[o.SymbolKind.File]=0,ye[o.SymbolKind.Module]=1,ye[o.SymbolKind.Namespace]=2,ye[o.SymbolKind.Package]=3,ye[o.SymbolKind.Class]=4,ye[o.SymbolKind.Method]=5,ye[o.SymbolKind.Property]=6,ye[o.SymbolKind.Field]=7,ye[o.SymbolKind.Constructor]=8,ye[o.SymbolKind.Enum]=9,ye[o.SymbolKind.Interface]=10,ye[o.SymbolKind.Function]=11,ye[o.SymbolKind.Variable]=12,ye[o.SymbolKind.Constant]=13,ye[o.SymbolKind.String]=14,ye[o.SymbolKind.Number]=15,ye[o.SymbolKind.Boolean]=16,ye[o.SymbolKind.Array]=17,ye[o.SymbolKind.Object]=18,ye[o.SymbolKind.Key]=19,ye[o.SymbolKind.Null]=20,ye[o.SymbolKind.EnumMember]=21,ye[o.SymbolKind.Struct]=22,ye[o.SymbolKind.Event]=23,ye[o.SymbolKind.Operator]=24,ye[o.SymbolKind.TypeParameter]=25;function me(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}_e.from=me;function ie(Ie){for(const Ae in ye)if(ye[Ae]===Ie)return Number(Ae);return o.SymbolKind.Property}_e.to=ie})(W=e.SymbolKind||(e.SymbolKind={}));var ee;(function(_e){function ye(ie){switch(ie){case o.SymbolTag.Deprecated:return 1}}_e.from=ye;function me(ie){switch(ie){case 1:return o.SymbolTag.Deprecated}}_e.to=me})(ee=e.SymbolTag||(e.SymbolTag={}));var Z;(function(_e){function ye(ie){return{name:ie.name,kind:W.from(ie.kind),tags:ie.tags&&ie.tags.map(ee.from),containerName:ie.containerName,location:Q.from(ie.location)}}_e.from=ye;function me(ie){const Ie=new o.SymbolInformation(ie.name,W.to(ie.kind),ie.containerName,Q.to(ie.location));return Ie.tags=ie.tags&&ie.tags.map(ee.to),Ie}_e.to=me})(Z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(_e){function ye(ie){const Ie={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),kind:W.from(ie.kind),tags:ie.tags?.map(ee.from)??[]};return ie.children&&(Ie.children=ie.children.map(ye)),Ie}_e.from=ye;function me(ie){const Ie=new o.DocumentSymbol(ie.name,ie.detail,W.to(ie.kind),u.to(ie.range),u.to(ie.selectionRange));return(0,f.isNonEmptyArray)(ie.tags)&&(Ie.tags=ie.tags.map(ee.to)),ie.children&&(Ie.children=ie.children.map(me)),Ie}_e.to=me})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(_e){function ye(ie){const Ie=new o.CallHierarchyItem(W.to(ie.kind),ie.name,ie.detail||"",L.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}_e.to=ye;function me(ie,Ie,Ae){if(Ie=Ie??ie._sessionId,Ae=Ae??ie._itemId,Ie===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ae,name:ie.name,detail:ie.detail,kind:W.from(ie.kind),uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(ee.from)}}_e.from=me})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var se;(function(_e){function ye(me){return new o.CallHierarchyIncomingCall(J.to(me.from),me.fromRanges.map(ie=>u.to(ie)))}_e.to=ye})(se=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ae;(function(_e){function ye(me){return new o.CallHierarchyOutgoingCall(J.to(me.to),me.fromRanges.map(ie=>u.to(ie)))}_e.to=ye})(ae=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(_e){function ye(ie){return{range:ie.range&&u.from(ie.range),uri:ie.uri}}_e.from=ye;function me(ie){return new o.Location(L.URI.revive(ie.uri),u.to(ie.range))}_e.to=me})(Q=e.location||(e.location={}));var Y;(function(_e){function ye(ie){const Ie=ie,Ae=ie;return{originSelectionRange:Ie.originSelectionRange?u.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Ae.uri,range:u.from(Ie.targetRange?Ie.targetRange:Ae.range),targetSelectionRange:Ie.targetSelectionRange?u.from(Ie.targetSelectionRange):void 0}}_e.from=ye;function me(ie){return{targetUri:L.URI.revive(ie.uri),targetRange:u.to(ie.range),targetSelectionRange:ie.targetSelectionRange?u.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?u.to(ie.originSelectionRange):void 0}}_e.to=me})(Y=e.DefinitionLink||(e.DefinitionLink={}));var oe;(function(_e){function ye(ie){return{range:u.from(ie.range),contents:A.fromMany(ie.contents)}}_e.from=ye;function me(ie){return new o.Hover(ie.contents.map(A.to),u.to(ie.range))}_e.to=me})(oe=e.Hover||(e.Hover={}));var de;(function(_e){function ye(ie){return{range:u.from(ie.range),expression:ie.expression}}_e.from=ye;function me(ie){return new o.EvaluatableExpression(u.to(ie.range),ie.expression)}_e.to=me})(de=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ee;(function(_e){function ye(ie){if(ie instanceof o.InlineValueText)return{type:"text",range:u.from(ie.range),text:ie.text};if(ie instanceof o.InlineValueVariableLookup)return{type:"variable",range:u.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ye;function me(ie){switch(ie.type){case"text":return{range:u.to(ie.range),text:ie.text};case"variable":return{range:u.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:u.to(ie.range),expression:ie.expression}}}_e.to=me})(Ee=e.InlineValue||(e.InlineValue={}));var Re;(function(_e){function ye(ie){return{frameId:ie.frameId,stoppedLocation:u.from(ie.stoppedLocation)}}_e.from=ye;function me(ie){return new o.InlineValueContext(ie.frameId,u.to(ie.stoppedLocation))}_e.to=me})(Re=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(_e){function ye(ie){return{range:u.from(ie.range),kind:ie.kind}}_e.from=ye;function me(ie){return new o.DocumentHighlight(u.to(ie.range),ie.kind)}_e.to=me})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(_e){function ye(me){switch(me){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}_e.to=ye})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var we;(function(_e){function ye(me){return{triggerKind:be.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}_e.to=ye})(we=e.CompletionContext||(e.CompletionContext={}));var H;(function(_e){function ye(ie){switch(ie){case o.CompletionItemTag.Deprecated:return 1}}_e.from=ye;function me(ie){switch(ie){case 1:return o.CompletionItemTag.Deprecated}}_e.to=me})(H=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(_e){const ye=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function me(Ae){return ye.get(Ae)??9}_e.from=me;const ie=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ie(Ae){return ie.get(Ae)??o.CompletionItemKind.Property}_e.to=Ie})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(_e){function ye(me,ie){const Ie=new o.CompletionItem(me.label);return Ie.insertText=me.insertText,Ie.kind=B.to(me.kind),Ie.tags=me.tags?.map(H.to),Ie.detail=me.detail,Ie.documentation=I.isMarkdownString(me.documentation)?A.to(me.documentation):me.documentation,Ie.sortText=me.sortText,Ie.filterText=me.filterText,Ie.preselect=me.preselect,Ie.commitCharacters=me.commitCharacters,O.Range.isIRange(me.range)?Ie.range=u.to(me.range):typeof me.range=="object"&&(Ie.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Ie.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Ie.insertText=new o.SnippetString(me.insertText):(Ie.insertText=me.insertText,Ie.textEdit=Ie.range instanceof o.Range?new o.TextEdit(Ie.range,Ie.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ie.additionalTextEdits=me.additionalTextEdits.map(Ae=>G.to(Ae))),Ie.command=ie&&me.command?ie.fromInternal(me.command):void 0,Ie}_e.to=ye})(N=e.CompletionItem||(e.CompletionItem={}));var z;(function(_e){function ye(ie){return{label:ie.label,documentation:A.fromStrict(ie.documentation)}}_e.from=ye;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?A.to(ie.documentation):ie.documentation}}_e.to=me})(z=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(_e){function ye(ie){return{label:ie.label,documentation:A.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(z.from):[],activeParameter:ie.activeParameter}}_e.from=ye;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?A.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(z.to):[],activeParameter:ie.activeParameter}}_e.to=me})(j=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function ye(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(j.from):[]}}_e.from=ye;function me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(j.to):[]}}_e.to=me})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(_e){function ye(me,ie){const Ie=new o.InlayHint(E.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Ce.to.bind(void 0,me)),ie.kind&&Te.to(ie.kind));return Ie.textEdits=ie.textEdits&&ie.textEdits.map(G.to),Ie.tooltip=I.isMarkdownString(ie.tooltip)?A.to(ie.tooltip):ie.tooltip,Ie.paddingLeft=ie.paddingLeft,Ie.paddingRight=ie.paddingRight,Ie}_e.to=ye})(he=e.InlayHint||(e.InlayHint={}));var Ce;(function(_e){function ye(me,ie){const Ie=new o.InlayHintLabelPart(ie.label);return Ie.tooltip=I.isMarkdownString(ie.tooltip)?A.to(ie.tooltip):ie.tooltip,y.Command.is(ie.command)&&(Ie.command=me.fromInternal(ie.command)),ie.location&&(Ie.location=Q.to(ie.location)),Ie}_e.to=ye})(Ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Te;(function(_e){function ye(ie){return ie}_e.from=ye;function me(ie){return ie}_e.to=me})(Te=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(_e){function ye(ie){return{range:u.from(ie.range),url:ie.target,tooltip:ie.tooltip}}_e.from=ye;function me(ie){let Ie;if(ie.url)try{Ie=typeof ie.url=="string"?L.URI.parse(ie.url,!0):L.URI.revive(ie.url)}catch{}return new o.DocumentLink(u.to(ie.range),Ie)}_e.to=me})(We=e.DocumentLink||(e.DocumentLink={}));var ze;(function(_e){function ye(ie){const Ie=new o.ColorPresentation(ie.label);return ie.textEdit&&(Ie.textEdit=G.to(ie.textEdit)),ie.additionalTextEdits&&(Ie.additionalTextEdits=ie.additionalTextEdits.map(Ae=>G.to(Ae))),Ie}_e.to=ye;function me(ie){return{label:ie.label,textEdit:ie.textEdit?G.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ie=>G.from(Ie)):void 0}}_e.from=me})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(_e){function ye(ie){return new o.Color(ie[0],ie[1],ie[2],ie[3])}_e.to=ye;function me(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}_e.from=me})(qe=e.Color||(e.Color={}));var He;(function(_e){function ye(ie){return{range:u.from(ie.range)}}_e.from=ye;function me(ie){return new o.SelectionRange(u.to(ie.range))}_e.to=me})(He=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(_e){function ye(me){switch(me){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}_e.to=ye})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function ye(ie){switch(ie){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ye;function me(ie){switch(ie){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}_e.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(_e){function ye(ie){if(ie===o.EndOfLine.CRLF)return 1;if(ie===o.EndOfLine.LF)return 0}_e.from=ye;function me(ie){if(ie===1)return o.EndOfLine.CRLF;if(ie===0)return o.EndOfLine.LF}_e.to=me})(et=e.EndOfLine||(e.EndOfLine={}));var Le;(function(_e){function ye(me){if(typeof me=="object")return me.viewId;switch(me){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ye})(Le=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(_e){function ye(me){const ie={start:me.start+1,end:me.end+1};return me.kind&&(ie.kind=ne.from(me.kind)),ie}_e.from=ye})(it=e.FoldingRange||(e.FoldingRange={}));var ne;(function(_e){function ye(me){if(me)switch(me){case o.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}_e.from=ye})(ne=e.FoldingRangeKind||(e.FoldingRangeKind={}));var le;(function(_e){function ye(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?v.EditorResolution.DISABLED:void 0}}_e.from=ye})(le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(_e){function ye(Ae){return Ae instanceof o.RelativePattern?Ae.toJSON():typeof Ae=="string"?Ae:me(Ae)||ie(Ae)?new o.RelativePattern(Ae.baseUri??Ae.base,Ae.pattern).toJSON():Ae}_e.from=ye;function me(Ae){const Ve=Ae;return Ve?L.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function ie(Ae){const Ve=Ae;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ie(Ae){return typeof Ae=="string"?Ae:new o.RelativePattern(L.URI.revive(Ae.baseUri),Ae.pattern)}_e.to=Ie})(X=e.GlobPattern||(e.GlobPattern={}));var ge;(function(_e){function ye(me){if(me){if(Array.isArray(me))return me.map(ye);if(typeof me=="string")return me;{const ie=me;return{language:ie.language,scheme:ie.scheme,pattern:X.from(ie.pattern),exclusive:ie.exclusive}}}else return}_e.from=ye})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(_e){function ye(ie){return{start:ie.start,end:ie.end}}_e.from=ye;function me(ie){return new o.NotebookRange(ie.start,ie.end)}_e.to=me})(Se=e.NotebookRange||(e.NotebookRange={}));var Me;(function(_e){function ye(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}_e.to=ye;function me(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}_e.from=me})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(_e){function ye(me){if(me===d.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;if(me===d.NotebookCellExecutionState.Pending)return o.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${me}`)}_e.to=ye})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(_e){function ye(ie){switch(ie){case o.NotebookCellKind.Markup:return d.CellKind.Markup;case o.NotebookCellKind.Code:default:return d.CellKind.Code}}_e.from=ye;function me(ie){switch(ie){case d.CellKind.Markup:return o.NotebookCellKind.Markup;case d.CellKind.Code:default:return o.NotebookCellKind.Code}}_e.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var lt;(function(_e){function ye(ie){const Ie={metadata:ie.metadata??Object.create(null),cells:[]};for(let Ae of ie.cells)o.NotebookCellData.validate(Ae),Ie.cells.push(vt.from(Ae));return Ie}_e.from=ye;function me(ie){const Ie=new o.NotebookData(ie.cells.map(vt.to));return(0,S.isEmptyObject)(ie.metadata)||(Ie.metadata=ie.metadata),Ie}_e.to=me})(lt=e.NotebookData||(e.NotebookData={}));var vt;(function(_e){function ye(ie){return{cellKind:Ye.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Me.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(je.from):[]}}_e.from=ye;function me(ie){return new o.NotebookCellData(Ye.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(je.to):void 0,ie.metadata,ie.internalMetadata?Me.to(ie.internalMetadata):void 0)}_e.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(_e){function ye(ie){return{mime:ie.mime,valueBytes:n.VSBuffer.wrap(ie.data)}}_e.from=ye;function me(ie){return new o.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}_e.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(_e){function ye(ie){return{outputId:ie.id,items:ie.items.map(wt.from),metadata:ie.metadata}}_e.from=ye;function me(ie){const Ie=ie.items.map(wt.to);return new o.NotebookCellOutput(Ie,ie.outputId,ie.metadata)}_e.to=me})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(_e){function ye(Ie){return ie(Ie)?{include:(0,S.withNullAsUndefined)(X.from(Ie.include)),exclude:(0,S.withNullAsUndefined)(X.from(Ie.exclude))}:(0,S.withNullAsUndefined)(X.from(Ie))}_e.from=ye;function me(Ie){return ie(Ie)?{include:X.to(Ie.include),exclude:X.to(Ie.exclude)}:X.to(Ie)}_e.to=me;function ie(Ie){const Ae=Ie;return Ae?!!Ae.include&&!!Ae.exclude:!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function ye(me){return{backgroundColor:me.backgroundColor,borderColor:me.borderColor,top:me.top?D.from(me.top):void 0}}_e.from=ye})(_t=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(_e){function ye(me,ie,Ie){const Ae=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Ae,Ie),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}_e.from=ye})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ct;(function(_e){function ye(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}_e.from=ye})(ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Rt;(function(_e){function ye(ie){return{uri:ie.uri,provides:ie.provides}}_e.from=ye;function me(ie){return new o.NotebookRendererScript(L.URI.revive(ie.uri),ie.provides)}_e.to=me})(Rt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(_e){function ye(ie){return{message:A.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location&&{range:u.from(ie.location.range),uri:ie.location.uri}}}_e.from=ye;function me(ie){const Ie=new o.TestMessage(typeof ie.message=="string"?ie.message:A.to(ie.message));return Ie.actualOutput=ie.actual,Ie.expectedOutput=ie.expected,Ie.location=ie.location?Q.to(ie.location):void 0,Ie}_e.to=me})(Tt=e.TestMessage||(e.TestMessage={}));var yt;(function(_e){_e.namespace=p.namespaceTestTag,_e.denamespace=p.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var mt;(function(_e){function ye(Ae){const Ve=(0,g.getPrivateApiFor)(Ae).controllerId;return{extId:P.TestId.fromExtHostTestItem(Ae,Ve).toString(),label:Ae.label,uri:L.URI.revive(Ae.uri),busy:!1,tags:Ae.tags.map(Xe=>yt.namespace(Ve,Xe.id)),range:O.Range.lift(u.from(Ae.range)),description:Ae.description||null,sortText:Ae.sortText||null,error:Ae.error&&A.fromStrict(Ae.error)||null}}_e.from=ye;function me(Ae){return{parent:void 0,error:void 0,id:P.TestId.fromString(Ae.extId).localId,label:Ae.label,uri:L.URI.revive(Ae.uri),tags:(Ae.tags||[]).map(Ve=>{const{tagId:Xe}=yt.denamespace(Ve);return new o.TestTag(Xe)}),range:u.to(Ae.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ae.description||void 0,sortText:Ae.sortText||void 0}}_e.toPlain=me;function ie(Ae){const Ve=P.TestId.fromString(Ae.extId),Xe=new g.TestItemImpl(Ve.controllerId,Ve.localId,Ae.label,L.URI.revive(Ae.uri)||void 0);return Xe.range=u.to(Ae.range||void 0),Xe.description=Ae.description||void 0,Xe.sortText=Ae.sortText||void 0,Xe}function Ie(Ae){let Ve;for(const Xe of Ae.tests){const ht=ie(Xe.item);(0,g.getPrivateApiFor)(ht).parent=Ve,Ve=ht}return Ve}_e.toItemFromContext=Ie})(mt=e.TestItem||(e.TestItem={})),function(_e){function ye(ie){return{id:ie.id}}_e.from=ye;function me(ie){return new o.TestTag(ie.id)}_e.to=me}(yt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){const ye=(ie,Ie)=>{const Ae={...mt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(Xe=>Xe.type===0).map(Tt.to)})),children:ie.children.map(Ve=>Ie.get(Ve)).filter(S.isDefined).map(Ve=>ye(Ve,Ie))};for(const Ve of Ae.children)Ve.parent=Ae;return Ae};function me(ie){const Ie=[],Ae=new Map;for(const Ve of ie.items)Ae.set(Ve.item.extId,Ve),ie.request.targets.some(Xe=>Xe.controllerId===Ve.controllerId&&Xe.testIds.includes(Ve.item.extId))&&Ie.push(Ve);return{completedAt:ie.completedAt,results:Ie.map(Ve=>ye(Ve,Ae))}}_e.to=me})(Lt=e.TestResults||(e.TestResults={}));var Mt;(function(_e){function ye(Ae){return{covered:Ae.covered,total:Ae.covered}}function me(Ae){return"line"in Ae?E.from(Ae):u.from(Ae)}function ie(Ae){return"branches"in Ae?{count:Ae.executionCount,location:me(Ae.location),type:1,branches:Ae.branches.length?Ae.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&me(Ve.location)})):void 0}:{type:0,count:Ae.executionCount,location:me(Ae.location)}}_e.fromDetailed=ie;function Ie(Ae){return{uri:Ae.uri,statement:ye(Ae.statementCoverage),branch:Ae.branchCoverage&&ye(Ae.branchCoverage),function:Ae.functionCoverage&&ye(Ae.functionCoverage),details:Ae.detailedCoverage?.map(ie)}}_e.fromFile=Ie})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(_e){function ye(me){switch(me){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}_e.to=ye})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(_e){function ye(ie){const Ie=new o.TypeHierarchyItem(W.to(ie.kind),ie.name,ie.detail||"",L.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}_e.to=ye;function me(ie,Ie,Ae){if(Ie=Ie??ie._sessionId,Ae=Ae??ie._itemId,Ie===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ae,kind:W.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(ee.from)}}_e.from=me})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[219],ve([1,0,2,15,7,14,90]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(L,O,y,v={timeout:1500,errors:3}){this._logService=L,this._documents=O,this._mainThreadBulkEdits=y,this._thresholds=v,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(L){return(O,y,v)=>{const g={dispose:this._callbacks.push([O,y,L])};return Array.isArray(v)&&v.push(g),g}}async $participateInSave(L,O){const y=f.URI.revive(L);let v=!1;const b=setTimeout(()=>v=!0,this._thresholds.timeout),g=[];try{for(let d of[...this._callbacks]){if(v)break;const p=this._documents.getDocument(y),P=await this._deliverEventAsyncAndBlameBadListeners(d,{document:p,reason:T.TextDocumentSaveReason.to(O)});g.push(P)}}finally{clearTimeout(b)}return g}_deliverEventAsyncAndBlameBadListeners([L,O,y],v){const b=this._badListeners.get(L);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,L,O,v).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this._badListeners.get(L);this._badListeners.set(L,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(L,O,y,v){const b=[],g=Date.now(),{document:d,reason:p}=v,{version:P}=d,_=Object.freeze({document:d,reason:p,waitUntil(o){if(Object.isFrozen(b))throw(0,n.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{O.apply(y,[_])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,c)=>{const u=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${L.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(u),o(l)}).catch(l=>{clearTimeout(u),c(l)})}).then(o=>{const c={edits:[]};for(const u of o)if(Array.isArray(u)&&u.every(l=>l instanceof I.TextEdit))for(const{newText:l,newEol:E,range:s}of u)c.edits.push({_type:2,resource:d.uri,edit:{range:s&&T.Range.from(s),text:l,eol:E&&T.EndOfLine.from(E)}});if(c.edits.length!==0)return P===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(pe[220],ve([1,0,10,25,2,14,128]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(y,v,b,g){this.start=y,this.deletedCount=v,this.deletedItems=b,this.items=g}static asApiEvents(y){return y.map(v=>({start:v.start,deletedCount:v.deletedCount,deletedItems:v.deletedItems,items:v.items.map(b=>b.apiCell)}))}}class S{constructor(y,v,b){this.notebook=y,this._extHostDocument=v,this._cellData=b,this.handle=b.handle,this.uri=I.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(y,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return y._mime},set mime(b){y._mime=b},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}})}return this._apiCell}setOutputs(y){this._outputs=y.map(T.NotebookCellOutput.to)}setOutputItems(y,v,b){const g=b.map(T.NotebookCellOutputItem.to),d=this._outputs.find(p=>p.id===y);d&&(v||(d.items.length=0),d.items.push(...g))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=S;class L{constructor(y,v,b,g,d,p){this._proxy=y,this._textDocumentsAndEditors=v,this._textDocuments=b,this._emitter=g,this.uri=d,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this;this._notebook={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===f.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(v){return v=y._validateIndex(v),y._cells[v].apiCell},getCells(v){return(v?y._getCells(v):y._cells).map(g=>g.apiCell)},save(){return y._save()}}}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,v){this._versionId=y.versionId,this._isDirty=v;for(const b of y.rawEvents)b.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===C.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let v=y.start|0,b=y.end|0;return v<0&&(v=0),b>this._cells.length&&(b=this._cells.length),y.with({start:v,end:b})}_getCells(y){y=this._validateRange(y);const v=[];for(let b=y.start;b<y.end;b++)v.push(this._cells[b]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,v){if(this._disposed)return;const b=[],g=[],d=[];y.reverse().forEach(p=>{const _=p[2].map(u=>{const l=new S(this,this._textDocumentsAndEditors,u);return v||g.push(S.asModelAddData(this.apiNotebook,u)),l}),o=new k(p[0],p[1],[],_),c=this._cells.splice(p[0],p[1],..._);for(const u of c)d.push(u.uri),o.deletedItems.push(u.apiCell);b.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:d}),v||this._emitter.emitModelChange((0,n.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(b)}))}_moveCell(y,v){const b=this._cells.splice(y,1);this._cells.splice(v,0,...b);const g=[new k(y,1,b.map(d=>d.apiCell),[]),new k(v,0,[],b)];this._emitter.emitModelChange((0,n.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(g)}))}_setCellOutputs(y,v){const b=this._cells[y];b.setOutputs(v),this._emitter.emitCellOutputsChange((0,n.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(y,v,b,g){const d=this._cells[y];d.setOutputItems(v,b,g),this._emitter.emitCellOutputsChange((0,n.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_changeCellLanguage(y,v){const b=this._cells[y];b.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelLanguageChanged(b.uri,v)}_changeCellMime(y,v){const b=this._cells[y];b.apiCell.mime=v}_changeCellMetadata(y,v){const b=this._cells[y],g=b.apiCell.metadata;b.setMetadata(v);const d=b.apiCell.metadata;(0,n.equals)(g,d)||this._emitter.emitCellMetadataChange((0,n.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(y,v){this._cells[y].setInternalMetadata(v)}getCellFromApiCell(y){return this._cells.find(v=>v.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(v=>v.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(pe[130],ve([1,0,7,14,15]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,L){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:L})}replaceCells(S,L,O){this._throwIfFinalized(),!(S===L&&O.length===0)&&this._collectedEdits.push({editType:1,index:S,count:L-S,cells:O.map(n.NotebookCellData.from)})}}class C{constructor(S,L,O,y,v,b){this.id=S,this._proxy=L,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._visibleRanges=y,this._viewColumn=b}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(L){if(!Array.isArray(L)||!L.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");S._selections=L,S._trySetSelections(L)},get visibleRanges(){return S._visibleRanges},revealRange(L,O){S._proxy.$tryRevealRange(S.id,n.NotebookRange.from(L),O??f.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(L){const O=new T(this.document.version);return L(O),S._applyEdit(O.finalize())},setDecorations(L,O){return S.setDecorations(L,O)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(n.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const L=[];let O=-1;for(let y=0;y<S.cellEdits.length;y++){if(O<0){L.push(S.cellEdits[y]),O++;continue}const b=L[O],g=S.cellEdits[y];if(b.editType===1&&g.editType===1&&b.index===g.index){b.cells.push(...S.cellEdits[y].cells),b.count+=S.cellEdits[y].count;continue}L.push(S.cellEdits[y]),O++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,L)}setDecorations(S,L){if(!(L.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return L.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,n.NotebookRange.from(L),S.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(pe[221],ve([1,0,14,118,168,21,56,15]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=v}async withProgress(v,b,g){const d=this._handles++,{title:p,location:P,cancellable:_}=b,o={label:(0,I.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this._proxy.$startProgress(d,{location:f.ProgressLocation.from(P),title:p,source:o,cancellable:_},v.isUnderDevelopment?void 0:v.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(d,g,!!_)}_withProgress(v,b,g){let d;g&&(d=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(v,d));const p=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),d&&d.dispose()};let P;try{P=b(new O(this._proxy,v),g&&d?d.token:T.CancellationToken.None)}catch(_){throw p(v),_}return P.then(_=>p(v),_=>p(v)),P}$acceptProgressCanceled(v){const b=this._mapHandleToCancellationSource.get(v);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(v))}}e.ExtHostProgress=S;function L(y,v){return y.message=v.message,typeof v.increment=="number"&&(typeof y.increment=="number"?y.increment+=v.increment:y.increment=v.increment),y}class O extends n.Progress{constructor(v,b){super(g=>this.throttledReport(g));this._proxy=v,this._handle=b}throttledReport(v){this._proxy.$progressReport(this._handle,v)}}Be([(0,C.throttle)(100,(y,v)=>L(y,v),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(pe[131],ve([1,0,55,15,75,14,7]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(v,b,g){const d=k._Keys.nextId();v.$registerTextEditorDecorationType(b.identifier,d,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){v.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(v,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,b){this._throwIfFinalized();let g=null;if(v instanceof C.Position)g=new C.Range(v,v);else if(v instanceof C.Range)g=v;else throw new Error("Unrecognized location");this._pushEdit(g,b,!1)}insert(v,b){this._throwIfFinalized(),this._pushEdit(new C.Range(v,v),b,!0)}delete(v){this._throwIfFinalized();let b=null;if(v instanceof C.Range)b=v;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(v,b,g){const d=this._document.validateRange(v);this._collectedEdits.push({range:d,text:b,forceMoveMarkers:g})}setEndOfLine(v){if(this._throwIfFinalized(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,n.illegalArgument)("endOfLine");this._setEndOfLine=v}}e.TextEditorEdit=S;class L{constructor(v,b,g,d){this._proxy=v,this._id=b,this._accept(g),this._logService=d;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(P){p._setTabSize(P)},get insertSpaces(){return p._insertSpaces},set insertSpaces(P){p._setInsertSpaces(P)},get cursorStyle(){return p._cursorStyle},set cursorStyle(P){p._setCursorStyle(P)},get lineNumbers(){return p._lineNumbers},set lineNumbers(P){p._setLineNumbers(P)}}}_accept(v){this._tabSize=v.tabSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const b=Math.floor(v);return b>0?b:null}if(typeof v=="string"){const b=parseInt(v,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(v){const b=this._validateTabSize(v);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}_setInsertSpaces(v){const b=this._validateInsertSpaces(v);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(v)})))}assign(v){const b={};let g=!1;if(typeof v.tabSize!="undefined"){const d=this._validateTabSize(v.tabSize);d==="auto"?(g=!0,b.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,g=!0,b.tabSize=d)}if(typeof v.insertSpaces!="undefined"){const d=this._validateInsertSpaces(v.insertSpaces);d==="auto"?(g=!0,b.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,g=!0,b.insertSpaces=d)}typeof v.cursorStyle!="undefined"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,g=!0,b.cursorStyle=v.cursorStyle),typeof v.lineNumbers!="undefined"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,g=!0,b.lineNumbers=T.TextEditorLineNumbersStyle.from(v.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(v,b){b.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=L;class O{constructor(v,b,g,d,p,P,_,o){this.id=v,this._proxy=b,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new L(this._proxy,this.id,P,g),this._visibleRanges=_,this._viewColumn=o;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(u){throw(0,n.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(u){if(!(u instanceof C.Selection))throw(0,n.illegalArgument)("selection");c._selections=[u],c._trySetSelection()},get selections(){return c._selections},set selections(u){if(!Array.isArray(u)||u.some(l=>!(l instanceof C.Selection)))throw(0,n.illegalArgument)("selections");c._selections=u,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(u){throw(0,n.readonly)("visibleRanges")},get options(){return c._options.value},set options(u){c._disposed||c._options.assign(u)},get viewColumn(){return c._viewColumn},set viewColumn(u){throw(0,n.readonly)("viewColumn")},edit(u,l={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new S(d.getValue(),l);return u(E),c._applyEdit(E)},insertSnippet(u,l,E={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!l||Array.isArray(l)&&l.length===0)s=c._selections.map(t=>T.Range.from(t));else if(l instanceof C.Position){const{lineNumber:t,column:r}=T.Position.from(l);s=[{startLineNumber:t,startColumn:r,endLineNumber:t,endColumn:r}]}else if(l instanceof C.Range)s=[T.Range.from(l)];else{s=[];for(const t of l)if(t instanceof C.Range)s.push(T.Range.from(t));else{const{lineNumber:r,column:i}=T.Position.from(t);s.push({startLineNumber:r,startColumn:i,endLineNumber:r,endColumn:i})}}return b.$tryInsertSnippet(v,u.value,s,E)},setDecorations(u,l){const E=l.length===0;E&&!c._hasDecorationsForKey.has(u.key)||(E?c._hasDecorationsForKey.delete(u.key):c._hasDecorationsForKey.add(u.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return b.$trySetDecorations(v,u.key,T.fromRangeOrRangeWithMessage(l));{const s=new Array(4*l.length);for(let t=0,r=l.length;t<r;t++){const i=l[t];s[4*t]=i.start.line+1,s[4*t+1]=i.start.character+1,s[4*t+2]=i.end.line+1,s[4*t+3]=i.end.character+1}return b.$trySetDecorationsFast(v,u.key,s)}}))},revealRange(u,l){c._runOnProxy(()=>b.$tryRevealRange(v,T.Range.from(u),l||C.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(v,T.ViewColumn.from(u))},hide(){b.$tryHideEditor(v)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,f.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,f.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,f.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,f.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const b=v.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(p=>p.range);g.sort((p,P)=>p.end.line===P.end.line?p.end.character===P.end.character?p.start.line===P.start.line?p.start.character-P.start.character:p.start.line-P.start.line:p.end.character-P.end.character:p.end.line-P.end.line);for(let p=0,P=g.length-1;p<P;p++){const _=g[p].end;if(g[p+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=b.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,d,{setEndOfLine:typeof b.setEndOfLine=="number"?T.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=O}),define(pe[222],ve([1,0,16,3,6,13,62,14,84,85,35]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class y extends I.Disposable{constructor(b){super();this.controllerId=b,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new n.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){const g=this.diff[this.diff.length-1];if(g&&b.op===1){if(g.op===1&&g.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(g.item,b.item);return}if(g.op===0&&g.item.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(g.item,b.item);return}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,g){const d=this.tree.get(b);if(!!d){if((d.expandLevels===void 0||g>d.expandLevels)&&(d.expandLevels=g),d.expand===1){const p=this.resolveChildren(d);return p.isOpen()?this.expandChildren(d,g-1):p.wait().then(()=>this.expandChildren(d,g-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,g-1)):this.expandChildren(d,g-1)}}dispose(){for(const b of this.tree.values())(0,C.getPrivateApiFor)(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,g){switch(g.op){case 2:this.pushDiff({op:4,itemId:b.fullId.toString()});break;case 1:this.removeItem(L.TestId.joinToString(b.fullId,g.id));break;case 0:this.upsertItem(g.item,b);break;case 4:for(const d of g.ops)this.onTestItemEvent(b,d);break;case 3:{const{key:d,value:p,previous:P}=g,_=b.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(b);break;case"tags":this.diffTagRefs(p,P,_);break;case"range":this.pushDiff({op:1,item:{extId:_,item:{range:O.Range.lift(k.Range.from(p))}}});break;case"error":this.pushDiff({op:1,item:{extId:_,item:{error:k.MarkdownString.fromStrict(p)||null}}});break;default:this.pushDiff({op:1,item:{extId:_,item:{[d]:p??null}}});break}break}default:(0,T.assertNever)(g)}}upsertItem(b,g){if(!(b instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${b.id} did not`);const d=L.TestId.fromExtHostTestItem(b,this.root.id,g?.actual),p=(0,C.getPrivateApiFor)(b);p.parent&&p.parent!==g?.actual&&p.parent.children.delete(b.id);let P=this.tree.get(d.toString());if(!P){P={fullId:d,actual:b,parent:g?d.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(P.fullId.toString(),P),this.setItemParent(b,g),this.pushDiff({op:0,item:{parent:P.parent&&P.parent.toString(),controllerId:this.controllerId,expand:P.expand,item:k.TestItem.from(b)}}),this.connectItemAndChildren(b,P,g);return}if(P.actual===b){this.connectItem(b,P,g);return}const _=P.actual.children,o=P.actual,c=(0,C.diffTestItems)(o,b);(0,C.getPrivateApiFor)(o).listener=void 0,P.actual=b,P.expand=0;for(const[u,l]of c)this.onTestItemEvent(P,{op:3,key:u,value:l,previous:o[u]});this.connectItemAndChildren(b,P,g);for(const u of _)b.children.get(u.id)||this.removeItem(L.TestId.joinToString(d,u.id))}diffTagRefs(b,g,d){const p=new Set(g.map(P=>P.id));for(const P of b)p.delete(P.id)||this.incrementTagRefs(P);this.pushDiff({op:1,item:{extId:d,item:{tags:b.map(P=>k.TestTag.namespace(this.controllerId,P.id))}}}),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const g=this.tags.get(b.id);g?g.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:5,tag:{id:k.TestTag.namespace(this.controllerId,b.id),ctrlLabel:this.root.label}}))}decrementTagRefs(b){const g=this.tags.get(b);g&&!--g.refCount&&(this.tags.delete(b),this.pushDiff({op:6,id:(0,S.namespaceTestTag)(this.controllerId,b)}))}setItemParent(b,g){(0,C.getPrivateApiFor)(b).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(b,g,d){this.setItemParent(b,d);const p=(0,C.getPrivateApiFor)(b);p.parent=d?.actual,p.listener=P=>this.onTestItemEvent(g,P),this.updateExpandability(g)}connectItemAndChildren(b,g,d){this.connectItem(b,g,d);for(const p of b.children)this.upsertItem(p,g)}updateExpandability(b){let g;this._resolveHandler?b.resolveBarrier?g=b.resolveBarrier.isOpen()?3:2:g=b.actual.canResolveChildren?1:0:g=0,g!==b.expand&&(b.expand=g,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:g}}),g===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,g){if(g<0)return;const d=[];for(const p of b.actual.children){const P=this.expand(L.TestId.joinToString(b.fullId,p.id),g);(0,f.isThenable)(P)&&d.push(P)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const P=new f.Barrier;return P.open(),P}b.expand=2,this.pushExpandStateUpdate(b);const g=b.resolveBarrier=new f.Barrier,d=P=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),b.actual!==this.root&&(b.actual.error=P.stack||P.message||String(P))};let p;try{p=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(P){d(P)}return(0,f.isThenable)(p)?p.catch(d).then(()=>{g.open(),this.updateExpandability(b)}):(g.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const g=this.tree.get(b);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:b});const d=[g];for(;d.length;){const p=d.pop();if(!!p){(0,C.getPrivateApiFor)(p.actual).listener=void 0;for(const P of p.actual.tags)this.decrementTagRefs(P.id);this.tree.delete(p.fullId.toString());for(const P of p.actual.children)d.push(this.tree.get(L.TestId.joinToString(p.fullId,P.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.SingleUseTestCollection=y}),define(pe[223],ve([1,0,4,185]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(n.IEnvironmentService)}),define(pe[224],ve([1,0,27,3,9]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(O){this.removedDueToLooping=O}}e.DeltaExtensionsResult=T;class C{constructor(O){this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=O,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const O of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(O.identifier))){console.error("Extension `"+O.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(O.identifier),O),this._extensionsArr.push(O),Array.isArray(O.activationEvents))for(let y of O.activationEvents)y==="onUri"&&(y=`onUri:${f.ExtensionIdentifier.toKey(O.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(O)}}keepOnly(O){const y=new Set;O.forEach(v=>y.add(f.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>y.has(f.ExtensionIdentifier.toKey(v.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(O,y){O.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(O));const v=C._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(v.map(b=>b.identifier)),y.length>0){const b=new Set;y.forEach(g=>b.add(f.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>!b.has(f.ExtensionIdentifier.toKey(g.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(v)}static _findLoopingExtensions(O){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,P){this.addNode(p),this.addNode(P),this._arcs.has(p)?this._arcs.get(p).push(P):this._arcs.set(p,[P])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,P){const _=y.getArcs(p);for(let o=0;o<_.length;o++)if(!P.has(_[o]))return!1;return!0}getNodes(){return this._nodesArr}};let v=new Map;for(let p of O){const P=f.ExtensionIdentifier.toKey(p.identifier);if(v.set(P,p),p.extensionDependencies)for(let _ of p.extensionDependencies){const o=f.ExtensionIdentifier.toKey(_);y.addArc(P,o)}}let b=new Set;y.getNodes().filter(p=>y.getArcs(p).length===0).forEach(p=>b.add(p));let g=y.getNodes().filter(p=>!b.has(p)),d;do{d=!1;for(let p=0;p<g.length;p++){const P=g[p];y.hasOnlyGoodArcs(P,b)&&(g.splice(p,1),p--,b.add(P),d=!0)}}while(d);return g.map(p=>v.get(p))}containsActivationEvent(O){return this._activationMap.has(O)}containsExtension(O){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(O))}getExtensionDescriptionsForActivationEvent(O){const y=this._activationMap.get(O);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(O){const y=this._extensionsMap.get(f.ExtensionIdentifier.toKey(O));return y||void 0}}e.ExtensionDescriptionRegistry=C;var k;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(k||(k={}));function S(L,O){const y=L.isBuiltin?0:L.isUnderDevelopment?2:1,v=O.isBuiltin?0:O.isUnderDevelopment?2:1;if(y!==v)return y-v;const b=I.posix.basename(L.extensionLocation.path),g=I.posix.basename(O.extensionLocation.path);return b<g?-1:b>g?1:0}}),define(pe[132],ve([1,0,22]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var n;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(n=e.UIKind||(e.UIKind={}));var I;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function C(S){const L=f.VSBuffer.alloc(1);switch(S){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function k(S,L){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=k}),define(pe[30],ve([1,0,3,2,4,27,122]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:n.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(c){c[c.None=0]="None",c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(c){switch(c){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class L{constructor(u){this.dependency=u}}e.MissingExtensionDependency=L;var O;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(O=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(c){switch(c){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function v(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function b(c,u){if(!v(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class g{constructor(u,l,E,s){this.codeLoadingTime=u,this.activateCallTime=l,this.activateResolvedTime=E,this.activationReason=s}}e.ActivationTimes=g;class d{constructor(u,l){this.description=u,this.value=l}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var p;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(p=e.ActivationKind||(e.ActivationKind={}));function P(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=P;function _(c,u){return{identifier:new T.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid}}e.toExtensionDescription=_;class o{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,l){return Promise.resolve()}}e.NullExtensionService=o}),define(pe[225],ve([1,0,15,27,30,11]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class k{constructor(d,p,P,_){this.startup=d,this.codeLoadingTime=p,this.activateCallTime=P,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,p){return d===-1||p===-1?-1:p-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class L{constructor(d,p,P,_,o,c){this.activationFailed=d,this.activationFailedError=p,this.activationTimes=P,this.module=_,this.exports=o,this.subscriptions=c}}e.ActivatedExtension=L;class O extends L{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class y extends L{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class v extends L{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=v;let b=class{constructor(d,p,P,_,o){this._logService=o,this._isDisposed=!1,this._registry=d,this._resolvedExtensionsSet=new Set,p.forEach(c=>this._resolvedExtensionsSet.add(n.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,P.forEach(c=>this._hostExtensionsMap.set(n.ExtensionIdentifier.toKey(c),c)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(d){const p=n.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(p)}getActivatedExtension(d){const p=n.ExtensionIdentifier.toKey(d),P=this._activatedExtensions.get(p);if(!P)throw new Error("Extension `"+d.value+"` is not known or not activated");return P}activateByEvent(d,p){if(this._alreadyActivatedEvents[d])return C;const P=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(P.map(_=>({id:_.identifier,reason:{startup:p,extensionId:_.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,p){const P=this._registry.getExtensionDescription(d);if(!P)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:P.identifier,reason:p}])}_handleActivateRequest(d,p,P){if(this._hostExtensionsMap.has(n.ExtensionIdentifier.toKey(d.id))){p[n.ExtensionIdentifier.toKey(d.id)]=d;return}const _=this._registry.getExtensionDescription(d.id);if(!_){const u=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,u,new I.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(n.ExtensionIdentifier.toKey(d.id),new v(u));return}const o=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let c=!0;for(let u=0,l=o.length;u<l;u++){const E=o[u];if(this._resolvedExtensionsSet.has(n.ExtensionIdentifier.toKey(E)))continue;const s=this._activatedExtensions.get(n.ExtensionIdentifier.toKey(E));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const a=_.displayName||_.identifier.value,m=this._registry.getExtensionDescription(E),h=m&&m.displayName||E,w=new Error(`Cannot activate the '${a}' extension because its dependency '${h}' failed to activate`);w.detail=s.activationFailedError,this._host.onExtensionActivationError(_.identifier,w,null),this._activatedExtensions.set(n.ExtensionIdentifier.toKey(_.identifier),new v(w));return}if(this._hostExtensionsMap.has(n.ExtensionIdentifier.toKey(E))){c=!1,p[n.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(n.ExtensionIdentifier.toKey(E)),reason:d.reason};continue}const t=this._registry.getExtensionDescription(E);if(t){if(!t.main&&!t.browser)continue;c=!1,p[n.ExtensionIdentifier.toKey(E)]={id:t.identifier,reason:d.reason};continue}const r=_.displayName||_.identifier.value,i=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(_.identifier,i,new I.MissingExtensionDependency(E)),this._activatedExtensions.set(n.ExtensionIdentifier.toKey(_.identifier),new v(i));return}c?p[n.ExtensionIdentifier.toKey(_.identifier)]=d:P.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(o=>!this._activatedExtensions.has(n.ExtensionIdentifier.toKey(o.id))),d.length===0))return Promise.resolve(void 0);const p=Object.create(null),P=[];for(let o=0,c=d.length;o<c;o++)this._handleActivateRequest(d[o],p,P);for(let o=0,c=P.length;o<c;o++){const u=n.ExtensionIdentifier.toKey(P[o].id);p[u]&&delete p[u]}const _=Object.keys(p).map(o=>p[o]);return P.length===0?Promise.all(_.map(o=>this._activateExtension(o.id,o.reason))).then(o=>{}):this._activateExtensions(_).then(o=>this._activateExtensions(P))}_activateExtension(d,p){const P=n.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(P))return Promise.resolve(void 0);const _=this._activatingExtensions.get(P);if(_)return _;const o=this._host.actualActivateExtension(d,p).then(void 0,c=>{const u=new Error;return c&&c.name&&(u.name=c.name),c&&c.message?u.message=`Activating extension '${d.value}' failed: ${c.message}.`:u.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(u.stack=c.stack),this._isDisposed&&f.isCancellationError(c)?new v(c):(this._host.onExtensionActivationError(d,u,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new v(c))}).then(c=>{this._activatedExtensions.set(P,c),this._activatingExtensions.delete(P)});return this._activatingExtensions.set(P,o),o}};b=Be([Fe(4,T.ILogService)],b),e.ExtensionsActivator=b}),define(pe[226],ve([1,0,11,26,30]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends f.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};T=Be([Fe(0,f.ILoggerService),Fe(1,n.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(pe[227],ve([1,0,15]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class n{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,C)=>{this._actualOk=T,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,f.onUnexpectedError)(T))}then(T,C){return this._ensureActual().then(T,C)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=n}),define(pe[52],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const n=[];function I(k){const S=new f(k);return n[S.nid]=S,S}e.createProxyIdentifier=I;function T(k){return n[k].sid}e.getStringIdentifierForProxy=T;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(pe[5],ve([1,0,58,2,52]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var T;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(_){_[_.Singular=0]="Singular",_[_.Diff=1]="Diff",_[_.SidebySide=2]="SidebySide",_[_.Other=3]="Other"})(C=e.TabKind||(e.TabKind={}));var k;(function(_){_[_.Editable=0]="Editable",_[_.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(_){_[_.Int8Array=1]="Int8Array",_[_.Uint8Array=2]="Uint8Array",_[_.Uint8ClampedArray=3]="Uint8ClampedArray",_[_.Int16Array=4]="Int16Array",_[_.Uint16Array=5]="Uint16Array",_[_.Int32Array=6]="Int32Array",_[_.Uint32Array=7]="Uint32Array",_[_.Float32Array=8]="Float32Array",_[_.Float64Array=9]="Float64Array",_[_.BigInt64Array=10]="BigInt64Array",_[_.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(_){_[_.Text=1]="Text",_[_.Error=2]="Error",_[_.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var O;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(O=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(_){_[_.None=0]="None",_[_.Process=1]="Process",_[_.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class v{static mixin(o){return o._id=v._n++,o}}e.IdObject=v,v._n=0;var b;(function(_){_.label="a",_.kind="b",_.detail="c",_.documentation="d",_.sortText="e",_.filterText="f",_.preselect="g",_.insertText="h",_.insertTextRules="i",_.range="j",_.commitCharacters="k",_.additionalTextEdits="l",_.command="m",_.kindModifier="n"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(_){_.defaultRanges="a",_.completions="b",_.isIncomplete="c",_.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(_){if(_&&_.edits)for(const o of _.edits)typeof o.resource=="object"?o.resource=n.URI.revive(o.resource):(o.newUri=n.URI.revive(o.newUri),o.oldUri=n.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,f.revive)(o.metadata));return _}e.reviveWorkspaceEditDto=p;var P;(function(_){_[_.Workspace=0]="Workspace",_[_.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(pe[86],ve([1,0,5,3,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new n.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,L){return this._proxy.$setPassword(k,S,L)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(pe[64],ve([1,0,4,11,5,17]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,L){this._extHostLogService=L,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,L,O){const y=this.getUsageKey(S,L);this._reportedUsages.has(y)||(this._reportedUsages.add(y),L.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:L.identifier.value,apiId:S}))}getUsageKey(S,L){return`${S}-${L.identifier.value}`}};C=Be([Fe(0,T.IExtHostRpcService),Fe(1,n.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,L){}})}),define(pe[228],ve([1,0,3,5,7,27]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(n.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,L,O,y={}){const v=T.ExtensionIdentifier.toKey(S.identifier),b=this._inFlightRequests.get(v)||[],g=[...O].sort().join(" ");let d=b.find(p=>p.scopes===g);if(d)return d.result;{const p=this._getSession(S,v,L,O,y);d={scopes:g,result:p},b.push(d),this._inFlightRequests.set(v,b);try{await p}finally{const P=b.findIndex(_=>_.scopes===g);P>-1&&(b.splice(P),this._inFlightRequests.set(v,b))}return p}}async _getSession(S,L,O,y,v={}){await this._proxy.$ensureProvider(O);const b=S.displayName||S.name;return this._proxy.$getSession(O,y,L,b,v)}async removeSession(S,L){const O=this._authenticationProviders.get(S);return O?O.provider.removeSession(L):this._proxy.$removeSession(S,L)}registerAuthenticationProvider(S,L,O,y){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:L,provider:O,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===S)||this._providers.push({id:S,label:L});const v=O.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(S,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,L,y?.supportsMultipleAccounts??!1),new I.Disposable(()=>{v.dispose(),this._authenticationProviders.delete(S);const b=this._providers.findIndex(g=>g.id===S);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,L){const O=this._authenticationProviders.get(S);if(O)return Promise.resolve(O.provider.createSession(L));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,L){const O=this._authenticationProviders.get(S);if(O)return Promise.resolve(O.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,L){const O=this._authenticationProviders.get(S);if(O)return Promise.resolve(O.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,L){return this._onDidChangeSessions.fire({provider:{id:S,label:L}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(pe[229],ve([1,0,5,17,14]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,S){this._proxy=k.getProxy(f.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:L=>S.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k){const S=I.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Be([Fe(0,n.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(pe[230],ve([1,0,5]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class n{constructor(T){const C=T.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(k){return C.$writeText(k)}})}}e.ExtHostClipboard=n});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[39],ve([1,0,13,7,14,25,5,18,11,58,35,48,2,6,4,17,62,22,52,49]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(i,a){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ke(this,c,i.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new l(this,m=>{const h=this._apiCommands.get(m);return h?.result===s.Void?h:void 0},a),this._argumentProcessors=[{processArgument(m){return(0,L.revive)(m)}},{processArgument(m){return(0,T.cloneAndChange)(m,function(h){if(O.Range.isIRange(h))return I.Range.to(h);if(y.Position.isIPosition(h))return I.Position.to(h);if(O.Range.isIRange(h.range)&&v.URI.isUri(h.uri))return I.location.to(h);if(h instanceof P.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const a=this.registerCommand(!1,i.id,async(...m)=>{const h=i.args.map((A,F)=>{if(!A.validate(m[F]))throw new Error(`Invalid argument '${A.name}' when running '${i.id}', received: ${m[F]}`);return A.convert(m[F])}),w=await this.executeCommand(i.internalId,...h);return i.result.convert(w,m,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new n.Disposable(()=>{a.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,a,m,h,w,A){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:m,thisArg:h,description:w,extension:A}),i&&ke(this,c,"f").$registerCommand(a),new n.Disposable(()=>{this._commands.delete(a)&&i&&ke(this,c,"f").$unregisterCommand(a)})}executeCommand(i,...a){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,a,!0)}async _doExecuteCommand(i,a,m){if(this._commands.has(i))return this._executeContributedCommand(i,a,!1);{let h=!1;const w=(0,T.cloneAndChange)(a,function(A){if(A instanceof n.Position)return I.Position.from(A);if(A instanceof n.Range)return I.Range.from(A);if(A instanceof n.Location)return I.location.from(A);if(n.NotebookRange.isNotebookRange(A))return I.NotebookRange.from(A);if(A instanceof ArrayBuffer)return h=!0,P.VSBuffer.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return h=!0,P.VSBuffer.wrap(A);if(!Array.isArray(A))return A});try{const A=await ke(this,c,"f").$executeCommand(i,h?new _.SerializableObjectWithBuffers(w):w,m);return(0,L.revive)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this._doExecuteCommand(i,a,!1);throw A}}}async _executeContributedCommand(i,a,m){const h=this._commands.get(i);if(!h)throw new Error("Unknown command");let{callback:w,thisArg:A,description:F}=h;if(F)for(let R=0;R<F.args.length;R++)try{(0,f.validateConstraint)(a[R],F.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${F.args[R].name}' - ${F.args[R].description}`)}try{return await w.apply(A,a)}catch(R){if(i===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...a);D&&(i=D.command)}throw this._logService.error(R,i,h.extension?.identifier),m?new class extends Error{constructor(){super((0,o.toErrorMessage)(R));this.id=i,this.source=h.extension?.displayName??h.extension?.name}}:R}}$executeContributedCommand(i,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(a=a.map(m=>this._argumentProcessors.reduce((h,w)=>w.processArgument(h),m)),this._executeContributedCommand(i,a,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),ke(this,c,"f").$getCommands().then(a=>(i&&(a=a.filter(m=>m[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[a,m]of this._commands){let{description:h}=m;h&&(i[a]=h)}return Promise.resolve(i)}};c=new WeakMap,u=Be([Fe(0,d.IExtHostRpcService),Fe(1,S.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class l{constructor(i,a,m){this._commands=i,this._lookupApiCommand=a,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,a){if(!i)return;const m={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return m;const h=this._lookupApiCommand(i.command);if(h)m.id=h.internalId,m.arguments=h.args.map((w,A)=>w.convert(i.arguments&&i.arguments[A]));else if((0,k.isNonEmptyArray)(i.arguments)){const w=++this._cachIdPool;this._cache.set(w,i),a.add((0,b.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),m.$ident=w,m.id=this.delegatingCommandId,m.arguments=[w],this._logService.trace("CommandsConverter#CREATE",i.command,w)}return m}fromInternal(i){return typeof i.$ident=="number"?this._cache.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const a=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class E{constructor(i,a,m,h){this.name=i,this.description=a,this.validate=m,this.convert=h}optional(){return new E(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,a){return new E(i??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",r=>v.URI.isUri(r),r=>r),E.Position=new E("position","A position in a text document",r=>n.Position.isPosition(r),I.Position.from),E.Range=new E("range","A range in a text document",r=>n.Range.isRange(r),I.Range.from),E.Selection=new E("selection","A selection in a text document",r=>n.Selection.isSelection(r),I.Selection.from),E.Number=new E("number","",r=>typeof r=="number",r=>r),E.String=new E("string","",r=>typeof r=="string",r=>r),E.CallHierarchyItem=new E("item","A call hierarchy item",r=>r instanceof n.CallHierarchyItem,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",r=>r instanceof n.TypeHierarchyItem,I.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",r=>r instanceof p.TestItemImpl,I.TestItem.from);class s{constructor(i,a){this.description=i,this.convert=a}}e.ApiCommandResult=s,s.Void=new s("no result",r=>r);class t{constructor(i,a,m,h,w){this.id=i,this.internalId=a,this.description=m,this.args=h,this.result=w}}e.ApiCommand=t}),define(pe[231],ve([1,0,2,14,7,78,39,18,111,117,10]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(n.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,p)=>{if((0,k.isFalsyOrEmpty)(d))return;class P extends I.SymbolInformation{static to(o){const c=new P(o.name,n.SymbolKind.to(o.kind),o.containerName||"",new I.Location(p[0],n.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=n.Range.to(o.selectionRange),c.children=o.children?o.children.map(P.to):[],c}}return d.map(P.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(n.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(n.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(n.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(p=>I.Position.isPosition(p)),d=>d.map(n.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(p=>{let P;for(const _ of p.reverse())P=new I.SelectionRange(n.Range.to(_),P);return P}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(n.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(n.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(n.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(n.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:n.Range.to(d.range),placeholder:d.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return n.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(n.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const p=(0,S.decodeSemanticTokensDto)(d);if(p.type==="full")return new I.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const p=(0,S.decodeSemanticTokensDto)(d);if(p.type==="full")return new I.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,p,P)=>{if(!d)return new I.CompletionList([]);const _=d.suggestions.map(o=>n.CompletionItem.to(o,P));return new I.CompletionList(_,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return n.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,p,P)=>b(_=>new I.CodeLens(n.Range.to(_.range),_.command&&P.fromInternal(_.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?n.Selection.from(d):n.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,p,P)=>b(_=>{if(_._isSynthetic){if(!_.command)throw new Error("Synthetic code actions must have a command");return P.fromInternal(_.command)}else{const o=new I.CodeAction(_.title,_.kind?new I.CodeActionKind(_.kind):void 0);return _.edit&&(o.edit=n.WorkspaceEdit.to(_.edit)),_.command&&(o.command=P.fromInternal(_.command)),o.isPreferred=_.isPreferred,o}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(p=>new I.ColorInformation(n.Range.to(p.range),n.Color.to(p.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,n.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:n.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(n.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,p,P)=>d.map(n.InlayHint.to.bind(void 0,P)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(p=>n.NotebookExclusiveDocumentPattern.to(p))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(n.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>f.URI.isUri(d)||typeof d=="string"&&(0,L.matchesSomeScheme)(d,O.Schemas.http,O.Schemas.https),d=>d),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[n.ViewColumn.from(d),void 0]:[n.ViewColumn.from(d.viewColumn),n.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[n.ViewColumn.from(d),void 0]:[n.ViewColumn.from(d.viewColumn),n.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[n.ViewColumn.from(d.viewColumn),n.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class v{static register(p){y.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=v;function b(d){return p=>{if(Array.isArray(p))return p.map(d)}}function g(d){if(!Array.isArray(d))return;const p=[];for(const P of d)T.isLocationLink(P)?p.push(n.DefinitionLink.to(P)):p.push(n.location.to(P));return p}}),define(pe[232],ve([1,0,16,56,3,6,2,78,27,14,7,5]),function(te,e,f,n,I,T,C,k,S,L,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(b,g,d){const p=b.getProxy(y.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const r=this._commentControllers.get(t.handle);return r||t}else if(t&&t.$mid===7){const r=this._commentControllers.get(t.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.commentThreadHandle);return i||t}else if(t&&t.$mid===8){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.thread.commentThreadHandle);return i?{thread:i,text:t.text}:t}else if(t&&t.$mid===9){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.thread.commentThreadHandle);if(!i)return t;let a=t.commentUniqueId,m=i.getCommentByUniqueId(a);return m||t}else if(t&&t.$mid===10){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.thread.commentThreadHandle);if(!i)return t;let a=t.text,m=t.commentUniqueId,h=i.getCommentByUniqueId(m);return h?(h.body=a,h):t}return t}})}createCommentController(t,r,i){const a=P.handlePool++,m=new o(t,a,r,i);this._commentControllers.set(m.handle,m);const h=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return h.push(m),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),h),m.value}$createCommentThreadTemplate(t,r,i){const a=this._commentControllers.get(t);!a||a.$createCommentThreadTemplate(r,i)}async $updateCommentThreadTemplate(t,r,i){const a=this._commentControllers.get(t);!a||a.$updateCommentThreadTemplate(r,i)}$deleteCommentThread(t,r){const i=this._commentControllers.get(t);i&&i.$deleteCommentThread(r)}$provideCommentingRanges(t,r,i){const a=this._commentControllers.get(t);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const m=d.getDocument(C.URI.revive(r));return(0,f.asPromise)(()=>a.commentingRangeProvider.provideCommentingRanges(m,i)).then(h=>h?h.map(w=>L.Range.from(w)):void 0)}$toggleReaction(t,r,i,a,m){const h=this._commentControllers.get(t);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const w=h.getCommentThread(r);if(w){const A=w.getCommentByUniqueId(a.uniqueIdInThread);if(h!==void 0&&A&&h.reactionHandler)return h.reactionHandler(A,l(m))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class _{constructor(t,r,i,a,m,h,w){this._commentControllerHandle=r,this._id=i,this._uri=a,this._range=m,this._comments=h,this.extensionDescription=w,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),p.$createCommentThread(r,this.handle,this._id,this._uri,L.Range.from(this._range),w.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(r,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(F){A.range=F},get comments(){return A.comments},set comments(F){A.comments=F},get collapsibleState(){return A.collapsibleState},set collapsibleState(F){A.collapsibleState=F},get canReply(){return A.canReply},set canReply(F){A.canReply=F},get contextValue(){return A.contextValue},set contextValue(F){A.contextValue=F},get label(){return A.label},set label(F){A.label=F},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const t=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),r={};t("range")&&(r.range=L.Range.from(this._range)),t("label")&&(r.label=this.label),t("contextValue")&&(r.contextValue=this.contextValue??null),t("comments")&&(r.comments=this._comments.map(i=>c(this,i,this._commentsMap))),t("collapsibleState")&&(r.collapseState=E(this._collapseState)),t("canReply")&&(r.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(t){for(let r of this._commentsMap){let i=r[0],a=r[1];if(t===a)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}_._handlePool=0,Be([(0,n.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,r,i,a){this._extension=t,this._handle=r,this._id=i,this._label=a,this._threads=new Map,p.$registerCommentController(this.handle,i,a);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,w,A){return m.createCommentThread(h,w,A).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,r,i,a){if(typeof t=="string"){const m=new _(this.id,this.handle,t,r,i,a,this._extension);return this._threads.set(m.handle,m),m}else{const m=new _(this.id,this.handle,void 0,t,r,i,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,r){const i=new _(this.id,this.handle,void 0,C.URI.revive(t),L.Range.to(r),[],this._extension);return i.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(t,r){let i=this._threads.get(t);i&&(i.range=L.Range.to(r))}$deleteCommentThread(t){let r=this._threads.get(t);r&&r.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function c(s,t,r){let i=r.get(t);i||(i=++s.commentHandle,r.set(t,i));const a=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:i,body:typeof t.body=="string"?t.body:L.MarkdownString.from(t.body),userName:t.author.name,userIconPath:a,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>u(m)):void 0,timestamp:t.timestamp?.toJSON()}}function u(s){return{label:s.label,iconPath:s.iconPath?L.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function l(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?C.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function E(s){if(s!==void 0)switch(s){case O.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=v}),define(pe[133],ve([1,0,2,5,7,4,17,11,18,8,9]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Ei{constructor(b,g){this._logService=g,this._provider=new Map,this._proxy=b.getProxy(n.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,g){const d=Ei._handlePool++;this._provider.set(d,{provider:b,extensionId:g}),this._proxy.$registerDecorationProvider(d,g.value);const p=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(d,null);return}let _=(0,S.asArray)(P);if(_.length<=Ei._maxEventSize){this._proxy.$onDidChange(d,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,_.length);const o=_.map(l=>({uri:l,rank:(0,L.count)(l.path,"/")})),c=(0,S.groupBy)(o,(l,E)=>l.rank-E.rank||(0,L.compare)(l.uri.path,E.uri.path));let u=[];e:for(let l of c){let E;for(let s of l){let t=(0,O.dirname)(s.uri.path);if(E!==t&&(E=t,u.push(s.uri)>=Ei._maxEventSize))break e}}this._proxy.$onDidChange(d,u)});return new I.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(b,g,d){if(!this._provider.has(b))return Object.create(null);const p=Object.create(null),{provider:P,extensionId:_}=this._provider.get(b);return await Promise.all(g.map(async o=>{try{const{uri:c,id:u}=o,l=await Promise.resolve(P.provideFileDecoration(f.URI.revive(c),d));if(!l)return;try{I.FileDecoration.validate(l),p[u]=[l.propagate,l.tooltip,l.badge,l.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${_.value}': ${E}`)}}catch(c){this._logService.error(c)}})),p}};y._handlePool=0,y._maxEventSize=250,y=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[233],ve([1,0,166,116,2,5,7,14,3,11,24,44]),function(te,e,f,n,I,T,C,k,S,L,O,y){"use strict";var v,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(_,o,c,u,l,E){this._name=_,this._owner=o,this._maxDiagnosticsPerFile=c,v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Ke(this,g,new O.ResourceMap(s=>u.getComparisonKey(s)),"f"),Ke(this,v,l,"f"),Ke(this,b,E,"f")}dispose(){this._isDisposed||(ke(this,b,"f").fire([...ke(this,g,"f").keys()]),ke(this,v,"f")&&ke(this,v,"f").$clear(this._owner),ke(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,o){if(!_){this.clear();return}this._checkDisposed();let c=[];if(I.URI.isUri(_)){if(!o){this.delete(_);return}ke(this,g,"f").set(_,o.slice()),c=[_]}else if(Array.isArray(_)){c=[];let l;_=[..._].sort(d._compareIndexedTuplesByUri);for(const E of _){const[s,t]=E;if((!l||s.toString()!==l.toString())&&(l&&ke(this,g,"f").get(l).length===0&&ke(this,g,"f").delete(l),l=s,c.push(s),ke(this,g,"f").set(s,[])),t){const r=ke(this,g,"f").get(s);r&&r.push(...t)}else{const r=ke(this,g,"f").get(s);r&&(r.length=0)}}}if(ke(this,b,"f").fire(c),!ke(this,v,"f"))return;const u=[];for(let l of c){let E=[];const s=ke(this,g,"f").get(l);if(s)if(s.length>this._maxDiagnosticsPerFile){E=[];const t=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let i of s)if(i.severity===t[r]&&E.push(k.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;E.push({severity:n.MarkerSeverity.Info,message:(0,f.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=s.map(t=>k.Diagnostic.from(t));u.push([l,E])}ke(this,v,"f").$changeMany(this._owner,u)}delete(_){this._checkDisposed(),ke(this,b,"f").fire([_]),ke(this,g,"f").delete(_),ke(this,v,"f")&&ke(this,v,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),ke(this,b,"f").fire([...ke(this,g,"f").keys()]),ke(this,g,"f").clear(),ke(this,v,"f")&&ke(this,v,"f").$clear(this._owner)}forEach(_,o){this._checkDisposed();for(let c of ke(this,g,"f").keys())_.apply(o,[c,this.get(c),this])}get(_){this._checkDisposed();const o=ke(this,g,"f").get(_);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(ke(this,g,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,o){return _[0].toString()<o[0].toString()?-1:_[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=d,v=new WeakMap,b=new WeakMap,g=new WeakMap;let p=class oi{constructor(_,o,c){this._logService=o,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(_){const o=new O.ResourceMap;for(const c of _)o.set(c,c);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(_,o){const{_collections:c,_proxy:u,_onDidChangeDiagnostics:l,_logService:E,_fileSystemInfoService:s}=this,t=new class{$changeMany(a,m){u.$changeMany(a,m),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,a,m.length===0?"CLEARING":m)}$clear(a){u.$clear(a),E.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,a)}dispose(){u.dispose()}};let r;if(!o)o="_generated_diagnostic_collection_name_#"+oi._idPool++,r=o;else if(!c.has(o))r=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do r=o+oi._idPool++;while(c.has(r))}return new class extends d{constructor(){super(o,r,oi._maxDiagnosticsPerFile,s.extUri,t,l);c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const o=new Map,c=[];for(const u of this._collections.values())u.forEach((l,E)=>{let s=o.get(l.toString());typeof s=="undefined"&&(s=c.length,o.set(l.toString(),s),c.push([l,[]])),c[s][1]=c[s][1].concat(...E)});return c}}_getDiagnostics(_){let o=[];for(let c of this._collections.values())c.has(_)&&(o=o.concat(c.get(_)));return o}$acceptMarkersChange(_){if(!this._mirrorCollection){const o="_generated_mirror",c=new d(o,o,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,c),this._mirrorCollection=c}for(const[o,c]of _)this._mirrorCollection.set(I.URI.revive(o),c.map(k.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Be([Fe(1,L.ILogService),Fe(2,y.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(pe[234],ve([1,0,2,5]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(C){this._proxy=C.getProxy(n.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(k=>k?k.map(S=>f.URI.revive(S)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(k=>k?f.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(pe[235],ve([1,0,15,2,7,5,10,21,8]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class L{constructor(y,v,b){this._documentsAndEditors=v,this._logService=b,this._documentContentProviders=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,v){if(Object.keys(C.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=L._handlePool++;this._documentContentProviders.set(b,v),this._proxy.$registerTextContentProvider(b,y);let g;return typeof v.onDidChange=="function"&&(g=v.onDidChange(d=>{if(d.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(b,d).then(p=>{if(!p&&typeof p!="string")return;const P=this._documentsAndEditors.getDocument(d);if(!P)return;const _=(0,S.splitLines)(p);if(!P.equalLines(_))return this._proxy.$onVirtualDocumentChange(d,p)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(y,v){const b=this._documentContentProviders.get(y);return b?Promise.resolve(b.provideTextDocumentContent(n.URI.revive(v),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=L,L._handlePool=0}),define(pe[236],ve([1,0,3,6,2,5,125,14,13,25,7]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(b,g){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new n.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const p of d)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const p of d)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const g=this._documentsAndEditors.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this._documentsAndEditors.getDocument(b);if(g)return Promise.resolve(g);let d=this._documentLoader.get(b.toString());return d||(d=this._proxy.$tryOpenDocument(b).then(p=>{this._documentLoader.delete(b.toString());const P=I.URI.revive(p);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(P))},p=>(this._documentLoader.delete(b.toString()),Promise.reject(p))),this._documentLoader.set(b.toString(),d)),d}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(b,g){const d=I.URI.revive(b),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(g),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(b){const g=I.URI.revive(b),d=this._documentsAndEditors.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(b,g){const d=I.URI.revive(b),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");p._acceptIsDirty(g),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,d){const p=I.URI.revive(b),P=this._documentsAndEditors.getDocument(p);if(!P)throw new Error("unknown document");P._acceptIsDirty(d),P.onEvents(g);let _;g.isUndoing?_=O.TextDocumentChangeReason.Undo:g.isRedoing&&(_=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,L.deepFreeze)({document:P.document,contentChanges:g.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:_}))}setWordDefinitionFor(b,g){(0,C.setWordDefinitionFor)(b,g)}}e.ExtHostDocuments=y}),define(pe[45],ve([1,0,55,3,6,2,4,5,125,17,131,14,11,24,10,76,89]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,u){this._extHostRpc=c,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new n.Emitter,this._onDidRemoveDocuments=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],l=[],E=[];if(c.removedDocuments)for(const s of c.removedDocuments){const t=T.URI.revive(s),r=this._documents.get(t);r?.unref()&&(this._documents.delete(t),u.push(r.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const t=T.URI.revive(s.uri);let r=this._documents.get(t);if(r&&t.scheme!==g.Schemas.vscodeNotebookCell&&t.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);r||(r=new P(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(t,r),l.push(r.value)),r.ref()}if(c.removedEditors)for(const s of c.removedEditors){const t=this._editors.get(s);this._editors.delete(s),t&&E.push(t)}if(c.addedEditors)for(const s of c.addedEditors){const t=T.URI.revive(s.documentUri);f.ok(this._documents.has(t),`document '${t}' does not exist`),f.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(t).value,i=new O.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>r.document),s.selections.map(y.Selection.to),s.options,s.visibleRanges.map(a=>y.Range.to(a)),typeof s.editorPosition=="number"?y.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,i)}c.newActiveEditor!==void 0&&(f.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(u),(0,I.dispose)(E),c.removedDocuments&&this._onDidRemoveDocuments.fire(u),c.addedDocuments&&this._onDidAddDocuments.fire(l),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return c?u:u?.value}allEditors(){return[...this._editors.values()]}};_=Be([Fe(0,L.IExtHostRpcService),Fe(1,v.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[53],ve([1,0,14,5,2,3,4,17]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");let S=class{constructor(O){this._onDidChangeTabGroup=new T.Emitter,this._onDidChangeActiveTabGroup=new T.Emitter,this._tabGroups={all:[],activeTabGroup:void 0,onDidChangeTabGroup:this._onDidChangeTabGroup.event,onDidChangeActiveTabGroup:this._onDidChangeActiveTabGroup.event},this._proxy=O.getProxy(n.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(O){this._tabGroups.all.length=0;let y=!1;for(const v of O){let b;const g=v.tabs.map(d=>{const p=this.createExtHostTabObject(d);return d.isActive&&(b=p),p});if(this._tabGroups.all.push(Object.freeze({isActive:v.isActive,viewColumn:f.ViewColumn.to(v.viewColumn),activeTab:b,tabs:g})),v.isActive){y=!0;const d=this._tabGroups.activeTabGroup;this._tabGroups.activeTabGroup=this._tabGroups.all[this._tabGroups.all.length-1],this.groupDiff(d,this._tabGroups.activeTabGroup)&&this._onDidChangeActiveTabGroup.fire(this._tabGroups.activeTabGroup)}}y||(this._tabGroups.activeTabGroup=void 0,this._onDidChangeActiveTabGroup.fire(void 0)),this._onDidChangeTabGroup.fire()}createExtHostTabObject(O){return Object.freeze({label:O.label,viewColumn:f.ViewColumn.to(O.viewColumn),resource:I.URI.revive(O.resource),additionalResourcesAndViewTypes:O.additionalResourcesAndViewTypes.map(({resource:y,viewId:v})=>({resource:I.URI.revive(y),viewType:v})),viewType:O.editorId,isActive:O.isActive,kind:O.kind,isDirty:O.isDirty,isPinned:O.isPinned,move:async(y,v)=>{this._proxy.$moveTab(O,y,f.ViewColumn.from(v))},close:async()=>{await this._proxy.$closeTab(O)}})}groupDiff(O,y){if(O===y)return!1;if(!O||!y||O.isActive!==y.isActive||O.viewColumn!==y.viewColumn||O.tabs.length!==y.tabs.length)return!0;for(let v=0;v<O.tabs.length;v++)if(this.tabDiff(O.tabs[v],y.tabs[v]))return!0;return!1}tabDiff(O,y){if(O===y)return!1;if(!O||!y||O.label!==y.label||O.viewColumn!==y.viewColumn||O.resource?.toString()!==y.resource?.toString()||O.viewType!==y.viewType||O.isActive!==y.isActive||O.isPinned!==y.isPinned||O.isDirty!==y.isDirty||O.additionalResourcesAndViewTypes.length!==y.additionalResourcesAndViewTypes.length)return!0;for(let v=0;v<O.additionalResourcesAndViewTypes.length;v++){const b=O.additionalResourcesAndViewTypes[v].resource,g=y.additionalResourcesAndViewTypes[v].resource,d=O.additionalResourcesAndViewTypes[v].viewType,p=y.additionalResourcesAndViewTypes[v].viewType;if(b?.toString()!==g?.toString()||d!==p)return!0}return!1}};S=Be([Fe(0,k.IExtHostRpcService)],S),e.ExtHostEditorTabs=S}),define(pe[237],ve([1,0,2,5,6,7,14,150,8,22,30]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const d=this._schemes.indexOf(g);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),d=[];let p,P,_=14,o=14;for(const c of g){let u=p?(0,S.commonPrefixLength)(p,c):0;for(u===0?P=1:P=o;u<c.length;u++)u+1===c.length?(_=o,o=9):o+=1,d.push([P,c.toUpperCase().charCodeAt(u),o]),d.push([P,c.toLowerCase().charCodeAt(u),o]),P=o;p=c,o=_}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new k.StateMachine(d)}}provideDocumentLinks(g){this._initStateMachine();const d=[],p=k.LinkComputer.computeLinks({getLineContent(P){return g.lineAt(P-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const P of p){const _=C.DocumentLink.to(P);_.target&&d.push(_)}return d}}class v{constructor(g,d){this._extHostLanguageFeatures=d,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(n.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,d,p,P={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(_,p);let o=2;P.isCaseSensitive&&(o+=1024),P.isReadonly&&(o+=2048),typeof p.copy=="function"&&(o+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,O.checkProposedApiEnabled)(g,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(_,d,o).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(u)});const c=p.onDidChangeFile(u=>{const l=[];for(const E of u){let{uri:s,type:t}=E;if(s.scheme!==d)continue;let r;switch(t){case T.FileChangeType.Changed:r=0;break;case T.FileChangeType.Created:r=1;break;case T.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:s,type:r})}this._proxy.$onFileSystemChange(_,l)});return(0,I.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(g){const{type:d,ctime:p,mtime:P,size:_,permissions:o}=g;return{type:d,ctime:p,mtime:P,size:_,permissions:o}}$stat(g,d){return Promise.resolve(this._getFsProvider(g).stat(f.URI.revive(d))).then(p=>v._asIStat(p))}$readdir(g,d){return Promise.resolve(this._getFsProvider(g).readDirectory(f.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this._getFsProvider(g).readFile(f.URI.revive(d))).then(p=>L.VSBuffer.wrap(p))}$writeFile(g,d,p,P){return Promise.resolve(this._getFsProvider(g).writeFile(f.URI.revive(d),p.buffer,P))}$delete(g,d,p){return Promise.resolve(this._getFsProvider(g).delete(f.URI.revive(d),p))}$rename(g,d,p,P){return Promise.resolve(this._getFsProvider(g).rename(f.URI.revive(d),f.URI.revive(p),P))}$copy(g,d,p,P){const _=this._getFsProvider(g);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(f.URI.revive(d),f.URI.revive(p),P))}$mkdir(g,d){return Promise.resolve(this._getFsProvider(g).createDirectory(f.URI.revive(d)))}$watch(g,d,p,P){const _=this._getFsProvider(g).watch(f.URI.revive(p),P);this._watches.set(d,_)}$unwatch(g,d){const p=this._watches.get(d);p&&(p.dispose(),this._watches.delete(d))}$open(g,d,p){const P=this._getFsProvider(g);if(!P.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(P.open(f.URI.revive(d),p))}$close(g,d){const p=this._getFsProvider(g);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(d))}$read(g,d,p,P){const _=this._getFsProvider(g);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const o=L.VSBuffer.alloc(P);return Promise.resolve(_.read(d,p,o.buffer,0,P)).then(c=>o.slice(0,c))}$write(g,d,p,P){const _=this._getFsProvider(g);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(d,p,P.buffer,0,P.byteLength))}_getFsProvider(g){const d=this._fsProvider.get(g);if(!d){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return d}}e.ExtHostFileSystem=v}),define(pe[65],ve([1,0,5,42,7,22,4,17,44,6]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class jt{constructor(v,b){this._fileSystemProvider=new Map,this._proxy=v.getProxy(f.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{const p=g._fileSystemProvider.get(d.scheme);if(!p)return await g._proxy.$stat(d);await g._proxy.$ensureActivation(d.scheme);const P=await p.stat(d);return{type:P.type,ctime:P.ctime,mtime:P.mtime,size:P.size,permissions:P.permissions}}catch(p){jt._handleError(p)}},async readDirectory(d){try{const p=g._fileSystemProvider.get(d.scheme);return p?(await g._proxy.$ensureActivation(d.scheme),(await p.readDirectory(d)).slice()):await g._proxy.$readdir(d)}catch(p){return jt._handleError(p)}},async createDirectory(d){try{return await g._proxy.$mkdir(d)}catch(p){return jt._handleError(p)}},async readFile(d){try{const p=g._fileSystemProvider.get(d.scheme);return p?(await g._proxy.$ensureActivation(d.scheme),(await p.readFile(d)).slice()):(await g._proxy.$readFile(d)).buffer}catch(p){return jt._handleError(p)}},async writeFile(d,p){try{return await g._proxy.$writeFile(d,T.VSBuffer.wrap(p))}catch(P){return jt._handleError(P)}},async delete(d,p){try{const P=g._fileSystemProvider.get(d.scheme);return P?(await g._proxy.$ensureActivation(d.scheme),await P.delete(d,{recursive:!1,...p})):await g._proxy.$delete(d,{recursive:!1,useTrash:!1,...p})}catch(P){return jt._handleError(P)}},async rename(d,p,P){try{return await g._proxy.$rename(d,p,{overwrite:!1,...P})}catch(_){return jt._handleError(_)}},async copy(d,p,P){try{return await g._proxy.$copy(d,p,{overwrite:!1,...P})}catch(_){return jt._handleError(_)}},isWritableFileSystem(d){const p=b.getCapabilities(d);if(typeof p=="number")return!(p&2048)}})}static _handleError(v){if(v instanceof I.FileSystemError)throw v;if(!(v instanceof Error))throw new I.FileSystemError(String(v));if(v.name==="ENOPRO")throw I.FileSystemError.Unavailable(v.message);switch(v.name){case n.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(v.message);case n.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(v.message);case n.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(v.message);case n.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(v.message);case n.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(v.message);case n.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(v.message);default:throw new I.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,b){return this._fileSystemProvider.set(v,b),(0,L.toDisposable)(()=>this._fileSystemProvider.delete(v))}};O=Be([Fe(0,k.IExtHostRpcService),Fe(1,S.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[238],ve([1,0,3,34,2,5,14,7]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(y,v,b,g,d,p,P,_){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const o=this.ensureWatching(y,b,d);this._config=0,p&&(this._config+=1),P&&(this._config+=2),_&&(this._config+=4);const c=(0,n.parse)(d),u=typeof d=="string",l=g(E=>{if(!p)for(let s of E.created){const t=I.URI.revive(s);c(t.fsPath)&&(!u||v.getWorkspaceFolder(t))&&this._onDidCreate.fire(t)}if(!P)for(let s of E.changed){const t=I.URI.revive(s);c(t.fsPath)&&(!u||v.getWorkspaceFolder(t))&&this._onDidChange.fire(t)}if(!_)for(let s of E.deleted){const t=I.URI.revive(s);c(t.fsPath)&&(!u||v.getWorkspaceFolder(t))&&this._onDidDelete.fire(t)}});this._disposable=k.Disposable.from(o,this._onDidCreate,this._onDidChange,this._onDidDelete,l)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(y,v,b){let g=k.Disposable.from();if(typeof b=="string")return g;const d=y.getProxy(T.MainContext.MainThreadFileSystem);let p=!1;(b.pattern.includes(n.GLOBSTAR)||b.pattern.includes(n.GLOB_SPLIT))&&(p=!0);const P=Math.random();return d.$watch(v.identifier.value,P,b.baseUri,{recursive:p,excludes:[]}),k.Disposable.from({dispose:()=>d.$unwatch(P)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(y,v,b){this._mainContext=y,this._logService=v,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,v,b,g,d,p){return new S(this._mainContext,y,v,this._onFileSystemEvent.event,C.GlobPattern.from(b),g,d,p)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,v){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:v.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:v.map(b=>I.URI.revive(b.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:v.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,v){return(b,g,d)=>{const p=function(_){b.call(g,_)};return p.extension=y,v.event(p,void 0,d)}}async $onWillRunFileOperation(y,v,b,g){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:v.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},b,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:v.map(d=>I.URI.revive(d.target))},b,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:v.map(d=>I.URI.revive(d.target))},b,g)}}async _fireWillEvent(y,v,b,g){const d=new Set,p=[];if(await y.fireAsync(v,g,async(_,o)=>{const c=Date.now(),u=await Promise.resolve(_);u instanceof k.WorkspaceEdit&&(p.push(u),d.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-c>b&&this._logService.warn("SLOW file-participant",o.extension.identifier)}),g.isCancellationRequested||p.length===0)return;const P={edits:[]};for(let _ of p){let{edits:o}=C.WorkspaceEdit.from(_,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});P.edits=P.edits.concat(o)}return{edit:P,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=L}),define(pe[239],ve([1,0,2,39]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(C,k,S,L){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=L;const O=new n.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new n.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new n.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new n.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new n.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new n.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const v=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri),notebookEditor:v.apiEditor}}return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(O)}$willAddInteractiveDocument(C,k,S,L){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(L))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=I}),define(pe[240],ve([1,0,6,5]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(C){this._handlePool=0,this._proxy=C.getProxy(n.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,C),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(pe[241],ve([1,0,2,25,14,7,5,8,35,18,13,146,21,6,111,75,82,46,15,3,16]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(H,B){this._documents=H,this._provider=B}async provideDocumentSymbols(H,B){const N=this._documents.getDocument(H),z=await this._provider.provideDocumentSymbols(N,B);if(!(0,L.isFalsyOrEmpty)(z))return z[0]instanceof T.DocumentSymbol?z.map(I.DocumentSymbol.from):u._asDocumentSymbolTree(z)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((z,j)=>{let re=z.location.range.start.compareTo(j.location.range.start);return re===0&&(re=j.location.range.end.compareTo(z.location.range.end)),re});const B=[],N=[];for(const z of H){const j={name:z.name||"!!MISSING: name!!",kind:I.SymbolKind.from(z.kind),tags:z.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:z.containerName,range:I.Range.from(z.location.range),selectionRange:I.Range.from(z.location.range),children:[]};for(;;){if(N.length===0){N.push(j),B.push(j);break}const re=N[N.length-1];if(S.Range.containsRange(re.range,j.range)&&!S.Range.equalsRange(re.range,j.range)){re.children&&re.children.push(j),N.push(j);break}N.pop()}}return B}}class l{constructor(H,B,N){this._documents=H,this._commands=B,this._provider=N,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,B){const N=this._documents.getDocument(H),z=await this._provider.provideCodeLenses(N,B);if(!z||B.isCancellationRequested)return;const j=this._cache.add(z),re=new b.DisposableStore;this._disposables.set(j,re);const he={cacheId:j,lenses:[]};for(let Ce=0;Ce<z.length;Ce++)he.lenses.push({cacheId:[j,Ce],range:I.Range.from(z[Ce].range),command:this._commands.toInternal(z[Ce].command,re)});return he}async resolveCodeLens(H,B){const N=H.cacheId&&this._cache.get(...H.cacheId);if(!N)return;let z;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?z=N:z=await this._provider.resolveCodeLens(N,B),z||(z=N),B.isCancellationRequested)return;const j=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!j)return H.command=this._commands.toInternal(z.command??l._badCmd,j),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function E(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class s{constructor(H,B){this._documents=H,this._provider=B}async provideDefinition(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideDefinition(z,j,N);return E(re)}}class t{constructor(H,B){this._documents=H,this._provider=B}async provideDeclaration(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideDeclaration(z,j,N);return E(re)}}class r{constructor(H,B){this._documents=H,this._provider=B}async provideImplementation(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideImplementation(z,j,N);return E(re)}}class i{constructor(H,B){this._documents=H,this._provider=B}async provideTypeDefinition(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideTypeDefinition(z,j,N);return E(re)}}class a{constructor(H,B){this._documents=H,this._provider=B}async provideHover(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideHover(z,j,N);if(!(!re||(0,L.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=z.getWordRangeAtPosition(j)),re.range||(re.range=new T.Range(j,j)),I.Hover.from(re)}}class m{constructor(H,B){this._documents=H,this._provider=B}async provideEvaluatableExpression(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideEvaluatableExpression(z,j,N);if(re)return I.EvaluatableExpression.from(re)}}class h{constructor(H,B){this._documents=H,this._provider=B}async provideInlineValues(H,B,N,z){const j=this._documents.getDocument(H),re=await this._provider.provideInlineValues(j,I.Range.to(B),I.InlineValueContext.to(N),z);if(Array.isArray(re))return re.map(he=>I.InlineValue.from(he))}}class w{constructor(H,B){this._documents=H,this._provider=B}async provideDocumentHighlights(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideDocumentHighlights(z,j,N);if(Array.isArray(re))return re.map(I.DocumentHighlight.from)}}class A{constructor(H,B){this._documents=H,this._provider=B}async provideLinkedEditingRanges(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.provideLinkedEditingRanges(z,j,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,L.coalesce)(re.ranges.map(I.Range.from)),wordPattern:re.wordPattern}}}class F{constructor(H,B){this._documents=H,this._provider=B}async provideReferences(H,B,N,z){const j=this._documents.getDocument(H),re=I.Position.to(B),he=await this._provider.provideReferences(j,re,N,z);if(Array.isArray(he))return he.map(I.location.from)}}class R{constructor(H,B,N,z,j,re,he){this._documents=H,this._commands=B,this._diagnostics=N,this._provider=z,this._logService=j,this._extension=re,this._apiDeprecation=he,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,B,N,z){const j=this._documents.getDocument(H),re=y.Selection.isISelection(B)?I.Selection.to(B):I.Range.to(B),he=[];for(const He of this._diagnostics.getDiagnostics(H))if(re.intersection(He.range)&&he.push(He)>R._maxCodeActionsPerFile)break;const Ce={diagnostics:he,only:N.only?new T.CodeActionKind(N.only):void 0,triggerKind:I.CodeActionTriggerKind.to(N.trigger)},Te=await this._provider.provideCodeActions(j,re,Ce,z);if(!(0,L.isNonEmptyArray)(Te)||z.isCancellationRequested)return;const We=this._cache.add(Te),ze=new b.DisposableStore;this._disposables.set(We,ze);const qe=[];for(let He=0;He<Te.length;He++){const Ue=Te[He];!Ue||(R._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,ze)})):(Ce.only&&(Ue.kind?Ce.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[We,He],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,ze),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(I.Diagnostic.from),edit:Ue.edit&&I.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:qe}}async resolveCodeAction(H,B){const[N,z]=H,j=this._cache.get(N,z);if(!j||R._isCommand(j)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(j,B)??j;return re?.edit?I.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}R._maxCodeActionsPerFile=1e3;class D{constructor(H,B){this._documents=H,this._provider=B}async provideDocumentFormattingEdits(H,B,N){const z=this._documents.getDocument(H),j=await this._provider.provideDocumentFormattingEdits(z,B,N);if(Array.isArray(j))return j.map(I.TextEdit.from)}}class ${constructor(H,B){this._documents=H,this._provider=B}async provideDocumentRangeFormattingEdits(H,B,N,z){const j=this._documents.getDocument(H),re=I.Range.to(B),he=await this._provider.provideDocumentRangeFormattingEdits(j,re,N,z);if(Array.isArray(he))return he.map(I.TextEdit.from)}}class M{constructor(H,B){this._documents=H,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,B,N,z,j){const re=this._documents.getDocument(H),he=I.Position.to(B),Ce=await this._provider.provideOnTypeFormattingEdits(re,he,N,z,j);if(Array.isArray(Ce))return Ce.map(I.TextEdit.from)}}class q{constructor(H,B){this._provider=H,this._logService=B,this._cache=new p.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(H,B){const N=await this._provider.provideWorkspaceSymbols(H,B);if(!(0,L.isNonEmptyArray)(N))return{symbols:[]};const z=this._cache.add(N),j={cacheId:z,symbols:[]};for(let re=0;re<N.length;re++){const he=N[re];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}j.symbols.push({...I.WorkspaceSymbol.from(he),cacheId:[z,re]})}return j}async resolveWorkspaceSymbol(H,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const N=this._cache.get(...H.cacheId);if(N){const z=await this._provider.resolveWorkspaceSymbol(N,B);return z&&(0,n.mixin)(H,I.WorkspaceSymbol.from(z),!0)}}releaseWorkspaceSymbols(H){this._cache.delete(H)}}class G{constructor(H,B,N){this._documents=H,this._provider=B,this._logService=N}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,B,N,z){const j=this._documents.getDocument(H),re=I.Position.to(B);try{const he=await this._provider.provideRenameEdits(j,re,N,z);return he?I.WorkspaceEdit.from(he):void 0}catch(he){const Ce=G._asMessage(he);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(H,B,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const z=this._documents.getDocument(H),j=I.Position.to(B);try{const re=await this._provider.prepareRename(z,j,N);let he,Ce;if(T.Range.isRange(re)?(he=re,Ce=z.getText(re)):(0,O.isObject)(re)&&(he=re.range,Ce=re.placeholder),!he||!Ce)return;if(he.start.line>j.line||he.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(he),text:Ce}}catch(re){const he=G._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class U{constructor(H,B){this.resultId=H,this.tokens=B}}class W{constructor(H,B){this._documents=H,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,B,N){const z=this._documents.getDocument(H),j=B!==0?this._previousResults.get(B):null;let re=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(z,j.resultId,N):await this._provider.provideDocumentSemanticTokens(z,N);return j&&this._previousResults.delete(B),re?(re=W._fixProvidedSemanticTokens(re),this._send(W._convertToEdits(j,re),re)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return W._isSemanticTokens(H)?W._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):W._isSemanticTokensEdits(H)?W._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(B=>new T.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const B of H.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,B){if(!W._isSemanticTokens(B)||!H||!H.tokens)return B;const N=H.tokens,z=N.length,j=B.data,re=j.length;let he=0;const Ce=Math.min(z,re);for(;he<Ce&&N[he]===j[he];)he++;if(he===z&&he===re)return new T.SemanticTokensEdits([],B.resultId);let Te=0;const We=Ce-he;for(;Te<We&&N[z-Te-1]===j[re-Te-1];)Te++;return new T.SemanticTokensEdits([{start:he,deleteCount:z-he-Te,data:j.subarray(he,re-Te)}],B.resultId)}_send(H,B){if(W._isSemanticTokens(H)){const N=this._nextResultId++;return this._previousResults.set(N,new U(H.resultId,H.data)),(0,g.encodeSemanticTokensDto)({id:N,type:"full",data:H.data})}if(W._isSemanticTokensEdits(H)){const N=this._nextResultId++;return W._isSemanticTokens(B)?this._previousResults.set(N,new U(B.resultId,B.data)):this._previousResults.set(N,new U(H.resultId)),(0,g.encodeSemanticTokensDto)({id:N,type:"delta",deltas:(H.edits||[]).map(z=>({start:z.start,deleteCount:z.deleteCount,data:z.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class ee{constructor(H,B){this._documents=H,this._provider=B}async provideDocumentRangeSemanticTokens(H,B,N){const z=this._documents.getDocument(H),j=await this._provider.provideDocumentRangeSemanticTokens(z,I.Range.to(B),N);return j?this._send(j):null}_send(H){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=ee;class Z{constructor(H,B,N,z,j){this._documents=H,this._commands=B,this._provider=N,this._apiDeprecation=z,this._extension=j,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,B,N,z){const j=this._documents.getDocument(H),re=I.Position.to(B),he=j.getWordRangeAtPosition(re)||new T.Range(re,re),Ce=he.with({end:re}),Te=new P.StopWatch(!0),We=await this._provider.provideCompletionItems(j,re,z,I.CompletionContext.to(N));if(!We||z.isCancellationRequested)return;const ze=Array.isArray(We)?new T.CompletionList(We):We,qe=Z.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),He=new b.DisposableStore;this._disposables.set(qe,He);const Ue=[],Je={x:qe,b:Ue,a:{replace:I.Range.from(he),insert:I.Range.from(Ce)},c:ze.isIncomplete||void 0,d:Te.elapsed()};for(let et=0;et<ze.items.length;et++){const Le=ze.items[et],it=this._convertCompletionItem(Le,[qe,et],Ce,he);Ue.push(it)}return Je}async resolveCompletionItem(H,B){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...H);if(!N)return;const z=await this._provider.resolveCompletionItem(N,B);if(!!z)return this._convertCompletionItem(z,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,B,N,z){const j=this._disposables.get(B[0]);if(!j)throw Error("DisposableStore is missing...");const re={x:B,a:H.label,b:H.kind!==void 0?I.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(I.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(H.command,j)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=H.textEdit.newText):typeof H.insertText=="string"?re.h=H.insertText:H.insertText instanceof T.SnippetString&&(re.h=H.insertText.value,re.i|=4);let he;return H.textEdit?he=H.textEdit.range:H.range&&(he=H.range),T.Range.isRange(he)?re.j=I.Range.from(he):he&&(!N?.isEqual(he.inserting)||!z?.isEqual(he.replacing))&&(re.j={insert:I.Range.from(he.inserting),replace:I.Range.from(he.replacing)}),re}}class V{constructor(H,B,N){this._documents=H,this._provider=B,this._commands=N,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,B,N,z){const j=this._documents.getDocument(H),re=I.Position.to(B),he=await this._provider.provideInlineCompletionItems(j,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:I.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},z);if(!he||z.isCancellationRequested)return;const Ce=(0,O.isArray)(he)?he:he.items,Te=this._cache.add(Ce);let We;return{pid:Te,items:Ce.map((ze,qe)=>{let He;ze.command&&(We||(We=new b.DisposableStore,this._disposables.set(Te,We)),He=this._commands.toInternal(ze.command,We));const Ue=ze.insertText??ze.text;if(Ue===void 0)throw new Error("text or insertText must be defined");return{text:typeof Ue=="string"?Ue:{snippet:Ue.value},range:ze.range?I.Range.from(ze.range):void 0,command:He,idx:qe,completeBracketPairs:ze.completeBracketPairs}})}}disposeCompletions(H){this._cache.delete(H);const B=this._disposables.get(H);B&&B.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,B){const N=this._cache.get(H,B);N&&J.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class J{constructor(){this._onDidShowCompletionItemEmitter=new o.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let B=J.map.get(H);return B||(B=new J,J.map.set(H,B)),B}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=J,J.map=new WeakMap;class se{constructor(H,B){this._documents=H,this._provider=B,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(H,B,N,z){const j=this._documents.getDocument(H),re=I.Position.to(B),he=this.reviveContext(N),Ce=await this._provider.provideSignatureHelp(j,re,z,he);if(Ce){const Te=this._cache.add([Ce]);return{...I.SignatureHelp.from(Ce),id:Te}}}reviveContext(H){let B;if(H.activeSignatureHelp){const N=I.SignatureHelp.to(H.activeSignatureHelp),z=this._cache.get(H.activeSignatureHelp.id,0);z?(B=z,B.activeSignature=N.activeSignature,B.activeParameter=N.activeParameter):B=N}return{...H,activeSignatureHelp:B}}releaseSignatureHelp(H){this._cache.delete(H)}}class ae{constructor(H,B,N,z,j){this._documents=H,this._commands=B,this._provider=N,this._logService=z,this._extension=j,this._cache=new p.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(H,B,N){const z=this._documents.getDocument(H),j=I.Range.to(B),re=await this._provider.provideInlayHints(z,j,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(N.isCancellationRequested)return;const he=this._cache.add(re);this._disposables.set(he,new b.DisposableStore);const Ce={hints:[],cacheId:he};for(let Te=0;Te<re.length;Te++)this._isValidInlayHint(re[Te],j)&&Ce.hints.push(this._convertInlayHint(re[Te],[he,Te]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ce}async resolveInlayHint(H,B){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...H);if(!N)return;const z=await this._provider.resolveInlayHint(N,B);if(!!z&&!!this._isValidInlayHint(z))return this._convertInlayHint(z,H)}releaseHints(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_isValidInlayHint(H,B){return H.label.length===0||Array.isArray(H.label)&&H.label.every(N=>N.value.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(B&&!B.contains(H.position))}_convertInlayHint(H,B){const N=this._disposables.get(B[0]);if(!N)throw Error("DisposableStore is missing...");const z={label:"",cacheId:B,tooltip:I.MarkdownString.fromStrict(H.tooltip),position:I.Position.from(H.position),textEdits:H.textEdits&&H.textEdits.map(I.TextEdit.from),kind:H.kind&&I.InlayHintKind.from(H.kind),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};return typeof H.label=="string"?z.label=H.label:z.label=H.label.map(j=>{let re={label:j.value};return re.tooltip=I.MarkdownString.fromStrict(j.tooltip),T.Location.isLocation(j.location)&&(re.location=I.location.from(j.location)),j.command&&(re.command=this._commands.toInternal(j.command,N)),re}),z}}class Q{constructor(H,B){this._documents=H,this._provider=B,this._cache=new p.Cache("DocumentLink")}async provideLinks(H,B){const N=this._documents.getDocument(H),z=await this._provider.provideDocumentLinks(N,B);if(!(!Array.isArray(z)||z.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:z.filter(Q._validateLink).map(I.DocumentLink.from)};{const j=this._cache.add(z),re={links:[],cacheId:j};for(let he=0;he<z.length;he++){if(!Q._validateLink(z[he]))continue;const Ce=I.DocumentLink.from(z[he]);Ce.cacheId=[j,he],re.links.push(Ce)}return re}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,B){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...H);if(!N)return;const z=await this._provider.resolveDocumentLink(N,B);if(!(!z||!Q._validateLink(z)))return I.DocumentLink.from(z)}releaseLinks(H){this._cache.delete(H)}}class Y{constructor(H,B){this._documents=H,this._provider=B}async provideColors(H,B){const N=this._documents.getDocument(H),z=await this._provider.provideDocumentColors(N,B);return Array.isArray(z)?z.map(re=>({color:I.Color.from(re.color),range:I.Range.from(re.range)})):[]}async provideColorPresentations(H,B,N){const z=this._documents.getDocument(H),j=I.Range.to(B.range),re=I.Color.to(B.color),he=await this._provider.provideColorPresentations(re,{document:z,range:j},N);if(!!Array.isArray(he))return he.map(I.ColorPresentation.from)}}class oe{constructor(H,B){this._documents=H,this._provider=B}async provideFoldingRanges(H,B,N){const z=this._documents.getDocument(H),j=await this._provider.provideFoldingRanges(z,B,N);if(!!Array.isArray(j))return j.map(I.FoldingRange.from)}}class de{constructor(H,B,N){this._documents=H,this._provider=B,this._logService=N}async provideSelectionRanges(H,B,N){const z=this._documents.getDocument(H),j=B.map(I.Position.to),re=await this._provider.provideSelectionRanges(z,j,N);if(!(0,L.isNonEmptyArray)(re))return[];if(re.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ce=0;Ce<j.length;Ce++){const Te=[];he.push(Te);let We=j[Ce],ze=re[Ce];for(;;){if(!ze.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Te.push(I.SelectionRange.from(ze)),!ze.parent)break;We=ze.range,ze=ze.parent}}return he}}class Ee{constructor(H,B){this._documents=H,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.prepareCallHierarchy(z,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo(H,B,N){const z=this._itemFromCache(H,B);if(!z)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(z,N);if(!!j)return j.map(re=>({from:this._cacheAndConvertItem(H,re.from),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}async provideCallsFrom(H,B,N){const z=this._itemFromCache(H,B);if(!z)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(z,N);if(!!j)return j.map(re=>({to:this._cacheAndConvertItem(H,re.to),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,B){const N=this._cache.get(H),z=I.CallHierarchyItem.from(B,H,N.size.toString(36));return N.set(z._itemId,B),z}_itemFromCache(H,B){return this._cache.get(H)?.get(B)}}class Re{constructor(H,B){this._documents=H,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(H,B,N){const z=this._documents.getDocument(H),j=I.Position.to(B),re=await this._provider.prepareTypeHierarchy(z,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes(H,B,N){const z=this._itemFromCache(H,B);if(!z)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(z,N);if(!!j)return j.map(re=>this._cacheAndConvertItem(H,re))}async provideSubtypes(H,B,N){const z=this._itemFromCache(H,B);if(!z)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(z,N);if(!!j)return j.map(re=>this._cacheAndConvertItem(H,re))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,B){const N=this._cache.get(H),z=I.TypeHierarchyItem.from(B,H,N.size.toString(36));return N.set(z._itemId,B),z}_itemFromCache(H,B){return this._cache.get(H)?.get(B)}}class Ne{constructor(H,B){this.adapter=H,this.extension=B}}class be{constructor(H,B,N,z,j,re,he){this._adapter=new Map,this._uriTransformer=B,this._proxy=H.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=z,this._diagnostics=j,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector(H){return I.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return be._handlePool++}async _withAdapter(H,B,N,z,j){const re=this._adapter.get(H);if(!re||!(re.adapter instanceof B))return z;const he=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const Ce=N(re.adapter,re.extension);return Promise.resolve(Ce).catch(Te=>{(0,_.isCancellationError)(Te)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Te))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-he}ms`)}),v.CancellationToken.isCancellationToken(j)?(0,c.raceCancellationError)(Ce,j):Ce}_addNewAdapter(H,B){const N=this._nextHandle();return this._adapter.set(N,new Ne(H,B)),N}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,B,N,z){const j=this._addNewAdapter(new u(this._documents,N),H),re=z&&z.label||be._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(B),re),this._createDisposable(j)}$provideDocumentSymbols(H,B,N){return this._withAdapter(H,u,z=>z.provideDocumentSymbols(f.URI.revive(B),N),void 0,N)}registerCodeLensProvider(H,B,N){const z=this._nextHandle(),j=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(z,new Ne(new l(this._documents,this._commands.converter,N),H)),this._proxy.$registerCodeLensSupport(z,this._transformDocumentSelector(B),j);let re=this._createDisposable(z);if(j!==void 0){const he=N.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(j));re=T.Disposable.from(re,he)}return re}$provideCodeLenses(H,B,N){return this._withAdapter(H,l,z=>z.provideCodeLenses(f.URI.revive(B),N),void 0,N)}$resolveCodeLens(H,B,N){return this._withAdapter(H,l,z=>z.resolveCodeLens(B,N),void 0,void 0)}$releaseCodeLenses(H,B){this._withAdapter(H,l,N=>Promise.resolve(N.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(H,B,N){const z=this._addNewAdapter(new s(this._documents,N),H);return this._proxy.$registerDefinitionSupport(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideDefinition(H,B,N,z){return this._withAdapter(H,s,j=>j.provideDefinition(f.URI.revive(B),N,z),[],z)}registerDeclarationProvider(H,B,N){const z=this._addNewAdapter(new t(this._documents,N),H);return this._proxy.$registerDeclarationSupport(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideDeclaration(H,B,N,z){return this._withAdapter(H,t,j=>j.provideDeclaration(f.URI.revive(B),N,z),[],z)}registerImplementationProvider(H,B,N){const z=this._addNewAdapter(new r(this._documents,N),H);return this._proxy.$registerImplementationSupport(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideImplementation(H,B,N,z){return this._withAdapter(H,r,j=>j.provideImplementation(f.URI.revive(B),N,z),[],z)}registerTypeDefinitionProvider(H,B,N){const z=this._addNewAdapter(new i(this._documents,N),H);return this._proxy.$registerTypeDefinitionSupport(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideTypeDefinition(H,B,N,z){return this._withAdapter(H,i,j=>j.provideTypeDefinition(f.URI.revive(B),N,z),[],z)}registerHoverProvider(H,B,N,z){const j=this._addNewAdapter(new a(this._documents,N),H);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideHover(H,B,N,z){return this._withAdapter(H,a,j=>j.provideHover(f.URI.revive(B),N,z),void 0,z)}registerEvaluatableExpressionProvider(H,B,N,z){const j=this._addNewAdapter(new m(this._documents,N),H);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideEvaluatableExpression(H,B,N,z){return this._withAdapter(H,m,j=>j.provideEvaluatableExpression(f.URI.revive(B),N,z),void 0,z)}registerInlineValuesProvider(H,B,N,z){const j=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new h(this._documents,N),H);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(B),j);let he=this._createDisposable(re);if(j!==void 0){const Ce=N.onDidChangeInlineValues(Te=>this._proxy.$emitInlineValuesEvent(j));he=T.Disposable.from(he,Ce)}return he}$provideInlineValues(H,B,N,z,j){return this._withAdapter(H,h,re=>re.provideInlineValues(f.URI.revive(B),N,z,j),void 0,j)}registerDocumentHighlightProvider(H,B,N){const z=this._addNewAdapter(new w(this._documents,N),H);return this._proxy.$registerDocumentHighlightProvider(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideDocumentHighlights(H,B,N,z){return this._withAdapter(H,w,j=>j.provideDocumentHighlights(f.URI.revive(B),N,z),void 0,z)}registerLinkedEditingRangeProvider(H,B,N){const z=this._addNewAdapter(new A(this._documents,N),H);return this._proxy.$registerLinkedEditingRangeProvider(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideLinkedEditingRanges(H,B,N,z){return this._withAdapter(H,A,async j=>{const re=await j.provideLinkedEditingRanges(f.URI.revive(B),N,z);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?be._serializeRegExp(re.wordPattern):void 0}},void 0,z)}registerReferenceProvider(H,B,N){const z=this._addNewAdapter(new F(this._documents,N),H);return this._proxy.$registerReferenceSupport(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideReferences(H,B,N,z,j){return this._withAdapter(H,F,re=>re.provideReferences(f.URI.revive(B),N,z,j),void 0,j)}registerCodeActionProvider(H,B,N,z){const j=new b.DisposableStore,re=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,N,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(B),{providedKinds:z?.providedCodeActionKinds?.map(he=>he.value),documentation:z?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,j)}))},be._extLabel(H),Boolean(N.resolveCodeAction)),j.add(this._createDisposable(re)),j}$provideCodeActions(H,B,N,z,j){return this._withAdapter(H,R,re=>re.provideCodeActions(f.URI.revive(B),N,z,j),void 0,j)}$resolveCodeAction(H,B,N){return this._withAdapter(H,R,z=>z.resolveCodeAction(B,N),void 0,void 0)}$releaseCodeActions(H,B){this._withAdapter(H,R,N=>Promise.resolve(N.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(H,B,N){const z=this._addNewAdapter(new D(this._documents,N),H);return this._proxy.$registerDocumentFormattingSupport(z,this._transformDocumentSelector(B),H.identifier,H.displayName||H.name),this._createDisposable(z)}$provideDocumentFormattingEdits(H,B,N,z){return this._withAdapter(H,D,j=>j.provideDocumentFormattingEdits(f.URI.revive(B),N,z),void 0,z)}registerDocumentRangeFormattingEditProvider(H,B,N){const z=this._addNewAdapter(new $(this._documents,N),H);return this._proxy.$registerRangeFormattingSupport(z,this._transformDocumentSelector(B),H.identifier,H.displayName||H.name),this._createDisposable(z)}$provideDocumentRangeFormattingEdits(H,B,N,z,j){return this._withAdapter(H,$,re=>re.provideDocumentRangeFormattingEdits(f.URI.revive(B),N,z,j),void 0,j)}registerOnTypeFormattingEditProvider(H,B,N,z){const j=this._addNewAdapter(new M(this._documents,N),H);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(B),z,H.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(H,B,N,z,j,re){return this._withAdapter(H,M,he=>he.provideOnTypeFormattingEdits(f.URI.revive(B),N,z,j,re),void 0,re)}registerWorkspaceSymbolProvider(H,B){const N=this._addNewAdapter(new q(B,this._logService),H);return this._proxy.$registerNavigateTypeSupport(N,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols(H,B,N){return this._withAdapter(H,q,z=>z.provideWorkspaceSymbols(B,N),{symbols:[]},N)}$resolveWorkspaceSymbol(H,B,N){return this._withAdapter(H,q,z=>z.resolveWorkspaceSymbol(B,N),void 0,void 0)}$releaseWorkspaceSymbols(H,B){this._withAdapter(H,q,N=>N.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(H,B,N){const z=this._addNewAdapter(new G(this._documents,N,this._logService),H);return this._proxy.$registerRenameSupport(z,this._transformDocumentSelector(B),G.supportsResolving(N)),this._createDisposable(z)}$provideRenameEdits(H,B,N,z,j){return this._withAdapter(H,G,re=>re.provideRenameEdits(f.URI.revive(B),N,z,j),void 0,j)}$resolveRenameLocation(H,B,N,z){return this._withAdapter(H,G,j=>j.resolveRenameLocation(f.URI.revive(B),N,z),void 0,z)}registerDocumentSemanticTokensProvider(H,B,N,z){const j=this._addNewAdapter(new W(this._documents,N),H),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(B),z,re);let he=this._createDisposable(j);if(re){const Ce=N.onDidChangeSemanticTokens(Te=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=T.Disposable.from(he,Ce)}return he}$provideDocumentSemanticTokens(H,B,N,z){return this._withAdapter(H,W,j=>j.provideDocumentSemanticTokens(f.URI.revive(B),N,z),null,z)}$releaseDocumentSemanticTokens(H,B){this._withAdapter(H,W,N=>N.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,B,N,z){const j=this._addNewAdapter(new ee(this._documents,N),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(B),z),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(H,B,N,z){return this._withAdapter(H,ee,j=>j.provideDocumentRangeSemanticTokens(f.URI.revive(B),N,z),null,z)}registerCompletionItemProvider(H,B,N,z){const j=this._addNewAdapter(new Z(this._documents,this._commands.converter,N,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(B),z,Z.supportsResolving(N),`${H.identifier.value}(${z.join("")})`),this._createDisposable(j)}$provideCompletionItems(H,B,N,z,j){return this._withAdapter(H,Z,re=>re.provideCompletionItems(f.URI.revive(B),N,z,j),void 0,j)}$resolveCompletionItem(H,B,N){return this._withAdapter(H,Z,z=>z.resolveCompletionItem(B,N),void 0,N)}$releaseCompletionItems(H,B){this._withAdapter(H,Z,N=>N.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(H,B,N){const z=this._addNewAdapter(new V(this._documents,N,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideInlineCompletions(H,B,N,z,j){return this._withAdapter(H,V,re=>re.provideInlineCompletions(f.URI.revive(B),N,z,j),void 0,j)}$handleInlineCompletionDidShow(H,B,N){this._withAdapter(H,V,async z=>{z.handleDidShowCompletionItem(B,N)},void 0,void 0)}$freeInlineCompletionsList(H,B){this._withAdapter(H,V,async N=>{N.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(H,B,N,z){const j=Array.isArray(z)?{triggerCharacters:z,retriggerCharacters:[]}:z,re=this._addNewAdapter(new se(this._documents,N),H);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(B),j),this._createDisposable(re)}$provideSignatureHelp(H,B,N,z,j){return this._withAdapter(H,se,re=>re.provideSignatureHelp(f.URI.revive(B),N,z,j),void 0,j)}$releaseSignatureHelp(H,B){this._withAdapter(H,se,N=>N.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(H,B,N){const z=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new ae(this._documents,this._commands.converter,N,this._logService,H),H);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(B),typeof N.resolveInlayHint=="function",z,be._extLabel(H));let re=this._createDisposable(j);if(z!==void 0){const he=N.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(z));re=T.Disposable.from(re,he)}return re}$provideInlayHints(H,B,N,z){return this._withAdapter(H,ae,j=>j.provideInlayHints(f.URI.revive(B),N,z),void 0,z)}$resolveInlayHint(H,B,N){return this._withAdapter(H,ae,z=>z.resolveInlayHint(B,N),void 0,N)}$releaseInlayHints(H,B){this._withAdapter(H,ae,N=>N.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(H,B,N){const z=this._addNewAdapter(new Q(this._documents,N),H);return this._proxy.$registerDocumentLinkProvider(z,this._transformDocumentSelector(B),typeof N.resolveDocumentLink=="function"),this._createDisposable(z)}$provideDocumentLinks(H,B,N){return this._withAdapter(H,Q,z=>z.provideLinks(f.URI.revive(B),N),void 0,N)}$resolveDocumentLink(H,B,N){return this._withAdapter(H,Q,z=>z.resolveLink(B,N),void 0,void 0)}$releaseDocumentLinks(H,B){this._withAdapter(H,Q,N=>N.releaseLinks(B),void 0,void 0)}registerColorProvider(H,B,N){const z=this._addNewAdapter(new Y(this._documents,N),H);return this._proxy.$registerDocumentColorProvider(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideDocumentColors(H,B,N){return this._withAdapter(H,Y,z=>z.provideColors(f.URI.revive(B),N),[],N)}$provideColorPresentations(H,B,N,z){return this._withAdapter(H,Y,j=>j.provideColorPresentations(f.URI.revive(B),N,z),void 0,z)}registerFoldingRangeProvider(H,B,N){const z=this._nextHandle(),j=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(z,new Ne(new oe(this._documents,N),H)),this._proxy.$registerFoldingRangeProvider(z,this._transformDocumentSelector(B),j);let re=this._createDisposable(z);if(j!==void 0){const he=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));re=T.Disposable.from(re,he)}return re}$provideFoldingRanges(H,B,N,z){return this._withAdapter(H,oe,j=>j.provideFoldingRanges(f.URI.revive(B),N,z),void 0,z)}registerSelectionRangeProvider(H,B,N){const z=this._addNewAdapter(new de(this._documents,N,this._logService),H);return this._proxy.$registerSelectionRangeProvider(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$provideSelectionRanges(H,B,N,z){return this._withAdapter(H,de,j=>j.provideSelectionRanges(f.URI.revive(B),N,z),[],z)}registerCallHierarchyProvider(H,B,N){const z=this._addNewAdapter(new Ee(this._documents,N),H);return this._proxy.$registerCallHierarchyProvider(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$prepareCallHierarchy(H,B,N,z){return this._withAdapter(H,Ee,j=>Promise.resolve(j.prepareSession(f.URI.revive(B),N,z)),void 0,z)}$provideCallHierarchyIncomingCalls(H,B,N,z){return this._withAdapter(H,Ee,j=>j.provideCallsTo(B,N,z),void 0,z)}$provideCallHierarchyOutgoingCalls(H,B,N,z){return this._withAdapter(H,Ee,j=>j.provideCallsFrom(B,N,z),void 0,z)}$releaseCallHierarchy(H,B){this._withAdapter(H,Ee,N=>Promise.resolve(N.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(H,B,N){const z=this._addNewAdapter(new Re(this._documents,N),H);return this._proxy.$registerTypeHierarchyProvider(z,this._transformDocumentSelector(B)),this._createDisposable(z)}$prepareTypeHierarchy(H,B,N,z){return this._withAdapter(H,Re,j=>Promise.resolve(j.prepareSession(f.URI.revive(B),N,z)),void 0,z)}$provideTypeHierarchySupertypes(H,B,N,z){return this._withAdapter(H,Re,j=>j.provideSupertypes(B,N,z),void 0,z)}$provideTypeHierarchySubtypes(H,B,N,z){return this._withAdapter(H,Re,j=>j.provideSubtypes(B,N,z),void 0,z)}$releaseTypeHierarchy(H,B){this._withAdapter(H,Re,N=>Promise.resolve(N.releaseSession(B)),void 0,void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,k.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:be._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:be._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?be._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?be._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:be._serializeRegExp(H.beforeText),afterText:H.afterText?be._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?be._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(be._serializeOnEnterRule)}setLanguageConfiguration(H,B,N){let{wordPattern:z}=N;if(z&&(0,k.regExpLeadsToEndlessLoop)(z))throw new Error(`Invalid language configuration: wordPattern '${z}' is not allowed to match the empty string.`);z?this._documents.setWordDefinitionFor(B,z):this._documents.setWordDefinitionFor(B,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const j=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?be._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?be._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?be._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,B,re),this._createDisposable(j)}$setWordDefinitions(H){for(const B of H)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=be,be._handlePool=0}),define(pe[242],ve([1,0,5,14,7,47,16,6]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(O,y,v,b){this._documents=y,this._commands=v,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,y){await this._proxy.$changeLanguage(O,y);const v=this._documents.getDocumentData(O);if(!v)throw new Error(`document '${O.toString()}' NOT found`);return v.document}async tokenAtPosition(O,y){const v=O.version,b=n.Position.from(y),g=await this._proxy.$tokensAtPosition(O.uri,b),d={type:I.StandardTokenType.Other,range:O.getWordRangeAtPosition(y)??new I.Range(y.line,y.character,y.line,y.character)};if(!g)return d;const p={range:n.Range.to(g.range),type:n.TokenType.to(g.type)};return!p.range.contains(y)||v!==O.version?d:p}createLanguageStatusItem(O,y,v){const b=this._handlePool++,g=this._proxy,d=this._ids,p=`${O.identifier.value}/${y}`;if(d.has(p))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);d.add(p);const P={selector:v,id:y,name:O.displayName??O.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,o=new k.DisposableStore;const c=()=>{_?.dispose(),_=(0,C.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(b,{id:p,name:P.name??O.displayName??O.name,source:O.displayName??O.name,selector:n.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===I.LanguageStatusSeverity.Error?T.default.Error:P.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:P.command&&this._commands.toInternal(P.command,o),accessibilityInfo:P.accessibilityInformation,busy:P.busy})},0)},u={dispose(){o.dispose(),_?.dispose(),g.$removeLanguageStatus(b),d.delete(p)},get id(){return P.id},get name(){return P.name},set name(l){P.name=l,c()},get selector(){return P.selector},set selector(l){P.selector=l,c()},get text(){return P.text},set text(l){P.text=l,c()},get detail(){return P.detail},set detail(l){P.detail=l,c()},get severity(){return P.severity},set severity(l){P.severity=l,c()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(l){P.accessibilityInformation=l,c()},get command(){return P.command},set command(l){P.command=l,c()},get busy(){return P.busy},set busy(l){P.busy=l,c()}};return c(),u}}e.ExtHostLanguages=S}),define(pe[134],ve([1,0,11,5,26,17,3]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends f.AbstractLoggerService{constructor(O,y){const v=new C.Emitter;super(y.logLevel,v.event);this._proxy=O.getProxy(n.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(v)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,y,v){return new S(this._proxy,O,y,v)}};k=Be([Fe(0,T.IExtHostRpcService),Fe(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends f.AbstractMessageLogger{constructor(O,y,v,b){super(b?.always);this.proxy=O,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.proxy.$createLogger(y,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,y){const v=[[O,y]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(O){this.proxy.$log(this.file,O)}}}),define(pe[243],ve([1,0,5,11,30]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let C=class{constructor(S,L){this._logService=L,this._proxy=S.getProxy(f.MainContext.MainThreadMessageService)}showMessage(S,L,O,y,v){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let g;typeof y=="string"||T(y)?g=[y,...v]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,g=v),b.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let p=0;p<g.length;p++){const P=g[p];if(typeof P=="string")d.push({title:P,handle:p,isCloseAffordance:!1});else if(typeof P=="object"){let{title:_,isCloseAffordance:o}=P;d.push({title:_,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(L,O,b,d).then(p=>{if(typeof p=="number")return g[p]})}};C=Be([Fe(1,n.ILogService)],C),e.ExtHostMessageService=C}),define(pe[244],ve([1,0,22,3,57,6,24,8,13,2,82,5,14,7,52,220,130]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(o,c,u,l,E){this._textDocumentsAndEditors=u,this._textDocuments=l,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new n.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new n.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new n.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new n.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new n.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new n.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new n.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const t=s.notebookEditor?.notebookUri,r=s.cell.handle,a=this._documents.get(t)?.getCell(r);if(a)return a.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const c=this._editors.get(o);if(!c)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(o){for(const[c,u]of this._editors)if(u.apiEditor===o)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,c){const u=this._documents.get(o);if(!u&&!c)throw new Error(`NO notebook document for '${o}'`);return u}_getProviderData(o){const c=this._notebookContentProviders.get(o);if(!c)throw new Error(`NO provider for '${o}'`);return c}registerNotebookContentProvider(o,c,u,l,E){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:o,provider:u});let s;return u.onDidChangeNotebookContentOptions&&(s=u.onDidChangeNotebookContentOptions(()=>{const t=v.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(c,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},c,v.NotebookDocumentContentOptions.from(l),P._convertNotebookRegistrationData(o,E)),new b.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(o,c){if(!c)return;const u=c.filenamePattern.map(l=>v.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(c.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:c.displayName,filenamePattern:u,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,c,u){const l=P._notebookStatusBarItemProviderHandlePool++,E=typeof u.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,E,c);let s;return E!==void 0&&(s=u.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(E))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,E),s&&s.dispose()})}async createNotebookDocument(o){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&v.NotebookData.from(o.content)});return L.URI.revive(c)}async openNotebookDocument(o){const c=this._documents.get(o);if(c)return c.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(o),l=this._documents.get(L.URI.revive(u));return(0,S.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(o,c){L.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let u;typeof c=="object"?u={position:v.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(v.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:u={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,u),E=l&&this._editors.get(l)?.apiEditor;if(E)return E;throw l?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,c,u,l){const E=this._notebookStatusBarItemProviders.get(o),s=L.URI.revive(c),t=this._documents.get(s);if(!t||!E)return;const r=t.getCellFromIndex(u);if(!r)return;const i=await E.provideCellStatusBarItems(r.apiCell,l);if(!i)return;const a=new T.DisposableStore,m=this._statusBarCache.add([a]),w=(Array.isArray(i)?i:[i]).map(A=>v.NotebookStatusBarItem.from(A,this._commandsConverter,a));return{cacheId:m,items:w}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,c,u,l,E){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,u),this._notebookProxy.$registerNotebookSerializer(s,{id:o.identifier,location:o.extensionLocation},c,v.NotebookDocumentContentOptions.from(l),P._convertNotebookRegistrationData(o,E)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(o,c,u){const l=this._notebookSerializer.get(o);if(!l)throw new Error("NO serializer found");const E=await l.deserializeNotebook(c.buffer,u);return new g.SerializableObjectWithBuffers(v.NotebookData.from(E))}async $notebookToData(o,c,u){const l=this._notebookSerializer.get(o);if(!l)throw new Error("NO serializer found");const E=await l.serializeNotebook(v.NotebookData.to(c.value),u);return f.VSBuffer.wrap(E)}async $openNotebook(o,c,u,l,E){const{provider:s}=this._getProviderData(o),t=await s.openNotebook(L.URI.revive(c),{backupId:u,untitledDocumentData:l?.buffer},E);return new g.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(v.NotebookCellData.from)})}async $saveNotebook(o,c,u){const l=this.getNotebookDocument(L.URI.revive(c)),{provider:E}=this._getProviderData(o);return await E.saveNotebook(l.apiNotebook,u),!0}async $saveNotebookAs(o,c,u,l){const E=this.getNotebookDocument(L.URI.revive(c)),{provider:s}=this._getProviderData(o);return await s.saveNotebookAs(L.URI.revive(u),E.apiNotebook,l),!0}async $backupNotebook(o,c,u){const l=this.getNotebookDocument(L.URI.revive(c)),E=this._getProviderData(o),s=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),t=String((0,I.hash)([l.uri.toString(),this._backupIdPool++])),r=L.URI.joinPath(s,t),i=await E.provider.backupNotebook(l.apiNotebook,{destination:r},u);return l.updateBackup(i),i.id}_createExtHostEditor(o,c,u){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const l=new p.ExtHostNotebookEditor(c,this._notebookEditorsProxy,o,u.visibleRanges.map(v.NotebookRange.to),u.selections.map(v.NotebookRange.to),typeof u.viewColumn=="number"?v.ViewColumn.to(u.viewColumn):void 0);this._editors.set(c,l)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const u of o.value.removedDocuments){const l=L.URI.revive(u),E=this._documents.get(l);E&&(E.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===l.toString()&&this._editors.delete(s.id)}if(o.value.addedDocuments){const u=[];for(const l of o.value.addedDocuments){const E=L.URI.revive(l.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const s=this,t=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){s._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){s._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){s._onDidChangeCellMetadata.fire(r)}},E,l);u.push(...l.cells.map(r=>d.ExtHostCell.asModelAddData(t.apiNotebook,r))),this._documents.get(E)?.dispose(),this._documents.set(E,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const u of o.value.addedEditors){if(this._editors.has(u.id))return;const l=L.URI.revive(u.documentUri),E=this._documents.get(l);E&&this._createExtHostEditor(E,u.id,u)}const c=[];if(o.value.removedEditors)for(const u of o.value.removedEditors){const l=this._editors.get(u);l&&(this._editors.delete(u),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),c.push(l))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const u=new Set;this._visibleNotebookEditors.forEach(l=>u.add(l.id));for(const l of this._editors.values()){const E=u.has(l.id);l._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(pe[245],ve([1,0,3,75,11,5,17,14]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(y,v){const b=S._Keys.nextId();y.$registerNotebookEditorDecorationType(b,k.NotebookDecorationRenderOptions.from(v)),this.value={key:b,dispose(){y.$removeNotebookEditorDecorationType(b)}}}}S._Keys=new n.IdGenerator("NotebookEditorDecorationType");let L=class{constructor(y,v,b){this._logService=y,this._extHostRpc=v,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new S(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,v);const b=this._notebooksAndEditors.getEditorById(y);v.visibleRanges&&b._acceptVisibleRanges(v.visibleRanges.ranges.map(k.NotebookRange.to)),v.selections&&b._acceptSelections(v.selections.selections.map(k.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const v in y)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(k.ViewColumn.to(y[v]))}};L=Be([Fe(0,I.ILogService),Fe(1,C.IExtHostRpcService)],L),e.ExtHostNotebookEditors=L}),define(pe[246],ve([1,0,18,16,21,3,6,24,2,27,11,5,39,14,7,83,213,30,52]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(t,r,i,a,m){this._initData=r,this._extHostNotebook=i,this._commands=a,this._logService=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=t.getProxy(y.MainContext.MainThreadNotebookKernels);const h=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const A=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:A}}else if(w&&"notebookEditor"in w){const A=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(A===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:A}}return w})],v.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(t,r,i,a,m,h){for(const J of this._kernelData.values())if(J.controller.id===r&&L.ExtensionIdentifier.equals(t.identifier,J.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const w=this._handlePool++,A=this;this._logService.trace(`NotebookController[${w}], CREATED by ${t.identifier.value}, ${r}`);const F=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${t.identifier}'`);let R=!1;const D=new C.DisposableStore,$=new T.Emitter,M=new T.Emitter,q={id:E(t,r),notebookType:i,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:a||t.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let G=m??F,U;this._proxy.$addKernel(w,q).catch(J=>{console.log(J),R=!0});let W=0;const ee=()=>{if(R)return;const J=++W;Promise.resolve().then(()=>{J===W&&this._proxy.$updateKernel(w,q)})},Z=new k.ResourceMap,V={get id(){return r},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return q.label},set label(J){q.label=J??t.displayName??t.name,ee()},get detail(){return q.detail??""},set detail(J){q.detail=J,ee()},get description(){return q.description??""},set description(J){q.description=J,ee()},get kind(){return(0,P.checkProposedApiEnabled)(t,"notebookControllerKind"),q.kind??""},set kind(J){(0,P.checkProposedApiEnabled)(t,"notebookControllerKind"),q.kind=J,ee()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(J){q.supportedLanguages=J,ee()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(J){q.supportsExecutionOrder=J,ee()},get rendererScripts(){return q.preloads?q.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(J){G=J??F},get interruptHandler(){return U},set interruptHandler(J){U=J,q.supportsInterrupt=Boolean(J),ee()},createNotebookCellExecution(J){if(R)throw new Error("notebook controller is DISPOSED");if(!Z.has(J.notebook.uri))throw A._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return A._createNotebookCellExecution(J,E(t,this.id))},dispose:()=>{R||(this._logService.trace(`NotebookController[${w}], DISPOSED`),R=!0,this._kernelData.delete(w),D.dispose(),$.dispose(),M.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(J,se){A._proxy.$updateNotebookPriority(w,J.uri,se)},onDidReceiveMessage:M.event,postMessage(J,se){return(0,P.checkProposedApiEnabled)(t,"notebookMessaging"),A._proxy.$postMessage(w,se&&A._extHostNotebook.getIdByEditor(se),J)},asWebviewUri(J){return(0,P.checkProposedApiEnabled)(t,"notebookMessaging"),(0,d.asWebviewUri)(J,A._initData.remote)}};return this._kernelData.set(w,{extensionId:t.identifier,controller:V,onDidReceiveMessage:M,onDidChangeSelection:$,associatedNotebooks:Z}),V}$acceptNotebookAssociation(t,r,i){const a=this._kernelData.get(t);if(a){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));i?a.associatedNotebooks.set(m.uri,!0):a.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,m.uri.toString(),i),a.onDidChangeSelection.fire({selected:i,notebook:m.apiNotebook})}}async $executeCells(t,r,i){const a=this._kernelData.get(t);if(!a)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),h=[];for(const w of i){const A=m.getCell(w);A&&h.push(A.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,m.uri.toString(),h.length),await a.controller.executeHandler.call(a.controller,h,m.apiNotebook,a.controller)}catch(w){this._logService.error(`NotebookController[${t}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(t,r,i){const a=this._kernelData.get(t);if(!a)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,m.apiNotebook);else for(const h of i){const w=m.getCell(h);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,i){const a=this._kernelData.get(t);if(!a)return;const m=this._extHostNotebook.getEditorById(r);a.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:i}))}$cellExecutionChanged(t,r,i){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)).getCell(r);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:i?b.NotebookCellExecutionState.to(i):g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(t,r){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const m=new u(r,a,this._proxy);this._activeExecutions.set(a.uri,m);const h=m.onDidChangeState(()=>{m.state===c.Resolved&&(m.dispose(),h.dispose(),this._activeExecutions.delete(a.uri))});return m.asApiObject()}};o=Be([Fe(4,O.ILogService)],o),e.ExtHostNotebookKernels=o;var c;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(c||(c={}));class u extends C.Disposable{constructor(t,r,i){super();this._cell=r,this._proxy=i,this._handle=u.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new l(10,a=>this.update(a)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,t,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const r=Array.isArray(t)?t:[t];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(t){return t.map(r=>{const i=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?b.NotebookCellOutput.from(r):b.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,i){const a=this.validateAndConvertOutputs((0,f.asArray)(t));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,append:i,outputs:a})}async updateOutputItems(t,r,i){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(t),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,items:t.map(b.NotebookCellOutputItem.from),outputId:r.id,append:i})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(i){t._executionOrder=i,t.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionOrder:t._executionOrder}])},start(i){if(t._state===c.Resolved||t._state===c.Started)throw new Error("Cannot call start again");t._state=c.Started,t._onDidChangeState.fire(),t.update({editType:p.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,a){if(t._state===c.Resolved)throw new Error("Cannot call resolve twice");t._state=c.Resolved,t._onDidChangeState.fire(),t._collector.flush(),t._proxy.$completeExecution(t._handle,new _.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:i}))},clearOutput(i){return t.verifyStateForOutput(),t.updateOutputs([],i,!1)},appendOutput(i,a){return t.verifyStateForOutput(),t.updateOutputs(i,a,!0)},replaceOutput(i,a){return t.verifyStateForOutput(),t.updateOutputs(i,a,!1)},appendOutputItems(i,a){return t.verifyStateForOutput(),t.updateOutputItems(i,a,!0)},replaceOutputItems(i,a){return t.verifyStateForOutput(),t.updateOutputItems(i,a,!1)}})}}u.HANDLE=0;class l{constructor(t,r){this.delay=t,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(t){return this.batch.push(t),this.currentDeferred||(this.currentDeferred=new n.DeferredPromise,this.startedTimer=Date.now(),(0,n.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const t=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>t.complete())}}function E(s,t){return`${s.identifier.value}/${t}`}}),define(pe[247],ve([1,0,3,5,130,30]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(S,L){this._extHostNotebook=L,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(n.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,L,O){const y=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(L)?.fire({editor:y.apiEditor,message:O})}createRendererMessaging(S,L){if(!S.contributes?.notebookRenderer?.some(b=>b.id===L))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${L})`);const O=(0,T.isProposedApiEnabled)(S,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(b,g,d)=>{const p=O?b:P=>{const _={};y.set(_,P.editor),b({editor:_,message:P.message})};return this.getOrCreateEmitterFor(L).event(p,g,d)},postMessage:(b,g)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,g]=[g,b]);const d=O?g:y.get(g),p=d&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(p?.id,L,b)}}}getOrCreateEmitterFor(S){let L=this._rendererMessageEmitters.get(S);return L||(L=new f.Emitter({onLastListenerRemove:()=>{L?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,L),L)}}e.ExtHostNotebookRenderers=C}),define(pe[135],ve([1,0,5,6,4,17,11,214,65,26,44,155,22,13]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends n.Disposable{constructor(P,_,o,c){super();this.id=P,this.name=_,this.logger=o,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(P){this.append(P+`
`)}append(P){this.write(P),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const P=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,P)}replace(P){const _=this.offset;this.write(P),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,_),this.visible&&this.logger.flush()}show(P,_){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof P=="boolean"?P:_))}hide(){this.proxy.$close(this.id)}write(P){this.offset+=v.VSBuffer.fromString(P).byteLength,this.logger.info(P)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let d=class{constructor(P,_,o,c,u){this.extHostFileSystem=o,this.extHostFileSystemInfo=c,this.loggerService=u,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=P.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(_.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(P){this.visibleChannelId=P;for(const[_,o]of this.channels)o.visible=_===this.visibleChannelId}createOutputChannel(P,_,o){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");if((0,b.isString)(_)&&!_.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(P,_,o);return c.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),this.createExtHostOutputChannel(P,c)}async doCreateOutputChannel(P,_,o){const c=await this.createOutputDirectory(),u=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),E=await this.proxy.$register(P,!1,u,_,o.identifier.value);return new g(E,P,l,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(P,_){let o=!1;const c=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return P},append(u){c(),_.then(l=>l.append(u))},appendLine(u){c(),_.then(l=>l.appendLine(u))},clear(){c(),_.then(u=>u.clear())},replace(u){c(),_.then(l=>l.replace(u))},show(u,l){c(),_.then(E=>E.show(u,l))},hide(){c(),_.then(u=>u.hide())},dispose(){o=!0,_.then(u=>u.dispose())}}}};d=Be([Fe(0,T.IExtHostRpcService),Fe(1,L.IExtHostInitDataService),Fe(2,S.IExtHostConsumerFileSystem),Fe(3,O.IExtHostFileSystemInfo),Fe(4,C.ILoggerService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(pe[248],ve([1,0,16,21,3,6,5,2,7,15,18,47,81]),function(te,e,f,n,I,T,C,k,S,L,O,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(g,d,p){const P=g.getProxy(C.MainContext.MainThreadQuickOpen);class _{constructor(i,a){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=a}showQuickPick(i,a,m=n.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(i),w=++this._instances,A=P.$show(w,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},m),F={},R=A.then(()=>F);return Promise.race([R,h]).then(D=>{if(D!==F)return h.then($=>{const M=[];for(let q=0;q<$.length;q++){const G=$[q];typeof G=="string"?M.push({label:G,handle:q}):G.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:G.label}):M.push({label:G.label,description:G.description,detail:G.detail,picked:G.picked,alwaysShow:G.alwaysShow,handle:q})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{a.onDidSelectItem($[q])}),P.$setItems(w,M),A.then(q=>{if(typeof q=="number")return $[q];if(Array.isArray(q))return q.map(G=>$[G])})})}).then(void 0,D=>{if(!(0,L.isCancellationError)(D))return P.$setError(w,D),Promise.reject(D)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,a=n.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,P.$input(i,typeof this._validateInput=="function",a).then(void 0,m=>{if(!(0,L.isCancellationError)(m))return Promise.reject(m)})}$validateInput(i){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,a=n.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!m)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(w=>w.uri.toString()===m.uri.toString())}createQuickPick(i){const a=new s(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(i){const a=new t(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(i,a){const m=this._sessions.get(i);m&&m._fireDidChangeValue(a)}$onDidAccept(i){const a=this._sessions.get(i);a&&a._fireDidAccept()}$onDidChangeActive(i,a){const m=this._sessions.get(i);m instanceof s&&m._fireDidChangeActive(a)}$onDidChangeSelection(i,a){const m=this._sessions.get(i);m instanceof s&&m._fireDidChangeSelection(a)}$onDidTriggerButton(i,a){const m=this._sessions.get(i);m&&m._fireDidTriggerButton(a)}$onDidTriggerItemButton(i,a,m){const h=this._sessions.get(i);h instanceof s&&h._fireDidTriggerItemButton(a,m)}$onDidHide(i){const a=this._sessions.get(i);a&&a._fireDidHide()}}class o{constructor(i,a){this._extensionId=i,this._onDidDispose=a,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((a,m)=>{const h=a===S.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(h,a)}),this.update({buttons:i.map((a,m)=>({...E(a),tooltip:a.tooltip,handle:a===S.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const a=this._handlesToButtons.get(i);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(i){if(!this._disposed){for(const a of Object.keys(i)){const m=i[a];this._pendingUpdate[a]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function c(r){if(r instanceof S.ThemeIcon)return{id:r.id};const i=l(r),a=u(r);return{dark:typeof i=="string"?k.URI.file(i):i,light:typeof a=="string"?k.URI.file(a):a}}function u(r){return typeof r=="object"&&"light"in r?r.light:r}function l(r){return typeof r=="object"&&"dark"in r?r.dark:r}function E(r){const i=c(r.iconPath);let a,m;return"id"in i?m=v.ThemeIcon.asClassName(i):a=i,{iconPath:a,iconClass:m}}class s extends o{constructor(i,a){super(i.identifier,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((m,h)=>{this._handlesToItems.set(h,m),this._itemsToHandles.set(m,h)});const a=[];for(let m=0;m<i.length;m++){const h=i[m];h.kind===S.QuickPickItemKind.Separator?a.push({type:"separator",label:h.label}):a.push({handle:m,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((w,A)=>({...E(w),tooltip:w.tooltip,handle:A}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(i){const a=(0,O.coalesce)(i.map(m=>this._handlesToItems.get(m)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(i){const a=(0,O.coalesce)(i.map(m=>this._handlesToItems.get(m)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(i,a){const m=this._handlesToItems.get(i);if(!m||!m.buttons||!m.buttons.length)return;const h=m.buttons[a];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:m})}}class t extends o{constructor(i,a){super(i,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?y.default.Error:y.default.Ignore})}}return new _(d,p)}e.createExtHostQuickOpen=b});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[249],ve([1,0,2,3,56,6,16,5,18,97,11,27,81,14,30]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g){"use strict";var d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function P(m){if(m)return typeof m.iconPath=="string"?f.URI.file(m.iconPath):f.URI.isUri(m.iconPath)||v.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function _(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof m.iconPath=="string"?m.iconPath:f.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,A=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,L.comparePaths)(w,A)}function o(m,h){let w=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(w=_(m,h),w!==0)return w;if(m.light&&h.light)w=_(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(w!==0)return w;if(m.dark&&h.dark)w=_(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return w}function c(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<m.arguments.length;w++){const A=m.arguments[w],F=h.arguments[w];if(A!==F)return A<F?-1:1}return 0}function u(m,h){let w=(0,L.comparePaths)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(m.command&&h.command)w=c(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(w!==0)return w;if(m.decorations&&h.decorations)w=o(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return w}function l(m,h){for(let w=0;w<m.length;w++)if(m[w]!==h[w])return!1;return!0}function E(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?l(m.arguments,h.arguments):m.arguments===h.arguments)}function s(m,h){return(0,S.equals)(m,h,E)}class t{constructor(h,w,A){this._extension=h,this._sourceControlHandle=A,d.set(this,void 0),this._value="",this._onDidChange=new n.Emitter,this._placeholder="",this._visible=!0,Ke(this,d,w,"f")}get value(){return this._value}set value(h){h=h??"",ke(this,d,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){ke(this,d,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,ke(this,d,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,ke(this,d,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,w){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),ke(this,d,"f").$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=t,d=new WeakMap;class r{constructor(h,w,A,F,R){this._proxy=h,this._commands=w,this._sourceControlHandle=A,this._id=F,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new n.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const A=this._resourceStatesCommandsMap.get(h);return A?(0,C.asPromise)(()=>this._commands.executeCommand(A.command,...A.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(u),A=(0,S.sortedDiff)(this._resourceSnapshot,h,u).map(D=>{const $=D.toInsert.map(M=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,M);const G=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const oe=new T.DisposableStore;U=this._commands.converter.toInternal(M.command,oe),this._resourceStatesDisposablesMap.set(q,oe)}else this._resourceStatesCommandsMap.set(q,M.command);const W=P(M.decorations),ee=M.decorations&&P(M.decorations.light)||W,Z=M.decorations&&P(M.decorations.dark)||W,V=[ee,Z],J=M.decorations&&M.decorations.tooltip||"",se=M.decorations&&!!M.decorations.strikeThrough,ae=M.decorations&&!!M.decorations.faded,Q=M.contextValue||"";return{rawResource:[q,G,V,J,se,ae,Q,U],handle:q}});return{start:D.start,deleteCount:D.deleteCount,toInsert:$}}),F=A.map(({start:D,deleteCount:$,toInsert:M})=>[D,$,M.map(q=>q.rawResource)]),R=A.reverse();for(const{start:D,deleteCount:$,toInsert:M}of R){const q=M.map(U=>U.handle),G=this._handlesSnapshot.splice(D,$,...q);for(const U of G)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=h,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(h,w,A,F,R,D){this._extension=h,this._commands=A,this._id=F,this._label=R,this._rootUri=D,p.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new n.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ke(this,p,w,"f"),this._inputBox=new t(h,ke(this,p,"f"),this.handle),ke(this,p,"f").$registerSourceControl(this.handle,F,R,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,ke(this,p,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,ke(this,p,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,ke(this,p,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);ke(this,p,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=h;const w=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),description:h.description}:void 0;ke(this,p,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&s(this._statusBarCommands,h))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(A=>this._commands.converter.toInternal(A,this._statusBarDisposables.value));ke(this,p,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(h,w){const A=new r(ke(this,p,"f"),this._commands,this.handle,h,w),F=n.Event.once(A.onDidDispose)(()=>this.createdResourceGroups.delete(A));return this.createdResourceGroups.set(A,F),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const h=[],w=[];for(const[A,F]of this.createdResourceGroups){F.dispose();const R=A.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(A),this.eventuallyUpdateResourceStates()});n.Event.once(A.onDidDispose)(()=>{this.updatedResourceGroups.delete(A),R.dispose(),this._groups.delete(A.handle),ke(this,p,"f").$unregisterGroup(this.handle,A.handle)}),h.push([A.handle,A.id,A.label,A.features]);const D=A._takeResourceStateSnapshot();D.length>0&&w.push([A.handle,D]),this._groups.set(A.handle,A)}ke(this,p,"f").$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const A=w._takeResourceStateSnapshot();A.length!==0&&h.push([w.handle,A])}),h.length>0&&ke(this,p,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),ke(this,p,"f").$unregisterSourceControl(this.handle)}}p=new WeakMap,i._handlePool=0,Be([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Be([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let a=class Vi{constructor(h,w,A){this._commands=w,this.logService=A,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new n.Emitter,this._proxy=h.getProxy(k.MainContext.MainThreadSCM),this._telemetry=h.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const R=this._sourceControls.get(F.sourceControlHandle);if(!R)return F;const D=R.getResourceGroup(F.groupHandle);return D?D.getResourceState(F.handle):F}else if(F&&F.$mid===4){const R=this._sourceControls.get(F.sourceControlHandle);return R?R.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const R=this._sourceControls.get(F.handle);return R||F}return F}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,w,A,F){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,A,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const R=Vi._handlePool++,D=new i(h,this._proxy,this._commands,w,A,F);this._sourceControls.set(R,D);const $=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return $.push(D),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(h.identifier),$),D}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier)),A=w&&w[w.length-1];return A&&A.inputBox}$provideOriginalResource(h,w,A){const F=f.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,F.toString());const R=this._sourceControls.get(h);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(F,A)).then(D=>D||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const A=this._sourceControls.get(h);return A&&A.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,A,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,A);const R=this._sourceControls.get(h);if(!R)return Promise.resolve(void 0);const D=R.getResourceGroup(w);return D?D.$executeResourceCommand(A,F):Promise.resolve(void 0)}$validateInput(h,w,A){this.logService.trace("ExtHostSCM#$validateInput",h);const F=this._sourceControls.get(h);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>F.inputBox.validateInput(w,A)).then(R=>{if(!R)return Promise.resolve(void 0);const D=b.MarkdownString.fromStrict(R.message);return D?Promise.resolve([D,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};a._handlePool=0,a=Be([Fe(2,O.ILogService)],a),e.ExtHostSCM=a});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[250],ve([1,0,7,5,169,6,14,13]),function(te,e,f,n,I,T,C,k){"use strict";var S,L;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(g,d,p,P,_=f.StatusBarAlignment.Left,o){S.set(this,void 0),L.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ke(this,S,g,"f"),Ke(this,L,d,"f"),this._entryId=O.ID_GEN++,this._extension=p,this._id=P,this._alignment=_,this._priority=this.validatePriority(o)}validatePriority(g){if(!!(0,k.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!O.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:ke(this,L,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:ke(this,L,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,ke(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let d;this._name?d=this._name:d=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=C.MarkdownString.fromStrict(this._tooltip);ke(this,S,"f").$setEntry(this._entryId,g,d,this._text,P,this._command?.internal,p,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,S=new WeakMap,L=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const d={message:g};return this._messages.unshift(d),this._update(),new f.Disposable(()=>{const p=this._messages.indexOf(d);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class v{constructor(g,d){this._proxy=g.getProxy(n.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new y(this)}createStatusBarEntry(g,d,p,P){return new O(this._proxy,this._commands,g,d,p,P)}setStatusBarMessage(g,d){const p=this._statusMessage.setMessage(g);let P;return typeof d=="number"?P=setTimeout(()=>p.dispose(),d):typeof d!="undefined"&&d.then(()=>p.dispose(),()=>p.dispose()),new f.Disposable(()=>{p.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=v}),define(pe[87],ve([1,0,5,3,4]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new n.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}initializeExtensionStorage(k,S,L){return this._proxy.$initializeExtensionStorage(k,S).then(O=>O||L)}setValue(k,S,L){return this._proxy.$setValue(k,S,L)}$acceptValue(k,S,L){this._onDidChangeStorage.fire({shared:k,key:S,value:L})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(pe[66],ve([1,0,4,26,11,65,2]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let k=class{constructor(L,O,y){this._logService=O,this._extHostFileSystem=y,this._workspace=L.workspace??void 0,this._environment=L.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(v=>this._value=v)}async _getWorkspaceStorageURI(L){return C.URI.joinPath(this._environment.workspaceStorageHome,L)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const L=this._workspace.id,O=await this._getWorkspaceStorageURI(L);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(L){if(this._value)return C.URI.joinPath(this._value,L.identifier.value)}globalValue(L){return C.URI.joinPath(this._environment.globalStorageHome,L.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Be([Fe(0,n.IExtHostInitDataService),Fe(1,I.ILogService),Fe(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(pe[33],ve([1,0,3,5,4,2,17,6,7,170,15,216,21,32,196,81,13,16]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class _{constructor(i,a,m,h){this._proxy=i,this._id=a,this._creationOptions=m,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(A,F=!0){w._checkDisposed(),w._proxy.$sendText(w._id,A,F)},show(A){w._checkDisposed(),w._proxy.$show(w._id,A)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(i,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,p.withNullAsUndefined)(i.shellPath),shellArgs:(0,p.withNullAsUndefined)(i.shellArgs),cwd:(0,p.withNullAsUndefined)(i.cwd),env:(0,p.withNullAsUndefined)(i.env),icon:(0,p.withNullAsUndefined)(s(i.iconPath)),color:d.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,p.withNullAsUndefined)(i.message),strictEnv:(0,p.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(i.location,a?.resolvedExtHostIdentifier),isTransient:(0,p.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,a,m,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:d.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(i,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(i,a){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in i?{viewColumn:i.viewColumn,preserveFocus:i.preserveFocus}:void 0:i}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,a){return i===this._cols&&a===this._rows||i===0||a===0?!1:(this._cols=i,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=_;class o{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput?.(i)}resize(i,a){this._pty.setDimensions?.({columns:i,rows:a})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(i||void 0),i&&this._pty.setDimensions?.(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=o;let c=1,u=class extends k.Disposable{constructor(i,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(n.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[m,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,a){const m=new _(this._proxy,(0,b.generateUuid)(),i,i.name),h=new o(i.pty);return m.createExtensionTerminal(i.location,this._serializeParentTerminal(i,a).resolvedExtHostIdentifier,s(i.iconPath),t(i.color)).then(w=>{const A=this._setupExtHostProcessListeners(w,h);this._terminalProcessDisposables[w]=A}),this._terminals.push(m),m.value}_serializeParentTerminal(i,a){if(a=a||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const m=i.location.parentTerminal;if(m){const h=this._terminals.find(w=>w.value===m);h&&(a.resolvedExtHostIdentifier=h._id)}}else i.location&&typeof i.location!="object"?a.location=i.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(i,a){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const h=new o(a),w=this._setupExtHostProcessListeners(i,h);this._terminalProcessDisposables[i]=w}async $acceptActiveTerminalChanged(i){const a=this._activeTerminal;if(i===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(i);m&&(this._activeTerminal=m,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,a){const m=this._getTerminalById(i);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:a})}async $acceptTerminalDimensions(i,a,m){const h=this._getTerminalById(i);h&&h.setDimensions(a,m)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(i,a,m){this._terminalProcesses.get(i)?.resize(a,m)}async $acceptTerminalTitleChange(i,a){const m=this._getTerminalById(i);m&&(m.name=a)}async $acceptTerminalClosed(i,a){const m=this._getTerminalObjectIndexById(this._terminals,i);if(m!==null){const h=this._terminals.splice(m,1)[0];h.setExitCode(a),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(i,a,m,h){if(a){const F=this._getTerminalObjectIndexById(this._terminals,a);if(F!==null){this._terminals[F]._id=i,this._onDidOpenTerminal.fire(this.terminals[F]),this._terminals[F].isOpen=!0;return}}const w={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:T.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},A=new _(this._proxy,i,w,m);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(i,a){const m=this._getTerminalById(i);m&&m._setProcessId(a)}async $startExtensionTerminal(i,a){const m=this._getTerminalById(i);if(!m)return{message:(0,L.localize)(0,null,i)};m.isOpen||await new Promise(w=>{const A=this.onDidOpenTerminal(async F=>{F===m.value&&(A.dispose(),w())})});const h=this._terminalProcesses.get(i);h?h.startSendingEvents(a):this._extensionTerminalAwaitingStart[i]={initialDimensions:a}}_setupExtHostProcessListeners(i,a){const m=new k.DisposableStore;m.add(a.onProcessReady(w=>this._proxy.$sendProcessReady(i,w.pid,w.cwd))),m.add(a.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(i,w))),this._bufferer.startBuffering(i,a.onProcessData),m.add(a.onProcessExit(w=>this._onProcessExit(i,w))),this._terminalProcesses.set(i,a);const h=this._extensionTerminalAwaitingStart[i];return h&&a instanceof o&&(a.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),m}$acceptProcessAckDataEvent(i,a){this._terminalProcesses.get(i)?.acknowledgeDataEvent(a)}$acceptProcessInput(i,a){this._terminalProcesses.get(i)?.input(a)}$acceptTerminalInteraction(i){const a=this._getTerminalById(i);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(i,a,m){try{this._terminalProcesses.get(i)?.resize(a,m)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(i,a){this._terminalProcesses.get(i)?.shutdown(a)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(i,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(a=>this._proxy.$sendProcessProperty(i,{type:"cwd",value:a}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,a,m){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,m),this._proxy.$registerProfileProvider(a,i.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(i,a){const m=new v.CancellationTokenSource().token;let h=await this._profileProviders.get(i)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,a);return}this.createTerminalFromOptions(h.options,a)}}async $provideLinks(i,a){const m=this._getTerminalById(i);if(!m)return[];this._terminalLinkCache.delete(i);const h=this._terminalLinkCancellationSource.get(i);h&&h.dispose(!0);const w=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,w);const A=[],F={terminal:m.value,line:a},R=[];for(const M of this._linkProviders)R.push(P.Promises.withAsyncBody(async q=>{w.token.onCancellationRequested(()=>q({provider:M,links:[]}));const G=await M.provideTerminalLinks(F,w.token)||[];w.token.isCancellationRequested||q({provider:M,links:G})}));const D=await Promise.all(R);if(w.token.isCancellationRequested)return[];const $=new Map;for(const M of D)M&&M.links.length>0&&A.push(...M.links.map(q=>{const G={id:c++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return $.set(G.id,{provider:M.provider,link:q}),G}));return this._terminalLinkCache.set(i,$),A}$activateLink(i,a){const m=this._terminalLinkCache.get(i)?.get(a);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(i,a){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const m=this._terminalProcessDisposables[i];m&&(m.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,a)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,a){const m=this._getTerminalObjectIndexById(i,a);return m!==null?i[m]:null}_getTerminalObjectIndexById(i,a){let m=null;return i.some((h,w)=>h._id===a?(m=w,!0):!1),m}getEnvironmentVariableCollection(i){let a=this._environmentVariableCollections.get(i.identifier.value);return a||(a=new l,this._setEnvironmentVariableCollection(i.identifier.value,a)),a}_syncEnvironmentVariableCollection(i,a){const m=(0,y.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(i,a.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(i){i.forEach(a=>{const m=a[0],h=new l(a[1]);this._setEnvironmentVariableCollection(m,h)})}$acceptDefaultProfile(i,a){this._defaultProfile=i,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(i,a){this._environmentVariableCollections.set(i,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,a)})}};u=Be([Fe(1,C.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class l{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,a){this._setIfDiffers(i,{value:a,type:S.EnvironmentVariableMutatorType.Replace})}append(i,a){this._setIfDiffers(i,{value:a,type:S.EnvironmentVariableMutatorType.Append})}prepend(i,a){this._setIfDiffers(i,{value:a,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,a){const m=this.map.get(i);(!m||m.value!==a.value||m.type!==a.type)&&(this.map.set(i,a),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,a){this.map.forEach((m,h)=>i.call(a,h,m,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let E=class extends u{constructor(i){super(!1,i)}createTerminal(i,a,m){throw new O.NotSupportedError}createTerminalFromOptions(i,a){throw new O.NotSupportedError}};E=Be([Fe(0,C.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function s(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function t(r){return d.ThemeColor.isThemeColor(r)?r:void 0}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[251],ve([1,0,18,22,21,3,74,57,6,25,13,32,5,17,62,14,7,222,84,85]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o){"use strict";var c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let l=class{constructor(R,D){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(v.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new s(this.proxy),D.registerArgumentProcessor({processArgument:$=>$?.$mid===13?d.TestItem.toItemFromContext($):$})}createTestController(R,D,$){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const M=new S.DisposableStore,q=M.add(new P.SingleUseTestCollection(R));q.root.label=D;const G=new Map,U=this.proxy,W={items:q.root.children,get label(){return D},set label(Z){D=Z,q.root.label=Z,U.$updateController(R,{label:D})},get refreshHandler(){return $},set refreshHandler(Z){$=Z,U.$updateController(R,{canRefresh:!!Z})},get id(){return R},createRunProfile:(Z,V,J,se,ae)=>{let Q=(0,k.hash)(Z);for(;G.has(Q);)Q++;return new w(this.proxy,G,R,Q,Z,V,J,se,ae)},createTestItem(Z,V,J){return new g.TestItemImpl(R,Z,V,J)},createTestRun:(Z,V,J=!0)=>this.runTracker.createTestRun(R,q,Z,V,J),set resolveHandler(Z){q.resolveHandler=Z},get resolveHandler(){return q.resolveHandler},dispose:()=>{M.dispose()}};U.$registerTestController(R,D,!!$),M.add((0,S.toDisposable)(()=>U.$unregisterTestController(R)));const ee={controller:W,collection:q,profiles:G};return this.controllers.set(R,ee),M.add((0,S.toDisposable)(()=>this.controllers.delete(R))),M.add(q.onDidGenerateDiff(Z=>U.$publishDiff(R,Z.map(_.TestsDiffOp.serialize)))),W}createTestObserver(){return this.observer.checkout()}async runTests(R,D=I.CancellationToken.None){const $=t(R);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get($.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(q=>o.TestId.fromExtHostTestItem(q,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:A[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:R.exclude?.map(q=>q.id)},D)}$provideFileCoverage(R,D,$){return(0,f.mapFind)(this.runTracker.trackers,q=>q.id===R?q.getCoverage(D):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(R,D,$,M){return(0,f.mapFind)(this.runTracker.trackers,G=>G.id===R?G.getCoverage(D):void 0)?.resolveFileCoverage($,M)??Promise.resolve([])}$configureRunProfile(R,D){this.controllers.get(R)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(R,D){await this.controllers.get(R)?.controller.refreshHandler?.(D)}$publishTestResults(R){this.results=Object.freeze(R.map(D=>(0,L.deepFreeze)(d.TestResults.to(D))).concat(this.results).sort((D,$)=>$.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,D){const $=this.controllers.get(o.TestId.fromString(R).controllerId)?.collection;$&&(await $.expand(R,D<0?1/0:D),$.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R.map(_.TestsDiffOp.deserialize))}async $runControllerTests(R,D){const $=this.controllers.get(R.controllerId);if(!$)return;const{collection:M,profiles:q}=$,G=q.get(R.profileId);if(!G)return;const U=R.testIds.map(V=>M.tree.get(V)).filter(O.isDefined),W=R.excludeExtIds.map(V=>$.collection.tree.get(V)).filter(O.isDefined).filter(V=>U.some(J=>J.fullId.compare(V.fullId)===2));if(!U.length)return;const ee=new p.TestRunRequest(U.some(V=>V.actual instanceof g.TestItemRootImpl)?void 0:U.map(V=>V.actual),W.map(V=>V.actual),G),Z=this.runTracker.prepareForMainThreadTestRun(ee,r.fromInternal(R,$.collection),D);try{await G.runHandler(ee,D)}finally{Z.isRunning&&!D.isCancellationRequested&&await T.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};l=Be([Fe(0,b.IExtHostRpcService)],l),e.ExtHostTesting=l;class E extends S.Disposable{constructor(R,D,$){super();this.dto=R,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const D=this.dto.id,$=this.dto.controllerId,M=(0,y.generateUuid)(),q=new i(this.proxy,D,M),G=Z=>(V,...J)=>{if(W){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),Z(V,...J))},U=(Z,V)=>{const J=V instanceof Array?V.map(d.TestMessage.from):[d.TestMessage.from(V)];if(Z.uri&&Z.range){const se={range:d.Range.from(Z.range),uri:Z.uri};for(const ae of J)ae.location=ae.location||se}this.proxy.$appendTestMessagesInRun(D,M,o.TestId.fromExtHostTestItem(Z,$).toString(),J)};let W=!1;const ee={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return q.coverageProvider},set coverageProvider(Z){q.coverageProvider=Z},enqueued:G(Z=>{this.proxy.$updateTestStateInRun(D,M,o.TestId.fromExtHostTestItem(Z,$).toString(),1)}),skipped:G(Z=>{this.proxy.$updateTestStateInRun(D,M,o.TestId.fromExtHostTestItem(Z,$).toString(),5)}),started:G(Z=>{this.proxy.$updateTestStateInRun(D,M,o.TestId.fromExtHostTestItem(Z,$).toString(),2)}),errored:G((Z,V,J)=>{U(Z,V),this.proxy.$updateTestStateInRun(D,M,o.TestId.fromExtHostTestItem(Z,$).toString(),6,J)}),failed:G((Z,V,J)=>{U(Z,V),this.proxy.$updateTestStateInRun(D,M,o.TestId.fromExtHostTestItem(Z,$).toString(),4,J)}),passed:G((Z,V)=>{this.proxy.$updateTestStateInRun(D,M,o.TestId.fromExtHostTestItem(Z,this.dto.controllerId).toString(),3,V)}),appendOutput:(Z,V,J)=>{W||(J&&(this.dto.isIncluded(J)?this.ensureTestIsKnown(J):J=void 0),this.proxy.$appendOutputToRun(D,M,n.VSBuffer.fromString(Z),V&&d.location.from(V),J&&o.TestId.fromExtHostTestItem(J,$).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(D,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:ee,coverage:q}),this.proxy.$startedTestRunTask(D,{id:M,name:R,running:!0}),ee}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof g.TestItemImpl))throw new g.InvalidTestItemError(R.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const D=[],$=this.dto.colllection.root;for(;;){const M=d.TestItem.from(R);if(D.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),R===$))break;R=R.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class s{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,D,$){return this.getTracker(R,D,$)}cancelRunById(R){for(const D of this.tracked.values())if(D.id===R){D.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,D,$,M,q){const G=this.tracked.get($);if(G)return G.createRun(M);const U=r.fromPublic(R,D,$,q),W=t($);this.proxy.$startedExtensionTestRun({controllerId:R,profile:W&&{group:A[W.kind],id:W.profileId},exclude:$.exclude?.map(Z=>o.TestId.fromExtHostTestItem(Z,D.root.id).toString())??[],id:U.id,include:$.include?.map(Z=>o.TestId.fromExtHostTestItem(Z,D.root.id).toString())??[D.root.id],persist:q});const ee=this.getTracker($,U);return ee.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),ee.createRun(M)}getTracker(R,D,$){const M=new E(D,this.proxy,$);return this.tracked.set(R,M),M.onEnd(()=>this.tracked.delete(R)),M}}e.TestRunCoordinator=s;const t=F=>{if(!!F.profile){if(!(F.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class r{constructor(R,D,$,M,q,G){this.controllerId=R,this.id=D,this.isPersisted=q,this.colllection=G,this.includePrefix=$.map(U=>U+"\0"),this.excludePrefix=M.map(U=>U+"\0")}static fromPublic(R,D,$,M){return new r(R,(0,y.generateUuid)(),$.include?.map(q=>o.TestId.fromExtHostTestItem(q,R).toString())??[R],$.exclude?.map(q=>o.TestId.fromExtHostTestItem(q,R).toString())??[],M,D)}static fromInternal(R,D){return new r(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,D)}isIncluded(R){const D=o.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(D===$||D.startsWith($))return!1;for(const $ of this.includePrefix)if(D===$||D.startsWith($))return!0;return!1}}e.TestRunDto=r;class i{constructor(R,D,$){this.proxy=R,this.runId=D,this.taskId=$}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(R,D){const $=await this.fileCoverage;let M=$?.[R];return!this._coverageProvider||!$||!M?[]:(M.detailedCoverage||(M=$[R]=await this._coverageProvider.resolveFileCoverage?.(M,D)??M),M.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class a extends _.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,d.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:D,removed:$}=this;return{get added(){return[...R].map(M=>M.revived)},get updated(){return[...D].map(M=>M.revived)},get removed(){return[...$].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,D){return{...R,revived:d.TestItem.toPlain(R.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=m;class h{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(D=>D.revived)},dispose:(0,C.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class w{constructor(R,D,$,M,q,G,U,W=!1,ee=void 0){this.controllerId=$,this.profileId=M,this._label=q,this.kind=G,this.runHandler=U,this._isDefault=W,this._tag=ee,c.set(this,void 0),u.set(this,void 0),Ke(this,c,R,"f"),Ke(this,u,D,"f"),D.set(M,this);const Z=A[G];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);ke(this,c,"f").$publishTestRunProfile({profileId:M,controllerId:$,tag:ee?d.TestTag.namespace(this.controllerId,ee.id):null,label:q,group:Z,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,ke(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,ke(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,ke(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?d.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,ke(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){ke(this,u,"f")?.delete(this.profileId)&&(Ke(this,u,void 0,"f"),ke(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=w,c=new WeakMap,u=new WeakMap;const A={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(pe[252],ve([1,0,3,18,5,131,14,7]),function(te,e,f,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(O,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const y=this._extHostDocumentsAndEditors.allEditors();return O?y:y.map(v=>v.value)}async showTextDocument(O,y,v){let b;typeof y=="number"?b={position:C.ViewColumn.from(y),preserveFocus:v}:typeof y=="object"?b={position:C.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?C.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(O.uri,b),d=g&&this._extHostDocumentsAndEditors.getEditor(g);if(d)return d.value;throw g?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,y){return new T.TextEditorDecorationType(this._proxy,O,y).value}$acceptEditorPropertiesChanged(O,y){const v=this._extHostDocumentsAndEditors.getEditor(O);if(!v)throw new Error("unknown text editor");if(y.options&&v._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(C.Selection.to);v._acceptSelections(b)}if(y.visibleRanges){const b=n.coalesce(y.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(b)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...y.options,lineNumbers:C.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=k.TextEditorSelectionChangeKind.fromValue(y.selections.source),g=y.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:g,kind:b})}if(y.visibleRanges){const b=n.coalesce(y.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:b})}}$acceptEditorPositionData(O){for(const y in O){const v=this._extHostDocumentsAndEditors.getEditor(y);if(!v)throw new Error("Unknown text editor");const b=C.ViewColumn.to(O[y]);v.value.viewColumn!==b&&(v._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:b}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=S}),define(pe[253],ve([1,0,2,4,5,6,7,14,13]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,n.createDecorator)("IExtHostTimeline");class L{constructor(v,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=v.getProxy(I.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const d=g.uri===void 0?void 0:f.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(O(d))?.get(g.handle)}return g}})}async $getTimeline(v,b,g,d,p){return this._providers.get(v)?.provideTimeline(f.URI.revive(b),g,d,p)}registerTimelineProvider(v,b,g,d){const p=new T.DisposableStore,P=this.convertTimelineItem(b.id,d,p).bind(this);let _;b.onDidChange&&(_=b.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:b.id}),this));const o=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:v,onDidChange:void 0,async provideTimeline(c,u,l,E){E?.resetCache&&(p.clear(),o.get(b.id)?.clear());const s=await b.provideTimeline(c,u,l);if(s==null)return;const t=P(c,E);return{...s,source:b.id,items:s.items.map(t)}},dispose(){for(const c of o.values())c.get(b.id)?.clear();_?.dispose(),p.dispose()}})}convertTimelineItem(v,b,g){return(d,p)=>{let P;if(p?.cacheResults){let _=this._itemsBySourceAndUriMap.get(v);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(v,_));const o=O(d);P=_.get(o),P===void 0&&(P=new Map,_.set(o,P))}return _=>{const{iconPath:o,...c}=_,u=`${v}|${_.id??_.timestamp}`;P?.set(u,_);let l,E,s;_.iconPath&&(o instanceof C.ThemeIcon?s={id:o.id,color:o.color}:f.URI.isUri(o)?(l=o,E=o):{light:l,dark:E}=o);let t;return C.MarkdownString.isMarkdownString(c.detail)?t=k.MarkdownString.from(c.detail):(0,S.isString)(c.detail)&&(t=c.detail),{...c,id:c.id??void 0,handle:u,source:v,command:_.command?b.toInternal(_.command,g):void 0,icon:l,iconDark:E,themeIcon:s,detail:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(v){if(this._providers.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this._proxy.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this._providers.set(v.id,v),(0,T.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(v.id)?.clear();this._providers.delete(v.id),this._proxy.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=L;function O(y){return y?.toString()}}),define(pe[254],ve([1,0,6,10,2,5]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,L,O,y){if(this._openers.has(L))throw new Error(`Opener with id '${L}' already registered`);const v=y.schemes.find(b=>!C.supportedSchemes.has(b));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(L,O),this._proxy.$registerUriOpener(L,y.schemes,S,y.label),(0,f.toDisposable)(()=>{this._openers.delete(L),this._proxy.$unregisterUriOpener(L)})}async $canOpenUri(S,L,O){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener with id: ${S}`);const v=I.URI.revive(L);return y.canOpenExternalUri(v,O)}async $openUri(S,L,O){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener id: '${S}'`);return y.openExternalUri(I.URI.revive(L.resolvedUri),{sourceUri:I.URI.revive(L.sourceUri)},O)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([n.Schemas.http,n.Schemas.https])}),define(pe[255],ve([1,0,5,2,6,15,27]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(L){this.handles=new Set,this.handlers=new Map,this._proxy=L.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(L,O){if(this.handles.has(C.ExtensionIdentifier.toKey(L)))throw new Error(`Protocol handler already registered for extension ${L}`);const y=k.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(L)),this.handlers.set(y,O),this._proxy.$registerUriHandler(y,L),(0,I.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(L)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(L,O){const y=this.handlers.get(L);if(!y)return Promise.resolve(void 0);try{y.handleUri(n.URI.revive(O))}catch(v){(0,T.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(L){return n.URI.revive(await this._proxy.$createAppUri(L))}}e.ExtHostUrls=k,k.HandlePool=0});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[67],ve([1,0,3,10,2,183,204,83,5]),function(te,e,f,n,I,T,C,k,S){"use strict";var L,O,y,v,b,g,d,p,P,_,o,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(m,h,w,A,F,R,D){L.set(this,void 0),O.set(this,void 0),y.set(this,void 0),v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,""),p.set(this,void 0),P.set(this,!1),_.set(this,!1),o.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new f.Emitter),this._onDidDispose=ke(this,c,"f").event,Ke(this,L,m,"f"),Ke(this,O,h,"f"),Ke(this,p,w,"f"),Ke(this,v,A,"f"),Ke(this,b,F,"f"),Ke(this,g,R,"f"),Ke(this,o,l(R),"f"),Ke(this,y,D,"f")}dispose(){Ke(this,P,!0,"f"),ke(this,c,"f").fire(),ke(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Ke(this,_,!0,"f"),(0,k.asWebviewUri)(m,ke(this,v,"f").remote)}get cspSource(){const m=ke(this,g,"f").extensionLocation;if(m.scheme===n.Schemas.https||m.scheme===n.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),ke(this,d,"f")}set html(m){this.assertNotDisposed(),ke(this,d,"f")!==m&&(Ke(this,d,m,"f"),!ke(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Ke(this,_,!0,"f"),ke(this,y,"f").report("Webview vscode-resource: uris",ke(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),ke(this,O,"f").$setHtml(ke(this,L,"f"),m))}get options(){return this.assertNotDisposed(),ke(this,p,"f")}set options(m){this.assertNotDisposed(),ke(this,O,"f").$setOptions(ke(this,L,"f"),t(ke(this,g,"f"),ke(this,b,"f"),m)),Ke(this,p,m,"f")}async postMessage(m){if(ke(this,P,"f"))return!1;const h=(0,C.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:ke(this,o,"f")});return ke(this,O,"f").$postMessage(ke(this,L,"f"),h.message,...h.buffers)}assertNotDisposed(){if(ke(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,L=new WeakMap,O=new WeakMap,y=new WeakMap,v=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,p=new WeakMap,P=new WeakMap,_=new WeakMap,o=new WeakMap,c=new WeakMap;function l(a){try{const m=(0,T.normalizeVersion)((0,T.parseVersion)(a.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class E{constructor(m,h,w,A,F){this.initData=h,this.workspace=w,this._logService=A,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=m.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(m,h,w){const A=this.getWebview(m);if(A){const{message:F}=(0,C.deserializeWebviewMessage)(h,w.value);A._onMessageEmitter.fire(F)}}$onMissingCsp(m,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,w){const A=new u(m,this._webviewProxy,r(h),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(m,A),A._onDidDispose(()=>{this._webviews.delete(m)}),A}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=E;function s(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=s;function t(a,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||i(a,m)}}e.serializeWebviewOptions=t;function r(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(m=>I.URI.from(m))}}e.reviveOptions=r;function i(a,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(pe[256],ve([1,0,21,57,6,10,23,2,14,67,82,5,7]),function(te,e,f,n,I,T,C,k,S,L,O,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(l,E){this.document=l,this._storagePath=E,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,E){await this.getEdit(l).undo(),E||this.disposeBackup()}async redo(l,E){await this.getEdit(l).redo(),E||this.disposeBackup()}disposeEdits(l){for(const E of l)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=c(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const E=this._edits.get(l,0);if(!E)throw new Error("No edit found");return E}}class g{constructor(){this._documents=new Map}get(l,E){return this._documents.get(this.key(l,E))}add(l,E,s){const t=this.key(l,E.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${l} resource:${E.uri}`);const r=new b(E,s);return this._documents.set(t,r),r}delete(l,E){const s=this.key(l,E.uri);this._documents.delete(s)}key(l,E){return`${l}@@@${E}`}}var d;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(d||(d={}));class p{constructor(){this._providers=new Map}addTextProvider(l,E,s){return this.add(0,l,E,s)}addCustomProvider(l,E,s){return this.add(1,l,E,s)}get(l){return this._providers.get(l)}add(l,E,s,t){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:l,extension:s,provider:t}),new v.Disposable(()=>this._providers.delete(E))}}class P{constructor(l,E,s,t,r){this._extHostDocuments=E,this._extensionStoragePaths=s,this._extHostWebview=t,this._extHostWebviewPanels=r,this._editorProviders=new p,this._documents=new g,this._proxy=l.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,E,s,t){const r=new I.DisposableStore;return _(s)?(r.add(this._editorProviders.addTextProvider(E,l,s)),this._proxy.$registerTextEditorProvider((0,L.toExtensionData)(l),E,t.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,L.shouldSerializeBuffersForPostMessage)(l))):(r.add(this._editorProviders.addCustomProvider(E,l,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(i=>{const a=this.getCustomDocumentEntry(E,i.document.uri);if(o(i)){const m=a.addEdit(i);this._proxy.$onDidEdit(i.document.uri,E,m,i.label)}else this._proxy.$onContentChange(i.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,L.toExtensionData)(l),E,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,L.shouldSerializeBuffersForPostMessage)(l))),v.Disposable.from(r,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(l,E,s,t,r){const i=this._editorProviders.get(E);if(!i)throw new Error(`No provider found for '${E}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${E}'`);const a=k.URI.revive(l),m=await i.provider.openCustomDocument(a,{backupId:s,untitledDocumentData:t?.buffer},r);let h;return this.supportEditing(i.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension)),this._documents.add(E,m,h),{editable:this.supportEditing(i.provider)}}async $disposeCustomDocument(l,E){const s=this._editorProviders.get(E);if(!s)throw new Error(`No provider found for '${E}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${E}'`);const t=k.URI.revive(l),{document:r}=this.getCustomDocumentEntry(E,t);this._documents.delete(E,r),r.dispose()}async $resolveWebviewEditor(l,E,s,t,r,i){const a=this._editorProviders.get(s);if(!a)throw new Error(`No provider found for '${s}'`);const m=S.ViewColumn.to(r),h=this._extHostWebview.createNewWebview(E,t.webviewOptions,a.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(E,s,t.title,m,t.panelOptions,h),A=k.URI.revive(l);switch(a.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,A);return a.provider.resolveCustomEditor(F,w,i)}case 0:{const F=this._extHostDocuments.getDocument(A);return a.provider.resolveCustomTextEditor(F,w,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,E,s){this.getCustomDocumentEntry(E,l).disposeEdits(s)}async $onMoveCustomEditor(l,E,s){const t=this._editorProviders.get(s);if(!t)throw new Error(`No provider found for '${s}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(l);if(!r)throw new Error("No webview found");const i=k.URI.revive(E),a=this._extHostDocuments.getDocument(i);await t.provider.moveCustomTextEditor(a,r,f.CancellationToken.None)}async $undo(l,E,s,t){return this.getCustomDocumentEntry(E,l).undo(s,t)}async $redo(l,E,s,t){return this.getCustomDocumentEntry(E,l).redo(s,t)}async $revert(l,E,s){const t=this.getCustomDocumentEntry(E,l);await this.getCustomEditorProvider(E).revertCustomDocument(t.document,s),t.disposeBackup()}async $onSave(l,E,s){const t=this.getCustomDocumentEntry(E,l);await this.getCustomEditorProvider(E).saveCustomDocument(t.document,s),t.disposeBackup()}async $onSaveAs(l,E,s,t){const r=this.getCustomDocumentEntry(E,l);return this.getCustomEditorProvider(E).saveCustomDocumentAs(r.document,k.URI.revive(s),t)}async $backup(l,E,s){const t=this.getCustomDocumentEntry(E,l),i=await this.getCustomEditorProvider(E).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},s);return t.updateBackup(i),i.id}getCustomDocumentEntry(l,E){const s=this._documents.get(l,k.URI.revive(E));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(l){const s=this._editorProviders.get(l)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function _(u){return typeof u.resolveCustomTextEditor=="function"}function o(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function c(u){const l=u.scheme===T.Schemas.file||u.scheme===T.Schemas.untitled?u.fsPath:u.toString();return(0,n.hash)(l)+""}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[257],ve([1,0,3,6,2,32,14,67,5,7]),function(te,e,f,n,I,T,C,k,S,L){"use strict";var O,y,v,b,g,d,p,P,_,o,c,u,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends n.Disposable{constructor(i,a,m,h,w,A,F){super();O.set(this,void 0),y.set(this,void 0),v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,void 0),p.set(this,void 0),P.set(this,void 0),_.set(this,!0),o.set(this,!0),c.set(this,!1),u.set(this,this._register(new f.Emitter)),this.onDidDispose=ke(this,u,"f").event,l.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=ke(this,l,"f").event,Ke(this,O,i,"f"),Ke(this,y,a,"f"),Ke(this,v,m,"f"),Ke(this,g,A,"f"),Ke(this,P,w,"f"),Ke(this,d,h,"f"),Ke(this,b,F,"f")}dispose(){ke(this,c,"f")||(Ke(this,c,!0,"f"),ke(this,u,"f").fire(),ke(this,y,"f").$disposeWebview(ke(this,O,"f")),ke(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),ke(this,b,"f")}get viewType(){return this.assertNotDisposed(),ke(this,v,"f")}get title(){return this.assertNotDisposed(),ke(this,d,"f")}set title(i){this.assertNotDisposed(),ke(this,d,"f")!==i&&(Ke(this,d,i,"f"),ke(this,y,"f").$setTitle(ke(this,O,"f"),i))}get iconPath(){return this.assertNotDisposed(),ke(this,p,"f")}set iconPath(i){this.assertNotDisposed(),ke(this,p,"f")!==i&&(Ke(this,p,i,"f"),ke(this,y,"f").$setIconPath(ke(this,O,"f"),I.URI.isUri(i)?{light:i,dark:i}:i))}get options(){return ke(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof ke(this,P,"f")=="number"&&ke(this,P,"f")<0))return ke(this,P,"f")}get active(){return this.assertNotDisposed(),ke(this,o,"f")}get visible(){return this.assertNotDisposed(),ke(this,_,"f")}_updateViewState(i){ke(this,c,"f")||(this.active!==i.active||this.visible!==i.visible||this.viewColumn!==i.viewColumn)&&(Ke(this,o,i.active,"f"),Ke(this,_,i.visible,"f"),Ke(this,P,i.viewColumn,"f"),ke(this,l,"f").fire({webviewPanel:this}))}reveal(i,a){this.assertNotDisposed(),ke(this,y,"f").$reveal(ke(this,O,"f"),{viewColumn:typeof i=="undefined"?void 0:C.ViewColumn.from(i),preserveFocus:!!a})}assertNotDisposed(){if(ke(this,c,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,y=new WeakMap,v=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,p=new WeakMap,P=new WeakMap,_=new WeakMap,o=new WeakMap,c=new WeakMap,u=new WeakMap,l=new WeakMap;class s{constructor(i,a,m){this.webviews=a,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=i.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(i,a,m,h,w={}){const A=typeof h=="object"?h.viewColumn:h,F={viewColumn:C.ViewColumn.from(A),preserveFocus:typeof h=="object"&&!!h.preserveFocus},R=(0,k.shouldSerializeBuffersForPostMessage)(i),D=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(i),D,a,{title:m,panelOptions:t(w),webviewOptions:(0,k.serializeWebviewOptions)(i,this.workspace,w),serializeBuffersForPostMessage:R},F);const $=this.webviews.createNewWebview(D,w,i);return this.createNewWebviewPanel(D,a,m,A,w,$)}$onDidChangeWebviewPanelViewStates(i){const a=Object.keys(i);a.sort((m,h)=>{const w=i[m],A=i[h];return w.active?1:A.active?-1:+w.visible-+A.visible});for(const m of a){const h=this.getWebviewPanel(m);if(!h)continue;const w=i[m];h._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(i){this.getWebviewPanel(i)?.dispose(),this._webviewPanels.delete(i),this.webviews.deleteWebview(i)}registerWebviewPanelSerializer(i,a,m){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:m,extension:i}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new L.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(i,a,m,h){const w=this._serializers.get(a);if(!w)throw new Error(`No serializer found for '${a}'`);const{serializer:A,extension:F}=w,R=this.webviews.createNewWebview(i,m.webviewOptions,F),D=this.createNewWebviewPanel(i,a,m.title,h,m.panelOptions,R);await A.deserializeWebviewPanel(D,m.state)}createNewWebviewPanel(i,a,m,h,w,A){const F=new E(i,this._proxy,a,m,h,w,A);return this._webviewPanels.set(i,F),F}getWebviewPanel(i){return this._webviewPanels.get(i)}}e.ExtHostWebviewPanels=s;function t(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[258],ve([1,0,3,6,67,5,7]),function(te,e,f,n,I,T,C){"use strict";var k,S,L,O,y,v,b,g,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends n.Disposable{constructor(c,u,l,E,s,t){super();k.set(this,void 0),S.set(this,void 0),L.set(this,void 0),O.set(this,void 0),y.set(this,!1),v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=ke(this,d,"f").event,p.set(this,this._register(new f.Emitter)),this.onDidDispose=ke(this,p,"f").event,Ke(this,L,l,"f"),Ke(this,b,E,"f"),Ke(this,k,c,"f"),Ke(this,S,u,"f"),Ke(this,O,s,"f"),Ke(this,v,t,"f")}dispose(){ke(this,y,"f")||(Ke(this,y,!0,"f"),ke(this,p,"f").fire(),ke(this,O,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),ke(this,b,"f")}set title(c){this.assertNotDisposed(),ke(this,b,"f")!==c&&(Ke(this,b,c,"f"),ke(this,S,"f").$setWebviewViewTitle(ke(this,k,"f"),c))}get description(){return this.assertNotDisposed(),ke(this,g,"f")}set description(c){this.assertNotDisposed(),ke(this,g,"f")!==c&&(Ke(this,g,c,"f"),ke(this,S,"f").$setWebviewViewDescription(ke(this,k,"f"),c))}get visible(){return ke(this,v,"f")}get webview(){return ke(this,O,"f")}get viewType(){return ke(this,L,"f")}_setVisible(c){c===ke(this,v,"f")||ke(this,y,"f")||(Ke(this,v,c,"f"),ke(this,d,"f").fire())}show(c){this.assertNotDisposed(),ke(this,S,"f").$show(ke(this,k,"f"),!!c)}assertNotDisposed(){if(ke(this,y,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,L=new WeakMap,O=new WeakMap,y=new WeakMap,v=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,p=new WeakMap;class _{constructor(c,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,u,l,E){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:l,extension:c}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(c),u,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(c,u,l,E,s){const t=this._viewProviders.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:i}=t,a=this._extHostWebview.createNewWebview(c,{},i),m=new P(c,this._proxy,u,l,a,!0);this._webviewViews.set(c,m),await r.resolveWebviewView(m,{state:E},s)}async $onDidChangeWebviewViewVisibility(c,u){this.getWebviewView(c)._setVisible(u)}async $disposeWebviewView(c){const u=this.getWebviewView(c);this._webviewViews.delete(c),u.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const u=this._webviewViews.get(c);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=_}),define(pe[136],ve([1,0,3,5,2,10,8,4,17]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let L=class ji{constructor(y){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=y.getProxy(n.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,v){let b;if(typeof y=="string"){b=y;try{y=I.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,C.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,b,v)}async asExternalUri(y,v){if((0,C.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(y,v);return I.URI.from(b)}};L.InitialState={focused:!0},L=Be([Fe(0,S.IExtHostRpcService)],L),e.ExtHostWindow=L,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(pe[259],ve([1,0,9,60,32,39,6,5,2,17]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let O=class extends C.Disposable{constructor(v,b){super();const g=v.getProxy(k.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async d=>{const p=S.URI.file((0,f.join)((0,n.tmpdir)(),(0,I.generateUuid)()));return await g.$download(d,p),p})}};O=Be([Fe(0,L.IExtHostRpcService),Fe(1,T.IExtHostCommands)],O),e.ExtHostDownloadService=O}),define(pe[260],ve([1,0,134,10,189,32]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends f.ExtHostLoggerService{doCreateLogger(S,L,O){return S.scheme===n.Schemas.file?new I.SpdLogLogger(O?.name||(0,T.generateUuid)(),S.fsPath,!O?.donotRotate,!!O?.donotUseFormatters,L):super.doCreateLogger(S,L,O)}}e.ExtHostLoggerService=C}),define(pe[261],ve([1,0,59,9,2,66,6,10,16,28]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class O extends T.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(l){const E=await super._getWorkspaceStorageURI(l);if(E.scheme!==k.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const s=E.fsPath;let t=0;do{let r;t===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${t}`:`${s}-${t}`,await y(r);const i=n.join(r,"vscode.lock"),a=await d(this._logService,i,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),I.URI.file(r);t++}while(t<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=O;async function y(u){try{await L.Promises.stat(u);return}catch{}try{await L.Promises.mkdir(u,{recursive:!0})}catch{}}const v=1e3,b=10*60*1e3;class g extends C.Disposable{constructor(l,E){super();this.logService=l,this.filename=E,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await p(l,E);(!s||s.pid!==process.pid)&&(l.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await L.Promises.utimes(E,new Date,new Date)}catch(t){l.error(t),l.info(`Lock '${E}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(l){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${l} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+l};await L.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function d(u,l,E){try{const t={pid:process.pid,willReleaseAt:0};await L.Promises.writeFile(l,JSON.stringify(t),{flag:"wx"})}catch(t){u.error(t)}const s=await p(u,l);return!s||s.pid!==process.pid?E?(u.info(`Lock '${l}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${l}': Could not acquire lock, checking if the file is stale.`),o(u,l)):(u.info(`Lock '${l}': Lock acquired.`),new g(u,l))}async function p(u,l){let E;try{E=await L.Promises.readFile(l)}catch(s){return u.error(s),null}try{return JSON.parse(String(E))}catch(s){return u.error(s),null}}async function P(u,l){let E;try{E=await L.Promises.stat(l)}catch(s){return u.error(s),0}return E.mtime.getTime()}function _(u){try{return process.kill(u,0),!0}catch{return!1}}async function o(u,l){const E=await p(u,l);if(!E)return u.info(`Lock '${l}': Could not read pid of lock holder.`),c(u,l);if(E.willReleaseAt){let a=E.willReleaseAt-Date.now();if(a<5e3){for(a>0?u.info(`Lock '${l}': The lockfile is scheduled to be released in ${a} ms.`):u.info(`Lock '${l}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,S.timeout)(Math.min(100,a)),await P(u,l)===0)return c(u,l);a=E.willReleaseAt-Date.now()}return c(u,l)}}if(!_(E.pid))return u.info(`Lock '${l}': The pid ${E.pid} appears to be gone.`),c(u,l);const s=await P(u,l),t=Date.now()-s;if(t<=b)return u.info(`Lock '${l}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;u.info(`Lock '${l}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await P(u,l),i=Date.now()-r;return i<=b?(u.info(`Lock '${l}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null):(u.info(`Lock '${l}': The lock looks stale even after waiting for 2s.`),c(u,l))}async function c(u,l){u.info(`Lock '${l}': Deleting a stale lock.`);try{await L.Promises.unlink(l)}catch{}return d(u,l,!0)}}),define(pe[262],ve([1,0,32,17,33]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,L){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:L})}createTerminalFromOptions(k,S){const L=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),k,k.name);return this._terminals.push(L),L.create(k,this._serializeParentTerminal(k,S)),L.value}};T=Be([Fe(0,n.IExtHostRpcService)],T),e.ExtHostTerminalService=T}),define(pe[263],ve([1,0,5,17,174,6,26,2,38,23,28,7,12,51,3,123,91,11]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(m,h,w){this.remoteAddress=m,this.localAddress=h,this._dispose=w,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(a){const m=a.trim().split(`
`),h=[];return m.forEach(A=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);F&&F.length>=3&&h.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),h.reduce((A,F)=>(A[F.socket]=F,A),{})}e.getSockets=o;function c(...a){const m=[].concat(...a.map(l));return[...new Map(m.filter(h=>h.st==="0A").map(h=>{const w=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:u(w[0]),port:parseInt(w[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function u(a){let m="";if(a.length===8)for(let h=a.length-2;h>=0;h-=2)m+=parseInt(a.substr(h,2),16),h!==0&&(m+=".");else for(let h=a.length-4;h>=0;h-=4)m+=parseInt(a.substr(h,4),16).toString(16),h!==0&&(m+=":");return m}e.parseIpAddress=u;function l(a){const m=a.trim().split(`
`),h=m.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return m.map(A=>A.trim().split(/\s+/).reduce((F,R,D)=>(F[h[D]||D]=R,F),{}))}e.loadConnectionTable=l;function E(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/server-main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function s(a){const m=a.trim().split(`
`),h=[];return m.forEach(w=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);A&&A.length>=4&&h.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),h}e.getRootProcesses=s;async function t(a,m,h){const w=h.reduce((F,R)=>(F[R.pid]=R,F),{}),A=[];return a.forEach(({socket:F,ip:R,port:D})=>{const $=m[F]?m[F].pid:void 0,M=$?w[$]?.cmd:void 0;$&&M&&!E(M)&&A.push({host:R,port:D,detail:M,pid:$})}),A}e.findPorts=t;function r(a,m,h){const w=new Map,A=s(m);for(const F of a){const R=h.get(F.port);if(R){w.set(F.port,R);continue}const D=A.find($=>$.cmd.includes(`${F.port}`));if(D){let $=D,M;do M=A.find(q=>q.ppid===$.pid),M&&($=M);while(M);w.set(F.port,{host:F.ip,port:F.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else w.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let i=class extends T.Disposable{constructor(m,h,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(f.MainContext.MainThreadTunnelService),v.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(h,m.displayName);if(w){const A=new _(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,h){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:m,provider:h}),this._proxy.$registerPortsAttributesProvider(m,w),new y.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(m,h,w,A,F){const R=[];for(const $ of m){const M=this._portAttributesProviders.get($);if(!M)return[];R.push(...await Promise.all(h.map(async q=>M.provider.providePortAttributes(q,w,A,F))))}const D=R.filter($=>!!$);return D.length>0?D.map($=>({autoForwardAction:$.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let h=new p.MovingAverage,w;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),F=(await this.findCandidatePorts()).filter(D=>(0,d.isLocalhost)(D.host)||(0,d.isAllInterfaces)(D.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(D=>D.port).join(", ")}`);const R=new Date().getTime()-A;h.update(R),(!w||JSON.stringify(w)!==JSON.stringify(F))&&(w=F,await this._proxy.$onFoundNewCandidates(w)),await new Promise(D=>setTimeout(()=>D(),this.calculateDelay(h.value)))}}async setTunnelFactory(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let h=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const w=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,h){if(this._extensionTunnels.has(m.host)){const w=this._extensionTunnels.get(m.host);w.has(m.port)&&(h&&w.get(m.port).disposeListener.dispose(),await w.get(m.port).tunnel.dispose(),w.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(m,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const A=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const F=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:A,disposeListener:F}),b.TunnelDtoConverter.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const h=await Promise.all(m.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),w=m.filter((A,F)=>h[F]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(A=>A.port).join(", ")} to ${w.map(A=>A.port).join(", ")}`),w}async findCandidatePorts(){let m="",h="";try{m=await O.Promises.readFile("/proc/net/tcp","utf8"),h=await O.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=c(m,h),A=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,ee,Z)=>{U(ee)})}),F=o(A),R=await O.Promises.readdir("/proc"),D=[];for(let U of R)try{const W=Number(U),ee=L.joinPath(k.URI.file("/proc"),U);if((await O.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(W)){const V=await O.Promises.readlink(L.joinPath(ee,"cwd").fsPath),J=await O.Promises.readFile(L.joinPath(ee,"cmdline").fsPath,"utf8");D.push({pid:W,cwd:V,cmd:J})}}catch{}const $=[],M=w.filter(U=>{const W=F[U.socket];return W||$.push(U),W}),q=t(M,F,D);let G;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const U=await new Promise(W=>{(0,S.exec)("ps -F -A -l | grep root",(ee,Z,V)=>{W(Z)})});this._foundRootPorts=r($,U,this._foundRootPorts),G=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.join(", ")}`)}return q.then(U=>G?U.concat(G):U)}};i=Be([Fe(0,n.IExtHostRpcService),Fe(1,C.IExtHostInitDataService),Fe(2,P.ILogService)],i),e.ExtHostTunnelService=i}),define(pe[264],ve([1,0,16,22,21,15,3,6,101,227,52]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(w,A){try{return JSON.stringify(w,A)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class d{constructor(A,F){this.jsonString=A,this.referencedBuffers=F}}function p(w,A=null,F=!1){const R=[];return{jsonString:(F?v:JSON.stringify)(w,($,M)=>{if(typeof M=="undefined")return g;if(typeof M=="object"){if(M instanceof n.VSBuffer){const q=R.push(M)-1;return{[b]:q}}if(A)return A($,M)}return M}),referencedBuffers:R}}e.stringifyJsonWithBufferRefs=p;function P(w,A,F){return JSON.parse(w,(R,D)=>{if(D){const $=D[b];if(typeof $=="number")return A[$];if(F&&D.$mid===1)return F.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=P;function _(w,A){return JSON.stringify(w,A)}function o(w){return w?(A,F)=>F&&F.$mid===1?w.transformOutgoing(F):F:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var u;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(u=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},E=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(A,F=null,R=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=F,this._uriTransformer=R,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,$=O.ProxyIdentifier.count;D<$;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,S.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:F,sid:R}=A;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,R)),this._proxies[F]}_createProxy(A,F){let R={get:(D,$)=>(typeof $=="string"&&!D[$]&&$.charCodeAt(0)===36&&(D[$]=(...M)=>this._remoteCall(A,$,M)),$===s?F:D[$])};return new Proxy(Object.create(null),R)}set(A,F){return this._locals[A.nid]=F,F}assertRegistered(A){for(let F=0,R=A.length;F<R;F++){const D=A[F];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(A){if(this._isDisposed)return;const F=A.byteLength,R=r.read(A,0),D=R.readUInt8(),$=R.readUInt32();switch(D){case 1:case 2:{let{rpcId:M,method:q,args:G}=a.deserializeRequestJSONArgs(R);this._uriTransformer&&(G=(0,S.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(F,$,M,q,G,D===2);break}case 3:case 4:{let{rpcId:M,method:q,args:G}=a.deserializeRequestMixedArgs(R);this._uriTransformer&&(G=(0,S.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(F,$,M,q,G,D===4);break}case 5:{this._logger&&this._logger.logIncoming(F,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(F,$);break}case 7:{this._receiveReply(F,$,void 0);break}case 9:{let M=a.deserializeReplyOKJSON(R);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(F,$,M);break}case 10:{const M=a.deserializeReplyOKJSONWithBuffers(R,this._uriTransformer);this._receiveReply(F,$,M);break}case 8:{let M=a.deserializeReplyOKVSBuffer(R);this._receiveReply(F,$,M);break}case 11:{let M=a.deserializeReplyErrError(R);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(F,$,M);break}case 12:{this._receiveReplyErr(F,$,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,F,R,D,$,M){this._logger&&this._logger.logIncoming(A,F,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(R)}.${D}(`,$);const q=String(F);let G,U;if(M){const ee=new I.CancellationTokenSource;$.push(ee.token),G=this._invokeHandler(R,D,$),U=()=>ee.cancel()}else G=this._invokeHandler(R,D,$),U=l;this._cancelInvokedHandlers[q]=U;const W=a.serializeAcknowledged(F);this._logger&&this._logger.logOutgoing(W.byteLength,F,1,"ack"),this._protocol.send(W),G.then(ee=>{delete this._cancelInvokedHandlers[q];const Z=a.serializeReplyOK(F,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(Z.byteLength,F,1,"reply:",ee),this._protocol.send(Z)},ee=>{delete this._cancelInvokedHandlers[q];const Z=a.serializeReplyErr(F,ee);this._logger&&this._logger.logOutgoing(Z.byteLength,F,1,"replyErr:",ee),this._protocol.send(Z)})}_receiveCancel(A,F){this._logger&&this._logger.logIncoming(A,F,1,"receiveCancel");const R=String(F);this._cancelInvokedHandlers[R]&&this._cancelInvokedHandlers[R]()}_receiveReply(A,F,R){this._logger&&this._logger.logIncoming(A,F,0,"receiveReply:",R);const D=String(F);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const $=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],$.resolveOk(R)}_receiveReplyErr(A,F,R){this._logger&&this._logger.logIncoming(A,F,0,"receiveReplyErr:",R);const D=String(F);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const $=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let M;R&&(R.$isError?(M=new Error,M.name=R.name,M.message=R.message,M.stack=R.stack):M=R),$.resolveErr(M)}_invokeHandler(A,F,R){try{return Promise.resolve(this._doInvokeHandler(A,F,R))}catch(D){return Promise.reject(D)}}_doInvokeHandler(A,F,R){const D=this._locals[A];if(!D)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(A));let $=D[F];if(typeof $!="function")throw new Error("Unknown method "+F+" on actor "+(0,O.getStringIdentifierForProxy)(A));return $.apply(D,R)}_remoteCall(A,F,R){if(this._isDisposed)return Promise.reject(T.canceled());let D=null;if(R.length>0&&I.CancellationToken.isCancellationToken(R[R.length-1])&&(D=R.pop()),D&&D.isCancellationRequested)return Promise.reject(T.canceled());const $=a.serializeRequestArguments(R,this._uriReplacer),M=++this._lastMessageId,q=String(M),G=new L.LazyPromise;D&&D.onCancellationRequested(()=>{const W=a.serializeCancel(M);this._logger&&this._logger.logOutgoing(W.byteLength,M,0,"cancel"),this._protocol.send(a.serializeCancel(M))}),this._pendingRPCReplies[q]=G,this._onWillSendRequest(M);const U=a.serializeRequest(M,A,F,$,!!D);return this._logger&&this._logger.logOutgoing(U.byteLength,M,0,`request: ${(0,O.getStringIdentifierForProxy)(A)}.${F}(`,R),this._protocol.send(U),G}}e.RPCProtocol=t,y=E,t.UNRESPONSIVE_TIME=3*1e3;class r{constructor(A,F){this._buff=A,this._offset=F}static alloc(A,F,R){let D=new r(n.VSBuffer.alloc(R+1+4),0);return D.writeUInt8(A),D.writeUInt32(F),D}static read(A,F){return new r(A,F)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const R=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,R}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,R}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,F}static sizeMixedArray(A){let F=0;F+=1;for(let R=0,D=A.length;R<D;R++){const $=A[R];switch(F+=1,$.type){case 1:F+=this.sizeLongString($.value);break;case 2:F+=this.sizeVSBuffer($.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString($.value);for(let M=0;M<$.buffers.length;++M)F+=this.sizeVSBuffer($.buffers[M]);break;case 4:break}}return F}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let F=0,R=A.length;F<R;F++){const D=A[F];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let $=0;$<D.buffers.length;++$)this.writeBuffer(D.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let F=new Array(A);for(let R=0;R<A;R++)switch(this.readUInt8()){case 1:F[R]=this.readLongString();break;case 2:F[R]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),M=this.readLongString(),q=[];for(let G=0;G<$;++G)q.push(this.readVSBuffer());F[R]=new O.SerializableObjectWithBuffers(P(M,q,null));break}case 4:F[R]=void 0;break}return F}}r.sizeUInt32=4;var i;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(i||(i={}));class a{static _useMixedArgSerialization(A){for(let F=0,R=A.length;F<R;F++)if(A[F]instanceof n.VSBuffer||A[F]instanceof O.SerializableObjectWithBuffers||typeof A[F]=="undefined")return!0;return!1}static serializeRequestArguments(A,F){if(this._useMixedArgSerialization(A)){const R=[];for(let D=0,$=A.length;D<$;D++){const M=A[D];if(M instanceof n.VSBuffer)R[D]={type:2,value:M};else if(typeof M=="undefined")R[D]={type:4};else if(M instanceof O.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:G}=p(M.value,F);R[D]={type:3,value:n.VSBuffer.fromString(q),buffers:G}}else R[D]={type:1,value:n.VSBuffer.fromString(_(M,F))}}return{type:1,args:R}}return{type:0,args:_(A,F)}}static serializeRequest(A,F,R,D,$){switch(D.type){case 0:return this._requestJSONArgs(A,F,R,D.args,$);case 1:return this._requestMixedArgs(A,F,R,D.args,$)}}static _requestJSONArgs(A,F,R,D,$){const M=n.VSBuffer.fromString(R),q=n.VSBuffer.fromString(D);let G=0;G+=r.sizeUInt8(),G+=r.sizeShortString(M),G+=r.sizeLongString(q);let U=r.alloc($?2:1,A,G);return U.writeUInt8(F),U.writeShortString(M),U.writeLongString(q),U.buffer}static deserializeRequestJSONArgs(A){const F=A.readUInt8(),R=A.readShortString(),D=A.readLongString();return{rpcId:F,method:R,args:JSON.parse(D)}}static _requestMixedArgs(A,F,R,D,$){const M=n.VSBuffer.fromString(R);let q=0;q+=r.sizeUInt8(),q+=r.sizeShortString(M),q+=r.sizeMixedArray(D);let G=r.alloc($?4:3,A,q);return G.writeUInt8(F),G.writeShortString(M),G.writeMixedArray(D),G.buffer}static deserializeRequestMixedArgs(A){const F=A.readUInt8(),R=A.readShortString(),D=A.readMixedArray(),$=new Array(D.length);for(let M=0,q=D.length;M<q;M++){const G=D[M];typeof G=="string"?$[M]=JSON.parse(G):$[M]=G}return{rpcId:F,method:R,args:$}}static serializeAcknowledged(A){return r.alloc(5,A,0).buffer}static serializeCancel(A){return r.alloc(6,A,0).buffer}static serializeReplyOK(A,F,R){if(typeof F=="undefined")return this._serializeReplyOKEmpty(A);if(F instanceof n.VSBuffer)return this._serializeReplyOKVSBuffer(A,F);if(F instanceof O.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:$}=p(F.value,R,!0);return this._serializeReplyOKJSONWithBuffers(A,D,$)}else return this._serializeReplyOKJSON(A,v(F,R))}static _serializeReplyOKEmpty(A){return r.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,F){let R=0;R+=r.sizeVSBuffer(F);let D=r.alloc(8,A,R);return D.writeVSBuffer(F),D.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,F){const R=n.VSBuffer.fromString(F);let D=0;D+=r.sizeLongString(R);let $=r.alloc(9,A,D);return $.writeLongString(R),$.buffer}static _serializeReplyOKJSONWithBuffers(A,F,R){const D=n.VSBuffer.fromString(F);let $=0;$+=r.sizeUInt32,$+=r.sizeLongString(D);for(const q of R)$+=r.sizeVSBuffer(q);let M=r.alloc(10,A,$);M.writeUInt32(R.length),M.writeLongString(D);for(const q of R)M.writeBuffer(q);return M.buffer}static deserializeReplyOKJSON(A){const F=A.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(A,F){const R=A.readUInt32(),D=A.readLongString(),$=[];for(let M=0;M<R;++M)$.push(A.readVSBuffer());return new O.SerializableObjectWithBuffers(P(D,$,F))}static serializeReplyErr(A,F){const R=F?v(T.transformErrorForSerialization(F),null):void 0;if(typeof R!="string")return this._serializeReplyErrEmpty(A);const D=n.VSBuffer.fromString(R);let $=0;$+=r.sizeLongString(D);let M=r.alloc(11,A,$);return M.writeLongString(D),M.buffer}static deserializeReplyErrError(A){const F=A.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(A){return r.alloc(12,A,0).buffer}}var m;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var h;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(h||(h={}))}),define(pe[265],ve([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(pe[266],ve([1,0,29,10,9,12,23,2,4,198,43,223,265]),function(te,e,f,n,I,T,C,k,S,L,O,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let b=class qi{constructor(d,p,P,_){this.localUserHome=d,this.remoteAgentService=p,this.environmentService=P,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const o=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=o?.userHome||d})()}hasValidBasename(d,p,P){return typeof p=="string"||typeof p=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(d,_,p)):this.doHasValidBasename(d,p,P)}doHasValidBasename(d,p,P){return d.scheme===n.Schemas.file||d.scheme===n.Schemas.vscodeRemote?(0,f.isValidBasename)(P??(0,C.basename)(d),p===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,p){if(d.remoteAuthority)return n.Schemas.vscodeRemote;const P=(0,L.getVirtualWorkspaceScheme)(p.getWorkspace());if(P)return P;const _=p.getWorkspace().folders[0];if(_)return _.uri.scheme;const o=p.getWorkspace().configuration;return o?o.scheme:n.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let p="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const _=d.indexOf("/",2);_===-1?(p=d.substring(2),d="/"):(p=d.substring(2,_),d=d.substring(_)||"/")}return k.URI.from({scheme:n.Schemas.file,authority:p,path:d,query:"",fragment:""})}};b=Be([Fe(1,v.IRemoteAgentService),Fe(2,y.IWorkbenchEnvironmentService),Fe(3,O.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(pe[68],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(C,k){this.line=C,this.character=k}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,k){return new f(0,0)}with(C){return new f(0,0)}}e.Position=f;class n{constructor(C,k,S,L){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(C,k),this.end=new f(S,L)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new n(0,0,0,0)}with(C){return new n(0,0,0,0)}}e.Range=n;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([1,0,18,34,25,29,8,4,9,15,68,16]),function(te,e,f,n,I,T,C,k,S,L,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",b=" characters skipped \u27EB",g=(v.length+b.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var d;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function P(V){return!!V.preview}e.resultIsMatch=P;function _(V){return!!V.resource}e.isFileMatch=_;function o(V){return!!V.message}e.isProgressMessage=o;var c;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=u;class l{constructor(J,se,ae){this.ranges=se;const Q=Array.isArray(se)?se:[se];if(ae&&ae.matchLines===1&&E(Q)){J=(0,C.getNLines)(J,ae.matchLines);let Y="",oe=0,de=0;const Ee=Math.floor(ae.charsPerLine/5),Re=[];for(const Ne of Q){const be=Math.max(Ne.startColumn-Ee,0),we=Ne.startColumn+ae.charsPerLine;if(be>de+Ee+g){const H=v+(be-de)+b;Y+=H+J.slice(be,we),oe+=be-(de+H.length)}else Y+=J.slice(de,we);Re.push(new t(0,Ne.startColumn-oe,Ne.endColumn-oe)),de=we}this.preview={text:Y,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const Y=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:J,matches:(0,f.mapArrayOrNot)(se,oe=>new s(oe.startLineNumber-Y,oe.startColumn,oe.endLineNumber-Y,oe.endColumn))}}}}e.TextSearchMatch=l;function E(V){const J=V[0].startLineNumber;for(const se of V)if(se.startLineNumber!==J||se.endLineNumber!==J)return!1;return!0}class s{constructor(J,se,ae,Q){this.startLineNumber=J,this.startColumn=se,this.endLineNumber=ae,this.endColumn=Q}}e.SearchRange=s;class t extends s{constructor(J,se,ae){super(J,se,J,ae)}}e.OneLineRange=t;var r;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function i(V,J=!0){const se=V&&V.files&&V.files.exclude,ae=J&&V&&V.search&&V.search.exclude;if(!se&&!ae)return;if(!se||!ae)return se||ae;let Q=Object.create(null);return Q=I.mixin(Q,I.deepClone(se)),Q=I.mixin(Q,I.deepClone(ae),!0),Q}e.getExcludes=i;function a(V,J){return V.excludePattern&&n.match(V.excludePattern,J)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&n.match(V.includePattern,J)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(se=>{const ae=se.folder.fsPath;if(T.isEqualOrParent(J,ae)){const Q=S.relative(ae,J);return!se.includePattern||!!n.match(se.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var m;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(J,se){super(J);this.code=se}}e.SearchError=h;function w(V){const J=V.message;if((0,L.isCancellationError)(V))return new h(J,m.canceled);try{const se=JSON.parse(J);return new h(se.message,se.code)}catch{return new h(J,m.other)}}e.deserializeSearchError=w;function A(V){const J={message:V.message,code:V.code};return new Error(JSON.stringify(J))}e.serializeSearchError=A;function F(V){return V.type==="error"?!0:V.type==="success"}e.isSerializedSearchComplete=F;function R(V){return V.type==="success"}e.isSerializedSearchSuccess=R;function D(V){return!!V.path}e.isSerializedFileMatch=D;function $(V,J){const se=V.searchPath?V.searchPath:V.relativePath;return(0,C.fuzzyContains)(se,J)}e.isFilePatternMatch=$;class M{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function q(V,J){const se={...V||{},...J||{}};return Object.keys(se).filter(ae=>{const Q=se[ae];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=q;class G{constructor(J,se){this._parsedIncludeExpression=null,this._excludeExpression={...J.excludePattern||{},...se.excludePattern||{}},this._parsedExcludeExpression=n.parse(this._excludeExpression);let ae=J.includePattern;se.includePattern&&(ae?ae={...ae,...se.includePattern}:ae=se.includePattern),ae&&(this._parsedIncludeExpression=n.parse(ae))}matchesExcludesSync(J,se,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,se,ae))}includedInQuerySync(J,se,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,se,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(J,se,ae))}includedInQuery(J,se,ae){const Q=this._parsedExcludeExpression(J,se,ae),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(J,se,ae):!0;return(0,y.isThenable)(Q)?Q.then(oe=>oe?!1:Y()):Y()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=G;function U(V){for(const J in V)if(typeof V[J]!="boolean")return!0;return!1}function W(V){if(!V)return;let J;return se=>(J||(J=(V()||Promise.resolve([])).then(ae=>ae?Z(ae):{})),J.then(ae=>!!ae[se]))}e.hasSiblingPromiseFn=W;function ee(V){if(!V)return;let J;return se=>{if(!J){const ae=V();J=ae?Z(ae):{}}return!!J[se]}}e.hasSiblingFn=ee;function Z(V){const J={};for(const se of V)J[se]=!0;return J}}),define(pe[36],ve([1,0,18,16,21,3,24,10,91,23,8,13,2,172,4,11,190,43,44,26,17,14,7,31,5]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c,u,l,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function t(F,R,D){return new L.ExtUri($=>m($,D)).isEqual(F,R)}function r(F,R,D){return t(F.uri,R.uri,D)?0:(0,O.compare)(F.uri.toString(),R.uri.toString())}function i(F,R,D){return F.index!==R.index?F.index<R.index?-1:1:t(F.uri,R.uri,D)?(0,O.compare)(F.name,R.name):(0,O.compare)(F.uri.toString(),R.uri.toString())}function a(F,R,D,$){const M=F.slice(0).sort((G,U)=>D(G,U,$)),q=R.slice(0).sort((G,U)=>D(G,U,$));return(0,f.delta)(M,q,(G,U)=>D(G,U,$))}function m(F,R){const D=R.getCapabilities(F.scheme);return!(D&&D&1024)}class h extends P.Workspace{constructor(R,D,$,M,q,G,U){super(R,$.map(W=>new P.WorkspaceFolder(W)),M,q,U);this._name=D,this._isUntitled=G,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(U),$.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(R,D,$,M){if(!R)return{workspace:null,added:[],removed:[]};const{id:q,name:G,folders:U,configuration:W,transient:ee,isUntitled:Z}=R,V=[],J=D;D?U.forEach((Y,oe)=>{const de=v.URI.revive(Y.uri),Ee=h._findFolder($||D,de,M);Ee?(Ee.name=Y.name,Ee.index=Y.index,V.push(Ee)):V.push({uri:de,name:Y.name,index:oe})}):V.push(...U.map(({uri:Y,name:oe,index:de})=>({uri:v.URI.revive(Y),name:oe,index:de}))),V.sort((Y,oe)=>Y.index<oe.index?-1:1);const se=new h(q,G,V,!!ee,W?v.URI.revive(W):null,!!Z,Y=>m(Y,M)),{added:ae,removed:Q}=a(J?J.workspaceFolders:[],se.workspaceFolders,r,M);return{workspace:se,added:ae,removed:Q}}static _findFolder(R,D,$){for(let M=0;M<R.folders.length;M++){const q=R.workspaceFolders[M];if(t(q.uri,D,$))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,D){return D&&this._structure.get(R)&&(R=(0,L.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let w=class{constructor(R,D,$,M){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=$,this._requestIdProvider=new S.Counter,this._barrier=new n.Barrier,this._proxy=R.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(s.MainContext.MainThreadMessageService);const q=D.workspace;this._confirmedWorkspace=q?new h(q.id,q.name,[],!!q.transient,q.configuration?v.URI.revive(q.configuration):null,!!q.isUntitled,G=>m(G,$)):void 0}$initializeWorkspace(R,D){this._trusted=D,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:k.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,D,$,...M){const q=[];if(Array.isArray(M)&&M.forEach(Z=>{v.URI.isUri(Z.uri)&&!q.some(V=>t(V.uri,Z.uri,this._extHostFileSystemInfo))&&q.push({uri:Z.uri,name:Z.name||(0,L.basenameOrAuthority)(Z.uri)})}),this._unconfirmedWorkspace||[D,$].some(Z=>typeof Z!="number"||Z<0)||$===0&&q.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(D+$>G.length)return!1;const U=G.slice(0);U.splice(D,$,...q.map(Z=>({uri:Z.uri,name:Z.name||(0,L.basenameOrAuthority)(Z.uri),index:void 0})));for(let Z=0;Z<U.length;Z++){const V=U[Z];if(U.some((J,se)=>se!==Z&&t(V.uri,J.uri,this._extHostFileSystemInfo)))return!1}U.forEach((Z,V)=>Z.index=V);const{added:W,removed:ee}=a(G,U,i,this._extHostFileSystemInfo);if(W.length===0&&ee.length===0)return!1;if(this._proxy){const Z=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(Z,D,$,q).then(void 0,V=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:R.identifier,label:R.displayName||R.name}};this._messageService.$showMessage(p.Severity.Error,(0,b.localize)(0,null,Z,V.toString()),J,[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(R,D){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,D)}async getWorkspaceFolder2(R,D){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,D)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,D){let $,M="";if(typeof R=="string"?($=v.URI.file(R),M=R):typeof R!="undefined"&&($=R,M=R.fsPath),!$)return M;const q=this.getWorkspaceFolder($,!0);if(!q)return M;typeof D=="undefined"&&this._actualWorkspace&&(D=this._actualWorkspace.folders.length>1);let G=(0,L.relativePath)(q.uri,$);return D&&q.name&&(G=`${q.name}/${G}`),G}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:D,added:$,removed:M}=h.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=D||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:M}))}findFiles(R,D,$,M,q=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let G;if(D===null?G=!1:D&&(typeof D=="string"?G=D:G=D.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:W}=A(u.GlobPattern.from(R));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(U),(0,y.withUndefinedAsNull)(W),(0,y.withUndefinedAsNull)(G),(0,y.withUndefinedAsNull)($),q).then(ee=>Array.isArray(ee)?ee.map(Z=>v.URI.revive(Z)):[])}async findTextInFiles(R,D,$,M,q=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),U=typeof D.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:D.previewOptions,{includePattern:W,folder:ee}=A(u.GlobPattern.from(D.include)),Z=typeof D.exclude=="string"?D.exclude:D.exclude?D.exclude.pattern:void 0,V={ignoreSymlinks:typeof D.followSymlinks=="boolean"?!D.followSymlinks:void 0,disregardIgnoreFiles:typeof D.useIgnoreFiles=="boolean"?!D.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof D.useGlobalIgnoreFiles=="boolean"?!D.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof D.useParentIgnoreFiles=="boolean"?!D.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof D.useDefaultExcludes=="boolean"?!D.useDefaultExcludes:!0,fileEncoding:D.encoding,maxResults:D.maxResults,previewOptions:U,afterContext:D.afterContext,beforeContext:D.beforeContext,includePattern:W,excludePattern:Z},J=!1;if(this._activeSearchCallbacks[G]=se=>{if(J)return;const ae=v.URI.revive(se.resource);se.results.forEach(Q=>{(0,E.resultIsMatch)(Q)?$({uri:ae,preview:{text:Q.preview.text,matches:(0,f.mapArrayOrNot)(Q.preview.matches,Y=>new l.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,f.mapArrayOrNot)(Q.ranges,Y=>new l.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):$({uri:ae,text:Q.text,lineNumber:Q.lineNumber})})},q.isCancellationRequested)return{};try{const se=await this._proxy.$startTextSearch(R,(0,y.withUndefinedAsNull)(ee),V,G,q);return delete this._activeSearchCallbacks[G],se||{}}catch(se){throw delete this._activeSearchCallbacks[G],se}}$handleTextSearchResult(R,D){this._activeSearchCallbacks[D]&&this._activeSearchCallbacks[D](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=Be([Fe(0,c.IExtHostRpcService),Fe(1,o.IExtHostInitDataService),Fe(2,_.IExtHostFileSystemInfo),Fe(3,d.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function A(F){let R,D;return F&&(typeof F=="string"?R=F:(R=F.pattern,D=v.URI.revive(F.baseUri))),{includePattern:R,folder:D}}}),define(pe[37],ve([1,0,25,3,36,5,7,193,119,13,16,4,17,11,2]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(E,s){if(s){const t=s.split(".");let r=E;for(let i=0;r&&i<t.length;i++)r=r[t[i]];return r}}function p(E){return E instanceof g.URI}function P(E){return E&&E.uri instanceof g.URI&&E.languageId&&typeof E.languageId=="string"}function _(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function o(E){return E&&E.uri instanceof g.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function c(E){if(p(E))return{resource:E};if(P(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(_(E))return{overrideIdentifier:E.languageId};if(o(E))return{resource:E.uri};if(E===null)return{resource:null}}let u=class{constructor(s,t,r){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=r,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new l(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,t){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,t))}};u=Be([Fe(0,v.IExtHostRpcService),Fe(1,I.IExtHostWorkspace),Fe(2,b.ILogService)],u),e.ExtHostConfiguration=u;class l{constructor(s,t,r,i){this._onDidChangeConfiguration=new n.Emitter,this._proxy=s,this._logService=i,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,t){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,r))}getConfiguration(s,t,r){const i=c(t)||{},a=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,i,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,i,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,i,r?.identifier);function m(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(w){return typeof d(a,w)!="undefined"},get:(w,A)=>{this._validateConfigurationAccess(s?`${s}.${w}`:w,i,r?.identifier);let F=d(a,w);if(typeof F=="undefined")F=A;else{let R;const D=($,M)=>{let q;const G=()=>{R=R||(0,f.deepClone)(a),q=q||d(R,M)};return(0,L.isObject)($)?new Proxy($,{get:(U,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return G(),()=>q;if(R)return q=q||d(R,M),q[W];const ee=U[W];return typeof W=="string"?D(ee,`${M}.${W}`):ee},set:(U,W,ee)=>(G(),q&&(q[W]=ee),!0),deleteProperty:(U,W)=>(G(),q&&delete q[W],!0),defineProperty:(U,W,ee)=>(G(),q&&Object.defineProperty(q,W,ee),!0)}):$};F=D(F,w)}return F},update:(w,A,F,R)=>{w=s?`${s}.${w}`:w;const D=m(F);return A!==void 0?this._proxy.$updateConfigurationOption(D,w,A,i,R):this._proxy.$removeConfigurationOption(D,w,i,R)},inspect:w=>{w=s?`${s}.${w}`:w;const A=(0,f.deepClone)(this._configuration.inspect(w,i,this._extHostWorkspace.workspace));if(A)return{key:w,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof a=="object"&&(0,f.mixin)(h,a,!1),Object.freeze(h)}_toReadonlyValue(s){const t=r=>(0,L.isObject)(r)?new Proxy(r,{get:(i,a)=>t(i[a]),set:(i,a,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(i,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(i,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:i=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return t(s)}_validateConfigurationAccess(s,t,r){const i=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),a=r?`[${r.value}] `:"";if(i===4){typeof t?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(i===3){t?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,t){const r=new k.ConfigurationChangeEvent(s,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(i,a)=>r.affectsConfiguration(i,c(a))})}_toMap(s){return s.reduce((t,r)=>(t.set(r[0],r[1]),t),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[69],ve([1,0,2,16,3,5,7,36,45,37,21,33,17,26,4,10,12,11,64,215,15]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(M){function q(U){if(U!=null)return U}M.from=q;function G(U){if(U!=null)return U}M.to=G})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(M){function q(U){if(U!=null)return U}M.from=q;function G(U){if(U!=null)return U}M.to=G})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(M){function q(U){if(U!=null)return U}M.from=q;function G(U){if(U!=null)return U}M.to=G})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(M){function q(W){if(W){const ee=W;return ee&&!!ee.process}else return!1}M.is=q;function G(W){if(W==null)return;const ee={process:W.process,args:W.args};return W.options&&(ee.options=s.from(W.options)),ee}M.from=G;function U(W){if(W!=null)return new C.ProcessExecution(W.process,W.args,W.options)}M.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(M){function q(U){if(U!=null)return U}M.from=q;function G(U){if(U!=null)return U}M.to=G})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var i;(function(M){function q(W){if(W){const ee=W;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}M.is=q;function G(W){if(W==null)return;const ee={};return W.commandLine!==void 0?ee.commandLine=W.commandLine:(ee.command=W.command,ee.args=W.args),W.options&&(ee.options=r.from(W.options)),ee}M.from=G;function U(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new C.ShellExecution(W.commandLine,W.options):new C.ShellExecution(W.command,W.args?W.args:[],W.options)}M.to=U})(i=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(M){function q(W){if(W){let ee=W;return ee&&ee.customExecution==="customExecution"}else return!1}M.is=q;function G(W){return{customExecution:"customExecution"}}M.from=G;function U(W,ee){return ee.get(W)}M.to=U})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(M){function q(G,U){let W;return G.scope!==void 0&&typeof G.scope!="number"?W=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===C.TaskScope.Workspace&&U&&U.workspaceFile?W=U.workspaceFile:W=o.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:W}}M.from=q})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(M){function q(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}M.from=q})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function q(W,ee){if(W==null)return[];const Z=[];for(let V of W){const J=G(V,ee);J&&Z.push(J)}return Z}M.fromMany=q;function G(W,ee){if(W==null)return;let Z;W.execution instanceof C.ProcessExecution?Z=t.from(W.execution):W.execution instanceof C.ShellExecution?Z=i.from(W.execution):W.execution&&W.execution instanceof C.CustomExecution&&(Z=a.from(W.execution));const V=l.from(W.definition);let J;return W.scope?typeof W.scope=="number"?J=W.scope:J=W.scope.uri:J=C.TaskScope.Workspace,!V||!J?void 0:{_id:W._id,definition:V,name:W.name,source:{extensionId:ee.identifier.value,label:W.source,scope:J},execution:Z,isBackground:W.isBackground,group:h.from(W.group),presentationOptions:E.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}M.from=G;async function U(W,ee,Z){if(W==null)return;let V;t.is(W.execution)?V=t.to(W.execution):i.is(W.execution)?V=i.to(W.execution):a.is(W.execution)&&(V=a.to(W._id,Z));const J=l.to(W.definition);let se;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?se=W.source.scope:se=await ee.resolveWorkspaceFolder(f.URI.revive(W.source.scope)):se=C.TaskScope.Workspace),!J||!se)return;const ae=new C.Task(J,se,W.name,W.source.label,V,W.problemMatchers);return W.isBackground!==void 0&&(ae.isBackground=W.isBackground),W.group!==void 0&&(ae.group=C.TaskGroup.from(W.group._id),ae.group&&W.group.isDefault&&(ae.group=new C.TaskGroup(ae.group.id,ae.group.label),W.group.isDefault&&(ae.group.isDefault=W.group.isDefault))),W.presentationOptions&&(ae.presentationOptions=E.to(W.presentationOptions)),W._id&&(ae._id=W._id),W.detail&&(ae.detail=W.detail),ae}M.to=U})(w=e.TaskDTO||(e.TaskDTO={}));var A;(function(M){function q(U){return U}M.from=q;function G(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=G})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(q,G,U){this._id=G,this._task=U,u.set(this,void 0),Ke(this,u,q,"f")}get task(){return this._task}terminate(){ke(this,u,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}u=new WeakMap;var R;(function(M){function q(G){return{id:G._id,task:void 0}}M.from=q})(R=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(q,G,U,W,ee,Z,V,J){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=q.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=W,this._configurationService=ee,this._terminalService=Z,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,G,U){if(!U)return new C.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:G,provider:U,extension:q}),this._proxy.$registerTaskProvider(W,G),new C.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(q,G){this._proxy.$registerTaskSystem(q,G)}fetchTasks(q){return this._proxy.$fetchTasks(A.from(q)).then(async G=>{const U=[];for(let W of G){const ee=await w.to(W,this._workspaceProvider,this._providedCustomExecutions2);ee&&U.push(ee)}return U})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(G=>q.push(G)),q}terminateTask(q){if(!(q instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,G,U){const W=this._providedCustomExecutions2.get(q.id);W&&(this._activeCustomExecutions2.set(q.id,W),this._terminalService.attachPtyToTerminal(G,await W.callback(U))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const G=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const G=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:G,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const G=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:q.exitCode})}$provideTasks(q,G){const U=this._handlers.get(q);if(!U)return Promise.reject(new Error("no handler found"));const W=[],ee=(0,n.asPromise)(()=>U.provider.provideTasks(O.CancellationToken.None)).then(Z=>this.provideTasksInternal(G,W,U,Z));return new Promise(Z=>{ee.then(V=>{Promise.all(W).then(()=>{Z(V)})})})}async $resolveTask(q,G){const U=this._handlers.get(q);if(!U)return Promise.reject(new Error("no handler found"));if(G.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${U.type}].`);const W=await w.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ee=await U.provider.resolveTask(W,O.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,U);const Z=w.from(ee,U.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(Z.execution)&&await this.addCustomExecution(Z,ee,!0),await this.resolveTaskInternal(Z)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,G,U){const W=await this._proxy.$createTaskId(q);!U&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,G.execution)),this._providedCustomExecutions2.set(W,G.execution)}async getTaskExecution(q,G){if(typeof q=="string"){const ee=this._taskExecutionPromises.get(q);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}let U=this._taskExecutionPromises.get(q.id);if(U)return U;const W=new Promise((ee,Z)=>{function V(J,se,ae){ae?ee(new F(J,se.id,ae)):Z("Unexpected: Task does not exist.")}G?V(this,q,G):w.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>V(this,q,J))});return this._taskExecutionPromises.set(q.id,W),W.then(ee=>(this._taskExecutions.set(q.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(q,G){q._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let U=this._notProvidedCustomExecutions.values(),W=U.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=U.next()}};D=Be([Fe(0,v.IExtHostRpcService),Fe(1,b.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,L.IExtHostConfiguration),Fe(5,y.IExtHostTerminalService),Fe(6,P.ILogService),Fe(7,_.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let $=class extends D{constructor(q,G,U,W,ee,Z,V,J){super(q,G,U,W,ee,Z,V,J);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(q,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const U=w.from(G,q);if(U===void 0)throw new Error("Task is not valid");if(a.is(U.execution))await this.addCustomExecution(U,G,!1);else throw new c.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),G);return this._proxy.$executeTask(U).catch(ee=>{throw new Error(ee)}),W}provideTasksInternal(q,G,U,W){const ee=[];if(W)for(let Z of W){this.checkDeprecation(Z,U),(!Z.definition||!q[Z.definition.type])&&this._logService.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const V=w.from(Z,U.extension);V&&a.is(V.execution)?(ee.push(V),G.push(this.addCustomExecution(V,Z,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:U.extension}}async resolveTaskInternal(q){if(a.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,G,U){}};$=Be([Fe(0,v.IExtHostRpcService),Fe(1,b.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,L.IExtHostConfiguration),Fe(5,y.IExtHostTerminalService),Fe(6,P.ILogService),Fe(7,_.IExtHostApiDeprecationService)],$),e.WorkerExtHostTask=$,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(pe[267],ve([1,0,9,21,49,34,23,46,31]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class L{constructor(v,b,g){this.config=v,this.provider=b,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&T.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&T.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const b=this.config.folderQueries||[];return new Promise((g,d)=>{const p=P=>{this.resultCount++,v(P)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const _=P.toString(),o=f.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,o)||this.matchFile(p,{base:P,basename:o})}),Promise.all(b.map(P=>this.searchInFolder(P,p))).then(P=>{g({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{d(new Error((0,I.toErrorMessage)(P)))})})}async searchInFolder(v,b){const g=new n.CancellationTokenSource,d=this.getSearchOptionsForFolder(v),p=this.initDirectoryTree(),P=new S.QueryGlobTester(this.config,v),_=!P.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(g),o=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,g.token),u=o.elapsed(),l=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(E=>{const s=f.posix.relative(v.folder.path,E.path);if(_){const t=f.basename(E.path);this.matchFile(b,{base:v.folder,relativePath:s,basename:t});return}this.addDirectoryEntries(p,v.folder,s,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,P,b),{providerTime:u,postProcessTime:l.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(v){const b=(0,S.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),g=(0,S.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:g,includes:b,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},b,g,d){if(g===this.filePattern){const P=f.basename(this.filePattern);this.matchFile(d,{base:b,relativePath:this.filePattern,basename:P})}function p(P){const _=f.basename(P),o=f.dirname(P);let c=v[o];c||(c=v[o]=[],p(o)),c.push({base:b,relativePath:P,basename:_})}p(g)}matchDirectoryTree({rootEntries:v,pathToEntries:b},g,d){const p=this,P=this.filePattern;function _(o){const c=(0,S.hasSiblingFn)(()=>o.map(u=>u.basename));for(let u=0,l=o.length;u<l;u++){const E=o[u],{relativePath:s,basename:t}=E;if(g.matchesExcludesSync(s,t,P!==t?c:void 0))continue;const r=b[s];if(r)_(r);else{if(s===P)continue;p.matchFile(d,E)}if(p.isLimitHit)break}}_(v)}matchFile(v,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(b))}}class O{constructor(){this.sessions=new Map}fileSearch(v,b,g,d){const p=this.getSessionTokenSource(v.cacheKey),P=new L(v,b,p&&p.token);let _=0;const o=c=>{_+=c.length,g(c.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(P,O.BATCH_SIZE,o,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(v){const b=this.getSessionTokenSource(v);b&&b.cancel()}getSessionTokenSource(v){if(!!v)return this.sessions.has(v)||this.sessions.set(v,new n.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,b,g,d){d.onCancellationRequested(()=>{v.cancel()});const p=_=>{_&&(P.push(_),b>0&&P.length>=b&&(g(P),P=[]))};let P=[];return v.search(p).then(_=>(P.length&&g(P),_),_=>(P.length&&g(P),Promise.reject(_)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(pe[268],ve([1,0,18,73,34,100,24,10,9,23,8,13,2,152,181,115,11,43,129,266,31]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(h,w,A,F,R){this.configurationService=h,this.workspaceContextService=w,this.editorGroupsService=A,this.logService=F,this.pathService=R}text(h,w,A={}){h=this.getContentPattern(h,A);const F=this.configurationService.getValue(),R=w&&w.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(w?.map(P.toWorkspaceFolder),A),type:2,contentPattern:h,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:F.search.usePCRE2||R||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}getContentPattern(h,w){const A=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const F={...h,wordSeparators:A.editor.wordSeparators};return this.isCaseSensitive(h,w)&&(F.isCaseSensitive=!0),this.isMultiline(h)&&(F.isMultiline=!0),F}file(h,w={}){return{...this.commonQuery(h,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(h,w){return h?(h=Array.isArray(h)?h.map(r):r(h),w?this.parseSearchPaths(h):{pattern:E(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],w={}){const A=this.handleIncludeExclude(w.includePattern,w.expandPatterns),F=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),R=h.length>1,D=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,w,F)):h.map(q=>this.getFolderQueryForRoot(q,w,F,R))).filter(q=>!!q),$={_reason:w._reason,folderQueries:D,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:F.pattern,includePattern:A.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const q=f.coalesce(f.flatten(this.editorGroupsService.groups.map(W=>W.editors.map(ee=>ee.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const G=q.filter(W=>(0,c.pathIncludedInQuery)($,W.fsPath)),U=this.commonQueryFromFileList(G);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...$,...U}}const M=w.extraFileResources&&w.extraFileResources.filter(q=>(0,c.pathIncludedInQuery)($,q.fsPath));return $.extraFileResources=M&&M.length?M:void 0,$}commonQueryFromFileList(h){const w=[],A=new C.ResourceMap,F={};let R=!1;return h.forEach(D=>{if(D.scheme===k.Schemas.walkThrough)return;if((0,L.isAbsolutePath)(D)){const M=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:S.dirname(D.fsPath)});let q=A.get(M);q||(R=!0,q={folder:M,includePattern:{}},w.push(q),A.set(M,q));const G=S.relative(M.fsPath,D.fsPath);(0,y.assertIsDefined)(q.includePattern)[G.replace(/\\/g,"/")]=!0}else D.fsPath&&(R=!0,F[D.fsPath]=!0)}),{folderQueries:w,includePattern:F,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(h,w){if(w.isSmartCase){if(h.isRegExp){if(O.containsUppercaseCharacter(h.pattern,!0))return!0}else if(O.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,b.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const w=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),F=(Array.isArray(h)?h:s(h)).map(U=>{const W=this.pathService.resolvedUserHome;return W?(0,T.untildify)(U,W.scheme===k.Schemas.file?W.fsPath:W.path):U}),R=n.groupBy(F,U=>w(U)?"searchPaths":"exprSegments"),D=(R.exprSegments||[]).map(U=>O.rtrim(U,"/")).map(U=>O.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),t(U))),$={},M=this.expandSearchPathPatterns(R.searchPaths||[]);M&&M.length&&($.searchPaths=M);const q=f.flatten(D),G=E(...q);return G&&($.pattern=G),$}getExcludesForFolder(h,w){return w.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const w=f.flatten(h.map(F=>{let{pathPortion:R,globPortion:D}=l(F);D&&(D=i(D));const $=this.expandOneSearchPath(R);return f.flatten($.map(M=>this.resolveOneSearchPathPattern(M,D)))})),A=new Map;return w.forEach(F=>{const R=F.searchPath.toString(),D=A.get(R);D?F.pattern&&(D.pattern=D.pattern||{},D.pattern[F.pattern]=!0):A.set(R,{searchPath:F.searchPath,pattern:F.pattern?E(F.pattern):void 0})}),Array.from(A.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==k.Schemas.file?[{searchPath:w[0].uri.with({path:h})}]:[{searchPath:v.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=r(h),h.startsWith("../")||h===".."){const F=S.posix.resolve(w.path,h);return[{searchPath:w.with({path:F})}]}const A=i(h);return[{searchPath:w,pattern:A}]}else{if(h==="./"||h===".\\")return[];{const w=h.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(R=>{const D=w.match(new RegExp(`^${O.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return D?{match:D,folder:R}:null}).filter(y.isDefined);if(F.length)return F.map(R=>{const D=R.match[1];return{searchPath:R.folder.uri,pattern:D&&i(D)}});{const R=h.match(/\.[\/\\](.+)[\/\\]?/),D=R?R[1]:h,$=g.localize(0,null,D);throw new Error($)}}}}resolveOneSearchPathPattern(h,w){const A=h.pattern&&w?`${h.pattern}/${w}`:h.pattern||w,F=[{searchPath:h.searchPath,pattern:A}];return A&&!A.endsWith("**")&&F.push({searchPath:h.searchPath,pattern:A+"/**"}),F}getFolderQueryForSearchPath(h,w,A){const F=this.getFolderQueryForRoot((0,P.toWorkspaceFolder)(h.searchPath),w,A,!1);return F?{...F,includePattern:h.pattern}:null}getFolderQueryForRoot(h,w,A,F){let R;const D=v.URI.isUri(h)?h:h.uri;if(A.searchPaths){const U=A.searchPaths.filter(W=>(0,L.isEqual)(W.searchPath,D))[0];if(U&&!U.pattern)return null;U&&(R=U.pattern)}const $=this.configurationService.getValue({resource:D}),q={...this.getExcludesForFolder($,w)||{},...R||{}},G=v.URI.isUri(h)?(0,L.basename)(h):h.name;return{folder:D,folderName:F?G:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!$.search.followSymlinks}}};u=Be([Fe(0,d.IConfigurationService),Fe(1,P.IWorkspaceContextService),Fe(2,_.IEditorGroupsService),Fe(3,p.ILogService),Fe(4,o.IPathService)],u),e.QueryBuilder=u;function l(m){const h=m.match(/[\*\{\}\(\)\[\]\?]/);if(h){const w=h.index,A=m.substr(0,w).match(/[/|\\][^/\\]*$/);if(A){let F=m.substr(0,A.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:m.substr((A.index||0)+1)}}}return{pathPortion:m}}function E(...m){return m.length?m.reduce((h,w)=>(h[w]=!0,h),Object.create(null)):void 0}function s(m){return I.splitGlobAware(m,",").map(h=>h.trim()).filter(h=>!!h.length)}function t(m){return[`**/${m}/**`,`**/${m}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function i(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(m,h){m=f.distinct(m,F=>F.toString());const w=[],A=h.getWorkspace();return m&&m.forEach(F=>{let R;if(h.getWorkbenchState()===2)R=(0,L.relativePath)(A.folders[0].uri,F),R&&R!=="."&&(R="./"+R);else{const D=h.getWorkspaceFolder(F);if(D){const $=D.name;if(A.folders.filter(q=>q.name===$).length===1){const q=(0,L.relativePath)(D.uri,F);q===""?R=`./${D.name}`:R=`./${D.name}/${q}`}else R=F.fsPath}}R&&w.push(R)}),w}e.resolveResourcesForSearchIncludes=a}),define(pe[269],ve([1,0,23,2,21,15,4,268,31,43]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function y(d,p){const P=p.activationEvents;if(!P)return Promise.resolve(void 0);const _=[],o=[];for(const t of P)if(/^workspaceContains:/.test(t)){const r=t.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?o.push(r):_.push(r)}if(_.length===0&&o.length===0)return Promise.resolve(void 0);let c;const u=new Promise((t,r)=>{c=t}),l=t=>c({activationEvent:t}),E=Promise.all(_.map(t=>v(d,t,l))).then(()=>{}),s=b(d,p.identifier,o,l);return Promise.all([E,s]).then(()=>{c(void 0)}),u}e.checkActivateWorkspaceContainsExtension=y;async function v(d,p,P){for(const _ of d.folders)if(await d.exists(f.joinPath(n.URI.revive(_),p))){P(`workspaceContains:${p}`);return}}async function b(d,p,P,_){if(P.length===0)return Promise.resolve(void 0);const o=new I.CancellationTokenSource,c=d.checkExists(d.folders,P,o.token),u=setTimeout(async()=>{o.cancel(),d.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${P.join(",")}`)},O);let l=!1;try{l=await c}catch(E){T.isCancellationError(E)||T.onUnexpectedError(E)}o.dispose(),clearTimeout(u),l&&_(`workspaceContains:${P.join(",")}`)}function g(d,p,P,_){const o=d.get(C.IInstantiationService),c=d.get(S.ISearchService),l=o.createInstance(k.QueryBuilder).file(p.map(E=>(0,L.toWorkspaceFolder)(n.URI.revive(E))),{_reason:"checkExists",includePattern:P,exists:!0});return c.fileSearch(l,_).then(E=>!!E.limitHit,E=>T.isCancellationError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=g});var Ke=this&&this.__classPrivateFieldSet||function(te,e,f,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},ke=this&&this.__classPrivateFieldGet||function(te,e,f,n){if(f==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!n:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?n:f==="a"?n.call(te):n?n.value:e.get(te)};define(pe[40],ve([1,0,167,9,70,23,16,6,24,2,11,5,37,225,87,36,30,224,15,27,22,199,7,120,4,26,66,17,80,51,33,3,269,86,201,10]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c,u,l,E,s,t,r,i,a,m,h,w,A,F,R,D){"use strict";var $,M,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let G=class Gi extends k.Disposable{constructor(V,J,se,ae,Q,Y,oe,de,Ee,Re){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=se,this._initData=oe,this._extHostWorkspace=ae,this._extHostConfiguration=Q,this._logService=Y,this._extHostTunnelService=Ee,this._extHostTerminalService=Re,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=V.createChild(new a.ServiceCollection([g.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(be=>Ne.add(o.ExtensionIdentifier.toKey(be))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(be,we,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(be,_.transformErrorForSerialization(we),H)},actualActivateExtension:async(be,we)=>{if(Ne.has(o.ExtensionIdentifier.toKey(be)))return await this._mainThreadExtensionsProxy.$activateExtension(be,we),new b.HostExtension;const H=this._registry.getExtensionDescription(be);return this._activateExtension(H,we)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){_.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch{}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,J){return this._activator.activateByEvent(V,J)}_activateById(V,J){return this._activator.activateById(V,J)}activateByIdWithErrors(V,J){return this._activateById(V,J).then(()=>{const se=this._activator.getActivatedExtension(V);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==D.Schemas.file)return V;const J=await this._hostUtils.realpath(V.fsPath);return L.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=S.TernarySearchTree.forUris(J=>T.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const se=await this._realPathExtensionUri(J.extensionLocation);V.set(se,J)}return V})()),this._extensionPathIndex}_deactivate(V){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return J;const se=this._activator.getActivatedExtension(V);if(!se)return J;try{typeof se.module.deactivate=="function"&&(J=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this._logService.error(ae),Promise.resolve(void 0))))}catch(ae){this._logService.error(`An error occurred when deactivating the extension '${V.value}':`),this._logService.error(ae)}try{(0,k.dispose)(se.subscriptions)}catch(ae){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this._logService.error(ae)}return J}async _activateExtension(V,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,J).then(se=>{const ae=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,J),this._logExtensionActivationTimes(V,J,"success",ae),se},se=>{throw this._logExtensionActivationTimes(V,J,"failure"),se})}_logExtensionActivationTimes(V,J,se,ae){const Q=U(V,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...ae||{},outcome:se})}_doActivateExtension(V,J){const se=U(V,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ae=this._getEntryPoint(V);if(!ae)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${V.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const Q=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,T.joinPath)(V.extensionLocation,ae),Q),this._loadExtensionContext(V)]).then(Y=>(I.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Gi._callActivate(this._logService,V.identifier,Y[0],Y[1],Q))).then(Y=>(I.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),Y))}_loadExtensionContext(V){const J=new u.ExtensionGlobalMemento(V,this._storage),se=new u.ExtensionMemento(V.identifier.value,!1,this._storage),ae=new R.ExtensionSecrets(V,this._secretState),Q=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,Y=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([J.whenReady,se.whenReady,this._storagePath.whenReady]).then(()=>{const oe=this;let de,Ee;const Re=(0,p.isProposedApiEnabled)(V,"ipc")?this._initData.messagePorts?.get(o.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:se,secrets:ae,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Ne){return n.join(V.extensionLocation.fsPath,Ne)},get storagePath(){return oe._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return oe._storagePath.globalValue(V).fsPath},get logPath(){return n.join(oe._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return L.URI.joinPath(oe._initData.logsLocation,V.identifier.value)},get storageUri(){return oe._storagePath.workspaceValue(V)},get globalStorageUri(){return oe._storagePath.globalValue(V)},get extensionMode(){return Q},get extension(){return de===void 0&&(de=new W(oe,V.identifier,V,Y)),de},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(V,"extensionRuntime"),oe.extensionRuntime},get environmentVariableCollection(){return oe._extHostTerminalService.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!Ee){if(!Re)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(Re,"message",be=>be.data));Re.start(),Ee={onDidReceiveMessage:Ne,postMessage:Re.postMessage.bind(Re)}}return Ee}})})}static _callActivate(V,J,se,ae,Q){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,J,se,ae,Q).then(Y=>new b.ActivatedExtension(!1,null,Q.build(),se,Y,ae.subscriptions))}static _callActivateOptional(V,J,se,ae,Q){if(typeof se.activate=="function")try{Q.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Y=typeof global=="object"?global:self,oe=se.activate.apply(Y,[ae]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(oe).then(de=>(Q.activateResolveStop(),de))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(se)}_activateOneStartupFinished(V,J){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:J}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const J of V.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(V,J)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(J),ae=Promise.all([V,se]).then(()=>{});return Promise.race([ae,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ae}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(V,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,J){if(this.isActivated(J.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ae={logService:this._logService,folders:V.map(Y=>Y.uri),forceUsingSearch:se,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,oe,de)=>this._mainThreadWorkspaceProxy.$checkExists(Y,oe,de)},Q=await(0,A.checkActivateWorkspaceContainsExtension)(ae,J);if(!!Q)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:Q.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:J}=this._initData.environment;if(!V||!J)throw new Error(f.localize(0,null));const se=await this._loadCommonJSModule(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(f.localize(1,null,J.toString()));return new Promise((ae,Q)=>{const Y=(Ee,Re)=>{Ee?Q(Ee):ae(typeof Re=="number"&&Re>0?1:0)},oe=(0,T.originalFSPath)(J),de=se.run(oe,Y);de&&de.then&&de.then(()=>{ae(0)}).catch(Ee=>{Q(Ee instanceof Error&&Ee.stack?Ee.stack:String(Ee))})})}async $extensionTestsExit(V){this._logService.info(`Extension host terminating: test runner requested exit with code ${V}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,J){return this._resolvers[V]=J,(0,k.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const J=V.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const se=V.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(V,J){this._logService.info(`$resolveAuthority invoked for authority (${ee(V)})`);const{authorityPrefix:se,resolver:ae}=await this._activateAndGetResolver(V);if(!ae)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ae)),I.mark(`code/extHost/willResolveAuthority/${se}`);const Q=await ae.resolve(V,{resolveAttempt:J});I.mark(`code/extHost/didResolveAuthorityOK/${se}`);const Y={authority:V,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},oe={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted,authenticationSession:Q.authenticationSessionForInitializingExtensions?{id:Q.authenticationSessionForInitializingExtensions.id,providerId:Q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:oe,tunnelInformation:{environmentTunnels:Q.environmentTunnels,features:Q.tunnelFeatures}}}}catch(Q){if(I.mark(`code/extHost/didResolveAuthorityError/${se}`),Q instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(V,J){this._logService.info(`$getCanonicalURI invoked for authority (${ee(V)})`);const{authorityPrefix:se,resolver:ae}=await this._activateAndGetResolver(V);if(!ae)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${se}`);const Q=L.URI.revive(J);if(typeof ae.getCanonicalURI=="undefined")return Q;const Y=await(0,C.asPromise)(()=>ae.getCanonicalURI(Q));return Y||Q}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,J){return J===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(V,!1))}async $activate(V,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,J),!0):!1}async $deltaExtensions(V,J){V.forEach(ae=>ae.extensionLocation=L.URI.revive(ae.extensionLocation));const se=await this.getExtensionPathIndex();return await Promise.all(J.map(async ae=>{const Q=this._registry.getExtensionDescription(ae);Q&&se.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(V.map(async ae=>{const Q=await this._realPathExtensionUri(ae.extensionLocation);se.set(Q,ae)})),this._registry.deltaExtensions(V,J),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let J=c.VSBuffer.alloc(V),se=Math.random()%256;for(let ae=0;ae<V;ae++)J.writeUInt8(se,ae);return J}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};G=Be([Fe(0,s.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,i.IExtHostRpcService),Fe(3,d.IExtHostWorkspace),Fe(4,v.IExtHostConfiguration),Fe(5,O.ILogService),Fe(6,t.IExtHostInitDataService),Fe(7,r.IExtensionStoragePaths),Fe(8,m.IExtHostTunnelService),Fe(9,h.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function U(Z,V){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class W{constructor(V,J,se,ae){$.set(this,void 0),M.set(this,void 0),q.set(this,void 0),Ke(this,$,V,"f"),Ke(this,M,J,"f"),Ke(this,q,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=n.normalize((0,T.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae}get isActive(){return ke(this,$,"f").isActivated(ke(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return ke(this,$,"f").getExtensionExports(ke(this,q,"f"))}activate(){return ke(this,$,"f").activateByIdWithErrors(ke(this,q,"f"),{startup:!1,extensionId:ke(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,$=new WeakMap,M=new WeakMap,q=new WeakMap;function ee(Z){const V=Z.indexOf("+");return V===-1?Z:Z.substring(0,V)}}),define(pe[54],ve([1,0,9,2,3,16,5,7,126,36,40,45,217,37,210,17,4,13,41,53]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let c=class{constructor(a,m,h,w,A,F){this._workspaceService=m,this._extensionService=h,this._editorsService=w,this._configurationService=A,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=a.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(D=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,m){const h=a;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let w=`debug:${encodeURIComponent(h.path||"")}`,A="?";return m&&(w+=`${A}session=${encodeURIComponent(m.id)}`,A="&"),w+=`${A}ref=${h.sourceReference}`,n.URI.parse(w)}else{if(h.path)return n.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const m=[];for(const h of a.getAllExtensionDescriptions())if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0)for(const A of w)(0,g.isDebuggerMainContribution)(A)&&m.push(A.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(m=>a.push(m)),a}addBreakpoints(a){this.startBreakpoints();const m=a.filter(A=>{const F=A.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,A),!0)});this.fireBreakpointChanges(m,[],[]);const h=[],w=new Map;for(const A of m)if(A instanceof k.SourceBreakpoint){let F=w.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},w.set(A.location.uri.toString(),F),h.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof k.FunctionBreakpoint&&h.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(a){this.startBreakpoints();const m=a.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],m,[]);const h=m.filter(F=>F instanceof k.SourceBreakpoint).map(F=>F.id),w=m.filter(F=>F instanceof k.FunctionBreakpoint).map(F=>F.id),A=m.filter(F=>F instanceof k.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(h,w,A)}startDebugging(a,m,h){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,m,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,m,h){if(!m)return new k.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:w,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,h,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,w),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(a,m,h){if(!h)return new k.Disposable(()=>{});if(!this.definesDebugType(a,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:w,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,w),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(a,m){if(!m)return new k.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:h,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==m)})}async $runInTerminal(a,m){return Promise.resolve(void 0)}async $substituteVariables(a,m){if(!this._variableResolver){const[A,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,F)}let h;const w=await this.getFolder(a);return w&&(h={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,m)}createDebugAdapter(a,m){if(a.type==="implementation")return new t(a.implementation)}createSignService(){}async $startDASession(a,m){const h=this,w=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const F=this.convertToDto(A),R=this.createDebugAdapter(F,w);if(!R)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const D=R;return this._debugAdapters.set(a,D),this.getDebugAdapterTrackers(w).then($=>($&&this._debugAdaptersTrackers.set(a,$),D.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const q=M,G={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(q.arguments.value);G.body={signature:U},D.sendResponse(G)}else throw new Error("no signer")}catch(U){G.success=!1,G.message=U.message,D.sendResponse(G)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(M),M=(0,g.convertToVSCPaths)(M,!0),h._debugServiceProxy.$acceptDAMessage(a,M)}),D.onError(M=>{$&&$.onError&&$.onError(M),this._debugServiceProxy.$acceptDAError(a,M.name,M.message,M.stack)}),D.onExit(M=>{$&&$.onExit&&$.onExit((0,P.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,P.withNullAsUndefined)(M),void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),D.startSession()))})}$sendDAMessage(a,m){m=(0,g.convertToDAPaths)(m,!1);const h=this._debugAdaptersTrackers.get(a);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(m);const w=this._debugAdapters.get(a);w&&w.sendMessage(m)}$stopDASession(a){const m=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),m&&m.onWillStopSession&&m.onWillStopSession();const h=this._debugAdapters.get(a);return this._debugAdapters.delete(a),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const m=[],h=[],w=[];if(a.added)for(const A of a.added){const F=A.id;if(F&&!this._breakpoints.has(F)){let R;if(A.type==="function")R=new k.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")R=new k.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const D=n.URI.revive(A.uri);R=new k.SourceBreakpoint(new k.Location(D,new k.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}R._id=F,this._breakpoints.set(F,R),m.push(R)}}if(a.removed)for(const A of a.removed){const F=this._breakpoints.get(A);F&&(this._breakpoints.delete(A),h.push(F))}if(a.changed){for(const A of a.changed)if(A.id){const F=this._breakpoints.get(A.id);if(F){if(F instanceof k.FunctionBreakpoint&&A.type==="function"){const R=F;R.enabled=A.enabled,R.condition=A.condition,R.hitCondition=A.hitCondition,R.logMessage=A.logMessage,R.functionName=A.functionName}else if(F instanceof k.SourceBreakpoint&&A.type==="source"){const R=F;R.enabled=A.enabled,R.condition=A.condition,R.hitCondition=A.hitCondition,R.logMessage=A.logMessage,R.location=new k.Location(n.URI.revive(A.uri),new k.Position(A.line,A.character))}w.push(F)}}}this.fireBreakpointChanges(m,h,w)}$provideDebugConfigurations(a,m,h){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(a);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(m);return w.provideDebugConfigurations(A,h)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(a,m,h,w){return(0,T.asPromise)(async()=>{const A=this.getConfigProviderByHandle(a);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(m);return A.resolveDebugConfiguration(F,h,w)})}$resolveDebugConfigurationWithSubstitutedVariables(a,m,h,w){return(0,T.asPromise)(async()=>{const A=this.getConfigProviderByHandle(a);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(m);return A.resolveDebugConfigurationWithSubstitutedVariables(F,h,w)})}async $provideDebugAdapter(a,m){const h=this.getAdapterDescriptorFactoryByHandle(a);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(m);return this.getAdapterDescriptor(h,w).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(a){const m=await this.getSession(a);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(a){const m=await this.getSession(a);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,m){const h=await this.getSession(a);h&&h._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(a,m){const w={session:await this.getSession(a),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(a){if(a instanceof k.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof k.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const m=this._adapterFactories.filter(h=>h.type===a);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(a){const m=this._adapterFactories.filter(h=>h.handle===a);if(m.length>0)return m[0].factory}getConfigProviderByHandle(a){const m=this._configProviders.filter(h=>h.handle===a);if(m.length>0)return m[0].provider}definesDebugType(a,m){if(a.contributes){const h=a.contributes.debuggers;if(h&&h.length>0){for(const w of h)if(w.label&&w.type&&w.type===m)return!0}}return!1}getDebugAdapterTrackers(a){const h=a.configuration.type,w=this._trackerFactories.filter(A=>A.type===h||A.type==="*").map(A=>(0,T.asPromise)(()=>A.factory.createDebugAdapterTracker(a)).then(F=>F,F=>null));return Promise.race([Promise.all(w).then(A=>{const F=A.filter(R=>!!R);if(F.length>0)return new s(F)}),new Promise((A,F)=>{const R=setTimeout(()=>{clearTimeout(R),F(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(a,m){const h=m.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new k.DebugAdapterServer(h));if(a){const A=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>a.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,A))).then(F=>{if(F)return F})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,w))}daExecutableFromPackage(a,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,m,h){(a.length>0||m.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:m,changed:h}))}async getSession(a){if(a)if(typeof a=="string"){const m=this._debugSessions.get(a);if(m)return m}else{let m=this._debugSessions.get(a.id);if(!m){const h=await this.getFolder(a.folderUri),w=a.parent?this._debugSessions.get(a.parent):void 0;m=new u(this._debugServiceProxy,a.id,a.type,a.name,h,a.configuration,w),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(a){if(a){const m=n.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};c=Be([Fe(0,d.IExtHostRpcService),Fe(1,L.IExtHostWorkspace),Fe(2,O.IExtHostExtensionService),Fe(3,y.IExtHostDocumentsAndEditors),Fe(4,b.IExtHostConfiguration),Fe(5,o.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class u{constructor(a,m,h,w,A,F,R){this._debugServiceProxy=a,this._id=m,this._type=h,this._name=w,this._workspaceFolder=A,this._configuration=F,this._parentSession=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,m)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=u;class l{constructor(a){this.value=Object.freeze({append(m){a.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=l;class E extends v.AbstractVariableResolverService{constructor(a,m,h,w,A,F){function R(){if(m){const D=m.activeEditor();if(D)return D.document.uri;const $=w.tabGroups.all.find(M=>M.isActive)?.activeTab;if($!==void 0){const M=$.resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:$.resource}}}super({getFolderUri:D=>{const $=a.filter(M=>M.name===D);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(D,$)=>h.getConfiguration(void 0,D).get($),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const D=R();if(D)return f.normalize(D.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const D=R();if(D){const $=A.getWorkspaceFolder(D);if($)return f.normalize($.uri.fsPath)}}},getSelectedText:()=>{if(m){const D=m.activeEditor();if(D&&!D.selection.isEmpty)return D.document.getText(D.selection)}},getLineNumber:()=>{if(m){const D=m.activeEditor();if(D)return String(D.selection.end.line+1)}}},void 0,F?Promise.resolve(F):void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=E;class s{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(m=>m.onError?m.onError(a):void 0)}onExit(a,m){this.trackers.forEach(h=>h.onExit?h.onExit(a,m):void 0)}}class t extends S.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(a,m,h,w,A,F){super(a,m,h,w,A,F)}createVariableResolver(a,m,h){return new E(a,m,h,this._editorTabs)}};r=Be([Fe(0,d.IExtHostRpcService),Fe(1,L.IExtHostWorkspace),Fe(2,O.IExtHostExtensionService),Fe(3,y.IExtHostDocumentsAndEditors),Fe(4,b.IExtHostConfiguration),Fe(5,o.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(pe[270],ve([1,0,70,2,5,37,30,27,17,26,4,40,41,11,8]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(u,l,E,s,t,r,i){this._apiFactory=u,this._extensionRegistry=l,this._instaService=E,this._extHostConfiguration=s,this._extHostExtensionService=t,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new P(this._apiFactory,l,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(_,l)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(o,l,this._initData.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(let l of u.nodeModuleName)this._factories.set(l,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(l=>u.alternativeModuleName(l))}};d=Be([Fe(2,O.IInstantiationService),Fe(3,T.IExtHostConfiguration),Fe(4,y.IExtHostExtensionService),Fe(5,L.IExtHostInitDataService),Fe(6,b.ILogService)],d),e.RequireInterceptor=d;let p=class $i{constructor(u){if(u.environment.appRoot&&$i.aliased.size){const l=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(u.environment.appRoot.fsPath)),E="[a-z0-9_.-]",s=`@${E}+\\/${E}+|${E}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${l}/${t}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(u){if(!this.re)return;const l=this.re.exec(this.forceForwardSlashes(u));if(!l)return;const[,E,s,t]=l,r=$i.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),E+r+t}forceForwardSlashes(u){return u.replace(/\\/g,"/")}};p.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),p=Be([Fe(0,L.IExtHostInitDataService)],p);class P{constructor(u,l,E,s,t){this._apiFactory=u,this._extensionPaths=l,this._extensionRegistry=E,this._configProvider=s,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,l){const E=this._extensionPaths.findSubstr(l);if(E){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(E.identifier));return s||(s=this._apiFactory(E,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(E.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((t,r)=>s+=`	${r} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(u,l,E){this._extensionPaths=u,this.nodeModuleName="keytar",this._mainThreadTelemetry=l.getProxy(I.MainContext.MainThreadTelemetry);const{environment:s}=E,t=l.getProxy(I.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>t.$getPassword(r,i),setPassword:(r,i,a)=>t.$setPassword(r,i,a),deletePassword:(r,i)=>t.$deletePassword(r,i),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(u,l){const E=this._extensionPaths.findSubstr(l);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:E?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(u){const l=u.length;if(l<=7||!this.alternativeNames)return;const E=l-7;if((u.charAt(E)==="/"||u.charAt(E)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};_=Be([Fe(1,S.IExtHostRpcService),Fe(2,L.IExtHostInitDataService)],_);let o=class{constructor(u,l,E){this._extensionPaths=u,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=E.getProxy(I.MainContext.MainThreadTelemetry);const s=E.getProxy(I.MainContext.MainThreadWindow);this._impl=(t,r)=>{const i=n.URI.parse(t);return r?this.callOriginal(t,r):i.scheme==="http"||i.scheme==="https"?s.$openUri(i,t,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?s.$openUri(i,t,{}):this.callOriginal(t,r)}}load(u,l,E){const s=this._extensionPaths.findSubstr(l);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=E(u),this._impl}callOriginal(u,l){return this.sendNoForwardTelemetry(),this._original(u,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};o=Be([Fe(2,S.IExtHostRpcService)],o)}),define(pe[271],ve([1,0,16,15,70,6,2,5,264,11,79,80,26,188,17,63,40,33]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,u,l,E,s){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new S.RPCProtocol(c,null,E),u=_._transform(u,this._rpcProtocol);const t=new y.ServiceCollection(...(0,O.getSingletonServiceDescriptors)());t.set(v.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:s}),t.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),t.set(d.IURITransformerService,new d.URITransformerService(E)),t.set(p.IHostUtils,l);const r=new b.InstantiationService(t,!0);this._disposables.add(r.invokeFunction(h=>h.get(P.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(h=>h.get(p.IExtHostExtensionService))),this._logService=r.invokeFunction(h=>h.get(L.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=r.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(w,A)=>{let F="",R,D;for(const $ of A)F+=`
	at ${$.toString()}`,D=$.getFileName(),!R&&D&&(R=h.findSubstr(C.URI.file(D)));return i.set(w,R),`${w.name||"Error"}: ${w.message||""}${F}`}});const a=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(h=>{const w=n.transformErrorForSerialization(h),A=i.get(h);A?a.$onExtensionRuntimeError(A.identifier,w):m.$onUnexpectedError(w)})}async asBrowserUri(c){const u=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService);return C.URI.revive(await u.$asBrowserUri(c))}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),n.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const u=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),u]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(c,u){c.extensions.forEach(E=>E.extensionLocation=C.URI.revive(u.transformIncomingURIs(E.extensionLocation))),c.environment.appRoot=C.URI.revive(u.transformIncomingURIs(c.environment.appRoot));const l=c.environment.extensionDevelopmentLocationURI;return l&&(c.environment.extensionDevelopmentLocationURI=l.map(E=>C.URI.revive(u.transformIncomingURIs(E)))),c.environment.extensionTestsLocationURI=C.URI.revive(u.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=C.URI.revive(u.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=C.URI.revive(u.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=C.URI.revive(u.transformIncomingURIs(c.logsLocation)),c.logFile=C.URI.revive(u.transformIncomingURIs(c.logFile)),c.workspace=u.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(pe[272],ve([1,0,173,60,12,7,211,36,40,45,37,33,17,54,195,16,212,53,187]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let o=class extends b.ExtHostDebugServiceBase{constructor(s,t,r,i,a,m,h){super(s,t,r,i,a,h);this._terminalService=m,this._integratedTerminalInstances=new l}createDebugAdapter(s,t){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,t.type)}return super.createDebugAdapter(s,t)}daExecutableFromPackage(s,t){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(t.getAllExtensionDescriptions(),s.type);if(r)return new T.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new g.SignService}async $runInTerminal(s,t){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const r=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),a=this._terminalService.getDefaultShellArgs(!0),m=s.title||f.localize(0,null),h=JSON.stringify({shell:i,shellArgs:a});let w=await this._integratedTerminalInstances.checkout(h,m),A,F=!1;if(w)A=s.cwd;else{const M={shellPath:i,shellArgs:a,cwd:s.cwd,name:m,iconPath:new T.ThemeIcon("debug")};F=!0,w=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(w,h)}w.show(!0);const R=await w.processId;F?await new Promise(M=>setTimeout(M,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?w.sendText("cls"):i.indexOf("bash")>=0?w.sendText("clear"):I.isWindows?w.sendText("cls"):w.sendText("clear"));const D=(0,p.prepareCommand)(i,s.args,A,s.env);w.sendText(D);const $=this.onDidTerminateDebugSession(M=>{M.id===t&&(this._integratedTerminalInstances.free(w),$.dispose())});return R}else if(s.kind==="external")return u(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,t)}createVariableResolver(s,t,r){return new b.ExtHostVariableResolverService(s,t,r,this._editorTabs,this._workspaceService,(0,n.homedir)())}};o=Be([Fe(0,v.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,S.IExtHostExtensionService),Fe(3,L.IExtHostDocumentsAndEditors),Fe(4,O.IExtHostConfiguration),Fe(5,y.IExtHostTerminalService),Fe(6,P.IExtHostEditorTabs)],o),e.ExtHostDebugService=o;let c;function u(E,s){if(!c)if(I.isWindows)c=new _.WindowsExternalTerminalService;else if(I.isMacintosh)c=new _.MacExternalTerminalService;else if(I.isLinux)c=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const t=s.getConfiguration("terminal");return c.runInTerminal(E.title,E.cwd,E.args,E.env||{},t.external||{})}e.runInExternalTerminal=u;class l{constructor(){this._terminalInstances=new Map}async checkout(s,t){const i=[...this._terminalInstances.entries()].map(([a,m])=>(0,d.createCancelablePromise)(async h=>{if(a.name!==t||m.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await a.processId))return null;const w=Date.now();return m.lastUsedAt+l.minUseDelay>w||h.isCancellationRequested||m.config!==s?null:(m.lastUsedAt=w,a)}));return await(0,d.firstParallel)(i,a=>!!a)}insert(s,t){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:t})}free(s){const t=this._terminalInstances.get(s);t&&(t.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}l.minUseDelay=1e3}),define(pe[273],ve([1,0,9,2,112,36,54,45,37,43,33,17,26,69,10,11,64,53,23,60]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends b.ExtHostTaskBase{constructor(l,E,s,t,r,i,a,m,h){super(l,E,s,t,r,i,a,m);this.workspaceService=s,this.editorTabs=h,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(l,E){const s=E;if(!E.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const t=b.TaskHandleDTO.from(s,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(r,E);return this._proxy.$executeTask(t).catch(()=>{}),i}else{const t=b.TaskDTO.from(E,l);if(t===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,E,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),E);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(l,E,s,t){const r=[];if(t)for(let i of t){this.checkDeprecation(i,s),(!i.definition||!l[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const a=b.TaskDTO.from(i,s.extension);a&&(r.push(a),b.CustomExecutionDTO.is(a.execution)&&E.push(this.addCustomExecution(a,i,!0)))}return{tasks:r,extension:s.extension}}async resolveTaskInternal(l){return l}async getVariableResolver(l){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(l,this._editorService,E,this.editorTabs,this.workspaceService,(0,o.homedir)())}return this._variableResolver}async getAFolder(l){let E=l&&l.length>0?l[0]:void 0;if(!E){const s=n.URI.file((0,o.homedir)());E=new L.WorkspaceFolder({uri:s,name:_.basename(s),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(l,E){const s=n.URI.revive(l),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(s),i=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.getVariableResolver(i),m=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(i);for(let h of E.variables)t.variables[h]=await a.resolveAsync(m,h);if(E.process!==void 0){let h;if(E.process.path!==void 0){h=E.process.path.split(f.delimiter);for(let w=0;w<h.length;w++)h[w]=await a.resolveAsync(m,h[w])}t.process=await I.win32.findExecutable(await a.resolveAsync(m,E.process.name),E.process.cwd!==void 0?await a.resolveAsync(m,E.process.cwd):void 0,h)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(l,E,s){return I.win32.findExecutable(l,E,s)}};c=Be([Fe(0,y.IExtHostRpcService),Fe(1,v.IExtHostInitDataService),Fe(2,T.IExtHostWorkspace),Fe(3,k.IExtHostDocumentsAndEditors),Fe(4,S.IExtHostConfiguration),Fe(5,O.IExtHostTerminalService),Fe(6,d.ILogService),Fe(7,p.IExtHostApiDeprecationService),Fe(8,P.IExtHostEditorTabs)],c),e.ExtHostTask=c}),define(pe[137],ve([1,0,18,16,21,49,10,9,23,13,2,31]),function(te,e,f,n,I,T,C,k,S,L,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class v{constructor(o,c,u,l){this.query=o,this.provider=c,this.fileUtils=u,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,c){const u=this.query.folderQueries||[],l=new I.CancellationTokenSource;return c.onCancellationRequested(()=>l.cancel()),new Promise((E,s)=>{this.collector=new g(o);let t=!1;const r=(i,a)=>{if(!t&&!this.isLimitHit){const m=this.resultSize(i);p(i)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,t=!0,l.cancel(),i=this.trimResultToSize(i,this.query.maxResults-this.resultCount));const h=this.resultSize(i);this.resultCount+=h,(h>0||!p(i))&&this.collector.add(i,a)}};Promise.all(u.map((i,a)=>this.searchInFolder(i,m=>r(m,a),l.token))).then(i=>{l.dispose(),this.collector.flush();const a=i.some(m=>!!m&&!!m.limitHit);E({limitHit:this.isLimitHit||a,messages:(0,f.flatten)(i.map(m=>m?.message?(0,L.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},i=>{l.dispose();const a=(0,T.toErrorMessage)(i);s(new Error(a))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,c){const u=Array.isArray(o.ranges)?o.ranges:[o.ranges],l=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:u.slice(0,c),preview:{matches:l.slice(0,c),text:o.preview.text},uri:o.uri}}async searchInFolder(o,c,u){const l=new y.QueryGlobTester(this.query,o),E=[],s={report:i=>{if(!this.validateProviderResult(i))return;const a=o.folder.scheme===C.Schemas.file?(0,y.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(i.uri))):void 0,m=S.relativePath(o.folder,i.uri);if(m){const h=l.includedInQuery(m,k.basename(m),a);(0,n.isThenable)(h)?E.push(h.then(w=>{w&&c(i)})):h&&c(i)}}},t=this.getSearchOptionsForFolder(o),r=await this.provider.provideTextSearchResults(b(this.query.contentPattern),t,s,u);return E.length&&await Promise.all(E),r}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const c=(0,y.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),u=(0,y.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),l={folder:O.URI.from(o.folder),excludes:u,includes:c,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=v;function b(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class g{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,c=>this.sendItems(c))}add(o,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!S.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(d(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=g;function d(_){return p(_)?{preview:{matches:(0,f.mapArrayOrNot)(_.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:_.preview.text},ranges:(0,f.mapArrayOrNot)(_.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function p(_){return!!_.preview}e.extensionResultIsMatch=p;class P{constructor(o,c){this.maxBatchSize=o,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,c){!o||this.addItemToBatch(o,c)}addItems(o,c){!o||this.addItemsToBatch(o,c)}addItemToBatch(o,c){this.batch.push(o),this.batchSize+=c,this.onUpdate()}addItemsToBatch(o,c){this.batch=this.batch.concat(o),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(pe[71],ve([1,0,6,5,4,267,17,63,11,2,137]),function(te,e,f,n,I,T,C,k,S,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let y=class{constructor(d,p,P){this.extHostRpc=d,this._uriTransformer=p,this._logService=P,this._proxy=this.extHostRpc.getProxy(n.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,p){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const P=this._handlePool++;return this._textSearchProvider.set(P,p),this._proxy.$registerTextSearchProvider(P,this._transformScheme(d)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(d,p){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const P=this._handlePool++;return this._fileSearchProvider.set(P,p),this._proxy.$registerFileSearchProvider(P,this._transformScheme(d)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(d,p,P,_){const o=v(P),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(o,c,u=>{this._proxy.$handleFileMatch(d,p,u.map(l=>l.resource))},_);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,p,P,_){const o=this._textSearchProvider.get(d);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=v(P);return this.createTextSearchManager(c,o).search(l=>this._proxy.$handleTextMatch(d,p,l),_)}$enableExtensionHostSearch(){}createTextSearchManager(d,p){return new O.TextSearchManager(d,p,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};y=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.IURITransformerService),Fe(2,S.ILogService)],y),e.ExtHostSearch=y;function v(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>L.URI.revive(d))}}e.reviveQuery=v;function b(g){return{...g,folder:L.URI.revive(g.folder)}}}),define(pe[274],ve([1,0,79,135,36,133,37,39,45,33,69,54,71,87,51,64,136,65,44,86,124,53,134,11,226]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c,u,l,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(E.ILoggerService,l.ExtHostLoggerService),(0,f.registerSingleton)(E.ILogService,s.ExtHostLogService),(0,f.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,f.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,f.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,f.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,f.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,f.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,f.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,f.registerSingleton)(n.IExtHostOutputService,n.ExtHostOutputService),(0,f.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,f.registerSingleton)(L.IExtHostTerminalService,L.WorkerExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,f.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,f.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,f.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs)}),define(pe[88],ve([1,0,18,11,31,68]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=C;function k(y,v,b,g){const d=(0,f.mapArrayOrNot)(b,S),p=new I.TextSearchMatch(v,d,g),P=p.preview.matches;return{ranges:(0,f.mapArrayOrNot)(d,L),uri:y,preview:{text:p.preview.text,matches:(0,f.mapArrayOrNot)(P,L)}}}e.createTextSearchResult=k;function S(y){return new I.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function L(y){return new T.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let O=class{constructor(v,b){this.prefix=v,this.logService=b}appendLine(v){this.logService.debug(`${this.prefix}#search`,v)}};O=Be([Fe(1,n.ILogService)],O),e.OutputChannel=O}),define(pe[275],ve([1,0,38,9,77,29,12,8,88,276]),function(te,e,f,n,I,T,C,k,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const O=L.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(o,c,u,l){const E=v(o,c,u,l),s=c.folder.fsPath;return{cmd:f.spawn(O,E.args,{cwd:s}),rgDiskPath:O,siblingClauses:E.siblingClauses,rgArgs:E,cwd:s}}e.spawnRipgrepCmd=y;function v(o,c,u,l){const E=["--files","--hidden","--case-sensitive"];g([c],u,!1).forEach(t=>{const r=(0,S.anchorGlob)(t);if(E.push("-g",r),C.isMacintosh){const i=(0,I.normalizeNFD)(r);i!==r&&E.push("-g",i)}});const s=b([c],l,void 0,!1);return s.globArgs.forEach(t=>{const r=`!${(0,S.anchorGlob)(t)}`;if(E.push("-g",r),C.isMacintosh){const i=(0,I.normalizeNFD)(r);i!==r&&E.push("-g",i)}}),c.disregardIgnoreFiles!==!1?E.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&E.push("--no-ignore-parent"),c.ignoreSymlinks||E.push("--follow"),o.exists&&E.push("--quiet"),E.push("--no-config"),c.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:s.siblingClauses}}function b(o,c,u,l=!0){const E=[];let s={};return o.forEach(t=>{const r=Object.assign({},t.excludePattern||{},c||{}),i=d(r,l?t.folder.fsPath:void 0,u);E.push(...i.globArgs),i.siblingClauses&&(s=Object.assign(s,i.siblingClauses))}),{globArgs:E,siblingClauses:s}}e.foldersToRgExcludeGlobs=b;function g(o,c,u=!0){const l=[];return o.forEach(E=>{const s=Object.assign({},c||{},E.includePattern||{}),t=d(s,u?E.folder.fsPath:void 0);l.push(...t.globArgs)}),l}e.foldersToIncludeGlobs=g;function d(o,c,u){const l=[],E={};return Object.keys(o).forEach(s=>{if(u&&u.has(s)||!s)return;const t=o[s];s=P(c?p(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof t=="boolean"&&t?(s.startsWith("\\\\")&&(s+="**"),l.push(_(s))):t&&t.when&&(E[s]=t)}),{globArgs:l,siblingClauses:E}}function p(o,c){return n.isAbsolute(c)?c:n.join(o,c)}e.getAbsoluteGlob=p;function P(o){return o=k.rtrim(o,"\\"),k.rtrim(o,"/")}function _(o){return T.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=_}),define(pe[277],ve([1,0,38,59,9,102,18,49,34,77,29,12,46,8,13,28,31,275,98]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(s=>s())});class c{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(r=>{const i=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),a=r.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==a).forEach(m=>{(0,O.isEqualOrParent)(m,a)&&(i[I.relative(a,m)]=!0)}),this.folderExcludePatterns.set(a,new l(i,a))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,r,i,a,m){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);r.forEach(h=>{const w=I.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,w)||this.matchFile(i,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(t,(h,w)=>{this.call(this.cmdTraversal,this,h,i,a,A=>{if(A){const F=(0,k.toErrorMessage)(A);console.error(F),this.errors.push(F),w(A,void 0)}else w(null,void 0)})},(h,w)=>{this.fileWalkSW.stop();const A=h?C.coalesce(h)[0]:null;m(A,this.isLimitHit)})}parallel(t,r,i){const a=new Array(t.length),m=new Array(t.length);let h=!1,w=0;if(t.length===0)return i(null,[]);t.forEach((A,F)=>{r(A,(R,D)=>{if(R?(h=!0,a[F]=null,m[F]=R):(a[F]=D,m[F]=null),++w===t.length)return i(h?m:null,a)})})}call(t,r,...i){try{t.apply(r,i)}catch(a){i[i.length-1](a)}}cmdTraversal(t,r,i,a){const m=t.folder.fsPath,h=y.isMacintosh;let w;const A=()=>w&&w.kill();o.add(A);let F=U=>{o.delete(A),F=()=>{},a(U)},R="";const D=this.initDirectoryTree();let $;const M=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);w=M.cmd,$=!Object.keys(M.siblingClauses).length;const q=M.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let G=`${M.rgDiskPath} ${q}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(G+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),i({message:G}),this.cmdResultCount=0,this.collectStdout(w,"utf8",i,(U,W,ee)=>{if(U){F(U);return}if(this.isLimitHit){F();return}const V=(R+(h?L.normalizeNFC(W||""):W)).split(`
`);if(ee){const J=V.length;V[J-1]=V[J-1].trim(),V[J-1]||V.pop()}else R=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,$){for(const J of V)if(this.matchFile(r,{base:m,relativePath:J,searchPath:this.getSearchPath(t,J)}),this.isLimitHit){A();break}(ee||this.isLimitHit)&&F();return}this.addDirectoryEntries(t,D,m,V,r),ee&&(this.matchDirectoryTree(D,m,r),F())})}spawnFindCmd(t){const r=this.folderExcludePatterns.get(t.folder.fsPath),i=r.getBasenameTerms(),a=r.getPathTerms(),m=["-L","."];if(i.length||a.length){m.push("-not","(","(");for(const h of i)m.push("-name",h),m.push("-o");for(const h of a)m.push("-path",h),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),f.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,r,i){let a="";this.collectStdout(t,r,()=>{},(m,h,w)=>{if(m){i(m);return}a+=h,w&&i(null,a)})}collectStdout(t,r,i,a){let m=(A,F,R)=>{(A||R)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),a(A,F,R)},h=!1;t.stdout?(this.forwardData(t.stdout,r,m),t.stdout.once("data",()=>h=!0)):i({message:"stdout is null"});let w;t.stderr?w=this.collectData(t.stderr):i({message:"stderr is null"}),t.on("error",A=>{m(A)}),t.on("close",A=>{let F;!h&&(F=this.decodeData(w,r))&&E(F)?m(new Error(`command failed with error code ${A}: ${this.decodeData(w,r)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,r,i){const a=new T.StringDecoder(r);return t.on("data",m=>{i(null,a.write(m))}),a}collectData(t){const r=[];return t.on("data",i=>{r.push(i)}),r}decodeData(t,r){const i=new T.StringDecoder(r);return t.map(a=>i.write(a)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:r},i,a,m){a.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:i,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const h=w=>{const A=I.basename(w),F=I.dirname(w);let R=r[F];R||(R=r[F]=[],h(F)),R.push({base:i,relativePath:w,basename:A,searchPath:this.getSearchPath(t,w)})};a.forEach(h)}matchDirectoryTree({rootEntries:t,pathToEntries:r},i,a){const m=this,h=this.folderExcludePatterns.get(i),w=this.filePattern;function A(F){m.directoriesWalked++;const R=(0,p.hasSiblingFn)(()=>F.map(D=>D.basename));for(let D=0,$=F.length;D<$;D++){const M=F[D],{relativePath:q,basename:G}=M;if(h.test(q,G,w!==G?R:void 0))continue;const U=r[q];if(U)A(U);else{if(m.filesWalked++,q===w)continue;m.matchFile(a,M)}if(m.isLimitHit)break}}A(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,r,i,a,m){const h=t.folder,w=(0,p.hasSiblingFn)(()=>i);this.parallel(i,(A,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const R=r?[r,A].join(I.sep):A;if(this.folderExcludePatterns.get(t.folder.fsPath).test(R,A,this.config.filePattern!==A?w:void 0))return F(null);const D=[h.fsPath,R].join(I.sep);n.lstat(D,($,M)=>{if($||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(D,M,(q,G)=>q||this.isCanceled||this.isLimitHit?F(null):G.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(D,M,(U,W)=>U||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?F(null):(this.walkedPaths[W]=!0,d.Promises.readdir(D).then(ee=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(t,R,ee,a,Z=>F(Z||null))},ee=>{F(null)})))):(this.filesWalked++,R===this.filePattern||this.maxFilesize&&g.isNumber(G.size)&&G.size>this.maxFilesize||this.matchFile(a,{base:h.fsPath,relativePath:R,searchPath:this.getSearchPath(t,R)}),F(null,void 0)))})},A=>{const F=A&&C.coalesce(A);return m(F&&F.length>0?F[0]:void 0)})}matchFile(t,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,I.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(r))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,p.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,r,i){return r.isSymbolicLink()?n.stat(t,i):i(null,r)}realPathIfNeeded(t,r,i){return r.isSymbolicLink()?n.realpath(t,(a,m)=>a?i(a):i(null,m)):i(null,t)}getSearchPath(t,r){return t.folderName?I.join(t.folderName,r):r}}e.FileWalker=c;class u{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new c(t)}search(t,r,i){this.walker.walk(this.folderQueries,this.extraFiles,t,r,(a,m)=>{i(a,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class l{constructor(t,r){this.expression=t,this.root=r,this.init(t)}init(t){let r,i;Object.keys(t).filter(a=>t[a]).forEach(a=>{I.isAbsolute(a)?(r=r||S.getEmptyExpression(),r[a]=t[a]):(i=i||S.getEmptyExpression(),i[a]=t[a])}),this.absoluteParsedExpr=r&&S.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=i&&S.parse(i,{trimForExclusions:!0})}test(t,r,i){return this.relativeParsedExpr&&this.relativeParsedExpr(t,r,i)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,t),r,i)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function E(s){const t=s.trim().split(`
`),r=t[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return b.uppercaseFirstLetter(t[t.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=E}),define(pe[278],ve([1,0,94,22]),function(te,e,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===s)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,C=512,k=512*8,S=512*128;var L;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(L=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class O extends Error{constructor(t,r){super(t);this.decodeStreamErrorKind=r}}e.DecodeStreamError=O;class y{constructor(t){this.iconvLiteDecoder=t}static async create(t){let r;if(t!==e.UTF8)r=(await new Promise((a,m)=>{te(["@vscode/iconv-lite-umd"],a,m)})).getDecoder(d(t));else{const i=new TextDecoder;r={write(a){return i.decode(a,{stream:!0})},end(){return i.decode()}}}return new y(r)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function v(s,t){const r=t.minBytesRequiredForDetection??t.guessEncoding?k:C;return new Promise((i,a)=>{const m=(0,f.newWriteableStream)(D=>D.join("")),h=[];let w=0,A,F;const R=async()=>{try{const D=await E({buffer:n.VSBuffer.concat(h),bytesRead:w},t.guessEncoding);if(D.seemsBinary&&t.acceptTextOnly)throw new O("Stream is binary but only text is accepted for decoding",1);D.encoding=await t.overwriteEncoding(D.encoding),A=await y.create(D.encoding);const $=A.write(n.VSBuffer.concat(h).buffer);m.write($),h.length=0,w=0,i({stream:m,detected:D})}catch(D){F?.dispose(),m.destroy(),a(D)}};F=(0,f.listenStream)(s,{onData:async D=>{A?m.write(A.write(D.buffer)):(h.push(D),w+=D.byteLength,w>=r&&(s.pause(),await R(),setTimeout(()=>s.resume())))},onError:D=>m.error(D),onEnd:async()=>{A||await R(),m.end(A?.end())}})})}e.toDecodeStream=v;async function b(s,t,r){const a=(await new Promise((w,A)=>{te(["@vscode/iconv-lite-umd"],w,A)})).getEncoder(d(t),r);let m=!1,h=!1;return{read(){if(h)return null;const w=s.read();if(typeof w!="string"){if(h=!0,!m&&r?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return n.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const A=a.end();return A&&A.length>0?(m=!0,n.VSBuffer.wrap(A)):null}return m=!0,n.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=b;async function g(s){return(await new Promise((r,i)=>{te(["@vscode/iconv-lite-umd"],r,i)})).encodingExists(d(s))}e.encodingExists=g;function d(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=d;function p(s,t){if(!s||t<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),i=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const a=s.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=p;const P=["ascii","utf-16","utf-32"];async function _(s){const t=await new Promise((h,w)=>{te(["jschardet"],h,w)}),r=s.slice(0,S),i=u(r.buffer),a=t.detect(i);if(!a||!a.encoding)return null;const m=a.encoding.toLowerCase();return 0<=P.indexOf(m)?null:c(a.encoding)}const o={ibm866:"cp866",big5:"cp950"};function c(s){const t=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[t]||t}function u(s){let t="";for(let r=0;r<s.length;r++)t+=String.fromCharCode(s[r]);return t}function l(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=s.match(/windows(\d+)/);return t?"windows-"+t[1]:s}}}e.toCanonicalName=l;function E({buffer:s,bytesRead:t},r){let i=p(s,t),a=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&s){let m=!0,h=!0,w=!1;for(let A=0;A<t&&A<T;A++){const F=A%2==1,R=s.readUInt8(A)===0;if(R&&(w=!0),m&&(F&&!R||!F&&R)&&(m=!1),h&&(F&&R||!F&&!R)&&(h=!1),R&&!m&&!h)break}w&&(m?i=e.UTF16le:h?i=e.UTF16be:a=!0)}return r&&!a&&!i&&s?_(s.slice(0,t)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:a,encoding:i}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[138],ve([1,0,278,28,137]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends I.TextSearchManager{constructor(k,S,L=n,O="searchProcess"){super(k,S,{readdir:y=>L.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,f.toCanonicalName)(y)},O)}}e.NativeTextSearchManager=T}),define(pe[279],ve([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class f{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const T=this._dragOperations.get(I);return this._dragOperations.delete(I),T}}addDragOperationTransfer(I,T){this._dragOperations.set(I,T)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,T){this._renderedElements.set(I,T)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=f}),define(pe[280],ve([1,0,171,23,2,3,6,16,7,13,18,14,21,205,279]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(_,o){if((0,L.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let c;return Array.isArray(_.highlights)&&(c=_.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),c=c.length?c:void 0),{label:_.label,highlights:c}}}class p{constructor(o,c,u){this._proxy=o,this.commands=c,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function l(E){return E&&E.$treeViewId&&E.$treeItemHandle}c.registerArgumentProcessor({processArgument:E=>l(E)?this.convertArgument(E):Array.isArray(E)&&E.length>0?E.map(s=>l(s)?this.convertArgument(s):s):E})}registerTreeDataProvider(o,c,u){const l=this.createTreeView(o,{treeDataProvider:c},u);return{dispose:()=>l.dispose()}}createTreeView(o,c,u){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=c.dragAndDropController?.dropMimeTypes??[],E=c.dragAndDropController?.dragMimeTypes??[],s=!!c.dragAndDropController?.handleDrag,t=!!c.dragAndDropController?.handleDrop,r=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:l,dragMimeTypes:E,hasHandleDrag:s,hasHandleDrop:t}),i=this.createExtHostTreeView(o,c,u);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(a){i.message=a},get title(){return i.title},set title(a){i.title=a},get description(){return i.description},set description(a){i.description=a},reveal:(a,m)=>i.reveal(a,m),dispose:async()=>{await r,this.treeViews.delete(o),i.dispose()}}}$getChildren(o,c){const u=this.treeViews.get(o);return u?u.getChildren(c):Promise.reject(new Error((0,f.localize)(0,null,o)))}async $handleDrop(o,c,u,l,E,s,t){const r=this.treeViews.get(o);if(!r)return Promise.reject(new Error((0,f.localize)(1,null,o)));const i=b.TreeDataTransferConverter.toITreeDataTransfer(c);return s===o&&t&&await this.addAdditionalTransferItems(i,r,t,l,E),r.onDrop(i,u,l)}async addAdditionalTransferItems(o,c,u,l,E){const s=this.treeDragAndDropService.removeDragOperationTransfer(E);if(s)(await s)?.forEach((t,r)=>{t&&o.set(r,t)});else if(E&&c.handleDrag){const t=c.handleDrag(u,o,l);this.treeDragAndDropService.addDragOperationTransfer(E,t),await t}return o}async $handleDrag(o,c,u,l){const E=this.treeViews.get(o);if(!E)return Promise.reject(new Error((0,f.localize)(2,null,o)));const s=await this.addAdditionalTransferItems(new Map,E,c,l,u);if(!!s)return b.TreeDataTransferConverter.toTreeDataTransferDTO(s)}async $hasResolve(o){const c=this.treeViews.get(o);if(!c)throw new Error((0,f.localize)(3,null,o));return c.hasResolve}$resolve(o,c,u){const l=this.treeViews.get(o);if(!l)throw new Error((0,f.localize)(4,null,o));return l.resolveTreeItem(c,u)}$setExpanded(o,c,u){const l=this.treeViews.get(o);if(!l)throw new Error((0,f.localize)(5,null,o));l.setExpanded(c,u)}$setSelection(o,c){const u=this.treeViews.get(o);if(!u)throw new Error((0,f.localize)(6,null,o));u.setSelection(c)}$setVisible(o,c){const u=this.treeViews.get(o);if(!u)throw new Error((0,f.localize)(7,null,o));u.setVisible(c)}createExtHostTreeView(o,c,u){const l=new P(o,c,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(o,l),l}convertArgument(o){const c=this.treeViews.get(o.$treeViewId);return c?c.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class P extends C.Disposable{constructor(o,c,u,l,E,s){super();if(this.viewId=o,this.proxy=u,this.commands=l,this.logService=E,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,s.contributes&&s.contributes.views)for(const i in s.contributes.views)for(const a of s.contributes.views[i])a.id===o&&(this._title=a.name);this.dataProvider=c.treeDataProvider,this.dndController=c.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let t,r;this._register(T.Event.debounce(this._onDidChangeData.event,(i,a)=>(i||(i={message:!1,elements:[]}),a.element!==!1&&(t||(t=new Promise(m=>r=m),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(a.element)?i.elements.push(...a.element):i.elements.push(a.element)),a.message&&(i.message=!0),i),200,!0)(({message:i,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=r;return t=null,this.refresh(a).then(()=>m())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,L.isUndefinedOrNull)(o))}async getChildren(o){const c=o?this.getExtensionElement(o):void 0;if(o&&!c)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(o);return u||(u=await this.fetchChildrenNodes(c)),u?u.map(l=>l.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,c){c=c||{select:!0,focus:!1};const u=(0,L.isUndefinedOrNull)(c.select)?!0:c.select,l=(0,L.isUndefinedOrNull)(c.focus)?!1:c.focus,E=(0,L.isUndefinedOrNull)(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:s.map(r=>r.item)},{select:u,focus:l,expand:E})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:l,expand:E})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,c){const u=this.getExtensionElement(o);u&&(c?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(o){(0,O.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(o,c,u){const l=[];for(const E of o){const s=this.getExtensionElement(E);s&&l.push(s)}if(!(!this.dndController?.handleDrag||l.length===0))return await this.dndController.handleDrag(l,c,u),c}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(o,c,u){const l=this.getExtensionElement(c);if(!(!l||!this.dndController?.handleDrop))return(0,k.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(l,o,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,c){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(o);if(u){const l=this.nodes.get(u);if(l){const E=await this.dataProvider.resolveTreeItem(l.extensionItem,u,c)??l.extensionItem;return l.item.tooltip=this.getTooltip(E.tooltip),l.item.command=this.getCommand(l.disposableStore,E.command),l.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(c=>c?this.resolveUnknownParentChain(c).then(u=>this.resolveTreeNode(c,u[u.length-1]).then(l=>(u.push(l),u))):Promise.resolve([]))}resolveParent(o){const c=this.nodes.get(o);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,c){const u=this.nodes.get(o);return u?Promise.resolve(u):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(l=>this.createHandle(o,l,c,!0)).then(l=>this.getChildren(c?c.item.handle:void 0).then(()=>{const E=this.getExtensionElement(l);if(E){const s=this.nodes.get(E);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(o){if(o){let c;if(typeof o=="string"){const u=this.getExtensionElement(o);c=u?this.nodes.get(u):void 0}else c=o;return c&&c.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const c=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=o?this.nodes.get(o):void 0,l=await this.dataProvider.getChildren(o);if(c.token.isCancellationRequested)return;const E=await Promise.all((0,O.coalesce)(l||[]).map(async s=>{const t=await this.dataProvider.getTreeItem(s);return t&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(s,t,u):null}));return c.token.isCancellationRequested?void 0:(0,O.coalesce)(E)}finally{c.dispose()}}refresh(o){if(o.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(o);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const c=new Set,u=o.map(E=>this.nodes.get(E));for(const E of u)if(E&&!c.has(E.item.handle)){let s=E;for(;s&&s.parent&&u.findIndex(t=>s&&s.parent&&t&&t.item.handle===s.parent.item.handle)===-1;){const t=this.elements.get(s.parent.item.handle);s=t?this.nodes.get(t):void 0}s&&!s.parent&&c.add(E.item.handle)}const l=[];return c.forEach(E=>{const s=this.elements.get(E);if(s){const t=this.nodes.get(s);t&&(!t.parent||!c.has(t.parent.item.handle))&&l.push(E)}}),l}refreshHandles(o){const c={};return Promise.all(o.map(u=>this.refreshNode(u).then(l=>{l&&(c[u]=l.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(o){const c=this.getExtensionElement(o);if(c){const u=this.nodes.get(c);if(u)return this.clearChildren(c),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(l=>{if(l){const E=this.createTreeNode(c,l,u.parent);return this.updateNodeCache(c,E,u,u.parent),u.dispose(),E}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,c,u){const l=this.createTreeNode(o,c,u);if(c.id&&this.elements.has(l.item.handle))throw new Error((0,f.localize)(8,null,c.id));return this.addNodeToCache(o,l),this.addNodeToParentCache(l,u),l}getTooltip(o){return S.MarkdownString.isMarkdownString(o)?y.MarkdownString.from(o):o}getCommand(o,c){return c?this.commands.toInternal(c,o):void 0}createTreeNode(o,c,u){const l=new C.DisposableStore,E=this.createHandle(o,c,u),s=this.getLightIconPath(c);return{item:{handle:E,parentHandle:u?u.item.handle:void 0,label:d(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(l,c.command),contextValue:c.contextValue,icon:s,iconDark:this.getDarkIconPath(c)||s,themeIcon:this.getThemeIcon(c),collapsibleState:(0,L.isUndefinedOrNull)(c.collapsibleState)?S.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:u,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(o){return o.iconPath instanceof S.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:c,label:u,resourceUri:l},E,s){if(c)return`${P.ID_HANDLE_PREFIX}/${c}`;const t=d(u,this.extension),r=E?E.item.handle:P.LABEL_HANDLE_PREFIX;let i=t?t.label:l?(0,n.basename)(l):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const a=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,m=this.getChildrenNodes(E)||[];let h,w=0;do{if(h=`${r}/${w}:${i}`,s||!this.elements.has(h)||a===h)break;w++}while(w<=m.length);return h}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof S.ThemeIcon))return typeof o.iconPath=="string"||I.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof S.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return I.URI.isUri(o)?o:I.URI.file(o)}addNodeToCache(o,c){this.elements.set(c.item.handle,o),this.nodes.set(o,c)}updateNodeCache(o,c,u,l){this.elements.delete(c.item.handle),this.nodes.delete(o),c.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(o,c);const E=this.getChildrenNodes(l)||[],s=E.filter(t=>t.item.handle===u.item.handle)[0];s&&E.splice(E.indexOf(s),1,c)}addNodeToParentCache(o,c){c?(c.children||(c.children=[]),c.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const c=this.nodes.get(o);if(c){if(c.children)for(const u of c.children){const l=this.elements.get(u.item.handle);l&&this.clear(l)}c.children=void 0}}else this.clearAll()}clear(o){const c=this.nodes.get(o);if(c){if(c.children)for(const u of c.children){const l=this.elements.get(u.item.handle);l&&this.clear(l)}this.nodes.delete(o),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(pe[281],ve([1,0,21,15,3,47,2,113,109,149,108,42,5,132,231,230,39,232,37,233,234,235,219,236,45,40,237,238,241,242,243,135,221,248,249,250,87,33,252,280,14,7,255,67,136,36,73,208,240,121,133,69,54,71,11,63,17,26,244,203,51,64,228,253,202,66,65,258,256,257,229,44,251,254,86,53,124,246,68,247,10,117,245,200,239,6,30,209]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_,o,c,u,l,E,s,t,r,i,a,m,h,w,A,F,R,D,$,M,q,G,U,W,ee,Z,V,J,se,ae,Q,Y,oe,de,Ee,Re,Ne,be,we,H,B,N,z,j,re,he,Ce,Te,We,ze,qe,He,Ue,Je,et,Le,it,ne,le,X,ge,Se,Me,$e,Ye,lt,vt,wt,je,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(nt){const ct=nt.get(H.IExtHostInitDataService),Rt=nt.get(Je.IExtHostFileSystemInfo),Tt=nt.get(We.IExtHostConsumerFileSystem),yt=nt.get(t.IExtHostExtensionService),mt=nt.get(J.IExtHostWorkspace),Lt=nt.get(le.IExtHostTelemetry),Mt=nt.get(_.IExtHostConfiguration),Ft=nt.get(be.IURITransformerService),xe=nt.get(we.IExtHostRpcService),_e=nt.get($.IExtHostStorage),ye=nt.get(Te.IExtensionStoragePaths),me=nt.get(Ne.ILoggerService),ie=nt.get(Ne.ILogService),Ie=nt.get(z.IExtHostTunnelService),Ae=nt.get(j.IExtHostApiDeprecationService),Ve=nt.get(V.IExtHostWindow),Xe=nt.get(it.IExtHostSecretState),ht=nt.get(ne.IExtHostEditorTabs);xe.set(v.ExtHostContext.ExtHostFileSystemInfo,Rt),xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,me),xe.set(v.ExtHostContext.ExtHostWorkspace,mt),xe.set(v.ExtHostContext.ExtHostConfiguration,Mt),xe.set(v.ExtHostContext.ExtHostExtensionService,yt),xe.set(v.ExtHostContext.ExtHostStorage,_e),xe.set(v.ExtHostContext.ExtHostTunnelService,Ie),xe.set(v.ExtHostContext.ExtHostWindow,Ve),xe.set(v.ExtHostContext.ExtHostSecretState,Xe),xe.set(v.ExtHostContext.ExtHostTelemetry,Lt),xe.set(v.ExtHostContext.ExtHostEditorTabs,ht);const Et=xe.set(v.ExtHostContext.ExtHostDecorations,nt.get(oe.IExtHostDecorations)),St=xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(s.IExtHostDocumentsAndEditors)),ot=xe.set(v.ExtHostContext.ExtHostCommands,nt.get(p.IExtHostCommands)),dt=xe.set(v.ExtHostContext.ExtHostTerminalService,nt.get(M.IExtHostTerminalService)),ut=xe.set(v.ExtHostContext.ExtHostDebugService,nt.get(Ee.IExtHostDebugService)),Nt=xe.set(v.ExtHostContext.ExtHostSearch,nt.get(Re.IExtHostSearch)),pt=xe.set(v.ExtHostContext.ExtHostTask,nt.get(de.IExtHostTask)),kt=xe.set(v.ExtHostContext.ExtHostOutputService,nt.get(w.IExtHostOutputService)),Ut=xe.set(v.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(xe)),Ct=xe.set(v.ExtHostContext.ExtHostDocuments,new E.ExtHostDocuments(xe,St)),Bt=xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(xe,St,ie)),Ht=xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new l.ExtHostDocumentSaveParticipant(ie,Ct,xe.getProxy(v.MainContext.MainThreadBulkEdits))),bt=xe.set(v.ExtHostContext.ExtHostNotebook,new B.ExtHostNotebookController(xe,ot,St,Ct,ye)),ei=xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new lt.ExtHostNotebookDocuments(ie,bt)),Xt=xe.set(v.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(ie,xe,bt)),ti=xe.set(v.ExtHostContext.ExtHostNotebookKernels,new X.ExtHostNotebookKernels(xe,ct,bt,ot,ie)),ai=xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(xe,bt)),Pt=xe.set(v.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(xe,St)),ii=xe.set(v.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(xe.getProxy(v.MainContext.MainThreadTreeViews),ot,ie)),bi=xe.set(v.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(xe.getProxy(v.MainContext.MainThreadEditorInsets),Pt,ct)),qt=xe.set(v.ExtHostContext.ExtHostDiagnostics,new o.ExtHostDiagnostics(xe,ie,Rt)),Gt=xe.set(v.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(xe,Ct,ot.converter,Ft)),at=xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(xe,Ft,Ct,ot,qt,ie,Ae)),li=xe.set(v.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(xe,at)),$t=xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new i.ExtHostFileSystemEventService(xe,ie,St)),xt=xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(xe,mt,ot)),ni=xe.set(v.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,ot,ie)),_i=xe.set(v.ExtHostContext.ExtHostComments,(0,P.createExtHostComments)(xe,ot,Ct)),fi=xe.set(v.ExtHostContext.ExtHostProgress,new A.ExtHostProgress(xe.getProxy(v.MainContext.MainThreadProgress))),Si=xe.set(v.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(xe)),mi=xe.set(v.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(xe)),ri=xe.set(v.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(xe)),Ci=xe.set(v.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(xe,ot)),Qt=xe.set(v.ExtHostContext.ExtHostWebviews,new Z.ExtHostWebviews(xe,{remote:ct.remote},mt,ie,Ae)),Yt=xe.set(v.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(xe,Qt,mt)),yi=xe.set(v.ExtHostContext.ExtHostCustomEditors,new qe.ExtHostCustomEditors(xe,Ct,ye,Qt,Yt)),Di=xe.set(v.ExtHostContext.ExtHostWebviewViews,new ze.ExtHostWebviewViews(xe,Qt)),Jt=xe.set(v.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(xe,ot)),si=xe.set(v.ExtHostContext.ExtHostUriOpeners,new Le.ExtHostUriOpeners(xe));xe.set(v.ExtHostContext.ExtHostInteractive,new vt.ExtHostInteractive(xe,bt,St,ot));const Ii=(0,se.values)(v.ExtHostContext);xe.assertRegistered(Ii);const ki=new Ue.ExtHostBulkEdits(xe,St),Pi=new d.ExtHostClipboard(xe),Zt=new h.ExtHostMessageService(xe,ie),gi=new c.ExtHostDialogs(xe),Kt=new D.ExtHostStatusBar(xe,ot.converter);return g.ExtHostApiCommands.register(ot),function(Oe,ci,Ot){const ft=function(){let ce=!Oe.isUnderDevelopment;function fe(){ce||(ie.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ce=!0)}return function Pe(tt){if(Array.isArray(tt))tt.forEach(Pe);else if(typeof tt=="string")fe();else{const gt=tt;typeof gt.scheme=="undefined"&&fe(),typeof gt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Oe,"documentFiltersExclusive"),typeof gt.notebookType=="string"&&(0,je.checkProposedApiEnabled)(Oe,"notebookDocumentSelector")}return tt}}(),Ti={getSession(ce,fe,Pe){return ri.getSession(Oe,ce,fe,Pe)},async hasSession(ce,fe){return(0,je.checkProposedApiEnabled)(Oe,"authSession"),!!await ri.getSession(Oe,ce,fe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(ce,fe,Pe,tt){return ri.registerAuthenticationProvider(ce,fe,Pe,tt)}},Ai={registerCommand(ce,fe,Pe){return ot.registerCommand(!0,ce,fe,Pe,void 0,Oe)},registerTextEditorCommand(ce,fe,Pe){return ot.registerCommand(!0,ce,(...tt)=>{const gt=Pt.getActiveTextEditor();if(!gt){ie.warn("Cannot execute "+ce+" because there is no active text editor.");return}return gt.edit(It=>{fe.apply(Pe,[gt,It,...tt])}).then(It=>{It||ie.warn("Edits from command "+ce+" were not applied.")},It=>{ie.warn("An error occurred while running command "+ce,It)})},void 0,void 0,Oe)},registerDiffInformationCommand:(ce,fe,Pe)=>((0,je.checkProposedApiEnabled)(Oe,"diffCommand"),ot.registerCommand(!0,ce,async(...tt)=>{const gt=St.activeEditor(!0);if(!gt){ie.warn("Cannot execute "+ce+" because there is no active text editor.");return}const It=await Pt.getDiffInformation(gt.id);fe.apply(Pe,[It,...tt])},void 0,void 0,Oe)),executeCommand(ce,...fe){return ot.executeCommand(ce,...fe)},getCommands(ce=!1){return ot.getCommands(ce)}},pi={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return Pi.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Lt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ce=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(ce)?!1:ce<1e3*60*60*24},openExternal(ce,fe){return Ve.openUri(ce,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ce){if(ce.scheme===ct.environment.appUriScheme)return Ut.createAppUri(ce);try{return await Ve.asExternalUri(ce,{allowTunneling:!!ct.remote.authority})}catch(fe){if((0,$e.matchesScheme)(ce,Me.Schemas.http)||(0,$e.matchesScheme)(ce,Me.Schemas.https))return ce;throw fe}},get remoteName(){return(0,Y.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ct.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Ri={createTestController(ce,fe,Pe){return Jt.createTestController(ce,fe,Pe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.createTestObserver()},runTests(ce){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.runTests(ce)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.results}},Li={getExtension(ce){const fe=ci.getExtensionDescription(ce);if(fe)return new t.Extension(yt,Oe.identifier,fe,vi)},get all(){return ci.getAllExtensionDescriptions().map(ce=>new t.Extension(yt,Oe.identifier,ce,vi))},get onDidChange(){return ci.onDidChange}},Oi={createDiagnosticCollection(ce){return qt.createDiagnosticCollection(Oe.identifier,ce)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:ce=>qt.getDiagnostics(ce),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(ce,fe){return Gt.changeLanguage(ce.uri,fe)},match(ce,fe){return(0,O.score)(U.LanguageSelector.from(ce),fe.uri,fe.languageId,!0,fe.notebook?.notebookType)},registerCodeActionsProvider(ce,fe,Pe){return at.registerCodeActionProvider(Oe,ft(ce),fe,Pe)},registerCodeLensProvider(ce,fe){return at.registerCodeLensProvider(Oe,ft(ce),fe)},registerDefinitionProvider(ce,fe){return at.registerDefinitionProvider(Oe,ft(ce),fe)},registerDeclarationProvider(ce,fe){return at.registerDeclarationProvider(Oe,ft(ce),fe)},registerImplementationProvider(ce,fe){return at.registerImplementationProvider(Oe,ft(ce),fe)},registerTypeDefinitionProvider(ce,fe){return at.registerTypeDefinitionProvider(Oe,ft(ce),fe)},registerHoverProvider(ce,fe){return at.registerHoverProvider(Oe,ft(ce),fe,Oe.identifier)},registerEvaluatableExpressionProvider(ce,fe){return at.registerEvaluatableExpressionProvider(Oe,ft(ce),fe,Oe.identifier)},registerInlineValuesProvider(ce,fe){return at.registerInlineValuesProvider(Oe,ft(ce),fe,Oe.identifier)},registerDocumentHighlightProvider(ce,fe){return at.registerDocumentHighlightProvider(Oe,ft(ce),fe)},registerLinkedEditingRangeProvider(ce,fe){return at.registerLinkedEditingRangeProvider(Oe,ft(ce),fe)},registerReferenceProvider(ce,fe){return at.registerReferenceProvider(Oe,ft(ce),fe)},registerRenameProvider(ce,fe){return at.registerRenameProvider(Oe,ft(ce),fe)},registerDocumentSymbolProvider(ce,fe,Pe){return at.registerDocumentSymbolProvider(Oe,ft(ce),fe,Pe)},registerWorkspaceSymbolProvider(ce){return at.registerWorkspaceSymbolProvider(Oe,ce)},registerDocumentFormattingEditProvider(ce,fe){return at.registerDocumentFormattingEditProvider(Oe,ft(ce),fe)},registerDocumentRangeFormattingEditProvider(ce,fe){return at.registerDocumentRangeFormattingEditProvider(Oe,ft(ce),fe)},registerOnTypeFormattingEditProvider(ce,fe,Pe,...tt){return at.registerOnTypeFormattingEditProvider(Oe,ft(ce),fe,[Pe].concat(tt))},registerDocumentSemanticTokensProvider(ce,fe,Pe){return at.registerDocumentSemanticTokensProvider(Oe,ft(ce),fe,Pe)},registerDocumentRangeSemanticTokensProvider(ce,fe,Pe){return at.registerDocumentRangeSemanticTokensProvider(Oe,ft(ce),fe,Pe)},registerSignatureHelpProvider(ce,fe,Pe,...tt){return typeof Pe=="object"?at.registerSignatureHelpProvider(Oe,ft(ce),fe,Pe):at.registerSignatureHelpProvider(Oe,ft(ce),fe,typeof Pe=="undefined"?[]:[Pe,...tt])},registerCompletionItemProvider(ce,fe,...Pe){return at.registerCompletionItemProvider(Oe,ft(ce),fe,Pe)},registerInlineCompletionItemProvider(ce,fe){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),at.registerInlineCompletionsProvider(Oe,ft(ce),fe)},registerDocumentLinkProvider(ce,fe){return at.registerDocumentLinkProvider(Oe,ft(ce),fe)},registerColorProvider(ce,fe){return at.registerColorProvider(Oe,ft(ce),fe)},registerFoldingRangeProvider(ce,fe){return at.registerFoldingRangeProvider(Oe,ft(ce),fe)},registerSelectionRangeProvider(ce,fe){return at.registerSelectionRangeProvider(Oe,ce,fe)},registerCallHierarchyProvider(ce,fe){return at.registerCallHierarchyProvider(Oe,ce,fe)},registerTypeHierarchyProvider(ce,fe){return at.registerTypeHierarchyProvider(Oe,ce,fe)},setLanguageConfiguration:(ce,fe)=>at.setLanguageConfiguration(Oe,ce,fe),getTokenInformationAtPosition(ce,fe){return(0,je.checkProposedApiEnabled)(Oe,"tokenInformation"),Gt.tokenAtPosition(ce,fe)},registerInlayHintsProvider(ce,fe){return at.registerInlayHintsProvider(Oe,ce,fe)},createLanguageStatusItem(ce,fe){return Gt.createLanguageStatusItem(Oe,ce,fe)}},ui={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ce,fe,Pe){const tt=await(C.URI.isUri(ce)?Promise.resolve(wi.openTextDocument(ce)):Promise.resolve(ce));return Pt.showTextDocument(tt,fe,Pe)},createTextEditorDecorationType(ce){return Pt.createTextEditorDecorationType(Oe,ce)},onDidChangeActiveTextEditor(ce,fe,Pe){return Pt.onDidChangeActiveTextEditor(ce,fe,Pe)},onDidChangeVisibleTextEditors(ce,fe,Pe){return Pt.onDidChangeVisibleTextEditors(ce,fe,Pe)},onDidChangeTextEditorSelection(ce,fe,Pe){return Pt.onDidChangeTextEditorSelection(ce,fe,Pe)},onDidChangeTextEditorOptions(ce,fe,Pe){return Pt.onDidChangeTextEditorOptions(ce,fe,Pe)},onDidChangeTextEditorVisibleRanges(ce,fe,Pe){return Pt.onDidChangeTextEditorVisibleRanges(ce,fe,Pe)},onDidChangeTextEditorViewColumn(ce,fe,Pe){return Pt.onDidChangeTextEditorViewColumn(ce,fe,Pe)},onDidCloseTerminal(ce,fe,Pe){return dt.onDidCloseTerminal(ce,fe,Pe)},onDidOpenTerminal(ce,fe,Pe){return dt.onDidOpenTerminal(ce,fe,Pe)},onDidChangeActiveTerminal(ce,fe,Pe){return dt.onDidChangeActiveTerminal(ce,fe,Pe)},onDidChangeTerminalDimensions(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"terminalDimensions"),dt.onDidChangeTerminalDimensions(ce,fe,Pe)},onDidChangeTerminalState(ce,fe,Pe){return dt.onDidChangeTerminalState(ce,fe,Pe)},onDidWriteTerminalData(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(ce,fe,Pe)},get state(){return Ve.state},onDidChangeWindowState(ce,fe,Pe){return Ve.onDidChangeWindowState(ce,fe,Pe)},showInformationMessage(ce,...fe){return Zt.showMessage(Oe,T.default.Info,ce,fe[0],fe.slice(1))},showWarningMessage(ce,...fe){return Zt.showMessage(Oe,T.default.Warning,ce,fe[0],fe.slice(1))},showErrorMessage(ce,...fe){return Zt.showMessage(Oe,T.default.Error,ce,fe[0],fe.slice(1))},showQuickPick(ce,fe,Pe){return xt.showQuickPick(ce,fe,Pe)},showWorkspaceFolderPick(ce){return xt.showWorkspaceFolderPick(ce)},showInputBox(ce,fe){return xt.showInput(ce,fe)},showOpenDialog(ce){return gi.showOpenDialog(ce)},showSaveDialog(ce){return gi.showSaveDialog(ce)},createStatusBarItem(ce,fe,Pe){let tt,gt,It;return typeof ce=="string"?(tt=ce,gt=fe,It=Pe):(gt=ce,It=fe),Kt.createStatusBarEntry(Oe,tt,gt,It)},setStatusBarMessage(ce,fe){return Kt.setStatusBarMessage(ce,fe)},withScmProgress(ce){return Ae.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),fi.withProgress(Oe,{location:W.ProgressLocation.SourceControl},(fe,Pe)=>ce({report(tt){}}))},withProgress(ce,fe){return fi.withProgress(Oe,ce,fe)},createOutputChannel(ce,fe){return fe&&(0,je.checkProposedApiEnabled)(Oe,"outputChannelLanguage"),kt.createOutputChannel(ce,fe,Oe)},createWebviewPanel(ce,fe,Pe,tt){return Yt.createWebviewPanel(Oe,ce,fe,Pe,tt)},createWebviewTextEditorInset(ce,fe,Pe,tt){return(0,je.checkProposedApiEnabled)(Oe,"editorInsets"),bi.createWebviewEditorInset(ce,fe,Pe,tt,Oe)},createTerminal(ce,fe,Pe){return typeof ce=="object"?"pty"in ce?dt.createExtensionTerminal(ce):dt.createTerminalFromOptions(ce):dt.createTerminal(ce,fe,Pe)},registerTerminalLinkProvider(ce){return dt.registerLinkProvider(ce)},registerTerminalProfileProvider(ce,fe){return dt.registerProfileProvider(Oe,ce,fe)},registerTreeDataProvider(ce,fe){return ii.registerTreeDataProvider(ce,fe,Oe)},createTreeView(ce,fe){return ii.createTreeView(ce,fe,Oe)},registerWebviewPanelSerializer:(ce,fe)=>Yt.registerWebviewPanelSerializer(Oe,ce,fe),registerCustomEditorProvider:(ce,fe,Pe={})=>yi.registerCustomEditorProvider(Oe,ce,fe,Pe),registerFileDecorationProvider(ce){return Et.registerFileDecorationProvider(ce,Oe.identifier)},registerUriHandler(ce){return Ut.registerUriHandler(Oe.identifier,ce)},createQuickPick(){return xt.createQuickPick(Oe)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ce,fe,Pe){return mi.onDidChangeActiveColorTheme(ce,fe,Pe)},registerWebviewViewProvider(ce,fe,Pe){return Di.registerWebviewViewProvider(Oe,ce,fe,Pe?.webviewOptions)},get activeNotebookEditor(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(ce,fe,Pe)},get visibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(ce,fe,Pe)},onDidChangeNotebookEditorVisibleRanges(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(ce,fe,Pe)},showNotebookDocument(ce,fe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.showNotebookDocument(ce,fe)},registerExternalUriOpener(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"externalUriOpener"),si.registerExternalUriOpener(Oe.identifier,ce,fe,Pe)},get tabGroups(){return(0,je.checkProposedApiEnabled)(Oe,"tabs"),ht.tabGroups},getInlineCompletionItemController(ce){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),a.InlineCompletionController.get(ce)}},wi={get rootPath(){return Ae.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ce){throw n.readonly()},getWorkspaceFolder(ce){return mt.getWorkspaceFolder(ce)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ce){throw n.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ce){throw n.readonly()},updateWorkspaceFolders:(ce,fe,...Pe)=>mt.updateWorkspaceFolders(Oe,ce,fe||0,...Pe),onDidChangeWorkspaceFolders:function(ce,fe,Pe){return mt.onDidChangeWorkspace(ce,fe,Pe)},asRelativePath:(ce,fe)=>mt.getRelativePath(ce,fe),findFiles:(ce,fe,Pe,tt)=>mt.findFiles(ce,fe,Pe,Oe.identifier,tt),findTextInFiles:(ce,fe,Pe,tt)=>{(0,je.checkProposedApiEnabled)(Oe,"findTextInFiles");let gt,It;return typeof fe=="object"?(gt=fe,It=Pe):(gt={},It=fe,tt=Pe),mt.findTextInFiles(ce,gt||{},It,Oe.identifier,tt)},saveAll:ce=>mt.saveAll(ce),applyEdit(ce){return ki.applyWorkspaceEdit(ce)},createFileSystemWatcher:(ce,fe,Pe,tt)=>$t.createFileSystemWatcher(mt,Oe,ce,fe,Pe,tt),get textDocuments(){return Ct.getAllDocumentData().map(ce=>ce.document)},set textDocuments(ce){throw n.readonly()},openTextDocument(ce){let fe;const Pe=ce;if(typeof ce=="string")fe=Promise.resolve(C.URI.file(ce));else if(C.URI.isUri(ce))fe=Promise.resolve(ce);else if(!Pe||typeof Pe=="object")fe=Ct.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(tt=>Ct.ensureDocumentData(tt).then(gt=>gt.document))},onDidOpenTextDocument:(ce,fe,Pe)=>Ct.onDidAddDocument(ce,fe,Pe),onDidCloseTextDocument:(ce,fe,Pe)=>Ct.onDidRemoveDocument(ce,fe,Pe),onDidChangeTextDocument:(ce,fe,Pe)=>Ct.onDidChangeDocument(ce,fe,Pe),onDidSaveTextDocument:(ce,fe,Pe)=>Ct.onDidSaveDocument(ce,fe,Pe),onWillSaveTextDocument:(ce,fe,Pe)=>Ht.getOnWillSaveTextDocumentEvent(Oe)(ce,fe,Pe),get notebookDocuments(){return bt.notebookDocuments.map(ce=>ce.apiNotebook)},async openNotebookDocument(ce,fe){let Pe;if(C.URI.isUri(ce))Pe=ce,await bt.openNotebookDocument(ce);else if(typeof ce=="string")Pe=C.URI.revive(await bt.createNotebookDocument({viewType:ce,content:fe}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ce,fe,Pe,tt){return bt.registerNotebookSerializer(Oe,ce,fe,Pe,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)},registerNotebookContentProvider:(ce,fe,Pe,tt)=>((0,je.checkProposedApiEnabled)(Oe,"notebookContentProvider"),bt.registerNotebookContentProvider(Oe,ce,fe,Pe,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)),onDidChangeConfiguration:(ce,fe,Pe)=>Ot.onDidChangeConfiguration(ce,fe,Pe),getConfiguration(ce,fe){return fe=arguments.length===1?void 0:fe,Ot.getConfiguration(ce,fe,Oe)},registerTextDocumentContentProvider(ce,fe){return Bt.registerTextDocumentContentProvider(ce,fe)},registerTaskProvider:(ce,fe)=>(Ae.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Oe,ce,fe)),registerFileSystemProvider(ce,fe,Pe){return(0,wt.combinedDisposable)(li.registerFileSystemProvider(Oe,ce,fe,Pe),Tt.addFileSystemProvider(ce,fe))},get fs(){return Tt.value},registerFileSearchProvider:(ce,fe)=>((0,je.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(ce,fe)),registerTextSearchProvider:(ce,fe)=>((0,je.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(ce,fe)),registerRemoteAuthorityResolver:(ce,fe)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),yt.registerRemoteAuthorityResolver(ce,fe)),registerResourceLabelFormatter:ce=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Si.$registerResourceLabelFormatter(ce)),onDidCreateFiles:(ce,fe,Pe)=>$t.onDidCreateFile(ce,fe,Pe),onDidDeleteFiles:(ce,fe,Pe)=>$t.onDidDeleteFile(ce,fe,Pe),onDidRenameFiles:(ce,fe,Pe)=>$t.onDidRenameFile(ce,fe,Pe),onWillCreateFiles:(ce,fe,Pe)=>$t.getOnWillCreateFileEvent(Oe)(ce,fe,Pe),onWillDeleteFiles:(ce,fe,Pe)=>$t.getOnWillDeleteFileEvent(Oe)(ce,fe,Pe),onWillRenameFiles:(ce,fe,Pe)=>$t.getOnWillRenameFileEvent(Oe)(ce,fe,Pe),openTunnel:ce=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.openTunnel(Oe,ce).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(ce,fe,Pe)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.onDidChangeTunnels(ce,fe,Pe)),registerPortAttributesProvider:(ce,fe)=>((0,je.checkProposedApiEnabled)(Oe,"portsAttributes"),Ie.registerPortsAttributesProvider(ce,fe)),registerTimelineProvider:(ce,fe)=>((0,je.checkProposedApiEnabled)(Oe,"timeline"),Ci.registerTimelineProvider(ce,fe,Oe.identifier,ot.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ce=>((0,je.checkProposedApiEnabled)(Oe,"workspaceTrust"),mt.requestWorkspaceTrust(ce)),onDidGrantWorkspaceTrust:(ce,fe,Pe)=>mt.onDidGrantWorkspaceTrust(ce,fe,Pe)},Fi={get inputBox(){return Ae.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Oe)},createSourceControl(ce,fe,Pe){return ni.createSourceControl(Oe,ce,fe,Pe)}},Ni={createCommentController(ce,fe){return _i.createCommentController(Oe,ce,fe)}},Mi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(ce,fe,Pe){return ut.onDidStartDebugSession(ce,fe,Pe)},onDidTerminateDebugSession(ce,fe,Pe){return ut.onDidTerminateDebugSession(ce,fe,Pe)},onDidChangeActiveDebugSession(ce,fe,Pe){return ut.onDidChangeActiveDebugSession(ce,fe,Pe)},onDidReceiveDebugSessionCustomEvent(ce,fe,Pe){return ut.onDidReceiveDebugSessionCustomEvent(ce,fe,Pe)},onDidChangeBreakpoints(ce,fe,Pe){return ut.onDidChangeBreakpoints(ce,fe,Pe)},registerDebugConfigurationProvider(ce,fe,Pe){return ut.registerDebugConfigurationProvider(ce,fe,Pe||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ce,fe){return ut.registerDebugAdapterDescriptorFactory(Oe,ce,fe)},registerDebugAdapterTrackerFactory(ce,fe){return ut.registerDebugAdapterTrackerFactory(ce,fe)},startDebugging(ce,fe,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?ut.startDebugging(ce,fe,{parentSession:Pe}):ut.startDebugging(ce,fe,Pe||{})},stopDebugging(ce){return ut.stopDebugging(ce)},addBreakpoints(ce){return ut.addBreakpoints(ce)},removeBreakpoints(ce){return ut.removeBreakpoints(ce)},asDebugSourceUri(ce,fe){return ut.asDebugSourceUri(ce,fe)}},Ui={registerTaskProvider:(ce,fe)=>pt.registerTaskProvider(Oe,ce,fe),fetchTasks:ce=>pt.fetchTasks(ce),executeTask:ce=>pt.executeTask(Oe,ce),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(ce,fe,Pe)=>pt.onDidStartTask(ce,fe,Pe),onDidEndTask:(ce,fe,Pe)=>pt.onDidEndTask(ce,fe,Pe),onDidStartTaskProcess:(ce,fe,Pe)=>pt.onDidStartTaskProcess(ce,fe,Pe),onDidEndTaskProcess:(ce,fe,Pe)=>pt.onDidEndTaskProcess(ce,fe,Pe)},Bi={createNotebookController(ce,fe,Pe,tt,gt){return ti.createNotebookController(Oe,ce,fe,Pe,tt,(0,je.isProposedApiEnabled)(Oe,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(ce,fe)=>bt.registerNotebookCellStatusBarItemProvider(Oe,ce,fe),get onDidSaveNotebookDocument(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ce){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(ce)},createRendererMessaging(ce){return ai.createRendererMessaging(Oe,ce)},onDidChangeNotebookDocumentMetadata(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(ce,fe,Pe)},onDidChangeNotebookCells(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeNotebookCells(ce,fe,Pe)},onDidChangeNotebookCellExecutionState(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(ce,fe,Pe)},onDidChangeCellOutputs(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellOutputs(ce,fe,Pe)},onDidChangeCellMetadata(ce,fe,Pe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellMetadata(ce,fe,Pe)},createConcatTextDocument(ce,fe){return(0,je.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new Ce.ExtHostNotebookConcatDocument(bt,Ct,ce,fe)}};return{version:ct.version,authentication:Ti,commands:Ai,comments:Ni,debug:Mi,env:pi,extensions:Li,languages:Oi,notebooks:Bi,scm:Fi,tasks:Ui,tests:Ri,window:ui,workspace:wi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:n.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:L.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,TabKind:v.TabKind,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:b.UIKind,Uri:C.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:ge.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=_t}),define(pe[282],ve([1,0,283,292,293,2,294]),function(te,e,f,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(y,v,b,g,d,p){const P=p.environment.useHostProxy,_=typeof P=="boolean"?P:!p.remote.isRemote,o=(0,C.createProxyResolver)({resolveProxy:u=>y.resolveProxy(u),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(u,l,...E)=>{switch(u){case C.LogLevel.Trace:g.trace(l,...E);break;case C.LogLevel.Debug:g.debug(l,...E);break;case C.LogLevel.Info:g.info(l,...E);break;case C.LogLevel.Warning:g.warn(l,...E);break;case C.LogLevel.Error:g.error(l,...E);break;case C.LogLevel.Critical:g.critical(l,...E);break;case C.LogLevel.Off:break;default:s(u,l,E);break}function s(t,r,...i){g.error("Unknown log level",t),g.error(r,...i)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:_,env:process.env}),c=S(v,o);return O(b,c)}e.connectProxyResolver=k;function S(y,v){const b={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(d=>{b.config=y.getConfiguration("http").get("proxySupport")||"off"});const g={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(d=>{g.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,C.createHttpPatch)(f,v,{config:"off"},g,!0)),on:Object.assign({},f,(0,C.createHttpPatch)(f,v,{config:"on"},g,!0)),override:Object.assign({},f,(0,C.createHttpPatch)(f,v,{config:"override"},g,!0)),onRequest:Object.assign({},f,(0,C.createHttpPatch)(f,v,b,g,!0)),default:Object.assign(f,(0,C.createHttpPatch)(f,v,b,g,!1))},https:{off:Object.assign({},n,(0,C.createHttpPatch)(n,v,{config:"off"},g,!0)),on:Object.assign({},n,(0,C.createHttpPatch)(n,v,{config:"on"},g,!0)),override:Object.assign({},n,(0,C.createHttpPatch)(n,v,{config:"override"},g,!0)),onRequest:Object.assign({},n,(0,C.createHttpPatch)(n,v,b,g,!0)),default:Object.assign(n,(0,C.createHttpPatch)(n,v,b,g,!1))},tls:Object.assign(I,(0,C.createTlsPatch)(I))}}const L=new Map;function O(y,v){return y.getExtensionPathIndex().then(b=>{const g=te.__$__nodeRequire("module"),d=g._load;g._load=function(P,_,o){if(P==="tls")return v.tls;if(P!=="http"&&P!=="https")return d.apply(this,arguments);const c=v[P],u=b.findSubstr(T.URI.file(_.filename));let l=L.get(u);if(l||L.set(u,l={}),!l[P]){let E=c.default;l[P]={...E}}return l[P]}})}}),define(pe[139],ve([1,0,38,295,102,18,73,34,9,8,2,31,68,296,276,88]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const p=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(h){this.outputChannel=h}provideTextSearchResults(h,w,A,F){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((R,D)=>{F.onCancellationRequested(()=>Z());const $=E(h,w),M=w.folder.fsPath,q=$.map(Q=>Q.match(/^-/)?Q:`'${Q}'`).join(" ");this.outputChannel.appendLine(`${p} ${q}
 - cwd: ${M}`);let G=f.spawn(p,$,{cwd:M});G.on("error",Q=>{console.error(Q),this.outputChannel.appendLine("Error: "+(Q&&Q.message)),D((0,y.serializeSearchError)(new y.SearchError(Q&&Q.message,y.SearchErrorCode.rgProcessError)))});let U=!1;const W=new c(w.maxResults,M,w.previewOptions);W.on("result",Q=>{U=!0,J="",A.report(Q)});let ee=!1;const Z=()=>{ee=!0,G&&G.kill(),W&&W.cancel()};let V=!1;W.on("hitLimit",()=>{V=!0,Z()});let J="";G.stdout.on("data",Q=>{W.handleData(Q),U||(J+=Q)});let se=!1;G.stdout.once("data",()=>se=!0);let ae="";G.stderr.on("data",Q=>{const Y=Q.toString();this.outputChannel.appendLine(Y),ae+=Y}),G.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),ee)R({limitHit:V});else{W.flush(),G=null;let Q;ae&&!se&&(Q=_(ae))?D((0,y.serializeSearchError)(new y.SearchError(Q.message,Q.code))):R({limitHit:V})}})})}}e.RipgrepTextSearchEngine=P;function _(m){const h=m.split(`
`),w=h[0].trim();if(h.some(F=>F.startsWith("regex parse error")))return new y.SearchError(o(h),y.SearchErrorCode.regexParseError);const A=w.match(/grep config error: unknown encoding: (.*)/);if(A)return new y.SearchError(`Unknown encoding: ${A[1]}`,y.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new y.SearchError(w.charAt(0).toUpperCase()+w.substr(1),y.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new y.SearchError(w.charAt(0).toUpperCase()+w.substr(1),y.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(w,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function o(m){const h=["Regex parse error"],w=m.filter(A=>A.startsWith("PCRE2:"));if(w.length>=1){const A=w[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const F=A.split(":")[1];h.push(":"+F)}}return h.join("")}e.buildRegexParseError=o;class c extends n.EventEmitter{constructor(h,w,A){super();this.maxResults=h,this.rootFolder=w,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,w){return super.on(h,w),this}handleData(h){if(this.isDone)return;const w=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(w)}handleDecodedData(h){let w=h.indexOf(`
`);const A=this.remainder+h;if(w>=0)w+=this.remainder.length;else{this.remainder=A;return}let F=0;for(;w>=0;)this.handleLine(A.substring(F,w).trim()),F=w+1,w=A.indexOf(`
`,F);this.remainder=A.substring(F)}handleLine(h){if(this.isDone||!h)return;let w;try{w=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(w.type==="match"){const A=u(w.data.path),F=O.URI.file(S.join(this.rootFolder,A)),R=this.createTextSearchMatch(w.data,F);this.onResult(R),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const A=u(w.data.path),F=O.URI.file(S.join(this.rootFolder,A));this.createTextSearchContext(w.data,F).forEach(D=>this.onResult(D))}}createTextSearchMatch(h,w){const A=h.line_number-1,F=u(h.lines),R=Buffer.from(F);let D=0,$=0,M=A;h.submatches.length===0&&h.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const q=(0,T.coalesce)(h.submatches.map((G,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const W=u(G.match),ee=R.slice(D,G.start).toString().length,Z=$+ee,V=l(W),J=M,se=V.numLines+J,ae=V.numLines>0?V.lastLineLength:V.lastLineLength+Z;return D=G.end,$=ae,M=se,new v.Range(J,Z,se,ae)}));return(0,d.createTextSearchResult)(w,F,q,this.previewOptions)}createTextSearchContext(h,w){const A=u(h.lines),F=h.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((R,D)=>({text:R,uri:w,lineNumber:F+D}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function u(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function l(m){const h=/\n/g;let w=0,A=-1,F;for(;F=h.exec(m);)w++,A=F.index;const R=A>=0?m.length-A-1:m.length;return{numLines:w,lastLineLength:R}}function E(m,h){const w=["--hidden"];w.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:F}=(0,C.groupBy)(h.includes,D=>D.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const D=new Set;F.forEach($=>{D.add($)}),w.push("-g","!*"),D.forEach($=>{s($).map(d.anchorGlob).forEach(M=>{w.push("-g",M)})})}A&&A.length&&A.forEach(D=>{w.push("-g",D)}),h.excludes.map(d.anchorGlob).forEach(D=>w.push("-g",`!${D}`)),h.maxFileSize&&w.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),h.followSymlinks&&w.push("--follow"),h.encoding&&h.encoding!=="utf8"&&w.push("--encoding",h.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,L.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),h.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),w.push("--engine","auto"));let R;if(m.isWordMatch){const $=(0,L.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",$)}else if(m.isRegExp){let D=i(m.pattern);D=a(D),w.push("--regexp",D)}else R=m.pattern,w.push("--fixed-strings");return w.push("--no-config"),h.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),m.isMultiline&&w.push("--multiline"),h.beforeContext&&w.push("--before-context",h.beforeContext+""),h.afterContext&&w.push("--after-context",h.afterContext+""),w.push("--"),R&&w.push(R),w.push("."),w}function s(m){const h=(0,k.splitGlobAware)(m,"/");return h.map((w,A)=>h.slice(0,A+1).join("/"))}e.spreadGlobComponents=s;function t(m){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(h);)m=m.replace(h,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(w);)m=m.replace(w,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const r=m=>m.type==="Assertion"&&m.kind==="lookbehind";function i(m){let h;try{h=new b.RegExpParser().parsePattern(m)}catch{return m}let w="",A=0;const F=($,M,q)=>{w+=m.slice(A,$)+q,A=M},R=[];return new b.RegExpVisitor({onCharacterEnter($){if($.raw!=="\\n")return;const M=R[0];if(!M)F($.start,$.end,"\\r?\\n");else if(!R.some(r))if(M.type==="CharacterClass")if(M.negate){const q=m.slice(M.start+2,$.start)+m.slice($.end,M.end-1);M.parent?.type==="Quantifier"?F(M.start,M.end,q?`[^${q}]`:"."):F(M.start,M.end,"(?!\\r?\\n"+(q?`|[${q}]`:"")+")")}else{const q=m.slice(M.start+1,$.start)+m.slice($.end,M.end-1);F(M.start,M.end,q===""?"\\r?\\n":`(?:[${q}]|\\r?\\n)`)}else M.type==="Quantifier"&&F($.start,$.end,"(?:\\r?\\n)")},onQuantifierEnter($){R.unshift($)},onQuantifierLeave(){R.shift()},onCharacterClassRangeEnter($){R.unshift($)},onCharacterClassRangeLeave(){R.shift()},onCharacterClassEnter($){R.unshift($)},onCharacterClassLeave(){R.shift()},onAssertionEnter($){r($)&&R.push($)},onAssertionLeave($){R[0]===$&&R.shift()}}).visit(h),w+=m.slice(A),w}e.fixRegexNewline=i;function a(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(pe[284],ve([1,0,21,139,118,10]),function(te,e,f,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(L){this.outputChannel=L,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(L,O,y,v){const b=new n.RipgrepTextSearchEngine(this.outputChannel);if(O.folder.scheme===T.Schemas.userData){const g={...O,folder:O.folder.with({scheme:T.Schemas.file})},d=new I.Progress(p=>y.report({...p,uri:p.uri.with({scheme:O.folder.scheme})}));return this.withToken(v,p=>b.provideTextSearchResults(L,g,d,p))}else return this.withToken(v,g=>b.provideTextSearchResults(L,O,y,g))}async withToken(L,O){const y=k(L);this.inProgress.add(y);const v=await O(y.token);return this.inProgress.delete(y),v}dispose(){this.inProgress.forEach(L=>L.cancel())}}e.RipgrepSearchProvider=C;function k(S){const L=new f.CancellationTokenSource;return S.onCancellationRequested(()=>L.cancel()),L}}),define(pe[285],ve([1,0,28,139,138]),function(te,e,f,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(S){this.query=S}search(S,L,O){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(b){O({message:b})}},v=new I.NativeTextSearchManager(this.query,new n.RipgrepTextSearchEngine(y),f);return new Promise((b,g)=>v.search(d=>{L(d.map(C))},S).then(d=>b({limitHit:d.limitHit,type:"success",stats:d.stats}),g))}}e.TextSearchEngineAdapter=T;function C(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,L)=>{if(L.ranges){const O=L;return S+(Array.isArray(O.ranges)?O.ranges.length:1)}else return S+1},0)}}}),define(pe[286],ve([1,0,18,16,15,3,98,9,46,2,42,31,277,285]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class g{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let u;const l=P(c),E=new T.Emitter({onFirstListenerDidAdd:()=>{u=(0,n.createCancelablePromise)(s=>this.doFileSearchWithEngine(v.Engine,l,t=>E.fire(t),s)),u.then(s=>E.fire(s),s=>E.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return E.event}textSearch(c){let u;const l=P(c),E=new T.Emitter({onFirstListenerDidAdd:()=>{u=(0,n.createCancelablePromise)(s=>this.ripgrepTextSearch(l,t=>E.fire(t),s)),u.then(s=>E.fire(s),s=>E.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return E.event}ripgrepTextSearch(c,u,l){return c.maxFileSize=(0,O.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(c).search(l,u,u)}doFileSearch(c,u,l){return this.doFileSearchWithEngine(v.Engine,c,u,l)}doFileSearchWithEngine(c,u,l,E,s=g.BATCH_SIZE){let t=0;const r=a=>{Array.isArray(a)?(t+=a.length,l(a.map(m=>this.rawMatchToSearchItem(m)))):a.relativePath?(t++,l(this.rawMatchToSearchItem(a))):l(a)};if(u.sortByScore){let a=this.trySortedSearchFromCache(u,r,E);if(!a){const m=u.maxResults?Object.assign({},u,{maxResults:null}):u,h=new c(m);a=this.doSortedSearch(h,u,l,r,E)}return new Promise((m,h)=>{a.then(([w,A])=>{const F=A.map(R=>this.rawMatchToSearchItem(R));this.sendProgress(F,l,s),m(w)},h)})}const i=new c(u);return this.doSearch(i,r,s,E).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,k.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,u,l,E,s){const t=new T.Emitter;let r=(0,n.createCancelablePromise)(a=>{let m=[];const h=w=>{Array.isArray(w)?m=w:(E(w),t.fire(w))};return this.doSearch(c,h,-1,a).then(w=>[w,m])}),i;if(u.cacheKey){i=this.getOrCreateCache(u.cacheKey);const a={promise:r,event:t.event,resolved:!1};i.resultsToSearchCache[u.filePattern||""]=a,r.then(()=>{a.resolved=!0},m=>{delete i.resultsToSearchCache[u.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([a,m])=>{const h=i?i.scorerCache:Object.create(null),w=(typeof u.maxResults!="number"||u.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(u,m,h,s).then(A=>{const F=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:F,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:A.length},messages:a.messages,limitHit:a.limitHit||typeof u.maxResults=="number"&&m.length>u.maxResults},A]})})}getOrCreateCache(c){const u=this.caches[c];return u||(this.caches[c]=new d)}trySortedSearchFromCache(c,u,l){const E=c.cacheKey&&this.caches[c.cacheKey];if(!E)return;const s=this.getResultsFromCache(E,c.filePattern||"",u,l);if(s)return s.then(([t,r,i])=>{const a=S.StopWatch.create(!1);return this.sortResults(c,r,E.scorerCache,l).then(m=>{const h=a.elapsed(),w={fromCache:!0,detailStats:i,type:this.processType,resultCount:r.length,sortingTime:h};return[{type:"success",limitHit:t.limitHit||typeof c.maxResults=="number"&&r.length>c.maxResults,stats:w},m]})})}sortResults(c,u,l,E){const s=(0,C.prepareQuery)(c.filePattern||""),t=(i,a)=>(0,C.compareItemsByFuzzyScore)(i,a,s,!0,p,l),r=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return f.topAsync(u,t,r,1e4,E)}sendProgress(c,u,l){if(l&&l>0)for(let E=0;E<c.length;E+=l)u(c.slice(E,E+l));else u(c)}getResultsFromCache(c,u,l,E){const s=S.StopWatch.create(!1),t=u.indexOf(k.sep)>=0;let r;for(const h in c.resultsToSearchCache)if(u.startsWith(h)){if(t&&h.indexOf(k.sep)<0&&h!=="")continue;const w=c.resultsToSearchCache[h];r={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const i=s.elapsed(),a=S.StopWatch.create(!1),m=r.event(l);return E&&E.onCancellationRequested(()=>{m.dispose()}),r.promise.then(([h,w])=>{if(E&&E.isCancellationRequested)throw(0,I.canceled)();const A=[],F=(0,C.prepareQuery)(u).normalizedLowercase;for(const R of w)!(0,y.isFilePatternMatch)(R,F)||A.push(R);return[h,A,{cacheWasResolved:r.resolved,cacheLookupTime:i,cacheFilterTime:a.elapsed(),cacheEntryCount:w.length}]})}doSearch(c,u,l,E){return new Promise((s,t)=>{let r=[];E&&E.onCancellationRequested(()=>c.cancel()),c.search(i=>{i&&(l?(r.push(i),l>0&&r.length>=l&&(u(r),r=[])):u(i))},i=>{u(i)},(i,a)=>{r.length&&u(r),i?t(i):s(a)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,l){return c.then(u,l)}catch(u){return this.then(void 0,u)}finally(u){return c.finally(u)}}}}e.SearchService=g,g.BATCH_SIZE=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(o){return(0,k.basename)(o.relativePath)}getItemDescription(o){return(0,k.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function P(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(_),extraFileResources:o.extraFileResources&&o.extraFileResources.map(c=>L.URI.revive(c))}}function _(o){return{...o,folder:L.URI.revive(o.folder)}}}),define(pe[287],ve([1,0,6,10,2,28,11,26,17,71,63,31,286,284,88,138]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let p=class extends L.ExtHostSearch{constructor(_,o,c,u){super(_,c,u);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const l=new g.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(n.Schemas.userData,new b.RipgrepSearchProvider(l)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new g.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(n.Schemas.file,new b.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(n.Schemas.file,new v.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,o){const c=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(_)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(_,o,c,u){const l=(0,L.reviveQuery)(c);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,o,l,u):super.$provideFileSearchResults(_,o,c,u)}doInternalFileSearch(_,o,c,u){const l=E=>{if((0,y.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(_,o,E.map(s=>I.URI.file(s.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,l,u)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,o){return new d.NativeTextSearchManager(_,o,void 0,"textSearchProvider")}};p=Be([Fe(0,S.IExtHostRpcService),Fe(1,k.IExtHostInitDataService),Fe(2,O.IURITransformerService),Fe(3,C.ILogService)],p),e.NativeExtHostSearch=p}),define(pe[140],ve([1,0,297,127,60,22,15,3,6,9,12,32,104,105,298]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(w,A=""){this.debugLabel=A,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,C.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,A){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,A)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const A=F=>{this.traceSocketEvent("read",F),w(T.VSBuffer.wrap(F))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(w){const A=F=>{this.traceSocketEvent("close",{hadError:F}),w({type:0,hadError:F,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(w){const A=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,C.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,C.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=d;var p;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var P;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(P||(P={}));class _ extends S.Disposable{constructor(w,A,F,R){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:F?.byteLength||0,recordInflateBytes:R}),this._flowManager=this._register(new o(this,A,F,R,this._onData,(D,$)=>this._write(D,$))),this._register(this._flowManager.onError(D=>{console.error(D),(0,C.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,A){this.socket.traceSocketEvent(w,A)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let F=2;w.byteLength<126?F+=0:w.byteLength<2**16?F+=2:F+=8;const R=T.VSBuffer.alloc(F);if(A?R.writeUInt8(194,0):R.writeUInt8(130,0),w.byteLength<126)R.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){R.writeUInt8(126,1);let D=1;R.writeUInt8(w.byteLength>>>8&255,++D),R.writeUInt8(w.byteLength>>>0&255,++D)}else{R.writeUInt8(127,1);let D=1;R.writeUInt8(0,++D),R.writeUInt8(0,++D),R.writeUInt8(0,++D),R.writeUInt8(0,++D),R.writeUInt8(w.byteLength>>>24&255,++D),R.writeUInt8(w.byteLength>>>16&255,++D),R.writeUInt8(w.byteLength>>>8&255,++D),R.writeUInt8(w.byteLength>>>0&255,++D)}this.socket.write(T.VSBuffer.concat([R,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),F=A.readUInt8(0),R=(F&128)>>>7,D=(F&64)>>>6,$=A.readUInt8(1),M=($&128)>>>7,q=$&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),F=A.readUInt8(1),R=(F&128)>>>7;let D=F&127,$=1;D===126?D=A.readUInt8(++$)*2**8+A.readUInt8(++$):D===127&&(D=A.readUInt8(++$)*0+A.readUInt8(++$)*0+A.readUInt8(++$)*0+A.readUInt8(++$)*0+A.readUInt8(++$)*2**24+A.readUInt8(++$)*2**16+A.readUInt8(++$)*2**8+A.readUInt8(++$));let M=0;R&&(M=A.readUInt8(++$)*2**24+A.readUInt8(++$)*2**16+A.readUInt8(++$)*2**8+A.readUInt8(++$)),this._state.state=3,this._state.readLen=D,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),l(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=_;class o extends S.Disposable{constructor(w,A,F,R,D,$){super();this._tracer=w,this._onData=D,this._writeFn=$,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new c(this._tracer,R,F,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(A,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,A){return new Promise((F,R)=>{w.write(A),w.flush(D=>F(D))})}acceptFrame(w,A,F){this._readQueue.push({data:w,isCompressed:A,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,A,F){return new Promise((R,D)=>{w.write(A),F&&w.write(T.VSBuffer.fromByteArray([0,0,255,255])),w.flush($=>R($))})}}class c extends S.Disposable{constructor(w,A,F,R){super();this._tracer=w,this._recordInflateBytes=A,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(R),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(T.VSBuffer.wrap(D))}),F&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(A)})}}class u extends S.Disposable{constructor(w,A){super();this._tracer=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent("zlibDeflateData",F),this._pendingDeflateData.push(T.VSBuffer.wrap(F))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),w(A)})}}function l(h,w){if(w===0)return;let A=h.byteLength>>>2;for(let q=0;q<A;q++){const G=h.readUInt32BE(q*4);h.writeUInt32BE(G^w,q*4)}let F=A*4,R=h.byteLength-F;const D=w>>>24&255,$=w>>>16&255,M=w>>>8&255;R>=1&&h.writeUInt8(h.readUInt8(F)^D,F),R>=2&&h.writeUInt8(h.readUInt8(F+1)^$,F+1),R>=3&&h.writeUInt8(h.readUInt8(F+2)^M,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function s(){const h=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):w=(0,L.join)((0,I.tmpdir)(),`vscode-ipc-${h}.sock`),r(w),w}e.createRandomIPCHandle=s;function t(h,w,A){const F=(0,f.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${w}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${A}-${w}.sock`):R=(0,L.join)(h,`${A}-${w}.sock`),r(R),R}e.createStaticIPCHandle=t;function r(h){const w=E[O.platform];typeof w=="number"&&h.length>=w&&console.warn(`WARNING: IPC handle "${h}" is longer than ${w} chars, try a shorter --user-data-dir`)}class i extends v.IPCServer{constructor(w){super(i.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const A=k.Event.fromNodeEventEmitter(w,"connection");return k.Event.map(A,F=>({protocol:new b.Protocol(new d(F,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function a(h){return new Promise((w,A)=>{const F=(0,n.createServer)();F.on("error",A),F.listen(h,()=>{F.removeListener("error",A),w(new i(F))})})}e.serve=a;function m(h,w){return new Promise((A,F)=>{const R=(0,n.createConnection)(h,()=>{R.removeListener("error",F),A(b.Client.fromSocket(new d(R,`ipc-client${w}`),w))});R.once("error",F)})}e.connect=m}),define(pe[288],ve([1,0,140,283,59,39,2,11,43]),function(te,e,f,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class L{constructor(v,b,g){this._commands=v,this.logService=b,this._ipcHandlePath=g,this._server=n.createServer((d,p)=>this.onRequest(d,p)),this.setup().catch(d=>(b.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",v=>this.logService.error(v))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(v,b){const g=(p,P)=>{b.writeHead(p,{"content-type":"application/json"}),b.end(JSON.stringify(P),_=>_&&this.logService.error(_))},d=[];v.setEncoding("utf8"),v.on("data",p=>d.push(p)),v.on("end",async()=>{try{const p=JSON.parse(d.join(""));let P;switch(p.type){case"open":P=await this.open(p);break;case"openExternal":P=await this.openExternal(p);break;case"status":P=await this.getStatus(p);break;case"extensionManagement":P=await this.manageExtensions(p);break;default:g(404,`Unknown message type: ${p.type}`);break}g(200,P)}catch(p){const P=p instanceof Error?p.message:JSON.stringify(p);g(500,P),this.logService.error("Error while processing pipe request",p)}})}async open(v){const{fileURIs:b,folderURIs:g,forceNewWindow:d,diffMode:p,addMode:P,forceReuseWindow:_,gotoLineMode:o,waitMarkerFilePath:c,remoteAuthority:u}=v,l=[];if(Array.isArray(g))for(const r of g)try{l.push({folderUri:C.URI.parse(r)})}catch{}if(Array.isArray(b))for(const r of b)try{(0,S.hasWorkspaceFileExtension)(r)?l.push({workspaceUri:C.URI.parse(r)}):l.push({fileUri:C.URI.parse(r)})}catch{}const E=c?C.URI.file(c):void 0,t={forceNewWindow:d,diffMode:p,addMode:P,gotoLineMode:o,forceReuseWindow:_,preferNewWindow:!_&&!E&&!P,waitMarkerFileURI:E,remoteAuthority:u};return this._commands.executeCommand("_remoteCLI.windowOpen",l,t),""}async openExternal(v){for(const b of v.uris){const g=C.URI.parse(b),d=g.scheme==="file"?g:b;await this._commands.executeCommand("_remoteCLI.openExternal",d)}}async manageExtensions(v){const b=d=>d?.map(p=>/\.vsix$/i.test(p)?C.URI.parse(p):p),g={list:v.list,install:b(v.install),uninstall:b(v.uninstall),force:v.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",g)}async getStatus(v){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=L;let O=class extends L{constructor(v,b){super(v,b,(0,f.createRandomIPCHandle)())}};O=Be([Fe(0,T.IExtHostCommands),Fe(1,k.ILogService)],O),e.CLIServer=O}),define(pe[289],ve([1,0,70,281,270,5,282,40,259,2,10,7,288,103]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends I.RequireInterceptor{_installInterceptor(){const P=this,_=te.__$__nodeRequire("module"),o=_._load;_._load=function(E,s,t){return E=u(E),P._factories.has(E)?P._factories.get(E).load(E,L.URI.file((0,b.realpathSync)(s.filename)),r=>o.apply(this,[r,s,t])):o.apply(this,arguments)};const c=_._resolveLookupPaths;_._resolveLookupPaths=(l,E)=>c.call(this,u(l),E);const u=l=>{for(let E of P._alternatives){let s=E(l);if(s){l=s;break}}return l}}}class d extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const l=this._instaService.createInstance(v.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=l.ipcHandlePath}await this._instaService.createInstance(g,P,this._registry).install(),f.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const c=process.send,u=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...l)=>l.length===0||!l[0]||l[0].type!=="__$console"?c.apply(process,l):(u.$logExtensionHostMessage(l[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,_,o){if(_.scheme!==O.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let c=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{P&&f.mark(`code/extHost/willLoadExtensionCode/${P.value}`),c=te.__$__nodeRequire(_.fsPath)}catch(u){return Promise.reject(u)}finally{P&&f.mark(`code/extHost/didLoadExtensionCode/${P.value}`),o.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const _ in P){const o=P[_];o===null?delete process.env[_]:process.env[_]=o}}}e.ExtHostExtensionService=d}),define(pe[290],ve([1,0,79,262,273,272,287,289,263,54,40,71,69,33,51,66,261,260,11]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(O.IExtHostExtensionService,k.ExtHostExtensionService),(0,f.registerSingleton)(_.ILoggerService,P.ExtHostLoggerService),(0,f.registerSingleton)(d.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,f.registerSingleton)(L.IExtHostDebugService,T.ExtHostDebugService),(0,f.registerSingleton)(y.IExtHostSearch,C.NativeExtHostSearch),(0,f.registerSingleton)(v.IExtHostTask,I.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,n.ExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,S.ExtHostTunnelService)}),define(pe[299],ve([1,0,127,300,70,15,105,140,191,132,271,22,28,103,16,113,206,274,290]),function(te,e,f,n,I,T,C,k,S,L,O,y,v,b,g,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const P=n(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const t=te.__$__nodeRequire("module"),r=t._load;t._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const _=process.exit.bind(process);function o(t){process.exit=function(r){if(t)_(r);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let c=function(t){_()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,r)=>{let i=null,a=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,h=3e5,w=new g.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (1)"),m),A=new g.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (2)"),h);process.on("message",(R,D)=>{if(R&&R.type==="VSCODE_EXTHOST_IPC_SOCKET"){D.setNoDelay(!0);const $=y.VSBuffer.wrap(Buffer.from(R.initialDataChunk,"base64"));let M;if(R.skipWebSocketFrames)M=new k.NodeSocket(D,"extHost-socket");else{const q=y.VSBuffer.wrap(Buffer.from(R.inflateBytes,"base64"));M=new k.WebSocketNodeSocket(new k.NodeSocket(D,"extHost-socket"),R.permessageDeflate,q,!1)}i?(w.cancel(),A.cancel(),i.beginAcceptReconnection(M,$),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(a),i=new C.PersistentProtocol(M,$),i.sendResume(),i.onDidDispose(()=>c("renderer disconnected")),t(i),i.onSocketClose(()=>{w.schedule()}))}if(R&&R.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;w.isScheduled()&&A.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(F)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,i)=>{const a=f.createConnection(t,()=>{a.removeListener("error",i),r(new C.PersistentProtocol(new k.NodeSocket(a,"extHost-renderer")))});a.once("error",i),a.on("close",()=>{c("renderer closed the socket")})})}}async function l(){const t=await u();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(r=>{(0,L.isMessageOfType)(r,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||t.send(r)}drain(){return t.drain()}}}function E(t){return new Promise(r=>{const i=t.onMessage(a=>{i.dispose();const m=JSON.parse(a.toString()),h=m.commit,w=S.default.commit;h&&w&&h!==w&&_(55);let A=0;setInterval(function(){try{process.kill(m.parentPid,0),A=0}catch(R){R&&R.code==="EPERM"?(A++,A>=3&&c(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${R.message} (code: ${R.code}) (errno: ${R.errno})`)):c(`parent process ${m.parentPid} does not exist anymore: ${R.message} (code: ${R.code}) (errno: ${R.errno})`)}},1e3);let F;try{F=te.__$__nodeRequire("native-watchdog"),F.start(m.parentPid)}catch(R){(0,T.onUnexpectedError)(R)}t.send((0,L.createMessageOfType)(0)),r({protocol:t,initData:m})});t.send((0,L.createMessageOfType)(1))})}async function s(){const t=[];process.on("unhandledRejection",(A,F)=>{t.push(F),setTimeout(()=>{const R=t.indexOf(F);R>=0&&F.catch(D=>{t.splice(R,1),(0,T.isCancellationError)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D&&D.stack&&console.warn(`stack trace: ${D.stack}`),A&&(0,T.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const F=t.indexOf(A);F>=0&&t.splice(F,1)}),process.on("uncaughtException",function(A){(0,T.onUnexpectedError)(A)}),I.mark("code/extHost/willConnectToRenderer");const r=await l();I.mark("code/extHost/didConnectToRenderer");const i=await E(r);I.mark("code/extHost/didWaitForInitData");const{initData:a}=i;o(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,d.boolean)(P.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(F){_(F)}exists(F){return v.Promises.exists(F)}realpath(F){return(0,b.realpath)(F)}};let h=null;a.remote.authority&&P.transformURIs&&(h=(0,p.createURITransformer)(a.remote.authority));const w=new O.ExtensionHostMain(i.protocol,a,m,h);c=A=>w.terminate(A)}e.startExtensionHostProcess=s,s().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/45b4204501ac1f50b6231af3c996d35f86359ecd/core/vs/workbench/api/node/extensionHostProcess.js.map
