/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],be=function(Z){for(var e=[],s=0,I=Z.length;s<I;s++)e[s]=we[Z[s]];return e};define(we[42],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=s}),define(we[70],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function I(N){const p=[];for(let d in N)s.call(N,d)&&p.push(N[d]);return p}e.values=I;function b(N,p){for(let d in N)if(s.call(N,d)&&p({key:d,value:N[d]},function(){delete N[d]})===!1)return}e.forEach=b;function B(N,p){const d=Object.create(null);for(const m of N){const l=p(m);let n=d[l];n||(n=d[l]=[]),n.push(m)}return d}e.groupBy=B;function D(N){const p=Object.create(null);return N&&N.forEach((d,m)=>{p[m]=d}),p}e.fromMap=D;function A(N,p){const d=[],m=[];for(let l of N)p.has(l)||d.push(l);for(let l of p)N.has(l)||m.push(l);return{removed:d,added:m}}e.diffSets=A;function y(N,p){const d=[],m=[];for(let[l,n]of N)p.has(l)||d.push(n);for(let[l,n]of p)N.has(l)||m.push(n);return{removed:d,added:m}}e.diffMaps=y;class F{constructor(){this.map=new Map}add(p,d){let m=this.map.get(p);m||(m=new Set,this.map.set(p,m)),m.add(d)}delete(p,d){const m=this.map.get(p);!m||(m.delete(d),m.size===0&&this.map.delete(p))}forEach(p,d){const m=this.map.get(p);!m||m.forEach(d)}}e.SetMap=F}),define(we[52],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(D){return(A,y,F)=>{let N=null,p=null;if(typeof F.value=="function"?(N="value",p=F.value):typeof F.get=="function"&&(N="get",p=F.get),!p)throw new Error("not supported");F[N]=D(p,y)}}e.createDecorator=s;function I(D,A,y){let F=null,N=null;if(typeof y.value=="function"?(F="value",N=y.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(F="get",N=y.get),!N)throw new Error("not supported");const p=`$memoize$${A}`;y[F]=function(...d){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,d)}),this[p]}}e.memoize=I;function b(D,A,y){return s((F,N)=>{const p=`$debounce$${N}`,d=`$debounce$result$${N}`;return function(...m){this[d]||(this[d]=y?y():void 0),clearTimeout(this[p]),A&&(this[d]=A(this[d],...m),m=[this[d]]),this[p]=setTimeout(()=>{F.apply(this,m),this[d]=y?y():void 0},D)}})}e.debounce=b;function B(D,A,y){return s((F,N)=>{const p=`$throttle$timer$${N}`,d=`$throttle$result$${N}`,m=`$throttle$lastRun$${N}`,l=`$throttle$pending$${N}`;return function(...n){if(this[d]||(this[d]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),A&&(this[d]=A(this[d],...n)),this[l])return;const h=this[m]+D;h<=Date.now()?(this[m]=Date.now(),F.apply(this,[this[d]]),this[d]=y?y():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),F.apply(this,[this[d]]),this[d]=y?y():void 0},h-Date.now()))}})}e.throttle=B}),define(we[53],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(we[100],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var I;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var B;(function(o){o.DEFAULT={allowTrailingComma:!0}})(B=e.ParseOptions||(e.ParseOptions={}));function D(o,T=!1){let r=0,i=o.length,c="",t=0,a=16,g=0;function f(W){let q=0,K=0;for(;q<W;){const V=o.charCodeAt(r);if(V>=48&&V<=57)K=K*16+V-48;else if(V>=65&&V<=70)K=K*16+V-65+10;else if(V>=97&&V<=102)K=K*16+V-97+10;else break;r++,q++}return q<W&&(K=-1),K}function _(W){r=W,c="",t=0,a=16,g=0}function P(){const W=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&F(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&F(o.charCodeAt(r)))for(r++;r<o.length&&F(o.charCodeAt(r));)r++;else return g=3,o.substring(W,r);let q=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&F(o.charCodeAt(r))){for(r++;r<o.length&&F(o.charCodeAt(r));)r++;q=r}else g=3;return o.substring(W,q)}function $(){let W="",q=r;for(;;){if(r>=i){W+=o.substring(q,r),g=2;break}const K=o.charCodeAt(r);if(K===34){W+=o.substring(q,r),r++;break}if(K===92){if(W+=o.substring(q,r),r++,r>=i){g=2;break}switch(o.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const z=f(4);z>=0?W+=String.fromCharCode(z):g=4;break}default:g=5}q=r;continue}if(K>=0&&K<=31)if(y(K)){W+=o.substring(q,r),g=2;break}else g=6;r++}return W}function L(){if(c="",g=0,t=r,r>=i)return t=i,a=17;let W=o.charCodeAt(r);if(A(W)){do r++,c+=String.fromCharCode(W),W=o.charCodeAt(r);while(A(W));return a=15}if(y(W))return r++,c+=String.fromCharCode(W),W===13&&o.charCodeAt(r)===10&&(r++,c+=`
`),a=14;switch(W){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,c=$(),a=10;case 47:{const q=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!y(o.charCodeAt(r));)r++;return c=o.substring(q,r),a=12}if(o.charCodeAt(r+1)===42){r+=2;const K=i-1;let V=!1;for(;r<K;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,V=!0;break}r++}return V||(r++,g=1),c=o.substring(q,r),a=13}return c+=String.fromCharCode(W),r++,a=16}case 45:if(c+=String.fromCharCode(W),r++,r===i||!F(o.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),a=11;default:for(;r<i&&v(W);)r++,W=o.charCodeAt(r);if(t!==r){switch(c=o.substring(t,r),c){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return c+=String.fromCharCode(W),r++,a=16}}function v(W){if(A(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let W;do W=L();while(W>=12&&W<=15);return W}return{setPosition:_,getPosition:()=>r,scan:T?H:L,getToken:()=>a,getTokenValue:()=>c,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>g}}e.createScanner=D;function A(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function y(o){return o===10||o===13||o===8232||o===8233}function F(o){return o>=48&&o<=57}var N;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(N||(N={}));function p(o,T){const r=[],i=new Object;let c;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(f,_,P,$){t.value=f,t.offset=_,t.length=P,t.type=$,t.colonOffset=void 0,c=t}try{u(o,{onObjectBegin:(f,_)=>{if(T<=f)throw i;c=void 0,a=T>f,r.push("")},onObjectProperty:(f,_,P)=>{if(T<_||(g(f,_,P,"property"),r[r.length-1]=f,T<=_+P))throw i},onObjectEnd:(f,_)=>{if(T<=f)throw i;c=void 0,r.pop()},onArrayBegin:(f,_)=>{if(T<=f)throw i;c=void 0,r.push(0)},onArrayEnd:(f,_)=>{if(T<=f)throw i;c=void 0,r.pop()},onLiteralValue:(f,_,P)=>{if(T<_||(g(f,_,P,w(f)),T<=_+P))throw i},onSeparator:(f,_,P)=>{if(T<=_)throw i;if(f===":"&&c&&c.type==="property")c.colonOffset=_,a=!1,c=void 0;else if(f===","){const $=r[r.length-1];typeof $=="number"?r[r.length-1]=$+1:(a=!0,r[r.length-1]=""),c=void 0}}})}catch(f){if(f!==i)throw f}return{path:r,previousNode:c,isAtPropertyKey:a,matches:f=>{let _=0;for(let P=0;_<f.length&&P<r.length;P++)if(f[_]===r[P]||f[_]==="*")_++;else if(f[_]!=="**")return!1;return _===f.length}}}e.getLocation=p;function d(o,T=[],r=B.DEFAULT){let i=null,c=[];const t=[];function a(f){Array.isArray(c)?c.push(f):i!==null&&(c[i]=f)}return u(o,{onObjectBegin:()=>{const f={};a(f),t.push(c),c=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{c=t.pop()},onArrayBegin:()=>{const f=[];a(f),t.push(c),c=f,i=null},onArrayEnd:()=>{c=t.pop()},onLiteralValue:a,onError:(f,_,P)=>{T.push({error:f,offset:_,length:P})}},r),c[0]}e.parse=d;function m(o,T=[],r=B.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function t(f){return i.children.push(f),f}u(o,{onObjectBegin:f=>{i=t({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,_,P)=>{i=t({type:"property",offset:_,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:_,length:P,parent:i})},onObjectEnd:(f,_)=>{i.length=f+_-i.offset,i=i.parent,c(f+_)},onArrayBegin:(f,_)=>{i=t({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,_)=>{i.length=f+_-i.offset,i=i.parent,c(f+_)},onLiteralValue:(f,_,P)=>{t({type:w(f),offset:_,length:P,parent:i,value:f}),c(_+P)},onSeparator:(f,_,P)=>{i.type==="property"&&(f===":"?i.colonOffset=_:f===","&&c(_))},onError:(f,_,P)=>{T.push({error:f,offset:_,length:P})}},r);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=m;function l(o,T){if(!o)return;let r=o;for(let i of T)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===i){r=t.children[1],c=!0;break}if(!c)return}else{const c=i;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=l;function n(o){if(!o.parent||!o.parent.children)return[];const T=n(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;T.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&T.push(r)}return T}e.getNodePath=n;function h(o){switch(o.type){case"array":return o.children.map(h);case"object":{const T=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(T[r.children[0].value]=h(i))}return T}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=h;function S(o,T,r=!1){return T>=o.offset&&T<o.offset+o.length||r&&T===o.offset+o.length}e.contains=S;function k(o,T,r=!1){if(S(o,T,r)){const i=o.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=T;c++){const t=k(i[c],T,r);if(t)return t}return o}}e.findNodeAtOffset=k;function u(o,T,r=B.DEFAULT){const i=D(o,!1);function c(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(he){return he?ue=>he(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=c(T.onObjectBegin),g=t(T.onObjectProperty),f=c(T.onObjectEnd),_=c(T.onArrayBegin),P=c(T.onArrayEnd),$=t(T.onLiteralValue),L=t(T.onSeparator),v=c(T.onComment),H=t(T.onError),W=r&&r.disallowComments,q=r&&r.allowTrailingComma;function K(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:W||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(he){case 12:case 13:W?V(10):v();break;case 16:V(1);break;case 15:case 14:break;default:return he}}}function V(he,ue=[],re=[]){if(H(he),ue.length+re.length>0){let ge=i.getToken();for(;ge!==17;){if(ue.indexOf(ge)!==-1){K();break}else if(re.indexOf(ge)!==-1)break;ge=K()}}}function z(he){const ue=i.getTokenValue();return he?$(ue):g(ue),K(),!0}function ae(){switch(i.getToken()){case 11:{let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(V(2),he=0)}catch{V(2)}$(he);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return K(),!0}function de(){return i.getToken()!==10?(V(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(L(":"),K(),ce()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Y(){a(),K();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||V(4,[],[]),L(","),K(),i.getToken()===2&&q)break}else he&&V(6,[],[]);de()||V(4,[],[2,5]),he=!0}return f(),i.getToken()!==2?V(7,[2],[]):K(),!0}function ie(){_(),K();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||V(4,[],[]),L(","),K(),i.getToken()===4&&q)break}else he&&V(6,[],[]);ce()||V(4,[],[4,5]),he=!0}return P(),i.getToken()!==4?V(8,[4],[]):K(),!0}function ce(){switch(i.getToken()){case 3:return ie();case 1:return Y();case 10:return z(!0);default:return ae()}}return K(),i.getToken()===17?r.allowEmptyContent?!0:(V(4,[],[]),!1):ce()?(i.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=u;function E(o,T){let r=D(o),i=[],c,t=0,a;do switch(a=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:t!==a&&i.push(o.substring(t,a)),T!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,T)),t=r.getPosition();break}while(c!==17);return i.join("")}e.stripComments=E;function w(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[101],be([0]),e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ve,fe){for(var M=0;M<fe.length;M++){var O=fe[M];O.enumerable=O.enumerable||!1,O.configurable=!0,"value"in O&&(O.writable=!0),Object.defineProperty(ve,O.key,O)}}function s(ve,fe,M){return fe&&e(ve.prototype,fe),M&&e(ve,M),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function I(ve,fe){if(!!ve){if(typeof ve=="string")return b(ve,fe);var M=Object.prototype.toString.call(ve).slice(8,-1);if(M==="Object"&&ve.constructor&&(M=ve.constructor.name),M==="Map"||M==="Set")return Array.from(ve);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return b(ve,fe)}}function b(ve,fe){(fe==null||fe>ve.length)&&(fe=ve.length);for(var M=0,O=new Array(fe);M<fe;M++)O[M]=ve[M];return O}function B(ve,fe){var M=typeof Symbol!="undefined"&&ve[Symbol.iterator]||ve["@@iterator"];if(M)return(M=M.call(ve)).next.bind(M);if(Array.isArray(ve)||(M=I(ve))||fe&&ve&&typeof ve.length=="number"){M&&(ve=M);var O=0;return function(){return O>=ve.length?{done:!0}:{done:!1,value:ve[O++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=D();function A(ve){Z.defaults=ve}var y=/[&<>"']/,F=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,p=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(fe){return d[fe]};function l(ve,fe){if(fe){if(y.test(ve))return ve.replace(F,m)}else if(N.test(ve))return ve.replace(p,m);return ve}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(ve){return ve.replace(n,function(fe,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var S=/(^|[^\[])\^/g;function k(ve,fe){ve=ve.source||ve,fe=fe||"";var M={replace:function(C,R){return R=R.source||R,R=R.replace(S,"$1"),ve=ve.replace(C,R),M},getRegex:function(){return new RegExp(ve,fe)}};return M}var u=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(ve,fe,M){if(ve){var O;try{O=decodeURIComponent(h(M)).replace(u,"").toLowerCase()}catch{return null}if(O.indexOf("javascript:")===0||O.indexOf("vbscript:")===0||O.indexOf("data:")===0)return null}fe&&!E.test(M)&&(M=c(fe,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var o={},T=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ve,fe){o[" "+ve]||(T.test(ve)?o[" "+ve]=ve+"/":o[" "+ve]=f(ve,"/",!0)),ve=o[" "+ve];var M=ve.indexOf(":")===-1;return fe.substring(0,2)==="//"?M?fe:ve.replace(r,"$1")+fe:fe.charAt(0)==="/"?M?fe:ve.replace(i,"$1")+fe:ve+fe}var t={exec:function(){}};function a(ve){for(var fe=1,M,O;fe<arguments.length;fe++){M=arguments[fe];for(O in M)Object.prototype.hasOwnProperty.call(M,O)&&(ve[O]=M[O])}return ve}function g(ve,fe){var M=ve.replace(/\|/g,function(R,x,Q){for(var ne=!1,Ee=x;--Ee>=0&&Q[Ee]==="\\";)ne=!ne;return ne?"|":" |"}),O=M.split(/ \|/),C=0;if(O[0].trim()||O.shift(),O[O.length-1].trim()||O.pop(),O.length>fe)O.splice(fe);else for(;O.length<fe;)O.push("");for(;C<O.length;C++)O[C]=O[C].trim().replace(/\\\|/g,"|");return O}function f(ve,fe,M){var O=ve.length;if(O===0)return"";for(var C=0;C<O;){var R=ve.charAt(O-C-1);if(R===fe&&!M)C++;else if(R!==fe&&M)C++;else break}return ve.substr(0,O-C)}function _(ve,fe){if(ve.indexOf(fe[1])===-1)return-1;for(var M=ve.length,O=0,C=0;C<M;C++)if(ve[C]==="\\")C++;else if(ve[C]===fe[0])O++;else if(ve[C]===fe[1]&&(O--,O<0))return C;return-1}function P(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(ve,fe){if(fe<1)return"";for(var M="";fe>1;)fe&1&&(M+=ve),fe>>=1,ve+=ve;return M+ve}function L(ve,fe,M,O){var C=fe.href,R=fe.title?l(fe.title):null,x=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){O.state.inLink=!0;var Q={type:"link",raw:M,href:C,title:R,text:x,tokens:O.inlineTokens(x,[])};return O.state.inLink=!1,Q}else return{type:"image",raw:M,href:C,title:R,text:l(x)}}function v(ve,fe){var M=ve.match(/^(\s+)(?:```)/);if(M===null)return fe;var O=M[1];return fe.split(`
`).map(function(C){var R=C.match(/^\s+/);if(R===null)return C;var x=R[0];return x.length>=O.length?C.slice(O.length):C}).join(`
`)}var H=function(){function ve(M){this.options=M||Z.defaults}var fe=ve.prototype;return fe.space=function(O){var C=this.rules.block.newline.exec(O);if(C&&C[0].length>0)return{type:"space",raw:C[0]}},fe.code=function(O){var C=this.rules.block.code.exec(O);if(C){var R=C[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:C[0],codeBlockStyle:"indented",text:this.options.pedantic?R:f(R,`
`)}}},fe.fences=function(O){var C=this.rules.block.fences.exec(O);if(C){var R=C[0],x=v(R,C[3]||"");return{type:"code",raw:R,lang:C[2]?C[2].trim():C[2],text:x}}},fe.heading=function(O){var C=this.rules.block.heading.exec(O);if(C){var R=C[2].trim();if(/#$/.test(R)){var x=f(R,"#");(this.options.pedantic||!x||/ $/.test(x))&&(R=x.trim())}var Q={type:"heading",raw:C[0],depth:C[1].length,text:R,tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},fe.hr=function(O){var C=this.rules.block.hr.exec(O);if(C)return{type:"hr",raw:C[0]}},fe.blockquote=function(O){var C=this.rules.block.blockquote.exec(O);if(C){var R=C[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:C[0],tokens:this.lexer.blockTokens(R,[]),text:R}}},fe.list=function(O){var C=this.rules.block.list.exec(O);if(C){var R,x,Q,ne,Ee,Ie,Me,Le,ze,Be,Ae,Qe,tt=C[1].trim(),ke=tt.length>1,it={type:"list",raw:"",ordered:ke,start:ke?+tt.slice(0,-1):"",loose:!1,items:[]};tt=ke?"\\d{1,9}\\"+tt.slice(-1):"\\"+tt,this.options.pedantic&&(tt=ke?tt:"[*+-]");for(var X=new RegExp("^( {0,3}"+tt+")((?: [^\\n]*)?(?:\\n|$))");O&&(Qe=!1,!(!(C=X.exec(O))||this.rules.block.hr.test(O)));){if(R=C[0],O=O.substring(R.length),Le=C[2].split(`
`,1)[0],ze=O.split(`
`,1)[0],this.options.pedantic?(ne=2,Ae=Le.trimLeft()):(ne=C[2].search(/[^ ]/),ne=ne>4?1:ne,Ae=Le.slice(ne),ne+=C[1].length),Ie=!1,!Le&&/^ *$/.test(ze)&&(R+=ze+`
`,O=O.substring(ze.length+1),Qe=!0),!Qe)for(var J=new RegExp("^ {0,"+Math.min(3,ne-1)+"}(?:[*+-]|\\d{1,9}[.)])");O&&(Be=O.split(`
`,1)[0],Le=Be,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!J.test(Le));){if(Le.search(/[^ ]/)>=ne||!Le.trim())Ae+=`
`+Le.slice(ne);else if(!Ie)Ae+=`
`+Le;else break;!Ie&&!Le.trim()&&(Ie=!0),R+=Be+`
`,O=O.substring(Be.length+1)}it.loose||(Me?it.loose=!0:/\n *\n *$/.test(R)&&(Me=!0)),this.options.gfm&&(x=/^\[[ xX]\] /.exec(Ae),x&&(Q=x[0]!=="[ ] ",Ae=Ae.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:R,task:!!x,checked:Q,loose:!1,text:Ae}),it.raw+=R}it.items[it.items.length-1].raw=R.trimRight(),it.items[it.items.length-1].text=Ae.trimRight(),it.raw=it.raw.trimRight();var le=it.items.length;for(Ee=0;Ee<le;Ee++){this.lexer.state.top=!1,it.items[Ee].tokens=this.lexer.blockTokens(it.items[Ee].text,[]);var Oe=it.items[Ee].tokens.filter(function(Ge){return Ge.type==="space"}),$e=Oe.every(function(Ge){for(var Je=Ge.raw.split(""),ft=0,It=B(Je),St;!(St=It()).done;){var kt=St.value;if(kt===`
`&&(ft+=1),ft>1)return!0}return!1});!it.loose&&Oe.length&&$e&&(it.loose=!0,it.items[Ee].loose=!0)}return it}},fe.html=function(O){var C=this.rules.block.html.exec(O);if(C){var R={type:"html",raw:C[0],pre:!this.options.sanitizer&&(C[1]==="pre"||C[1]==="script"||C[1]==="style"),text:C[0]};return this.options.sanitize&&(R.type="paragraph",R.text=this.options.sanitizer?this.options.sanitizer(C[0]):l(C[0]),R.tokens=[],this.lexer.inline(R.text,R.tokens)),R}},fe.def=function(O){var C=this.rules.block.def.exec(O);if(C){C[3]&&(C[3]=C[3].substring(1,C[3].length-1));var R=C[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:R,raw:C[0],href:C[2],title:C[3]}}},fe.table=function(O){var C=this.rules.block.table.exec(O);if(C){var R={type:"table",header:g(C[1]).map(function(Me){return{text:Me}}),align:C[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:C[3]?C[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(R.header.length===R.align.length){R.raw=C[0];var x=R.align.length,Q,ne,Ee,Ie;for(Q=0;Q<x;Q++)/^ *-+: *$/.test(R.align[Q])?R.align[Q]="right":/^ *:-+: *$/.test(R.align[Q])?R.align[Q]="center":/^ *:-+ *$/.test(R.align[Q])?R.align[Q]="left":R.align[Q]=null;for(x=R.rows.length,Q=0;Q<x;Q++)R.rows[Q]=g(R.rows[Q],R.header.length).map(function(Me){return{text:Me}});for(x=R.header.length,ne=0;ne<x;ne++)R.header[ne].tokens=[],this.lexer.inlineTokens(R.header[ne].text,R.header[ne].tokens);for(x=R.rows.length,ne=0;ne<x;ne++)for(Ie=R.rows[ne],Ee=0;Ee<Ie.length;Ee++)Ie[Ee].tokens=[],this.lexer.inlineTokens(Ie[Ee].text,Ie[Ee].tokens);return R}}},fe.lheading=function(O){var C=this.rules.block.lheading.exec(O);if(C){var R={type:"heading",raw:C[0],depth:C[2].charAt(0)==="="?1:2,text:C[1],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},fe.paragraph=function(O){var C=this.rules.block.paragraph.exec(O);if(C){var R={type:"paragraph",raw:C[0],text:C[1].charAt(C[1].length-1)===`
`?C[1].slice(0,-1):C[1],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},fe.text=function(O){var C=this.rules.block.text.exec(O);if(C){var R={type:"text",raw:C[0],text:C[0],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},fe.escape=function(O){var C=this.rules.inline.escape.exec(O);if(C)return{type:"escape",raw:C[0],text:l(C[1])}},fe.tag=function(O){var C=this.rules.inline.tag.exec(O);if(C)return!this.lexer.state.inLink&&/^<a /i.test(C[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(C[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(C[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(C[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:C[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):l(C[0]):C[0]}},fe.link=function(O){var C=this.rules.inline.link.exec(O);if(C){var R=C[2].trim();if(!this.options.pedantic&&/^</.test(R)){if(!/>$/.test(R))return;var x=f(R.slice(0,-1),"\\");if((R.length-x.length)%2==0)return}else{var Q=_(C[2],"()");if(Q>-1){var ne=C[0].indexOf("!")===0?5:4,Ee=ne+C[1].length+Q;C[2]=C[2].substring(0,Q),C[0]=C[0].substring(0,Ee).trim(),C[3]=""}}var Ie=C[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);Le&&(Ie=Le[1],Me=Le[3])}else Me=C[3]?C[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(R)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),L(C,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},C[0],this.lexer)}},fe.reflink=function(O,C){var R;if((R=this.rules.inline.reflink.exec(O))||(R=this.rules.inline.nolink.exec(O))){var x=(R[2]||R[1]).replace(/\s+/g," ");if(x=C[x.toLowerCase()],!x||!x.href){var Q=R[0].charAt(0);return{type:"text",raw:Q,text:Q}}return L(R,x,R[0],this.lexer)}},fe.emStrong=function(O,C,R){R===void 0&&(R="");var x=this.rules.inline.emStrong.lDelim.exec(O);if(!!x&&!(x[3]&&R.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Q=x[1]||x[2]||"";if(!Q||Q&&(R===""||this.rules.inline.punctuation.exec(R))){var ne=x[0].length-1,Ee,Ie,Me=ne,Le=0,ze=x[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,C=C.slice(-1*O.length+ne);(x=ze.exec(C))!=null;)if(Ee=x[1]||x[2]||x[3]||x[4]||x[5]||x[6],!!Ee){if(Ie=Ee.length,x[3]||x[4]){Me+=Ie;continue}else if((x[5]||x[6])&&ne%3&&!((ne+Ie)%3)){Le+=Ie;continue}if(Me-=Ie,!(Me>0)){if(Ie=Math.min(Ie,Ie+Me+Le),Math.min(ne,Ie)%2){var Be=O.slice(1,ne+x.index+Ie);return{type:"em",raw:O.slice(0,ne+x.index+Ie+1),text:Be,tokens:this.lexer.inlineTokens(Be,[])}}var Ae=O.slice(2,ne+x.index+Ie-1);return{type:"strong",raw:O.slice(0,ne+x.index+Ie+1),text:Ae,tokens:this.lexer.inlineTokens(Ae,[])}}}}}},fe.codespan=function(O){var C=this.rules.inline.code.exec(O);if(C){var R=C[2].replace(/\n/g," "),x=/[^ ]/.test(R),Q=/^ /.test(R)&&/ $/.test(R);return x&&Q&&(R=R.substring(1,R.length-1)),R=l(R,!0),{type:"codespan",raw:C[0],text:R}}},fe.br=function(O){var C=this.rules.inline.br.exec(O);if(C)return{type:"br",raw:C[0]}},fe.del=function(O){var C=this.rules.inline.del.exec(O);if(C)return{type:"del",raw:C[0],text:C[2],tokens:this.lexer.inlineTokens(C[2],[])}},fe.autolink=function(O,C){var R=this.rules.inline.autolink.exec(O);if(R){var x,Q;return R[2]==="@"?(x=l(this.options.mangle?C(R[1]):R[1]),Q="mailto:"+x):(x=l(R[1]),Q=x),{type:"link",raw:R[0],text:x,href:Q,tokens:[{type:"text",raw:x,text:x}]}}},fe.url=function(O,C){var R;if(R=this.rules.inline.url.exec(O)){var x,Q;if(R[2]==="@")x=l(this.options.mangle?C(R[0]):R[0]),Q="mailto:"+x;else{var ne;do ne=R[0],R[0]=this.rules.inline._backpedal.exec(R[0])[0];while(ne!==R[0]);x=l(R[0]),R[1]==="www."?Q="http://"+x:Q=x}return{type:"link",raw:R[0],text:x,href:Q,tokens:[{type:"text",raw:x,text:x}]}}},fe.inlineText=function(O,C){var R=this.rules.inline.text.exec(O);if(R){var x;return this.lexer.state.inRawBlock?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):l(R[0]):R[0]:x=l(this.options.smartypants?C(R[0]):R[0]),{type:"text",raw:R[0],text:x}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=k(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=k(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=k(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=k(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=k(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=k(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=a({},W),W.gfm=a({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=k(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=k(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=a({},W.normal,{html:k(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:k(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=k(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=k(W._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=k(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=k(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=k(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=k(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=k(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=k(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=k(q.reflink).replace("label",q._label).replace("ref",W._label).getRegex(),q.nolink=k(q.nolink).replace("ref",W._label).getRegex(),q.reflinkSearch=k(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=a({},q),q.pedantic=a({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:k(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:k(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=a({},q.normal,{escape:k(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=k(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=a({},q.gfm,{br:k(q.br).replace("{2,}","*").getRegex(),text:k(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ve){var fe="",M,O,C=ve.length;for(M=0;M<C;M++)O=ve.charCodeAt(M),Math.random()>.5&&(O="x"+O.toString(16)),fe+="&#"+O+";";return fe}var z=function(){function ve(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||Z.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var O={block:W.normal,inline:q.normal};this.options.pedantic?(O.block=W.pedantic,O.inline=q.pedantic):this.options.gfm&&(O.block=W.gfm,this.options.breaks?O.inline=q.breaks:O.inline=q.gfm),this.tokenizer.rules=O}ve.lex=function(O,C){var R=new ve(C);return R.lex(O)},ve.lexInline=function(O,C){var R=new ve(C);return R.inlineTokens(O)};var fe=ve.prototype;return fe.lex=function(O){O=O.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(O,this.tokens);for(var C;C=this.inlineQueue.shift();)this.inlineTokens(C.src,C.tokens);return this.tokens},fe.blockTokens=function(O,C){var R=this;C===void 0&&(C=[]),this.options.pedantic&&(O=O.replace(/^ +$/gm,""));for(var x,Q,ne,Ee;O;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(x=Me.call({lexer:R},O,C))?(O=O.substring(x.raw.length),C.push(x),!0):!1}))){if(x=this.tokenizer.space(O)){O=O.substring(x.raw.length),x.raw.length===1&&C.length>0?C[C.length-1].raw+=`
`:C.push(x);continue}if(x=this.tokenizer.code(O)){O=O.substring(x.raw.length),Q=C[C.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):C.push(x);continue}if(x=this.tokenizer.fences(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.heading(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.hr(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.blockquote(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.list(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.html(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.def(O)){O=O.substring(x.raw.length),Q=C[C.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.raw,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):this.tokens.links[x.tag]||(this.tokens.links[x.tag]={href:x.href,title:x.title});continue}if(x=this.tokenizer.table(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.lheading(O)){O=O.substring(x.raw.length),C.push(x);continue}if(ne=O,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=O.slice(1),ze=void 0;R.options.extensions.startBlock.forEach(function(Be){ze=Be.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(ne=O.substring(0,Me+1))}(),this.state.top&&(x=this.tokenizer.paragraph(ne))){Q=C[C.length-1],Ee&&Q.type==="paragraph"?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):C.push(x),Ee=ne.length!==O.length,O=O.substring(x.raw.length);continue}if(x=this.tokenizer.text(O)){O=O.substring(x.raw.length),Q=C[C.length-1],Q&&Q.type==="text"?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):C.push(x);continue}if(O){var Ie="Infinite loop on byte: "+O.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,C},fe.inline=function(O,C){this.inlineQueue.push({src:O,tokens:C})},fe.inlineTokens=function(O,C){var R=this;C===void 0&&(C=[]);var x,Q,ne,Ee=O,Ie,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Ie.index)+"["+$("a",Ie[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Ie.index)+"["+$("a",Ie[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Ie.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;O;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ae){return(x=Ae.call({lexer:R},O,C))?(O=O.substring(x.raw.length),C.push(x),!0):!1}))){if(x=this.tokenizer.escape(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.tag(O)){O=O.substring(x.raw.length),Q=C[C.length-1],Q&&x.type==="text"&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):C.push(x);continue}if(x=this.tokenizer.link(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.reflink(O,this.tokens.links)){O=O.substring(x.raw.length),Q=C[C.length-1],Q&&x.type==="text"&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):C.push(x);continue}if(x=this.tokenizer.emStrong(O,Ee,Le)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.codespan(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.br(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.del(O)){O=O.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.autolink(O,V)){O=O.substring(x.raw.length),C.push(x);continue}if(!this.state.inLink&&(x=this.tokenizer.url(O,V))){O=O.substring(x.raw.length),C.push(x);continue}if(ne=O,this.options.extensions&&this.options.extensions.startInline&&function(){var Ae=1/0,Qe=O.slice(1),tt=void 0;R.options.extensions.startInline.forEach(function(ke){tt=ke.call({lexer:this},Qe),typeof tt=="number"&&tt>=0&&(Ae=Math.min(Ae,tt))}),Ae<1/0&&Ae>=0&&(ne=O.substring(0,Ae+1))}(),x=this.tokenizer.inlineText(ne,K)){O=O.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(Le=x.raw.slice(-1)),Me=!0,Q=C[C.length-1],Q&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):C.push(x);continue}if(O){var Be="Infinite loop on byte: "+O.charCodeAt(0);if(this.options.silent){console.error(Be);break}else throw new Error(Be)}}return C},s(ve,null,[{key:"rules",get:function(){return{block:W,inline:q}}}]),ve}(),ae=function(){function ve(M){this.options=M||Z.defaults}var fe=ve.prototype;return fe.code=function(O,C,R){var x=(C||"").match(/\S*/)[0];if(this.options.highlight){var Q=this.options.highlight(O,x);Q!=null&&Q!==O&&(R=!0,O=Q)}return O=O.replace(/\n$/,"")+`
`,x?'<pre><code class="'+this.options.langPrefix+l(x,!0)+'">'+(R?O:l(O,!0))+`</code></pre>
`:"<pre><code>"+(R?O:l(O,!0))+`</code></pre>
`},fe.blockquote=function(O){return`<blockquote>
`+O+`</blockquote>
`},fe.html=function(O){return O},fe.heading=function(O,C,R,x){return this.options.headerIds?"<h"+C+' id="'+this.options.headerPrefix+x.slug(R)+'">'+O+"</h"+C+`>
`:"<h"+C+">"+O+"</h"+C+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(O,C,R){var x=C?"ol":"ul",Q=C&&R!==1?' start="'+R+'"':"";return"<"+x+Q+`>
`+O+"</"+x+`>
`},fe.listitem=function(O){return"<li>"+O+`</li>
`},fe.checkbox=function(O){return"<input "+(O?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(O){return"<p>"+O+`</p>
`},fe.table=function(O,C){return C&&(C="<tbody>"+C+"</tbody>"),`<table>
<thead>
`+O+`</thead>
`+C+`</table>
`},fe.tablerow=function(O){return`<tr>
`+O+`</tr>
`},fe.tablecell=function(O,C){var R=C.header?"th":"td",x=C.align?"<"+R+' align="'+C.align+'">':"<"+R+">";return x+O+"</"+R+`>
`},fe.strong=function(O){return"<strong>"+O+"</strong>"},fe.em=function(O){return"<em>"+O+"</em>"},fe.codespan=function(O){return"<code>"+O+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(O){return"<del>"+O+"</del>"},fe.link=function(O,C,R){if(O=w(this.options.sanitize,this.options.baseUrl,O),O===null)return R;var x='<a href="'+l(O)+'"';return C&&(x+=' title="'+C+'"'),x+=">"+R+"</a>",x},fe.image=function(O,C,R){if(O=w(this.options.sanitize,this.options.baseUrl,O),O===null)return R;var x='<img src="'+O+'" alt="'+R+'"';return C&&(x+=' title="'+C+'"'),x+=this.options.xhtml?"/>":">",x},fe.text=function(O){return O},ve}(),de=function(){function ve(){}var fe=ve.prototype;return fe.strong=function(O){return O},fe.em=function(O){return O},fe.codespan=function(O){return O},fe.del=function(O){return O},fe.html=function(O){return O},fe.text=function(O){return O},fe.link=function(O,C,R){return""+R},fe.image=function(O,C,R){return""+R},fe.br=function(){return""},ve}(),Y=function(){function ve(){this.seen={}}var fe=ve.prototype;return fe.serialize=function(O){return O.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(O,C){var R=O,x=0;if(this.seen.hasOwnProperty(R)){x=this.seen[O];do x++,R=O+"-"+x;while(this.seen.hasOwnProperty(R))}return C||(this.seen[O]=x,this.seen[R]=0),R},fe.slug=function(O,C){C===void 0&&(C={});var R=this.serialize(O);return this.getNextSafeSlug(R,C.dryrun)},ve}(),ie=function(){function ve(M){this.options=M||Z.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new Y}ve.parse=function(O,C){var R=new ve(C);return R.parse(O)},ve.parseInline=function(O,C){var R=new ve(C);return R.parseInline(O)};var fe=ve.prototype;return fe.parse=function(O,C){C===void 0&&(C=!0);var R="",x,Q,ne,Ee,Ie,Me,Le,ze,Be,Ae,Qe,tt,ke,it,X,J,le,Oe,$e,Ge=O.length;for(x=0;x<Ge;x++){if(Ae=O[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&($e=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ae.type))){R+=$e||"";continue}switch(Ae.type){case"space":continue;case"hr":{R+=this.renderer.hr();continue}case"heading":{R+=this.renderer.heading(this.parseInline(Ae.tokens),Ae.depth,h(this.parseInline(Ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{R+=this.renderer.code(Ae.text,Ae.lang,Ae.escaped);continue}case"table":{for(ze="",Le="",Ee=Ae.header.length,Q=0;Q<Ee;Q++)Le+=this.renderer.tablecell(this.parseInline(Ae.header[Q].tokens),{header:!0,align:Ae.align[Q]});for(ze+=this.renderer.tablerow(Le),Be="",Ee=Ae.rows.length,Q=0;Q<Ee;Q++){for(Me=Ae.rows[Q],Le="",Ie=Me.length,ne=0;ne<Ie;ne++)Le+=this.renderer.tablecell(this.parseInline(Me[ne].tokens),{header:!1,align:Ae.align[ne]});Be+=this.renderer.tablerow(Le)}R+=this.renderer.table(ze,Be);continue}case"blockquote":{Be=this.parse(Ae.tokens),R+=this.renderer.blockquote(Be);continue}case"list":{for(Qe=Ae.ordered,tt=Ae.start,ke=Ae.loose,Ee=Ae.items.length,Be="",Q=0;Q<Ee;Q++)X=Ae.items[Q],J=X.checked,le=X.task,it="",X.task&&(Oe=this.renderer.checkbox(J),ke?X.tokens.length>0&&X.tokens[0].type==="paragraph"?(X.tokens[0].text=Oe+" "+X.tokens[0].text,X.tokens[0].tokens&&X.tokens[0].tokens.length>0&&X.tokens[0].tokens[0].type==="text"&&(X.tokens[0].tokens[0].text=Oe+" "+X.tokens[0].tokens[0].text)):X.tokens.unshift({type:"text",text:Oe}):it+=Oe),it+=this.parse(X.tokens,ke),Be+=this.renderer.listitem(it,le,J);R+=this.renderer.list(Be,Qe,tt);continue}case"html":{R+=this.renderer.html(Ae.text);continue}case"paragraph":{R+=this.renderer.paragraph(this.parseInline(Ae.tokens));continue}case"text":{for(Be=Ae.tokens?this.parseInline(Ae.tokens):Ae.text;x+1<Ge&&O[x+1].type==="text";)Ae=O[++x],Be+=`
`+(Ae.tokens?this.parseInline(Ae.tokens):Ae.text);R+=C?this.renderer.paragraph(Be):Be;continue}default:{var Je='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return R},fe.parseInline=function(O,C){C=C||this.renderer;var R="",x,Q,ne,Ee=O.length;for(x=0;x<Ee;x++){if(Q=O[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(ne=this.options.extensions.renderers[Q.type].call({parser:this},Q),ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Q.type))){R+=ne||"";continue}switch(Q.type){case"escape":{R+=C.text(Q.text);break}case"html":{R+=C.html(Q.text);break}case"link":{R+=C.link(Q.href,Q.title,this.parseInline(Q.tokens,C));break}case"image":{R+=C.image(Q.href,Q.title,Q.text);break}case"strong":{R+=C.strong(this.parseInline(Q.tokens,C));break}case"em":{R+=C.em(this.parseInline(Q.tokens,C));break}case"codespan":{R+=C.codespan(Q.text);break}case"br":{R+=C.br();break}case"del":{R+=C.del(this.parseInline(Q.tokens,C));break}case"text":{R+=C.text(Q.text);break}default:{var Ie='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return R},ve}();function ce(ve,fe,M){if(typeof ve=="undefined"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof fe=="function"&&(M=fe,fe=null),fe=a({},ce.defaults,fe||{}),P(fe),M){var O=fe.highlight,C;try{C=z.lex(ve,fe)}catch(ne){return M(ne)}var R=function(Ee){var Ie;if(!Ee)try{fe.walkTokens&&ce.walkTokens(C,fe.walkTokens),Ie=ie.parse(C,fe)}catch(Me){Ee=Me}return fe.highlight=O,Ee?M(Ee):M(null,Ie)};if(!O||O.length<3||(delete fe.highlight,!C.length))return R();var x=0;ce.walkTokens(C,function(ne){ne.type==="code"&&(x++,setTimeout(function(){O(ne.text,ne.lang,function(Ee,Ie){if(Ee)return R(Ee);Ie!=null&&Ie!==ne.text&&(ne.text=Ie,ne.escaped=!0),x--,x===0&&R()})},0))}),x===0&&R();return}try{var Q=z.lex(ve,fe);return fe.walkTokens&&ce.walkTokens(Q,fe.walkTokens),ie.parse(Q,fe)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+l(ne.message+"",!0)+"</pre>";throw ne}}ce.options=ce.setOptions=function(ve){return a(ce.defaults,ve),A(ce.defaults),ce},ce.getDefaults=D,ce.defaults=Z.defaults,ce.use=function(){for(var ve=arguments.length,fe=new Array(ve),M=0;M<ve;M++)fe[M]=arguments[M];var O=a.apply(void 0,[{}].concat(fe)),C=ce.defaults.extensions||{renderers:{},childTokens:{}},R;fe.forEach(function(x){if(x.extensions&&(R=!0,x.extensions.forEach(function(ne){if(!ne.name)throw new Error("extension name required");if(ne.renderer){var Ee=C.renderers?C.renderers[ne.name]:null;Ee?C.renderers[ne.name]=function(){for(var Ie=arguments.length,Me=new Array(Ie),Le=0;Le<Ie;Le++)Me[Le]=arguments[Le];var ze=ne.renderer.apply(this,Me);return ze===!1&&(ze=Ee.apply(this,Me)),ze}:C.renderers[ne.name]=ne.renderer}if(ne.tokenizer){if(!ne.level||ne.level!=="block"&&ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");C[ne.level]?C[ne.level].unshift(ne.tokenizer):C[ne.level]=[ne.tokenizer],ne.start&&(ne.level==="block"?C.startBlock?C.startBlock.push(ne.start):C.startBlock=[ne.start]:ne.level==="inline"&&(C.startInline?C.startInline.push(ne.start):C.startInline=[ne.start]))}ne.childTokens&&(C.childTokens[ne.name]=ne.childTokens)})),x.renderer&&function(){var ne=ce.defaults.renderer||new ae,Ee=function(Le){var ze=ne[Le];ne[Le]=function(){for(var Be=arguments.length,Ae=new Array(Be),Qe=0;Qe<Be;Qe++)Ae[Qe]=arguments[Qe];var tt=x.renderer[Le].apply(ne,Ae);return tt===!1&&(tt=ze.apply(ne,Ae)),tt}};for(var Ie in x.renderer)Ee(Ie);O.renderer=ne}(),x.tokenizer&&function(){var ne=ce.defaults.tokenizer||new H,Ee=function(Le){var ze=ne[Le];ne[Le]=function(){for(var Be=arguments.length,Ae=new Array(Be),Qe=0;Qe<Be;Qe++)Ae[Qe]=arguments[Qe];var tt=x.tokenizer[Le].apply(ne,Ae);return tt===!1&&(tt=ze.apply(ne,Ae)),tt}};for(var Ie in x.tokenizer)Ee(Ie);O.tokenizer=ne}(),x.walkTokens){var Q=ce.defaults.walkTokens;O.walkTokens=function(ne){x.walkTokens.call(this,ne),Q&&Q.call(this,ne)}}R&&(O.extensions=C),ce.setOptions(O)})},ce.walkTokens=function(ve,fe){for(var M=function(){var x=C.value;switch(fe.call(ce,x),x.type){case"table":{for(var Q=B(x.header),ne;!(ne=Q()).done;){var Ee=ne.value;ce.walkTokens(Ee.tokens,fe)}for(var Ie=B(x.rows),Me;!(Me=Ie()).done;)for(var Le=Me.value,ze=B(Le),Be;!(Be=ze()).done;){var Ae=Be.value;ce.walkTokens(Ae.tokens,fe)}break}case"list":{ce.walkTokens(x.items,fe);break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[x.type]?ce.defaults.extensions.childTokens[x.type].forEach(function(Qe){ce.walkTokens(x[Qe],fe)}):x.tokens&&ce.walkTokens(x.tokens,fe)}},O=B(ve),C;!(C=O()).done;)M()},ce.parseInline=function(ve,fe){if(typeof ve=="undefined"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");fe=a({},ce.defaults,fe||{}),P(fe);try{var M=z.lexInline(ve,fe);return fe.walkTokens&&ce.walkTokens(M,fe.walkTokens),ie.parseInline(M,fe)}catch(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+l(O.message+"",!0)+"</pre>";throw O}},ce.Parser=ie,ce.parser=ie.parse,ce.Renderer=ae,ce.TextRenderer=de,ce.Lexer=z,ce.lexer=z.lex,ce.Tokenizer=H,ce.Slugger=Y,ce.parse=ce;var he=ce.options,ue=ce.setOptions,re=ce.use,ge=ce.walkTokens,Te=ce.parseInline,Re=ce,He=ie.parse,Xe=z.lex;Z.Lexer=z,Z.Parser=ie,Z.Renderer=ae,Z.Slugger=Y,Z.TextRenderer=de,Z.Tokenizer=H,Z.getDefaults=D,Z.lexer=Xe,Z.marked=ce,Z.options=he,Z.parse=Re,Z.parseInline=Te,Z.parser=He,Z.setOptions=ue,Z.use=re,Z.walkTokens=ge,Object.defineProperty(Z,"__esModule",{value:!0})}),define(we[102],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(A,y,F){return Math.min(Math.max(A,y),F)}e.clamp=s;function I(A,y){return(y+A%y)%y}e.rot=I;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class B{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=B;class D{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const F=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=F,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function Z(b){const B=[];typeof b=="number"&&B.push("code/timeOrigin",b);function D(y){B.push(y,Date.now())}function A(){const y=[];for(let F=0;F<B.length;F+=2)y.push({name:B[F],startTime:B[F+1]});return y}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const B=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))B.push({name:D.name,startTime:Math.round(b+D.startTime)});return B}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function s(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=s(I))}(),define(we[71],be([1,0,17]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var I;(function(p){p.text="text/plain",p.binary="application/octet-stream",p.unknown="application/unknown",p.markdown="text/markdown",p.latex="text/latex",p.uriList="text/uri-list"})(I=e.Mimes||(e.Mimes={}));const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(p){const d=(0,s.extname)(p),m=b[d.toLowerCase()];return m!==void 0?m:A(p)}e.getMediaOrTextMime=D;function A(p){const d=(0,s.extname)(p);return B[d.toLowerCase()]}e.getMediaMime=A;function y(p){for(const d in B)if(B[d]===p)return d}e.getExtensionForMimeType=y;const F=/^(.+)\/(.+?)(;.+)?$/;function N(p,d){const m=F.exec(p);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:d?void 0:p}e.normalizeMimeType=N}),define(we[103],be([1,0,15,6]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(E){const w=E;return w?typeof w.read=="function":!1}e.isReadable=b;function B(E){const w=E;return w?[w.on,w.pause,w.resume,w.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=B;function D(E){const w=E;return w?B(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(E,w){return new y(E,w)}e.newWriteableStream=A;class y{constructor(w,o){this.reducer=w,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(o=>o(w))}emitError(w){this.listeners.error.length===0?(0,s.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(o=>o(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,o){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(w,o){if(this.state.destroyed)return;let T;switch(w){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const r=T.indexOf(o);r>=0&&T.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function F(E,w){const o=[];let T;for(;(T=E.read())!==null;)o.push(T);return w(o)}e.consumeReadable=F;function N(E,w,o){const T=[];let r;for(;(r=E.read())!==null&&T.length<o;)T.push(r);return r===null&&T.length>0?w(T):{read:()=>{if(T.length>0)return T.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return E.read()}}}e.peekReadable=N;function p(E,w){return new Promise((o,T)=>{const r=[];d(E,{onData:i=>{w&&r.push(i)},onError:i=>{w?T(i):o(void 0)},onEnd:()=>{o(w?w(r):void 0)}})})}e.consumeStream=p;function d(E,w){let o=!1;return E.on("error",T=>{o||w.onError(T)}),E.on("end",()=>{o||w.onEnd()}),E.on("data",T=>{o||w.onData(T)}),(0,I.toDisposable)(()=>o=!0)}e.listenStream=d;function m(E,w){return new Promise((o,T)=>{const r=new I.DisposableStore,i=[],c=g=>{if(i.push(g),i.length>w)return r.dispose(),E.pause(),o({stream:E,buffer:i,ended:!1})},t=g=>T(g),a=()=>o({stream:E,buffer:i,ended:!0});r.add((0,I.toDisposable)(()=>E.removeListener("error",t))),E.on("error",t),r.add((0,I.toDisposable)(()=>E.removeListener("end",a))),E.on("end",a),r.add((0,I.toDisposable)(()=>E.removeListener("data",c))),E.on("data",c)})}e.peekStream=m;function l(E,w){const o=A(w);return o.end(E),o}e.toStream=l;function n(){const E=A(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=n;function h(E){let w=!1;return{read:()=>w?null:(w=!0,E)}}e.toReadable=h;function S(E,w,o){const T=A(o);return d(E,{onData:r=>T.write(w.data(r)),onError:r=>T.error(w.error?w.error(r):r),onEnd:()=>T.end()}),T}e.transform=S;function k(E,w,o){let T=!1;return{read:()=>{const r=w.read();return T?r:(T=!0,r!==null?o([E,r]):E)}}}e.prefixedReadable=k;function u(E,w,o){let T=!1;const r=A(o);return d(w,{onData:i=>T?r.write(i):(T=!0,r.write(o([E,i]))),onError:i=>r.error(i),onEnd:()=>{T||(T=!0,r.write(E)),r.end()}}),r}e.prefixedStream=u}),define(we[21],be([1,0,103]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,B;class D{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return I?new D(Buffer.allocUnsafe(g)):new D(new Uint8Array(g))}static wrap(g){return I&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new D(g)}static fromString(g,f){return!(f?.dontUseNodeBuffer||!1)&&I?new D(Buffer.from(g)):(b||(b=new TextEncoder),new D(b.encode(g)))}static fromByteArray(g){const f=D.alloc(g.length);for(let _=0,P=g.length;_<P;_++)f.buffer[_]=g[_];return f}static concat(g,f){if(typeof f=="undefined"){f=0;for(let $=0,L=g.length;$<L;$++)f+=g[$].byteLength}const _=D.alloc(f);let P=0;for(let $=0,L=g.length;$<L;$++){const v=g[$];_.set(v,P),P+=v.byteLength}return _}clone(){const g=D.alloc(this.byteLength);return g.set(this),g}toString(){return I?this.buffer.toString():(B||(B=new TextDecoder),B.decode(this.buffer))}slice(g,f){return new D(this.buffer.subarray(g,f))}set(g,f){if(g instanceof D)this.buffer.set(g.buffer,f);else if(g instanceof Uint8Array)this.buffer.set(g,f);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),f);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return F(this.buffer,g)}writeUInt32BE(g,f){N(this.buffer,g,f)}readUInt32LE(g){return p(this.buffer,g)}writeUInt32LE(g,f){d(this.buffer,g,f)}readUInt8(g){return m(this.buffer,g)}writeUInt8(g,f){l(this.buffer,g,f)}}e.VSBuffer=D;function A(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=A;function y(a,g,f){a[f+0]=g&255,g=g>>>8,a[f+1]=g&255}e.writeUInt16LE=y;function F(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=F;function N(a,g,f){a[f+3]=g,g=g>>>8,a[f+2]=g,g=g>>>8,a[f+1]=g,g=g>>>8,a[f]=g}e.writeUInt32BE=N;function p(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=p;function d(a,g,f){a[f+0]=g&255,g=g>>>8,a[f+1]=g&255,g=g>>>8,a[f+2]=g&255,g=g>>>8,a[f+3]=g&255}e.writeUInt32LE=d;function m(a,g){return a[g]}e.readUInt8=m;function l(a,g,f){a[f]=g}e.writeUInt8=l;function n(a){return s.consumeReadable(a,g=>D.concat(g))}e.readableToBuffer=n;function h(a){return s.toReadable(a)}e.bufferToReadable=h;function S(a){return s.consumeStream(a,g=>D.concat(g))}e.streamToBuffer=S;async function k(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await S(a.stream)])}e.bufferedStreamToBuffer=k;function u(a){return s.toStream(a,g=>D.concat(g))}e.bufferToStream=u;function E(a){return s.transform(a,{data:g=>typeof g=="string"?D.fromString(g):D.wrap(g)},g=>D.concat(g))}e.streamToBufferReadableStream=E;function w(a){return s.newWriteableStream(g=>D.concat(g),a)}e.newWriteableBufferStream=w;function o(a,g){return s.prefixedReadable(a,g,f=>D.concat(f))}e.prefixedBufferReadable=o;function T(a,g){return s.prefixedStream(a,g,f=>D.concat(f))}e.prefixedBufferStream=T;function r(a){let g=0,f=0,_=0;const P=new Uint8Array(Math.floor(a.length/4*3)),$=v=>{switch(f){case 3:P[_++]=g|v,f=0;break;case 2:P[_++]=g|v>>>2,g=v<<6,f=3;break;case 1:P[_++]=g|v>>>4,g=v<<4,f=2;break;default:g=v<<2,f=1}};for(let v=0;v<a.length;v++){const H=a.charCodeAt(v);if(H>=65&&H<=90)$(H-65);else if(H>=97&&H<=122)$(H-97+26);else if(H>=48&&H<=57)$(H-48+52);else if(H===43||H===45)$(62);else if(H===47||H===95)$(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${a[v]}`)}}const L=_;for(;f>0;)$(0);return D.wrap(P).slice(0,L)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:a},g=!0,f=!1){const _=f?c:i;let P="";const $=a.byteLength%3;let L=0;for(;L<a.byteLength-$;L+=3){const v=a[L+0],H=a[L+1],W=a[L+2];P+=_[v>>>2],P+=_[(v<<4|H>>>4)&63],P+=_[(H<<2|W>>>6)&63],P+=_[W&63]}if($===1){const v=a[L+0];P+=_[v>>>2],P+=_[v<<4&63],g&&(P+="==")}else if($===2){const v=a[L+0],H=a[L+1];P+=_[v>>>2],P+=_[(v<<4|H>>>4)&63],P+=_[H<<2&63],g&&(P+="=")}return P}e.encodeBase64=t});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[22],be([1,0,16,9]),function(Z,e,s,I){"use strict";var b,B,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(r,i,c){let t=r.get(i);return t===void 0&&(t=c,r.set(i,t)),t}e.getOrSet=A;function y(r){const i=[];return r.forEach((c,t)=>{i.push(`${t} => ${c}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=y;function F(r){const i=[];return r.forEach(c=>{i.push(c)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=F;class N{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const c=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return c-t}value(){return this._value[this._pos]}}e.StringIterator=N;class p{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class d{constructor(i=!0,c=!0){this._splitOnBackslash=i,this._caseSensitive=c}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let c=i.length-1;c>=0;c--,this._valueLen--){const t=this._value.charCodeAt(c);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var m;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,I.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class n{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(h||(h={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new l(i))}static forPaths(i=!1){return new S(new d(void 0,!i))}static forStrings(){return new S(new N)}static forConfigKeys(){return new S(new p)}clear(){this._root=void 0}fill(i,c){if(c){const t=c.slice(0);(0,s.shuffle)(t);for(let a of t)this.set(a,i)}else{const t=i.slice(0);(0,s.shuffle)(t);for(let a of t)this.set(a[0],a[1])}}set(i,c){const t=this._iter.reset(i);let a;this._root||(this._root=new n,this._root.segment=t.value());const g=[];for(a=this._root;;){const _=t.cmp(a.segment);if(_>0)a.left||(a.left=new n,a.left.segment=t.value()),g.push([-1,a]),a=a.left;else if(_<0)a.right||(a.right=new n,a.right.segment=t.value()),g.push([1,a]),a=a.right;else if(t.hasNext())t.next(),a.mid||(a.mid=new n,a.mid.segment=t.value()),g.push([0,a]),a=a.mid;else break}const f=a.value;a.value=c,a.key=i;for(let _=g.length-1;_>=0;_--){const P=g[_][1];P.updateHeight();const $=P.balanceFactor();if($<-1||$>1){const L=g[_][0],v=g[_+1][0];if(L===1&&v===1)g[_][1]=P.rotateLeft();else if(L===-1&&v===-1)g[_][1]=P.rotateRight();else if(L===1&&v===-1)P.right=g[_+1][1]=g[_+1][1].rotateRight(),g[_][1]=P.rotateLeft();else if(L===-1&&v===1)P.left=g[_+1][1]=g[_+1][1].rotateLeft(),g[_][1]=P.rotateRight();else throw new Error;if(_>0)switch(g[_-1][0]){case-1:g[_-1][1].left=g[_][1];break;case 1:g[_-1][1].right=g[_][1];break;case 0:g[_-1][1].mid=g[_][1];break}else this._root=g[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const c=this._iter.reset(i);let t=this._root;for(;t;){const a=c.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(c.hasNext())c.next(),t=t.mid;else break}return t}has(i){const c=this._getNode(i);return!(c?.value===void 0&&c?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,c){const t=this._iter.reset(i),a=[];let g=this._root;for(;g;){const f=t.cmp(g.segment);if(f>0)a.push([-1,g]),g=g.left;else if(f<0)a.push([1,g]),g=g.right;else if(t.hasNext())t.next(),a.push([0,g]),g=g.mid;else break}if(!!g){if(c?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const f=this._min(g.right),{key:_,value:P,segment:$}=f;this._delete(f.key,!1),g.key=_,g.value=P,g.segment=$}else{const f=g.left??g.right;if(a.length>0){const[_,P]=a[a.length-1];switch(_){case-1:P.left=f;break;case 0:P.mid=f;break;case 1:P.right=f;break}}else this._root=f}for(let f=a.length-1;f>=0;f--){const _=a[f][1];_.updateHeight();const P=_.balanceFactor();if(P>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),a[f][1]=_.rotateLeft()):P<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),a[f][1]=_.rotateRight()),f>0)switch(a[f-1][0]){case-1:a[f-1][1].left=a[f][1];break;case 1:a[f-1][1].right=a[f][1];break;case 0:a[f-1][1].mid=a[f][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const c=this._iter.reset(i);let t=this._root,a;for(;t;){const g=c.cmp(t.segment);if(g>0)t=t.left;else if(g<0)t=t.right;else if(c.hasNext())c.next(),a=t.value||a,t=t.mid;else break}return t&&t.value||a}findSuperstr(i){const c=this._iter.reset(i);let t=this._root;for(;t;){const a=c.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(c.hasNext())c.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[c,t]of this)i(t,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=c=>{if(!c)return!0;const t=c.balanceFactor();return t<-1||t>1?!1:i(c.left)&&i(c.right)};return i(this._root)}}e.TernarySearchTree=S;class k{constructor(i,c){this.uri=i,this.value=c}}class u{constructor(i,c){this[b]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=c??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,c){return this.map.set(this.toKey(i),new k(i,c)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,c){typeof c!="undefined"&&(i=i.bind(c));for(let[t,a]of this.map)i(a.value,a.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=r=>r.toString();var E;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class w{constructor(){this[B]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,c=0){const t=this._map.get(i);if(!!t)return c!==0&&this.touch(t,c),t.value}set(i,c,t=0){let a=this._map.get(i);if(a)a.value=c,t!==0&&this.touch(a,t);else{switch(a={key:i,value:c,next:void 0,previous:void 0},t){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this._map.get(i);if(!!c)return this._map.delete(i),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,c){const t=this._state;let a=this._head;for(;a;){if(c?i.bind(c)(a.value,a.key,this):i(a.value,a.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,c=this._state;let t=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const g={value:t.key,done:!1};return t=t.next,g}else return{value:void 0,done:!0}}};return a}values(){const i=this,c=this._state;let t=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const g={value:t.value,done:!1};return t=t.next,g}else return{value:void 0,done:!0}}};return a}entries(){const i=this,c=this._state;let t=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const g={value:[t.key,t.value],done:!1};return t=t.next,g}else return{value:void 0,done:!0}}};return a}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this._head,t=this.size;for(;c&&t>i;)this._map.delete(c.key),c=c.next,t--;this._head=c,this._size=t,c&&(c.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const c=i.next,t=i.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}i.next=void 0,i.previous=void 0,this._state++}touch(i,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this._head)return;const t=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(t.previous=a,a.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(c===2){if(i===this._tail)return;const t=i.next,a=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=a,a.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((c,t)=>{i.push([t,c])}),i}fromJSON(i){this.clear();for(const[c,t]of i)this.set(c,t)}}e.LinkedMap=w;class o extends w{constructor(i,c=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class T{constructor(i){D.set(this,void 0),Ve(this,D,i,"f")}get size(){return ye(this,D,"f").size}forEach(i,c){ye(this,D,"f").forEach(i,c)}get(i){return ye(this,D,"f").get(i)}has(i){return ye(this,D,"f").has(i)}entries(){return ye(this,D,"f").entries()}keys(){return ye(this,D,"f").keys()}values(){return ye(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return ye(this,D,"f").entries()}}e.ReadonlyMapView=T}),define(we[104],be([1,0,22,9]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...C){return function(R,x){for(let Q=0,ne=C.length;Q<ne;Q++){const Ee=C[Q](R,x);if(Ee)return Ee}return null}}e.or=b,e.matchesStrictPrefix=B.bind(void 0,!1),e.matchesPrefix=B.bind(void 0,!0);function B(C,R,x){if(!x||x.length<R.length)return null;let Q;return C?Q=I.startsWithIgnoreCase(x,R):Q=x.indexOf(R)===0,Q?R.length>0?[{start:0,end:R.length}]:[]:null}function D(C,R){const x=R.toLowerCase().indexOf(C.toLowerCase());return x===-1?null:[{start:x,end:x+C.length}]}e.matchesContiguousSubString=D;function A(C,R){return y(C.toLowerCase(),R.toLowerCase(),0,0)}e.matchesSubString=A;function y(C,R,x,Q){if(x===C.length)return[];if(Q===R.length)return null;if(C[x]===R[Q]){let ne=null;return(ne=y(C,R,x+1,Q+1))?S({start:Q,end:Q+1},ne):null}return y(C,R,x,Q+1)}function F(C){return 97<=C&&C<=122}function N(C){return 65<=C&&C<=90}e.isUpper=N;function p(C){return 48<=C&&C<=57}function d(C){return C===32||C===9||C===10||C===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>m.add(C.charCodeAt(0)));function l(C){return d(C)||m.has(C)}function n(C,R){return C===R||l(C)&&l(R)}function h(C){return F(C)||N(C)||p(C)}function S(C,R){return R.length===0?R=[C]:C.end===R[0].start?R[0].start=C.start:R.unshift(C),R}function k(C,R){for(let x=R;x<C.length;x++){const Q=C.charCodeAt(x);if(N(Q)||p(Q)||x>0&&!h(C.charCodeAt(x-1)))return x}return C.length}function u(C,R,x,Q){if(x===C.length)return[];if(Q===R.length)return null;if(C[x]!==R[Q].toLowerCase())return null;{let ne=null,Ee=Q+1;for(ne=u(C,R,x+1,Q+1);!ne&&(Ee=k(R,Ee))<R.length;)ne=u(C,R,x+1,Ee),Ee++;return ne===null?null:S({start:Q,end:Q+1},ne)}}function E(C){let R=0,x=0,Q=0,ne=0,Ee=0;for(let Be=0;Be<C.length;Be++)Ee=C.charCodeAt(Be),N(Ee)&&R++,F(Ee)&&x++,h(Ee)&&Q++,p(Ee)&&ne++;const Ie=R/C.length,Me=x/C.length,Le=Q/C.length,ze=ne/C.length;return{upperPercent:Ie,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function w(C){const{upperPercent:R,lowerPercent:x}=C;return x===0&&R>.6}function o(C){const{upperPercent:R,lowerPercent:x,alphaPercent:Q,numericPercent:ne}=C;return x>.2&&R<.8&&Q>.6&&ne<.2}function T(C){let R=0,x=0,Q=0,ne=0;for(let Ee=0;Ee<C.length;Ee++)Q=C.charCodeAt(Ee),N(Q)&&R++,F(Q)&&x++,d(Q)&&ne++;return(R===0||x===0)&&ne===0?C.length<=30:R<=5}function r(C,R){if(!R||(R=R.trim(),R.length===0)||!T(C)||R.length>60)return null;const x=E(R);if(!o(x)){if(!w(x))return null;R=R.toLowerCase()}let Q=null,ne=0;for(C=C.toLowerCase();ne<R.length&&(Q=u(C,R,0,ne))===null;)ne=k(R,ne+1);return Q}e.matchesCamelCase=r;function i(C,R,x=!1){if(!R||R.length===0)return null;let Q=null,ne=0;for(C=C.toLowerCase(),R=R.toLowerCase();ne<R.length&&(Q=c(C,R,0,ne,x))===null;)ne=t(R,ne+1);return Q}e.matchesWords=i;function c(C,R,x,Q,ne){if(x===C.length)return[];if(Q===R.length)return null;if(n(C.charCodeAt(x),R.charCodeAt(Q))){let Ee=null,Ie=Q+1;if(Ee=c(C,R,x+1,Q+1,ne),!ne)for(;!Ee&&(Ie=t(R,Ie))<R.length;)Ee=c(C,R,x+1,Ie,ne),Ie++;return Ee===null?null:S({start:Q,end:Q+1},Ee)}else return null}function t(C,R){for(let x=R;x<C.length;x++)if(l(C.charCodeAt(x))||x>0&&l(C.charCodeAt(x-1)))return x;return C.length}const a=b(e.matchesPrefix,r,D),g=b(e.matchesPrefix,r,A),f=new s.LRUCache(1e4);function _(C,R,x=!1){if(typeof C!="string"||typeof R!="string")return null;let Q=f.get(C);Q||(Q=new RegExp(I.convertSimple2RegExpPattern(C),"i"),f.set(C,Q));const ne=Q.exec(R);return ne?[{start:ne.index,end:ne.index+ne[0].length}]:x?g(C,R):a(C,R)}e.matchesFuzzy=_;function P(C,R){const x=Re(C,C.toLowerCase(),0,R,R.toLowerCase(),0,!0);return x?L(x):null}e.matchesFuzzy2=P;function $(C,R,x,Q,ne,Ee){const Ie=Math.min(13,C.length);for(;x<Ie;x++){const Me=Re(C,R,x,Q,ne,Ee,!1);if(Me)return Me}return[0,Ee]}e.anyScore=$;function L(C){if(typeof C=="undefined")return[];const R=[],x=C[1];for(let Q=C.length-1;Q>1;Q--){const ne=C[Q]+x,Ee=R[R.length-1];Ee&&Ee.end===ne?Ee.end=ne+1:R.push({start:ne,end:ne+1})}return R}e.createMatches=L;const v=128;function H(){const C=[],R=[];for(let x=0;x<=v;x++)R[x]=0;for(let x=0;x<=v;x++)C.push(R.slice(0));return C}function W(C){const R=[];for(let x=0;x<=C;x++)R[x]=0;return R}const q=W(2*v),K=W(2*v),V=H(),z=H(),ae=H(),de=!1;function Y(C,R,x,Q,ne){function Ee(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let Ie=` |   |${Q.split("").map(Me=>Ee(Me,3)).join("|")}
`;for(let Me=0;Me<=x;Me++)Me===0?Ie+=" |":Ie+=`${R[Me-1]}|`,Ie+=C[Me].slice(0,ne+1).map(Le=>Ee(Le.toString(),3)).join("|")+`
`;return Ie}function ie(C,R,x,Q){C=C.substr(R),x=x.substr(Q),console.log(Y(z,C,C.length,x,x.length)),console.log(Y(ae,C,C.length,x,x.length)),console.log(Y(V,C,C.length,x,x.length))}function ce(C,R){if(R<0||R>=C.length)return!1;const x=C.codePointAt(R);switch(x){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(x)}}function he(C,R){if(R<0||R>=C.length)return!1;switch(C.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function ue(C,R,x){return R[C]!==x[C]}function re(C,R,x,Q,ne,Ee,Ie=!1){for(;R<x&&ne<Ee;)C[R]===Q[ne]&&(Ie&&(q[R]=ne),R+=1),ne+=1;return R===x}e.isPatternInWord=re;var ge;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Te;(function(C){C.Default=[-100,0];function R(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}C.isDefault=R})(Te=e.FuzzyScore||(e.FuzzyScore={}));function Re(C,R,x,Q,ne,Ee,Ie){const Me=C.length>v?v:C.length,Le=Q.length>v?v:Q.length;if(x>=Me||Ee>=Le||Me-x>Le-Ee||!re(R,x,Me,ne,Ee,Le,!0))return;He(Me,Le,x,Ee,R,ne);let ze=1,Be=1,Ae=x,Qe=Ee;const tt=[!1];for(ze=1,Ae=x;Ae<Me;ze++,Ae++){const le=q[Ae],Oe=K[Ae],$e=Ae+1<Me?K[Ae+1]:Le;for(Be=le-Ee+1,Qe=le;Qe<$e;Be++,Qe++){let Ge=Number.MIN_SAFE_INTEGER,Je=!1;Qe<=Oe&&(Ge=Xe(C,R,Ae,x,Q,ne,Qe,Le,Ee,V[ze-1][Be-1]===0,tt));let ft=0;Ge!==Number.MAX_SAFE_INTEGER&&(Je=!0,ft=Ge+z[ze-1][Be-1]);const It=Qe>le,St=It?z[ze][Be-1]+(V[ze][Be-1]>0?-5:0):0,kt=Qe>le+1&&V[ze][Be-1]>0,qe=kt?z[ze][Be-2]+(V[ze][Be-2]>0?-5:0):0;if(kt&&(!It||qe>=St)&&(!Je||qe>=ft))z[ze][Be]=qe,ae[ze][Be]=3,V[ze][Be]=0;else if(It&&(!Je||St>=ft))z[ze][Be]=St,ae[ze][Be]=2,V[ze][Be]=0;else if(Je)z[ze][Be]=ft,ae[ze][Be]=1,V[ze][Be]=V[ze-1][Be-1]+1;else throw new Error("not possible")}}if(de&&ie(C,x,Q,Ee),!tt[0]&&!Ie)return;ze--,Be--;const ke=[z[ze][Be],Ee];let it=0,X=0;for(;ze>=1;){let le=Be;do{const Oe=ae[ze][le];if(Oe===3)le=le-2;else if(Oe===2)le=le-1;else break}while(le>=1);it>1&&R[x+ze-1]===ne[Ee+Be-1]&&!ue(le+Ee-1,Q,ne)&&it+1>V[ze][le]&&(le=Be),le===Be?it++:it=1,X||(X=le),ze--,Be=le-1,ke.push(Be)}Le===Me&&(ke[0]+=2);const J=X-Me;return ke[0]-=J,ke}e.fuzzyScore=Re;function He(C,R,x,Q,ne,Ee){let Ie=C-1,Me=R-1;for(;Ie>=x&&Me>=Q;)ne[Ie]===Ee[Me]&&(K[Ie]=Me,Ie--),Me--}function Xe(C,R,x,Q,ne,Ee,Ie,Me,Le,ze,Be){if(R[x]!==Ee[Ie])return Number.MIN_SAFE_INTEGER;let Ae=1,Qe=!1;return Ie===x-Q?Ae=C[x]===ne[Ie]?7:5:ue(Ie,ne,Ee)&&(Ie===0||!ue(Ie-1,ne,Ee))?(Ae=C[x]===ne[Ie]?7:5,Qe=!0):ce(Ee,Ie)&&(Ie===0||!ce(Ee,Ie-1))?Ae=5:(ce(Ee,Ie-1)||he(Ee,Ie-1))&&(Ae=5,Qe=!0),Ae>1&&x===Q&&(Be[0]=!0),Qe||(Qe=ue(Ie,ne,Ee)||ce(Ee,Ie-1)||he(Ee,Ie-1)),x===Q?Ie>Le&&(Ae-=Qe?3:5):ze?Ae+=Qe?2:0:Ae+=Qe?0:1,Ie+1===Me&&(Ae-=Qe?3:5),Ae}function ve(C,R,x,Q,ne,Ee,Ie){return M(C,R,x,Q,ne,Ee,!0,Ie)}e.fuzzyScoreGracefulAggressive=ve;function fe(C,R,x,Q,ne,Ee,Ie){return M(C,R,x,Q,ne,Ee,!1,Ie)}e.fuzzyScoreGraceful=fe;function M(C,R,x,Q,ne,Ee,Ie,Me){let Le=Re(C,R,x,Q,ne,Ee,Me);if(Le&&!Ie)return Le;if(C.length>=3){const ze=Math.min(7,C.length-1);for(let Be=x+1;Be<ze;Be++){const Ae=O(C,Be);if(Ae){const Qe=Re(Ae,Ae.toLowerCase(),x,Q,ne,Ee,Me);Qe&&(Qe[0]-=3,(!Le||Qe[0]>Le[0])&&(Le=Qe))}}}return Le}function O(C,R){if(R+1>=C.length)return;const x=C[R],Q=C[R+1];if(x!==Q)return C.slice(0,R)+Q+x+C.slice(R+2)}}),define(we[105],be([1,0,106,104,9]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const B=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(s.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${B.source}`,"g");function y(h){return h.replace(A,(S,k)=>k?S:`\\${S}`)}e.escapeIcons=y;const F=new RegExp(`\\\\${B.source}`,"g");function N(h){return h.replace(F,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=N;const p=new RegExp(`(\\s)?(\\\\)?${B.source}(\\s)?`,"g");function d(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(p,(S,k,u,E)=>u?S:k||E||"")}e.stripIcons=d;function m(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:l(h,S)}e.parseLabelWithIcons=m;function l(h,S){const k=[];let u="";function E(a){if(a){u+=a;for(const g of a)k.push(T)}}let w=-1,o="",T=0,r,i,c=S;const t=h.length;for(E(h.substr(0,S));c<t;)r=h[c],i=h[c+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(w=c,E(o),o=e.iconStartMarker,c++):r===")"&&w!==-1?(T+=c-w+1,w=-1,o=""):w!==-1?D.test(r)?o+=r:(E(o),w=-1,o=""):E(r),c++;return E(o),{text:u,iconOffsets:k}}function n(h,S,k=!1){const{text:u,iconOffsets:E}=S;if(!E||E.length===0)return(0,I.matchesFuzzy)(h,u,k);const w=(0,b.ltrim)(u," "),o=u.length-w.length,T=(0,I.matchesFuzzy)(h,w,k);if(T)for(const r of T){const i=E[r.start+o]+o;r.start+=i,r.end+=i}return T}e.matchesFuzzyIconAware=n}),define(we[34],be([1,0,9]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(I||(I={})),function(b){const B="error",D="warning",A="warn",y="info",F="ignore";function N(d){return d?s.equalsIgnoreCase(B,d)?b.Error:s.equalsIgnoreCase(D,d)||s.equalsIgnoreCase(A,d)?b.Warning:s.equalsIgnoreCase(y,d)?b.Info:b.Ignore:b.Ignore}b.fromValue=N;function p(d){switch(d){case b.Error:return B;case b.Warning:return D;case b.Info:return y;default:return F}}b.toString=p}(I||(I={})),e.default=I}),define(we[35],be([1,0,17,23,9,11]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(c){return c===47||c===92}e.isPathSeparator=D;function A(c){return c.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=A;function y(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function F(c,t=s.posix.sep){if(!c)return"";const a=c.length,g=c.charCodeAt(0);if(D(g)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let _=3;const P=_;for(;_<a&&!D(c.charCodeAt(_));_++);if(P!==_&&!D(c.charCodeAt(_+1))){for(_+=1;_<a;_++)if(D(c.charCodeAt(_)))return c.slice(0,_+1).replace(/[\\/]/g,t)}}return t}else if(S(g)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+t:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(D(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=F;function N(c){if(!I.isWindows||!c||c.length<5)return!1;let t=c.charCodeAt(0);if(t!==92||(t=c.charCodeAt(1),t!==92))return!1;let a=2;const g=a;for(;a<c.length&&(t=c.charCodeAt(a),t!==92);a++);return!(g===a||(t=c.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=N;const p=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(c,t=I.isWindows){const a=t?p:d;return!(!c||c.length===0||/^\s+$/.test(c)||(a.lastIndex=0,a.test(c))||t&&m.test(c)||c==="."||c===".."||t&&c[c.length-1]==="."||t&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=l;function n(c,t,a){const g=c===t;return!a||g?g:!c||!t?!1:(0,b.equalsIgnoreCase)(c,t)}e.isEqual=n;function h(c,t,a,g=s.sep){if(c===t)return!0;if(!c||!t||t.length>c.length)return!1;if(a){if(!(0,b.startsWithIgnoreCase)(c,t))return!1;if(t.length===c.length)return!0;let _=t.length;return t.charAt(t.length-1)===g&&_--,c.charAt(_)===g}return t.charAt(t.length-1)!==g&&(t+=g),c.indexOf(t)===0}e.isEqualOrParent=h;function S(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=S;function k(c,t){return I.isWindows&&c.endsWith(":")&&(c+=s.sep),(0,s.isAbsolute)(c)||(c=(0,s.join)(t,c)),c=(0,s.normalize)(c),I.isWindows?(c=(0,b.rtrim)(c,s.sep),c.endsWith(":")&&(c+=s.sep)):(c=(0,b.rtrim)(c,s.sep),c||(c=s.sep)),c}e.sanitizeFilePath=k;function u(c){const t=(0,s.normalize)(c);return I.isWindows?c.length>3?!1:E(t)&&(c.length===2||t.charCodeAt(2)===92):t===s.posix.sep}e.isRootOrDriveLetter=u;function E(c,t){return(t!==void 0?t:I.isWindows)?S(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function w(c){return E(c)?c[0]:void 0}e.getDriveLetter=w;function o(c,t,a){return t.length>c.length?-1:c===t?0:(a&&(c=c.toLowerCase(),t=t.toLowerCase()),c.indexOf(t))}e.indexOfPath=o;function T(c){const t=c.split(":");let a,g,f;for(const _ of t){const P=Number(_);(0,B.isNumber)(P)?g===void 0?g=P:f===void 0&&(f=P):a=a?[a,_].join(":"):_}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(c,t,a=8){let g="";for(let _=0;_<a;_++)g+=r.charAt(Math.floor(Math.random()*r.length));let f;return t?f=`${t}-${g}`:f=g,c?(0,s.join)(c,f):f}e.randomPath=i}),define(we[54],be([1,0,21,9,2]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function B(F){return JSON.stringify(F,A)}e.stringify=B;function D(F){let N=JSON.parse(F);return N=y(N),N}e.parse=D;function A(F,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,I.regExpFlags)(N)}:N}function y(F,N=0){if(!F||N>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return b.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof s.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let p=0;p<F.length;++p)F[p]=y(F[p],N+1);else for(const p in F)Object.hasOwnProperty.call(F,p)&&(F[p]=y(F[p],N+1))}return F}e.revive=y}),define(we[10],be([1,0,23,2]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,F,N){this._hosts[y]=F,this._ports[y]=N}setConnectionToken(y,F){this._connectionTokens[y]=F}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const F=y.authority;let N=this._hosts[F];N&&N.indexOf(":")!==-1&&(N=`[${N}]`);const p=this._ports[F],d=this._connectionTokens[F];let m=`path=${encodeURIComponent(y.path)}`;return typeof d=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),I.URI.from({scheme:s.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${N}:${p}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new B;class D{asBrowserUri(y,F){const N=this.toUri(y,F);return N.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===b.file&&(s.isNative||s.isWebWorker&&s.globals.origin===`${b.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?N.with({scheme:b.vscodeFileResource,authority:N.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(y,F){const N=this.toUri(y,F);return N.scheme===b.vscodeFileResource?N.with({scheme:b.file,authority:N.authority!==D.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(y,F){return I.URI.isUri(y)?y:I.URI.parse(F.toUrl(y))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(we[24],be([1,0,35,10,17,23,9,2]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=y;class F{constructor(l){this._ignorePathCasing=l}compare(l,n,h=!1){return l===n?0:(0,D.compare)(this.getComparisonKey(l,h),this.getComparisonKey(n,h))}isEqual(l,n,h=!1){return l===n?!0:!l||!n?!1:this.getComparisonKey(l,h)===this.getComparisonKey(n,h)}getComparisonKey(l,n=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,n,h=!1){if(l.scheme===n.scheme){if(l.scheme===I.Schemas.file)return s.isEqualOrParent(y(l),y(n),this._ignorePathCasing(l))&&l.query===n.query&&(h||l.fragment===n.fragment);if((0,e.isEqualAuthority)(l.authority,n.authority))return s.isEqualOrParent(l.path,n.path,this._ignorePathCasing(l),"/")&&l.query===n.query&&(h||l.fragment===n.fragment)}return!1}joinPath(l,...n){return A.URI.joinPath(l,...n)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return b.posix.basename(l.path)}extname(l){return b.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let n;return l.scheme===I.Schemas.file?n=A.URI.file(b.dirname(y(l))).path:(n=b.posix.dirname(l.path),l.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),n="/")),l.with({path:n})}normalizePath(l){if(!l.path.length)return l;let n;return l.scheme===I.Schemas.file?n=A.URI.file(b.normalize(y(l))).path:n=b.posix.normalize(l.path),l.with({path:n})}relativePath(l,n){if(l.scheme!==n.scheme||!(0,e.isEqualAuthority)(l.authority,n.authority))return;if(l.scheme===I.Schemas.file){const k=b.relative(y(l),y(n));return B.isWindows?s.toSlashes(k):k}let h=l.path||"/",S=n.path||"/";if(this._ignorePathCasing(l)){let k=0;for(const u=Math.min(h.length,S.length);k<u&&!(h.charCodeAt(k)!==S.charCodeAt(k)&&h.charAt(k).toLowerCase()!==S.charAt(k).toLowerCase());k++);h=S.substr(0,k)+h.substr(k)}return b.posix.relative(h,S)}resolvePath(l,n){if(l.scheme===I.Schemas.file){const h=A.URI.file(b.resolve(y(l),n));return l.with({authority:h.authority,path:h.path})}return n=s.toPosixPath(n),l.with({path:b.posix.resolve(l.path,n)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,n){return l===n||l!==void 0&&n!==void 0&&(0,D.equalsIgnoreCase)(l,n)}hasTrailingPathSeparator(l,n=b.sep){if(l.scheme===I.Schemas.file){const h=y(l);return h.length>s.getRoot(h).length&&h[h.length-1]===n}else{const h=l.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,n=b.sep){return(0,e.hasTrailingPathSeparator)(l,n)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,n=b.sep){let h=!1;if(l.scheme===I.Schemas.file){const S=y(l);h=S!==void 0&&S.length===s.getRoot(S).length&&S[S.length-1]===n}else{n="/";const S=l.path;h=S.length===1&&S.charCodeAt(S.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(l,n)?l.with({path:l.path+"/"}):l}}e.ExtUri=F,e.extUri=new F(()=>!1),e.extUriBiasedIgnorePathCase=new F(m=>m.scheme===I.Schemas.file?!B.isLinux:!0),e.extUriIgnorePathCase=new F(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(m,l){const n=[];for(let h=0;h<m.length;h++){const S=l(m[h]);m.some((k,u)=>u===h?!1:(0,e.isEqualOrParent)(S,l(k)))||n.push(m[h])}return n}e.distinctParents=N;var p;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(n){const h=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(u=>{const[E,w]=u.split(":");E&&w&&h.set(E,w)});const k=n.path.substring(0,n.path.indexOf(";"));return k&&h.set(m.META_DATA_MIME,k),h}m.parseMetaData=l})(p=e.DataUri||(e.DataUri={}));function d(m,l,n){if(l){let h=m.path;return h&&h[0]!==b.posix.sep&&(h=b.posix.sep+h),m.with({scheme:n,authority:l,path:h})}return m.with({scheme:n})}e.toLocalResource=d}),define(we[13],be([1,0,20,15,5,6,24,23]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=y;function F(ue){const re=new s.CancellationTokenSource,ge=ue(re.token),Te=new Promise((Re,He)=>{const Xe=re.token.onCancellationRequested(()=>{Xe.dispose(),re.dispose(),He(new I.CancellationError)});Promise.resolve(ge).then(ve=>{Xe.dispose(),re.dispose(),Re(ve)},ve=>{Xe.dispose(),re.dispose(),He(ve)})});return new class{cancel(){re.cancel()}then(Re,He){return Te.then(Re,He)}catch(Re){return this.then(void 0,Re)}finally(Re){return Te.finally(Re)}}}e.createCancelablePromise=F;function N(ue,re,ge){return new Promise((Te,Re)=>{const He=re.onCancellationRequested(()=>{He.dispose(),Te(ge)});ue.then(Te,Re).finally(()=>He.dispose())})}e.raceCancellation=N;function p(ue,re){return new Promise((ge,Te)=>{const Re=re.onCancellationRequested(()=>{Re.dispose(),Te(new I.CancellationError)});ue.then(ge,Te).finally(()=>Re.dispose())})}e.raceCancellationError=p;async function d(ue){let re=-1;const ge=ue.map((Re,He)=>Re.then(Xe=>(re=He,Xe))),Te=await Promise.race(ge);return ue.forEach((Re,He)=>{He!==re&&Re.cancel()}),Te}e.raceCancellablePromises=d;function m(ue,re,ge){let Te;const Re=setTimeout(()=>{Te?.(void 0),ge?.()},re);return Promise.race([ue.finally(()=>clearTimeout(Re)),new Promise(He=>Te=He)])}e.raceTimeout=m;function l(ue){return new Promise((re,ge)=>{const Te=ue();y(Te)?Te.then(re,ge):re(Te)})}e.asPromise=l;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(re){if(this.activePromise){if(this.queuedPromiseFactory=re,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Te=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Te};this.queuedPromise=new Promise(Te=>{this.activePromise.then(ge,ge).then(Te)})}return new Promise((ge,Te)=>{this.queuedPromise.then(ge,Te)})}return this.activePromise=re(),new Promise((ge,Te)=>{this.activePromise.then(Re=>{this.activePromise=null,ge(Re)},Re=>{this.activePromise=null,Te(Re)})})}}e.Throttler=n;class h{constructor(){this.current=Promise.resolve(null)}queue(re){return this.current=this.current.then(()=>re(),()=>re())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(re,ge){const Re=(this.promiseMap.get(re)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(re)===Re&&this.promiseMap.delete(re)});return this.promiseMap.set(re,Re),Re}}e.SequencerByKey=S;const k=(ue,re)=>{let ge=!0;const Te=setTimeout(()=>{ge=!1,re()},ue);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Te),ge=!1}}},u=ue=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,ue())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(re){this.defaultDelay=re,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(re,ge=this.defaultDelay){this.task=re,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Re,He)=>{this.doResolve=Re,this.doReject=He}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Re=this.task;return this.task=null,Re()}}));const Te=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?u(Te):k(ge,Te),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class w{constructor(re){this.delayer=new E(re),this.throttler=new n}trigger(re,ge){return this.delayer.trigger(()=>this.throttler.queue(re),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class o{constructor(){this._isOpen=!1,this._promise=new Promise((re,ge)=>{this._completePromise=re})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class T extends o{constructor(re){super();this._timeout=setTimeout(()=>this.open(),re)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=T;function r(ue,re){return re?new Promise((ge,Te)=>{const Re=setTimeout(()=>{He.dispose(),ge()},ue),He=re.onCancellationRequested(()=>{clearTimeout(Re),He.dispose(),Te(new I.CancellationError)})}):F(ge=>r(ue,ge))}e.timeout=r;function i(ue,re=0){const ge=setTimeout(ue,re);return(0,B.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=i;function c(ue){const re=[];let ge=0;const Te=ue.length;function Re(){return ge<Te?ue[ge++]():null}function He(Xe){Xe!=null&&re.push(Xe);const ve=Re();return ve?ve.then(He):Promise.resolve(re)}return Promise.resolve(null).then(He)}e.sequence=c;function t(ue,re=Te=>!!Te,ge=null){let Te=0;const Re=ue.length,He=()=>{if(Te>=Re)return Promise.resolve(ge);const Xe=ue[Te++];return Promise.resolve(Xe()).then(fe=>re(fe)?Promise.resolve(fe):He())};return He()}e.first=t;function a(ue,re=Te=>!!Te,ge=null){if(ue.length===0)return Promise.resolve(ge);let Te=ue.length;const Re=()=>{Te=-1;for(const He of ue)He.cancel?.()};return new Promise((He,Xe)=>{for(const ve of ue)ve.then(fe=>{--Te>=0&&re(fe)?(Re(),He(fe)):Te===0&&He(ge)}).catch(fe=>{--Te>=0&&(Re(),Xe(fe))})})}e.firstParallel=a;class g{constructor(re){this._size=0,this.maxDegreeOfParalellism=re,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(re){return this._size++,new Promise((ge,Te)=>{this.outstandingPromises.push({factory:re,c:ge,e:Te}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const re=this.outstandingPromises.shift();this.runningPromises++;const ge=re.factory();ge.then(re.c,re.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class f extends g{constructor(){super(1)}}e.Queue=f;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const re=new ae;return this.drainers.add(re),re.p}isDrained(){for(const[,re]of this.queues)if(re.size>0)return!1;return!0}queueFor(re,ge=D.extUri){const Te=ge.getComparisonKey(re);let Re=this.queues.get(Te);return Re||(Re=new f,b.Event.once(Re.onFinished)(()=>{Re?.dispose(),this.queues.delete(Te),this.onDidQueueFinish()}),this.queues.set(Te,Re)),Re}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const re of this.drainers)re.complete();this.drainers.clear()}dispose(){for(const[,re]of this.queues)re.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class P{constructor(re,ge){this._token=-1,typeof re=="function"&&typeof ge=="number"&&this.setIfNotSet(re,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(re,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,re()},ge)}setIfNotSet(re,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,re()},ge))}}e.TimeoutTimer=P;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(re,ge){this.cancel(),this._token=setInterval(()=>{re()},ge)}}e.IntervalTimer=$;class L{constructor(re,ge){this.timeoutToken=-1,this.runner=re,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(re=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,re)}get delay(){return this.timeout}set delay(re){this.timeout=re}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class v{constructor(re,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=re,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(re=this.timeout){re%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(re/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=v;class H extends L{constructor(re,ge){super(re,ge);this.units=[]}work(re){this.units.push(re),this.isScheduled()||this.schedule()}doRun(){const re=this.units;this.units=[],this.runner&&this.runner(re)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class W extends B.Disposable{constructor(re,ge){super();this.options=re,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new B.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(re){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+re.length>this.options.maxBufferedWork)return!1}else if(this.pending+re.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...re),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,A.setTimeout0)(()=>{if(re)return;const ge=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.runWhenIdle=(ue,re)=>{const ge=requestIdleCallback(ue,typeof re=="number"?{timeout:re}:void 0);let Te=!1;return{dispose(){Te||(Te=!0,cancelIdleCallback(ge))}}}}();class q{constructor(re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function K(ue,re,ge){let Te;for(let Re=0;Re<ge;Re++)try{return await ue()}catch(He){Te=He,await r(re)}throw Te}e.retry=K;class V{hasPending(re){return this._pending?typeof re=="number"?this._pending.taskId===re:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(re,ge,Te){return this._pending={taskId:re,cancel:()=>Te?.(),promise:ge},ge.then(()=>this.donePending(re),()=>this.donePending(re)),ge}donePending(re){this._pending&&re===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const re=this._next;this._next=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}setNext(re){if(this._next)this._next.run=re;else{let ge,Te;const Re=new Promise((He,Xe)=>{ge=He,Te=Xe});this._next={run:re,promise:Re,promiseResolve:ge,promiseReject:Te}}return this._next.promise}}e.TaskSequentializer=V;class z{constructor(re,ge=()=>Date.now()){this.interval=re,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const re=this.nowFn();return re-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=re,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ae{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((re,ge)=>{this.completeCallback=re,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(re){return new Promise(ge=>{this.completeCallback(re),this.resolved=!0,ge()})}error(re){return new Promise(ge=>{this.errorCallback(re),this.rejected=!0,ge()})}cancel(){new Promise(re=>{this.errorCallback(new I.CancellationError),this.rejected=!0,re()})}}e.DeferredPromise=ae;var de;(function(ue){async function re(Te){let Re;const He=await Promise.all(Te.map(Xe=>Xe.then(ve=>ve,ve=>{Re||(Re=ve)})));if(typeof Re!="undefined")throw Re;return He}ue.settled=re;function ge(Te){return new Promise(async(Re,He)=>{try{await Te(Re,He)}catch(Xe){He(Xe)}})}ue.withAsyncBody=ge})(de=e.Promises||(e.Promises={}));var Y;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(Y||(Y={}));class ie{constructor(re){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const ge={emitOne:Te=>this.emitOne(Te),emitMany:Te=>this.emitMany(Te),reject:Te=>this.reject(Te)};try{await Promise.resolve(re(ge)),this.resolve()}catch(Te){this.reject(Te)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(re){return new ie(ge=>{ge.emitMany(re)})}static fromPromise(re){return new ie(async ge=>{ge.emitMany(await re)})}static fromPromises(re){return new ie(async ge=>{await Promise.all(re.map(async Te=>ge.emitOne(await Te)))})}static merge(re){return new ie(async ge=>{await Promise.all(re.map(async Te=>{for await(const Re of Te)ge.emitOne(Re)}))})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(re<this._results.length)return{done:!1,value:this._results[re++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(re,ge){return new ie(async Te=>{for await(const Re of re)Te.emitOne(ge(Re))})}map(re){return ie.map(this,re)}static filter(re,ge){return new ie(async Te=>{for await(const Re of re)ge(Re)&&Te.emitOne(Re)})}filter(re){return ie.filter(this,re)}static coalesce(re){return ie.filter(re,ge=>!!ge)}coalesce(){return ie.coalesce(this)}static async toPromise(re){const ge=[];for await(const Te of re)ge.push(Te);return ge}toPromise(){return ie.toPromise(this)}emitOne(re){this._state===0&&(this._results.push(re),this._onStateChanged.fire())}emitMany(re){this._state===0&&(this._results=this._results.concat(re),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(re){this._state===0&&(this._state=2,this._error=re,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class ce extends ie{constructor(re,ge){super(ge);this._source=re}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function he(ue){const re=new s.CancellationTokenSource,ge=ue(re.token);return new ce(re,async Te=>{const Re=re.token.onCancellationRequested(()=>{Re.dispose(),re.dispose(),Te.reject(new I.CancellationError)});try{for await(const He of ge){if(re.token.isCancellationRequested)return;Te.emitOne(He)}Re.dispose(),re.dispose()}catch(He){Re.dispose(),re.dispose(),Te.reject(He)}})}e.createCancelableAsyncIterable=he}),define(we[107],be([1,0,13,17]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new s.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),B=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(f,_,P=!1){const $=f||"",L=_||"",v=b.value.collator.compare($,L);return b.value.collatorIsNumeric&&v===0&&$!==L?$<L?-1:1:v}e.compareFileNames=A;function y(f,_){const P=B.value.collator;return f=f||"",_=_||"",w(P,f,_)}e.compareFileNamesDefault=y;function F(f,_){const P=B.value.collator;return f=f||"",_=_||"",i(f,_)||w(P,f,_)}e.compareFileNamesUpper=F;function N(f,_){const P=B.value.collator;return f=f||"",_=_||"",r(f,_)||w(P,f,_)}e.compareFileNamesLower=N;function p(f,_){return f=f||"",_=_||"",f===_?0:f<_?-1:1}e.compareFileNamesUnicode=p;function d(f,_,P=!1){P||(f=f&&f.toLowerCase(),_=_&&_.toLowerCase());const[$,L]=u(f),[v,H]=u(_);return $!==v?$<v?-1:1:L===H?0:L<H?-1:1}e.noIntlCompareFileNames=d;function m(f,_){const[P,$]=u(f),[L,v]=u(_);let H=b.value.collator.compare($,v);if(H===0){if(b.value.collatorIsNumeric&&$!==v)return $<v?-1:1;if(H=b.value.collator.compare(P,L),b.value.collatorIsNumeric&&H===0&&P!==L)return P<L?-1:1}return H}e.compareFileExtensions=m;function l(f,_){f=f||"",_=_||"";const P=E(f),$=E(_),L=B.value.collator,v=D.value.collator;return w(v,P,$)||w(L,f,_)}e.compareFileExtensionsDefault=l;function n(f,_){f=f||"",_=_||"";const P=E(f),$=E(_),L=B.value.collator,v=D.value.collator;return w(v,P,$)||i(f,_)||w(L,f,_)}e.compareFileExtensionsUpper=n;function h(f,_){f=f||"",_=_||"";const P=E(f),$=E(_),L=B.value.collator,v=D.value.collator;return w(v,P,$)||r(f,_)||w(L,f,_)}e.compareFileExtensionsLower=h;function S(f,_){f=f||"",_=_||"";const P=E(f).toLowerCase(),$=E(_).toLowerCase();return P!==$?P<$?-1:1:f!==_?f<_?-1:1:0}e.compareFileExtensionsUnicode=S;const k=/^(.*?)(\.([^.]*))?$/;function u(f,_=!1){const P=f?k.exec(f):[];let $=[P&&P[1]||"",P&&P[3]||""];return _&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function E(f){const _=f?k.exec(f):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function w(f,_,P){let $=f.compare(_,P);return $!==0?$:_.length!==P.length?_.length<P.length?-1:1:0}function o(f){const _=f.charAt(0);return _.toLocaleUpperCase()!==_}function T(f){const _=f.charAt(0);return _.toLocaleLowerCase()!==_}function r(f,_){return o(f)&&T(_)?-1:T(f)&&o(_)?1:0}function i(f,_){return T(f)&&o(_)?-1:o(f)&&T(_)?1:0}function c(f,_,P=!1){return P||(f=f&&f.toLowerCase(),_=_&&_.toLowerCase()),f===_?0:f<_?-1:1}function t(f,_,P=!1){const $=f.split(I.sep),L=_.split(I.sep),v=$.length-1,H=L.length-1;let W,q;for(let K=0;;K++){if(W=v===K,q=H===K,W&&q)return A($[K],L[K],P);if(W)return-1;if(q)return 1;const V=c($[K],L[K],P);if(V!==0)return V}}e.comparePaths=t;function a(f,_,P){const $=f.toLowerCase(),L=_.toLowerCase(),v=g(f,_,P);if(v)return v;const H=$.endsWith(P),W=L.endsWith(P);if(H!==W)return H?-1:1;const q=A($,L);return q!==0?q:$.localeCompare(L)}e.compareAnything=a;function g(f,_,P){const $=f.toLowerCase(),L=_.toLowerCase(),v=$.startsWith(P),H=L.startsWith(P);if(v!==H)return v?-1:1;if(v&&H){if($.length<L.length)return-1;if($.length>L.length)return 1}return 0}e.compareByPrefix=g}),define(we[29],be([1,0,13,35,22,17,23,9]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const F="[/\\\\]",N="[^/\\\\]",p=/\//g;function d(V,z){switch(V){case 0:return"";case 1:return`${N}*?`;default:return`(?:${F}|${N}+${F}${z?`|${F}${N}+`:""})*?`}}function m(V,z){if(!V)return[];const ae=[];let de=!1,Y=!1,ie="";for(const ce of V){switch(ce){case z:if(!de&&!Y){ae.push(ie),ie="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}ie+=ce}return ie&&ae.push(ie),ae}e.splitGlobAware=m;function l(V){if(!V)return"";let z="";const ae=m(V,e.GLOB_SPLIT);if(ae.every(de=>de===e.GLOBSTAR))z=".*";else{let de=!1;ae.forEach((Y,ie)=>{if(Y===e.GLOBSTAR){if(de)return;z+=d(2,ie===ae.length-1)}else{let ce=!1,he="",ue=!1,re="";for(const ge of Y){if(ge!=="}"&&ce){he+=ge;continue}if(ue&&(ge!=="]"||!re)){let Te;ge==="-"?Te=ge:(ge==="^"||ge==="!")&&!re?Te="^":ge===e.GLOB_SPLIT?Te="":Te=(0,A.escapeRegExpCharacters)(ge),re+=Te;continue}switch(ge){case"{":ce=!0;continue;case"[":ue=!0;continue;case"}":{z+=`(?:${m(he,",").map(He=>l(He)).join("|")})`,ce=!1,he="";break}case"]":{z+="["+re+"]",ue=!1,re="";break}case"?":z+=N;continue;case"*":z+=d(1);continue;default:z+=(0,A.escapeRegExpCharacters)(ge)}}ie<ae.length-1&&(ae[ie+1]!==e.GLOBSTAR||ie+2<ae.length)&&(z+=F)}de=Y===e.GLOBSTAR})}return z}const n=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,w=new b.LRUCache(1e4),o=function(){return!1},T=function(){return null};function r(V,z){if(!V)return T;let ae;typeof V!="string"?ae=V.pattern:ae=V,ae=ae.trim();const de=`${ae}_${!!z.trimForExclusions}`;let Y=w.get(de);if(Y)return i(Y,V);let ie;return n.test(ae)?Y=t(ae.substr(4),ae):(ie=h.exec(c(ae,z)))?Y=a(ie[1],ae):(z.trimForExclusions?k:S).test(ae)?Y=g(ae,z):(ie=u.exec(c(ae,z)))?Y=f(ie[1].substr(1),ae,!0):(ie=E.exec(c(ae,z)))?Y=f(ie[1],ae,!1):Y=_(ae),w.set(de,Y),i(Y,V)}function i(V,z){return typeof z=="string"?V:function(ae,de){return(0,I.isEqualOrParent)(ae,z.base,!D.isLinux)?V(ae.substr(z.base.length+1),de):null}}function c(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function t(V,z){return function(ae,de){return typeof ae=="string"&&ae.endsWith(V)?z:null}}function a(V,z){const ae=`/${V}`,de=`\\${V}`,Y=function(ce,he){return typeof ce!="string"?null:he?he===V?z:null:ce===V||ce.endsWith(ae)||ce.endsWith(de)?z:null},ie=[V];return Y.basenames=ie,Y.patterns=[z],Y.allBasenames=ie,Y}function g(V,z){const ae=K(V.slice(1,-1).split(",").map(he=>r(he,z)).filter(he=>he!==T),V),de=ae.length;if(!de)return T;if(de===1)return ae[0];const Y=function(he,ue){for(let re=0,ge=ae.length;re<ge;re++)if(ae[re](he,ue))return V;return null},ie=ae.find(he=>!!he.allBasenames);ie&&(Y.allBasenames=ie.allBasenames);const ce=ae.reduce((he,ue)=>ue.allPaths?he.concat(ue.allPaths):he,[]);return ce.length&&(Y.allPaths=ce),Y}function f(V,z,ae){const de=B.sep===B.posix.sep,Y=de?V:V.replace(p,B.sep),ie=B.sep+Y,ce=B.posix.sep+V;let he;return ae?he=function(ue,re){return typeof ue=="string"&&(ue===Y||ue.endsWith(ie)||!de&&(ue===V||ue.endsWith(ce)))?z:null}:he=function(ue,re){return typeof ue=="string"&&(ue===Y||!de&&ue===V)?z:null},he.allPaths=[(ae?"*/":"./")+V],he}function _(V){try{const z=new RegExp(`^${l(V)}$`);return function(ae){return z.lastIndex=0,typeof ae=="string"&&z.test(ae)?V:null}}catch{return T}}function P(V,z,ae){return!V||typeof z!="string"?!1:$(V)(z,void 0,ae)}e.match=P;function $(V,z={}){if(!V)return o;if(typeof V=="string"||L(V)){const ae=r(V,z);if(ae===T)return o;const de=function(Y,ie){return!!ae(Y,ie)};return ae.allBasenames&&(de.allBasenames=ae.allBasenames),ae.allPaths&&(de.allPaths=ae.allPaths),de}return W(V,z)}e.parse=$;function L(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=L;function v(V){return V.allBasenames||[]}e.getBasenameTerms=v;function H(V){return V.allPaths||[]}e.getPathTerms=H;function W(V,z){const ae=K(Object.getOwnPropertyNames(V).map(he=>q(he,V[he],z)).filter(he=>he!==T)),de=ae.length;if(!de)return T;if(!ae.some(he=>!!he.requiresSiblings)){if(de===1)return ae[0];const he=function(ge,Te){for(let Re=0,He=ae.length;Re<He;Re++){const Xe=ae[Re](ge,Te);if(Xe)return Xe}return null},ue=ae.find(ge=>!!ge.allBasenames);ue&&(he.allBasenames=ue.allBasenames);const re=ae.reduce((ge,Te)=>Te.allPaths?ge.concat(Te.allPaths):ge,[]);return re.length&&(he.allPaths=re),he}const Y=function(he,ue,re){let ge;for(let Te=0,Re=ae.length;Te<Re;Te++){const He=ae[Te];He.requiresSiblings&&re&&(ue||(ue=(0,B.basename)(he)),ge||(ge=ue.substr(0,ue.length-(0,B.extname)(he).length)));const Xe=He(he,ue,ge,re);if(Xe)return Xe}return null},ie=ae.find(he=>!!he.allBasenames);ie&&(Y.allBasenames=ie.allBasenames);const ce=ae.reduce((he,ue)=>ue.allPaths?he.concat(ue.allPaths):he,[]);return ce.length&&(Y.allPaths=ce),Y}function q(V,z,ae){if(z===!1)return T;const de=r(V,ae);if(de===T)return T;if(typeof z=="boolean")return de;if(z){const Y=z.when;if(typeof Y=="string"){const ie=(ce,he,ue,re)=>{if(!re||!de(ce,he))return null;const ge=Y.replace("$(basename)",ue),Te=re(ge);return(0,s.isThenable)(Te)?Te.then(Re=>Re?V:null):Te?V:null};return ie.requiresSiblings=!0,ie}}return de}function K(V,z){const ae=V.filter(he=>!!he.basenames);if(ae.length<2)return V;const de=ae.reduce((he,ue)=>{const re=ue.basenames;return re?he.concat(re):he},[]);let Y;if(z){Y=[];for(let he=0,ue=de.length;he<ue;he++)Y.push(z)}else Y=ae.reduce((he,ue)=>{const re=ue.patterns;return re?he.concat(re):he},[]);const ie=function(he,ue){if(typeof he!="string")return null;if(!ue){let ge;for(ge=he.length;ge>0;ge--){const Te=he.charCodeAt(ge-1);if(Te===47||Te===92)break}ue=he.substr(ge)}const re=de.indexOf(ue);return re!==-1?Y[re]:null};ie.basenames=de,ie.patterns=Y,ie.allBasenames=de;const ce=V.filter(he=>!he.basenames);return ce.push(ie),ce}}),define(we[72],be([1,0,15,105,24,9,2]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",S=!1){if(this.value=h,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=S.isTrusted??void 0,this.supportThemeIcons=S.supportThemeIcons??!1,this.supportHtml=S.supportHtml??!1)}appendText(h,S=0){return this.value+=d(this.supportThemeIcons?(0,I.escapeIcons)(h):h).replace(/([ \t]+)/g,(k,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,S){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}appendLink(h,S,k){return this.value+="[",this.value+=this._escape(S,"]"),this.value+="](",this.value+=this._escape(String(h),")"),k&&(this.value+=` "${this._escape(this._escape(k,'"'),")")}"`),this.value+=")",this}_escape(h,S){const k=new RegExp((0,B.escapeRegExpCharacters)(S),"g");return h.replace(k,(u,E)=>h.charAt(E-1)!=="\\"?`\\${u}`:u)}}e.MarkdownString=y;function F(n){return N(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function N(n){return n instanceof y?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function p(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,b.isEqual)(D.URI.from(n.baseUri),D.URI.from(h.baseUri)))}e.markdownStringEqual=p;function d(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=d;function m(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function l(n){const h=[],S=n.split("|").map(u=>u.trim());n=S[0];const k=S[1];if(k){const u=/height=(\d+)/.exec(k),E=/width=(\d+)/.exec(k),w=u?u[1]:"",o=E?E[1]:"",T=isFinite(parseInt(o)),r=isFinite(parseInt(w));T&&h.push(`width="${o}"`),r&&h.push(`height="${w}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=l}),define(we[73],be([1,0,35,10,17,23,24,9,2]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function F(i,c,t){if(typeof i=="string"&&(i=y.URI.file(i)),t){const g=t.getWorkspaceFolder(i);if(g){const f=t.getWorkspace().folders.length>1;let _;if((0,D.isEqual)(g.uri,i)?_="":_=(0,D.relativePath)(g.uri,i),f){const P=g.name?g.name:(0,D.basename)(g.uri);_=_?P+" \u2022 "+_:P}return _}}if(i.scheme!==I.Schemas.file&&i.scheme!==I.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,s.hasDriveLetter)(i.fsPath))return(0,b.normalize)(p(i.fsPath));let a=(0,b.normalize)(i.fsPath);return!B.isWindows&&c?.userHome&&(a=m(a,c.userHome.fsPath)),a}e.getPathLabel=F;function N(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,D.basename)(i)||(i.scheme===I.Schemas.file?i.fsPath:i.path);return B.isWindows&&(0,s.isRootOrDriveLetter)(c)?p(c):c}e.getBaseLabel=N;function p(i,c){return(0,s.hasDriveLetter)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=p;let d=Object.create(null);function m(i,c){if(B.isWindows||!i||!c)return i;let t=d.original===c?d.normalized:void 0;return t||(t=`${(0,A.rtrim)(c,b.posix.sep)}${b.posix.sep}`,d={original:c,normalized:t}),(B.isLinux?i.startsWith(t):(0,A.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=m;function l(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=l;const n="\u2026",h="\\\\",S="~";function k(i,c=b.sep){const t=new Array(i.length);let a=!1;for(let g=0;g<i.length;g++){let f=i[g];if(f===""){t[g]=`.${c}`;continue}if(!f){t[g]=f;continue}a=!0;let _="";f.indexOf(h)===0?(_=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(c)===0?(_=f.substr(0,f.indexOf(c)+c.length),f=f.substr(f.indexOf(c)+c.length)):f.indexOf(S)===0&&(_=f.substr(0,f.indexOf(S)+S.length),f=f.substr(f.indexOf(S)+S.length));const P=f.split(c);for(let $=1;a&&$<=P.length;$++)for(let L=P.length-$;a&&L>=0;L--){a=!1;let v=P.slice(L,L+$).join(c);for(let H=0;!a&&H<i.length;H++)if(H!==g&&i[H]&&i[H].indexOf(v)>-1){const W=L+$===P.length,q=L>0&&i[H].indexOf(c)>-1?c+v:v,K=i[H].endsWith(q);a=!W||K}if(!a){let H="";(P[0].endsWith(":")||_!=="")&&(L===1&&(L=0,$++,v=P[0]+c+v),L>0&&(H=P[0]+c),H=_+H),L>0&&(H=H+n+c),H=H+v,L+$<P.length&&(H=H+c+n),t[g]=H}}a&&(t[g]=f)}return t}e.shorten=k;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function E(i,c=Object.create(null)){const t=[];let a=!1,g="";for(const f of i)if(f==="$"||a&&f==="{")g&&t.push({value:g,type:u.TEXT}),g="",a=!0;else if(f==="}"&&a){const _=c[g];if(typeof _=="string")_.length&&t.push({value:_,type:u.VARIABLE});else if(_){const P=t[t.length-1];(!P||P.type!==u.SEPARATOR)&&t.push({value:_.label,type:u.SEPARATOR})}g="",a=!1}else g+=f;return g&&!a&&t.push({value:g,type:u.TEXT}),t.filter((f,_)=>{if(f.type===u.SEPARATOR){const P=t[_-1],$=t[_+1];return[P,$].every(L=>L&&(L.type===u.VARIABLE||L.type===u.TEXT)&&L.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=E;function w(i,c){return B.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,B.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function o(i,c){return B.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):B.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function T(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=T;function r(i){const c=i.indexOf("/")!==-1?b.posix:b.win32,t=c.basename(i),a=c.dirname(i);return t.length?{name:t,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(we[108],be([1,0,2]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(N){return N.toJSON()}class b{constructor(p){this._uriTransformer=p}transformIncoming(p){const d=this._uriTransformer.transformIncoming(p);return d===p?p:I(s.URI.from(d))}transformOutgoing(p){const d=this._uriTransformer.transformOutgoing(p);return d===p?p:I(s.URI.from(d))}transformOutgoingURI(p){const d=this._uriTransformer.transformOutgoing(p);return d===p?p:s.URI.from(d)}transformOutgoingScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function B(N,p,d){if(!N||d>200)return null;if(typeof N=="object"){if(N instanceof s.URI)return p.transformOutgoing(N);for(let m in N)if(Object.hasOwnProperty.call(N,m)){const l=B(N[m],p,d+1);l!==null&&(N[m]=l)}}return null}function D(N,p){const d=B(N,p,0);return d===null?N:d}e.transformOutgoingURIs=D;function A(N,p,d,m){if(!N||m>200)return null;if(typeof N=="object"){if(N.$mid===1)return d?s.URI.revive(p.transformIncoming(N)):p.transformIncoming(N);for(let l in N)if(Object.hasOwnProperty.call(N,l)){const n=A(N[l],p,d,m+1);n!==null&&(N[l]=n)}}return null}function y(N,p){const d=A(N,p,!1,0);return d===null?N:d}e.transformIncomingURIs=y;function F(N,p){const d=A(N,p,!0,0);return d===null?N:d}e.transformAndReviveIncomingURIs=F}),define(we[36],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(y){return s.test(y)}e.isUUID=I;const b=new Uint8Array(16),B=[];for(let y=0;y<256;y++)B.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let F=0;F<y.length;F++)y[F]=Math.floor(Math.random()*256);return y};function A(){D(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let y=0,F="";return F+=B[b[y++]],F+=B[b[y++]],F+=B[b[y++]],F+=B[b[y++]],F+="-",F+=B[b[y++]],F+=B[b[y++]],F+="-",F+=B[b[y++]],F+=B[b[y++]],F+="-",F+=B[b[y++]],F+=B[b[y++]],F+="-",F+=B[b[y++]],F+=B[b[y++]],F+=B[b[y++]],F+=B[b[y++]],F+=B[b[y++]],F+=B[b[y++]],F}e.generateUuid=A}),define(we[109],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(we[74],be([1,0,29,17]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(B,D,A,y,F){if(Array.isArray(B)){let N=0;for(const p of B){const d=b(p,D,A,y,F);if(d===10)return d;d>N&&(N=d)}return N}else{if(typeof B=="string")return y?B==="*"?5:B===A?10:0:0;if(B){const{language:N,pattern:p,scheme:d,hasAccessToAllModels:m,notebookType:l}=B;if(!y&&!m)return 0;let n=0;if(d)if(d===D.scheme)n=10;else if(d==="*")n=5;else return 0;if(N)if(N===A)n=10;else if(N==="*")n=Math.max(n,5);else return 0;if(l)if(l===F)n=10;else if(l==="*")n=Math.max(n,5);else return 0;if(p){let h;if(typeof p=="string"?h=p:h={...p,base:(0,I.normalize)(p.base)},h===D.fsPath||(0,s.match)(h,D.fsPath))n=10;else return 0}return n}else return 0}}e.score=b}),define(we[110],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,F=A.notIn.length;y<F;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const F=A.findTokenIndexAtOffset(y-2),N=A.getStandardTokenType(F);return this.isOK(N)}_findNeutralCharacterInRange(A,y){for(let F=A;F<=y;F++){const N=String.fromCharCode(F);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class b{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)B(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),B(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),B(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),B(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&B(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=b;function B(D,A,y){D.has(A)?D.get(A).push(y):D.set(A,[y])}}),define(we[75],be([1,0,21,23]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(p){p[p.Full=1]="Full",p[p.Delta=2]="Delta"})(b||(b={}));function B(p){for(let d=0,m=p.length;d<m;d+=4){const l=p[d+0],n=p[d+1],h=p[d+2],S=p[d+3];p[d+0]=S,p[d+1]=h,p[d+2]=n,p[d+3]=l}}function D(p){const d=new Uint8Array(p.buffer,p.byteOffset,p.length*4);return I.isLittleEndian()||B(d),s.VSBuffer.wrap(d)}function A(p){const d=p.buffer;if(I.isLittleEndian()||B(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const m=new Uint8Array(d.byteLength);return m.set(d),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(p){const d=new Uint32Array(F(p));let m=0;if(d[m++]=p.id,p.type==="full")d[m++]=1,d[m++]=p.data.length,d.set(p.data,m),m+=p.data.length;else{d[m++]=2,d[m++]=p.deltas.length;for(const l of p.deltas)d[m++]=l.start,d[m++]=l.deleteCount,l.data?(d[m++]=l.data.length,d.set(l.data,m),m+=l.data.length):d[m++]=0}return D(d)}e.encodeSemanticTokensDto=y;function F(p){let d=0;if(d+=1+1,p.type==="full")d+=1+p.data.length;else{d+=1,d+=(1+1+1)*p.deltas.length;for(const m of p.deltas)m.data&&(d+=m.data.length)}return d}function N(p){const d=A(p);let m=0;const l=d[m++];if(d[m++]===1){const k=d[m++],u=d.subarray(m,m+k);return m+=k,{id:l,type:"full",data:u}}const h=d[m++],S=[];for(let k=0;k<h;k++){const u=d[m++],E=d[m++],w=d[m++];let o;w>0&&(o=d.subarray(m,m+w),m+=w),S[k]={start:u,deleteCount:E,data:o}}return{id:l,type:"delta",deltas:S}}e.decodeSemanticTokensDto=N}),define(we[111],be([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(we[112],be([1,0,111]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,b=I*60,B=b*24,D=B*7,A=B*30,y=B*365;function F(p,d,m){typeof p!="number"&&(p=p.getTime());const l=Math.round((new Date().getTime()-p)/1e3);if(l<-30)return(0,s.localize)(0,null,F(new Date().getTime()+l*1e3,!1));if(l<30)return(0,s.localize)(1,null);let n;return l<I?(n=l,d?n===1?m?(0,s.localize)(2,null,n):(0,s.localize)(3,null,n):m?(0,s.localize)(4,null,n):(0,s.localize)(5,null,n):n===1?m?(0,s.localize)(6,null,n):(0,s.localize)(7,null,n):m?(0,s.localize)(8,null,n):(0,s.localize)(9,null,n)):l<b?(n=Math.floor(l/I),d?n===1?m?(0,s.localize)(10,null,n):(0,s.localize)(11,null,n):m?(0,s.localize)(12,null,n):(0,s.localize)(13,null,n):n===1?m?(0,s.localize)(14,null,n):(0,s.localize)(15,null,n):m?(0,s.localize)(16,null,n):(0,s.localize)(17,null,n)):l<B?(n=Math.floor(l/b),d?n===1?m?(0,s.localize)(18,null,n):(0,s.localize)(19,null,n):m?(0,s.localize)(20,null,n):(0,s.localize)(21,null,n):n===1?m?(0,s.localize)(22,null,n):(0,s.localize)(23,null,n):m?(0,s.localize)(24,null,n):(0,s.localize)(25,null,n)):l<D?(n=Math.floor(l/B),d?n===1?(0,s.localize)(26,null,n):(0,s.localize)(27,null,n):n===1?(0,s.localize)(28,null,n):(0,s.localize)(29,null,n)):l<A?(n=Math.floor(l/D),d?n===1?m?(0,s.localize)(30,null,n):(0,s.localize)(31,null,n):m?(0,s.localize)(32,null,n):(0,s.localize)(33,null,n):n===1?m?(0,s.localize)(34,null,n):(0,s.localize)(35,null,n):m?(0,s.localize)(36,null,n):(0,s.localize)(37,null,n)):l<y?(n=Math.floor(l/A),d?n===1?m?(0,s.localize)(38,null,n):(0,s.localize)(39,null,n):m?(0,s.localize)(40,null,n):(0,s.localize)(41,null,n):n===1?m?(0,s.localize)(42,null,n):(0,s.localize)(43,null,n):m?(0,s.localize)(44,null,n):(0,s.localize)(45,null,n)):(n=Math.floor(l/y),d?n===1?m?(0,s.localize)(46,null,n):(0,s.localize)(47,null,n):m?(0,s.localize)(48,null,n):(0,s.localize)(49,null,n):n===1?m?(0,s.localize)(50,null,n):(0,s.localize)(51,null,n):m?(0,s.localize)(52,null,n):(0,s.localize)(53,null,n))}e.fromNow=F;function N(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(we[113],be([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(we[43],be([1,0,16,11,113]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function B(p,d){return d&&(p.stack||p.stacktrace)?b.localize(0,null,A(p),D(p.stack)||D(p.stacktrace)):A(p)}function D(p){return Array.isArray(p)?p.join(`
`):p}function A(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?b.localize(1,null,p.message):p.message||b.localize(2,null)}function y(p=null,d=!1){if(!p)return b.localize(3,null);if(Array.isArray(p)){const m=s.coalesce(p),l=y(m[0],d);return m.length>1?b.localize(4,null,l,m.length):l}if(I.isString(p))return p;if(p.detail){const m=p.detail;if(m.error)return B(m.error,d);if(m.exception)return B(m.exception,d)}return p.stack?B(p,d):p.message?p.message:b.localize(5,null)}e.toErrorMessage=y;function F(p){const d=p;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=F;function N(p,d=Object.create(null)){const m=new Error(p);return d.actions&&(m.actions=d.actions),m}e.createErrorWithActions=N}),define(we[114],be([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(we[115],be([1,0,114,23,116,16,26,109]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class p{constructor(J,le,Oe,$e){this.id=J,this.name=le,this.defaultValue=Oe,this.schema=$e}applyUpdate(J,le){return m(J,le)}compute(J,le,Oe){return Oe}}class d{constructor(J,le){this.newValue=J,this.didChange=le}}e.ApplyUpdateResult=d;function m(X,J){if(typeof X!="object"||typeof J!="object"||!X||!J)return new d(J,X!==J);if(Array.isArray(X)||Array.isArray(J)){const Oe=Array.isArray(X)&&Array.isArray(J)&&B.equals(X,J);return new d(J,Oe)}let le=!1;for(const Oe in J)if(J.hasOwnProperty(Oe)){const $e=m(X[Oe],J[Oe]);$e.didChange&&(X[Oe]=$e.newValue,le=!0)}return new d(X,le)}class l{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,le){return m(J,le)}validate(J){return this.defaultValue}}class n{constructor(J,le,Oe,$e){this.id=J,this.name=le,this.defaultValue=Oe,this.schema=$e}applyUpdate(J,le){return m(J,le)}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,le,Oe){return Oe}}function h(X,J){return typeof X=="undefined"?J:X==="false"?!1:Boolean(X)}e.boolean=h;class S extends n{constructor(J,le,Oe,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Oe);super(J,le,Oe,$e)}validate(J){return h(J,this.defaultValue)}}function k(X,J,le,Oe){if(typeof X=="undefined")return J;let $e=parseInt(X,10);return isNaN($e)?J:($e=Math.max(le,$e),$e=Math.min(Oe,$e),$e|0)}e.clampedInt=k;class u extends n{constructor(J,le,Oe,$e,Ge,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Oe,Je.minimum=$e,Je.maximum=Ge);super(J,le,Oe,Je);this.minimum=$e,this.maximum=Ge}static clampedInt(J,le,Oe,$e){return k(J,le,Oe,$e)}validate(J){return u.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class E extends n{constructor(J,le,Oe,$e,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Oe);super(J,le,Oe,Ge);this.validationFn=$e}static clamp(J,le,Oe){return J<le?le:J>Oe?Oe:J}static float(J,le){if(typeof J=="number")return J;if(typeof J=="undefined")return le;const Oe=parseFloat(J);return isNaN(Oe)?le:Oe}validate(J){return this.validationFn(E.float(J,this.defaultValue))}}class w extends n{static string(J,le){return typeof J!="string"?le:J}constructor(J,le,Oe,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Oe);super(J,le,Oe,$e)}validate(J){return w.string(J,this.defaultValue)}}function o(X,J,le){return typeof X!="string"||le.indexOf(X)===-1?J:X}e.stringSet=o;class T extends n{constructor(J,le,Oe,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=$e,Ge.default=Oe);super(J,le,Oe,Ge);this._allowedValues=$e}validate(J){return o(J,this.defaultValue,this._allowedValues)}}class r extends p{constructor(J,le,Oe,$e,Ge,Je,ft=void 0){typeof ft!="undefined"&&(ft.type="string",ft.enum=Ge,ft.default=$e);super(J,le,Oe,ft);this._allowedValues=Ge,this._convert=Je}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function i(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends p{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,le,Oe){return Oe===0?J.accessibilitySupport:Oe}}class t extends p{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:s.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{insertSpace:h(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function g(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(X){switch(X){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function P(X){switch(X){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class $ extends l{constructor(){super(128)}compute(J,le,Oe){const $e=["monaco-editor"];return le.get(33)&&$e.push(le.get(33)),J.extraEditorClassName&&$e.push(J.extraEditorClassName),le.get(66)==="default"?$e.push("mouse-default"):le.get(66)==="copy"&&$e.push("mouse-copy"),le.get(100)&&$e.push("showUnused"),le.get(126)&&$e.push("showDeprecated"),$e.join(" ")}}class L extends S{constructor(){super(32,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(J,le,Oe){return Oe&&J.emptySelectionClipboard}}class v extends p{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:s.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:s.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{cursorMoveOnType:h(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":o(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":o(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(le.loop,this.defaultValue.loop)}}}class H extends p{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?H.OFF:J==="true"?H.ON:J:Boolean(J)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class W extends l{constructor(){super(44)}compute(J,le,Oe){return J.fontInfo}}class q extends n{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(J){const le=E.float(J,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(le,6,100)}compute(J,le,Oe){return J.fontInfo.fontSize}}class K extends p{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(u.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class V extends p{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...le},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...le},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...le},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:s.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{multiple:o(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??o(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??o(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??o(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??o(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??o(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends p{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:s.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),delay:u.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:h(le.sticky,this.defaultValue.sticky),above:h(le.above,this.defaultValue.above)}}}var ae;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ae=e.RenderMinimap||(e.RenderMinimap={}));class de extends l{constructor(){super(131)}compute(J,le,Oe){return de.computeLayout(le,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const le=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?le-1:0,$e=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),Ge=Math.floor(J.viewLineCount/$e);return{typicalViewportLineCount:le,extraLinesBeyondLastLine:Oe,desiredRatio:$e,minimapLineCount:Ge}}static _computeMinimapLayout(J,le){const Oe=J.outerWidth,$e=J.outerHeight,Ge=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Je=le.stableMinimapLayoutInput,ft=Je&&J.outerHeight===Je.outerHeight&&J.lineHeight===Je.lineHeight&&J.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&J.pixelRatio===Je.pixelRatio&&J.scrollBeyondLastLine===Je.scrollBeyondLastLine&&J.minimap.enabled===Je.minimap.enabled&&J.minimap.side===Je.minimap.side&&J.minimap.size===Je.minimap.size&&J.minimap.showSlider===Je.minimap.showSlider&&J.minimap.renderCharacters===Je.minimap.renderCharacters&&J.minimap.maxColumn===Je.minimap.maxColumn&&J.minimap.scale===Je.minimap.scale&&J.verticalScrollbarWidth===Je.verticalScrollbarWidth&&J.isViewportWrapping===Je.isViewportWrapping,It=J.lineHeight,St=J.typicalHalfwidthCharacterWidth,kt=J.scrollBeyondLastLine,qe=J.minimap.renderCharacters;let vt=Ge>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Nt=J.minimap.maxColumn,nt=J.minimap.size,ut=J.minimap.side,At=J.verticalScrollbarWidth,Tt=J.viewLineCount,bt=J.remainingWidth,dt=J.isViewportWrapping,Rt=qe?2:3;let Lt=Math.floor(Ge*$e);const Ft=Lt/Ge;let Ue=!1,me=!1,pe=Rt*vt,oe=vt/Ge,G=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:rt,desiredRatio:at,minimapLineCount:ot}=de.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:kt,height:$e,lineHeight:It,pixelRatio:Ge});if(Tt/ot>1)Ue=!0,me=!0,vt=1,pe=1,oe=vt/Ge;else{let mt=!1,Dt=vt+1;if(nt==="fit"){const Ut=Math.ceil((Tt+rt)*pe);dt&&ft&&bt<=le.stableFitRemainingWidth?(mt=!0,Dt=le.stableFitMaxMinimapScale):mt=Ut>Lt}if(nt==="fill"||mt){Ue=!0;const Ut=vt;pe=Math.min(It*Ge,Math.max(1,Math.floor(1/at))),dt&&ft&&bt<=le.stableFitRemainingWidth&&(Dt=le.stableFitMaxMinimapScale),vt=Math.min(Dt,Math.max(1,Math.floor(pe/Rt))),vt>Ut&&(G=Math.min(2,vt/Ut)),oe=vt/Ge/G,Lt=Math.ceil(Math.max(Et,Tt+rt)*pe),dt?(le.stableMinimapLayoutInput=J,le.stableFitRemainingWidth=bt,le.stableFitMaxMinimapScale=vt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const Se=Math.floor(Nt*oe),Ce=Math.min(Se,Math.max(0,Math.floor((bt-At-2)*oe/(St+oe)))+e.MINIMAP_GUTTER_WIDTH);let xe=Math.floor(Ge*Ce);const je=xe/Ge;xe=Math.floor(xe*G);const lt=qe?1:2,gt=ut==="left"?0:Oe-Ce-At;return{renderMinimap:lt,minimapLeft:gt,minimapWidth:Ce,minimapHeightIsEditorHeight:Ue,minimapIsSampling:me,minimapScale:vt,minimapLineHeight:pe,minimapCanvasInnerWidth:xe,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:je,minimapCanvasOuterHeight:Ft}}static computeLayout(J,le){const Oe=le.outerWidth|0,$e=le.outerHeight|0,Ge=le.lineHeight|0,Je=le.lineNumbersDigitCount|0,ft=le.typicalHalfwidthCharacterWidth,It=le.maxDigitWidth,St=le.pixelRatio,kt=le.viewLineCount,qe=J.get(123),vt=qe==="inherit"?J.get(122):qe,Nt=vt==="inherit"?J.get(118):vt,nt=J.get(121),ut=J.get(2),At=le.isDominatedByLongLines,Tt=J.get(50),bt=J.get(60).renderType!==0,dt=J.get(61),Rt=J.get(94),Lt=J.get(65),Ft=J.get(92),Ue=Ft.verticalScrollbarSize,me=Ft.verticalHasArrows,pe=Ft.arrowSize,oe=Ft.horizontalScrollbarSize,G=J.get(58),Se=J.get(37);let Ce;if(typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)){const Wt=parseFloat(G.substr(0,G.length-2));Ce=u.clampedInt(Wt*ft,0,0,1e3)}else Ce=u.clampedInt(G,0,0,1e3);Se&&(Ce+=16);let xe=0;if(bt){const Wt=Math.max(Je,dt);xe=Math.round(Wt*It)}let je=0;Tt&&(je=Ge);let lt=0,gt=lt+je,Et=gt+xe,rt=Et+Ce;const at=Oe-je-xe-Ce;let ot=!1,Mt=!1,mt=-1;ut!==2&&(vt==="inherit"&&At?(ot=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(mt=nt));const Dt=de._computeMinimapLayout({outerWidth:Oe,outerHeight:$e,lineHeight:Ge,typicalHalfwidthCharacterWidth:ft,pixelRatio:St,scrollBeyondLastLine:Rt,minimap:Lt,verticalScrollbarWidth:Ue,viewLineCount:kt,remainingWidth:at,isViewportWrapping:Mt},le.memory||new N);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(lt+=Dt.minimapWidth,gt+=Dt.minimapWidth,Et+=Dt.minimapWidth,rt+=Dt.minimapWidth);const Ut=at-Dt.minimapWidth,wt=Math.max(1,Math.floor((Ut-Ue-2)/ft)),Bt=me?pe:0;return Mt&&(mt=Math.max(1,wt),Nt==="bounded"&&(mt=Math.min(mt,nt))),{width:Oe,height:$e,glyphMarginLeft:lt,glyphMarginWidth:je,lineNumbersLeft:gt,lineNumbersWidth:xe,decorationsLeft:Et,decorationsWidth:Ce,contentLeft:rt,contentWidth:Ut,minimap:Dt,viewportColumn:wt,isWordWrapMinified:ot,isViewportWrapping:Mt,wrappingColumn:mt,verticalScrollbarWidth:Ue,horizontalScrollbarHeight:oe,overviewRuler:{top:Bt,width:Ue,height:$e-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=de;class Y extends p{constructor(){const J={enabled:!0};super(57,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:s.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:h(J.enabled,this.defaultValue.enabled)}}}class ie extends p{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:s.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:s.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:s.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(le.fontFamily,this.defaultValue.fontFamily)}}}class ce extends E{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>E.clamp(J,0,150),{markdownDescription:s.localize(47,null)})}compute(J,le,Oe){return J.fontInfo.lineHeight}}class he extends p{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:s.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(49,null),s.localize(50,null),s.localize(51,null)],default:J.size,description:s.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:s.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:s.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:s.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:s.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),size:o(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(le.side,this.defaultValue.side,["right","left"]),showSlider:o(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(le.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(le.scale,1,1,3),maxColumn:u.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class re extends p{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{top:u.clampedInt(le.top,0,0,1e3),bottom:u.clampedInt(le.bottom,0,0,1e3)}}}class ge extends p{constructor(){const J={enabled:!0,cycle:!1};super(76,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:s.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:s.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),cycle:h(le.cycle,this.defaultValue.cycle)}}}class Te extends l{constructor(){super(129)}compute(J,le,Oe){return J.pixelRatio}}class Re extends p{constructor(){const J={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:s.localize(62,null)},comments:{type:"boolean",default:J.comments,description:s.localize(63,null)},other:{type:"boolean",default:J.other,description:s.localize(64,null)}}}],default:J,description:s.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const le=J,Oe={other:h(le.other,this.defaultValue.other),comments:h(le.comments,this.defaultValue.comments),strings:h(le.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var He;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(He=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends p{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(66,null),s.localize(67,null),s.localize(68,null),s.localize(69,null)],default:"on",description:s.localize(70,null)})}validate(J){let le=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(le=4,Oe=J):J==="interval"?le=3:J==="relative"?le=2:J==="on"?le=1:le=0),{renderType:le,renderFn:Oe}}}function ve(X){const J=X.get(87);return J==="editable"?X.get(81):J!=="on"}e.filterValidationDecorations=ve;class fe extends p{constructor(){const J=[],le={type:"number",description:s.localize(71,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:s.localize(72,null),format:"color-hex"}}}]},default:J,description:s.localize(73,null)})}validate(J){if(Array.isArray(J)){const le=[];for(let Oe of J)if(typeof Oe=="number")le.push({column:u.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const $e=Oe;le.push({column:u.clampedInt($e.column,0,0,1e4),color:$e.color})}return le.sort((Oe,$e)=>Oe.column-$e.column),le}return this.defaultValue}}function M(X,J){if(typeof X!="string")return J;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends p{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null)],default:"auto",description:s.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"auto",description:s.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:s.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:s.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:s.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J,Oe=u.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=u.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(le.vertical,this.defaultValue.vertical),horizontal:M(le.horizontal,this.defaultValue.horizontal),useShadows:h(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:u.clampedInt(le.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:u.clampedInt(le.verticalSliderSize,$e,0,1e3),scrollByPage:h(le.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class C extends p{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:s.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:s.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:s.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:s.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:s.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:s.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:s.localize(91,null)}})}applyUpdate(J,le){let Oe=!1;le.allowedCharacters&&(D.equals(J.allowedCharacters,le.allowedCharacters)||(J={...J,allowedCharacters:le.allowedCharacters},Oe=!0)),le.allowedLocales&&(D.equals(J.allowedLocales,le.allowedLocales)||(J={...J,allowedLocales:le.allowedLocales},Oe=!0));const $e=super.applyUpdate(J,le);return Oe?new d($e.newValue,!0):$e}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{nonBasicASCII:ne(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ne(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ne(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(J.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(J,le){if(typeof J!="object"||!J)return le;const Oe={};for(const[$e,Ge]of Object.entries(J))Ge===!0&&(Oe[$e]=!0);return Oe}}class R extends p{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:s.localize(92,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),mode:o(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends p{constructor(){const J={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:s.localize(93,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:h(J.enabled,this.defaultValue.enabled)}}}class Q extends p{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:J.bracketPairs,description:s.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(98,null),s.localize(99,null),s.localize(100,null)],default:J.bracketPairsHorizontal,description:s.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:s.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:s.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:s.localize(104,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{bracketPairs:ne(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ne(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:h(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ne(X,J,le){const Oe=le.indexOf(X);return Oe===-1?J:le[Oe]}class Ee extends p{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(105,null),s.localize(106,null)],default:J.insertMode,description:s.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:s.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:s.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:s.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:s.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:s.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:s.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:s.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:s.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{insertMode:o(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(le.showIcons,this.defaultValue.showIcons),showStatusBar:h(le.showStatusBar,this.defaultValue.showStatusBar),preview:h(le.preview,this.defaultValue.preview),previewMode:o(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(le.showMethods,this.defaultValue.showMethods),showFunctions:h(le.showFunctions,this.defaultValue.showFunctions),showConstructors:h(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(le.showDeprecated,this.defaultValue.showDeprecated),showFields:h(le.showFields,this.defaultValue.showFields),showVariables:h(le.showVariables,this.defaultValue.showVariables),showClasses:h(le.showClasses,this.defaultValue.showClasses),showStructs:h(le.showStructs,this.defaultValue.showStructs),showInterfaces:h(le.showInterfaces,this.defaultValue.showInterfaces),showModules:h(le.showModules,this.defaultValue.showModules),showProperties:h(le.showProperties,this.defaultValue.showProperties),showEvents:h(le.showEvents,this.defaultValue.showEvents),showOperators:h(le.showOperators,this.defaultValue.showOperators),showUnits:h(le.showUnits,this.defaultValue.showUnits),showValues:h(le.showValues,this.defaultValue.showValues),showConstants:h(le.showConstants,this.defaultValue.showConstants),showEnums:h(le.showEnums,this.defaultValue.showEnums),showEnumMembers:h(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(le.showKeywords,this.defaultValue.showKeywords),showWords:h(le.showWords,this.defaultValue.showWords),showColors:h(le.showColors,this.defaultValue.showColors),showFiles:h(le.showFiles,this.defaultValue.showFiles),showReferences:h(le.showReferences,this.defaultValue.showReferences),showFolders:h(le.showFolders,this.defaultValue.showFolders),showTypeParameters:h(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(le.showSnippets,this.defaultValue.showSnippets),showUsers:h(le.showUsers,this.defaultValue.showUsers),showIssues:h(le.showIssues,this.defaultValue.showIssues)}}}class Ie extends p{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(147,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends l{constructor(){super(130)}compute(J,le,Oe){return le.get(81)?!0:J.tabFocusMode}}var Le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends l{constructor(){super(132)}compute(J,le,Oe){const $e=le.get(131);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Qe:I.isLinux?tt:Ae,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(X){return e.editorOptionsRegistry[X.id]=X,X}var it;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.emptySelectionClipboard=32]="emptySelectionClipboard",X[X.extraEditorClassName=33]="extraEditorClassName",X[X.fastScrollSensitivity=34]="fastScrollSensitivity",X[X.find=35]="find",X[X.fixedOverflowWidgets=36]="fixedOverflowWidgets",X[X.folding=37]="folding",X[X.foldingStrategy=38]="foldingStrategy",X[X.foldingHighlight=39]="foldingHighlight",X[X.foldingImportsByDefault=40]="foldingImportsByDefault",X[X.foldingMaximumRegions=41]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=43]="fontFamily",X[X.fontInfo=44]="fontInfo",X[X.fontLigatures=45]="fontLigatures",X[X.fontSize=46]="fontSize",X[X.fontWeight=47]="fontWeight",X[X.formatOnPaste=48]="formatOnPaste",X[X.formatOnType=49]="formatOnType",X[X.glyphMargin=50]="glyphMargin",X[X.gotoLocation=51]="gotoLocation",X[X.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",X[X.hover=53]="hover",X[X.inDiffEditor=54]="inDiffEditor",X[X.inlineSuggest=55]="inlineSuggest",X[X.letterSpacing=56]="letterSpacing",X[X.lightbulb=57]="lightbulb",X[X.lineDecorationsWidth=58]="lineDecorationsWidth",X[X.lineHeight=59]="lineHeight",X[X.lineNumbers=60]="lineNumbers",X[X.lineNumbersMinChars=61]="lineNumbersMinChars",X[X.linkedEditing=62]="linkedEditing",X[X.links=63]="links",X[X.matchBrackets=64]="matchBrackets",X[X.minimap=65]="minimap",X[X.mouseStyle=66]="mouseStyle",X[X.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=68]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",X[X.multiCursorModifier=70]="multiCursorModifier",X[X.multiCursorPaste=71]="multiCursorPaste",X[X.occurrencesHighlight=72]="occurrencesHighlight",X[X.overviewRulerBorder=73]="overviewRulerBorder",X[X.overviewRulerLanes=74]="overviewRulerLanes",X[X.padding=75]="padding",X[X.parameterHints=76]="parameterHints",X[X.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",X[X.quickSuggestions=79]="quickSuggestions",X[X.quickSuggestionsDelay=80]="quickSuggestionsDelay",X[X.readOnly=81]="readOnly",X[X.renameOnType=82]="renameOnType",X[X.renderControlCharacters=83]="renderControlCharacters",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unicodeHighlighting=113]="unicodeHighlighting",X[X.unusualLineTerminators=114]="unusualLineTerminators",X[X.useShadowDOM=115]="useShadowDOM",X[X.useTabStops=116]="useTabStops",X[X.wordSeparators=117]="wordSeparators",X[X.wordWrap=118]="wordWrap",X[X.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=121]="wordWrapColumn",X[X.wordWrapOverride1=122]="wordWrapOverride1",X[X.wordWrapOverride2=123]="wordWrapOverride2",X[X.wrappingIndent=124]="wrappingIndent",X[X.wrappingStrategy=125]="wrappingStrategy",X[X.showDeprecated=126]="showDeprecated",X[X.inlayHints=127]="inlayHints",X[X.editorClassName=128]="editorClassName",X[X.pixelRatio=129]="pixelRatio",X[X.tabFocusMode=130]="tabFocusMode",X[X.layoutInfo=131]="layoutInfo",X[X.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new S(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(148,null)})),acceptSuggestionOnEnter:ke(new T(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(149,null),""],markdownDescription:s.localize(150,null)})),accessibilitySupport:ke(new c),accessibilityPageSize:ke(new u(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(151,null)})),ariaLabel:ke(new w(4,"ariaLabel",s.localize(152,null))),autoClosingBrackets:ke(new T(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(153,null),s.localize(154,null),""],description:s.localize(155,null)})),autoClosingDelete:ke(new T(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(156,null),""],description:s.localize(157,null)})),autoClosingOvertype:ke(new T(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(158,null),""],description:s.localize(159,null)})),autoClosingQuotes:ke(new T(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(160,null),s.localize(161,null),""],description:s.localize(162,null)})),autoIndent:ke(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[s.localize(163,null),s.localize(164,null),s.localize(165,null),s.localize(166,null),s.localize(167,null)],description:s.localize(168,null)})),automaticLayout:ke(new S(10,"automaticLayout",!1)),autoSurround:ke(new T(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(169,null),s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),bracketPairColorization:ke(new x),bracketPairGuides:ke(new Q),stickyTabStops:ke(new S(104,"stickyTabStops",!1,{description:s.localize(173,null)})),codeLens:ke(new S(14,"codeLens",!0,{description:s.localize(174,null)})),codeLensFontFamily:ke(new w(15,"codeLensFontFamily","",{description:s.localize(175,null)})),codeLensFontSize:ke(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(176,null)})),colorDecorators:ke(new S(17,"colorDecorators",!0,{description:s.localize(177,null)})),columnSelection:ke(new S(18,"columnSelection",!1,{description:s.localize(178,null)})),comments:ke(new t),contextmenu:ke(new S(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new S(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(179,null)})),cursorBlinking:ke(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:s.localize(180,null)})),cursorSmoothCaretAnimation:ke(new S(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(181,null)})),cursorStyle:ke(new r(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:s.localize(182,null)})),cursorSurroundingLines:ke(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(183,null)})),cursorSurroundingLinesStyle:ke(new T(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(184,null),s.localize(185,null)],description:s.localize(186,null)})),cursorWidth:ke(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(187,null)})),disableLayerHinting:ke(new S(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new S(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new S(30,"domReadOnly",!1)),dragAndDrop:ke(new S(31,"dragAndDrop",!0,{description:s.localize(188,null)})),emptySelectionClipboard:ke(new L),extraEditorClassName:ke(new w(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new E(34,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:s.localize(189,null)})),find:ke(new v),fixedOverflowWidgets:ke(new S(36,"fixedOverflowWidgets",!1)),folding:ke(new S(37,"folding",!0,{description:s.localize(190,null)})),foldingStrategy:ke(new T(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(191,null),s.localize(192,null)],description:s.localize(193,null)})),foldingHighlight:ke(new S(39,"foldingHighlight",!0,{description:s.localize(194,null)})),foldingImportsByDefault:ke(new S(40,"foldingImportsByDefault",!1,{description:s.localize(195,null)})),foldingMaximumRegions:ke(new u(41,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(196,null)})),unfoldOnClickAfterEndOfLine:ke(new S(42,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(197,null)})),fontFamily:ke(new w(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(198,null)})),fontInfo:ke(new W),fontLigatures2:ke(new H),fontSize:ke(new q),fontWeight:ke(new K),formatOnPaste:ke(new S(48,"formatOnPaste",!1,{description:s.localize(199,null)})),formatOnType:ke(new S(49,"formatOnType",!1,{description:s.localize(200,null)})),glyphMargin:ke(new S(50,"glyphMargin",!0,{description:s.localize(201,null)})),gotoLocation:ke(new V),hideCursorInOverviewRuler:ke(new S(52,"hideCursorInOverviewRuler",!1,{description:s.localize(202,null)})),hover:ke(new z),inDiffEditor:ke(new S(54,"inDiffEditor",!1)),letterSpacing:ke(new E(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>E.clamp(X,-5,20),{description:s.localize(203,null)})),lightbulb:ke(new Y),lineDecorationsWidth:ke(new n(58,"lineDecorationsWidth",10)),lineHeight:ke(new ce),lineNumbers:ke(new Xe),lineNumbersMinChars:ke(new u(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new S(62,"linkedEditing",!1,{description:s.localize(204,null)})),links:ke(new S(63,"links",!0,{description:s.localize(205,null)})),matchBrackets:ke(new T(64,"matchBrackets","always",["always","near","never"],{description:s.localize(206,null)})),minimap:ke(new he),mouseStyle:ke(new T(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new E(67,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:s.localize(207,null)})),mouseWheelZoom:ke(new S(68,"mouseWheelZoom",!1,{markdownDescription:s.localize(208,null)})),multiCursorMergeOverlapping:ke(new S(69,"multiCursorMergeOverlapping",!0,{description:s.localize(209,null)})),multiCursorModifier:ke(new r(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[s.localize(210,null),s.localize(211,null)],markdownDescription:s.localize(212,null)})),multiCursorPaste:ke(new T(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(213,null),s.localize(214,null)],markdownDescription:s.localize(215,null)})),occurrencesHighlight:ke(new S(72,"occurrencesHighlight",!0,{description:s.localize(216,null)})),overviewRulerBorder:ke(new S(73,"overviewRulerBorder",!0,{description:s.localize(217,null)})),overviewRulerLanes:ke(new u(74,"overviewRulerLanes",3,0,3)),padding:ke(new re),parameterHints:ke(new ge),peekWidgetDefaultFocus:ke(new T(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(218,null),s.localize(219,null)],description:s.localize(220,null)})),definitionLinkOpensInPeek:ke(new S(78,"definitionLinkOpensInPeek",!1,{description:s.localize(221,null)})),quickSuggestions:ke(new Re),quickSuggestionsDelay:ke(new u(80,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(222,null)})),readOnly:ke(new S(81,"readOnly",!1)),renameOnType:ke(new S(82,"renameOnType",!1,{description:s.localize(223,null),markdownDeprecationMessage:s.localize(224,null)})),renderControlCharacters:ke(new S(83,"renderControlCharacters",!0,{description:s.localize(225,null),restricted:!0})),renderFinalNewline:ke(new S(84,"renderFinalNewline",!0,{description:s.localize(226,null)})),renderLineHighlight:ke(new T(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(227,null)],description:s.localize(228,null)})),renderLineHighlightOnlyWhenFocus:ke(new S(86,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(229,null)})),renderValidationDecorations:ke(new T(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new T(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(230,null),s.localize(231,null),s.localize(232,null),""],description:s.localize(233,null)})),revealHorizontalRightPadding:ke(new u(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new S(90,"roundedSelection",!0,{description:s.localize(234,null)})),rulers:ke(new fe),scrollbar:ke(new O),scrollBeyondLastColumn:ke(new u(93,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(235,null)})),scrollBeyondLastLine:ke(new S(94,"scrollBeyondLastLine",!0,{description:s.localize(236,null)})),scrollPredominantAxis:ke(new S(95,"scrollPredominantAxis",!0,{description:s.localize(237,null)})),selectionClipboard:ke(new S(96,"selectionClipboard",!0,{description:s.localize(238,null),included:I.isLinux})),selectionHighlight:ke(new S(97,"selectionHighlight",!0,{description:s.localize(239,null)})),selectOnLineNumbers:ke(new S(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new T(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(240,null),s.localize(241,null)],description:s.localize(242,null)})),showUnused:ke(new S(100,"showUnused",!0,{description:s.localize(243,null)})),showDeprecated:ke(new S(126,"showDeprecated",!0,{description:s.localize(244,null)})),inlayHints:ke(new ie),snippetSuggestions:ke(new T(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(245,null),s.localize(246,null),s.localize(247,null),s.localize(248,null)],description:s.localize(249,null)})),smartSelect:ke(new Ie),smoothScrolling:ke(new S(103,"smoothScrolling",!1,{description:s.localize(250,null)})),stopRenderingLineAfter:ke(new u(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new Ee),inlineSuggest:ke(new R),suggestFontSize:ke(new u(107,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(251,null)})),suggestLineHeight:ke(new u(108,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(252,null)})),suggestOnTriggerCharacters:ke(new S(109,"suggestOnTriggerCharacters",!0,{description:s.localize(253,null)})),suggestSelection:ke(new T(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(254,null),s.localize(255,null),s.localize(256,null)],description:s.localize(257,null)})),tabCompletion:ke(new T(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(258,null),s.localize(259,null),s.localize(260,null)],description:s.localize(261,null)})),tabIndex:ke(new u(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new C),unusualLineTerminators:ke(new T(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(262,null),s.localize(263,null),s.localize(264,null)],description:s.localize(265,null)})),useShadowDOM:ke(new S(115,"useShadowDOM",!0)),useTabStops:ke(new S(116,"useTabStops",!0,{description:s.localize(266,null)})),wordSeparators:ke(new w(117,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:s.localize(267,null)})),wordWrap:ke(new T(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(268,null),s.localize(269,null),s.localize(270,null),s.localize(271,null)],description:s.localize(272,null)})),wordWrapBreakAfterCharacters:ke(new w(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new w(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new u(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(273,null)})),wordWrapOverride1:ke(new T(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new T(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new r(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[s.localize(274,null),s.localize(275,null),s.localize(276,null),s.localize(277,null)],description:s.localize(278,null)})),wrappingStrategy:ke(new T(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(279,null),s.localize(280,null)],description:s.localize(281,null)})),editorClassName:ke(new $),pixelRatio:ke(new Te),tabFocusMode:ke(new Me),layoutInfo:ke(new de),wrappingInfo:ke(new Be)}}),define(we[117],be([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[118],be([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[119],be([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(we[120],be([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(we[121],be([18,19]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(we[122],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[123],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[124],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(we[125],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[126],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[127],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[128],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[129],be([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(we[130],be([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[131],be([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(we[132],be([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[133],be([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[134],be([18,19]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(we[135],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var s;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var I;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(I=e.EditorResolution||(e.EditorResolution={}));var b;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var B;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(B=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(A){A.PROGRAMMATIC="api",A.NAVIGATION="code.navigation",A.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[136],be([1,0,118]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function B(d){return d=d.trim(),d==="*"||I.test(d)}e.isValidVersionStr=B;function D(d){if(!B(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=d.match(I);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=D;function A(d){if(!d)return null;let m=d.majorBase,l=d.majorMustEqual,n=d.minorBase,h=d.minorMustEqual,S=d.patchBase,k=d.patchMustEqual;d.hasCaret&&(m===0||(h=!1),k=!1);let u=0;if(d.preRelease){const E=b.exec(d.preRelease);if(E){const[,w,o,T]=E;u=Date.UTC(Number(w),Number(o)-1,Number(T))}}return{majorBase:m,majorMustEqual:l,minorBase:n,minorMustEqual:h,patchBase:S,patchMustEqual:k,isMinimum:d.hasGreaterEquals,notBefore:u}}e.normalizeVersion=A;function y(d,m,l){let n;typeof d=="string"?n=A(D(d)):n=d;let h;m instanceof Date?h=m.getTime():typeof m=="string"&&(h=new Date(m).getTime());let S;if(typeof l=="string"?S=A(D(l)):S=l,!n||!S)return!1;let k=n.majorBase,u=n.minorBase,E=n.patchBase,w=S.majorBase,o=S.minorBase,T=S.patchBase,r=S.notBefore,i=S.majorMustEqual,c=S.minorMustEqual,t=S.patchMustEqual;return S.isMinimum?k>w?!0:k<w?!1:u>o?!0:u<o||h&&h<r?!1:E>=T:(k===1&&w===0&&(!i||!c||!t)&&(w=1,o=0,T=0,i=!0,c=!1,t=!1),k<w?!1:k>w?!i:u<o?!1:u>o?!c:E<T?!1:E>T?!t:!(h&&h<r))}e.isValidVersion=y;function F(d,m,l,n){return l.isBuiltin||typeof l.main=="undefined"?!0:p(d,m,l.engines.vscode,n)}e.isValidExtensionVersion=F;function N(d,m,l){return d==="*"||p(m,l,d)}e.isEngineValid=N;function p(d,m,l,n=[]){let h=A(D(l));if(!h)return n.push(s.localize(0,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return n.push(s.localize(1,null,l)),!1}else if(!h.majorMustEqual)return n.push(s.localize(2,null,l)),!1;return y(d,m,h)?!0:(n.push(s.localize(3,null,d,l)),!1)}}),define(we[76],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(b,B=[],D=!1){this.ctor=b,this.staticArguments=B,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=s}),define(we[55],be([1,0,76]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function b(D,A,y){A instanceof s.SyncDescriptor||(A=new s.SyncDescriptor(A,[],y)),I.push([D,A])}e.registerSingleton=b;function B(){return I}e.getSingletonServiceDescriptors=B}),define(we[137],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(B){this.incoming=new Map,this.outgoing=new Map,this.data=B}}e.Node=s;class I{constructor(B){this._hashFn=B,this._nodes=new Map}roots(){const B=[];for(let D of this._nodes.values())D.outgoing.size===0&&B.push(D);return B}insertEdge(B,D){const A=this.lookupOrInsertNode(B),y=this.lookupOrInsertNode(D);A.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(B),A)}removeNode(B){const D=this._hashFn(B);this._nodes.delete(D);for(let A of this._nodes.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(B){const D=this._hashFn(B);let A=this._nodes.get(D);return A||(A=new s(B),this._nodes.set(D,A)),A}lookup(B){return this._nodes.get(this._hashFn(B))}isEmpty(){return this._nodes.size===0}toString(){let B=[];for(let[D,A]of this._nodes)B.push(`${D}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return B.join(`
`)}findCycleSlow(){for(let[B,D]of this._nodes){const A=new Set([B]),y=this._findCycle(D,A);if(y)return y}}_findCycle(B,D){for(let[A,y]of B.outgoing){if(D.has(A))return[...D,A].join(" -> ");D.add(A);const F=this._findCycle(y,D);if(F)return F;D.delete(A)}}}e.Graph=I}),define(we[3],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(s=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function I(D,A,y){A[s.DI_TARGET]===A?A[s.DI_DEPENDENCIES].push({id:D,index:y}):(A[s.DI_DEPENDENCIES]=[{id:D,index:y}],A[s.DI_TARGET]=A)}function b(D){if(s.serviceIds.has(D))return s.serviceIds.get(D);const A=function(y,F,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,y,N)};return A.toString=()=>D,s.serviceIds.set(D,A),A}e.createDecorator=b;function B(D){return D}e.refineServiceDecorator=B}),define(we[77],be([1,0,11,2,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function B(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof I.URI)}e.isConfigurationOverrides=B;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||s.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=D;var A;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function F(h,S){const k=Object.create(null);for(let u in h)N(k,u,h[u],S);return k}e.toValuesTree=F;function N(h,S,k,u){const E=S.split("."),w=E.pop();let o=h;for(let T=0;T<E.length;T++){let r=E[T],i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:u(`Ignoring ${S} as ${E.slice(0,T+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[w]=k}catch{u(`Ignoring ${S} as ${E.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${S} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=N;function p(h,S){const k=S.split(".");d(h,k)}e.removeFromValueTree=p;function d(h,S){const k=S.shift();if(S.length===0){delete h[k];return}if(Object.keys(h).indexOf(k)!==-1){const u=h[k];typeof u=="object"&&!Array.isArray(u)&&(d(u,S),Object.keys(u).length===0&&delete h[k])}}function m(h,S,k){function u(o,T){let r=o;for(const i of T){if(typeof r!="object"||r===null)return;r=r[i]}return r}const E=S.split("."),w=u(h,E);return typeof w=="undefined"?k:w}e.getConfigurationValue=m;function l(h,S,k){Object.keys(S).forEach(u=>{u!=="__proto__"&&(u in h?s.isObject(h[u])&&s.isObject(S[u])?l(h[u],S[u],k):k&&(h[u]=S[u]):h[u]=S[u])})}e.merge=l;function n(h,S,k){const u=h.inspect(S),E=h.inspect(k);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:u.defaultValue}e.getMigratedSettingValue=n}),define(we[44],be([1,0,23,9,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const B=new Map;B.set("false",!1),B.set("true",!0),B.set("isMac",s.isMacintosh),B.set("isLinux",s.isLinux),B.set("isWindows",s.isWindows),B.set("isWeb",s.isWeb),B.set("isMacNative",s.isMacintosh&&!s.isWeb),B.set("isEdge",s.isEdge),B.set("isFirefox",s.isFirefox),B.set("isChrome",s.isChrome),B.set("isSafari",s.isSafari);const D=Object.prototype.hasOwnProperty;var A;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return p.INSTANCE}static true(){return d.INSTANCE}static has(v){return m.create(v)}static equals(v,H){return l.create(v,H)}static notEquals(v,H){return S.create(v,H)}static regex(v,H){return r.create(v,H)}static in(v,H){return n.create(v,H)}static not(v){return k.create(v)}static and(...v){return t.create(v,null)}static or(...v){return a.create(v,null,!0)}static greater(v,H){return E.create(v,H)}static greaterEquals(v,H){return w.create(v,H)}static smaller(v,H){return o.create(v,H)}static smallerEquals(v,H){return T.create(v,H)}static deserialize(v,H=!1){if(!!v)return this._deserializeOrExpression(v,H)}static _deserializeOrExpression(v,H){let W=v.split("||");return a.create(W.map(q=>this._deserializeAndExpression(q,H)),null,!0)}static _deserializeAndExpression(v,H){let W=v.split("&&");return t.create(W.map(q=>this._deserializeOne(q,H)),null)}static _deserializeOne(v,H){if(v=v.trim(),v.indexOf("!=")>=0){let W=v.split("!=");return S.create(W[0].trim(),this._deserializeValue(W[1],H))}if(v.indexOf("==")>=0){let W=v.split("==");return l.create(W[0].trim(),this._deserializeValue(W[1],H))}if(v.indexOf("=~")>=0){let W=v.split("=~");return r.create(W[0].trim(),this._deserializeRegexValue(W[1],H))}if(v.indexOf(" in ")>=0){let W=v.split(" in ");return n.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const W=v.split(">=");return w.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const W=v.split(">");return E.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const W=v.split("<=");return T.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const W=v.split("<");return o.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(v)?k.create(v.substr(1).trim()):m.create(v)}static _deserializeValue(v,H){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let W=/^'([^']*)'$/.exec(v);return W?W[1].trim():v}static _deserializeRegexValue(v,H){if((0,I.isFalsyOrWhitespace)(v)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=v.indexOf("/"),q=v.lastIndexOf("/");if(W===q||W<0){if(H)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let K=v.slice(W+1,q),V=v[q+1]==="i"?"i":"";try{return new RegExp(K,V)}catch(z){if(H)throw new Error(`bad regexp-value '${v}', parse error: ${z}`);return console.warn(`bad regexp-value '${v}', parse error: ${z}`),null}}}e.ContextKeyExpr=y;function F(L,v){const H=L?L.substituteConstants():void 0,W=v?v.substituteConstants():void 0;return!H&&!W?!0:!H||!W?!1:H.equals(W)}e.expressionsAreEqualWithConstantSubstitution=F;function N(L,v){return L.cmp(v)}class p{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=p,p.INSTANCE=new p;class d{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return p.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class m{constructor(v,H){this.key=v,this.negated=H,this.type=2}static create(v,H=null){const W=B.get(v);return typeof W=="boolean"?W?d.INSTANCE:p.INSTANCE:new m(v,H)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=B.get(this.key);return typeof v=="boolean"?v?d.INSTANCE:p.INSTANCE:this}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class l{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=4}static create(v,H,W=null){if(typeof H=="boolean")return H?m.create(v,W):k.create(v,W);const q=B.get(v);return typeof q=="boolean"?H===(q?"true":"false")?d.INSTANCE:p.INSTANCE:new l(v,H,W)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=B.get(this.key);if(typeof v=="boolean"){const H=v?"true":"false";return this.value===H?d.INSTANCE:p.INSTANCE}return this}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class n{constructor(v,H){this.key=v,this.valueKey=H,this.type=10,this.negated=null}static create(v,H){return new n(v,H)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}substituteConstants(){return this}evaluate(v){const H=v.getValue(this.valueKey),W=v.getValue(this.key);return Array.isArray(H)?H.indexOf(W)>=0:typeof W=="string"&&typeof H=="object"&&H!==null?D.call(H,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this)),this.negated}}e.ContextKeyInExpr=n;class h{constructor(v){this._actual=v,this.type=11}static create(v){return new h(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new h(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=h;class S{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=5}static create(v,H,W=null){if(typeof H=="boolean")return H?k.create(v,W):m.create(v,W);const q=B.get(v);return typeof q=="boolean"?H===(q?"true":"false")?p.INSTANCE:d.INSTANCE:new S(v,H,W)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=B.get(this.key);if(typeof v=="boolean"){const H=v?"true":"false";return this.value===H?p.INSTANCE:d.INSTANCE}return this}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class k{constructor(v,H){this.key=v,this.negated=H,this.type=3}static create(v,H=null){const W=B.get(v);return typeof W=="boolean"?W?p.INSTANCE:d.INSTANCE:new k(v,H)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=B.get(this.key);return typeof v=="boolean"?v?p.INSTANCE:d.INSTANCE:this}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function u(L,v){if(typeof L=="string"){const H=parseFloat(L);isNaN(H)||(L=H)}return typeof L=="string"||typeof L=="number"?v(L):p.INSTANCE}class E{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=12}static create(v,H,W=null){return u(H,q=>new E(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=E;class w{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=13}static create(v,H,W=null){return u(H,q=>new w(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class o{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=14}static create(v,H,W=null){return u(H,q=>new o(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class T{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=15}static create(v,H,W=null){return u(H,q=>new T(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=T;class r{constructor(v,H){this.key=v,this.regexp=H,this.type=7,this.negated=null}static create(v,H){return new r(v,H)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const H=this.regexp?this.regexp.source:"",W=v.regexp?v.regexp.source:"";return H<W?-1:H>W?1:0}equals(v){if(v.type===this.type){const H=this.regexp?this.regexp.source:"",W=v.regexp?v.regexp.source:"";return this.key===v.key&&H===W}return!1}substituteConstants(){return this}evaluate(v){let H=v.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(v){this._actual=v,this.type=8}static create(v){return new i(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new i(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function c(L){let v=null;for(let H=0,W=L.length;H<W;H++){const q=L[H].substituteConstants();if(L[H]!==q&&v===null){v=[];for(let K=0;K<H;K++)v[K]=L[K]}v!==null&&(v[H]=q)}return v===null?L:v}class t{constructor(v,H){this.expr=v,this.negated=H,this.type=6}static create(v,H){return t._normalizeArr(v,H)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let H=0,W=this.expr.length;H<W;H++){const q=N(this.expr[H],v.expr[H]);if(q!==0)return q}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let H=0,W=this.expr.length;H<W;H++)if(!this.expr[H].equals(v.expr[H]))return!1;return!0}return!1}substituteConstants(){const v=c(this.expr);return v===this.expr?this:t.create(v,this.negated)}evaluate(v){for(let H=0,W=this.expr.length;H<W;H++)if(!this.expr[H].evaluate(v))return!1;return!0}static _normalizeArr(v,H){const W=[];let q=!1;for(const K of v)if(!!K){if(K.type===1){q=!0;continue}if(K.type===0)return p.INSTANCE;if(K.type===6){W.push(...K.expr);continue}W.push(K)}if(W.length===0&&q)return d.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(N);for(let K=1;K<W.length;K++)W[K-1].equals(W[K])&&(W.splice(K,1),K--);if(W.length===1)return W[0];for(;W.length>1;){const K=W[W.length-1];if(K.type!==9)break;W.pop();const V=W.pop(),z=W.length===0,ae=a.create(K.expr.map(de=>t.create([de,V],null)),null,z);ae&&(W.push(ae),W.sort(N))}return W.length===1?W[0]:new t(W,H)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let H of this.expr)v.push(...H.keys());return v}map(v){return new t(this.expr.map(H=>H.map(v)),null)}negate(){if(!this.negated){const v=[];for(let H of this.expr)v.push(H.negate());this.negated=a.create(v,this,!0)}return this.negated}}class a{constructor(v,H){this.expr=v,this.negated=H,this.type=9}static create(v,H,W){return a._normalizeArr(v,H,W)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let H=0,W=this.expr.length;H<W;H++){const q=N(this.expr[H],v.expr[H]);if(q!==0)return q}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let H=0,W=this.expr.length;H<W;H++)if(!this.expr[H].equals(v.expr[H]))return!1;return!0}return!1}substituteConstants(){const v=c(this.expr);return v===this.expr?this:a.create(v,this.negated,!1)}evaluate(v){for(let H=0,W=this.expr.length;H<W;H++)if(this.expr[H].evaluate(v))return!0;return!1}static _normalizeArr(v,H,W){let q=[],K=!1;if(v){for(let V=0,z=v.length;V<z;V++){const ae=v[V];if(!!ae){if(ae.type===0){K=!0;continue}if(ae.type===1)return d.INSTANCE;if(ae.type===9){q=q.concat(ae.expr);continue}q.push(ae)}}if(q.length===0&&K)return p.INSTANCE;q.sort(N)}if(q.length!==0){if(q.length===1)return q[0];for(let V=1;V<q.length;V++)q[V-1].equals(q[V])&&(q.splice(V,1),V--);if(q.length===1)return q[0];if(W){for(let V=0;V<q.length;V++)for(let z=V+1;z<q.length;z++)P(q[V],q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0]}return new a(q,H)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let H of this.expr)v.push(...H.keys());return v}map(v){return new a(this.expr.map(H=>H.map(v)),null)}negate(){if(!this.negated){let v=[];for(let H of this.expr)v.push(H.negate());for(;v.length>1;){const H=v.shift(),W=v.shift(),q=[];for(const V of $(H))for(const z of $(W))q.push(t.create([V,z],null));const K=v.length===0;v.unshift(a.create(q,null,K))}this.negated=v[0]}return this.negated}}class g extends m{constructor(v,H,W){super(v,null);this._defaultValue=H,typeof W=="object"?g._info.push({...W,key:v}):W!==!0&&g._info.push({key:v,description:W,type:H!=null?typeof H:void 0})}static all(){return g._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return l.create(this.key,v)}notEqualsTo(v){return S.create(this.key,v)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(L,v){return L<v?-1:L>v?1:0}function _(L,v,H,W){return L<H?-1:L>H?1:v<W?-1:v>W?1:0}function P(L,v){if(v.type===6&&L.type!==9&&L.type!==6){for(const q of v.expr)if(L.equals(q))return!0}const H=L.negate(),W=$(H).concat($(v));W.sort(N);for(let q=0;q<W.length;q++){const V=W[q].negate();for(let z=q+1;z<W.length;z++){const ae=W[z];if(V.equals(ae))return!0}}return!1}e.implies=P;function $(L){return L.type===9?L.expr:[L]}}),define(we[138],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(we[45],be([1,0,15,22,17,9,11,2,119,3]),function(Z,e,s,I,b,B,D,A,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,F.createDecorator)("fileService");function N(V){return V.create===!0}e.isFileOpenForWriteOptions=N;var p;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(p=e.FileType||(e.FileType={}));var d;(function(V){V[V.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var m;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function l(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=l;function n(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=n;function h(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=S;function k(V){return l(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var u;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(z,ae){super(z);this.code=ae}}e.FileSystemProviderError=E;function w(V,z){const ae=new E(V.toString(),z);return T(ae,z),ae}e.createFileSystemProviderError=w;function o(V){return V||w((0,y.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=o;function T(V,z){return V.name=z?`${z} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=T;function r(V){if(!V)return u.Unknown;if(V instanceof E)return V.code;const z=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!z)return u.Unknown;switch(z[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=r;function i(V){if(V instanceof _)return V.fileOperationResult;switch(r(V)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var c;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class t{constructor(z,ae,de){this.resource=z,this.operation=ae,this.target=de}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var a;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(z,ae){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const de=new Map;for(const Y of z){const ie=de.get(Y.type);switch(ie?ie.push([Y.resource,Y]):de.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ie]of de)switch(Y){case 1:this.added=I.TernarySearchTree.forUris(()=>ae),this.added.fill(ie);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>ae),this.updated.fill(ie);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>ae),this.deleted.fill(ie);break}}contains(z,...ae){return this.doContains(z,{includeChildren:!1},...ae)}affects(z,...ae){return this.doContains(z,{includeChildren:!0},...ae)}doContains(z,ae,...de){if(!z)return!1;const Y=de.length>0;return!!((!Y||de.includes(1))&&(this.added?.get(z)||ae.includeChildren&&this.added?.findSuperstr(z))||(!Y||de.includes(0))&&(this.updated?.get(z)||ae.includeChildren&&this.updated?.findSuperstr(z))||(!Y||de.includes(2))&&(this.deleted?.findSubstr(z)||ae.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function f(V,z,ae){return!V||!z||V===z||z.length>V.length?!1:(z.charAt(z.length-1)!==b.sep&&(z+=b.sep),ae?(0,B.startsWithIgnoreCase)(V,z):V.indexOf(z)===0)}e.isParent=f;class _ extends s.ErrorNoTelemetry{constructor(z,ae,de){super(z);this.fileOperationResult=ae,this.options=de}}e.FileOperationError=_;class P extends _{constructor(z,ae,de){super(z,2,de);this.stat=ae}}e.NotModifiedSinceFileOperationError=P;var $;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})($=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=v;async function H(V,z){if(!z.hasProvider(A.URI.from({scheme:V.scheme})))return new Promise(ae=>{const de=z.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===V.scheme&&Y.added&&(de.dispose(),ae())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(z){return(0,D.isNumber)(z)||(z=0),z<W.KB?(0,y.localize)(1,null,z.toFixed(0)):z<W.MB?(0,y.localize)(2,null,(z/W.KB).toFixed(2)):z<W.GB?(0,y.localize)(3,null,(z/W.MB).toFixed(2)):z<W.TB?(0,y.localize)(4,null,(z/W.GB).toFixed(2)):(0,y.localize)(5,null,(z/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var q;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function K(V){return{maxFileSize:V===0?300*W.MB:16*W.GB,maxHeapSize:V===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=K}),define(we[56],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...b){this._entries=new Map;for(let[B,D]of b)this.set(B,D)}set(b,B){const D=this._entries.get(b);return this._entries.set(b,B),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=s}),define(we[139],be([1,0,13,15,76,137,3,56]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class F extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class N{constructor(l=new A.ServiceCollection,n=!1,h){this._activeInstantiations=new Set,this._services=l,this._strict=n,this._parent=h,this._services.set(D.IInstantiationService,this)}createChild(l){return new N(l,this._strict,this)}invokeFunction(l,...n){let h=d.traceInvocation(l),S=!1;try{return l({get:u=>{if(S)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const E=this._getOrCreateServiceInstance(u,h);if(!E)throw new Error(`[invokeFunction] unknown service '${u}'`);return E}},...n)}finally{S=!0,h.stop()}}createInstance(l,...n){let h,S;return l instanceof b.SyncDescriptor?(h=d.traceCreation(l.ctor),S=this._createInstance(l.ctor,l.staticArguments.concat(n),h)):(h=d.traceCreation(l),S=this._createInstance(l,n,h)),h.stop(),S}_createInstance(l,n=[],h){let S=D._util.getServiceDependencies(l).sort((E,w)=>E.index-w.index),k=[];for(const E of S){let w=this._getOrCreateServiceInstance(E.id,h);w||this._throwIfStrict(`[createInstance] ${l.name} depends on UNKNOWN service ${E.id}.`,!1),k.push(w)}let u=S.length>0?S[0].index:n.length;if(n.length!==u){console.warn(`[createInstance] First service dependency of ${l.name} at position ${u+1} conflicts with ${n.length} static arguments`);let E=u-n.length;E>0?n=n.concat(new Array(E)):n=n.slice(0,u)}return new l(...[...n,...k])}_setServiceInstance(l,n){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,n);else if(this._parent)this._parent._setServiceInstance(l,n);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let n=this._services.get(l);return!n&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):n}_getOrCreateServiceInstance(l,n){let h=this._getServiceInstanceOrDescriptor(l);return h instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,h,n.branch(l,!0)):(n.branch(l,!1),h)}_safeCreateAndCacheServiceInstance(l,n,h){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,n,h)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,n,h){const S=new B.Graph(E=>E.id.toString());let k=0;const u=[{id:l,desc:n,_trace:h}];for(;u.length;){const E=u.pop();if(S.lookupOrInsertNode(E),k++>1e3)throw new F(S);for(let w of D._util.getServiceDependencies(E.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(w.id);if(o||this._throwIfStrict(`[createInstance] ${l} depends on ${w.id} which is NOT registered.`,!0),o instanceof b.SyncDescriptor){const T={id:w.id,desc:o,_trace:E._trace.branch(w.id,!0)};S.insertEdge(E,T),u.push(T)}}}for(;;){const E=S.roots();if(E.length===0){if(!S.isEmpty())throw new F(S);break}for(const{data:w}of E){if(this._getServiceInstanceOrDescriptor(w.id)instanceof b.SyncDescriptor){const T=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,T)}S.removeNode(w)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,n,h=[],S,k){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(n,h,S,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,n,h,S,k);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}_createServiceInstance(l,n=[],h,S){if(h){const k=new s.IdleValue(()=>this._createInstance(l,n,S));return new Proxy(Object.create(null),{get(u,E){if(E in u)return u[E];let w=k.value,o=w[E];return typeof o!="function"||(o=o.bind(w),u[E]=o),o},set(u,E,w){return k.value[E]=w,!0}})}else return this._createInstance(l,n,S)}_throwIfStrict(l,n){if(n&&console.warn(n),this._strict)throw new Error(l)}}e.InstantiationService=N;var p;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(p||(p={}));class d{constructor(l,n){this.type=l,this.name=n,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return y?new d(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(l){return y?new d(0,l.name):d._None}branch(l,n){let h=new d(2,l.toString());return this._dep.push([l,n,h]),h}stop(){let l=Date.now()-this._start;d._totals+=l;let n=!1;function h(k,u){let E=[],w=new Array(k+1).join("	");for(const[o,T,r]of u._dep)if(T&&r){n=!0,E.push(`${w}CREATES -> ${o}`);let i=h(k+1,r);i&&E.push(i)}else E.push(`${w}uses -> ${o}`);return E.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(l>2||n)&&console.log(S.join(`
`))}}e.Trace=d,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(we[12],be([1,0,43,5,6,23,3]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function A(){return new Date().toISOString()}var y;(function(T){T[T.Trace=0]="Trace",T[T.Debug=1]="Debug",T[T.Info=2]="Info",T[T.Warning=3]="Warning",T[T.Error=4]="Error",T[T.Critical=5]="Critical",T[T.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function F(T,r,i){switch(r){case y.Trace:T.trace(i);break;case y.Debug:T.debug(i);break;case y.Info:T.info(i);break;case y.Warning:T.warn(i);break;case y.Error:T.error(i);break;case y.Critical:T.critical(i);break;default:throw new Error("Invalid log level")}}e.log=F;function N(T){let r="";for(let i=0;i<T.length;i++){let c=T[i];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}r+=(i>0?" ":"")+c}return r}e.format=N;class p extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class d extends p{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,N([r,...i]))}debug(r,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,N([r,...i]))}info(r,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,N([r,...i]))}warn(r,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,N([r,...i]))}error(r,...i){if(this.checkLogLevel(y.Error))if(r instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=r.stack,this.log(y.Error,N(c))}else this.log(y.Error,N([r,...i]))}critical(r,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,N([r,...i]))}flush(){}}e.AbstractMessageLogger=d;class m extends p{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!B.isWindows}trace(r,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}debug(r,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}info(r,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}warn(r,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,r,...i):console.warn(`[main ${A()}]`,r,...i))}error(r,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}critical(r,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class l extends p{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class n extends p{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,s.toErrorMessage)(r,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=n;class h extends p{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const c of this.logServices)c.trace(r,...i)}debug(r,...i){for(const c of this.logServices)c.debug(r,...i)}info(r,...i){for(const c of this.logServices)c.info(r,...i)}warn(r,...i){for(const c of this.logServices)c.warn(r,...i)}error(r,...i){for(const c of this.logServices)c.error(r,...i)}critical(r,...i){for(const c of this.logServices)c.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=h;class S extends b.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=S;class k extends b.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(c))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let c=this.loggers.get(r.toString());return c||(c=this.doCreateLogger(r,i?.always?y.Trace:this.logLevel,i),this.loggers.set(r.toString(),c),i?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class u{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(r){}getLevel(){return y.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=u;function E(T){if(T.verbose)return y.Trace;if(typeof T.logLevel=="string"){const r=w(T.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function w(T){switch(T){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=w;function o(T){switch(T){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=o}),define(we[78],be([1,0,34,120,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var B;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(B=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function F(l,n){return n-l}y.compare=F;const N=Object.create(null);N[y.Error]=(0,I.localize)(0,null),N[y.Warning]=(0,I.localize)(1,null),N[y.Info]=(0,I.localize)(2,null);function p(l){return N[l]||""}y.toString=p;function d(l){switch(l){case s.default.Error:return y.Error;case s.default.Warning:return y.Warning;case s.default.Info:return y.Info;case s.default.Ignore:return y.Hint}}y.fromSeverity=d;function m(l){switch(l){case y.Error:return s.default.Error;case y.Warning:return s.default.Warning;case y.Info:return s.default.Info;case y.Hint:return s.default.Ignore}}y.toSeverity=m}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const F="";function N(d){return p(d,!0)}y.makeKey=N;function p(d,m){let l=[F];return d.source?l.push(d.source.replace("\xA6","\\\xA6")):l.push(F),d.code?typeof d.code=="string"?l.push(d.code.replace("\xA6","\\\xA6")):l.push(d.code.value.replace("\xA6","\\\xA6")):l.push(F),d.severity!==void 0&&d.severity!==null?l.push(D.toString(d.severity)):l.push(F),d.message&&m?l.push(d.message.replace("\xA6","\\\xA6")):l.push(F),d.startLineNumber!==void 0&&d.startLineNumber!==null?l.push(d.startLineNumber.toString()):l.push(F),d.startColumn!==void 0&&d.startColumn!==null?l.push(d.startColumn.toString()):l.push(F),d.endLineNumber!==void 0&&d.endLineNumber!==null?l.push(d.endLineNumber.toString()):l.push(F),d.endColumn!==void 0&&d.endColumn!==null?l.push(d.endColumn.toString()):l.push(F),l.push(F),l.join("\xA6")}y.makeKeyOptionalMessage=p})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(we[140],be([1,0,5,34,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,b.createDecorator)("notificationService");var B;(function(F){F[F.WORKSPACE=0]="WORKSPACE",F[F.GLOBAL=1]="GLOBAL"})(B=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(F){F[F.OFF=0]="OFF",F[F.SILENT=1]="SILENT",F[F.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=y}),define(we[79],be([1,0,6,9,2,3]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,B.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(N){return{resolved:N,dispose(){}}}});function D(N,p){return b.URI.isUri(N)?(0,I.equalsIgnoreCase)(N.scheme,p):(0,I.startsWithIgnoreCase)(N,p+":")}e.matchesScheme=D;function A(N,...p){return p.some(d=>D(N,d))}e.matchesSomeScheme=A;function y(N,p){return N.with({fragment:`${p.startLineNumber},${p.startColumn}${p.endLineNumber?`-${p.endLineNumber}${p.endColumn?`,${p.endColumn}`:""}`:""}`})}e.withSelection=y;function F(N){let p;const d=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(N.fragment);return d&&(p={startLineNumber:parseInt(d[1]),startColumn:d[2]?parseInt(d[2]):1,endLineNumber:d[4]?parseInt(d[4]):void 0,endColumn:d[4]?d[5]?parseInt(d[5]):1:void 0},N=N.with({fragment:""})),{selection:p,uri:N}}e.extractSelection=F});var Fe=this&&this.__decorate||function(Z,e,s,I){var b=arguments.length,B=b<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,s):I,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(Z,e,s,I);else for(var A=Z.length-1;A>=0;A--)(D=Z[A])&&(B=(b<3?D(B):b>3?D(e,s,B):D(e,s))||B);return b>3&&B&&Object.defineProperty(e,s,B),B},Ne=this&&this.__param||function(Z,e){return function(s,I){e(s,I,Z)}};define(we[141],be([1,0,13,20,6,3]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,B.createDecorator)("progressService");var D;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(p){this.callback=p}get value(){return this._value}report(p){this._value=p,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends b.Disposable{constructor(p,d){super();this.deferred=new s.DeferredPromise,d.withProgress(p,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(p){this.reporter?this.reporter.report(p):this.lastStep=p}};y=Fe([Ne(1,e.IProgressService)],y),e.UnmanagedProgress=y;class F extends b.Disposable{constructor(p){super();this.progressIndicator=p,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(p){this.stop();const d=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},p),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:m.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(p){this.currentOperationId===p&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=F,e.IEditorProgressService=(0,B.createDecorator)("editorProgressService")}),define(we[37],be([1,0,42,11]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(D,A){s.ok(I.isString(D)),s.ok(I.isObject(A)),s.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,A)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new b}),define(we[142],be([1,0,5,37]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class B{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,F){this.schemasById[b(y)]=F,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new B;I.Registry.add(e.Extensions.JSONContribution,D)}),define(we[80],be([1,0,16,5,11,117,142,37]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var F;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const N=A.Registry.as(D.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:B.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(w,o=!0){this.registerConfigurations([w],o)}registerConfigurations(w,o=!0){const T=this.doRegisterConfigurations(w,o);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T})}deregisterConfigurations(w){const o=this.doDeregisterConfigurations(w);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:w,remove:o}){const T=[];T.push(...this.doDeregisterConfigurations(o)),T.push(...this.doRegisterConfigurations(w,!1)),N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(T)})}registerDefaultConfigurations(w){const o=[],T=[];for(const{overrides:r,source:i}of w)for(const c in r)if(o.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const t={...this.configurationDefaultsOverrides.get(c)?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:i,value:t});const a={type:"object",default:t,description:B.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t,source:b.isString(i)?void 0:i};T.push(...l(c)),this.configurationProperties[c]=a,this.defaultLanguageConfigurationOverridesNode.properties[c]=a}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:i});const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(T),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(w){const o=[];for(const{overrides:T,source:r}of w)for(const i in T){const c=this.configurationDefaultsOverrides.get(i),t=b.isString(r)?r:r?.id,a=b.isString(c?.source)?c?.source:c?.source?.id;if(t===a)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const o of w)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(w,o){const T=[];return w.forEach(r=>{T.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),T}doDeregisterConfigurations(w){const o=[],T=r=>{if(r.properties)for(const i in r.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>T(i))};for(const r of w){T(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(w,o=!0,T,r,i=3){i=b.isUndefinedOrNull(w.scope)?i:w.scope;let c=[],t=w.properties;if(t)for(let g in t){if(o&&k(g)){delete t[g];continue}const f=t[g];if(f.source=T,f.defaultDefaultValue=t[g].default,this.updatePropertyDefaultValue(g,f),e.OVERRIDE_PROPERTY_REGEX.test(g)?f.scope=void 0:(f.scope=b.isUndefinedOrNull(f.scope)?i:f.scope,f.restricted=b.isUndefinedOrNull(f.restricted)?!!r?.includes(g):f.restricted),t[g].hasOwnProperty("included")&&!t[g].included){this.excludedConfigurationProperties[g]=t[g],delete t[g];continue}else this.configurationProperties[g]=t[g];!t[g].deprecationMessage&&t[g].markdownDeprecationMessage&&(t[g].deprecationMessage=t[g].markdownDeprecationMessage),c.push(g)}let a=w.allOf;if(a)for(let g of a)c.push(...this.validateAndRegisterProperties(g,o,T,r,i));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(w){const o=T=>{let r=T.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);let i=T.allOf;i&&i.forEach(o)};o(w)}updateSchema(w,o){switch(e.allSettings.properties[w]=o,o.scope){case 1:e.applicationSettings.properties[w]=o;break;case 2:e.machineSettings.properties[w]=o;break;case 6:e.machineOverridableSettings.properties[w]=o;break;case 3:e.windowSettings.properties[w]=o;break;case 4:e.resourceSettings.properties[w]=o;break;case 5:e.resourceSettings.properties[w]=o,this.resourceLanguageSettingsSchema.properties[w]=o;break}}removeFromSchema(w,o){switch(delete e.allSettings.properties[w],o.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w],delete this.resourceLanguageSettingsSchema.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const o=`[${w}]`,T={type:"object",description:B.localize(2,null),errorMessage:B.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,T),e.allSettings.properties[o]=T,e.applicationSettings.properties[o]=T,e.machineSettings.properties[o]=T,e.machineOverridableSettings.properties[o]=T,e.windowSettings.properties[o]=T,e.resourceSettings.properties[o]=T}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const w={type:"object",description:B.localize(4,null),errorMessage:B.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,o){const T=this.configurationDefaultsOverrides.get(w);let r=T?.value,i=T?.source;b.isUndefined(r)&&(r=o.defaultDefaultValue,i=void 0),b.isUndefined(r)&&(r=h(o.type)),o.default=r,o.defaultValueSource=i}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(E){const w=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let o=m.exec(E);for(;o?.length;){const T=o[1].trim();T&&w.push(T),o=m.exec(E)}}return(0,s.distinct)(w)}e.overrideIdentifiersFromKey=l;function n(E){return E.reduce((w,o)=>`${w}[${o}]`,"")}e.keyFromOverrideIdentifiers=n;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const S=new p;A.Registry.add(e.Extensions.Configuration,S);function k(E){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?B.localize(7,null,E):S.getConfigurationProperties()[E]!==void 0?B.localize(8,null,E):null:B.localize(6,null)}e.validateProperty=k;function u(){const E=[],w=S.getConfigurationProperties();for(const o of Object.keys(w))E.push([o,w[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=u}),define(we[143],be([1,0,16,5,100,6,22,26,11,2,77,80,37]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(r={},i=[],c=[]){this._contents=r,this._keys=i,this._overrides=c,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const c=this.getContentsForOverrideIdentifer(i);return c?r?(0,N.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const c of this.overrides)c.identifiers.includes(r)&&i.push(...c.keys);return s.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return s.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),c=A.deepClone(this.overrides),t=[...this.keys];for(const a of r){this.mergeContents(i,a.contents);for(const g of a.overrides){const[f]=c.filter(_=>s.equals(_.identifiers,g.identifiers));f?(this.mergeContents(f.contents,g.contents),f.keys.push(...g.keys),f.keys=s.distinct(f.keys)):c.push(A.deepClone(g))}for(const g of a.keys)t.indexOf(g)===-1&&t.push(g)}return new m(i,t,c)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let c={};for(const t of s.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[t],g=i[t];g&&(typeof a=="object"&&typeof g=="object"?(a=A.deepClone(a),this.mergeContents(a,g)):a=g),c[t]=a}return new m(c,this.keys,this.overrides)}mergeContents(r,i){for(const c of Object.keys(i)){if(c in r&&y.isObject(r[c])&&y.isObject(i[c])){this.mergeContents(r[c],i[c]);continue}r[c]=A.deepClone(i[c])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?A.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,c=null;const t=a=>{a&&(c?this.mergeContents(c,a):c=A.deepClone(a))};for(const a of this.overrides)s.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&t(a.contents);return t(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,N.addToValueTree)(this.contents,r,i,c=>{throw new Error(c)})}removeValue(r){this.removeKey(r)&&(0,N.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let c=0;c<i;c++)r.indexOf(this.keys[c])===0&&(i=c);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(r={}){const i=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(i),t=Object.create(null),a=[];for(const g in i){const f=r[g],_=f!==void 0?f:i[g].default;(0,N.addToValueTree)(t,g,_,P=>console.error(`Conflict in default settings: ${P}`))}for(const g of Object.keys(t))p.OVERRIDE_PROPERTY_REGEX.test(g)&&a.push({identifiers:(0,p.overrideIdentifiersFromKey)(g),keys:Object.keys(t[g]),contents:(0,N.toValuesTree)(t[g],f=>console.error(`Conflict in default settings file: ${f}`))});super(t,c,a)}}e.DefaultConfigurationModel=l;class n{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!y.isUndefinedOrNull(r)){const c=this.doParseContent(r);this.parseRaw(c,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:c,keys:t,overrides:a,restricted:g}=this.doParseRaw(r,i);this._configurationModel=new m(c,t,a),this._restrictedConfigurations=g||[]}doParseContent(r){let i={},c=null,t=[],a=[],g=[];function f(P){Array.isArray(t)?t.push(P):c!==null&&(t[c]=P)}let _={onObjectBegin:()=>{let P={};f(P),a.push(t),t=P,c=null},onObjectProperty:P=>{c=P},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let P=[];f(P),a.push(t),t=P,c=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:f,onError:(P,$,L)=>{g.push({error:P,offset:$,length:L})}};if(r)try{b.visit(r,_),i=t[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(r,i){const c=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),t=this.filter(r,c,!0,i);r=t.raw;const a=(0,N.toValuesTree)(r,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),g=Object.keys(r),f=this.toOverrides(r,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:g,overrides:f,restricted:t.restricted}}filter(r,i,c,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:r,restricted:[]};const a={},g=[];for(let f in r)if(p.OVERRIDE_PROPERTY_REGEX.test(f)&&c){const _=this.filter(r[f],i,!1,t);a[f]=_.raw,g.push(..._.restricted)}else{const _=i[f],P=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&g.push(f),(P===void 0||t.scopes===void 0||t.scopes.includes(P))&&(t.skipRestricted&&_?.restricted||(a[f]=r[f]))}return{raw:a,restricted:g}}toOverrides(r,i){const c=[];for(const t of Object.keys(r))if(p.OVERRIDE_PROPERTY_REGEX.test(t)){const a={};for(const g in r[t])a[g]=r[t][g];c.push({identifiers:(0,p.overrideIdentifiersFromKey)(t),keys:Object.keys(a),contents:(0,N.toValuesTree)(a,i)})}return c}}e.ConfigurationModelParser=n;class h extends B.Disposable{constructor(r,i,c,t){super();this.userSettingsResource=r,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new n(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&c.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class S{constructor(r,i,c=new m,t=new m,a=new D.ResourceMap,g=new m,f=new D.ResourceMap,_=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=c,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=g,this._memoryConfigurationByResource=f,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,c){return this.getConsolidateConfigurationModel(i,c).getValue(r)}updateValue(r,i,c={}){let t;c.resource?(t=this._memoryConfigurationByResource.get(c.resource),t||(t=new m,this._memoryConfigurationByResource.set(c.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(r):t.setValue(r,i),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,c){const t=this.getConsolidateConfigurationModel(i,c),a=this.getFolderConfigurationModelForResource(i.resource,c),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),_=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),$=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),L=c?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,v=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,H=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(r):g.getValue(r),W=t.getValue(r),q=s.distinct(s.flatten(t.overrides.map(K=>K.identifiers))).filter(K=>t.getOverrideValue(r,K)!==void 0);return{defaultValue:f,userValue:_,userLocalValue:P,userRemoteValue:$,workspaceValue:L,workspaceFolderValue:v,memoryValue:H,value:W,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:v!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(r),override:i.overrideIdentifier?g.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const c=[];if(!i){const{added:t,updated:a,removed:g}=w(this._defaultConfiguration,r);i=[...t,...a,...g]}for(const t of i)for(const a of(0,p.overrideIdentifiersFromKey)(t)){const g=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=r.getKeysForOverrideIdentifier(a),_=[...f.filter(P=>g.indexOf(P)===-1),...g.filter(P=>f.indexOf(P)===-1),...g.filter(P=>!A.equals(this._defaultConfiguration.override(a).getValue(P),r.override(a).getValue(P)))];c.push([a,_])}return this.updateDefaultConfiguration(r),{keys:i,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:c,removed:t,overrides:a}=w(this.localUserConfiguration,r),g=[...i,...c,...t];return g.length&&this.updateLocalUserConfiguration(r),{keys:g,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:c,removed:t,overrides:a}=w(this.remoteUserConfiguration,r);let g=[...i,...c,...t];return g.length&&this.updateRemoteUserConfiguration(r),{keys:g,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:c,removed:t,overrides:a}=w(this.workspaceConfiguration,r);let g=[...i,...c,...t];return g.length&&this.updateWorkspaceConfiguration(r),{keys:g,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const c=this.folderConfigurations.get(r),{added:t,updated:a,removed:g,overrides:f}=w(c,i);let _=[...t,...a,...g];return(_.length||!c)&&this.updateFolderConfiguration(r,i),{keys:_,overrides:f}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:t,removed:a,overrides:g}=w(i,void 0);return{keys:[...c,...t,...a],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let c=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?c.override(r.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:r},i){let c=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const t=i.getFolder(r);t&&(c=this.getFolderConsolidatedConfiguration(t.uri)||c);const a=this._memoryConfigurationByResource.get(r);a&&(c=c.merge(a))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const c=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(r);t?(i=c.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=c}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const c=i.getFolder(r);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:c,overrides:t,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:c,overrides:t,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(c=>r.add(c))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(t=>i.add(t))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),c=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((g,f)=>(g.set(F.URI.revive(f[0]),this.parseConfigurationModel(f[1])),g),new D.ResourceMap);return new S(i,c,new m,t,a,new m,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function k(...T){if(T.length===0)return{keys:[],overrides:[]};if(T.length===1)return T[0];const r=new Set,i=new Map;for(const t of T)t.keys.forEach(a=>r.add(a)),t.overrides.forEach(([a,g])=>{const f=(0,D.getOrSet)(i,a,new Set);g.forEach(_=>f.add(_))});const c=[];return i.forEach((t,a)=>c.push([a,[...t.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=k;class u{constructor(r,i,c,t){this.change=r,this.previous=i,this.currentConfiguraiton=c,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(f=>a.add(f)),r.overrides.forEach(([,f])=>f.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const g=new m;this.affectedKeys.forEach(f=>g.setValue(f,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const c=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!A.equals(c,t)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let c=(0,N.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof c=="object"&&(t=Object.keys(c)[0]);){if(r=r[t],!r)return!1;c=c[t]}return!0}}e.ConfigurationChangeEvent=u;class E extends u{constructor(r,i,c,t){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=c,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=E;function w(T,r){const{added:i,removed:c,updated:t}=o(r,T),a=[],g=T?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const _=f.filter(P=>!g.includes(P));for(const P of _)a.push([P,r.getKeysForOverrideIdentifier(P)])}if(T){const _=g.filter(P=>!f.includes(P));for(const P of _)a.push([P,T.getKeysForOverrideIdentifier(P)])}if(r&&T){for(const _ of g)if(f.includes(_)){const P=o({contents:T.getOverrideValue(void 0,_)||{},keys:T.getKeysForOverrideIdentifier(_)},{contents:r.getOverrideValue(void 0,_)||{},keys:r.getKeysForOverrideIdentifier(_)});a.push([_,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:c,updated:t,overrides:a}}function o(T,r){const i=T?r?T.keys.filter(a=>r.keys.indexOf(a)===-1):[...T.keys]:[],c=r?T?r.keys.filter(a=>T.keys.indexOf(a)===-1):[...r.keys]:[],t=[];if(T&&r){for(const a of r.keys)if(T.keys.indexOf(a)!==-1){const g=(0,N.getConfigurationValue)(r.contents,a),f=(0,N.getConfigurationValue)(T.contents,a);A.equals(g,f)||t.push(a)}}return{added:i,removed:c,updated:t}}}),define(we[81],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var I;(function(B){B.Unknown="Unknown",B.NotAvailable="NotAvailable",B.TemporarilyNotAvailable="TemporarilyNotAvailable",B.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(D,A=I.Unknown,y){super(D);this._message=D,this._code=A,this._detail=y,this.isHandled=A===I.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(D){return D instanceof b&&D._code===I.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof b&&D._code===I.NoResolverFound}static isHandled(D){return D instanceof b&&D.isHandled}}e.RemoteAuthorityResolverError=b}),define(we[82],be([1,0,10]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(B){return B.scheme===s.Schemas.vscodeRemote?B.authority:void 0}e.getRemoteAuthority=I;function b(B){if(!B)return;const D=B.indexOf("+");return D<0?B:B.substr(0,D)}e.getRemoteName=b}),define(we[25],be([1,0,9,3,82]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function B(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=B;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,l){if(typeof m=="undefined"||m===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof m=="string"||typeof l=="string"){let n=typeof m=="string"?m:m.value,h=typeof l=="string"?l:l.value;return s.equalsIgnoreCase(n,h)}return m._lower===l._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=y;function F(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=F;function N(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=N;function p(d,m){if(m){const l=`onResolveRemoteAuthority:${(0,b.getRemoteName)(m)}`;return d.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[144],be([1,0,9,25]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(l,n){return l.uuid&&n.uuid?l.uuid===n.uuid:l.id===n.id?!0:(0,s.compareIgnoreCase)(l.id,n.id)===0}e.areSameExtensions=b;class B{constructor(n,h){this.version=h,this.id=n.id,this.uuid=n.uuid}key(){return`${this.id}-${this.version}`}equals(n){return n instanceof B?b(this,n)&&this.version===n.version:!1}}e.ExtensionIdentifierWithVersion=B;function D(l,n){return`${l}.${n}`}e.getExtensionId=D;function A(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function y(l,n){return A(D(l,n))}e.getGalleryExtensionId=y;function F(l,n){const h=[],S=k=>{for(const u of h)if(u.some(E=>b(n(E),n(k))))return u;return null};for(const k of l){const u=S(k);u?u.push(k):h.push([k])}return h}e.groupByExtension=F;function N(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=N;function p(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(l){const n=new Set;if(l.malicious)for(const h of l.malicious)n.add(h.id);return n}e.getMaliciousExtensionsSet=d;function m(l,n){const h=[],S=n.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&h.every(u=>!b(u.identifier,{id:k}))){const u=l.filter(E=>b(E.identifier,{id:k}));u.length===1&&(h.push(u[0]),S.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}e.getExtensionDependencies=m}),define(we[145],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,B,D=5){let A;return A=B(y=>{const F=typeof y=="string"?y:y.data;let N=this._terminalBufferMap.get(b);if(N){N.data.push(F);return}const p=setTimeout(()=>this.flushBuffer(b),D);N={data:[F],timeoutId:p,dispose:()=>{clearTimeout(p),this.flushBuffer(b),A.dispose()}},this._terminalBufferMap.set(b,N)}),A}stopBuffering(b){const B=this._terminalBufferMap.get(b);B&&B.dispose()}flushBuffer(b){const B=this._terminalBufferMap.get(b);B&&(this._terminalBufferMap.delete(b),this._callback(b,B.data.join("")))}}e.TerminalDataBufferer=s}),define(we[146],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var s;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(s=e.ColorScheme||(e.ColorScheme={}))}),define(we[57],be([1,0,106,5,6,3,37,146]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,B.createDecorator)("themeService");var y;(function(h){function S(k){return k&&typeof k=="object"&&typeof k.id=="string"}h.isThemeColor=S})(y=e.ThemeColor||(e.ThemeColor={}));function F(h){return{id:h}}e.themeColorFromId=F;var N;(function(h){function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}h.isThemeIcon=S;const k=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const c=k.exec(i);if(!c)return;let[,t]=c;return{id:t}}h.fromString=u;function E(i){return{id:i}}h.fromId=E;function w(i,c){let t=i.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),c&&(t=`${t}~${c}`),{id:t}}h.modify=w;function o(i){const c=i.id.lastIndexOf("~");if(c!==-1)return i.id.substring(c+1)}h.getModifier=o;function T(i,c){return i.id===c.id&&i.color?.id===c.color?.id}h.isEqual=T;function r(i,c){return{id:i.id,color:c?F(c):void 0}}h.asThemeIcon=r,h.asClassNameArray=s.CSSIcon.asClassNameArray,h.asClassName=s.CSSIcon.asClassName,h.asCSSSelector=s.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function p(h){switch(h){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=p,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,b.toDisposable)(()=>{const k=this.themingParticipants.indexOf(S);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new d;D.Registry.add(e.Extensions.ThemingContribution,m);function l(h){return m.onColorThemeChange(h)}e.registerThemingParticipant=l;class n extends b.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,k){let u=this.theme.getColor(S);return u&&k&&(u=k(u,this.theme)),u?u.toString():null}}e.Themable=n}),define(we[147],be([1,0,5,23,3,12]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var D;(function(l){l.Http="http",l.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function F(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=F,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=p;function d(l,n){return n?n!==1&&l<1024:!I.isWindows&&l<1024}e.isPortPrivileged=d;let m=class{constructor(n){this.logService=n,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],h=Array.from(this._tunnels.values());for(let S of h){const k=Array.from(S.values());for(let u of k){const E=await u.value;E&&n.push(E)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:h}of n.values())await h.then(S=>S?.dispose());n.clear()}this._tunnels.clear()}openTunnel(n,h,S,k,u=!1,E=A.Private,w){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${S} on local port ${k}.`),!n)return;h||(h="localhost");const o=this.retainOrCreateTunnel(n,h,S,k,u,E,w);return o?o.then(T=>{if(!T){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(T);return(T.tunnelRemoteHost!==h||T.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const h=this._tunnels.get(n.tunnelRemoteHost);if(h){const S=h.get(n.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,S))}}}}async tryDisposeTunnel(n,h,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${h}.`);const k=S.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(h),k}}async closeTunnel(n,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${h} `);const S=this._tunnels.get(n);if(S&&S.has(h)){const k=S.get(h);k.refcount=0,await this.tryDisposeTunnel(n,h,k)}}addTunnelToMap(n,h,S){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(h,{refcount:1,value:S})}async removeEmptyTunnelFromMap(n,h){const S=this._tunnels.get(n);S&&(await S.get(h)||S.delete(h),S.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,h){let S=[n];N(n)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):p(n)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const k=S.map(u=>this._tunnels.get(u));for(const u of k){const E=u?.get(h);if(E)return E}}canTunnel(n){return!!F(n)}createWithProvider(n,h,S,k,u,E,w){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${S} on local port ${k}.`);const T={elevationRequired:u?d(k===void 0?S:k):!1},r={remoteAddress:{host:h,port:S},localAddressPort:k,privacy:E,public:E!==A.Private,protocol:w},i=n.forwardPort(r,T);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(h,S,i),i}};m=Fe([Ne(0,B.ILogService)],m),e.AbstractTunnelService=m}),define(we[148],be([1,0,10]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(A){return A.scheme!==s.Schemas.file&&A.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=I;function b(A){if(A.folders.length)return A.folders.every(y=>I(y.uri))?A.folders[0].uri:void 0;if(A.configuration&&I(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=b;function B(A){return b(A)?.scheme}e.getVirtualWorkspaceScheme=B;function D(A){return b(A)!==void 0}e.isVirtualWorkspace=D}),define(we[46],be([1,0,121,17,22,24,2,3,10]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function F(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=F;function N(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=N;function p(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=p;function d(r){const i=r;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=d;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function l(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=l;function n(r){const i=r;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=n;class h{constructor(i,c,t,a,g){this._id=i,this._transient=t,this._configuration=a,this._ignorePathCasing=g,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class S{constructor(i,c){this.raw=c,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,B.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function k(r){return new S({uri:r,index:0,name:(0,B.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,s.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(r,i){return B.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function w(r){let i;return D.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=w;function o(r,i){return!E(r,i)&&!w(r)}e.isSavedWorkspace=o;function T(r){return(typeof r=="string"?(0,I.extname)(r):(0,B.extname)(r))===u}e.hasWorkspaceFileExtension=T}),define(we[58],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const B=this._idPool++;return this._data.set(B,b),this.logDebugInfo(),B}get(b,B){return this._data.has(b)?this._data.get(b)[B]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(we[30],be([1,0,10,24,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class B{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=B,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(we[149],be([1,0,13]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(D,A,y){this._deferredPromises=new Map,this._id=D,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(F=>(this._value=F,this)),this._storageListener=this._storage.onDidChangeStorage(F=>{F.shared===this._shared&&F.key===this._id&&(this._value=F.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const F=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of F.values())N.complete()}catch(N){for(const p of F.values())p.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,A){let y=this._value[D];return typeof y=="undefined"&&(y=A),y}update(D,A){this._value[D]=A;let y=this._deferredPromises.get(D);if(y!==void 0)return y.p;const F=new s.DeferredPromise;return this._deferredPromises.set(D,F),this._scheduler.isScheduled()||this._scheduler.schedule(),F.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class b extends I{constructor(D,A){super(D.identifier.value,!0,A);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=b}),define(we[150],be([1,0,5,2,12]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let B=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new s.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,y,F){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(y.value,F)}$acceptDirtyStateChanged(A,y){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptDirty(y)}$acceptModelSaved(A){const y=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,y);const F=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));F.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:F.apiNotebook})}};B=Fe([Ne(0,b.ILogService)],B),e.ExtHostNotebookDocuments=B}),define(we[14],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class I{constructor(B){this.getProxy=B.getProxy.bind(B),this.set=B.set.bind(B),this.assertRegistered=B.assertRegistered.bind(B),this.drain=B.drain.bind(B)}}e.ExtHostRpcService=I});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[151],be([1,0,25,5]),function(Z,e,s,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class B{constructor(A,y){b.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(A.identifier),Ve(this,b,y,"f"),ye(this,b,"f").onDidChangePassword(F=>{F.extensionId===this._id&&this._onDidChange.fire({key:F.key})})}get(A){return ye(this,b,"f").get(this._id,A)}store(A,y){return ye(this,b,"f").store(this._id,A,y)}delete(A){return ye(this,b,"f").delete(this._id,A)}}e.ExtensionSecrets=B,b=new WeakMap}),define(we[83],be([1,0,3,5]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(D){this._level=D}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(we[47],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var s;(function(k){k[k.Upsert=0]="Upsert",k[k.RemoveChild=1]="RemoveChild",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp",k[k.Bulk=4]="Bulk"})(s=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const I=new WeakMap,b=(k,u)=>{const E={controllerId:u};return I.set(k,E),E};e.createPrivateApiFor=b;const B=k=>I.get(k);e.getPrivateApiFor=B;const D=(k,u,E,w)=>{let o=E;return{enumerable:!0,configurable:!1,get(){return o},set(T){if(!w(o,T)){const r=o;o=T,k.listener?.({op:3,key:u,value:T,previous:r})}}}},A=(k,u)=>k===u,y={range:(k,u)=>k===u?!0:!k||!u?!1:k.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(k,u)=>!(k.length!==u.length||k.some(E=>!u.find(w=>E.id===w.id)))},F=Object.keys(y),N=(k,u)=>({range:D(k,"range",void 0,y.range),label:D(k,"label",u,y.label),description:D(k,"description",void 0,y.description),sortText:D(k,"sortText",void 0,y.sortText),canResolveChildren:D(k,"canResolveChildren",!1,y.canResolveChildren),busy:D(k,"busy",!1,y.busy),error:D(k,"error",void 0,y.error),tags:D(k,"tags",[],y.tags)}),p=(k,u)=>{const E=new Map;for(const w of F)y[w](k[w],u[w])||E.set(w,u[w]);return E};e.diffTestItems=p;class d extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=d;class m extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class l extends Error{constructor(u,E,w){super(`TestItem with ID "${u}" is from controller "${E}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=l;const n=k=>{const u=(0,e.getPrivateApiFor)(k);let E=new Map;return{get size(){return E.size},forEach(w,o){for(const T of E.values())w.call(o,T,this)},replace(w){const o=new Map,T=new Set(E.keys()),r={op:4,ops:[]};for(const i of w){if(!(i instanceof h))throw new m(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==u.controllerId)throw new l(i.id,c,u.controllerId);if(o.has(i.id))throw new d(i.id);o.set(i.id,i),T.delete(i.id),r.ops.push({op:0,item:i})}for(const i of T.keys())r.ops.push({op:1,id:i});u.listener?.(r),E=o},add(w){if(!(w instanceof h))throw new m(w.id);E.set(w.id,w),u.listener?.({op:0,item:w})},delete(w){E.delete(w)&&u.listener?.({op:1,id:w})},get(w){return E.get(w)},toJSON(){return Array.from(E.values())},[Symbol.iterator](){return E.values()}}};class h{constructor(u,E,w,o){if(E.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(E)} symbol`);const T=(0,e.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:E,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return T.parent instanceof S?void 0:T.parent}},children:{value:n(this),enumerable:!0,writable:!1},...N(T,w)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=h;class S extends h{constructor(u,E){super(u,u,E,void 0)}}e.TestItemRootImpl=S}),define(we[59],be([1,0,3,147,5,14]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(y){function F(p){return{remoteAddress:p.remoteAddress,localAddress:p.localAddress,public:!!p.public,privacy:p.privacy??(p.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:p.protocol}}y.fromApiTunnel=F;function N(p){return{remoteAddress:{host:p.tunnelRemoteHost,port:p.tunnelRemotePort},localAddress:p.localAddress,public:p.privacy!==I.TunnelPrivacyId.ConstantPrivate&&p.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:p.privacy,protocol:p.protocol}}y.fromServiceTunnel=N})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let A=class{constructor(F){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(F){return F}async openTunnel(F,N){}async getTunnels(){return[]}async setTunnelFactory(F){return{dispose:()=>{}}}registerPortsAttributesProvider(F,N){return{dispose:()=>{}}}async $providePortAttributes(F,N,p,d,m){return[]}async $forwardPort(F,N){}async $closeTunnel(F){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Fe([Ne(0,B.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[7],be([1,0,16,15,72,22,71,9,11,2,36,45,81]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d){"use strict";var m,l,n,h,S,k,u,E,w,o,T,r,i,c,t,a,g,f,_,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function $(j){function U(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(U,j),Object.setPrototypeOf(U.prototype,j.prototype),U}let L=S=class{constructor(U){m.set(this,void 0),Ve(this,m,U,"f")}static from(...U){let te=U;return new S(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof ye(this,m,"f")=="function"&&(ye(this,m,"f").call(this),Ve(this,m,void 0,"f"))}};m=new WeakMap,L=S=Fe([$],L),e.Disposable=L;let v=k=class{constructor(U,te){if(U<0)throw(0,I.illegalArgument)("line must be non-negative");if(te<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=U,this._character=te}static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let _e=1;_e<U.length;_e++){const We=U[_e];We.isBefore(te)&&(te=We)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let _e=1;_e<U.length;_e++){const We=U[_e];We.isAfter(te)&&(te=We)}return te}static isPosition(U){if(!U)return!1;if(U instanceof k)return!0;let{line:te,character:_e}=U;return typeof te=="number"&&typeof _e=="number"}static of(U){if(U instanceof k)return U;if(this.isPosition(U))return new k(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,te=0){if(U===null||te===null)throw(0,I.illegalArgument)();let _e;return typeof U=="undefined"?_e=0:typeof U=="number"?_e=U:(_e=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),_e===0&&te===0?this:new k(this.line+_e,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,I.illegalArgument)();let _e;return typeof U=="undefined"?_e=this.line:typeof U=="number"?_e=U:(_e=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),_e===this.line&&te===this.character?this:new k(_e,te)}toJSON(){return{line:this.line,character:this.character}}};v=k=Fe([$],v),e.Position=v;let H=u=class{constructor(U,te,_e,We){let Ke,Ye;if(typeof U=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof We=="number"?(Ke=new v(U,te),Ye=new v(_e,We)):v.isPosition(U)&&v.isPosition(te)&&(Ke=v.of(U),Ye=v.of(te)),!Ke||!Ye)throw new Error("Invalid arguments");Ke.isBefore(Ye)?(this._start=Ke,this._end=Ye):(this._start=Ye,this._end=Ke)}static isRange(U){return U instanceof u?!0:U?v.isPosition(U.start)&&v.isPosition(U.end):!1}static of(U){if(U instanceof u)return U;if(this.isRange(U))return new u(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(U){return u.isRange(U)?this.contains(U.start)&&this.contains(U.end):v.isPosition(U)?!(v.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const te=v.Max(U.start,this._start),_e=v.Min(U.end,this._end);if(!te.isAfter(_e))return new u(te,_e)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=v.Min(U.start,this._start),_e=v.Max(U.end,this.end);return new u(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,te=this.end){if(U===null||te===null)throw(0,I.illegalArgument)();let _e;return U?v.isPosition(U)?_e=U:(_e=U.start||this.start,te=U.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new u(_e,te)}toJSON(){return[this.start,this.end]}};H=u=Fe([$],H),e.Range=H;let W=E=class extends H{constructor(U,te,_e,We){let Ke,Ye;if(typeof U=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof We=="number"?(Ke=new v(U,te),Ye=new v(_e,We)):v.isPosition(U)&&v.isPosition(te)&&(Ke=v.of(U),Ye=v.of(te)),!Ke||!Ye)throw new Error("Invalid arguments");super(Ke,Ye);this._anchor=Ke,this._active=Ye}static isSelection(U){return U instanceof E?!0:U?H.isRange(U)&&v.isPosition(U.anchor)&&v.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=E=Fe([$],W),e.Selection=W;class q{constructor(U,te,_e){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,I.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,I.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=q;class K extends Error{constructor(U,te=d.RemoteAuthorityResolverErrorCode.Unknown,_e){super(U);this._message=U,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype)}static NotAvailable(U,te){return new K(U,d.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new K(U,d.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=K;var V;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var z;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ae=w=class{constructor(U,te){this._range=U,this._newText=te}static isTextEdit(U){return U instanceof w?!0:U?H.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new w(U,te)}static insert(U,te){return w.replace(new H(U,U),te)}static delete(U){return w.replace(U,"")}static setEndOfLine(U){const te=new w(new H(new v(0,0),new v(0,0)),"");return te.newEol=U,te}get range(){return this._range}set range(U){if(U&&!H.isRange(U))throw(0,I.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,I.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,I.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ae=w=Fe([$],ae),e.TextEdit=ae;var de;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(de=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,te,_e,We){this._edits.push({_type:1,from:U,to:te,options:_e,metadata:We})}createFile(U,te,_e){this._edits.push({_type:1,from:void 0,to:U,options:te,metadata:_e})}deleteFile(U,te,_e){this._edits.push({_type:1,from:U,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(U,te,_e){this._edits.push({_type:3,metadata:_e,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(U,te,_e,We,Ke){let Ye,et,_t=[],Pt;if(Gt.isNotebookRange(te)&&Pe.isNotebookCellDataArray(_e)&&!Pe.isNotebookCellDataArray(We)?(Ye=te.start,et=te.end,_t=_e,Pt=We):typeof te=="number"&&typeof _e=="number"&&Pe.isNotebookCellDataArray(We)&&(Ye=te,et=_e,_t=We,Pt=Ke),Ye===void 0||et===void 0)throw new Error("Invalid arguments");(Ye!==et||_t.length>0)&&this._edits.push({_type:5,uri:U,index:Ye,count:et-Ye,cells:_t,metadata:Pt})}replaceNotebookCellMetadata(U,te,_e,We){this._edits.push({_type:3,metadata:We,uri:U,edit:{editType:8,index:te,metadata:_e}})}replace(U,te,_e,We){this._edits.push({_type:2,uri:U,edit:new ae(te,_e),metadata:We})}insert(U,te,_e,We){this.replace(U,new H(te,te),_e,We)}delete(U,te,_e){this.replace(U,te,"",_e)}has(U){return this._edits.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:U,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const We=this._edits[_e];We._type===2&&We.uri.toString()===U.toString()&&(this._edits[_e]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(U){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===U.toString()&&te.push(_e.edit);return te}entries(){const U=new B.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=U.get(te.uri);_e||(_e=[te.uri,[]],U.set(te.uri,_e)),_e[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=Fe([$],Y),e.WorkspaceEdit=Y;let ie=o=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof o?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=o._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this._tabstop++){if(typeof U=="function"){const _e=new o;_e._tabstop=this._tabstop,U(_e),this._tabstop=_e._tabstop,U=_e.value}else U=o._escape(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this._tabstop++){const _e=U.map(We=>We.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const _e=new o;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ie=o=Fe([$],ie),e.SnippetString=ie;var ce;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ce=e.DiagnosticTag||(e.DiagnosticTag={}));var he;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(he=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=T=class{constructor(U,te){if(this.uri=U,te)if(H.isRange(te))this.range=H.of(te);else if(v.isPosition(te))this.range=new H(te,te);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof T?!0:U?H.isRange(U.range)&&F.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ue=T=Fe([$],ue),e.Location=ue;let re=class{constructor(U,te){this.location=U,this.message=te}static is(U){return U?typeof U.message=="string"&&U.location&&H.isRange(U.location.range)&&F.URI.isUri(U.location.uri):!1}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};re=Fe([$],re),e.DiagnosticRelatedInformation=re;let ge=class{constructor(U,te,_e=he.Error){if(!H.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=_e}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,s.equals)(U.tags,te.tags)&&(0,s.equals)(U.relatedInformation,te.relatedInformation,re.isEqual)}};ge=Fe([$],ge),e.Diagnostic=ge;let Te=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Te=Fe([$],Te),e.Hover=Te;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let He=class{constructor(U,te=Re.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:Re[this.kind]}}};He=Fe([$],He),e.DocumentHighlight=He;var Xe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var ve;(function(j){j[j.Deprecated=1]="Deprecated"})(ve=e.SymbolTag||(e.SymbolTag={}));let fe=r=class{constructor(U,te,_e,We,Ke){this.name=U,this.kind=te,this.containerName=Ke,typeof _e=="string"&&(this.containerName=_e),We instanceof ue?this.location=We:_e instanceof H&&(this.location=new ue(We,_e)),r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};fe=r=Fe([$],fe),e.SymbolInformation=fe;let M=i=class{constructor(U,te,_e,We,Ke){this.name=U,this.detail=te,this.kind=_e,this.range=We,this.selectionRange=Ke,this.children=[],i.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(i.validate)}};M=i=Fe([$],M),e.DocumentSymbol=M;var O;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(O=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let C=class{constructor(U,te){this.title=U,this.kind=te}};C=Fe([$],C),e.CodeAction=C;let R=c=class{constructor(U){this.value=U}append(U){return new c(this.value?this.value+c.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+c.sep)}};R.sep=".",R=c=Fe([$],R),e.CodeActionKind=R,R.Empty=new R(""),R.QuickFix=R.Empty.append("quickfix"),R.Refactor=R.Empty.append("refactor"),R.RefactorExtract=R.Refactor.append("extract"),R.RefactorInline=R.Refactor.append("inline"),R.RefactorRewrite=R.Refactor.append("rewrite"),R.Source=R.Empty.append("source"),R.SourceOrganizeImports=R.Source.append("organizeImports"),R.SourceFixAll=R.Source.append("fixAll");let x=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};x=Fe([$],x),e.SelectionRange=x;class Q{constructor(U,te,_e,We,Ke,Ye){this.kind=U,this.name=te,this.detail=_e,this.uri=We,this.range=Ke,this.selectionRange=Ye}}e.CallHierarchyItem=Q;class ne{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=ne;class Ee{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=Ee;var Ie;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ie=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};Me=Fe([$],Me),e.CodeLens=Me;let Le=t=class{constructor(U,te=!1){l.set(this,void 0),Ve(this,l,new b.MarkdownString(U,{supportThemeIcons:te}),"f")}static isMarkdownString(U){return U instanceof t?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return ye(this,l,"f").value}set value(U){ye(this,l,"f").value=U}get isTrusted(){return ye(this,l,"f").isTrusted}set isTrusted(U){ye(this,l,"f").isTrusted=U}get supportThemeIcons(){return ye(this,l,"f").supportThemeIcons}set supportThemeIcons(U){ye(this,l,"f").supportThemeIcons=U}get supportHtml(){return ye(this,l,"f").supportHtml}set supportHtml(U){ye(this,l,"f").supportHtml=U}get baseUri(){return ye(this,l,"f").baseUri}set baseUri(U){ye(this,l,"f").baseUri=U}appendText(U){return ye(this,l,"f").appendText(U),this}appendMarkdown(U){return ye(this,l,"f").appendMarkdown(U),this}appendCodeblock(U,te){return ye(this,l,"f").appendCodeblock(te??"",U),this}};l=new WeakMap,Le=t=Fe([$],Le),e.MarkdownString=Le;let ze=class{constructor(U,te){this.label=U,this.documentation=te}};ze=Fe([$],ze),e.ParameterInformation=ze;let Be=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Be=Fe([$],Be),e.SignatureInformation=Be;let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ae=Fe([$],Ae),e.SignatureHelp=Ae;var Qe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor(U){this.value=U}};ke=Fe([$],ke),e.InlayHintLabelPart=ke;let it=class{constructor(U,te,_e){this.position=U,this.label=te,this.kind=_e}};it=Fe([$],it),e.InlayHint=it;var X;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(j){j[j.Deprecated=1]="Deprecated"})(le=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&J[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=Fe([$],Oe),e.CompletionItem=Oe;let $e=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};$e=Fe([$],$e),e.CompletionList=$e;let Ge=class{constructor(U,te,_e){this.insertText=U,this.range=te,this.command=_e}};Ge=Fe([$],Ge),e.InlineSuggestion=Ge;let Je=class{constructor(U){this.items=U}};Je=Fe([$],Je),e.InlineSuggestions=Je;var ft;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var It;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(It=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(qe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var vt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function U(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(U,te){if(te&&!F.URI.isUri(te))throw(0,I.illegalArgument)("target");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.target=te}};ut=Fe([$],ut),e.DocumentLink=ut;let At=class{constructor(U,te,_e,We){this.red=U,this.green=te,this.blue=_e,this.alpha=We}};At=Fe([$],At),e.Color=At;let Tt=class{constructor(U,te){if(te&&!(te instanceof At))throw(0,I.illegalArgument)("color");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.color=te}};Tt=Fe([$],Tt),e.ColorInformation=Tt;let bt=class{constructor(U){if(!U||typeof U!="string")throw(0,I.illegalArgument)("label");this.label=U}};bt=Fe([$],bt),e.ColorPresentation=bt;var dt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var Rt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(U,te,_e){if(this.startIndex=U,this.length=te,this.tooltip=_e,typeof U!="number"||U<0)throw(0,I.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,I.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var Ft;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class Ue{constructor(U){this.options=U,typeof U!="object"&&(0,I.illegalArgument)("options")}}e.TerminalProfile=Ue;var me;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(me=e.TaskRevealKind||(e.TaskRevealKind={}));var pe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(pe=e.TaskPanelKind||(e.TaskPanelKind={}));let oe=a=class{constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,I.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};oe.Clean=new a("clean","Clean"),oe.Build=new a("build","Build"),oe.Rebuild=new a("rebuild","Rebuild"),oe.Test=new a("test","Test"),oe=a=Fe([$],oe),e.TaskGroup=oe;function G(j){let U="";for(let te=0;te<j.length;te++)U+=j[te].replace(/,/g,",,")+",";return U}let Se=class{constructor(U,te,_e){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=U,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let te of this._args)U.push(te);return G(U)}};Se=Fe([$],Se),e.ProcessExecution=Se;let Ce=class{constructor(U,te,_e){if(this._args=[],Array.isArray(te)){if(!U)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U,this._args=te,this._options=_e}else{if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U,this._options=te}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)U.push(typeof te=="string"?te:te.value);return G(U)}};Ce=Fe([$],Ce),e.ShellExecution=Ce;var xe;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(xe=e.ShellQuoting||(e.ShellQuoting={}));var je;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(je=e.TaskScope||(e.TaskScope={}));class lt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=lt;let gt=g=class{constructor(U,te,_e,We,Ke,Ye){this.__deprecated=!1,this._definition=this.definition=U;let et;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=We,et=Ke,this.__deprecated=!0):te===je.Global||te===je.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=We,this.execution=Ke,et=Ye):(this.target=te,this._name=this.name=_e,this._source=this.source=We,this.execution=Ke,et=Ye),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Se?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ce?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const te=this._definition.type;(g.EmptyType===te||g.ProcessType===te||g.ShellType===te||g.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=g=Fe([$],gt),e.Task=gt;var Et;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(U,te=at.None){this.collapsibleState=te,F.URI.isUri(U)?this.resourceUri=U:this.label=U}};rt=Fe([$],rt),e.TreeItem=rt;var at;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ot=class{constructor(U){this.value=U}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ot=Fe([$],ot),e.DataTransferItem=ot;let Mt=class{constructor(){this._items=new Map}get(U){return this._items.get(U)}set(U,te){this._items.set(U,te)}forEach(U){this._items.forEach(U)}};Mt=Fe([$],Mt),e.DataTransfer=Mt;let mt=class{constructor(U,te){this.id=U,this.color=te}};mt=Fe([$],mt),e.ThemeIcon=mt,mt.File=new mt("file"),mt.Folder=new mt("folder");let Dt=class{constructor(U){this.id=U}};Dt=Fe([$],Dt),e.ThemeColor=Dt;var Ut;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let wt=class{constructor(U,te){if(typeof U!="string"&&(!U||!F.URI.isUri(U)&&!F.URI.isUri(U.uri)))throw(0,I.illegalArgument)("base");if(typeof te!="string")throw(0,I.illegalArgument)("pattern");typeof U=="string"?this.baseUri=F.URI.file(U):F.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}get base(){return this._base}set base(U){this._base=U,this._baseUri=F.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};wt=Fe([$],wt),e.RelativePattern=wt;let Bt=class{constructor(U,te,_e,We){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof We=="string"&&(this.logMessage=We)}get id(){return this._id||(this._id=(0,N.generateUuid)()),this._id}};Bt=Fe([$],Bt),e.Breakpoint=Bt;let Wt=class extends Bt{constructor(U,te,_e,We,Ke){super(te,_e,We,Ke);if(U===null)throw(0,I.illegalArgument)("location");this.location=U}};Wt=Fe([$],Wt),e.SourceBreakpoint=Wt;let pt=class extends Bt{constructor(U,te,_e,We,Ke){super(te,_e,We,Ke);this.functionName=U}};pt=Fe([$],pt),e.FunctionBreakpoint=pt;let ei=class extends Bt{constructor(U,te,_e,We,Ke,Ye,et){super(We,Ke,Ye,et);if(!te)throw(0,I.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=_e}};ei=Fe([$],ei),e.DataBreakpoint=ei;let Xt=class{constructor(U,te,_e){this.command=U,this.args=te||[],this.options=_e}};Xt=Fe([$],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(U,te){this.port=U,this.host=te}};ti=Fe([$],ti),e.DebugAdapterServer=ti;let ai=class{constructor(U){this.path=U}};ai=Fe([$],ai),e.DebugAdapterNamedPipeServer=ai;let Ct=class{constructor(U){this.implementation=U}};Ct=Fe([$],Ct),e.DebugAdapterInlineImplementation=Ct;let ii=class{constructor(U,te){this.range=U,this.expression=te}};ii=Fe([$],ii),e.EvaluatableExpression=ii;var bi;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(U,te){this.range=U,this.text=te}};qt=Fe([$],qt),e.InlineValueText=qt;let Kt=class{constructor(U,te,_e=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=_e}};Kt=Fe([$],Kt),e.InlineValueVariableLookup=Kt;let st=class{constructor(U,te){this.range=U,this.expression=te}};st=Fe([$],st),e.InlineValueEvaluatableExpression=st;let li=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};li=Fe([$],li),e.InlineValueContext=li;var Ht;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ht=e.FileChangeType||(e.FileChangeType={}));let zt=f=class extends Error{constructor(U,te=p.FileSystemProviderErrorCode.Unknown,_e){super(F.URI.isUri(U)?U.toString(!0):U);this.code=_e?.name??"Unknown",(0,p.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(U){return new f(U,p.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(U){return new f(U,p.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(U){return new f(U,p.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(U){return new f(U,p.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(U){return new f(U,p.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(U){return new f(U,p.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};zt=f=Fe([$],zt),e.FileSystemError=zt;let ni=class{constructor(U,te,_e){this.start=U,this.end=te,this.kind=_e}};ni=Fe([$],ni),e.FoldingRange=ni;var _i;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=ri;function yi(j){return typeof j=="undefined"||(0,y.isStringArray)(j)}class Qt{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let te=0,_e=U.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(U.tokenTypes[te],te);for(let te=0,_e=U.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(U.tokenModifiers[te],te)}}push(U,te,_e,We,Ke){if(typeof U=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof We=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(U,te,_e,We,Ke);if(H.isRange(U)&&typeof te=="string"&&yi(_e))return this._push(U,te,_e);throw(0,I.illegalArgument)()}_push(U,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const We=U.start.line,Ke=U.start.character,Ye=U.end.character-U.start.character,et=this._tokenTypeStrToInt.get(te);let _t=0;if(_e)for(const Pt of _e){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Pt);_t|=1<<xt>>>0}this._pushEncoded(We,Ke,Ye,et,_t)}_pushEncoded(U,te,_e,We,Ke){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let Pt=0,xt=0;for(let $t=0;$t<_t;$t++){let Vt=this._data[5*$t],di=this._data[5*$t+1];Vt===0?(Vt=Pt,di+=xt):Vt+=Pt,this._data[5*$t]=Vt,this._data[5*$t+1]=di,Pt=Vt,xt=di}}let Ye=U,et=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=et,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=We,this._data[this._dataLen++]=Ke,this._prevLine=U,this._prevChar=te}static _sortAndDeltaEncode(U){let te=[];const _e=U.length/5|0;for(let et=0;et<_e;et++)te[et]=et;te.sort((et,_t)=>{const Pt=U[5*et],xt=U[5*_t];if(Pt===xt){const $t=U[5*et+1],Vt=U[5*_t+1];return $t-Vt}return Pt-xt});const We=new Uint32Array(U.length);let Ke=0,Ye=0;for(let et=0;et<_e;et++){const _t=5*te[et],Pt=U[_t+0],xt=U[_t+1],$t=U[_t+2],Vt=U[_t+3],di=U[_t+4],zi=Pt-Ke,Ji=zi===0?xt-Ye:xt,hi=5*et;We[hi+0]=zi,We[hi+1]=Ji,We[hi+2]=$t,We[hi+3]=Vt,We[hi+4]=di,Ke=Pt,Ye=xt}return We}build(U){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),U):new Yt(Qt._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=Yt;class Di{constructor(U,te,_e){this.start=U,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=Di;class Ci{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=Ci;var Jt;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new mt("arrow-left")},si=Fe([$],si),e.QuickInputButtons=si;var Ii;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(U,te,_e){this.badge=U,this.tooltip=te,this.color=_e}static validate(U){if(U.badge){let te=(0,A.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,A.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let Zt=class{constructor(U){this.kind=U}};Zt=Fe([$],Zt),e.ColorTheme=Zt;var gi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{constructor(U,te){if(U<0)throw(0,I.illegalArgument)("start must be positive");if(te<0)throw(0,I.illegalArgument)("end must be positive");U<=te?(this._start=U,this._end=te):(this._start=te,this._end=U)}static isNotebookRange(U){return U instanceof Gt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let te=this._start,_e=this._end;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(_e=U.end),te===this._start&&_e===this._end?this:new Gt(te,_e)}}e.NotebookRange=Gt;class Pe{constructor(U,te,_e,We,Ke,Ye,et){this.kind=U,this.value=te,this.languageId=_e,this.mime=We,this.outputs=Ke??[],this.metadata=Ye,this.executionSummary=et,Pe.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>Pe.isNotebookCellData(te))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Pe;class ci{constructor(U){this.cells=U}}e.NotebookData=ci;class Ot{constructor(U,te){this.data=U,this.mime=te;const _e=(0,D.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(U){return U instanceof Ot?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return Ot.json(te,"application/vnd.code.notebook.error")}static stdout(U){return Ot.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Ot.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new Ot(U,te)}static text(U,te=D.Mimes.text){const _e=ye(Ot,n,"f",h).encode(String(U));return new Ot(_e,te)}static json(U,te="text/x-json"){const _e=JSON.stringify(U,void 0,"	");return Ot.text(_e,te)}}e.NotebookCellOutputItem=Ot,n=Ot,h={value:new TextEncoder};class ct{constructor(U,te,_e){this.items=ct.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,N.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(U){return U instanceof ct?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,y.isArray)(U.items)}static ensureUniqueMimeTypes(U,te=!1){const _e=new Set,We=new Set;for(let Ke=0;Ke<U.length;Ke++){const Ye=U[Ke],et=(0,D.normalizeMimeType)(Ye.mime);if(!_e.has(et)){_e.add(et);continue}We.add(Ke),te&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return We.size===0?U:U.filter((Ke,Ye)=>!We.has(Ye))}}e.NotebookCellOutput=ct;var Pi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Pi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=Ri;var Oi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Oi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Fi{constructor(U,te=[]){this.uri=U,this.provides=(0,s.asArray)(te)}}e.NotebookRendererScript=Fi;let ui=class{constructor(U,te){this.label=U,this.timestamp=te}};ui=Fe([$],ui),e.TimelineItem=ui;var Ei;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Ei=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=Li;class Ui{constructor(U,te){this._port=U,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var ee;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ee=e.TestRunProfileKind||(e.TestRunProfileKind={}));let se=class{constructor(U=void 0,te=void 0,_e=void 0){this.include=U,this.exclude=te,this.profile=_e}};se=Fe([$],se),e.TestRunRequest=se;let De=_=class{constructor(U){this.message=U}static diff(U,te,_e){const We=new _(U);return We.expectedOutput=te,We.actualOutput=_e,We}};De=_=Fe([$],De),e.TestMessage=De;let Ze=class{constructor(U){this.id=U}};Ze=Fe([$],Ze),e.TestTag=Ze;let ht=class{constructor(U,te){this.covered=U,this.total=te}};ht=Fe([$],ht),e.CoveredCount=ht;let yt=P=class{constructor(U,te,_e,We){this.uri=U,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=We}static fromDetails(U,te){const _e=new ht(0,0),We=new ht(0,0),Ke=new ht(0,0);for(const et of te)if("branches"in et){_e.total+=1,_e.covered+=et.executionCount>0?1:0;for(const _t of et.branches)We.total+=1,We.covered+=_t.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=et.executionCount>0?1:0;const Ye=new P(U,_e,We.total>0?We:void 0,Ke.total>0?Ke:void 0);return Ye.detailedCoverage=te,Ye}};yt=P=Fe([$],yt),e.FileCoverage=yt;let xi=class{constructor(U,te,_e=[]){this.executionCount=U,this.location=te,this.branches=_e}};xi=Fe([$],xi),e.StatementCoverage=xi;let $i=class{constructor(U,te){this.executionCount=U,this.location=te}};$i=Fe([$],$i),e.BranchCoverage=$i;let Wi=class{constructor(U,te){this.executionCount=U,this.location=te}};Wi=Fe([$],Wi),e.FunctionCoverage=Wi;var Gi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(U,te,_e,We,Ke,Ye){this.kind=U,this.name=te,this.detail=_e,this.uri=We,this.range=Ke,this.selectionRange=Ye}}e.TypeHierarchyItem=Yi}),define(we[84],be([1,0,42,10,9,226,116,7,16]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const F=new Map;function N(l,n){n?F.set(l,n):F.delete(l)}e.setWordDefinitionFor=N;function p(l){return F.get(l)}e.getWordDefinitionFor=p;class d extends B.MirrorTextModel{constructor(n,h,S,k,u,E,w,o){super(h,S,k,u);this._proxy=n,this._languageId=E,this._isDirty=w,this._notebook=o,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,y.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===I.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},get notebook(){return n._notebook},save(){return n._save()},getText(h){return h?n._getTextInRange(h):n.getText()},get eol(){return n._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(h){return n._lineAt(h)},offsetAt(h){return n._offsetAt(h)},positionAt(h){return n._positionAt(h)},validateRange(h){return n._validateRange(h)},validatePosition(h){return n._validatePosition(h)},getWordRangeAtPosition(h,S){return n._getWordRangeAtPosition(h,S)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,s.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,s.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const h=this._validateRange(n);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const S=this._eol,k=h.start.line,u=h.end.line,E=[];E.push(this._lines[k].substring(h.start.character));for(let w=k+1;w<u;w++)E.push(this._lines[w]);return E.push(this._lines[u].substring(0,h.end.character)),E.join(S)}_lineAt(n){let h;if(n instanceof A.Position?h=n.line:typeof n=="number"&&(h=n),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new m(h,this._lines[h],h===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(n),S=this._lines[h.index].length;return new A.Position(h.index,Math.min(h.remainder,S))}_validateRange(n){if(!(n instanceof A.Range))throw new Error("Invalid argument");const h=this._validatePosition(n.start),S=this._validatePosition(n.end);return h===n.start&&S===n.end?n:new A.Range(h.line,h.character,S.line,S.character)}_validatePosition(n){if(!(n instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:h,character:S}=n,k=!1;if(h<0)h=0,S=0,k=!0;else if(h>=this._lines.length)h=this._lines.length-1,S=this._lines[h].length,k=!0;else{const u=this._lines[h].length;S<0?(S=0,k=!0):S>u&&(S=u,k=!0)}return k?new A.Position(h,S):n}_getWordRangeAtPosition(n,h){const S=this._validatePosition(n);if(!h)h=p(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const k=(0,D.getWordAtText)(S.character+1,(0,D.ensureValidWordDefinition)(h),this._lines[S.line],0);if(k)return new A.Range(S.line,k.startColumn-1,S.line,k.endColumn-1)}}e.ExtHostDocumentData=d;class m{constructor(n,h,S){this._line=n,this._text=h,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(we[152],be([1,0,7,5,227,6,74,22,2,36]),function(Z,e,s,I,b,B,D,A,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class N{constructor(d,m,l,n){this._notebook=l,this._selector=n,this._disposables=new B.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,F.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(S=>{const k=this._cellUris.get(S.document.uri);k!==void 0&&(this._cellLengths.setValue(k,this._cells[k].document.getText().length+1),this._cellLines.setValue(k,this._cells[k].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const h=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(S=>h(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const d=[],m=[];for(const l of this._notebook.getCells())l.kind===s.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,l.document.uri,l.document.languageId,!0,void 0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),d.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(d){if(!d){let k="";for(const u of this._cells)k+=u.document.getText()+`
`;return k=k.slice(0,-1),k}if(d.isEmpty)return"";const m=this.locationAt(d.start),l=this.locationAt(d.end),n=this._cellUris.get(m.uri),h=this._cellUris.get(l.uri);if(n===void 0||h===void 0)return"";if(n===h)return this._cells[n].document.getText(new s.Range(m.range.start,l.range.end));const S=[this._cells[n].document.getText(new s.Range(m.range.start,new s.Position(this._cells[n].document.lineCount,0)))];for(let k=n+1;k<h;k++)S.push(this._cells[k].document.getText());return S.push(this._cells[h].document.getText(new s.Range(new s.Position(0,0),l.range.end))),S.join(`
`)}offsetAt(d){const m=this._cellLines.getIndexOf(d.line),l=this._cellLengths.getPrefixSum(m.index-1),n=this._cells[m.index].document.offsetAt(d.with(m.remainder));return l+n}positionAt(d){if(typeof d=="number"){const l=this._cellLengths.getIndexOf(d),n=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(n)}const m=this._cellUris.get(d.uri);if(m!==void 0){const l=this._cellLines.getPrefixSum(m-1);return new s.Position(l+d.range.start.line,d.range.start.character)}return new s.Position(0,0)}locationAt(d){s.Range.isRange(d)||(d=new s.Range(d,d));const m=this._cellLines.getIndexOf(d.start.line);let l=m;d.isEmpty||(l=this._cellLines.getIndexOf(d.end.line));const n=new s.Position(m.remainder,d.start.character),h=new s.Position(l.remainder,d.end.character),S=new s.Range(n,h),k=this._cells[m.index];return new s.Location(k.document.uri,k.document.validateRange(S))}contains(d){return this._cellUris.has(d)}validateRange(d){const m=this.validatePosition(d.start),l=this.validatePosition(d.end);return d.with(m,l)}validatePosition(d){const m=this._cellLines.getIndexOf(d.line),l=new s.Position(m.remainder,d.character),n=this._cells[m.index].document.validatePosition(l),h=this._cellLines.getPrefixSum(m.index-1);return new s.Position(h+n.line,n.character)}}e.ExtHostNotebookConcatDocument=N}),define(we[153],be([1,0,7,14,5]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let B=class{constructor(A){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y=A==="light"?s.ColorThemeKind.Light:A==="dark"?s.ColorThemeKind.Dark:s.ColorThemeKind.HighContrast;this._actual=new s.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostTheming=B}),define(we[60],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class I{constructor(B){B?(this.transformIncoming=B.transformIncoming.bind(B),this.transformOutgoing=B.transformOutgoing.bind(B),this.transformOutgoingURI=B.transformOutgoingURI.bind(B),this.transformOutgoingScheme=B.transformOutgoingScheme.bind(B)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=I}),define(we[154],be([1,0,21]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let F=this.buffers.indexOf(y);return F<0&&(F=this.buffers.length,this.buffers.push(y)),F}}function b(A,y){if(y.serializeBuffersForPostMessage){const F=new I,N=(m,l)=>{if(l instanceof ArrayBuffer){const n=F.add(l);return{$$vscode_array_buffer_reference$$:!0,index:n}}else if(ArrayBuffer.isView(l)){const n=B(l);if(n){const h=F.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:n,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},p=JSON.stringify(A,N),d=F.buffers.map(m=>{const l=new Uint8Array(m);return s.VSBuffer.wrap(l)});return{message:p,buffers:d}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=b;function B(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(A,y){const F=y.map(d=>{const m=new ArrayBuffer(d.byteLength);return new Uint8Array(m).set(d.buffer),m}),N=y.length?(d,m)=>{if(m&&typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:n}=l,h=F[n];if(l.view)switch(l.view.type){case 1:return new Int8Array(h,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return m}:void 0;return{message:JSON.parse(A,N),arrayBuffers:F}}e.deserializeWebviewMessage=D}),define(we[155],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var s;(function(I){function b(D){const A=new Map;return D.types.forEach((y,F)=>{A.set(y,{asString:async()=>D.items[F].asString,value:void 0})}),A}I.toITreeDataTransfer=b;async function B(D){const A={types:[],items:[]},y=Array.from(D.entries());for(const F of y)A.types.push(F[0]),A.items.push({asString:await F[1].asString()});return A}I.toTreeDataTransferDTO=B})(s=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[156],be([1,0,129,11,2,6,3,37,45,16,10]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(p=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var d;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(d=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(K){const V=K;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=m;function l(K,V,z){for(const ae of z.visibleEditorPanes)if(ae.group.id===V&&K.matches(ae.input))return ae.getViewState()}e.findViewStateForEditor=l;function n(K){if(T(K))return!1;const V=K;return b.URI.isUri(V?.resource)}e.isResourceEditorInput=n;function h(K){if(T(K))return!1;const V=K;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=h;function S(K){if(T(K)||h(K))return!1;const V=K;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function k(K){if(T(K))return!1;const V=K;return V?V.resource===void 0||V.resource.scheme===N.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=k;var u;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var E;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(E=e.SaveReason||(e.SaveReason={}));var w;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends B.Disposable{}e.AbstractEditorInput=o;function T(K){return K instanceof o}e.isEditorInput=T;function r(K){const V=K;return b.URI.isUri(V?.preferredResource)}function i(K){const V=K;return T(V?.primary)&&T(V?.secondary)}e.isSideBySideEditorInput=i;function c(K){const V=K;return T(V?.modified)&&T(V?.original)}e.isDiffEditorInput=c;function t(K){return T(K?.editor)}e.isEditorInputWithOptions=t;function a(K){const V=K;return t(K)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=a;function g(K){const V=K;return typeof V?.groupId=="number"&&T(V.editor)}e.isEditorIdentifier=g;var f;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(f=e.EditorCloseContext||(e.EditorCloseContext={}));var _;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(_=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var P;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(P=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(V,z){if(!V)return;if(z?.supportSideBySide){const{primary:de,secondary:Y}=this.getSideEditors(V);if(de&&Y){if(z?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===P.ANY)return this.getOriginalUri(de,{filterByScheme:z.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:z.filterByScheme});V=z.supportSideBySide===P.PRIMARY?de:Y}}if(h(V)||S(V))return;const ae=r(V)?V.preferredResource:V.resource;return!ae||!z||!z.filterByScheme?ae:this.filterUri(ae,z.filterByScheme)}getSideEditors(V){return i(V)||S(V)?{primary:V.primary,secondary:V.secondary}:c(V)||h(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,z){if(!V)return;if(z?.supportSideBySide){const{primary:de,secondary:Y}=this.getSideEditors(V);if(de&&Y){if(z?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===P.ANY)return this.getCanonicalUri(de,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:z.filterByScheme});V=z.supportSideBySide===P.PRIMARY?de:Y}}if(h(V)||S(V))return;const ae=V.resource;return!ae||!z||!z.filterByScheme?ae:this.filterUri(ae,z.filterByScheme)}filterUri(V,z){if(Array.isArray(z)){if(z.some(ae=>V.scheme===ae))return V}else if(z===V.scheme)return V}}e.EditorResourceAccessor=new $;var L;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class v{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(V){const z=this.instantiationService=V.get(D.IInstantiationService);for(const[ae,de]of this.editorSerializerConstructors)this.createEditorSerializer(ae,de,z);this.editorSerializerConstructors.clear()}createEditorSerializer(V,z,ae){const de=ae.createInstance(z);this.editorSerializerInstances.set(V,de)}registerFileEditorFactory(V){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=V}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(V,z){if(this.editorSerializerConstructors.has(V)||this.editorSerializerInstances.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.instantiationService?this.createEditorSerializer(V,z,this.instantiationService):this.editorSerializerConstructors.set(V,z),(0,B.toDisposable)(()=>{this.editorSerializerConstructors.delete(V),this.editorSerializerInstances.delete(V)})}getEditorSerializer(V){return this.editorSerializerInstances.get(typeof V=="string"?V:V.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new v);async function H(K,V){if(!K||!K.length)return[];const z=await Promise.all(K.map(async ae=>{const de=b.URI.revive(ae.fileUri);if(!de||!await V.canHandleResource(de))return;let ie=ae.exists,ce=ae.type;if(typeof ie!="boolean"||typeof ce!="number")try{ce=(await V.stat(de)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&ae.openOnlyIfExists||ce===y.FileType.Directory)return;const he={selection:ie?ae.selection:void 0,pinned:!0,override:ae.editorOverrideId};let ue;return ie?ue={resource:de,options:he}:ue={resource:de,options:he,forceUntitled:!0},ue}));return(0,F.coalesce)(z)}e.pathsToEditors=H;var W;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function q(K){const V=K;if(!V)return!1;const z=V;if(z.modified)return q(z.modified);const ae=V;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.isTextEditorViewState=q}),define(we[61],be([1,0,10,2]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(A,y){return A.scheme===s.Schemas.http||A.scheme===s.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===s.Schemas.file&&(A=I.URI.from({scheme:s.Schemas.vscodeRemote,authority:y.authority,path:A.path})),I.URI.from({scheme:s.Schemas.https,authority:`${A.scheme}+${B(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=b;function B(A){return A.replace(/./g,y=>{const F=y.charCodeAt(0);return F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57?y:"-"+F.toString(16).padStart(4,"0")})}function D(A){return A.replace(/-([0-9a-f]{4})/g,(y,F)=>String.fromCharCode(parseInt(F,16)))}e.decodeAuthority=D}),define(we[157],be([1,0,5,6,61]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class B{constructor(A,y,F){this._proxy=A,this._editors=y,this._initData=F,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const N=y.getVisibleTextEditors();for(const p of this._insets.values())N.indexOf(p.editor)<0&&p.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,F,N,p){let d;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===A){d=u;break}if(!d)throw new Error("not a visible editor");const m=this,l=this._handlePool++,n=new s.Emitter,h=new s.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,b.asWebviewUri)(u,m._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(u){this._options=u,m._proxy.$setOptions(l,u)}get options(){return this._options}set html(u){this._html=u,m._proxy.$setHtml(l,u)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(u){return m._proxy.$postMessage(l,u)}},k=new class{constructor(){this.editor=A,this.line=y,this.height=F,this.webview=S,this.onDidDispose=h.event}dispose(){m._insets.has(l)&&(m._insets.delete(l),m._proxy.$disposeEditorInset(l),h.fire(),h.dispose(),n.dispose())}};return this._proxy.$createEditorInset(l,d.id,d.value.document.uri,y+1,F,N||{},p.identifier,p.extensionLocation),this._insets.set(l,{editor:A,inset:k,onDidReceiveMessage:n}),k}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){const F=this._insets.get(A);F&&F.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=B}),define(we[158],be([1,0,5,13,130]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class B{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,F,N){const p={command:A};if(y&&Object.keys(y).length>0&&(p.arguments=y),this.internalSend("request",p),typeof N=="number"){const d=setTimeout(()=>{clearTimeout(d);const m=this.pendingRequests.get(p.seq);if(m){this.pendingRequests.delete(p.seq);const l={type:"response",seq:0,request_seq:p.seq,success:!1,command:A,message:(0,b.localize)(0,null,N,A)};m(l)}},N)}return F&&this.pendingRequests.set(p.seq,F),p.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":{const y=A,F=this.pendingRequests.get(y.request_seq);F&&(this.pendingRequests.delete(y.request_seq),F(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,F)=>A.set(F,y)),await(0,I.timeout)(500),A.forEach((y,F)=>{y({type:"response",seq:0,request_seq:F,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(F)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=B}),define(we[159],be([1,0,131,44,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:s.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:s.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:s.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:s.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:s.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:s.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:s.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:s.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:s.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:s.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:s.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:s.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:s.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:s.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:s.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:s.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:s.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:s.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:s.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:s.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:s.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new I.RawContextKey("breakpointAccessType",void 0,{type:"string",description:s.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:s.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:s.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:s.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:s.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:s.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:s.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:s.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:s.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:s.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:s.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:s.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:s.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:s.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:s.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:s.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:s.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:s.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:s.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:s.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:s.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:s.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:s.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:s.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:s.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:s.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:s.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:s.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:s.localize(49,null)});const B=p=>s.localize(50,null,p);e.debuggerDisabledMessage=B,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:s.localize(51,null)};var D;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(D=e.State||(e.State={}));function A(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var F;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(F=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var N;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(N=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(we[160],be([1,0,9,2,17,26,10]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(r,i,c){return r.replace(A,function(t,a){return i&&a.length>0&&a[0]!=="_"?t:c&&c.hasOwnProperty(a)?c[a]:t})}e.formatPII=y;function F(r){const i={};for(const c of Object.keys(r))c.startsWith("!")||(i[c]=r[c]);return i}e.filterExceptionsFromTelemetry=F;function N(r){return r.configuration.request==="attach"&&!p(r)&&(!r.parentSession||N(r.parentSession))}e.isSessionAttach=N;function p(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(i,"extensionhost")||(0,s.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?p(r.parentSession):void 0}e.getExtensionHostDebugSession=p;function d(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=d;function m(r,i,c){let t,a=0;const g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=g.exec(r);){const _=f.index+1,P=_+f[0].length;if(_<=i&&P>=c){t=f[0],a=_;break}}if(t){const _=/\w+/g;let P=null;for(;(P=_.exec(t))&&!(P.index+1+a+P[0].length>=c););P&&(t=t.substring(0,_.lastIndex))}return t?{start:a,end:a+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(r){return!!(r&&r.match(l))}e.isUri=n;function h(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(n(r.path))return I.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return I.URI.file(r.path)}return r.path}function S(r){if(typeof r.path=="object"){const i=I.URI.revive(r.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return r.path}function k(r,i){const c=i?h:S,t=(0,B.deepClone)(r);return E(t,(a,g)=>{a&&g&&(g.path=c(g))}),t}e.convertToDAPaths=k;function u(r,i){const c=i?h:S,t=(0,B.deepClone)(r);return E(t,(a,g)=>{!a&&g&&(g.path=c(g))}),t}e.convertToVSCPaths=u;function E(r,i){switch(r.type){case"event":{const c=r;switch(c.event){case"output":i(!1,c.body.source);break;case"loadedSource":i(!1,c.body.source);break;case"breakpoint":i(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=r;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":c.body.sources.forEach(t=>i(!1,t));break;case"scopes":c.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":c.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=c;t.body&&t.body.instructions.forEach(a=>i(!1,a.location))}break;default:break}break}}}function w(r){return r.filter(i=>!i.presentation?.hidden).sort((i,c)=>i.presentation?c.presentation?i.presentation.group?c.presentation.group?i.presentation.group!==c.presentation.group?i.presentation.group.localeCompare(c.presentation.group):o(i.presentation.order,c.presentation.order):-1:c.presentation.group?1:o(i.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function o(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function T(r,i){const c=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(c!=="none"&&(await i.saveAll(),c==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=T}),define(we[85],be([1,0,29,161,71,10,17,23,44]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var F;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(F=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",b.Mimes.latex,b.Mimes.markdown,"image/png","image/jpeg",b.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[b.Mimes.latex,b.Mimes.markdown,"application/json",b.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var N;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(N=e.NotebookRunState||(e.NotebookRunState={}));var p;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(p=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var d;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(d=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeLanguage=5]="ChangeLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var S;(function(t){t.scheme=B.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function g(v,H){return v.with({scheme:t.scheme,fragment:`ch${H.toString().padStart(7,"0")}${v.scheme!==B.Schemas.file?v.scheme:""}`})}t.generate=g;function f(v){if(v.scheme!==t.scheme)return;const H=a.exec(v.fragment);return H?{handle:Number(H[1]),notebook:v.with({scheme:v.fragment.substring(H[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parse=f;function _(v,H){return v.with({scheme:B.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${v.scheme!==B.Schemas.file?v.scheme:""}`})}t.generateCellOutputUri=_;function P(v){if(v.scheme!==B.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(v.fragment);if(!H)return;const W=H[1]&&H[1]!==""?H[1]:void 0,q=H[2];return{outputId:W,notebook:v.with({scheme:q||B.Schemas.file,fragment:null})}}t.parseCellOutputUri=P;function $(v,H,W){return v.with({scheme:W,fragment:`ch${H.toString().padStart(7,"0")}${v.scheme!==B.Schemas.file?v.scheme:""}`})}t.generateCellUri=$;function L(v,H){if(v.scheme!==H)return;const W=a.exec(v.fragment);return W?{handle:Number(W[1]),notebook:v.with({scheme:v.fragment.substring(W[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parseCellUri=L})(S=e.CellUri||(e.CellUri={}));const k=t=>A.isWindows?t.replace(/\//g,"\\"):t;class u{constructor(a=[],g=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=g,this.order=[...new Set(a)].map(f=>({pattern:f,matches:s.parse(k(f))}))}sort(a){const g=new Map(I.Iterable.map(a,_=>[_,k(_)]));let f=[];for(const{matches:_}of this.order)for(const[P,$]of g)if(_($)){f.push(P),g.delete(P);break}return g.size&&(f=f.concat([...g.keys()].sort((_,P)=>this.defaultOrder.indexOf(_)-this.defaultOrder.indexOf(P)))),f}prioritize(a,g){const f=this.findIndex(a);if(f===-1){this.order.unshift({pattern:a,matches:s.parse(k(a))});return}const _=new Set(g.map($=>this.findIndex($,f)));_.delete(-1);const P=Array.from(_).sort();this.order.splice(f+1,0,...P.map($=>this.order[$]));for(let $=P.length-1;$>=0;$--)this.order.splice(P[$],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,g=this.order.length){const f=k(a);for(let _=0;_<g;_++)if(this.order[_].matches(f))return _;return-1}}e.MimeTypeDisplayOrder=u;function E(t,a,g,f=(_,P)=>_===P){const _=[];function P(v,H,W){if(H===0&&W.length===0)return;const q=_[_.length-1];q&&q.start+q.deleteCount===v?(q.deleteCount+=H,q.toInsert.push(...W)):_.push({start:v,deleteCount:H,toInsert:W})}let $=0,L=0;for(;;){if($===t.length){P($,0,a.slice(L));break}if(L===a.length){P($,t.length-$,[]);break}const v=t[$],H=a[L];if(f(v,H)){$+=1,L+=1;continue}g(H)?(P($,1,[]),$+=1):(P($,0,[H]),L+=1)}return _}e.diff=E,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var w;(function(t){t.default="default",t.option="option"})(w=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(t){const a=t;return!!((typeof a.include=="string"||s.isRelativePattern(a.include))&&(typeof a.exclude=="string"||s.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=o;function T(t,a,g){if(Array.isArray(t.viewType)&&t.viewType.indexOf(a)>=0||t.viewType===a)return!0;if(t.filenamePattern){const f=o(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,_=o(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(s.match(f,(0,D.basename)(g.fsPath).toLowerCase()))return!(_&&s.match(_,(0,D.basename)(g.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=T;class r{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let g=0;g<this.textModel.cells.length;g++)a[g]=this.textModel.cells[g].getHashValue();return a}}e.CellSequence=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(a){return`${c._prefix}${a}`}static parse(a){if(a.startsWith(c._prefix))return a.substring(c._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c._prefix="notebook/"}),define(we[162],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(we[163],be([1,0,3,44]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,s.createDecorator)(e.OUTPUT_SERVICE_ID);var b;(function(B){B[B.Append=1]="Append",B[B.Replace=2]="Replace",B[B.Clear=3]="Clear"})(b=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[164],be([1,0,132,3,44]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,s.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,s.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,s.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[165],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=s;function I(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=I}),define(we[62],be([1,0,2,48]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var B;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable"})(B=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(c){c.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),c.deserialize=t=>({range:I.Range.lift(t.range),uri:s.URI.revive(t.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var A;(function(c){c[c.Error=0]="Error",c[c.Info=1]="Info"})(A=e.TestMessageType||(e.TestMessageType={}));var y;(function(c){c.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.serialize(t.location)}),c.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.deserialize(t.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));var F;(function(c){c.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&D.serialize(t.location)}),c.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&D.deserialize(t.location)})})(F=e.ITestOutputMessage||(e.ITestOutputMessage={}));var N;(function(c){c.serialize=t=>t.type===0?y.serialize(t):F.serialize(t),c.deserialize=t=>t.type===0?y.deserialize(t):F.deserialize(t)})(N=e.ITestMessage||(e.ITestMessage={}));var p;(function(c){c.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(N.serialize)}),c.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(N.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const d="\0",m=(c,t)=>c+d+t;e.namespaceTestTag=m;const l=c=>{const t=c.indexOf(d);return{ctrlId:c.slice(0,t),tagId:c.slice(t+1)}};e.denamespaceTestTag=l;var n;(function(c){c.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),c.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?s.URI.revive(t.uri):void 0,range:t.range?I.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(n=e.ITestItem||(e.ITestItem={}));var h;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(c){c.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.serialize(t.item)}),c.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.deserialize(t.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var k;(function(c){c.serialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.uri!==void 0&&(a.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(a.range=t.item.range?.toJSON()),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}},c.deserialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.range!==void 0&&(a.range=t.item.range?I.Range.lift(t.item.range):null),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}}})(k=e.ITestItemUpdate||(e.ITestItemUpdate={}));const u=(c,t)=>{t.expand!==void 0&&(c.expand=t.expand),t.item!==void 0&&(c.item=c.item?Object.assign(c.item,t.item):t.item)};e.applyTestItemUpdate=u;var E;(function(c){c.serialize=(t,a)=>({...S.serialize(t),children:a,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(p.serialize)})})(E=e.TestResultItem||(e.TestResultItem={}));var w;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(w=e.DetailType||(e.DetailType={}));var o;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.Remove=2]="Remove",c[c.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",c[c.Retire=4]="Retire",c[c.AddTag=5]="AddTag",c[c.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var T;(function(c){c.deserialize=t=>t.op===0?{op:t.op,item:S.deserialize(t.item)}:t.op===1?{op:t.op,item:k.deserialize(t.item)}:t,c.serialize=t=>t.op===0?{op:t.op,item:S.serialize(t.item)}:t.op===1?{op:t.op,item:k.serialize(t.item)}:t})(T=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,a){}complete(){}}e.IncrementalChangeCollector=r;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const a=this.createChangeCollector();for(const g of t)switch(g.op){case 0:{const f=S.deserialize(g.item);if(f.parent){if(this.items.has(f.parent)){const _=this.items.get(f.parent);_.children.add(f.item.extId);const P=this.createItem(f,_);this.items.set(f.item.extId,P),a.add(P)}}else{const _=this.createItem(f);this.roots.add(_),this.items.set(f.item.extId,_),a.add(_)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=k.deserialize(g.item),_=this.items.get(f.extId);if(!_)break;f.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,f),a.update(_);break}case 2:{const f=this.items.get(g.itemId);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const _=[[g.itemId]];for(;_.length;)for(const P of _.pop()){const $=this.items.get(P);$&&(_.push($.children),this.items.delete(P),a.remove($,$!==f),$.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g.itemId);break;case 3:this.updatePendingRoots(g.amount);break;case 5:this._tags.set(g.tag.id,g.tag);break;case 6:this._tags.delete(g.id);break}a.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=i}),define(we[63],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(B){B.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(B){B[B.IsSame=0]="IsSame",B[B.Disconnected=1]="Disconnected",B[B.IsChild=2]="IsChild",B[B.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class b{constructor(D,A=D.length){if(this.path=D,this.viewEnd=A,D.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,A,y=D.parent){if(D.id===A)return new b([A]);let F=[D.id];for(let N=y;N&&N.id!==A;N=N.parent)F.push(N.id);return F.push(A),new b(F.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const A=D.indexOf("\0");return A===-1?D:D.slice(0,A)}static fromString(D){return new b(D.split("\0"))}static join(D,A){return new b([...D.path,A])}static joinToString(D,A){return D.toString()+"\0"+A}static compare(D,A){return D===A?0:A.startsWith(D+"\0")?2:D.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new b(this.path,D)}compare(D){if(typeof D=="string")return b.compare(this.toString(),D);for(let A=0;A<D.viewEnd&&A<this.viewEnd;A++)if(D.path[A]!==this.path[A])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=b}),define(we[166],be([1,0,17,86,11,26,23,73,133]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class F{constructor(p,d,m,l){this._contributedVariables=new Map,this._context=p,this._labelService=d,this._userHomePromise=m,l&&(this._envVariablesPromise=l.then(n=>this.prepareEnv(n)))}prepareEnv(p){if(D.isWindows){const d=Object.create(null);return Object.keys(p).forEach(m=>{d[m.toLowerCase()]=p[m]}),d}return p}resolveWithEnvironment(p,d,m){return this.recursiveResolve({env:this.prepareEnv(p),userHome:void 0},d?d.uri:void 0,m)}async resolveAsync(p,d){const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,p?p.uri:void 0,d)}async resolveAnyBase(p,d,m,l){const n=B.deepClone(d);D.isWindows&&n.windows?Object.keys(n.windows).forEach(S=>n[S]=n.windows[S]):D.isMacintosh&&n.osx?Object.keys(n.osx).forEach(S=>n[S]=n.osx[S]):D.isLinux&&n.linux&&Object.keys(n.linux).forEach(S=>n[S]=n.linux[S]),delete n.windows,delete n.osx,delete n.linux;const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,p?p.uri:void 0,n,m,l)}async resolveAnyAsync(p,d,m){return this.resolveAnyBase(p,d,m)}async resolveAnyMap(p,d,m){const l=new Map;return{newConfig:await this.resolveAnyBase(p,d,m,l),resolvedVariables:l}}resolveWithInteractionReplace(p,d,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,d,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,d){if(this._contributedVariables.has(p))throw new Error("Variable "+p+" is contributed twice.");this._contributedVariables.set(p,d)}recursiveResolve(p,d,m,l,n){if(b.isString(m))return this.resolveString(p,d,m,l,n);if(b.isArray(m))return m.map(h=>this.recursiveResolve(p,d,h,l,n));if(b.isObject(m)){let h=Object.create(null);return Object.keys(m).forEach(S=>{const k=this.resolveString(p,d,S,l,n);h[k]=this.recursiveResolve(p,d,m[S],l,n)}),h}return m}resolveString(p,d,m,l,n){return m.replace(F.VARIABLE_REGEXP,(S,k)=>{if(k.includes(F.VARIABLE_LHS))return S;let u=this.evaluateSingleVariable(p,S,k,d,l);return n&&n.set(k,u),u!==S&&b.isString(u)&&u.match(F.VARIABLE_REGEXP)&&(u=this.resolveString(p,d,u,l,n)),u})}fsPath(p){return this._labelService?this._labelService.getUriLabel(p,{noPrefix:!0}):p.fsPath}evaluateSingleVariable(p,d,m,l,n){let h;const S=m.split(":");S.length>1&&(m=S[0],h=S[1]);const k=()=>{const w=this._context.getFilePath();if(w)return w;throw new Error((0,y.localize)(0,null,d))},u=()=>{const w=k();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,y.localize)(1,null,d,s.basename(w)))},E=()=>{if(h){const w=this._context.getFolderUri(h);if(w)return w;throw new Error((0,y.localize)(2,null,d,h))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,d)):new Error((0,y.localize)(4,null,d))};switch(m){case"env":if(h){if(p.env){const w=p.env[D.isWindows?h.toLowerCase():h];if(b.isString(w))return w}return""}throw new Error((0,y.localize)(5,null,d));case"config":if(h){const w=this._context.getConfigurationValue(l,h);if(b.isUndefinedOrNull(w))throw new Error((0,y.localize)(6,null,d,h));if(b.isObject(w))throw new Error((0,y.localize)(7,null,d,h));return w}throw new Error((0,y.localize)(8,null,d));case"command":return this.resolveFromMap(d,h,n,"command");case"input":return this.resolveFromMap(d,h,n,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(E()));case"cwd":return l||h?(0,A.normalizeDriveLetter)(this.fsPath(E())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(E()));case"userHome":{if(p.userHome)return p.userHome;throw new Error((0,y.localize)(9,null,d))}case"lineNumber":{const w=this._context.getLineNumber();if(w)return w;throw new Error((0,y.localize)(10,null,d))}case"selectedText":{const w=this._context.getSelectedText();if(w)return w;throw new Error((0,y.localize)(11,null,d))}case"file":return k();case"fileWorkspaceFolder":return u();case"relativeFile":return l||h?s.relative(this.fsPath(E()),k()):k();case"relativeFileDirname":{const w=s.dirname(k());if(l||h){const o=s.relative(this.fsPath(E()),w);return o.length===0?".":o}return w}case"fileDirname":return s.dirname(k());case"fileExtname":return s.extname(k());case"fileBasename":return s.basename(k());case"fileBasenameNoExtension":{const w=s.basename(k());return w.slice(0,w.length-s.extname(w).length)}case"fileDirnameBasename":return s.basename(s.dirname(k()));case"execPath":{const w=this._context.getExecPath();return w||d}case"execInstallFolder":{const w=this._context.getAppRoot();return w||d}case"pathSeparator":return s.sep;default:try{const w=h?`${m}:${h}`:m;return this.resolveFromMap(d,w,n,void 0)}catch{return d}}}}resolveFromMap(p,d,m,l){if(d&&m){const n=l===void 0?m[d]:m[l+":"+d];if(typeof n=="string")return n;throw new Error((0,y.localize)(12,null,p))}return p}}e.AbstractVariableResolverService=F,F.VARIABLE_LHS="${",F.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[87],be([1,0,3,156]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var b;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var B;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(B=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function F(l){const n=l;return(0,I.isEditorInput)(n?.editor)&&(0,I.isEditorInput)(n?.replacement)}e.isEditorReplacement=F;var N;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var p;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(p=e.OpenEditorContext||(e.OpenEditorContext={}));function d(l){const n=l;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=d;function m(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(we[167],be([1,0,3,87]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(B){const D=B;return typeof B=="number"||(0,I.isEditorGroup)(D)}e.isPreferredGroup=b}),define(we[8],be([1,0,16,21,72,101,54,26,11,2,48,88,135,78,47,85,62,63,167,7]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(me){function pe(G){const{selectionStartLineNumber:Se,selectionStartColumn:Ce,positionLineNumber:xe,positionColumn:je}=G,lt=new u.Position(Se-1,Ce-1),gt=new u.Position(xe-1,je-1);return new u.Selection(lt,gt)}me.to=pe;function oe(G){const{anchor:Se,active:Ce}=G;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}me.from=oe})(E=e.Selection||(e.Selection={}));var w;(function(me){function pe(G){if(!G)return;const{start:Se,end:Ce}=G;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}me.from=pe;function oe(G){if(!G)return;const{startLineNumber:Se,startColumn:Ce,endLineNumber:xe,endColumn:je}=G;return new u.Range(Se-1,Ce-1,xe-1,je-1)}me.to=oe})(w=e.Range||(e.Range={}));var o;(function(me){function pe(oe){switch(oe){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}me.to=pe})(o=e.TokenType||(e.TokenType={}));var T;(function(me){function pe(G){return new u.Position(G.lineNumber-1,G.column-1)}me.to=pe;function oe(G){return{lineNumber:G.line+1,column:G.character+1}}me.from=oe})(T=e.Position||(e.Position={}));var r;(function(me){function pe(Se,Ce){return(0,s.coalesce)((0,s.asArray)(Se).map(xe=>oe(xe,Ce)))}me.from=pe;function oe(Se,Ce){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:G(Se.scheme,Ce),pattern:le.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType}}function G(Se,Ce){return Ce&&typeof Se=="string"?Ce.transformOutgoingScheme(Se):Se}})(r=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(me){function pe(G){switch(G){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}me.from=pe;function oe(G){switch(G){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}me.to=oe})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(me){function pe(G){let Se;return G.code&&((0,y.isString)(G.code)||(0,y.isNumber)(G.code)?Se=String(G.code):Se={value:String(G.code.value),target:G.code.target}),{...w.from(G.range),message:G.message,source:G.source,code:Se,severity:a.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?(0,s.coalesce)(G.tags.map(i.from)):void 0}}me.from=pe;function oe(G){const Se=new u.Diagnostic(w.to(G),G.message,a.to(G.severity));return Se.source=G.source,Se.code=(0,y.isString)(G.code)?G.code:G.code?.value,Se.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Se.tags=G.tags&&(0,s.coalesce)(G.tags.map(i.to)),Se}me.to=oe})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(me){function pe(G){return{...w.from(G.location.range),message:G.message,resource:G.location.uri}}me.from=pe;function oe(G){return new u.DiagnosticRelatedInformation(new u.Location(G.resource,w.to(G)),G.message)}me.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(me){function pe(G){switch(G){case u.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}me.from=pe;function oe(G){switch(G){case m.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}me.to=oe})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var g;(function(me){function pe(G){return typeof G=="number"&&G>=u.ViewColumn.One?G-1:G===u.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}me.from=pe;function oe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=oe})(g=e.ViewColumn||(e.ViewColumn={}));function f(me){return typeof me.range!="undefined"}function _(me){return me.length===0?!0:!!f(me[0])}e.isDecorationOptionsArr=_;var P;(function(me){function pe(je){return je.map(me.from)}me.fromMany=pe;function oe(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function G(je){let lt;if(oe(je)){const{language:at,value:ot}=je;lt={value:"```"+at+`
`+ot+"\n```\n"}}else u.MarkdownString.isMarkdownString(je)?lt={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?lt={value:je}:lt={value:""};const gt=Object.create(null);lt.uris=gt;const Et=at=>{try{let ot=F.URI.parse(at,!0);ot=ot.with({query:Se(ot.query,gt)}),gt[at]=ot}catch{}return""},rt=new B.marked.Renderer;return rt.link=Et,rt.image=at=>typeof at=="string"?Et(b.parseHrefAndDimensions(at).href):"",(0,B.marked)(lt.value,{renderer:rt}),lt}me.from=G;function Se(je,lt){if(!je)return je;let gt;try{gt=(0,D.parse)(je)}catch{}if(!gt)return je;let Et=!1;return gt=(0,A.cloneAndChange)(gt,rt=>{if(F.URI.isUri(rt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[at]=rt,Et=!0,at}else return}),Et?JSON.stringify(gt):je}function Ce(je){const lt=new u.MarkdownString(je.value,je.supportThemeIcons);return lt.isTrusted=je.isTrusted,lt.supportHtml=je.supportHtml,lt.baseUri=je.baseUri?F.URI.from(je.baseUri):void 0,lt}me.to=Ce;function xe(je){if(!!je)return typeof je=="string"?je:me.from(je)}me.fromStrict=xe})(P=e.MarkdownString||(e.MarkdownString={}));function $(me){return _(me)?me.map(pe=>({range:w.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?P.fromMany(pe.hoverMessage):pe.hoverMessage?P.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):me.map(pe=>({range:w.from(pe)}))}e.fromRangeOrRangeWithMessage=$;function L(me){return typeof me=="undefined"?me:typeof me=="string"?F.URI.file(me):me}e.pathOrURIToURI=L;var v;(function(me){function pe(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?L(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}me.from=pe})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(me){function pe(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?L(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}me.from=pe})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(me){function pe(oe){if(typeof oe=="undefined")return oe;switch(oe){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=pe})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(me){function pe(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?W.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?H.from(oe.light):void 0,dark:oe.dark?H.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?L(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}me.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(me){function pe(G){return{text:G.newText,eol:G.newEol&&tt.from(G.newEol),range:w.from(G.range)}}me.from=pe;function oe(G){const Se=new u.TextEdit(w.to(G.range),G.text);return Se.newEol=typeof G.eol=="undefined"?void 0:tt.to(G.eol),Se}me.to=oe})(K=e.TextEdit||(e.TextEdit={}));var V;(function(me){function pe(G,Se){const Ce={edits:[]};if(G instanceof u.WorkspaceEdit)for(let xe of G._allEntries())xe._type===1?Ce.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata}):xe._type===2?Ce.edits.push({_type:2,resource:xe.uri,edit:K.from(xe.edit),modelVersionId:Se?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Ce.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Ce.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:Se?.getNotebookDocumentVersion(xe.uri),edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(St.from)}});return Ce}me.from=pe;function oe(G){const Se=new u.WorkspaceEdit;for(const Ce of G.edits)Ce.edit?Se.replace(F.URI.revive(Ce.resource),w.to(Ce.edit.range),Ce.edit.text):Se.renameFile(F.URI.revive(Ce.oldUri),F.URI.revive(Ce.newUri),Ce.options);return Se}me.to=oe})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(me){const pe=Object.create(null);pe[u.SymbolKind.File]=0,pe[u.SymbolKind.Module]=1,pe[u.SymbolKind.Namespace]=2,pe[u.SymbolKind.Package]=3,pe[u.SymbolKind.Class]=4,pe[u.SymbolKind.Method]=5,pe[u.SymbolKind.Property]=6,pe[u.SymbolKind.Field]=7,pe[u.SymbolKind.Constructor]=8,pe[u.SymbolKind.Enum]=9,pe[u.SymbolKind.Interface]=10,pe[u.SymbolKind.Function]=11,pe[u.SymbolKind.Variable]=12,pe[u.SymbolKind.Constant]=13,pe[u.SymbolKind.String]=14,pe[u.SymbolKind.Number]=15,pe[u.SymbolKind.Boolean]=16,pe[u.SymbolKind.Array]=17,pe[u.SymbolKind.Object]=18,pe[u.SymbolKind.Key]=19,pe[u.SymbolKind.Null]=20,pe[u.SymbolKind.EnumMember]=21,pe[u.SymbolKind.Struct]=22,pe[u.SymbolKind.Event]=23,pe[u.SymbolKind.Operator]=24,pe[u.SymbolKind.TypeParameter]=25;function oe(Se){return typeof pe[Se]=="number"?pe[Se]:6}me.from=oe;function G(Se){for(const Ce in pe)if(pe[Ce]===Se)return Number(Ce);return u.SymbolKind.Property}me.to=G})(z=e.SymbolKind||(e.SymbolKind={}));var ae;(function(me){function pe(G){switch(G){case u.SymbolTag.Deprecated:return 1}}me.from=pe;function oe(G){switch(G){case 1:return u.SymbolTag.Deprecated}}me.to=oe})(ae=e.SymbolTag||(e.SymbolTag={}));var de;(function(me){function pe(G){return{name:G.name,kind:z.from(G.kind),tags:G.tags&&G.tags.map(ae.from),containerName:G.containerName,location:ue.from(G.location)}}me.from=pe;function oe(G){const Se=new u.SymbolInformation(G.name,z.to(G.kind),G.containerName,ue.to(G.location));return Se.tags=G.tags&&G.tags.map(ae.to),Se}me.to=oe})(de=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(me){function pe(G){const Se={name:G.name||"!!MISSING: name!!",detail:G.detail,range:w.from(G.range),selectionRange:w.from(G.selectionRange),kind:z.from(G.kind),tags:G.tags?.map(ae.from)??[]};return G.children&&(Se.children=G.children.map(pe)),Se}me.from=pe;function oe(G){const Se=new u.DocumentSymbol(G.name,G.detail,z.to(G.kind),w.to(G.range),w.to(G.selectionRange));return(0,s.isNonEmptyArray)(G.tags)&&(Se.tags=G.tags.map(ae.to)),G.children&&(Se.children=G.children.map(oe)),Se}me.to=oe})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(me){function pe(G){const Se=new u.CallHierarchyItem(z.to(G.kind),G.name,G.detail||"",F.URI.revive(G.uri),w.to(G.range),w.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}me.to=pe;function oe(G,Se,Ce){if(Se=Se??G._sessionId,Ce=Ce??G._itemId,Se===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Ce,name:G.name,detail:G.detail,kind:z.from(G.kind),uri:G.uri,range:w.from(G.range),selectionRange:w.from(G.selectionRange),tags:G.tags?.map(ae.from)}}me.from=oe})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(me){function pe(oe){return new u.CallHierarchyIncomingCall(ie.to(oe.from),oe.fromRanges.map(G=>w.to(G)))}me.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(me){function pe(oe){return new u.CallHierarchyOutgoingCall(ie.to(oe.to),oe.fromRanges.map(G=>w.to(G)))}me.to=pe})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(me){function pe(G){return{range:G.range&&w.from(G.range),uri:G.uri}}me.from=pe;function oe(G){return new u.Location(F.URI.revive(G.uri),w.to(G.range))}me.to=oe})(ue=e.location||(e.location={}));var re;(function(me){function pe(G){const Se=G,Ce=G;return{originSelectionRange:Se.originSelectionRange?w.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Ce.uri,range:w.from(Se.targetRange?Se.targetRange:Ce.range),targetSelectionRange:Se.targetSelectionRange?w.from(Se.targetSelectionRange):void 0}}me.from=pe;function oe(G){return{targetUri:F.URI.revive(G.uri),targetRange:w.to(G.range),targetSelectionRange:G.targetSelectionRange?w.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?w.to(G.originSelectionRange):void 0}}me.to=oe})(re=e.DefinitionLink||(e.DefinitionLink={}));var ge;(function(me){function pe(G){return{range:w.from(G.range),contents:P.fromMany(G.contents)}}me.from=pe;function oe(G){return new u.Hover(G.contents.map(P.to),w.to(G.range))}me.to=oe})(ge=e.Hover||(e.Hover={}));var Te;(function(me){function pe(G){return{range:w.from(G.range),expression:G.expression}}me.from=pe;function oe(G){return new u.EvaluatableExpression(w.to(G.range),G.expression)}me.to=oe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(me){function pe(G){if(G instanceof u.InlineValueText)return{type:"text",range:w.from(G.range),text:G.text};if(G instanceof u.InlineValueVariableLookup)return{type:"variable",range:w.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}me.from=pe;function oe(G){switch(G.type){case"text":return{range:w.to(G.range),text:G.text};case"variable":return{range:w.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:w.to(G.range),expression:G.expression}}}me.to=oe})(Re=e.InlineValue||(e.InlineValue={}));var He;(function(me){function pe(G){return{frameId:G.frameId,stoppedLocation:w.from(G.stoppedLocation)}}me.from=pe;function oe(G){return new u.InlineValueContext(G.frameId,w.to(G.stoppedLocation))}me.to=oe})(He=e.InlineValueContext||(e.InlineValueContext={}));var Xe;(function(me){function pe(G){return{range:w.from(G.range),kind:G.kind}}me.from=pe;function oe(G){return new u.DocumentHighlight(w.to(G.range),G.kind)}me.to=oe})(Xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ve;(function(me){function pe(oe){switch(oe){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}me.to=pe})(ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var fe;(function(me){function pe(oe){return{triggerKind:ve.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}me.to=pe})(fe=e.CompletionContext||(e.CompletionContext={}));var M;(function(me){function pe(G){switch(G){case u.CompletionItemTag.Deprecated:return 1}}me.from=pe;function oe(G){switch(G){case 1:return u.CompletionItemTag.Deprecated}}me.to=oe})(M=e.CompletionItemTag||(e.CompletionItemTag={}));var O;(function(me){const pe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function oe(Ce){return pe.get(Ce)??9}me.from=oe;const G=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Se(Ce){return G.get(Ce)??u.CompletionItemKind.Property}me.to=Se})(O=e.CompletionItemKind||(e.CompletionItemKind={}));var C;(function(me){function pe(oe,G){const Se=new u.CompletionItem(oe.label);return Se.insertText=oe.insertText,Se.kind=O.to(oe.kind),Se.tags=oe.tags?.map(M.to),Se.detail=oe.detail,Se.documentation=b.isMarkdownString(oe.documentation)?P.to(oe.documentation):oe.documentation,Se.sortText=oe.sortText,Se.filterText=oe.filterText,Se.preselect=oe.preselect,Se.commitCharacters=oe.commitCharacters,N.Range.isIRange(oe.range)?Se.range=w.to(oe.range):typeof oe.range=="object"&&(Se.range={inserting:w.to(oe.range.insert),replacing:w.to(oe.range.replace)}),Se.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Se.insertText=new u.SnippetString(oe.insertText):(Se.insertText=oe.insertText,Se.textEdit=Se.range instanceof u.Range?new u.TextEdit(Se.range,Se.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Se.additionalTextEdits=oe.additionalTextEdits.map(Ce=>K.to(Ce))),Se.command=G&&oe.command?G.fromInternal(oe.command):void 0,Se}me.to=pe})(C=e.CompletionItem||(e.CompletionItem={}));var R;(function(me){function pe(G){return{label:G.label,documentation:P.fromStrict(G.documentation)}}me.from=pe;function oe(G){return{label:G.label,documentation:b.isMarkdownString(G.documentation)?P.to(G.documentation):G.documentation}}me.to=oe})(R=e.ParameterInformation||(e.ParameterInformation={}));var x;(function(me){function pe(G){return{label:G.label,documentation:P.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(R.from):[],activeParameter:G.activeParameter}}me.from=pe;function oe(G){return{label:G.label,documentation:b.isMarkdownString(G.documentation)?P.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(R.to):[],activeParameter:G.activeParameter}}me.to=oe})(x=e.SignatureInformation||(e.SignatureInformation={}));var Q;(function(me){function pe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(x.from):[]}}me.from=pe;function oe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(x.to):[]}}me.to=oe})(Q=e.SignatureHelp||(e.SignatureHelp={}));var ne;(function(me){function pe(oe,G){const Se=new u.InlayHint(T.to(G.position),typeof G.label=="string"?G.label:G.label.map(Ee.to.bind(void 0,oe)),G.kind&&Ie.to(G.kind));return Se.textEdits=G.textEdits&&G.textEdits.map(K.to),Se.tooltip=b.isMarkdownString(G.tooltip)?P.to(G.tooltip):G.tooltip,Se.paddingLeft=G.paddingLeft,Se.paddingRight=G.paddingRight,Se}me.to=pe})(ne=e.InlayHint||(e.InlayHint={}));var Ee;(function(me){function pe(oe,G){const Se=new u.InlayHintLabelPart(G.label);return Se.tooltip=b.isMarkdownString(G.tooltip)?P.to(G.tooltip):G.tooltip,p.Command.is(G.command)&&(Se.command=oe.fromInternal(G.command)),G.location&&(Se.location=ue.to(G.location)),Se}me.to=pe})(Ee=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ie;(function(me){function pe(G){return G}me.from=pe;function oe(G){return G}me.to=oe})(Ie=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(me){function pe(G){return{range:w.from(G.range),url:G.target,tooltip:G.tooltip}}me.from=pe;function oe(G){let Se;if(G.url)try{Se=typeof G.url=="string"?F.URI.parse(G.url,!0):F.URI.revive(G.url)}catch{}return new u.DocumentLink(w.to(G.range),Se)}me.to=oe})(Me=e.DocumentLink||(e.DocumentLink={}));var Le;(function(me){function pe(G){const Se=new u.ColorPresentation(G.label);return G.textEdit&&(Se.textEdit=K.to(G.textEdit)),G.additionalTextEdits&&(Se.additionalTextEdits=G.additionalTextEdits.map(Ce=>K.to(Ce))),Se}me.to=pe;function oe(G){return{label:G.label,textEdit:G.textEdit?K.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Se=>K.from(Se)):void 0}}me.from=oe})(Le=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(me){function pe(G){return new u.Color(G[0],G[1],G[2],G[3])}me.to=pe;function oe(G){return[G.red,G.green,G.blue,G.alpha]}me.from=oe})(ze=e.Color||(e.Color={}));var Be;(function(me){function pe(G){return{range:w.from(G.range)}}me.from=pe;function oe(G){return new u.SelectionRange(w.to(G.range))}me.to=oe})(Be=e.SelectionRange||(e.SelectionRange={}));var Ae;(function(me){function pe(oe){switch(oe){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}me.to=pe})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(me){function pe(G){switch(G){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}me.from=pe;function oe(G){switch(G){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}me.to=oe})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var tt;(function(me){function pe(G){if(G===u.EndOfLine.CRLF)return 1;if(G===u.EndOfLine.LF)return 0}me.from=pe;function oe(G){if(G===1)return u.EndOfLine.CRLF;if(G===0)return u.EndOfLine.LF}me.to=oe})(tt=e.EndOfLine||(e.EndOfLine={}));var ke;(function(me){function pe(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=pe})(ke=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(me){function pe(oe){const G={start:oe.start+1,end:oe.end+1};return oe.kind&&(G.kind=X.from(oe.kind)),G}me.from=pe})(it=e.FoldingRange||(e.FoldingRange={}));var X;(function(me){function pe(oe){if(oe)switch(oe){case u.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}me.from=pe})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var J;(function(me){function pe(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?w.from(oe.selection):void 0,override:typeof oe.override=="boolean"?d.EditorResolution.DISABLED:void 0}}me.from=pe})(J=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(me){function pe(Ce){return Ce instanceof u.RelativePattern?Ce.toJSON():typeof Ce=="string"?Ce:oe(Ce)||G(Ce)?new u.RelativePattern(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}me.from=pe;function oe(Ce){const xe=Ce;return xe?F.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function G(Ce){const xe=Ce;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Se(Ce){return typeof Ce=="string"?Ce:new u.RelativePattern(F.URI.revive(Ce.baseUri),Ce.pattern)}me.to=Se})(le=e.GlobPattern||(e.GlobPattern={}));var Oe;(function(me){function pe(oe){if(oe){if(Array.isArray(oe))return oe.map(pe);if(typeof oe=="string")return oe;{const G=oe;return{language:G.language,scheme:G.scheme,pattern:le.from(G.pattern),exclusive:G.exclusive}}}else return}me.from=pe})(Oe=e.LanguageSelector||(e.LanguageSelector={}));var $e;(function(me){function pe(G){return{start:G.start,end:G.end}}me.from=pe;function oe(G){return new u.NotebookRange(G.start,G.end)}me.to=oe})($e=e.NotebookRange||(e.NotebookRange={}));var Ge;(function(me){function pe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}me.to=pe;function oe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}me.from=oe})(Ge=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Je;(function(me){function pe(oe){if(oe===n.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;if(oe===n.NotebookCellExecutionState.Pending)return u.NotebookCellExecutionState.Pending;if(oe===n.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${oe}`)}me.to=pe})(Je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ft;(function(me){function pe(G){switch(G){case u.NotebookCellKind.Markup:return n.CellKind.Markup;case u.NotebookCellKind.Code:default:return n.CellKind.Code}}me.from=pe;function oe(G){switch(G){case n.CellKind.Markup:return u.NotebookCellKind.Markup;case n.CellKind.Code:default:return u.NotebookCellKind.Code}}me.to=oe})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(me){function pe(G){const Se={metadata:G.metadata??Object.create(null),cells:[]};for(let Ce of G.cells)u.NotebookCellData.validate(Ce),Se.cells.push(St.from(Ce));return Se}me.from=pe;function oe(G){const Se=new u.NotebookData(G.cells.map(St.to));return(0,y.isEmptyObject)(G.metadata)||(Se.metadata=G.metadata),Se}me.to=oe})(It=e.NotebookData||(e.NotebookData={}));var St;(function(me){function pe(G){return{cellKind:ft.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ge.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(qe.from):[]}}me.from=pe;function oe(G){return new u.NotebookCellData(ft.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(qe.to):void 0,G.metadata,G.internalMetadata?Ge.to(G.internalMetadata):void 0)}me.to=oe})(St=e.NotebookCellData||(e.NotebookCellData={}));var kt;(function(me){function pe(G){return{mime:G.mime,valueBytes:I.VSBuffer.wrap(G.data)}}me.from=pe;function oe(G){return new u.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}me.to=oe})(kt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(me){function pe(G){return{outputId:G.id,items:G.items.map(kt.from),metadata:G.metadata}}me.from=pe;function oe(G){const Se=G.items.map(kt.to);return new u.NotebookCellOutput(Se,G.outputId,G.metadata)}me.to=oe})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var vt;(function(me){function pe(Se){return G(Se)?{include:(0,y.withNullAsUndefined)(le.from(Se.include)),exclude:(0,y.withNullAsUndefined)(le.from(Se.exclude))}:(0,y.withNullAsUndefined)(le.from(Se))}me.from=pe;function oe(Se){return G(Se)?{include:le.to(Se.include),exclude:le.to(Se.exclude)}:le.to(Se)}me.to=oe;function G(Se){const Ce=Se;return Ce?!!Ce.include&&!!Ce.exclude:!1}})(vt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Nt;(function(me){function pe(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?v.from(oe.top):void 0}}me.from=pe})(Nt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(me){function pe(oe,G,Se){const Ce=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ce,Se),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}me.from=pe})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ut;(function(me){function pe(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{}}}me.from=pe})(ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(me){function pe(G){return{uri:G.uri,provides:G.provides}}me.from=pe;function oe(G){return new u.NotebookRendererScript(F.URI.revive(G.uri),G.provides)}me.to=oe})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(me){function pe(G){return{message:P.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:w.from(G.location.range),uri:G.location.uri}}}me.from=pe;function oe(G){const Se=new u.TestMessage(typeof G.message=="string"?G.message:P.to(G.message));return Se.actualOutput=G.actual,Se.expectedOutput=G.expected,Se.location=G.location?ue.to(G.location):void 0,Se}me.to=oe})(Tt=e.TestMessage||(e.TestMessage={}));var bt;(function(me){me.namespace=h.namespaceTestTag,me.denamespace=h.denamespaceTestTag})(bt=e.TestTag||(e.TestTag={}));var dt;(function(me){function pe(Ce){const xe=(0,l.getPrivateApiFor)(Ce).controllerId;return{extId:S.TestId.fromExtHostTestItem(Ce,xe).toString(),label:Ce.label,uri:F.URI.revive(Ce.uri),busy:!1,tags:Ce.tags.map(je=>bt.namespace(xe,je.id)),range:N.Range.lift(w.from(Ce.range)),description:Ce.description||null,sortText:Ce.sortText||null,error:Ce.error&&P.fromStrict(Ce.error)||null}}me.from=pe;function oe(Ce){return{parent:void 0,error:void 0,id:S.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:F.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(xe=>{const{tagId:je}=bt.denamespace(xe);return new u.TestTag(je)}),range:w.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0,sortText:Ce.sortText||void 0}}me.toPlain=oe;function G(Ce){const xe=S.TestId.fromString(Ce.extId),je=new l.TestItemImpl(xe.controllerId,xe.localId,Ce.label,F.URI.revive(Ce.uri)||void 0);return je.range=w.to(Ce.range||void 0),je.description=Ce.description||void 0,je.sortText=Ce.sortText||void 0,je}function Se(Ce){let xe;for(const je of Ce.tests){const lt=G(je.item);(0,l.getPrivateApiFor)(lt).parent=xe,xe=lt}return xe}me.toItemFromContext=Se})(dt=e.TestItem||(e.TestItem={})),function(me){function pe(G){return{id:G.id}}me.from=pe;function oe(G){return new u.TestTag(G.id)}me.to=oe}(bt=e.TestTag||(e.TestTag={}));var Rt;(function(me){const pe=(G,Se)=>{const Ce={...dt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(je=>je.type===0).map(Tt.to)})),children:G.children.map(xe=>Se.get(xe)).filter(y.isDefined).map(xe=>pe(xe,Se))};for(const xe of Ce.children)xe.parent=Ce;return Ce};function oe(G){const Se=[],Ce=new Map;for(const xe of G.items)Ce.set(xe.item.extId,xe),G.request.targets.some(je=>je.controllerId===xe.controllerId&&je.testIds.includes(xe.item.extId))&&Se.push(xe);return{completedAt:G.completedAt,results:Se.map(xe=>pe(xe,Ce))}}me.to=oe})(Rt=e.TestResults||(e.TestResults={}));var Lt;(function(me){function pe(Ce){return{covered:Ce.covered,total:Ce.covered}}function oe(Ce){return"line"in Ce?T.from(Ce):w.from(Ce)}function G(Ce){return"branches"in Ce?{count:Ce.executionCount,location:oe(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(xe=>({count:xe.executionCount,location:xe.location&&oe(xe.location)})):void 0}:{type:0,count:Ce.executionCount,location:oe(Ce.location)}}me.fromDetailed=G;function Se(Ce){return{uri:Ce.uri,statement:pe(Ce.statementCoverage),branch:Ce.branchCoverage&&pe(Ce.branchCoverage),function:Ce.functionCoverage&&pe(Ce.functionCoverage),details:Ce.detailedCoverage?.map(G)}}me.fromFile=Se})(Lt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(me){function pe(oe){switch(oe){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}me.to=pe})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ue;(function(me){function pe(G){const Se=new u.TypeHierarchyItem(z.to(G.kind),G.name,G.detail||"",F.URI.revive(G.uri),w.to(G.range),w.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}me.to=pe;function oe(G,Se,Ce){if(Se=Se??G._sessionId,Ce=Ce??G._itemId,Se===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Ce,kind:z.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:w.from(G.range),selectionRange:w.from(G.selectionRange),tags:G.tags?.map(ae.from)}}me.from=oe})(Ue=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[168],be([1,0,2,15,7,8,228]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(F,N,p,d={timeout:1500,errors:3}){this._logService=F,this._documents=N,this._mainThreadBulkEdits=p,this._thresholds=d,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(F){return(N,p,d)=>{const l={dispose:this._callbacks.push([N,p,F])};return Array.isArray(d)&&d.push(l),l}}async $participateInSave(F,N){const p=s.URI.revive(F);let d=!1;const m=setTimeout(()=>d=!0,this._thresholds.timeout),l=[];try{for(let n of[...this._callbacks]){if(d)break;const h=this._documents.getDocument(p),S=await this._deliverEventAsyncAndBlameBadListeners(n,{document:h,reason:B.TextDocumentSaveReason.to(N)});l.push(S)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([F,N,p],d){const m=this._badListeners.get(F);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(p,F,N,d).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const n=this._badListeners.get(F);this._badListeners.set(F,n?n+1:1),typeof n=="number"&&n>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(F,N,p,d){const m=[],l=Date.now(),{document:n,reason:h}=d,{version:S}=n,k=Object.freeze({document:n,reason:h,waitUntil(u){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(u))}});try{N.apply(p,[k])}catch(u){return Promise.reject(u)}return Object.freeze(m),new Promise((u,E)=>{const w=setTimeout(()=>E(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${F.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(w),u(o)}).catch(o=>{clearTimeout(w),E(o)})}).then(u=>{const E={edits:[]};for(const w of u)if(Array.isArray(w)&&w.every(o=>o instanceof b.TextEdit))for(const{newText:o,newEol:T,range:r}of w)E.edits.push({_type:2,resource:n.uri,edit:{range:r&&B.Range.from(r),text:o,eol:T&&B.EndOfLine.from(T)}});if(E.edits.length!==0)return S===n.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(we[169],be([1,0,10,26,2,8,85]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(p,d,m,l){this.start=p,this.deletedCount=d,this.deletedItems=m,this.items=l}static asApiEvents(p){return p.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(m=>m.apiCell)}))}}class y{constructor(p,d,m){this.notebook=p,this._extHostDocument=d,this._cellData=m,this.handle=m.handle,this.uri=b.URI.revive(m.uri),this.cellKind=m.cellKind,this._outputs=m.outputs.map(B.NotebookCellOutput.to),this._internalMetadata=m.internalMetadata??{},this._metadata=Object.freeze(m.metadata??{}),this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(m.internalMetadata??{}))}static asModelAddData(p,d){return{EOL:d.eol,lines:d.source,languageId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:p}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const p=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return p.notebook.getCellIndex(p)},notebook:p.notebook.apiNotebook,kind:B.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return p._mime},set mime(m){p._mime=m},get outputs(){return p._outputs.slice(0)},get metadata(){return p._metadata},get executionSummary(){return p._previousResult}})}return this._apiCell}setOutputs(p){this._outputs=p.map(B.NotebookCellOutput.to)}setOutputItems(p,d,m){const l=m.map(B.NotebookCellOutputItem.to),n=this._outputs.find(h=>h.id===p);n&&(d||(n.items.length=0),n.items.push(...l))}setMetadata(p){this._metadata=Object.freeze(p)}setInternalMetadata(p){this._internalMetadata=p,this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(p))}setMime(p){}}e.ExtHostCell=y;class F{constructor(p,d,m,l,n,h){this._proxy=p,this._textDocumentsAndEditors=d,this._textDocuments=m,this._emitter=l,this.uri=n,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const p=this;this._notebook={get uri(){return p.uri},get version(){return p._versionId},get notebookType(){return p._notebookType},get isDirty(){return p._isDirty},get isUntitled(){return p.uri.scheme===s.Schemas.untitled},get isClosed(){return p._disposed},get metadata(){return p._metadata},get cellCount(){return p._cells.length},cellAt(d){return d=p._validateIndex(d),p._cells[d].apiCell},getCells(d){return(d?p._getCells(d):p._cells).map(l=>l.apiCell)},save(){return p._save()}}}return this._notebook}updateBackup(p){this._backup?.delete(),this._backup=p}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(p){p.metadata&&(this._metadata=Object.freeze({...this._metadata,...p.metadata}))}acceptDirty(p){this._isDirty=p}acceptModelChanged(p,d){this._versionId=p.versionId,this._isDirty=d;for(const m of p.rawEvents)m.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1):m.kind===D.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx):m.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(m.index,m.outputs):m.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems):m.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(m.index,m.language):m.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(m.index,m.mime):m.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(m.index,m.metadata):m.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(m.index,m.internalMetadata)}_validateIndex(p){return p=p|0,p<0?0:p>=this._cells.length?this._cells.length-1:p}_validateRange(p){let d=p.start|0,m=p.end|0;return d<0&&(d=0),m>this._cells.length&&(m=this._cells.length),p.with({start:d,end:m})}_getCells(p){p=this._validateRange(p);const d=[];for(let m=p.start;m<p.end;m++)d.push(this._cells[m]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(p,d){if(this._disposed)return;const m=[],l=[],n=[];p.reverse().forEach(h=>{const k=h[2].map(w=>{const o=new y(this,this._textDocumentsAndEditors,w);return d||l.push(y.asModelAddData(this.apiNotebook,w)),o}),u=new A(h[0],h[1],[],k),E=this._cells.splice(h[0],h[1],...k);for(const w of E)n.push(w.uri),u.deletedItems.push(w.apiCell);m.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:n}),d||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(m)}))}_moveCell(p,d){const m=this._cells.splice(p,1);this._cells.splice(d,0,...m);const l=[new A(p,1,m.map(n=>n.apiCell),[]),new A(d,0,[],m)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(l)}))}_setCellOutputs(p,d){const m=this._cells[p];m.setOutputs(d),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[m.apiCell]}))}_setCellOutputItems(p,d,m,l){const n=this._cells[p];n.setOutputItems(d,m,l),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[n.apiCell]}))}_changeCellLanguage(p,d){const m=this._cells[p];m.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelLanguageChanged(m.uri,d)}_changeCellMime(p,d){const m=this._cells[p];m.apiCell.mime=d}_changeCellMetadata(p,d){const m=this._cells[p],l=m.apiCell.metadata;m.setMetadata(d);const n=m.apiCell.metadata;(0,I.equals)(l,n)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:m.apiCell}))}_changeCellInternalMetadata(p,d){this._cells[p].setInternalMetadata(d)}getCellFromApiCell(p){return this._cells.find(d=>d.apiCell===p)}getCellFromIndex(p){return this._cells[p]}getCell(p){return this._cells.find(d=>d.handle===p)}getCellIndex(p){return this._cells.indexOf(p)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(we[89],be([1,0,7,8,15]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class B{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,F){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:F})}replaceCells(y,F,N){this._throwIfFinalized(),!(y===F&&N.length===0)&&this._collectedEdits.push({editType:1,index:y,count:F-y,cells:N.map(I.NotebookCellData.from)})}}class D{constructor(y,F,N,p,d,m){this.id=y,this._proxy=F,this.notebookData=N,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._visibleRanges=p,this._viewColumn=m}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(F){if(!Array.isArray(F)||!F.every(s.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");y._selections=F,y._trySetSelections(F)},get visibleRanges(){return y._visibleRanges},revealRange(F,N){y._proxy.$tryRevealRange(y.id,I.NotebookRange.from(F),N??s.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(F){const N=new B(this.document.version);return F(N),y._applyEdit(N.finalize())},setDecorations(F,N){return y.setDecorations(F,N)}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(I.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const F=[];let N=-1;for(let p=0;p<y.cellEdits.length;p++){if(N<0){F.push(y.cellEdits[p]),N++;continue}const m=F[N],l=y.cellEdits[p];if(m.editType===1&&l.editType===1&&m.index===l.index){m.cells.push(...y.cellEdits[p].cells),m.count+=y.cellEdits[p].count;continue}F.push(y.cellEdits[p]),N++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,F)}setDecorations(y,F){if(!(F.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return F.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(F),y.key)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(we[170],be([1,0,8,141,124,20,52,15]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(d){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=d}async withProgress(d,m,l){const n=this._handles++,{title:h,location:S,cancellable:k}=m,u={label:(0,b.localize)(0,null,d.displayName||d.name),id:d.identifier.value};return this._proxy.$startProgress(n,{location:s.ProgressLocation.from(S),title:h,source:u,cancellable:k},d.isUnderDevelopment?void 0:d.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(n,l,!!k)}_withProgress(d,m,l){let n;l&&(n=new B.CancellationTokenSource,this._mapHandleToCancellationSource.set(d,n));const h=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),n&&n.dispose()};let S;try{S=m(new N(this._proxy,d),l&&n?n.token:B.CancellationToken.None)}catch(k){throw h(d),k}return S.then(k=>h(d),k=>h(d)),S}$acceptProgressCanceled(d){const m=this._mapHandleToCancellationSource.get(d);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(d))}}e.ExtHostProgress=y;function F(p,d){return p.message=d.message,typeof d.increment=="number"&&(typeof p.increment=="number"?p.increment+=d.increment:p.increment=d.increment),p}class N extends I.Progress{constructor(d,m){super(l=>this.throttledReport(l));this._proxy=d,this._handle=m}throttledReport(d){this._proxy.$progressReport(this._handle,d)}}Fe([(0,D.throttle)(100,(p,d)=>F(p,d),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(we[90],be([1,0,42,15,53,8,7]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(d,m,l){const n=A._Keys.nextId();d.$registerTextEditorDecorationType(m.identifier,n,B.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:n,dispose(){d.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=A,A._Keys=new b.IdGenerator("TextEditorDecorationType");class y{constructor(d,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,m){this._throwIfFinalized();let l=null;if(d instanceof D.Position)l=new D.Range(d,d);else if(d instanceof D.Range)l=d;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(d,m){this._throwIfFinalized(),this._pushEdit(new D.Range(d,d),m,!0)}delete(d){this._throwIfFinalized();let m=null;if(d instanceof D.Range)m=d;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(d,m,l){const n=this._document.validateRange(d);this._collectedEdits.push({range:n,text:m,forceMoveMarkers:l})}setEndOfLine(d){if(this._throwIfFinalized(),d!==D.EndOfLine.LF&&d!==D.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=y;class F{constructor(d,m,l,n){this._proxy=d,this._id=m,this._accept(l),this._logService=n;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(S){h._setTabSize(S)},get insertSpaces(){return h._insertSpaces},set insertSpaces(S){h._setInsertSpaces(S)},get cursorStyle(){return h._cursorStyle},set cursorStyle(S){h._setCursorStyle(S)},get lineNumbers(){return h._lineNumbers},set lineNumbers(S){h._setLineNumbers(S)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=B.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const m=Math.floor(d);return m>0?m:null}if(typeof d=="string"){const m=parseInt(d,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(d){const m=this._validateTabSize(d);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const m=this._validateInsertSpaces(d);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:B.TextEditorLineNumbersStyle.from(d)})))}assign(d){const m={};let l=!1;if(typeof d.tabSize!="undefined"){const n=this._validateTabSize(d.tabSize);n==="auto"?(l=!0,m.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,l=!0,m.tabSize=n)}if(typeof d.insertSpaces!="undefined"){const n=this._validateInsertSpaces(d.insertSpaces);n==="auto"?(l=!0,m.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,l=!0,m.insertSpaces=n)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,l=!0,m.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,l=!0,m.lineNumbers=B.TextEditorLineNumbersStyle.from(d.lineNumbers)),l&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,m))}_warnOnError(d,m){m.catch(l=>{this._logService.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this._logService.warn(l)})}}e.ExtHostTextEditorOptions=F;class N{constructor(d,m,l,n,h,S,k,u){this.id=d,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new F(this._proxy,this.id,S,l),this._visibleRanges=k,this._viewColumn=u;const E=this;this.value=Object.freeze({get document(){return n.getValue()},set document(w){throw(0,I.readonly)("document")},get selection(){return E._selections&&E._selections[0]},set selection(w){if(!(w instanceof D.Selection))throw(0,I.illegalArgument)("selection");E._selections=[w],E._trySetSelection()},get selections(){return E._selections},set selections(w){if(!Array.isArray(w)||w.some(o=>!(o instanceof D.Selection)))throw(0,I.illegalArgument)("selections");E._selections=w,E._trySetSelection()},get visibleRanges(){return E._visibleRanges},set visibleRanges(w){throw(0,I.readonly)("visibleRanges")},get options(){return E._options.value},set options(w){E._disposed||E._options.assign(w)},get viewColumn(){return E._viewColumn},set viewColumn(w){throw(0,I.readonly)("viewColumn")},edit(w,o={undoStopBefore:!0,undoStopAfter:!0}){if(E._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const T=new y(n.getValue(),o);return w(T),E._applyEdit(T)},insertSnippet(w,o,T={undoStopBefore:!0,undoStopAfter:!0}){if(E._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=E._selections.map(i=>B.Range.from(i));else if(o instanceof D.Position){const{lineNumber:i,column:c}=B.Position.from(o);r=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(o instanceof D.Range)r=[B.Range.from(o)];else{r=[];for(const i of o)if(i instanceof D.Range)r.push(B.Range.from(i));else{const{lineNumber:c,column:t}=B.Position.from(i);r.push({startLineNumber:c,startColumn:t,endLineNumber:c,endColumn:t})}}return m.$tryInsertSnippet(d,w.value,r,T)},setDecorations(w,o){const T=o.length===0;T&&!E._hasDecorationsForKey.has(w.key)||(T?E._hasDecorationsForKey.delete(w.key):E._hasDecorationsForKey.add(w.key),E._runOnProxy(()=>{if(B.isDecorationOptionsArr(o))return m.$trySetDecorations(d,w.key,B.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let i=0,c=o.length;i<c;i++){const t=o[i];r[4*i]=t.start.line+1,r[4*i+1]=t.start.character+1,r[4*i+2]=t.end.line+1,r[4*i+3]=t.end.character+1}return m.$trySetDecorationsFast(d,w.key,r)}}))},revealRange(w,o){E._runOnProxy(()=>m.$tryRevealRange(d,B.Range.from(w),o||D.TextEditorRevealType.Default))},show(w){m.$tryShowEditor(d,B.ViewColumn.from(w))},hide(){m.$tryHideEditor(d)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,s.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,s.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,s.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,s.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(B.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const m=d.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(h=>h.range);l.sort((h,S)=>h.end.line===S.end.line?h.end.character===S.end.character?h.start.line===S.start.line?h.start.character-S.start.character:h.start.line-S.start.line:h.end.character-S.end.character:h.end.line-S.end.line);for(let h=0,S=l.length-1;h<S;h++){const k=l[h].end;if(l[h+1].start.isBefore(k))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=m.edits.map(h=>({range:B.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,n,{setEndOfLine:typeof m.setEndOfLine=="number"?B.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=N}),define(we[171],be([1,0,13,5,6,11,47,8,62,63,48]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class p extends b.Disposable{constructor(m){super();this.controllerId=m,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.root=new D.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(m){this._resolveHandler=m;for(const l of this.tree.values())this.updateExpandability(l)}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){const l=this.diff[this.diff.length-1];if(l&&m.op===1){if(l.op===1&&l.item.extId===m.item.extId){(0,y.applyTestItemUpdate)(l.item,m.item);return}if(l.op===0&&l.item.item.extId===m.item.extId){(0,y.applyTestItemUpdate)(l.item,m.item);return}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,l){const n=this.tree.get(m);if(!!n){if((n.expandLevels===void 0||l>n.expandLevels)&&(n.expandLevels=l),n.expand===1){const h=this.resolveChildren(n);return h.isOpen()?this.expandChildren(n,l-1):h.wait().then(()=>this.expandChildren(n,l-1))}else if(n.expand===3)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.expandChildren(n,l-1)):this.expandChildren(n,l-1)}}dispose(){for(const m of this.tree.values())(0,D.getPrivateApiFor)(m.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(m,l){switch(l.op){case 2:this.pushDiff({op:4,itemId:m.fullId.toString()});break;case 1:this.removeItem(F.TestId.joinToString(m.fullId,l.id));break;case 0:this.upsertItem(l.item,m);break;case 4:for(const n of l.ops)this.onTestItemEvent(m,n);break;case 3:{const{key:n,value:h,previous:S}=l,k=m.fullId.toString();switch(n){case"canResolveChildren":this.updateExpandability(m);break;case"tags":this.diffTagRefs(h,S,k);break;case"range":this.pushDiff({op:1,item:{extId:k,item:{range:N.Range.lift(A.Range.from(h))}}});break;case"error":this.pushDiff({op:1,item:{extId:k,item:{error:A.MarkdownString.fromStrict(h)||null}}});break;default:this.pushDiff({op:1,item:{extId:k,item:{[n]:h??null}}});break}break}default:(0,B.assertNever)(l)}}upsertItem(m,l){if(!(m instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${m.id} did not`);const n=F.TestId.fromExtHostTestItem(m,this.root.id,l?.actual),h=(0,D.getPrivateApiFor)(m);h.parent&&h.parent!==l?.actual&&h.parent.children.delete(m.id);let S=this.tree.get(n.toString());if(!S){S={fullId:n,actual:m,parent:l?n.parentId:null,expandLevels:l?.expandLevels?l.expandLevels-1:void 0,expand:0},m.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(m,l),this.pushDiff({op:0,item:{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:A.TestItem.from(m)}}),this.connectItemAndChildren(m,S,l);return}if(S.actual===m){this.connectItem(m,S,l);return}const k=S.actual.children,u=S.actual,E=(0,D.diffTestItems)(u,m);(0,D.getPrivateApiFor)(u).listener=void 0,S.actual=m,S.expand=0;for(const[w,o]of E)this.onTestItemEvent(S,{op:3,key:w,value:o,previous:u[w]});this.connectItemAndChildren(m,S,l);for(const w of k)m.children.get(w.id)||this.removeItem(F.TestId.joinToString(n,w.id))}diffTagRefs(m,l,n){const h=new Set(l.map(S=>S.id));for(const S of m)h.delete(S.id)||this.incrementTagRefs(S);this.pushDiff({op:1,item:{extId:n,item:{tags:m.map(S=>A.TestTag.namespace(this.controllerId,S.id))}}}),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(m){const l=this.tags.get(m.id);l?l.refCount++:(this.tags.set(m.id,{refCount:1}),this.pushDiff({op:5,tag:{id:A.TestTag.namespace(this.controllerId,m.id),ctrlLabel:this.root.label}}))}decrementTagRefs(m){const l=this.tags.get(m);l&&!--l.refCount&&(this.tags.delete(m),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.controllerId,m)}))}setItemParent(m,l){(0,D.getPrivateApiFor)(m).parent=l&&l.actual!==this.root?l.actual:void 0}connectItem(m,l,n){this.setItemParent(m,n);const h=(0,D.getPrivateApiFor)(m);h.parent=n?.actual,h.listener=S=>this.onTestItemEvent(l,S),this.updateExpandability(l)}connectItemAndChildren(m,l,n){this.connectItem(m,l,n);for(const h of m.children)this.upsertItem(h,l)}updateExpandability(m){let l;this._resolveHandler?m.resolveBarrier?l=m.resolveBarrier.isOpen()?3:2:l=m.actual.canResolveChildren?1:0:l=0,l!==m.expand&&(m.expand=l,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:l}}),l===1&&m.expandLevels!==void 0&&this.resolveChildren(m))}expandChildren(m,l){if(l<0)return;const n=[];for(const h of m.actual.children){const S=this.expand(F.TestId.joinToString(m.fullId,h.id),l);(0,s.isThenable)(S)&&n.push(S)}if(n.length)return Promise.all(n).then(()=>{})}resolveChildren(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this._resolveHandler){const S=new s.Barrier;return S.open(),S}m.expand=2,this.pushExpandStateUpdate(m);const l=m.resolveBarrier=new s.Barrier,n=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),m.actual!==this.root&&(m.actual.error=S.stack||S.message||String(S))};let h;try{h=this._resolveHandler(m.actual===this.root?void 0:m.actual)}catch(S){n(S)}return(0,s.isThenable)(h)?h.catch(n).then(()=>{l.open(),this.updateExpandability(m)}):(l.open(),this.updateExpandability(m)),m.resolveBarrier}pushExpandStateUpdate(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}removeItem(m){const l=this.tree.get(m);if(!l)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:m});const n=[l];for(;n.length;){const h=n.pop();if(!!h){(0,D.getPrivateApiFor)(h.actual).listener=void 0;for(const S of h.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(h.fullId.toString());for(const S of h.actual.children)n.push(this.tree.get(F.TestId.joinToString(h.fullId,S.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.diffOpEmitter.fire(m)}}e.SingleUseTestCollection=p}),define(we[172],be([1,0,3,138]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(I.IEnvironmentService)}),define(we[173],be([1,0,25,5,17]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class B{constructor(N){this.removedDueToLooping=N}}e.DeltaExtensionsResult=B;class D{constructor(N){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=N,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const N of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(N.identifier))){console.error("Extension `"+N.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(N.identifier),N),this._extensionsArr.push(N),Array.isArray(N.activationEvents))for(let p of N.activationEvents)p==="onUri"&&(p=`onUri:${s.ExtensionIdentifier.toKey(N.identifier)}`),this._activationMap.has(p)||this._activationMap.set(p,[]),this._activationMap.get(p).push(N)}}keepOnly(N){const p=new Set;N.forEach(d=>p.add(s.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>p.has(s.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(N,p){N.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(N));const d=D._findLoopingExtensions(this._extensionDescriptions);if(p=p.concat(d.map(m=>m.identifier)),p.length>0){const m=new Set;p.forEach(l=>m.add(s.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(s.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new B(d)}static _findLoopingExtensions(N){const p=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,S){this.addNode(h),this.addNode(S),this._arcs.has(h)?this._arcs.get(h).push(S):this._arcs.set(h,[S])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,S){const k=p.getArcs(h);for(let u=0;u<k.length;u++)if(!S.has(k[u]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let h of N){const S=s.ExtensionIdentifier.toKey(h.identifier);if(d.set(S,h),h.extensionDependencies)for(let k of h.extensionDependencies){const u=s.ExtensionIdentifier.toKey(k);p.addArc(S,u)}}let m=new Set;p.getNodes().filter(h=>p.getArcs(h).length===0).forEach(h=>m.add(h));let l=p.getNodes().filter(h=>!m.has(h)),n;do{n=!1;for(let h=0;h<l.length;h++){const S=l[h];p.hasOnlyGoodArcs(S,m)&&(l.splice(h,1),h--,m.add(S),n=!0)}}while(n);return l.map(h=>d.get(h))}containsActivationEvent(N){return this._activationMap.has(N)}containsExtension(N){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(N))}getExtensionDescriptionsForActivationEvent(N){const p=this._activationMap.get(N);return p?p.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(N){const p=this._extensionsMap.get(s.ExtensionIdentifier.toKey(N));return p||void 0}}e.ExtensionDescriptionRegistry=D;var A;(function(F){F[F.Builtin=0]="Builtin",F[F.User=1]="User",F[F.Dev=2]="Dev"})(A||(A={}));function y(F,N){const p=F.isBuiltin?0:F.isUnderDevelopment?2:1,d=N.isBuiltin?0:N.isUnderDevelopment?2:1;if(p!==d)return p-d;const m=b.posix.basename(F.extensionLocation.path),l=b.posix.basename(N.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(we[91],be([1,0,21]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var b;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var B;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(B=e.MessageType||(e.MessageType={}));function D(y){const F=s.VSBuffer.alloc(1);switch(y){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}e.createMessageOfType=D;function A(y,F){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}e.isMessageOfType=A}),define(we[28],be([1,0,5,2,3,25,144]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new B.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var A;(function(E){E[E.None=0]="None",E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(E){switch(E){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class F{constructor(w){this.dependency=w}}e.MissingExtensionDependency=F;var N;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(N=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(E){switch(E){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=p;function d(E,w){return E.enabledApiProposals?E.enabledApiProposals.includes(w):!1}e.isProposedApiEnabled=d;function m(E,w){if(!d(E,w))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${w}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${w}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.checkProposedApiEnabled=m;class l{constructor(w,o,T,r){this.codeLoadingTime=w,this.activateCallTime=o,this.activateResolvedTime=T,this.activationReason=r}}e.ActivationTimes=l;class n{constructor(w,o){this.description=w,this.value=o}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var h;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function S(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=S;function k(E,w){return{identifier:new B.ExtensionIdentifier((0,D.getExtensionId)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!w,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=k;class u{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(w){return Promise.resolve(void 0)}activationEventIsDone(w){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,o){return Promise.resolve()}}e.NullExtensionService=u}),define(we[174],be([1,0,15,25,28,12]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class A{constructor(n,h,S,k){this.startup=n,this.codeLoadingTime=h,this.activateCallTime=S,this.activateResolvedTime=k}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(n){this._startup=n,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(n,h){return n===-1||h===-1?-1:h-n}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class F{constructor(n,h,S,k,u,E){this.activationFailed=n,this.activationFailedError=h,this.activationTimes=S,this.module=k,this.exports=u,this.subscriptions=E}}e.ActivatedExtension=F;class N extends F{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class p extends F{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=p;class d extends F{constructor(n){super(!0,n,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=d;let m=class{constructor(n,h,S,k,u){this._logService=u,this._isDisposed=!1,this._registry=n,this._resolvedExtensionsSet=new Set,h.forEach(E=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(E))),this._hostExtensionsMap=new Map,S.forEach(E=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(E),E)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(n){const h=I.ExtensionIdentifier.toKey(n);return this._activatedExtensions.has(h)}getActivatedExtension(n){const h=I.ExtensionIdentifier.toKey(n),S=this._activatedExtensions.get(h);if(!S)throw new Error("Extension `"+n.value+"` is not known or not activated");return S}activateByEvent(n,h){if(this._alreadyActivatedEvents[n])return D;const S=this._registry.getExtensionDescriptionsForActivationEvent(n);return this._activateExtensions(S.map(k=>({id:k.identifier,reason:{startup:h,extensionId:k.identifier,activationEvent:n}}))).then(()=>{this._alreadyActivatedEvents[n]=!0})}activateById(n,h){const S=this._registry.getExtensionDescription(n);if(!S)throw new Error("Extension `"+n+"` is not known");return this._activateExtensions([{id:S.identifier,reason:h}])}_handleActivateRequest(n,h,S){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n.id))){h[I.ExtensionIdentifier.toKey(n.id)]=n;return}const k=this._registry.getExtensionDescription(n.id);if(!k){const w=new Error(`Cannot activate unknown extension '${n.id.value}'`);this._host.onExtensionActivationError(n.id,w,new b.MissingExtensionDependency(n.id.value)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(n.id),new d(w));return}const u=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let E=!0;for(let w=0,o=u.length;w<o;w++){const T=u[w];if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(T)))continue;const r=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(T));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const a=k.displayName||k.identifier.value,g=this._registry.getExtensionDescription(T),f=g&&g.displayName||T,_=new Error(`Cannot activate the '${a}' extension because its dependency '${f}' failed to activate`);_.detail=r.activationFailedError,this._host.onExtensionActivationError(k.identifier,_,null),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(k.identifier),new d(_));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(T))){E=!1,h[I.ExtensionIdentifier.toKey(T)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(T)),reason:n.reason};continue}const i=this._registry.getExtensionDescription(T);if(i){if(!i.main&&!i.browser)continue;E=!1,h[I.ExtensionIdentifier.toKey(T)]={id:i.identifier,reason:n.reason};continue}const c=k.displayName||k.identifier.value,t=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${T}'`);this._host.onExtensionActivationError(k.identifier,t,new b.MissingExtensionDependency(T)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(k.identifier),new d(t));return}E?h[I.ExtensionIdentifier.toKey(k.identifier)]=n:S.push(n)}_activateExtensions(n){if(n.length===0||(n=n.filter(u=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(u.id))),n.length===0))return Promise.resolve(void 0);const h=Object.create(null),S=[];for(let u=0,E=n.length;u<E;u++)this._handleActivateRequest(n[u],h,S);for(let u=0,E=S.length;u<E;u++){const w=I.ExtensionIdentifier.toKey(S[u].id);h[w]&&delete h[w]}const k=Object.keys(h).map(u=>h[u]);return S.length===0?Promise.all(k.map(u=>this._activateExtension(u.id,u.reason))).then(u=>{}):this._activateExtensions(k).then(u=>this._activateExtensions(S))}_activateExtension(n,h){const S=I.ExtensionIdentifier.toKey(n);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const k=this._activatingExtensions.get(S);if(k)return k;const u=this._host.actualActivateExtension(n,h).then(void 0,E=>{const w=new Error;return E&&E.name&&(w.name=E.name),E&&E.message?w.message=`Activating extension '${n.value}' failed: ${E.message}.`:w.message=`Activating extension '${n.value}' failed: ${E}.`,E&&E.stack&&(w.stack=E.stack),this._isDisposed&&s.isCancellationError(E)?new d(E):(this._host.onExtensionActivationError(n,w,null),this._logService.error(`Activating extension ${n.value} failed due to an error:`),this._logService.error(E),new d(E))}).then(E=>{this._activatedExtensions.set(S,E),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,u),u}};m=Fe([Ne(4,B.ILogService)],m),e.ExtensionsActivator=m}),define(we[175],be([1,0,12,27,28]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let B=class extends s.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:b.ExtensionHostLogFileName}))}};B=Fe([Ne(0,s.ILoggerService),Ne(1,I.IExtHostInitDataService)],B),e.ExtHostLogService=B}),define(we[176],be([1,0,15]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((B,D)=>{this._actualOk=B,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(B){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=B,this._actual&&this._actualOk(B))}resolveErr(B){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=B,this._actual?this._actualErr(B):(0,s.onUnexpectedError)(B))}then(B,D){return this._ensureActual().then(B,D)}catch(B){return this._ensureActual().then(void 0,B)}finally(B){return this._ensureActual().finally(B)}}e.LazyPromise=I}),define(we[38],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const I=[];function b(A){const y=new s(A);return I[y.nid]=y,y}e.createProxyIdentifier=b;function B(A){return I[A].sid}e.getStringIdentifierForProxy=B;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(we[4],be([1,0,54,2,38]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var B;(function(k){k[k.Default=0]="Default",k[k.InCenter=1]="InCenter",k[k.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",k[k.AtTop=3]="AtTop"})(B=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(k){k[k.Singular=0]="Singular",k[k.Diff=1]="Diff",k[k.SidebySide=2]="SidebySide",k[k.Other=3]="Other"})(D=e.TabKind||(e.TabKind={}));var A;(function(k){k[k.Editable=0]="Editable",k[k.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(k){k[k.Int8Array=1]="Int8Array",k[k.Uint8Array=2]="Uint8Array",k[k.Uint8ClampedArray=3]="Uint8ClampedArray",k[k.Int16Array=4]="Int16Array",k[k.Uint16Array=5]="Uint16Array",k[k.Int32Array=6]="Int32Array",k[k.Uint32Array=7]="Uint32Array",k[k.Float32Array=8]="Float32Array",k[k.Float64Array=9]="Float64Array",k[k.BigInt64Array=10]="BigInt64Array",k[k.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var F;(function(k){k[k.Text=1]="Text",k[k.Error=2]="Error",k[k.Rich=3]="Rich"})(F=e.CellOutputKind||(e.CellOutputKind={}));var N;(function(k){k[k.Default=0]="Default",k[k.InCenter=1]="InCenter",k[k.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",k[k.AtTop=3]="AtTop"})(N=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var p;(function(k){k[k.None=0]="None",k[k.Process=1]="Process",k[k.Output=2]="Output"})(p=e.CandidatePortSource||(e.CandidatePortSource={}));class d{static mixin(u){return u._id=d._n++,u}}e.IdObject=d,d._n=0;var m;(function(k){k.label="a",k.kind="b",k.detail="c",k.documentation="d",k.sortText="e",k.filterText="f",k.preselect="g",k.insertText="h",k.insertTextRules="i",k.range="j",k.commitCharacters="k",k.additionalTextEdits="l",k.command="m",k.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(k){k.defaultRanges="a",k.completions="b",k.isIncomplete="c",k.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var n;(function(k){k[k.File=1]="File",k[k.Text=2]="Text",k[k.Cell=3]="Cell"})(n=e.WorkspaceEditType||(e.WorkspaceEditType={}));function h(k){if(k&&k.edits)for(const u of k.edits)typeof u.resource=="object"?u.resource=I.URI.revive(u.resource):(u.newUri=I.URI.revive(u.newUri),u.oldUri=I.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,s.revive)(u.metadata));return k}e.reviveWorkspaceEditDto=h;var S;(function(k){k[k.Workspace=0]="Workspace",k[k.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createProxyIdentifier)("ExtHostTelemetry")}}),define(we[64],be([1,0,4,5,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class B{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,F){return this._proxy.$setPassword(A,y,F)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=B,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(we[65],be([1,0,3,12,4,14]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,F){this._extHostLogService=F,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(b.MainContext.MainThreadTelemetry)}report(y,F,N){const p=this.getUsageKey(y,F);this._reportedUsages.has(p)||(this._reportedUsages.add(p),F.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:F.identifier.value,apiId:y}))}getUsageKey(y,F){return`${y}-${F.identifier.value}`}};D=Fe([Ne(0,B.IExtHostRpcService),Ne(1,I.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,F){}})}),define(we[177],be([1,0,5,4,7,25]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,F,N,p={}){const d=B.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(d)||[],l=[...N].sort().join(" ");let n=m.find(h=>h.scopes===l);if(n)return n.result;{const h=this._getSession(y,d,F,N,p);n={scopes:l,result:h},m.push(n),this._inFlightRequests.set(d,m);try{await h}finally{const S=m.findIndex(k=>k.scopes===l);S>-1&&(m.splice(S),this._inFlightRequests.set(d,m))}return h}}async _getSession(y,F,N,p,d={}){await this._proxy.$ensureProvider(N);const m=y.displayName||y.name;return this._proxy.$getSession(N,p,F,m,d)}async removeSession(y,F){const N=this._authenticationProviders.get(y);return N?N.provider.removeSession(F):this._proxy.$removeSession(y,F)}registerAuthenticationProvider(y,F,N,p){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:F,provider:N,options:p??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===y)||this._providers.push({id:y,label:F});const d=N.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(y,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,F,p?.supportsMultipleAccounts??!1),new b.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(y);const m=this._providers.findIndex(l=>l.id===y);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,F){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.createSession(F));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,F){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.removeSession(F));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,F){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.getSessions(F));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,F){return this._onDidChangeSessions.fire({provider:{id:y,label:F}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(we[178],be([1,0,4,14,8]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let B=class{constructor(A,y){this._proxy=A.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:F=>y.getDocument(F)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A){const y=b.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(y)}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostBulkEdits=B}),define(we[179],be([1,0,4]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(B){const D=B.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(A){return D.$writeText(A)}})}}e.ExtHostClipboard=I});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[39],be([1,0,11,7,8,26,4,16,12,54,48,229,2,6,3,14,47,21,38,43]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,a){E.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ve(this,E,t.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new o(this,g=>{const f=this._apiCommands.get(g);return f?.result===r.Void?f:void 0},a),this._argumentProcessors=[{processArgument(g){return(0,F.revive)(g)}},{processArgument(g){return(0,B.cloneAndChange)(g,function(f){if(N.Range.isIRange(f))return b.Range.to(f);if(p.Position.isIPosition(f))return b.Position.to(f);if(N.Range.isIRange(f.range)&&d.URI.isUri(f.uri))return b.location.to(f);if(f instanceof S.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const a=this.registerCommand(!1,t.id,async(...g)=>{const f=t.args.map((P,$)=>{if(!P.validate(g[$]))throw new Error(`Invalid argument '${P.name}' when running '${t.id}', received: ${g[$]}`);return P.convert(g[$])}),_=await this.executeCommand(t.internalId,...f);return t.result.convert(_,g,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{a.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,a,g,f,_,P){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:g,thisArg:f,description:_,extension:P}),t&&ye(this,E,"f").$registerCommand(a),new I.Disposable(()=>{this._commands.delete(a)&&t&&ye(this,E,"f").$unregisterCommand(a)})}executeCommand(t,...a){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,a,!0)}async _doExecuteCommand(t,a,g){if(this._commands.has(t))return this._executeContributedCommand(t,a,!1);{let f=!1;const _=(0,B.cloneAndChange)(a,function(P){if(P instanceof I.Position)return b.Position.from(P);if(P instanceof I.Range)return b.Range.from(P);if(P instanceof I.Location)return b.location.from(P);if(I.NotebookRange.isNotebookRange(P))return b.NotebookRange.from(P);if(P instanceof ArrayBuffer)return f=!0,S.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return f=!0,S.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await ye(this,E,"f").$executeCommand(t,f?new k.SerializableObjectWithBuffers(_):_,g);return(0,F.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(t,a,!1);throw P}}}async _executeContributedCommand(t,a,g){const f=this._commands.get(t);if(!f)throw new Error("Unknown command");let{callback:_,thisArg:P,description:$}=f;if($)for(let L=0;L<$.args.length;L++)try{(0,s.validateConstraint)(a[L],$.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${$.args[L].name}' - ${$.args[L].description}`)}try{return await _.apply(P,a)}catch(L){if(t===this.converter.delegatingCommandId){const v=this.converter.getActualCommand(...a);v&&(t=v.command)}throw this._logService.error(L,t,f.extension?.identifier),g?new class extends Error{constructor(){super((0,u.toErrorMessage)(L));this.id=t,this.source=f.extension?.displayName??f.extension?.name}}:L}}$executeContributedCommand(t,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(a=a.map(g=>this._argumentProcessors.reduce((f,_)=>_.processArgument(f),g)),this._executeContributedCommand(t,a,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),ye(this,E,"f").$getCommands().then(a=>(t&&(a=a.filter(g=>g[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[a,g]of this._commands){let{description:f}=g;f&&(t[a]=f)}return Promise.resolve(t)}};E=new WeakMap,w=Fe([Ne(0,n.IExtHostRpcService),Ne(1,y.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class o{constructor(t,a,g){this._commands=t,this._lookupApiCommand=a,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,a){if(!t)return;const g={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return g;const f=this._lookupApiCommand(t.command);if(f)g.id=f.internalId,g.arguments=f.args.map((_,P)=>_.convert(t.arguments&&t.arguments[P]));else if((0,A.isNonEmptyArray)(t.arguments)){const _=++this._cachIdPool;this._cache.set(_,t),a.add((0,m.toDisposable)(()=>{this._cache.delete(_),this._logService.trace("CommandsConverter#DISPOSE",_)})),g.$ident=_,g.id=this.delegatingCommandId,g.arguments=[_],this._logService.trace("CommandsConverter#CREATE",t.command,_)}return g}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const a=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class T{constructor(t,a,g,f){this.name=t,this.description=a,this.validate=g,this.convert=f}optional(){return new T(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,a){return new T(t??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=T,T.Uri=new T("uri","Uri of a text document",c=>d.URI.isUri(c),c=>c),T.Position=new T("position","A position in a text document",c=>I.Position.isPosition(c),b.Position.from),T.Range=new T("range","A range in a text document",c=>I.Range.isRange(c),b.Range.from),T.Selection=new T("selection","A selection in a text document",c=>I.Selection.isSelection(c),b.Selection.from),T.Number=new T("number","",c=>typeof c=="number",c=>c),T.String=new T("string","",c=>typeof c=="string",c=>c),T.CallHierarchyItem=new T("item","A call hierarchy item",c=>c instanceof I.CallHierarchyItem,b.CallHierarchyItem.from),T.TypeHierarchyItem=new T("item","A type hierarchy item",c=>c instanceof I.TypeHierarchyItem,b.TypeHierarchyItem.from),T.TestItem=new T("testItem","A VS Code TestItem",c=>c instanceof h.TestItemImpl,b.TestItem.from);class r{constructor(t,a){this.description=t,this.convert=a}}e.ApiCommandResult=r,r.Void=new r("no result",c=>c);class i{constructor(t,a,g,f,_){this.id=t,this.internalId=a,this.description=g,this.args=f,this.result=_}}e.ApiCommand=i}),define(we[180],be([1,0,2,8,7,88,39,16,75,79,10]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const p=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",m(I.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,A.isFalsyOrEmpty)(n))return;class S extends b.SymbolInformation{static to(u){const E=new S(u.name,I.SymbolKind.to(u.kind),u.containerName||"",new b.Location(h[0],I.Range.to(u.range)));return E.detail=u.detail,E.range=E.location.range,E.selectionRange=I.Range.to(u.selectionRange),E.children=u.children?u.children.map(S.to):[],E}}return n.map(S.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new D.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(I.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",m(I.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",m(I.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>b.Position.isPosition(h)),n=>n.map(I.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let S;for(const k of h.reverse())S=new b.SelectionRange(I.Range.to(k),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(I.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:I.Range.to(n.range),placeholder:n.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return I.WorkspaceEdit.to(n)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(I.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new b.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,y.decodeSemanticTokensDto)(n);if(h.type==="full")return new b.SemanticTokens(h.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new b.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,y.decodeSemanticTokensDto)(n);if(h.type==="full")return new b.SemanticTokens(h.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,S)=>{if(!n)return new b.CompletionList([]);const k=n.suggestions.map(u=>I.CompletionItem.to(u,S));return new b.CompletionList(k,n.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return I.SignatureHelp.to(n)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,S)=>m(k=>new b.CodeLens(I.Range.to(k.range),k.command&&S.fromInternal(k.command)))(n))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>b.Range.isRange(n),n=>b.Selection.isSelection(n)?I.Selection.from(n):I.Range.from(n)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,S)=>m(k=>{if(k._isSynthetic){if(!k.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(k.command)}else{const u=new b.CodeAction(k.title,k.kind?new b.CodeActionKind(k.kind):void 0);return k.edit&&(u.edit=I.WorkspaceEdit.to(k.edit)),k.command&&(u.command=S.fromInternal(k.command)),u.isPreferred=k.isPreferred,u}})(n))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new b.ColorInformation(I.Range.to(h.range),I.Color.to(h.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",n=>n instanceof b.Color,I.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:I.Range.from(n.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(I.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,h,S)=>n.map(I.InlayHint.to.bind(void 0,S)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",m(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>I.NotebookExclusiveDocumentPattern.to(h))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(I.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>s.URI.isUri(n)||typeof n=="string"&&(0,F.matchesSomeScheme)(n,N.Schemas.http,N.Schemas.https),n=>n),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class d{static register(h){p.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=d;function m(n){return h=>{if(Array.isArray(h))return h.map(n)}}function l(n){if(!Array.isArray(n))return;const h=[];for(const S of n)B.isLocationLink(S)?h.push(I.DefinitionLink.to(S)):h.push(I.location.to(S));return h}}),define(we[181],be([1,0,13,52,5,6,2,88,25,8,7,4]),function(Z,e,s,I,b,B,D,A,y,F,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function d(m,l,n){const h=m.getProxy(p.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.commentThreadHandle);return t||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.thread.commentThreadHandle);return t?{thread:t,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let a=i.commentUniqueId,g=t.getCommentByUniqueId(a);return g||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let a=i.text,g=i.commentUniqueId,f=t.getCommentByUniqueId(g);return f?(f.body=a,f):i}return i}})}createCommentController(i,c,t){const a=S.handlePool++,g=new u(i,a,c,t);this._commentControllers.set(g.handle,g);const f=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return f.push(g),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),f),g.value}$createCommentThreadTemplate(i,c,t){const a=this._commentControllers.get(i);!a||a.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(i,c,t){const a=this._commentControllers.get(i);!a||a.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(i,c){const t=this._commentControllers.get(i);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(i,c,t){const a=this._commentControllers.get(i);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const g=n.getDocument(D.URI.revive(c));return(0,s.asPromise)(()=>a.commentingRangeProvider.provideCommentingRanges(g,t)).then(f=>f?f.map(_=>F.Range.from(_)):void 0)}$toggleReaction(i,c,t,a,g){const f=this._commentControllers.get(i);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const _=f.getCommentThread(c);if(_){const P=_.getCommentByUniqueId(a.uniqueIdInThread);if(f!==void 0&&P&&f.reactionHandler)return f.reactionHandler(P,o(g))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class k{constructor(i,c,t,a,g,f,_){this._commentControllerHandle=c,this._id=t,this._uri=a,this._range=g,this._comments=f,this.extensionDescription=_,this.handle=k._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputDisposables.value=new B.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),h.$createCommentThread(c,this.handle,this._id,this._uri,F.Range.from(this._range),_.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(c,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range($){P.range=$},get comments(){return P.comments},set comments($){P.comments=$},get collapsibleState(){return P.collapsibleState},set collapsibleState($){P.collapsibleState=$},get canReply(){return P.canReply},set canReply($){P.canReply=$},get contextValue(){return P.contextValue},set contextValue($){P.contextValue=$},get label(){return P.label},set label($){P.label=$},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new B.DisposableStore);const i=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};i("range")&&(c.range=F.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue??null),i("comments")&&(c.comments=this._comments.map(t=>E(this,t,this._commentsMap))),i("collapsibleState")&&(c.collapseState=T(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let t=c[0],a=c[1];if(i===a)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}k._handlePool=0,Fe([(0,I.debounce)(100)],k.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(i,c,t,a){this._extension=i,this._handle=c,this._id=t,this._label=a,this._threads=new Map,h.$registerCommentController(this.handle,t,a);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(f){g.options=f},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(f){g.commentingRangeProvider=f},get reactionHandler(){return g.reactionHandler},set reactionHandler(f){g.reactionHandler=f},createCommentThread(f,_,P){return g.createCommentThread(f,_,P).value},dispose:()=>{g.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,t,a){if(typeof i=="string"){const g=new k(this.id,this.handle,i,c,t,a,this._extension);return this._threads.set(g.handle,g),g}else{const g=new k(this.id,this.handle,void 0,i,c,t,this._extension);return this._threads.set(g.handle,g),g}}$createCommentThreadTemplate(i,c){const t=new k(this.id,this.handle,void 0,D.URI.revive(i),F.Range.to(c),[],this._extension);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(i,c){let t=this._threads.get(i);t&&(t.range=F.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function E(r,i,c){let t=c.get(i);t||(t=++r.commentHandle,c.set(i,t));const a=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:t,body:typeof i.body=="string"?i.body:F.MarkdownString.from(i.body),userName:i.author.name,userIconPath:a,label:i.label,commentReactions:i.reactions?i.reactions.map(g=>w(g)):void 0,timestamp:i.timestamp?.toJSON()}}function w(r){return{label:r.label,iconPath:r.iconPath?F.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function o(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function T(r){if(r!==void 0)switch(r){case N.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=d}),define(we[92],be([1,0,2,4,7,3,14,12,16,9,17]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let p=class wi{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const n=wi._handlePool++;this._provider.set(n,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(n,l.value);const h=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(n,null);return}let k=(0,y.asArray)(S);if(k.length<=wi._maxEventSize){this._proxy.$onDidChange(n,k);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,k.length);const u=k.map(o=>({uri:o,rank:(0,F.count)(o.path,"/")})),E=(0,y.groupBy)(u,(o,T)=>o.rank-T.rank||(0,F.compare)(o.uri.path,T.uri.path));let w=[];e:for(let o of E){let T;for(let r of o){let i=(0,N.dirname)(r.uri.path);if(T!==i&&(T=i,w.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(n,w)});return new b.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(m,l,n){if(!this._provider.has(m))return Object.create(null);const h=Object.create(null),{provider:S,extensionId:k}=this._provider.get(m);return await Promise.all(l.map(async u=>{try{const{uri:E,id:w}=u,o=await Promise.resolve(S.provideFileDecoration(s.URI.revive(E),n));if(!o)return;try{b.FileDecoration.validate(o),h[w]=[o.propagate,o.tooltip,o.badge,o.color]}catch(T){this._logService.warn(`INVALID decoration from extension '${k.value}': ${T}`)}}catch(E){this._logService.error(E)}})),h}};p._handlePool=0,p._maxEventSize=250,p=Fe([Ne(0,D.IExtHostRpcService),Ne(1,A.ILogService)],p),e.ExtHostDecorations=p,e.IExtHostDecorations=(0,B.createDecorator)("IExtHostDecorations")});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[182],be([1,0,122,78,2,4,7,8,5,12,22,30]),function(Z,e,s,I,b,B,D,A,y,F,N,p){"use strict";var d,m,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class n{constructor(k,u,E,w,o,T){this._name=k,this._owner=u,this._maxDiagnosticsPerFile=E,d.set(this,void 0),m.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Ve(this,l,new N.ResourceMap(r=>w.getComparisonKey(r)),"f"),Ve(this,d,o,"f"),Ve(this,m,T,"f")}dispose(){this._isDisposed||(ye(this,m,"f").fire([...ye(this,l,"f").keys()]),ye(this,d,"f")&&ye(this,d,"f").$clear(this._owner),ye(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(k,u){if(!k){this.clear();return}this._checkDisposed();let E=[];if(b.URI.isUri(k)){if(!u){this.delete(k);return}ye(this,l,"f").set(k,u.slice()),E=[k]}else if(Array.isArray(k)){E=[];let o;k=[...k].sort(n._compareIndexedTuplesByUri);for(const T of k){const[r,i]=T;if((!o||r.toString()!==o.toString())&&(o&&ye(this,l,"f").get(o).length===0&&ye(this,l,"f").delete(o),o=r,E.push(r),ye(this,l,"f").set(r,[])),i){const c=ye(this,l,"f").get(r);c&&c.push(...i)}else{const c=ye(this,l,"f").get(r);c&&(c.length=0)}}}if(ye(this,m,"f").fire(E),!ye(this,d,"f"))return;const w=[];for(let o of E){let T=[];const r=ye(this,l,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){T=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(let t of r)if(t.severity===i[c]&&T.push(A.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;T.push({severity:I.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:T[T.length-1].startLineNumber,startColumn:T[T.length-1].startColumn,endLineNumber:T[T.length-1].endLineNumber,endColumn:T[T.length-1].endColumn})}else T=r.map(i=>A.Diagnostic.from(i));w.push([o,T])}ye(this,d,"f").$changeMany(this._owner,w)}delete(k){this._checkDisposed(),ye(this,m,"f").fire([k]),ye(this,l,"f").delete(k),ye(this,d,"f")&&ye(this,d,"f").$changeMany(this._owner,[[k,void 0]])}clear(){this._checkDisposed(),ye(this,m,"f").fire([...ye(this,l,"f").keys()]),ye(this,l,"f").clear(),ye(this,d,"f")&&ye(this,d,"f").$clear(this._owner)}forEach(k,u){this._checkDisposed();for(let E of ye(this,l,"f").keys())k.apply(u,[E,this.get(E),this])}get(k){this._checkDisposed();const u=ye(this,l,"f").get(k);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(k){return this._checkDisposed(),Array.isArray(ye(this,l,"f").get(k))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(k,u){return k[0].toString()<u[0].toString()?-1:k[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=n,d=new WeakMap,m=new WeakMap,l=new WeakMap;let h=class oi{constructor(k,u,E){this._logService=u,this._fileSystemInfoService=E,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=k.getProxy(B.MainContext.MainThreadDiagnostics)}static _mapper(k){const u=new N.ResourceMap;for(const E of k)u.set(E,E);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(k,u){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:o,_logService:T,_fileSystemInfoService:r}=this,i=new class{$changeMany(a,g){w.$changeMany(a,g),T.trace("[DiagnosticCollection] change many (extension, owner, uris)",k.value,a,g.length===0?"CLEARING":g)}$clear(a){w.$clear(a),T.trace("[DiagnosticCollection] remove all (extension, owner)",k.value,a)}dispose(){w.dispose()}};let c;if(!u)u="_generated_diagnostic_collection_name_#"+oi._idPool++,c=u;else if(!E.has(u))c=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do c=u+oi._idPool++;while(E.has(c))}return new class extends n{constructor(){super(u,c,oi._maxDiagnosticsPerFile,r.extUri,i,o);E.set(c,this)}dispose(){super.dispose(),E.delete(c)}}}getDiagnostics(k){if(k)return this._getDiagnostics(k);{const u=new Map,E=[];for(const w of this._collections.values())w.forEach((o,T)=>{let r=u.get(o.toString());typeof r=="undefined"&&(r=E.length,u.set(o.toString(),r),E.push([o,[]])),E[r][1]=E[r][1].concat(...T)});return E}}_getDiagnostics(k){let u=[];for(let E of this._collections.values())E.has(k)&&(u=u.concat(E.get(k)));return u}$acceptMarkersChange(k){if(!this._mirrorCollection){const u="_generated_mirror",E=new n(u,u,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(u,E),this._mirrorCollection=E}for(const[u,E]of k)this._mirrorCollection.set(b.URI.revive(u),E.map(A.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=Fe([Ne(1,F.ILogService),Ne(2,p.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(we[183],be([1,0,2,4]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(D){this._proxy=D.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(A=>A?A.map(y=>s.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(A=>A?s.URI.revive(A):void 0)}}e.ExtHostDialogs=b}),define(we[184],be([1,0,15,2,7,4,10,20,9]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class F{constructor(p,d,m){this._documentsAndEditors=d,this._logService=m,this._documentContentProviders=new Map,this._proxy=p.getProxy(B.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(p,d){if(Object.keys(D.Schemas).indexOf(p)>=0)throw new Error(`scheme '${p}' already registered`);const m=F._handlePool++;this._documentContentProviders.set(m,d),this._proxy.$registerTextContentProvider(m,p);let l;return typeof d.onDidChange=="function"&&(l=d.onDidChange(n=>{if(n.scheme!==p){this._logService.warn(`Provider for scheme '${p}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(n)&&this.$provideTextDocumentContent(m,n).then(h=>{if(!h&&typeof h!="string")return;const S=this._documentsAndEditors.getDocument(n);if(!S)return;const k=(0,y.splitLines)(h);if(!S.equalLines(k))return this._proxy.$onVirtualDocumentChange(n,h)},s.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(p,d){const m=this._documentContentProviders.get(p);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(d),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=F,F._handlePool=0}),define(we[185],be([1,0,5,6,2,4,84,8,11,26,7]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class p{constructor(m,l){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(B.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const h of n)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const h of n)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const l=this._documentsAndEditors.getDocument(m);if(l)return l}getDocument(m){const l=this.getDocumentData(m);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return l.document}ensureDocumentData(m){const l=this._documentsAndEditors.getDocument(m);if(l)return Promise.resolve(l);let n=this._documentLoader.get(m.toString());return n||(n=this._proxy.$tryOpenDocument(m).then(h=>{this._documentLoader.delete(m.toString());const S=b.URI.revive(h);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},h=>(this._documentLoader.delete(m.toString()),Promise.reject(h))),this._documentLoader.set(m.toString(),n)),n}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(l=>b.URI.revive(l))}$acceptModelLanguageChanged(m,l){const n=b.URI.revive(m),h=this._documentsAndEditors.getDocument(n);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(l),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(m){const l=b.URI.revive(m),n=this._documentsAndEditors.getDocument(l);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(m,l){const n=b.URI.revive(m),h=this._documentsAndEditors.getDocument(n);if(!h)throw new Error("unknown document");h._acceptIsDirty(l),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,l,n){const h=b.URI.revive(m),S=this._documentsAndEditors.getDocument(h);if(!S)throw new Error("unknown document");S._acceptIsDirty(n),S.onEvents(l);let k;l.isUndoing?k=N.TextDocumentChangeReason.Undo:l.isRedoing&&(k=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,F.deepFreeze)({document:S.document,contentChanges:l.changes.map(u=>({range:A.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:k}))}setWordDefinitionFor(m,l){(0,D.setWordDefinitionFor)(m,l)}}e.ExtHostDocuments=p}),define(we[49],be([1,0,42,5,6,2,3,4,84,14,90,8,12,22,10,161,230]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(E){this.value=E,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let k=class{constructor(E,w){this._extHostRpc=E,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const w=[],o=[],T=[];if(E.removedDocuments)for(const r of E.removedDocuments){const i=B.URI.revive(r),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),w.push(c.value))}if(E.addedDocuments)for(const r of E.addedDocuments){const i=B.URI.revive(r.uri);let c=this._documents.get(i);if(c&&i.scheme!==l.Schemas.vscodeNotebookCell&&i.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new S(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,c),o.push(c.value)),c.ref()}if(E.removedEditors)for(const r of E.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&T.push(i)}if(E.addedEditors)for(const r of E.addedEditors){const i=B.URI.revive(r.documentUri);s.ok(this._documents.has(i),`document '${i}' does not exist`),s.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const c=this._documents.get(i).value,t=new N.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>c.document),r.selections.map(p.Selection.to),r.options,r.visibleRanges.map(a=>p.Range.to(a)),typeof r.editorPosition=="number"?p.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}E.newActiveEditor!==void 0&&(s.ok(E.newActiveEditor===null||this._editors.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this._activeEditorId=E.newActiveEditor),(0,b.dispose)(w),(0,b.dispose)(T),E.removedDocuments&&this._onDidRemoveDocuments.fire(w),E.addedDocuments&&this._onDidAddDocuments.fire(o),(E.removedEditors||E.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),E.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(E){return this._documents.get(E)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),E=>E.value)}getEditor(E){return this._editors.get(E)}activeEditor(E){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return E?w:w?.value}allEditors(){return[...this._editors.values()]}};k=Fe([Ne(0,F.IExtHostRpcService),Ne(1,d.ILogService)],k),e.ExtHostDocumentsAndEditors=k,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[66],be([1,0,8,4,2,5,3,14]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");let y=class{constructor(N){this._onDidChangeTabGroup=new B.Emitter,this._onDidChangeActiveTabGroup=new B.Emitter,this._tabGroups={all:[],activeTabGroup:void 0,onDidChangeTabGroup:this._onDidChangeTabGroup.event,onDidChangeActiveTabGroup:this._onDidChangeActiveTabGroup.event},this._proxy=N.getProxy(I.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(N){this._tabGroups.all.length=0;let p=!1;for(const d of N){let m;const l=d.tabs.map(n=>{const h=this.createExtHostTabObject(n);return n.isActive&&(m=h),h});if(this._tabGroups.all.push(Object.freeze({isActive:d.isActive,viewColumn:s.ViewColumn.to(d.viewColumn),activeTab:m,tabs:l})),d.isActive){p=!0;const n=this._tabGroups.activeTabGroup;this._tabGroups.activeTabGroup=this._tabGroups.all[this._tabGroups.all.length-1],this.groupDiff(n,this._tabGroups.activeTabGroup)&&this._onDidChangeActiveTabGroup.fire(this._tabGroups.activeTabGroup)}}p||(this._tabGroups.activeTabGroup=void 0,this._onDidChangeActiveTabGroup.fire(void 0)),this._onDidChangeTabGroup.fire()}createExtHostTabObject(N){return Object.freeze({label:N.label,viewColumn:s.ViewColumn.to(N.viewColumn),resource:b.URI.revive(N.resource),additionalResourcesAndViewTypes:N.additionalResourcesAndViewTypes.map(({resource:p,viewId:d})=>({resource:b.URI.revive(p),viewType:d})),viewType:N.editorId,isActive:N.isActive,kind:N.kind,isDirty:N.isDirty,isPinned:N.isPinned,move:async(p,d)=>{this._proxy.$moveTab(N,p,s.ViewColumn.from(d))},close:async()=>{await this._proxy.$closeTab(N)}})}groupDiff(N,p){if(N===p)return!1;if(!N||!p||N.isActive!==p.isActive||N.viewColumn!==p.viewColumn||N.tabs.length!==p.tabs.length)return!0;for(let d=0;d<N.tabs.length;d++)if(this.tabDiff(N.tabs[d],p.tabs[d]))return!0;return!1}tabDiff(N,p){if(N===p)return!1;if(!N||!p||N.label!==p.label||N.viewColumn!==p.viewColumn||N.resource?.toString()!==p.resource?.toString()||N.viewType!==p.viewType||N.isActive!==p.isActive||N.isPinned!==p.isPinned||N.isDirty!==p.isDirty||N.additionalResourcesAndViewTypes.length!==p.additionalResourcesAndViewTypes.length)return!0;for(let d=0;d<N.additionalResourcesAndViewTypes.length;d++){const m=N.additionalResourcesAndViewTypes[d].resource,l=p.additionalResourcesAndViewTypes[d].resource,n=N.additionalResourcesAndViewTypes[d].viewType,h=p.additionalResourcesAndViewTypes[d].viewType;if(m?.toString()!==l?.toString()||n!==h)return!0}return!1}};y=Fe([Ne(0,A.IExtHostRpcService)],y),e.ExtHostEditorTabs=y}),define(we[186],be([1,0,2,4,6,7,8,231,9,21,28]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class p{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const n=this._schemes.indexOf(l);n>=0&&(this._schemes.splice(n,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),n=[];let h,S,k=14,u=14;for(const E of l){let w=h?(0,y.commonPrefixLength)(h,E):0;for(w===0?S=1:S=u;w<E.length;w++)w+1===E.length?(k=u,u=9):u+=1,n.push([S,E.toUpperCase().charCodeAt(w),u]),n.push([S,E.toLowerCase().charCodeAt(w),u]),S=u;h=E,u=k}n.push([9,58,10]),n.push([10,47,12]),this._stateMachine=new A.StateMachine(n)}}provideDocumentLinks(l){this._initStateMachine();const n=[],h=A.LinkComputer.computeLinks({getLineContent(S){return l.lineAt(S-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const S of h){const k=D.DocumentLink.to(S);k.target&&n.push(k)}return n}}class d{constructor(l,n){this._extHostLanguageFeatures=n,this._linkProvider=new p,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,n,h,S={}){if(this._registeredSchemes.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const k=this._handlePool++;this._linkProvider.add(n),this._registeredSchemes.add(n),this._fsProvider.set(k,h);let u=2;S.isCaseSensitive&&(u+=1024),S.isReadonly&&(u+=2048),typeof h.copy=="function"&&(u+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,N.checkProposedApiEnabled)(l,"fsChunks"),u+=4),this._proxy.$registerFileSystemProvider(k,n,u).catch(w=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${n}`),console.error(w)});const E=h.onDidChangeFile(w=>{const o=[];for(const T of w){let{uri:r,type:i}=T;if(r.scheme!==n)continue;let c;switch(i){case B.FileChangeType.Changed:c=0;break;case B.FileChangeType.Created:c=1;break;case B.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:c})}this._proxy.$onFileSystemChange(k,o)});return(0,b.toDisposable)(()=>{E.dispose(),this._linkProvider.delete(n),this._registeredSchemes.delete(n),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(l){const{type:n,ctime:h,mtime:S,size:k,permissions:u}=l;return{type:n,ctime:h,mtime:S,size:k,permissions:u}}$stat(l,n){return Promise.resolve(this._getFsProvider(l).stat(s.URI.revive(n))).then(h=>d._asIStat(h))}$readdir(l,n){return Promise.resolve(this._getFsProvider(l).readDirectory(s.URI.revive(n)))}$readFile(l,n){return Promise.resolve(this._getFsProvider(l).readFile(s.URI.revive(n))).then(h=>F.VSBuffer.wrap(h))}$writeFile(l,n,h,S){return Promise.resolve(this._getFsProvider(l).writeFile(s.URI.revive(n),h.buffer,S))}$delete(l,n,h){return Promise.resolve(this._getFsProvider(l).delete(s.URI.revive(n),h))}$rename(l,n,h,S){return Promise.resolve(this._getFsProvider(l).rename(s.URI.revive(n),s.URI.revive(h),S))}$copy(l,n,h,S){const k=this._getFsProvider(l);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(s.URI.revive(n),s.URI.revive(h),S))}$mkdir(l,n){return Promise.resolve(this._getFsProvider(l).createDirectory(s.URI.revive(n)))}$watch(l,n,h,S){const k=this._getFsProvider(l).watch(s.URI.revive(h),S);this._watches.set(n,k)}$unwatch(l,n){const h=this._watches.get(n);h&&(h.dispose(),this._watches.delete(n))}$open(l,n,h){const S=this._getFsProvider(l);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(s.URI.revive(n),h))}$close(l,n){const h=this._getFsProvider(l);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(n))}$read(l,n,h,S){const k=this._getFsProvider(l);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const u=F.VSBuffer.alloc(S);return Promise.resolve(k.read(n,h,u.buffer,0,S)).then(E=>u.slice(0,E))}$write(l,n,h,S){const k=this._getFsProvider(l);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(n,h,S.buffer,0,S.byteLength))}_getFsProvider(l){const n=this._fsProvider.get(l);if(!n){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return n}}e.ExtHostFileSystem=d}),define(we[50],be([1,0,4,45,7,21,3,14,30,6]),function(Z,e,s,I,b,B,D,A,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class jt{constructor(d,m){this._fileSystemProvider=new Map,this._proxy=d.getProxy(s.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(n){try{const h=l._fileSystemProvider.get(n.scheme);if(!h)return await l._proxy.$stat(n);await l._proxy.$ensureActivation(n.scheme);const S=await h.stat(n);return{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions}}catch(h){jt._handleError(h)}},async readDirectory(n){try{const h=l._fileSystemProvider.get(n.scheme);return h?(await l._proxy.$ensureActivation(n.scheme),(await h.readDirectory(n)).slice()):await l._proxy.$readdir(n)}catch(h){return jt._handleError(h)}},async createDirectory(n){try{return await l._proxy.$mkdir(n)}catch(h){return jt._handleError(h)}},async readFile(n){try{const h=l._fileSystemProvider.get(n.scheme);return h?(await l._proxy.$ensureActivation(n.scheme),(await h.readFile(n)).slice()):(await l._proxy.$readFile(n)).buffer}catch(h){return jt._handleError(h)}},async writeFile(n,h){try{return await l._proxy.$writeFile(n,B.VSBuffer.wrap(h))}catch(S){return jt._handleError(S)}},async delete(n,h){try{const S=l._fileSystemProvider.get(n.scheme);return S?(await l._proxy.$ensureActivation(n.scheme),await S.delete(n,{recursive:!1,...h})):await l._proxy.$delete(n,{recursive:!1,useTrash:!1,...h})}catch(S){return jt._handleError(S)}},async rename(n,h,S){try{return await l._proxy.$rename(n,h,{overwrite:!1,...S})}catch(k){return jt._handleError(k)}},async copy(n,h,S){try{return await l._proxy.$copy(n,h,{overwrite:!1,...S})}catch(k){return jt._handleError(k)}},isWritableFileSystem(n){const h=m.getCapabilities(n);if(typeof h=="number")return!(h&2048)}})}static _handleError(d){if(d instanceof b.FileSystemError)throw d;if(!(d instanceof Error))throw new b.FileSystemError(String(d));if(d.name==="ENOPRO")throw b.FileSystemError.Unavailable(d.message);switch(d.name){case I.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(d.message);case I.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(d.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(d.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(d.message);case I.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(d.message);case I.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(d.message);default:throw new b.FileSystemError(d.message,d.name)}}addFileSystemProvider(d,m){return this._fileSystemProvider.set(d,m),(0,F.toDisposable)(()=>this._fileSystemProvider.delete(d))}};N=Fe([Ne(0,A.IExtHostRpcService),Ne(1,y.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(we[187],be([1,0,5,29,2,4,8,7]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(p,d,m,l,n,h,S,k){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter;const u=this.ensureWatching(p,m,n);this._config=0,h&&(this._config+=1),S&&(this._config+=2),k&&(this._config+=4);const E=(0,I.parse)(n),w=typeof n=="string",o=l(T=>{if(!h)for(let r of T.created){const i=b.URI.revive(r);E(i.fsPath)&&(!w||d.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!S)for(let r of T.changed){const i=b.URI.revive(r);E(i.fsPath)&&(!w||d.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!k)for(let r of T.deleted){const i=b.URI.revive(r);E(i.fsPath)&&(!w||d.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=A.Disposable.from(u,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(p,d,m){let l=A.Disposable.from();if(typeof m=="string")return l;const n=p.getProxy(B.MainContext.MainThreadFileSystem);let h=!1;(m.pattern.includes(I.GLOBSTAR)||m.pattern.includes(I.GLOB_SPLIT))&&(h=!0);const S=Math.random();return n.$watch(d.identifier.value,S,m.baseUri,{recursive:h,excludes:[]}),A.Disposable.from({dispose:()=>n.$unwatch(S)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class F{constructor(p,d,m){this._mainContext=p,this._logService=d,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(p,d,m,l,n,h){return new y(this._mainContext,p,d,this._onFileSystemEvent.event,D.GlobPattern.from(m),l,n,h)}$onFileEvent(p){this._onFileSystemEvent.fire(p)}$onDidRunFileOperation(p,d){switch(p){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(m=>({oldUri:b.URI.revive(m.source),newUri:b.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(m=>b.URI.revive(m.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:d.map(m=>b.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(p){return this._createWillExecuteEvent(p,this._onWillRenameFile)}getOnWillCreateFileEvent(p){return this._createWillExecuteEvent(p,this._onWillCreateFile)}getOnWillDeleteFileEvent(p){return this._createWillExecuteEvent(p,this._onWillDeleteFile)}_createWillExecuteEvent(p,d){return(m,l,n)=>{const h=function(k){m.call(l,k)};return h.extension=p,d.event(h,void 0,n)}}async $onWillRunFileOperation(p,d,m,l){switch(p){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))},m,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(n=>b.URI.revive(n.target))},m,l);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(n=>b.URI.revive(n.target))},m,l)}}async _fireWillEvent(p,d,m,l){const n=new Set,h=[];if(await p.fireAsync(d,l,async(k,u)=>{const E=Date.now(),w=await Promise.resolve(k);w instanceof A.WorkspaceEdit&&(h.push(w),n.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-E>m&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),l.isCancellationRequested||h.length===0)return;const S={edits:[]};for(let k of h){let{edits:u}=D.WorkspaceEdit.from(k,{getTextDocumentVersion:E=>this._extHostDocumentsAndEditors.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});S.edits=S.edits.concat(u)}return{edit:S,extensionNames:Array.from(n)}}}e.ExtHostFileSystemEventService=F}),define(we[188],be([1,0,2,39]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(D,A,y,F){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=F;const N=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",p=>!0,p=>p),new I.ApiCommandArgument("resource","Interactive resource Uri",p=>!0,p=>p),new I.ApiCommandArgument("controllerId","Notebook controller Id",p=>!0,p=>p),new I.ApiCommandArgument("title","Interactive editor title",p=>!0,p=>p)],new I.ApiCommandResult("Notebook and input URI",p=>{if(p.notebookEditorId!==void 0){const d=this._extHostNotebooks.getEditorById(p.notebookEditorId);return{notebookUri:s.URI.revive(p.notebookUri),inputUri:s.URI.revive(p.inputUri),notebookEditor:d.apiEditor}}return{notebookUri:s.URI.revive(p.notebookUri),inputUri:s.URI.revive(p.inputUri)}}));this._commands.registerApiCommand(N)}$willAddInteractiveDocument(D,A,y,F){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(F))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=b}),define(we[189],be([1,0,6,4]),function(Z,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(D){this._handlePool=0,this._proxy=D.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,D),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=b}),define(we[190],be([1,0,2,26,8,7,4,9,48,16,11,232,20,6,75,53,58,191,15,5,13]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class w{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentSymbols(M,O){const C=this._documents.getDocument(M),R=await this._provider.provideDocumentSymbols(C,O);if(!(0,F.isFalsyOrEmpty)(R))return R[0]instanceof B.DocumentSymbol?R.map(b.DocumentSymbol.from):w._asDocumentSymbolTree(R)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((R,x)=>{let Q=R.location.range.start.compareTo(x.location.range.start);return Q===0&&(Q=x.location.range.end.compareTo(R.location.range.end)),Q});const O=[],C=[];for(const R of M){const x={name:R.name||"!!MISSING: name!!",kind:b.SymbolKind.from(R.kind),tags:R.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:R.containerName,range:b.Range.from(R.location.range),selectionRange:b.Range.from(R.location.range),children:[]};for(;;){if(C.length===0){C.push(x),O.push(x);break}const Q=C[C.length-1];if(y.Range.containsRange(Q.range,x.range)&&!y.Range.equalsRange(Q.range,x.range)){Q.children&&Q.children.push(x),C.push(x);break}C.pop()}}return O}}class o{constructor(M,O,C){this._documents=M,this._commands=O,this._provider=C,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,O){const C=this._documents.getDocument(M),R=await this._provider.provideCodeLenses(C,O);if(!R||O.isCancellationRequested)return;const x=this._cache.add(R),Q=new m.DisposableStore;this._disposables.set(x,Q);const ne={cacheId:x,lenses:[]};for(let Ee=0;Ee<R.length;Ee++)ne.lenses.push({cacheId:[x,Ee],range:b.Range.from(R[Ee].range),command:this._commands.toInternal(R[Ee].command,Q)});return ne}async resolveCodeLens(M,O){const C=M.cacheId&&this._cache.get(...M.cacheId);if(!C)return;let R;if(typeof this._provider.resolveCodeLens!="function"||C.isResolved?R=C:R=await this._provider.resolveCodeLens(C,O),R||(R=C),O.isCancellationRequested)return;const x=M.cacheId&&this._disposables.get(M.cacheId[0]);if(!!x)return M.command=this._commands.toInternal(R.command??o._badCmd,x),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function T(fe){return Array.isArray(fe)?fe.map(b.DefinitionLink.from):fe?[b.DefinitionLink.from(fe)]:[]}class r{constructor(M,O){this._documents=M,this._provider=O}async provideDefinition(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideDefinition(R,x,C);return T(Q)}}class i{constructor(M,O){this._documents=M,this._provider=O}async provideDeclaration(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideDeclaration(R,x,C);return T(Q)}}class c{constructor(M,O){this._documents=M,this._provider=O}async provideImplementation(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideImplementation(R,x,C);return T(Q)}}class t{constructor(M,O){this._documents=M,this._provider=O}async provideTypeDefinition(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideTypeDefinition(R,x,C);return T(Q)}}class a{constructor(M,O){this._documents=M,this._provider=O}async provideHover(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideHover(R,x,C);if(!(!Q||(0,F.isFalsyOrEmpty)(Q.contents)))return Q.range||(Q.range=R.getWordRangeAtPosition(x)),Q.range||(Q.range=new B.Range(x,x)),b.Hover.from(Q)}}class g{constructor(M,O){this._documents=M,this._provider=O}async provideEvaluatableExpression(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideEvaluatableExpression(R,x,C);if(Q)return b.EvaluatableExpression.from(Q)}}class f{constructor(M,O){this._documents=M,this._provider=O}async provideInlineValues(M,O,C,R){const x=this._documents.getDocument(M),Q=await this._provider.provideInlineValues(x,b.Range.to(O),b.InlineValueContext.to(C),R);if(Array.isArray(Q))return Q.map(ne=>b.InlineValue.from(ne))}}class _{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentHighlights(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideDocumentHighlights(R,x,C);if(Array.isArray(Q))return Q.map(b.DocumentHighlight.from)}}class P{constructor(M,O){this._documents=M,this._provider=O}async provideLinkedEditingRanges(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.provideLinkedEditingRanges(R,x,C);if(Q&&Array.isArray(Q.ranges))return{ranges:(0,F.coalesce)(Q.ranges.map(b.Range.from)),wordPattern:Q.wordPattern}}}class ${constructor(M,O){this._documents=M,this._provider=O}async provideReferences(M,O,C,R){const x=this._documents.getDocument(M),Q=b.Position.to(O),ne=await this._provider.provideReferences(x,Q,C,R);if(Array.isArray(ne))return ne.map(b.location.from)}}class L{constructor(M,O,C,R,x,Q,ne){this._documents=M,this._commands=O,this._diagnostics=C,this._provider=R,this._logService=x,this._extension=Q,this._apiDeprecation=ne,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,O,C,R){const x=this._documents.getDocument(M),Q=p.Selection.isISelection(O)?b.Selection.to(O):b.Range.to(O),ne=[];for(const Be of this._diagnostics.getDiagnostics(M))if(Q.intersection(Be.range)&&ne.push(Be)>L._maxCodeActionsPerFile)break;const Ee={diagnostics:ne,only:C.only?new B.CodeActionKind(C.only):void 0,triggerKind:b.CodeActionTriggerKind.to(C.trigger)},Ie=await this._provider.provideCodeActions(x,Q,Ee,R);if(!(0,F.isNonEmptyArray)(Ie)||R.isCancellationRequested)return;const Me=this._cache.add(Ie),Le=new m.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let Be=0;Be<Ie.length;Be++){const Ae=Ie[Be];!Ae||(L._isCommand(Ae)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Ae.title,command:this._commands.toInternal(Ae,Le)})):(Ee.only&&(Ae.kind?Ee.only.contains(Ae.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,Be],title:Ae.title,command:Ae.command&&this._commands.toInternal(Ae.command,Le),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(b.Diagnostic.from),edit:Ae.edit&&b.WorkspaceEdit.from(Ae.edit),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(M,O){const[C,R]=M,x=this._cache.get(C,R);if(!x||L._isCommand(x)||!this._provider.resolveCodeAction)return;const Q=await this._provider.resolveCodeAction(x,O)??x;return Q?.edit?b.WorkspaceEdit.from(Q.edit):void 0}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}L._maxCodeActionsPerFile=1e3;class v{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentFormattingEdits(M,O,C){const R=this._documents.getDocument(M),x=await this._provider.provideDocumentFormattingEdits(R,O,C);if(Array.isArray(x))return x.map(b.TextEdit.from)}}class H{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentRangeFormattingEdits(M,O,C,R){const x=this._documents.getDocument(M),Q=b.Range.to(O),ne=await this._provider.provideDocumentRangeFormattingEdits(x,Q,C,R);if(Array.isArray(ne))return ne.map(b.TextEdit.from)}}class W{constructor(M,O){this._documents=M,this._provider=O,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,O,C,R,x){const Q=this._documents.getDocument(M),ne=b.Position.to(O),Ee=await this._provider.provideOnTypeFormattingEdits(Q,ne,C,R,x);if(Array.isArray(Ee))return Ee.map(b.TextEdit.from)}}class q{constructor(M,O){this._provider=M,this._logService=O,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,O){const C=await this._provider.provideWorkspaceSymbols(M,O);if(!(0,F.isNonEmptyArray)(C))return{symbols:[]};const R=this._cache.add(C),x={cacheId:R,symbols:[]};for(let Q=0;Q<C.length;Q++){const ne=C[Q];if(!ne||!ne.name){this._logService.warn("INVALID SymbolInformation",ne);continue}x.symbols.push({...b.WorkspaceSymbol.from(ne),cacheId:[R,Q]})}return x}async resolveWorkspaceSymbol(M,O){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const C=this._cache.get(...M.cacheId);if(C){const R=await this._provider.resolveWorkspaceSymbol(C,O);return R&&(0,I.mixin)(M,b.WorkspaceSymbol.from(R),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class K{constructor(M,O,C){this._documents=M,this._provider=O,this._logService=C}static supportsResolving(M){return typeof M.prepareRename=="function"}async provideRenameEdits(M,O,C,R){const x=this._documents.getDocument(M),Q=b.Position.to(O);try{const ne=await this._provider.provideRenameEdits(x,Q,C,R);return ne?b.WorkspaceEdit.from(ne):void 0}catch(ne){const Ee=K._asMessage(ne);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(ne)}}async resolveRenameLocation(M,O,C){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const R=this._documents.getDocument(M),x=b.Position.to(O);try{const Q=await this._provider.prepareRename(R,x,C);let ne,Ee;if(B.Range.isRange(Q)?(ne=Q,Ee=R.getText(Q)):(0,N.isObject)(Q)&&(ne=Q.range,Ee=Q.placeholder),!ne||!Ee)return;if(ne.start.line>x.line||ne.end.line<x.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(ne),text:Ee}}catch(Q){const ne=K._asMessage(Q);return ne?{rejectReason:ne,range:void 0,text:void 0}:Promise.reject(Q)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class V{constructor(M,O){this.resultId=M,this.tokens=O}}class z{constructor(M,O){this._documents=M,this._provider=O,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,O,C){const R=this._documents.getDocument(M),x=O!==0?this._previousResults.get(O):null;let Q=typeof x?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(R,x.resultId,C):await this._provider.provideDocumentSemanticTokens(R,C);return x&&this._previousResults.delete(O),Q?(Q=z._fixProvidedSemanticTokens(Q),this._send(z._convertToEdits(x,Q),Q)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return z._isSemanticTokens(M)?z._isCorrectSemanticTokens(M)?M:new B.SemanticTokens(new Uint32Array(M.data),M.resultId):z._isSemanticTokensEdits(M)?z._isCorrectSemanticTokensEdits(M)?M:new B.SemanticTokensEdits(M.edits.map(O=>new B.SemanticTokensEdit(O.start,O.deleteCount,O.data?new Uint32Array(O.data):O.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const O of M.edits)if(!(O.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,O){if(!z._isSemanticTokens(O)||!M||!M.tokens)return O;const C=M.tokens,R=C.length,x=O.data,Q=x.length;let ne=0;const Ee=Math.min(R,Q);for(;ne<Ee&&C[ne]===x[ne];)ne++;if(ne===R&&ne===Q)return new B.SemanticTokensEdits([],O.resultId);let Ie=0;const Me=Ee-ne;for(;Ie<Me&&C[R-Ie-1]===x[Q-Ie-1];)Ie++;return new B.SemanticTokensEdits([{start:ne,deleteCount:R-ne-Ie,data:x.subarray(ne,Q-Ie)}],O.resultId)}_send(M,O){if(z._isSemanticTokens(M)){const C=this._nextResultId++;return this._previousResults.set(C,new V(M.resultId,M.data)),(0,l.encodeSemanticTokensDto)({id:C,type:"full",data:M.data})}if(z._isSemanticTokensEdits(M)){const C=this._nextResultId++;return z._isSemanticTokens(O)?this._previousResults.set(C,new V(O.resultId,O.data)):this._previousResults.set(C,new V(M.resultId)),(0,l.encodeSemanticTokensDto)({id:C,type:"delta",deltas:(M.edits||[]).map(R=>({start:R.start,deleteCount:R.deleteCount,data:R.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class ae{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentRangeSemanticTokens(M,O,C){const R=this._documents.getDocument(M),x=await this._provider.provideDocumentRangeSemanticTokens(R,b.Range.to(O),C);return x?this._send(x):null}_send(M){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}e.DocumentRangeSemanticTokensAdapter=ae;class de{constructor(M,O,C,R,x){this._documents=M,this._commands=O,this._provider=C,this._apiDeprecation=R,this._extension=x,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}async provideCompletionItems(M,O,C,R){const x=this._documents.getDocument(M),Q=b.Position.to(O),ne=x.getWordRangeAtPosition(Q)||new B.Range(Q,Q),Ee=ne.with({end:Q}),Ie=new S.StopWatch(!0),Me=await this._provider.provideCompletionItems(x,Q,R,b.CompletionContext.to(C));if(!Me||R.isCancellationRequested)return;const Le=Array.isArray(Me)?new B.CompletionList(Me):Me,ze=de.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),Be=new m.DisposableStore;this._disposables.set(ze,Be);const Ae=[],Qe={x:ze,b:Ae,a:{replace:b.Range.from(ne),insert:b.Range.from(Ee)},c:Le.isIncomplete||void 0,d:Ie.elapsed()};for(let tt=0;tt<Le.items.length;tt++){const ke=Le.items[tt],it=this._convertCompletionItem(ke,[ze,tt],Ee,ne);Ae.push(it)}return Qe}async resolveCompletionItem(M,O){if(typeof this._provider.resolveCompletionItem!="function")return;const C=this._cache.get(...M);if(!C)return;const R=await this._provider.resolveCompletionItem(C,O);if(!!R)return this._convertCompletionItem(R,M)}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,O,C,R){const x=this._disposables.get(O[0]);if(!x)throw Error("DisposableStore is missing...");const Q={x:O,a:M.label,b:M.kind!==void 0?b.CompletionItemKind.from(M.kind):void 0,n:M.tags&&M.tags.map(b.CompletionItemTag.from),c:M.detail,d:typeof M.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters,l:M.additionalTextEdits&&M.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(M.command,x)};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Q.h=M.textEdit.newText):typeof M.insertText=="string"?Q.h=M.insertText:M.insertText instanceof B.SnippetString&&(Q.h=M.insertText.value,Q.i|=4);let ne;return M.textEdit?ne=M.textEdit.range:M.range&&(ne=M.range),B.Range.isRange(ne)?Q.j=b.Range.from(ne):ne&&(!C?.isEqual(ne.inserting)||!R?.isEqual(ne.replacing))&&(Q.j={insert:b.Range.from(ne.inserting),replace:b.Range.from(ne.replacing)}),Q}}class Y{constructor(M,O,C){this._documents=M,this._provider=O,this._commands=C,this._cache=new h.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(M,O,C,R){const x=this._documents.getDocument(M),Q=b.Position.to(O),ne=await this._provider.provideInlineCompletionItems(x,Q,{selectedCompletionInfo:C.selectedSuggestionInfo?{range:b.Range.to(C.selectedSuggestionInfo.range),text:C.selectedSuggestionInfo.text,isSnippetText:C.selectedSuggestionInfo.isSnippetText,completionKind:b.CompletionItemKind.to(C.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:C.triggerKind},R);if(!ne||R.isCancellationRequested)return;const Ee=(0,N.isArray)(ne)?ne:ne.items,Ie=this._cache.add(Ee);let Me;return{pid:Ie,items:Ee.map((Le,ze)=>{let Be;Le.command&&(Me||(Me=new m.DisposableStore,this._disposables.set(Ie,Me)),Be=this._commands.toInternal(Le.command,Me));const Ae=Le.insertText??Le.text;if(Ae===void 0)throw new Error("text or insertText must be defined");return{text:typeof Ae=="string"?Ae:{snippet:Ae.value},range:Le.range?b.Range.from(Le.range):void 0,command:Be,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(M){this._cache.delete(M);const O=this._disposables.get(M);O&&O.clear(),this._disposables.delete(M)}handleDidShowCompletionItem(M,O){const C=this._cache.get(M,O);C&&ie.get(this._provider).fireOnDidShowCompletionItem({completionItem:C})}}class ie{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(M){let O=ie.map.get(M);return O||(O=new ie,ie.map.set(M,O)),O}fireOnDidShowCompletionItem(M){this._onDidShowCompletionItemEmitter.fire(M)}}e.InlineCompletionController=ie,ie.map=new WeakMap;class ce{constructor(M,O){this._documents=M,this._provider=O,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(M,O,C,R){const x=this._documents.getDocument(M),Q=b.Position.to(O),ne=this.reviveContext(C),Ee=await this._provider.provideSignatureHelp(x,Q,R,ne);if(Ee){const Ie=this._cache.add([Ee]);return{...b.SignatureHelp.from(Ee),id:Ie}}}reviveContext(M){let O;if(M.activeSignatureHelp){const C=b.SignatureHelp.to(M.activeSignatureHelp),R=this._cache.get(M.activeSignatureHelp.id,0);R?(O=R,O.activeSignature=C.activeSignature,O.activeParameter=C.activeParameter):O=C}return{...M,activeSignatureHelp:O}}releaseSignatureHelp(M){this._cache.delete(M)}}class he{constructor(M,O,C,R,x){this._documents=M,this._commands=O,this._provider=C,this._logService=R,this._extension=x,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,O,C){const R=this._documents.getDocument(M),x=b.Range.to(O),Q=await this._provider.provideInlayHints(R,x,C);if(!Array.isArray(Q)||Q.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${O}`);return}if(C.isCancellationRequested)return;const ne=this._cache.add(Q);this._disposables.set(ne,new m.DisposableStore);const Ee={hints:[],cacheId:ne};for(let Ie=0;Ie<Q.length;Ie++)this._isValidInlayHint(Q[Ie],x)&&Ee.hints.push(this._convertInlayHint(Q[Ie],[ne,Ie]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${O}`),Ee}async resolveInlayHint(M,O){if(typeof this._provider.resolveInlayHint!="function")return;const C=this._cache.get(...M);if(!C)return;const R=await this._provider.resolveInlayHint(C,O);if(!!R&&!!this._isValidInlayHint(R))return this._convertInlayHint(R,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,O){return M.label.length===0||Array.isArray(M.label)&&M.label.every(C=>C.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(O&&!O.contains(M.position))}_convertInlayHint(M,O){const C=this._disposables.get(O[0]);if(!C)throw Error("DisposableStore is missing...");const R={label:"",cacheId:O,tooltip:b.MarkdownString.fromStrict(M.tooltip),position:b.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(b.TextEdit.from),kind:M.kind&&b.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?R.label=M.label:R.label=M.label.map(x=>{let Q={label:x.value};return Q.tooltip=b.MarkdownString.fromStrict(x.tooltip),B.Location.isLocation(x.location)&&(Q.location=b.location.from(x.location)),x.command&&(Q.command=this._commands.toInternal(x.command,C)),Q}),R}}class ue{constructor(M,O){this._documents=M,this._provider=O,this._cache=new h.Cache("DocumentLink")}async provideLinks(M,O){const C=this._documents.getDocument(M),R=await this._provider.provideDocumentLinks(C,O);if(!(!Array.isArray(R)||R.length===0)&&!O.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:R.filter(ue._validateLink).map(b.DocumentLink.from)};{const x=this._cache.add(R),Q={links:[],cacheId:x};for(let ne=0;ne<R.length;ne++){if(!ue._validateLink(R[ne]))continue;const Ee=b.DocumentLink.from(R[ne]);Ee.cacheId=[x,ne],Q.links.push(Ee)}return Q}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,O){if(typeof this._provider.resolveDocumentLink!="function")return;const C=this._cache.get(...M);if(!C)return;const R=await this._provider.resolveDocumentLink(C,O);if(!(!R||!ue._validateLink(R)))return b.DocumentLink.from(R)}releaseLinks(M){this._cache.delete(M)}}class re{constructor(M,O){this._documents=M,this._provider=O}async provideColors(M,O){const C=this._documents.getDocument(M),R=await this._provider.provideDocumentColors(C,O);return Array.isArray(R)?R.map(Q=>({color:b.Color.from(Q.color),range:b.Range.from(Q.range)})):[]}async provideColorPresentations(M,O,C){const R=this._documents.getDocument(M),x=b.Range.to(O.range),Q=b.Color.to(O.color),ne=await this._provider.provideColorPresentations(Q,{document:R,range:x},C);if(!!Array.isArray(ne))return ne.map(b.ColorPresentation.from)}}class ge{constructor(M,O){this._documents=M,this._provider=O}async provideFoldingRanges(M,O,C){const R=this._documents.getDocument(M),x=await this._provider.provideFoldingRanges(R,O,C);if(!!Array.isArray(x))return x.map(b.FoldingRange.from)}}class Te{constructor(M,O,C){this._documents=M,this._provider=O,this._logService=C}async provideSelectionRanges(M,O,C){const R=this._documents.getDocument(M),x=O.map(b.Position.to),Q=await this._provider.provideSelectionRanges(R,x,C);if(!(0,F.isNonEmptyArray)(Q))return[];if(Q.length!==x.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ne=[];for(let Ee=0;Ee<x.length;Ee++){const Ie=[];ne.push(Ie);let Me=x[Ee],Le=Q[Ee];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(b.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return ne}}class Re{constructor(M,O){this._documents=M,this._provider=O,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.prepareCallHierarchy(R,x,C);if(!Q)return;const ne=this._idPool.nextId();return this._cache.set(ne,new Map),Array.isArray(Q)?Q.map(Ee=>this._cacheAndConvertItem(ne,Ee)):[this._cacheAndConvertItem(ne,Q)]}async provideCallsTo(M,O,C){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyIncomingCalls(R,C);if(!!x)return x.map(Q=>({from:this._cacheAndConvertItem(M,Q.from),fromRanges:Q.fromRanges.map(ne=>b.Range.from(ne))}))}async provideCallsFrom(M,O,C){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyOutgoingCalls(R,C);if(!!x)return x.map(Q=>({to:this._cacheAndConvertItem(M,Q.to),fromRanges:Q.fromRanges.map(ne=>b.Range.from(ne))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,O){const C=this._cache.get(M),R=b.CallHierarchyItem.from(O,M,C.size.toString(36));return C.set(R._itemId,O),R}_itemFromCache(M,O){return this._cache.get(M)?.get(O)}}class He{constructor(M,O){this._documents=M,this._provider=O,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(M,O,C){const R=this._documents.getDocument(M),x=b.Position.to(O),Q=await this._provider.prepareTypeHierarchy(R,x,C);if(!Q)return;const ne=this._idPool.nextId();return this._cache.set(ne,new Map),Array.isArray(Q)?Q.map(Ee=>this._cacheAndConvertItem(ne,Ee)):[this._cacheAndConvertItem(ne,Q)]}async provideSupertypes(M,O,C){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySupertypes(R,C);if(!!x)return x.map(Q=>this._cacheAndConvertItem(M,Q))}async provideSubtypes(M,O,C){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySubtypes(R,C);if(!!x)return x.map(Q=>this._cacheAndConvertItem(M,Q))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,O){const C=this._cache.get(M),R=b.TypeHierarchyItem.from(O,M,C.size.toString(36));return C.set(R._itemId,O),R}_itemFromCache(M,O){return this._cache.get(M)?.get(O)}}class Xe{constructor(M,O){this.adapter=M,this.extension=O}}class ve{constructor(M,O,C,R,x,Q,ne){this._adapter=new Map,this._uriTransformer=O,this._proxy=M.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=C,this._commands=R,this._diagnostics=x,this._logService=Q,this._apiDeprecation=ne}_transformDocumentSelector(M){return b.DocumentSelector.from(M,this._uriTransformer)}_createDisposable(M){return new B.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return ve._handlePool++}async _withAdapter(M,O,C,R,x){const Q=this._adapter.get(M);if(!Q||!(Q.adapter instanceof O))return R;const ne=Date.now();this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${C.toString().replace(/[\r\n]/g,"")}'`);const Ee=C(Q.adapter,Q.extension);return Promise.resolve(Ee).catch(Ie=>{(0,k.isCancellationError)(Ie)||(this._logService.error(`[${Q.extension.identifier.value}] provider FAILED`),this._logService.error(Ie))}).finally(()=>{this._logService.trace(`[${Q.extension.identifier.value}] provider DONE after ${Date.now()-ne}ms`)}),d.CancellationToken.isCancellationToken(x)?(0,E.raceCancellationError)(Ee,x):Ee}_addNewAdapter(M,O){const C=this._nextHandle();return this._adapter.set(C,new Xe(M,O)),C}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,O,C,R){const x=this._addNewAdapter(new w(this._documents,C),M),Q=R&&R.label||ve._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(x,this._transformDocumentSelector(O),Q),this._createDisposable(x)}$provideDocumentSymbols(M,O,C){return this._withAdapter(M,w,R=>R.provideDocumentSymbols(s.URI.revive(O),C),void 0,C)}registerCodeLensProvider(M,O,C){const R=this._nextHandle(),x=typeof C.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(R,new Xe(new o(this._documents,this._commands.converter,C),M)),this._proxy.$registerCodeLensSupport(R,this._transformDocumentSelector(O),x);let Q=this._createDisposable(R);if(x!==void 0){const ne=C.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(x));Q=B.Disposable.from(Q,ne)}return Q}$provideCodeLenses(M,O,C){return this._withAdapter(M,o,R=>R.provideCodeLenses(s.URI.revive(O),C),void 0,C)}$resolveCodeLens(M,O,C){return this._withAdapter(M,o,R=>R.resolveCodeLens(O,C),void 0,void 0)}$releaseCodeLenses(M,O){this._withAdapter(M,o,C=>Promise.resolve(C.releaseCodeLenses(O)),void 0,void 0)}registerDefinitionProvider(M,O,C){const R=this._addNewAdapter(new r(this._documents,C),M);return this._proxy.$registerDefinitionSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDefinition(M,O,C,R){return this._withAdapter(M,r,x=>x.provideDefinition(s.URI.revive(O),C,R),[],R)}registerDeclarationProvider(M,O,C){const R=this._addNewAdapter(new i(this._documents,C),M);return this._proxy.$registerDeclarationSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDeclaration(M,O,C,R){return this._withAdapter(M,i,x=>x.provideDeclaration(s.URI.revive(O),C,R),[],R)}registerImplementationProvider(M,O,C){const R=this._addNewAdapter(new c(this._documents,C),M);return this._proxy.$registerImplementationSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideImplementation(M,O,C,R){return this._withAdapter(M,c,x=>x.provideImplementation(s.URI.revive(O),C,R),[],R)}registerTypeDefinitionProvider(M,O,C){const R=this._addNewAdapter(new t(this._documents,C),M);return this._proxy.$registerTypeDefinitionSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideTypeDefinition(M,O,C,R){return this._withAdapter(M,t,x=>x.provideTypeDefinition(s.URI.revive(O),C,R),[],R)}registerHoverProvider(M,O,C,R){const x=this._addNewAdapter(new a(this._documents,C),M);return this._proxy.$registerHoverProvider(x,this._transformDocumentSelector(O)),this._createDisposable(x)}$provideHover(M,O,C,R){return this._withAdapter(M,a,x=>x.provideHover(s.URI.revive(O),C,R),void 0,R)}registerEvaluatableExpressionProvider(M,O,C,R){const x=this._addNewAdapter(new g(this._documents,C),M);return this._proxy.$registerEvaluatableExpressionProvider(x,this._transformDocumentSelector(O)),this._createDisposable(x)}$provideEvaluatableExpression(M,O,C,R){return this._withAdapter(M,g,x=>x.provideEvaluatableExpression(s.URI.revive(O),C,R),void 0,R)}registerInlineValuesProvider(M,O,C,R){const x=typeof C.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new f(this._documents,C),M);this._proxy.$registerInlineValuesProvider(Q,this._transformDocumentSelector(O),x);let ne=this._createDisposable(Q);if(x!==void 0){const Ee=C.onDidChangeInlineValues(Ie=>this._proxy.$emitInlineValuesEvent(x));ne=B.Disposable.from(ne,Ee)}return ne}$provideInlineValues(M,O,C,R,x){return this._withAdapter(M,f,Q=>Q.provideInlineValues(s.URI.revive(O),C,R,x),void 0,x)}registerDocumentHighlightProvider(M,O,C){const R=this._addNewAdapter(new _(this._documents,C),M);return this._proxy.$registerDocumentHighlightProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDocumentHighlights(M,O,C,R){return this._withAdapter(M,_,x=>x.provideDocumentHighlights(s.URI.revive(O),C,R),void 0,R)}registerLinkedEditingRangeProvider(M,O,C){const R=this._addNewAdapter(new P(this._documents,C),M);return this._proxy.$registerLinkedEditingRangeProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideLinkedEditingRanges(M,O,C,R){return this._withAdapter(M,P,async x=>{const Q=await x.provideLinkedEditingRanges(s.URI.revive(O),C,R);if(Q)return{ranges:Q.ranges,wordPattern:Q.wordPattern?ve._serializeRegExp(Q.wordPattern):void 0}},void 0,R)}registerReferenceProvider(M,O,C){const R=this._addNewAdapter(new $(this._documents,C),M);return this._proxy.$registerReferenceSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideReferences(M,O,C,R,x){return this._withAdapter(M,$,Q=>Q.provideReferences(s.URI.revive(O),C,R,x),void 0,x)}registerCodeActionProvider(M,O,C,R){const x=new m.DisposableStore,Q=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,C,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(Q,this._transformDocumentSelector(O),{providedKinds:R?.providedCodeActionKinds?.map(ne=>ne.value),documentation:R?.documentation?.map(ne=>({kind:ne.kind.value,command:this._commands.converter.toInternal(ne.command,x)}))},ve._extLabel(M),Boolean(C.resolveCodeAction)),x.add(this._createDisposable(Q)),x}$provideCodeActions(M,O,C,R,x){return this._withAdapter(M,L,Q=>Q.provideCodeActions(s.URI.revive(O),C,R,x),void 0,x)}$resolveCodeAction(M,O,C){return this._withAdapter(M,L,R=>R.resolveCodeAction(O,C),void 0,void 0)}$releaseCodeActions(M,O){this._withAdapter(M,L,C=>Promise.resolve(C.releaseCodeActions(O)),void 0,void 0)}registerDocumentFormattingEditProvider(M,O,C){const R=this._addNewAdapter(new v(this._documents,C),M);return this._proxy.$registerDocumentFormattingSupport(R,this._transformDocumentSelector(O),M.identifier,M.displayName||M.name),this._createDisposable(R)}$provideDocumentFormattingEdits(M,O,C,R){return this._withAdapter(M,v,x=>x.provideDocumentFormattingEdits(s.URI.revive(O),C,R),void 0,R)}registerDocumentRangeFormattingEditProvider(M,O,C){const R=this._addNewAdapter(new H(this._documents,C),M);return this._proxy.$registerRangeFormattingSupport(R,this._transformDocumentSelector(O),M.identifier,M.displayName||M.name),this._createDisposable(R)}$provideDocumentRangeFormattingEdits(M,O,C,R,x){return this._withAdapter(M,H,Q=>Q.provideDocumentRangeFormattingEdits(s.URI.revive(O),C,R,x),void 0,x)}registerOnTypeFormattingEditProvider(M,O,C,R){const x=this._addNewAdapter(new W(this._documents,C),M);return this._proxy.$registerOnTypeFormattingSupport(x,this._transformDocumentSelector(O),R,M.identifier),this._createDisposable(x)}$provideOnTypeFormattingEdits(M,O,C,R,x,Q){return this._withAdapter(M,W,ne=>ne.provideOnTypeFormattingEdits(s.URI.revive(O),C,R,x,Q),void 0,Q)}registerWorkspaceSymbolProvider(M,O){const C=this._addNewAdapter(new q(O,this._logService),M);return this._proxy.$registerNavigateTypeSupport(C,typeof O.resolveWorkspaceSymbol=="function"),this._createDisposable(C)}$provideWorkspaceSymbols(M,O,C){return this._withAdapter(M,q,R=>R.provideWorkspaceSymbols(O,C),{symbols:[]},C)}$resolveWorkspaceSymbol(M,O,C){return this._withAdapter(M,q,R=>R.resolveWorkspaceSymbol(O,C),void 0,void 0)}$releaseWorkspaceSymbols(M,O){this._withAdapter(M,q,C=>C.releaseWorkspaceSymbols(O),void 0,void 0)}registerRenameProvider(M,O,C){const R=this._addNewAdapter(new K(this._documents,C,this._logService),M);return this._proxy.$registerRenameSupport(R,this._transformDocumentSelector(O),K.supportsResolving(C)),this._createDisposable(R)}$provideRenameEdits(M,O,C,R,x){return this._withAdapter(M,K,Q=>Q.provideRenameEdits(s.URI.revive(O),C,R,x),void 0,x)}$resolveRenameLocation(M,O,C,R){return this._withAdapter(M,K,x=>x.resolveRenameLocation(s.URI.revive(O),C,R),void 0,R)}registerDocumentSemanticTokensProvider(M,O,C,R){const x=this._addNewAdapter(new z(this._documents,C),M),Q=typeof C.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(x,this._transformDocumentSelector(O),R,Q);let ne=this._createDisposable(x);if(Q){const Ee=C.onDidChangeSemanticTokens(Ie=>this._proxy.$emitDocumentSemanticTokensEvent(Q));ne=B.Disposable.from(ne,Ee)}return ne}$provideDocumentSemanticTokens(M,O,C,R){return this._withAdapter(M,z,x=>x.provideDocumentSemanticTokens(s.URI.revive(O),C,R),null,R)}$releaseDocumentSemanticTokens(M,O){this._withAdapter(M,z,C=>C.releaseDocumentSemanticColoring(O),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,O,C,R){const x=this._addNewAdapter(new ae(this._documents,C),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(x,this._transformDocumentSelector(O),R),this._createDisposable(x)}$provideDocumentRangeSemanticTokens(M,O,C,R){return this._withAdapter(M,ae,x=>x.provideDocumentRangeSemanticTokens(s.URI.revive(O),C,R),null,R)}registerCompletionItemProvider(M,O,C,R){const x=this._addNewAdapter(new de(this._documents,this._commands.converter,C,this._apiDeprecation,M),M);return this._proxy.$registerSuggestSupport(x,this._transformDocumentSelector(O),R,de.supportsResolving(C),`${M.identifier.value}(${R.join("")})`),this._createDisposable(x)}$provideCompletionItems(M,O,C,R,x){return this._withAdapter(M,de,Q=>Q.provideCompletionItems(s.URI.revive(O),C,R,x),void 0,x)}$resolveCompletionItem(M,O,C){return this._withAdapter(M,de,R=>R.resolveCompletionItem(O,C),void 0,C)}$releaseCompletionItems(M,O){this._withAdapter(M,de,C=>C.releaseCompletionItems(O),void 0,void 0)}registerInlineCompletionsProvider(M,O,C){const R=this._addNewAdapter(new Y(this._documents,C,this._commands.converter),M);return this._proxy.$registerInlineCompletionsSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideInlineCompletions(M,O,C,R,x){return this._withAdapter(M,Y,Q=>Q.provideInlineCompletions(s.URI.revive(O),C,R,x),void 0,x)}$handleInlineCompletionDidShow(M,O,C){this._withAdapter(M,Y,async R=>{R.handleDidShowCompletionItem(O,C)},void 0,void 0)}$freeInlineCompletionsList(M,O){this._withAdapter(M,Y,async C=>{C.disposeCompletions(O)},void 0,void 0)}registerSignatureHelpProvider(M,O,C,R){const x=Array.isArray(R)?{triggerCharacters:R,retriggerCharacters:[]}:R,Q=this._addNewAdapter(new ce(this._documents,C),M);return this._proxy.$registerSignatureHelpProvider(Q,this._transformDocumentSelector(O),x),this._createDisposable(Q)}$provideSignatureHelp(M,O,C,R,x){return this._withAdapter(M,ce,Q=>Q.provideSignatureHelp(s.URI.revive(O),C,R,x),void 0,x)}$releaseSignatureHelp(M,O){this._withAdapter(M,ce,C=>C.releaseSignatureHelp(O),void 0,void 0)}registerInlayHintsProvider(M,O,C){const R=typeof C.onDidChangeInlayHints=="function"?this._nextHandle():void 0,x=this._addNewAdapter(new he(this._documents,this._commands.converter,C,this._logService,M),M);this._proxy.$registerInlayHintsProvider(x,this._transformDocumentSelector(O),typeof C.resolveInlayHint=="function",R,ve._extLabel(M));let Q=this._createDisposable(x);if(R!==void 0){const ne=C.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(R));Q=B.Disposable.from(Q,ne)}return Q}$provideInlayHints(M,O,C,R){return this._withAdapter(M,he,x=>x.provideInlayHints(s.URI.revive(O),C,R),void 0,R)}$resolveInlayHint(M,O,C){return this._withAdapter(M,he,R=>R.resolveInlayHint(O,C),void 0,C)}$releaseInlayHints(M,O){this._withAdapter(M,he,C=>C.releaseHints(O),void 0,void 0)}registerDocumentLinkProvider(M,O,C){const R=this._addNewAdapter(new ue(this._documents,C),M);return this._proxy.$registerDocumentLinkProvider(R,this._transformDocumentSelector(O),typeof C.resolveDocumentLink=="function"),this._createDisposable(R)}$provideDocumentLinks(M,O,C){return this._withAdapter(M,ue,R=>R.provideLinks(s.URI.revive(O),C),void 0,C)}$resolveDocumentLink(M,O,C){return this._withAdapter(M,ue,R=>R.resolveLink(O,C),void 0,void 0)}$releaseDocumentLinks(M,O){this._withAdapter(M,ue,C=>C.releaseLinks(O),void 0,void 0)}registerColorProvider(M,O,C){const R=this._addNewAdapter(new re(this._documents,C),M);return this._proxy.$registerDocumentColorProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDocumentColors(M,O,C){return this._withAdapter(M,re,R=>R.provideColors(s.URI.revive(O),C),[],C)}$provideColorPresentations(M,O,C,R){return this._withAdapter(M,re,x=>x.provideColorPresentations(s.URI.revive(O),C,R),void 0,R)}registerFoldingRangeProvider(M,O,C){const R=this._nextHandle(),x=typeof C.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(R,new Xe(new ge(this._documents,C),M)),this._proxy.$registerFoldingRangeProvider(R,this._transformDocumentSelector(O),x);let Q=this._createDisposable(R);if(x!==void 0){const ne=C.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(x));Q=B.Disposable.from(Q,ne)}return Q}$provideFoldingRanges(M,O,C,R){return this._withAdapter(M,ge,x=>x.provideFoldingRanges(s.URI.revive(O),C,R),void 0,R)}registerSelectionRangeProvider(M,O,C){const R=this._addNewAdapter(new Te(this._documents,C,this._logService),M);return this._proxy.$registerSelectionRangeProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideSelectionRanges(M,O,C,R){return this._withAdapter(M,Te,x=>x.provideSelectionRanges(s.URI.revive(O),C,R),[],R)}registerCallHierarchyProvider(M,O,C){const R=this._addNewAdapter(new Re(this._documents,C),M);return this._proxy.$registerCallHierarchyProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$prepareCallHierarchy(M,O,C,R){return this._withAdapter(M,Re,x=>Promise.resolve(x.prepareSession(s.URI.revive(O),C,R)),void 0,R)}$provideCallHierarchyIncomingCalls(M,O,C,R){return this._withAdapter(M,Re,x=>x.provideCallsTo(O,C,R),void 0,R)}$provideCallHierarchyOutgoingCalls(M,O,C,R){return this._withAdapter(M,Re,x=>x.provideCallsFrom(O,C,R),void 0,R)}$releaseCallHierarchy(M,O){this._withAdapter(M,Re,C=>Promise.resolve(C.releaseSession(O)),void 0,void 0)}registerTypeHierarchyProvider(M,O,C){const R=this._addNewAdapter(new He(this._documents,C),M);return this._proxy.$registerTypeHierarchyProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$prepareTypeHierarchy(M,O,C,R){return this._withAdapter(M,He,x=>Promise.resolve(x.prepareSession(s.URI.revive(O),C,R)),void 0,R)}$provideTypeHierarchySupertypes(M,O,C,R){return this._withAdapter(M,He,x=>x.provideSupertypes(O,C,R),void 0,R)}$provideTypeHierarchySubtypes(M,O,C,R){return this._withAdapter(M,He,x=>x.provideSubtypes(O,C,R),void 0,R)}$releaseTypeHierarchy(M,O){this._withAdapter(M,He,C=>Promise.resolve(C.releaseSession(O)),void 0,void 0)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,A.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:ve._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:ve._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ve._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ve._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:ve._serializeRegExp(M.beforeText),afterText:M.afterText?ve._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?ve._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(ve._serializeOnEnterRule)}setLanguageConfiguration(M,O,C){let{wordPattern:R}=C;if(R&&(0,A.regExpLeadsToEndlessLoop)(R))throw new Error(`Invalid language configuration: wordPattern '${R}' is not allowed to match the empty string.`);R?this._documents.setWordDefinitionFor(O,R):this._documents.setWordDefinitionFor(O,void 0),C.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),C.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const x=this._nextHandle(),Q={comments:C.comments,brackets:C.brackets,wordPattern:C.wordPattern?ve._serializeRegExp(C.wordPattern):void 0,indentationRules:C.indentationRules?ve._serializeIndentationRule(C.indentationRules):void 0,onEnterRules:C.onEnterRules?ve._serializeOnEnterRules(C.onEnterRules):void 0,__electricCharacterSupport:C.__electricCharacterSupport,__characterPairSupport:C.__characterPairSupport};return this._proxy.$setLanguageConfiguration(x,O,Q),this._createDisposable(x)}$setWordDefinitions(M){for(const O of M)this._documents.setWordDefinitionFor(O.languageId,new RegExp(O.regexSource,O.regexFlags))}}e.ExtHostLanguageFeatures=ve,ve._handlePool=0}),define(we[192],be([1,0,4,8,7,34,13,6]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(N,p,d,m){this._documents=p,this._commands=d,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,p){await this._proxy.$changeLanguage(N,p);const d=this._documents.getDocumentData(N);if(!d)throw new Error(`document '${N.toString()}' NOT found`);return d.document}async tokenAtPosition(N,p){const d=N.version,m=I.Position.from(p),l=await this._proxy.$tokensAtPosition(N.uri,m),n={type:b.StandardTokenType.Other,range:N.getWordRangeAtPosition(p)??new b.Range(p.line,p.character,p.line,p.character)};if(!l)return n;const h={range:I.Range.to(l.range),type:I.TokenType.to(l.type)};return!h.range.contains(p)||d!==N.version?n:h}createLanguageStatusItem(N,p,d){const m=this._handlePool++,l=this._proxy,n=this._ids,h=`${N.identifier.value}/${p}`;if(n.has(h))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);n.add(h);const S={selector:d,id:p,name:N.displayName??N.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let k,u=new A.DisposableStore;const E=()=>{k?.dispose(),k=(0,D.disposableTimeout)(()=>{u.clear(),this._proxy.$setLanguageStatus(m,{id:h,name:S.name??N.displayName??N.name,source:N.displayName??N.name,selector:I.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===b.LanguageStatusSeverity.Error?B.default.Error:S.severity===b.LanguageStatusSeverity.Warning?B.default.Warning:B.default.Info,command:S.command&&this._commands.toInternal(S.command,u),accessibilityInfo:S.accessibilityInformation,busy:S.busy})},0)},w={dispose(){u.dispose(),k?.dispose(),l.$removeLanguageStatus(m),n.delete(h)},get id(){return S.id},get name(){return S.name},set name(o){S.name=o,E()},get selector(){return S.selector},set selector(o){S.selector=o,E()},get text(){return S.text},set text(o){S.text=o,E()},get detail(){return S.detail},set detail(o){S.detail=o,E()},get severity(){return S.severity},set severity(o){S.severity=o,E()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(o){S.accessibilityInformation=o,E()},get command(){return S.command},set command(o){S.command=o,E()},get busy(){return S.busy},set busy(o){S.busy=o,E()}};return E(),w}}e.ExtHostLanguages=y}),define(we[193],be([1,0,12,4,27,14,5]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends s.AbstractLoggerService{constructor(N,p){const d=new D.Emitter;super(p.logLevel,d.event);this._proxy=N.getProxy(I.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(d)}$setLevel(N){this._onDidChangeLogLevel.fire(N)}doCreateLogger(N,p,d){return new y(this._proxy,N,p,d)}};A=Fe([Ne(0,B.IExtHostRpcService),Ne(1,b.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class y extends s.AbstractMessageLogger{constructor(N,p,d,m){super(m?.always);this.proxy=N,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.proxy.$createLogger(p,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(N,p){const d=[[N,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(N){this.proxy.$log(this.file,N)}}}),define(we[194],be([1,0,4,12,28]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function B(A){return A&&A.title}let D=class{constructor(y,F){this._logService=F,this._proxy=y.getProxy(s.MainContext.MainThreadMessageService)}showMessage(y,F,N,p,d){const m={source:{identifier:y.identifier,label:y.displayName||y.name}};let l;typeof p=="string"||B(p)?l=[p,...d]:(m.modal=p?.modal,m.useCustom=p?.useCustom,m.detail=p?.detail,l=d),m.useCustom&&(0,b.checkProposedApiEnabled)(y,"resolvers");const n=[];for(let h=0;h<l.length;h++){const S=l[h];if(typeof S=="string")n.push({title:S,handle:h,isCloseAffordance:!1});else if(typeof S=="object"){let{title:k,isCloseAffordance:u}=S;n.push({title:k,isCloseAffordance:!!u,handle:h})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(F,N,m,n).then(h=>{if(typeof h=="number")return l[h]})}};D=Fe([Ne(1,I.ILogService)],D),e.ExtHostMessageService=D}),define(we[195],be([1,0,21,5,93,6,22,9,11,2,58,4,8,7,38,169,89]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(u,E,w,o,T){this._textDocumentsAndEditors=w,this._textDocuments=o,this._extensionStoragePaths=T,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new N.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(p.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(p.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(p.MainContext.MainThreadNotebookEditors),this._commandsConverter=E.converter,E.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,c=r.cell.handle,a=this._documents.get(i)?.getCell(c);if(a)return a.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){const E=this._editors.get(u);if(!E)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return E}getIdByEditor(u){for(const[E,w]of this._editors)if(w.apiEditor===u)return E}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,E){const w=this._documents.get(u);if(!w&&!E)throw new Error(`NO notebook document for '${u}'`);return w}_getProviderData(u){const E=this._notebookContentProviders.get(u);if(!E)throw new Error(`NO provider for '${u}'`);return E}registerNotebookContentProvider(u,E,w,o,T){if((0,A.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(E))throw new Error(`Notebook provider for '${E}' already registered`);this._notebookContentProviders.set(E,{extension:u,provider:w});let r;return w.onDidChangeNotebookContentOptions&&(r=w.onDidChangeNotebookContentOptions(()=>{const i=d.NotebookDocumentContentOptions.from(w.options);this._notebookProxy.$updateNotebookProviderOptions(E,i)})),this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation},E,d.NotebookDocumentContentOptions.from(o),S._convertNotebookRegistrationData(u,T)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(E),this._notebookProxy.$unregisterNotebookProvider(E)})}static _convertNotebookRegistrationData(u,E){if(!E)return;const w=E.filenamePattern.map(o=>d.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(E.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:E.displayName,filenamePattern:w,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,E,w){const o=S._notebookStatusBarItemProviderHandlePool++,T=typeof w.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,T,E);let r;return T!==void 0&&(r=w.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(T))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,T),r&&r.dispose()})}async createNotebookDocument(u){const E=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&d.NotebookData.from(u.content)});return F.URI.revive(E)}async openNotebookDocument(u){const E=this._documents.get(u);if(E)return E.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(u),o=this._documents.get(F.URI.revive(w));return(0,y.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(u,E){F.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let w;typeof E=="object"?w={position:d.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(d.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:w={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,w),T=o&&this._editors.get(o)?.apiEditor;if(T)return T;throw o?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,E,w,o){const T=this._notebookStatusBarItemProviders.get(u),r=F.URI.revive(E),i=this._documents.get(r);if(!i||!T)return;const c=i.getCellFromIndex(w);if(!c)return;const t=await T.provideCellStatusBarItems(c.apiCell,o);if(!t)return;const a=new B.DisposableStore,g=this._statusBarCache.add([a]),_=(Array.isArray(t)?t:[t]).map(P=>d.NotebookStatusBarItem.from(P,this._commandsConverter,a));return{cacheId:g,items:_}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,E,w,o,T){if((0,A.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,w),this._notebookProxy.$registerNotebookSerializer(r,{id:u.identifier,location:u.extensionLocation},E,d.NotebookDocumentContentOptions.from(o),S._convertNotebookRegistrationData(u,T)),(0,B.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(u,E,w){const o=this._notebookSerializer.get(u);if(!o)throw new Error("NO serializer found");const T=await o.deserializeNotebook(E.buffer,w);return new l.SerializableObjectWithBuffers(d.NotebookData.from(T))}async $notebookToData(u,E,w){const o=this._notebookSerializer.get(u);if(!o)throw new Error("NO serializer found");const T=await o.serializeNotebook(d.NotebookData.to(E.value),w);return s.VSBuffer.wrap(T)}async $openNotebook(u,E,w,o,T){const{provider:r}=this._getProviderData(u),i=await r.openNotebook(F.URI.revive(E),{backupId:w,untitledDocumentData:o?.buffer},T);return new l.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(d.NotebookCellData.from)})}async $saveNotebook(u,E,w){const o=this.getNotebookDocument(F.URI.revive(E)),{provider:T}=this._getProviderData(u);return await T.saveNotebook(o.apiNotebook,w),!0}async $saveNotebookAs(u,E,w,o){const T=this.getNotebookDocument(F.URI.revive(E)),{provider:r}=this._getProviderData(u);return await r.saveNotebookAs(F.URI.revive(w),T.apiNotebook,o),!0}async $backupNotebook(u,E,w){const o=this.getNotebookDocument(F.URI.revive(E)),T=this._getProviderData(u),r=this._extensionStoragePaths.workspaceValue(T.extension)??this._extensionStoragePaths.globalValue(T.extension),i=String((0,b.hash)([o.uri.toString(),this._backupIdPool++])),c=F.URI.joinPath(r,i),t=await T.provider.backupNotebook(o.apiNotebook,{destination:c},w);return o.updateBackup(t),t.id}_createExtHostEditor(u,E,w){if(this._editors.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const o=new h.ExtHostNotebookEditor(E,this._notebookEditorsProxy,u,w.visibleRanges.map(d.NotebookRange.to),w.selections.map(d.NotebookRange.to),typeof w.viewColumn=="number"?d.ViewColumn.to(w.viewColumn):void 0);this._editors.set(E,o)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const w of u.value.removedDocuments){const o=F.URI.revive(w),T=this._documents.get(o);T&&(T.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:T.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(T.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===o.toString()&&this._editors.delete(r.id)}if(u.value.addedDocuments){const w=[];for(const o of u.value.addedDocuments){const T=F.URI.revive(o.uri);if(this._documents.has(T))throw new Error(`adding EXISTING notebook ${T} `);const r=this,i=new n.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){r._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){r._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){r._onDidChangeCellMetadata.fire(c)}},T,o);w.push(...o.cells.map(c=>n.ExtHostCell.asModelAddData(i.apiNotebook,c))),this._documents.get(T)?.dispose(),this._documents.set(T,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(u.value.addedEditors)for(const w of u.value.addedEditors){if(this._editors.has(w.id))return;const o=F.URI.revive(w.documentUri),T=this._documents.get(o);T&&this._createExtHostEditor(T,w.id,w)}const E=[];if(u.value.removedEditors)for(const w of u.value.removedEditors){const o=this._editors.get(w);o&&(this._editors.delete(w),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),E.push(o))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const w=new Set;this._visibleNotebookEditors.forEach(o=>w.add(o.id));for(const o of this._editors.values()){const T=w.has(o.id);o._acceptVisibility(T)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(we[196],be([1,0,5,53,12,4,14,8]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(p,d){const m=y._Keys.nextId();p.$registerNotebookEditorDecorationType(m,A.NotebookDecorationRenderOptions.from(d)),this.value={key:m,dispose(){p.$removeNotebookEditorDecorationType(m)}}}}y._Keys=new I.IdGenerator("NotebookEditorDecorationType");let F=class{constructor(p,d,m){this._logService=p,this._extHostRpc=d,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(p){return new y(this._extHostRpc.getProxy(B.MainContext.MainThreadNotebookEditors),p).value}$acceptEditorPropertiesChanged(p,d){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,d);const m=this._notebooksAndEditors.getEditorById(p);d.visibleRanges&&m._acceptVisibleRanges(d.visibleRanges.ranges.map(A.NotebookRange.to)),d.selections&&m._acceptSelections(d.selections.selections.map(A.NotebookRange.to)),d.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),d.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const d in p)this._notebooksAndEditors.getEditorById(d)._acceptViewColumn(A.ViewColumn.to(p[d]))}};F=Fe([Ne(0,b.ILogService),Ne(1,D.IExtHostRpcService)],F),e.ExtHostNotebookEditors=F}),define(we[197],be([1,0,16,13,20,5,6,22,2,25,12,4,39,8,7,61,162,28,38]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let u=class{constructor(i,c,t,a,g){this._initData=c,this._extHostNotebook=t,this._commands=a,this._logService=g,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new B.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(p.MainContext.MainThreadNotebookKernels);const f=new d.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const P=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:P}}else if(_&&"notebookEditor"in _){const P=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return _})],d.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,c,t,a,g,f){for(const ie of this._kernelData.values())if(ie.controller.id===c&&F.ExtensionIdentifier.equals(i.identifier,ie.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const _=this._handlePool++,P=this;this._logService.trace(`NotebookController[${_}], CREATED by ${i.identifier.value}, ${c}`);const $=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${i.identifier}'`);let L=!1;const v=new D.DisposableStore,H=new B.Emitter,W=new B.Emitter,q={id:T(i,c),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:a||i.identifier.value,preloads:f?f.map(m.NotebookRendererScript.from):[]};let K=g??$,V;this._proxy.$addKernel(_,q).catch(ie=>{console.log(ie),L=!0});let z=0;const ae=()=>{if(L)return;const ie=++z;Promise.resolve().then(()=>{ie===z&&this._proxy.$updateKernel(_,q)})},de=new A.ResourceMap,Y={get id(){return c},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return q.label},set label(ie){q.label=ie??i.displayName??i.name,ae()},get detail(){return q.detail??""},set detail(ie){q.detail=ie,ae()},get description(){return q.description??""},set description(ie){q.description=ie,ae()},get kind(){return(0,S.checkProposedApiEnabled)(i,"notebookControllerKind"),q.kind??""},set kind(ie){(0,S.checkProposedApiEnabled)(i,"notebookControllerKind"),q.kind=ie,ae()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ie){q.supportedLanguages=ie,ae()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){q.supportsExecutionOrder=ie,ae()},get rendererScripts(){return q.preloads?q.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ie){K=ie??$},get interruptHandler(){return V},set interruptHandler(ie){V=ie,q.supportsInterrupt=Boolean(ie),ae()},createNotebookCellExecution(ie){if(L)throw new Error("notebook controller is DISPOSED");if(!de.has(ie.notebook.uri))throw P._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return P._createNotebookCellExecution(ie,T(i,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${_}], DISPOSED`),L=!0,this._kernelData.delete(_),v.dispose(),H.dispose(),W.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(ie,ce){P._proxy.$updateNotebookPriority(_,ie.uri,ce)},onDidReceiveMessage:W.event,postMessage(ie,ce){return(0,S.checkProposedApiEnabled)(i,"notebookMessaging"),P._proxy.$postMessage(_,ce&&P._extHostNotebook.getIdByEditor(ce),ie)},asWebviewUri(ie){return(0,S.checkProposedApiEnabled)(i,"notebookMessaging"),(0,n.asWebviewUri)(ie,P._initData.remote)}};return this._kernelData.set(_,{extensionId:i.identifier,controller:Y,onDidReceiveMessage:W,onDidChangeSelection:H,associatedNotebooks:de}),Y}$acceptNotebookAssociation(i,c,t){const a=this._kernelData.get(i);if(a){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));t?a.associatedNotebooks.set(g.uri,!0):a.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,g.uri.toString(),t),a.onDidChangeSelection.fire({selected:t,notebook:g.apiNotebook})}}async $executeCells(i,c,t){const a=this._kernelData.get(i);if(!a)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)),f=[];for(const _ of t){const P=g.getCell(_);P&&f.push(P.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,g.uri.toString(),f.length),await a.controller.executeHandler.call(a.controller,f,g.apiNotebook,a.controller)}catch(_){this._logService.error(`NotebookController[${i}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(i,c,t){const a=this._kernelData.get(i);if(!a)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,g.apiNotebook);else for(const f of t){const _=g.getCell(f);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,c,t){const a=this._kernelData.get(i);if(!a)return;const g=this._extHostNotebook.getEditorById(c);a.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:t}))}$cellExecutionChanged(i,c,t){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(c);g&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:t?m.NotebookCellExecutionState.to(t):l.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,c){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const g=new w(c,a,this._proxy);this._activeExecutions.set(a.uri,g);const f=g.onDidChangeState(()=>{g.state===E.Resolved&&(g.dispose(),f.dispose(),this._activeExecutions.delete(a.uri))});return g.asApiObject()}};u=Fe([Ne(4,N.ILogService)],u),e.ExtHostNotebookKernels=u;var E;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(E||(E={}));class w extends D.Disposable{constructor(i,c,t){super();this._cell=c,this._proxy=t,this._handle=w.HANDLE++,this._onDidChangeState=new B.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new o(10,a=>this.update(a)),this._executionOrder=c.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const c=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new k.SerializableObjectWithBuffers(c))}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(c=>{const t=l.NotebookCellOutput.ensureUniqueMimeTypes(c.items,!0);return t===c.items?m.NotebookCellOutput.from(c):m.NotebookCellOutput.from({items:t,id:c.id,metadata:c.metadata})})}async updateOutputs(i,c,t){const a=this.validateAndConvertOutputs((0,s.asArray)(i));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,append:t,outputs:a})}async updateOutputItems(i,c,t){return i=l.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(i),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:i.map(m.NotebookCellOutputItem.from),outputId:c.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===E.Resolved||i._state===E.Started)throw new Error("Cannot call start again");i._state=E.Started,i._onDidChangeState.fire(),i.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,a){if(i._state===E.Resolved)throw new Error("Cannot call resolve twice");i._state=E.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new k.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,a){return i.verifyStateForOutput(),i.updateOutputs(t,a,!0)},replaceOutput(t,a){return i.verifyStateForOutput(),i.updateOutputs(t,a,!1)},appendOutputItems(t,a){return i.verifyStateForOutput(),i.updateOutputItems(t,a,!0)},replaceOutputItems(t,a){return i.verifyStateForOutput(),i.updateOutputItems(t,a,!1)}})}}w.HANDLE=0;class o{constructor(i,c){this.delay=i,this.callback=c,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const c=this.batch;return this.batch=[],this.callback(c).finally(()=>i.complete())}}function T(r,i){return`${r.identifier.value}/${i}`}}),define(we[198],be([1,0,5,4,89,28]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class D{constructor(y,F){this._extHostNotebook=F,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,F,N){const p=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(F)?.fire({editor:p.apiEditor,message:N})}createRendererMessaging(y,F){if(!y.contributes?.notebookRenderer?.some(m=>m.id===F))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${F})`);const N=(0,B.isProposedApiEnabled)(y,"notebookEditor"),p=new WeakMap;return{onDidReceiveMessage:(m,l,n)=>{const h=N?m:S=>{const k={};p.set(k,S.editor),m({editor:k,message:S.message})};return this.getOrCreateEmitterFor(F).event(h,l,n)},postMessage:(m,l)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,l]=[l,m]);const n=N?l:p.get(l),h=n&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(n);return this.proxy.$postMessage(h?.id,F,m)}}}getOrCreateEmitterFor(y){let F=this._rendererMessageEmitters.get(y);return F||(F=new s.Emitter({onLastListenerRemove:()=>{F?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,F),F)}}e.ExtHostNotebookRenderers=D}),define(we[94],be([1,0,4,6,3,14,12,163,50,27,30,112,21,11]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class l extends I.Disposable{constructor(S,k,u,E){super();this.id=S,this.name=k,this.logger=u,this.proxy=E,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(S){this.append(S+`
`)}append(S){this.write(S),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const S=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,S)}replace(S){const k=this.offset;this.write(S),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,k),this.visible&&this.logger.flush()}show(S,k){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof S=="boolean"?S:k))}hide(){this.proxy.$close(this.id)}write(S){this.offset+=d.VSBuffer.fromString(S).byteLength,this.logger.info(S)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=l;let n=class{constructor(S,k,u,E,w){this.extHostFileSystem=u,this.extHostFileSystemInfo=E,this.loggerService=w,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=S.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(k.logsLocation,`output_logging_${(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(S){this.visibleChannelId=S;for(const[k,u]of this.channels)u.visible=k===this.visibleChannelId}createOutputChannel(S,k,u){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");if((0,m.isString)(k)&&!k.trim())throw new Error("illegal argument `languageId`. must not be empty");const E=this.doCreateOutputChannel(S,k,u);return E.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(S,E)}async doCreateOutputChannel(S,k,u){const E=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(E,`${this.namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),T=await this.proxy.$register(S,!1,w,k,u.identifier.value);return new l(T,S,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(S,k){let u=!1;const E=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return S},append(w){E(),k.then(o=>o.append(w))},appendLine(w){E(),k.then(o=>o.appendLine(w))},clear(){E(),k.then(w=>w.clear())},replace(w){E(),k.then(o=>o.replace(w))},show(w,o){E(),k.then(T=>T.show(w,o))},hide(){E(),k.then(w=>w.hide())},dispose(){u=!0,k.then(w=>w.dispose())}}}};n=Fe([Ne(0,B.IExtHostRpcService),Ne(1,F.IExtHostInitDataService),Ne(2,y.IExtHostConsumerFileSystem),Ne(3,N.IExtHostFileSystemInfo),Ne(4,D.ILoggerService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(we[199],be([1,0,13,20,5,6,4,2,7,15,16,34,57]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(l,n,h){const S=l.getProxy(D.MainContext.MainThreadQuickOpen);class k{constructor(t,a){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=a}showQuickPick(t,a,g=I.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(t),_=++this._instances,P=S.$show(_,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},g),$={},L=P.then(()=>$);return Promise.race([L,f]).then(v=>{if(v!==$)return f.then(H=>{const W=[];for(let q=0;q<H.length;q++){const K=H[q];typeof K=="string"?W.push({label:K,handle:q}):K.kind===y.QuickPickItemKind.Separator?W.push({type:"separator",label:K.label}):W.push({label:K.label,description:K.description,detail:K.detail,picked:K.picked,alwaysShow:K.alwaysShow,handle:q})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{a.onDidSelectItem(H[q])}),S.$setItems(_,W),P.then(q=>{if(typeof q=="number")return H[q];if(Array.isArray(q))return q.map(K=>H[K])})})}).then(void 0,v=>{if(!(0,F.isCancellationError)(v))return S.$setError(_,v),Promise.reject(v)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,a=I.CancellationToken.None){return this._validateInput=t?t.validateInput:void 0,S.$input(t,typeof this._validateInput=="function",a).then(void 0,g=>{if(!(0,F.isCancellationError)(g))return Promise.reject(g)})}$validateInput(t){return this._validateInput?(0,s.asPromise)(()=>this._validateInput(t)):Promise.resolve(void 0)}async showWorkspaceFolderPick(t,a=I.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!g)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(_=>_.uri.toString()===g.uri.toString())}createQuickPick(t){const a=new r(t,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(t){const a=new i(t,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(t,a){const g=this._sessions.get(t);g&&g._fireDidChangeValue(a)}$onDidAccept(t){const a=this._sessions.get(t);a&&a._fireDidAccept()}$onDidChangeActive(t,a){const g=this._sessions.get(t);g instanceof r&&g._fireDidChangeActive(a)}$onDidChangeSelection(t,a){const g=this._sessions.get(t);g instanceof r&&g._fireDidChangeSelection(a)}$onDidTriggerButton(t,a){const g=this._sessions.get(t);g&&g._fireDidTriggerButton(a)}$onDidTriggerItemButton(t,a,g){const f=this._sessions.get(t);f instanceof r&&f._fireDidTriggerItemButton(a,g)}$onDidHide(t){const a=this._sessions.get(t);a&&a._fireDidHide()}}class u{constructor(t,a){this._extensionId=t,this._onDidDispose=a,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((a,g)=>{const f=a===y.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(f,a)}),this.update({buttons:t.map((a,g)=>({...T(a),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const a=this._handlesToButtons.get(t);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,B.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(t){if(!this._disposed){for(const a of Object.keys(t)){const g=t[a];this._pendingUpdate[a]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}u._nextId=1;function E(c){if(c instanceof y.ThemeIcon)return{id:c.id};const t=o(c),a=w(c);return{dark:typeof t=="string"?A.URI.file(t):t,light:typeof a=="string"?A.URI.file(a):a}}function w(c){return typeof c=="object"&&"light"in c?c.light:c}function o(c){return typeof c=="object"&&"dark"in c?c.dark:c}function T(c){const t=E(c.iconPath);let a,g;return"id"in t?g=d.ThemeIcon.asClassName(t):a=t,{iconPath:a,iconClass:g}}class r extends u{constructor(t,a){super(t.identifier,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((g,f)=>{this._handlesToItems.set(f,g),this._itemsToHandles.set(g,f)});const a=[];for(let g=0;g<t.length;g++){const f=t[g];f.kind===y.QuickPickItemKind.Separator?a.push({type:"separator",label:f.label}):a.push({handle:g,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons?.map((_,P)=>({...T(_),tooltip:_.tooltip,handle:P}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(t){const a=(0,N.coalesce)(t.map(g=>this._handlesToItems.get(g)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(t){const a=(0,N.coalesce)(t.map(g=>this._handlesToItems.get(g)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(t,a){const g=this._handlesToItems.get(t);if(!g||!g.buttons||!g.buttons.length)return;const f=g.buttons[a];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:g})}}class i extends u{constructor(t,a){super(t,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?p.default.Error:p.default.Ignore})}}return new k(n,h)}e.createExtHostQuickOpen=m});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[200],be([1,0,2,5,52,6,13,4,16,107,12,25,57,8,28]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l){"use strict";var n,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(g){if(g)return typeof g.iconPath=="string"?s.URI.file(g.iconPath):s.URI.isUri(g.iconPath)||d.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function k(g,f){if(!g.iconPath&&!f.iconPath)return 0;if(g.iconPath){if(!f.iconPath)return 1}else return-1;const _=typeof g.iconPath=="string"?g.iconPath:s.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,P=typeof f.iconPath=="string"?f.iconPath:s.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,F.comparePaths)(_,P)}function u(g,f){let _=0;if(g.strikeThrough!==f.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==f.faded)return g.faded?1:-1;if(g.tooltip!==f.tooltip)return(g.tooltip||"").localeCompare(f.tooltip||"");if(_=k(g,f),_!==0)return _;if(g.light&&f.light)_=k(g.light,f.light);else{if(g.light)return 1;if(f.light)return-1}if(_!==0)return _;if(g.dark&&f.dark)_=k(g.dark,f.dark);else{if(g.dark)return 1;if(f.dark)return-1}return _}function E(g,f){if(g.command!==f.command)return g.command<f.command?-1:1;if(g.title!==f.title)return g.title<f.title?-1:1;if(g.tooltip!==f.tooltip){if(g.tooltip!==void 0&&f.tooltip!==void 0)return g.tooltip<f.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(g.arguments===f.arguments)return 0;if(g.arguments)if(f.arguments){if(g.arguments.length!==f.arguments.length)return g.arguments.length-f.arguments.length}else return 1;else return-1;for(let _=0;_<g.arguments.length;_++){const P=g.arguments[_],$=f.arguments[_];if(P!==$)return P<$?-1:1}return 0}function w(g,f){let _=(0,F.comparePaths)(g.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(_!==0)return _;if(g.command&&f.command)_=E(g.command,f.command);else{if(g.command)return 1;if(f.command)return-1}if(_!==0)return _;if(g.decorations&&f.decorations)_=u(g.decorations,f.decorations);else{if(g.decorations)return 1;if(f.decorations)return-1}return _}function o(g,f){for(let _=0;_<g.length;_++)if(g[_]!==f[_])return!1;return!0}function T(g,f){return g.command===f.command&&g.title===f.title&&g.tooltip===f.tooltip&&(g.arguments&&f.arguments?o(g.arguments,f.arguments):g.arguments===f.arguments)}function r(g,f){return(0,y.equals)(g,f,T)}class i{constructor(f,_,P){this._extension=f,this._sourceControlHandle=P,n.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0,Ve(this,n,_,"f")}get value(){return this._value}set value(f){f=f??"",ye(this,n,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){ye(this,n,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,ye(this,n,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,ye(this,n,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,_){(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),ye(this,n,"f").$showValidationMessage(this._sourceControlHandle,f,_)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=i,n=new WeakMap;class c{constructor(f,_,P,$,L){this._proxy=f,this._commands=_,this._sourceControlHandle=P,this._id=$,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,_){const P=this._resourceStatesCommandsMap.get(f);return P?(0,D.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(w),P=(0,y.sortedDiff)(this._resourceSnapshot,f,w).map(v=>{const H=v.toInsert.map(W=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,W);const K=W.resourceUri;let V;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ge=new B.DisposableStore;V=this._commands.converter.toInternal(W.command,ge),this._resourceStatesDisposablesMap.set(q,ge)}else this._resourceStatesCommandsMap.set(q,W.command);const z=S(W.decorations),ae=W.decorations&&S(W.decorations.light)||z,de=W.decorations&&S(W.decorations.dark)||z,Y=[ae,de],ie=W.decorations&&W.decorations.tooltip||"",ce=W.decorations&&!!W.decorations.strikeThrough,he=W.decorations&&!!W.decorations.faded,ue=W.contextValue||"";return{rawResource:[q,K,Y,ie,ce,he,ue,V],handle:q}});return{start:v.start,deleteCount:v.deleteCount,toInsert:H}}),$=P.map(({start:v,deleteCount:H,toInsert:W})=>[v,H,W.map(q=>q.rawResource)]),L=P.reverse();for(const{start:v,deleteCount:H,toInsert:W}of L){const q=W.map(V=>V.handle),K=this._handlesSnapshot.splice(v,H,...q);for(const V of K)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=f,$}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class t{constructor(f,_,P,$,L,v){this._extension=f,this._commands=P,this._id=$,this._label=L,this._rootUri=v,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new B.MutableDisposable,this._statusBarDisposables=new B.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ve(this,h,_,"f"),this._inputBox=new i(f,ye(this,h,"f"),this.handle),ye(this,h,"f").$registerSourceControl(this.handle,$,L,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,ye(this,h,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,ye(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,ye(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new B.DisposableStore,this._acceptInputCommand=f;const _=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);ye(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new B.DisposableStore,this._actionButton=f;const _=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),description:f.description}:void 0;ye(this,h,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&r(this._statusBarCommands,f))return;this._statusBarDisposables.value=new B.DisposableStore,this._statusBarCommands=f;const _=(f||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));ye(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}createResourceGroup(f,_){const P=new c(ye(this,h,"f"),this._commands,this.handle,f,_),$=I.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,$),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const f=[],_=[];for(const[P,$]of this.createdResourceGroups){$.dispose();const L=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});I.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),L.dispose(),this._groups.delete(P.handle),ye(this,h,"f").$unregisterGroup(this.handle,P.handle)}),f.push([P.handle,P.id,P.label,P.features]);const v=P._takeResourceStateSnapshot();v.length>0&&_.push([P.handle,v]),this._groups.set(P.handle,P)}ye(this,h,"f").$registerGroups(this.handle,f,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(_=>{const P=_._takeResourceStateSnapshot();P.length!==0&&f.push([_.handle,P])}),f.length>0&&ye(this,h,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),ye(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,t._handlePool=0,Fe([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Fe([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let a=class Vi{constructor(f,_,P){this._commands=_,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=f.getProxy(A.MainContext.MainThreadSCM),this._telemetry=f.getProxy(A.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===3){const L=this._sourceControls.get($.sourceControlHandle);if(!L)return $;const v=L.getResourceGroup($.groupHandle);return v?v.getResourceState($.handle):$}else if($&&$.$mid===4){const L=this._sourceControls.get($.sourceControlHandle);return L?L.getResourceGroup($.groupHandle):$}else if($&&$.$mid===5){const L=this._sourceControls.get($.handle);return L||$}return $}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,_,P,$){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,_,P,$),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const L=Vi._handlePool++,v=new t(f,this._proxy,this._commands,_,P,$);this._sourceControls.set(L,v);const H=this._sourceControlsByExtension.get(p.ExtensionIdentifier.toKey(f.identifier))||[];return H.push(v),this._sourceControlsByExtension.set(p.ExtensionIdentifier.toKey(f.identifier),H),v}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const _=this._sourceControlsByExtension.get(p.ExtensionIdentifier.toKey(f.identifier)),P=_&&_[_.length-1];return P&&P.inputBox}$provideOriginalResource(f,_,P){const $=s.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,$.toString());const L=this._sourceControls.get(f);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>L.quickDiffProvider.provideOriginalResource($,P)).then(v=>v||null)}$onInputBoxValueChange(f,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const P=this._sourceControls.get(f);return P&&P.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(f,_,P,$){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,_,P);const L=this._sourceControls.get(f);if(!L)return Promise.resolve(void 0);const v=L.getResourceGroup(_);return v?v.$executeResourceCommand(P,$):Promise.resolve(void 0)}$validateInput(f,_,P){this.logService.trace("ExtHostSCM#$validateInput",f);const $=this._sourceControls.get(f);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>$.inputBox.validateInput(_,P)).then(L=>{if(!L)return Promise.resolve(void 0);const v=m.MarkdownString.fromStrict(L.message);return v?Promise.resolve([v,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};a._handlePool=0,a=Fe([Ne(2,N.ILogService)],a),e.ExtHostSCM=a});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[201],be([1,0,7,4,125,6,8,11]),function(Z,e,s,I,b,B,D,A){"use strict";var y,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(l,n,h,S,k=s.StatusBarAlignment.Left,u){y.set(this,void 0),F.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new B.DisposableStore,Ve(this,y,l,"f"),Ve(this,F,n,"f"),this._entryId=N.ID_GEN++,this._extension=h,this._id=S,this._alignment=k,this._priority=this.validatePriority(u)}validatePriority(l){if(!!(0,A.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!N.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:ye(this,F,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:ye(this,F,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,ye(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let n;this._name?n=this._name:n=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=D.MarkdownString.fromStrict(this._tooltip);ye(this,y,"f").$setEntry(this._entryId,l,n,this._text,S,this._command?.internal,h,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=N,y=new WeakMap,F=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class p{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const n={message:l};return this._messages.unshift(n),this._update(),new s.Disposable(()=>{const h=this._messages.indexOf(n);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class d{constructor(l,n){this._proxy=l.getProxy(I.MainContext.MainThreadStatusBar),this._commands=n,this._statusMessage=new p(this)}createStatusBarEntry(l,n,h,S){return new N(this._proxy,this._commands,l,n,h,S)}setStatusBarMessage(l,n){const h=this._statusMessage.setMessage(l);let S;return typeof n=="number"?S=setTimeout(()=>h.dispose(),n):typeof n!="undefined"&&n.then(()=>h.dispose(),()=>h.dispose()),new s.Disposable(()=>{h.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=d}),define(we[67],be([1,0,4,5,3]),function(Z,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class B{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,F){return this._proxy.$initializeExtensionStorage(A,y).then(N=>N||F)}setValue(A,y,F){return this._proxy.$setValue(A,y,F)}$acceptValue(A,y,F){this._onDidChangeStorage.fire({shared:A,key:y,value:F})}}e.ExtHostStorage=B,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(we[68],be([1,0,3,27,12,50,2]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let A=class{constructor(F,N,p){this._logService=N,this._extHostFileSystem=p,this._workspace=F.workspace??void 0,this._environment=F.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getWorkspaceStorageURI(F){return D.URI.joinPath(this._environment.workspaceStorageHome,F)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const F=this._workspace.id,N=await this._getWorkspaceStorageURI(F);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(p){this._logService.error("[ExtHostStorage]",p);return}}workspaceValue(F){if(this._value)return D.URI.joinPath(this._value,F.identifier.value)}globalValue(F){return D.URI.joinPath(this._environment.globalStorageHome,F.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Fe([Ne(0,I.IExtHostInitDataService),Ne(1,b.ILogService),Ne(2,B.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(we[40],be([1,0,5,4,3,2,14,6,7,126,15,165,20,36,145,57,11,13]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class k{constructor(t,a,g,f){this._proxy=t,this._id=a,this._creationOptions=g,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(P,$=!0){_._checkDisposed(),_._proxy.$sendText(_._id,P,$)},show(P){_._checkDisposed(),_._proxy.$show(_._id,P)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(t,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,h.withNullAsUndefined)(t.shellPath),shellArgs:(0,h.withNullAsUndefined)(t.shellArgs),cwd:(0,h.withNullAsUndefined)(t.cwd),env:(0,h.withNullAsUndefined)(t.env),icon:(0,h.withNullAsUndefined)(r(t.iconPath)),color:n.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,h.withNullAsUndefined)(t.message),strictEnv:(0,h.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(t.location,a?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,a,g,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:n.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(t,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,a){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,a){return t===this._cols&&a===this._rows||t===0||a===0?!1:(this._cols=t,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=k;class u{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,a){this._pty.setDimensions?.({columns:t,rows:a})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=u;let E=1,w=class extends A.Disposable{constructor(t,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[g,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,a){const g=new k(this._proxy,(0,m.generateUuid)(),t,t.name),f=new u(t.pty);return g.createExtensionTerminal(t.location,this._serializeParentTerminal(t,a).resolvedExtHostIdentifier,r(t.iconPath),i(t.color)).then(_=>{const P=this._setupExtHostProcessListeners(_,f);this._terminalProcessDisposables[_]=P}),this._terminals.push(g),g.value}_serializeParentTerminal(t,a){if(a=a||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const g=t.location.parentTerminal;if(g){const f=this._terminals.find(_=>_.value===g);f&&(a.resolvedExtHostIdentifier=f._id)}}else t.location&&typeof t.location!="object"?a.location=t.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(t,a){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const f=new u(a),_=this._setupExtHostProcessListeners(t,f);this._terminalProcessDisposables[t]=_}async $acceptActiveTerminalChanged(t){const a=this._activeTerminal;if(t===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(t);g&&(this._activeTerminal=g,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,a){const g=this._getTerminalById(t);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:a})}async $acceptTerminalDimensions(t,a,g){const f=this._getTerminalById(t);f&&f.setDimensions(a,g)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(t,a,g){this._terminalProcesses.get(t)?.resize(a,g)}async $acceptTerminalTitleChange(t,a){const g=this._getTerminalById(t);g&&(g.name=a)}async $acceptTerminalClosed(t,a){const g=this._getTerminalObjectIndexById(this._terminals,t);if(g!==null){const f=this._terminals.splice(g,1)[0];f.setExitCode(a),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(t,a,g,f){if(a){const $=this._getTerminalObjectIndexById(this._terminals,a);if($!==null){this._terminals[$]._id=t,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const _={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:B.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},P=new k(this._proxy,t,_,g);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(t,a){const g=this._getTerminalById(t);g&&g._setProcessId(a)}async $startExtensionTerminal(t,a){const g=this._getTerminalById(t);if(!g)return{message:(0,F.localize)(0,null,t)};g.isOpen||await new Promise(_=>{const P=this.onDidOpenTerminal(async $=>{$===g.value&&(P.dispose(),_())})});const f=this._terminalProcesses.get(t);f?f.startSendingEvents(a):this._extensionTerminalAwaitingStart[t]={initialDimensions:a}}_setupExtHostProcessListeners(t,a){const g=new A.DisposableStore;g.add(a.onProcessReady(_=>this._proxy.$sendProcessReady(t,_.pid,_.cwd))),g.add(a.onDidChangeProperty(_=>this._proxy.$sendProcessProperty(t,_))),this._bufferer.startBuffering(t,a.onProcessData),g.add(a.onProcessExit(_=>this._onProcessExit(t,_))),this._terminalProcesses.set(t,a);const f=this._extensionTerminalAwaitingStart[t];return f&&a instanceof u&&(a.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),g}$acceptProcessAckDataEvent(t,a){this._terminalProcesses.get(t)?.acknowledgeDataEvent(a)}$acceptProcessInput(t,a){this._terminalProcesses.get(t)?.input(a)}$acceptTerminalInteraction(t){const a=this._getTerminalById(t);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(t,a,g){try{this._terminalProcesses.get(t)?.resize(a,g)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(t,a){this._terminalProcesses.get(t)?.shutdown(a)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:a}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,a,g){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,g),this._proxy.$registerProfileProvider(a,t.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(t,a){const g=new d.CancellationTokenSource().token;let f=await this._profileProviders.get(t)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,a);return}this.createTerminalFromOptions(f.options,a)}}async $provideLinks(t,a){const g=this._getTerminalById(t);if(!g)return[];this._terminalLinkCache.delete(t);const f=this._terminalLinkCancellationSource.get(t);f&&f.dispose(!0);const _=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,_);const P=[],$={terminal:g.value,line:a},L=[];for(const W of this._linkProviders)L.push(S.Promises.withAsyncBody(async q=>{_.token.onCancellationRequested(()=>q({provider:W,links:[]}));const K=await W.provideTerminalLinks($,_.token)||[];_.token.isCancellationRequested||q({provider:W,links:K})}));const v=await Promise.all(L);if(_.token.isCancellationRequested)return[];const H=new Map;for(const W of v)W&&W.links.length>0&&P.push(...W.links.map(q=>{const K={id:E++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return H.set(K.id,{provider:W.provider,link:q}),K}));return this._terminalLinkCache.set(t,H),P}$activateLink(t,a){const g=this._terminalLinkCache.get(t)?.get(a);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(t,a){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const g=this._terminalProcessDisposables[t];g&&(g.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,a)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,a){const g=this._getTerminalObjectIndexById(t,a);return g!==null?t[g]:null}_getTerminalObjectIndexById(t,a){let g=null;return t.some((f,_)=>f._id===a?(g=_,!0):!1),g}getEnvironmentVariableCollection(t){let a=this._environmentVariableCollections.get(t.identifier.value);return a||(a=new o,this._setEnvironmentVariableCollection(t.identifier.value,a)),a}_syncEnvironmentVariableCollection(t,a){const g=(0,p.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(t,a.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(t){t.forEach(a=>{const g=a[0],f=new o(a[1]);this._setEnvironmentVariableCollection(g,f)})}$acceptDefaultProfile(t,a){this._defaultProfile=t,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(t,a){this._environmentVariableCollections.set(t,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,a)})}};w=Fe([Ne(1,D.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class o{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,a){this._setIfDiffers(t,{value:a,type:y.EnvironmentVariableMutatorType.Replace})}append(t,a){this._setIfDiffers(t,{value:a,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,a){this._setIfDiffers(t,{value:a,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,a){const g=this.map.get(t);(!g||g.value!==a.value||g.type!==a.type)&&(this.map.set(t,a),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,a){this.map.forEach((g,f)=>t.call(a,f,g,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let T=class extends w{constructor(t){super(!1,t)}createTerminal(t,a,g){throw new N.NotSupportedError}createTerminalFromOptions(t,a){throw new N.NotSupportedError}};T=Fe([Ne(0,D.IExtHostRpcService)],T),e.WorkerExtHostTerminalService=T;function r(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function i(c){return n.ThemeColor.isThemeColor(c)?c:void 0}});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[202],be([1,0,16,21,20,5,233,93,6,26,11,36,4,14,47,8,7,171,62,63]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u){"use strict";var E,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(L,v){this.resultsChangedEmitter=new B.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(d.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new r(this.proxy),v.registerArgumentProcessor({processArgument:H=>H?.$mid===13?n.TestItem.toItemFromContext(H):H})}createTestController(L,v,H){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const W=new y.DisposableStore,q=W.add(new S.SingleUseTestCollection(L));q.root.label=v;const K=new Map,V=this.proxy,z={items:q.root.children,get label(){return v},set label(de){v=de,q.root.label=de,V.$updateController(L,{label:v})},get refreshHandler(){return H},set refreshHandler(de){H=de,V.$updateController(L,{canRefresh:!!de})},get id(){return L},createRunProfile:(de,Y,ie,ce,he)=>{let ue=(0,A.hash)(de);for(;K.has(ue);)ue++;return new _(this.proxy,K,L,ue,de,Y,ie,ce,he)},createTestItem(de,Y,ie){return new l.TestItemImpl(L,de,Y,ie)},createTestRun:(de,Y,ie=!0)=>this.runTracker.createTestRun(L,q,de,Y,ie),set resolveHandler(de){q.resolveHandler=de},get resolveHandler(){return q.resolveHandler},dispose:()=>{W.dispose()}};V.$registerTestController(L,v,!!H),W.add((0,y.toDisposable)(()=>V.$unregisterTestController(L)));const ae={controller:z,collection:q,profiles:K};return this.controllers.set(L,ae),W.add((0,y.toDisposable)(()=>this.controllers.delete(L))),W.add(q.onDidGenerateDiff(de=>V.$publishDiff(L,de.map(k.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(L,v=b.CancellationToken.None){const H=i(L);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(H.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(q=>u.TestId.fromExtHostTestItem(q,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:P[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:L.exclude?.map(q=>q.id)},v)}$provideFileCoverage(L,v,H){return(0,s.mapFind)(this.runTracker.trackers,q=>q.id===L?q.getCoverage(v):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(L,v,H,W){return(0,s.mapFind)(this.runTracker.trackers,K=>K.id===L?K.getCoverage(v):void 0)?.resolveFileCoverage(H,W)??Promise.resolve([])}$configureRunProfile(L,v){this.controllers.get(L)?.profiles.get(v)?.configureHandler?.()}async $refreshTests(L,v){await this.controllers.get(L)?.controller.refreshHandler?.(v)}$publishTestResults(L){this.results=Object.freeze(L.map(v=>(0,F.deepFreeze)(n.TestResults.to(v))).concat(this.results).sort((v,H)=>H.completedAt-v.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,v){const H=this.controllers.get(u.TestId.fromString(L).controllerId)?.collection;H&&(await H.expand(L,v<0?1/0:v),H.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(k.TestsDiffOp.deserialize))}async $runControllerTests(L,v){const H=this.controllers.get(L.controllerId);if(!H)return;const{collection:W,profiles:q}=H,K=q.get(L.profileId);if(!K)return;const V=L.testIds.map(Y=>W.tree.get(Y)).filter(N.isDefined),z=L.excludeExtIds.map(Y=>H.collection.tree.get(Y)).filter(N.isDefined).filter(Y=>V.some(ie=>ie.fullId.compare(Y.fullId)===2));if(!V.length)return;const ae=new h.TestRunRequest(V.some(Y=>Y.actual instanceof l.TestItemRootImpl)?void 0:V.map(Y=>Y.actual),z.map(Y=>Y.actual),K),de=this.runTracker.prepareForMainThreadTestRun(ae,c.fromInternal(L,H.collection),v);try{await K.runHandler(ae,v)}finally{de.isRunning&&!v.isCancellationRequested&&await B.Event.toPromise(de.onEnd),de.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};o=Fe([Ne(0,m.IExtHostRpcService)],o),e.ExtHostTesting=o;class T extends y.Disposable{constructor(L,v,H){super();this.dto=L,this.proxy=v,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new B.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(H)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:W}of this.tasks.values())W.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const v=this.dto.id,H=this.dto.controllerId,W=(0,p.generateUuid)(),q=new t(this.proxy,v,W),K=de=>(Y,...ie)=>{if(z){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Y)||(this.ensureTestIsKnown(Y),de(Y,...ie))},V=(de,Y)=>{const ie=Y instanceof Array?Y.map(n.TestMessage.from):[n.TestMessage.from(Y)];if(de.uri&&de.range){const ce={range:n.Range.from(de.range),uri:de.uri};for(const he of ie)he.location=he.location||ce}this.proxy.$appendTestMessagesInRun(v,W,u.TestId.fromExtHostTestItem(de,H).toString(),ie)};let z=!1;const ae={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return q.coverageProvider},set coverageProvider(de){q.coverageProvider=de},enqueued:K(de=>{this.proxy.$updateTestStateInRun(v,W,u.TestId.fromExtHostTestItem(de,H).toString(),1)}),skipped:K(de=>{this.proxy.$updateTestStateInRun(v,W,u.TestId.fromExtHostTestItem(de,H).toString(),5)}),started:K(de=>{this.proxy.$updateTestStateInRun(v,W,u.TestId.fromExtHostTestItem(de,H).toString(),2)}),errored:K((de,Y,ie)=>{V(de,Y),this.proxy.$updateTestStateInRun(v,W,u.TestId.fromExtHostTestItem(de,H).toString(),6,ie)}),failed:K((de,Y,ie)=>{V(de,Y),this.proxy.$updateTestStateInRun(v,W,u.TestId.fromExtHostTestItem(de,H).toString(),4,ie)}),passed:K((de,Y)=>{this.proxy.$updateTestStateInRun(v,W,u.TestId.fromExtHostTestItem(de,this.dto.controllerId).toString(),3,Y)}),appendOutput:(de,Y,ie)=>{z||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(v,W,I.VSBuffer.fromString(de),Y&&n.location.from(Y),ie&&u.TestId.fromExtHostTestItem(ie,H).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(v,W),this.tasks.delete(W),this.isRunning||this.dispose())}};return this.tasks.set(W,{run:ae,coverage:q}),this.proxy.$startedTestRunTask(v,{id:W,name:L,running:!0}),ae}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof l.TestItemImpl))throw new l.InvalidTestItemError(L.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const v=[],H=this.dto.colllection.root;for(;;){const W=n.TestItem.from(L);if(v.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),L===H))break;L=L.parent||H}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,v)}}class r{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,v,H){return this.getTracker(L,v,H)}cancelRunById(L){for(const v of this.tracked.values())if(v.id===L){v.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,v,H,W,q){const K=this.tracked.get(H);if(K)return K.createRun(W);const V=c.fromPublic(L,v,H,q),z=i(H);this.proxy.$startedExtensionTestRun({controllerId:L,profile:z&&{group:P[z.kind],id:z.profileId},exclude:H.exclude?.map(de=>u.TestId.fromExtHostTestItem(de,v.root.id).toString())??[],id:V.id,include:H.include?.map(de=>u.TestId.fromExtHostTestItem(de,v.root.id).toString())??[v.root.id],persist:q});const ae=this.getTracker(H,V);return ae.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),ae.createRun(W)}getTracker(L,v,H){const W=new T(v,this.proxy,H);return this.tracked.set(L,W),W.onEnd(()=>this.tracked.delete(L)),W}}e.TestRunCoordinator=r;const i=$=>{if(!!$.profile){if(!($.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class c{constructor(L,v,H,W,q,K){this.controllerId=L,this.id=v,this.isPersisted=q,this.colllection=K,this.includePrefix=H.map(V=>V+"\0"),this.excludePrefix=W.map(V=>V+"\0")}static fromPublic(L,v,H,W){return new c(L,(0,p.generateUuid)(),H.include?.map(q=>u.TestId.fromExtHostTestItem(q,L).toString())??[L],H.exclude?.map(q=>u.TestId.fromExtHostTestItem(q,L).toString())??[],W,v)}static fromInternal(L,v){return new c(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,v)}isIncluded(L){const v=u.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const H of this.excludePrefix)if(v===H||v.startsWith(H))return!1;for(const H of this.includePrefix)if(v===H||v.startsWith(H))return!0;return!1}}e.TestRunDto=c;class t{constructor(L,v,H){this.proxy=L,this.runId=v,this.taskId=H}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(v){throw this.fileCoverage=void 0,v}}async resolveFileCoverage(L,v){const H=await this.fileCoverage;let W=H?.[L];return!this._coverageProvider||!H||!W?[]:(W.detailedCoverage||(W=H[L]=await this._coverageProvider.resolveFileCoverage?.(W,v)??W),W.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class a extends k.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,n.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:v,removed:H}=this;return{get added(){return[...L].map(W=>W.revived)},get updated(){return[...v].map(W=>W.revived)},get removed(){return[...H].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends k.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new B.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,v){return{...L,revived:n.TestItem.toPlain(L.item),depth:v?v.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=g;class f{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(v=>v.revived)},dispose:(0,D.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class _{constructor(L,v,H,W,q,K,V,z=!1,ae=void 0){this.controllerId=H,this.profileId=W,this._label=q,this.kind=K,this.runHandler=V,this._isDefault=z,this._tag=ae,E.set(this,void 0),w.set(this,void 0),Ve(this,E,L,"f"),Ve(this,w,v,"f"),v.set(W,this);const de=P[K];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);ye(this,E,"f").$publishTestRunProfile({profileId:W,controllerId:H,tag:ae?n.TestTag.namespace(this.controllerId,ae.id):null,label:q,group:de,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,ye(this,E,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,ye(this,E,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,ye(this,E,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?n.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,ye(this,E,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){ye(this,w,"f")?.delete(this.profileId)&&(Ve(this,w,void 0,"f"),ye(this,E,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,E=new WeakMap,w=new WeakMap;const P={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(we[203],be([1,0,5,16,4,90,8,7]),function(Z,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(N,p){this._extHostDocumentsAndEditors=p,this._onDidChangeTextEditorSelection=new s.Emitter,this._onDidChangeTextEditorOptions=new s.Emitter,this._onDidChangeTextEditorVisibleRanges=new s.Emitter,this._onDidChangeTextEditorViewColumn=new s.Emitter,this._onDidChangeActiveTextEditor=new s.Emitter,this._onDidChangeVisibleTextEditors=new s.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const p=this._extHostDocumentsAndEditors.allEditors();return N?p:p.map(d=>d.value)}async showTextDocument(N,p,d){let m;typeof p=="number"?m={position:D.ViewColumn.from(p),preserveFocus:d}:typeof p=="object"?m={position:D.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?D.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(N.uri,m),n=l&&this._extHostDocumentsAndEditors.getEditor(l);if(n)return n.value;throw l?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,p){return new B.TextEditorDecorationType(this._proxy,N,p).value}$acceptEditorPropertiesChanged(N,p){const d=this._extHostDocumentsAndEditors.getEditor(N);if(!d)throw new Error("unknown text editor");if(p.options&&d._acceptOptions(p.options),p.selections){const m=p.selections.selections.map(D.Selection.to);d._acceptSelections(m)}if(p.visibleRanges){const m=I.coalesce(p.visibleRanges.map(D.Range.to));d._acceptVisibleRanges(m)}if(p.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:{...p.options,lineNumbers:D.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const m=A.TextEditorSelectionChangeKind.fromValue(p.selections.source),l=p.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:l,kind:m})}if(p.visibleRanges){const m=I.coalesce(p.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:m})}}$acceptEditorPositionData(N){for(const p in N){const d=this._extHostDocumentsAndEditors.getEditor(p);if(!d)throw new Error("Unknown text editor");const m=D.ViewColumn.to(N[p]);d.value.viewColumn!==m&&(d._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:m}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=y}),define(we[204],be([1,0,2,3,4,6,7,8,11]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class F{constructor(d,m){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=d.getProxy(b.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const n=l.uri===void 0?void 0:s.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(N(n))?.get(l.handle)}return l}})}async $getTimeline(d,m,l,n,h){return this._providers.get(d)?.provideTimeline(s.URI.revive(m),l,n,h)}registerTimelineProvider(d,m,l,n){const h=new B.DisposableStore,S=this.convertTimelineItem(m.id,n,h).bind(this);let k;m.onDidChange&&(k=m.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:m.id}),this));const u=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...m,scheme:d,onDidChange:void 0,async provideTimeline(E,w,o,T){T?.resetCache&&(h.clear(),u.get(m.id)?.clear());const r=await m.provideTimeline(E,w,o);if(r==null)return;const i=S(E,T);return{...r,source:m.id,items:r.items.map(i)}},dispose(){for(const E of u.values())E.get(m.id)?.clear();k?.dispose(),h.dispose()}})}convertTimelineItem(d,m,l){return(n,h)=>{let S;if(h?.cacheResults){let k=this._itemsBySourceAndUriMap.get(d);k===void 0&&(k=new Map,this._itemsBySourceAndUriMap.set(d,k));const u=N(n);S=k.get(u),S===void 0&&(S=new Map,k.set(u,S))}return k=>{const{iconPath:u,...E}=k,w=`${d}|${k.id??k.timestamp}`;S?.set(w,k);let o,T,r;k.iconPath&&(u instanceof D.ThemeIcon?r={id:u.id,color:u.color}:s.URI.isUri(u)?(o=u,T=u):{light:o,dark:T}=u);let i;return D.MarkdownString.isMarkdownString(E.detail)?i=A.MarkdownString.from(E.detail):(0,y.isString)(E.detail)&&(i=E.detail),{...E,id:E.id??void 0,handle:w,source:d,command:k.command?m.toInternal(k.command,l):void 0,icon:o,iconDark:T,themeIcon:r,detail:i,accessibilityInformation:k.accessibilityInformation}}}}registerTimelineProviderCore(d){if(this._providers.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this._proxy.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this._providers.set(d.id,d),(0,B.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(d.id)?.clear();this._providers.delete(d.id),this._proxy.$unregisterTimelineProvider(d.id),d.dispose()})}}e.ExtHostTimeline=F;function N(p){return p?.toString()}}),define(we[205],be([1,0,6,10,2,4]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(B.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,F,N,p){if(this._openers.has(F))throw new Error(`Opener with id '${F}' already registered`);const d=p.schemes.find(m=>!D.supportedSchemes.has(m));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(F,N),this._proxy.$registerUriOpener(F,p.schemes,y,p.label),(0,s.toDisposable)(()=>{this._openers.delete(F),this._proxy.$unregisterUriOpener(F)})}async $canOpenUri(y,F,N){const p=this._openers.get(y);if(!p)throw new Error(`Unknown opener with id: ${y}`);const d=b.URI.revive(F);return p.canOpenExternalUri(d,N)}async $openUri(y,F,N){const p=this._openers.get(y);if(!p)throw new Error(`Unknown opener id: '${y}'`);return p.openExternalUri(b.URI.revive(F.resolvedUri),{sourceUri:b.URI.revive(F.sourceUri)},N)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(we[206],be([1,0,4,2,6,15,25]),function(Z,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(F){this.handles=new Set,this.handlers=new Map,this._proxy=F.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(F,N){if(this.handles.has(D.ExtensionIdentifier.toKey(F)))throw new Error(`Protocol handler already registered for extension ${F}`);const p=A.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(F)),this.handlers.set(p,N),this._proxy.$registerUriHandler(p,F),(0,b.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(F)),this.handlers.delete(p),this._proxy.$unregisterUriHandler(p)})}$handleExternalUri(F,N){const p=this.handlers.get(F);if(!p)return Promise.resolve(void 0);try{p.handleUri(I.URI.revive(N))}catch(d){(0,B.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(F){return I.URI.revive(await this._proxy.$createAppUri(F))}}e.ExtHostUrls=A,A.HandlePool=0});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[51],be([1,0,5,10,2,136,154,61,4]),function(Z,e,s,I,b,B,D,A,y){"use strict";var F,N,p,d,m,l,n,h,S,k,u,E;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(g,f,_,P,$,L,v){F.set(this,void 0),N.set(this,void 0),p.set(this,void 0),d.set(this,void 0),m.set(this,void 0),l.set(this,void 0),n.set(this,""),h.set(this,void 0),S.set(this,!1),k.set(this,!1),u.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,E.set(this,new s.Emitter),this._onDidDispose=ye(this,E,"f").event,Ve(this,F,g,"f"),Ve(this,N,f,"f"),Ve(this,h,_,"f"),Ve(this,d,P,"f"),Ve(this,m,$,"f"),Ve(this,l,L,"f"),Ve(this,u,o(L),"f"),Ve(this,p,v,"f")}dispose(){Ve(this,S,!0,"f"),ye(this,E,"f").fire(),ye(this,E,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Ve(this,k,!0,"f"),(0,A.asWebviewUri)(g,ye(this,d,"f").remote)}get cspSource(){const g=ye(this,l,"f").extensionLocation;if(g.scheme===I.Schemas.https||g.scheme===I.Schemas.http){let f=g.toString();return f.endsWith("/")||(f+="/"),f+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),ye(this,n,"f")}set html(g){this.assertNotDisposed(),ye(this,n,"f")!==g&&(Ve(this,n,g,"f"),!ye(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Ve(this,k,!0,"f"),ye(this,p,"f").report("Webview vscode-resource: uris",ye(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),ye(this,N,"f").$setHtml(ye(this,F,"f"),g))}get options(){return this.assertNotDisposed(),ye(this,h,"f")}set options(g){this.assertNotDisposed(),ye(this,N,"f").$setOptions(ye(this,F,"f"),i(ye(this,l,"f"),ye(this,m,"f"),g)),Ve(this,h,g,"f")}async postMessage(g){if(ye(this,S,"f"))return!1;const f=(0,D.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:ye(this,u,"f")});return ye(this,N,"f").$postMessage(ye(this,F,"f"),f.message,...f.buffers)}assertNotDisposed(){if(ye(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,F=new WeakMap,N=new WeakMap,p=new WeakMap,d=new WeakMap,m=new WeakMap,l=new WeakMap,n=new WeakMap,h=new WeakMap,S=new WeakMap,k=new WeakMap,u=new WeakMap,E=new WeakMap;function o(a){try{const g=(0,B.normalizeVersion)((0,B.parseVersion)(a.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class T{constructor(g,f,_,P,$){this.initData=f,this.workspace=_,this._logService=P,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=g.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(g,f,_){const P=this.getWebview(g);if(P){const{message:$}=(0,D.deserializeWebviewMessage)(f,_.value);P._onMessageEmitter.fire($)}}$onMissingCsp(g,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,f,_){const P=new w(g,this._webviewProxy,c(f),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(g,P),P._onDidDispose(()=>{this._webviews.delete(g)}),P}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=T;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=r;function i(a,g,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||t(a,g)}}e.serializeWebviewOptions=i;function c(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(g=>b.URI.from(g))}}e.reviveOptions=c;function t(a,g){return[...(g?.getWorkspaceFolders()||[]).map(f=>f.uri),a.extensionLocation]}}),define(we[207],be([1,0,20,93,6,10,24,2,8,51,58,4,7]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(o,T){this.document=o,this._storagePath=T,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,T){await this.getEdit(o).undo(),T||this.disposeBackup()}async redo(o,T){await this.getEdit(o).redo(),T||this.disposeBackup()}disposeEdits(o){for(const T of o)this._edits.delete(T)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=E(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const T=this._edits.get(o,0);if(!T)throw new Error("No edit found");return T}}class l{constructor(){this._documents=new Map}get(o,T){return this._documents.get(this.key(o,T))}add(o,T,r){const i=this.key(o,T.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${o} resource:${T.uri}`);const c=new m(T,r);return this._documents.set(i,c),c}delete(o,T){const r=this.key(o,T.uri);this._documents.delete(r)}key(o,T){return`${o}@@@${T}`}}var n;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(n||(n={}));class h{constructor(){this._providers=new Map}addTextProvider(o,T,r){return this.add(0,o,T,r)}addCustomProvider(o,T,r){return this.add(1,o,T,r)}get(o){return this._providers.get(o)}add(o,T,r,i){if(this._providers.has(T))throw new Error(`Provider for viewType:${T} already registered`);return this._providers.set(T,{type:o,extension:r,provider:i}),new d.Disposable(()=>this._providers.delete(T))}}class S{constructor(o,T,r,i,c){this._extHostDocuments=T,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new h,this._documents=new l,this._proxy=o.getProxy(p.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,T,r,i){const c=new b.DisposableStore;return k(r)?(c.add(this._editorProviders.addTextProvider(T,o,r)),this._proxy.$registerTextEditorProvider((0,F.toExtensionData)(o),T,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,F.shouldSerializeBuffersForPostMessage)(o))):(c.add(this._editorProviders.addCustomProvider(T,o,r)),this.supportEditing(r)&&c.add(r.onDidChangeCustomDocument(t=>{const a=this.getCustomDocumentEntry(T,t.document.uri);if(u(t)){const g=a.addEdit(t);this._proxy.$onDidEdit(t.document.uri,T,g,t.label)}else this._proxy.$onContentChange(t.document.uri,T)})),this._proxy.$registerCustomEditorProvider((0,F.toExtensionData)(o),T,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,F.shouldSerializeBuffersForPostMessage)(o))),d.Disposable.from(c,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(T)}))}async $createCustomDocument(o,T,r,i,c){const t=this._editorProviders.get(T);if(!t)throw new Error(`No provider found for '${T}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${T}'`);const a=A.URI.revive(o),g=await t.provider.openCustomDocument(a,{backupId:r,untitledDocumentData:i?.buffer},c);let f;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(T,g,f),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(o,T){const r=this._editorProviders.get(T);if(!r)throw new Error(`No provider found for '${T}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${T}'`);const i=A.URI.revive(o),{document:c}=this.getCustomDocumentEntry(T,i);this._documents.delete(T,c),c.dispose()}async $resolveWebviewEditor(o,T,r,i,c,t){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);const g=y.ViewColumn.to(c),f=this._extHostWebview.createNewWebview(T,i.webviewOptions,a.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(T,r,i.title,g,i.panelOptions,f),P=A.URI.revive(o);switch(a.type){case 1:{const{document:$}=this.getCustomDocumentEntry(r,P);return a.provider.resolveCustomEditor($,_,t)}case 0:{const $=this._extHostDocuments.getDocument(P);return a.provider.resolveCustomTextEditor($,_,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,T,r){this.getCustomDocumentEntry(T,o).disposeEdits(r)}async $onMoveCustomEditor(o,T,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const c=this._extHostWebviewPanels.getWebviewPanel(o);if(!c)throw new Error("No webview found");const t=A.URI.revive(T),a=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(a,c,s.CancellationToken.None)}async $undo(o,T,r,i){return this.getCustomDocumentEntry(T,o).undo(r,i)}async $redo(o,T,r,i){return this.getCustomDocumentEntry(T,o).redo(r,i)}async $revert(o,T,r){const i=this.getCustomDocumentEntry(T,o);await this.getCustomEditorProvider(T).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(o,T,r){const i=this.getCustomDocumentEntry(T,o);await this.getCustomEditorProvider(T).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(o,T,r,i){const c=this.getCustomDocumentEntry(T,o);return this.getCustomEditorProvider(T).saveCustomDocumentAs(c.document,A.URI.revive(r),i)}async $backup(o,T,r){const i=this.getCustomDocumentEntry(T,o),t=await this.getCustomEditorProvider(T).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(t),t.id}getCustomDocumentEntry(o,T){const r=this._documents.get(o,A.URI.revive(T));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function k(w){return typeof w.resolveCustomTextEditor=="function"}function u(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function E(w){const o=w.scheme===B.Schemas.file||w.scheme===B.Schemas.untitled?w.fsPath:w.toString();return(0,I.hash)(o)+""}});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[208],be([1,0,5,6,2,36,8,51,4,7]),function(Z,e,s,I,b,B,D,A,y,F){"use strict";var N,p,d,m,l,n,h,S,k,u,E,w,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends I.Disposable{constructor(t,a,g,f,_,P,$){super();N.set(this,void 0),p.set(this,void 0),d.set(this,void 0),m.set(this,void 0),l.set(this,void 0),n.set(this,void 0),h.set(this,void 0),S.set(this,void 0),k.set(this,!0),u.set(this,!0),E.set(this,!1),w.set(this,this._register(new s.Emitter)),this.onDidDispose=ye(this,w,"f").event,o.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=ye(this,o,"f").event,Ve(this,N,t,"f"),Ve(this,p,a,"f"),Ve(this,d,g,"f"),Ve(this,l,P,"f"),Ve(this,S,_,"f"),Ve(this,n,f,"f"),Ve(this,m,$,"f")}dispose(){ye(this,E,"f")||(Ve(this,E,!0,"f"),ye(this,w,"f").fire(),ye(this,p,"f").$disposeWebview(ye(this,N,"f")),ye(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),ye(this,m,"f")}get viewType(){return this.assertNotDisposed(),ye(this,d,"f")}get title(){return this.assertNotDisposed(),ye(this,n,"f")}set title(t){this.assertNotDisposed(),ye(this,n,"f")!==t&&(Ve(this,n,t,"f"),ye(this,p,"f").$setTitle(ye(this,N,"f"),t))}get iconPath(){return this.assertNotDisposed(),ye(this,h,"f")}set iconPath(t){this.assertNotDisposed(),ye(this,h,"f")!==t&&(Ve(this,h,t,"f"),ye(this,p,"f").$setIconPath(ye(this,N,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return ye(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof ye(this,S,"f")=="number"&&ye(this,S,"f")<0))return ye(this,S,"f")}get active(){return this.assertNotDisposed(),ye(this,u,"f")}get visible(){return this.assertNotDisposed(),ye(this,k,"f")}_updateViewState(t){ye(this,E,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ve(this,u,t.active,"f"),Ve(this,k,t.visible,"f"),Ve(this,S,t.viewColumn,"f"),ye(this,o,"f").fire({webviewPanel:this}))}reveal(t,a){this.assertNotDisposed(),ye(this,p,"f").$reveal(ye(this,N,"f"),{viewColumn:typeof t=="undefined"?void 0:D.ViewColumn.from(t),preserveFocus:!!a})}assertNotDisposed(){if(ye(this,E,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,p=new WeakMap,d=new WeakMap,m=new WeakMap,l=new WeakMap,n=new WeakMap,h=new WeakMap,S=new WeakMap,k=new WeakMap,u=new WeakMap,E=new WeakMap,w=new WeakMap,o=new WeakMap;class r{constructor(t,a,g){this.webviews=a,this.workspace=g,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,B.generateUuid)()}createWebviewPanel(t,a,g,f,_={}){const P=typeof f=="object"?f.viewColumn:f,$={viewColumn:D.ViewColumn.from(P),preserveFocus:typeof f=="object"&&!!f.preserveFocus},L=(0,A.shouldSerializeBuffersForPostMessage)(t),v=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(t),v,a,{title:g,panelOptions:i(_),webviewOptions:(0,A.serializeWebviewOptions)(t,this.workspace,_),serializeBuffersForPostMessage:L},$);const H=this.webviews.createNewWebview(v,_,t);return this.createNewWebviewPanel(v,a,g,P,_,H)}$onDidChangeWebviewPanelViewStates(t){const a=Object.keys(t);a.sort((g,f)=>{const _=t[g],P=t[f];return _.active?1:P.active?-1:+_.visible-+P.visible});for(const g of a){const f=this.getWebviewPanel(g);if(!f)continue;const _=t[g];f._updateViewState({active:_.active,visible:_.visible,viewColumn:D.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,a,g){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:g,extension:t}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(t)}),new F.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(t,a,g,f){const _=this._serializers.get(a);if(!_)throw new Error(`No serializer found for '${a}'`);const{serializer:P,extension:$}=_,L=this.webviews.createNewWebview(t,g.webviewOptions,$),v=this.createNewWebviewPanel(t,a,g.title,f,g.panelOptions,L);await P.deserializeWebviewPanel(v,g.state)}createNewWebviewPanel(t,a,g,f,_,P){const $=new T(t,this._proxy,a,g,f,_,P);return this._webviewPanels.set(t,$),$}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[209],be([1,0,5,6,51,4,7]),function(Z,e,s,I,b,B,D){"use strict";var A,y,F,N,p,d,m,l,n,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends I.Disposable{constructor(E,w,o,T,r,i){super();A.set(this,void 0),y.set(this,void 0),F.set(this,void 0),N.set(this,void 0),p.set(this,!1),d.set(this,void 0),m.set(this,void 0),l.set(this,void 0),n.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=ye(this,n,"f").event,h.set(this,this._register(new s.Emitter)),this.onDidDispose=ye(this,h,"f").event,Ve(this,F,o,"f"),Ve(this,m,T,"f"),Ve(this,A,E,"f"),Ve(this,y,w,"f"),Ve(this,N,r,"f"),Ve(this,d,i,"f")}dispose(){ye(this,p,"f")||(Ve(this,p,!0,"f"),ye(this,h,"f").fire(),ye(this,N,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),ye(this,m,"f")}set title(E){this.assertNotDisposed(),ye(this,m,"f")!==E&&(Ve(this,m,E,"f"),ye(this,y,"f").$setWebviewViewTitle(ye(this,A,"f"),E))}get description(){return this.assertNotDisposed(),ye(this,l,"f")}set description(E){this.assertNotDisposed(),ye(this,l,"f")!==E&&(Ve(this,l,E,"f"),ye(this,y,"f").$setWebviewViewDescription(ye(this,A,"f"),E))}get visible(){return ye(this,d,"f")}get webview(){return ye(this,N,"f")}get viewType(){return ye(this,F,"f")}_setVisible(E){E===ye(this,d,"f")||ye(this,p,"f")||(Ve(this,d,E,"f"),ye(this,n,"f").fire())}show(E){this.assertNotDisposed(),ye(this,y,"f").$show(ye(this,A,"f"),!!E)}assertNotDisposed(){if(ye(this,p,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,y=new WeakMap,F=new WeakMap,N=new WeakMap,p=new WeakMap,d=new WeakMap,m=new WeakMap,l=new WeakMap,n=new WeakMap,h=new WeakMap;class k{constructor(E,w){this._extHostWebview=w,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=E.getProxy(B.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(E,w,o,T){if(this._viewProviders.has(w))throw new Error(`View provider for '${w}' already registered`);return this._viewProviders.set(w,{provider:o,extension:E}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(E),w,{retainContextWhenHidden:T?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(w),this._proxy.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(E,w,o,T,r){const i=this._viewProviders.get(w);if(!i)throw new Error(`No view provider found for '${w}'`);const{provider:c,extension:t}=i,a=this._extHostWebview.createNewWebview(E,{},t),g=new S(E,this._proxy,w,o,a,!0);this._webviewViews.set(E,g),await c.resolveWebviewView(g,{state:T},r)}async $onDidChangeWebviewViewVisibility(E,w){this.getWebviewView(E)._setVisible(w)}async $disposeWebviewView(E){const w=this.getWebviewView(E);this._webviewViews.delete(E),w.dispose(),this._extHostWebview.deleteWebview(E)}getWebviewView(E){const w=this._webviewViews.get(E);if(!w)throw new Error("No webview found");return w}}e.ExtHostWebviewViews=k}),define(we[95],be([1,0,5,4,2,10,9,3,14]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let F=class ji{constructor(p){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=p.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(p){p!==this._state.focused&&(this._state={...this._state,focused:p},this._onDidChangeWindowState.fire(this._state))}openUri(p,d){let m;if(typeof p=="string"){m=p;try{p=b.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,D.isFalsyOrWhitespace)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===B.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this._proxy.$openUri(p,m,d)}async asExternalUri(p,d){if((0,D.isFalsyOrWhitespace)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(p,d);return b.URI.from(m)}};F.InitialState={focused:!0},F=Fe([Ne(0,y.IExtHostRpcService)],F),e.ExtHostWindow=F,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(we[210],be([1,0,13,21,20,15,5,6,108,176,38]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function d(_,P){try{return JSON.stringify(_,P)}catch{return"null"}}const m="$$ref$$",l={[m]:-1};class n{constructor(P,$){this.jsonString=P,this.referencedBuffers=$}}function h(_,P=null,$=!1){const L=[];return{jsonString:($?d:JSON.stringify)(_,(H,W)=>{if(typeof W=="undefined")return l;if(typeof W=="object"){if(W instanceof I.VSBuffer){const q=L.push(W)-1;return{[m]:q}}if(P)return P(H,W)}return W}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=h;function S(_,P,$){return JSON.parse(_,(L,v)=>{if(v){const H=v[m];if(typeof H=="number")return P[H];if($&&v.$mid===1)return $.transformIncoming(v)}return v})}e.parseJsonAndRestoreBufferRefs=S;function k(_,P){return JSON.stringify(_,P)}function u(_){return _?(P,$)=>$&&$.$mid===1?_.transformOutgoing($):$:null}var E;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},T=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(P,$=null,L=null){super();this[p]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=$,this._uriTransformer=L,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let v=0,H=N.ProxyIdentifier.count;v<H;v++)this._locals[v]=null,this._proxies[v]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(v=>this._receiveOneMessage(v))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(B.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:$,sid:L}=P;return this._proxies[$]||(this._proxies[$]=this._createProxy($,L)),this._proxies[$]}_createProxy(P,$){let L={get:(v,H)=>(typeof H=="string"&&!v[H]&&H.charCodeAt(0)===36&&(v[H]=(...W)=>this._remoteCall(P,H,W)),H===r?$:v[H])};return new Proxy(Object.create(null),L)}set(P,$){return this._locals[P.nid]=$,$}assertRegistered(P){for(let $=0,L=P.length;$<L;$++){const v=P[$];if(!this._locals[v.nid])throw new Error(`Missing proxy instance ${v.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const $=P.byteLength,L=c.read(P,0),v=L.readUInt8(),H=L.readUInt32();switch(v){case 1:case 2:{let{rpcId:W,method:q,args:K}=a.deserializeRequestJSONArgs(L);this._uriTransformer&&(K=(0,y.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest($,H,W,q,K,v===2);break}case 3:case 4:{let{rpcId:W,method:q,args:K}=a.deserializeRequestMixedArgs(L);this._uriTransformer&&(K=(0,y.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest($,H,W,q,K,v===4);break}case 5:{this._logger&&this._logger.logIncoming($,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel($,H);break}case 7:{this._receiveReply($,H,void 0);break}case 9:{let W=a.deserializeReplyOKJSON(L);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply($,H,W);break}case 10:{const W=a.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply($,H,W);break}case 8:{let W=a.deserializeReplyOKVSBuffer(L);this._receiveReply($,H,W);break}case 11:{let W=a.deserializeReplyErrError(L);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr($,H,W);break}case 12:{this._receiveReplyErr($,H,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,$,L,v,H,W){this._logger&&this._logger.logIncoming(P,$,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(L)}.${v}(`,H);const q=String($);let K,V;if(W){const ae=new b.CancellationTokenSource;H.push(ae.token),K=this._invokeHandler(L,v,H),V=()=>ae.cancel()}else K=this._invokeHandler(L,v,H),V=o;this._cancelInvokedHandlers[q]=V;const z=a.serializeAcknowledged($);this._logger&&this._logger.logOutgoing(z.byteLength,$,1,"ack"),this._protocol.send(z),K.then(ae=>{delete this._cancelInvokedHandlers[q];const de=a.serializeReplyOK($,ae,this._uriReplacer);this._logger&&this._logger.logOutgoing(de.byteLength,$,1,"reply:",ae),this._protocol.send(de)},ae=>{delete this._cancelInvokedHandlers[q];const de=a.serializeReplyErr($,ae);this._logger&&this._logger.logOutgoing(de.byteLength,$,1,"replyErr:",ae),this._protocol.send(de)})}_receiveCancel(P,$){this._logger&&this._logger.logIncoming(P,$,1,"receiveCancel");const L=String($);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(P,$,L){this._logger&&this._logger.logIncoming(P,$,0,"receiveReply:",L);const v=String($);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const H=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v],H.resolveOk(L)}_receiveReplyErr(P,$,L){this._logger&&this._logger.logIncoming(P,$,0,"receiveReplyErr:",L);const v=String($);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const H=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v];let W;L&&(L.$isError?(W=new Error,W.name=L.name,W.message=L.message,W.stack=L.stack):W=L),H.resolveErr(W)}_invokeHandler(P,$,L){try{return Promise.resolve(this._doInvokeHandler(P,$,L))}catch(v){return Promise.reject(v)}}_doInvokeHandler(P,$,L){const v=this._locals[P];if(!v)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(P));let H=v[$];if(typeof H!="function")throw new Error("Unknown method "+$+" on actor "+(0,N.getStringIdentifierForProxy)(P));return H.apply(v,L)}_remoteCall(P,$,L){if(this._isDisposed)return Promise.reject(B.canceled());let v=null;if(L.length>0&&b.CancellationToken.isCancellationToken(L[L.length-1])&&(v=L.pop()),v&&v.isCancellationRequested)return Promise.reject(B.canceled());const H=a.serializeRequestArguments(L,this._uriReplacer),W=++this._lastMessageId,q=String(W),K=new F.LazyPromise;v&&v.onCancellationRequested(()=>{const z=a.serializeCancel(W);this._logger&&this._logger.logOutgoing(z.byteLength,W,0,"cancel"),this._protocol.send(a.serializeCancel(W))}),this._pendingRPCReplies[q]=K,this._onWillSendRequest(W);const V=a.serializeRequest(W,P,$,H,!!v);return this._logger&&this._logger.logOutgoing(V.byteLength,W,0,`request: ${(0,N.getStringIdentifierForProxy)(P)}.${$}(`,L),this._protocol.send(V),K}}e.RPCProtocol=i,p=T,i.UNRESPONSIVE_TIME=3*1e3;class c{constructor(P,$){this._buff=P,this._offset=$}static alloc(P,$,L){let v=new c(I.VSBuffer.alloc(L+1+4),0);return v.writeUInt8(P),v.writeUInt32($),v}static read(P,$){return new c(P,$)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,L}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,L}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,$}static sizeMixedArray(P){let $=0;$+=1;for(let L=0,v=P.length;L<v;L++){const H=P[L];switch($+=1,H.type){case 1:$+=this.sizeLongString(H.value);break;case 2:$+=this.sizeVSBuffer(H.value);break;case 3:$+=this.sizeUInt32,$+=this.sizeLongString(H.value);for(let W=0;W<H.buffers.length;++W)$+=this.sizeVSBuffer(H.buffers[W]);break;case 4:break}}return $}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let $=0,L=P.length;$<L;$++){const v=P[$];switch(v.type){case 1:this.writeUInt8(1),this.writeLongString(v.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v.value);break;case 3:this.writeUInt8(3),this.writeUInt32(v.buffers.length),this.writeLongString(v.value);for(let H=0;H<v.buffers.length;++H)this.writeBuffer(v.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let $=new Array(P);for(let L=0;L<P;L++)switch(this.readUInt8()){case 1:$[L]=this.readLongString();break;case 2:$[L]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),W=this.readLongString(),q=[];for(let K=0;K<H;++K)q.push(this.readVSBuffer());$[L]=new N.SerializableObjectWithBuffers(S(W,q,null));break}case 4:$[L]=void 0;break}return $}}c.sizeUInt32=4;var t;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(t||(t={}));class a{static _useMixedArgSerialization(P){for(let $=0,L=P.length;$<L;$++)if(P[$]instanceof I.VSBuffer||P[$]instanceof N.SerializableObjectWithBuffers||typeof P[$]=="undefined")return!0;return!1}static serializeRequestArguments(P,$){if(this._useMixedArgSerialization(P)){const L=[];for(let v=0,H=P.length;v<H;v++){const W=P[v];if(W instanceof I.VSBuffer)L[v]={type:2,value:W};else if(typeof W=="undefined")L[v]={type:4};else if(W instanceof N.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:K}=h(W.value,$);L[v]={type:3,value:I.VSBuffer.fromString(q),buffers:K}}else L[v]={type:1,value:I.VSBuffer.fromString(k(W,$))}}return{type:1,args:L}}return{type:0,args:k(P,$)}}static serializeRequest(P,$,L,v,H){switch(v.type){case 0:return this._requestJSONArgs(P,$,L,v.args,H);case 1:return this._requestMixedArgs(P,$,L,v.args,H)}}static _requestJSONArgs(P,$,L,v,H){const W=I.VSBuffer.fromString(L),q=I.VSBuffer.fromString(v);let K=0;K+=c.sizeUInt8(),K+=c.sizeShortString(W),K+=c.sizeLongString(q);let V=c.alloc(H?2:1,P,K);return V.writeUInt8($),V.writeShortString(W),V.writeLongString(q),V.buffer}static deserializeRequestJSONArgs(P){const $=P.readUInt8(),L=P.readShortString(),v=P.readLongString();return{rpcId:$,method:L,args:JSON.parse(v)}}static _requestMixedArgs(P,$,L,v,H){const W=I.VSBuffer.fromString(L);let q=0;q+=c.sizeUInt8(),q+=c.sizeShortString(W),q+=c.sizeMixedArray(v);let K=c.alloc(H?4:3,P,q);return K.writeUInt8($),K.writeShortString(W),K.writeMixedArray(v),K.buffer}static deserializeRequestMixedArgs(P){const $=P.readUInt8(),L=P.readShortString(),v=P.readMixedArray(),H=new Array(v.length);for(let W=0,q=v.length;W<q;W++){const K=v[W];typeof K=="string"?H[W]=JSON.parse(K):H[W]=K}return{rpcId:$,method:L,args:H}}static serializeAcknowledged(P){return c.alloc(5,P,0).buffer}static serializeCancel(P){return c.alloc(6,P,0).buffer}static serializeReplyOK(P,$,L){if(typeof $=="undefined")return this._serializeReplyOKEmpty(P);if($ instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(P,$);if($ instanceof N.SerializableObjectWithBuffers){const{jsonString:v,referencedBuffers:H}=h($.value,L,!0);return this._serializeReplyOKJSONWithBuffers(P,v,H)}else return this._serializeReplyOKJSON(P,d($,L))}static _serializeReplyOKEmpty(P){return c.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,$){let L=0;L+=c.sizeVSBuffer($);let v=c.alloc(8,P,L);return v.writeVSBuffer($),v.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,$){const L=I.VSBuffer.fromString($);let v=0;v+=c.sizeLongString(L);let H=c.alloc(9,P,v);return H.writeLongString(L),H.buffer}static _serializeReplyOKJSONWithBuffers(P,$,L){const v=I.VSBuffer.fromString($);let H=0;H+=c.sizeUInt32,H+=c.sizeLongString(v);for(const q of L)H+=c.sizeVSBuffer(q);let W=c.alloc(10,P,H);W.writeUInt32(L.length),W.writeLongString(v);for(const q of L)W.writeBuffer(q);return W.buffer}static deserializeReplyOKJSON(P){const $=P.readLongString();return JSON.parse($)}static deserializeReplyOKJSONWithBuffers(P,$){const L=P.readUInt32(),v=P.readLongString(),H=[];for(let W=0;W<L;++W)H.push(P.readVSBuffer());return new N.SerializableObjectWithBuffers(S(v,H,$))}static serializeReplyErr(P,$){const L=$?d(B.transformErrorForSerialization($),null):void 0;if(typeof L!="string")return this._serializeReplyErrEmpty(P);const v=I.VSBuffer.fromString(L);let H=0;H+=c.sizeLongString(v);let W=c.alloc(11,P,H);return W.writeLongString(v),W.buffer}static deserializeReplyErrError(P){const $=P.readLongString();return JSON.parse($)}static _serializeReplyErrEmpty(P){return c.alloc(12,P,0).buffer}}var g;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var f;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(f||(f={}))}),define(we[211],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(B){const D=A=>{self.removeEventListener("message",D);const y=A.data;Object.defineProperties(self,{postMessage:{value(F,N){y.postMessage(F,N)}},onmessage:{get(){return y.onmessage},set(F){y.onmessage=F}}}),y.addEventListener("message",F=>{self.dispatchEvent(new MessageEvent("message",{data:F.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(B)};self.addEventListener("message",D)}.toString();class I extends EventTarget{constructor(B,D,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${s})('${D}'))`,F=new Blob([y],{type:"application/javascript"}),N=URL.createObjectURL(F),p=new MessageChannel,d=N,m={type:"_newWorker",id:d,port:p.port2,url:N,options:A};B(m,[p.port2]),this.postMessage=p.port1.postMessage.bind(p.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:d};p.port1.postMessage(l),URL.revokeObjectURL(N),p.port1.close(),p.port2.close()},Object.defineProperties(this,{onmessage:{get(){return p.port1.onmessage},set(l){p.port1.onmessage=l}},onmessageerror:{get(){return p.port1.onmessageerror},set(l){p.port1.onmessageerror=l}}}),p.port1.addEventListener("messageerror",l=>{const n=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(n)}),p.port1.addEventListener("message",l=>{const n=new MessageEvent("message",{data:l.data});this.dispatchEvent(n)}),p.port1.start()}}e.NestedWorker=I}),define(we[212],be([1,0,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(we[213],be([1,0,35,10,17,23,24,2,3,148,46,172,212]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let m=class qi{constructor(n,h,S,k){this.localUserHome=n,this.remoteAgentService=h,this.environmentService=S,this.contextService=k,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||B.OS)(),this.resolveUserHome=(async()=>{const u=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=u?.userHome||n})()}hasValidBasename(n,h,S){return typeof h=="string"||typeof h=="undefined"?this.resolveOS.then(k=>this.doHasValidBasename(n,k,h)):this.doHasValidBasename(n,h,S)}doHasValidBasename(n,h,S){return n.scheme===I.Schemas.file||n.scheme===I.Schemas.vscodeRemote?(0,s.isValidBasename)(S??(0,D.basename)(n),h===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(n,h){if(n.remoteAuthority)return I.Schemas.vscodeRemote;const S=(0,F.getVirtualWorkspaceScheme)(h.getWorkspace());if(S)return S;const k=h.getWorkspace().folders[0];if(k)return k.uri.scheme;const u=h.getWorkspace().configuration;return u?u.scheme:I.Schemas.file}async userHome(n){return n?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?b.win32:b.posix)}async fileURI(n){let h="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const k=n.indexOf("/",2);k===-1?(h=n.substring(2),n="/"):(h=n.substring(2,k),n=n.substring(k)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:h,path:n,query:"",fragment:""})}};m=Fe([Ne(1,d.IRemoteAgentService),Ne(2,p.IWorkbenchEnvironmentService),Ne(3,N.IWorkspaceContextService)],m),e.AbstractPathService=m}),define(we[96],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(D,A){this.line=D,this.character=A}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,A){return new s(0,0)}with(D){return new s(0,0)}}e.Position=s;class I{constructor(D,A,y,F){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(D,A),this.end=new s(y,F)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new I(0,0,0,0)}with(D){return new I(0,0,0,0)}}e.Range=I;var b;(function(B){B[B.Information=1]="Information",B[B.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],be([1,0,16,29,26,35,9,3,17,15,96,13]),function(Z,e,s,I,b,B,D,A,y,F,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const d="\u27EA ",m=" characters skipped \u27EB",l=(d.length+m.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var n;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(n=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function S(Y){return!!Y.preview}e.resultIsMatch=S;function k(Y){return!!Y.resource}e.isFileMatch=k;function u(Y){return!!Y.message}e.isProgressMessage=u;var E;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=w;class o{constructor(ie,ce,he){this.ranges=ce;const ue=Array.isArray(ce)?ce:[ce];if(he&&he.matchLines===1&&T(ue)){ie=(0,D.getNLines)(ie,he.matchLines);let re="",ge=0,Te=0;const Re=Math.floor(he.charsPerLine/5),He=[];for(const Xe of ue){const ve=Math.max(Xe.startColumn-Re,0),fe=Xe.startColumn+he.charsPerLine;if(ve>Te+Re+l){const M=d+(ve-Te)+m;re+=M+ie.slice(ve,fe),ge+=ve-(Te+M.length)}else re+=ie.slice(Te,fe);He.push(new i(0,Xe.startColumn-ge,Xe.endColumn-ge)),Te=fe}this.preview={text:re,matches:Array.isArray(this.ranges)?He:He[0]}}else{const re=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:ie,matches:(0,s.mapArrayOrNot)(ce,ge=>new r(ge.startLineNumber-re,ge.startColumn,ge.endLineNumber-re,ge.endColumn))}}}}e.TextSearchMatch=o;function T(Y){const ie=Y[0].startLineNumber;for(const ce of Y)if(ce.startLineNumber!==ie||ce.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ce,he,ue){this.startLineNumber=ie,this.startColumn=ce,this.endLineNumber=he,this.endColumn=ue}}e.SearchRange=r;class i extends r{constructor(ie,ce,he){super(ie,ce,ie,he)}}e.OneLineRange=i;var c;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function t(Y,ie=!0){const ce=Y&&Y.files&&Y.files.exclude,he=ie&&Y&&Y.search&&Y.search.exclude;if(!ce&&!he)return;if(!ce||!he)return ce||he;let ue=Object.create(null);return ue=b.mixin(ue,b.deepClone(ce)),ue=b.mixin(ue,b.deepClone(he),!0),ue}e.getExcludes=t;function a(Y,ie){return Y.excludePattern&&I.match(Y.excludePattern,ie)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&I.match(Y.includePattern,ie)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ce=>{const he=ce.folder.fsPath;if(B.isEqualOrParent(ie,he)){const ue=y.relative(he,ie);return!ce.includePattern||!!I.match(ce.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var g;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(ie,ce){super(ie);this.code=ce}}e.SearchError=f;function _(Y){const ie=Y.message;if((0,F.isCancellationError)(Y))return new f(ie,g.canceled);try{const ce=JSON.parse(ie);return new f(ce.message,ce.code)}catch{return new f(ie,g.other)}}e.deserializeSearchError=_;function P(Y){const ie={message:Y.message,code:Y.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=P;function $(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=$;function L(Y){return Y.type==="success"}e.isSerializedSearchSuccess=L;function v(Y){return!!Y.path}e.isSerializedFileMatch=v;function H(Y,ie){const ce=Y.searchPath?Y.searchPath:Y.relativePath;return(0,D.fuzzyContains)(ce,ie)}e.isFilePatternMatch=H;class W{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function q(Y,ie){const ce={...Y||{},...ie||{}};return Object.keys(ce).filter(he=>{const ue=ce[he];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=q;class K{constructor(ie,ce){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let he=ie.includePattern;ce.includePattern&&(he?he={...he,...ce.includePattern}:he=ce.includePattern),he&&(this._parsedIncludeExpression=I.parse(he))}matchesExcludesSync(ie,ce,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ce,he))}includedInQuerySync(ie,ce,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ce,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,ce,he))}includedInQuery(ie,ce,he){const ue=this._parsedExcludeExpression(ie,ce,he),re=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,ce,he):!0;return(0,p.isThenable)(ue)?ue.then(ge=>ge?!1:re()):re()}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=K;function V(Y){for(const ie in Y)if(typeof Y[ie]!="boolean")return!0;return!1}function z(Y){if(!Y)return;let ie;return ce=>(ie||(ie=(Y()||Promise.resolve([])).then(he=>he?de(he):{})),ie.then(he=>!!he[ce]))}e.hasSiblingPromiseFn=z;function ae(Y){if(!Y)return;let ie;return ce=>{if(!ie){const he=Y();ie=he?de(he):{}}return!!ie[ce]}}e.hasSiblingFn=ae;function de(Y){const ie={};for(const ce of Y)ie[ce]=!0;return ie}}),define(we[31],be([1,0,16,13,20,5,22,10,102,24,9,11,2,128,3,12,140,46,30,27,14,8,7,41,4]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E,w,o,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i($,L,v){return new F.ExtUri(H=>g(H,v)).isEqual($,L)}function c($,L,v){return i($.uri,L.uri,v)?0:(0,N.compare)($.uri.toString(),L.uri.toString())}function t($,L,v){return $.index!==L.index?$.index<L.index?-1:1:i($.uri,L.uri,v)?(0,N.compare)($.name,L.name):(0,N.compare)($.uri.toString(),L.uri.toString())}function a($,L,v,H){const W=$.slice(0).sort((K,V)=>v(K,V,H)),q=L.slice(0).sort((K,V)=>v(K,V,H));return(0,s.delta)(W,q,(K,V)=>v(K,V,H))}function g($,L){const v=L.getCapabilities($.scheme);return!(v&&v&1024)}class f extends S.Workspace{constructor(L,v,H,W,q,K,V){super(L,H.map(z=>new S.WorkspaceFolder(z)),W,q,V);this._name=v,this._isUntitled=K,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(V),H.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(L,v,H,W){if(!L)return{workspace:null,added:[],removed:[]};const{id:q,name:K,folders:V,configuration:z,transient:ae,isUntitled:de}=L,Y=[],ie=v;v?V.forEach((re,ge)=>{const Te=d.URI.revive(re.uri),Re=f._findFolder(H||v,Te,W);Re?(Re.name=re.name,Re.index=re.index,Y.push(Re)):Y.push({uri:Te,name:re.name,index:ge})}):Y.push(...V.map(({uri:re,name:ge,index:Te})=>({uri:d.URI.revive(re),name:ge,index:Te}))),Y.sort((re,ge)=>re.index<ge.index?-1:1);const ce=new f(q,K,Y,!!ae,z?d.URI.revive(z):null,!!de,re=>g(re,W)),{added:he,removed:ue}=a(ie?ie.workspaceFolders:[],ce.workspaceFolders,c,W);return{workspace:ce,added:he,removed:ue}}static _findFolder(L,v,H){for(let W=0;W<L.folders.length;W++){const q=L.workspaceFolders[W];if(i(q.uri,v,H))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,v){return v&&this._structure.get(L)&&(L=(0,F.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let _=class{constructor(L,v,H,W){this._onDidChangeWorkspace=new B.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new B.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=W,this._extHostFileSystemInfo=H,this._requestIdProvider=new y.Counter,this._barrier=new I.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const q=v.workspace;this._confirmedWorkspace=q?new f(q.id,q.name,[],!!q.transient,q.configuration?d.URI.revive(q.configuration):null,!!q.isUntitled,K=>g(K,H)):void 0}$initializeWorkspace(L,v){this._trusted=v,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:A.Schemas.untitled,path:(0,F.basename)((0,F.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,v,H,...W){const q=[];if(Array.isArray(W)&&W.forEach(de=>{d.URI.isUri(de.uri)&&!q.some(Y=>i(Y.uri,de.uri,this._extHostFileSystemInfo))&&q.push({uri:de.uri,name:de.name||(0,F.basenameOrAuthority)(de.uri)})}),this._unconfirmedWorkspace||[v,H].some(de=>typeof de!="number"||de<0)||H===0&&q.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(v+H>K.length)return!1;const V=K.slice(0);V.splice(v,H,...q.map(de=>({uri:de.uri,name:de.name||(0,F.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<V.length;de++){const Y=V[de];if(V.some((ie,ce)=>ce!==de&&i(Y.uri,ie.uri,this._extHostFileSystemInfo)))return!1}V.forEach((de,Y)=>de.index=Y);const{added:z,removed:ae}=a(K,V,t,this._extHostFileSystemInfo);if(z.length===0&&ae.length===0)return!1;if(this._proxy){const de=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(de,v,H,q).then(void 0,Y=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(h.Severity.Error,(0,m.localize)(0,null,de,Y.toString()),ie,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,v){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,v)}async getWorkspaceFolder2(L,v){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,v)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,v){let H,W="";if(typeof L=="string"?(H=d.URI.file(L),W=L):typeof L!="undefined"&&(H=L,W=L.fsPath),!H)return W;const q=this.getWorkspaceFolder(H,!0);if(!q)return W;typeof v=="undefined"&&this._actualWorkspace&&(v=this._actualWorkspace.folders.length>1);let K=(0,F.relativePath)(q.uri,H);return v&&q.name&&(K=`${q.name}/${K}`),K}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:v,added:H,removed:W}=f.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=v||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:W}))}findFiles(L,v,H,W,q=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let K;if(v===null?K=!1:v&&(typeof v=="string"?K=v:K=v.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:z}=P(w.GlobPattern.from(L));return this._proxy.$startFileSearch((0,p.withUndefinedAsNull)(V),(0,p.withUndefinedAsNull)(z),(0,p.withUndefinedAsNull)(K),(0,p.withUndefinedAsNull)(H),q).then(ae=>Array.isArray(ae)?ae.map(de=>d.URI.revive(de)):[])}async findTextInFiles(L,v,H,W,q=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),V=typeof v.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:v.previewOptions,{includePattern:z,folder:ae}=P(w.GlobPattern.from(v.include)),de=typeof v.exclude=="string"?v.exclude:v.exclude?v.exclude.pattern:void 0,Y={ignoreSymlinks:typeof v.followSymlinks=="boolean"?!v.followSymlinks:void 0,disregardIgnoreFiles:typeof v.useIgnoreFiles=="boolean"?!v.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof v.useGlobalIgnoreFiles=="boolean"?!v.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof v.useParentIgnoreFiles=="boolean"?!v.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof v.useDefaultExcludes=="boolean"?!v.useDefaultExcludes:!0,fileEncoding:v.encoding,maxResults:v.maxResults,previewOptions:V,afterContext:v.afterContext,beforeContext:v.beforeContext,includePattern:z,excludePattern:de},ie=!1;if(this._activeSearchCallbacks[K]=ce=>{if(ie)return;const he=d.URI.revive(ce.resource);ce.results.forEach(ue=>{(0,T.resultIsMatch)(ue)?H({uri:he,preview:{text:ue.preview.text,matches:(0,s.mapArrayOrNot)(ue.preview.matches,re=>new o.Range(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,s.mapArrayOrNot)(ue.ranges,re=>new o.Range(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):H({uri:he,text:ue.text,lineNumber:ue.lineNumber})})},q.isCancellationRequested)return{};try{const ce=await this._proxy.$startTextSearch(L,(0,p.withUndefinedAsNull)(ae),Y,K,q);return delete this._activeSearchCallbacks[K],ce||{}}catch(ce){throw delete this._activeSearchCallbacks[K],ce}}$handleTextSearchResult(L,v){this._activeSearchCallbacks[v]&&this._activeSearchCallbacks[v](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};_=Fe([Ne(0,E.IExtHostRpcService),Ne(1,u.IExtHostInitDataService),Ne(2,k.IExtHostFileSystemInfo),Ne(3,n.ILogService)],_),e.ExtHostWorkspace=_,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function P($){let L,v;return $&&(typeof $=="string"?L=$:(L=$.pattern,v=d.URI.revive($.baseUri))),{includePattern:L,folder:v}}}),define(we[32],be([1,0,26,5,31,4,7,143,80,11,13,3,14,12,2]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(T,r){if(r){const i=r.split(".");let c=T;for(let t=0;c&&t<i.length;t++)c=c[i[t]];return c}}function h(T){return T instanceof l.URI}function S(T){return T&&T.uri instanceof l.URI&&T.languageId&&typeof T.languageId=="string"}function k(T){return T&&!T.uri&&T.languageId&&typeof T.languageId=="string"}function u(T){return T&&T.uri instanceof l.URI&&(!T.name||typeof T.name=="string")&&(!T.index||typeof T.index=="number")}function E(T){if(h(T))return{resource:T};if(S(T))return{resource:T.uri,overrideIdentifier:T.languageId};if(k(T))return{overrideIdentifier:T.languageId};if(u(T))return{resource:T.uri};if(T===null)return{resource:null}}let w=class{constructor(r,i,c){this._proxy=r.getProxy(B.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,i))}};w=Fe([Ne(0,d.IExtHostRpcService),Ne(1,b.IExtHostWorkspace),Ne(2,m.ILogService)],w),e.ExtHostConfiguration=w;class o{constructor(r,i,c,t){this._onDidChangeConfiguration=new I.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(r,i,c){const t=E(i)||{},a=this._toReadonlyValue(r?n(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,c?.identifier);function g(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(_){return typeof n(a,_)!="undefined"},get:(_,P)=>{this._validateConfigurationAccess(r?`${r}.${_}`:_,t,c?.identifier);let $=n(a,_);if(typeof $=="undefined")$=P;else{let L;const v=(H,W)=>{let q;const K=()=>{L=L||(0,s.deepClone)(a),q=q||n(L,W)};return(0,F.isObject)(H)?new Proxy(H,{get:(V,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return K(),()=>q;if(L)return q=q||n(L,W),q[z];const ae=V[z];return typeof z=="string"?v(ae,`${W}.${z}`):ae},set:(V,z,ae)=>(K(),q&&(q[z]=ae),!0),deleteProperty:(V,z)=>(K(),q&&delete q[z],!0),defineProperty:(V,z,ae)=>(K(),q&&Object.defineProperty(q,z,ae),!0)}):H};$=v($,_)}return $},update:(_,P,$,L)=>{_=r?`${r}.${_}`:_;const v=g($);return P!==void 0?this._proxy.$updateConfigurationOption(v,_,P,t,L):this._proxy.$removeConfigurationOption(v,_,t,L)},inspect:_=>{_=r?`${r}.${_}`:_;const P=(0,s.deepClone)(this._configuration.inspect(_,t,this._extHostWorkspace.workspace));if(P)return{key:_,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof a=="object"&&(0,s.mixin)(f,a,!1),Object.freeze(f)}_toReadonlyValue(r){const i=c=>(0,F.isObject)(c)?new Proxy(c,{get:(t,a)=>i(t[a]),set:(t,a,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(t,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(t,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(r)}_validateConfigurationAccess(r,i,c){const t=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),a=c?`[${c.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const c=new A.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,a)=>c.affectsConfiguration(t,E(a))})}_toMap(r){return r.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,p.createDecorator)("IExtHostConfiguration")});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[97],be([1,0,2,13,5,4,7,31,49,32,20,40,14,27,3,10,23,12,65,164,15]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var T;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(T=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(W){function q(z){if(z){const ae=z;return ae&&!!ae.process}else return!1}W.is=q;function K(z){if(z==null)return;const ae={process:z.process,args:z.args};return z.options&&(ae.options=r.from(z.options)),ae}W.from=K;function V(z){if(z!=null)return new D.ProcessExecution(z.process,z.args,z.options)}W.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(W){function q(z){if(z){const ae=z;return ae&&(!!ae.commandLine||!!ae.command)}else return!1}W.is=q;function K(z){if(z==null)return;const ae={};return z.commandLine!==void 0?ae.commandLine=z.commandLine:(ae.command=z.command,ae.args=z.args),z.options&&(ae.options=c.from(z.options)),ae}W.from=K;function V(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new D.ShellExecution(z.commandLine,z.options):new D.ShellExecution(z.command,z.args?z.args:[],z.options)}W.to=V})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(W){function q(z){if(z){let ae=z;return ae&&ae.customExecution==="customExecution"}else return!1}W.is=q;function K(z){return{customExecution:"customExecution"}}W.from=K;function V(z,ae){return ae.get(z)}W.to=V})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var g;(function(W){function q(K,V){let z;return K.scope!==void 0&&typeof K.scope!="number"?z=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===D.TaskScope.Workspace&&V&&V.workspaceFile?z=V.workspaceFile:z=u.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:z}}W.from=q})(g=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(W){function q(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}W.from=q})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function(W){function q(z,ae){if(z==null)return[];const de=[];for(let Y of z){const ie=K(Y,ae);ie&&de.push(ie)}return de}W.fromMany=q;function K(z,ae){if(z==null)return;let de;z.execution instanceof D.ProcessExecution?de=i.from(z.execution):z.execution instanceof D.ShellExecution?de=t.from(z.execution):z.execution&&z.execution instanceof D.CustomExecution&&(de=a.from(z.execution));const Y=o.from(z.definition);let ie;return z.scope?typeof z.scope=="number"?ie=z.scope:ie=z.scope.uri:ie=D.TaskScope.Workspace,!Y||!ie?void 0:{_id:z._id,definition:Y,name:z.name,source:{extensionId:ae.identifier.value,label:z.source,scope:ie},execution:de,isBackground:z.isBackground,group:f.from(z.group),presentationOptions:T.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}W.from=K;async function V(z,ae,de){if(z==null)return;let Y;i.is(z.execution)?Y=i.to(z.execution):t.is(z.execution)?Y=t.to(z.execution):a.is(z.execution)&&(Y=a.to(z._id,de));const ie=o.to(z.definition);let ce;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ce=z.source.scope:ce=await ae.resolveWorkspaceFolder(s.URI.revive(z.source.scope)):ce=D.TaskScope.Workspace),!ie||!ce)return;const he=new D.Task(ie,ce,z.name,z.source.label,Y,z.problemMatchers);return z.isBackground!==void 0&&(he.isBackground=z.isBackground),z.group!==void 0&&(he.group=D.TaskGroup.from(z.group._id),he.group&&z.group.isDefault&&(he.group=new D.TaskGroup(he.group.id,he.group.label),z.group.isDefault&&(he.group.isDefault=z.group.isDefault))),z.presentationOptions&&(he.presentationOptions=T.to(z.presentationOptions)),z._id&&(he._id=z._id),z.detail&&(he.detail=z.detail),he}W.to=V})(_=e.TaskDTO||(e.TaskDTO={}));var P;(function(W){function q(V){return V}W.from=q;function K(V){if(!!V)return Object.assign(Object.create(null),V)}W.to=K})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class ${constructor(q,K,V){this._id=K,this._task=V,w.set(this,void 0),Ve(this,w,q,"f")}get task(){return this._task}terminate(){ye(this,w,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}w=new WeakMap;var L;(function(W){function q(K){return{id:K._id,task:void 0}}W.from=q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let v=class{constructor(q,K,V,z,ae,de,Y,ie){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=q.getProxy(B.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=z,this._configurationService=ae,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,K,V){if(!V)return new D.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:K,provider:V,extension:q}),this._proxy.$registerTaskProvider(z,K),new D.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(q,K){this._proxy.$registerTaskSystem(q,K)}fetchTasks(q){return this._proxy.$fetchTasks(P.from(q)).then(async K=>{const V=[];for(let z of K){const ae=await _.to(z,this._workspaceProvider,this._providedCustomExecutions2);ae&&V.push(ae)}return V})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(K=>q.push(K)),q}terminateTask(q){if(!(q instanceof $))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,K,V){const z=this._providedCustomExecutions2.get(q.id);z&&(this._activeCustomExecutions2.set(q.id,z),this._terminalService.attachPtyToTerminal(K,await z.callback(V))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const K=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const K=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:K,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const K=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:q.exitCode})}$provideTasks(q,K){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));const z=[],ae=(0,I.asPromise)(()=>V.provider.provideTasks(N.CancellationToken.None)).then(de=>this.provideTasksInternal(K,z,V,de));return new Promise(de=>{ae.then(Y=>{Promise.all(z).then(()=>{de(Y)})})})}async $resolveTask(q,K){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));if(K.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${V.type}].`);const z=await _.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ae=await V.provider.resolveTask(z,N.CancellationToken.None);if(!ae)return;this.checkDeprecation(ae,V);const de=_.from(ae,V.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(ae.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(de.execution)&&await this.addCustomExecution(de,ae,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,K,V){const z=await this._proxy.$createTaskId(q);!V&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,K.execution)),this._providedCustomExecutions2.set(z,K.execution)}async getTaskExecution(q,K){if(typeof q=="string"){const ae=this._taskExecutionPromises.get(q);if(!ae)throw new Error("Unexpected: The specified task is missing an execution");return ae}let V=this._taskExecutionPromises.get(q.id);if(V)return V;const z=new Promise((ae,de)=>{function Y(ie,ce,he){he?ae(new $(ie,ce.id,he)):de("Unexpected: Task does not exist.")}K?Y(this,q,K):_.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>Y(this,q,ie))});return this._taskExecutionPromises.set(q.id,z),z.then(ae=>(this._taskExecutions.set(q.id,ae),ae),ae=>Promise.reject(ae))}checkDeprecation(q,K){q._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let V=this._notProvidedCustomExecutions.values(),z=V.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=V.next()}};v=Fe([Ne(0,d.IExtHostRpcService),Ne(1,m.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,y.IExtHostDocumentsAndEditors),Ne(4,F.IExtHostConfiguration),Ne(5,p.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,k.IExtHostApiDeprecationService)],v),e.ExtHostTaskBase=v;let H=class extends v{constructor(q,K,V,z,ae,de,Y,ie){super(q,K,V,z,ae,de,Y,ie);this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(q,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const V=_.from(K,q);if(V===void 0)throw new Error("Task is not valid");if(a.is(V.execution))await this.addCustomExecution(V,K,!1);else throw new E.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),K);return this._proxy.$executeTask(V).catch(ae=>{throw new Error(ae)}),z}provideTasksInternal(q,K,V,z){const ae=[];if(z)for(let de of z){this.checkDeprecation(de,V),(!de.definition||!q[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=_.from(de,V.extension);Y&&a.is(Y.execution)?(ae.push(Y),K.push(this.addCustomExecution(Y,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ae,extension:V.extension}}async resolveTaskInternal(q){if(a.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,K,V){}};H=Fe([Ne(0,d.IExtHostRpcService),Ne(1,m.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,y.IExtHostDocumentsAndEditors),Ne(4,F.IExtHostConfiguration),Ne(5,p.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,k.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(we[214],be([1,0,17,20,43,29,24,191,41]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class F{constructor(d,m,l){this.config=d,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&B.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&B.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const m=this.config.folderQueries||[];return new Promise((l,n)=>{const h=S=>{this.resultCount++,d(S)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const k=S.toString(),u=s.basename(k);this.globalExcludePattern&&this.globalExcludePattern(k,u)||this.matchFile(h,{base:S,basename:u})}),Promise.all(m.map(S=>this.searchInFolder(S,h))).then(S=>{l({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{n(new Error((0,b.toErrorMessage)(S)))})})}async searchInFolder(d,m){const l=new I.CancellationTokenSource,n=this.getSearchOptionsForFolder(d),h=this.initDirectoryTree(),S=new y.QueryGlobTester(this.config,d),k=!S.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(l),u=A.StopWatch.create();const E=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,l.token),w=u.elapsed(),o=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(E&&E.forEach(T=>{const r=s.posix.relative(d.folder.path,T.path);if(k){const i=s.basename(T.path);this.matchFile(m,{base:d.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(h,d.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,S,m),{providerTime:w,postProcessTime:o.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(d){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),l=(0,y.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:l,includes:m,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},m,l,n){if(l===this.filePattern){const S=s.basename(this.filePattern);this.matchFile(n,{base:m,relativePath:this.filePattern,basename:S})}function h(S){const k=s.basename(S),u=s.dirname(S);let E=d[u];E||(E=d[u]=[],h(u)),E.push({base:m,relativePath:S,basename:k})}h(l)}matchDirectoryTree({rootEntries:d,pathToEntries:m},l,n){const h=this,S=this.filePattern;function k(u){const E=(0,y.hasSiblingFn)(()=>u.map(w=>w.basename));for(let w=0,o=u.length;w<o;w++){const T=u[w],{relativePath:r,basename:i}=T;if(l.matchesExcludesSync(r,i,S!==i?E:void 0))continue;const c=m[r];if(c)k(c);else{if(r===S)continue;h.matchFile(n,T)}if(h.isLimitHit)break}}k(d)}matchFile(d,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(m))}}class N{constructor(){this.sessions=new Map}fileSearch(d,m,l,n){const h=this.getSessionTokenSource(d.cacheKey),S=new F(d,m,h&&h.token);let k=0;const u=E=>{k+=E.length,l(E.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(S,N.BATCH_SIZE,u,n).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:k,detailStats:E.stats}}))}clearCache(d){const m=this.getSessionTokenSource(d);m&&m.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new I.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:D.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,m,l,n){n.onCancellationRequested(()=>{d.cancel()});const h=k=>{k&&(S.push(k),m>0&&S.length>=m&&(l(S),S=[]))};let S=[];return d.search(h).then(k=>(S.length&&l(S),k),k=>(S.length&&l(S),Promise.reject(k)))}}e.FileSearchManager=N,N.BATCH_SIZE=512}),define(we[215],be([1,0,16,70,29,73,22,10,17,24,9,11,2,234,134,77,12,46,87,213,41]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(f,_,P,$,L){this.configurationService=f,this.workspaceContextService=_,this.editorGroupsService=P,this.logService=$,this.pathService=L}text(f,_,P={}){f=this.getContentPattern(f,P);const $=this.configurationService.getValue(),L=_&&_.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(_?.map(S.toWorkspaceFolder),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:$.search.usePCRE2||L||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(f,_){const P=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const $={...f,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(f,_)&&($.isCaseSensitive=!0),this.isMultiline(f)&&($.isMultiline=!0),$}file(f,_={}){return{...this.commonQuery(f,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(f,_){return f?(f=Array.isArray(f)?f.map(c):c(f),_?this.parseSearchPaths(f):{pattern:T(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],_={}){const P=this.handleIncludeExclude(_.includePattern,_.expandPatterns),$=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),L=f.length>1,v=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,_,$)):f.map(q=>this.getFolderQueryForRoot(q,_,$,L))).filter(q=>!!q),H={_reason:_._reason,folderQueries:v,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:$.pattern,includePattern:P.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const q=s.coalesce(s.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(ae=>ae.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const K=q.filter(z=>(0,E.pathIncludedInQuery)(H,z.fsPath)),V=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...H,...V}}const W=_.extraFileResources&&_.extraFileResources.filter(q=>(0,E.pathIncludedInQuery)(H,q.fsPath));return H.extraFileResources=W&&W.length?W:void 0,H}commonQueryFromFileList(f){const _=[],P=new D.ResourceMap,$={};let L=!1;return f.forEach(v=>{if(v.scheme===A.Schemas.walkThrough)return;if((0,F.isAbsolutePath)(v)){const W=this.workspaceContextService.getWorkspaceFolder(v)?.uri??v.with({path:y.dirname(v.fsPath)});let q=P.get(W);q||(L=!0,q={folder:W,includePattern:{}},_.push(q),P.set(W,q));const K=y.relative(W.fsPath,v.fsPath);(0,p.assertIsDefined)(q.includePattern)[K.replace(/\\/g,"/")]=!0}else v.fsPath&&(L=!0,$[v.fsPath]=!0)}),{folderQueries:_,includePattern:$,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(f,_){if(_.isSmartCase){if(f.isRegExp){if(N.containsUppercaseCharacter(f.pattern,!0))return!0}else if(N.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,m.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const _=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),$=(Array.isArray(f)?f:r(f)).map(V=>{const z=this.pathService.resolvedUserHome;return z?(0,B.untildify)(V,z.scheme===A.Schemas.file?z.fsPath:z.path):V}),L=I.groupBy($,V=>_(V)?"searchPaths":"exprSegments"),v=(L.exprSegments||[]).map(V=>N.rtrim(V,"/")).map(V=>N.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),H={},W=this.expandSearchPathPatterns(L.searchPaths||[]);W&&W.length&&(H.searchPaths=W);const q=s.flatten(v),K=T(...q);return K&&(H.pattern=K),H}getExcludesForFolder(f,_){return _.disregardExcludeSettings?void 0:(0,E.getExcludes)(f,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const _=s.flatten(f.map($=>{let{pathPortion:L,globPortion:v}=o($);v&&(v=t(v));const H=this.expandOneSearchPath(L);return s.flatten(H.map(W=>this.resolveOneSearchPathPattern(W,v)))})),P=new Map;return _.forEach($=>{const L=$.searchPath.toString(),v=P.get(L);v?$.pattern&&(v.pattern=v.pattern||{},v.pattern[$.pattern]=!0):P.set(L,{searchPath:$.searchPath,pattern:$.pattern?T($.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(f){if(y.isAbsolute(f)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==A.Schemas.file?[{searchPath:_[0].uri.with({path:f})}]:[{searchPath:d.URI.file(y.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=c(f),f.startsWith("../")||f===".."){const $=y.posix.resolve(_.path,f);return[{searchPath:_.with({path:$})}]}const P=t(f);return[{searchPath:_,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const _=f.replace(/^\.[\/\\]/,""),$=this.workspaceContextService.getWorkspace().folders.map(L=>{const v=_.match(new RegExp(`^${N.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return v?{match:v,folder:L}:null}).filter(p.isDefined);if($.length)return $.map(L=>{const v=L.match[1];return{searchPath:L.folder.uri,pattern:v&&t(v)}});{const L=f.match(/\.[\/\\](.+)[\/\\]?/),v=L?L[1]:f,H=l.localize(0,null,v);throw new Error(H)}}}}resolveOneSearchPathPattern(f,_){const P=f.pattern&&_?`${f.pattern}/${_}`:f.pattern||_,$=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&$.push({searchPath:f.searchPath,pattern:P+"/**"}),$}getFolderQueryForSearchPath(f,_,P){const $=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(f.searchPath),_,P,!1);return $?{...$,includePattern:f.pattern}:null}getFolderQueryForRoot(f,_,P,$){let L;const v=d.URI.isUri(f)?f:f.uri;if(P.searchPaths){const V=P.searchPaths.filter(z=>(0,F.isEqual)(z.searchPath,v))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const H=this.configurationService.getValue({resource:v}),q={...this.getExcludesForFolder(H,_)||{},...L||{}},K=d.URI.isUri(f)?(0,F.basename)(f):f.name;return{folder:v,folderName:$?K:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!H.search.followSymlinks}}};w=Fe([Ne(0,n.IConfigurationService),Ne(1,S.IWorkspaceContextService),Ne(2,k.IEditorGroupsService),Ne(3,h.ILogService),Ne(4,u.IPathService)],w),e.QueryBuilder=w;function o(g){const f=g.match(/[\*\{\}\(\)\[\]\?]/);if(f){const _=f.index,P=g.substr(0,_).match(/[/|\\][^/\\]*$/);if(P){let $=g.substr(0,P.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function T(...g){return g.length?g.reduce((f,_)=>(f[_]=!0,f),Object.create(null)):void 0}function r(g){return b.splitGlobAware(g,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(g){return[`**/${g}/**`,`**/${g}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function c(g){return g.replace(/\\/g,"/")}function t(g){return c(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(g,f){g=s.distinct(g,$=>$.toString());const _=[],P=f.getWorkspace();return g&&g.forEach($=>{let L;if(f.getWorkbenchState()===2)L=(0,F.relativePath)(P.folders[0].uri,$),L&&L!=="."&&(L="./"+L);else{const v=f.getWorkspaceFolder($);if(v){const H=v.name;if(P.folders.filter(q=>q.name===H).length===1){const q=(0,F.relativePath)(v.uri,$);q===""?L=`./${v.name}`:L=`./${v.name}/${q}`}else L=$.fsPath}}L&&_.push(L)}),_}e.resolveResourcesForSearchIncludes=a}),define(we[216],be([1,0,24,2,20,15,3,215,41,46]),function(Z,e,s,I,b,B,D,A,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function p(n,h){const S=h.activationEvents;if(!S)return Promise.resolve(void 0);const k=[],u=[];for(const i of S)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||n.forceUsingSearch?u.push(c):k.push(c)}if(k.length===0&&u.length===0)return Promise.resolve(void 0);let E;const w=new Promise((i,c)=>{E=i}),o=i=>E({activationEvent:i}),T=Promise.all(k.map(i=>d(n,i,o))).then(()=>{}),r=m(n,h.identifier,u,o);return Promise.all([T,r]).then(()=>{E(void 0)}),w}e.checkActivateWorkspaceContainsExtension=p;async function d(n,h,S){for(const k of n.folders)if(await n.exists(s.joinPath(I.URI.revive(k),h))){S(`workspaceContains:${h}`);return}}async function m(n,h,S,k){if(S.length===0)return Promise.resolve(void 0);const u=new b.CancellationTokenSource,E=n.checkExists(n.folders,S,u.token),w=setTimeout(async()=>{u.cancel(),n.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${S.join(",")}`)},N);let o=!1;try{o=await E}catch(T){B.isCancellationError(T)||B.onUnexpectedError(T)}u.dispose(),clearTimeout(w),o&&k(`workspaceContains:${S.join(",")}`)}function l(n,h,S,k){const u=n.get(D.IInstantiationService),E=n.get(y.ISearchService),o=u.createInstance(A.QueryBuilder).file(h.map(T=>(0,F.toWorkspaceFolder)(I.URI.revive(T))),{_reason:"checkExists",includePattern:S,exists:!0});return E.fileSearch(o,k).then(T=>!!T.limitHit,T=>B.isCancellationError(T)?!1:Promise.reject(T))}e.checkGlobFileExists=l});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!b:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(Z,s):b?b.value=s:e.set(Z,s),s},ye=this&&this.__classPrivateFieldGet||function(Z,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(Z):I?I.value:e.get(Z)};define(we[33],be([1,0,123,17,69,24,13,6,22,2,12,4,32,174,67,31,28,173,15,25,21,149,7,81,3,27,68,14,56,59,40,5,216,64,151,10]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E,w,o,T,r,i,c,t,a,g,f,_,P,$,L,v){"use strict";var H,W,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let K=class Ki extends A.Disposable{constructor(Y,ie,ce,he,ue,re,ge,Te,Re,He){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ie,this._extHostContext=ce,this._initData=ge,this._extHostWorkspace=he,this._extHostConfiguration=ue,this._logService=re,this._extHostTunnelService=Re,this._extHostTerminalService=He,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(p.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(p.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(p.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=Y.createChild(new a.ServiceCollection([l.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(ve=>Xe.add(u.ExtensionIdentifier.toKey(ve))),this._activator=this._register(new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ve,fe,M)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ve,k.transformErrorForSerialization(fe),M)},actualActivateExtension:async(ve,fe)=>{if(Xe.has(u.ExtensionIdentifier.toKey(ve)))return await this._mainThreadExtensionsProxy.$activateExtension(ve,fe),new m.HostExtension;const M=this._registry.getExtensionDescription(ve);return this._activateExtension(M,fe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){k.onUnexpectedError(Y)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch{}await Promise.all(Y)}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}_activateByEvent(Y,ie){return this._activator.activateByEvent(Y,ie)}_activateById(Y,ie){return this._activator.activateById(Y,ie)}activateByIdWithErrors(Y,ie){return this._activateById(Y,ie).then(()=>{const ce=this._activator.getActivatedExtension(Y);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._registry)}getExtensionExports(Y){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Y).exports:null}async _realPathExtensionUri(Y){if(Y.scheme!==v.Schemas.file)return Y;const ie=await this._hostUtils.realpath(Y.fsPath);return F.URI.file(ie)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const Y=y.TernarySearchTree.forUris(ie=>B.extUriBiasedIgnorePathCase.ignorePathCasing(ie));for(const ie of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ie)){const ce=await this._realPathExtensionUri(ie.extensionLocation);Y.set(ce,ie)}return Y})()),this._extensionPathIndex}_deactivate(Y){let ie=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return ie;const ce=this._activator.getActivatedExtension(Y);if(!ce)return ie;try{typeof ce.module.deactivate=="function"&&(ie=Promise.resolve(ce.module.deactivate()).then(void 0,he=>(this._logService.error(he),Promise.resolve(void 0))))}catch(he){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(he)}try{(0,A.dispose)(ce.subscriptions)}catch(he){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this._logService.error(he)}return ie}async _activateExtension(Y,ie){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,ie).then(ce=>{const he=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,he.codeLoadingTime,he.activateCallTime,he.activateResolvedTime,ie),this._logExtensionActivationTimes(Y,ie,"success",he),ce},ce=>{throw this._logExtensionActivationTimes(Y,ie,"failure"),ce})}_logExtensionActivationTimes(Y,ie,ce,he){const ue=V(Y,ie);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...he||{},outcome:ce})}_doActivateExtension(Y,ie){const ce=V(Y,ie);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const he=this._getEntryPoint(Y);if(!he)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${Y.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this._logService.flush();const ue=new m.ExtensionActivationTimesBuilder(ie.startup);return Promise.all([this._loadCommonJSModule(Y.identifier,(0,B.joinPath)(Y.extensionLocation,he),ue),this._loadExtensionContext(Y)]).then(re=>(b.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Ki._callActivate(this._logService,Y.identifier,re[0],re[1],ue))).then(re=>(b.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),re))}_loadExtensionContext(Y){const ie=new w.ExtensionGlobalMemento(Y,this._storage),ce=new w.ExtensionMemento(Y.identifier.value,!1,this._storage),he=new L.ExtensionSecrets(Y,this._secretState),ue=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,re=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ie.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const ge=this;let Te,Re;const He=(0,h.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(u.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:ce,secrets:he,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Xe){return I.join(Y.extensionLocation.fsPath,Xe)},get storagePath(){return ge._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ge._storagePath.globalValue(Y).fsPath},get logPath(){return I.join(ge._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return F.URI.joinPath(ge._initData.logsLocation,Y.identifier.value)},get storageUri(){return ge._storagePath.workspaceValue(Y)},get globalStorageUri(){return ge._storagePath.globalValue(Y)},get extensionMode(){return ue},get extension(){return Te===void 0&&(Te=new z(ge,Y.identifier,Y,re)),Te},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(Y,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Re){if(!He)return;const Xe=_.Event.buffer(_.Event.fromDOMEventEmitter(He,"message",ve=>ve.data));He.start(),Re={onDidReceiveMessage:Xe,postMessage:He.postMessage.bind(He)}}return Re}})})}static _callActivate(Y,ie,ce,he,ue){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,ie,ce,he,ue).then(re=>new m.ActivatedExtension(!1,null,ue.build(),ce,re,he.subscriptions))}static _callActivateOptional(Y,ie,ce,he,ue){if(typeof ce.activate=="function")try{ue.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const re=typeof global=="object"?global:self,ge=ce.activate.apply(re,[he]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(ge).then(Te=>(ue.activateResolveStop(),Te))}catch(re){return Promise.reject(re)}else return Promise.resolve(ce)}_activateOneStartupFinished(Y,ie){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:ie}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const Y of this._registry.getAllExtensionDescriptions())if(Y.activationEvents)for(const ie of Y.activationEvents)ie==="onStartupFinished"&&this._activateOneStartupFinished(Y,ie)}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const ie=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(ie),he=Promise.all([Y,ce]).then(()=>{});return Promise.race([he,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),he}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ie=>this._handleWorkspaceContainsEagerExtension(Y,ie))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,ie){if(this.isActivated(ie.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,he={logService:this._logService,folders:Y.map(re=>re.uri),forceUsingSearch:ce,exists:re=>this._hostUtils.exists(re.fsPath),checkExists:(re,ge,Te)=>this._mainThreadWorkspaceProxy.$checkExists(re,ge,Te)},ue=await(0,P.checkActivateWorkspaceContainsExtension)(he,ie);if(!!ue)return this._activateById(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ue.activationEvent}).then(void 0,re=>this._logService.error(re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:ie}=this._initData.environment;if(!Y||!ie)throw new Error(s.localize(0,null));const ce=await this._loadCommonJSModule(null,ie,new m.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(s.localize(1,null,ie.toString()));return new Promise((he,ue)=>{const re=(Re,He)=>{Re?ue(Re):he(typeof He=="number"&&He>0?1:0)},ge=(0,B.originalFSPath)(ie),Te=ce.run(ge,re);Te&&Te.then&&Te.then(()=>{he(0)}).catch(Re=>{ue(Re instanceof Error&&Re.stack?Re.stack:String(Re))})})}async $extensionTestsExit(Y){this._logService.info(`Extension host terminating: test runner requested exit with code ${Y}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Y}`),this._logService.flush(),this._hostUtils.exit(Y)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,ie){return this._resolvers[Y]=ie,(0,A.toDisposable)(()=>{delete this._resolvers[Y]})}async _activateAndGetResolver(Y){const ie=Y.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const ce=Y.substr(0,ie);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(Y,ie){this._logService.info(`$resolveAuthority invoked for authority (${ae(Y)})`);const{authorityPrefix:ce,resolver:he}=await this._activateAndGetResolver(Y);if(!he)return{type:"error",error:{code:T.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(he)),b.mark(`code/extHost/willResolveAuthority/${ce}`);const ue=await he.resolve(Y,{resolveAttempt:ie});b.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const re={authority:Y,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ge={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:re,options:ge,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(b.mark(`code/extHost/didResolveAuthorityError/${ce}`),ue instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(Y,ie){this._logService.info(`$getCanonicalURI invoked for authority (${ae(Y)})`);const{authorityPrefix:ce,resolver:he}=await this._activateAndGetResolver(Y);if(!he)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const ue=F.URI.revive(ie);if(typeof he.getCanonicalURI=="undefined")return ue;const re=await(0,D.asPromise)(()=>he.getCanonicalURI(ue));return re||ue}$startExtensionHost(Y){return this._registry.keepOnly(Y),this._startExtensionHost()}$activateByEvent(Y,ie){return ie===1?this._activateByEvent(Y,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(Y,!1))}async $activate(Y,ie){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(Y)?(await this._activateById(Y,ie),!0):!1}async $deltaExtensions(Y,ie){Y.forEach(he=>he.extensionLocation=F.URI.revive(he.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(ie.map(async he=>{const ue=this._registry.getExtensionDescription(he);ue&&ce.delete(await this._realPathExtensionUri(ue.extensionLocation))})),await Promise.all(Y.map(async he=>{const ue=await this._realPathExtensionUri(he.extensionLocation);ce.set(ue,he)})),this._registry.deltaExtensions(Y,ie),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){let ie=E.VSBuffer.alloc(Y),ce=Math.random()%256;for(let he=0;he<Y;he++)ie.writeUInt8(ce,he);return ie}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};K=Fe([Ne(0,r.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,t.IExtHostRpcService),Ne(3,n.IExtHostWorkspace),Ne(4,d.IExtHostConfiguration),Ne(5,N.ILogService),Ne(6,i.IExtHostInitDataService),Ne(7,c.IExtensionStoragePaths),Ne(8,g.IExtHostTunnelService),Ne(9,f.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function V(de,Y){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class z{constructor(Y,ie,ce,he){H.set(this,void 0),W.set(this,void 0),q.set(this,void 0),Ve(this,H,Y,"f"),Ve(this,W,ie,"f"),Ve(this,q,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=I.normalize((0,B.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=he}get isActive(){return ye(this,H,"f").isActivated(ye(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return ye(this,H,"f").getExtensionExports(ye(this,q,"f"))}activate(){return ye(this,H,"f").activateByIdWithErrors(ye(this,q,"f"),{startup:!1,extensionId:ye(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,H=new WeakMap,W=new WeakMap,q=new WeakMap;function ae(de){const Y=de.indexOf("+");return Y===-1?de:de.substring(0,Y)}}),define(we[98],be([1,0,17,2,5,13,4,7,158,31,33,49,166,32,160,14,3,11,86,66]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,h.createDecorator)("IExtHostDebugService");let E=class{constructor(a,g,f,_,P,$){this._workspaceService=g,this._extensionService=f,this._editorsService=_,this._configurationService=P,this._editorTabs=$,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=a.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,g){const f=a;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let _=`debug:${encodeURIComponent(f.path||"")}`,P="?";return g&&(_+=`${P}session=${encodeURIComponent(g.id)}`,P="&"),_+=`${P}ref=${f.sourceReference}`,I.URI.parse(_)}else{if(f.path)return I.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const g=[];for(const f of a.getAllExtensionDescriptions())if(f.contributes){const _=f.contributes.debuggers;if(_&&_.length>0)for(const P of _)(0,l.isDebuggerMainContribution)(P)&&g.push(P.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(g=>a.push(g)),a}addBreakpoints(a){this.startBreakpoints();const g=a.filter(P=>{const $=P.id;return this._breakpoints.has($)?!1:(this._breakpoints.set($,P),!0)});this.fireBreakpointChanges(g,[],[]);const f=[],_=new Map;for(const P of g)if(P instanceof A.SourceBreakpoint){let $=_.get(P.location.uri.toString());$||($={type:"sourceMulti",uri:P.location.uri,lines:[]},_.set(P.location.uri.toString(),$),f.push($)),$.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof A.FunctionBreakpoint&&f.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(a){this.startBreakpoints();const g=a.filter($=>this._breakpoints.delete($.id));this.fireBreakpointChanges([],g,[]);const f=g.filter($=>$ instanceof A.SourceBreakpoint).map($=>$.id),_=g.filter($=>$ instanceof A.FunctionBreakpoint).map($=>$.id),P=g.filter($=>$ instanceof A.DataBreakpoint).map($=>$.id);return this._debugServiceProxy.$unregisterBreakpoints(f,_,P)}startDebugging(a,g,f){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,g,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,g,f){if(!g)return new A.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:_,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,f,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,_),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(a,g,f){if(!f)return new A.Disposable(()=>{});if(!this.definesDebugType(a,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:_,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,_),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(a,g){if(!g)return new A.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:f,factory:g}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==g)})}async $runInTerminal(a,g){return Promise.resolve(void 0)}async $substituteVariables(a,g){if(!this._variableResolver){const[P,$]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,$)}let f;const _=await this.getFolder(a);return _&&(f={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,g)}createDebugAdapter(a,g){if(a.type==="implementation")return new i(a.implementation)}createSignService(){}async $startDASession(a,g){const f=this,_=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const $=this.convertToDto(P),L=this.createDebugAdapter($,_);if(!L)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const v=L;return this._debugAdapters.set(a,v),this.getDebugAdapterTrackers(_).then(H=>(H&&this._debugAdaptersTrackers.set(a,H),v.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const q=W,K={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const V=await this._signService.sign(q.arguments.value);K.body={signature:V},v.sendResponse(K)}else throw new Error("no signer")}catch(V){K.success=!1,K.message=V.message,v.sendResponse(K)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(W),W=(0,l.convertToVSCPaths)(W,!0),f._debugServiceProxy.$acceptDAMessage(a,W)}),v.onError(W=>{H&&H.onError&&H.onError(W),this._debugServiceProxy.$acceptDAError(a,W.name,W.message,W.stack)}),v.onExit(W=>{H&&H.onExit&&H.onExit((0,S.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,S.withNullAsUndefined)(W),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),v.startSession()))})}$sendDAMessage(a,g){g=(0,l.convertToDAPaths)(g,!1);const f=this._debugAdaptersTrackers.get(a);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(g);const _=this._debugAdapters.get(a);_&&_.sendMessage(g)}$stopDASession(a){const g=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),g&&g.onWillStopSession&&g.onWillStopSession();const f=this._debugAdapters.get(a);return this._debugAdapters.delete(a),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const g=[],f=[],_=[];if(a.added)for(const P of a.added){const $=P.id;if($&&!this._breakpoints.has($)){let L;if(P.type==="function")L=new A.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")L=new A.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const v=I.URI.revive(P.uri);L=new A.SourceBreakpoint(new A.Location(v,new A.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}L._id=$,this._breakpoints.set($,L),g.push(L)}}if(a.removed)for(const P of a.removed){const $=this._breakpoints.get(P);$&&(this._breakpoints.delete(P),f.push($))}if(a.changed){for(const P of a.changed)if(P.id){const $=this._breakpoints.get(P.id);if($){if($ instanceof A.FunctionBreakpoint&&P.type==="function"){const L=$;L.enabled=P.enabled,L.condition=P.condition,L.hitCondition=P.hitCondition,L.logMessage=P.logMessage,L.functionName=P.functionName}else if($ instanceof A.SourceBreakpoint&&P.type==="source"){const L=$;L.enabled=P.enabled,L.condition=P.condition,L.hitCondition=P.hitCondition,L.logMessage=P.logMessage,L.location=new A.Location(I.URI.revive(P.uri),new A.Position(P.line,P.character))}_.push($)}}}this.fireBreakpointChanges(g,f,_)}$provideDebugConfigurations(a,g,f){return(0,B.asPromise)(async()=>{const _=this.getConfigProviderByHandle(a);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(g);return _.provideDebugConfigurations(P,f)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(a,g,f,_){return(0,B.asPromise)(async()=>{const P=this.getConfigProviderByHandle(a);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const $=await this.getFolder(g);return P.resolveDebugConfiguration($,f,_)})}$resolveDebugConfigurationWithSubstitutedVariables(a,g,f,_){return(0,B.asPromise)(async()=>{const P=this.getConfigProviderByHandle(a);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const $=await this.getFolder(g);return P.resolveDebugConfigurationWithSubstitutedVariables($,f,_)})}async $provideDebugAdapter(a,g){const f=this.getAdapterDescriptorFactoryByHandle(a);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(g);return this.getAdapterDescriptor(f,_).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(a){const g=await this.getSession(a);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(a){const g=await this.getSession(a);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,g){const f=await this.getSession(a);f&&f._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(a,g){const _={session:await this.getSession(a),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(a){if(a instanceof A.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof A.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const g=this._adapterFactories.filter(f=>f.type===a);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(a){const g=this._adapterFactories.filter(f=>f.handle===a);if(g.length>0)return g[0].factory}getConfigProviderByHandle(a){const g=this._configProviders.filter(f=>f.handle===a);if(g.length>0)return g[0].provider}definesDebugType(a,g){if(a.contributes){const f=a.contributes.debuggers;if(f&&f.length>0){for(const _ of f)if(_.label&&_.type&&_.type===g)return!0}}return!1}getDebugAdapterTrackers(a){const f=a.configuration.type,_=this._trackerFactories.filter(P=>P.type===f||P.type==="*").map(P=>(0,B.asPromise)(()=>P.factory.createDebugAdapterTracker(a)).then($=>$,$=>null));return Promise.race([Promise.all(_).then(P=>{const $=P.filter(L=>!!L);if($.length>0)return new r($)}),new Promise((P,$)=>{const L=setTimeout(()=>{clearTimeout(L),$(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(a,g){const f=g.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new A.DebugAdapterServer(f));if(a){const P=await this._extensionService.getExtensionRegistry();return(0,B.asPromise)(()=>a.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,P))).then($=>{if($)return $})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,_))}daExecutableFromPackage(a,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,g,f){(a.length>0||g.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:g,changed:f}))}async getSession(a){if(a)if(typeof a=="string"){const g=this._debugSessions.get(a);if(g)return g}else{let g=this._debugSessions.get(a.id);if(!g){const f=await this.getFolder(a.folderUri),_=a.parent?this._debugSessions.get(a.parent):void 0;g=new w(this._debugServiceProxy,a.id,a.type,a.name,f,a.configuration,_),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(a){if(a){const g=I.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};E=Fe([Ne(0,n.IExtHostRpcService),Ne(1,F.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,p.IExtHostDocumentsAndEditors),Ne(4,m.IExtHostConfiguration),Ne(5,u.IExtHostEditorTabs)],E),e.ExtHostDebugServiceBase=E;class w{constructor(a,g,f,_,P,$,L){this._debugServiceProxy=a,this._id=g,this._type=f,this._name=_,this._workspaceFolder=P,this._configuration=$,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,g)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=w;class o{constructor(a){this.value=Object.freeze({append(g){a.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=o;class T extends d.AbstractVariableResolverService{constructor(a,g,f,_,P,$){function L(){if(g){const v=g.activeEditor();if(v)return v.document.uri;const H=_.tabGroups.all.find(W=>W.isActive)?.activeTab;if(H!==void 0){const W=H.resource;return W&&(W.primary||W.secondary)?W.primary??W.secondary:H.resource}}}super({getFolderUri:v=>{const H=a.filter(W=>W.name===v);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(v,H)=>f.getConfiguration(void 0,v).get(H),getAppRoot:()=>k.cwd(),getExecPath:()=>k.env.VSCODE_EXEC_PATH,getFilePath:()=>{const v=L();if(v)return s.normalize(v.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const v=L();if(v){const H=P.getWorkspaceFolder(v);if(H)return s.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(g){const v=g.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(g){const v=g.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,$?Promise.resolve($):void 0,Promise.resolve(k.env))}}e.ExtHostVariableResolverService=T;class r{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(g=>g.onError?g.onError(a):void 0)}onExit(a,g){this.trackers.forEach(f=>f.onExit?f.onExit(a,g):void 0)}}class i extends y.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends E{constructor(a,g,f,_,P,$){super(a,g,f,_,P,$)}createVariableResolver(a,g,f){return new T(a,g,f,this._editorTabs)}};c=Fe([Ne(0,n.IExtHostRpcService),Ne(1,F.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,p.IExtHostDocumentsAndEditors),Ne(4,m.IExtHostConfiguration),Ne(5,u.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(we[217],be([1,0,69,2,4,32,28,25,14,27,3,33,86,12,9]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(w,o,T,r,i,c,t){this._apiFactory=w,this._extensionRegistry=o,this._instaService=T,this._extHostConfiguration=r,this._extHostExtensionService=i,this._initData=c,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new S(this._apiFactory,o,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(k,o)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,o,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(let o of w.nodeModuleName)this._factories.set(o,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(o=>w.alternativeModuleName(o))}};n=Fe([Ne(2,N.IInstantiationService),Ne(3,B.IExtHostConfiguration),Ne(4,p.IExtHostExtensionService),Ne(5,F.IExtHostInitDataService),Ne(6,m.ILogService)],n),e.RequireInterceptor=n;let h=class Hi{constructor(w){if(w.environment.appRoot&&Hi.aliased.size){const o=(0,l.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),T="[a-z0-9_.-]",r=`@${T}+\\/${T}+|${T}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${i}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(w));if(!o)return;const[,T,r,i]=o,c=Hi.aliased.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),T+c+i}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=Fe([Ne(0,F.IExtHostInitDataService)],h);class S{constructor(w,o,T,r,i){this._apiFactory=w,this._extensionPaths=o,this._extensionRegistry=T,this._configProvider=r,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,o){const T=this._extensionPaths.findSubstr(o);if(T){let r=this._extApiImpl.get(A.ExtensionIdentifier.toKey(T.identifier));return r||(r=this._apiFactory(T,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(T.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((i,c)=>r+=`	${c} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let k=class{constructor(w,o,T){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(b.MainContext.MainThreadTelemetry);const{environment:r}=T,i=o.getProxy(b.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;d.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${c}/node_modules.asar/keytar`),this.alternativeNames.add(`${c}/node_modules/keytar`)}this._impl={getPassword:(c,t)=>i.$getPassword(c,t),setPassword:(c,t,a)=>i.$setPassword(c,t,a),deletePassword:(c,t)=>i.$deletePassword(c,t),findPassword:c=>i.$findPassword(c),findCredentials(c){return i.$findCredentials(c)}}}load(w,o){const T=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:T?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const o=w.length;if(o<=7||!this.alternativeNames)return;const T=o-7;if((w.charAt(T)==="/"||w.charAt(T)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};k=Fe([Ne(1,y.IExtHostRpcService),Ne(2,F.IExtHostInitDataService)],k);let u=class{constructor(w,o,T){this._extensionPaths=w,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=T.getProxy(b.MainContext.MainThreadTelemetry);const r=T.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,c)=>{const t=I.URI.parse(i);return c?this.callOriginal(i,c):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,i,{}):this.callOriginal(i,c)}}load(w,o,T){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=T(w),this._impl}callOriginal(w,o){return this.sendNoForwardTelemetry(),this._original(w,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=Fe([Ne(2,y.IExtHostRpcService)],u)}),define(we[218],be([1,0,13,15,69,6,2,4,210,12,55,56,27,139,14,60,33,40]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class k{constructor(E,w,o,T,r){this._disposables=new B.DisposableStore,this._isTerminating=!1,this._hostUtils=o,this._rpcProtocol=new y.RPCProtocol(E,null,T),w=k._transform(w,this._rpcProtocol);const i=new p.ServiceCollection(...(0,N.getSingletonServiceDescriptors)());i.set(d.IExtHostInitDataService,{_serviceBrand:void 0,...w,messagePorts:r}),i.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),i.set(n.IURITransformerService,new n.URITransformerService(T)),i.set(h.IHostUtils,o);const c=new m.InstantiationService(i,!0);this._disposables.add(c.invokeFunction(f=>f.get(S.IExtHostTerminalService))),this._disposables.add(c.invokeFunction(f=>f.get(h.IExtHostExtensionService))),this._logService=c.invokeFunction(f=>f.get(F.ILogService)),b.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",w),this._extensionService=c.invokeFunction(f=>f.get(h.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(_,P)=>{let $="",L,v;for(const H of P)$+=`
	at ${H.toString()}`,v=H.getFileName(),!L&&v&&(L=f.findSubstr(D.URI.file(v)));return t.set(_,L),`${_.name||"Error"}: ${_.message||""}${$}`}});const a=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),g=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{const _=I.transformErrorForSerialization(f),P=t.get(f);P?a.$onExtensionRuntimeError(P.identifier,_):g.$onUnexpectedError(_)})}async asBrowserUri(E){const w=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return D.URI.revive(await w.$asBrowserUri(E))}terminate(E){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${E}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(o=>{this._logService.error(o)}),this._rpcProtocol.dispose();const w=this._extensionService.deactivateAll();Promise.race([(0,s.timeout)(5e3),w]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(E,w){E.extensions.forEach(T=>T.extensionLocation=D.URI.revive(w.transformIncomingURIs(T.extensionLocation))),E.environment.appRoot=D.URI.revive(w.transformIncomingURIs(E.environment.appRoot));const o=E.environment.extensionDevelopmentLocationURI;return o&&(E.environment.extensionDevelopmentLocationURI=o.map(T=>D.URI.revive(w.transformIncomingURIs(T)))),E.environment.extensionTestsLocationURI=D.URI.revive(w.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=D.URI.revive(w.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=D.URI.revive(w.transformIncomingURIs(E.environment.workspaceStorageHome)),E.logsLocation=D.URI.revive(w.transformIncomingURIs(E.logsLocation)),E.logFile=D.URI.revive(w.transformIncomingURIs(E.logFile)),E.workspace=w.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=k}),define(we[219],be([1,0,16,13,20,43,10,17,24,11,2,41]),function(Z,e,s,I,b,B,D,A,y,F,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(u,E,w,o){this.query=u,this.provider=E,this.fileUtils=w,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,E){const w=this.query.folderQueries||[],o=new b.CancellationTokenSource;return E.onCancellationRequested(()=>o.cancel()),new Promise((T,r)=>{this.collector=new l(u);let i=!1;const c=(t,a)=>{if(!i&&!this.isLimitHit){const g=this.resultSize(t);h(t)&&typeof this.query.maxResults=="number"&&this.resultCount+g>this.query.maxResults&&(this.isLimitHit=!0,i=!0,o.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const f=this.resultSize(t);this.resultCount+=f,(f>0||!h(t))&&this.collector.add(t,a)}};Promise.all(w.map((t,a)=>this.searchInFolder(t,g=>c(g,a),o.token))).then(t=>{o.dispose(),this.collector.flush();const a=t.some(g=>!!g&&!!g.limitHit);T({limitHit:this.isLimitHit||a,messages:(0,s.flatten)(t.map(g=>g?.message?(0,F.isArray)(g.message)?g.message:[g.message]:[])),stats:{type:this.processType}})},t=>{o.dispose();const a=(0,B.toErrorMessage)(t);r(new Error(a))})})}resultSize(u){return h(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,E){const w=Array.isArray(u.ranges)?u.ranges:[u.ranges],o=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:w.slice(0,E),preview:{matches:o.slice(0,E),text:u.preview.text},uri:u.uri}}async searchInFolder(u,E,w){const o=new p.QueryGlobTester(this.query,u),T=[],r={report:t=>{if(!this.validateProviderResult(t))return;const a=u.folder.scheme===D.Schemas.file?(0,p.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(t.uri))):void 0,g=y.relativePath(u.folder,t.uri);if(g){const f=o.includedInQuery(g,A.basename(g),a);(0,I.isThenable)(f)?T.push(f.then(_=>{_&&E(t)})):f&&E(t)}}},i=this.getSearchOptionsForFolder(u),c=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,r,w);return T.length&&await Promise.all(T),c}validateProviderResult(u){if(h(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const E=(0,p.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),w=(0,p.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),o={folder:N.URI.from(u.folder),excludes:w,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=d;function m(k){return{isCaseSensitive:k.isCaseSensitive||!1,isRegExp:k.isRegExp||!1,isWordMatch:k.isWordMatch||!1,isMultiline:k.isMultiline||!1,pattern:k.pattern}}class l{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,E=>this.sendItems(E))}add(u,E){this._currentFileMatch&&(this._currentFolderIdx!==E||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=E,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(n(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=l;function n(k){return h(k)?{preview:{matches:(0,s.mapArrayOrNot)(k.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:k.preview.text},ranges:(0,s.mapArrayOrNot)(k.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:k.text,lineNumber:k.lineNumber}}function h(k){return!!k.preview}e.extensionResultIsMatch=h;class S{constructor(u,E){this.maxBatchSize=u,this.cb=E,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,E){!u||this.addItemToBatch(u,E)}addItems(u,E){!u||this.addItemsToBatch(u,E)}addItemToBatch(u,E){this.batch.push(u),this.batchSize+=E,this.onUpdate()}addItemsToBatch(u,E){this.batch=this.batch.concat(u),this.batchSize+=E,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(we[99],be([1,0,6,4,3,214,14,60,12,2,219]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let p=class{constructor(n,h,S){this.extHostRpc=n,this._uriTransformer=h,this._logService=S,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new B.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,h){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const S=this._handlePool++;return this._textSearchProvider.set(S,h),this._proxy.$registerTextSearchProvider(S,this._transformScheme(n)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(n,h){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const S=this._handlePool++;return this._fileSearchProvider.set(S,h),this._proxy.$registerFileSearchProvider(S,this._transformScheme(n)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(n,h,S,k){const u=d(S),E=this._fileSearchProvider.get(n);if(E)return this._fileSearchManager.fileSearch(u,E,w=>{this._proxy.$handleFileMatch(n,h,w.map(o=>o.resource))},k);throw new Error("unknown provider: "+n)}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,h,S,k){const u=this._textSearchProvider.get(n);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const E=d(S);return this.createTextSearchManager(E,u).search(o=>this._proxy.$handleTextMatch(n,h,o),k)}$enableExtensionHostSearch(){}createTextSearchManager(n,h){return new N.TextSearchManager(n,h,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};p=Fe([Ne(0,D.IExtHostRpcService),Ne(1,A.IURITransformerService),Ne(2,y.ILogService)],p),e.ExtHostSearch=p;function d(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(n=>F.URI.revive(n))}}e.reviveQuery=d;function m(l){return{...l,folder:F.URI.revive(l.folder)}}}),define(we[220],be([1,0,55,94,31,92,32,39,49,40,97,98,99,67,59,65,95,50,30,64,83,66,193,12,175]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E,w,o,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(T.ILoggerService,o.ExtHostLoggerService),(0,s.registerSingleton)(T.ILogService,r.ExtHostLogService),(0,s.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService),(0,s.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,s.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,s.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,s.registerSingleton)(p.IExtHostDebugService,p.WorkerExtHostDebugService),(0,s.registerSingleton)(B.IExtHostDecorations,B.ExtHostDecorations),(0,s.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(k.IExtHostFileSystemInfo,k.ExtHostFileSystemInfo),(0,s.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,s.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,s.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,s.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask),(0,s.registerSingleton)(F.IExtHostTerminalService,F.WorkerExtHostTerminalService),(0,s.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,s.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,s.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,s.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,s.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry),(0,s.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs)}),define(we[221],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class s{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const B=this._dragOperations.get(b);return this._dragOperations.delete(b),B}}addDragOperationTransfer(b,B){this._dragOperations.set(b,B)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,B){this._renderedElements.set(b,B)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=s}),define(we[222],be([1,0,127,24,2,5,6,13,7,11,16,8,20,155,221]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function n(k,u){if((0,F.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let E;return Array.isArray(k.highlights)&&(E=k.highlights.filter(w=>w.length===2&&typeof w[0]=="number"&&typeof w[1]=="number"),E=E.length?E:void 0),{label:k.label,highlights:E}}}class h{constructor(u,E,w){this._proxy=u,this.commands=E,this.logService=w,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeviewsService;function o(T){return T&&T.$treeViewId&&T.$treeItemHandle}E.registerArgumentProcessor({processArgument:T=>o(T)?this.convertArgument(T):Array.isArray(T)&&T.length>0?T.map(r=>o(r)?this.convertArgument(r):r):T})}registerTreeDataProvider(u,E,w){const o=this.createTreeView(u,{treeDataProvider:E},w);return{dispose:()=>o.dispose()}}createTreeView(u,E,w){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=E.dragAndDropController?.dropMimeTypes??[],T=E.dragAndDropController?.dragMimeTypes??[],r=!!E.dragAndDropController?.handleDrag,i=!!E.dragAndDropController?.handleDrop,c=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,dropMimeTypes:o,dragMimeTypes:T,hasHandleDrag:r,hasHandleDrop:i}),t=this.createExtHostTreeView(u,E,w);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(a){t.message=a},get title(){return t.title},set title(a){t.title=a},get description(){return t.description},set description(a){t.description=a},reveal:(a,g)=>t.reveal(a,g),dispose:async()=>{await c,this.treeViews.delete(u),t.dispose()}}}$getChildren(u,E){const w=this.treeViews.get(u);return w?w.getChildren(E):Promise.reject(new Error((0,s.localize)(0,null,u)))}async $handleDrop(u,E,w,o,T,r,i){const c=this.treeViews.get(u);if(!c)return Promise.reject(new Error((0,s.localize)(1,null,u)));const t=m.TreeDataTransferConverter.toITreeDataTransfer(E);return r===u&&i&&await this.addAdditionalTransferItems(t,c,i,o,T),c.onDrop(t,w,o)}async addAdditionalTransferItems(u,E,w,o,T){const r=this.treeDragAndDropService.removeDragOperationTransfer(T);if(r)(await r)?.forEach((i,c)=>{i&&u.set(c,i)});else if(T&&E.handleDrag){const i=E.handleDrag(w,u,o);this.treeDragAndDropService.addDragOperationTransfer(T,i),await i}return u}async $handleDrag(u,E,w,o){const T=this.treeViews.get(u);if(!T)return Promise.reject(new Error((0,s.localize)(2,null,u)));const r=await this.addAdditionalTransferItems(new Map,T,E,o,w);if(!!r)return m.TreeDataTransferConverter.toTreeDataTransferDTO(r)}async $hasResolve(u){const E=this.treeViews.get(u);if(!E)throw new Error((0,s.localize)(3,null,u));return E.hasResolve}$resolve(u,E,w){const o=this.treeViews.get(u);if(!o)throw new Error((0,s.localize)(4,null,u));return o.resolveTreeItem(E,w)}$setExpanded(u,E,w){const o=this.treeViews.get(u);if(!o)throw new Error((0,s.localize)(5,null,u));o.setExpanded(E,w)}$setSelection(u,E){const w=this.treeViews.get(u);if(!w)throw new Error((0,s.localize)(6,null,u));w.setSelection(E)}$setVisible(u,E){const w=this.treeViews.get(u);if(!w)throw new Error((0,s.localize)(7,null,u));w.setVisible(E)}createExtHostTreeView(u,E,w){const o=new S(u,E,this._proxy,this.commands.converter,this.logService,w);return this.treeViews.set(u,o),o}convertArgument(u){const E=this.treeViews.get(u.$treeViewId);return E?E.getExtensionElement(u.$treeItemHandle):null}}e.ExtHostTreeViews=h;class S extends D.Disposable{constructor(u,E,w,o,T,r){super();if(this.viewId=u,this.proxy=w,this.commands=o,this.logService=T,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new B.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new B.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new B.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new B.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new B.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const a of r.contributes.views[t])a.id===u&&(this._title=a.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,c;this._register(B.Event.debounce(this._onDidChangeData.event,(t,a)=>(t||(t={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(g=>c=g),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(a.element)?t.elements.push(...a.element):t.elements.push(a.element)),a.message&&(t.message=!0),t),200,!0)(({message:t,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=c;return i=null,this.refresh(a).then(()=>g())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,F.isUndefinedOrNull)(u))}async getChildren(u){const E=u?this.getExtensionElement(u):void 0;if(u&&!E)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let w=this.getChildrenNodes(u);return w||(w=await this.fetchChildrenNodes(E)),w?w.map(o=>o.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,E){E=E||{select:!0,focus:!1};const w=(0,F.isUndefinedOrNull)(E.select)?!0:E.select,o=(0,F.isUndefinedOrNull)(E.focus)?!1:E.focus,T=(0,F.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(r=>this.resolveTreeNode(u,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(c=>c.item)},{select:w,focus:o,expand:T})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:w,focus:o,expand:T})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}setExpanded(u,E){const w=this.getExtensionElement(u);w&&(E?this._onDidExpandElement.fire(Object.freeze({element:w})):this._onDidCollapseElement.fire(Object.freeze({element:w})))}setSelection(u){(0,N.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(u,E,w){const o=[];for(const T of u){const r=this.getExtensionElement(T);r&&o.push(r)}if(!(!this.dndController?.handleDrag||o.length===0))return await this.dndController.handleDrag(o,E,w),E}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,E,w){const o=this.getExtensionElement(E);if(!(!o||!this.dndController?.handleDrop))return(0,A.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(o,u,w):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,E){if(!this.dataProvider.resolveTreeItem)return;const w=this.elements.get(u);if(w){const o=this.nodes.get(w);if(o){const T=await this.dataProvider.resolveTreeItem(o.extensionItem,w,E)??o.extensionItem;return o.item.tooltip=this.getTooltip(T.tooltip),o.item.command=this.getCommand(o.disposableStore,T.command),o.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(E=>E?this.resolveUnknownParentChain(E).then(w=>this.resolveTreeNode(E,w[w.length-1]).then(o=>(w.push(o),w))):Promise.resolve([]))}resolveParent(u){const E=this.nodes.get(u);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,E){const w=this.nodes.get(u);return w?Promise.resolve(w):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(o=>this.createHandle(u,o,E,!0)).then(o=>this.getChildren(E?E.item.handle:void 0).then(()=>{const T=this.getExtensionElement(o);if(T){const r=this.nodes.get(T);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(u){if(u){let E;if(typeof u=="string"){const w=this.getExtensionElement(u);E=w?this.nodes.get(w):void 0}else E=u;return E&&E.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const w=u?this.nodes.get(u):void 0,o=await this.dataProvider.getChildren(u);if(E.token.isCancellationRequested)return;const T=await Promise.all((0,N.coalesce)(o||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,w):null}));return E.token.isCancellationRequested?void 0:(0,N.coalesce)(T)}finally{E.dispose()}}refresh(u){if(u.some(w=>!w))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const w=this.getHandlesToRefresh(u);if(w.length)return this.refreshHandles(w)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const E=new Set,w=u.map(T=>this.nodes.get(T));for(const T of w)if(T&&!E.has(T.item.handle)){let r=T;for(;r&&r.parent&&w.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&E.add(T.item.handle)}const o=[];return E.forEach(T=>{const r=this.elements.get(T);if(r){const i=this.nodes.get(r);i&&(!i.parent||!E.has(i.parent.item.handle))&&o.push(T)}}),o}refreshHandles(u){const E={};return Promise.all(u.map(w=>this.refreshNode(w).then(o=>{o&&(E[w]=o.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(u){const E=this.getExtensionElement(u);if(E){const w=this.nodes.get(E);if(w)return this.clearChildren(E),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(o=>{if(o){const T=this.createTreeNode(E,o,w.parent);return this.updateNodeCache(E,T,w,w.parent),w.dispose(),T}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,E,w){const o=this.createTreeNode(u,E,w);if(E.id&&this.elements.has(o.item.handle))throw new Error((0,s.localize)(8,null,E.id));return this.addNodeToCache(u,o),this.addNodeToParentCache(o,w),o}getTooltip(u){return y.MarkdownString.isMarkdownString(u)?p.MarkdownString.from(u):u}getCommand(u,E){return E?this.commands.toInternal(E,u):void 0}createTreeNode(u,E,w){const o=new D.DisposableStore,T=this.createHandle(u,E,w),r=this.getLightIconPath(E);return{item:{handle:T,parentHandle:w?w.item.handle:void 0,label:n(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(o,E.command),contextValue:E.contextValue,icon:r,iconDark:this.getDarkIconPath(E)||r,themeIcon:this.getThemeIcon(E),collapsibleState:(0,F.isUndefinedOrNull)(E.collapsibleState)?y.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:w,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(u){return u.iconPath instanceof y.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:E,label:w,resourceUri:o},T,r){if(E)return`${S.ID_HANDLE_PREFIX}/${E}`;const i=n(w,this.extension),c=T?T.item.handle:S.LABEL_HANDLE_PREFIX;let t=i?i.label:o?(0,I.basename)(o):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const a=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,g=this.getChildrenNodes(T)||[];let f,_=0;do{if(f=`${c}/${_}:${t}`,r||!this.elements.has(f)||a===f)break;_++}while(_<=g.length);return f}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof y.ThemeIcon))return typeof u.iconPath=="string"||b.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof y.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return b.URI.isUri(u)?u:b.URI.file(u)}addNodeToCache(u,E){this.elements.set(E.item.handle,u),this.nodes.set(u,E)}updateNodeCache(u,E,w,o){this.elements.delete(E.item.handle),this.nodes.delete(u),E.item.handle!==w.item.handle&&this.elements.delete(w.item.handle),this.addNodeToCache(u,E);const T=this.getChildrenNodes(o)||[],r=T.filter(i=>i.item.handle===w.item.handle)[0];r&&T.splice(T.indexOf(r),1,E)}addNodeToParentCache(u,E){E?(E.children||(E.children=[]),E.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const E=this.nodes.get(u);if(E){if(E.children)for(const w of E.children){const o=this.elements.get(w.item.handle);o&&this.clear(o)}E.children=void 0}}else this.clearAll()}clear(u){const E=this.nodes.get(u);if(E){if(E.children)for(const w of E.children){const o=this.elements.get(w.item.handle);o&&this.clear(o)}this.nodes.delete(u),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(we[223],be([1,0,20,15,5,34,2,115,235,110,74,45,4,91,180,179,39,181,32,182,183,184,168,185,49,33,186,187,190,192,194,94,170,199,200,201,67,40,203,222,8,7,206,51,95,31,70,157,189,82,92,97,98,99,12,60,14,27,195,153,59,65,177,204,152,68,50,209,207,208,178,30,202,205,64,66,83,197,96,198,10,79,196,150,188,6,28,159]),function(Z,e,s,I,b,B,D,A,y,F,N,p,d,m,l,n,h,S,k,u,E,w,o,T,r,i,c,t,a,g,f,_,P,$,L,v,H,W,q,K,V,z,ae,de,Y,ie,ce,he,ue,re,ge,Te,Re,He,Xe,ve,fe,M,O,C,R,x,Q,ne,Ee,Ie,Me,Le,ze,Be,Ae,Qe,tt,ke,it,X,J,le,Oe,$e,Ge,Je,ft,It,St,kt,qe,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(nt){const ut=nt.get(M.IExtHostInitDataService),At=nt.get(Qe.IExtHostFileSystemInfo),Tt=nt.get(Me.IExtHostConsumerFileSystem),bt=nt.get(i.IExtHostExtensionService),dt=nt.get(ie.IExtHostWorkspace),Rt=nt.get(J.IExtHostTelemetry),Lt=nt.get(k.IExtHostConfiguration),Ft=nt.get(ve.IURITransformerService),Ue=nt.get(fe.IExtHostRpcService),me=nt.get(H.IExtHostStorage),pe=nt.get(Ie.IExtensionStoragePaths),oe=nt.get(Xe.ILoggerService),G=nt.get(Xe.ILogService),Se=nt.get(R.IExtHostTunnelService),Ce=nt.get(x.IExtHostApiDeprecationService),xe=nt.get(Y.IExtHostWindow),je=nt.get(it.IExtHostSecretState),lt=nt.get(X.IExtHostEditorTabs);Ue.set(d.ExtHostContext.ExtHostFileSystemInfo,At),Ue.set(d.ExtHostContext.ExtHostLogLevelServiceShape,oe),Ue.set(d.ExtHostContext.ExtHostWorkspace,dt),Ue.set(d.ExtHostContext.ExtHostConfiguration,Lt),Ue.set(d.ExtHostContext.ExtHostExtensionService,bt),Ue.set(d.ExtHostContext.ExtHostStorage,me),Ue.set(d.ExtHostContext.ExtHostTunnelService,Se),Ue.set(d.ExtHostContext.ExtHostWindow,xe),Ue.set(d.ExtHostContext.ExtHostSecretState,je),Ue.set(d.ExtHostContext.ExtHostTelemetry,Rt),Ue.set(d.ExtHostContext.ExtHostEditorTabs,lt);const gt=Ue.set(d.ExtHostContext.ExtHostDecorations,nt.get(ge.IExtHostDecorations)),Et=Ue.set(d.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(r.IExtHostDocumentsAndEditors)),rt=Ue.set(d.ExtHostContext.ExtHostCommands,nt.get(h.IExtHostCommands)),at=Ue.set(d.ExtHostContext.ExtHostTerminalService,nt.get(W.IExtHostTerminalService)),ot=Ue.set(d.ExtHostContext.ExtHostDebugService,nt.get(Re.IExtHostDebugService)),Mt=Ue.set(d.ExtHostContext.ExtHostSearch,nt.get(He.IExtHostSearch)),mt=Ue.set(d.ExtHostContext.ExtHostTask,nt.get(Te.IExtHostTask)),Dt=Ue.set(d.ExtHostContext.ExtHostOutputService,nt.get(_.IExtHostOutputService)),Ut=Ue.set(d.ExtHostContext.ExtHostUrls,new ae.ExtHostUrls(Ue)),wt=Ue.set(d.ExtHostContext.ExtHostDocuments,new T.ExtHostDocuments(Ue,Et)),Bt=Ue.set(d.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ue,Et,G)),Wt=Ue.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(G,wt,Ue.getProxy(d.MainContext.MainThreadBulkEdits))),pt=Ue.set(d.ExtHostContext.ExtHostNotebook,new O.ExtHostNotebookController(Ue,rt,Et,wt,pe)),ei=Ue.set(d.ExtHostContext.ExtHostNotebookDocuments,new It.ExtHostNotebookDocuments(G,pt)),Xt=Ue.set(d.ExtHostContext.ExtHostNotebookEditors,new ft.ExtHostNotebookEditors(G,Ue,pt)),ti=Ue.set(d.ExtHostContext.ExtHostNotebookKernels,new le.ExtHostNotebookKernels(Ue,ut,pt,rt,G)),ai=Ue.set(d.ExtHostContext.ExtHostNotebookRenderers,new $e.ExtHostNotebookRenderers(Ue,pt)),Ct=Ue.set(d.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(Ue,Et)),ii=Ue.set(d.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ue.getProxy(d.MainContext.MainThreadTreeViews),rt,G)),bi=Ue.set(d.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Ue.getProxy(d.MainContext.MainThreadEditorInsets),Ct,ut)),qt=Ue.set(d.ExtHostContext.ExtHostDiagnostics,new u.ExtHostDiagnostics(Ue,G,At)),Kt=Ue.set(d.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(Ue,wt,rt.converter,Ft)),st=Ue.set(d.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ue,Ft,wt,rt,qt,G,Ce)),li=Ue.set(d.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ue,st)),Ht=Ue.set(d.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ue,G,Et)),zt=Ue.set(d.ExtHostContext.ExtHostQuickOpen,(0,$.createExtHostQuickOpen)(Ue,dt,rt)),ni=Ue.set(d.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Ue,rt,G)),_i=Ue.set(d.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(Ue,rt,wt)),fi=Ue.set(d.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(Ue.getProxy(d.MainContext.MainThreadProgress))),Si=Ue.set(d.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Ue)),mi=Ue.set(d.ExtHostContext.ExtHostTheming,new C.ExtHostTheming(Ue)),ri=Ue.set(d.ExtHostContext.ExtHostAuthentication,new Q.ExtHostAuthentication(Ue)),yi=Ue.set(d.ExtHostContext.ExtHostTimeline,new ne.ExtHostTimeline(Ue,rt)),Qt=Ue.set(d.ExtHostContext.ExtHostWebviews,new de.ExtHostWebviews(Ue,{remote:ut.remote},dt,G,Ce)),Yt=Ue.set(d.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(Ue,Qt,dt)),Di=Ue.set(d.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(Ue,wt,pe,Qt,Yt)),Ci=Ue.set(d.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(Ue,Qt)),Jt=Ue.set(d.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(Ue,rt)),si=Ue.set(d.ExtHostContext.ExtHostUriOpeners,new ke.ExtHostUriOpeners(Ue));Ue.set(d.ExtHostContext.ExtHostInteractive,new St.ExtHostInteractive(Ue,pt,Et,rt));const Ii=(0,ce.values)(d.ExtHostContext);Ue.assertRegistered(Ii);const ki=new Ae.ExtHostBulkEdits(Ue,Et),Ti=new n.ExtHostClipboard(Ue),Zt=new f.ExtHostMessageService(Ue,G),gi=new E.ExtHostDialogs(Ue),Gt=new v.ExtHostStatusBar(Ue,rt.converter);return l.ExtHostApiCommands.register(rt),function(Pe,ci,Ot){const ct=function(){let ee=!Pe.isUnderDevelopment;function se(){ee||(G.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function De(Ze){if(Array.isArray(Ze))Ze.forEach(De);else if(typeof Ze=="string")se();else{const ht=Ze;typeof ht.scheme=="undefined"&&se(),typeof ht.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Pe,"documentFiltersExclusive"),typeof ht.notebookType=="string"&&(0,qe.checkProposedApiEnabled)(Pe,"notebookDocumentSelector")}return Ze}}(),Pi={getSession(ee,se,De){return ri.getSession(Pe,ee,se,De)},async hasSession(ee,se){return(0,qe.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,ee,se,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(ee,se,De,Ze){return ri.registerAuthenticationProvider(ee,se,De,Ze)}},Ai={registerCommand(ee,se,De){return rt.registerCommand(!0,ee,se,De,void 0,Pe)},registerTextEditorCommand(ee,se,De){return rt.registerCommand(!0,ee,(...Ze)=>{const ht=Ct.getActiveTextEditor();if(!ht){G.warn("Cannot execute "+ee+" because there is no active text editor.");return}return ht.edit(yt=>{se.apply(De,[ht,yt,...Ze])}).then(yt=>{yt||G.warn("Edits from command "+ee+" were not applied.")},yt=>{G.warn("An error occurred while running command "+ee,yt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(ee,se,De)=>((0,qe.checkProposedApiEnabled)(Pe,"diffCommand"),rt.registerCommand(!0,ee,async(...Ze)=>{const ht=Et.activeEditor(!0);if(!ht){G.warn("Cannot execute "+ee+" because there is no active text editor.");return}const yt=await Ct.getDiffInformation(ht.id);se.apply(De,[yt,...Ze])},void 0,void 0,Pe)),executeCommand(ee,...se){return rt.executeCommand(ee,...se)},getCommands(ee=!1){return rt.getCommands(ee)}},pi={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ee=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,se){return xe.openUri(ee,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===ut.environment.appUriScheme)return Ut.createAppUri(ee);try{return await xe.asExternalUri(ee,{allowTunneling:!!ut.remote.authority})}catch(se){if((0,Je.matchesScheme)(ee,Ge.Schemas.http)||(0,Je.matchesScheme)(ee,Ge.Schemas.https))return ee;throw se}},get remoteName(){return(0,re.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ut.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ri={createTestController(ee,se,De){return Jt.createTestController(ee,se,De)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.createTestObserver()},runTests(ee){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.runTests(ee)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.results}},Oi={getExtension(ee){const se=ci.getExtensionDescription(ee);if(se)return new i.Extension(bt,Pe.identifier,se,vi)},get all(){return ci.getAllExtensionDescriptions().map(ee=>new i.Extension(bt,Pe.identifier,ee,vi))},get onDidChange(){return ci.onDidChange}},Fi={createDiagnosticCollection(ee){return qt.createDiagnosticCollection(Pe.identifier,ee)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:ee=>qt.getDiagnostics(ee),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(ee,se){return Kt.changeLanguage(ee.uri,se)},match(ee,se){return(0,N.score)(V.LanguageSelector.from(ee),se.uri,se.languageId,!0,se.notebook?.notebookType)},registerCodeActionsProvider(ee,se,De){return st.registerCodeActionProvider(Pe,ct(ee),se,De)},registerCodeLensProvider(ee,se){return st.registerCodeLensProvider(Pe,ct(ee),se)},registerDefinitionProvider(ee,se){return st.registerDefinitionProvider(Pe,ct(ee),se)},registerDeclarationProvider(ee,se){return st.registerDeclarationProvider(Pe,ct(ee),se)},registerImplementationProvider(ee,se){return st.registerImplementationProvider(Pe,ct(ee),se)},registerTypeDefinitionProvider(ee,se){return st.registerTypeDefinitionProvider(Pe,ct(ee),se)},registerHoverProvider(ee,se){return st.registerHoverProvider(Pe,ct(ee),se,Pe.identifier)},registerEvaluatableExpressionProvider(ee,se){return st.registerEvaluatableExpressionProvider(Pe,ct(ee),se,Pe.identifier)},registerInlineValuesProvider(ee,se){return st.registerInlineValuesProvider(Pe,ct(ee),se,Pe.identifier)},registerDocumentHighlightProvider(ee,se){return st.registerDocumentHighlightProvider(Pe,ct(ee),se)},registerLinkedEditingRangeProvider(ee,se){return st.registerLinkedEditingRangeProvider(Pe,ct(ee),se)},registerReferenceProvider(ee,se){return st.registerReferenceProvider(Pe,ct(ee),se)},registerRenameProvider(ee,se){return st.registerRenameProvider(Pe,ct(ee),se)},registerDocumentSymbolProvider(ee,se,De){return st.registerDocumentSymbolProvider(Pe,ct(ee),se,De)},registerWorkspaceSymbolProvider(ee){return st.registerWorkspaceSymbolProvider(Pe,ee)},registerDocumentFormattingEditProvider(ee,se){return st.registerDocumentFormattingEditProvider(Pe,ct(ee),se)},registerDocumentRangeFormattingEditProvider(ee,se){return st.registerDocumentRangeFormattingEditProvider(Pe,ct(ee),se)},registerOnTypeFormattingEditProvider(ee,se,De,...Ze){return st.registerOnTypeFormattingEditProvider(Pe,ct(ee),se,[De].concat(Ze))},registerDocumentSemanticTokensProvider(ee,se,De){return st.registerDocumentSemanticTokensProvider(Pe,ct(ee),se,De)},registerDocumentRangeSemanticTokensProvider(ee,se,De){return st.registerDocumentRangeSemanticTokensProvider(Pe,ct(ee),se,De)},registerSignatureHelpProvider(ee,se,De,...Ze){return typeof De=="object"?st.registerSignatureHelpProvider(Pe,ct(ee),se,De):st.registerSignatureHelpProvider(Pe,ct(ee),se,typeof De=="undefined"?[]:[De,...Ze])},registerCompletionItemProvider(ee,se,...De){return st.registerCompletionItemProvider(Pe,ct(ee),se,De)},registerInlineCompletionItemProvider(ee,se){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),st.registerInlineCompletionsProvider(Pe,ct(ee),se)},registerDocumentLinkProvider(ee,se){return st.registerDocumentLinkProvider(Pe,ct(ee),se)},registerColorProvider(ee,se){return st.registerColorProvider(Pe,ct(ee),se)},registerFoldingRangeProvider(ee,se){return st.registerFoldingRangeProvider(Pe,ct(ee),se)},registerSelectionRangeProvider(ee,se){return st.registerSelectionRangeProvider(Pe,ee,se)},registerCallHierarchyProvider(ee,se){return st.registerCallHierarchyProvider(Pe,ee,se)},registerTypeHierarchyProvider(ee,se){return st.registerTypeHierarchyProvider(Pe,ee,se)},setLanguageConfiguration:(ee,se)=>st.setLanguageConfiguration(Pe,ee,se),getTokenInformationAtPosition(ee,se){return(0,qe.checkProposedApiEnabled)(Pe,"tokenInformation"),Kt.tokenAtPosition(ee,se)},registerInlayHintsProvider(ee,se){return st.registerInlayHintsProvider(Pe,ee,se)},createLanguageStatusItem(ee,se){return Kt.createLanguageStatusItem(Pe,ee,se)}},ui={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(ee,se,De){const Ze=await(D.URI.isUri(ee)?Promise.resolve(Ei.openTextDocument(ee)):Promise.resolve(ee));return Ct.showTextDocument(Ze,se,De)},createTextEditorDecorationType(ee){return Ct.createTextEditorDecorationType(Pe,ee)},onDidChangeActiveTextEditor(ee,se,De){return Ct.onDidChangeActiveTextEditor(ee,se,De)},onDidChangeVisibleTextEditors(ee,se,De){return Ct.onDidChangeVisibleTextEditors(ee,se,De)},onDidChangeTextEditorSelection(ee,se,De){return Ct.onDidChangeTextEditorSelection(ee,se,De)},onDidChangeTextEditorOptions(ee,se,De){return Ct.onDidChangeTextEditorOptions(ee,se,De)},onDidChangeTextEditorVisibleRanges(ee,se,De){return Ct.onDidChangeTextEditorVisibleRanges(ee,se,De)},onDidChangeTextEditorViewColumn(ee,se,De){return Ct.onDidChangeTextEditorViewColumn(ee,se,De)},onDidCloseTerminal(ee,se,De){return at.onDidCloseTerminal(ee,se,De)},onDidOpenTerminal(ee,se,De){return at.onDidOpenTerminal(ee,se,De)},onDidChangeActiveTerminal(ee,se,De){return at.onDidChangeActiveTerminal(ee,se,De)},onDidChangeTerminalDimensions(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDimensions"),at.onDidChangeTerminalDimensions(ee,se,De)},onDidChangeTerminalState(ee,se,De){return at.onDidChangeTerminalState(ee,se,De)},onDidWriteTerminalData(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),at.onDidWriteTerminalData(ee,se,De)},get state(){return xe.state},onDidChangeWindowState(ee,se,De){return xe.onDidChangeWindowState(ee,se,De)},showInformationMessage(ee,...se){return Zt.showMessage(Pe,B.default.Info,ee,se[0],se.slice(1))},showWarningMessage(ee,...se){return Zt.showMessage(Pe,B.default.Warning,ee,se[0],se.slice(1))},showErrorMessage(ee,...se){return Zt.showMessage(Pe,B.default.Error,ee,se[0],se.slice(1))},showQuickPick(ee,se,De){return zt.showQuickPick(ee,se,De)},showWorkspaceFolderPick(ee){return zt.showWorkspaceFolderPick(ee)},showInputBox(ee,se){return zt.showInput(ee,se)},showOpenDialog(ee){return gi.showOpenDialog(ee)},showSaveDialog(ee){return gi.showSaveDialog(ee)},createStatusBarItem(ee,se,De){let Ze,ht,yt;return typeof ee=="string"?(Ze=ee,ht=se,yt=De):(ht=ee,yt=se),Gt.createStatusBarEntry(Pe,Ze,ht,yt)},setStatusBarMessage(ee,se){return Gt.setStatusBarMessage(ee,se)},withScmProgress(ee){return Ce.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),fi.withProgress(Pe,{location:z.ProgressLocation.SourceControl},(se,De)=>ee({report(Ze){}}))},withProgress(ee,se){return fi.withProgress(Pe,ee,se)},createOutputChannel(ee,se){return se&&(0,qe.checkProposedApiEnabled)(Pe,"outputChannelLanguage"),Dt.createOutputChannel(ee,se,Pe)},createWebviewPanel(ee,se,De,Ze){return Yt.createWebviewPanel(Pe,ee,se,De,Ze)},createWebviewTextEditorInset(ee,se,De,Ze){return(0,qe.checkProposedApiEnabled)(Pe,"editorInsets"),bi.createWebviewEditorInset(ee,se,De,Ze,Pe)},createTerminal(ee,se,De){return typeof ee=="object"?"pty"in ee?at.createExtensionTerminal(ee):at.createTerminalFromOptions(ee):at.createTerminal(ee,se,De)},registerTerminalLinkProvider(ee){return at.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,se){return at.registerProfileProvider(Pe,ee,se)},registerTreeDataProvider(ee,se){return ii.registerTreeDataProvider(ee,se,Pe)},createTreeView(ee,se){return ii.createTreeView(ee,se,Pe)},registerWebviewPanelSerializer:(ee,se)=>Yt.registerWebviewPanelSerializer(Pe,ee,se),registerCustomEditorProvider:(ee,se,De={})=>Di.registerCustomEditorProvider(Pe,ee,se,De),registerFileDecorationProvider(ee){return gt.registerFileDecorationProvider(ee,Pe.identifier)},registerUriHandler(ee){return Ut.registerUriHandler(Pe.identifier,ee)},createQuickPick(){return zt.createQuickPick(Pe)},createInputBox(){return zt.createInputBox(Pe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ee,se,De){return mi.onDidChangeActiveColorTheme(ee,se,De)},registerWebviewViewProvider(ee,se,De){return Ci.registerWebviewViewProvider(Pe,ee,se,De?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeActiveNotebookEditor(ee,se,De)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(ee,se,De)},onDidChangeNotebookEditorVisibleRanges(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(ee,se,De)},showNotebookDocument(ee,se){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.showNotebookDocument(ee,se)},registerExternalUriOpener(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"externalUriOpener"),si.registerExternalUriOpener(Pe.identifier,ee,se,De)},get tabGroups(){return(0,qe.checkProposedApiEnabled)(Pe,"tabs"),lt.tabGroups},getInlineCompletionItemController(ee){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),a.InlineCompletionController.get(ee)}},Ei={get rootPath(){return Ce.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw I.readonly()},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw I.readonly()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw I.readonly()},updateWorkspaceFolders:(ee,se,...De)=>dt.updateWorkspaceFolders(Pe,ee,se||0,...De),onDidChangeWorkspaceFolders:function(ee,se,De){return dt.onDidChangeWorkspace(ee,se,De)},asRelativePath:(ee,se)=>dt.getRelativePath(ee,se),findFiles:(ee,se,De,Ze)=>dt.findFiles(ee,se,De,Pe.identifier,Ze),findTextInFiles:(ee,se,De,Ze)=>{(0,qe.checkProposedApiEnabled)(Pe,"findTextInFiles");let ht,yt;return typeof se=="object"?(ht=se,yt=De):(ht={},yt=se,Ze=De),dt.findTextInFiles(ee,ht||{},yt,Pe.identifier,Ze)},saveAll:ee=>dt.saveAll(ee),applyEdit(ee){return ki.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,se,De,Ze)=>Ht.createFileSystemWatcher(dt,Pe,ee,se,De,Ze),get textDocuments(){return wt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw I.readonly()},openTextDocument(ee){let se;const De=ee;if(typeof ee=="string")se=Promise.resolve(D.URI.file(ee));else if(D.URI.isUri(ee))se=Promise.resolve(ee);else if(!De||typeof De=="object")se=wt.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(Ze=>wt.ensureDocumentData(Ze).then(ht=>ht.document))},onDidOpenTextDocument:(ee,se,De)=>wt.onDidAddDocument(ee,se,De),onDidCloseTextDocument:(ee,se,De)=>wt.onDidRemoveDocument(ee,se,De),onDidChangeTextDocument:(ee,se,De)=>wt.onDidChangeDocument(ee,se,De),onDidSaveTextDocument:(ee,se,De)=>wt.onDidSaveDocument(ee,se,De),onWillSaveTextDocument:(ee,se,De)=>Wt.getOnWillSaveTextDocumentEvent(Pe)(ee,se,De),get notebookDocuments(){return pt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,se){let De;if(D.URI.isUri(ee))De=ee,await pt.openNotebookDocument(ee);else if(typeof ee=="string")De=D.URI.revive(await pt.createNotebookDocument({viewType:ee,content:se}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ee,se,De,Ze){return pt.registerNotebookSerializer(Pe,ee,se,De,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)},registerNotebookContentProvider:(ee,se,De,Ze)=>((0,qe.checkProposedApiEnabled)(Pe,"notebookContentProvider"),pt.registerNotebookContentProvider(Pe,ee,se,De,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)),onDidChangeConfiguration:(ee,se,De)=>Ot.onDidChangeConfiguration(ee,se,De),getConfiguration(ee,se){return se=arguments.length===1?void 0:se,Ot.getConfiguration(ee,se,Pe)},registerTextDocumentContentProvider(ee,se){return Bt.registerTextDocumentContentProvider(ee,se)},registerTaskProvider:(ee,se)=>(Ce.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Pe,ee,se)),registerFileSystemProvider(ee,se,De){return(0,kt.combinedDisposable)(li.registerFileSystemProvider(Pe,ee,se,De),Tt.addFileSystemProvider(ee,se))},get fs(){return Tt.value},registerFileSearchProvider:(ee,se)=>((0,qe.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,se)),registerTextSearchProvider:(ee,se)=>((0,qe.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(ee,se)),registerRemoteAuthorityResolver:(ee,se)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),bt.registerRemoteAuthorityResolver(ee,se)),registerResourceLabelFormatter:ee=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Si.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,se,De)=>Ht.onDidCreateFile(ee,se,De),onDidDeleteFiles:(ee,se,De)=>Ht.onDidDeleteFile(ee,se,De),onDidRenameFiles:(ee,se,De)=>Ht.onDidRenameFile(ee,se,De),onWillCreateFiles:(ee,se,De)=>Ht.getOnWillCreateFileEvent(Pe)(ee,se,De),onWillDeleteFiles:(ee,se,De)=>Ht.getOnWillDeleteFileEvent(Pe)(ee,se,De),onWillRenameFiles:(ee,se,De)=>Ht.getOnWillRenameFileEvent(Pe)(ee,se,De),openTunnel:ee=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Se.openTunnel(Pe,ee).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Se.getTunnels()},onDidChangeTunnels:(ee,se,De)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Se.onDidChangeTunnels(ee,se,De)),registerPortAttributesProvider:(ee,se)=>((0,qe.checkProposedApiEnabled)(Pe,"portsAttributes"),Se.registerPortsAttributesProvider(ee,se)),registerTimelineProvider:(ee,se)=>((0,qe.checkProposedApiEnabled)(Pe,"timeline"),yi.registerTimelineProvider(ee,se,Pe.identifier,rt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,qe.checkProposedApiEnabled)(Pe,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,se,De)=>dt.onDidGrantWorkspaceTrust(ee,se,De)},Mi={get inputBox(){return Ce.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(ee,se,De){return ni.createSourceControl(Pe,ee,se,De)}},Ni={createCommentController(ee,se){return _i.createCommentController(Pe,ee,se)}},Li={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(ee,se,De){return ot.onDidStartDebugSession(ee,se,De)},onDidTerminateDebugSession(ee,se,De){return ot.onDidTerminateDebugSession(ee,se,De)},onDidChangeActiveDebugSession(ee,se,De){return ot.onDidChangeActiveDebugSession(ee,se,De)},onDidReceiveDebugSessionCustomEvent(ee,se,De){return ot.onDidReceiveDebugSessionCustomEvent(ee,se,De)},onDidChangeBreakpoints(ee,se,De){return ot.onDidChangeBreakpoints(ee,se,De)},registerDebugConfigurationProvider(ee,se,De){return ot.registerDebugConfigurationProvider(ee,se,De||vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,se){return ot.registerDebugAdapterDescriptorFactory(Pe,ee,se)},registerDebugAdapterTrackerFactory(ee,se){return ot.registerDebugAdapterTrackerFactory(ee,se)},startDebugging(ee,se,De){return!De||typeof De=="object"&&"configuration"in De?ot.startDebugging(ee,se,{parentSession:De}):ot.startDebugging(ee,se,De||{})},stopDebugging(ee){return ot.stopDebugging(ee)},addBreakpoints(ee){return ot.addBreakpoints(ee)},removeBreakpoints(ee){return ot.removeBreakpoints(ee)},asDebugSourceUri(ee,se){return ot.asDebugSourceUri(ee,se)}},Ui={registerTaskProvider:(ee,se)=>mt.registerTaskProvider(Pe,ee,se),fetchTasks:ee=>mt.fetchTasks(ee),executeTask:ee=>mt.executeTask(Pe,ee),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(ee,se,De)=>mt.onDidStartTask(ee,se,De),onDidEndTask:(ee,se,De)=>mt.onDidEndTask(ee,se,De),onDidStartTaskProcess:(ee,se,De)=>mt.onDidStartTaskProcess(ee,se,De),onDidEndTaskProcess:(ee,se,De)=>mt.onDidEndTaskProcess(ee,se,De)},Bi={createNotebookController(ee,se,De,Ze,ht){return ti.createNotebookController(Pe,ee,se,De,Ze,(0,qe.isProposedApiEnabled)(Pe,"notebookMessaging")?ht:void 0)},registerNotebookCellStatusBarItemProvider:(ee,se)=>pt.registerNotebookCellStatusBarItemProvider(Pe,ee,se),get onDidSaveNotebookDocument(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ee){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(ee)},createRendererMessaging(ee){return ai.createRendererMessaging(Pe,ee)},onDidChangeNotebookDocumentMetadata(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(ee,se,De)},onDidChangeNotebookCells(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeNotebookCells(ee,se,De)},onDidChangeNotebookCellExecutionState(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(ee,se,De)},onDidChangeCellOutputs(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellOutputs(ee,se,De)},onDidChangeCellMetadata(ee,se,De){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellMetadata(ee,se,De)},createConcatTextDocument(ee,se){return(0,qe.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new Ee.ExtHostNotebookConcatDocument(pt,wt,ee,se)}};return{version:ut.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:pi,extensions:Oi,languages:Fi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:ui,workspace:Ei,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestions,Hover:z.Hover,IndentAction:F.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,TabKind:d.TabKind,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:m.UIKind,Uri:D.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(we[224],be([1,0,223,33,2,217,7,13,4]),function(Z,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class F extends B.RequireInterceptor{_installInterceptor(){}getModule(l,n){for(let h of this._alternatives){let S=h(l);if(S){l=S;break}}if(this._factories.has(l))return this._factories.get(l).load(l,n,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);d(l,this._initData.environment.isExtensionDevelopmentDebug);const n=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,n,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,n,h){n=n.with({path:p(n.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const S=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(n)),k=await fetch(S.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),k.status!==200)throw new Error(k.statusText);const u=await k.text(),E=`${n.toString(!0)}#vscode-extension`,w=`${u}
//# sourceURL=${E}`;let o;try{o=new Function("module","exports","require",w)}catch(c){throw console.error(l?`Loading code for extension ${l.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${n.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const T={},r={exports:T},i=c=>{const t=this._fakeModules.getModule(c,n);if(t===void 0)throw new Error(`Cannot load module '${c}'`);return t};try{return h.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),o(r,T,i),r.exports!==T?r.exports:T}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const n=Date.now()+l;for(;Date.now()<n&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=N;function p(m,l){return m.endsWith(l)?m:m+l}function d(m,l){n("info","log"),n("log","log"),n("warn","warn"),n("error","error");function n(k,u){const E=console[k];console[k]=function(){m.$logExtensionHostMessage({type:"__$console",severity:u,arguments:S(arguments)}),l&&E.apply(console,arguments)}}const h=1e5;function S(k){const u=[],E=[];if(k.length)for(let w=0;w<k.length;w++){if(typeof k[w]=="undefined")k[w]="undefined";else if(k[w]instanceof Error){const o=k[w];o.stack?k[w]=o.stack:k[w]=o.toString()}E.push(k[w])}try{const w=JSON.stringify(E,function(o,T){if(T&&typeof T=="object"){if(u.indexOf(T)!==-1)return"[Circular]";u.push(T)}return T});return w.length>h?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}}),define(we[225],be([1,0,55,33,68,224]),function(Z,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(I.IExtHostExtensionService,B.ExtHostExtensionService),(0,s.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(we[236],be([1,0,21,5,91,218,211,17,69,10,2,220,225]),function(Z,e,s,I,b,B,D,A,y,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const p=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function m(o){return/^(file|vscode-remote):/i.test(o)}const l=fetch.bind(self);function n(o){self.fetch=async function(T,r){return T instanceof Request||m(String(T))&&(T=(await o(N.URI.parse(String(T)))).toString(!0)),l(T,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,r,i,c,t){(async()=>{m(r.toString())&&(r=(await o(N.URI.parse(r.toString()))).toString(!0)),super.open(T,r,i??!0,c,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(T,r){if(/^file:/i.test(T.toString()))T=F.FileAccess.asBrowserUri(N.URI.parse(T.toString())).toString(!0);else if(/^vscode-remote:/i.test(T.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(f){function _(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const P=fetch.bind(self);self.fetch=function(L,v){return L instanceof Request?P(L,v):P(_(L),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,v,H,W,q){return super.open(L,_(v),H??!0,W,q)}};const $=importScripts.bind(self);self.importScripts=(...L)=>{$(...L.map(_))},$(f)}.toString()}('${T}'))`;r=r||{},r.name=r.name||A.basename(T.toString());const t=new Blob([c],{type:"application/javascript"}),a=URL.createObjectURL(t);return new o(a,r)}}else self.Worker=class extends D.NestedWorker{constructor(o,T){super(d,o,{name:A.basename(o.toString()),...T})}};const h=new class{constructor(){this.pid=void 0}exit(o){p()}async exists(o){return!0}async realpath(o){return o}};class S{constructor(){const T=new MessageChannel,r=new I.Emitter;let i=!1;d(T.port2,[T.port2]),T.port1.onmessage=c=>{const{data:t}=c;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const a=s.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(a,2)){i=!0,u("received terminate message from renderer");return}r.fire(a)},this.protocol={onMessage:r.event,send:c=>{if(!i){const t=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);T.port1.postMessage(t,[t])}}}}}function k(o){return new Promise(T=>{const r=o.onMessage(i=>{r.dispose();const c=JSON.parse(i.toString());o.send((0,b.createMessageOfType)(0)),T({protocol:o,initData:c})});o.send((0,b.createMessageOfType)(1))})}let u=o=>p();function E(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function w(){y.mark("code/extHost/willConnectToRenderer");const o=new S;return{onmessage(T){!E(T)||k(o.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const i=new B.ExtensionHostMain(r.protocol,r.initData,h,null,T.data);n(c=>i.asBrowserUri(c)),u=c=>i.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/45b4204501ac1f50b6231af3c996d35f86359ecd/core/vs/workbench/api/worker/extensionHostWorker.js.map
